
AC N      Auto Correlation - Normalized                      AC N
                                                            09/10/96

PURPOSE:  Computes the normalized auto-correlation function of a picture
          by using the Fourier transform relationship.  The dimension
          of the picture need not be a power of two (see "FT" for 
          restrictions).  Works for 2D and 3D.

SEE ALSO: AC     (Auto Correlation)
          AC MS  (Auto Correlation - MaSked and normalized)
          CC     (Cross Correlation)
          CC N   (Cross Correlation - Normalized)
          CN     (CoNvolution)
          CN N   (CoNvolution - Normalized)
          FT     (Fourier Transform)

USAGE:    AC N

          .INPUT FILE: PIC001
          [Enter the name of the picture to be auto-correlated.]

          .OUTPUT FILE: ACF001
          [Enter name of the file which will contain the auto-correlation
          coefficients.]

NOTES: 1. On completion of this operation, the output file will contain
          the auto-correlation function.  The origin is at: 
          (NSAM/2 + 1, NROW/2 + 1).
          
       2. The input data must be real.

       3. If the data cannot fit into the memory, use the 'FT' and 'MU'
          commands to calculate the ACF:
         '<PRE>'
              FT
              INPUT
              FOUR
              SQ
              FOUR
              MODFT
              FT
              MODFT
              ACF
         '</PRE>'
         '<STRONG>'WARNING'</STRONG>': The orgin of the ACF calculated in
          this way is in (1,1).


SUBROUTINES: ACRS_2, ACRS_2R, ACRS_3, ACRS_3R

CALLER:      CORR1


