
AP CA     Alignment Program - Classification and Alignment  AP CA    
                                                            2/4/96

PURPOSE:  Rotationally aligns the image series and at the same time
          classifies the images into K groups.

SEE ALSO:  AP MD  (3D projection alignment)
           AP RA  (Rotational alignment)
           AP SA  (Shift alignment)
           AP SR  (Shift & rotational alignment)

USAGE:    AP CA

          .TEMPLATE FOR 2-D IMAGE NAME FILE: UKN***
          [Give the name of any of the existing files from the series
           to be aligned]

          .FILE NUMBERS: 1-5,8,20-230

          .FIRST AND LAST RING: 5,15
          [Only rings 5 to 15 will be analyzed]

          .SKIP: 1
          [If skip=0 or 1, then each ring between 5 and 15 will be taken; 
           for skip=2 every second ring, etc.]

          .FULL OR HALF: H
          [Full - full ring treated (real data); Half - half ring 
           treated (autocorrelation function).]

          .NORMALIZE UNDER THE MASK (Y/N): Y
          [For Y, input rings are normalized to compensate for the negative
           stain effect.]

          .NUMBER OF GROUPS, NUMBER OF ITERATIONS: 5,30
          [Number of groups the images will be divided into and upper limit of
           iterations permitted (to avoid infinite loop in the case of lack of
           convergence)]

          .DOCUMENT FILE NAME: HALDOC
          [This is the only output produced by this program. It contains 
           4 columns:
           '<PRE>'
           1.File number    2.Rota. angle      3.Distance   4.Group number
             Real number      Note that         From the      Results of
             to handle        sign of angle     total         classification.
       	     gaps in file     should NOT be     average.  
             series.          reversed in
                              forma. of average.                            ]
           '</PRE>'


NOTE:  1. Please note that all the parameters produced by this program,
          namely, rotation and/or shift parameters -- are given with
          the proper signs. This means that to rotate and/or shift the images
          afterwards, these parameters should be applied directly (without
          sign reversal). To combine parameters given by repeated
          alignments, the 'SA P' command must be used. Only the angle signs 
	  used for 3-D reconstruction from tilted series need to be reversed.

       2. For details see Appendix in P.A.Penczek, J.Zhu, J.Frank.  
          A common-lines based method for determining orientations
          for N>3 particle projections simultaneously.  
          Ultramicroscopy, 63 (1996) 205-218.

SUBROUTINES: HALI, HALI_P, NORMAS, ALRQ, FOURING, CROSRNG, UPDTC, ENER,
            SEEDS, HKMC

CALLER:     UTIL4
