

AP SR     Alignment Program - Shift and Rotational alignment     AP SR
                                                                 2/4/94


PURPOSE:  Reference-free alignment of an image series - shift and rotation.


SEE ALSO:  AP CA  (classification alignment)
           AP MD  (3D projection alignment)
           AP MR  (multi-reference alignment)
           AP RA  (rotational alignment)
           AP SA  (shift alignment)

USAGE:    AP SR

          .Template for 2-D image name file: UKZ005
          [Give the name of any of the existing files from the series
           to be aligned.]

          .Selection doc file: SELECT
          [Enter selection document file name containing the numbers
           of the input images in the first column.]

          .Expected size of the object: 25
          [Expected size of the object in pixels should not exceed image size.]

          .First and last ring: 5,15
          [In the rotational alignment, only rings with the radii in the range
           5-15 (in pixel units) will be analyzed.]

          .Enter template for output file: OUA***
          [The output files will contain averages produced by the alignment
           program after each iteration step.]

          .Enter template for output doc file: PRM***
          [The document files will contain the alignment parameters after
           each iteration. They contain three parameters: rotation angle and 
           x- and y-shifts. These parameters can be used directly in the RT SQ
           operation to produce an aligned image series from the input image
           series.
           When used in conjunction with the Random Conical 3D reconstruction,
           the rotation angle (phi) has to have its sign changed.]


NOTE:  1. This command implements a reference-free strategy to the problem
          of the alignment 2D image series. The theory is described in
          "Three-dimensional reconstruction of single particles embedded
          in ice", P. Penczek et al., Ultramicroscopy 40 (1992) 33-53.
          The search for rotation and shift parameters is not separated.

       2. The program will switch to an "on disk" version (all images will
          be read from the disk many times) in the case of insufficient memory.
          In this case the program will work slower.

       3. The program will work for images with positive contrast
          (bright images on dark background) ONLY.  Dark images on the bright
          should first have the contrast inverted (for example using 
          'AR' to do multiplication by -1).

       4. Images do not have to have power-of-two dimensions, but mixed
          radix FFT is used in the program, so please consult 'FT' manual
          for the restrictions.

       5. The internal accuracy of the search is set to 0.5 pixel.

       6. Please note that the parameters produced by this program,
          rotation and shift, are given with the proper signs. It means
          that to rotate and shift the images (using 'RT SQ', for example)
          this parameters should be applied directly (without
          sign reversion). To combine parameters given by repeated
          alignment 'SA P' command has to be used.

       7. Should the program not give good results, commands 'AP SA'
          and 'AP RA' (procedure refal.sys) can be used instead.

       8. Implemented by Paul Penczek.

SUBROUTINES: GALI, GALI_P, GETIMA_Q, ALROSI_Q, ALROSF_Q, RTQS_Q, 
             CROSRNG_Q, SHFI_2, SUMAP, BLOB_Q, ALRQ_Q, ALPRBS_Q,
             FOURING_Q, RTQ_Q, CENT_Q, FMRS_1D, FMRS_1,
             FINDMX_Q,  OUTIM_Q, QUADRI_Q, OUTPR, UPDF, FNRM

CALLER:     UTIL4

