
AS        Average images - find & save variance                   AS      
                                                           08/15/96

PURPOSE:  Adds 2 or more (up to 20000) pictures together, computes
          several measures of variance (per point, total, etc.).
          The average and the variance image are stored in separate
          output files.  The command works for 2D as well as 3D files.
          '<STRONG>' WARNING:  See Note 3 below if you want a better variance
          measure!  Use of this command for variances is no longer
          recommended!'</STRONG>'
   
SEE ALSO: AS AD  (Average images - add to the existing average - find variance.)
          AS DC  (Average images - find & save variance, doc. file)
          AS F   (Average images - find statistics & Q factor map)
          AS R   (Average images - find & save variance, better)      

USAGE:    AS X10
          [The optional register is to receive the value of the
          average offset.]

           FOR IMAGES TO BE AVERAGED
          .ENTER 3 LETTER FILE PREFIX OR TEMPLATE (EG. PIC****): PIC
          [Enter prefix of images to be added.]

          .ENTER FILE NUMBERS: 1-10,12,15-17
          [Enter numbers of files within a series to be added.]

          .ALL, ODD-EVEN (A/O): O
          ['A '- all images will be added,
          'O'  - two subaverages will be calculated: one for odd-numbered
          images and one for even numbered images. For this option the
          next two questions will appear twice.]

          .AVERAGE FILE: AVG001
          [Enter name of output file receiving average.]

          .VARIANCE FILE: VAR001
          [Enter name of output file receiving variance map.]

          [Questions for average and variance files are repeated if
          option 'O' was chosen.]

          The following values are then printed out:
          '<PRE>'
          Number of images
          Number of elements
          Total variance             Total std. deviation
          Variance per point         Std. deviation per point
          Average offset
          Variance of average image
          '</PRE>'

NOTES:    1. The average file will be normalized so that its mean pixel
          value (X5) is equal to 0.  To "restore" MIN and MAX values
          comparable to those of the input files, use 'AR'.  For
          example, if the average offset was 0.00131, you would have
          ((P1+0.00131)*1.), with P1 as the input average file.
          This is important if you intend to contour the average
          using 'FC', since negative values in the file will give a
          nonsense result.

          2. If the optional register (e.g. X10) is used, 'AR' can be
          used with the formula ((P1+X10)*1.).  If you calculate an
          average in more than one step, each average-offset is 
          independent.  To get the correct average-offset of the 
          complete image, the average of the subaverage average-offsets
          has to be used.

          3. This version of 'AS' does subtracts the average from
          each image during the calculation of global average
          and variance.  Thus,   Operation 'AS'
          results in the variance estimator which is usually
          far 'too optimistic' - the variance obtained is too small
          and cannot be used for statistical tests. Use 'AS R'.
          instead.

SUBROUTINE: ADDS

CALLER:     UTIL2
