
AS F      Average images - find statistics & Q factor map        AS F    
                                                            01/02/96

PURPOSE:  Adds a series of images representing single,
          aligned particles or patches of a crystal lattice, and
          computes a Q factor map. Images have to have power-of-two
          dimensions (internally FFT is used).

SEE ALSO: AS     (Average images - find & save variance)
          AS AD  (Average images - add to the existing average - find variance.)
          AS DC  (Average images - find & save variance, doc. file)
          AS R   (Average images - find & save variance, better)      

USAGE:    AS F

          FOR IMAGES:
          .ENTER FILE PREFIX OR TEMPLATE (EG. PIC****): IMA***
          [Enter the template for the image file series.]

          .ENTER FILE NUMBERS: 1-10,19-78
          [Self explanatory.]

          .AVERAGE FILE: AVA001
          [Enter the name of the output file where the average of
           the image series is to be written.]

          .Q FACTOR FILE: QFA001
          [Enter the name of the file where the Q factor map (= Q
          factor computed at each point of the reciprocal lattice)
          is to be put.]

          .INDICES FOR VECTOR LISTING: 2,2
          [A single reflection may be specified for which the cumulative
           Q factor is calculated and listed in the DOCUMENT file as
           a function of the number of transforms added.
           Enter <Return>  or 0,0 if you do not wish to use this option.]

     If non-zero indices were entered in the previous line:        
          .DOCUMENT FILE: DOC001
          [Enter document file name which will contain the cumulative
           Q factor for the Fourier coefficient chosen.]

NOTES:    The theory of the Q factor analysis can be found in the following
          texts:

       1. M.Kessel, M.Radermacher, J.Frank. The structure of the stalk layer
          of a brine pond microorganism: correlation averaging applied to
          a double layered structure. '<I>'Journal of Microscopy'</I>', vol.139, pt.1,
          July 1985, pp.63-74.
  
       2. M. van Heel, J. Hollenberg. On the stretching of distorted images
          of two-dimensional crystals. '<I>'Electron Microscopy at Molecular
          Dimensions'</I>' (eds.: W. Baumeister and W. Vogell), pp. 256-260,.
          Springer, Heidelberg, 1980.
   
       3. K.V. Mardia.'<I>' Statistics of Directional Data'</I>'. Academic Press,
          London, 1972.

       4. Implemented by: Paul Penczek.

SUBROUTINES: QFACT, QFACT_P

CALLER:      UTIL2
