
BC        Box Convolution                                    BC      
                                                             9/7/94

PURPOSE:  Performs various contrast enhancement operations in 2D and 3D
          using local averaging.

USAGE:    BC

          .INPUT FILE: H_PIC001
          [Enter name of image file to be enhanced.]

          .OUTPUT FILE: OUT001
          [Enter the name of the file where enhanced image is to be put.
           Sample Outputs : 1:(H)IGH PASS- H_IMG010, 2:(L)OW PASS - H_IMG011,
           3:(T)HRES - H_IMG012, 4: (D)IVIS - H_IMG013]

          (H)IGH PASS / (L)OW PASS / (T)HRES / (D)IVIS: H/L/T/D
          [Enter enhancement option:

           Option "H" - High-Pass Filtering.  For each point (IN) of 
                        the input image, the average (AV) of the surrounding 
                        area within a box (see below) is computed. The output 
                        image (OUT) is computed according to the following 
                        formula:

                        OUT = (IN-AV)*F+IN*(1-F)

                        where F is a weighting factor (see below).  
                        F=1.0 results in a pure high-pass filtered image.
                        Values of F  between 1.0 and 0.0 result in images 
                        with various degrees of high resolution enhancement.

           Option "L" - Low-Pass Filtering.  For each point of the input 
                        image, the average (AV) of a surrounding area within 
                        a box (see below) is computed. The output image is 
                        computed according to the following formula:

                        OUT = AV*F+IN*(1-F)

                        where F is a weighting factor (see below).  
                        F=1.0 results in a pure low-pass filtered image.  
                        Values of F between 1.0 and 0.0 result in images 
                        with various degrees of low spatial frequency 
                        enhancement.
          
           Option "T" - Local Threshold Filtering (restricted to images
                        that have been previously stretched or histogram 
                        equalized). For each point of the input image, the 
                        average (AV) of a surrounding area is computed.  
                        The output image is computed according to the 
                        following formula:

                        OUT = (1.-F)*IN       FOR IN < AV
                        OUT = (1.-F)*IN+F*2.  FOR IN >= AV

                        where F is a weighting factor (see below).  
                        F=1.0 results in a purely threshold filtered image.
                        Values of F between 1.0 and 0.0 result in images with
                        various proportions of the input image added on.

           Option "D" - Divisive Local Contrast Correction. For each point of
                        the input image, the average (AV) of a surrounding 
                        area within a box (see below) is computed.  Each point
                        is divided by its local average. The formula for this 
                        procedure is:

                            OUT = F*IN/(AV+EPS)+FC*IN

                        where F is a weighting factor (see below) and EPS is
                        an offset constant for avoiding zero division.  (EPS
                        is set to .1 times the global input average).  F=1.0
                        results in a pure divisive-corrected image.  Values of
                        F between 1.0 and 0.0 result in images with various
                        degrees of divisive correction.]

          .LOCAL AREA SIZE  COL,ROWS: 5,6
          [Enter dimensions of averaging box.  Note that the
          dimensions may be different.  If only NSAM is entered,
          NROW=NSAM will be assumed.]

     If the input is a volume the following question appears:
          .LOCAL AREA SIZE  SLICES: 5,6
          [Enter dimensions of averaging box.  Note that the
          dimensions may be different.  If only NSAM is entered,
          NROW=NSAM will be assumed.]


          FILTER WEIGHT (0.0->1.0): 0.8
          [Enter weight for mixing]
   
       
NOTE:     The margins are replaced by the nearest value possible to
          calculate. This can result in errors for structures filling
          the image close to boundaries and for large local area (box)
          dimensions.

SUBROUTINE: BOXX, AVERG, AVERG3

CALLER:     UTIL3
