
BP 3      Back Projection - 3D, iterative (ART)               BP 3    
                                                            9/17/94

PURPOSE:  Performs one step of a three-dimensional ART back 
          projection from a series of images taken with arbitrary 
	  azimuths PHI and tilt angles THETA.
       
SEE ALSO: BP 3D   (Back Projection - 3D, using Euler angles, ||)
          BP 3E   (Back Projection - 3D, using Euler angles)
          BP CTF  (Back Projection - 3D, CTF correction, ||)
          BP GW   (Back Projection - weighted, arbitrary geometry)
          BP GW3  (Back Projection - weighted, arbitrary geometry, 3 angles)
          BP MEM2 (Back Projection - 2D maximum entropy method)
          BP R2   (Back Projection - 2D, R**2 weighting of the image series)
          BP RP   (Back Projection - 3D, iterative, with constraints, ||)
          BP S2   (Back Projection - 2D, single tilt iterative, with constraints)
          BP W2   (Back Projection - 2D, filtered weighted)
          BP WX   (Back Projection - weighted, X)
          BP WY   (Back Projection - weighted, Y)
          BP XY   (Back Projection - simple for single axis & conical tilting)

USAGE:    BP 3,X10
          [The optional output parameters specify registers where
          the sum of the absolute error and the root mean squared
          error are to be written.  This register can be used to
          follow the progress of the reconstruction.]

          .THREED FILE: REC001
          [Enter the name of the existing 3-D file containing the
          current estimate.  The file will be modified in each back
          projection step.]

          .PROJECTION FILE: PRO005
          [Enter the name of the experimental projection file.  Be
          sure this contains the values for theta and phi in its
          header.  They are written into the header by a previous 'ST'
          operation, e.g.]                '<BR>'
                  ST                     '<BR>'
                  .INPUT FILE: PRO005    '<BR>'
                  A                      '<BR>'
                  50,10                  '<BR>'

NOTES:    This program uses the interpolation philosophy of
          M. Radermacher's projection program.

SUBROUTINES: BPROJ3

CALLER:      VTIL2
