    
BP GW     Back Projection - weighted, arbitrary geometry           BP GW   
                                                                   9/17/94

PURPOSE:  This is the first step of the weighted back projection
          with arbitrary geometry.  

SEE ALSO: BP 3    (Back Projection - 3D, iterative (ART))
          BP 3D   (Back Projection - 3D, using Euler angles, ||)
          BP 3E   (Back Projection - 3D, using Euler angles)
          BP CTF  (Back Projection - 3D, CTF correction, ||)
          BP GW3  (Back Projection - weighted, arbitrary geometry, 3 angles)
          BP MEM2 (Back Projection - 2D maximum entropy method)
          BP R2   (Back Projection - 2D, R**2 weighting of the image series)
          BP RP   (Back Projection - 3D, iterative, with constraints, ||)
          BP S2   (Back Projection - 2D, single tilt iterative, with constraints)
          BP W2   (Back Projection - 2D, filtered weighted)
          BP WX   (Back Projection - weighted, X)
          BP WY   (Back Projection - weighted, Y)
          BP XY   (Back Projection - simple for single axis & conical tilting)

USAGE:    BP GW 

          .CRITICAL VALUE FOR W: 0.6
          [Give upper limit for inverse of  weighting function to avoid 
           noise enhancement. (remark: this parameter will be changed. A
           value smaller than 1 allows a weighting function larger than 1
           A value of 0.6 seems to be adequate) ]

          .3D VOLUME DIAMETER: 32
          [Enter diameter of reconstruction volume]

          .GENER.ANGLES IN (L)ABEL,(D)OCF,(E)XTERNAL: L
          [Enter if angles of the projections, which are used to generate
           the weighting function are contained in the label of the files,
           in a document file or if they will be entered externally]

          .WGT. ANGLES IN (L)ABEL,(D)OCF,(E)XTERNAL: L
          [Enter if angles of the projections which will be weighted are
           contained in label, document file, or externally given]

          .TEMPLATE OF INPUT FILE SERIES: PRO***
          [Enter prefix of input files]
 
          .TEMPLATE OF OUTPUT FILE SERIES: PRW***
          [Enter prefix of output files]

          .FILE NUMBERS OF GENERATING FILES: 1,5,6-36
          [Enter file numbers of the projections, which generate the 
           weighting function]

          .FILE NUMBERS OF FILES TO BE WEIGHTED: 1,5, 7-36
          [Enter file numbers of files which will be weighted]

          If angles of generating projections are given externally:
           .PHI: 10.
           .THETA: 45.
              .
              .
              .
          [Enter phi and theta for each generating projection]

          If angles of generating projections are contained in document file:
          .DOC1: DOC001
          [Enter name of document file which contains the angles of
           the generating projections. see also note 2!!!]

          .BOTH IMAGE SETS IDENTICAL (Y/N): N
          [If the set of projections which generate the weighting function
           and the set which is to be weighted are identical answer Y. 
           Note: Answer yes only, if both sets are really the same images,
           correponding to each other image by image including the file
           numbers.] 
 
    If they are not identical and the angles of the projections which
    are to be weighted are given externally:

          .INPUT DATA OF THE PROJECTION SET TO BE WEIGHTED: 
          .PHI: 10
          .THETA: 50
              .
              .
              .
          [Enter the angles of these projections]


    If they are not identical and the angles of the projections which
    are to be weighted are contained in document file:

          .DOC2: DOC002
          [Enter document file that contains the angle of the projections
          that are to be weighted. It can be the same file as DOC1. see
          also note 2.!!!]


NOTES:    The projections must have power-of-2 dimensions.
          'BP GW' also does an in-core Fourier transform.  Maximum size 
          of projections is currently 128x128.

          The document files have to have the format:
          KEY=file #, THETA (cone angle), PHI (azimuth), 
          FLAG (1 if used,0 if skipped)

          Gaps in keys are not allowed, instead enter a line that has a 
          0 flag. Document file keys must be in sequential order !!!


          The program calculates the weighting function along a section
          in Fourier space corresponding to a projection. The weighting
          function is the invers of the sum of the sinc-functions along
          the z-directions in the coordinate systems of each generating
          projection.
       
          Let PW be the projection to be weighted and PG the projection
          generating the sinc-function. Let RW(w) be a vector in the
          coordinate system belonging to PW and RW(g) the same vector 
          represented in the coordinate system of PG. The argument of the
          sinc-function is the plane RW(g) with ZW=0 (ZW z-coordinate in
          PW).

          Let R be a vector in the space fixed coordinate system. [DW]
          the rotation matrix from R to RW (R(w)=[DW]*R). analogous let
          [DG] be the rotation matrix from R to RG (R(g)=[DG]*R). The
          argument of the sinc function then is: projection onto Zg of
          '<PRE>'      
                                -1
          RW(g)=[D]*RW(w)=[DG]*[DW]  *RW(w)
              :=[DGthe]*[DGphi]*[DWphi]*[DWthe]*RW(w).
          '</PRE>'      
          The matrices used are (consistent with MIRQBXS used in the simple
          backprojection called in spider by 'BP XY'):
          '<PRE>'      
                |cos(theta(g)) 0 -sin(theta(g))| | cos(phi(g)) sin(phi(g) 0|
          [DG]= |       0       1       0      |*|-sin(phi(g)) cos(phi(g) 0|
                |sin(theta(g)) 0  cos(theta(g))| |      0          0      1|

              -1 |cos(phi(w)) -sin(phi(w)) 0| | cos(theta(w)) 0 sin(theta(w))|
          [DW]  =|sin(phi(w))  cos(phi(w)) 0|*|       0       1       0      |
                 |     0            0      1| |-sin(theta(w)) 0 cos(theta(w))|
          '</PRE>'      

SUBROUTINES: GENW, FOUR2

CALLER: VTIL2

