    
BP GW3    Back Projection - weighted, arbitrary geometry, 3 angles  BP GW3   
                                                                    1/26/94
	  
PURPOSE:  This is the first step of the weighted back projection
          with arbitrary geometry and three Euler angles.  

SEE ALSO: BP 3    (Back Projection - 3D, iterative (ART))
          BP 3D   (Back Projection - 3D, using Euler angles, ||)
          BP 3E   (Back Projection - 3D, using Euler angles)
          BP CTF  (Back Projection - 3D, CTF correction, ||)
          BP GW   (Back Projection - weighted, arbitrary geometry)
          BP MEM2 (Back Projection - 2D maximum entropy method)
          BP R2   (Back Projection - 2D, R**2 weighting of the image series)
          BP RP   (Back Projection - 3D, iterative, with constraints, ||)
          BP S2   (Back Projection - 2D, single tilt iterative, with constraints)
          BP W2   (Back Projection - 2D, filtered weighted)
          BP WX   (Back Projection - weighted. X)
          BP WY   (Back Projection - weighted, Y)
          BP XY   (Back Projection - simple for single axis & conical tilting)

USAGE:    BP GW3 

           .(S)INC-FCT.,(G)AUSS-FCT.,(M)IXED : M
           [Enter if weighting function should be constructed by a summation
            of sinc-functions, Gaussian functions or a mixture of both. Sinc
            function weighting implies that the reprojection rays are limited
            by a multiplication with a box-function, i.e., a sharp cutoff,
            Gaussian, that the (infinite) reprojection rays are limited
            by multiplication with a Gaussian function, Mixed, that the rays
            are limited by an apodized box function, the falloff of this box
            function is determined by the half width of the Gaussian. The 
            weighting function then is calculated from the sum of 
            sinc-functions multiplied with Gaussians]

       If either G of M was answered:
           .SIGMA (absolute units): .1
           [Enter the sigma of the Gaussian in Fourier space, use absolute
            units. If in real space the box-function is apodized by 
            multiplication of the box function with a Gaussian function with 
            halfwidth s (in pixels) then sigma should be 1/s.] 

           .(T)RANSFER OR (W)EIGHTING-FCT.: w
           [Enter if you want the Transfer function or the Weighting function
            (= 1./(Transfer function)). The calculation of the transfer 
            function may be desirable for test purposes]

          .CRITICAL VALUE FOR W: 0.6
          [Give upper limit for inverse of  weighting function (=transfer
           function) to avoid noise enhancement. (remark: this parameter 
           will be changed. A value smaller than 1 allows a weighting 
           function larger than 1. A value of 0.6 seems to be adequate) ]


           .3D VOLUME DIAMETER: 80
           [Enter diameter of reconstructed volume in real space]

          .GENER.ANGLES IN (L)ABEL,(D)OCF,(E)XTERNAL: L
          [Enter if angles of the projections, which are used to generate
           the weighting function are contained in the label of the files,
           in a document file or if they will be entered externally. It is
           strongly recommended to provide these angle in the file label. 
           This is the most used mode and thus the best tested.]

          .WGT. ANGLES IN (L)ABEL,(D)OCF,(E)XTERNAL: L
          [Enter if angles of the projections which will be weighted are
           contained in label, document file, or externally given. s. remark
           above.]

          .TEMPLATE OF INPUT FILE SERIES: PRO***
          [Enter prefix of input files]
 
          .TEMPLATE OF OUTPUT FILE SERIES: PRW***
          [Enter prefix of output files]

          .FILE NUMBERS OF GENERATING FILES: 1,5,6-36
          [Enter file numbers of the projections, which generate the 
           weighting function]

          .FILE NUMBERS OF FILES TO BE WEIGHTED: 1,5, 7-36
          [Enter file numbers of files which will be weighted]

          If angles of generating projections are given externally:
           .PHI: 10.
           .THETA: 45.
              .
              .
              .
          [Enter phi and theta for each generating projection]

          If angles of generating projections are contained in document file:
          .DOC1: DOC001
          [Enter name of document file which contains the angles of
           the generating projections. see also note 2!!!]

          .BOTH IMAGE SETS IDENTICAL (Y/N): N
          [Answer "N"!. Only if the set of projections which generate the 
           weighting function and the set which is to be weighted are 
           identical you may answer Y. 
           Warning: Answer yes only, if both sets are really the same images,
           corresponding to each other image by image including the file
           numbers. N always works! ] 
 
    If they are not identical and the angles of the projections which
    are to be weighted are given externally:

          .INPUT DATA OF THE PROJECTION SET TO BE WEIGHTED: 
          .PHI: 10
          .THETA: 50
              .
              .
              .
          [Enter the angles of these projections]


    If they are not identical and the angles of the projections which
    are to be weighted are contained in document file:

          .DOC2: DOC002
          [Enter document file that contains the angle of the projections
          that are to be weighted. It can be the same file as DOC1. see
          also note 2.!!!]

NOTES:    The projections must have power-of-2 dimensions.
          'BP GW' also does an in-core Fourier transform.  Maximum size 
          of projections is currently 128x128.

          The document files have to have the format:
          KEY=file #, PHI (azimuth), THETA (cone angle), PSI (rotation
          within the plane of the projection), FLAG (1 if image used,0 
          if skipped)

          Gaps in keys are not allowed, instead enter a line that has a 
          0 flag. Document file keys must be in sequential order !!!

          The program calculates the weighting function along a section
          in Fourier space corresponding to a projection. The weighting
          function is the invers of the sum of the sinc-functions along
          the z-directions in the coordinate systems of each generating
          projection.
       
          Let PW be the projection to be weighted and PG the projection
          generating the sinc-function. Let RW(w) be a vector in the 
          coordinate system belonging to PW and RW(g) the same vector 
          represented in the coordinate system of PG. The argument of the
          sinc-function is the plane RW(g) with ZW=0 (ZW z-coordinate in
          PW).

          Let R be a vector in the space fixed coordinate system. [DW]
          the rotation matrix from R to RW (R(w)=[DW]*R). analogous let
          [DG] be the rotation matrix from R to RG (R(g)=[DG]*R). The
          argument of the sinc function then is: projection onto Zg of
          '<PRE>'      
                                   -1
          RW(g)=[D]*RW(w)=[DG]*[DW]  *RW(w)
                                       -1        -1        -1
              :=[DGthe]*[DGphi]*[DWphi]  *[DWthe]  *[DWPSI]  *RW(w).
          '</PRE>'      

          The matrices used are consistent with BAPI3A used in the simple
          backprojection called in SPIDER by 'BP 3E'.

SUBROUTINES: GENW3E, FOUR2

COTASK: VTIL2
