
BP MEM2   Back Projection - 2D maximum entropy method        BP MEM2   
                                                              8/12/96

PURPOSE:  Calculates 2-dimensional reconstruction using Maximum
          Entropy Method.
          The projections need not have power-of-two dimensions.

SEE ALSO: BP 3    (Back Projection - 3D, iterative (ART))
          BP 3D   (Back Projection - 3D, using Euler angles, ||)
          BP 3E   (Back Projection - 3D, using Euler angles)
          BP CTF  (Back Projection - 3D, CTF correction, ||)
          BP GW   (Back Projection - weighted, arbitrary geometry)
          BP GW3  (Back Projection - weighted, arbitrary geometry, 3 angles)
          BP R2   (Back Projection - 2D, R**2 weighting of the image series)
          BP RP   (Back Projection - 3D, iterative, with constraints, ||)
          BP S2   (Back Projection - 2D, single tilt iterative, with constraints)
          BP W2   (Back Projection - 2D, filtered weighted)
          BP WX   (Back Projection - weighted, X)
          BP WY   (Back Projection - weighted, Y)
          BP XY   (Back Projection - simple for single axis & conical tilting)

USAGE:    BP MEM2

          .PROJECTIONS: PRO***
          [Enter the prefix of the projection file series.]

          .FILE NUMBERS: 1-20,33,45-128
          [Enter number of files containing projections.]

          .SLICE NUMBER, RADIUS OF RECONSTRUCTED CIRCLE: 23,52
          [Enter number of slice to be reconstructed and the radius
           of the reconstructed circle.]

          .SEARCH DIRECTIONS, ENTROPY TYPE: 3,1
          [Number of gradient search directions for the optimization program: 
           only 3, 4 or 6 is allowed. Three directions are sufficient.

           Entropy type determines the definition of the entropy to be used:

              0 - fixed default value - the average of the reconstructed
                  image is kept constant and equal to the default value;

              1 - variable average, no default value needed;

              2 - not supported;

              3 - not supported;

              4 - values of reconstructed object are kept 0<f<1 at
                  fixed default value. This option can be treated as
                  the constraint of maximum value of the reconstruction
                  provided that the projections are scaled properly.]


          .C_AIM, VARIANCE: 1000,1
          [C_aim is the expected chi-squared error used for convergence
           test. Variance is the error of each pixel. Only a constant error
           model is used. Note that the two numbers are related.]

          .STARTING VALUE, DEFAULT VALUE: 0.1,0.2
          [Starting value used as a background for the reconstructed image.
           It must be positive. A good guess is 1/N, where N is the number of
           reconstructed pixels.
           Default value is used for maximization of entropy type 0 or 4.]

          .ITERATION LIMIT, CONVERGENCE TEST: 100,1
          [Iteration limit prevents excessively long calculations.
           
          Convergence test defines the stopping criterion used:

              1 -  C <= 1.005*C_aim  or  TEST <= 0.01;

              2 -  as in opt. 1, but stop after 8 iterations if TEST starts
                   increasing;

              3 -  as in opt. 1, but stop if C changes by less than 1%.]

          .PRINT INFORMATION EACH ITERATION STEP (Y/N): N
           [Self-explanatory.]

          .SCALING FACTOR: 1.0
           [Projections are multiplied be this factor. It simplifies
            adjustment of the projections' values to obey constraints.]

          .RECONSTRUCTED 2-D FILE: SLI023
           [Name of output file.]


NOTES:    1. The projection angle must be provided in the position
             THETA of the header of each file.

          2. The projections need not have power-of-2 dimensions.

          3. If the radius of the reconstructed circle is too large
             compared to the size of the projections, a warning is printed.
             The reconstruction is calculated, but it is incorrect
             on the boundary.

          4.  Implemented by:  P. Penczek.

CALLER:      VTIL2
