
BP RP     Back Projection - 3D, iterative, with constraints, ||     BP RP   
                                                           04/23/97

PURPOSE:  Calculates 3D reconstruction using constraints.

SEE ALSO: BP 3    (Back Projection - 3D, iterative (ART))
          BP 3D   (Back Projection - 3D, using Euler angles, ||)
          BP 3E   (Back Projection - 3D, using Euler angles)
          BP CTF  (Back Projection - 3D, CTF correction, ||)
          BP GW   (Back Projection - weighted, arbitrary geometry)
          BP GW3  (Back Projection - weighted, arbitrary geometry, 3 angles)
          BP MEM2 (Back Projection - 2D maximum entropy method)
          BP R2   (Back Projection - 2D, R**2 weighting of the image series)
          BP S2   (Back Projection - 2D, single tilt iterative, with constraints)
          BP W2   (Back Projection - 2D, filtered weighted)
          BP WX   (Back Projection - weighted, X)
          BP WY   (Back Projection - weighted, Y)
          BP XY   (Back Projection - simple for single axis & conical tilting)

USAGE:    BP RP

          .ENTER TEMPLATE FOR 2-D IMAGE FILE: PROJ***
          [Enter template for projection input files.]

          .SELECTION DOC FILE: IMAGES127
          [Enter the name of the document file containing projection
           file numbers in the first column.]

          .RADIUS OF RESTORED OBJECT: 23
          [Enter radius of reconstructed object (smaller than the
           volume size). The reconstruction is calculated inside the
           sphere only.]

          .ANGLES DOC FILE: ANGLES27
          [Enter the name of the document file containing Eulerian
           angles for the projections used (psi, theta, phi).]
                
          .DOES YOUR VOLUME HAVE SYMMETRIES? (Y/N): Y
          [Answer Yes if you want the symmetries to be internally
           enforced on your volume.  The reconstruction in this case is
           calculated as though the projections were multiplied
           as many times as there are symmetries.]

    If the answer was 'Y' SPIDER will ask:

          .SYMMETRIES ANGLES DOC FILE: ANGSYM
          [Enter the name of the document file containing Eulerian
           angles defining symmetries (psi, theta, phi). The angles
           should be such that when used in operation 'RT 3D' transform
           the volume into itself.  The identity operation 
           (angles 0,0,0) MUST be included.]
                
          .RECONSTRUCTED 3-D FILE: VOLUME1001
          [Name of the output file.]

          .LAMBDA, CORRECTION LIMIT: 1.0e-4,0.0
          [Lambda determines the weight of corrections. Too small a
           value results in long time of calculations; too large
           value will terminate the iterations too soon.
           Correction limit is used to terminate the iterations.
           When the squared correction of the structure becomes
           smaller than the preset value, the iterations are
           terminated. When correction limit is set to zero,
           this criterion is not used.]

          .ITERATION LIMIT, MODE: 25,8
          [Program will terminate after number of iterations given.
           Mode determines the constraints used:              '<BR>'
           1 - frequency limit (smoothing),                   '<BR>'
           2 - min constraint,                                '<BR>'
           5 - max constraint.                                '<BR>'
           Any combination of constraints can be used. The mode answered
           should be the sum of any single modes, for example mode=7
           activates both min and max constraints, mode=8 all three of 
           them.]

          .MINIMUM, MAXIMUM: 1.77,1.90
          [Values of min and max constraints. They relate to the values
           in 2D projection data.]

          .SMOOTHING CONST (0-0.999):0.9994
          [Smoothing constant determines relative weight of the low-pass
           filtration. See note #3.]

NOTES:    1. The projections need not have power-of-2 dimensions.

          2. If the radius of the reconstructed circle is too large
             comparing to the size of projections, a warning is printed.
             The reconstruction is calculated, but it is incorrect
             along the boundary.

          3. Smoothing constant determines relative weight of the 
             low-pass filtration.
             It has to be larger than zero and smaller than one.
             In addition smoothing constant has to be lower than
                1/(1+6*lambda).                

             Zero means no smoothing.                             '<BR>'

             To achieve stronger low-pass filtration effect one can 
             decrease lambda and increase the smoothing constant. '<BR>'

             Approximate frequency response:

           '<PRE>'
             lambda     smoothing const    res'n limit (pixels)
              .5E-3         0.990                 3
              .5E-3         0.997                 5
              .1E-3         0.9994               10
           '</PRE>'

          4. It is assumed that projections are squares (NSAM=NROW), so
             the output volume has dimensions NSAMxNSAMxNSAM.

          5. Memory requirement: 2*(NSAM**3)

          6. Implemented by: Paul Penczek.

SUBROUTINES: REPS, REDPRQ, RPRQ, ASTA, PREPCUB_S, BCKCQ, PRJCQ, REPR3_Q, 
             SMT3_Q, DOMIN3_S, DOMAX3_S, DOCORS3_S, BMAX_S, BMIN_S,
             FMAX_Q, FMIN_Q

CALLER:      VTIL2
