
BP W2     Back Projection - 2D, filtered weighted               BP W2   
                                                             09/17/94

PURPOSE:  Calculates 2-dimensional weighted back projection
          reconstruction for single-tilt geometry using built-in 
          Parzen filter function.
          The dimensions of projections do not have to be powers of two.

SEE ALSO: BP 3    (Back Projection - 3D, iterative (ART))
          BP 3D   (Back Projection - 3D, using Euler angles, ||)
          BP 3E   (Back Projection - 3D, using Euler angles)
          BP CTF  (Back Projection - 3D, CTF correction, ||)
          BP GW   (Back Projection - weighted, arbitrary geometry)
          BP GW3  (Back Projection - weighted, arbitrary geometry, 3 angles)
          BP MEM2 (Back Projection - 2D maximum entropy method)
          BP R2   (Back Projection - 2D, R**2 weighting of the image series)
          BP RP   (Back Projection - 3D, iterative, with constraints, ||)
          BP S2   (Back Projection - 2D, single tilt iterative, with constraints)
          BP WX   (Back Projection - weighted, X)
          BP WY   (Back Projection - weighted, Y)
          BP XY   (Back Projection - simple for single axis & conical tilting)

USAGE:    BP W2

          .ENTER TEMPLATE FOR 2-D IMAGE NAME: PRJ***
          [Enter the prefix of the projection file series.]

          .SELECTION DOC FILE: SELECT
          [Enter the name of the document file containing projection
           file numbers in the first column.]

          .ANGULAR DOC FILE: ANGLES
          [Enter the name of the document file containing Eulerian
           angles for the projections used (psi, theta, phi).
           Only theta is actually used, psi and phi are ignored.]

          .RADIUS OF RECONSTRUCTED OBJECT, HEIGHT OF THE SLICE: 45,30
          [The reconstruction is calculated for the circle only
           and within the slab of specified height.  This height is
           NSLICE dimension of resulting 3D volume.]

          .RECONSTRUCTION FROM NROW1 TO NROW2: 2,73
          [The reconstruction is calculated between specified
           nrow borders. Default is nrow1=1, nrow2=nrow.
           3D volume will have dimensions:
            NSAM, NROW2-NROW1+1, height of the slice
           where NSAM is original 2D projection dimension.]

          .FREQUENCY CUT-OFF FOR PARZEN FILTER: 0.3
          [The Parzen filter is zero for the frequences higher then
           the cut-off frequency. If zero is answered no filter is
           used.]

          .3-D OUTPUT FILE: UUU101
          [Name of the output file.]

NOTES:    1. Only theta angle from the angular document file is used.
             Two remaining angles (psi and phi) are ignored.

          2. The projections do not have to have power-of-2 dimensions.

          3. If the radius of the reconstructed circle is too large
             comparing to the size of projections the warning is printed.
             The reconstruction is calculated, but it is incorrect
             on the boundary.

          4. Implemented by: Paul Penczek.

SUBROUTINES: WGBP2, RDPA, REPRWB, PREPSL_2, BPRJ2, BCKC2, BCKC0

CALLER:      VTIL2
