
BP WX     Back Projection - weighted, X                       BP WX   
                                                            9/17/94

PURPOSE:  This is the first step of the weighted back projection for
          a tilt series with equal angular increment (not statistical). 
          A series of projections is weighted by R in Fourier space.
          The direction (x or y <> wx or wy) depends on the tilting
          and reconstruction geometry (see 'BP XY' or 'BP YZ', the
          simple back projection used in the second step of the
          reconstruction.

SEE ALSO: BP 3    (Back Projection - 3D, iterative (ART))
          BP 3D   (Back Projection - 3D, using Euler angles, ||)
          BP 3E   (Back Projection - 3D, using Euler angles)
          BP CTF  (Back Projection - 3D, CTF correction, ||)
          BP GW   (Back Projection - weighted, arbitrary geometry)
          BP GW3  (Back Projection - weighted, arbitrary geometry, 3 angles)
          BP MEM2 (Back Projection - 2D maximum entropy method)
          BP R2   (Back Projection - 2D, R**2 weighting of the image series)
          BP RP   (Back Projection - 3D, iterative, with constraints, ||)
          BP S2   (Back Projection - 2D, single tilt iterative, with constraints)
          BP W2   (Back Projection - 2D, filtered weighted)
          BP WY   (Back Projection - weighted, Y)
          BP XY   (Back Projection - simple for single axis & conical tilting)

USAGE:    BP WX

          .FIRST FILE: PRO001
          [Enter the name of the first projection.]

          .LAST FILE: PRO020
          [Enter the name of the last projection.]

          .OUTPUT FILE TEMPLAT: WEIGHT***
          [ENTER TEMPLATE FOR OUTPUT FILE]

          .START AT RADIUS 0 OR 1: 0
          [for a single axis tilt series the avergae per projection
          line should be preserved. thus answer 1. otherwise for true
          r* weighting answer 0]

NOTES: 1. The projections must have power-of-2 dimensions.
          'BP WX' also does an in-core Fourier transform.  
          Maximum size of projections is currently 128x128.

       2. The file series need not be contiguous; gaps in the
          file numbers are allowed.


SUBROUTINES: WEIGHTC,WEIGHTF,WEIFU,WEIFU3,FOUR2

CALLER:      VTIL2
