
BP XY     Back Projection - simple for single axis & conical tilting   BP XY   
                                                                  9/17/94

PURPOSE:  The second step of the weighted back projection method.
          The input projections are back projected into a given volume.
          This volume may already exist; in this case the 
          projections are added on.  If the volume does not exist, it
          will create a volume containing 0 density, if the 
          question ".IS THIS A NEW 3D (Y/N):" is answered 'Y'. 
          The program works for both single axis and
          conical tilting series.  
          The geometrical relation between the
          object and the projections is described by the rotation
          matrix:                                 
          '<PRE>'
              COS(THETA)COS(PHI)   COS(THETA)SIN(PHI)   -SIN(THETA)
              -SIN(PHI)            COS(PHI)               1
          '</PRE>'
          If, for example, you have a single-axis tilting series
          with Y as the tilt axis, use 'BP WX' to weight the 
          projections perpendicular to the tilt axis and define only 
          THETA in the back projection step.

SEE ALSO: BP 3    (Back Projection - 3D, iterative (ART))
          BP 3D   (Back Projection - 3D, using Euler angles, ||)
          BP 3E   (Back Projection - 3D, using Euler angles)
          BP CTF  (Back Projection - 3D, CTF correction, ||)
          BP GW   (Back Projection - weighted, arbitrary geometry)
          BP GW3  (Back Projection - weighted, arbitrary geometry, 3 angles)
          BP MEM2 (Back Projection - 2D maximum entropy method)
          BP R2   (Back Projection - 2D, R**2 weighting of the image series)
          BP RP   (Back Projection - 3D, iterative, with constraints, ||)
          BP S2   (Back Projection - 2D, single tilt iterative, with constraints)
          BP W2   (Back Projection - 2D, filtered weighted)
          BP WX   (Back Projection - weighted, X)
          BP WY   (Back Projection - weighted, Y)

USAGE:    BP XY

          .3D FILE: REC100
          [Enter the name of the reconstruction volume.]

          .IS THIS A NEW 3D? (Y/N): Y
         
       If the last answer was "Y" it asks:

          .X,Y DIMENSIONS: 64,64
          .Z DIMENSION: 64
          [Define the dimensions of the reconstruction volume.
          These are independent of the dimensions of the
          projections.  The center is assumed to be at point (NSAM/2+1,
          NROW/2+1,NSLICE/2+1).]

          .FIRST,LAST SLICE TO BE RECONSTRUCTED: 10,50
          [Self-explanatory.]

          .SLICE INTERVAL: 1
          [Enter the steps between the slices to be calculated.
          This allows for the reconstruction, for example, of every
          second slice.  However, the slices not calculated are
          still part of the reconstructed volume, and contain 0
          density.]

          .ENLARGEMENT FACTOR: 1
          [Since the dimensions of the volume are independent of
          those of the projections, different grids for the 
          reconstruction volume and the projections may be defined by the
          enlargement factor.  The default=1.0]

          .FIRST PROJECTION FILE: PRO001
          .LAST PROJECTION FILE: PRO020
          [Enter the names of the first and last projections.]

NOTES:    The reconstructed volume has to be filtered to the correct
          resolution, which is determined by the number of 
          projecttions.  This can be done either after the reconstruction,
          by filtering the volume, or by filtering the input 
          projections before the reconstruction the the correct 
          resolution.  For the formulas to calculate the resolution, see:
          '<BR>'
          Single-Axis Tilting:                             '<BR>'
              Crowther R.A., DeRosier D.J., Klug A., Proc. Roy. Soc.
              Lond. A. 317,319-340 (1970)  (specifically, page 332).
          Conical Tilting:                                 '<BR>'
              Radermacher M., Hoppe W., Proc. 7th Europ. Congr. El.
              Micr. den Haag, 1980 Vol.1 132-133.
          Arbitrary tilting:                               '<BR>'
              The resolution can be estimated from 
              a histogram of the angular distribution or a comparison
              of two or more independent reconstructions. Exact formulas
              are not available. 

SUBROUTINES: BAPI, MIRQBXS

CALLER:      VTIL2

