
CA MAP    Correspondence Analysis - nonlinear MAPping         CA MAP  
                                                            12/15/93

PURPOSE:  Calculate a distance-preserving map from a cluster file
          created by CORAN.  A nonlinear mapping algorithm is used,
          which minimizes SUM((DH-DL)**2/DH**EXP), where DH are the
          distances in high-dimensional space and DL the distances
          in the two-dimensional space.

SEE ALSO: CA S   (Correspondence Analysis - find solution)           
          CA SI  (Correspondence AnalysiS - initialize)
          CA SM  (Correspondence Analysis - factor map)
          CA SME (Correspondence Analysis - factor map and Eigen Values)
          CA SR  (Correspondence Analysis - full reconstitution of images)
          CA SRD (Correspondence AnalysiS - reconstitute differential images)
          CA SRI (Correspondence AnalysiS - reconstitute importance images)
          CA SRP (Correspondence Analysis - PCA reconstitution)
          CA VIS (Correspondence Analysis - Create visual map)
      
USAGE:    CA MAP

          .COORDINATE FILE VERSION: (1)OLD, (2)NEW: 1
          [Enter version of CORAN used to create cluster file]

          .COORDINATE FILE: IMC001
          [Enter the name of the cluster file created by CORAN.]

          .FACTOR NUMBERS: 1,3,4,6
          [Enter the factors that you want to include in the
          nonlinear mapping algorithm.]

          .FACTOR WEIGHTS (2 PER LINE): 1,1.5
          [Enter weights for each selected factor.]

          .ASSIGN SYMBOLS (Y/N): Y
          [enter Y if you want to have a map where symbols (letters)
           are printed for specified images.]

    If "Y" was answered:
          .SYMBOL: A
          [Enter symbol.]

          .SYMBOL ASSIGNED TO IMAGE # FROM,TO: 1,100
          [Enter the image numbers for which the symbol should be 
          used.]

          .ASSIGN SYMBOLS (Y/N): .....
          [This question reappears until you answer "N".]

          .LOWER THRESHOLD FOR DISTANCES: 0.0001
          [Images with a distance lower than this threshold are
          considered identical and only one of a set of identical
          images is used in the algorithm; the others are excluded,
          enter 0 if you want to keep all elements.]

          .DEFINE STARTING 2-D DISTRIBUTION:'<BR>'
          [(1) GIVEN EIGENVECTOR PROJECTION'<BR>'
           (2) RANDOM DISTRIBUTION'<BR>'
           (3) EIDENVECTOR PROJECTION WITH MINIMAL STARTING ERROR.'<BR>'
           (4) READ START DISTRIBUTION IN FILE COD001'<BR>'

          .START:(1)GIVEN,(2)RANDOM,(3)MIN.ERR.,(4)READ: 1
          [Enter the kind of start distribution you want.(will be changed !!!)]
          

          .RELATIVE AXES OF START PROJECTIONS: 1,2
          [If you entered '1' above for "GIVEN", the program asks
          for the map you want to start with.  The numbers entered
          correspond to the position of the numbers entered for
          "FACTOR NUMBERS".  (Here the starting map will be factor 1
          versus factor 3.)]

          .NUMBER OF ITERATIONS: 40
          [Give the number of iterations which should be done, if
          the error never becomes less than epsilon.  If in any
          iteration step prior to the given one the error was less
          than in the last iteration, the program continues until
          the error is less than or equal to the smallest previous
          error.  However, there is an absolute limit of 200 iterations.]

          .EPSILON: 0.001
          [Enter the value of the remaining error when the iterations
          should stop.  This value may be 0. because the program has 
          additional controls to limit the number of iterations.]

          .EXPONENT IN ERROR: 0.0001
          [Enter the exponent, in the formula given above, of the
          error.  An exponent close to 1 means a stronger weight
          for the small distances; a value close to 0, a higher
          weight for the long distances.  Normally in the first run
          one should use an exponent << 1. Instead of 0 use a very
          small value e.g. 0.00001, because the exponentiation in 
          VAX-Fortran sometimes does not tolerate an exact 0]

          .2D FILE: COD001
          [Document file in which the coordinates of the nonlinear map
          will be stored.  It can be used as input for another 
          nonlinear mapping process, or from a previous run.  The file
          is then overwritten with the new result. Also usable as input
          to CA VIS (visual map)]

          .MAP FILE: MAP001
          [Enter the name of the file where the map will be displayed.]

          .PAGES: 2
          [Enter size of map:  1x1 or 2x2 pages.]

NOTES:    Details may be found in: M. Radermacher & J. Frank,
          Ultramicroscopy,17,(1985), 117-126, (erratum: Ultramicr. 19
          (1986), p75

SUBROUTINES: MRDEV,DIST2D,DISTLST,DISTTST,MRNLSTRT,NLCLUSRD,NONLMAP,
             STRTDIS,NLTFILE

CALLER:      UTIL1
