
CA SI     Correspondence AnalysiS - Initialize                  CA SI   
                                                             08/22/97

PURPOSE:  First part of CORAN or PCA:
          Creates sequential file from image set, to be used in
          Correspondence Analysis - CORAN, or Principal Component 
          Analysis - PCA, ('CA S').
          This sequential file contains:           '<BR>'
          1. all image data within the mask array, '<BR>'
          2. the mask address array,               '<BR>'
          3. the image identifications.            '<BR>'

SEE ALSO: CA MAP (Correspondence Analysis - nonlinear mapping)
          CA S   (Correspondence Analysis - find solution)           
          CA SM  (Correspondence Analysis - factor map)
          CA SME (Correspondence Analysis - factor map and Eigen Values)
          CA SR  (Correspondence Analysis - full reconstitution of images)
          CA SRD (Correspondence AnalysiS - reconstitute differential images)
          CA SRI (Correspondence AnalysiS - reconstitute importance images)
          CA SRP (Correspondence Analysis - PCA reconstitution)
          CA VIS (Correspondence Analysis - Create visual map)
  
USAGE:    CA SI

          .ENTER IMAGE FILE TEMPLATE : SEC***
          [Enter a file name template identifying the image series 
          to be analyzed.]

          .ENTER IMAGE NUMBERS: 1-40,45,50-70
          [Self-explanatory.  If the data are supplied as a 3D
          stack, then the numbers are interpreted as slice numbers.
          If the 'R' (Random) option is used (see below), then
          the total number of images to be created is determined
          by the sequence entered here, although only the first
          file need be supplied.]

          .MASK FILE: MAS002
          [Enter the name of the file containing the mask.  Only
          image pixels where mask pixels are greater than 0.5 are
          analyzed in CORAN and PCA.
          The mask address array is stored as part of the sequential
          file. It allows the user to recover the original [masked]
          images or to reconstitute images using selected factors
          (see also 'CA SR'). 
          Current limitation for total number of pixels in mask: 4000.]

          .SEQUENCE FILE: SEQ001
          [Enter the name of the sequential file where data are
          to be stored.]

          .ALL FILES EXIST (Y/N), (I)NV, (R)ANDOM: Y
          [Options are read in as string; e.g., 'YI' or 'NR'.            '<BR>'
          If all files in the sequence specified exist, enter 'Y'.       '<BR>'
          If there are any gaps, enter 'N'.                              '<BR>'
          The 'I' option is used to invert the contrast of the images
          as they are being read in.                                     '<BR>'
          The 'R' option is used to create an image set by successive 
          random permutations, starting with the first image.  Only the
          first image of the sequence needs to exist; it is the only
          one used in this computation.]

       If 'R' is specified, the system asks an additional question:

          .SHUFFLE FACTOR: 1.5
          [Randomization is achieved by specification of a shuffle 
          factor > 1. The total number of permutations in going from 
          one image to its successor is equal to the number of pixels 
          in the mask times the shuffle factor.  A shuffle factor of 1
          is not normally sufficient to eliminate correlation in the
          X direction.  Suggested value is 2.]          

          .ADDITIVE CONSTANT: 0.0
          [If your images have negative values, this can be corrected by 
          specifying an additive constant that will be added to all 
          (within-mask) pixels of all images]. The smallest additive 
          constant needed to achieve positivity will be printed. Unlike
          CORAN, PCA does accept negative pixel values (in images); thus, 
          it is not necessary to add a constant (although it will be 
          displayed).

NOTES:    The next operation in the Correspondence Analysis (and PCA) 
          sequence is 'CA S', the actual run of the factor analysis.

SUBROUTINES: JPMSK1

CALLER:      UTIL1
