
CA SME     Correspondence Analysis - Factor Map and Eigen Values  CA SME   
                                                             4/1/96

PURPOSE:  Print selected factor map and/or list of eigenvalues.

SEE ALSO: CA MAP (Correspondence Analysis - nonlinear mapping)
          CA S   (Correspondence Analysis - find solution)           
          CA SI  (Correspondence AnalysiS - initialize)
          CA SM  (Correspondence Analysis - factor map)
          CA SR  (Correspondence Analysis - full reconstitution of images)
          CA SRD (Correspondence AnalysiS - reconstitute differential images)
          CA SRI (Correspondence AnalysiS - reconstitute importance images)
          CA SRP (Correspondence Analysis - PCA reconstitution)
          CA VIS (Correspondence Analysis - Create visual map)
    
USAGE:    CA SME

          .(I)MAGE OR (P)IXEL: I
          [Enter 'I' if you wish to have a map of images, and 'P'
          for a map of pixels.  For the 'CA SME' option. if only the
          list of eigenvalues is desired enter <return>.]

          .COORDINATE FILE CODE, NO. OF HOR. PATCHES: 2,0
          [Enter the CODE number identifying the three sequential files
          to store the output from the previous 'CA_S' run: IMC00#,
          PIX00#, EIG00#.  
          The number of horizontal patches does not need to be 
          specified, UNLESS this particular CORAN analysis
          was done on a set of correlation patch averages.  In this
          case, a small lookup map is printed on the sheet
          preceding the actual map, which helps you trace the image
          numbers back to the patches they originated from in the 
          image field.  E.g., a set of 18 patch averages originating 
          from 3 rows of 6 patches each would require the input 
          NO. OF HOR. PATCHES = 6, and this would yield the lookup map:
                                                       '<BR>'
                        1  2  3  4  5  6               '<BR>'
                        7  8  9 10 11 12               '<BR>'
                       13 14 15 16 17 18 ]             '<BR>'

          .'ENTER 2 FACTOR NUMBERS (e.g: 1,5): 1,4
          [Enter the number identifying the factors for which the map
          is to be printed.  Factor 1 is the first non-trivial factor.]

          .(S)YMBOL, (A)SSIGN SYMBOL, (C)LASS, (D)OC, (I)D: I

          [Enter 'S' if you want to enter a character symbol for
                     each active image;               '<BR>'
           Enter 'I' if you want the numbers identifying the images
                     or pixels to be printed. (this is the standard 
                     option for a CORAN map);]
          
    If 'S', then:

          .ENTER 1 CHAR. SYMBOL FOR ACTIVE IMAGES:
     
           [The following additional options are for images only:'<BR>'
            Enter 'A' if you want to assign symbols to specific 
                      ranges of ID numbers.               '<BR>'
            Enter 'C' if you want the class number of the image to
                      appear as symbol (in this case, a classification file
                      from a previous run of 'CA CLA' must be available); '<BR>'
            Enter 'D' if you want to supply a specific symbol for each
                      image. (in this case, a document file must be supplied
                      that specifies the symbol lookup)]. 
  
          .'PREPARE CONTOUR METAFILE FOR MAP? (Y/N/O): Y
          [Option 'Y' prepares a contour metafile containing the map. 
           Option 'N' lists map in RESULTS file only. Option 'O' 
           prepares an contour plot metafile using an obsolete method
          which closely mirrors the data as shown in the results file.] 

 
      If the answer is "N" or "O' the following questions appear. 

          .NUMBER OF PAGES (1,2,3) OR <CR>=1: 2
          [Specify number of pages for the map.] 

          .NUMBER OF LINES OR <CR>: <return>
          [Default: horizontal space, known from the number of pages, 
           is used to determine the number of lines. Enter a number 
           if you want to override the default.] 

       For all answers, the following three questions appear: 

          .NUMBER OF SD OR <CR>=2.3: <return>
          [The map is truncated for efficient visualization of the
          data cloud.  Normal cutoff is set at 2.3 x standard 
          deviation.  Outliers outside the map are listed along with
          their coordinates, and printed exactly on the border.]

          .1=FLIP #1/ 2=FLIP #2/ 3=FLIP 1+2/ <CR>=NO FLIP: 
          
          .TITLE: 70S ribosomal subunits in overlap range
          [The title will appear on the top of the map.]

    In case the 'C' option was selected, the name of the
    classification file will be solicited:

          .CLASS FILE: CLU002

    In case of 'A' option:
          .SYMBOL: X
          [enter symbol]

          .Until ID #: 320
          [Enter upper limit up to which the symbol should be used]

          .SYMBOL: y
              .
          .UNTIL ID #: 320
              .
          [The questions continue until 0 or <ret> is entered for
           ID #.]

    In case the 'D' option was selected, the name of the document
    file containing the symbol lookup will be solicited:

          .LOOKUP FILE: DOC001

          [the document file should contain a sequential key, the
          original image ID number (=Register 1), and the standard
          Fortran code number of the ASCII character to be used
          as symbol (=Register 2)].

    If a plot line printer orinted plot map is desired the following
    question will appear:

          .ENTER FILE NAME FOR THIS MAP PAGE: MAP001

    If a contour plot metafile map was requested the following
    questions  will appear:

          .ENTER NAME FOR THIS MAP PAGE FILE: MAP001
          [If the answer is "O' the name of the map file will be          solicited for each page of the line printer oriented map.]

          .TEXT SIZE FOR AXIS AND DATA (USE <CR> FOR DEFAULT = 24):24 48
          [Allows control over text size if the output device 
          supports this option.  A size of 24 is a reasonable
          default.]

          .ENTER X AXIS OFFSET:0

          Bounds for X axis of plot listed.

          .ENTER NEW LOWER, UPPER AXIS BOUNDS OR <CR>: <CR>
          [Can change y axis bounds or keep default by entering
          <return>.]

          X axis label units listed.

          .ENTER NEW AXIS LABEL UNIT AND TICKS / LABEL OR <CR>: <CR>
          [Can change X axis label unit or keep default]

          .ENTER LABEL NO. TO EDIT. USE 0 FOR LABEL: 1
          -1 TO RELIST ALL LABELS, OR <CR> TO CONTINUE: <CR>

          Bounds for Y axis of plot listed.

          .ENTER NEW LOWER, UPPER AXIS BOUNDS OR <CR>: <CR>

          .ENTER Y AXIS OFFSET: 0 

           Y axis label units listed.

          .ENTER NEW AXIS LABEL UNIT AND TICKS / LABEL OR <CR>: <CR>

          .ENTER LABEL NO. TO EDIT. USE 0 FOR LABEL: 1
          -1 TO RELIST ALL LABELS, OR <CR> TO CONTINUE: <CR>


NOTES:  1. The list of eigenvalues, their percentages, and cumulative 
           percentages will be written on the terminal.  IMPORTANT: 
           if the operation 'CA S' was used with the 'Project' option 
           (i.e., inactive co-projection of one image set into the 
           factor space spanned by another image set), then is no 
           eigenvector file with the file code specified, and
           option 'CA SME' cannot be used.

        2. Use 'CS DI PO' or WEB to display the contour metafile.

SUBROUTINES: SGRAF, SGRAF1, HISMAP, HISMAP4, BORNS, 

CALLER:      UTIL1

