
CA SRI    Correspondence Analysis - Reconstitute Importance images    CA SRI
                                                                       08/21/96
          
PURPOSE:  Compute importance image for a selected factor.
          The suboption '/C' refers to a cluster coordinate file.  In this
          case, the center of gravity coordinates of stable clusters
          found by 'CA CLA' or other classification operations are 
          used. 

SEE ALSO: CA MAP (Correspondence Analysis - nonlinear mapping)
          CA S   (Correspondence Analysis - find solution)           
          CA SI  (Correspondence AnalysiS - initialize)
          CA SM  (Correspondence Analysis - factor map)
          CA SME (Correspondence Analysis - factor map and Eigen Values)
          CA SR  (Correspondence Analysis - full reconstitution of images)
          CA SRD (Correspondence Analysis - reconstitute differential images)
          CA SRP (Correspondence Analysis - PCA reconstitution)
          CA VIS (Correspondence Analysis - Create visual map)
    
USAGE:    CA SRI        [optional: /C]
         
          .ENTER FILE TEMPLATE (EG. PIC****): TST***
          [Enter the template forthe file or file series to be
          created.]

          .ENTER FILE NUMBERS (EG. 1-8,12-22,55): 1-80,90-95
          [Numbers are consecutive, and refer to the sequence of
          files specified in 'CA S'.  However, in the case of
          the cluster option (/C), the numbers refer to the cluster
          numbers, and are restricted to the range of these numbers]
          
       For the /C option, specify a cluster file:

          .CLUST  FILE: CLU003
          [Enter cluster coordinate file created by previous 
          'CA CLA' run or other classification operations.]
   
          .COORDINATE FILE CODE: 2
          [Enter the number identifying the three files used to store 
          the output from the previous 'CA S' run: IMC#, PIX#, EIG#.]

       The following factor selection is NOT supported for /C option:

          .ENTER FACTORS TO BE USED: 2-4
          [Enter the factors to be used for image reconstitution.
          Note that the numbers have to be less that the number of
          images and less than or equal to the number of factors
          originally specified in 'CA S'.]
          
          If there is no existing image with the number given above, in
          response to ".ENTER FILE NUMBERS", then coordinates are solicited 
          for each of the factors specified:  

          .ENTER COORDINATES FOR EACH FACTOR SELECTED: 0.0013, -0.0011,
          0.0004
          [Enter coordinates related to the scales of the factorial axes
          in the Results file from 'CA S' or from factorial maps produced
          by 'CA SM' or 'CA SME'.]   

NOTES: 1. The "importance image" obtained by using 'CA SRI' has both 
          positive and negative values.  To obtain the more familiar 
          pair of complementary positive-definite importance images
          used in the earlier literature (e.g. Frank et al., 1982), 
          follow this operation by 'TH' (threshold), specifying '0' 
          as the lower or upper threshold, respectively.  
          Then invert contrast of the latter thresholded image.

       2. For a detailed explanation of concepts used here see:
          J.P. Bretaudiere and J. Frank (1986)'<I>' J. Microscopy'</I>' 144:1-14. 
          Importance images are defined in J. Frank and M. van Heel
          (1982)'<I>' J. Mol. Biol.'</I>' 161:133-137.

SUBROUTINES: JPMSK2,RECDUM,RECONS,SRIPE,MSKDEC

CALLER:      UTIL1
