
CC C      Cross Correlation Coefficient                           CC C      
                                                               12/6/96

PURPOSE:  Computes the correlation coefficient and Euclidean distance
	  between two pictures by direct computation.
          The precise area to be compared is defined
          by a mask function (elements > 0.5 define the pass region).
          The dimensions of the images and the mask function have to 
          be equal. Optional register output can be requested.
          Pictures can be 2D or 3D.

SEE ALSO: AC  (auto correlation)
          CC  (cross correlation)
   
USAGE:    CC C,X10,X11,X12,X13,X14,X15
          [Meaning of registers in order of position:             '<BR>'
                X10  cross-correlation coefficient                '<BR>'
                X11  average of image #1 within mask              '<BR>'
                X12  standard deviation of image #1 within mask   '<BR>'
                X13  average of image #2 within mask              '<BR>'
                X14  standard deviation of image #2 within mask]  '<BR>'
                X15  Euclidean distance                           '<BR>'

          .INPUT1 FILE: PIC001
          [Enter the name of the first image]

          .INPUT2 FILE: PIC002
          [Enter the name of the second image file]

          .MASK FILE: MSK001
          [Enter the name of the mask file defining the area to
          be compared]

          [Terminal output consists of:

            average of image #1 over mask,               '<BR>'
            average of image #2 over mask,               '<BR>'
            standard deviation of #1 over mask,          '<BR>'
            standard deviation of #2 over mask,          '<BR>'
            correlation coefficient,                     '<BR>'          
            Euclidean distance.]

SUBROUTINES: CCC

CALLER:      CORR1
