
CE GNC    Contrast Enhancement - Graduated Non Convex restoration  CE GNC
                                                          12/27/93

PURPOSE:  Applies graduated non-convex restoration algorithm to an image.


SEE ALSO: CE      (Contrast enhancement)
          CE FIT  (Contrast enhancement - fit histogram)
          CE MED  (Contrast enhancement - using median filtering)

USAGE:    CE GNC

          .INPUT FILE: PIC001
          [Enter name of picture to be processed.]

          .OUTPUT FILE: PIC002
          [Enter name of file receiving the output picture.]

          .LAMBDA: 3
          [The parameter LAMBDA is a characteristic length or 'scale'.
           The lower LAMBDA, the finer the structure that is found.]

          .H0: 0.02
          [The ratio H0 [=sqrt(2*alpha/LAMBDA)] is a 'contrast' sensitivity
           threshold determining the minimum contrast for detection of an
           isolated step edge. A step edge in the data counts as isolated
           if there are no features within a distance LAMBDA of it.]

          .EPS: 0.00000001
          [EPS indicates the accuracy of restoration. The smaller EPS,
           the longer computation time. Reasonable results can be obtained
           for EPS<=0.0000001]

NOTES:    1. The ratio g=H0/(2*LAMBDA) is a limit on the gradient above which
          spurious discontinuities may be generated. If the gradient
          exceeds g, one or mores discontinuities may appear in the
          fitted function.
         
          2. The parameter alpha is a measure of immunity to noise. If the
          mean noise has standard dev. sigma, then no spurious
          discontinuities are generated provided alpha>2*sigma**2,
          approximately.

          3. This program is highly recommended for restoration of noisy pictures.
          It applies a graduated non-convex algorithm to find the solution
          of the weak continuity constraints problem for a given picture. Weak
          continuity constraints prefer continuity, but allow occasional
          discontinuities if that makes for a simpler overall description.
          For a detailed discussion of the method and parameters values
          look in '<I>'Visual Reconstruction'</I>', Andrew Blake & Andrew Zisserman.
          (Available in NYS Library)

          4. Implemented by: Paul Penczek.

SUBROUTINES: GNC, GNC2S, GP, ERC

CALLER:     UTIL2
