
CG        Center of Gravity                                 CG      
                                                            8/22/97

PURPOSE:  Compute coordinates of center of gravity of an image with
          respect to the image center (at NSAM/2 + 1, NROW/2 + 1).

SEE ALSO:  CG 3   (center of gravity - radius of gyration)
           CG 3S  (center of gravity - solid body)
           CG PH  (center of gravity - phase approximation)

USAGE:    CG X10,X11

          .INPUT FILE: PIC001
          [Enter name of image file.]

          .THRESHOLD: 0.23
          [Enter a threshold T. The center of gravity is evaluated
          for the following function:

          '<PRE>'
           D(K,I)-T        for D(K,I) greater or equal to T

               0           elsewhere.]
          '</PRE>'

NOTES:    The coordinates of the center of gravity are printed out,
          and are put into the optional registers appearing in the
          command line.

          EXAMPLE: To shift an image into its center of gravity 
          computed for a threshold of T=0.23, one could use the 
          following command sequence:
          '<PRE>'
          CG X10,X11
          PIC001
          .23
          SH
          PIC001
          SHI001
          -X10,-X11
          '</PRE>'

SUBROUTINE: CENGRA

CALLER:     UTIL1
