
CI        Confidence Interval                               CI      
                                                            7/24/89

PURPOSE:  Computes the confidence interval for each point of an 
          average image resulting from adding a particle series.  Input
          are the error probability of the confidence interval and the
          average and variance files.  (Source: Haenicke, MPI Goettingen.)

SEE ALSO: EP (Error probability)

USAGE:    CI
          
          .AVERAGE: AVA001
          [Enter the name of the file containing the average 
          of each averaged image point.  This is obtained by
          using operation 'AS'.]
          
          .VARIANCE: STD001
          [Enter the name of the file containing the variance
          of each averaged image point.  This is obtained by
          using operation 'AS R'.]
          
          .UPPER LIMIT OUTPUT FILE: UCI001
          [Enter the name of the file to receive the upper limit for
          confidence interval associated with the estimated mean for
          the choice of the error probability.]
          
          .LOWER LIMIT OUTPUT FILE: LCI001
          [Enter the name of the file to receive the lower limit for
          confidence interval associated with the estimated mean for
          the choice of the error probability.]

          .NUMBER OF FILES ADDED: 56
          [Enter the number of images added when the average image
          was formed.]

          .ERROR PROBABILITY IN %: 5
          [The error probability in % for confidence interval.]

NOTES:    For an elementary introduction into the theory of 
          statistical inference, see (e.g.) P. Armitage, '<I>'Statistical
          Methods in Medical Research'</I>', Blackwell Scientific
          Publications, p99ff. (WCL&R Library:  19.A77)

SUBROUTINE: CONF, NORPPF

CALLER:     CONF1
