
CL CLA    CLAssification - Clusters                           CL CLA   
                                                              8/22/97

PURPOSE:  To find clusters of images in factor space (or a selected 
          subspace) by using Didat's method of moving centers, and  
          to apply hierarchical ascendant classification (HAC) to   
          the resulting cluster centers.                            

SEE ALSO: CL HC    (CLassification - Hierarchical clustering)
          CL HD    (CLassification - Hierarchical clustering, calculate classes)
          CL HE    (CLassification - Hierarchical clustering, create doc files)
          CL KM    (CLassification - K Means clustering) 

USAGE:    CL CLA   

          .INPUT FILE CODE: 6                                         
          [enter number of the IMC file previously created by       
          CORAN85, which contains the image coordinates in factor   
          space]                                                    

          .CLUSTER FILE: CLU001                                       
          [enter name of cluster file where cluster and             
          classification parameters are put for later reference]    

          .FACTORS TO BE USED: 1-3,6-8                              
          [enter factors to be used in the cluster search]          

          .# OF ITER./PART., # OF CENTERS/PART.: 5,8                
          [enter number of iterations per partition, NIP (default=5)     
          and number of centers, NS ("seeds") per partition (default=5)]

          .# OF PARTITIONS: 3                                       
          [enter number of partitions, NP (default=4)]

          .ENTER SEED INTEGER (0=RANDOM DRAW): 0
          [If you wnat to precisely duplicate a previous run, you
           mutst enter the seed used in that run.]

          .PERCENT FOR CLASS CUTOFF (0=NO CUTOFF): 2.4
          [Only classes with equal or higher percentage of numbers are
           used in HAC.]

          .DO YOU WANT DENDROGRAM PLOT FILE (Y/N): Y
          [If the answer is "Y" a dendrogram plot metafile will be
           made.]
        
    If the answer is "Y" the name of the plot metafile will be 
    solicited:

          .ENTER FILE NAME FOR DENDROGRAM: DEN001

          .DO YOU WANT DENDROGRAM DOC FILE? (Y/N): Y
           [Allows preparation of a document file containing the
           dendrogram tree.]

    If the answer is "Y" the name of the document file will be 
    solicited:

          .DOCUMENT FILE:   DOC000
          
          .DO YOU WANT THE CLUSTER DOC FILE? (Y/N): Y
           [Allows preparation of a cluster document file for
	    hierarchical clustering.]

    If the answer is "Y" the name of the document file will be 
    solicited:

          .DOCUMENT FILE:   DOC001
          

NOTES: 1. The RESULTS file contains the following information:'<BR>'

          A) Aggregation history:'<BR>'
          For each of the NP partitions, the NS seeds and sizes of
          clusters are listed.  The non-empty clusters in the crossed  
          partion are given by size and cummulative percentage.  A 
          total of NS**NP clusters are possible, but in practice, only
          10% of these are non-empty. '<BR>'

          B) Description of hierarchy nodes in HAC:'<BR>'
          The nodes are numbered starting from the number of the highest
          cluster.  For each node, the Senior, Junior, size, weight
          and hierarchy index are given.  The hierarchy index is printed
          out as a histogram.'<BR>'

          C) Description of the hierarchy classes:'<BR>'
          For each node the constituent classes are listed.'<BR>'

          D) HAC Dendrogram:'<BR>'
          The class relationships are represented in the form of a     
          dendrogram (tree structure).  The lengths of the branches (in
          horizontal print direction) are proportional to the heirarchy
          indices.'<BR>'

          E) List of class members:'<BR>'
          The members are listed for each of the basic non-empty classes.
          '<BR>'
          F) List of class center coordinates:'<BR>'
          For each class, the NFAC coordinates of its center is listed.
          These are contained in the cluster file.'<BR>'

          G) Re-classification lookup table:'<BR>'
          Each cutoff point in the dendrogram, from right to left, defines
          a new classification scheme with the number of classes increasing
          by 1 each time.  The table gives the new class memberships for
          any cutoff point selected.'<BR>'


       2. The algorithm underlying this set of programs is described by
          Lebart et al., '<I>'MULTIVARIATE DESCRIPTIVE STATISTICAL ANALYSIS,
          '</I>'J. Wiley and Sons, New York 1984, Chapter V, p.109.

       3. To display the plot use 'CS DI **' and enter the name
          of the plot metafile.


SUBROUTINES: SCLASSI, SCLASSY, SEMIS, NOYAU, CHAVA, DEUCL, RGRI,
             RCLU, DENDRO, ARBRE, PARST, STABK, SHELK, COUPE, CLAST,
             RETIR, SEN3A, CLUSTERLST

CALLER:      UTIL1
