
CL HC     CLassification - Hierarchical Clustering            CL HC   
                                                           08/22/97

PURPOSE:  Performs hierarchical clustering according to one of several
          clustering criteria, on factors produced by CORAN.

SEE ALSO: CL CLA   (CLassification - Clusters)
          CL HD    (CLassification - Hierarchical clustering, calculate classes)
          CL HE    (CLassification - Hierarchical clustering, create doc files)
          CL KM    (CLassification - K Means clustering)
 
USAGE:    CL HC

          .ENTER DATA FILENAME TYPE (SEQ(1), IMC(2) or PIX(3)): 2
          [Enter type of input file name.  All three types files are produced
          by CORAN/PCA.  Type 1 means that classification will be performed
          on the sequential image data; type 2, on image factor coordinates;
          type 3, on pixel factor coordinates.]

          .IMAGE COORDINATES FILE CODE: 1
          [Enter the code number of the IMC file created by CORAN.]

          .FACTOR NUMBERS: 1,3,4,6
          [Enter the factors to be included in the hierarchical clustering 
          algorithm.]

          .FACTOR WEIGHT: 1.5
          [Enter a weight for each factor selected. If the answer zero is
          given at any point, all weights from the current factor onwards 
          are set to one. This question is asked as many times as the number 
          of factors specified, or is terminated by the answer zero.]

          .CLUSTERING CRITERION (1-5): 2
          [Enter the number indicating clustering criterion to be
          used. Possible choices are:                               '<BR>'
          Option 1: single linkage                                  '<BR>'
          Option 2: complete linkage                                '<BR>'
          Option 3: average  linkage                                '<BR>'
          Option 4: centroid method                                 '<BR>' 
          Option 5: Ward's method                                   ]

          .DO YOU WANT DENDROGRAM PLOT FILE? (Y/T/N): T
          [Y - the whole dendrogram will be produced                '<BR>'
           T - truncated dendrogram will be produced (useful for
               large number of objects                              '<BR>'
           N - no dendrogram                                        ]

    If answer is Y or T then:

          .DENDROGRAM FILE: MAP001
          [Enter name of file where the dendrogram will be stored.]

    If truncated dendrogram was requested:

          .ENTER PLOT CUTOFF: 12.3
          [Enter the cutoff number at which the dendrogram will
          be cut. Only top portion will be produced. This number must
          be taken from the RESULTS file from the previous run and
          must be in the range of the scaling of the dendrogram tree.
          This range is written in the line under the tree in the
          RESULTS file.]

          .DO YOU WANT DENDROGRAM DOC FILE? (Y/N): Y
          [ Y - the document file will be produced containing
          information about classification tree. Using this
          information, one can retrieve the clustering behavior  
          for any number of groups.]

    If previous answer was Y, then:

          .DOCUMENT FILE: MAP001
          [Enter the document file name where the dendrogram information
           will be stored.]

NOTES: 1. To get the classification on a given "cutting" level use
          command 'CL HD'.

       2. To get the selection doc files corresponding to the given "cutting"
          use command 'CL HE'.

       3. To calculate averages for the classes use command 'AS DC' and
          selection doc. files.

       4. Implemented by P. Penczek.

SUBROUTINES: HCLS, HCLP, DIST_P

CALLER:      UTIL1
