
CL HD     CLassification - Hierarchical clustering, calculate classes CL HD
                                                                       08/19/96

PURPOSE:  Calculates number of classes for given threshold, after CL HC. 

SEE ALSO: CL CLA   (CLassification - Clusters)
          CL HC    (CLassification - Hierarchical clustering)
          CL HE    (CLassification - Hierarchical clustering, create doc files)
          CL KM    (CLassification - K Means clustering) 

USAGE:    CL HD

          .THRESHOLD (0-1): 0.2

          .DENDOGRAM DOCUMENT FILE: DND102
          [Enter the document file name containing information about
          classification tree (produced by CL HC).]

          .DOCUMENT FILE: CLAS02
          [Enter the document file name which will contain number
          of objects belonging to every class.]

NOTES: 1. This command uses output from CL HC and works only in conjunction
          with hierarchical clustering.

       2. To get the selection doc files corresponding to the given "cutting"
          use command CL HE.

       3. To calculate averages for the classes use command AS DC and
          selection doc files.

       4. This command implements the following batch program:
          '<PRE>'
                ;
                ; X51 - "cutting" level taken from the tree
                ;X51=0.585
                X51=0.4
                ; # OF OBJECTS IN A GROUP
                X41=0.0
                ; # OF GROUPS
                X42=1.0
                X55=1.0
                ; HCLAS - document file produced by CL HC
                UD IC,X55,X31,X32
                HCLAS
                X41=X41+1.0
                DO LB1 I=2,838
                UD IC,X0,X21,X22
                HCLAS
                IF(X32.LT.X51) GOTO LB2
                SD X42,X41
                CLASA
                X42=X42+1.0
                X41=1.0
                X32=X22
                IF(X41.EQ.1.0) GOTO LB1
                LB2
                X41=X41+1.0
                X32=X22
                LB1
                ;
                ;  CLASA contains number of objects in each class
                SD X42,X41
                CLASA
                EN
          '</PRE>'

       5. Implemented by P. Penczek.

SUBROUTINES: HDLS

CALLER:      UTIL1
