
CL HE     CLassification - Hierarchical clustering, create docfiles   CL HE
                                                                       08/19/96

PURPOSE:  Creates selection docfiles for a given threshold. 

SEE ALSO: CL CLA   (CLassification - Clusters)
          CL HC    (CLassification - Hierarchical clustering)
          CL HD    (CLassification - Hierarchical clustering, calculate classes)
          CL KM    (CLassification - K Means clustering)
 
USAGE:    CL HE

          .THRESHOLD (0-1): 0.2

          .DENDOGRAM DOCUMENT FILE: DND102
          [Enter the document file name containing information about
          classification tree (produced by CL HC).]

          .ENTER TEMPLATE FOR SELECTION DOC FILE: GRP***
          [Enter the template for selection document file names which will
          contain numbers of objects for every class. Thus, for example,
          selection document file GRP012 will contain number of images
          belonging to class 12 at a threshold 0.2.]


Notes: 1. This command uses output from CL HC and works only in conjunction
          with hierarchical clustering.

       2. To calculate averages for the classes, use command AS DC and
          selection doc files.

       3. This command implements the following batch program:
          '<PRE>'
                ; HCLASS - retrieving of groups on a given level
                X51=0.42
                ; # OF OBJECTS IN A GROUP
                X41=0.0
                ; # OF GROUPS
                X42=1.0
                X55=1.0
                UD IC,X55,X31,X32
                HCLAS2
                X41=X41+1.0
                SD X41,X31
                GRPX42
                DO LB1 I=2,838
                UD IC,X0,X21,X22
                HCLAS2
                IF(X32.LT.X51) GOTO LB2
                SD X42,X41
                CLASD
                X42=X42+1.0
                X41=1.0
                SD X41,X21
                GRPX42
                IF(X41.EQ.1.0) GOTO LB1
                LB2
                X41=X41+1.0
                SD X41,X21
                GRPX42
                X32=X22
                LB1
                SD X42,X41
                CLASD
                EN
          '</PRE>'

       4. Implemented by P. Penczek.

SUBROUTINES: HELS

CALLER:      UTIL1
