
CN        CoNvolution                                       CN      
                                                            09/10/96

PURPOSE:  Computes the convolution product of two pictures by using
          the Fourier transform relationship.
          Operation CN works for 2D as well as 3D input data.
          The dimensions of the pictures must correspond to each
          other.  The dimensions need not be powers of two
          (see FT for restrictions).

SEE ALSO:  CN N   (CoNvolution - Normalized)
           CC     (Cross Correlation)
           CC N   (Cross Correlation - Normalized)
           AC     (Auto Correlation)
           AC N   (Auto Correlation - Normalized)
           CC C   (Cross Correlation Coefficient)

USAGE:    CN

          .INPUT FILE: PIC001
          [Enter the name of the first picture.]

          .REFER FILE: REF001
          [Enter the name of the second picture, which is used as the
          reference.]

          .OUTPUT FILE: CNF001
          [Enter name of the file which will contain the convolution
          coefficients. It can be the same as the input file.  In this case
          INPUT FILE will be replaced by the convolution.]


NOTES: 1. The type of the input data can be real or Fourier in any 
          mixed form.

       2. The convolution data are not scaled.

       3. The origin of the CNF is at (NSAM/2 + 1, NROW/2 + 1).

       4. The convolution product contains artifacts from 
           wrap-around overlaps implicit in the Fourier computation.
           However, the convolution product is artifact-free
           within                                                '<BR>'
                  -L <= K <= +L                                  '<BR>'
                  -M <= I <= +M                                  '<BR>'
           if the pictures are surrounded by frames containing
           the average, where the frame width is M/2 and the
           frame height is L/2.
           The complete artifact-free convolution product is
           obtained for the widths M=NROW/2, L=NSAM/2.  In this
           case, the padded pictures are just twice as large in
           each dimension as the original pictures.

       5. Note that RC (Real Convolution) offers an 
           alternative to Fourier computation of the convolution
           product.  RC should be used if the width of the point
           spread function is small (.le. 15).

       6. If the data cannot fit into the memory use the 'FT' and 'MU'
          commands to calculate the CNF:
         '<PRE>'
              FT
              INPUT1
              FOUR1
              FT
              INPUT2
              FOUR2
              MU
              FOUR1
              FOUR2
              FT
              FOUR2
              CNF12
         '</PRE>'
         '<STRONG>'Warning'</STRONG>': The origin of CNF12 calculated in 
          this way is in (1,1).

SUBROUTINES: CNRS_2, CNRS_2R, CNRS_3, CNRS_3R,
             CNRD_2, CNRD_2R, CNRD_3, CNRD_3R

CALLER:      CORR1



