
CP TO BRIX   CoPy SPIDER volume to BRIX file for O input      CP TO BRIX
                                                               10/10/96

PURPOSE:  Copies a SPIDER-format volume file into a "Brix" file
          file compatible with the MAP_FILE option of the "O" molecular 
          modeling program.  In O, MAP_DRAW produces a wiremesh 
          representation that can be moved interactively using knob 
          controls.  Several objects imported from SPIDER can thus be 
          moved independently.
          
SEE ALSO: 
#include "cp_include.also"

USAGE:    CP TO BRIX

          .SPIDER INPUT FILE: VOL001
          [Enter the name of the SPIDER file containing the
           volume.  Make sure the volume has valid FMIN, FMAX,
           e.g. from a previous display by WEB, or operation 'FS']

          .OUTPUT FILE: VOL001.PREBRIX
          [Enter the name of the map file (formatted for input to 
           map_file option of O) into which you want to copy 
           the volume. Use complete file name (incl. any extension).
           Extension will not be overwritten.]

          .SAMPLING DISTANCE: 5.2
          [Enter the sampling distance, in Angstrom]
          
          .DEFAULT UNIT CELL IS NSAM,NROW,NSLICE. OVERWRITE (Y/N)? Y
          [Enter 'Y' if you wish to overwrite the default dimensions
           given by the dimensions of the volume.  Note that the
           fictitious orthogonal unit cell dimensions are merely used for
           setting up display parameters.]
   
     If you have selected 'Y' as in above example:

          .ENTER UNIT CELL DIMS (X,Y,Z): 80,60,60
          [Enter the cell dimensions]

     If you have not selected 'Y':

           No further input is solicited, and the volume dimensions are
           taken as unit cell dimensions.

NOTE:    1. The origin of the "unit cell" is set at -NSAM/2, -NROW/2, 
            -NSLICE/2.

         2. Upon reading in the map file, O restores the original density
            range of the data based on the values of scale and offset 
            parameters stored in the file's header.  Because of format
            limitations of O, scale and offset will not be read correctly 
            unless the SPIDER file has a density range specified in one or 
            two digits before the decimal point.  Therefore 'AR' (followed by
            'FS') should be used in SPIDER to multiply the volume prior to 
            'CP BRIX' so that the density is pushed into a "safe" range.

         3. J. Frank 4/10/95

SUBROUTINE: COPYBRIX

CALLER:     COPY1


