
CS DI PO  Contour display - convert to Postscript         CS DI PO
                                                            1/30/96

PURPOSE:  Converts contour storage plot metafile to Postscript and
          outputs the file to a printer.

SEE ALSO: CS DI GD  (Contour display - on Gould plotter)
          CS DI PL  (Contour display - convert to HPGL)                      
          CS DI TX  (Contour display - on Tektronix 4662 plotter)
          CS DI VT  (Contour display - on VT125/240 terminal)

USAGE:    CS DI PO      

          .CONTOUR INPUT FILE: CNT001
          [Enter name of an existing plot metafile.  This plot file
          will be opened but the converted Postscript output is not
          not sent to the Postscript file until the "PRI" or "SEN" 
          command is issued.  If a <CR> is entered then no contour 
          file is opened.  If no 
          contour file is opened then the only active commands which
          apply are "LOC", "COM" and "PRI".]

          .POSTSCRIPT FILE: POS001
          [Enter name of Postscript output file where Postscript commands
          will be placed.  If the Postscript output file already exists, 
          new Postscript commands will be appended at end of existing
          file. (Note: appending to existing file does not work on VMS)]

     Further commands are selected from a menu.  The following lines 
     will repeatedly occur:

          Plot Menu (enter MEN to see the choices).
          .Enter Plot Menu Choice: PRI
          [If you just desire a simple default print from your contour 
          file, enter PRI at the first menu prompt.  PRI will convert 
          the contours to Postscript commands, store the Postscript 
          commands in the Postscript output file, send the output 
          file to the local printer, and return the user to the main
          SPIDER input prompt.  

          .Enter Plot Menu Choice: MEN
          [When MEN option is chosen the following menu appears:]
          '<PRE>'
          PRI    PRInt Postscript file & return    MEN    display MENu
          RET    RETurn to caller                  

          SCA    set plot scale                    CNT    new contour file
          COM    add comment                       SEN    send data to 
          LOC    set location                                post file

          FLI    FLIP top & bottem                 FRA    display frame
          INZ    invert Z order                    LAB    show LABels
          CEN    CENter plot                       HID    HIDden lines
          FIL    FILled contours                   TEX    print TEXt
          '</PRE>'


    If Plot Menu Choice is CNT, Spider asks:
          
          .PLOT FILE: CNT002
          [Enter name of an existing plot metafile.  This plot file
          will be opened but the contents are not sent to the 
          Postscript file until the PRI or SEN command is given.  
          This command is used for combining further contour plots 
          into a single current Postscript plot.]

     If Plot Menu Choice is SEN:
          [Converts current contour plot to Postscript commands and
          places commands in Postscript output file according to current
          values of any modifier toggles (see below).]

     If Plot Menu Choice is LOC, Spider asks:

          .X & Y COOR. (0..1000 WITH ORIGIN AT UPPER LEFT): 100 200
          [Sets the current location in Postscript output file.  This
          command is useful for positioning added text in Postscript
          file.]

     If Plot Menu Choice is COM, Spider asks:
          
          .COMMENT (OR <CR> FOR NONE): This is a comment
          [Places a comment in the current Postscript output file at
          the current location.]

     If Plot Menu Choice is SCA, Spider responds 
     CURRENT SCALING FACTOR (% OF FULL PAGE): 95, and asks:
 
          .Enter new scaling factor or <CR>: 80
          [Current scaling or magnifaction of the contour plot is
          listed then the user is asked to input new scaling factor.
          The default value is 95%.  The scaling alters the size of 
          contours drawn in the Postscript output file by following 
          SEN or PRI commands.]

     If Plot Menu Choice is CEN:
          [Toggles centering of contour plot from default (on)
          to off.  This alters the way contours are drawn in the 
          Postscript output file by following SEN or PRI commands.]

     If Plot Menu Choice is HID:
          [Toggles hidden line removal for contours from default (off)
          to on.  This alters the way contours are drawn in the 
          Postscript output file by following SEN or PRI commands.]

     If Plot Menu Choice is LAB:
          [Toggles labeling of contour numbers from default (off)
          to on.  This alters the way contours are labeled when 
          contours are drawn in the Postscript output file by 
          following SEN or PRI commands.]

     If Plot Menu Choice is FIL:
          [Toggles filling inside of contours from default (off)
          to on.  This alters the way contours are filled when 
          contours are drawn in the Postscript output file by 
          following SEN or PRI commands.]

     If Plot Menu Choice is FRA:
          [Toggles drawing of frame outlining plots from default (off)
          to on.  This frame is drawn when contours are drawn in the 
          Postscript output file by following SEN or PRI commands.]

     If Plot Menu Choice is INZ:
          [Toggles inversion of contour order from default (off)
          to on.  This alters the order in which contours are drawn in
          the Postscript output file by following SEN or PRI commands.]

     If Plot Menu Choice is FLI:
          [Toggles mirroring of contours around X axis from default (off)
          to on.  This alters the appearance of contours when they 
          are sent from the contour file to the Postscript output file 
          by following SEN or PRI commands.]

     If Plot Menu Choice is TEX:
          [Toggles text labels appearance from default (on)
          to off.  This alters the existence of any text when text is 
          sent from the contour file to the Postscript output file 
          by following SEN or PRI commands.]

     If Plot Menu Choice is RET:
          [Return the user to the main SPIDER input prompt.  Does not
          convert the current CNT file (if any) to Postscript before
          returning.]

NOTE:     The Fortran code for directing the output to the local printer 
          will have to be altered for your local system.

SUBROUTINES: CNDISP, CNPOST, CNHELP

CALLER:      PLOT1

