DR DIFF   Density Reference - Error & DIFference between two volumes  DR DIFF
                                                                8/25/97

PURPOSE:  Calculates the mean relative error and the discrepancy
          between two volumes within an (optional) mask. A scaling 
          factor and additive constant is determined to scale the second 
          volume such that the errors are minimized. Optionally volume 1
          is subtracted from the scaled volume 2 and the results stored in
          an output volume. (program includes all functions of 'DR ERR')

SEE ALSO: DR      (Density reference)
          DR ERR  (Density reference - error between two volumes)
  
USAGE:    DR DIFF

          .FIRST FILE: 3DR004
          [Enter name of 3-D file]

          .SECOND FILE: 3DR005
          [Enter name of second 3-D file]

          .MASK FILE: MASK001
          [Enter name of mask file or "*" if no mask is to be applied]

       If a mask was specified :
     
          .APPLY MASK TO BOTH, SCALING AND DIFFERENCE/ERROR? (Y/N): Y
          [Specify if the mask should be applied only in the step of
          scaling the two volumes (answer: N) or, besides during scaling
          also during the error calculation and difference volume 
          calculation (answer: Y) ]

          .OUTPUT DIFFERENCE FILE: THREEDDIFFERENCE001
          [Enter file name for difference. Enter "*" if no difference
          volume is desired.]


NOTES:    Error formulas:                                          '<BR>'

          Mean relative error: E=SUM |A*DIJ2-DIJ1-CONST| / SUM |DIJ1-D|'<BR>'
          Discrepancy:  E=SQRT [ SUM ((A*DIJ2-DIJ1)**2)/ SUM ((DIJ-D)**2)]'<BR>'

          DIJ1,DIJ2 voxel values of volume 1 and volume 2.          '<BR>'
          An optimum scaling factor.                                '<BR>'
          CONST offset between the two volumes.                     '<BR>'

          For more details about the error measures see e.g.:
          Colsher J.G. Iterative Three-dimensional Image Reconstruction
          from Tomographic Projections, '<I>'Computer Graph. & Image Proc.'</I>' 6,
          (1977) 513-537.                                              '<BR>'
          Herman G.T. Two Direct Methods for reconstructing
          pictures from their projections: A comparative study. '<I>'Computer
          Graph. & Image Proc.'</I>' 1,(1972) 123-144
  
SUBROUTINE: COMP3DMAD

CALLER:     VTIL2


