
DR  ERR   Density Reference - Error between two volumes       DR  ERR
                                                              8/25/97

PURPOSE:  Calculates the mean relative error and the discepancy
          between two volumes.  A scaling factor and additive 
          constant is determined to scale the first volume such
          that the errors are minimized.

SEE ALSO: DR      (Density reference)
          DR DIFF (Density reference - error & difference between 2 volumes)

USAGE:    DR ERR

          .FIRST FILE: 3DR004
          [Enter name of 3-D file]

          .SECOND FILE: 3DR005
          [Enter name of second 3-D file]

NOTES:    Error formulas:                                               '<BR>'

          Mean relative error: E=SUM |A*DIJ2-DIJ1-CONST| / SUM |DIJ1-D| '<BR>'

          Discrepancy:  E=SQRT [ SUM ((A*DIJ2-DIJ1)**2)/ SUM ((DIJ-D)**2)]'<BR>'

          DIJ1,DIJ2 voxel values of volume 1 and volume 2                '<BR>'
          An optimum scaling factor.                                     '<BR>'
          CONST offset between the two volumes.                          '<BR>'

          For more details about the error measures see e.g.:
          Colsher J.G. Iterative Three-dimensional Image Reconstruction
          from Tomographic Projections, '<I>'Computer Graph. & Image Proc.'</I>' 6,
          (1977) 513-537.                                                '<BR>'

          Herman G.T. Two Direct Methods for reconstructing 
          pictures from their projections: A comparative study. '<I>'Computer 
          Graph. & Image Proc.'</I>' 1,(1972) 123-144

SUBROUTINE: COMP3D

CALLER:     VTIL2
