
EC CL     Extract Connected CLusters                        EC CL
							    11/7/96

PURPOSE:  Segments a volume that contains two or more unconnected 
          objects of the same intensity. The resulting volume can be 
          used for masking or with other 'EC' operations.                 '<BR>'
                                                                        '<BR>'
          'EC CL' works by reading a SPIDER 3D image file and a threshold 
          level. It locates connected clusters of voxels that are above 
          the threshold. Each cluster is given a number. A new 3D image 
          file is created that contains a cluster number for each object
          voxel or zero for background voxels.

SEE ALSO: EC SELECT (Extract connected clusters - selection)
	  EC CLOSE  (Extract connected clusters - merge close)
	  EC FILTER (Extract connected clusters - filter)
	  EC STAT   (Extract connected clusters - statistics)
	  
USAGE:    EC CL

          .INPUT FILE: VOL001
          [File containing SPIDER 3D image (volume) to be segmented.]
	  
          .ENTER SLICE NUMBERS: 1-64
          [Range of image slices the user wants to search.]
	  
          .THRESHOLD LEVEL: 1.3
          [Finds connected clusters that have a value greater than
          this threshold.]
	  
          .CLUSTER OUTPUT FILE: VVV001
          [Output cluster file name.]
	  
NOTES:    1. If the following output is observed, no clusters were 
             found for the given threshold value. Try a larger 
             threshold value.                                        '<BR>'
	'<PRE>'
              Original:     0 clusters mapped to:     0              '<BR>'
	'</PRE>'
          2. Usually you will want to follow this operation with the 
             'EC STAT' operation.
  
SUBROUTINES: CONINT, FILSLI, CCONECT, EMPSLI, SHOSLI, SHOSLI2, MAKTAB,
             MAPIM 

CALLER:      UTIL6

