
ED        Edge Detection                                    ED      
                                                            1/14/90

PURPOSE:  Detects edges using a Wiener-Filtering approach.  The
          input image is processed with a recursive filter, 
          and the filtered version is stored in a scratch file.  
          The scratch file is subsequently searched for 
          continuous lines along which the density variation 
          exceeds a certain threshold.  The resulting cartoon 
          image is written into the output file.

USAGE:    ED

          .INPUT FILE: PIC001
          [Enter name of input image for filtering and edge  
          detection.]

          .OUTPUT FILE: EDG001
          [Enter name of file where edge contours are to be put.]

          .FILTER NUMBER (1/2/3/4): 1/2/3/4
          [Specify one of the standard Wiener filters to be used.]

          These four filters roughly correspond to the following
          situations:
                      1.  Very high S/N ratio
                      2.  Medium S/N ratio, many edges expected
                      3.  Medium S/N ratio, fewer edges expected
                      4.  Low S/N ratio

          .THRESHOLD (1)LOW/(2)MEDIUM/(3)HIGH: 1/2/3
          [Enter threshold option.  Options 1, 2, and 3 have 
          decreasing sensitivity but increasing stability against 
          noise.]

NOTES:    contact:    JF
 
Subroutine: EDGE
Caller:     UTIL3
