
EP        Error Probability                                  EP      
                                                            7/1/85

PURPOSE:  Computes the error probability for each point of an 
          average image resulting from adding a particle series. 
          Input are the magnitude of the confidence interval and the
          variance file. (Source: Haenicke, MPI Goettingen.)

SEE ALSO: CI (Confidence interval)

USAGE:    EP

          .VARIANCE: STD001
          [Enter the name of the file containing the variance
          of each averaged image point.  This is obtained by
          using operation 'AS R'.]

          .OUTPUT FILE: EPB001
          [Enter the name of the file to receive the point-for-point
          error probabilities associated with the estimated mean for
          the choice of the confidence interval.]

          .NUMBER OF FILES ADDED: 56
          [Enter the number of images added when the average image
          was formed.]

          .MAGNITUDE OF CONFIDENCE INTERVAL: 0.02
          [The magnitude is the actual (not the relative)
          fluctuation permitted.  In the above example, the optical 
          density is allowed to deviate by +/- 0.02 from the theoretical
          mean.]

NOTES:    The numbers obtained are Alpha significance levels.
          For an elementary introduction into the theory of  
          statistical inference, see (e.g.) P. Armitage, '<I>'Statistical
          Methods in Medical Research'</I>', Blackwell Scientific  
          Publications, p99ff.
          (WCL&R Library:  19.A77)

SUBROUTINE: PROBER,ORCDF

CALLER:     CONF1
