
FC        File Contouring                                   FC      
                                                            8/28/97

PURPOSE:  Computes image contours by density foldover (cf 'DF') and
          subsequent line tracing.  The result is a "visible"
          contour diagram contained in a file.  The contours may
          optionally be superimposed on the original image.

SEE ALSO:  FC E  (File contouring - external contour levels)

USAGE:    FC

          .INPUT FILE: H_PIC001
          [Enter name of the image file to be contoured.]

          .OUTPUT FILE: OUT001
          [Enter name of image file where contoured file is to be put.
	   Sample Outputs : 1:(W)HITE - H_IMG016, 2:(B)LACK - H_IMG017, 
	   3:(A)DJUSTED CONTOURS - H_IMG018]

          .NUMBER OF CONTOUR LEVELS: 5
          [Enter number of contour levels desired.  Note that these
          include the levels FMAX, FMIN which are often only
          assumed by one point each.  Therefore, for a specification
          of 5 contours, only 3 contour lines will be visible.]

          .OVERWRITE (Y/N): Y
          [This option specifies the output file format:  enter 'Y'
          if you want to have the contour lines superimposed on the
          input picture; enter 'N' if you want to have the contour
          lines only.]

    In the case 'Y' was specified for overwriting, SPIDER asks:

          .(W)HITE, (B)LACK, OR (A)DJUSTED CONTOURS?: A
          [Enter 'W' for white contours (i.e., maximum density),
          'B' for black contours (i.e., minimum density), or 'A'
          for contours of maximum or minimum density, depending
          on the density of the surrounding image.]

NOTES:    White on the TV screen corresponds to high density values
          on tape, black on the filmwritten image, and white on a
          print from the negative.

          This routine will fail for images where the range of values 
          is <= .000001.  Minima may be surrounded by contour lines,
          rather than having a line at the minimum level.  This is an
          unavoidable feature of the density foldover algorithm used
          here.

SUBROUTINE: CNTRFL

CALLER:     UTIL3
