
FF        Fourier Filter                                    FF      
                                                            9/04/96

PURPOSE:  Applies filters to 2-D or 3-D Fourier transforms.

SEE ALSO:  FF B    (Fourier filter/bar ky direction)
           FF BX   (Fourier filter/bar kx  direction)
           FF PLOT (Design of filter)
           FF S    (Fourier filter, restore surface topograpy) 
           FP      (Fourier interpolation)
           FQ      (Fourier quick)
           FT      (Fourier transformation)

USAGE:    FF

          .INPUT FILE: FIN001
          [Enter name of input file containing Fourier transform.]

          .OUTPUT FILE: FOU001
          [Enter name of output file containing filtered Fourier file.]

          1: low-pass, 2: high-pass, 3: Gauss low-pass, 4: Gauss high-pass
          5: Fermi low-pass, 6: Fermi high-pass, 7: Remez

          .FILTER TYPE (1-7): 7
          [Enter filter option code.

          (1)  Low-pass truncation.  Filter is "top-hat" function
               that truncates Fourier transform at spatial frequency
               RAD.

          (2)  High-pass truncation.  Filter is inverse "top-hat"
               function that passes Fourier transform beyond spatial
               frequency radius RAD.

          (3)  Gaussian low-pass.  Filter is Gaussian function
               EXP(-f**2/(2.*RAD**2)), where F is the frequency.

          (4)  Gaussian high-pass.  Filter is complement of Gaussian
               function:  1.0-EXP(-F**2/(2.*RAD**2)).

          (5)  Fermi low-pass.  Filter is 1/(1+EXP[(F-RAD)/T]) which
               negotiates between "top-hat" and Gaussian 
               characteristics, depending on the value of T (see below).

          (6)  Fermi high-pass.  As low-pass, but T is replaced by
               -T.

          (7) Multiplication by the Remez filter designed with the help
              of 'FF PLOT' command.

          .FILTER RADIUS: 0.12
          [Enter filter function radius in frequency units. They are
           of the range 0.0<=f<=0.5.]

       For the Fermi filters [(5) and (6)], the temperature parameter T 
       will be solicited:

          .TEMPERATURE (0=CUTOFF): 0.3
          [Roughly within this reciprocal distance (in terms of
          frequency units), the filter falls off.]

       For the Remez filter (7), the filter file will be solicited: 
      
          .FILTER FILE: REM000
          [This file can be created by 'FF PLOT', or it can be any
           Fourier file used as a filter.]

SUBROUTINE: FFILTS

CALLER:     FOUR1
