
FI X      File Information - place header values in registers   FI X
                                                                4/7/97

PURPOSE:  Retrieve particular locations from the file header and place 
          them in specified registers. 

SEE ALSO: FI    (File information - single file information)
          FI A  (File information - multiple files)
          FI N  (File information - single file, do not stop if not found)
          FI X  (File information - place header values in registers)
          FR    (File read)

USAGE:    FI  X23,X24
          
          .FILE INFO. ON FILE: PIC002
          [The routine allows the user to retrieve particular locations
          from the file header and place them in the desired registers. 
          The following question will appear:

          ENTER NUMBER(S) OF LABEL LOCATION TO BE RETRIEVED:  7,9

          [Label location No. 7 (which is FMAX) is placed in
          register 23 and No. 9 (which is AVD) is placed in 
          register 24. 
          The label location input is done using subroutine GETNUM. 
          i.e. no parentheses needed in DO loops.]
  
NOTES:  1.  Some locations from the  from the file header that can be
            retrieved; 
           '<PRE>'
            7  FMAX  = IMAGE MAXIMUM
            8  FMIN  = IMAGE MINIMUM
            9  AVD   = IMAGE AVERAGE
           10  SIG   = STANDARD DEVIATION (SQ. ROOT OF VARIANCE)
           11  IHIST = FLAG INDICATING THAT HISTOGRAM HAS
                              BEEN COMPUTED, AND STORED
           14  IANGLE= FLAG INDICATING THAT TILT ANGLES STORED
           15  PHI   = TILT ANGLE
           16  THETA = TILT ANGLE
           17  PSI   = TILT ANGLE
           18  XOFF  = X OFFSET
           19  YOFF  = Y OFFSET
           20  ZOFF  = Z OFFSET
           21  SCALE = SCALE
          '</PRE>'

        2. See '<A HREF='"'../image_doc.html'"'>'SPIDER image file format description'</A>'
           for a complete listing of buffer positions.

SUBROUTINE: FILGEN,FILDAT

CALLER:     UTIL1

