
FP        Fourier interPolation                             FP      
                                                            4/10/96

PURPOSE:  Creates enlarged picture MGS*NSAM by MGR*NROW
          by MGS*NSLICE (where MGS, MGR, and MGS are magnification
          factors for corresponding dimensions) using zero-padding
          in Fourier space.  Command works for 2D and 3D files.
          Input and output are real pictures.  All magnification
          factors are integers > 1.  

SEE ALSO:  IP    (interpolation, 2D and 3D)
           IP T  (interpolation, triangular)

USAGE:    FP

          .INPUT FILE: H_PIC001
          [Enter name of file containing input picture.]

          .OUTPUT FILE: H_IMG022 
          [Enter name of file where output picture is to
           be kept.]

          .Magnification factors for columns & rows: 3, 4
          [Enter integral magnification factors.  Default is 2.
           Warning: these are NOT  new dimensions of the image.]

      For 3D image:
          .Magnification factor for slices: 5
          [Enterintegral magnification factor. Default is 2.
           Warning: this is _NOT_ new dimension of the image.]

NOTES:    1. Dimensions of the input image have to be even.

          2. In the example above for the input image with dimensions
          (24,12,10) the output image will have dimensions (72,48,50).

          3. Interpolation is exact in a sense that the total energy of 
          an image is preserved (one has to remember that sampling 
          grid of an interpolated picture is two times smaller,
          which means that energy term has to be divided by 2**MF).
          Note that the interpolation is not exact on the old grid !

SUBROUTINES: FOUR1A_FP, FINT, FINT3

CALLER:     FOUR1
