FQ NP     Filter - Quick, No Padding                          FQ NP      
                                                           4/14/95

PURPOSE:  Applies Fourier filters to 2-D or 3-D real images. Images 
          NEED NOT have power-of-two dimensions (see notes).
          No padding is applied.

SEE ALSO: FQ     (Filter - quick)
          FF     (Fourier filter)
          FL     (Fourier list)
          FP     (Fourier interpolation)
          FT     (Fourier transformation)

USAGE:    FQ NP

          .INPUT FILE: PIC001
          [Enter name of input file containing real picture.]

          .OUTPUT FILE: FIC001
          [Enter name of output file containing filtered real picture.]

          1: low-pass, 2: high-pass, 3: Gauss low-pass, 4: Gauss high-pass
          5: Fermi low-pass, 6: Fermi high-pass, 7: Buter low-pass,
          8: Buter high-pass

          .Filter type (1-8): 7
          [Enter filter option code.]
                               
           Option "1" - Low-pass truncation.  Filter is "top-hat" function
                        that truncates Fourier transform at spatial frequency
                        RAD.

           Option "2" - High-pass truncation.  Filter is inverse "top-hat"
                        function that passes Fourier transform beyond spatial
                        frequency radius RAD.

           Option "3" - Gaussian low-pass.  Filter is Gaussian function
                        EXP(-f**2/(2.*RAD**2)), where F is the frequency.

           Option "4" - Gaussian high-pass.  Filter is complement of Gaussian
                        function:  1.0-EXP(-F**2/(2.*RAD**2)).

           Option "5" - Fermi low-pass.  Filter is 1/(1+EXP[(F-RAD)/T]) which
                        negotiates between "top-hat" and Gaussian  
                        characteristics, depending on the value of T (see below).

           Option "6" - Fermi high-pass.  As low-pass, but T is replaced by
                        -T.

           Option "7" - Butterworth low-pass. Filter is
                              1/(SQRT(1+F/RAD)**(2*ORDER))
                        In the actual implementation of the filter the parameters,
                        RAD and ORDER are calculated from the pass-band frequency
                        and cut-off frequency specified by the user.
                        See NOTE 5 below.
                        
           Option "8" - Butterworth high-pass. Filter is 
                              1-(1/(SQRT(1+F/RAD)**(2*ORDER)))]
    
    For options 1-6:

          .FILTER RADIUS: 0.12
          [Enter filter function radius in frequency units. They are
           of the range 0.0<=f<=0.5. For an explanation of this units,
           see FF PLOT.]

    For options 7-8:

          .PASS-BAND AND STOP-BAND FREQUENCY: 0.1,0.2
          [Enter filter function radii in frequency units. 

    For the Fermi filters [(5) and (6)], the temperature
    parameter T will be solicited:

          .TEMPERATURE (0=CUTOFF): .3
          [Roughly within this reciprocal distance (in terms of
          frequency units), the filter falls off.]


NOTES:    FQ NP has similar functions to FF except that:

          1. it accepts only real space images (2- & 3-D) and leaves the 
             filtered image real,

          2. it runs only in core, so it is much faster than the FF operation,

          3. The FILTER RADIUS can be given either in absolute units or pixel
          units. If answer is >1.0 it is treated as given in pixel units.

          4. In the Butterworth filter the ORDER determines
             the filter fall off and RAD corresponds to the cut-off radius.
             In the program RAD and ORDER are calculated from the parameters
             specified by the user using following equations:         '<BR>'
             
             RAD = fp/((eps)**(2/ORDER))                            '<BR>'

             ORDER = [2*log(eps/sqrt(a**2-1))]/[log(fp/fs)]         '<BR>'

             where fp and fs are the pass-band and stop-band frequencies and 
             parameters "eps" and "a" are given by 0.882 and 10.624 resp. 
             Note that fp and fs deviate from 1.0 and 0.0 by about 0.2 and 0.09
             respectively (for a low-pass filter.)
             For reference see 'FF PLOT'.

          5. Implemented by:  Paul Penczek.

SUBROUTINE: FOUR1A, FQ_Q, FQ3_P

CALLER:     FOUR1
