
IF        conditional execution                                  IF      
                                                            9/22/97

PURPOSE:  To allow evaluation of a conditional expression
          (modeled after the FORTRAN IF).

SEE ALSO: IF_GOTO  (Conditional jump)
          IF_THEN  (Conditional execution of operation series)

USAGE:    IF(<EXP>.<LC>.<EXP>) X<R> = <EXP>

          '<PRE>'
          where <EXP>  is an expression
                <LC> is a logical comparator.  The following 
                     comparators are allowed:
                       EQ  equal
                       NE  not equal
                       GT  greater
                       GE  greater/equal
                       LT  less
                       LE  less/equal
                <R> is a register number, with <R> assuming any value  
                       between 10 and 99.

          EXAMPLES:
              IF(X9.GE.15.)X45=57
              IF(X1.LT.(13-2))X45=57

          EXAMPLES OF INVALID USAGE:
              IF(X2.EQ.13.3)X100= 5+7 (REGISTER number larger than 99.)
          '</PRE>'

NOTES: 1.  Contact: A. Leith

SUBROUTINE: LOGIFQ

CALLER:     SPIDER
