
IF_GOTO   conditional jump                                   IF_GOTO      
                                                            9/22/97

PURPOSE:  To allow jumps to other sections of the command stream
          depending on the validity of equalities or inequalities
          (modeled after the FORTRAN logical IF).

SEE ALSO: IF       (Conditional execution)
          IF_THEN  (Conditional execution of operation series)
          GOTO     (Unconditional jump)
          DO       (Do loop)

USAGE:    IF(<EXP>.<LC>.<EXP>) GOTO LB<N>

          '<PRE>'
          where <EXP>  is an expression
                <LC> is a logical comparator.  The following 
                     comparators are allowed:
                       EQ  equal
                       NE  not equal
                       GT  greater
                       GE  greater/equal
                       LT  less
                       LE  less/equal
                LB<N> is a label, with <N> assuming any value  
                       between 0 and 99.

          EXAMPLES:
              IF(X9.GE.15)GOTO LB9
              IF(X1.LT.X50)GOTO LB12

          EXAMPLES OF INVALID USAGE:
              IF(X2.EQ.13.3)GOTO LB100 (Label number larger than 99.)
          '</PRE>'

NOTES: 1.  Only forward jumping is allowed. No jumping into a 
           DO-loop.

       2. Contact: J. Frank

SUBROUTINE: LOGIFQ

CALLER:     SPIDER
