
IF_THEN   conditional execution of operation series         IF_THEN      
                                                            9/22/97

PURPOSE:  To allow jumps to other sections of the command stream
          depending on the validity of equalities or inequalities
          (modeled after the FORTRAN IF...ELSE...ENDIF).

SEE ALSO: IF       (Conditional execution)
          IF_THEN  (Conditional execution of operation series)

USAGE:    IF(<EXP>.<LC>.<EXP>) THEN

          '<PRE>'
          where <EXP>  is an expression
                <LC> is a logical comparator.  The following 
                     comparators are allowed:
                       EQ  equal
                       NE  not equal
                       GT  greater
                       GE  greater/equal
                       LT  less
                       LE  less/equal

          EXAMPLES:
              IF(X9.GE.15) THEN
                 OP
              ENDIF

              IF(X9.GE.15.) THEN
                 OP
              ELSE
                 OP
                 OP
              ENDIF
          '</PRE>'

NOTES: 1.  Nesting of if_then..else...endif is limited to MAXPRC
           levels. See spider.f for assignment of MAXPRC

       2.  For every 'IF_THEN' there must be a closing ENDIF.

       3. Implemented by: A. Leith

SUBROUTINE: LOGIFQ

CALLER:     SPIDER
