
IP        InterPolate                                       IP      
                                                           04/18/95

PURPOSE:  Interpolates a 2-D picture using bilinear interpolation
          or a 3-D picture using trilinear interpolation.


SEE ALSO:  IP T  (interpolation, triangular)
           FP  (Fourier interpolation)


USAGE:    IP

          .INPUT1 FILE: H_PIC001
          [Enter the name of the file to be interpolated.]

          .OUTPUT FILE: H_IMG024
          [Enter the file where the interpolated image is to be kept.]

          .ENTER DIMS NSAM,NROW: 128,128
          [Enter the dimensions of the interpolated image.]

    For 3-D image:

          .NSLICE: 79

          [PIC001 will then be interpolated to a picture of size
          128x128x79, and the interpolated image will be put into
          INT001.]

NOTES: 1. This operation can be used for either interpolation or
          extrapolation.

       2. The output image does not have to have the same 
          proportions (ratio NSAM/NROW) as the input picture.

       3. For a rectangular input image, only the new side
          length (NSAM) of the output image need be entered.
          The other side length (NROW) will then be computed 
          assuming the same proportions as the input image.  For
          example, let the input image have the size 60x40.
          Then the sequence
                  .ENTER DIMS NSAM, NROW: 120
          will have the same effect as
                  .ENTER DIMS NSAM, NROW: 120,80

       4. For an output picture with dimensions exactly two times
          smaller than those of an input picture the adding of
          four neighbouring pixels is done. The resulting picture
          contains frequencies up to 0.25 (roughly) and has improved
          SNR (two times).
          For an output picture with dimensions exactly four times
          smaller than those of an input picture the adding of sixteen
          neighbouring pixels is done.

           Notes 3, and 4 deal with 2-D pictures only.

       5. The memory needed is (NSAM*NROW*NSLICE+NSAM) in MAXMEM.

       6. The program works by throwing a new grid onto the image
          whose  boundaries coincide with those of the old grid.  Each
          pixel of the new grid is computed from its old neighbors  by
          bilinear  interpolation  or triangular interpolation.

       7. Note that for raw data, a  reduction  in  scale  by  IP
          results  in  a loss of s/n ratio, since only a subset of the
          original points may be used for interpolation.   The  proper
          procedure  maintaining  the  original information as much as
          possible is by preceding 'IP' with 'BC'  (box  convolution).
          The  box  size  used should be comparable with the reduction
          factor.
         
SUBROUTINES: INTERP, INTERP3, IRP3

CALLER:      UTIL2
