
IP T      Triangular InterPolation                          IP T
                                                           01/13/94

PURPOSE:  Interpolates a 2-D picture using triangular interpolation


SEE ALSO:  IP  (interpolation, 2D and 3D)
           FP  (Fourier interpolation)


USAGE:    IP T

          .INPUT1 FILE: H_PIC001
          [Enter the name of the file to be interpolated.]

          .OUTPUT FILE: H_IMG025
          [Enter the file where the interpolated image is to be
          kept.]

          .ENTER DIMS NSAM,NROW: 128,128
          [Enter the dimensions of the interpolated image.]


NOTES: 1. This operation can be used for either interpolation or
          extrapolation.

       2. The output image does not have to have the same
          proportions (ratio NSAM/NROW) as the input picture.

       3. For a rectangular input image, only the new side
          length (NSAM) of the output image need be entered.
          The other side length (NROW) will then be computed 
          assuming the same proportions as the input image.  For
          example, let the input image have the size 60x40.
          Then the sequence
                  .ENTER DIMS NSAM, NROW: 120
          will have the same effect as
                  .ENTER DIMS NSAM, NROW: 120,80

       4. For an output picture with dimensions exactly two times
          smaller than those of an input picture the adding of
          four neighbouring pixels is done. The resulting picture
          contains frequencies up to 0.25 (roughly) and has improved
          SNR (two times).
          For an output picture with dimensions exactly four times
          smaller than those of an input picture the adding of sixteen
          neighbouring pixels is done.

       5. The triangular interpolation scheme is used for any image
          sizes.

       6. THE MEMORY NEEDED IS (NSAM*NROW*NSLICE+NSAM) in MAXMEM.

       7. The triangular interpolation is for 2-D pictures only.

Subroutines: TRINTER
Caller:      UTIL2
