
MA        MAsk - using circular radii                            MA      
                                                            4/23/97

PURPOSE:  Masks a specified picture with circular masks of specified
	  radii.  Pixels in the area inside the inner circle and the
	  area outside the outer circle are set to a specified
	  background.  Operation works for both 2-D and 3-D images.

SEE ALSO: MA L  (Mask - a line across image)
          MA X  (Mask - 1D, in sample direction)
          MA Y  (Mask - 1D, in row direction)
          MM    (Mask multiplication)
          MM C  (Mask multiplication - continuous)

USAGE:    MA

          .INPUT FILE: H_PIC001
          [Enter the name of the file to be masked.]

          .OUTPUT FILE: PIC002
          [Enter the name of the output file. Sample Outputs: H_IMG026, 
           H_IMG027]

	  .OUTER & INNER RADII: 12.0, 0.0
          [Enter the radii of the outer and inner mask circles, in
          pixels.  Pixels in areas outside the outer radius and inside
          the inner radius are set to background.  Enter zero inner
          radius for no inner radius masking.  Enter zero outer radius
          for inner masking only (the old 'CA I' operation).]

          .(D)ISK, (G)AUSSIAN EDGE, OR (T)RUE GAUSSIAN: D/G/T
          [Enter 'D' for a sharp disk-profile cutoff, (for 2D image
           only:) 'G' for a piece-wise mask (no modification inside 
          a circle with the specified radius, and Gaussian-shaped 
          falloff from this radius outwards), or 'T' for a true 
          Gaussian mask.]

          .(A)V, (P)REC AV, (C)IRCUMF, OR (E)XTERNAL: P
          [Enter 'A' if the background is to be the average of
          the picture before masking; enter 'P' if the
          background is to be the average after masking; or enter
          'E' if the background is to be specified EXTERNALLY.
          Enter 'C' if you want the background to be determined
          by averaging along the circumference of the mask].

    If 'E' was entered, the following question appears:

          .ENTER BACKGROUND: 3.0
          [Enter the desired background.]

          .MASK CENTER COOS (NSAM, NROW): 50, 15
          [Enter the coordinates of the circular mask center.  Note
          that you have to specify coordinates equal to NSAM/2+1,
          NROW/2+1 if you want the mask center to coincide with the
          nominal image center.]

    The following question appears only when using a 3-D volume.

          .MASK CENTER COOS (NSLICE): 45

          [Enter the slice number for the circular mask center.  Note
          that you have to specify slice equal to NSLICE/2+1 if you 
          want the mask center to coincide with the nominal volume 
          center.]

    If a 'G' was specified in response to the '(D)ISK OR (G)AUSSIAN:'
    prompt, the following question appears]:

          .HALFWIDTH: 3.5
          [Enter the halfwidth of the Gaussian falloff function.]

SUBROUTINES: MASK

CALLER:      UTIL2
