
MA X      MAsk - 1D, in sample direction                   MA X
                                                         9/23/96

PURPOSE:  Masks a specified image with a circle of specified
          radius and background.  The 'X' option cause the flanks
          in the X direction to be masked off beyond the 
          diameter = 2*radius.  This operation is for 2D images
          only.

SEE ALSO:  MA    (MAsk - using circular radii)
           MA L  (Mask - mask a line across image)
           MA Y  (Mask - 1D, in row direction)
           MM    (Mask multiplication)

USAGE:    MA X

          .INPUT FILE: H_PIC001
          [Enter the name of the file to be masked.]

          .OUTPUT FILE: H_IMG031
          [Enter the name of the output file.]

          .OUTER & INNER RADII: 12.0
          [Enter the radius of the mask circle, in pixels.]

          .(D)ISK, (G)AUSSIAN EDGE, OR (T)RUE GAUSSIAN: D/G/T
          [Enter 'D' for a sharp disk-profile cutoff, (for 2D image
           only:) 'G' for a piece-wise mask (no modification inside 
          a circle with the specified radius, and Gaussian-shaped 
          falloff from this radius outwards), or 'T' for a true 
          Gaussian mask.]

          .(A)V, (P)REC AV, (C)IRCUMF, OR (E)XTERNAL: P
          [Enter 'A' if the background is to be the average of
          the picture before masking; enter 'P' if the
          background is to be the average after masking; or enter
          'E' if the background is to be specified EXTERNALLY.
          Enter 'C' if you want the background to be determined
          by averaging along the circumference of the mask].

    If 'E' was entered, the system asks:

          .ENTER BACKGROUND: 3.0
          [Enter the desired background.]

          .MASK CENTER COOS (NSAM, NROW): 50,15
          [Enter the coordinates of the circular mask center.  Note
          that you have to specify coordinates equal to NSAM/2+1,
          NROW/2+1 if you want the mask center to coincide with the
          nominal image center.]

    This question is asked for the 3D file only.

          .MASK CENTER COOS (NSLICE): 45
          [This question is asked for the 3-D file only.]

    If a 'G' was specified in response to the ".(D)ISK OR
    (G)AUSSIAN:" prompt, SPIDER asks]:

          .HALFWIDTH: 3.5
          [Enter the halfwidth of the Gaussian falloff function.]

SUBROUTINES: MASK

CALLER:      UTIL2
