
MD        MoDe                                              MD      
                                                            5/13/97

PURPOSE:  Switches between different operating modes of SPIDER.  Can
          also adjust size of the two inline file buffers on VMS.

USAGE:    MD

          .MODE: 
          [Enter the mode command. The available commands are:]'<BR>'

          /ME/STA/TR ON/TR OFF/OP ON/OP OFF/VB ON/VB OFF
          MOSAIC ON/MOSAIC OFF/INLN BUFF/

NOTES:  Explanation Of Modes
        '<PRE>'       
        ME         Lists the mode menu.
        STA        Gives the current status of 'MD' options.
        TR ON      Write trace to the terminal in batch runs
                       (DO-loop index, and procedure calls).
        TR OFF     (Default)  No messages written.
        OP ON      Show operation.
        OP OFF     Show operation off.
        VB ON      Verbose on.  Normal listings to terminal and
                        results file.
        VB OFF     Verbose off.  Shortened listing to results file.
                        Useful for complicated batch runs.
        MOSAIC ON  Use WWW browser to give help.  The documents
		       are all hyperlinked for easy use.
        MOSAIC OFF Turn off use of WWW browser for help.
        INLN BUFF  Toggles use of inlined buffers ON/OFF (default is
                        ON)  On VMS sets the size of each buffer. 
                        On Unix, the size is determined based upon  
                        need at runtime.
        SET MP     Sets maximum number of processors used.
        SET MEM    Resets maximum Mega-bytes of allocatable memory.
                        This is initially set to a default value  or
                        the value given in the Unix environmental
                        variable 'SP_MEMALLOC'

         '</PRE>'       
 
       2. The mode commands 'STA' and 'ME' leave the user in
          MODE.  A carriage return will bring the system back
          into operation input status.

       3. The mode command 'INLN BUFF' toggles the availability
          of inline files (saved in memory not on disk).  If this 
          toggle is ON (the default) filenames which begin with "_" or
          "___" followed by one digit are interpreted as inline files.
          The user can write to (read from) the inline files as if 
          writing to (reading from) a disk file.  

SUBROUTINES: SETMODE, INITINLN

CALLER:      DRIV1
