
MK        MarKer                                            MK
                                                           5/2/96

PURPOSE:  Align set of markers for single tilt geometry.

SEE ALSO: MK 3 (Marker program - find 3D orientation)

USAGE:    MK

          .ENTER PREFIX OF X,Y COORD FILES: MRK***
          [Enter prefix of the name of document files containing
          X,Y coordinates of marker's positions.]

          .ENTER FILE NUMBERS: 1-63
          [Enter numbers of the document files containing
          X,Y coordinates of marker's positions.]

          .REFERENCE FILE NUMBER: 30
          [Enter number of the file which will be treated as
          a reference.  Usually it is file containing markers
          0-degree projection.]

          .ENTER X,Y DIMENSIONS OF IMAGE: 600,900
          [Enter original nsam, nrow dimensions of projection files.]

          .REFINE SCALE (VS REFERENCE)? (Y/N): Y
          ['Y' - scale will be modified, 'N' - scale will be set to 1.]

          .REFINE TILT ANGLE (VS REFERENCE)? (Y/N): N
          ['Y' - tilt angle will be modified,
           'N' - tilt angle will remain as read from the marker document
                 files.]

          .REFINE IN-PLANE ROTATION? (Y/N): Y
          [Y - in-plane rotation (psi angle) will be modified, 
           N - in-plane rotation (psi angle) will be set to 0.]

          .REFINE SHIFT (VS REFERENCE)? (Y/N): Y
          ['Y' - shift will be modified, 'N' - shift will be set to 0.]

          .USE PREVIOUS CORRECTIONS? (Y/N): N
          ['N' - next question will be skipped.]

     If Y, corrections from the previous run will be used as
     a starting point, in this case next question will be:
                
          .ENTER CORRECTIONS FILE: COR101
          [Enter the name of the corrections document file from the
          previous run.]

          .Full output (Y/N): N
          [Enter Y to have information about all the markers
           (errors per marker in 2D) stored in the results files.]

          .ENTER DOC FILE TO HOLD CORRECTIONS: COR001
          [Enter the name of the document file in which corrections will
          be stored (see note #3).]

          .ENTER DOC FILE TO HOLD 3-D COORDS: CRD001
          [Enter the name of the document file in which 3-D markers
          coordinates (X,Y,Z) will be stored.]

NOTES: 1. In the program there is a limit set to 100 markers and 300 views.

       2. Input document files must have markers coordinates stored
          X - first column, Y - second column.        
          Number of markers has to be exactly the same in all the
          input document files.
          The order of markers coordinates has to be the same in all
          the input document files (i.e. marker #3 has to be stored
          under key #3 in all the document files.          '<BR>'

          The original tilt angle (theta) has to be stored in the
          input document files in the second column of key#-1 (key
          line commented out).                             '<BR>'

       3. The document file with corrections has the following
          format:                                           '<BR>'
             column 1 - scale                               '<BR>'
             column 2 - tilt angle (theta)                  '<BR>'
             column 3 - in-plane rotation angle (psi)       '<BR>'
             column 4 - x-shift                             '<BR>'
             column 5 - y-shift                             '<BR>'

          The following program is an example how the corrections
          have to be used to modify the projections:

          '<PRE>'
          X55=0.0
          DO LB1 I=1,63
          UD IC, X0,X21,X77,X22,X23,X24
          COR001
          ; MODIFY THE PROJECTIONS
          RT SQ
          <INPUT PROJECTION>X0
          <OUTPUT PROJECTION>X0
          X21,X22
          X23,X24
          ; STORE NEW THETA ANGLE IN THE ANGULAR DOC FILE
          ; AS REQUIRED BY BP W2 OR BP S2.
          SD X0,X55,X77,X55
          ANGLES
          LB1
          '</PRE>'

       4. Written by: Paul A. Penczek


SUBROUTINE: MRK,MR2TO3D,MRALIGN,MRANG2,MRCALERR,MRCENTI,MRCG3D,
            MRDOC,MRGETINFO,MRPROJ,MRPUTINFO,MRRLINE,MRSCALE,MRSHIFT,
            MRTHETA

CALLER:     UTIL3
