
MO        MOdel image creation                                   MO      
                                                            4/18/97

PURPOSE:  Creates a model image.  The following options are 
          available:                                             '<BR>'
              1.  Constant density                               '<BR>'
              2.  Circle of specified radius                     '<BR>'
              3.  Diagonal sine wave of frequency (2,2)          '<BR>'
              4.  Test pattern consisting of specified sine waves'<BR>'
              5.  Random pattern with uniform distribution       '<BR>'
              6.  Random pattern with Gaussian distribution      '<BR>'
              7.  Wedge '<BR>'

SEE ALSO: MO 3  (Model volume creation)
          BL    (Blank image creation)
          PT    (Create a pattern)
          PP L  (Put lines in image)

USAGE:    MO

          .OUTPUT FILE: MOD001
          [Enter the name of the output file.]
 
          .ENTER DIMENSIONS (NSAM,NROW): 64,64
          [Enter the dimensions of the image in the output file.]

          [Following menu appears.]                    '<BR>'
          .MENU:                                       '<BR>'
           (B)LANK    -- BLANK IMAGE                   '<BR>'
           (C)IRCLE   -- FILLED CIRCLE                 '<BR>'
           (Q)UICK    -- RANDOM UNIFORM/GAUSSIAN STATISTICS     '<BR>'
           (R)ANDOM   -- RANDOM UNIFORM/GAUSSIAN STATISTICS     '<BR>'
           (S)INE     -- SET OF SINE WAVES             '<BR>'
           (T)EST     -- 2D SINE WAVE                  '<BR>'
           (W)EDGE    -- DENSITY WEDGE                 '<BR>'

          .ENTER B/C/Q/R/S/T/W: T
          [Enter the desired option.] 

    For '<B>' Option "B" -Blank Image'</B>' 

          .BACKGROUND CONSTANT: 12.0
          [Enter the desired intensity for the image.]

    For '<B>' Option "C" - Circle'</B>' 

          .RADIUS (FLOATING POINT): 12.0
          [Enter the desired radius of the circle.  Any floating
          point number between 0.0 and SQRT[(NSAM/2)**2 +
          (NROW/2)**2] may be specified.]

          [The output file will then contain a circle of radius 12.0
          (filled with pixel values of 2.0, and a blank (pixel value 0.0)
          background.] '<BR>'

    For '<B>' Option "Q" - Quick Random'</B>'
 
          .GAUSSIAN DISTRIBUTION? (Y/N): N
          [For 'N' a random image with the values uniformly distributed
          between 0 and 1 is generated. If 'Y' was specified, 
          SPIDER will ask]

          .MEAN AND STANDARD. DEVIATION. OF GAUSSIAN DIST.: 0.0,0.35
          [Enter the mean value and standard deviation of the gaussian
          distribution for random numbers to be generated.]

          [The random generator is the faster one of the two, yet
          in power of 2 images random generator creates image with
          a noisy, sine-shaped periodicity in the power spectrum.
          If the frequency distribution of the noise is critical
          option 'R' should be used.] 

    For '<B>' Option "R" - Random'</B>' 
 
          .GAUSSIAN DISTRIBUTION? (Y/N): N
          [For 'N 'a random image with the values uniformly distributed
          between 0 and 1 is generated. If 'Y' was specified, gaussian
          distributed noise with 0.0 mean and standard deviation 1.0 is 
          created.

    For '<B>' Option "S" - Sine waves'</B>'

          .NUMBER OF SINE WAVES: 2
          [Enter the number of sine waves to be added together. The
           maximum is 20.]

          .I=1 AMPLITUDE, PHASE, SP. FREQUENCY (KX,KY): 1.0,45.,1,10
          [Enter the amplitude and phase of the first sine wave,
          and its X and Y frequencies, respectively.]

          .I=2 AMPLITUDE, PHASE, SP. FREQUENCY (KX,KY): 2.5,90., -2,5
          [Enter the relative amplitude and phase of the second
          sine wave, and its X and Y frequencies, respectively.]

          [The output file  will now contain a 64 x 64 image, which is the
          sum of two sine waves, of specified amplitudes and
          phases, one of X-frequency 1 and Y-frequency 10, and
          the other of X-frequency -2 and Y-frequency 5.  Note
          that the amplitudes and phases must be given as 
          floating point numbers.

    For '<B>' Option "T" - TEST'</B>'
          [The output file will contain a test sine wave of size 
          64 x 64 and spatial frequency (2,2), i.e. a 
          diagonally-running sine wave with two full periods. 

    For '<B>' Option "W" - Wedge '</B>'
           The output file will contain a density wedge of size 64 x 64. '<BR>'

SUBROUTINES: MODEL, MRAND, BLANK

CALLER:      UTIL1
