
MO 3      MOdel volume creation                                MO 3    
                                                            4/17/97

PURPOSE:  Creates a 3-D model density distribution.

SEE ALSO: MO    (Model image creation)
          BL    (Blank image creation)

USAGE:    MO 3

          .OUTPUT FILE: MOD001
          [Enter the name of the file where the 3-D density 
          distribution is to be kept.]

          .ENTER DIMENSIONS (NSAM,NROW): 32,32
          [Enter number of samples and rows.]

          .ENTER NUMBER OF SLICES (NSLICE): 16

          [Following menu appears.]                            '<BR>'
          .MENU:                                               '<BR>'
           (B)LANK    -- CONSTANT DENSITY                      '<BR>' 
           (C)YLINDER -- SET OF CYLINDERS                      '<BR>'
           (H)ELIX    -- HELIX OF SPHERES                      '<BR>'
           (HA)       -- HELIX OF SPHERES, ADD DENSITITY       '<BR>'
           (NUM)BERS  -- LINE NUMBERS                          '<BR>'
           (Q)UICK    -- RANDOM UNIFORM/GAUSSIAN STATISTICS    '<BR>'
           (R)ANDOM   -- RANDOM UNIFORM/GAUSSIAN STATISTICS    '<BR>'
           (S)INE     -- SET OF SINE WAVES                     '<BR>'
           (SP)HERE   -- SET OF SPHERES                        '<BR>'
           (SPA)      -- SET OF SPHERES, ADD DENSITIES         '<BR>'
           (SPV)      -- SET OF SPHERES, VARIABLE DENSITIES    '<BR>'
           (T)EST     -- 3D SINE WAVE                          '<BR>'
           (W)EDGE    -- DENSITY WEDGE                         '<BR>'
           

	  .B/C/H/HA/NUM/Q/R/S/SP/SPA/SPV/T/W: SPA
          [Enter the desired menu option.]

       For option '<B>'"B" - Blank'</B>'. 
          A blank volume of constant background is created.

         .CONSTANT BACKGROUND: 7.0
          [Enter intensity value for the image.]

       For Option '<B>'"C" - Cylinder'</B>'  
          A cylinder with uniform density is created. Cylinder axis lies
          along the Y-coordinate.

          .VALUE OF VOLUME BACKGROUND: 0
          [Enter value the volume outside of the cylinder(s) will
          be filled with]

          .CHOOSE X, Y, Z (OR Q TO END CYLINDER ENTRY): Y
          [Give axis direction of cylinder]
   
          .RADIUS, HEIGHT: 4.5,6.2
          [Give radius and height of cylinder.]

          .X & Y COORDINATES OF CENTER: 12.,4.3
          [Enter X, Y coordinates of center.]

          .Z COORDINATE, DENSITY: 7.8,2
          [Enter Z coordinate of center, and density value.]

          .CHOOSE X, Y, Z (OR Q TO END CYLINDER ENTRY) Y
          [You may specify another cylinder now or enter 'Q' to
           terminate.]

       For Options '<B>'"H/HA" - Helix'</B>'  
          A helical arrangement of spheres running in the Y-direction 
          is created.
  
          .ENTER MASS VALUE PER VOXEL (DEFAULT = 2.0): 

          .SPHERE RADIUS, HELIX RADIUS: 4.2, 8.5
          [Enter the radiI for spheres and helix.]

          .NO. OF SPHERES, NO. OF TURNS: 12,2
          [Enter the total number of sphereS and the total number
          of turns in NROW.]

       For Option '<B>'"NUM"- NUMBERS'</B>'  
          A test volume containing numbers is created.
          The line number in the 3D file is put into each line at a specified position.

          .POSITION IN LINE: 5
          [Enter the position where the line number should be
           put in each line]

          .SCALING FACTOR: 3
          [Enter scaling factor]
         
          .NUMBER PIXELS IN LINE? (Y/N): Y 
          [If answer is "Y" following two questions appear.]

          .SLICE NUMBER, LINE NUMBER: 3,4
          [Enter slice number and line number]

          .SCALING FACTOR: 2
          [Enter scaling number]

       For Option  '<B>' Option "Q" - Quick Random'</B>' 
          A volume containing random densities is created. 
 
          .GAUSSIAN DISTRIBUTION? (Y/N): N
          [For 'N' a random image with the values uniformly distributed
          between 0 and 1 is generated. If 'Y' was specified, 
          SPIDER will ask]

          .MEAN AND STANDARD. DEVIATION. OF GAUSSIAN DIST.: 0.0,0.35
          [Enter the mean value and standard deviation of the gaussian
          distribution for random numbers to be generated.] '<P>'

          SCALING NEW_VALUE = OLD_VALUE * F + C')
         .ENTER C, F (DEFAULTS = 0,1)': 0.0, 1.0

         [This random generator is the faster one of the two, yet
          in power of 2 images random generator creates image with
          a noisy, sine-shaped periodicity in the power spectrum.
          If the frequency distribution of the noise is critical
          option 'R' should be used.] 

       For Option '<B>'"R" - Random'</B>'  
          A volume containing random densities is created. 

          .GAUSSIAN DISTRIBUTION? (Y/N): N
          [For 'N' a random image with the values uniformly distributed
          between 0 and 1 is generated. If 'Y' was specified, 
          distributed noise is created, SPIDER will ask:]

          .MEAN AND STANDARD. DEVIATION. OF GAUSSIAN DIST.: 0.0,0.35
          [Enter the mean value and standard deviation of the gaussian
          distribution for random numbers to be generated.]

       For Option '<B>'"S" - Sine.'</B>' 
           A volume containing a 3-D distribution from an arbitrary
           number of 3-d sine waves  with arbitrary spatial frequency vector
           is created.

          .NUMBER OF SINE WAVES: 3
          [Enter number of sine waves, with a maximum of 20.]

          .I=1  REL.AMPL.,SPATIAL FREQUENCY(KX,KY,KZ): .5,1,2,4
          .I=2  REL.AMPL.,SPATIAL FREQUENCY(KX,KY,KZ): 1.,2,2,2
          .I=3  REL.AMPL.,SPATIAL FREQUENCY(KX,KY,KZ): 1.,1,2,1
          [Enter relative amplitude and spatial frequency for
          each sine wave.]

          [The actual amplitudes used "AMPL" are calculated from
          the input amplitudes according to the formula:     '<BR>'
                  AMPL = 2. * AMPLIN / AMPSUM                '<BR>'
          where "AMPSUM" is the sum of all input amplitudes.  A
          list of the actual amplitudes is printed out.]

       For Options '<B>'"SP/SPA/SPV"'</B>' 
          Spheres of given outer and inner radius with a given density are
          created, with centers located at specified points.  The default 
          inner radius is zero and the default density value is 2.0. After
          modelling a sphere of a given radius the  program should ask for 
          the radii (but does not) and location of the next sphere.  If the
          outer radius + the any of the center coordinates exceeds the 
          boundary of the 3-D file, the program warns that part of the
          sphere will be truncated.

          .GET COORDINATES FROM DOCUMENT FILE (Y/N): N
          [Otherwise the user will input sphere coordinates from the
           command line.]
            
       If the answer is 'Y' SPIDER asks:]
          .DOCUMENT FILE: DOC001
          [Enter name of document file with center coordinates of 
          spheres, in order: X,Y,Z ( ,Radius2, Radius1 - optional) 
               (,Mass value - optional) starting in any column]

          .NUMBER OF SPHERES, STARTING COL. FOR X,Y,Z: 50,1
          [Enter number of spheres and column of X-coordinate
          in document file]                            

          .X,Y, & Z  OFFSET: 20.,-10.,51.
          [Enter offset for X,Y,Z]

          .OUTER AND INNER RADII OF SPHERES: 4.5,1.7
          [Enter radius of sphere as a floating point number.
          If a negative value is entered for one or both of the
          radii, they are taken from the document file. If
          the inner radius is taken from the document file, the
          outer radius also must be in this file, the outer
          radius can be taken from the document file while the inner
          one can be fixed for all spheres and enetered explicitly.]
               
       If the answer is 'N' SPIDER asks:]
          .OUTER AND INNER RADII OF SPHERES: 4.5,1.7
          [Enter radii of spheres as a floating point number. 
           To exit enter '0,0,0' as coordinates.]

       For Option  '<B>'"SP/SPA"'</B>':

          .ENTER MASS VALUE PER VOXEL (DEFAULT = 2.0): 3.0
          [Enter the density value to be stored.]

       For Option '<B>'"SP/SPA/SPV"'</B>' 

          .OUTER AND INNER RADIUS OF SPHERE: 2,1
          [Enter radius of sphere as a floating point number.]

       For Option '<B>'"SP/SPA/SPV"'</B>' without input from a doc file:
          .X,Y,Z: 10,10,15
          [Enter the coordinates of the sphere. To exit enter '0,0,0' 
          as coordinates.]

       For Option '<B>'"T" - Test'</B>'  
          A three-dimensional (circularly continuous) sine wave is created 
          in the given volume.  It has the spatial frequency (1,1,1).]

       For Option '<B>'"W" - Wedge'</B>' 
          A three-dimensional, linearly increasing density distribution is 
          created.  The values increase linearly with increasing X, Y, and Z.
                         .
SUBROUTINES: MODEL3, MODELH, RANN

CALLER:      UTIL1

