
OR 3A     ORientation search - 3D, arbitrary center             OR 3A    
                                                                07/22/97

PURPOSE:  Determines orientation between two 3D volumes
          in terms of three Eulerian angles.  Rotation around
          arbitrary center.

SEE ALSO:  OR 3Q  (Orientation search - 3D, Eulerian angles)
           OR 2   (Orientation search for rotation angles in 2D)
           OR 2M  (Orientation search - 2D, multiple peaks)
          
USAGE:    OR 3Q,X10,X11,X12,X55
          [The first three optional registers will contain the phi, theta
          and psi Eulerian angles found by the program. The fourth register 
          will contain the value of the correlation coefficient found by 
          the program.] 

          .REFERENCE 3D FILE: VOL001
          [Enter name of the file containing the 3D reference volume.]
          
          .SECOND FILE: VOL002
          [Enter name of the file containing the 3D volume to be matched
          with the reference file.]

          .RADIUS OF THE MASK: 14
          [The correlation coefficient is calculated only inside a sphere 
          of the specified radius.]

          Initial Eulerian angles:

          .PHI, THETA: 76.0,45.0

          .PSI: 275.0
          [Enter three Eulerian angles defining the starting position
          for optimization procedure.]

          .CENTER OF ROTATION NX, NY: 12,27
          [Enter x,y coordinates of a center of rotation.  Volume
           extends in x from 1 to NSAM and in y from 1 to NROW.]

          .CENTER OF ROTATION NZ: 55
          [Enter z coordinate of a center of rotation.  Volume
           extends in a from 1 to NSLICE.]

NOTES: 1. The Eulerian angles agree with the convention used in SPIDER.
          In particular, to rotate the second volume to the orientation
          of the reference volume, the command 'RT 3D' must be used
          with the angles determined by this operation. To rotate the
          reference volume to the position of the second volume, the
          following transformation must be applied: phi'=-psi, 
          theta'=-theta, psi'=-phi. The 'primed' angles are then applied 
          to the reference volume in 'RT 3A'.

       2. In most cases it is sufficient to use the input volumes
          interpolated to the smaller dimensions, for example, 2-fold
          smaller. The accuracy is excellent, and the gain in speed for
          this example is eightfold. The speed of the calculations is 
          very high (on the order of a few minutes for a 32X32X32 cube 
          and radius 14). It is recommended that different initial Eulerian
          angles be tried to verify the results.

       3. If two volumes are shifted with respect to one another, the 3D 
          croscorrelation function must be used after (or before) the 
          rotational search, and the whole procedure must be repeated to 
          determine the best orientation.

       4. Memory requirements: 2*NSAM*NROW*NSLICE.

       5. Implemented by P. Penczek.

SUBROUTINES: QALI, QALI_P, QNR, QNRF, UQU, FCNQ, FUNIQ, AMOEBA

CALLER:      UTIL3
