OR FM     ORientation search - Full circle, Find > one peak    OR FM
                                                               8/25/97

PURPOSE:  Does the same calculations as 'OR F', but looks for 
          more than one peak. 
          Determines orientation between two auto-correlation  
          functions.  It can be used to determine the angle between two
          similar images lying in arbitrary orientations.  Image
          dimensions must be powers of two.

SEE ALSO:  OR     (Orientation search - half circle used)
           OR 3A  (Orientation search - 3D, arbitrary center)
           OR 3Q  (Orientation search - 3D, Eulerian angles)
           OR F   (Orientation search - full circle used)
           OR M   (Orientation search - find > one peak)
           OR P   (ORientation search - not power of two 

USAGE:    OR FM X10,X11,X12......

          [The optional output parameters X10,X11 specify register
          positions for the rotation angles (in degrees) found in 
          this operation] 

          .INPUT1 FILE: ACF001
          [Enter name of the file containing the ACF of the first
          picture, 64x64 or 128x128.]

          .INPUT2 FILE: ACF002
          [Enter the name of the file containing the ACF of second
          picture; dimensions must correspond to those of the first
          picture.]

          .NO. OF RINGS, WEIGHT OVERRIDE(1/0): 5,0
          [Enter number of ring segments to be used for orientation
          search, and enter '1' if the default weights and radii are
          to be overridden (see notes).]

          .GRAPH FOR EACH RING?(Y/N): N
          [Indicate if a plot of the CCF in the RESULTS file for each
          ring is desired.]

    If the weight override option is chosen, SPIDER then asks
    for the radii and weights:

          .ENTER RADII: 20.,25.,30.,50.,54.
          [Enter radii (as floating point values) for each ring,
          (up to 10 per line). CAUTION: you must use the decimal 
          point, otherwise the program does not use the correct 
          values!]

          .ENTER WEIGHTS: 0.1,0.2,0.5,1.0,0.1
          [Enter a weighting factor (as floating point values)
          for each ring (10 per line).]

          .NUMBER OF PEAK: 3
          [Enter the number of peaks that are to be analysed
          in the angular CCF].

          [SPIDER computes the cross-correlation of equispaced data
          along concentric circles around the centers of the ACFs;
          the resulting one-dimensional cross-correlation functions
          are weighted and added together.  The orientation graph
          (between -180 and +180 degrees) is printed to the RESULTS
          file, with the position of the highest peak indicating the
          angle where optimum match occurs.  The position and  
          accuracy of the peak are also printed.  If option ".GRAPH FOR
          EACH RING?(Y/N):" is chosen, the CCF of each ring before
          weighting is printed out (use this option for tests only,
          because one page is used for each ring in the printout).
          In addition, the rotation angle will be put into the
          temporary register if an output parameter X10 is specified.
          This can be used as input to a subsequent 
           RT operation.]

NOTES: 1. Accuracy and computing time increase with the number
          of rings.

       2. Default weights are .1 for the first ring and 1. for
          all other rings.

       3. Maximum number of rings is currently 20.  If a larger
          number is specified, the system defaults to 20.  The
          default radii are a function of the image size and the
          number of rings chosen.  For example, for a 128x128
          image, the default radii are 4.8, 9.6, 14.4, ..., 48.
          if 10 rings are specified.

       4. In the 'OR M' operation, only the upper half-plane of
          the input files is correlated, assuming centrosymmetry
          of the input patterns, as in the case of the ACFs.  
          But in the 'OR FM' operation, the full plane is
          correlated.

SUBROUTINES: ORNTS, CRCSE1, CRCSEC, ORPKS

CALLER:      UTIL3
