
PJ 3Q     ProJect - 3D volume using Eulerian angles            PJ 3Q    
                                                            825/97

PURPOSE:  Computes a projection of a 3D volume according to the three
          Eulerian angles.

SEE ALSO: PJ 3    (ProJect - 3D volume)
          PJ 3E   (ProJect - 3D volume using Eulerian angles, fast)
          PJ 3T   (ProJect - 3D volume using internal Threshold)
          PJ AT   (ProJect - 3D volume using exponential ATtenuation)
          PJ CYL  (ProJect - 3D volume onto cylinder)

USAGE:    PJ 3Q
  
          .3-D FILE: 
          [Enter the name of the file whose projections are to be
           computed.]

          .RADIUS OF THE OBJECT: 26.0
          [The projections are computed only for the object inside
          the sphere of the given radius.]

	  .SELECTION DOC FILE: sel001
          [Enter the name of the document file containing the serial  
          numbers of the projections (from the whole set) that you want
          to use in the first column.  ]

          .ANGLES DOC FILE: ANGLES
          [Enter the name of the document file containing the Eulerian
          angles of the projections. The angles have to be given
          in the order: psi, theta, phi. The meaning of the angles
          is the same as in command RT 3Q. Projections will be
          calculated for every entry in the selection document file.]

          .ENTER TEMPLATE FOR 2-D PROJECTION: PRJ****
          [Enter the template for 2-D projections.]

NOTES: 1. Memory requirements: NSAM*NROW+12*R**3+15*R**2, where R is the 
          radius,  but no more than   6*NSAM*NROW+NSAM*NROW*NSLICE

       2. The projection file has always dimensions NSAM x NROW.

       3. For the projection of the whole volume (not the internal
          sphere only) give the radius larger than any linear
          dimension of the volume.  Please note that usually
          such projection is incorrect and the program works
          much longer. 

       4. Implemented by: P.Penczek.

SUBROUTINES: PJ3Q, PREPCUB_Q, WRITPRO, WPRO, MOVIPC

CALLER:      VTIL2
