
PJ ST     ProJected Surface - Creation                           PJ ST   
                                                                04/22/97

PURPOSE:  Create a surface image of a three-dimensional structure.
          (I suggest you use the Web "Surface" operation instead ie
          you want to make a shaded surface representation. It
          uses similar algorithm, can usually rotate the volume,
          is faster, and can save the output image.)


SEE ALSO: PJ INTER (ProJected Surface - INTERlace 2 surface representations)
          PJ SHAD  (ProJected Surface - cosine SHADing)
          PJ COL   (ProJected Surface - coloring)   
 
USAGE:    PJ ST

          .3-D FILE: 3DR100
          [Enter the file containing the three-dimensional
          structure.]

          .ROTATION AXIS (Y) (=DEF) OR Z: Z
          [Enter rotation axis. Z as rotation axis is a lot faster
          than Y.]        

          .OUTPUT FILE: SUR001
          [Enter the output file name for the surface image.]

          .HORIZONTAL DIMENSION OF SURFACE DEPTH BUFFER: 100
          [Enter dimension in the X direction.  Does not have to
          be related to volume dimensions.]

          .DEPTH FROM, TO: -32,20
          [Enter depth range which should be scanned.  The center of
          the three-dimensional structure is at zero depth, corresponding
          to x-dim/2+1,y-dim/2+1,z-dim/2+1. Negative values are on the 
          near side of the surface, positive values on the far side, with 
          respect to the reference plane.]

          .VIEWING ANGLE: 25
          [Enter angle, in degrees, between X direction of reference
          plane and X direction of 3D object.]

          .THRESHOLD: 0.25
          [Enter the threshold value that defines the surface.  The
          surface is defined by the values higher than a positive
          threshold value or lower than a negative threshold value.]

          .BACKGROUND (0)ZERO,(1)MIN,(2)MAX,(3)LOCAL MIN,(4)LOCAL MAX: 4
          [Enter the desired background for those areas in the resulting 
          image where no surface was found. Explanation of options:      '<BR>'
          
          0 = Set background to 0. (Option 0 must be used if subsequent 
              shading is to be applied to the surface. Other options will 
              result in a mottled background after shading.)             '<BR>'
          1 = Set background to the minimum (distance-1 of the surface 
              image).                                                    '<BR>'
          2 = Set background to the maximum (distance+1 of the surface 
              image).                                                    '<BR>'
          3 = Set background to minimum and correct for curvature in 
              Y direction.                                               '<BR>'
          4 = Set background to maximum and correct for curvature.
              Options 3 and 4 can be used to reduce the dynamic range
              of the depth buffer, when e.g. a long curved fiber 
              creates a large depth difference from one end of the 
              volume to the other and thus delicate surface features
              are obscured.                                              '<BR>'

          To obtain the correct contrast, if no shading is being
          applied, you must scale the final image with -1.  Then option 
          '0', '1' or '3' will give a white background; option '2' or '4' 
          a black background.]

    If a '3' or '4' was entered, SPIDER asks:

          .BOX LENGTH FOR BACKGROUND FILTER: 25
          [Enter the box length, in the X direction, for box  
          convolution used in the background correction.]

          .BACKGROUND OFFSET: 5
          [Enter offset of box-convoluted background.  See
          below for explanation.]


NOTES: 1. The background correction calculates the background
          for each line in the surface image and does a box
          convolution to low-pass filter this background  
          function.  This function is then subtracted from the  
          surface image.  The offset is necessary to ensure that
          all parts of the surface are on the same side of the
          background (if desired).

       2. For a detailed description, see: M. Radermacher & J.
          Frank (1984) "Representation of three-dimensionally  
          reconstructed objects in electron microscopy by surfaces of
          equal density", Journal of Microscopy 136:77-85.

       3. When the reference plane is placed in the interior, then
          a cutaway version of the object is computed. However, the
          flat cutting plane of such a representation frequently 
          shows artifacts. In order to obtain a "clean" cutting plane
          in the interior, you must create a separate volume from the
          portion of the volume you wish to represent, and pad ('PD') the
          new volume by adding at least one additional slice "in front".
          If oblique representations are needed, then the number of slices 
          to be added in front must accommodate the extra depth.

       4. The 'PJ SHAD' operation would normally be used after this operation
          to make a shaded surface representation.

SUBROUTINES: MRRSURF

CALLER:      VTIL2
