
PK 3      PeaK search - 3D                                 PK 3    
                                                            09/09/96

PURPOSE:  Searches for local density peaks in a volume.

SEE ALSO:  PK     (Peak search)
           PK 3D  (Peak search - 3D, output to doc. file)
           PK C   (Peak search - center of gravity)
           PK D   (Peak search - output to doc. file)
           PK DC  (PeaK search - center of gravity, output to doc. file
  
USAGE:    PK 3 X11,X12,X13,X14,X15,X16,X17
          [The first three registers pass the integer coordinates
          of the highest peak, and the second three pass the floating
          point coordinates resulting from the center of mass 
          calculation within a 3x3x3 box.
          The last register passes the absolute height of the peak.]  

          .INPUT FILE: REC001
          [Enter the name of the file containing the 3D density
          distribution.]

          .MAXIMA(+) OR MINIMA(-)?: +
          [Enter '+' if you want the local maxima and '-' if you
          want the local minima. Default is '+'.]

          .ENTER # OF PEAKS, CENTER ORIGIN OVERRIDE (0/1): 80,0
          [Enter the number of maxima or minima sought.  The default
          origin is assumed at the volume's center (NSAM/2 + 1,
          NROW/2 + 1, NSLICE/2 + 1).  If a different origin position
          is desired, enter '1' in the second position.  The system
          will then allow you to enter the X,Y,Z coordinates of the
          origin to be used.  In addition, a reference peak may be
          specified, and the ratio of the height of each data peak
          to this peak value will be calculated.  Default reference
          peak number is 1.]

          .CENTER OF GRAVITY CALCULATION(Y/N)? N
          [Answer N if only simple peak search is requested.]

    If the answer is 'Y' Spider then asks for the next two specifications:

          .X-Y RADIUS OF ELLIPSES: 5.3,4.5
          [Enter the X-Y radii of the ellipses determining the spatial
          region around the highest peak where the center of gravity
          is going to be calculated]
 
          .Z RADIUS OF ELLIPSES: 4.5
          [Enter the Z radius for the center of gravity calculations]

    If CENTER ORIGIN OVERRIDE option was chosen, Spider asks for
    the next three specifications:

          .X,Y ORIGIN COORDINATES: 12,15

          .Z ORIGIN COORDINATE: 11
          [Enter the new origin coordinates.]

          .ENTER PEAK NUMBER FOR RATIO: 1
          [Enter the number of the peak relative to which the
          heights of the other peaks are calculated.  This ratio
          is printed out and listed in the document file along
          with the other parameters of the peaks.]
 
          .BOX SELECTION (Y/N): Y
          [Enter 'Y' if you want to confine the search within a box
          smaller than the 3D volume.]

    If 'Y' is specified, Spider asks for the next three specifications:

          .LOWER,UPPER SLICE: 10,50
          [Enter lower and upper Z coordinates of confining box]

          .LOWER,UPPER ROW: 0,60
          [Enter lower, upper Y coordinates of confining box.]

          .LOWER,UPPER SAMPLE: 12,48
          [Enter lower, upper X coordinates of confining box.]
          
NOTE:     Memory required: 3*NSAM*NROW+7*(Number of peaks requested)

SUBROUTINES: SPEAK3, PKSR3, ROUT, CGR_3

CALLER:      UTIL1
