
PK DC     PeaK search - Center of gravity, output to Doc. file   PK DC
                                                            1/24/96

PURPOSE:  Searches for local peaks in a picture.

SEE ALSO:  PK     (Peak search)
           PK 3   (Peak search - 3D)
           PK 3D  (Peak search - 3D, output to doc. file)
           PK C   (Peak search - center of gravity)
           PK D   (Peak search - output to doc. file)

USAGE:    PK DC X11,X12,X13,X14,X15,X16,X17

          [The first three optional output parameters (in this 
          example X11,X12,X13) specify registers that are to receive
          the coordinates and the value of the largest peak found 
          in this operation (real values). X14 contains the ratio
          of the first peak relative to the peak # specified for 
          that ratio (option ORIGIN OVERRIDE). The last two registers 
          (here X15 and X16) return the non-integer coordinates 
          according to a 9-point parabolic fit, X17 contains the 
          value of the maximum.]

          .INPUT1 FILE: PIC001
          [Enter the name of the image file.]

          .ENTER # OF PEAKS,CENTER ORIGIN OVERRIDE (0/1): 12,0
          [Enter the number of peaks to be searched for.  If an 
          origin position other than at the picture's center (NSAM/2 +
          1, NROW/2 + 1) is desired, enter '1' in the second  
          position.  The system will then allow you to enter the x,y
          coordinates of the origin to be used.]

    If the option 'CENTER ORIGIN OVERRIDE' is specified, Spider asks for
    the next two specifications:

          .NEW ORIGIN COORDINATES: 1,1
          [Enter the new origin coordinates.]

          .ENTER PEAK NUMBER FOR RATIO: 1
          [Enter the number of the peak relative to which the
          heights of the other peaks are calculated.  This ratio
          is printed out and listed in the document file along
          with the other parameters of the peaks.]

          .ELLIPSE AXES (X,Y) FOR CGR CALCULATION: 2.5,3.5
          [Enter the axes of the ellipse limiting the area around 
          each peak, that is used for the center of gravity 
          calculation. (default for Y=0 is X=Y, assuming a circular
          area)]

          .POSITIVITY ENFORCED? (Y/N): N
          [If 'Y' is answered first the minimum in the area used for
          the CGR calculation is determined and subtracted from all
          pixels in that area]

          .NEIGHB.DIST.: 5.0
          [Only peaks with a distance larger than the specified 
          neighborhood distance will be written into a document 
          file.  The specification of a minimal neighborhood
          distance does not affect the printed output.]

          .EDGE EXCL. WIDTH X,Y : 4,3
          [enter the minimum distance (in pixels (integer)) of 
          peaks towards the edge of the image. The program uses 
          the length of the ellipse half-axes for the edge 
          exclusion if values lower than the ones for the CGR 
          elliptical area are given]

          .DOCUMENT FILE: DOC001
          [Enter the name of the document file.]

          [In the above example, the computer will find the 12
          largest peaks.  Their positions will be printed in the
          RESULTS file, and the value position of the largest peak
          will be printed to the user's terminal.  In addition, the
          peak positions and values will be put into the temporary
          registers if output parameters X11-X17 are specified, and
          will be written into the document file.  The registers can 
          be used as input to a subsequent 
          'SH' (SHIFT) operation.

NOTES:    1. Neighborhood exclusion and edge exclusion affect only the
          peaks which are entered into the document file.  The 
          results file still contains all peaks originally found.

SUBROUTINES: SPEAK, SPEAKC

CALLER:      UTIL1
