
PL        Plot doc. file data into CNT meta-file                 PL 
                                                            7/16/96

PURPOSE:  Prepares plot from selected columns of a 
          document file.  One column of registers stored in 
          document file may be assigned to the X axis, and
          one or more different columns to the Y axis of the 
          plot.  The Y vs X profiles are plotted within the
          range of keys specified.  A specification of 0 as 
          the column number for X register results in the 
          keys being assigned to the X axis.

SEE ALSO: PL FIT   (Fit polynomial to data stored in doc. file)
          PL HI    (Plot histogram from doc. file into CNT meta-file)
          CS DI PO (Converts Contour Storage File to Postsript)

USAGE:    PL

          .DOCUMENT FILE: DOC001
          [Enter the name of the document file of interest.]

          .CONTOUR FILE: CNT001
          [Enter name for CNT meta-file.]

          .ENTER MAX. NUMBER OF CONTOURS EXPECTED:  500
          [Use at least 200 here to be safe.]

          .ENTER REGISTER NUMBER(S) FOR Y AXIS: 1,2
          [Enter the register number(s) of interest.]

          [In the above example, profiles of the contents of
          document registers in columns 1 and 2 will be drawn 
          on the same plot.]

          .ENTER REGISTER NUMBER FOR X AXIS: 0
          [Enter the column number for the register 
          plotted on the X axis.  Column number 0 gives a
          plot of Y register(s) versus their keys.

          .ENTER INITIAL AND FINAL KEY NUMBERS:  1 44
          [Enter key range for registers being plotted.]

          Lists bounds on Y axis of plot.

          .ENTER NEW LOWER, UPPER Y AXIS BOUNDS OR <CR>:
          [Can change Y axis bounds. To keep default enter <return>.]

          Lists bounds on X axis of plot.

          .ENTER NEW LOWER, UPPER X AXIS BOUNDS OR <CR>:
          [Can change X axis bounds. To keep default enter <return>.]

          .ENTER NEW AXIS LABEL UNIT AND TICKS / LABEL OR <CR> :
          [Can change Y axis label unit or keep default]

          Y axis label units listed.

          .ENTER LABEL NO. TO EDIT.  USE  0  FOR LABEL:  1   '<BR>'
           -1  TO RELIST ALL LABELS,  OR  <CR> TO CONTINUE: <CR>
          [Can change X axis label unit or keep default]

          .ENTER NEW AXIS LABEL UNIT AND TICKS / LABEL OR <CR> :

          X axis label units listed.

          .ENTER LABEL NO. TO EDIT.  USE  0  FOR LABEL:  1   '<BR>'
           -1  TO RELIST ALL LABELS,  OR  <CR> TO CONTINUE: <CR>
          [Can change X axis label unit or keep default.]

NOTES: 1. To convert CNT meta-file to Postscript use the 'CS DI PO' 
          operation.

       2. To view the CNT meta-file use Web and 'Show contourfile'

SUBROUTINES: DPROFD, CSAXIS, CSPUSH, CSTRAP, CSSCALT, OPENDOC

CALLER:      PLOT1


