             The Pocket calculator 

             Available  in  SPIDER  is  a  "pocket  calculator"  which
        enables  the  user  to  evaluate  arithmetic expressions.  For
        example, in the command input status of SPIDER, the  user  may
        type

                        2*3+5

        SPIDER will then respond with '11.0000'.

             The arithmetic operations are defined as follows:

                  Operation           Symbol
                  --------------      ------
                  Addition              +
                  Subtraction           -
                  Multiplication        *
                  Division              /
                  Exponentiation        **
                  [Square root is available as a function; see 6.2]

             The expression is  evaluated  from  left  to  right  with
        standard  rules  of  precedence.   In  addition,  the user may
        specify negative numbers and  parentheses  just  as  he  would
        normally.  For example, if the user typed:

                  (3*-2)*(2+6)

        SPIDER would respond with '-48.0000'.

             The "pocket calculator" is especially  useful  when  used
        with  registers.  For example, if the user typed the following
        sequence:

                  X11=4.1
                  2*X11

        SPIDER would respond with 8.2000.  In addition, the  user  may
        set  a  register  equal to an expression.  For example, if the
        user typed:

                  X12=9.6
                  X12=X12+5

        SPIDER would store in X12 the value 14.6.

             If the user types an expression  that  does  not  conform
        with  the syntax rules of the conversion routines, SPIDER will
        respond with


                  '.  *** INVALID EXPRESSION'.

        Examples of valid expressions are:

                  2*-6
                  ((3+6)*(7*3))**9.1
                  X11=(X12+7)*(X16/X13)

        Examples of invalid expressions are:

                  X100           (Exceeds 99)
                  X12=(2+3       (Unbalanced parenthesis)
                  (2+3/6))       (Unbalanced parenthesis)



        Mathematical Functions

             The  following  mathematical  functions   are   presently
        implemented:

            PAD(<Expression>)     Compute next highest power of
                                    two to expression
            SIN(<Expression>)     Compute sine of expression
            COS(<Expression>)     Compute cosine of expression
            ACOS(<Expression>)    Compute arc-cosine of expression
            ASIN(<Expression>)    Compute arc-sine of expression
            EXP(<Expression>)     Compute exponential of
                                    expression
            LN (<Expression>)     Compute natural logarithm of expression
            LOG(<Expression>)     Compute logarithm10 of expression
            SQRT(<Expression>)    Compute square root of
                                    expression
            MOD(N1,N2)            Compute N1 modulo N2
            INT(<Expression>)     Compute rounded up/off integer
            ABS(<Expression>)     Compute absolute value of
                                    expression

            where  <Expression>  stands  for  any   valid   expression
            described in 6.1, and N1,N2 are numbers or registers.

            Examples:
                      SIN(4.5/(X5-100.))
                      X10=EXP(-400./X11**2)

        Note that the mathematical functions may only be used  in  the
        outermost  position.   They  may  not  be  used  inside  of an
        arithmetic expression.

        Example for invalid use:
                  X15=X14-SIN(45./180.*X91)

        In this case, use the sequence
                  X16=SIN(45./180.*X91)
                  X15=X14-X16
