
PP P      Put Points in image - from doc file, alters neighbors   PP P
                                                               06/20/96

PURPOSE:  Reads locations from a document file and places a value 
          into the specified image file at that location.   The pixel
          value (intensity) is also read from the document file.
          The four pixels surrounding this location are set to the
          maximum value previously found in the file.  This is
          apparently useful for marking images with the peak locations
          found by correlation.  Use 'PP P' if you do not want to
          alter the nearest four locations also.

SEE ALSO: PP L  (Put points in image - from doc file listing)
          PP LL (Put lines in image - from doc file listing)
          
USAGE:    PP P 

          .INPUT FILE: CCF001
          [Enter the name of the image file to be marked]

          .DOCUMENT FILE: DOC001
          [Enter name of document file where values to be interpreted
          as coordinates are located.]

          .XCOL, YCOL: 2,4
          [Enter the columns of the document file where the values
          are stored that are to be interpreted as x,y coordinates,
          respectively.  Note that a 0 specification for XPOS will
          cause the keys to be used as x-positions.]

          .HEIGHT COLUMN: 5
          [Enter the column of the document file where the values
          of the peak height are stored.]

          .XFACTOR, YFACTOR: 1.,1.
          [Enter scaling factors to be applied in x and y directions.
          If the output dimensions specified are equal to the
          dimensions of the file where the coordinates originated,
          XFACTOR=1 and YFACTOR=1 would be the normal specification.
          However, for histogram plotting (see example below),
          use XFACTOR=1, YFACTOR=-NROW, where NROW is the number of rows
          specified for the output file.  The minus sign inverts the
          y-direction so that a plot with conventional axes directions
          is obtained.]

          .KEYS TO BE USED:  1-25,28
          [Enter the keys of the document records you wish to use.
          Keys are normally numbers of particles, iteration counts,
          or ranks of peaks in a correlation search.]

NOTES:     1.  File statistics are now correct after this routine
               (June 1996, al). 

SUBROUTINES: PUTPT

CALLER:      UTIL2

