
PT        create PaTtern or Mask file                            PT
                                                            4/21/97

PURPOSE:  Using 'PT' you are able to create a 2D pattern or mask file
          (consisting of 0's and 1's) by combining sets of elementary
          patterns.  Elementary patterns available are:
          (P)oints, (L)ines, (C)ircles, (T)riangles, and (R)ectangles.
          These elementary patterns can either be "added" (i.e. the
          corresponding image points will be set to 1.0) or 
          "subtracted" (i.e. the corresponding image points will be set
          to 0.0) from the image.

SEE ALSO: PP L  (Put points in image from doc. file coordinates)
          PP LL (Put lines in image from doc. file coordinates)
          MO    (Create model image)
          BL    (Create blank image)

USAGE:    PT 

          .OUTPUT FILE: H_IMG042
          [Enter the name of an existing or new pattern file.]

    If the pattern file does not exist, SPIDER will ask:

          .ENTER DIMENSIONS (NSAM, NROW): 32,64
          [Enter the sample and row sizes of the pattern file.]

          .ENTER PATTERN CODE (P,L,C,T,R,S): P
          [Enter the pattern code desired (see below for listing
           of all possible codes.]

    For '<B>' (P)oint ('P' or 'PS') '</B>', SPIDER will ask:
         
          .ENTER COORDINATES: 12,15
          [Enter the coordinates of the point.]

          [The specified image point will be set to 1.0 
          (code: 'P') or to 0.0 (code 'PS'), respectively.]

    For '<B>' (L)ine ('L' or 'LS') '</B>', SPIDER will ask:

          .ENTER COORDINATES OF STARTING POINT: 12,17
          .ENTER COORDINATES OF ENDING   POINT: 23,32
          [Enter the coordinates of the two end points of the line.]

          [All points along the line between the two specified
          margin points (i.e. the nearest grid point in every
          column and row) will be set to 1.0 (code: 'L') or to 0.0
          (code: LS), respectively.]

    For '<B>' (C)ircle ('C', 'CS', 'CL', or 'CLS' ) '</B>', SPIDER will ask:

          .ENTER CENTER COORDINATES: 12,15
          .ENTER RADIUS: 8.
          [Enter center coordinates and radius of the circle.]

          [Either, all points within the area limited by circle
          with the specified center and radius are set to 1.0
          (code: 'C') or 0.0 (code: 'CS'), respectively, or, only
          those image points belonging to the margin of the 
          specified circle (i.e. the points lying on the margin line of
          the circle) are set to 1.0 (code: 'CL') or to 0.0 (code:
          'CLS'), respectively.]

    For '<B>' (T)riangle ('T', 'TS', 'TL', or 'TLS' ) '</B>', SPIDER will ask:
              
          .ENTER COORDINATES OF FIRST  POINT: 12,16
          .ENTER COORDINATES OF SECOND POINT: 22,10
          .ENTER COORDINATES OF THIRD  POINT: 3,5
          [Enter the coordinates of the three apexes of the triangle.]

          [Either, all points within the area limited by the
          triangle with the specified margin points are set to
          1.0 (code: T) or 0.0 (code: 'TS'), respectively, or,
          only those image points belonging to the margin lines
          of the specified triangle are set to 1.0 (code: 'TL') or
          to 0.0 (code: 'TLS'), respectively.]

    For '<B>' (R)ectangle ('R', 'RS', 'RL', or 'RLS' ) '</B>', SPIDER will ask:

          .ENTER COORDINATES OF UPPER LEFT POINT: 10,8
          [Enter the coordinates of the upper left corner of the
          rectangle.]
          .ENTER X AND Y OFFSETS: 2,4
          [Enter the X and Y offsets to the lower right corner.]

          [Either, all points within the area limited by the
          specified rectangle are set to 1.0 (code: 'R') or 0.0
          (code: 'RS'), respectively, or, only those image points
          belonging to the margin lines of the specified  
          rectangle are set to 1.0 (code: 'RL') or to 0.0 (code: 'RLS'),
          respectively.]

    For all selections SPIDER will ask:

          .CONTINUE ? (Y,N): Y
          [Enter 'Y' if you want to "add" or "subtract" another
          elementary pattern, enter 'N' if you are finished.]

SUBROUTINES: MCIRCL, MLINE, MPOINT, MRECTL, MTRIAN, PTTERN

CALLER:      CONF1
