
PW        PoWer spectrum                                    PW      
                                                            8/27/96

PURPOSE:  Generates full, unscrambled Fourier moduli from complex
          Fourier transform on disk for 2-D or 3-D pictures.
          The input 2D image can be real if it fits into the memory.
          Operations supports multiple radix FFT, thus the input
          image does not have to have power-of-two dimensions
          (see  'FT').
          The resulting data are real and can be displayed like
          a normal picture.

SEE ALSO: PW L  (Power spectrum - Log10)

USAGE:    PW

          .INPUT FILE: FOU001
          [Enter the file name of the Fourier transform.]

          .OUTPUT FILE: POW001
          [Enter the name of the file where the power spectrum is to
          be kept.]

NOTES: 1. The center of 2-D power spectrum is placed in
          (NSAM/2+1,NROW/2+1); for 3-D case in 
          (NSAM/2+1,NROW/2+1,NSLICE/2+1).

       2. Memory requirements:
          '<PRE>'
          input image                memory in words
             2d real                   (NSAM+2)*NROW
             2d complex                (NSAM+2)*NROW
             3d real                   (NSAM+2)NROW*NSLICE
          '</PRE>'

SUBROUTINES: PW2S,  PW2SD, PW2SDR,PW2SR, PW3S,  PW3SD, PW3SDR,  PW3SR 

CALLER:      FOUR1, FOUR1B
