
RC        Real Convolution                                  RC      
                                                            3/25/96

PURPOSE:  Computes convolution product between picture and specified
          matrix (point spread function (PSF)) in real space.  PSF is 
          assumed square.

USAGE:    RC

          .INPUT FILE: PIC001
          [Enter name of picture to be convoluted.]

          .OUTPUT FILE: PIC002
          [Enter name of file where convoluted picture is to be
          kept.]

          .PSF IN FILE: PSF001/*/#
          [Enter (1) Name of file where PSF matrix is found, 
                 (2) '*' to indicate that PSF matrix is typed in and is not 
                     to be saved,
                 (3) '#' to indicate that PSF is typed in and is to be saved.
          ]

          1.  PSF001 (refers to existing PSF file).  The system will
              then read in the PSF file and print out:        '<BR>'

              .PSF IN EFFECT                                  '<BR>'
              -0.1 -0.1 -0.2 -0.1 -0.1                        '<BR>'
              -0.1 -0.1 -0.3 -0.1 -0.1                        '<BR>'
              -0.1 -0.1  3.0 -0.1 -0.1                        '<BR>'
              -0.1 -0.1 -0.3 -0.1 -0.1                        '<BR>'
              -0.1 -0.1 -0.2 -0.1 -0.1                        '<BR>'

              [The convolution product between PIC001 and PSF001 is
              then computed and written into PIC002.]

          2.  '*' (PSF matrix to be entered, not to be saved).

              .PSF WIDTH: 5
              [Enter linear size of PSF matrix.  Number must be odd.
              See notes regarding range.]

              .ENTER PSF MATRIX (5 ROWS and COLUMNS): 
                #    #    #    #    # ....          '<BR>'
              
              [Enter matrix, up to <PSF WIDTH> numbers per line]

              -0.1 -0.1 -0.2 -0.1 -0.1        '<BR>'
              -0.1 -0.1 -0.3 -0.1 -0.1        '<BR>'
              -0.1 -0.1  3.0 -0.1 -0.1        '<BR>'
              -0.1 -0.1 -0.3 -0.1 -0.1        '<BR>'
              -0.1 -0.1 -0.2 -0.1 -0.1        '<BR>'

              [SPIDER will then normalize the PSF and print out]:

              .PSF IN EFFECT
              [...and proceed as in (1), above.]

          3.  '#'  (PSF matrix to be entered and saved).

              .PSFOUT FILE: PSF002
              [Enter name of file where PSF matrix is to be saved.]

              .PSF WIDTH: 5
              [Enter linear size of PSF matrix.  Number must be odd.
              See notes regarding range.]

              [...proceed as in (2), above.]

NOTES: 1. CPU time increases with the square of the PSF dimension.

       2. If PSF has "box" form (i.e., all coefficients of matrix
          have equal value), use box convolution ('BC').

       3. Memory required:
          p - size of PSF
          2D - NSAM*(p+1)+p*p
          3D - NSAM*NROW*(p+1)+p*p*p
 
       4. Fourier convolution, 'CN', is the method of choice
          for large PSFs (with PSFs as large as the image!).

       5. 'RC' has been rarely used since it was first 
          programmed.  It is entirely possible that bugs have
          developed over the years.
           
       6. 'RC has been revised for more general application.
          PSF was assumed to be centrosymmetric in ealier 
          version.

SUBROUTINES: RCONV, RCNV3_P, RCNV2_P

CALLER:      UTIL3
