
RF        R Factor                                         RF  
                                                           9/05/96

PURPOSE:  Computes various measures of proximity between 
          two images: R factor, phase residual, 
          and Fourier ring correlation.

SEE ALSO: RF 3    (Phase residual in 3D)
          RF SN   (Spectral Signal-to-Noise Ratio)
  
USAGE:    RF

          .FIRST INPUT FILE: FIL001
          [Enter the name of the first (real) file.]

          .SECOND INPUT FILE: FIL002
          [Enter the name of the second (real) file.]

          .RING WIDTH:1.
          [Enter the ring thickness in reciprocal space sampling units.] 

          .SCALE FACTOR (LOWER,UPPER): 0.8,1.2
          [Give the range of scale factors by which the second
          Fourier must be multiplied for the comparison.  This
          range is divided into 20 steps for a scale search.]

          .DOCUMENT FILE: DOC001
          [Enter name of doc file in which results are to be saved.] 

NOTES: 1. Scale search is done separately for each ring in Fourier
          space.  This will NOT lead to sensible results if one 
          of the transforms  falls off rapidly in a frequency range
          where the other transform is strong.
          The range specified by the user is searched for 
          the lowest value, and the actual scaling
          factor used is printed along with the RF measures.

      2.  If the scale range specified contains no minimum, then
          an error message is printed: "NO MINIMUM IN RFACT CURVE
          FOUND FOR RING XX" where XX is the ring number where the
          error occurred.

      3.  Internally Fourier transforms of input images are
          calculated.  Check manual chapter FT for the list
          of "forbidden" dimensions.

      4.  The following measures are computed and tabulated:
          [those marked with "*" are commented out in the subroutine,
          but can be easily re-activated.]                      '<BR>'

          a) R(AKEY et al.) = 2*SUM(ABS(F1-F2))/SUM(ABS(F1)+ABS(F2));'<BR>'

          b)  R(McPherson) = 2*SUM(ABS(F1)-ABS(F2))/SUM(ABS(F1)+ABS(F2));'<BR>'

          c)  PHASE RESIDUAL = SQRT(SUM[(ABS(F1)+ABS(F2))*DPHI**2]/
                                            SUM(ABS(F1)+ABS(F2)))'<BR>'
              where DPHI = The phase difference between corresponding
                           Fourier coefficients, which should be <45 deg.;'<BR>'

          d) R.M.S ERROR = 2*SQRT(SUM(ABS(F1-F2)**2)/SUM(ABS(F1)**2+
                                             ABS(F2)**2));       '<BR>'

          e)  FOURIER RING CORRELATION, which should be larger than
              the Critical Fourier Ring Correlation provided for
              comparison;                                        '<BR>'

          f)  Critical Fourier Ring Correlation                  '<BR>'
         
SUBROUTINES: RFACTSDO, RFACTSD2

CALLER:      FOUR1

