RF 3       Phase Residual & Fourier shell correlation, 3D        RF 3
                                                                5/1/96

PURPOSE:   Calculate the differential 3-D phase residual and the Fourier  
           Shell Correlation between two 3-D volumes. The Differential  
           Phase Residual over a shell with thickness given by shell
           width and the Fourier Shell Correlation between shells of 
           specified widths are computed and stored in the document 
           file. Does not need powers of two dimensions (for exclusions 
           see 'FT' operation) and  needs REAL input images.  
           NSAM, NROW and NSLICE need to be equal. 

SEE ALSO:  RF    (R Factor)
           RF SN (Spectral signal to noise ratio)
           FT    (Fourier transform)

USAGE:     RF 3

           .FIRST INPUT FILE: SUB001
           [Enter name of first real 3-D volume.] 

           .SECOND INPUT FILE: SUB002
           [Enter name of second real 3-D volume.] 

           .RING WIDTH:1.
           [Enter the shell thickness in reciprocal space sampling units.] 

           .SCALE FACTOR (LOWER,UPPER): 0.6,1.2
           [Give the range of scale factors by which the second Fourier must be 
           multiplied for the comparison.] 

           .MISSING CONE/WEDGE ANGLE(C/W):c
           [Use 'C' if you have a missing cone and w if you have a missing wedge. 

           .MAXIMUM TILT ANGLE:30
           [Give the angle of maximum tilt angle in degrees. (When the missing 
            cone is covered angle=90.0)] 
	
	   .FACTOR FOR NOISE COMPARISON: 3.0
           [The factor given here determines the FSCCRIT. Here 3.0 corresponds to 
           the 3 sigma criterion i.e., 3/SQRT(N), where N is number of voxels for 
           a given shell.  You could use 2, 1,4 or anything.]

           .DOCUMENT FILE: DOC001
           [Enter name of doc file in which results are to be saved.] 

NOTES:     1.  The inclination angle theta starts from the Z*=0 plane. 

           2.  Scale search is done separately for each shell. This will NOT lead 
           to sensible results if one of the transforms falls off rapidly in a 
           frequency range where the other transform is strong.  The range specified 
           by the user is divided into 20 steps and searched for the lowest
           value The value: '<BR>'
           R(McPherson) = 2*SUM(ABS(F1)-ABS(F2))/SUM(ABS(F1)+ABS(F2))   '<BR>'
           is calculated at each step within a ring and its minimum is used to 
           determine the correct scale factor for the second Fourier transform. 

           3.  The following measures are computed and tabulated:       '<PRE>'
            a) PHASE RESIDUAL =  
                  SQRT(SUM[(ABS(F1)+ABS(F2))*DPHI**2]/ SUM(ABS(F1)+ABS(F2))) 
               where DPHI = The phase difference between corresponding Fourier,
               coefficients which should be < 45 DEG. 
            b) SHELL CORRELATION = 
                  [SUM(F1*CONJ(F2))]/ [SQRT{SUM(ABS(F1)**2)*SUM(ABS(F2)**2)}] 
              where CONJ implies complex conjugate.
                                                                        '</PRE>'

           4.  Contents of DOC file:                                       
            '<PRE>'
            COLUMN:     #1         #2    #3    #4         #5     #6                                                    '<BR>'
           |NUMBER| |NORMALIZED |DPH| |FSC| |FSCCRIT| |VOXELS| |FREQUENCY|						 	        '<BR>'
            '</PRE>'

           5.  COMMENTS and REFERENCES with regard to FSC Ref: Saxton and Baumeister,
           '<I>'J.of.Micr.'</I>', 127,(1982) 127-138. 
           M. van Heel, '<I>'Ultramicroscopy'</I>'., 21, (1987) 95-100. 
           Unser,et.al.,  '<I>'Ultramicroscopy'</I>', 23, (1987) 39-52. 
           A correlation coefficient "r" implies a SNR=2*r/(1-r). (factor
           2 comes from the fact that for the purpose of comparison whole data set is 
           divided into halves). SNR=4.0 implies r=0.67 SNR=2.0 implies r=0.5 WHY 
           these two special cases of SNR? According to Unser FSC=0.67 should 
           correspond to DPH=45. 

SUBROUTINES:  PR3D, PR3DB

CALLER:       FOUR1 

