RF SN     Spectral SNR of images                            RF SN
                                                            8/25/97

PURPOSE:  Compute the Spectral Signal-to-Noise Ratio (SSNR) of a given 
          series of images.

SEE ALSO:  RF    (R Factor)
           RF 3  (Phase residual in 3D)

USAGE:    RF SN

          .ENTER TEMPLATE FOR IMAGE NAME: IMG***
 
          .Selection doc file: SELECT
          [Enter selection document file name containing the numbers
           of the input images in the first column.] 

          .MASK FILE: MAS999
          [Enter the name of mask image for masking each image in the set]

          .RING WIDTH: 0.5
          [Enter ring width of each frequency radius for SSNR computation.]

          .DOCUMENT FILE: DOC001
          [Enter name of resulting document file.]

          FR(I) = N*{SUM(SIG(kX,kY))/SUM[NOI(kX,kY)/(N-1)]}       '<BR>'
          Sum over Fourier units in each ring of radius I
                                  
NOTES: 1. If you do not want to mask the images, you still have to create
          a mask image with constant value 1 by using command 'BL'.

       2. Command calculates the following equations:   '<BR>'

          SSNR:    SSNR(I) = FR(I)-1  if FR(I).GT.1     '<BR>'
                           = 0        if FR(I).LE.1     '<BR>'

          VAR(I) is the expected variance of SSNR(I):   '<BR>'
          VAR(I) = SQRT{2[(N2+N1-2)*(1+2*SSNR(I))+N1*SSNR(I)**2)]/
                          [N1*(N2-4)]}   '<BR>'

                         --- N1 = NRING(I)/2            '<BR>'
                         --- N2 =N1*(N-1)               '<BR>'
                         --- NRING = Number of Fourier units for each ring.'<BR>'
         
          DOC file: COLUMN: #1        #2           #3       #4      #5     '<BR>'
                       RING RADIUS  RING RADIUS   SSNR(I)  NRING(I) VAR(I) '<BR>'
                                (NORMALIZED SCALE) 
       3. References:                                                      '<BR>'
          [1] M. Unser, B.L. Trus & A.C. Steven, '<I>'Ultramicroscopy'</I>' 23(1987)
              39-52: "A New Resolution Criterion Based on Spectral 
              Signal to-Noise Ratios"  '<P>'                                    '<BR>'
               
          [2] M. Unser, B.L.Trus & A.C. Steven, '<I>'Ultramicroscopy '</I>'30(1989)
              429-434: "The Spectral Signal-to-Noise Ratio Resolution 
              Criterion: Computational Efficiency and Statistical 
              Precision"
 
SUBROUTINES:  SSNR,SSNRB

CALLER:       FOUR1
