
RR        Read Register                                     RR      
                                                            3/22/96

PURPOSE:  To read a value into a register of a procedure at run
          time.

USAGE:    RR X10

       OUTSIDE OF PROCEDURE:

          .VALUE: 4.
          [Enter the value (floating point) to be put into register
          X10.  In this form the command is equivalent to the 
          command 'X10 = 4'.  Indeed, it offers no advantage over this
          simple statement.]

       WITHIN A PROCEDURE:

          ? ENTER MAGNIFICATION ?

          [An interactive call to a procedure containing this
          statement produces the following sequence...]:

          ? ENTER MAGNIFICATION ?  4./X20/<2>

          [...where the value may either be explicitly entered (4.),
          declared as the contents of a register of the calling 
          command stream (X20), or, if the calling command stream is a
          procedure, declared as a previously solicited value (<2>).
          The value entered in any of the three forms will be stored
          in register X10 and used in the subsequent computation.]

NOTES:    'RR' may also be used within a DO-loop to enter a set of
          numbers successively into a register:

              DO LB1 I=1,5                          '<BR>'
              RR X10                                '<BR>'
              4.3,8.1,0.12,5.0,8.55                 '<BR>'
              .                                     '<BR>'
              .                                     '<BR>'
              .                                     '<BR>'
              LB1                                   '<BR>'

          For I=1, X10 will be filled with the value 4.3, and so
          forth.

SUBROUTINES: READRQ, READPQ, SHRINKQ, CHKSTRQ

CALLER:      DRIV3
