
RT        RoTate - image or volume, use average as background      RT
                                                               8/25/97

PURPOSE:  Rotates a picture counter-clockwise around the center
          (NSAM/2 + 1, NROW/2 + 1).  
          Note that the notions "clockwise" and "counter-clockwise"
          refer to the mirrored x-y system used for image display. 
          The background rotated into the image field is 
          the average of the input image 

SEE ALSO: RT 3   (RoTate - volume, slow)
          RT 3A  (RoTate - volume, around arbitrary center)
          RT 3D  (RoTate - volume, fast)
          RT 90  (RoTate - image or volume, by 90, 180, or 270 degrees)
          RT B   (RoTate - image or volume, supply background)
          RT C   (Rotate - image, around arbitrary center, for small files)
          RT M   (Rotate - image or volume, use minimum as background)
          RT SQ  (RoTate - image or volume, shift, use quadratic interpolation)

USAGE:    RT

          .INPUT FILE: H_PIC001
          [Enter the name of the file to be rotated.]

          .OUTPUT FILE: H_IMG044
          [Enter the name of the file where the rotated image is to
          be kept.]

          .ROTATION ANGLE: 90.0
          [Enter the rotation angle in degrees.]

          [PIC001 will then be rotated 90 degrees, and the rotated
          image put in ROT001.]

NOTES: 1. The rotation angle can be specified by reference to a
          register:  '-X10' will input the rotation angle (with
          inverted sign) found in a previous 'OR X10' operation.
          Whether or not the sign has to be inverted follows
          from the order of argument files in 'OR'.

       2. The input file may be three-dimensional.  In this
          case, each of the slices is separately rotated around
          the z-axis, and stored in the output file which will
          be created with the same dimensions.

SUBROUTINES: ROT, ROT32

CALLER:      UTIL3
