
RT 3D     RoTate - volume, fast                            RT 3D
                                                        07/25/95

PURPOSE:  Rotates a volume by the three Eulerian angles.

SEE ALSO: RT     (RoTate - image or volume, use average as background)
          RT 3   (RoTate - volume, slow)
          RT 3A  (RoTate - volume, around arbitrary center)
          RT 90  (RoTate - image or volume, by 90, 180, or 270 degrees)
          RT B   (RoTate - image or volume, supply background)
          RT C   (Rotate - image, around arbitrary center, for small files)
          RT M   (Rotate - image or volume, use minimum as background)
          RT SQ  (RoTate - image or volume, shift, use quadratic interpolation)

USAGE:    RT 3D

          .INPUT FILE: PIC001
          [Enter the name of the file to be rotated.]

          .OUTPUT FILE: ROT001
          [Enter the name of the file where the rotated volume is to
          be stored.]

          .Phi, Theta: 10.5,13.7 
          [Enter the rotation angles Phi (around Z) and Theta (around 
          the new Y after the first rotation by Phi).]

          .Psi: 45.8
          [Enter the third rotation angle (around the new Z)]. 

NOTES: 1. Program reads first volume into the memory - larger volumes
          may not fit. In this case use 'RT 3' instead. Unfortunately 
          'RT 3' gives slightly incorrect results and does not use the 
          proper interpolation scheme and has sign of theta reversed.
  
       2. Tri-linear interpolation scheme is used.

       3. Non-matching points are replaced by the average.

       4. All the rotations are done clockwise.

       4. Rotation matrix used:
          '<PRE>'
          R = R(psi) * R(theta) * R(phi)

           c  s  0        c  0 -s      c  s  0
          -s  c  0    *   0  1  0   * -s  c  0
           0  0  1        s  0  c      0  0  1
          '</PRE>'

       5. In the corners, old values are left.

       6. Implemented by Paul Penczek.

SUBROUTINES: ROTAS3, ROTS3, BLDR

CALLER:      UTIL3
