
RT C      RoTate - image, around arbitrary center, for small files      RT C
                                                              3/25/96

PURPOSE:  Rotates an image counter-clockwise around a 
          center specified by the user.  (Negative angles: 
          clockwise.   Note that the notions "clockwise" and 
          "counter-clockwise" refer to the mirrored x-y system used 
          for image display).  The background rotated into the image 
          field is the average of the input image.

SEE ALSO: RT     (Rotate - image or volume, use average as background)
          RT 3   (Rotate - volume, slow)
          RT 3A  (Rotate - volume, around arbitrary center)
          RT 3D  (Rotate - volume, fast)
          RT 90  (Rotate - image or volume, by 90, 180, or 270 degrees)
          RT B   (Rotate - image or volume, supply background)
          RT M   (Rotate - image or volume, use minimum as background)
          RT SQ  (Rotate - image or volume, shift, use quadratic interpolation)

USAGE:    RT C

          .INPUT1 FILE: H_PIC001
          [Enter the name of the file to be rotated.]

          .OUTPUT FILE: H_IMG046
          [Enter the name of the file where the rotated image is to
          be kept.]

          .ROTATION ANGLE: 90.0
          [Enter the rotation angle in degrees.]

          [PIC001 will then be rotated 90 degrees, and the rotated
          image put in ROT001.]

          .X-SHIFT:
          [Enter the desired X location of the rotational center
          relative to the center of the image]

          .Y-SHIFT:
          [Enter the desired Y location of the rotational center]

NOTES: 1. The rotation angle can be specified by reference to a
          register:  '-X10' will input the rotation angle (with
          inverted sign) found in a previous 'OR X10' operation.
          Whether or not the sign has to be inverted follows
          from the order of argument files in 'OR'.

SUBROUTINES: ROT, ROT32

CALLER:      UTIL3
