
RT SQ     RoTate - image or volume, Shift, use Quadratic interpolation   RT SQ
                                                              01/25/98

PURPOSE:  Changes the scale, rotates and shifts image circularly. 
          Rotates a picture counter-clockwise around the center
          (NSAM/2 + 1, NROW/2 + 1). (Negative angles = clockwise.
          Note that the terms "clockwise" and "counter-clockwise"
          refer to the mirrored x-y system used for image display). 

SEE ALSO: RT     (RoTate - image or volume, use average as background)
          RT 3   (RoTate - volume, slow)
          RT 3A  (RoTate - volume, around arbitrary center)
          RT 3D  (RoTate - volume, fast)
          RT 90  (RoTate - image or volume, by 90, 180, or 270 degrees)
          RT B   (RoTate - image or volume, supply background)
          RT C   (Rotate - image, around arbitrary center, for small files)
          RT M   (Rotate - image or volume, use minimum as background)

USAGE:    RT SQ

          .INPUT FILE: H_PIC001
          [Enter the name of the file to be rotated.  (The file can
           be a whole stack)]

          .OUTPUT FILE: H_IMG048
          [Enter the name of the file where the rotated and shifted
          image is to be kept.  (If the input file is a whole stack
          this  file can be a whole stack)]

      If the input file is a whole stack the following questions appear.
         .ENTER REG. NUMBERS FOR ANGLE, SCALE, X,  & Y SHIFT: 1 2 3 4

         . ANGLE/SCALE DOCUMENT FILE: ANGDOC
          [Doc. file contains angle in degrees, scale factor (>0),
           X, and Y shifts.

      If the input file is not a whole stack the following questions 
      appear.
          .ROTATION ANGLE, SCALE: 90.0, .75
          [Enter the rotation angle in degrees, and scale factor (>0).
          Default scale is set to 1.0 (see Note 2).]

          .X, Y SHIFT : 12.34,-1.987
          [Enter the X and Y shift values.]

NOTES: 1. The whole task is done using only one interpolation
          of the input image; thus, the problem of accumulation of 
          interpolation errors during alignment can be entirely overcome.

       2. The change of scale will not change the image dimensions.
          The scale is provided from the single-tilt alignment,
          and all the parameters agree with the output of the
          marker program (command 'MK').

       3. The input file may be three-dimensional.  In this case, 
          each of the slices is separately rotated and shifted with
          respect to the z-axis, and stored in the output file, which 
          will be created with the same dimensions.

       4. The dimensions of the image need not be powers of two,
          and shifts can be any real numbers.

       5. The accuracy of interpolation is much higher than that of the
          bilinear interpolation used in the 'RT' command, but it is 
          lower than the accuracy of bi-spline interpolation. In 
          particular, the derivatives of the interpolated image are 
          not continuous.  The speed, however, is much higher than 
          for bi-spline interpolation.

       6. Memory requirements: NSAM*NROW+NSAM

       7. Implemented by: P. Penczek.

SUBROUTINES: ROTQS, ROT2QS, QUADRI, GETDOCDAT, NEXTIMG

CALLER: UTIL3
