
SA        Sum Alignment                                     SA
                                                         3/27/96

PURPOSE:  To perform vector addition of rotation and shift values
          from two successive cycles of alignment of an image
          series.  The summed values, saved in registers, can then
          be applied to the original images.  Additive interpolation
          errors are thus avoided.

SEE ALSO:  SA P (Sum alignment - positive rotation and shift)

USAGE:    SA   X10,X11,X12,X20,X21,X22,X30,X31,X32

          [The first three (input) registers specified contain the
          rotation angle, the x-shift value, and the y-shift value
          from the initial alignment cycle.  The second group of
          three (input) registers contain the rotation and x  and y 
          shift values from the refinement cycle.

          The first three will typically have been retrieved
          from a document file by an UNSAVE ('UD') operation just
          prior to the call to 'SA'.  The second three can also have
          been UNSAVEd in this manner from another document file, or,
          if the 'SA' is performed in the same session (batch run) as
          the second cycle, they may simply be the current register
          contents (see below).
          
          The final three registers specified are output
          registers, and receive the vector sums for the rotation
          and shift.

NOTES: 1. Rotational matrix used in SA has form:       '<BR>'
        
                    c    -s       '<BR>'
                    s     c       '<BR>'
       
          It works for the angles and shifts obtained from CC IC
          and OR commands which have to be used with reversed
          signes in 'RT SQ'.
        
       2. 'SA'  may be applied most conveniently within the second
          cycle loop.  The intermediate image series (rotated and
          translated by the amounts found in the first cycle) are
          realigned against a refined reference, and the values are
          stored in X20-X22.  The values from cycle 1 are then
          UNSAVEd into X10-X12, and 'SA' is used to obtain X30-X32.
          These output values are finally applied to rotate and
          shift the unaligned original image series.  They should
          also be saved in another document file, using 'SD'.  Note
          that two input and one output series must be on disk at
          one time.  The original images may be deleted individually
          (within the DO-loop) once the corresponding final, aligned
          images have been obtained.

       3. After having obtained resulting angle and shifts the 'RT SQ'
          command is highly recommended for the final step.

SUBROUTINES: SUMALI

CALLER:      DRIV1
