
TF        Transfer Function - defocus dependent                   TF      
                                                            10/23/96

PURPOSE:  Generates a transfer function, squared transfer function,
          or envelope function within a specified defocus range and
          for specified electron optical parameters.

SEE ALSO: TF C    (Transfer Function - complex)
          TF C3   (Transfer Function - complex 3D)
          TF CT   (Transfer Function - phase flipping, complex, ternary)
          TF CT3  (Transfer Function - complex, ternary 3D)
          TF CTF  (Transfer Function - CTF correction)
          TF D    (Transfer Function - display)
          TF DDF  (Transfer Function - determine defocus and amplitude contrast)
          TF DEV  (Transfer Function - determine envelope function)
          TF DNS  (Transfer Function - determine and delete noise background)
          TF FL   (Transfer Function - flip sign of Fourier transform)
          TF MFL  (Transfer Function - make filter file for 'TF FL')

USAGE:    TF

          .OUTPUT FILE: TRA001
          [Enter the name of the file where the transfer function is
          to be stored.]

          .CS: 3.5
          [Enter the spherical aberration coefficient in mm.]

          .LAMBDA: 0.037
          [Enter the electron wavelength in Angstroems.]

          .LOWER DEFOCUS LIMIT: -1800.
          [Enter the lower defocus limit in Angstroems.]

          .UPPER DEFOCUS LIMIT: 3000.
          [Enter the upper defocus limit in Angstroems.]

          .NUMBER OF SP. FREQ. PTS./DEF. POINTS: 120,300
          [Enter the number of spatial frequency grid points and the
          number of defocus grid points.]

          .MAXIMUM SPATIAL FREQUENCY [A**-1]: 0.5
          [Enter the spatial frequency limit in 1./Angstroems.]

          .SOURCE SIZE: .005
          [Enter the source size in spatial frequency units,
          1./Angstroems.]

          .DEFOCUS SPREAD [A]: 200.
          [Enter the 1/e halfwidth of the defocus distribution in
          Angstroems.]

          .AMPLITUDE CONTRAST RATIO [0-1], GAUSSIAN ENVELOPE PARAMETER: 0.2,100
          [Enter ACR and GEP; see below for definition.]

          .(D)IFFRACTOGRAM/(E)NVELOPE/(S)TRAIGHT: D
          [Either the transfer function is put into the array directly as
          computed (option 'S'), or its square (option 'D') is stored, or
          else the envelope function describing the attenuation of the 
          transfer function due to partial coherence effects (option
          'E').]

          .FRAME? (Y/N): Y
          [The specified function will then be generated, and stored
          in TRA001.]

NOTES: 1. Theory and all definitions of electron optical parameters
          are according to:  J. Frank (1973) Optik 38:519, and R. Wade
          & J. Frank (1974) '<I>'Optik'</I>' 49:81.  Internally, the program
          uses the generalized coordinates defined in these papers.

       2. In addition, an optional cosine term has been added with a weight,
          and an ad hoc Gaussian falloff function has been added as discussed
          in Stewart et al. (1993) '<I>'EMBO J.'</I>' 12:2589-2599.

          The complete expression is:                                  '<BR>'

          TF(K) = [(1-ACR)*sin(GAMMA) - ACR*cos(GAMMA)]*ENV(K)*exp[-GEP*K^2]

       3. 10/01/96 - The equation was corrected; dependence on the defocus
          spread was changed; see the 'TF' and 'TFD' subroutines.

SUBROUTINES: TF, TRAF

CALLER:      UTIL1
