
UD IC     Unsave Document - In Core                          UD IC   
                                                           09/13/96

PURPOSE:  To unsave a document file and store its contents in-core  
          for further fast accesses within this session.  On Unix 
          10 document files with unlimited keys each can be stored 
          in concurrently in-core.  On VAX/VMS, only two document 
          files with maximum key numbers of 9999 can be stored.
          'UD ICE' terminates access to current in-core image of the 
          document file specified, and allows access to a different 
          document file after another 'UD IC' operation.           

SEE ALSO: UD ICE (Unsave document - in core, end)
          UD     (Unsave document)
          UD S   (Unsave document - sequential search)
          
 
USAGE:    UD IC,<KEY>,X<N1>,X<N2>, ... ,X<N5>                       

          [Where:                                                 '<BR>'
           <KEY> is the key;  X<N1> ... X<N5> are up to 5 registers 
           to be filled. 

          Examples:'<BR>'
           
          E1. UD IC,300,X51,X52,X60,X65 (key is explicit number)     '<BR>' 
            
          E2. UD IC,X90,X40,X35,X34,X10 (key is contained in register)'<BR>'
           
          E3. UD IC,I,X30,X31           (key is the DO-LOOP index) '<BR>'   

          .DOCUMENT FILE: ADC998                                    
          [Enter the name of the document file previously created   
          by a 'SD' command or by operations such as 'PK']        '<BR>'         

          [In example E1, let's say the document file has the first  
          490 keys filled.  The command listed above will cause all 
          490 x 4 numbers of the document file to be stored for     
          future access within  this session, and will fill         
          registers X51,X52,X60, and X65 with the values stored     
          under key 300.  Subsequent access to any other key        
          present in the file (namely 1 ... 490),                   
          e.g.                                                    '<BR>'                                             
                          UD IC,410,X51,X52,X60,X65               '<BR>'                 
                          
          will quickly look up the values stored under key  
          410 in the in-core image, without the need to access the     
          file.                                                   '<BR>'                                                   

          IMPORTANT: only a imited number of document files may be 
          accessed concurrently with 'UD IC'.  Once the limit is
          reached one of the current files must be       
          cleared by a 'UD ICE' command.  An attempt
          to apply 'UD IC' to a additional document file before execution
          of a 'UD ICE' command to free the area reserved for data from
          an existing file will result in an error message.]

NOTES: 1. 'UD IC' should always be used when more than    
          one access to a large document file takes place.          

       2. Even though it is not advisable, because of its slow   
          speed, it should be mentioned that a command 'UD' without 
          the in-core option may be applied to a file currently     
          existing as in-core image, without causing interference.     

       3. If the specified key is less than zero and > -1000 then the 
          routine searches the document file for a line preceeded by a 
          semicolon similar to a comment.  This line is treated as
          a regular line containing a special key and list of 
          registers.  This allows the retrieval of a limited set of 
          values such as rotation angles which are somehow associated 
          with the contents of the file.  The normal retrieval process 
          (positive keys) treats these lines like comments.

SUBROUTINES:   RDDOCA2Q, UNSDAL, DOCCOM, OPENDOC
                      
CALLER:        DRIV3                                            

