
UD S      Unsave Document - Sequential search              UD S
                                                          3/25/96

PURPOSE:  Unsaves a sequence of registers from a document file.

SEE ALSO: UD      (Unsave document)
          UD E    (Unsave document - end)
          UD IC   (Unsave document - in core)
          UD ICE  (Unsave document - in core, end)

USAGE:    UD S,X0,X15,X20,X50
      
          .DOCUMENT FILE: DOC001
          [Enter the name of the file where the registers are to be
          found.]

          [The first register or number after 'UD S' is used as a key
          for retrieving the desired register set stored there
          previously.  In the above example, let us assume X0 has the
          value 4.  The system then searches the file for the first
          entry under this key number.  If this entry consisted of the 
          line '<BR>'

                  4  3  -1.5   30.8   0.0 '<BR>'

          then the values -1.5, 30.8, and 0.0 are put into the
          registers X15, X20, and X50, respectively.]

          [If more registers are specified in the 'UD' command than
          were used in the 'SD' command creating the entry, an error
          message is printed out.  In the above example, a command '<BR>'

                  UD S X0,X15,X20,X50,X28'<BR>'

          would produce an error statement because the number of
          registers exceeds the number in the corresponding 'SD'
          operation.]


NOTES: 1. Sequential search is much faster than non-sequential, and
          should be used whenever it is certain that no updates have
          occurred.

       2. If the specified key is -999 < key < 0 then the routine 
          searches the document file for a line preceeded by a 
          semicolon similar to a comment.  This line is treated as
          as a regular line containing a special key and list of 
          registers.  This allows the retrieval of a limited set of 
          values like rotation angles which are somehow associated 
          with the contents of the file.  The normal retrieval 
          process (positive keys) treats these lines like comments.

       3. The document file is left open until closed with 'UD E' or
          until another document file is used with 'UD'.  This saves
          time when there are multiple accesses.

SUBROUTINES:  RDDOCQ, CHKSTRQ, OPENDOC, UNSAV,

CALLER:       DRIV3

