
VM        VMS spawn or Unix system call                          VM      
                                                            7/14/97

PURPOSE:  To access the operating system from SPIDER using a 
          system (Unix) command or spawn (VMS) command.

USAGE:    VM

          .SYSTEM COMMAND:   ls  *.OMM           (e.g.)
          [Enter the command you want executed.  This may also
          be a command file.  '<A HREF="../user_doc.html#file_names">'
          Substitution '</A>' of do-loop indices and register 
          contents for characters within {} is allowed anywhere in
          the command line (not just in filenames).]

NOTE: 1.  Comments are not accepted in the command line as a SPIDER comment
          character (;) is used to string system commands together on the
          same line in Unix.

      2.  You must specify the extension for any filenames within
          the system command as they are '<EM>' NOT '</EM>'appended automatically
          by SPIDER (as there is no way to recognize what is a 
          filename).  However, you can use the string:
          '<I>'$DATEXT '</I>' to substitute the current SPIDER data 
          extension into the corresponding position in your command
          line.  You can use the string:
          '<I>'$PRJEXT '</I>' to substitute the current SPIDER project 
          extension into the corresponding position in your command
          line.

      3.  Samples of usage within SPIDER loops (on Unix only).

      '<PRE>'

      xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
      -- sample loop for converting series of 1024 x 512 raw images 
      -- to SGI rgb format'<P>'
      X11 = 1024     ; nsam
      X12 = 512      ; nrow
      DO LB1 I=1,1   ; loop
      VM             ; use "imgcopy" to convert images
      frombin raw{***i}.$DATEXT   sgi{***i}.rgb {****x11} {***X12} 
      LB1            ; end loop
      '<P>'
      xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx'<P>'
      --sample loop for renaming/renumbering series of SPIDER images '<P>'
      
      X33=33 
      DO LB2 I=1,4     ; loop
      VM               ; system call for renumbering
      cp jnk{***X33}.vms    jnk444{***I}.vms 
      X33=X33+1
      LB2              ; end loop
      '<P>'
      xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx'<P>'
      --sample loop for consecutively renaming/renumbering series of SPIDER 
      -- while skipping any missing image numbers '<P>'
	
      X11=0                ; initialize output file number counter
      DO LB3 I=1,4         ; loop
      FI N                 ; use "FI N" to see if file exists
      jnk{***I}            ; filename
      ;
      IF(X2.LE.0)GOTO LB3  ; skip if file not found
      X11=X11+1            ; increment output file number counter
      VM                   ; system call for renaming/renumbering SPIDER images
      cp jnk{***I}.vms   jnk444{***X11}.vms 
      LB3                  ; end loop

      '</PRE>'

      4.  On VAX/VMS this command only works in interactive mode.

SUBROUTINES: VMS

CALLER:      DRIV1
