                                       
VO EA     Vector Operation - Even Angles doc. file               VO EA   
                                                               09/03/96

PURPOSE:  Create angular document file containing three Eulerian angles
          defining quasi-evenly spaced projection directions. This document 
          file can be used to calculate reference projections (operation 
          'PJ 3Q') for the 'AP MD' operation (3D Projection Alignment).

SEE ALSO: VO       (Vector operation)
          VO CEUL  (Vector operation - combine Euler rotations)
          VO MD    (Vector operation - angular doc. file from 'AP MD' output)
          VO RA    (Vector operation - rotate angular doc.  file)
   
USAGE:    VO EA,X21

          .DELTA THETA: 2.0
          [The angular step for the theta angles.  The angular step for the phi
          angle is adjusted according to the equation '<BR>'
          d(phi)=d(theta)/sin(theta)'<BR>'
          to create quasi-evenly spaced directions. X21 is an optional register
          which will contain the number of angular directions for the angular 
          step specified (see note 3).]
 
          .RANGE OF THETA (0,90): 0.0,90.0
          [Range of theta angle. Default is 0,90, as required by the 'AP MD' 
          command.]

          .RANGE OF PHI (0,359.9): 0.0,359.9
          [Range of phi angle. Default is 0,359.9, as required by the 'AP MD '
          command.]

          .ANGULAR DOCUMENT FILE NAME: ANGFULL
          [Enter the name of the output angular docfile. The file will 
          contain the Eulerian angles psi, theta, phi as required by 
          the 'AP MD' command.]

NOTES: 1. The default range of angles covers only half of the full
          angular range of directions.  The full range would require
          0<theta<180, but the projections with theta>90 are mirrored
          versions of projections with theta<90; this is implicitly
          taken into account in the 'AP MD' operation.

       2. For symmetric structures the ranges of angles must be adjusted
          properly (depending on the symmetry).

       3. Numbers of directions for default angular range:
          '<PRE>'
            Delta theta               number of directions
               15.0                            84
               10.0                           195
                5.0                           799
                2.5                          3248
                2.0                          5088
                1.5                          9076
                1.0                         20489
          '</PRE>'
 
       4. Implemented by P. Penczek

SUBROUTINE: VOEA

CALLER:     DRIV1
