
VO MD     Vector Operation - angular doc. file from 'AP MD' output  VO MD
                                                                 09/03/96

PURPOSE:  Convert output document file from the 'AP MD' operation
          to an angular document file containing three Eulerian angles.

SEE ALSO: VO       (Vector operation)
          VO CEUL  (Vector operation - combine Euler rotations)
          VO EA    (Vector operation - even angles doc. file)
          VO RA    (Vector operation - rotate angular doc. file)
   
USAGE:    VO MD

          .ANGULAR DOCUMENT FILE NAME: ANGFULL
          [Enter the name of the angular document file name (created 
          by 'VO EA') used to calculate reference projections required 
          for 'AP MD'.]

          .OUTPUT FROM AP MD DOCUMENT: APMD101
          [Enter the name of the document file produced by the 'AP MD' 
          command.   This document file should contain 3 columns:
          '<PRE>'
          1.Number of the most      2.Distance.             3. psi angle
          similar reference         Can be used as          In-plane rotation
          projection.  When         a similarity measure.   angle determined.  
          this number is larger     Output from 
          than number of            AP MD document.
          reference projections
          the most similar is
          a mirrored projection
          (see appended batch program).
          '</PRE>'

          .DOCUMENT: ANGLES101
          [Enter the name for the angular document file that will 
          be produced. This document file will contain three 
          columns with the three Eulerian angles psi, theta, and phi.  
          It can be subsequently used in the 'BP RP' operation to 
          calculate a refined 3D reconstruction.]


NOTES: 1. In 3D space the projection with the direction (psi, theta, phi)
          has its mirrored [around X-axis] counterpart in the direction:'<BR>'
             (-psi, 180-theta, phi+180).'<BR>'
          To save time, the operation AP MD takes this into account, and 
          each data projection is compared with the reference projection and 
          its mirrored version at the same time.  Thus, only half of the total 
          number of reference projections are required, namely, only those
          with 0<theta<90.
          If the best match was with the mirrored reference projection,
          then the number stored in the first column of the document file
          is equal to the number of the corresponding mirrored reference
          projection plus an offset equal to the total number of reference 
          projections (see appended batch program).
  
        2.  Implemented by P. Penczek

SUBROUTINE: VOMD

CALLER:     DRIV1

The command 'VO MD' is equivalent to the following SPIDER batch program:
'<PRE>'
;  Prepare ang doc file after the alignment of projections
;
;  ANGLES101 - document file produced by AP MD command
;  ang288    - output ang document file to be used for 3D reconstruction
; x77 - number of 2D reference projections whose angles are stored
;       in the ang document file 'angsss' in the order (psi, theta, phi)
x77=5266
do lb1 i=1,129
ud ic,x0,x51,x52,x41
ANGLES101
x61=x51
if(x51.le.x77) goto lb3
x61=x51-x77
lb3
ud ic,x61,x22,x42,x43
angsss
if(x51.le.x77) goto lb4
x41=x41+180.0
x42=180.0-x42
x43=x43+180.0
lb4
sd x0,x41,x42,x43
ang288
lb1
en
'</PRE>'
