
WT        Lattice indexing                                  WT      
                                                            3/1/96

PURPOSE:  Automatically indexes a reciprocal lattice from 2 or
          more reflections entered.  Creates a filter file for 
          quasi-optical crystal-line Fourier filtration.

SEE ALSO: WT TV  (Lattice Indexing)
          GF     (General Filter for quasi-optical Fourier Filtration)
          GF C   (General Filter- Condesnsed Fourier)
          RD     (ReDuce transform)

USAGE:    WT

          .POWER SPECTRUM FILE: POW001
          [Enter the name of the power spectrum file.]
        
          .FOURIER FILE: FOU001
          [Enter the name of the Fourier file.]

          .WINDOW SIZES (SEARCH,FILT): 7,5
          [Enter the dimensions of square windows to be used in the
          search for maxima and filtration (2nd not presently
          used).]

          .LATTICE INDICES (H,K): 1,0
          [Enter the lattices indices of first reflection.]

          .FOURIER POSITIONS (KX,KY): 42,27
          [Enter the approximate kx and ky positions (relative to
          0.0 at center of Fourier transform and associated power
          spectrum) of the reflection associated with the above
          indices.  The exact position of the maximum within the
          search window is determined and returned.  Note: axes are
          transposed going from real to Fourier space.  Real space:
          +x is to the right, +y is down.  Fourier space: +kx is
          down, +ky is to the right.]

          .LATTICE INDICES (H,K): 2,1
          [Enter the lattice indices of the second reflection.]

          .FOURIER POSITION (KX,KY): 57,30
          [Enter the approximate kx,ky position of the second
          reflection.]      '<BR>'
            .               '<BR>'
            .               '<BR>'
            .               '<BR>'
          [...continues until (0,0) is entered for Lattice Indices.
          A minimum of 2 reflections in linearly independent  
          positions are required.  All reflections entered will be used
          in a least square fit to extrapolate the reciprocal
          lattice.]

          .MAXIMUM RESOLUTION DISTANCE: 120
          [Enter the radius of a circle in Fourier space within
          which reflections on the indexed lattice are being
          deterdetermined.]

          [The initial and the refined lattice parameters will be
          listed along with x and y components of each.  A list of
          the reflections found, and their energies, is recorded in
          the RESULTS file.]

          .FILTER FILE: FIL001
          [Enter the name of the file that will contain the
          coordinates of the refined lattice for use in filtration.  
          See 'GF' and 'RD' for details.]

NOTES:    A detailed description of quasi-optical filtration using
          SPIDER is found in the document FILTER.DOC.

SUBROUTINES: LATCEN, SOLV2D

CALLER:      TVWN1

