
WV        Window aVeraging                                WV
                                                          2/21/96

PURPOSE:  Part of correlation averaging of crystalline lattices:
          Window out areas from a large image and sum these to
          create the output file.  Windowing coordinates are taken
          from a document file. Sequential search of document file
          should be used if no multiple entries exist.

SEE ALSO:  WV P  (Window averaging - over Patches)
           WV S  (Window averaging - sequential document search)
 
USAGE:    WV

          .INPUT FILE: PIC001
          [Enter the name of the large data file to be windowed.]

          .OUTPUT FILE: AVE001
          [Enter the name of the file where the average is to be
          kept.]

       If the input file is a volume, the system will ask:
          .ENTER NSLICE: 22
          [Enter the slice to be processed.]

          .DIMENSIONS OF CCF WINDOW: 480,480
          [Enter the dimensions of a centered window.  Only peak 
          coordinates lying inside this window will be used.  Others
          will be skipped.]

          .DOCUMENT FILE: DOC001
          [Enter the name of the document file containing the 
          coordinates for the windowing of the large data file previously
          created by using 'PK' on a cross-correlation map. If the
          keys in the document file (i.e. the peak numbers) are strictly
          sequential, with no multiple entries, then the computation
          can be speeded up by using the 'WV S' (sequential search)
          option]

          .ENTER PEAK NUMBERS: 12-54
          [Enter the key numbers of the document file to be used.
          Current limitation is 4000 peaks.]

          .NUMBER OF PEAKS FIXED? (Y/N): Y
          [If the answer is 'Y', for each peak that is skipped on
          account of its position outside of the window, an
          additional peak with a higher number than specified in the
          previous line is used.  This way the number of peaks used
          for the average is fixed.  With answer 'N', no additional
          peaks will be used to make up for the skipped ones.]

          .PEAK NUMBER INCREMENT: 2
          [Enter the increment of the peak numbers to be used.  In
          the case shown, peaks #12,14,16,18,... will be used.]

          .CONTROL WINDOWS? (Y/N): Y
          [Enter 'Y' if you want to create files containing the
          windows used for window averaging.  These are mainly used for
          checking resolution, Q-factor analysis, and other 
          statistical checks (see Kessel,Radermacher,Frank, 
          J.Microscopy 1985.]

       If 'Y' was answered, the system will ask:

          .CONTROL INTERVAL: 10
          [A pair of windows belonging to each 10th(+9th) peak
          in the document file will be created.]

          .PREFIX OF CONTROL WINDOWS: CON***
          [Enter the prefix of the files containing the control
          windows.  The file number will correspond to the peak
          number used.]

SUBROUTINES: WINAVE

CALLER:      UTIL2
