
C...  COMMONS TO BE INCLUDED IN MAIN PROGRAMS

C  CMBLOCK.INC  CHANGED 9/21/79,  1/1/81, 9/27/82, 11/16/87,  4/9/91,
C                       10/2/91, 2/23/92, 3/10/92, 12/28/93, 12/30/93
C                       17/4/95

C...    BATCH    COMMON BLOCK FOR BATCH MODE OPERATIONS ---------------

	COMMON    /BATCH/IBCNT,NLOOP,IABSLP,ILOOP
	INTEGER          IBCNT,NLOOP,IABSLP,ILOOP

C...    IBCNT    LINE COUNTER IN BATCH MODE
C...    NLOOP    TOTAL NO. OF LOOPS TO BE EXECUTED IN CURRENT DO LOOP
C...    IABSLP   EXACT CURRENT DO LOOP COUNTER
C...    ILOOP    OFFSET OF CURRENT DO LOOP COUNTER FROM STARTING 
C...             LOOP COUNT + 1

        COMMON    /BATCH2/COPT
        CHARACTER         COPT

C...    COPT     = 'I' FOR INTERACTIVE MODE, = 'B' FOR BATCH MODE

C...    UNITS    COMMON BLOCK FOR UNIT NOS. ---------------------------

	COMMON /UNITS/LUNC,NIN,NOUT,NECHO,IFOUND,NPROC,NDAT
	INTEGER       LUNC,NIN,NOUT,NECHO,IFOUND,NPROC,NDAT

C...    LUNC     UNIT NO. FOR FRAZER'S DISK FFT (CORR1 AND FOUR1)
C...    NIN      UNIT NO. FOR A COMMAND INPUT STREAM
C...    NOUT     UNIT NO. FOR TERMINAL OUTPUT EXCEPT IN BATCH OPERATION
C...             (IN BATCH MODE IT IS ATTACHED TO RESULTS FILE)
C...    NECHO    UNIT NO. FOR ECHO OF COMMANDS TO TERMINAL/RESULT
C...             FILE 
C...    IFOUND   CONTROL VARIABLE FOR PRINTING OF MESSAGES BY OPEN
C...    NPROC    UNIT NO. FOR BATCH INPUT FILE
C...    NDAT     UNIT NO. FOR RESULTS FILE

C...    IPRTT    COMMON BLOCK FOR INPUT/OUTPUT CONTROL ----------------
        LOGICAL  SILENT
        INTEGER  IPRTT,NTRACE,NALPH,N_VERBOSE,N_MOSAIC
        COMMON   /IPRTT/ IPRTT,NTRACE,NALPH,N_VERBOSE,N_MOSAIC,SILENT

C...    IPRTT      LOCAL(DURING SESSION)/GLOBAL(AFTER SESSION) 
C...               RESULTS PRINTOUT
C...    NTRACE     ENABLE/DISABLE TRACING ON TERMINAL DURING BATCH MODE
C...    NALPH      NO. OF CHARACTERS IN THE MOST RECENT OPERATION 
C...    N_VERBOSE  USER SET CONTROL VARIABLE FOR PRINTING OF INFO
C...    SILENT     OPERATION SET CONTROL VARIABLE FOR PRINTING OF INFO


C...    MASTER   COMMON BLOCK FOR LABEL OF MOST RECENT FILE OPENED ----

	COMMON /MASTER/ NSAMC,NROWC,IREC,NHISTREC,IFORM,IMAMI,
     &                  FMAX,FMIN,AV,SIG,IHIST,IPROT

	INTEGER         NSAMC,NROWC,IREC,NHISTREC,IFORM,IMAMI,IHIST
        INTEGER         IPROT
        REAL            FMAX,FMIN,AV,SIG

C...    NSAMC    NO. OF SAMPLES (COLUMNS) PER ROW
C...    NROWC    NO. OF ROWS PER SLICE
C...    IREC     TOTAL NO. OF RECORDS IN THE FILE
C...    NHISTREC AUXILIARY NUMBER TO COMPUTE TOTAL NO. OF RECORDS
C...    IFORM    FILE TYPE SPECIFIER
C...    IMAMI    MAXIMUM/MINIMUM FLAG. IS SET AT 0 WHEN FILE IS CREATED,
C...             AND AT 1 WHEN THE MAXIMUM AND MINIMUM HAVE BEEN 
C...             COMPUTED AND STORED INTO THIS LABEL RECORD.
C...    FMAX     MAXIMUM VALUE
C...    FMIN     MINIMUM VALUE
C...    AV       AVERAGE VALUE
C...    SIG      STANDARD DEVIATION, A VALUE OF -1 INDICATES SIG HAS 
C...             NOT BEEN COMPUTED PREVIOUSLY
C...    IHIST    INTEGER FLAG INDICATING THAT HISTOGRAM HAS BEEN 
C...             COMPUTED AND STORED IN FILE


C...    MASTER1  COMMON BLOCK FOR LABEL INFORMATION OF MOST RECENT FILE

        COMMON /MASTER1/ DATEXC,PRJEXC,CDAT,CTIM,CTIT
        CHARACTER *4     DATEXC,PRJEXC
        CHARACTER *10    CDAT
        CHARACTER *8     CTIM
        CHARACTER *160   CTIT

C...    DATEXC   CHARACTER VARIABLE CONTAINING DATA EXTENSION CODE
C...    PRJEXC   CHARACTER VARIABLE CONTAINING PROJECT EXTENSION CODE
C...    CDAT     CHARACTER VARIABLE CONTAINING DATE OF FILE
C...    CTIM     CHARACTER VARIABLE CONTAINING TIME OF FILE
C...    CTIT     CHARACTER VARIABLE CONTAINING TITLE OF FILE


C...    PARAM    COMMON BLOCK FOR REGISTER SELECTION AND CONTENTS -----
 
	COMMON /PARAM/ PARAM(103),NSEL(20)
	INTEGER        NSEL
        REAL           PARAM

C...    PARAM    CONTAINS CONTENTS OF REGISTERS X0 THROUGH X102
C...    NSEL     CONTAINS THE NUMBERS OF REGISTERS SELECTED IN THE 
C...             OPERATION LINE. PK X12,X20 WOULD RETURN 13,21 IN 
C...             NSEL(1) AND NSEL(2)
    
C...    PROC     COMMON BLOCK FOR PROCEDURE OPERATION -----------------

	COMMON   /PROC/ IPROC,ITI,IWHERE,INFLUN,PNAME
	INTEGER         IPROC,ITI,IWHERE,INFLUN
        REAL            PNAME

C...    IPROC    =0 FOR INTERACTIVE MODE, OPT = 'I' ALSO
C..              =1 FOR BATCH MODE, OPT = 'B' ALSO 
C...    ITI      LOGICAL UNIT NO. ASSOCIATED WITH TERMINAL (USED ONLY 
C...             IN CASE OF TRACING AND ERROR REPORTING)
C...    IWHERE   POINTER IN NEXT HIGHER LEVEL COMMAND FILE
C...    INFLUN   LOGICAL UNIT NO. ASSOCIATED WITH PARAMETER FILE 
C...    PNAME    PROCEDURE FILE NAME (UNUSED?)

C...    DOLOOP   COMMON BLOCK FOR DOLOOP VARIABLES --------------------

	COMMON /DOLOOP/ IALPHA(26)
	INTEGER         IALPHA

C...    IALPHA   LOOK UP TABLE FOR CURRENT VALUE OF ALPHA CHARACTERS


C...    FUNCTION   COMMON BLOCK FOR CURRENT OPERATION -----------------

	COMMON /FUNCTION/FCHAR,NSTART
        CHARACTER *80    FCHAR
        INTEGER          NSTART

C...    FCHAR     USED TO READ OPERATION CODES ETC. FROM INPUT STREAM.
C...    NSTART    COUNTER


C...    CMAX      COMMON BLOCK FOR LINE PRINTER USE -------------------

	COMMON/CMAX/CRVMAX,CRVMIN
        REAL        CRVMAX,CRVMIN

C...    CRVMAX     USED ONLY IN PRINTER LINE PLOT MODULES
C...    CRVMIN     USED ONLY IN PRINTER LINE PLOT MODULES


