C************************************************************************
C
C ADDS.FOR
C
C **************************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK            *
C *  COPYRIGHT (C)1981,1987, WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *  THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR       *
C *  LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR    *
C *  USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF     *
C *  THE CENTER FOR LABORATORIES AND RESEARCH   			   *
C **************************************************************************
C
C--************************************************************************

         SUBROUTINE ADDS(LUN1,LUN2,LUNS,MAXMEM)

         PARAMETER  (NUMTOT=20000)
         COMMON DUMMY(80),BUF(1024),NUMB(NUMTOT),Q(1)

         INCLUDE 'CMBLOCK.INC'

         COMMON /COMMUN/ FILNAM,FILA,FILN,FILV,FILPAT

         DOUBLE PRECISION VARAV,AV2,VV
         CHARACTER *81    FILNAM,FILA,FILN,FILV,FILPAT
         CHARACTER *1     NULL,MODE,SER
         CHARACTER*81     DOCFIL
CNO_SAVE

         DATA  NDOC/55/
         NULL=CHAR(0)

         IF (FCHAR(4:5) .EQ. 'DC')  THEN

C           ASK FOR DATA FILE

            CALL  FILERD(FILPAT,NLETP,NULL,'INPUT',INTFLG)

            CALL  FILERD(DOCFIL,NLETI,NULL,
     &              'DOCUMENT WITH FILE NUMBERS',IRTFLG)
            IF (IRTFLG.EQ.-1)  RETURN
            K=0
            K2=1
            NUMT=0
778         LERR=-1
            KP1=K+1
            CALL  UNSAV(DOCFIL,K,NDOC ,KP1,Q,1,LERR,K2)
            IF (LERR.EQ.0)  THEN
               NUMT=NUMT+1
		IF(NUMT.GT.NUMTOT)  THEN
	WRITE(NOUT,*) ' LIST TRUNCATED, ONLY HOLDS',NUMTOT,' VALUES'
		GOTO  7780
		ENDIF
               NUMB(NUMT)=Q(1)
               K=K+1
               GOTO  778
            ENDIF
7780	    CLOSE(NDOC)
            FCHAR(4:4)='R'
         ELSE
            WRITE(NOUT,*) ' FOR IMAGES TO BE AVERAGED:'
            CALL FILSEQP(FILPAT,NLETP,NUMB,NUMTOT,NUMT,
     $        'FILE PREFIX OR TEMPLATE (EG. PIC****)',IRTFLG)
     
	    
            IF (IRTFLG .NE. 0) RETURN
         ENDIF

C        GET FIRST PICTURE TO DETERMINE DIMS
         CALL FILGET(FILPAT,FILNAM,NLETP,NUMB(1),IRTFLG)
         IF (IRTFLG .NE. 0) RETURN

         CALL OPENFB(BUF,FILNAM,LUN2,NSAM,NROW,'O',NF,NSLICE)
         IF (NF.NE.2) RETURN

         CLOSE(LUN2)
	 NSLICE=MAX0(1,NSLICE)
         NSR=NSAM*NROW*NSLICE
         IF(3*NSR+1104+NUMTOT.LE.MAXMEM)  THEN
            MODE='C'
         ELSEIF(2*NSR+NSAM+1104+NUMTOT.LE.MAXMEM)  THEN
            MODE='D'
         ELSE
            CALL  ERRT(6,'ADDS  ',NE)
         RETURN
      ENDIF

C     AVERAGE
      N1=1

C     VARIANCE
      N2=N1+NSR

C     BUFFER OR IMAGE
      N3=N2+NSR

      CALL  RDPRMC(SER,NUMC,.TRUE., 'ALL, ODD-EVEN (A/O)',NULL,IRT)

      IF (SER.NE.'O' .AND. SER.NE.'E') THEN
         SER='A'
         LUP=1
      ELSE
         LUP=2
       ENDIF
      DO    ILUP=1,LUP
         IF(LUP.EQ.2)  THEN
            IF (ILUP.EQ.1)  THEN
               WRITE(NOUT,*) 'FOR ODD-NUMBERED IMAGES'
               SER='O'
            ELSE
               WRITE(NOUT,*) 'FOR EVEN-NUMBERED IMAGES'
               SER='E'
            ENDIF
         ENDIF
         CALL FILERD(FILA,NLETA,NULL,'AVERAGE',IRTFLG)
         IF (IRTFLG .NE. 0) RETURN

C        COMMAND  AS AD  MEANS THAT AVERAGE FILE ALREADY EXISTS
         IF (FCHAR(4:5) .EQ. 'AD')  GOTO 5

C        FILE DOES NOT EXIST - OPEN WITH DIMS OF FIRST FILE & INITIALIZE
	 IF (NSLICE.GT.1)  THEN
	    IFORM=3
	 ELSE
            IFORM = 1
	 ENDIF
         CALL OPENFB(BUF,FILA,LUN1,NSAM,NROW,'UNKNOWN',NF,NSLICE)

         CALL FILERD(FILV,NLETV,NULL,'VARIANCE',IRTFLG)
         CALL OPENFB(BUF,FILV,LUNS,NSAM,NROW,'UNKNOWN',NF,NSLICE)

C        CLEAR BOTH AVERAGE AND VARIANCE ARRAYS
         DO   K=1,NSR
            Q(N1+K-1)=0.0
            Q(N2+K-1)=0.0
         ENDDO

         NUMPR=0
C        NUMBER OF PREVIOUS PICTURES IS 0

         GOTO 8



C        FILES ALREADY EXIST - FIND OUT HOW MANY PICTURES ALREADY AVERAGED

5        IF (NSEL(1) .EQ. 0)  THEN
            WRITE(NOUT,*)  '*** MISSING OFFSET VALUE'
            CALL ERRT(100,'ADDS',NE)
            RETURN
         ENDIF

         CALL  RDPRMI(NUMPR,NDUM,NLOOP,ILOOP,
     &      'ENTER NO. OF IMAGES ALREADY AVERAGED')

         CALL OPENFB(BUF,FILA,LUN1,NSAM,NROW,'Z',NF,NSLICE)

         CALL FILERD(FILV,NLETV,NULL,'VARIANCE',IRTFLG)
         CALL OPENFB(BUF,FILV,LUNS,NSAM,NROW,'UNKNOWN',NF,NSLICE)
         IF (NF .NE. 2) RETURN

C        GET OLD OFFSET
         OFFOLD = PARAM(NSEL(1))
         DO  I=1,NROW*NSLICE
            CALL REDLIN(LUN1,Q(N1+(I-1)*NSAM),NSAM,I)
         ENDDO

         DO  I=1,NROW*NSLICE
            CALL REDLIN(LUNS,Q(N2+(I-1)*NSAM),NSAM,I)
         ENDDO

         DO K=1,NSR
            Q(N2-1+K)=Q(N2-1+K)*(NUMPR-1)+Q(N1-1+K)*Q(N1-1+K)*NUMPR
            Q(N1-1+K)=Q(N1-1+K)*NUMPR
         ENDDO

8        NUMC=1
         AV1=0.0
C        TO ALLOW GAPS IN FILE SERIES 7/21/89 MR.:
         NUMA=0
         NMT=0
         DO 550 IFIL=1,NUMT

            CALL FILGET(FILPAT,FILNAM,NLETP,NUMB(IFIL),IRTFLG)
            IF (IRTFLG .NE. 0) THEN
               CALL ERRT(3,'ADDS  ',NE)
C              TAKEN OUT, MR
               RETURN
            ENDIF
            CALL OPENFB(BUF,FILNAM,LUN2,NSAM,NROW,'Z',NF,NSLICE)
            IF (NF .NE. 2) THEN
C              TO ALLOW GAPS IN FILE SERIES 7/21/89 MR.:
               WRITE(NOUT,100) FILNAM
100            FORMAT(' FILE: ',A,' NOT FOUND, FILE SKIPPED')
               GOTO 550
            ENDIF
            NMT=NMT+1
            IF (SER.EQ.'O' .AND. MOD(NMT,2).EQ.0)  GOTO  707
            IF (SER.EQ.'E' .AND. MOD(NMT,2).EQ.1)  GOTO  707
            NUMA=NUMA+1
            AV2=0
            IF (MODE.EQ.'D')  THEN
               DO    I=1,NROW*NSLICE
                  CALL  REDLIN(LUN2,Q(N3),NSAM,I)
                  IF (FCHAR(4:4) .NE. 'R') THEN
                     DO     J=1,NSAM
                        AV2=AV2+Q(N3-1+J)
                     ENDDO
                  ENDIF
               ENDDO
            ELSE
               DO    I=1,NROW*NSLICE
                  CALL  REDLIN(LUN2,Q(N3+(I-1)*NSAM),NSAM,I)
                  IF (FCHAR(4:4) .NE. 'R')  THEN
                     DO    J=1,NSAM
                        AV2=AV2+Q(J+(I-1)*NSAM+N3-1)
                     ENDDO
                  ENDIF
                  CONTINUE
               ENDDO
            ENDIF

            AV2=AV2/NSAM/NROW/NSLICE

            IF (MODE .EQ. 'D')  THEN
               DO     I=1,NROW*NSLICE
                  CALL  REDLIN(LUN2,Q(N3),NSAM,I)
                  DO    K=1,NSAM
                     LK=K+(I-1)*NSAM
                     IF (FCHAR(4:4).NE.'R')  THEN
                        T=Q(N3+K-1)-AV2
                     ELSE
                        T=Q(N3+K-1)
                     ENDIF
                     Q(LK+N1-1)=Q(LK+N1-1)+T
               	  Q(LK+N2-1)=Q(LK+N2-1)+T*T
	          ENDDO
	       ENDDO
            ELSE
               DO     K=1,NSR
                  IF (FCHAR(4:4) .NE. 'R')  THEN
                     T=Q(N3+K-1)-AV2
                  ELSE
                     T=Q(N3+K-1)
                  ENDIF
                 Q(K+N1-1)=Q(K+N1-1)+T
                 Q(K+N2-1)=Q(K+N2-1)+T*T
              ENDDO
           ENDIF

           AV1=AV1+AV2
707        CLOSE(LUN2)
550      CONTINUE
C
         FNUMT = NUMA+NUMPR
C        NOW COMPUTE NORMALIZED AVERAGE AND VARIANCE IMAGE
         VARAV = 0
         VV    = 0

         DO  K=1,NSR
            L     = N1+K-1
            Q(L)  = Q(L)/FNUMT
            VV    = VV+Q(L)*Q(L)
            M     = N2+K-1
            Q(M)  = (Q(M)-Q(L)*Q(L)*FNUMT)/(FNUMT-1.0)
            VARAV = VARAV+Q(M)
         ENDDO

         DO I=1,NROW*NSLICE
            CALL WRTLIN(LUN1,Q(N1+(I-1)*NSAM),NSAM,I)
         ENDDO

         DO I=1,NROW*NSLICE
            CALL WRTLIN(LUNS,Q(N2+(I-1)*NSAM),NSAM,I)
         ENDDO

         CLOSE(LUNS)
         CLOSE(LUN1)

         VV   = VV/FLOAT(NSAM*NROW*NSLICE)
         SAVT = SQRT(VARAV)
         VAV  = VARAV/(FLOAT(NSAM)*FLOAT(NROW)*FLOAT(NSLICE))
         SAV  = SQRT(VAV)
C        IF (NSEL(1) .NE. 0) PARAM(NSEL(1))=AV1/FLOAT(NUMA)
         OFF  = AV1/FLOAT(NUMA)
         IF (NUMPR.NE.0.AND.NSEL(1).NE.0.AND.PARAM(NSEL(1)).NE.0.0)
     1   OFF = (OFFOLD*FLOAT(NUMPR)+AV1)/FLOAT(NUMA+NUMPR)
         IF (NSEL(1).NE.0) PARAM(NSEL(1))=OFF
         IF (NOUT.NE.NDAT)
     1   WRITE(NDAT,7001) NUMA+NUMPR,NSAM*NROW*NSLICE,VARAV,SAVT,
     1                    VAV,SAV,OFF,VV
         WRITE(NOUT,7001) NUMA+NUMPR,NSAM*NROW*NSLICE,VARAV,SAVT,
     1                    VAV,SAV,OFF,VV
7001     FORMAT(' ** VARIANCE COMPUTATION BASED ON ',I4,' IMAGES ',
     1   /'    CONTAINING ',I6,' ELEMENTS',
     2   /'      TOTAL VARIANCE = ',G12.5,' TOTAL S.D. = ',G12.5,
     3   /'      VARIANCE P.P.  = ',G12.5,' S.D. P.P.  = ',G12.5,
     4   /'      AVERAGE OFFSET = ',G12.5,
     5   /'      VARIANCE OF AVERAGE IMAGE = ',G12.5)
	ENDDO
c 829      CONTINUE

         END
