
C++*************************************************************************
C
C $$ ADJUST.FOR                         
C
C **************************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK            *
C *  COPYRIGHT (C)1981,1987, WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH 			   *
C **************************************************************************
C
C  $$ ADJUST(LUNLOW,LUNHI,LUNOUT,NSAM,NROW,NSLICE)
C
C  PURPOSE:   MERGES TWO SIMILAR EIKONIX IMAGES OF DIFFERENT DENSITIES
C
C  PARAMETERS
C        LUNLOW        LOGICAL UNIT NUMBER OF FILE 1
C        LUNHI         LOGICAL UNIT NUMBER OF FILE 2
C        LUNOUT        LOGICAL UNIT FOR OUTPUT FILE
C
C  CALLS:
C
C  CALLED BY:          UTIL2
C
C        0         2         3         4         5         6         7     
C23456789 123456789 123456789 123456789 123456789 123456789 123456789 12
C--*******************************************************************

      SUBROUTINE ADJUST(LUNLOW,LUNHI,LUNOUT,IRTFLG)

      INCLUDE 'CMBLOCK.INC'
      COMMON  BUF(1)
      COMMON /COMMUN/ FILNAM

      CHARACTER * 81 FILNAM
      CHARACTER      NULL

      NULL = CHAR(0)

C     OPEN LOW ILLUMINATION INPUT FILE
10    CALL FILERD(FILNAM,NLETL,NULL,'LOW ILLUMINATION',IRTFLG)
      IF (IRTFLG .EQ. -1) RETURN
      CALL OPENF(FILNAM,LUNLOW,NSAM,NROW,'OLD',NF,NSLICE) 
      IF (NF .EQ. 1) GOTO 10

C     OPEN HIGH ILLUMINATION INPUT FILE
20    CALL FILERD(FILNAM,NLETI2,NULL,'HIGH ILLUMINATION',IRTFLG)
      IF (IRTFLG .EQ. -1) GOTO 10
      CALL OPENF(FILNAM,LUNHI,NSAMHI,NROWHI,'OLD',NF,NSLICEHI) 
      IF (NF .EQ .1) GOTO 20

      IF (NSAM .NE. NSAMHI .OR. NROW .NE. NROWHI .OR.
     &      NSLICE .NE. NSLICEHI) THEN
            WRITE(NOUT,*) ' *** ERROR, IMAGES MUST BE SAME SIZE'
            GOTO 999
      ENDIF

C     OPEN OUTPUT FILE
30    CALL FILERD(FILNAM,NLETI2,NULL,'INPUT2',IRTFLG)
      IF (IRTFLG .EQ. -1) GOTO 20
      CALL OPENF(FILNAM,LUNOUT,NSAM,NROW,'UNK',NF,NSLICE) 
      IF (NF .EQ .1) GOTO 30


      FACTOR = 1.0
      CUTOFF = 0.0
      CALL RDPRIS(CUTOFF,FACTOR,NLOOP,ILOOP,
     &            'ENTER CUTOFF AND ADJUSTMENT FACTOR$',IRTFLG)
      IF (IRTFLG .EQ. -1) GOTO 30

      NSAMP1 = NSAM + 1

      DO I = 1, NROW * NSLICE
        CALL REDLIN(LUNH,BUF,NSAM,I)
        CALL REDLIN(LUNLOW,BUF(NSAMP1),NSAM,I)

        DO  K = 1, NSAM
          IF (BUF(K) .GT. CUTOFF) BUF(K) = BUF(NSAM+K) * FACTOR
        ENDDO

        CALL WRTLIN(LUNHI,BUF,NSAM,I)
      ENDDO

999   CLOSE(LUNLOW)
      CLOSE(LUNHI)
      CLOSE(LUNOUT)

      RETURN
      END





