C++************************************************************************
C
C $$ ALRQ_Q.FOR
C
C **************************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK            *
C *  COPYRIGHT (C)1981,1987, WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *  THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR       *
C *  LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR    *
C *  USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF     *
C *  THE CENTER FOR LABORATORIES AND RESEARCH                              *
C **************************************************************************
C
C
C
C23456789012345678901234567890123456789012345678901234567890123456789012
C--************************************************************************
C
C $$ ALRQ_Q.FOR
C
        SUBROUTINE  ALRQ_Q
     &  (XIM,LSD,NSAM,NROW,NUMR,CIRC,LCIRC,NRING,MODE,IPIC)
        DIMENSION  XIM(LSD,NROW),CIRC(LCIRC)
        INTEGER*2  NUMR(3,NRING)
        CHARACTER*1  MODE
        DOUBLE PRECISION  PI,DFI
CNO_SAVE
C
C  INTERPOLATION INTO POLAR COORDINATES
C
c$doacross local(i)
        DO    I=1,LCIRC
        CIRC(I)=0.0
	ENDDO
C
        NS2=NSAM/2+1
        NR2=NROW/2+1
        PI=2*DATAN(1.0D0)
c$doacross local(i,j,inr,yq,l,lt,nsim,dfi,kcirc,xold,yold,fi,x,y)
        DO  I=1,NRING
C
C  RADIUS OF THE RING
        INR=NUMR(1,I)
        YQ=INR
C The actual, power-of-two length is NUMR(3,I)-2, additional
C two locations are only for the new FFT.
        L=NUMR(3,I)-2
        IF(MODE.EQ.'H')  THEN
        LT=L/2
        ENDIF
        IF(MODE.EQ.'F')  THEN
        LT=L/4
        ENDIF
        NSIM=LT-1
        DFI=PI/(NSIM+1)
        KCIRC=NUMR(2,I)
        XOLD=0.0
        YOLD=INR
        CIRC(KCIRC)=QUADRI_Q(XOLD+NS2,YOLD+NR2,LSD,NSAM,NROW,XIM)
        XOLD=INR
        YOLD=0.0
        CIRC(LT+KCIRC)=QUADRI_Q(XOLD+NS2,YOLD+NR2,LSD,NSAM,NROW,XIM)
        IF(MODE.EQ.'F')  THEN
        XOLD=0.0
        YOLD=-INR
        CIRC(LT+LT+KCIRC)=QUADRI_Q(XOLD+NS2,YOLD+NR2,LSD,NSAM,NROW,XIM)
        XOLD=-INR
        YOLD=0.0
        CIRC(LT+LT+LT+KCIRC)=
     &		QUADRI_Q(XOLD+NS2,YOLD+NR2,LSD,NSAM,NROW,XIM)
        ENDIF
        DO  J=1,NSIM
        FI=DFI*J
        X=SIN(FI)*YQ
        Y=COS(FI)*YQ
C
        XOLD=X
        YOLD=Y
        CIRC(J+KCIRC)=QUADRI_Q(XOLD+NS2,YOLD+NR2,LSD,NSAM,NROW,XIM)
        XOLD=Y
        YOLD=-X
        CIRC(J+LT+KCIRC)=QUADRI_Q(XOLD+NS2,YOLD+NR2,LSD,NSAM,NROW,XIM)
        IF(MODE.EQ.'F')  THEN
        XOLD=-X
        YOLD=-Y
        CIRC(J+LT+LT+KCIRC)=
     &		QUADRI_Q(XOLD+NS2,YOLD+NR2,LSD,NSAM,NROW,XIM)
        XOLD=-Y
        YOLD=X
        CIRC(J+LT+LT+LT+KCIRC)=
     &		QUADRI_Q(XOLD+NS2,YOLD+NR2,LSD,NSAM,NROW,XIM)
        ENDIF
	ENDDO
	ENDDO
c 20     CONTINUE
C
        END
