C++************************************************************************
C
C $$ AMOEBA.FOR
C
C **************************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK            *
C *  COPYRIGHT (C)1981,1987, WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *  THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR       *
C *  LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR    *
C *  USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF     *
C *  THE CENTER FOR LABORATORIES AND RESEARCH   			   *
C **************************************************************************
C
C
C
C--************************************************************************
C
C $$ AMOEBA.FOR
C
         SUBROUTINE AMOEBA(P,Y,NDIM,FTOL,FUNK,ITER,ITMAX,PR,PRR,PBAR)
        INCLUDE 'CMBLOCK.INC'
         PARAMETER (ALPHA=1.0,BETA=0.5,GAMMA=2.0)
      DIMENSION P(NDIM+1,NDIM),Y(NDIM+1),PR(NDIM),PRR(NDIM),PBAR(NDIM)
         EXTERNAL FUNK
CNO_SAVE
         MPTS=NDIM+1
         ITER=0
1        ILO=1
         IF(Y(1).GT.Y(2))THEN
         IHI=1
         INHI=2
         ELSE
         IHI=2
         INHI=1
         ENDIF
         DO I=1,MPTS
         IF(Y(I).LT.Y(ILO)) ILO=I
         IF(Y(I).GT.Y(IHI))THEN
         INHI=IHI
         IHI=I
         ELSE IF(Y(I).GT.Y(INHI))THEN
         IF(I.NE.IHI) INHI=I
         ENDIF
	 ENDDO
c 11       CONTINUE
         RTOL=2.*ABS(Y(IHI)-Y(ILO))/(ABS(Y(IHI))+ABS(Y(ILO)))
         IF(RTOL.LT.FTOL)RETURN
         IF(ITER.EQ.ITMAX) THEN
         WRITE(NOUT,*) ' Amoeba exceeding maximum iterations.'
         RETURN
         ENDIF
         ITER=ITER+1
         DO J=1,NDIM
         PBAR(J)=0.
	 ENDDO
c 12       CONTINUE
         DO I=1,MPTS
         IF(I.NE.IHI)THEN
         DO  J=1,NDIM
         PBAR(J)=PBAR(J)+P(I,J)
	 ENDDO
c 13       CONTINUE
         ENDIF
	 ENDDO
c 14       CONTINUE
         DO J=1,NDIM
         PBAR(J)=PBAR(J)/NDIM
         PR(J)=(1.+ALPHA)*PBAR(J)-ALPHA*P(IHI,J)
	 ENDDO
c 15       CONTINUE
         YPR=FUNK(PR)
         IF(YPR.LE.Y(ILO))THEN
         DO  J=1,NDIM
         PRR(J)=GAMMA*PR(J)+(1.-GAMMA)*PBAR(J)
	 ENDDO
c 16       CONTINUE
         YPRR=FUNK(PRR)
         IF(YPRR.LT.Y(ILO))THEN
         DO J=1,NDIM
         P(IHI,J)=PRR(J)
	 ENDDO
c 17       CONTINUE
         Y(IHI)=YPRR
         ELSE
         DO  J=1,NDIM
         P(IHI,J)=PR(J)
	 ENDDO
c 18       CONTINUE
         Y(IHI)=YPR
         ENDIF
         ELSE IF(YPR.GE.Y(INHI))THEN
         IF(YPR.LT.Y(IHI))THEN
         DO  J=1,NDIM
         P(IHI,J)=PR(J)
	 ENDDO
c 19       CONTINUE
         Y(IHI)=YPR
         ENDIF
         DO J=1,NDIM
         PRR(J)=BETA*P(IHI,J)+(1.-BETA)*PBAR(J)
	 ENDDO
c 21       CONTINUE
         YPRR=FUNK(PRR)
         IF(YPRR.LT.Y(IHI))THEN
         DO J=1,NDIM
         P(IHI,J)=PRR(J)
	 ENDDO
c 22       CONTINUE
         Y(IHI)=YPRR
         ELSE
         DO  I=1,MPTS
         IF(I.NE.ILO)THEN
         DO  J=1,NDIM
         PR(J)=0.5*(P(I,J)+P(ILO,J))
         P(I,J)=PR(J)
	 ENDDO
c 23       CONTINUE
         Y(I)=FUNK(PR)
         ENDIF
	 ENDDO
c 24       CONTINUE
         ENDIF
         ELSE
         DO  J=1,NDIM
         P(IHI,J)=PR(J)
	 ENDDO
c 25       CONTINUE
         Y(IHI)=YPR
         ENDIF
         GO TO 1
         END
