
C++*****************************************************************************
C
C ARASQ.F                      ADAPTED FROM ARAS.FOR FOR CHAR. AUG 89 al
C                              CHANGED ERROR MESG. SEPT 97 al
C
C **************************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK            *
C *  COPYRIGHT (C)1981,1987, WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH 			   *
C **************************************************************************
C
C ARASQ(STRING,L1,IFLAG)
C
C PURPOSE:       SUBROUTINE TO EVALUATE ARITHMETIC EXPRESSION
C
C--*****************************************************************************

	SUBROUTINE ARASQ(OLDSTR,L1,IFLAG)

	COMMON/UNITS/LUN,NIN,NOUT
	COMMON/PARAM/PARAM(103),NSEL(10)

        CHARACTER *(*) OLDSTR
        CHARACTER *89  NEWSTR

	IFLAG=0
	CALL SHRINKQ(OLDSTR,L1,NEWSTR,L2)
	IF (L2 .LE. 0) GOTO 1000
        
C       OMIT COMMENT SECTION AT END OF STRING IF ANY
        ICOMNT = INDEX(NEWSTR(:L2),';')
C       TRAP LINE WITH ONLY A COMMENT ON IT (SHOULD NEVER GET, ANYWAY)
        IF (ICOMNT .EQ. 1) RETURN
        IF (ICOMNT .GT. 1) THEN
C          REMOVE THE SPIDER COMMENT FOLLOWING ;
           L2 = ICOMNT - 1
C          MAY NEED TO SKIP TAB BEFORE COMMENT?
           L2=lnblnk(NEWSTR(1:L2))
        ENDIF

        IEQUAL = INDEX(NEWSTR(:L2),'=')
        IF (IEQUAL .EQ. 0) THEN
C          NO EQUALS SIGN FOUND
           CALL EXPRQ(NEWSTR(:L2),L2,VALUE,IFLAG)
           WRITE(NOUT,14)VALUE
14         FORMAT(1X,F15.4)
           RETURN
        ENDIF

	NEQ = IEQUAL + 1
C       NEQ NOW POINTS TO POSITION OF EQUAL SIGN

C       EVALUATE LEFT HAND NEQ-1 CHARACTERS, THEN RIGHT HAND L2-NEQ CHARS

	IF (NEWSTR(1:1) .NE. 'X') GOTO 1000

        IF (NEQ-1 .EQ. 2) THEN
            READ(NEWSTR(2:2),605,ERR=1000) ITEMP
605	    FORMAT(I1)
        ELSE
            READ(NEWSTR(2:3),606,ERR=1000) ITEMP
606	    FORMAT(I2)
        ENDIF

	CALL EXPRQ(NEWSTR(NEQ:L2),L2-NEQ+1,VALUE,IFLAG)
	IF (IFLAG .NE. 0) GOTO 1000
	PARAM(ITEMP+1) = VALUE
	RETURN

1000	WRITE(NOUT,*) '*** ERROR: ARITHMETIC ASSIGNMENT FAILED'
	RETURN
	END
