
C *NAME* = ARBRE.FOR                   31-JAN-86      13:23:00                  
C----------------------------------=*=----------------------------------        
C           COPYRIGHT 1986 - JEAN-PIERRE BRETAUDIERE                            
C THE UNIVERSITY OF TEXAS HEALTH SCIENCE CENTER AT HOUSTON                      
C MEDICAL SCHOOL - DEPARTMENT OF PATHOLOGY AND LABORATORY MEDICINE              
C P.O. BOX 20708, HOUSTON, TX 77225.                                            
C DISCLAIMER: NO GUARANTEES OF PERFORMANCE ACCOMPANY THIS SOFTWARE,             
C NOR IS ANY RESPONSIBILITY ASSUMED ON THE PART OF THE AUTHOR                   
C OR THE INSTITUTION.  ALL THE SOFTWARE HAS BEEN TESTED EXTENSIVELY             
C AND EVERY EFFORT HAS BEEN MADE TO INSURE ITS RELIABILITY.                     
C THE FOLLOWING SOFTWARE MAY NOT BE COMMUNICATED TO A THIRD PARTY               
C UNDER ANY FORM WITHOUT WRITTEN PERMISSION OF THE AUTHOR.                      
C PLEASE REPORT ANY BUG(S) TO JPB AT (713) 792 52 00.                           
C OR THRU ARPANET AT  ......!rice!ots!ut-path!suprim                            
C*--------------------------------------------------------------------*         
C*                                                                    *         
C*                                                                    *         
C*      TREE DESCRIPTION AND DENDROGRAM                               *         
C*                                                                    *         
C*      NKLA SUMMITS            JFIN =2*NKLA - 1                      *         
C*      ARRAYS PROVIDED BY CHAVA  VAL(JFIN), LA(NKLA), LB(NKLA)       *         
C*                                PK(JFIN), IDK(NKLA)                 *         
C*                                                                    *         
C*      WORKING ARRAYS            NO(JFIN), V(NKLA), NT(NKLA),        *         
C*                                IW(NKLA), W(NKLA), IV(NKLA),        *         
C*                                NUM(NKLA)                           *         
C*                                                                    *         
C==06.07.80                                                           *         
C==01.12.86                                                           *         
C*--------------------------------------------------------------------*         

      SUBROUTINE ARBRE (NKLA, JFIN, VAL, LA, LB, PK, IDK,                       
     #                               NO,NUM,NT,IV,IW,V,W,VMIN,VMAX)
C
      COMMON  /ENSOR/ LEC,IMP                                                   
      DIMENSION VAL(JFIN),LA(NKLA),LB(NKLA),PK(JFIN),IDK(NKLA)       
     #   ,NO(JFIN),V(NKLA),NT(NKLA),IW(NKLA),W(NKLA),IV(NKLA),NUM(NKLA)
	CHARACTER*1  IBLAN,ISTAR,LIGN(102)
c                       space       dot      
      DATA  LIG/102/ , IBLAN/' '/ , ISTAR/'.'/                                  
      JDEB  = NKLA + 1                                                          
      VMIN  = VAL(JDEB)                                                         
      VMAX  = VAL(JFIN)                                                         
        DO   J = JDEB,JFIN                                                   
      IR    = J - JDEB + 1                                                      
      IA    = LA(IR)                                                            
      IB    = LB(IR)                                                            
        IF (VAL(J) .LT. VMIN)          VMIN = VAL(J)                            
        IF (VAL(J) .GT. VMAX)          VMAX = VAL(J)                            
      NO(IA)= J                                                                 
      NO(IB)= J                                                                 
      ENDDO
      NO(JFIN)= JFIN                                                            
C                                                                               
C......... DESCRIPTION OF THE HIERARCHY CLASSES                                 
C                                                                               
      WRITE (IMP,600)                                                           
        DO    J = JDEB,JFIN                                                   
      NT(1) = J                                                                 
      KPT   = 0                                                                 
      JI    = 1                                                                 
   20   IF (NT(JI) .GT. NKLA)          GO TO  30                                
      K     = NT(JI)                                                            
      KPT   = KPT + 1                                                           
      IV(KPT)= IDK(K)                                                           
      IW(KPT)= K                                                                
      NUM(NKLA-KPT+1)= IDK(K)                                                   
      JI    = JI - 1                                                            
                                       GO TO  40                                
   30 IJ    = JI + 1                                                            
      NI    = NT(JI) - JDEB + 1                                                 
      NT(IJ)= LA(NI)                                                            
      NT(JI)= LB(NI)                                                            
      JI    = JI + 1                                                            
   40   IF (JI .NE. 0)                 GO TO  20                                
      IR    = J - JDEB + 1                                                      
      WRITE (IMP,610)  J, VAL(J),LA(IR),LB(IR),KPT,(IV(KK),KK=1,KPT)            
      I1    = IW(1)                                                             
      I2    = IW(KPT)                                                           
      W(I1) = NO(J) + 0.0001                                                    
      W(I2) = NO(I2) + 0.0001                                                   
	ENDDO
c   50   CONTINUE                                                                
C                                                                               
C......... GRAPH OF DENDROGRAM                                                  
C                                                                               
      WRITE (IMP,620)  VMIN, VMAX                                               
        DO   J = 1,NKLA                                                       
      K     = W(J)                                                              
      W(J)  = VAL(K)                                                            
	ENDDO
        DO   J = 1,NKLA                                                       
      IWI   = IW(J)                                                             
      V(NKLA-J+1)= W(IWI)                                                       
	ENDDO
        DO   L = 1,LIG                                                        
      LIGN(L)= IBLAN                                                          
	ENDDO  
      PAS   = FLOAT(LIG) / (VMAX - VMIN)                                        
      I1    = NKLA - 1                                                          
        DO   J = 1,I1                                                        
      LX    = (V(J) - VMIN)*PAS + 1.0                                           
        IF (LX .LE. 1)                 LX = 1                                   
        IF (LX .GT. LIG)               LX = LIG                                 
        DO   LL = 1,LX                                                        
      LIGN(LL)= ISTAR                                                           
	ENDDO
      JJ    = IW(NKLA-J+1)                                                      
      POID  = PK(JJ)                                                            
      WRITE (IMP,630)  POID, V(J), NUM(J), (LIGN(L),L=1,LIG)                    
        IF (LX .EQ. 1)                 GO TO  110                               
      LX    = LX - 1                                                            
        DO   LL = 1,LX                                                       
      LIGN(LL)= IBLAN                                                           
	ENDDO
  110 WRITE (IMP,640)  (LIGN(L),L=1,LIG)                                        
	ENDDO
c  120   CONTINUE                                                                
        DO   L = 1,LIG                                                       
      LIGN(L)= ISTAR                                                            
	ENDDO
      JJ    = IW(1)                                                             
      POID  = PK(JJ)                                                            
      WRITE (IMP,650)  POID, NUM(NKLA), (LIGN(L),L=1,LIG)                       
  600 FORMAT ('1','NODE  INDEX  SENIOR  JUNIOR  SIZE'    ,5X,                   
     #  'DESCRIPTION OF THE HIERARCHY CLASSES'     /' ',64('. ') / )            
  610 FORMAT
     # (//1X,I4,1X,1PG10.3,I5,I6,I6,4X,18(1X,A4),(/' ',36X,18(1X,A4)))
  620 FORMAT ('1',5X, 'WEIGHT',4X, 'INDEX' ,9X,'DENDROGRAM',                    
     #                            4X, '(SCALE  ',2(1X,1PG10.3),' )',//)
  630 FORMAT (' ',2(1PG10.3),1X,A4,2X,'..',102A1)
  640 FORMAT (' ',29X,102A1)
  650 FORMAT (' ',1PG10.3,4X,6('-'),1X,A4,2X,'..',102A1)
         RETURN                                                                 
         END                                                                    
