
C++*************************************************************************
C
C $$ ARITH.FOR
C
C **************************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK            *
C *  COPYRIGHT (C)1981,1987, WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH 			   *
C **************************************************************************
C
C $$ ARITH:    ARITHMETIC OPERATION
C
C      CALL ARITH(LUN1,LUN2,NSAM,NROW,NSLICE)
C        LUN1         LOGICAL UNIT NUMBER OF FILE 1
C        LUN2         LOGICAL UNIT NUMBER OF FILE 2
C        NSAM,NROW    DIMENSIONS OF FILES
C
C--*******************************************************************

      SUBROUTINE ARITH(LUN1,LUN2,NSAM,NROW,NSLICE)

      INCLUDE 'CMBLOCK.INC'
      COMMON BUF(1)

      CHARACTER *80 S
      CHARACTER *4  AR
      CHARACTER     NULL
      CHARACTER     PL,P,A1,A2,RP,L,O,G,X
      LOGICAL       FLOG,FABS,FEXP

      DATA PL/'('/,AR/'+-*/'/,P/'P'/,RP/')'/,L/'L'/,X/'X'/
      DATA O/'O'/,G/'G'/
      DATA S(1:40)/'                                        '/

      NULL = CHAR(0)

      FLOG = .FALSE.
      FABS = .FALSE.        
      FEXP = .FALSE.

1     CALL RDPRMC(S,NCHAR,.TRUE.,'FORMULA: P2=$',NULL,IRTFLG)
      NS = 2

      IF (S(1:3) .EQ. 'LOG') THEN
3        FLOG = .TRUE.
         NS = NS+3

      ELSEIF (S(1:3) .EQ. 'ABS') THEN
4        FABS = .TRUE.
         NS=NS+3

      ELSEIF (S(1:3) .EQ. 'EXP') THEN
         FEXP = .TRUE.
         NS=NS+3
      ENDIF

2     IF (S(NS+1:NS+1) .NE. 'P') GOTO 300

      A1   = S(NS+3:NS+3)
      NADD = 3
      IAR1 = INDEX(AR,A1)
      IF (IAR1 .LE. 0) GOTO 300

40    NADD = NADD+1
      IF (NS + NADD .GT. 80) GOTO 300
      IF (S(NS+NADD:NS+NADD) .NE. ')') GOTO 40
      NS1 = NS+NADD-1
      LENGTH = NS1-(NS+4)+1

      IF (S(NS+4:NS+4) .EQ. 'X') THEN
        IX = LENGTH-1
        IF (IX.NE.1.AND.IX.NE.2) GOTO 300
        CALL CHKNUMQ(S(NS+5:80),IX,'I',NUM,DUM,IER)
        IF (IER.EQ.1) GOTO 300
        F1 = PARAM(NUM+1)
      ELSE
42      CALL CHKNUMQ(S(NS+4:80),LENGTH,'R',NUM,F1,IER)
         IF (IER.EQ.1) GOTO 300
      ENDIF

45    IF(IAR1.EQ.2) F1=-F1
      IF(IAR1.EQ.4) F1=1./F1
      A2 = S(NS+NADD+1:NS+NADD+1)
      NADD = NADD+1

      DO  I=1,4
        IAR2 = I
        IF (A2 .EQ. AR(I:I)) GOTO 70
      ENDDO
c50    CONTINUE
      GOTO 300

70    NADD1 = NADD+1
80    NADD = NADD+1
      IF (NS+NADD.GT.80) GOTO 300
      IF (S(NS+NADD:NS+NADD) .NE. ')') GOTO 80
      NS2 = NS+NADD-1
      LENGTH = NS2-(NS+NADD1)+1
      IF (S(NS+NADD1:NS+NADD1) .NE. 'X') GOTO 82
      IX = LENGTH-1
      IF (IX .NE. 1 .AND. IX .NE. 2) GOTO 300
      CALL CHKNUMQ(S(NS+NADD1+1:80),IX,'I',NUM,DUM,IER)
      IF (IER.EQ.1) GOTO 300
      F2 = PARAM(NUM+1)
      GOTO 85
82    CALL CHKNUMQ(S(NS+NADD1:80),LENGTH,'R',NUM,F2,IER)
      IF (IER.EQ.1) GOTO 300
85    IF (IAR2.EQ.2) F2 = -F2
      IF (IAR2.EQ.4) F2 = 1./F2
      IF (IAR1.LT.3.AND.IAR2.GE.3) GOTO 100
      IF (IAR1.GE.3.AND.IAR2.LT.3) GOTO 150
      GOTO 300

100   DO  ISL=1,NSLICE
        IOFF=(ISL-1)*NROW
        DO  I = 1,NROW
          IROW=IOFF+I
          CALL REDLIN(LUN1,BUF,NSAM,IROW)
          DO  K = 1,NSAM
          BUF(K) = (BUF(K)+F1)*F2
	  ENDDO

          IF (FLOG) THEN
            DO  K = 1,NSAM
            BUF(K) = ALOG10(BUF(K))
	    ENDDO

          ENDIF
116       IF(FABS) THEN
            DO  K = 1,NSAM
            BUF(K) = ABS(BUF(K))     
	    ENDDO

          ENDIF
118       IF (FEXP) THEN
            DO  K = 1,NSAM
            BUF(K)=EXP(BUF(K))
  	    ENDDO
          ENDIF
        CALL WRTLIN(LUN2,BUF,NSAM,IROW)
	ENDDO
      ENDDO
c121   CONTINUE

      IF(IMAMI.NE.1) RETURN
      FMAX = (FMAX+F1)*F2
      FMIN = (FMIN+F1)*F2
      AV = (AV+F1)*F2
	SIG=SIG*F2
      GOTO 190

150   DO  ISL=1,NSLICE
        IOFF=(ISL-1)*NROW
        DO 180 I = 1,NROW
          IROW=IOFF+I
          CALL REDLIN(LUN1,BUF,NSAM,IROW)
          DO  K = 1,NSAM
          BUF(K) = BUF(K)*F1+F2
	  ENDDO

          IF(.NOT.FLOG) GOTO 176
          DO  K = 1,NSAM
          BUF(K) = ALOG10(BUF(K))
	  ENDDO

          GOTO 180
176       IF(.NOT.FABS) GOTO 178 
          DO  K = 1,NSAM
          BUF(K) = ABS(BUF(K))
	  ENDDO

          GOTO 180

178       IF(FEXP) THEN
            DO  K=1,NSAM
              BUF(K) = EXP(BUF(K))
	    ENDDO
c 179         CONTINUE 
          ENDIF

180     CALL WRTLIN(LUN2,BUF,NSAM,IROW)
      ENDDO
c181   CONTINUE

      IF (IMAMI.NE.1) RETURN
      V1   = FMAX*F1+F2
      V2   = FMIN*F1+F2
      FMAX = AMAX1(V1,V2)
      FMIN = AMIN1(V1,V2)
      AV   = AV*F1+F2
      SIG  = SIG*F1

190   IF(FLOG.OR.FABS) RETURN
200    CALL SETPRM(LUN2,NSAM,NROW,FMAX,FMIN,AV,'U')
      RETURN

300   CALL ERRT(16,'ARITH ',NE)
      WRITE(NOUT,*) ' IX=', IX
      IBCNT = IBCNT-1
      GOTO 1

      END
