#ifdef SP_DISTRIB 
 
C   THIS ROUTINE SPECIFIC TO WADSWORTH LABS AND IS NOT 
C       DISTRIBUTED TO OUTSIDE SITES
 
       SUBROUTINE atiltax3
 
       COMMON /UNITS/LUNC,NIN,NOUT
 
       WRITE(NOUT,*) 'DUMMY CALL: atiltax3'
       RETURN
       END
 
#else
 


C MARCH 86 VERSION OF TILTAXIS DETERMINATION, BASED ON ATILTAX.
C PROGRAM TO PRESORT COORDINATES AND DETERMINE TILT AXIX DIRECTION.
C APPLICABLE TO DIRECT SPACE IMAGES ONLY.
C THE FIRST TWO COORDINATE PAIRS DEFINE AN ESTIMATE FOR THE TILT
C AXIS.
C JAN 85  M.RADERMACHER


	SUBROUTINE ATILTAX3

        PARAMETER (IDIS=1000)
#ifdef SP_UNIX
        INCLUDE 'CMBLOCK.INC'
#else
        INCLUDE 'COMMON1:CMBLOCK.INC'
#endif

        COMMON /ATLTXP/ OUT
        COMMON /COMMUN/FLNAM,FLN2
        COMMON DUMMY(20),XCOOSI(IDIS),YCOOSI(IDIS),XCOOST(IDIS),
     $  YCOOST(IDIS),PLIST(4),WRE(IDIS),WT(IDIS),
     $  DM(2,2),DISQRI(IDIS),DISQRT(IDIS),
     $  ITAKE(IDIS),DBUF(2000)

        CHARACTER *81 FLNAM,FLN2
        CHARACTER *1  NULL,ANS
        LOGICAL OUT

        NULL=CHAR(0)

	PI=3.14159
        MLIM=(1.+SQRT(8.*FLOAT(IDIS)+1.))/2.
        OUT=.TRUE. 

	CALL RDPRMI(IM1,IM2,NLOOP,ILOOP,
     $           'MICROGRAPH NUMBERS O DEG, TILTED')
        CALL RDPRMC(ANS,NA,.TRUE.,'LONG OUTPUT (Y/N)? (DEF:Y)',
     &              NULL,IRTFLG)
        IF (ANS .EQ. 'N' .OR. ANS .EQ. 'n') OUT=.FALSE. 
        CALL RDPRM(WLIM,NLOOP,ILOOP,'MAXIMUM ANGLE TO REFERENCE')
        CALL RDPRM(WLO,NLOOP,ILOOP,
     $        'UPPER BOUND FOR ANGULAR (INPUT) ERROR')
        CALL RDPRM(DMIN,NLOOP,ILOOP,'MINIMUM LENGTH')

	NLIST=2

C GET NAME OF DOC-FILE WITH MARKER COORDINATES IN UNTILTED IMAGE
C THE FIRST TWO POINTS DEFINE A REFERENCE LINE WHICH SHOULD BE 
C CLOSE TO THE DIRECTION OF THE TILT AXIS. (+-20 DEG)

	CALL FILERD(FLNAM,NLET,NULL,'0-DOC',IRTFLG)

C READ MARKER COORDINATES OF UNTILTED IMAGE

        ICALL=0
        DO 1 I=1,MLIM
           CALL UNSDAL(FLNAM,ICALL,15,I,PLIST,NLIST,
     1              DBUF,999,3,NKEY,LERR)
C          CALL UNSAV(FLNAM,NOPEN,15,I,PLIST,NLIST,LERR,NSS)
	   IF (LERR.EQ.1) GOTO 2
           IF (LERR.GT.0) RETURN
           XCOOSI(I)=PLIST(1)
           YCOOSI(I)=PLIST(2)
           NUM=I
1       CONTINUE	
2	CONTINUE
        CLOSE (15)
        WRITE(NOUT,277) NUM,MLIM
277     FORMAT(' ',I4,' MEASUREMENTS USED (LIMIT:',I4,' )')
        NOPEN=0
        NM=NUM-2
C
C GET MARKER COORDINATES OF TILTED IMAGE. 
C
        CALL FILERD(FLN2,NLET,NULL,'T-DOC',IRTFLG)
	DO 3 I=1,NUM
        CALL UNSDAL(FLN2,NOPEN,15,I,PLIST,NLIST,
     &              DBUF,999,3,NKEY,LERR)
C        CALL UNSAV(FLN2,NOPEN,15,I,PLIST,NLIST,LERR,NSS)        
	XCOOST(I)=PLIST(1)
        YCOOST(I)=PLIST(2)
        IF(LERR.EQ.0) GOTO 3
        IF(LERR.EQ.2) RETURN
        WRITE(NOUT,4)I
        RETURN
3	CONTINUE
        CLOSE(15)
C NOW ALL MARKER POINTS ARE KNOWN.    
        WRITE(NOUT,512) IM1,IM2
C
C WRITE OUT REFERENCE POINTS:
C
         IF (OUT) WRITE(NOUT,102) (XCOOSI(L),YCOOSI(L),L=1,2)
         IF (OUT) WRITE(NOUT,102) (XCOOST(L),YCOOST(L),L=1,2)
C
C WRITE OUT MARKER POINTS:
C
        IF (OUT) WRITE(NOUT,103)
        IF (OUT) WRITE(NOUT,101) 
     $  (XCOOSI(L),YCOOSI(L),XCOOST(L),YCOOST(L),L=1,NUM)
C
C	CALCULATE REFERENCE VECTORS:
C
        XREF=XCOOSI(2)-XCOOSI(1)
        YREF=YCOOSI(2)-YCOOSI(1)
        XREFT=XCOOST(2)-XCOOST(1)
        YREFT=YCOOST(2)-YCOOST(1)

        DO 11 K=1,NM
        XCOOSI(K)=XCOOSI(K+2)
        YCOOSI(K)=YCOOSI(K+2)
        XCOOST(K)=XCOOST(K+2)
        YCOOST(K)=YCOOST(K+2)
11      CONTINUE

C  CALCULATE TILTANGLE
C  * WRE IS ENTERED HERE AS A BUFFER ARRAY *
        CALL TILTANG(XCOOSI,YCOOSI,XCOOST,YCOOST,NM,THETA,IAR,WRE)
        CALL CALCERR(WRE,THETA,IAR,STDEV,VAR)
        WRITE(NOUT,120) IAR,THETA,STDEV
	CALL RDPRM(TH,NLOOP,ILOOP,
     $  'TILT ANGLE (0 IF CALULATED ONE IS TO BE USED)')
        IF(TH.GT.0) THETA=TH
C
C REFWINK AND REFT ARE THE ANGLES BETWEEN THE REFERENCE LINE AND 
C THE DIGITIZING TABLET X-AXIS (IN 0 DEG AND TILTED IMAGE)
C
        REFWINK=PI/2.
        IF(XREF.EQ.0) GOTO 12
        AREF=YREF/XREF
        REFWINK=ATAN(AREF)
12      REFT=PI/2. 
        IF(XREFT.EQ.0) GOTO 13
        TREF=YREFT/XREFT
        REFT=ATAN(TREF) 
13      CONTINUE
	WRITE(NOUT,108) XREF,YREF,(REFWINK/PI*180.)
	WRITE(NOUT,109) XREFT,YREFT,(REFT/PI*180.)
C
C CALCULATE DIFFERENCE VECTORS:
C
	IND=0.
        DO 6 L=1,NM
        XI=XCOOSI(L)
        YI=YCOOSI(L)
	XT=XCOOST(L)
        YT=YCOOST(L)
	DO 7 LL=L+1,NM
        IND=IND+1
        XDI=XCOOSI(LL)-XI
        YDI=YCOOSI(LL)-YI
        DISQRI(IND)=SQRT(XDI*XDI+YDI*YDI)
C 
        XDT=XCOOST(LL)-XT
        YDT=YCOOST(LL)-YT
	DISQRT(IND)=SQRT(XDT*XDT+YDT*YDT)
C
C FIND ANGLES RELATIVE TO REFERENCE LINE 
C
C        WRITE(NOUT,104)L,LL,XI,YI,XCOOSI(LL),YCOOSI(LL),DISQRI(IND),
C     $  XT,YT,XCOOST(LL),YCOOST(LL),DISQRT(IND)

C  0 DEG:
        A1=YDI
        A2=XDI
        AW=1000.
        IF(A2.NE.0) AW=A1/A2
        WINK=ATAN(AW) 
        WRE(IND)=WINK-REFWINK
        IF(WRE(IND).LT.(-PI/2.)) WRE(IND)=WRE(IND)+PI
        IF(WRE(IND).GT.(PI/2.)) WRE(IND)=WRE(IND)-PI 
C  TILTED:
        A1=YDT
        A2=XDT
        AW=1000.
        IF(A2.NE.0) AW=A1/A2
        WINK=ATAN(AW) 
        WT(IND)=WINK-REFT 
        IF(WT(IND).LT.(-PI/2.)) WT(IND)=WT(IND)+PI
        IF(WT(IND).GT.(PI/2.)) WT(IND)=WT(IND)-PI
C        WRITE(NOUT,105) XDI,YDI,
C     $  (WINK/PI*180.),(WRE(IND)/PI*180.)
        IALL=IND
7	CONTINUE
6	CONTINUE

C
C ELIMINATE ALL DISTANCE VECTORS WITH ANGLES LARGER THEN WLIM DEG 
C AND SMALLER THAN WLO DEG RELATIVE TO THE REFERENCE LINE 
C (TO AVOID UNDEFINED ARCSINES IN WINKEL5 AND MAKE THE ANGLE SIGN UNIQUE).
C AND ALL DISTANCES SHORTER THAN DMIN
C
        WLIM=WLIM/180.*PI
        WLO=WLO/180.*PI
	ITOT=IALL
        INUL=0

        DO 8 L=1,IALL
        ITAKE(L)=1
        IF(ABS(WRE(L)).LT.WLIM.AND.ABS(WRE(L)).GT.WLO) GOTO 88
        ITAKE(L)=0
        INUL=INUL+1
        GOTO 8
88	CONTINUE

        IF(DISQRI(L).GT.DMIN) GOTO 8
        ITAKE(L)=0
        INUL=INUL+1
8       CONTINUE         
        IOK=IALL-INUL
        ISTRT=1
C
C REORDER THE LINES
C
        DO 9 LL=1,IOK
        DO 10 KK=ISTRT,IALL
        IF(ITAKE(KK).EQ.0) GOTO 10
        WRE(LL)=WRE(KK)
        WT(LL)=WT(KK)
        DISQRI(LL)=DISQRI(KK)
        DISQRT(LL)=DISQRT(KK)
        ISTRT=KK+1
	GOTO 9
10      CONTINUE
9	CONTINUE

C
C WRITE OUT THE INPUT DATA FOR THE ACTUAL ANGLE DETERMINATION:
C
C        WRITE(NOUT,107) (WRE(KK)/PI*180.,WINK/PI*180.,
C     $  DISQRI(KK),DISQRT(KK),KK=1,IOK)
C       WRITE(NOUT,118) (ITAKE(LL),LL=1,IALL)

C CALCULATE TILT AXIS DIRECTION IN 0 DEG IMAGE:

	CALL WINKEL5(IM1,IM2,DISQRI,DISQRT,IOK,WRE,THETA,NOUT)

C CALCULATE TILT AXIS DIRECTION IN TILTED IMAGE:
        CALL WINKELT(IM1,IM2,DISQRI,DISQRT,IOK,WT,THETA,NOUT)

C-------------------------------------------------------------
C FORMAT STATEMENTS:
4       FORMAT(' DOCUMENT FILES INCONSISTENT, KEY=',I5)
102     FORMAT(' ',/' REFERENCE POINTS:'/1H ,
     $   '     X       Y   '/1H ,2(1X,F7.2,1X))
101     FORMAT(/'      X0     Y0     XT      YT  ',
     $  /4(1X,F7.2,1X))
103     FORMAT(' ',/' MARKER COORDINATES:')
108     FORMAT(' ',/'  0 DEG:XREF=',F12.4,
     $  '  YREF=',F12.4,'  REFWINK=',F12.4)
109     FORMAT(' TILTED:XREF=',F12.4,
     $  '  YREF=',F12.4,'  REFWINK=',F12.4)
133     FORMAT(' ',5(' A:=',F12.4))
104     FORMAT(' L,LL',2I5,
     $  /' XI,YI,XCOOSI,YCOOSI,DISQRI',/1X,5F12.5,/
     $  ' XT,YT,XCOOST,YCOOST,DISQRT'/1X,5F12.5,1X)
105     FORMAT(' XDI,YDI:',2F10.4,'  ANGLES ABS,REL:',2F10.4)
107	FORMAT(' DISQRI,DISQRT,WRE',/1H ,3(F12.6,1X))
118     FORMAT(' ITAKE: ',/5(1X,I4))
120     FORMAT(' ',/
     $  ' TILTANGLE CALCULATED FROM ',I6,' MEASUREMENTS: ',F12.4,
     $  'STANDARD DEVIATION: ',F12.4//)
512     FORMAT(' MICROGRAPH NUMBERS:',I10,I10)
	RETURN
	END

 
#endif
 
