
C ++********************************************************************
C
C AUXFILERD
C
C **********************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK            *
C *  COPYRIGHT (C)1981,1993, WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH                            *
C **************************************************************************
C
C AUXFILERD(FILNAM,NCHAR,EXTEN,PROMPT,IRTFLG)
C
C PURPOSE: READS NAME FOR A NON-SPIDER FILE (CAN HAVE EXTENSION OTHER
C          THAN DATEXC)
C
C PARAMETERS: FILNAM                                 (RETURNED)
C             NCHAR      LENGHT OF FILENAME          (RETURNED)
C             EXTEN      EXTENSION                   (SENT/RETURNED)
C             PROMPT     PROMPT FOR FILE             (SENT)
C             IRTFLG     ERROR FLAG (0 IS OK)        (RETURNED)
C
C        0         2         3         4         5         6         7
C23456789012345678901234567890123456789012345678901234567890123456789012
C**************************************************************************

        SUBROUTINE AUXFILERD(FILNAM,NCHAR,EXTEN,PROMPT,IRTFLG)

        INCLUDE 'CMBLOCK.INC'
CNO_SAVE
        CHARACTER *(*)  FILNAM,EXTEN,PROMPT
        CHARACTER       NULL

        NULL = CHAR(0)

C       SET IRTFLG TO ALLOW FILE EXTENSION ON INPUT
        IRTFLG = 9

        CALL FILERD(FILNAM,NCHAR,EXTEN,PROMPT,IRTFLG)
        IF (IRTFLG .NE. 0) RETURN

        IF (INDEX(EXTEN,NULL) .EQ. 1) THEN
C          ADD DATEXC TO FILNAM
           CALL FILCAN(FILNAM,NLET,NULL,NULL,FILNAM,DATEXC,IRTFLG)
           IF (IRTFLG .NE. 0) THEN
              CALL ERRT(100,'AUXFILERD',NE)
              RETURN
           ENDIF
        ENDIF

C       write(6,*) nlet,'exten: ',exten
C       write(6,*) nlet,'filnam: ',filnam

        IRTFLG = 0
        RETURN

        END

