
C ************************************************************************** 
C
C AUXOPN.FOR  -- CREATED MAY 87
C
C **************************************************************************
C *  AUTHOR: ArDean Leith 
C *  COPYRIGHT (C)1987, WADSWORTH CENTER FOR LABORATORIES AND RESEARCH    *
C *    NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.              *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH  			   *
C **************************************************************************
C
C    AUXOPN(FILNAM,DISP,LUN,IRTFLG)
C
C    PURPOSE:    OPENS AN OLD OR NEW FILE FOR STORAGE OR RECOVERY OF DATA.
C
C    PARAMETERS: FILNAM = WHOLE FILE NAME FOR FILE TO BE OPENED
C                DISP   = CHAR FLAG THAT FILE IS OLD, NEW, OR UNKNOWN
C                LUN    = LOGICAL UNIT FOR OPENING FILE IF NECESSARY
C                IRTFLG = ERROR FLAG
C
C    CALLED BY:  AUXFIL
C
C    CALLS:      
C
C--********************************************************************

      SUBROUTINE AUXOPN(FILNAM,DISP,LUN,IRTFLG)

      INCLUDE 'CONSTG.INC'

      COMMON /UNITS/LUNDOC,NIN,NOUT
      COMMON /LUNARA/ LUNARA(100)

      CHARACTER * 1  NULL
      CHARACTER *(*) FILNAM,DISP
      LOGICAL        EX
        
	NULL=CHAR(0)

C       SET NO ERROR RETURN
        IRTFLG = 0

C       FIND LENGTH OF EXTENDED FILE NAME
        NLET   = INDEX(FILNAM,NULL) - 1
        IF (NLET .LE. 1) THEN
C          ERROR IN INCOMING NAME
           NLET = 1
           GOTO 5001
        ENDIF

        IF (LUN .LE. 0 .OR. LUN .GT. 100) THEN
           WRITE(NOUT,1093)
1093       FORMAT(' ERROR: LUN MUST BE 1...100, HAVE SET IT TO 99'/)
           LUN = 99
        ENDIF
        LUNARA(LUN) = LUN

C       CHECK FOR FILE EXISTENCE 
        INQUIRE (FILE=FILNAM,ERR=5001,EXIST=EX) 

        IF (.NOT. EX .AND. DISP(1:1) .EQ. 'O') THEN
           GOTO 5001

        ELSEIF (DISP(1:1) .EQ. 'O') THEN
C          OPEN EXISTING FILE
           OPEN(UNIT=LUN,FILE=FILNAM,STATUS='UNKNOWN',ERR=5001)

        ELSEIF (DISP(1:1) .EQ. 'U' .AND. EX) THEN
C          OPEN EXISTING FILE
           OPEN(UNIT=LUN,FILE=FILNAM,STATUS='UNKNOWN',ERR=5001)

        ELSE
C          OPEN A NEW FILE
           OPEN(UNIT=LUN,FILE=FILNAM,STATUS='NEW',ERR=5001)
        ENDIF

        IRTFLG = 0
        RETURN


C..     REPORT ERROR 
5001    WRITE(NOUT,102) LUN,FILNAM(1:NLET)
 102    FORMAT(' ERROR ON UNIT:',I3,' OPENING FILE: ',A)
        WRITE(NOUT,*) ' '         
        IRTFLG = 1
        RETURN

      END

