C++*******************************************************************
C
C $$ AVERG.FOR
C
C **************************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK            *
C *  COPYRIGHT (C)1981,1987, WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH 			   *
C **************************************************************************
C
C
C $$ AVERG:
C
C      CALL AVERG(LUN1,XAVG,J,K,NSAM,NROW,DS,DR,MOVWAY)
C      
C      FOR FURTHER INFORMATION, SEE COMMENTS IN AVERG.
C
C--*******************************************************************
C
C
	SUBROUTINE AVERG(LUN1,XAVG,J,K,NSAM,NROW,DS,DR,MOVWAY)
C  XAVG: RECURSIVE LOCAL AVERAGE OF PICTURE AREA
C  X( ): DR PICTURE LINES STORED  X[J,K]<>X((MOD(J-1,DR))*NSAM+K)
C  J,K PICTURE COORD
C  NSAM,NROW: PICTURE SIZE
C  DS,DR: LOCAL BOX  SIZE
C  MOVWAY= 1: READ IN DR LINE AND COMPUTE 1ST AVERAGE VALUE FROM SCRATCH
C             IF J,K IS IN A BORDER AREA COMPUTE XAVG FOR NEAREST
C             ACTIVE POINT
C        = 2: MOVE RT ONE PIXEL
C        = 3: MOVE LEFT ONE PIXEL
C        = 4: MOVE DOWN ONE PIXEL, READ IN NEXT LINE
C
	INTEGER DS,DR,HDS,HDR,EDGFST,EDGLST,EDGLFT,EDGRT
	COMMON /UNITS/LUN,NIN,NOUT,NECHO,IFOUND,NPROC,NDAT
	DIMENSION X(1)
	COMMON X
	SAVE
C
	GO TO(1000,2000,3000,4000),MOVWAY
C   INITIALIZE PARM AND XAVG
1000	HDR=DR/2
	HDS=DS/2
	EDGFST=HDR+1
	EDGLST=NROW-HDR
	EDGLFT=HDS+1
	EDGRT=NSAM-HDS
C   CHECK IF IN BORDER
	XAVG=0.
	JT=J
	KT=K
	IF(J.LT.EDGFST)JT=EDGFST
	IF(J.GT.EDGLST)JT=EDGLST
	IF(K.LT.EDGLFT)KT=EDGLFT
	IF(K.GT.EDGRT)KT=EDGRT
C   READ IN DR LINES AND COMPUTE AVERAGE FROM SCRATCH
	DO  JJ=JT-HDR,JT+HDR
	LSTART=(MOD(JJ-1,DR))*NSAM
	CALL REDLIN(LUN1,X(LSTART+1),NSAM,JJ)
	DO  KK=KT-HDS,KT+HDS
	XAVG=XAVG+X(LSTART+KK)
	ENDDO
	ENDDO
c 1010	CONTINUE
	XAVG=XAVG/FLOAT(DR*DS)
	RETURN
C
C  MOVE RT ONE PIXEL, UPDATE XAVG
2000	JT=J
	IF(K.EQ.EDGLFT.OR.K.LT.EDGLFT.OR.K.GT.EDGRT)RETURN
	IF(J.LT.EDGFST)JT=EDGFST
	IF(J.GT.EDGLST)JT=EDGLST
	CORECT=0.
	DO  JJ=JT-HDR,JT+HDR
	LSTART=(MOD(JJ-1,DR))*NSAM
	CORECT=CORECT+X(LSTART+K+HDS)-X(LSTART+K-HDS-1)
	ENDDO
	XAVG=CORECT/FLOAT(DR*DS)+XAVG
	RETURN
C	MOVE LEFT ONE PIXEL UPDATE XAVG
3000	JT=J
	IF(K.LT.EDGLFT.OR.K.GT.EDGRT.OR.K.EQ.EDGRT)RETURN
	IF(J.LT.EDGFST)JT=EDGFST
	IF(J.GT.EDGLST)JT=EDGLST
	CORECT=0.
	DO  JJ=JT-HDR,JT+HDR
	LSTART=(MOD(JJ-1,DR))*NSAM
	CORECT=CORECT+X(LSTART+K-HDS)-X(LSTART+K+HDS+1)
	ENDDO
	XAVG=CORECT/FLOAT(DR*DS)+XAVG
	RETURN
C  J INCREMENTED ONE
4000	IF(J.LE.EDGFST.OR.J.GT.EDGLST)RETURN
	KT=K
	IF(K.LT.EDGLFT)KT=EDGLFT
	IF(K.GT.EDGRT)KT=EDGRT
	CORECT=0.
	JOLD=J-HDR-1
	LSTART=(MOD(JOLD-1,DR))*NSAM
	DO  KK=KT-HDS,KT+HDS
	CORECT=CORECT-X(LSTART+KK)
	ENDDO
	CALL REDLIN(LUN1,X(LSTART+1),NSAM,J+HDR)
	DO  KK=KT-HDS,KT+HDS
	CORECT=CORECT+X(LSTART+KK)
	ENDDO
	XAVG=XAVG+CORECT/FLOAT(DS*DR)
	RETURN
	END
