C++*******************************************************************
C
C $$ AVERG3.FOR
C
C **************************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK            *
C *  COPYRIGHT (C)1981,1987, WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH 			   *
C **************************************************************************
C
C
C $$ AVERG3:
C
C      CALL AVERG3(LUN1,XAVG,J,K,L,NSAM,NROW,NSLICE,DS,DR,DL,MOVWAY)
C      
C      FOR FURTHER INFORMATION, SEE COMMENTS IN AVERG3.
C
C--*******************************************************************
C
C
	SUBROUTINE AVERG3(LUN1,XAVG,J,K,L,NSAM,NROW,NSLICE,DS,DR,DL,MOVWAY)
C  XAVG: RECURSIVE LOCAL AVERAGE OF 3D PICTURE VOLUME
C  X( ): DL PICTURE SLICES STORED
C  X[J,K,L]<>X(MOD(L-1,DL)*NROW+J*NSAM+K)
C  J,K,L PICTURE COORD
C  NSAM,NROW,NSLICE: PICTURE SIZE
C  DS,DR,DL: LOCAL BOX  SIZE
C  MOVWAY= 1: READ IN DL SLICES AND COMPUTE 1ST AVERAGE VALUE FROM SCRATCH
C             IF J,K,L IS IN A BORDER AREA COMPUTE XAVG FOR NEAREST
C             ACTIVE POINT
C        = 2: MOVE RT ONE PIXEL
C        = 3: MOVE LEFT ONE PIXEL
C        = 4: MOVE DOWN RIGHT ONE PIXEL
C        = 5: MOVE DOWN LEFT  ONE PIXEL
C        = 6: MOVE UP, READ IN NEXT SLICE
C
	INTEGER DS,DR,DL,HDS,HDR,HDL,EDGFST,EDGLST,EDGLFT,EDGRT,EDGDW,EDGUP
	COMMON /UNITS/LUN,NIN,NOUT,NECHO,IFOUND,NPROC,NDAT
	DIMENSION X(1)
	COMMON X
        SAVE
C
	GO TO(1000,2000,3000,4000,5000,6000),MOVWAY
C   INITIALIZE PARM AND XAVG
1000	HDR=DR/2
	HDS=DS/2
	HDL=DL/2
	EDGFST=HDR+1
	EDGLST=NROW-HDR
	EDGLFT=HDS+1
	EDGRT=NSAM-HDS
	EDGDW =HDL+1
	EDGUP=NSLICE-HDL
C   CHECK IF IN BORDER
	XAVG=0.
	JT=J
	KT=K
	KL=L
	IF(J.LT.EDGFST)JT=EDGFST
	IF(J.GT.EDGLST)JT=EDGLST
	IF(K.LT.EDGLFT)KT=EDGLFT
	IF(K.GT.EDGRT)KT=EDGRT
	IF(L.LT.EDGDW) KL=EDGDW
	IF(L.GT.EDGUP) KL=EDGUP
C   READ IN DL SLICES AND COMPUTE AVERAGE FROM SCRATCH
	DO    LL=1,DL
	LSTART=(LL-1)*NSAM*NROW
	DO    JJ=1,NROW
	NL=MOD(LL-1,DL)*NROW+JJ
	NI=LSTART+(JJ-1)*NSAM
        CALL  REDLIN(LUN1,X(NI+1),NSAM,NL)
	ENDDO
	ENDDO
C
	DO  LL=KL-HDL,KL+HDL
	LSTART=MOD(LL-1,DL)*NSAM*NROW
	DO  JJ=JT-HDR,JT+HDR
	NI=LSTART+(JJ-1)*NSAM
	DO  KK=KT-HDS,KT+HDS
	XAVG=XAVG+X(NI+KK)
	ENDDO
	ENDDO
	ENDDO
	XAVG=XAVG/FLOAT(DR*DS*DL)
	RETURN
C
C  MOVE RT ONE PIXEL, UPDATE XAVG
2000	JT=J
	LT=L
	IF(K.LE.EDGLFT.OR.K.GT.EDGRT)RETURN
	IF(J.LT.EDGFST)JT=EDGFST
	IF(J.GT.EDGLST)JT=EDGLST
	IF(L.LT.EDGDW) LT=EDGDW
	IF(L.GT.EDGUP) LT=EDGUP
	CORECT=0.
	DO    LL=LT-HDL,LT+HDL
	LSTART=MOD(LL-1,DL)*NROW*NSAM
	DO  JJ=JT-HDR,JT+HDR
	NI=LSTART+(JJ-1)*NSAM
	CORECT=CORECT+X(NI+K+HDS)-X(NI+K-HDS-1)
	ENDDO
	ENDDO
	XAVG=CORECT/FLOAT(DR*DS*DL)+XAVG
	RETURN
C	MOVE LEFT ONE PIXEL UPDATE XAVG
3000	JT=J
	LT=L
	IF(K.LT.EDGLFT.OR.K.GE.EDGRT)RETURN
	IF(J.LT.EDGFST)JT=EDGFST
	IF(J.GT.EDGLST)JT=EDGLST
	IF(L.LT.EDGDW) LT=EDGDW
	IF(L.GT.EDGUP) LT=EDGUP
	CORECT=0.
	DO    LL=LT-HDL,LT+HDL
	LSTART=MOD(LL-1,DL)*NROW*NSAM
	DO  JJ=JT-HDR,JT+HDR
	NI=LSTART+(JJ-1)*NSAM
	CORECT=CORECT+X(NI+K-HDS)-X(NI+K+HDS+1)
	ENDDO
	ENDDO
	XAVG=CORECT/FLOAT(DR*DS*DL)+XAVG
	RETURN
C  J INCREMENTED ONE
4000	IF(J.LE.EDGFST.OR.J.GT.EDGLST)RETURN
	LT=L
	KT=K
	IF(K.LT.EDGLFT)KT=EDGLFT
	IF(K.GT.EDGRT)KT=EDGRT
	IF(L.LT.EDGDW) LT=EDGDW
	IF(L.GT.EDGUP) LT=EDGUP
	CORECT=0.
	DO    LL=LT-HDL,LT+HDL
	LSTART=MOD(LL-1,DL)*NROW*NSAM
	DO  KK=KT-HDS,KT+HDS
	NI=LSTART+KK+(J-HDR-2)*NSAM
	NO=LSTART+KK+(J-1+HDR)*NSAM
	CORECT=CORECT+X(NO)-X(NI)
	ENDDO
	ENDDO
	XAVG=XAVG+CORECT/FLOAT(DS*DR*DL)
	RETURN
C  J DECREMENTED ONE
5000	IF(J.LT.EDGFST.OR.J.GE.EDGLST)RETURN
	LT=L
	KT=K
	IF(K.LT.EDGLFT)KT=EDGLFT
	IF(K.GT.EDGRT)KT=EDGRT
	IF(L.LT.EDGDW) LT=EDGDW
	IF(L.GT.EDGUP) LT=EDGUP
	CORECT=0.
	DO    LL=LT-HDL,LT+HDL
	LSTART=MOD(LL-1,DL)*NROW*NSAM
	DO  KK=KT-HDS,KT+HDS
	NI=LSTART+KK+(J+HDR)*NSAM
	NO=LSTART+KK+(J-HDR-1)*NSAM
	CORECT=CORECT+X(NO)-X(NI)
	ENDDO
	ENDDO
	XAVG=XAVG+CORECT/FLOAT(DS*DR*DL)
	RETURN
C L INCREMENTED ONE
6000	IF(L.LE.EDGDW.OR.L.GT.EDGUP)  RETURN
	JT=J
	IF(J.LT.EDGFST)JT=EDGFST
	IF(J.GT.EDGLST)JT=EDGLST
	KT=K
	IF(K.LT.EDGLFT)KT=EDGLFT
	IF(K.GT.EDGRT)KT=EDGRT
	CORECT=0.0
	LOLD=L-HDL-1
	LSTART=MOD(LOLD-1,DL)*NSAM*NROW
	DO    JJ=JT-HDR,JT+HDR
	NI=(JJ-1)*NSAM+LSTART
	DO  KK=KT-HDS,KT+HDS
	CORECT=CORECT-X(NI+KK)
	ENDDO
	ENDDO
C
	DO    JJ=1,NROW
	NL=L*NROW+JJ
	NI=LSTART+(JJ-1)*NSAM
        CALL  REDLIN(LUN1,X(NI+1),NSAM,NL)
	ENDDO
C
	DO    JJ=JT-HDR,JT+HDR
	NI=(JJ-1)*NSAM+LSTART
	DO  KK=KT-HDS,KT+HDS
	CORECT=CORECT+X(NI+KK)
	ENDDO
	ENDDO
	XAVG=XAVG+CORECT/FLOAT(DS*DR*DL)
	RETURN
	END
