
C
C                                      LONG FILE NAMES JAN 23 89 al
c
C **************************************************************************
C
C COMPUTES BACK-PROJECTION FROM PROJECTION ARRAY, USING
C ARBITRARY DIRECTIONS. BASED ON MICHAEL RADERMACHER'S PROJECTION
C ALGORITHM. JF 11/07/83
C
C ***************************************************************************

	SUBROUTINE BPROJ3(LUN3,LUNP,MAXDIM,IER)

	COMMON ADUM(80),BUF(1)
	REAL DPO(3),DP(3),XP(2),X(3),DM(3,3),FF(2)

        CHARACTER *1  NULL
        CHARACTER *81 FILNAM
        COMMON /COMMUN/ FILNAM
	INTEGER   MAXDIM
	INCLUDE 'CMBLOCK.INC'
	DATA PI/3.14159265/
        NULL=CHAR(0)

	IER=1
	CALL FILERD(FILNAM,NLET,NULL,'THREED',IRTFLG)
        IF (IRTFLG .NE. 0) RETURN
	CALL OPENF(FILNAM,LUN3,NSAM,NROW,'OLD',NF,NSLICE)
	IF(NF.NE.2)GOTO 9300
	IF(IFORM.NE.3)GOTO 9100
C
	CALL FILERD(FILNAM,NLET,NULL,'PROJECT',IRTFLG)
        IF (IRTFLG .NE. 0) RETURN

	CALL OPENF(FILNAM,LUNP,NSAMP,NROWP,'OLD',NF,NDUM)
	IF(NF.NE.2)GOTO 9300
	IER=0

C*      NOV 87 al
C*	CALL REDLIN(LUNP,BUF,NSAM,0)
C*	CALL RDPRMT(FF,NN,BUF)
        NN = 2
        CALL GETANG(LUNP,NSAM,BUF,15,NN,FF,IRTFLG)
	PHIR=FF(1)*PI/180.
	THETAR=FF(2)*PI/180.

C FOLLOWING ARE INCREMENTS THAT WERE IN THE ORIGINAL PROGRAM
C ON THE SCALE OF THE OBJECT.
	DX=1.
	DY=1.
	DZ=1.
	DXP=1.
	DYP=1.

	DP(1)=FLOAT(NSAMP)/2.
	DP(2)=FLOAT(NROWP)/2.
	DPO(1)=FLOAT(NSAM)/2.
	DPO(2)=FLOAT(NROW)/2.
	DPO(3)=FLOAT(NSLICE)/2.

	NPTOT=NSAMP*NROWP
	NOFF=MAX0(NSAMP,NSAM)
C CALCULATE THE DIRECTION OF PROJECTION AND PROJECTION PLANE.

	CPHI=COS(PHIR)
	SPHI=SIN(PHIR)
	CTHE=COS(THETAR)
	STHE=SIN(THETAR)
	DM(1,1)=CPHI*CTHE
	DM(2,1)=SPHI*CTHE
	DM(3,1)=-STHE
	DM(1,2)=-SPHI
	DM(2,2)=CPHI
	DM(3,2)=0.0
	DM(1,3)=CPHI*STHE
	DM(2,3)=SPHI*STHE
	DM(3,3)=CTHE
	WRITE(NOUT,11)(DM(I,3),I=1,3)
11	FORMAT(' ** DIRECTION OF PROJECTION : ',3F8.3)

C ********* FIRST PASS TO COMPUTE PROJECTION AND WEIGHT ARRAY ********

C INITIALIZE WEIGHT ARRAY

	DO  K=1,NPTOT
	BUF(NOFF+NPTOT+K)=-1.E-37
	ENDDO

C COMPUTATION OF THE PROJECTION POINT

	X(3)=-DZ
	DO  I1=1,NSLICE
	X(3)=X(3)+DZ
	X(2)=-DY

	DO  I2=1,NROW
	X(2)=X(2)+DY
	X(1)=-DX
	IROW=(I1-1)*NROW+I2
	CALL REDLIN(LUN3,BUF,NSAM,IROW)

	DO 15 I3=1,NSAM
	X(1)=X(1)+DX
	XP(1)=0.0
	XP(2)=0.0

	DO  I4=1,3
	XP(1)=XP(1)+(X(I4)-DPO(I4))*DM(I4,1)
	XP(2)=XP(2)+(X(I4)-DPO(I4))*DM(I4,2)
	ENDDO
	XP(1)=XP(1)+DP(1)
	XP(2)=XP(2)+DP(2)
	IF(XP(1).LT.DXP  .OR.  XP(1).GT.NSAMP-DXP  .OR.  XP(2).LT.DYP
     1                .OR.  XP(2).GT.NROWP-DYP) GOTO 15

	ZWX=XP(1)
C	ZWX=XP(1)/DXP
	ZWY=XP(2)
C	ZWY=XP(2)/DYP
	IPX=IFIX(ZWX)
	IPY=IFIX(ZWY)
	DIPX=ZWX-FLOAT(IPX)
	DIPY=ZWY-FLOAT(IPY)

	NRUN=0
	W=BUF(I3)
	INDP=IPX+1+IPY*NSAMP +NOFF
12	NRUN=NRUN+1
	BUF(INDP)=BUF(INDP)+(1.0-DIPX)*(1.0-DIPY)*W
	BUF(INDP+1)=BUF(INDP+1)+DIPX*(1.0-DIPY)*W
	INDP=INDP+NSAMP
	BUF(INDP)=BUF(INDP)+(1.0-DIPX)*DIPY*W
	BUF(INDP+1)=BUF(INDP+1)+DIPX*DIPY*W

C FIRST CYCLE (NRUN=1) STORES PROJECTION VALUES,
C SECOND CYCLE (NRUN=2) STORES WEIGHTS.
	W=1.
	INDP=INDP+NPTOT-NSAMP
	GOTO (12,15),NRUN
15	CONTINUE
	ENDDO
	ENDDO

C NOW READ PROJECTION ARRAY AND COMPUTE DIFFERENCES
	ERR=0
	ERR2=0
	NPT=0
	DO  I=1,NROWP
	INDP=(I-1)*NSAMP+1+NOFF
	INDW=INDP+NPTOT
	CALL REDLIN(LUNP,BUF,NSAMP,I)
	DO 35 K=1,NSAMP
	W=BUF(INDW+K-1)
	IF(W.LT.0.)GOTO 35
	BS=(BUF(INDP+K-1)-BUF(K))/W
	ERR=ERR+ABS(BS)
	ERR2=ERR2+BS**2
	NPT=NPT+1
	BUF(INDP+K-1)=BS
35	CONTINUE
	ENDDO

C PUT NORMALIZED ERRORS INTO REGISTERS
	ERR=ERR/(FLOAT(NPT))
	ERR2=SQRT(ERR2/FLOAT(NPT))
	PARAM(NSEL(1))=ERR
	PARAM(NSEL(2))=ERR2

C ************ APPLY DIFFFERENCES TO 3-D ARRAY  ******************

	X(3)=-DZ
	DO  I1=1,NSLICE
	X(3)=X(3)+DZ
	X(2)=-DY

	DO  I2=1,NROW
	X(2)=X(2)+DY
	X(1)=-DX
	IROW=(I1-1)*NROW+I2
	CALL REDLIN(LUN3,BUF,NSAM,IROW)
C
	DO 115 I3=1,NSAM
	X(1)=X(1)+DX
	XP(1)=0.0
	XP(2)=0.0
C
	DO  I4=1,3
	XP(1)=XP(1)+(X(I4)-DPO(I4))*DM(I4,1)
	XP(2)=XP(2)+(X(I4)-DPO(I4))*DM(I4,2)
	ENDDO
	XP(1)=XP(1)+DP(1)
	XP(2)=XP(2)+DP(2)
	IF(XP(1).LT.DXP  .OR.  XP(1).GT.NSAMP-DXP  .OR.  XP(2).LT.DYP
     1                .OR.  XP(2).GT.NROWP-DYP) GOTO 115
C
	ZWX=XP(1)
C	ZWX=XP(1)/DXP
	ZWY=XP(2)
C	ZWY=XP(2)/DYP
	IPX=IFIX(ZWX)
	IPY=IFIX(ZWY)
	DIPX=ZWX-FLOAT(IPX)
	DIPY=ZWY-FLOAT(IPY)
C
	INDP=IPX+1+IPY*NSAMP +NOFF
	BUF(I3)=BUF(I3) - ( (1.0-DIPX)*(1.0-DIPY)*BUF(INDP)
     1                 + DIPX*(1.0-DIPY)*BUF(INDP+1)
     2                 + DIPX*DIPY*BUF(INDP+1+NSAMP)
     3                 + (1.0-DIPX)*DIPY*BUF(INDP+NSAMP) )

115	CONTINUE

	CALL WRTLIN(LUN3,BUF,NSAM,IROW)

	ENDDO
120	CONTINUE
	ENDDO
	CLOSE(LUN3)
	CLOSE(LUNP)
	RETURN

9100	CALL ERRT(2,'BPROJ3',NE)
	RETURN
9300	CALL ERRT(4,'BPROJ3',NE)
	END
