
#ifdef SP_DISTRIB 
 
C   THIS ROUTINE SPECIFIC TO WADSWORTH LABS AND IS NOT 
C       DISTRIBUTED TO OUTSIDE SITES
 
       SUBROUTINE bproj4
 
       COMMON /UNITS/LUNC,NIN,NOUT
 
       WRITE(NOUT,*) 'DUMMY CALL: bproj4'
       RETURN
       END
 
#else
 

C                                     LONG FILENAMES JAN 89 al
C *********************************************************************
C
C COMPUTES BACK-PROJECTION FROM PROJECTION ARRAY, USING
C ARBITRARY DIRECTIONS. BASED ON MICHAEL RADERMACHER'S PROJECTION
C ALGORITHM. JF 11/07/83
C 1/17/85 JF VERSION FOR SIMULTANEOUS BACK-PROJECTION
C
C ***********************************************************************

	SUBROUTINE BPROJ4(LUN3,LUNP,MAXDIM,IER)

	PARAMETER (MAXP=50)
	COMMON ADUM(80),BUF(1)
	REAL DPO(3),DP(3),XP(2),X(3),DM(3,3,MAXP),FF(2)
	CHARACTER *81 FILNAM
        CHARACTER *1  NULL
        COMMON /COMMUN/ FILNAM 
	INTEGER   MAXDIM,NOFFP,NOFFE,NOFFW,INDP,INDW,INDE,NPTOT
	INTEGER   NOFF,NPT

#ifdef SP_UNIX
	INCLUDE 'CMBLOCK.INC'
#else
	INCLUDE 'COMMON1:CMBLOCK.INC'
#endif

	DATA PI/3.14159265/

        NULL=CHAR(0)

	IER=1
	CALL RDPRM(EPS,NLOOP,ILOOP,'WEIGHT THRESHOLD')
	CALL FILERD(FILNAM,NLET,NULL,'THREED',IRTFLG)
	IF(IRTFLG .NE. 0)RETURN
	CALL OPENF(FILNAM,LUN3,NSAM,NROW,'OLD',NF,NSLICE)
	IF(NF.NE.2)GOTO 9300
	IF(IFORM.NE.3)GOTO 9100
C
C
C READ AND OPEN FIRST FILE TO FIND DIMENSIONS
	CALL FILERD(FILNAM,NLET,NULL,'PROJECT',IRTFLG)
	IF(IRTFLG .NE. 0)RETURN
	CALL OPENF(FILNAM,LUNP,NSAMP,NROWP,'OLD',NF,NDUM)
	IF(NF.NE.2)GOTO 9300	
	IF(IFORM.NE.1)GOTO 9100
	NSAMP1=NSAMP
	NROWP1=NROWP
C FOLLOWING PROJECTIONS CHECKED AGAINST THIS ONE
C
C
C FOLLOWING ARE INCREMENTS THAT WERE IN THE ORIGINAL PROGRAM
C ON THE SCALE OF THE OBJECT.
	DX=1.
	DY=1.
	DZ=1.
	DXP=1.
	DYP=1.
C
	DP(1)=FLOAT(NSAMP)/2.
	DP(2)=FLOAT(NROWP)/2.
	DPO(1)=FLOAT(NSAM)/2.
	DPO(2)=FLOAT(NROW)/2.
	DPO(3)=FLOAT(NSLICE)/2.
C
	NPTOT=NSAMP*NROWP
	NOFF=MAX0(NSAMP,NSAM)
C
C NOW READ FILENAME AND OPEN SECOND AND FOLLOWING FILES
C UNTIL ESCAPE ('*') IS ENCOUNTERED
	NPROJ=1
	GOTO 910
C
900	CALL FILERD(FILNAM,NLET,NULL,'PROJECT',IRTFLG)
	IF(IRTFLG .NE. 0)GOTO 50
	CALL OPENF(FILNAM,LUNP,NSAMP,NROWP,'OLD',NF,NDUM)
	IF(NF.NE.2)GOTO 9300
	IF(IFORM.NE.1)GOTO  9100
	IF(NSAMP.NE.NSAMP1.OR.NROWP.NE.NROWP1)GOTO 9500
	NPROJ=NPROJ+1
	IF (NPROJ .GT. MAXP) then
           CALL ERRT(28,'BPROJ4',NE)
           RETURN
        ENDIF

	IER=0

910     NN = 2
        CALL GETANG(LUNP,NSAMP,BUF,15,NN,FF,IRTFLG)

	PHIR=FF(1)*PI/180.
	THETAR=FF(2)*PI/180.
C ***********************************************


C CALCULATE THE DIRECTION OF PROJECTION AND PROJECTION PLANE.

	CPHI=COS(PHIR)
	SPHI=SIN(PHIR)
	CTHE=COS(THETAR)
	STHE=SIN(THETAR)
	DM(1,1,NPROJ)=CPHI*CTHE
	DM(2,1,NPROJ)=SPHI*CTHE
	DM(3,1,NPROJ)=-STHE
	DM(1,2,NPROJ)=-SPHI
	DM(2,2,NPROJ)=CPHI
	DM(3,2,NPROJ)=0.0
	DM(1,3,NPROJ)=CPHI*STHE
	DM(2,3,NPROJ)=SPHI*STHE
	DM(3,3,NPROJ)=CTHE
	WRITE(NOUT,11)(DM(I,3,NPROJ),I=1,3)
11	FORMAT(' ** DIRECTION OF PROJECTION : ',3F8.3)

C BUFFER ADDRESS OFFSET FOR MODEL PROJECTION DATA = NOFFP
C OFFSET FOR EXPERIMENTAL PROJECTION DATA = NOFFE

	NOFFP=NOFF+(NPROJ-1)*NPTOT*(3)
	NOFFW=NOFFP+NPTOT
	NOFFE=NOFFP+NPTOT*(2)

C INITIALIZE WEIGHT ARRAY
	DO 80 K=1,NPTOT
80	BUF(NOFFW+K)=-1.E-37
C
C NOW READ PROJECTION INTO BUFFER

	DO 90 I=1,NROWP
	N1=(I-1)*NSAMP+1
90	CALL REDLIN(LUNP,BUF(NOFFE+N1),NSAMP,I)
C
	CLOSE(UNIT=LUNP)
	GOTO 900


C ********* FIRST PASS TO COMPUTE PROJECTION AND WEIGHT ARRAY ********

50	FN=1./FLOAT(NPROJ)


C COMPUTATION OF THE PROJECTION POINT

	X(3)=-DZ
	DO 250 I1=1,NSLICE
	X(3)=X(3)+DZ
	X(2)=-DY

	DO 200 I2=1,NROW
	X(2)=X(2)+DY
	X(1)=-DX
	IROW=(I1-1)*NROW+I2
	CALL REDLIN(LUN3,BUF,NSAM,IROW)

	DO 150 I3=1,NSAM
	X(1)=X(1)+DX

	DO 130 IPROJ=1,NPROJ
	NOFFP=NOFF+(IPROJ-1)*NPTOT*(3)
	XP(1)=0.
	XP(2)=0.
	DO 100 I4=1,3
	XP(1)=XP(1)+(X(I4)-DPO(I4))*DM(I4,1,IPROJ)
100	XP(2)=XP(2)+(X(I4)-DPO(I4))*DM(I4,2,IPROJ)
	XP(1)=XP(1)+DP(1)
	XP(2)=XP(2)+DP(2)
	IF(XP(1).LT.DXP  .OR.  XP(1).GT.NSAMP-DXP  .OR.  XP(2).LT.DYP
     1                .OR.  XP(2).GT.NROWP-DYP) GOTO 130

	ZWX=XP(1)
	ZWY=XP(2)
	IPX=IFIX(ZWX)
	IPY=IFIX(ZWY)
	DIPX=ZWX-FLOAT(IPX)
	DIPY=ZWY-FLOAT(IPY)

	NRUN=0
	W=BUF(I3)
	INDP=(IPX+1)+(IPY*NSAMP) +NOFFP
120	NRUN=NRUN+1
	BUF(INDP)=BUF(INDP)+(1.0-DIPX)*(1.0-DIPY)*W
	BUF(INDP+1)=BUF(INDP+1)+DIPX*(1.0-DIPY)*W
	INDP=INDP+(NSAMP)
	BUF(INDP)=BUF(INDP)+(1.0-DIPX)*DIPY*W
	BUF(INDP+1)=BUF(INDP+1)+DIPX*DIPY*W

C FIRST CYCLE (NRUN=1) STORES PROJECTION VALUES,
C SECOND CYCLE (NRUN=2) STORES WEIGHTS.
	W=1.
	INDP=INDP+NPTOT-(NSAMP)
	GOTO (120,130),NRUN
130	CONTINUE
150	CONTINUE
200	CONTINUE
250	CONTINUE

C NOW COMPUTE DIFFERENCES BETWEEN EXPERIMENTAL AND MODEL PROJ

C ERROR VARIABLES INITIALIZATION
	ERRP=0
	ERR2P=0
	DO 500 IPROJ=1,NPROJ
	NPT=0
	ERR=0
	ERR2=0
	NOFFP=NOFF+(IPROJ-1)*NPTOT*(3)
	DO 400 I=1,NROWP
	INDP=((I-1)*NSAMP+1)+NOFFP
	INDW=INDP+NPTOT
	INDE=INDW+NPTOT
	DO 350 K=1,NSAMP
	W=BUF(INDW+K-1)
	IF(W.LE.EPS)GOTO 350
C	WRITE(NOUT,9999)IPROJ,I,K,BUF(INDP+K-1),BUF(INDE+K-1),W
C9999	FORMAT(1X,3I4,3E12.8)
	BS=(BUF(INDP+K-1)-BUF(INDE+K-1))/W
	NPT=NPT+1
	ERR=ERR+ABS(BS)
	ERR2=ERR2+BS**2
	BUF(INDP+K-1)=BS
350	CONTINUE
400	CONTINUE
	IF(NPT.EQ.0)GOTO 500
	ERRP=ERRP+ERR/FLOAT(NPT)
	ERR2P=ERR2P+ERR2/FLOAT(NPT)
500	CONTINUE

C ************ APPLY DIFFFERENCES TO 3-D ARRAY  ******************

	X(3)=-DZ
	DO 1250 I1=1,NSLICE
	X(3)=X(3)+DZ
	X(2)=-DY

	DO 1200 I2=1,NROW
	X(2)=X(2)+DY
	X(1)=-DX
	IROW=(I1-1)*NROW+I2
	CALL REDLIN(LUN3,BUF,NSAM,IROW)

	DO 1150 I3=1,NSAM
	X(1)=X(1)+DX

C PROJECT POINT INTO ALL DIRECTIONS
	DIFF=0
	DO 1100 IPROJ=1,NPROJ
	NOFFP=NOFF+(IPROJ-1)*NPTOT*(3)
	XP(1)=0.
	XP(2)=0.
	DO 1000 I4=1,3
	XP(1)=XP(1)+(X(I4)-DPO(I4))*DM(I4,1,IPROJ)
1000	XP(2)=XP(2)+(X(I4)-DPO(I4))*DM(I4,2,IPROJ)
	XP(1)=XP(1)+DP(1)
	XP(2)=XP(2)+DP(2)
	IF(XP(1).LT.DXP  .OR.  XP(1).GT.NSAMP-DXP  .OR.  XP(2).LT.DYP
     1                .OR.  XP(2).GT.NROWP-DYP) GOTO 1100
C
	ZWX=XP(1)
	ZWY=XP(2)
	IPX=IFIX(ZWX)
	IPY=IFIX(ZWY)
	DIPX=ZWX-FLOAT(IPX)
	DIPY=ZWY-FLOAT(IPY)
C
	INDP=(IPX+1+IPY*NSAMP)+NOFFP
	DIFF=DIFF + ( (1.0-DIPX)*(1.0-DIPY)*BUF(INDP)
     1                 + DIPX*(1.0-DIPY)*BUF(INDP+1)
     2                 + DIPX*DIPY*BUF(INDP+1+NSAMP)
     3                 + (1.0-DIPX)*DIPY*BUF(INDP+NSAMP) )
C
1100	CONTINUE
	BUF(I3)=BUF(I3)-DIFF*FN
1150	CONTINUE
C
	CALL WRTLIN(LUN3,BUF,NSAM,IROW)
C
1200	CONTINUE
1250	CONTINUE
	CLOSE(UNIT=LUN3)
	ERR2P=SQRT(ERR2P)
	WRITE(NOUT,1301)ERRP,ERR2P
	IF(NDAT.NE.NOUT) WRITE(NDAT,1301)ERRP,ERR2P
1301	FORMAT(' ** MEAN ABSOLUTE ERROR = ',F12.6/,
     1         '    MEAN SQUARED ERROR = ',F12.6)
	IF (NSEL(1).EQ.0) RETURN
	PARAM(NSEL(1))=ERRP
	IF (NSEL(2).EQ.0) RETURN
	PARAM(NSEL(2))=ERR2P
	RETURN

9100	CALL ERRT(2,'BPROJ4',NE)
	RETURN
9300	CALL ERRT(4,'BPROJ4',NE)
	RETURN
9500	CALL ERRT(1,'BPROJ4',NE)
	RETURN

	END
 
#endif
 
