
	SUBROUTINE BPS2(MAXMEM)

c  UNIX-Spider version
C  Reprojections 3D - slices, Richardson's method, 
c  reconstruction kept in the square to introduce other constraints.
c  Reconstruction from nrowl to nrowh.
c  Average outside the window is subtracted
c  min, max relate to the projections
c  Geometry  cylindrical
c  Simplified version
C                01/05/94

	PARAMETER  (NILMAX=93,NILMXX=560)
        INCLUDE 'CMBLOCK.INC' 
	COMMON  /F_SPEC/  FINPAT,FINPIC,NLET
	CHARACTER*80  FINPIC
	CHARACTER*80  FINPAT
	CHARACTER*1  NULL
	COMMON     DUMMY(80),BUF(1024),ILIST(NILMXX),
     A    NSAM,NROW,INANG,NN,NMAT,
     1	  LTB,LTBN,K_ANG,K_DM,K_LB,K_MAP,K_IPCUBE,
     2	  K_BCKE,K_PROJ,K_bckn,K_PRJE,K_SIGMA,
     3    KDM(7),
     4	  IUNIT,Q(1)
	COMMON /PAR/  LDPX,LDPY,LDPZ,LDPNMX,LDPNMY
	DOUBLE PRECISION  ABA

        DATA  INPIC/100/,IOFF/6/
CNO_SAVE

	NULL=CHAR(0)

C  N - linear dimension of projections and restored cube
C  NANG - number of angles (projections)
C
        write(nout,*)' Single-tilt iterative 3D reconstruction program'
	IUNIT=NOUT
 	CALL  FILERD(FINPAT,NLET,NULL,
     &	  'Enter template for 2-D image name',IRTFLG)
	CALL  FILERD(FINPic,NLETI,NULL,'Selection doc',IRTFLG)
	k=0
	k2=1
	NANG=0
778	LERR=-1
	IF (NANG.EQ.NILMAX)  THEN
		WRITE(NOUT,*) '  Too many images, list truncated'
		GOTO  779
	endif
	KP1=K+1
	CALL  UNSAV(FINPIC,K,INPIC,KP1,Q,1,LERR,K2)
	IF (LERR.EQ.0)  THEN
	   NANG=NANG+1
	   ILIST(NANG)=Q(1)
	   K=K+1
	   GOTO  778
	ENDIF
779	CLOSE(INPIC)

C  NANG - total number of images

	WRITE(NOUT,2001) NANG
2001	FORMAT('  Number of images =',i5)

C GET THE ANGLES

 	K_ANG=1
 	CALL  FILERD(FINPIC,NLETI,NULL,'Angular doc',IRTFLG)
	K2=1
        DO k=0,NANG-1
	LERR=-1
	CALL  UNSAV(FINPIC,K,INPIC,ILIST(k+1),BUF,2,LERR,K2)
	IF (LERR.EQ.0)  THEN
	   Q(K_ANG+k)=BUF(2)
        ELSE
           WRITE(NOUT,*)  ' Something wrong in the angular doc file'
           CLOSE(INPIC)
           RETURN
        ENDIF
	ENDDO
c 758    CONTINUE
	CLOSE(INPIC)

        CALL RDPRMI(IRI,NSLICE,NLOOP,ILOOP,
     &	   'Radius of reconstructed object, height of the slice')
        ri=iri
        CALL  RDPRMI(NROWL,NROWH,NLOOP,ILOOP,
     &	   'Reconstruction from nrow1 to nrow2')

C  Open all the projection files ....

	do    k=1,nang
 	CALL  FILGET(FINPAT,FINPIC,NLET,ILIST(k),INTFLG)
 	CALL  OPENFB(BUF,FINPIC,IOFF+K,NSAM,NROW,'O',NF,NSL)
 	IF (NF.NE.2)  THEN
	WRITE(NOUT,*) ' File not found'
	RETURN
	ENDIF
	enddo
c 77	continue

	IF(NROWL.LT.1.OR.NROWL.GT.NROW.OR.NROWH.LT.1.OR.NROWH.GT.NROW
     &		.OR.NROWL.GT.NROWH)  THEN
	NROWL=1
	NROWH=NROW
	ENDIF
	LCYL=NROWH-NROWL+1

	INANG=NANG

	LDPX=NSAM/2+1
	LDPY=NROW/2+1
	LDPZ=NSLICE/2+1
	LDPNMX=NSAM/2+1
	LDPNMY=NROW/2+1

 	K_DM=IPALIGN64(K_ANG+NANG)
	K_LB=IPALIGN64(K_DM+9*NANG)
	K_MAP=K_LB
	K_IPCUBE=K_MAP

	CALL  PREPSL_S(NSAM,NSLICE,NN,NMAT,Q(K_IPCUBE),RI)
c!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
	nmat=nsam*nslice
C
	K_PROJ=IPALIGN64(K_IPCUBE+5*NN)

        K_X=IPALIGN64(K_PROJ+Nsam*NANG)
        K_IBN=K_X

	MEMTOT=K_IBN
C	MEMTOT=IPALIGN64(K_IBN+NANG*N*N)
	IF(MEMTOT.GT.MAXMEM)  THEN
	WRITE(NOUT,1001)  MEMTOT
	WRITE(NOUT,1002)  MAXMEM
	GOTO 9999
	ENDIF
C  LTB  will be found in READPRO = NANG*Nsam*Nrow
C
	CALL  REDPRO2(NSAM,NROWL,NROWH,NANG,
     1	Q(K_PROJ),Q(K_ANG),LTB,LTBN,ILIST,Q(K_IPCUBE),NN,Q(K_DM),
     2	RI,aba,NOUT)
C
	K_PRJE=IPALIGN64(K_PROJ+LTB)
C In this version sigma is assumed to be proprotional to PROJ
C and the corresponding array is not used anywhere.
	K_SIGMA=K_PRJE
C	K_SIGMA=K_PRJE+LTB 
c ltbn = nsam*nang
	K_BCKE=IPALIGN64(K_prje+LTBN)
	k_bckn=IPALIGN64(k_bcke+nmat*3)
        K_CB=K_bcke
	MEMTOT=IPALIGN64(k_bckn+nmat)
	WRITE(NOUT,1001)  MEMTOT
1001	FORMAT(//'  Reprojection program for 3-D back-projection',/,
     1     '           Memory needed - ',I8,/)
	IF (MEMTOT.GT.MAXMEM)  THEN
	   WRITE(NOUT,1002)  MAXMEM
1002	   FORMAT('  Sorry, your buffer length is only',I9,/,
     1      '  Program cannot be run')
	   GOTO 9999
	ENDIF
C
	CALL  FILERD(FINPAT,NLETI,NULL,'3-D output',ITRFLG)
	IF(IRTFLG.EQ.-1)  GOTO 9999
	IFORM=3
 	CALL  OPENFB(BUF,FINPAT,INPIC,NSAM,LCYL,'UNKNOWN',NF,NSLICE)
	IF(NF.NE.2)  GOTO 9999
C
	CALL  REPR2_S
     1	  (Q(K_BCKE),Q(K_BCKN),NSAM,LCYL,NSLICE,NROWL,NROWH,NANG,
     2     Q(K_IPCUBE),NN,Q(K_PROJ),Q(K_PRJE),
     3		IRI,LTB,LTBN,ABA,INPIC)
	CLOSE(INPIC)
 
c close all the projection files ...

	DO    K=1,NANG
	CLOSE(IOFF+K)
	ENDDO
C
9999	CONTINUE
	END
