
C++************************************************************************
C
C BPWR.FOR
C
C **************************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK            *
C *  COPYRIGHT (C)1981,1987, WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *  THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR       *
C *  LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR    *
C *  USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF     *
C *  THE CENTER FOR LABORATORIES AND RESEARCH   			   *
C **************************************************************************
C
C BPWR.FOR
C R**2 weighting,                             03/04/92
C
C23456789012345678901234567890123456789012345678901234567890123456789012
C--************************************************************************

         SUBROUTINE BPWR(MAXMEM)
         INCLUDE 'CMBLOCK.INC'
         CHARACTER*80      FINPAT,FINPIC,FOUT
         COMMON  /F_SPEC/  FINPAT,FINPIC,FOUT,NLET,NLOT

         PARAMETER  (NILMAX=2000)
         COMMON     DUMMY(80),BUF(1024),ILIST(NILMAX),Q(1)

         CHARACTER * 1  NULL

         DATA  INPIC/99/
CNO_SAVE
         NULL = CHAR(0)

         CALL  FILERD(FINPAT,NLET,NULL,
     &      'Enter template for 2-D image name',IRTFLG)
         CALL  FILERD(FOUT,NLOT,NULL,
     &      'Enter template for 2-D output image',IRTFLG)
         CALL  FILERD(FINPIC,NLETI,NULL,'Selection doc',IRTFLG)
         CALL  RDPRM(FM,NLOOP,ILOOP,
     &      'Cut-off frequency of Parzen filter')
         K    = 0
         K2   = 1
         NANG = 0
778      LERR = -1
         IF(NANG.EQ.NILMAX)  THEN
            WRITE(NOUT,*) '*** Too many images, list truncated'
            GOTO  779
         ENDIF

         KP1 = K+1
         CALL  UNSAV(FINPIC,K,INPIC,KP1,Q,1,LERR,K2)
         IF (LERR.EQ.0)  THEN
            NANG = NANG+1
            ILIST(NANG)=Q(1)
            K=K+1
            GOTO  778
         ENDIF

779      CLOSE(INPIC)
         WRITE(NOUT,2001) NANG
2001     FORMAT('  Number of images =',I5)
         CALL  FILGET(FINPAT,FINPIC,NLET,ILIST(1),INTFLG)
         CALL  OPENFB(BUF,FINPIC,INPIC,NSAM,NROW,'O',NF,NSL)
         IF (NF .NE. 2)  THEN
            WRITE(NOUT,*) '*** File not found'
            RETURN
         ENDIF
         CLOSE(INPIC)

         N2S = 2*NSAM
         N2R = 2*NROW

         K1     = 1
         K2     = K1+N2R*(N2S+2)
         MEMTOT = K2+N2R*(N2S+2)
	IF(FM.GE.0.0)  THEN
         WRITE(NOUT,1001)  MEMTOT,N2S,N2R
1001     FORMAT(//'  R**2 weighting of 2D images',/,
     1   '  Memory needed - ',I8,/,
     2   '  Dimensions used:',2I8,/)
	ELSE
         WRITE(NOUT,1003)  MEMTOT,N2S,N2R
1003     FORMAT(//'  R*   weighting of 2D images',/,
     1   '  Memory needed - ',I8,/,
     2   '  Dimensions used:',2I8,/)
	ENDIF
         IF (MEMTOT.GT.MAXMEM)  THEN
            WRITE(NOUT,1002)  MAXMEM
1002        FORMAT('  Sorry, your buffer length is only',I9,/,
     1             '  Program cannot be run')
            RETURN
         ENDIF

         CALL  BPWR_Q(BUF,Q(K1),Q(K2),FM,ILIST,NANG,N2S,N2R,NSAM,NROW)
         END
