C++************************************************************************
C
C $$ BPWR_Q.FOR
C
C **************************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK            *
C *  COPYRIGHT (C)1981,1987, WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *  THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR       *
C *  LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR    *
C *  USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF     *
C *  THE CENTER FOR LABORATORIES AND RESEARCH   			   *
C **************************************************************************
C
C
C
C23456789012345678901234567890123456789012345678901234567890123456789012
C--************************************************************************
C
C $$ BPWR_Q.FOR
C
         SUBROUTINE  BPWR_Q(BUF,B,W,FM,ILIST,NANG,N2S,N2R,NSAM,NROW)
         DIMENSION   B(N2S+2,N2R),W(N2S+2,N2R)
         DOUBLE PRECISION  AVE
         INCLUDE 'CMBLOCK.INC'
         DIMENSION  ILIST(NANG),BUF(1024)
         COMMON  /F_SPEC/  FINPAT,FINPIC,FOUT,NLET,NLOT
         CHARACTER*80  FINPAT,FINPIC,FOUT
         DATA  LUNI/99/
CNO_SAVE
C
         NS2=N2S/2
         NR2=N2R/2
         X1=FLOAT(NS2)**2
         Y1=FLOAT(NR2)**2
C
C  Prepare weighting function R**2
C
         DO    J=1,N2R
         IY=J-1
         IF(IY.GT.NR2)  IY=IY-N2R
         DO    I=1,N2S+2,2
         IX=(I-1)/2
	IF(FM.GE.0.0)  THEN
         FQ=0.25*(FLOAT(IX*IX)/X1+FLOAT(IY*IY)/Y1)
	ELSE
         FQ=0.5*SQRT(FLOAT(IX*IX)/X1+FLOAT(IY*IY)/Y1)
	ENDIF
         W(I,J)=FQ
         W(I+1,J)=FQ
	 ENDDO
	 ENDDO
         W(1,1)=1.0
         W(2,1)=1.0
C
C  Parzen filter
C
	FM=ABS(FM)
	IF(.NOT.(FM.EQ.0.0.OR.FM.EQ.1.0))  THEN
	DO    J=1,N2R
	IY=J-1
	IF(IY.GT.NR2)  IY=IY-N2R
	DO    I=1,N2S+2,2
	IX=(I-1)/2
	FQ=0.5*SQRT(FLOAT(IX*IX)/X1+FLOAT(IY*IY)/Y1)
	PARZ=0.0
	IF(FQ.LE.FM)  THEN
	IF(FQ.LE.FM/2.0)  THEN
	PARZ=1.0-6.0*(FQ/FM)**2*(1.0-FQ/FM)
	ELSE
	PARZ=2.0*(1.0-FQ/FM)**3
	ENDIF
	ENDIF
	W(I,J)=W(I,J)*PARZ
	W(I+1,J)=W(I+1,J)*PARZ
	ENDDO
	ENDDO
	ENDIF
C --
         DO  2202  K=1,NANG
C Read one projection
         CALL  FILGET(FINPAT,FINPIC,NLET,ILIST(K),INTFLAG)
         CALL  OPENFB(BUF,FINPIC,LUNI,LSAM,LROW,'O',NF,NSL)
         IF(NF.NE.2)  THEN
         WRITE(NOUT,2032)  FINPIC
2032     FORMAT(' File skipped ',A80)
         GOTO  2202
         ENDIF
C
C  READ  IMAGE
C
         DO    I=1,NROW
         CALL  REDLIN(LUNI,B(1,I),NSAM,I)
  	 ENDDO
       CLOSE(LUNI)
C
C  Padding with border average
C
         IF(N2S.NE.NSAM.AND.N2R.NE.NROW)  THEN
         AVE=0.0
         DO    J=1,NROW
         AVE=AVE+B(NSAM,J)
         AVE=AVE+B(1,J)
   	 ENDDO
	 DO    I=1,NSAM
         AVE=AVE+B(I,1)
         AVE=AVE+B(I,NROW)
	 ENDDO
         AVE=AVE/(2*FLOAT(NSAM)+2*FLOAT(NROW))
         DO    J=1,N2R
         DO    I=NSAM+1,N2S
         B(I,J)=AVE
	 ENDDO
	 ENDDO
         DO    J=NROW+1,N2R
         DO    I=1,NSAM
         B(I,J)=AVE
	 ENDDO
	 ENDDO
         ENDIF
C
	INV=+1
	CALL  FMRS_2(B,N2S,N2R,INV)
C
C  Apply filter
C
c$doacross local(i,j)
         DO    J=1,N2R
         DO    I=1,N2S+2
         B(I,J)=B(I,J)*W(I,J)
	 ENDDO
	 ENDDO
C
	INV=-1
	CALL  FMRS_2(B,N2S,N2R,INV)
C
C  WRITE  IMAGE
C
         CALL  FILGET(FOUT,FINPIC,NLOT,ILIST(K),INTFLAG)
         CALL  OPENFB(BUF,FINPIC,LUNI,LSAM,LROW,'UNKNOWN',NF,NSL)
         DO    I=1,NROW
         CALL  WRTLIN(LUNI,B(1,I),NSAM,I)
	 ENDDO
         CLOSE(LUNI)
2202     CONTINUE
         END
