
C++**************************************************************1/11/82  VAX
C
C    CAMAP.FOR                                 LONG FILE NAMES JAN 89 al
C
C **********************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.    AUTHOR: J.FRANK      *
C *  COPYRIGHT (C)1985, 1996 HEALTH RESEARCH INCORPORATED, ALBANY, NY. *
C * THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO HEALTH            *
C * RESEARCH INC. AND ARE NOT TO BE DISCLOSED TO OTHERS OR USED        *
C * FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF       *
C * HEALTH RESEARCH INC.                                               *
C **********************************************************************
C
C       CAMAP(LUN,OPTIN)
C
C 	SUBROUTINE TO MAKE A SMALL (80 CHAR) MAP FROM CLUSTER FILE FOR 
C 	TERMINAL DISPLAY OR A CORRECTLY SCALED MAP FOR LINE PRINTER
C	DISPLAY.
C
C--************************************************************************

	SUBROUTINE CAMAP(LUN,OPTIN)

        INCLUDE 'CMBLOCK.INC'
CNO_SAVE

        PARAMETER      (NPART=400)
        CHARACTER *81  FILNAM
        CHARACTER *108 PRINT
        CHARACTER *4   CODE(NPART)
        COMMON/COMMUN/ FILNAM,PRINT,CODE

        COMMON         VAR(NPART), RAVG(NPART)
	DIMENSION      X(NPART),   Y(NPART)
	EQUIVALENCE    (X,VAR),(Y,RAVG)

        CHARACTER *(*) OPTIN
        CHARACTER *8   MULT
        CHARACTER *4   DUM
        CHARACTER      NULL,OPTT,ANS,CHR
	REAL           NCOO(10)

	DATA MULT/'01234567'/

        NULL   = CHAR(0)
	PRATIO = 21./35.

	OPTT   = OPTIN(1:1)
	IF (OPTIN(2:2) .EQ. 'T') THEN
		NPRINT=NOUT
		NXFUL=68
		NYFUL=22
	ELSE
		NPRINT=NDAT
		NXFUL=100
C               NYFUL=52
	ENDIF
	CALL FILERD(FILNAM,NLET,NULL,'CLUSTER',IRTFLG)
        IF (IRTFLG .NE. 0) RETURN

        CALL FILCAN(FILNAM,NLET,NULL,NULL,FILNAM,DATEXC,IRTFLG)
        IF (IRTFLG .NE. 0) RETURN
	OPEN(LUN,FILE=FILNAM,IOSTAT=IER,STATUS='OLD')
        IF (IER .NE. 0) RETURN

	CALL RDPRMI(MAP,NSKIP,NLOOP,ILOOP,
     &              'MAP#, NO. OF ELEMENTS IN MASK')
	IF (OPTT .EQ. 'C')GOTO 600
	IGRAV=0
	IF (NSKIP.LT.0)IGRAV=1
	IF (NSKIP.LT.0)NSKIP=-NSKIP
	MAP1=MAP/10
	MAP2=MAP-MAP1*10
	IF (MAP1.GT.8.OR.MAP2.GT.8) GOTO 999
	DO I=1,NSKIP
          READ(LUN,11) DUM
11	  FORMAT(A4,8F5.0)
        ENDDO

	XSUM=0
	YSUM=0
	NIM = 0
20	NIM=NIM+1
	READ(LUN,11,END=30) CODE(NIM)(1:4),(NCOO(K),K=1,8)
	X(NIM) = NCOO(MAP2)
	Y(NIM) = NCOO(MAP1)
	XSUM=XSUM+X(NIM)
	YSUM=YSUM+Y(NIM)
	GOTO 20

30	CONTINUE
	XMIN=10000
	YMIN=XMIN
	XMAX = -XMIN
	YMAX=-YMIN

	DO IM=1,NIM
	   IF(X(IM).LT.XMIN)XMIN=X(IM)
	   IF(X(IM).GT.XMAX)XMAX=X(IM)
	   IF(Y(IM).LT.YMIN)YMIN=Y(IM)
	   IF(Y(IM).GT.YMAX)YMAX=Y(IM)
        ENDDO

C	XSCALE=FLOAT(NXFUL)/FLOAT(XMAX-XMIN)
	XSCALE=FLOAT(NXFUL)/(XMAX-XMIN)
	NXZERO=(0.-XMIN)*XSCALE+0.5
C	YSCALE=FLOAT(NYFUL)/FLOAT(YMAX-YMIN)
	IF (OPTIN(2:2) .EQ. 'T') THEN
            YSCALE=FLOAT(NYFUL)/(YMAX-YMIN)
	ELSE
            YSCALE=XSCALE*PRATIO
	ENDIF
C
	DELTA=1./YSCALE
	WRITE(NPRINT,45)MAP1,YMIN,YMAX,MAP2,XMIN,XMAX
45	FORMAT(1X,'** VERTICAL(',I1,')  MIN = ',F10.4,'  MAX = ',F10.4/
     1       '    HORIZONTAL(',I1,')  MIN = ',F10.4,'  MAX = ',F10.4)
	XSUM=XSUM/FLOAT(NIM)
	YSUM=YSUM/FLOAT(NIM)

	CALL RDPRMI(IX,IY,NLOOP,ILOOP,'ENTER CENTER COOS$')
	CALL RDPRM(RAD,NLOOP,ILOOP,'ENTER RADIUS$')
	IF(RAD.EQ.0.)GOTO 556
	WRITE(NPRINT,554)
554	FORMAT(/,' ** LIST OF IMAGES INSIDE OF CIRCLE'/)
	DO 560 I=1,NIM
C	IF(FLOAT(X(I)-IX)**2+FLOAT(Y(I)-IY)**2.GT.RAD**2)GOTO 560
	IF((X(I)-IX)**2 + (Y(I)-IY)**2.GT.RAD**2) GOTO 560
	WRITE(NPRINT,561) CODE(I)(1:4)
561	FORMAT(1X,A4)
560	CONTINUE

556	IF(IGRAV.EQ.1)RETURN
C	DO 100 I=1,NYFUL+1
	YNOW=YMAX
590	CONTINUE
C	YNOW = YMAX-(I-1)*DELTA
	NCOUNT=0
	CHR = ' '
	IF(ABS(YNOW).LT.DELTA/2.) CHR = '-'
C	IF(I.EQ.1.OR.I.EQ.NYFUL+1) CHR = '-'
	IF(YNOW.EQ.YMAX.OR.YNOW.LE.YMIN) CHR = '-'
	NOFF=4
	NFUL=NXFUL+2*NOFF
	DO K=1,NFUL
           PRINT(K:K)= CHR
        ENDDO

	PRINT(1+NOFF:1+NOFF) = 'I'
	PRINT(NXFUL+NOFF:NXFUL+NOFF) = 'I'
	PRINT(NXZERO+NOFF:NXZERO+NOFF) = 'I'
	DO 80 ICOMP=1,NIM
	IF(ABS(YNOW-Y(ICOMP)).GT.DELTA/2.) GOTO 80
	XNOW=(X(ICOMP)-XMIN)*XSCALE+0.5
	NCOUNT=NCOUNT+1
498	DO 50 L=1,4
          NADDR=XNOW-3+L+NOFF
          IF(NADDR.LE.0)GOTO 50
          IF(NADDR.GT.NXFUL+2*NOFF)GOTO 50
          PRINT(NADDR:NADDR) = CODE(ICOMP)(L:L)
50	CONTINUE
80	CONTINUE
	PRINT(NOFF+NXFUL+2:NOFF+NXFUL+2) = MULT(NCOUNT+1:NCOUNT+1)
	WRITE(NPRINT,51)PRINT
51	FORMAT(1X,A108)
	YNOW=YNOW-DELTA
	IF(YNOW.LE.YMIN-DELTA)RETURN
	GOTO 590

C THIS FOLLOWING PART FOR PRINTING BASE HISTOGRAMS ONLY

600	NBASE=NSKIP/5
	VARMAX=0.
	IF(MAP.GT.8)GOTO 999
	DO I=1,NBASE
           VAR(I)=0
	   DO J=1,5
	      READ(LUN,11) DUM,(NCOO(K),K=1,8)
   	      VAR(I)=VAR(I)+ABS(NCOO(MAP))
           ENDDO
	   IF(VAR(I).GT.VARMAX)VARMAX=VAR(I)
   	ENDDO

	SCALE=FLOAT(NXFUL)/VARMAX
	DO I=1,NBASE
           IND=VAR(I)*SCALE + 1.5
           DO K=1,IND
              PRINT(K:K)='*'
           ENDDO
           IF (IND.LT.NXFUL)THEN
	      DO K=IND+1,NXFUL
                 PRINT(K:K)=' '
              ENDDO
           ENDIF
           WRITE(NPRINT,651)I,PRINT
        ENDDO

651	FORMAT(1X,I6,2X,A80)
951	FORMAT(1X,I6,2X,F8.2,2X,A60)
	CLOSE(LUN)

	CALL RDPRMC(ANS,NC,.TRUE.,'AVERAGE SEGMENTS? (Y/N)',NULL,IRT)
	IF (ANS .NE. 'Y') RETURN
	CALL RDPRMC(ANS,NC,.TRUE.,'RUNNING AVERAGE? (Y/N)',NULL,IRT)
	IF (ANS.EQ.'Y') GOTO 800
680	CALL RDPRMI(I1,I2,NLOOP,ILOOP,'BASE#1, BASE#2')
	IF(I1.EQ.0.AND.I2.EQ.0)RETURN
	AVG=0
	DO I=I1,I2
	   AVG=AVG+VAR(I)
   	ENDDO

	AVG=AVG/FLOAT(I2-I1+1)
	WRITE(NOUT,701)I1,I2,AVG,AVG*100/VARMAX
701	FORMAT(' ** AV. ABS. IMPORTANCE OF SEGMENT ',I3,'-',I3,
     1  ' IS ',F8.2,' ( ',F8.2,' )')
	GOTO 680

800	CALL RDPRMI(I1,NDUM,NLOOP,ILOOP,'NUMBER TO BE AVERAGED')
	IF (I1.LT.2)RETURN
	DO I=1,NBASE
           RAVG(I)=0.
        ENDDO

	N=1
820	AVG=0
	DO I=N,N+I1-1
	   AVG=AVG+VAR(I)
        ENDDO

	RAVG(N+I1/2)=RAVG(N+I1/2)+AVG/FLOAT(I1)
	N=N+1
	IF (N+I1-1.LE.NBASE)GOTO 820
	SUM=0
	DO I=I1/2,NBASE-I1/2
           SUM=SUM+RAVG(I)
        ENDDO

	DO I=1,NBASE
	   IND=RAVG(I)*SCALE+1.5
	   DO  K=1,IND
   	      PRINT(K:K)='*'
           ENDDO

	   IF (IND.LT.NXFUL) THEN
	      DO K=IND+1,NXFUL
   	         PRINT(K:K)=' '
              ENDDO
           ENDIF
   	   WRITE(NPRINT,951)I,RAVG(I)/SUM*100,PRINT
        ENDDO

	RETURN
999	CALL ERRT(99,'CAMAP ',NE)
	RETURN
	END
