
C++************************************************************************
C
C   CASCENGR.FOR
C
C **************************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK            *
C *  COPYRIGHT (C)1981,1987, WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *  THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR       *
C *  LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR    *
C *  USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF     *
C *  THE CENTER FOR LABORATORIES AND RESEARCH   			   *
C **************************************************************************
C
C
C
C--************************************************************************

         SUBROUTINE CASCENGR(LUNS,LUN2)

         PARAMETER (NFACMAX=24)
         INCLUDE 'CMBLOCK.INC'
         COMMON  DUM(80),COO(NFACMAX),X(NFACMAX),XMIN(NFACMAX)
     $          ,XMAX(NFACMAX),XX(NFACMAX),DLIST(20)

         COMMON /COMMUN/ CLUSTI,CLUST,FILPATI,FILPATP
         CHARACTER *81   CLUSTI(3),CLUST,FILPATI,FILPATP
         CHARACTER       NULL,ANS
         LOGICAL         MAXFLAG

         NULL = CHAR(0)

         MAXFLAG=.TRUE.

         FILPATI = 'IMC***'//NULL
         FILPATP = 'PIX***'//NULL

         NFILE = 1
6666     CALL RDPRMC(ANS,NCHAR,.TRUE.,'(I)MAGE OR (P)IXEL',NULL,IRT)

         IF (ANS .EQ. 'I') THEN
            NFILE=1
         ELSEIF (ANS .EQ. 'P') THEN
            NFILE=2
         ENDIF

         CALL RDPRMI(IMNO,IKEY1,NLOOP,ILOOP,
     &      'COORDINATE FILE CODE,FIRST KEY IN OUTPUT DOC.-FILE')

         NLET = 6
         CALL FILGET(FILPATI,CLUSTI(1),NLET,IMNO,IRTFLG)
         CALL FILGET(FILPATP,CLUSTI(2),NLET,IMNO,IRTFLG)

         CALL FILCAN(CLUST,NF,NULL,NULL,CLUSTI(NFILE),DATEXC,IER)
         OPEN(FILE=CLUST,UNIT=LUNS,STATUS='OLD',FORM='UNFORMATTED')

         READ(LUNS) NITEM,NFAC,NOC,NOR

C       CHECK FOR TRANSPOSE SWITCH
         IT = 1
         IF (NOC .LT. 0) THEN
            CLOSE(LUNS)
            NFILP  = NFILE
            IF (NFILP .EQ. 1) NFILE=2
            IF (NFILP .EQ. 2) NFILE=1
            CALL FILCAN(CLUST,NF,NULL,NULL,CLUSTI(NFILE),DATEXCT,IER)
            OPEN(FILE=CLUST,UNIT=LUNS,STATUS='OLD',FORM='UNFORMATTED')
            READ(LUNS) NITEM,NFAC,NOC,NOR
            NOC = -NOC
            IT  = -1
         ENDIF

         IF(NFAC.GT.NFACMAX) THEN
            WRITE(NOUT,200) NFACMAX,NFAC
200         FORMAT(' THE MAXIMUM NUMBER OF FACTORS ALLOWED IN THIS',
     $         ' PROGRAM IS ',I4,/' IF YOU WANT TO USE IT FOR YOUR ',
     $         I4,' ITEMS, CHANGE PRGRAM CASCENGR.F')
            RETURN
         ENDIF

C START THE REAL CALCULATIONS:


C PRESET XMAX,XMIN:
         DO  I=1,NFAC
            XMAX(I)=-1000
         XMIN(I)=1000
	 ENDDO


98       CALL RDPRMI(IFROM,ITO,NLOOP,ILOOP,'ID # FROM, TO')
         IF(IFROM.EQ.0.AND.ITO.EQ.0) GOTO 1000
         REWIND (LUNS)
         READ(LUNS) A


C CLEAR CGR ARRAY:

         DO  LL=1,NFAC
         X(LL)=0.
	 ENDDO

C ADD THE IMAGE/PIXEL VECTORS:

         KK=0

         DO I=1,NITEM
            READ(LUNS) (COO(K),K=1,NFAC),RWGT,DIO,IIII,IMSTA

C DETERMINE MAXIMUM AND MINIMUM FOR EACH FACTOR (JUST ONCE):

            IF(MAXFLAG) THEN
               DO LL=1,NFAC
                  IF(XMAX(LL).LT.COO(LL)) XMAX(LL)=COO(LL)
                  IF(XMIN(LL).GT.COO(LL)) XMIN(LL)=COO(LL)
	       ENDDO
            ENDIF

C ADD THE VECTORS:

         IF(IIII.GE.IFROM.AND.IIII.LE.ITO) THEN
            KK=KK+1
            DO LL=1,NFAC
               X(LL) = X(LL)+COO(LL)
	    ENDDO
         ENDIF
	 ENDDO
         IF(MAXFLAG) THEN
C SAVE IN DOCUMENT FILE:
C 1) SAVE MAXIMA
            DLIST(1)=-1
            NLIST=NFAC+1
            DO IK=1,NFAC
               DLIST(IK+1)=XMAX(IK)
	    ENDDO
            CALL SAVD(LUN2,DLIST,NLIST,IRTFLG)
C 2) SAVE MINIMA
            DLIST(1)=-2
            DO IK=1,NFAC
               DLIST(IK+1)=XMIN(IK)
	    ENDDO
            CALL SAVD(LUN2,DLIST,NLIST,IRTFLG)
C 3) NOW SAVE ABSOLUT VALUES
            DLIST(1)=-3
            DO  IK=1,NFAC
               XXMA=ABS(XMAX(IK))
               XXMI=ABS(XMIN(IK))
               XXX=AMAX1(XXMA,XXMI)
               DLIST(IK+1)=XXX
	    ENDDO
            CALL SAVD(LUN2,DLIST,NLIST,IRTFLG)
         ENDIF

C DIVIDE BY NUMBER OF ITEMS USED:

         IF(KK.NE.0) THEN
            DO  LL=1,NFAC
               X(LL)=X(LL)/FLOAT(KK)
	    ENDDO
         ENDIF

C WRITE OUT RESULTS:
         WRITE(NDAT,112) CLUST(1:6)
         WRITE(NOUT,112) CLUST(1:6)
112      FORMAT(' ',//' COORDINATE FILE:',A6)
         WRITE(NDAT,103) IFROM,ITO,KK,(X(LL),LL=1,NFAC)
         WRITE(NOUT,103) IFROM,ITO,KK,(X(LL),LL=1,NFAC)
103      FORMAT(/' THE CENTER OF GRAVITY FOR ID# ',I5,' TO ',I5,
     $   /' CONTAINING ',I5,' IMAGES IS:'/1X,(5(G12.6,1X)))
C        PUT INTO DOCUMENT FILE:
         DLIST(1)=IKEY1
         DO  IK=1,NFAC
            DLIST(IK+1)=X(IK)
	 ENDDO
         DLIST(NFAC+2)=IFROM
         DLIST(NFAC+3)=ITO
         NLIST=NFAC+3
         CALL SAVD(LUN2,DLIST,NLIST,IRTFLG)
         IKEY1=IKEY1+1
C NORMALIZE EACH AXIS TO RANGE [0,1000]

         DO LL=1,NFAC
            RANGE=XMAX(LL)-XMIN(LL)
            XX(LL)=(X(LL)-XMIN(LL))/RANGE*1000
	 ENDDO
         WRITE(NDAT,111) (XX(LL),LL=1,NFAC)
         WRITE(NOUT,111) (XX(LL),LL=1,NFAC)
111      FORMAT(/' NORMALIZED TO RANGE [0,1000] :'
     $              /,(10(2X,F5.0)))
         WRITE(NDAT,115) (XMAX(LL),XMIN(LL),LL=1,NFAC)
         WRITE(NOUT,115) (XMAX(LL),XMIN(LL),LL=1,NFAC)
115      FORMAT(/' MAXIMUM/MINIMUM:'
     $          /,(5(2X,E12.4)))
         WRITE(NDAT,113)
         WRITE(NOUT,113)
113      FORMAT(' ',//1X)
C MAKE SURE MAXIMUM IS NOT DETERMINED AGAIN

         MAXFLAG=.FALSE.

C GET NEXT SET:
         GOTO 98

C DONE:
1000     CONTINUE
C SAVE LAST SET IN REGISTERS:
         DO  L=1,NFAC
            IF(NSEL(L).NE.0) PARAM(NSEL(L))=X(L)
	 ENDDO
c114      CONTINUE
         CALL SAVDC
         CLOSE (LUNS)
         CLOSE (LUN2)
         END

