C++************************************************************************
C
C $$ CCRD_2R.FOR
C
C **************************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK            *
C *  COPYRIGHT (C)1981,1987, WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *  THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR       *
C *  LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR    *
C *  USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF     *
C *  THE CENTER FOR LABORATORIES AND RESEARCH   			   *
C **************************************************************************
C
C
C
C--************************************************************************
C
C $$ CCRD_2R.FOR
C
	SUBROUTINE  CCRD_2R(LUN2,X,BUF,O,NNNN,NSAM,NROW)
C
C  Calculates circular croscorrelation, non-power-of-two dimensions
C  Input - X,Y Fourier transforms
C  Output -  O=F(X*conjg(LUN2))
C
	COMPLEX  X(NNNN,NROW),BUF(NNNN),O(NNNN,NROW)
        DOUBLE PRECISION  PI2
CNO_SAVE
C
C	INS=1
C	CALL  FMRS_2(X,NSAM,NROW,INS)
C	IF(INS.EQ.0)  RETURN
C	CALL  FMRS_2(Y,NSAM,NROW,INS)
C
	LRS=2*NNNN
        PI2=8.0*DATAN(1.0D0)
 	ITMP=NSAM/2
	SX=PI2*FLOAT(ITMP)/FLOAT(NSAM)
	ITMP=NROW/2
	SY=PI2*FLOAT(ITMP)/FLOAT(NROW)
        DO    J=1,NROW
        IY=J-1
        IF(IY.GT.NROW/2)  IY=IY-NROW
        ARGY=SY*IY
	CALL  REDLIN(LUN2,BUF,LRS,J)
        DO    I=1,NNNN
        IX=I-1
        ARG=SX*IX+ARGY
        O(I,J)=X(I,J)*CONJG(BUF(I))*CMPLX(COS(ARG),SIN(ARG))
	ENDDO
	ENDDO
C
	INS=-1
	CALL  FMRS_2(O,NSAM,NROW,INS)
	END
