
C                                       LONG FILENAMES JAN 89 al
C
C
C CALCULATES CENTER OF GRAVITY AND RADIUS OF GYRATION OF A DENSITY
C MASS STORED IN A THREE-D FILE. FOR REFERENCE, SEE INTERNATIONAL
C TABLES OF CRYSTALLOGRAPHY, VOL.III P. 327.     --- JF 6/01/83
C

	SUBROUTINE CENGR3(LUN3)
	INCLUDE 'CMBLOCK.INC' 
	COMMON BUF(1)
        COMMON /COMMUN/FILNAM

        CHARACTER *81 FILNAM
        CHARACTER     NULL

        NULL=CHAR(0)
CNO_SAVE
	CALL FILERD(FILNAM,NLET,NULL,'THREED',IRTFLG)
        IF (IRTFLG .NE. 0) RETURN

	CALL OPENF(FILNAM,LUN3,NSAM,NROW,'OLD',NF,NSLICE)
	IF(NF.NE.2)RETURN
	CALL RDPRM(TH,NLOOP,ILOOP,'THRESHOLD$')

C FIRST CALCULATE CENTER OF GRAVITY
	XM=0.0
	YM=0.0
	ZM=0.0
	BT=0.0
	DO  L=1,NSLICE
	I1=(L-1)*NROW
	DO   I=1,NROW
	CALL REDLIN(LUN3,BUF,NSAM,I+I1)
	DO 70  K=1,NSAM
	IF (BUF(K).LT.TH)GOTO 70
	B=BUF(K)
	IF (FCHAR(5:5).EQ.'S')B=1.
	BT=B+BT
	XM=XM+B*(K)
	YM=YM+B*(I)
	ZM=ZM+B*(L)
70	CONTINUE
	ENDDO
	ENDDO
	ZM=ZM/BT
	YM=YM/BT
	XM=XM/BT

C NOW CALCULATE RADIUS OF GYRATION, RG
	BT=0.0
	RG=0.0
	DO  L=1,NSLICE
	I1=(L-1)*NROW
	DO  I=1,NROW
	REST=(YM-I)**2+(ZM-L)**2
	CALL REDLIN(LUN3,BUF,NSAM,I+I1)
	DO 170 K=1,NSAM
	IF (BUF(K).LT.TH)GOTO 170
	IF (FCHAR(5:5) .EQ. 'S')BUF(K)=1.
	RG=RG+BUF(K)*((XM-K)**2+REST)
	BT=BT+BUF(K)
170	CONTINUE
	ENDDO
	ENDDO
	RG=SQRT(RG/BT)
	XM=XM-NSAM/2-1
	YM=YM-NROW/2-1
	ZM=ZM-NSLICE/2-1
C
	WRITE(NOUT,201)XM,YM,ZM,RG
201	FORMAT(' ** COMPONENTS OF CENTER OF GRAVITY:'//,
     1 '           X = ',F7.2,'  Y = ',F7.2,'  Z = ',F7.2,
     2 //'      RADIUS OF GYRATION = ',F12.2/)

	IF (NSEL(1).NE.0)PARAM(NSEL(1))=XM
	IF (NSEL(2).NE.0)PARAM(NSEL(2))=YM
	IF (NSEL(3).NE.0)PARAM(NSEL(3))=ZM
	IF (NSEL(4).NE.0)PARAM(NSEL(4))=RG
	END
