
C++**************************************************************************
C
C $$ CENGRA.FOR
C                                          LONG FILE NAMES JAN 89 al
C **************************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK            *
C *  COPYRIGHT (C)1981,1987, WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH 			   *
C **************************************************************************
C
C CENGRA  2/16/81  COMPUTES CENTER OF GRAVITY OF IMAGE
C
C **************************************************************************

	SUBROUTINE CENGRA(LUN1,NSAM,NROW)
	INCLUDE 'CMBLOCK.INC' 

	COMMON BUF(1)
        COMMON /COMMUN/FILNAM

        CHARACTER *81 FILNAM
        CHARACTER     NULL
	REAL          R(4,4),PHI(10),MU00
	DOUBLE PRECISION       MU(4,4)
	INTEGER       POW1,POW2,P,Q
	INTEGER       IND,IND1,K
CNO_SAVE
        NULL=CHAR(0)
C
	NSAM1=NSAM/2+1
	NROW1=NROW/2+1
        CALL RDPRM(TH,NLOOP,ILOOP,'THRESHOLD')
C	CALL RDPRM(RAD,NLOOP,ILOOP,'MASK RADIUS')
C	R2=RAD**2
	C=0.
	CX=0.
	CY=0.
C
	IND=1
	DO  I=1,NROW
	CALL REDLIN(LUN1,BUF(IND),NSAM,I)
	DO 50 K=1,NSAM
	IND1=IND+K-1
	VAL = BUF(IND1)-TH
      IF (VAL.LT.0.)GOTO 50
	CX=CX+VAL*(K-NSAM1)
	CY=CY+VAL*(I-NROW1)
	C=C+VAL
50	CONTINUE
        IND=IND+NSAM
	ENDDO
	XCEN=CX/C
	YCEN=CY/C
	WRITE(NOUT,101)XCEN,YCEN
101	FORMAT(' ** CENTER OF GRAVITY W.RESP. TO IMAGE CENTER ',
     &         2F6.1)
	NS1=NSEL(1)
	NS2=NSEL(2)
	PARAM(NS1)=XCEN
	PARAM(NS2)=YCEN
C NEW SECTION
	IND=1
	DO  P=1,4
	DO  Q=1,4
	MU(P,Q)=0.0
	ENDDO
	ENDDO
	DO  I=1,NROW
	DO 200 K=1,NSAM
      IF (FLOAT(K-NSAM1).EQ.XCEN)GOTO 200
      IF (FLOAT(I-NROW1).EQ.YCEN)GOTO 200
C
	IF (BUF(IND+K).LT.TH)GOTO 200
C	IF(FLOAT(K-NSAM1)**2 + FLOAT(I-NROW1)**2.GT.R2)GOTO 200
	DO  P=1,4
	DO  Q=1,4
	MU(P,Q)=MU(P,Q)+(BUF(IND+K-1)-TH)*
     1 (FLOAT(K-NSAM1)-XCEN)**(P-1) * (FLOAT(I-NROW1)-YCEN)**(Q-1)
	ENDDO
	ENDDO
200	CONTINUE
	IND=IND+NSAM
	ENDDO

	MU00=C

	DO  P=1,4
	DO  Q=1,4
	S=(P+Q-2)/2+1
	R(P,Q)=MU(P,Q)/(MU00**S)
	ENDDO
	ENDDO

	PHI(1)=R(3,1)+R(1,3)
	PHI(2)=(R(3,1)-R(1,3))**2+4*R(2,2)**2
	PHI(3)=(R(4,1)-3*R(2,3))**2 + (3*R(3,2)-R(1,4))**2
	PHI(4)=(R(4,1)+R(2,3))**2 + (R(3,2)+R(1,4))**2
      PHI(5)=(R(4,1)-3*R(2,3))*(R(4,1)+R(2,3))
     1 *((R(4,1)+R(2,3))**2-3*(R(3,2)+R(1,4))**2)
     2 +(3*R(3,2)-R(1,4))*(R(3,2)+R(1,4))
     3 *(3*(R(4,1)+R(2,3))**2-(R(3,2)+R(1,4))**2)

	PHI(6)=(R(3,1)-R(1,3))* ((R(4,1)+R(2,3))**2
     1 -(R(3,2)+R(1,4))**2)
     2 +4*R(4,1)*(R(4,1)+R(2,3))*(R(3,2)+R(1,4))

	PHI(7)=(3*R(3,2)-R(1,4))*(R(4,1)+R(2,3)) *
     1 ((R(4,1)+R(2,3))**2-3*(R(3,2)+R(1,4))**2)
     2 +(R(4,1)-3*R(2,3))*(R(3,2)+R(1,4)) *
     3 ((R(3,2)+R(1,4))**2-3*(R(4,1)+R(2,3))**2)

	PHI(8)=XCEN
	PHI(9)=YCEN
	PHI(10)=MU00
	WRITE(NOUT,55)PHI
55	FORMAT(1X,3G20.10)

	IF (FCHAR(4:4) .NE. 'S')RETURN
	CLOSE(LUN1)

	CALL FILERD(FILNAM,NLET,NULL,'MOMENT',IRTFLG)
	CALL OPENF(FILNAM,LUN1,NSAM,1,'UNKNOWN',NF,1)
	CALL WRTLIN(LUN1,PHI,10,1)
	END
