C++************************************************************************
C
C $$ CGR_3.FOR
C
C **************************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK            *
C *  COPYRIGHT (C)1981,1987, WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *  THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR       *
C *  LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR    *
C *  USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF     *
C *  THE CENTER FOR LABORATORIES AND RESEARCH   			   *
C **************************************************************************
C
C
C
C23456789012345678901234567890123456789012345678901234567890123456789012
C--************************************************************************
C
C $$ CGR_3.FOR
C
         SUBROUTINE  CGR_3
     &   (LUN,BUF,NSAM,NROW,NSLICE,ELIPX,ELIPY,ELIPZ,NPC,
     &   RXCEN,RYCEN,RZCEN,RSUM)
         DIMENSION  BUF(NSAM),NPC(3)
CNO_SAVE
C
C IT CALCULATES THE CENTER OF GRAVITY INSIDE ELLIPSOIDE AROUND HIGEST PEAK
C
         XCOOR=NPC(1)
         YCOOR=NPC(2)
         ZCOOR=NPC(3)
         XMAXI= XCOOR+ELIPX
         XMINI= XCOOR-ELIPX
         YMAXI= YCOOR+ELIPY
         YMINI= YCOOR-ELIPY
         ZMAXI= ZCOOR+ELIPZ
         ZMINI= ZCOOR-ELIPZ
         RSUM=0
         RXCEN=0
         RYCEN=0
         RZCEN=0
         DO  I=ZMINI,ZMAXI
         RRAUZI=((FLOAT(I)-ZCOOR)/ELIPZ)**2
         IR=MOD(I-1+NSLICE,NSLICE)+1
         DO  II=YMINI,YMAXI
         IIR=MOD(II-1+NROW,NROW)+1
         CALL REDLIN (LUN,BUF,NSAM,(IR-1)*NROW+IIR)
         RRAUXI=((FLOAT(II)-YCOOR)/ELIPY)**2+RRAUZI
         DO  III=XMINI,XMAXI
         RELIPS=((FLOAT(III)-XCOOR)/ELIPX)**2+RRAUXI
         IF (RELIPS.LE.1.0) THEN
         IIIR=MOD(III-1+NSAM,NSAM)+1
         IF(BUF(IIIR).LT.0.0)  THEN
         RSUM=0.0
         RETURN
         ENDIF
         RXCEN=BUF(IIIR)*III+RXCEN
         RYCEN=BUF(IIIR)*II+RYCEN
         RZCEN=BUF(IIIR)*I+RZCEN
         RSUM=BUF(IIIR)+RSUM
         ENDIF
	 ENDDO
	 ENDDO
	 ENDDO
         IF(RSUM.EQ.0.0) RETURN
         RXCEN=RXCEN/RSUM
         RYCEN=RYCEN/RSUM
         RZCEN=RZCEN/RSUM
         END
