
C++*************************************************************************
C
C  CHARINSIDE.F                                     MAY 1997 al
C
C **************************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK            *
C *  COPYRIGHT (C)1981,1987, WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH 			   *
C **************************************************************************
C
C CHARINSIDE(STRING,CLEFT,CRIGHT,INCLUSIVE,IGO,IEND,NCHAR)
C
C PARAMETERS:    STRING     INPUT STRING                 (INPUT)
C                CLEFT      START DELIMITER              (INPUT)
C                CRIGHT     END   DELIMITER              (INPUT)
C                INCLUSIVE  FLAG TO EXCLUDE DELIMITERS   (INPUT)
C                IGO        STARTING LOCATION            (RETURNED)
C                IEND       ENDING LOCATION              (RETURNED)
C                NCHAR      NUMBER OF CHAR.              (RETURNED)
C
C--*********************************************************************

       SUBROUTINE CHARINSIDE(STRING,CLEFT,CRIGHT,INCLUSIVE,
     &                       IGO,IEND,NCHAR)
CNO_SAVE

       INCLUDE 'CMBLOCK.INC'

       CHARACTER *(*) STRING
       CHARACTER      CLEFT,CRIGHT
       LOGICAL        INCLUSIVE

C      FIND BEGINNING OF SUBSTRING
       IGO   = INDEX(STRING,CLEFT)

C      FIND END OF SUBSTRING
       IEND  = INDEX(STRING(IGO+1:),CRIGHT) + IGO

C      CHECK IF SUBSTRING WAS PRESENT
       IF (IGO .EQ. 0 .OR. IEND .EQ. 0 .OR. IGO .GT. IEND) THEN
C         SUBSTRING NOT PRESENT, (DIFFERENT FROM EMPTY SUBSTRING)
          NCHAR = -1
          RETURN
       ENDIF

       IF (INCLUSIVE) THEN
C         DO NOT WANT TO INCLUDE DELIMITER LOCATIONS
          IGO  = IGO  + 1
          IEND = IEND - 1
       ENDIF

C      FIND NUMBER OF CHARACTERS IN RETURNED SUBSTRING
       NCHAR = IEND - IGO + 1

       RETURN
       END


