C *NAME* = CHAVA.FOR                   31-JAN-86      13:23:01                  
C----------------------------------=*=----------------------------------        
C           COPYRIGHT 1986 - JEAN-PIERRE BRETAUDIERE                            
C THE UNIVERSITY OF TEXAS HEALTH SCIENCE CENTER AT HOUSTON                      
C MEDICAL SCHOOL - DEPARTMENT OF PATHOLOGY AND LABORATORY MEDICINE              
C P.O. BOX 20708, HOUSTON, TX 77225.                                            
C DISCLAIMER: NO GUARANTEES OF PERFORMANCE ACCOMPANY THIS SOFTWARE,             
C NOR IS ANY RESPONSIBILITY ASSUMED ON THE PART OF THE AUTHOR                   
C OR THE INSTITUTION.  ALL THE SOFTWARE HAS BEEN TESTED EXTENSIVELY             
C AND EVERY EFFORT HAS BEEN MADE TO INSURE ITS RELIABILITY.                     
C THE FOLLOWING SOFTWARE MAY NOT BE COMMUNICATED TO A THIRD PARTY               
C UNDER ANY FORM WITHOUT WRITTEN PERMISSION OF THE AUTHOR.                      
C PLEASE REPORT ANY BUG(S) TO JPB AT (713) 792 52 00.                           
C OR THRU ARPANET AT  ......!rice!ots!ut-path!suprim                            
C*--------------------------------------------------------------------*         
C*                                                                    *         
C*                                                                    *         
C*      HIERARCHICAL ASCENDENT CLASSIFICATION USING THE VARIANCE AS   *         
C*      AN AGGREGATION CRITERION.  THE DISTANCES ARE IN THE MONO-     *         
C*      INDEXED TABLE D(MCAR).                                        *         
C*                                                                    *         
C*      INPUT:                                                        *         
C*      NKLA            = NUMBER OF ELEMENTS TO BE CLASSIFIED         *         
C*      MCARD           = NKLA * (NKLA-1) /2                          *         
C*      JFIN            = 2*NKLA - 1                                  *         
C*      D(MCARD)        = TABLE OF DISTANCES DESTROYED AFTER EXECUTION*         
C*      PK(1,...,NKLA)  = WEIGHT OF THE NKLA ELEMENTS                 *         
C*                                                                    *         
C*      OUTPUT:                                                       *         
C*                                                                    *         
C*      PK(NKLA+1,...)      = WEIGHT OF THE NODES OF THE HIERARCHY    *         
C*      IDK(NKLA)           = ELEMENT IDENTIFIERS (NUMBERS IN A4)     *         
C*      LA(NKLA,LB(NKLA)    = SENIORS AND JUNIORS OF THE              *         
C*                            CLASSIFICATION                          *         
C*      VAL(NKLA+1,...)     = NODE INDICES                            *         
C*      NT(NKLA+1,...)      = SIZE OF CLASSES                         *         
C*      NO(NKLA+1,...)      = WORKING ARRAY                           *         
C*                                                                    *         
C*      INTERNAL FUNCTION ... MONO                                    *         
C*                                                                    *         
C==04.11.81                                                           *         
C==01.12.86                                                           *         
C*--------------------------------------------------------------------*         
      SUBROUTINE CHAVA (NKLA, MCARD, JFIN,  D, IDK, PK,                         
     #                  VAL, LA, LB, NT, NO, NBAND, MODE, LLL)
C
C                                                                               
      DIMENSION D(MCARD),IDK(NKLA),PK(JFIN),VAL(JFIN),LA(NKLA),                 
     #   LB(NKLA),NT(JFIN),NO(JFIN)                                
      COMMON  / ENSOR / LEC,IMP
	CHARACTER*8  CTM
	CHARACTER*1  IAST,KLIGN(110)
      DATA  IAST /'*'/ 
CNO_SAVE                                                         
C                                                                               
C.......... MONO-INDEXING OF THE TABLE OF DISTANCES                             
C                                                                               
      MONO(K1,K2)= MIN0(K1,K2) + ((MAX0(K1,K2)-1)*(MAX0(K1,K2)-2)/2)            
C                                                                               
C.......... GENERATION OF IDENTIFIERS, NUMBERS IN A4                            
C                                                            
	IF(LLL.EQ.0)  THEN                   
	DO  10  K=1,NKLA
	WRITE(CTM,2000)  K
 10	READ(CTM,3000)  IDK(K)
	ELSE
	DO  11  K=1,NKLA
	WRITE(CTM,2000)  IDK(K)
 11	READ(CTM,3000)  IDK(K)
	ENDIF
	GOTO  (21,22,23,24,25),MODE
 21	WRITE(IMP,31)
	GOTO  29
 22	WRITE(IMP,32)
	GOTO  29
 23	WRITE(IMP,33)
	GOTO  29
 24	WRITE(IMP,34)
	GOTO  29
 25	WRITE(IMP,35)
	GOTO  29
 31	FORMAT('0','CLUSTERING CRITERION: ',
     &	  'SINGLE LINKAGE')
 32	FORMAT('0','CLUSTERING CRITERION: ',
     &	  'COMPLETE LINKAGE')
 33	FORMAT('0','CLUSTERING CRITERION: ',
     &	  'AVERAGE LINKAGE')
 34	FORMAT('0','CLUSTERING CRITERION: ',
     &	  'CENTROID METHOD')
 35	FORMAT('0','CLUSTERING CRITERION: ',
     &	  'WARD','"','S METHOD')
 29	CONTINUE
C
	IF(MODE.LE.3)  THEN
	DO  19  K=1,MCARD
 19	D(K)=SQRT(D(K))
	ENDIF
C
      WRITE (IMP,650)                                                           
        DO 90  L=1,100                                                          
   90 KLIGN(L)= IAST                                                            
        DO 100 J = 1,JFIN                                                       
      NO(J) = J                                                                 
      VAL(J)= 0.0                                                               
  100 NT(J) = 1                                                                 
C                                                                               
C.......... CALCULATIONS AND LISTINGS                                           
C                                                                               
      JDEB  = NKLA + 1                                                          
      VMAX  = 0.0                                                               
      REWIND  NBAND                                                             
        DO 150  J = JDEB,JFIN                                                   
      DINF  = D(1)                                                              
      II1   = 1                                                                 
      II2   = 2                                                                 
      II    = 2*NKLA  - J + 1                                                   
        DO 110  I1 = 2,II                                                       
      I3    = I1 - 1                                                            
        DO 110  I2 = 1,I3                                                       
      I1I2  = MONO (I1, I2)                                                     
        IF (D(I1I2) .GE. DINF)         GO TO  110                               
      DINF  = D(I1I2)                                                           
      II1   = I1                                                                
      II2   = I2                                                                
  110   CONTINUE                                                                
      IR    = J - JDEB + 1                                                      
      LA(IR)= MIN0 (NO(II1), NO(II2))                                           
      LB(IR)= MAX0 (NO(II1), NO(II2))                                           
      VAL(J)= DINF                                                              
      LAI   = LA(IR)                                                            
      LBI   = LB(IR)                                                            
      NT(J) = NT(LAI) + NT(LBI)                                                 
      VA    = VAL(LAI)                                                          
      VB    = VAL(LBI)                        
	P1=PK(LAI)
	P2=PK(LBI)
      PK(J) = P1 + P2
      NO(II1)= J                                                                
        DO 120  III = 1,II                                                      
        IF (III.EQ.II1 .OR. III.EQ.II2) GO TO 120                               
      M1    = MONO (III, II1)                                                   
      M2    = MONO (III, II2)                                                   
      JS    = NO(III)                                                           
      VJS   = PK(JS)
	GOTO  (51,52,53,54,55),MODE
 51	D(M1)=AMIN1(D(M1),D(M2))
	GOTO  120
 52	D(M1)=AMAX1(D(M1),D(M2))
	GOTO  120
 53	D(M1)=(P1*D(M1)+P2*D(M2))/(P1+P2)
	GOTO  120
 54	D(M1)=((P1*D(M1)+P2*D(M2))/(P1+P2))-(P1*P2*DINF/((P1+P2)**2))
	GOTO  120
 55   D(M1) = ((VA+VJS)*D(M1)+(VB+VJS)*D(M2)-VJS*DINF)/(VA+VB+VJS)
  120   CONTINUE                                                                
        IF (II2 .EQ. II)               GO TO  140                               
      NO(II2)= NO(II)                                                           
      IT    = II - 1                                                            
        DO 130  III = 1,IT                                                      
        IF (III .EQ. II2)              GO TO  130                               
      M1    = MONO (III, II2)                                                   
      M2    = MONO (III, II)                                                    
      D(M1) = D(M2)                                                             
  130   CONTINUE                                                                
  140   IF (VAL(J) .GT. VMAX)          VMAX = VAL(J)                            
      WRITE (NBAND)  J,LA(IR),LB(IR),NT(J),PK(J),VAL(J)                         
  150   CONTINUE                                                                
      REWIND  NBAND                                                             
      NKLA1 = NKLA - 1                                                          
        DO 160  JJ = 1,NKLA1                                                    
      J    = JJ + NKLA                                                          
      IR   = J - JDEB + 1                                                       
      READ (NBAND)   J,LA(IR),LB(IR),NT(J),PK(J),VAL(J)                         
      LIG   = 90.0*VAL(J)/VMAX + 1.0                                            
        IF (LIG .GT. 90)               LIG = 90                                 
      WRITE (IMP,660) J,LA(IR),LB(IR),NT(J),PK(J),VAL(J),                       
     #                              (KLIGN(L),L=1,LIG)                          
  160   CONTINUE                                                                
         RETURN                                                                 
  650 FORMAT (//1X,'DESCRIPTION OF THE HIERARCHY NODES'      /                  
     #      //1X,'   NO SENIOR JUNIOR NO.  WEIGHT   INDEX'   /)
  660 FORMAT (1X,I5,3I5,2(1PG10.2,1X),90A1)
 2000 FORMAT (I4)                                                             
 3000 FORMAT (A4)                                                             
         END                                                                    
