
C ++********************************************************************
C
C CHKMEM.F
C
C **********************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK        *
C *  COPYRIGHT (C)1985, 1996 HEALTH RESEARCH INCORPORATED, ALBANY,     *
C *             NY 12201                                               *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO HEALTH         *
C *    RESEARCH INC. AND ARE NOT TO BE DISCLOSED TO OTHERS             *
C *    OR USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN        *
C *    APPROVAL OF HEALTH RESEARCH INC.                                *
C **********************************************************************
C  CHKMEM(MEMWANT,BUFIN,LENBUFIN,RUNTIME,IPQ,IRTFLG)
C                                                                    
C  PURPOSE:  CHECK FOR MEMORY AVAILABLILITY AND ALLOCATION
C   
C  PARAMETERS: MEMWANT      NUMBER OF 32 BIT WORDS WANTED    (SENT)
C              BUFIN        STATIC BUFFER AVAILABLE          (SENT)
C              LENBUFIN     LENGTH OF STATIC BUF             (SENT)
C              RUNTIME      FLAG INDICATES DYNAMIC MEMORY    (RETURNED)
C              IPQ          POINTER TO BUFFER                (RETURNED)
C              IRTFLG       ERROR FLAG (0 IS NORMAL)    (SENT/RETURNED)
C                           -9 SENT MEANS DO NOT CALL ERRT
C                                                                      
C        0         2         3         4         5         6         7
C23456789012345678901234567890123456789012345678901234567890123456789012
C **********************************************************************

      SUBROUTINE CHKMEM(MEMWANT,BUFIN,LENBUFIN,RUNTIME,IPQ,IRTFLG)

C DO NOT COMPILE WITH STATIC
CNO_SAVE
    
      DIMENSION    BUFIN(1)
      LOGICAL      RUNTIME,WANTERRT
      DIMENSION    Q(1)
      POINTER      (IPQ,Q) 

      WANTERRT = .TRUE.
      IF (IRTFLG .EQ. -9) WANTERRT = .FALSE.
     
C     SET ERROR RETURN FLAG
      IRTFLG = 1

      IF (MEMWANT .LE. LENBUFIN) THEN
C        HAVE SUFFICIENT STATIC MEMORY, USE IT BY ASSIGNING IPQ
C        TO ADDRESS OF BUFIN
         IPQ     = %LOC(BUFIN) 
         RUNTIME = .FALSE.  
         IRTFLG  = 0
         RETURN
      ENDIF

C     ON UNIX CAN REQUEST RUN-TIME ALLOCATION OF IPQ 
      RUNTIME = .TRUE.
      CALL ALLOCIT(MEMWANT,RUNTIME,IPQ,'CHKMEM',IRTFLG)

      IF (.NOT. RUNTIME)  THEN
C        NOT ENOUGH DYNAMIC MEMORY AVAILABLE FOR MEMWANT
         IF (WANTERRT)
     &      CALL ERRT(101,'INSUFFICIENT STATIC & DYNAMIC MEMORY',NE)
         RETURN
      ENDIF
      IRTFLG = 0

      RETURN
      END

