
C++*******************************************************************
C
C $$ CHKNUMQ.FOR
C                   ADAPTED FROM CHKNUM FOR CHAR. AUG 89 al
C **************************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK            *
C *  COPYRIGHT (C)1981,1987, WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH 			   *
C **************************************************************************
C
C
C $$ CHKNUMQ(STRING,NCHAR,TYPE,NUM,FNUM,IER)
C
C    PARAMETERS:     STRING       INPUT STRING
C                    NCHAR        LENGTH OF STRING.  IF NCHAR IS ZERO
C                                 WILL SET NCHAR TO LENGTH OF FIRST
C                                 NON-BLANK SEQUENCE IN STRING
C                    TYPE         CHARACTER VARIABLE OR CONSTANT
C                                 REAL IS "R", INTEGER IS ANYTHING ELSE.
C                    NUM          INTEGER RETURN
C                    FNUM         REAL NUMBER RETURN
C                    IER          ERROR FLAG.  ZERO IS NORMAL RETURN.
C
C    NOTE:   STRING, NCHAR & TYPE ARE INPUT VALUES.  
C            NUM, FNUM & IER      ARE RETURNED VARIABLES.
C            TYPE MAY BE A CHARACTER VARIABLE OR CONSTANT.
C
C--*******************************************************************

	SUBROUTINE CHKNUMQ(STRING,NCHAR,TYPE,NUM,FNUM,IER)

	COMMON /UNITS/LUN,NIN,NOUT

        CHARACTER *(*) STRING,TYPE

C       SET ERROR FLAG
	IER  = 0

        IGO  = 1
        IEND = NCHAR

        IF (NCHAR .EQ. 0) THEN
C          FIND USED STRING LENGTH
           LENS = LEN(STRING)
           DO  IGO = 1,LENS
             IF (STRING(IGO:IGO) .NE. ' ') GOTO 15
	   ENDDO

C          STRING ALL BLANK
           RETURN
           
15         DO IEND=LENS,IGO,-1
             IF (STRING(IEND:IEND) .NE. ' ') GOTO 16
	   ENDDO

        
        ENDIF


16	IF (TYPE(1:1) .EQ. 'R') THEN

C	   EXTRACT REAL NUMBER FROM STRING
           READ(STRING(IGO:IEND),*,ERR=7)  FNUM

        ELSE 
         
C          EXTRACT INTEGER FROM STRING
C          STRING CAN ONLY HAVE DIGITS, PERIODS, OR MINUS SIGNS IN IT
C          ACCEPT AN INTEGER IF IT HAS DECIMAL POINT AT END.            

           READ(STRING(IGO:IEND),*,ERR=7) NUM
        ENDIF
        RETURN


7	WRITE(NOUT,8) NCHAR,STRING
8	FORMAT(' *** SYNTAX ERROR.  NO. OF CHARS.= ',I3,' STRING =',A)
	IER = 1

	RETURN
	END
