
C++*******************************************************************
C
C    CHKSTRQ.FOR       ADAPTED FROM CHKSTR AUG 89 al
C
C **************************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK            *
C *  COPYRIGHT (C)1981,1987, WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH 			   *
C **************************************************************************
C
C    CHKSTRQ(STRING,NCHAR,TYPE,NUML,FNUML,INUM,IER)
C
C    PARAMETERS:
C	  STRING	INPUT STRING
C	  NCHAR		# OF CHARACTERS IN INPUT STRING
C	  TYPE		TYPE OF NUMBER
C	  NUML		INTEGER ARRAY, IF NEEDED
C	  FNUML		REAL ARRAY, IF NEEDED
C	  INUM		# OF NUMBERS RETURNED IN NUML OR FNUML
C	  IER		ERROR=0 IF ALL O.K.
C
C   NOTE:   STRING, NCHAR, AND TYPE ARE INPUTTED VALUES
C           NUML, FNUML, INUM, AND IER ARE RETURNED VALUES
C
C--*******************************************************************

      SUBROUTINE CHKSTRQ(STRING,NCHAR,TYPE,NUML,FNUML,INUM,IER)

      COMMON /UNITS/LUN,NIN,NOUT

      DIMENSION      NUML(*),FNUML(*)

      CHARACTER *(*) STRING,TYPE
      CHARACTER *12  SMSTR
      CHARACTER      TP,S
      LOGICAL        PFLAG

C     PFLAG IS SWITCHED ON IF PARAMETER TRANSFER ENCOUNTERED

      INUM  = 0
      IER   = 0
      TP    = TYPE
      PFLAG = .FALSE.

      IF (NCHAR.EQ.0) THEN
        INUM     = 1
        NUML(1)  = 0
        FNUML(1) = 0.
        RETURN
      ENDIF

1     ISM   = 0
      INUMF = 1
      INUMI = 1
      IBL   = 0
      I1    = 1

      IF (STRING(1:1) .EQ. 'x') STRING(1:1) = 'X'
      IF (STRING(2:2) .EQ. 'x') STRING(2:2) = 'X'
      IF (STRING(1:1) .EQ. 'X' .OR. STRING(2:2) .EQ. 'X') THEN
        PFLAG = .TRUE.
	TP    = 'I'

C       DELETE HEADING '(' AND TRAILING ')'  AROUND REGISTER EXPRESSION
	DO 2 I=1,NCHAR
          IF (STRING(I:I).EQ.' ') GOTO 2
          IF (STRING(I:I).EQ.'(') STRING(I:I)=' '
          GOTO 3
2	CONTINUE

3	DO 4 I=NCHAR,1,-1
          IF (STRING(I:I).EQ.' ') GOTO 4
          IF (STRING(I:I).EQ.')') STRING(I:I) = ' '
          GOTO 5
4	CONTINUE
      ENDIF

C     FIND END OF A NUMBER
5     DO I = I1,NCHAR
        IC = I
        S  = STRING(I:I)
        IF (S .EQ. ';') RETURN
        IF (S .NE. ' ' .AND. S .NE. ',' .AND. S .NE. '(' .AND.
     &      S .NE.')' .AND. (.NOT. PFLAG .OR. 
     &     (S .NE. 'X' .AND. S .NE. '-'))) GOTO 20
10      IBL = IBL+1
      ENDDO

      IF (I .GE. NCHAR) RETURN

C     EXTRACT NUMBER
20    I2 = IC
      DO  I = I2,NCHAR
        S = STRING(I:I)
        IF (S.EQ.' ' .OR. S .EQ. ',' .OR. S .EQ. '(' .OR. 
     &      S .EQ.')') GOTO 40
29      SMSTR(I-I2+1:I-I2+1) = STRING(I:I)
        ISM = ISM+1
      ENDDO


40    INUM = INUM +1
      IF (TYPE .EQ. 'R') THEN
         INUMF = INUM
      ELSE
         INUMI = INUM
      ENDIF
      CALL CHKNUMQ(SMSTR,ISM,TP,NUML(INUMI),FNUML(INUMF),IER)
      IF (IER.NE.0) RETURN
      IF (PFLAG) THEN
         NUML(INUMI) = NUML(INUMI)+1
C*       IF (STRING(I2-2:I2-2) .EQ. '-') NUML(INUMI)=-NUML(INUMI) 21MAY90 al
         IF (I2 .GT. 2 .AND.
     &       STRING(I2-2:I2-2) .EQ. '-') NUML(INUMI) = -NUML(INUMI)
      ENDIF

      I1  = I1+ISM+IBL
      ISM = 0
      IBL = 0
      IF (I1 .LT. NCHAR) GOTO 5

      RETURN
      END

