

C----------------------------------=*=----------------------------------        
C           COPYRIGHT 1986 - JEAN-PIERRE BRETAUDIERE                            
C THE UNIVERSITY OF TEXAS HEALTH SCIENCE CENTER AT HOUSTON                      
C MEDICAL SCHOOL - DEPARTMENT OF PATHOLOGY AND LABORATORY MEDICINE              
C P.O. BOX 20708, HOUSTON, TX 77225.                                            
C DISCLAIMER: NO GUARANTEES OF PERFORMANCE ACCOMPANY THIS SOFTWARE,             
C NOR IS ANY RESPONSIBILITY ASSUMED ON THE PART OF THE AUTHOR                   
C OR THE INSTITUTION.  ALL THE SOFTWARE HAS BEEN TESTED EXTENSIVELY             
C AND EVERY EFFORT HAS BEEN MADE TO INSURE ITS RELIABILITY.                     
C THE FOLLOWING SOFTWARE MAY NOT BE COMMUNICATED TO A THIRD PARTY               
C UNDER ANY FORM WITHOUT WRITTEN PERMISSION OF THE AUTHOR.                      
C PLEASE REPORT ANY BUG(S) TO JPB AT (713) 792 52 00.                           
C OR THRU ARPANET AT  ......!rice!ots!ut-path!suprim                            
C*--------------------------------------------------------------------*         
C*                                                                    *         
C*      DETERMINATION OF CLASSES FROM COORDINATES.  THE DISTANCE      *         
C*      BETWEEN OBJECT I AND THE NCLAS CENTERS IS CALCULATED.         *         
C*      THE COORDINATES OF THE NCLAS CENTERS ARE IN G(NCLAS,*).       *         
C*      OBJECT I IS ASSIGNED TO THE NEAREST CLASS.  THE GRAVITY       *         
C*      CENTERS OF THE NEWLY FORMED NCLAS CLASSES ARE DETERMINED      *         
C*      AND USED IN THE NEXT ITERATION.                               *         
C*      FILLINF OF KLAS(ICARD).                                       *         
C*                                                                    *         
C==01.14.81                                                           *         
C==01.12.86                                                           *         
C*--------------------------------------------------------------------*         

      SUBROUTINE CLAST (N2DIM,NFAC,ICARD,KFAC,NCLAS,G,KLAS,CI,PCLAS,            
     #                                                   NGUS  )                
                                                                               
      COMMON /UNITS/LUNC,NIN,NOUT

      DIMENSION KLAS(ICARD),CI(NFAC),PCLAS(NCLAS), G(N2DIM,KFAC)
      DIMENSION VAR(10)
      CALL REW(NGUS, 0)                                                         
      DO   N = 1,NCLAS                                                      
         DO   KF = 1,KFAC                                                      
         G(NCLAS+N,KF)= 0.0                                                        
	 ENDDO
      PCLAS(N)= 0.0                                                             
      ENDDO
                                                                         
C     ASSIGNMENT OF OBJECT TO THE NEAREST CENTER                              
                                                                               
      DO   I = 1,ICARD                                                      
         READ(NGUS)(CI(KF),KF=1,KFAC)                                              
         SUP   = 1.0 E+15                                                          
         KAT   = 1                                                                 
         DO 40  N = 1,NCLAS                                                      
            DIST  = 0.0                                                               
            DO   KF = 1,KFAC                                                      
               DC    = CI(KF) - G(N,KF)                                                  
               DIST  = DIST + DC*DC                                                      
	    ENDDO
            IF (DIST .GT. SUP) GO TO  40                                
            KAT   = N                                                                 
            SUP   = DIST                                                              
   40    CONTINUE                                                                
         KLAS(I)= KAT                                                              
         PCLAS(KAT)= PCLAS(KAT) + 1.0                                              
         DO   KF = 1,KFAC                                                      
           G(NCLAS+KAT,KF)= G(NCLAS+KAT,KF) + CI(KF)                                 
         ENDDO
      ENDDO
                                                                              
C     PROTECTION AGAINST AN EMPTY CLASS (REJECTED FURTHER)               
                                                                              
        DO 80  N = 1,NCLAS                                                      
           IF (PCLAS(N) .GT. 0.0)  GO TO  80                               
           DO   KF = 1,KFAC                                                      
             G(NCLAS+N,KF)= 1.0 E+8                                                    
	   ENDDO
   80   CONTINUE                                                                
                                                                               
C       UPDATE COORDINATES OF THE GRAVITY CENTERS                              
                                                                               
        DO  N = 1,NCLAS                                                     
           IF (PCLAS(N) .LE. 0.0)  PCLAS(N) = 1.0 E-8                    
           DO  KF = 1,KFAC                                                      
             G(N,KF)= G(NCLAS+N,KF) / PCLAS(N)
	   ENDDO
	ENDDO
	DO  N=1,NCLAS
  		VAR(N)=0.0
	ENDDO
	DO I=1,ICARD
	   N=KLAS(I)
	   DO KF=1,KFAC
	   VAR(N)=VAR(N)+(CI(KF)-G(N,KF))**2
	   ENDDO
	ENDDO
	DO N=1,NCLAS
	   WRITE(NOUT,*) N,VAR(N),(G(N,KF),KF=1,KFAC)
	ENDDO

        RETURN                                                                 
        END                                                                    
