C++************************************************************************
C
C $$ CLUSTERLST.FOR
C
C **************************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK            *
C *  COPYRIGHT (C)1981,1987, WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *  THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR       *
C *  LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR    *
C *  USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF     *
C *  THE CENTER FOR LABORATORIES AND RESEARCH   			   *
C **************************************************************************
C
C
C
C--************************************************************************
C
C $$ CLUSTERLST.FOR
C
         SUBROUTINE CLUSTERLST(NDOC,VMIN,VMAX,NKLA,V,NUM,
     #                 ICARD,KLAS,IDI,IRTFLG)

         COMMON /UNITS/ LUNC,NIN,NOUT

         DIMENSION V(NKLA),DLIST(4),NUM(NKLA)
     	 DIMENSION KLAS(ICARD),IDI(ICARD)
         INTEGER      NUMT, IKEY
         CHARACTER *4 CNUM
         EQUIVALENCE  (CNUM,NUMT)
CNO_SAVE
         IF (VMAX .EQ. VMIN) THEN
C        PREVENT DIVISION BY ZERO
         WRITE(NOUT,*) 'DENLST ABORTED TO AVOID DIVISION BY 0'
         IRTFLG = 1
         RETURN
         ENDIF

         FACT = 1.0 / (VMAX - VMIN)

	 IKEY = 1

C	 FIND THE LAST HIGHEST CLASS -- THE SMALLEST V(I) WHICH ISN'T ZERO
	 CLUMIN = VMAX
	 DO I = 1,NKLA
 	   IF((V(I).LE.CLUMIN).AND.(V(I).NE.VMIN)) THEN
	     CLUMIN = V(I)
	   ENDIF
	 ENDDO


         DO I = 1,NKLA

C        FOR SOME REASON NUM IS STORED AS CHAR. IN INTEGER VARIABLES
         NUMT = NUM(I)
c this is temporary - the problem is for N>9999
         READ(CNUM,8000,ERR=21) N
8000     FORMAT(I4)
	GOTO 22
21	N=I
22	CONTINUE

         DLIST(4) = N

C	 SET THE HEIGHTS TO A SMALL VALUE, SO IT WON'T BE DISPLAY IN WEB
         DLIST(3) = 0.0

C        STORE THIS CLASS IN DOC FILE
	 K = 0
         DO  J=1, ICARD
          IF(KLAS(J).EQ.N) THEN

C	    SAVE THE PREVIOUS IMAGE
	    IF(K.NE.0) CALL SAVD(NDOC,DLIST,4,IRTFLG)

            DLIST(1) = IKEY
            DLIST(2)=IDI(J)
	    IKEY = IKEY +1
	    K = K+1
          ENDIF
	 ENDDO


C 	 USE THE ORIGINAL HEIGHT FOR THE LAST MEMBER OF THE CLASS
C        NORMALIZE THE V VALUES FROM 0...1.0
	 IF (V(I).NE.VMIN) THEN
           DLIST(3) = (V(I) - VMIN) * FACT
	 ELSE 
	   DLIST(3) = (CLUMIN - VMIN) * FACT/2
	 ENDIF
         CALL SAVD(NDOC,DLIST,4,IRTFLG)
	 
	 ENDDO
         CALL  SAVDC
         CLOSE(NDOC)
         IRTFLG = 0
         END
