
C++*************************************************************************
C
C  CNDISP.FOR  -- CREATED JULY 92
C **************************************************************************
C *  AUTHOR: A. LEITH                                                      *
C *  COPYRIGHT (C)1992, WADSWORTH CENTER FOR LABORATORIES AND              *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH 			   *
C **************************************************************************
C
C    CNDISP(CSFILET,POSTFILET,DEFPOSTNAME,GOPRINT,LUNCS,LUNPOST,IRTFLG)
C
C    PURPOSE:       SELECT OPTIONS FOR DISPLAY OF CNT FILES
C
C    PARAMETERS:    CSTILET      CNT FILE NAME (WITH EXTENSION)   (READ)
C                   POSTFILET    POSTSCRIPT FILE NAME (WITH EXT.) (READ)
C                   DEFPOSTNAME  DEFAULT THE POST. FILE NAME      (READ)
C                   GOPIRINT     IMMEDIATE PRINT-OUT              (READ)
C                   LUNCS        CNT FILE UNIT                    (READ)
C                   LUNPOST      POST. FILE UNIT                  (READ)
C                   IRTFLG       ERROR RETURN
C
C    CALLED BY:     PLOT1
C
C    CALLS:         RDPRMC     SSTOGL    CNPOST
C        0         2         3         4         5         6         7
C23456789012345678901234567890123456789012345678901234567890123456789012
C--*********************************************************************

       SUBROUTINE CNDISP(CSFILET,POSTFILET,DEFPOSTNAME,GOPRINT,
     &                   LUNCS,LUNPOST,IRTFLG)

       INCLUDE 'CMBLOCK.INC'
       INCLUDE 'CONSTG.INC'

       LOGICAL ONSUN,ONUNIX,ONSGI,ONOSF
       COMMON /OPSYS/ ONSUN,ONUNIX,ONSGI,ONOSF,MEMALLOCABLE

       CHARACTER *(*) CSFILET,POSTFILET
       CHARACTER *81  CSFILE,POSTFILE

       CHARACTER *60  LIN1
       CHARACTER * 80 COMLIN
       CHARACTER * 20 OUTDEV(7)
       CHARACTER * 3  ANSW,DISP
       CHARACTER * 1  NULL

       LOGICAL        ASK,NEEDSEND,NEEDSTART,GOTSHOW,DEFPOSTNAME
       LOGICAL        CENTER,FLIP,HIDE,FILLED,INVERZ,FRAMES
       LOGICAL        DOTEXT,GOPRINT
         
        DATA MININT/-32768/,MAXINT/32767/,FLTMIN/-10E30/,
     &       FLTZER/10E-30/,FLTMAX/10E30/

        DATA OUTDEV(1)/'DEC Terminal        '/,
     &       OUTDEV(2)/'Gould Plotter       '/,
     &       OUTDEV(3)/'Lexidata monitor    '/,
     &       OUTDEV(4)/'printer Hardcopy    '/,
     &       OUTDEV(5)/'Tektronix plotter   '/,
     &       OUTDEV(7)/'Postscript file     '/

	NULL=CHAR(0)
C      OPEN THE EXISTING CONTOUR STORAGE INPUT FILE

       IF (CSFILET .EQ. NULL) THEN
C        SOLICIT CONTOUR FILE NAME FROM USER
c1        CALL FILERD(CSFILE,NLET,NULL,'CONTOUR INPUT',IRTFLG)
         CALL FILERD(CSFILE,NLET,NULL,'CONTOUR INPUT',IRTFLG)
         IF (IRTFLG .EQ. -1) RETURN
         IF (NLET .GT. 0) CSFILE   = CSFILE(:NLET) // '.' // DATEXC

       ELSE
C        USE FILE NAME SENT BY CALLER (MUST HAVE EXTENSION ON IT!)
         CSFILE = CSFILET

         NLET   = 1
       ENDIF

c      avoid jump inside a loop 
1      continue
       IF (NLET .GT. 0) THEN
         NEEDSEND = .TRUE.
         DISP     = 'O'
         CALL CNOPN(CSFILE,DISP,LUNCS,IRCLND,IRTFLG)
C         IF (IRTFLG .NE. 0) GOTO 1
         IF (IRTFLG .NE. 0) THEN
           CALL FILERD(CSFILE,NLET,NULL,'CONTOUR INPUT',IRTFLG)
           IF (IRTFLG .EQ. -1) RETURN
           IF (NLET .GT. 0) CSFILE   = CSFILE(:NLET) // '.' // DATEXC
	   GOTO 1
         END IF
         IF (SCALE .EQ. 0.0) THEN
C          FILE NEEDS SCALING
           CALL CSSCALT(LUNCS,0)
           CALL CSTRAP(LUNCS)
         ENDIF
       ELSE
C        DO NOT WANT TO USE A CNT FILE FOR INPUT
         NEEDSEND = .FALSE.
       ENDIF  
               

C      GET FILE NAME FOR POSTSCRIPT OUTPUT FILE (NEW OR EXISTING)
       DISP    = 'UNK'

       IF (DEFPOSTNAME) THEN
C        CREATE POSTSCRIPT FILE NAME FR0M CNT FILE NAME (HAS EXT)

         NLEN     = LASTOCCUR(CSFILE,0,'.')
         POSTFILE = CSFILE(1:NLEN-1) // '_p' // CSFILE(NLEN:)
         NLETP    = LASTOCCUR(POSTFILE,0,'.') - 1
         WRITE(NOUT,*) ' NEW POSTSCRIPT FILE: ',POSTFILE(1:NLETP+4)
         NEEDSTART = .TRUE.
         DISP = 'NEW'
         GOTO 100

       ELSEIF (POSTFILET .EQ. NULL) THEN
C        SOLICIT NAME FROM USER
2        CALL FILERD(POSTFILE,NLETP,NULL,'POSTSCRIPT',IRTFLG)
C         IF (IRTFLG .NE. 0) GOTO 1
         IF (IRTFLG .NE. 0)  THEN
           CALL FILERD(CSFILE,NLET,NULL,'CONTOUR INPUT',IRTFLG)
           IF (IRTFLG .EQ. -1) RETURN
           IF (NLET .GT. 0) CSFILE   = CSFILE(:NLET) // '.' // DATEXC
	   GOTO 1
	 END IF
	 
         POSTFILE = POSTFILE(1:NLETP) // '.' // DATEXC // NULL

       ELSE
C        USE THE FILE WHOSE NAME IS SENT FROM THE CALLER
         POSTFILE = POSTFILET
         NLETP    = LASTOCCUR(POSTFILE,0,'.') - 1
       ENDIF

C      FIND IF POSTSCRIPT FILE NEEDS INTRODUCTORY HEADER 
       INQUIRE (FILE=POSTFILE,EXIST=NEEDSTART)
       NEEDSTART = .NOT. NEEDSTART
       
100    CONTINUE
       CALL AUXOPN(POSTFILE,DISP,LUNPOST,IRTFLG)
       IF (.NOT. NEEDSTART) THEN
C         POSITION FILE BEFORE SHOWPAGE STATEMENT

          WRITE(NOUT,*) 'WARNING: ADDING TO EXISTING POSTSCRIPT FILE: ',
     &                   POSTFILE

          GOTSHOW = .FALSE.
          DO WHILE (.NOT. GOTSHOW)
            READ (LUNPOST,80,END=5) COMLIN
80          FORMAT(A)
            IF ((INDEX(COMLIN,'showpage') .GT. 0) .OR.
     &          (INDEX(COMLIN,'SHOWPAGE') .GT. 0)) THEN
                BACKSPACE(UNIT=LUNPOST)
                GOTSHOW = .TRUE.
            ENDIF
          ENDDO
       ENDIF
5      CONTINUE

C     NOTE: AT THIS POINT CSFILE AND POSTFILE DO NOT HAVE EXTENSIONS ON THEM

C     POSTSCRIPT OUTPUT FILE POSITIONED AT CORRECT LOCATION
      ASK      = .TRUE.

      DOTEXT = .TRUE.
      CENTER = .TRUE.
      FLIP   = .FALSE.
      HIDE   = .FALSE.
      FILLED = .FALSE.
      FRAMES = .FALSE.
      INVERZ = .FALSE.
      PLSCL  = 950.0
      IF (GOPRINT) THEN
         WRITE(NOUT,*) ' USE "CS DI PO" FOR FURTHER PLOTS OF THIS FILE'
         GOTO 21
      ENDIF

 3    WRITE(NOUT,*) ' '
      WRITE(NOUT,*) ' Plot Menu (enter MEN to see the choices).'

 4    CALL RDPRMC(ANSW,NCHAR,.TRUE.,
     &    'Enter plot menu choice',NULL,IRTFLG)
      IF (NCHAR .EQ. 0 .OR. IRTFLG .EQ. -1) RETURN

C                   11 12 13 14 15 16 17 18 19 20 21 22 23 24 30 
      LIN1(1:45) = 'CNTSENSCAHIDLABCENFILFRAINZFLIPRICOMLOCTEXTST'
C                   50 52
      LIN1(46:60)= 'RETMEN'

C     CHECK REPLY STRING
      J = INDEX(LIN1,ANSW)
      IF (J .GT. 0) THEN
C        FIND THE CHOICE NO. FROM THE POSITION IN THE STRING
         ISEL = (J + 2) / 3
      ELSE
         WRITE(NOUT,*)' NOT A VALID SELECTION, PLEASE TRY AGAIN'
         GOTO 4
      ENDIF

      GOTO (11,12,13,14,15,16,17,18,19,20,21,22,23,24,30,50,52),ISEL



   11 CONTINUE        
C        NEW CNT INPUT FILE                               CNT
         CLOSE(LUNCS)
C        SOLICIT CONTOUR FILE NAME FROM USER
 111     CALL FILERD(CSFILE,NLET,NULL,'CONTOUR',IRTFLG)
         IF (IRTFLG .NE. 0) GOTO 4
         CSFILE   = CSFILE(1:NLET)//'.' // DATEXC // CHAR(0)
         DISP     = 'O'
         CALL CNOPN(CSFILE,DISP,LUNCS,IRCLND,IRTFLG)
         IF (IRTFLG .NE. 0) GOTO 111
         ASK      = .TRUE.
         NEEDSEND = .TRUE.
         IF (SCALE .EQ. 0.0) THEN
C          FILE NEEDS SCALING
           WRITE(NOUT,*)' SCALING CONTOUR FILE NOW.'
           CALL CSSCALT(LUNCS,0)
           CALL CSTRAP(LUNCS)
         ENDIF
         GOTO 4

   12 CONTINUE
C        SEND TO OUTPUT DEVICE                            SEN
         CALL CNPOST(CSFILE,POSTFILE,LUNCS,LUNPOST,PLSCL,
     &               CENTER,FLIP,HIDE,FILLED,INVERZ,FRAMES,
     &               NEEDSTART,.FALSE.,DOTEXT,IRTFLG)
         NEEDSTART = .FALSE.
         NEEDSEND  = .FALSE.
         GOTO 4


   13 CONTINUE        
C..      ALTER PLOT SCALING                                SCA
         PLSCLT = PLSCL / 10.0
         WRITE(NOUT,90) PLSCLT
90       FORMAT('  CURRENT SCALING FACTOR (% OF FULL PAGE): ',F7.2)

         CALL RDPRM2S(PLSCLT,FDUM,NLOOP,ILOOP,
     &      'Enter new scaling factor or <CR>',IRTFLG)
         IF (IRTFLG .EQ. -1) GOTO 4

         PLSCL = PLSCLT * 10
         ASK   = .TRUE.
         GOTO 4

   14 CONTINUE        
C        HIDDEN LINE                                      HID
         CALL SSTOGL(HIDE,' Hidden line removal.',
     &     ' No hidden line removal.',.TRUE.,ASK,IRTFLG)
         GOTO 4


   15 CONTINUE        
C        LABEL CONTOURS                                   LAB
         CALL SSTOGL(LABELS,' Contours labeled.',
     &     ' Contours not labeled.',.TRUE.,ASK,IRTFLG)
         GOTO 4

   16 CONTINUE        
C        CENTER CONTOURS                                  CEN
         CALL SSTOGL(CENTER,' Center plot.',
     &      ' Do not center plot.',.TRUE.,ASK,IRTFLG)
         GOTO 4

   17 CONTINUE        
C        FILLED CONTOURS                                  FIL
         CALL SSTOGL(FILL,' Fill contours.',
     &      ' Do not fill contours.',.TRUE.,ASK,IRTFLG)
         GOTO 4

   18 CONTINUE        
C        DRAW FRAMES                                      FRA
         CALL SSTOGL(FRAME,' Draw frame.',
     &      ' Do not draw frame.',.TRUE.,ASK,IRTFLG)
         GOTO 4

   19 CONTINUE        
C        INVERT Z ORDER OF CONTOURS                       INZ
         CALL SSTOGL(INVERZ,' Invert Z order.',
     &      ' Do not invert Z order.',.TRUE.,ASK,IRTFLG)
         GOTO 4

   20 CONTINUE        
C        MIRROR AOUND X AXIS                              FLI
         CALL SSTOGL(FLIP,' Mirror aound X axis.',
     &      ' Do not mirror X axis.',.TRUE.,ASK,IRTFLG)
         GOTO 4


   21 CONTINUE                                           
C        PRINT POSTSCRIPT FILE NOW                        PRI
         IF (NEEDSEND) THEN
c**        WRITE(NOUT,*) ' ADDING CNT DATA TO POSTSCRIPT FILE '
           CALL CNPOST(CSFILE,POSTFILE,LUNCS,LUNPOST,PLSCL,
     &               CENTER,FLIP,HIDE,FILLED,INVERZ,FRAMES,
     &               NEEDSTART,.FALSE.,DOTEXT,IRTFLG)
           NEEDSTART = .FALSE.
           NEEDSEND  = .FALSE.
         ENDIF

         CALL POEND(LUNPOST)
         CLOSE(LUNPOST)

         WRITE(NOUT,*) ' WARNING: SITE SPECIFIC COMMAND IN CNDISP'
         IF (ONUNIX) THEN
            COMLIN = 'lpr -Pyap -h ' // POSTFILE(1:NLETP) // '.' // 
     &                DATEXC // NULL
         ELSE
            COMLIN = 'PRINT/NOFLAG/QUE=SPIDER_POST_QUE ' // 
     &             POSTFILE(1:NLETP) // '.' // DATEXC // NULL
         ENDIF
         CALL CSVMS(COMLIN,IERR)

         ASK = .FALSE.
         RETURN


   22 CONTINUE
C        ADD COMMENT TO POSTSCRIPT FILE                    COM
         CALL RDPRMC(COMLIN,NALP,.TRUE.,
     &               'COMMENT (OR <CR> FOR NONE)',NULL,IRTFLG)
         IF (NALP .GT. 0) THEN
           IF (NEEDSTART) THEN
              CALL POSTRT(LUNPOST)
              NEEDSTART = .FALSE.
           ENDIF
           CALL POTEXT(LUNPOST,COMLIN,NALP)
         ENDIF
         GOTO 4

   23 CONTINUE
C        SET LOCATION IN POSTSCRIPT FILE                    LOC

         IF (NEEDSTART) THEN
            CALL POSTRT(LUNPOST)
            NEEDSTART = .FALSE.
         ENDIF

         CALL RDPRM2S(FX,FY,NLOOP,ILOOP,
     &   'X & Y COOR. (0..1000 WITH ORIGIN AT UPPER LEFT)',IRTFLG)

         IF (IRTFLG .NE. -1) THEN
            FX = FX - 640.0
            FY = 511.0  - FY
            CALL POPATH(LUNPOST,FX,FY)
         ENDIF
         GOTO 4
           
   24 CONTINUE        
C        PRINT TEXT                                         TEX
         CALL SSTOGL(DOTEXT,' Print text.',
     &      ' Do not print text.',.TRUE.,ASK,IRTFLG)
         GOTO 4

   50 CONTINUE        
C        RETURN AFTER CLOSING POSTSCRIPT FILE               RET
         CALL POEND(LUNPOST)
         CLOSE(LUNPOST)
         RETURN 


   52 CONTINUE
C       LIST MENU                                           MEN
        IF (ICNTFMT .EQ. 0) THEN
          CALL CNHELP('cnhl01.men',12)
        ELSE
          CALL CNHELP('cnhl02.men',12)
        ENDIF
        GOTO 4

   30 CONTINUE
C       TEST SOMETHING
        IF (NEEDSTART) THEN
            CALL POSTRT(LUNPOST)
            NEEDSTART = .FALSE.
        ENDIF
        CALL POTEX(LUNPOST,'UPPER LEFT',10,  -200.0, 200.0, 32,0,0)
        CALL POTEX(LUNPOST,'LOWER RIGHT',11,  200.0,-200.0, 32,0,0)
        CALL POLL(LUNPOST)
        CALL POTEXT(LUNPOST,'NEW LOWER LEFT',14)
        GOTO 4
      END         

