
C++*************************************************************************
C
C CNHELP.FOR        
C
C **************************************************************************
C *  COPYRIGHT (C)1985, WADSWORTH CENTER FOR LABORATORIES AND             *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH  			   *
C **************************************************************************
C
C    CNHELP(DOCFIL,LUNDOC)
C
C    PURPOSE:  READ HELP DOCUMENTATION FILE AND DISPLAY IT ON TERMINAL
C
C    PARAMETERS:   DOCFIL    DOCUMENT FILENAME WITH EXTENSION
C                  LUNDOC    UNIT TO BE USED FOR OPENING THE DOCUMENT FILE
C
C    CALLED BY:    CNDISP
C
C--*******************************************************************

      SUBROUTINE CNHELP(DOCFIL,LUNDOC)
       
      INCLUDE 'CMBLOCK.INC'

      LOGICAL ONSUN,ONUNIX,ONSGI,ONOSF
      COMMON /OPSYS/ ONSUN,ONUNIX,ONSGI,ONOSF,MEMALLOCABLE

      CHARACTER *(*) DOCFIL
      CHARACTER * 80 LINE,DIRNAM
      CHARACTER * 9  ENVVAR
      CHARACTER * 1  NULL

      DATA ENVVAR/'SPMAN_DIR'/

	NULL=CHAR(0)

      CALL MYGETENV(ENVVAR,DIRNAM,NCHAR,
     &              'DIR_CONTAINING_SPIDER_MANUALS',IRTFLG)
      IF (IRTFLG .NE. 0) RETURN

      IF (ONUNIX) THEN
         LINE =  DIRNAM(:NCHAR) // DOCFIL // NULL
      ELSE
         LINE =  DIRNAM(:NCHAR) // ':' // DOCFIL // NULL
      ENDIF

C     OPEN THE FILE
      OPEN(LUNDOC,FILE=LINE,STATUS='OLD',ERR=9999)

C     READ LINES FROM THE FILE AND DISPLAY ON THE TERMINAL
  10  READ(LUNDOC,80,END=100) LINE
  80  FORMAT(A)

      WRITE(NOUT,90) LINE
  90  FORMAT(1X,A)
      GOTO 10


   
 100  CLOSE(LUNDOC)
      RETURN

 9999 CONTINUE
C     REPORT ERROR AND RETURN
      WRITE(NOUT,91) LINE
  91  FORMAT(' *** ERROR OPENING: ',A)
      CALL ERRT(100,'CNHELP',NE)
      RETURN
      END

