
C**************************************************************************
C
C   CNINT4.FOR  -- CREATED JAN 87             LONG FILE NAMES FEB 89 al
C
C **************************************************************************
C *  AUTHOR: ArDean Leith 
C *  COPYRIGHT (C)1987 , WADSWORTH CENTER FOR LABORATORIES AND RESEARCH    *
C *    NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.              *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH  			   *
C **************************************************************************
C
C      CNINT4(EXTEN,UNUSED,MAXDIM)
C
C      PURPOSE:     READS  SPIDER PICTURE FILES, EXTRACTS CONTOURS, AND 
C                   TRANSFERS THEM TO SERIAL SECTION INPUT FILE
C
C      PARAMETERS:  EXTEN        EXTENSION
C                   MAXDIM       COMMON BUFFER LENGTH
C
C      CALLED BY:   PLOT1
C
C      CALLS:       RDPRC             RDPRIS            REDLIN 
C                   CNTUR             GETNUM            FILGET             
C                   RDPRM2S           FILSEQ
C
C                                                  ...CNCALC
C      CALL TREE:   PLOT1...CNINT4...CNTUR...CNSCAN...CNTRCE...SSPUSH
C
C--********************************************************************

        SUBROUTINE CNINT4(EXTEN,UNUSED,MAXDIM)

        INCLUDE 'CONSTG.INC'
        INCLUDE 'CMBLOCK.INC'
CNO_SAVE
  
C---------------------------------------------------------
       PARAMETER       (KULIAH=20)
       CHARACTER * 4   CLASNM(KULIAH)
       COMMON /SSRECN/ NSEC,NPLAN,NCLAS,NCNT,
     &                 ISEC,IPLAN,ICLAS,ICNT,LUNSS,CLASNM
C---------------------------------------------------------

C*      NMAXIRR IS DIM. OF PIXEL TAGGED ARRAY (MAY NEED TO BE BIGGER)
        PARAMETER       (NMAXIRR = 50000)

C*      NMAXI IS DIMENSION OF X AND Y ARRAYS
        PARAMETER       (NSIZE   = 2000)
        PARAMETER       (NMAXI   = 2000)
        INTEGER         SLICES,NUMBER
        COMMON          X(NMAXI),Y(NMAXI),DATA(3,NSIZE),SLICES(200),
     &                  NUMBER(200),BUF(1)

        COMMON /POLY/   MINPTS
        CHARACTER * 81  CNTFIL,FILNAM,FILPAT
        COMMON /COMMUN/ CNTFIL,FILNAM,FILPAT

        CHARACTER *(*)  EXTEN
        DIMENSION       DATAFR(3,5)
        CHARACTER * 4   CLCODE
        CHARACTER * 1   CCHAR,NULL,ANSW
        LOGICAL         MULTIZ,ERRI2,ISOLDFILE,NEWFILE
       
        DATA FLTZER,LUNIM,LUNSS/10E-30,11,12/

C       MAXPTS CONTROLS NUMBER OF POINTS ON STORED CONTOURS
        DATA MAXPTS/400/

        NULL=CHAR(0)

        MAXPIX = MAXDIM  - NMAXIRR - 2*NMAXI - 3*NSIZE - 400
        MULTIZ = .TRUE.


4000    CALL RDPRMC(ANSW,N,.TRUE.,'NEW STERECON INPUT FILE? (Y/N)',
     &              NULL,IRTFLG)
        IF (IRTFLG .EQ. -1) RETURN

4001    CALL RDPRMC(CNTFIL,NLET1,.TRUE.,
     &              'ENTER STERECON FILE NAME',NULL,IRTFLG)
        IF (IRTFLG .EQ. -1) GOTO 4000

        ISOLDFILE =  (ANSW .EQ. 'N' .OR. ANSW .EQ. 'n')

C       USE OPENDOC TO OPEN A TEXT FILE (WITHOUT STARTING DOC COMMENT)
        CNTFIL(NLET1+1:NLET1+1) = NULL 
        CALL OPENDOC(CNTFIL,.TRUE.,NLET,LUNSS,.FALSE.,
     &                     ISOLDFILE,ISOLDFILE,.FALSE.,NEWFILE,IRTFLG)

        IF (NEWFILE) THEN

C          FIND MAXIMUM NUMBER OF SECTIONS 
           NSEC   = 200
4002       CALL RDPRIS(NSEC,IDUM,NLOOP,ILOOP,
     &        'MAX NUMBER OF SECTIONS IN THE RECONSTRUCTION',IRTFLG)
           IF (IRTFLG .EQ. -1) GOTO 4000
           IF (ERRI2(NSEC,IDUM,1,1,MAXTOR,IDUM,IDUM)) GOTO 4002

C          FIND MAXIMUM NUMBER OF CONTOURS ON A SECTION 
           NCNT   = 50
4003       CALL RDPRIS(NCNT,IDUM,NLOOP,ILOOP,
     &        'MAX NUMBER OF CONTOURS IN ANY SECTION',IRTFLG)
           IF (IRTFLG .EQ. -1) GOTO 4002

C          ONLY ONE PLANE PER SECTION
           NPLAN  = 1
           IPLAN  = 1

C          FIND MAXIMUM NUMBER OF CLASSES 
           IMAX   = KULIAH
           NCLAS  = 1
4004       CALL RDPRIS(NCLAS,IDUM,NLOOP,ILOOP,
     &        'NUMBER OF CLASSES IN THE RECONSTRUCTION',IRTFLG)
           IF (IRTFLG .EQ. -1) GOTO 4003
           IF (ERRI2(NCLAS,IDUM,1,1,IMAX,IDUM,IDUM)) GOTO 4004

C          Enter CLASS CODE (FOUR LETTERS) FOR EACH CLASS

4005       IF (NCLAS .EQ. 1) THEN
             CLASNM(1) = 'CONT'
             ICLAS = 1
           ELSE
             I = 1
6003         IMOD10 = MOD(I,10)
             IF (IMOD10 .LE. 0) IMOD10 = 10
             WRITE(NOUT,103) I
  103        FORMAT(' Class number = ',I2)
             CALL RDPRMC(CLCODE,N,.TRUE.,
     &          '.ENTER CLASS NAME (4 CHAR.)',NULL,IRTFLG)

             IF (IRTFLG .EQ. -1) THEN
                I = I - 1
                IF ( I .GT. 0) THEN
                   GOTO 6003
                ELSE
                   GOTO 4004
                ENDIF
             ENDIF

             CLASNM(I) = CLCODE(1:4)
             I = I  + 1
             IF (I .LE. NCLAS) GOTO 6003
           ENDIF

           WRITE(LUNSS,90)NSEC,NPLAN,NCLAS,NCNT 
 90        FORMAT(4I10)

        ENDIF

C       GET IMAGE FILE NAMES

4007    WRITE(NOUT,*) ' FOR IMAGE FILE SERIES:'
        NIMAG = 100
        CALL FILSEQP(FILPAT,NLET,NUMBER,200,NIMAG, 
     &       'FILE PREFIX OR TEMPLATE (EG. PIC****)', IRTFLG)
        IF (IRTFLG .NE. 0) RETURN

        ISEC  = 0

        IF (NCLAS .GT. 1) THEN
C         NEED CLASS NAME INPUT
4008      CALL RDPRMC(CLCODE,NCHAR,.TRUE.,
     &       '.ENTER CONTOUR CLASS NAME',NULL,IRTFLG)
          IF (IRTFLG .EQ. -1) GOTO 4007

          ICLAS = 0
          DO IT = 1, NCLAS
             IF (CLCODE .EQ. CLASNM(IT)) THEN
                ICLAS = IT
                GOTO 4009
             ENDIF
          ENDDO

 4009     IF (ICLAS .EQ. 0) THEN
C            SET ERROR FLAG
             WRITE(NOUT,102)LINE
  102        FORMAT(' NO CLASS FOUND FOR ',A4,'. VALID CLASSES ARE:')
             WRITE(NOUT,101)(CLASNM(J),J = 1, NCLAS)
  101        FORMAT(16(1X,A4))
          ENDIF

          WRITE(NOUT,9919) 
9919      FORMAT(' If you want to have contours of different classes in'
     &           ,' the same',/,' reconstruction use the CO S operation'
     &           ,' multiple times with same output file.'/)
        ENDIF

C       SET INVARIABLE CORNERS FOR FRAME
        DATAFR(1,1) = 0.0
        DATAFR(2,1) = 0.0
        DATAFR(1,2) = 0.0
        DATAFR(2,4) = 0.0
        DATAFR(1,5) = 0.0
        DATAFR(2,5) = 0.0
        NDATAF      = 5

        DO IFIL = 1,NIMAG
          CALL FILGET(FILPAT,FILNAM,NLET,NUMBER(IFIL),IRTFLG)
          IF (IRTFLG .NE. 0) GOTO 1000
         
C         OPEN A SPIDER IMAGE TYPE FILE AS INPUT
          MAXIM = 0
          CALL OPFIL(.FALSE.,FILNAM,LUNIM,'O',NSAM,NROW,NSLICE,
     &             MAXIM,'XXXX',.FALSE.,IRTFLG)
          IF (IRTFLG .NE. 0) GOTO 1000
 
          IF (IMAMI .NE. 1) THEN
C           FIND IMAGE MIN AND MAX
            CALL NORM3(LUNIM,NSAM,NROW,NSLICE,FMAX,FMIN,AV)
          ENDIF
            
          IF ((FMAX - FMIN) .LT. FLTZER) THEN
            WRITE(NOUT,*) ' *** ERROR: BLANK FILE SKIPPED '
            GOTO 99
          ENDIF

C         DISPLAY MAX AND MIN VALUE OF PICTURE , ASK FOR THE CONTOUR LEVELS
          WRITE(NOUT,106) FMIN,FMAX
  106     FORMAT(' IMAGE RANGE: ',1PG11.3,'....',1PG11.3)

          IF (IFIL .EQ. 1) THEN

 1009       CALL RDPRM2S(BLEV,FDUM,NLOOP,ILOOP,
     &         'STARTING CONTOUR LEVEL',IRTFLG)
            IF (IRTFLG .EQ. -1) GOTO 4007

 1010       CALL RDPRM2S(ELEV,FDUM,NLOOP,ILOOP,
     &         'ENDING CONTOUR LEVEL',IRTFLG)
            IF (IRTFLG .EQ. -1) GOTO 1009

 1011       CALL RDPRM2S(RINC,FDUM,NLOOP,ILOOP,
     &        'CONTOUR LEVEL INCREMENT (>>ENDING FOR 1 CONTOUR)',IRTFLG)
            IF (IRTFLG .EQ. -1) GOTO 1010

 1012       MINPTS = 0
            CALL RDPRIS(MINPTS,IDUM,NLOOP,ILOOP,
     &         'MIN LENGTH CONTOUR SAVED',IRTFLG)
           IF (IRTFLG .EQ. -1) GOTO 1011
          ENDIF

          IF (IFORM .EQ. 1) THEN
C            2-D IMAGE FILE

             IF ((NSAM * NROW) .GT. MAXPIX) THEN
               WRITE(NOUT,9945) MAXPIX
 9945          FORMAT(' SORRY, PGM LIMIT:',I7,' PIXELS, FILE SKIPPED'/)
               GOTO 1000
             ENDIF

C..          READ THE SPIDER FILE INTO AM ARRAY
             J = NMAXIRR + NSAM * NROW + 1
             DO I = 1,NROW
               J = J - NSAM
               CALL REDLIN (LUNIM,BUF(J),NSAM,I)
             ENDDO

             ISEC = ISEC + 1

C            SET ZCOO TO FILE NUMBER - FIRST FILE NUMBER
             ZCOO = NUMBER(IFIL) - NUMBER(1)

C            CNTUR EXTRACTS CONTOURS FROM THE IMAGE FILE AND PLACES
C            THEM IN THE CONTOUR STORAGE FILE, INCREMENTS ICNT FOR EACH
C            CONTOUR EXTRACTED FROM THIS FILE

C            SET VARIABLE PART OF FRAME SIZE FOR FIRST CONTOUR IN EACH SECTION
             DATAFR(2,2) = NROW
             DATAFR(1,3) = NSAM
             DATAFR(2,3) = NROW
             DATAFR(1,4) = NSAM

C            PUT IN FRAME
             ICLAS = 1
             ICNT  = 1
             CALL SSPUSH(DATAFR,NDATAF,NF)

             CALL CNTUR(BUF(NMAXIRR+1),NROW,NSAM,BLEV,ELEV,RINC,BUF,
     &           X,Y,NMAXI,LUNSS,MULTIZ,MAXPTS,NMAXIRR)

          ELSE IF (IFORM .EQ. 3) THEN
C            3-D VOLUME FILE

13           CALL RDPRMC(ANSW,NC,.TRUE.,'ENTER SLICE AXIS (X,Y,Z)',
     &       NULL,IRTFLG)
             IF (IRTFLG .EQ. -1) THEN
                CLOSE(LUNIM)
                GOTO 4007
             ENDIF
             IF (NC .EQ. 0) ANSW = 'Z'

             CCHAR = ANSW
             IF (CCHAR .EQ. 'X') WRITE(NOUT,9978)
9978         FORMAT(' WARNING: X SLICING IS VERY SLOW!'/)

             IF ((CCHAR .EQ. 'Z' .AND. (NSAM * NROW) .GT. MAXPIX) .OR.
     &         (CCHAR .EQ. 'X' .AND. (NSLICE * NROW) .GT. MAXPIX) .OR.
     &         (CCHAR .EQ. 'Y' .AND. (NSAM * NSLICE) .GT. MAXPIX)) THEN
               WRITE(NOUT,9945) MAXPIX
               GOTO 1000
             ENDIF

C            SET VRIABLE PART OF FRAME SIZE FOR FIRST CONTOUR IN EACH SECTION
             IF (CCHAR .EQ. 'Z') THEN
               DATAFR(2,2) = NROW
               DATAFR(1,3) = NSAM
               DATAFR(2,3) = NROW
               DATAFR(1,4) = NSAM

             ELSEIF (CCHAR .EQ. 'Y') THEN
               DATAFR(2,2) = NSLICE
               DATAFR(1,3) = NSAM
               DATAFR(2,3) = NSLICE
               DATAFR(1,4) = NSAM

             ELSEIF (CCHAR .EQ. 'X') THEN
               DATAFR(2,2) = NSLICE
               DATAFR(1,3) = NROW
               DATAFR(2,3) = NSLICE
               DATAFR(1,4) = NROW
             ENDIF

 
14           NUMSLI = 200
             CALL RDPRAI(SLICES,200,NUMSLI,1,NSLICE,
     &            'ENTER SLICE NUMBERS',NULL,IRTFLG)

             DO KJ = 1,NUMSLI

               ISEC = ISEC + 1
C              ICNT IS INCREMENTED IN CNTRCE
               ZCOO = ISEC
               IF (CCHAR .EQ. 'Z') THEN
C                 3-D FILE WITH Z SLICE
                  ISLICE = SLICES(KJ)
                  IF (ISLICE .LT. 1 .OR. ISLICE .GT. NSLICE) THEN
C                    NONEXISTENT SLICE
                     WRITE(NOUT,9911) ISLICE,NSLICE
9911                 FORMAT(' *** ERROR: SLICE',I5,' MUST BE <=',I5/)
                     GOTO 40
                  ENDIF

                  NREC1 = (ISLICE - 1) * NROW + 1
                  NREC2 = NREC1 + NROW - 1

C..               READ THE SPIDER FILE INTO AM ARRAY
                  DO  I = NREC1,NREC2
                     J = (I -NREC1) * NSAM + 1 + NMAXIRR
                     CALL REDLIN(LUNIM,BUF(J),NSAM,I)
                  ENDDO

               ELSE IF (CCHAR .EQ. 'Y') THEN
C                 3-D FILE WITH Y SLICE

                  IROW = SLICES(KJ)
                  IF (IROW .LT. 1 .OR. IROW .GT. NROW) THEN
C                    NONEXISTENT SLICE
                     WRITE(NOUT,9912)IROW,NROW
9912                 FORMAT(' ***  ROW',I5,'  MUST BE <=',I5/)
                     GOTO 40
                  ENDIF

                  DO  ISLICE=1,NSLICE
C..                  READ THE SPIDER FILE INTO AM ARRAY
                     IREC = (ISLICE - 1) * NROW + IROW
                     J    = (ISLICE -1 ) * NSAM + 1 + NMAXIRR
                     CALL REDLIN(LUNIM,BUF(J),NSAM,IREC)
                  ENDDO

               ELSE IF (CCHAR .EQ. 'X') THEN
C                3-D FILE WITH X SLICE

                 ISAM = SLICES(KJ)
                 IF (ISAM .LT. 1 .OR. ISAM .GT. NSAM) THEN
C                    NONEXISTENT SLICE
                     WRITE(NOUT,9913)ISAM,NSAM
9913                 FORMAT(' *** COL.',I5,'  MUST BE <=',I5/)
                     GOTO 40
                  ENDIF

                  J = NMAXIRR
328               DO  ISLICE = 1,NSLICE
                    IREC1 = (ISLICE - 1) * NROW
                    DO  IROW = 1, NROW
                      CALL REDLIN(LUNIM,BUF,NSAM,IREC1+IROW-1)
                      J = J + 1
C**                   AM(J)  = BUF(ISAM)
                      BUF(J) = BUF(ISAM)
                    ENDDO
                  ENDDO
               ENDIF

C              PUT IN FRAME
               ICLAS = 1
               ICNT  = 1
               CALL SSPUSH(DATAFR,NDATAF,NF)

               CALL CNTUR(BUF(NMAXIRR+1),NROW,NSAM,BLEV,ELEV,RINC,BUF,
     &                 X,Y,NMAXI,LUNSS,MULTIZ,MAXPTS,NMAXIRR)

40             CONTINUE 
            ENDDO          
          ENDIF

99        NSAM = 0
          NROW = 0

1000      CLOSE(LUNIM)
        ENDDO

C       CLOSE THE STERECON INPUT FILE
        CLOSE(LUNSS)

        RETURN
        END

