
C++*********************************************************************
C
C      CNSTUFF.FOR 
C
C      LAST UPDATE        8/27/96 al     3/27/92 al      2/04/98 al
C **********************************************************************
C
C    PURPOSE:      PLACE CONTOUR FROM CNTRCE IN SSR AND CNT FILE
C
C    PARAMETERS:   LUN     CONTOUR FILE UNIT
C                  X,Y     DATA ARRAY
C                  NPTS    NUMBER OF POINTS IN DATA
C                  MULTIZ  LOGICAL FLAG FOR Z SERIES
C                  MAXPTS  THIN LIMIT
C                  IPEN    COLOR FOR CONTOUR
C                  IRTFLG  ERROR FLAG
C
C    CALLED BY:    CNTRCE
C
C    CALLS:        CNCALC    CSPUSH    SSPUSH
C                                                          ...CNCALC
C    CALL TREE:    PLOT1...CNINT4...CNTUR...CNSCAN...CNTRCE...SSPUSH
C                                                          ...CSPUSH
C                                                          ...CNSTUFF
C--********************************************************************

      SUBROUTINE CNSTUFF(LUN,X,Y,NPTS,MULTIZ,MAXPTS,IPENT,IRTFLG)

      INCLUDE   'CONSTG.INC'
CNO_SAVE

C---------------------------------------------------------
       PARAMETER       (KULIAH=20)
       CHARACTER * 4   CLASNM(KULIAH)
       COMMON /SSRECN/ NSEC,NPLAN,NCLAS,NCNT,
     &                 ISEC,IPLAN,ICLAS,ICNT,LUNSS,CLASNM
C---------------------------------------------------------

      COMMON /UNITS/ LUNC,NIN,NOUT,NECHO,IFOUND,NPROC,NDAT
      COMMON /POLY/  MINPTS

      PARAMETER      (NSIZE = 2000)
      PARAMETER      (NBUFSIZ = 17008)
      DIMENSION      DATA(3,NSIZE),WORK(3,NSIZE)
      EQUIVALENCE    (BUF(1),DATA(1,1)), (BUF(6400),WORK(1,1))
      COMMON /IOBUF/ BUF(NBUFSIZ)

      DIMENSION      X(NSIZE),Y(NSIZE)
      LOGICAL        MULTIZ,THINED

      IRTFLG = 0
      IPEN   = IPENT

      DO I2 = 1, NPTS
         DATA(1,I2) = X(I2)
         DATA(2,I2) = Y(I2)
      ENDDO

      THINED = .FALSE.
      IF (NPTS .GT. MAXPTS) THEN 
C       TOO MANY POINTS ON THIS CONTOUR, TRY TO THIN IT
        N0      = NPTS
        RETANG  = 178.0
        MAXTRYS = 2
        CALL RATHIN(DATA,NPTS,0.0333,RETANG,MAXPTS,MAXTRYS,WORK,IRTFLGR)
        IF (NPTS .LT. N0) THINED = .TRUE.
      ENDIF

C     SET LINE PARAMETERS
      MARK  = 0
      LINTP = 0
      INTEN = 9

      IF (NPTS .LT. MINPTS) THEN
C        ABANDON THIS TOO-SHORT CONTOUR
         WRITE(NOUT,1112) NPTS
 1112    FORMAT(' SHORT CONTOUR WITH: ',I4,' POINTS ABANDONED.')

      ELSEIF (MULTIZ) THEN
C..      STORE THE CONTOUR
         ICNT   = ICNT + 1
         CALL SSPUSH(DATA,NPTS,NERR)
         IF (NERR .EQ. 0) THEN
            IF (THINED) THEN 
              WRITE(NOUT,1101) ISEC,ICLAS,ICNT,ZCOO,N0,NPTS
 1101         FORMAT(' CONTOUR',I3,I4,' ',I4,' AT Z:',1PG11.3,
     &        ' WITH: ',I4,' --> ',I4,' POINTS STORED.')
            ELSE
              WRITE(NOUT,1103) ISEC,ICLAS,ICNT,ZCOO,NPTS
 1103         FORMAT(' CONTOUR',I3,I4,' ',I4,' AT Z:',1PG11.3,
     &        ' WITH: ',I4,' POINTS STORED.')
            ENDIF
         ELSE
            WRITE(NOUT,1102) ISEC,ICLAS,ICNT,ZCOO,NPTS
 1102       FORMAT(' *** ERROR STORING CONTOUR',I3,' ',I3,' ',I4,
     &      ' AT Z:',1PG11.3,' WITH: ',I4,' POINTS'//)
            ICNT = ICNT - 1
         ENDIF

      ELSE
         ISTFLG = 1
         CALL CSPUSH(LUN,DATA,NPTS,NERR,ISTFLG,ICNTR)
         IF (NERR .EQ. 0) THEN
            IF (THINED) THEN
              WRITE(NOUT,101) ICNTR,ZCOO,N0,NPTS
  101         FORMAT(' CONTOUR:',I5,' AT Z:',1PG11.3,
     &        ' WITH: ',I4,' --> ',I4,' POINTS STORED.')
            ELSE
              WRITE(NOUT,103) ICNTR,ZCOO,NPTS
  103         FORMAT(' CONTOUR:',I5,' AT Z:',1PG11.3,
     &        ' WITH: ',I4,' POINTS STORED.')
            ENDIF
         ELSE
            WRITE(NOUT,102) ICNTR,NPTS
  102       FORMAT(' *** ERROR STORING CONTOUR: ',I5,' WITH ',
     &           I4,' POINTS')
         ENDIF
      ENDIF
        
      RETURN
      END
