
C++*************************************************************************
C
C    CNTERM.FOR -- CREATED JAN 85
C                  FEB 86 VARIABLE PLOT SCALE ADDED al
C                  TITLE PRINTED BEFORE PLOTTING al
C                  NAME CHANGED FROM DRVT25.FOR AND CNVT25 al
C                  INVERTS AROUND X AXIS TO CORRECT BUG al
C                  EXTENSIVELY REWRITTEN SEPT 86 al
C                  TEXT SIZES AND LINE TYPES ADDED MAR 86 al
C **************************************************************************
C *  AUTHOR: R. BANERJEE & A. LEITH                                        *
C *  COPYRIGHT (C)1985,1987, WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH  			   *
C **************************************************************************
C
C    CNTERM (FILNAM,FILEXT,LUN,ISEL,NF)
C
C    PURPOSE:   DRIVER FOR DIGITAL VT125 or VT240 TERMINAL WHICH INTERFACES 
C               WITH A CONTOUR STORAGE FILE.
C               READS THE CONTOUR AND TEXT DATA FROM THE FILE AND PLOTS THEM.
C
C    PARAMETERS:
C           FILNAM   THE NAME OF THE CONTOUR STORAGE FILE IN CHARACTER FORMAT.
C           FILEXT   THE EXTENSION OF THE CONTOUR STORAGE FILE (CHARACTER * 3)
C           LUN      UNIT NO. USED TO READ THIS FILE
C           ISEL    FLAG FOR SELECTION OF SCALE
C                   = 0    ASK USER FOR THE SCALING VALUE
C                   = 1    USE DEFAULT HARDWARE SCALE
C           NF      ERROR RETURN FLAG
C                   (= 0   NO ERROR,  = 1   ERROR IN PLOTTING)
C
C       CALLED BY:  PLOT1            CNGRAF         CNINT
C
C       CALLS:      RDPRMC           RDPRM2S        CSCLIP
C                   TMSTRT           TMCLR          TMDRAW
C                   TMMOVE           TMTEXT         TMEND
C                   CSGTTX           (TM.. IN TERMDR.FOR)
C                   CSGET
C
C       NOTES:   FOR THE DEC VT125 TERMINAL THE ORIGIN IS NORMALLY
C                AT THE UPPER LEFT.  THE X AXIS EXTENDS TO THE
C                RIGHT FROM 0...767.  THE POSITIVE Y AXIS EXTENDS
C                DOWN! FROM 0...479.
C               
C               (0,0)..........................(0,767)
C                 :                              :
C                 :                              :
C                 :                              :
C                 :                              :
C               (0,479)......................(767,479)
C
C
C--********************************************************************

      SUBROUTINE CNTERM(FILNAM,FILEXT,LUN,ISEL,NF)

      INCLUDE 'CMBLOCK.INC'
      INCLUDE 'CONSTG.INC'
CC      INCLUDE 'DISPAR.INC' INLINED MAR 97 AL

       LOGICAL   HIDE,CENTER,MIRROR,INVERZ,CWISE,ANGLES,FRAMES,
     &           MICBAR,LABELS,TITLE,VARINT,SPHERE,RECALC,ADDROT,
     &           CHACON,CLEARS,ANIM,THINS,TOFILE,INVORD,MOVIE,
     &           WINGOT,PLSGOT,MONTAG,TWOMON,PICKEM

C      DTX, DTY, DTZ, ZMAX, AMIN,PLSCL & EXPLOD ARE FLOATING POINT NUMBERS.
       INTEGER * 4  NUMLIS,IDEVIC,ITHIN
       COMMON /DISPAR/HIDE,CENTER,MIRROR,INVERZ,CWISE,ANGLES,FRAMES,
     &        MICBAR,LABELS,TITLE,VARINT,SPHERE,RECALC,EXPLOD,ADDROT,
     &        CHACON,NUMLIS,IDEVIC,CLEARS,ANIM,ZMIN,ZMAX,DTX,DTY,DTZ,
     &        THINS,ITHIN,TOFILE,INVORD,PLSCL,MOVIE,WINGOT,IXULD,IYULD,
     &        IXLRD,IYLRD,PLSGOT,MONTAG,TWOMON,PICKEM

      PARAMETER      (NSIZE=2000)
      DIMENSION      DATA(3,NSIZE)
      COMMON ADUM(80),DATA

      CHARACTER * 80 LINE
      CHARACTER *(*) FILNAM,FILEXT
      CHARACTER * 3  ANSW
      CHARACTER * 1  NULL
      LOGICAL        NOMOVE,TEXT,CLEAR,WINDOW,DEBUG

      DATA MININT/-32768/,MAXINT/32767/,FLTMIN/-10E30/,
     &     FLTZER/10E-30/,FLTMAX/10E30/
	NULL=CHAR(0)

        NF     = 0

 4000    CONTINUE
         CALL RDPRMC(ANSW,N,.TRUE.,'Clear screen first? (Y/N)',
     &      NULL,IRTFLG)
         IF (IRTFLG .EQ. -1) RETURN
         CLEAR = .TRUE.
         IF (ANSW(1:1) .EQ. 'N') CLEAR = .FALSE.

C..      ASSIGN DEFAULT VIEWPORT OF 480 FOR DEC VT125 TERMINAL
C..      (THIS VALUE WILL CHANGE FOR DIFFERENT HARDWARES)
C        ORIGIN IS UPPER LEFT. SCREEN SIZE IS 768 X 480
         IXSIZE = 768
         IYSIZE = 480
         IVPTSZ = 480

         IF (ISEL .EQ. 1) THEN
C..         ASK IF USER WANTS TO CHOOSE THE VIEWPORT
            CALL RDPRIS(IVPTSZ,IDUM,NLOOP,ILOOP,
     &        'Enter viewport size (100-480)',IRTFLG)
            IF (IRTFLG .EQ. -1) GOTO 4000
         ENDIF

 4001       CONTINUE

C..     SET DEFAULT WINDOW
        WXMINP = 0.0
        WYMINP = 0.0
        WXMAXP = 1.0
        WYMAXP = 1.0

C..     ASK USER WHETHER HE WANTS TO WINDOW 
 5001   CALL RDPRMC(ANSW,N,.TRUE.,'Do you want to window? (Y/N)',
     &  			NULL,IRTFLG)
        IF(IRTFLG .EQ. -1) THEN
C..         ASK IF USER WANTS TO CHOOSE THE VIEWPORT
            CALL RDPRIS(IVPTSZ,IDUM,NLOOP,ILOOP,
     &        'Enter viewport size (100-480)',IRTFLG)
            IF (IRTFLG .EQ. -1) GOTO 4000
	    GOTO 4001
	END IF
        DEBUG = .FALSE.
        IF (ANSW(1:1) .EQ. 'n' .OR. ANSW(1:1) .EQ. 'y') DEBUG = .TRUE.

        WINDOW = .FALSE.
        IF (ANSW(1:1) .EQ. 'Y') THEN
C..          USER WANTS TO WINDOW SO ASK FOR CO-ORDINATES
             WINDOW = .TRUE.
             WRITE(NOUT,5020)
 5020        FORMAT(' ASSUME PICTURE TO BE 1.0 X 1.0')

 5002        CALL RDPRM2S(WXMINP,WYMINP,NLOOP,ILOOP,
     &         'X & Y co-ord. of bottem left corner (0.0 - 1.0)',IRTFLG)
             IF (IRTFLG .EQ. -1) GOTO 5001

 5003        CONTINUE
C            DO NOT ALLOW RIGHT SAME AS LEFT CORNER
             FXMIN = WXMINP + FLTZER
             FYMIN = WYMINP + FLTZER
             CALL RDPRM2S(WXMAXP,WYMAXP,NLOOP,ILOOP,
     &          'X & Y co-ord. of top right corner (0.0 - 1.0)',IRTFLG)
             IF (IRTFLG .EQ. -1) GOTO 5002
         ENDIF  


 5005    CALL RDPRMC(ANSW,N,.TRUE.,'Center the plot? (Y/N)',NULL,IRTFLG)
         IF (IRTFLG .EQ. -1) THEN
            IF (WINDOW) GOTO 5003
            GOTO 5001
         ENDIF
         IF (ANSW(1:1) .EQ. 'Y' .OR. ANSW(1:1) .EQ. 'y') THEN 
            CENTER = .TRUE.

C           FIND DEFAULT SCALING FOR CENTERED WINDOW
            PXDIFF = WXMAXP - WXMINP
            PYDIFF = WYMAXP - WYMINP
            IF (PXDIFF .LT. PYDIFF) THEN
               PDIFF = PYDIFF
            ELSE
               PDIFF = PXDIFF
            ENDIF
            PLSCL = 0.95 * IVPTSZ / PDIFF

         ELSE
C           FIND DEFAULT UNCENTERED SCALING
            CENTER = .FALSE.
            PLSCL = 0.95 * IVPTSZ 
         ENDIF

C..      LIST DEFAULT PLOTTING SCALE AND ASK FOR CHANGES
 4342    WRITE(NOUT,*) 'CURRENT DISPLAY SCALE:',PLSCL
         CALL RDPRM2S(PLSCL,FDUM,NLOOP,ILOOP,'DISPLAY SCALE',IRTFLG)
         IF (IRTFLG .EQ. -1) GOTO 5005
         IF (PLSCL .LE. 0.0) THEN
            WRITE(NOUT,*) '*** DISPLAY SCALE MUST BE > 0'
            GOTO 4342
         ENDIF

         WXMIN = WXMINP * PLSCL
         WYMIN = WYMINP * PLSCL
         WXMAX = WXMAXP * PLSCL
         WYMAX = WYMAXP * PLSCL

         IF (CENTER) THEN
C           FIND CENTERING OFFSET
            XXTRA = ((IXSIZE - IVPTSZ) / 2) + (IVPTSZ / 2) - 
     &               (WXMIN + ((WXMAX - WXMIN) / 2))
            YXTRA =  IYSIZE - (((IYSIZE - IVPTSZ) / 2) +
     &               (IVPTSZ / 2) - (WYMIN + ((WYMAX - WYMIN) / 2)))
         ELSE
C           FIND NON-CENTERED OFFSET
            XXTRA = 0.0
            YXTRA = IYSIZE
         ENDIF
         
         MIRROR = .FALSE.
 4343    CALL RDPRMC(ANSW,N,.TRUE.,'Print text? (Y/N/M)',NULL,IRTFLG)
         IF (IRTFLG .EQ. -1) GOTO 4342
         IF (ANSW(1:1) .EQ. 'M') THEN 
            MIRROR = .TRUE. 
            WRITE(NOUT,4099)
 4099       FORMAT(' Y COORDINATES MIRRORED AROUND X AXIS',/)
            GOTO 4343
         ELSE
            TEXT = .TRUE.
            IF (ANSW(1:1) .EQ. 'N') TEXT = .FALSE.
         ENDIF

C*********************** DEBUG
c         IF (DEBUG) THEN
c         WRITE(116,6991)XMIN,YMIN,XMAX,YMAX,SCALE
c 6991    FORMAT(1X,'XMIN,YMIN,XMAX,YMAX,SCALE: ',5F9.2)
c         WRITE(116,998)XDIFF,YDIFF,DIFF,PLSCL
c  998    FORMAT(1X,'XDIFF,YDIFF,DIFF,PLSCL: ',6F7.1)
c         WRITE(116,996)IVPTSZ,XXTRA,YXTRA
c  996    FORMAT(1X,'IVPTSZ,XXTRA,YXTRA: ',I5,2F5.0)
c         WRITE(116,995)LSTCON,LSTTXT
c  995    FORMAT(1X,'LSTCON,LSTTXT: ',2I5)
c         WRITE(116,997)WXMIN,WYMIN,WXMAX,WXMAX
c  997    FORMAT(1X,'WXMIN,WYMIN,WXMAX,WXMAX: ',
c     &   4F8.2,2I5)
c         WRITE(116,999)WXMINP,WYMINP,WXMAXP,WXMAXP
c  999    FORMAT(1X,'WXMINP,WYMINP,WXMAXP,WXMAXP: ',4F8.2)
c         ENDIF
C*********************************************************88

C..      ASSIGN UNIT NO. TO THE PLOTTING HARDWARE, CURRENTLY NOUT
         IPLUN = NOUT

C..      CLEAR ANY TEXT FROM THE SCREEN
         WRITE(NOUT,5555)
 5555    FORMAT(//////////////////////////)

C..      INITIALIZE THE PLOTTER
         CALL TMSTRT(IPLUN)
C..      CLEAR THE GRAPHICS SCREEN
         IF (CLEAR) CALL TMCLR(IPLUN)

         IF (TEXT) THEN
C..        GO FROM 1 TO LSTTXT & PLOT EXISTING TEXTS ONLY
           DO 1003 I = 1, LSTTXT
             IF (TXTCTR(1,I) .LE. 0.0) GOTO 1003
             ITEXT = I
             CALL CSGTTX(LINE,NCHAR,LUN,NF,ITEXT)
             IF (NCHAR .GT. 0) THEN
                X1 = TXTCTR(4,I) * PLSCL

                IF (MIRROR) THEN
                   Y1 = (1.0-TXTCTR(5,I)) * PLSCL 
                ELSE 
                   Y1 = TXTCTR(5,I) * PLSCL 
                ENDIF

C********************** DEBUG
C               IF (DEBUG) WRITE(116,993)ITEXT,X1,Y1,LINE(1:NCHAR)
C  993          FORMAT(' TEXT',I4,' AT (X,Y): (',F7.2,',',F7.2,') ',
C     &                  A)
C*******************************************

                IF ((X1 .LT. WXMIN) .OR. (X1 .GT. WXMAX) .OR.
     &              (Y1 .LT. WYMIN) .OR. (Y1 .GT. WYMAX)) GOTO 1003
                X1 = XXTRA + X1
                Y1 = YXTRA - Y1
                CALL TMTEX(IPLUN,LINE,NCHAR,X1,Y1,ITSIZE,ITANGL,JUST)
             ENDIF
 1003      CONTINUE
         ENDIF

         TITLE = .FALSE.
         IF (TITLE) THEN
C..        WRITE THE TITLE
           LINE(1:47) = 'TITLE: '//TITLCS(1:40)
           NCHAR = 47

           X1 = 5
           Y1 = 1
           CALL TMMOVE(IPLUN,X1,Y1)
           CALL TMTEXT(IPLUN,LINE,NCHAR)
         ENDIF

C..      GO FROM 1 TO LSTCON & PLOT VALID CONTOURS ONLY
         DO 1001 I = 1, LSTCON
            IF (CONTRL(1,I) .LE. 0.0) GOTO 1001
            ICNTR = I
            CALL CSGET(ICNTR,NSIZE,DATA,NDATA,LUN,NF)

            IF (NDATA .GT. 0) THEN
C..            INITIALIZE DATA
               NOMOVE = .FALSE.
               XPR = DATA(1,1) * PLSCL

C*             MIRROR IMAGE INVERSION ADDED TO CORRECT BUG
               IF (MIRROR) THEN
                 YPR = (1.0-DATA(2,1)) * PLSCL
               ELSE 
                 YPR = DATA(2,1) * PLSCL
               ENDIF

               DO I2 = 1, NDATA
                  X2 = PLSCL * DATA(1,I2)

                  IF(MIRROR) THEN
                    Y2 = PLSCL * (1.0-DATA(2,I2))
                  ELSE
                    Y2 = PLSCL * DATA(2,I2)
                  ENDIF
                  X1 = XPR
                  Y1 = YPR
                  XPR = X2
                  YPR = Y2
                  CALL CSCLIP(X1,Y1,X2,Y2,WXMIN,WXMAX,WYMIN,WYMAX,
     &                        ICLIP)        

                  IF ((ICLIP .EQ. 1) .AND. NOMOVE) THEN
                     YM = YXTRA - Y2 
                     XM = XXTRA + X2 
                     CALL TMLINE(IPLUN,XM,YM,INTEN,LINTYP)
                  ELSE
                     IF (ICLIP .NE. 0) THEN
                        XM = XXTRA + X1 
                        YM = YXTRA - Y1
                        CALL TMMOVE(IPLUN,XM,YM)
                        XM = XXTRA + X2 
                        YM = YXTRA - Y2 
                        CALL TMLINE(IPLUN,XM,YM,INTEN,LINTYP)
                     ENDIF
                  ENDIF

                  IF (ICLIP .EQ. 1) THEN
                     NOMOVE = .TRUE.
                  ELSE
                     NOMOVE = .FALSE.
                  ENDIF
	      ENDDO

            ENDIF
 1001    CONTINUE

C..      TURN OFF THE PLOTTER
         CALL TMEND(IPLUN)

 4344    CALL RDPRMC(ANSW,N,.TRUE.,
     &      'PLOT AGAIN (P), HARDCOPY (H), DO NOT CLEAR(D) (P/H/D)',
     &      NULL,IRTFLG)
         IF (ANSW(1:1) .EQ. 'H') THEN
            CALL TMHARD(IPLUN)
            GOTO 4344
         ENDIF
         IF (ANSW(1:1) .EQ. 'Y' .OR. ANSW(1:1) .EQ. 'P') GOTO 4000

         IF (ANSW(1:1) .NE. 'D') THEN
C..        CLEAR THE GRAPHICS SCREEN
           CALL TMSTRT(IPLUN)
           CALL TMCLR(IPLUN)
           CALL TMEND(IPLUN)
         ENDIF

      RETURN
      END         

