C++************************************************************************
C
C $$ COMBEUL1.FOR
C
C **************************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK            *
C *  COPYRIGHT (C)1981,1987, WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *  THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR       *
C *  LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR    *
C *  USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF     *
C *  THE CENTER FOR LABORATORIES AND RESEARCH   			   *
C **************************************************************************
C
C
C $$ COMBEUL1.FOR
C
C
C--************************************************************************

         SUBROUTINE COMBEUL1 (LUN1,LUN2)

 
         INCLUDE 'CMBLOCK.INC'
 

         EQUIVALENCE    (NS1,NSEL(1))
         EQUIVALENCE    (NS2,NSEL(2))
         EQUIVALENCE    (NS3,NSEL(3))
         CHARACTER*1 NUL,ANS,ANS2
         CHARACTER*81 FILN1,FILN2,FILE
C dum(200) to leave enough space in the unnamed common for
C subroutine combeul.
         COMMON DUM(200),VALUE(10),VAL(10),IARRY(2000),BUF(2000)
         DIMENSION PLIST(10)
         EQUIVALENCE (PLIST(1),VALUE(1))

         DATA NUL/'0'/

         CALL RDPRMC(ANS,NLET,.FALSE.,
     $   '(H)eader, (D)oc.file, (E)xternal, (M)ixed=H+E$'
     $   ,NUL,IRTFLG)

C input and output in document files:
         IF(ANS.EQ.'D') THEN
         ICALL=0
         NLIST=6
         MAXKEY=2000
         MAXREG=7
         NKEY=2000
         CALL FILERD(FILE,NLET,NUL,'input document$',IRTFLG)
         CALL FILCAN(FILN1,NLET,NUL,NUL,FILE,DATEXC,IER)
         CALL RDPRMI(IFIRST,ILAST,NLOOP,ILOOP,'first/last key$')
         CALL FILERD(FILN2,NLET,NUL,'output document$',IRTFLG)
         NRUN=0
         DO I=IFIRST,ILAST
         CALL UNSDAL(FILN1,ICALL,LUN1,I,PLIST,NLIST,BUF
     $   ,MAXKEY,MAXREG,NKEY,LERR)
C the first rotation (of the object on the grid) is in the second
C set of columns in the document file.
         A=PLIST(3)
         B=PLIST(2)
         C1=PLIST(1)
C the second rotation is in the first set of columns in the document file.
         C2=PLIST(6)
         D=PLIST(5)
         E=PLIST(4)
         CALL COMBEUL(A,B,C1,C2,D,E,PSI,THETA,PHI,.FALSE.)
C store result in output document file:
         PLIST(1)=I
         PLIST(4)=PSI
         PLIST(3)=THETA
         PLIST(2)=PHI
         IAP=1
         CALL SAVDN1(LUN2,FILN2,PLIST,4,NRUN,IAP)
         NRUN=1
	 ENDDO
         CLOSE(LUN1)
         CLOSE(LUN2)
         RETURN
         ENDIF
C input and output in file header
         IF(ANS.EQ.'H') THEN
         NMAX=2000
         CALL  FILSEQP(FILN1,NLET,IARRY,NMAX,IHOW, 
     $  'FILE PREFIX OR TEMPLATE (EG. PIC****)', IRTFLG)
     
         DO 3 I=1,IHOW
         CALL FILGET(FILN1,FILN2,NLET,IARRY(I),IRTFLAG)
         NDUM=1
         CALL OPENFB(BUF,FILN2,LUN1,NSAM,NROW,'OLD',IER,NDUM)
C skip nonexisting files:
         IF(IER.NE.2) GOTO 3
C first assume that both rotations are stored in position 2 and 3
C of the file header buffer location 31ff :
         IBUF1=30
         NBUF=7
         CALL GETLAB(LUN1,NSAM,BUF,IBUF1,NBUF,VALUE,IRTFLG)
         IMANY=VALUE(1)
         C2 =VALUE(4)
         D =VALUE(3)
         E =VALUE(2)
         A =VALUE(7)
         B =VALUE(6)
         C1=VALUE(5)
         IF(IMANY.EQ.2) GOTO 888
C if the second rotation was not there, take it from position 1
C (buffer location 15 ff)
         NBUF=4
         IBUF1=14
         CALL GETLAB(LUN1,NSAM,BUF,IBUF1,NBUF,VAL,IRTFLG)
         ISET=VAL(1)
         IF(ISET.EQ.0) THEN
C if angles were not set, make sure they are 0
         VAL(2)=0.
         VAL(3)=0.
         VAL(4)=0.
         ENDIF
         C1 = VAL(2)
         B = VAL(3)
         A = VAL(4)
888      CONTINUE
         CALL COMBEUL(A,B,C1,C2,D,E,PSI,THETA,PHI,.FALSE.)
C store result in position 1
         VAL(1)=1
         VAL(4)=PSI
         VAL(3)=THETA
         VAL(2)=PHI
         IRTFLG=-1
         CALL SETLAB (LUN1,NSAM,BUF,14,4,VAL,'U',IRTFLG)
C save original position 1 values in position 3
         VALUE(1)=2
         VALUE(2)=E
         VALUE(3)=D
         VALUE(4)=C2
         VALUE(5)=C1
         VALUE(6)=B
         VALUE(7)=A
         IRTFLG=-1
         CALL SETLAB (LUN1,NSAM,BUF,30,7,VALUE,'U',IRTFLG)
         CLOSE (LUN1)
3        CONTINUE
         RETURN
         ENDIF
C rotations given externally:
         IF(ANS.EQ.'E') THEN
         CALL RDPRM2(C1,B,NLOOP,ILOOP,'phi1,theta1$')
         CALL RDPRM (A,NLOOP,ILOOP,'psi1$')
         CALL RDPRM2(E,D,NLOOP,ILOOP,'phi2,theta2$')
         CALL RDPRM (C2,NLOOP,ILOOP,'psi2$')
         CALL COMBEUL(A,B,C1,C2,D,E,PSI,THETA,PHI,.FALSE.)
         IF(NS1.NE.0) PARAM(NS1)=PHI
         IF(NS2.NE.0) PARAM(NS2)=THETA
         IF(NS3.NE.0) PARAM(NS3)=PSI
         RETURN
         ENDIF
C mixed input
C input of second rotation in file header, first rotation external
C one set of input angle is applied to a file series
C (gaps allowed):
         IF(ANS.EQ.'M') THEN
         NMAX=2000
         CALL  FILSEQP(FILN1,NLET,IARRY,NMAX,IHOW, 
     $  'FILE PREFIX OR TEMPLATE (EG. PIC****)' ,IRTFLG)
     
         CALL RDPRMC(ANS2,NLET2,.FALSE.,
     $   'first set of angles in (F)inal or (S)aved position$',
     $   NUL,IRTFLG)
         IPLUS=1
         IPF=14
         IF(ANS2.EQ.'S') THEN
         IPLUS=4
         IPF=30
         ENDIF
         CALL RDPRM2(E,D,NLOOP,ILOOP,'phi2,theta2$')
         CALL RDPRM(C2,NLOOP,ILOOP,'psi2$')
         DO 4 I=1,IHOW
         CALL FILGET(FILN1,FILN2,NLET,IARRY(I),IRTFLAG)
         NDUM=1
         CALL OPENFB(BUF,FILN2,LUN1,NSAM,NROW,'OLD',IER,NDUM)
C skip nonexisting files:
         IF(IER.NE.2) GOTO 4
         IBUF1=IPF
         NBUF=7
         CALL GETLAB(LUN1,NSAM,BUF,IBUF1,NBUF,VALUE,IRTFLG)
         IMANY=VALUE(1)
C check if angles are really set:
         IF((IPF.EQ.14.AND.IMANY.NE.1).OR.
     $   (IPF.EQ.30.AND.IMANY.NE.2)) THEN
         WRITE(NOUT,100)
100      FORMAT(' **the angles you want are not in the title ***')
         CLOSE(LUN1)
         RETURN
         ENDIF
         C1=VALUE(IPLUS+1)
         B=VALUE(IPLUS+2)
         A=VALUE(IPLUS+3)
         CALL COMBEUL(A,B,C1,C2,D,E,PSI,THETA,PHI,.FALSE.)
C store result in position 1
         VAL(1)=1
         VAL(2)=PHI
         VAL(3)=THETA
         VAL(4)=PSI
         IRTFLG=-1
         CALL SETLAB (LUN1,NSAM,BUF,14,4,VAL,'U',IRTFLG)
C save original position 1 values in position 3
         VALUE(1)=2
         VALUE(2)=C1
         VALUE(3)=B
         VALUE(4)=A
         VALUE(5)=E
         VALUE(6)=D
         VALUE(7)=C2
         IRTFLG=-1
         CALL SETLAB (LUN1,NSAM,BUF,30,7,VALUE,'U',IRTFLG)
         CLOSE (LUN1)
4        CONTINUE
         RETURN
         ENDIF
         END
 
