C++************************************************************************
C
C **********************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.    AUTHOR: J.FRANK      *
C *  COPYRIGHT (C)1985, 1996 HEALTH RESEARCH INCORPORATED, ALBANY, NY. *
C * THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO HEALTH            *
C * RESEARCH INC. AND ARE NOT TO BE DISCLOSED TO OTHERS OR USED        *
C * FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF       *
C * HEALTH RESEARCH INC.                                               *
C **********************************************************************
C
C   COMP3D(LUN,LUN2)
C
C   PURPOSE:  
C
C   PARAMETERS: 
C
C23456789 123456789 123456789 123456789 123456789 123456789 123456789 12
C--*********************************************************************

      SUBROUTINE COMP3D(LUN,LUN2)                                       

      IMPLICIT DOUBLE PRECISION (A-H,O-X)                               
      INCLUDE 'CMBLOCK.INC'                                             
CNO_SAVE                                                                        

      COMMON          BUF(2048)                                         
      COMMON /COMMUN/ FIL2,FIL1                                         
      REAL            ADUM,BUF                                                     
      CHARACTER *81   FIL2,FIL1                                           
      CHARACTER *1    NULL                                                
      INTEGER         NVOX                                                

      NULL=CHAR(0)                                                      

      WRITE(NOUT,*) ' COMPARISON OF 2 3D ARRAYS:'                                                   

      MAXIM = 0                         
      CALL OPFIL(.TRUE.,FIL1,LUN,'O',NSAM,NROW,NSLICE,
     &           MAXIM,'FIRST',.FALSE.,IRTFLG)
      IF (IRTFLG .NE. 0) GOTO 9100

      MAXIM = 0                         
      CALL OPFIL(.TRUE.,FIL2,LUN1,'O',NSAM2,NROW2,NSLIC2,
     &           MAXIM,'SECOND',.FALSE.,IRTFLG)
      IF (IRTFLG .NE. 0) GOTO 9100

      IF(NSAM2.NE.NSAM.OR.NROW2.NE.NROW.OR.NSLIC2.NE.NSLICE) GOTO 9900  
      S1=0.                                                             
      S2=0.                                                             
      S3=0.                                                             
      S4=0.                                                             
      SUM1=0.
      SUM2=0.
      NVOX=FLOAT(NSAM)*FLOAT(NROW)*FLOAT(NSLICE)                  
      DO  ISL=1,NSLICE                                                   
         IOFF=(ISL-1)*NROW                                                      
         DO  I = 1,NROW      
            CALL REDLIN(LUN,BUF,NSAM,I+IOFF)                                  
            CALL REDLIN(LUN2,BUF(NSAM+1),NSAM,I+IOFF)                         
            DO  K = 1,NSAM                                             
               B = BUF(K)                                                        
               C=BUF(NSAM+K)                                                     
               P1=B*C                                                            
               P2=C*C                                                            
               S1=S1+P1                                                          
               S2=S2+P2                                                          
               S3=S3+C                                                           
               S4=S4+B                                                           
C              IF((B.NE.0.OR.C.NE.0).AND.NSAM.LE.16)                             
C     $        WRITE(NOUT,103)ISL,I,K,B,C,P1,P2,S1,S2,S3,S4                    
C103           FORMAT(' SLICE: ',I3,' , ROW: ',I3,' , COL: ',I3,/             
C     $      ' VOXEL 1: ',F16.4,' , VOXEL 2: ',F16.4, /                        
C     $      '     AD1: ',F16.4,'       AD2: ',F16.4, /                        
C     $      '      S1: ',F16.4,'        S2: ',F16.4, /                        
C     $      '      S3: ',F16.4,'        S4: ',F16.4)                          
            ENDDO
         ENDDO
      ENDDO
                                                                        
      A=(S1-S3*S4/NVOX)/(S2-S3*S3/NVOX)                                 
      CONST=(A*S3-S4)/NVOX                                              
      BMEAN=S4/NVOX                                                     
      SUM1=0                                                            
      SUM2=0                                                            
      DNOM=0                                                            
      DNUM=0                                                            
      DO  ISL=1,NSLICE
         IOFF=(ISL-1)*NROW                                                      
         DO  I = 1,NROW
            CALL REDLIN(LUN,BUF,NSAM,I+IOFF)                                  
            CALL REDLIN(LUN2,BUF(NSAM+1),NSAM,I+IOFF)                         
            DO  K = 1,NSAM
               B = BUF(K)                                                        
               C=BUF(NSAM+K)                                                     
               BD1=DABS(A*C-B-CONST)                                             
               BD2=DABS(B-BMEAN)                                                 
               SUM1=SUM1+BD1                                                     
               SUM2=SUM2+BD2                                                     
               BD1SQ=BD1*BD1                                                     
               DNOM=DNOM+(B-BMEAN)*(B-BMEAN)                                     
               DNUM=DNUM+BD1SQ                                                   
C              IF((B.NE.0.OR.C.NE.0).AND.NSAM.LE.16)                             
C     $        WRITE(NOUT,104)ISL,I,K,B,C,BD1,BD2,SUM1,SUM2                     
C104           FORMAT(' SLICE: ',I3,' , ROW: ',I3,' , COL: ',I3,/
C     $        ' VOXEL 1: ',F16.4,' , VOXEL 2: ',F16.4, /
C     $        '     BD1: ',F16.4,'       BD2: ',F16.4, /
C     $        '    SUM1: ',F16.4,'      SUM2: ',F16.4)
            ENDDO
         ENDDO
      ENDDO

      DIF=(SUM1)/SUM2                                                   
      DISCR=DSQRT(DNUM/DNOM)                                            
      WRITE(NOUT,100) A,CONST,DIF,DISCR                                 
100   FORMAT(' SCALING OF SECOND 3D: VOXEL_NEW=VOXEL_OLD*',G16.6,    
     $' - ',G16.6/                                                      
     $' MEAN RELATIVE ERROR: ',G10.5/                                   
     $'         DISCREPANCY: ',G15.5)                                   
      GOTO 9999  
                                                       
9100  CONTINUE                                                          
9300  CONTINUE                                                          
9900  CALL READPQ(FCHAR)                                              
      CALL ERRT(IER,'COMP3D',NE)
                                         
9999  CLOSE (LUN)                                                       
      CLOSE (LUN2)                                                     
      END                                                               
                                                                        
