	SUBROUTINE CONF(N,ALPHA,LUN1,LUN2,LUN3,LUN4,NSAM,NROW)
C
C
C CONF EVALUATES CONFIDENCE INTERVALS AT EACH IMAGE POINT (X,Y)
C
C N:		NUMBER OF IMAGE FILES ADDED
C ALPHA:	PROBABILITY OF ERROR
C LUN1:		LUN CONTAINING AVERAGE FILE
C LUN2:		LUN CONTAINING VARIANCE FILE
C LUN3:		LUN OF FILE TO RECEIVE THE UPPER CONFIDENCE IMAGE
C LUN4:		LUN OF FILE TO RECEIVE THE LOWER CONFIDENCE IMAGE
C
C WRITTEN BY W.HAENICKE, MPI FUER BIOPHYSIKALISCHE CHEMIE, GOETTINGEN.
C
	COMMON ADUM(80),BUF(1)
CNO_SAVE
C
	AN1=1./SQRT(FLOAT(N))
	PHIX=1.-ALPHA*0.005
	CALL NORPPF(PHIX,ZALPHA,IER)
	IF(IER.EQ.1) ZALPHA=4.
	DO  I=1,NROW
	CALL REDLIN(LUN1,BUF,NSAM,I)
	CALL REDLIN(LUN2,BUF(NSAM+1),NSAM,I)
	DO  J=1,NSAM
	AM=BUF(J)
	BM=ZALPHA*AN1*SQRT(BUF(NSAM+J))
	BUF(J)=AM+BM
	BUF(NSAM+J)=AM-BM
	ENDDO
	CALL WRTLIN(LUN3,BUF,NSAM,I)
	CALL WRTLIN(LUN4,BUF(NSAM+1),NSAM,I)
	ENDDO
	END
