
C ++********************************************************************
C
C   CONF1.FC                  LONG FILE NAMES        JAN 89 al
C   CHANGES:               MAHIEDDINE LADJADJ        4/30/93
C                                     JING SU        9/1/93
C
C **********************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.    AUTHOR: J.FRANK      *
C *  COPYRIGHT (C)1985, 1996 HEALTH RESEARCH INCORPORATED, ALBANY, NY. *
C * THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO HEALTH            *
C * RESEARCH INC. AND ARE NOT TO BE DISCLOSED TO OTHERS OR USED        *
C * FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF       *
C * HEALTH RESEARCH INC.                                               *
C **********************************************************************
C                                                                      *
C RK IS THE COMPOSITE OF TWO MAIN PROGRAMS ORIGINALLY DEVELOPED
C BY W.HAENICKE FOR A PDP 11/70 IN GOETTINGEN. THE RANK SUM
C ANALYSIS HAS BEEN DESCRIBED IN W.HAENICKE'S THESIS (AVAILABLE
C FROM THE AUTHOR OR FROM J.FRANK) AND IN HAENICKE ET AL., J.MICROSCOPY
C JAN.84. FIRST IMPLEMENTED IN ALBANY OCT 8,1982. CURRENT COMPOSITE
C PROGRAM NOV 8 1983. JF.
C
C************************************************************************

        SUBROUTINE CONF1(MAXDIM)

        PARAMETER (NFUNC=4)

        INCLUDE 'CMBLOCK.INC'

C COMMON BLOCK CONTAINING RANK SUM LABEL INFO (SEE COMMENT OF WRKLBL.F).
C TO GET THE INFO, USE RRKLBL.F  (IREC1 MUST BE KNOWN).

        COMMON /RKLABL/ ITREC,NR,NPTS,NTYP,NPTS1,RN,CRDIF5,CRDIF1,FIL1
C       ACTUAL MAX. LENGTH OF A0 IS SET IN INILUN
        COMMON          A0(8192)
        COMMON /NUMS/   NRS,IPIC1(100),IXS,IYS
        CHARACTER *81   FILNAM,FILNM2,FILTST
        CHARACTER *11   FILLIS
        COMMON /COMMUN/ FILNAM,FILLIS,FILNM2,FILTST

        CHARACTER *2    CFUNC(NFUNC)
        CHARACTER       NULL,FTEMP,DISP
        LOGICAL         EX,ISOPEN

C       COMMAND OPTIONS:
        DATA CFUNC /'RS', 'PT', 'CI', 'EP'/

CNO_SAVE
        NULL   = CHAR(0)
        LUN1   = 10
        LUN2   = 7
        LUN3   = 8
        LUN4   = 9
        LUN5   = 12
        DO IFUNC = 1, NFUNC
          IF (FCHAR(1:2) .EQ. CFUNC(IFUNC)) THEN
            GOTO (1, 2, 3, 4), IFUNC
          ENDIF
        ENDDO
        RETURN


C       OPERATION ----------------------------------------------- 'RS'
1       FTEMP = FCHAR(4:4)
        IF (FTEMP .NE. 'E' .AND. FTEMP .NE. 'R' .AND. 
     &      FTEMP .NE. ' ') GOTO 42

131     CONTINUE
C       FRIEDMAN'S RANK VARIANCE ANALYSIS (COMMENTED OUT) !!!!!!!
c       CALL RKANAL(LUN1,LUN2,MAXDIM,NSAM,NROW,FILNM2,FCHAR(4:))
        GOTO 9000

C       RANK SUM FILE USED AS INPUT
42	CALL OPFIL(.TRUE.,FILNM2,LUN1,'O',NSAM,NROW,NSLICE,
     &  	   IDUM,'INPUT RANK SUM',.TRUE.,IRTFLG)
	IF (IRTFLG .NE. 0) GOTO 9000
        IF (NSLICE .NE. 1) GOTO 9600
        ITREC = NROW * NSLICE

C       RRKLBL COMMENTED OUT !!!!!!!!!!!!!!!!!!!!!!!!!
c       CALL RRKLBL(LUN1,NSAM)

        IF (NR.LE.0 .OR. NPTS.LE.1) GOTO 9600
        IF (FTEMP .EQ.'F' .OR. FTEMP .EQ. 'H') GOTO 62
        IF (FTEMP .EQ. 'D' .OR.FTEMP.EQ.'A' .OR.FTEMP .EQ.'B') GOTO 131
        IF (FTEMP .EQ.'I') GOTO 22

C       OUTPUT FILE IS A RANK SUM FILE
        IFORM  = 1
        NSLICE = 1
	CALL OPFIL(.TRUE.,FILNAM,LUN2,'U',NSAM,NROW,NSLICE,
     &  	   IDUM,'OUTPUT RANK SUM',.FALSE.,IRTFLG)
	IF (IRTFLG .NE. 0) GOTO 9000
        GOTO 131 

C       OUTPUT FILE IS A LIST FILE
C       LIST FILE: OUTRKS.LST OR OUTRKS.TXT
62      IF (FTEMP .EQ. 'H') THEN
          FILLIS = 'OUTRKS.TXT' // NULL
        ELSE
          IF (FTEMP .EQ. 'F') THEN
            FILLIS = 'OUTRKS.LST' // NULL
          END IF
        ENDIF
        WRITE(NOUT,1003) FILLIS
1003    FORMAT(/' LISTFILE:  ',A/)
        OPEN(LUN2,STATUS='NEW',FILE=FILLIS)
        GOTO 131

C       IMAGE FILE IS OUTPUT
22      IFORM = 1
        NSLICE = 1
	CALL OPFIL(.TRUE.,FILNAM,LUN2,'U',NSAM,NROW,NSLICE,
     &  	   IDUM,'OUTPUT',.FALSE.,IRTFLG)
	IF (IRTFLG .NE. 0) GOTO 9000
        GOTO 131


C       OPERATION ----------------------------------------------- 'PT'
2       CONTINUE

        IF (FCHAR(4:4) .EQ. 'U') THEN
           WRITE(NOUT,*) '*** PT U OPERATIION MERGED WITH PLAIN PT NOW'
           CALL ERRT(100,'CONF1',NE)
           RETURN
        ENDIF

C       GET NAME FOR EXISTING OR NEW IMAGE FILE
10      CALL FILERD(FILNAM,NLET,NULL,'OUTPUT',IRTFLG)
        IF (IRTFLG .EQ. -1) RETURN

C       MERGE FILNAM WITH DATEXC IF NECESARY
        IF (FILNAM(1:1) .NE. '_' .AND. INDEX(FILNAM,'@') .EQ. 0) THEN
           CALL FILCAN(FILTST,NLET,NULL,NULL,FILNAM,DATEXC,IER)
           IF (IRTFLG .NE. 0) RETURN
        ELSE
           FILTST = FILNAM
        ENDIF

C       FIND IF FILE EXISTS
        CALL INQUIREIF1(LUN1,FILTST,A0,640000,EX,ISOPEN,LUNOP,
     &                  INLNED,IMGNUM,IRTFLG)

        DISP = 'U'
        IF (EX) DISP = 'O'

C       OPEN IMAGE FILE
        IFORM  = 1
        NSAM   = 0
        NSLICE = 1
        CALL OPFIL(.FALSE.,FILNAM,LUN1,DISP,NSAM,NROW,NSLICE,
     &             IDUM,'IMAGE',.FALSE.,IRTFLG)
        IF (IRTFLG .NE. 0) GOTO 10
        IF (NSLICE .NE. 1) GOTO 9600
        IF (.NOT. EX) THEN
C          FILL THE OUTPUT IMAGE WITH ZEROS
           DO I = 1, NSAM
              A0(I) = 0.0
           ENDDO
           DO  I = 1, NROW
              CALL WRTLIN(LUN1,A0,NSAM,I)
           ENDDO
           FMIN = 0.0
           FMAX = 0.0
        ELSE
           IF (IMAMI.NE.1) 
     &        CALL NORM3(LUN1,NSAM,NROW,NSLICE,FMAXD,FMIND,AVD)
        ENDIF

C       CREATE PATTERN
        IF (FMAX .EQ. FMIN) FMAX = FMIN + 1.0
        CALL PTTERN(LUN1,NSAM,NROW,FMAX,FMIN)
        GOTO 9000

C      OPERATION ------------------------------------------------- 'CI'
C      INPUT FILE (MEAN FILE)
3      CALL OPFIL(.TRUE.,FILNAM,LUN1,'O',NSAM1,NROW1,NSLIC1,
     &  	   IDUM,'AVERAGE',.FALSE.,IRTFLG)
       IF (IRTFLG .NE. 0) GOTO 9000
       IF (NSLIC1 .NE. 1) GOTO 9600

C      SECOND INPUT FILE CONTAINING THE VARIANCE
       CALL OPFIL(.TRUE.,FILNAM,LUN2,'O',NSAM2,NROW2,NSLIC2,
     &  	   IDUM,'VARIANCE',.FALSE.,IRTFLG)
       IF (IRTFLG .NE. 0) GOTO 9000
       IF (NSLIC2 .NE. 1) GOTO 9600
       IF (NSAM1 .NE. NSAM2 .OR. NROW1 .NE. NROW2) GOTO 9200

C      OUTPUT FILE OR FILE TO RECEIVE UPPER LIMIT OF CONFIDENCE INTERVAL
       NROW3 = NROW2
       NSAM3 = NSAM2
       NSAM  = NSAM2
       NROW  = NROW2
       IFORM = 1
       CALL OPFIL(.TRUE.,FILNAM,LUN3,'U',NSAM3,NROW3,1,
     &  	   IDUM,'UPPER LIMIT OUTPUT',.FALSE.,IRTFLG)
       IF (IRTFLG .NE. 0) GOTO 9000

C      FILE TO RECEIVE LOWER LIMIT OF CONFIDENCE INTERVAL
       NROW4 = NROW2
       NSAM4 = NSAM2
       IFORM = 1
       CALL OPFIL(.TRUE.,FILNAM,LUN4,'U',NSAM4,NROW4,1,
     &  	   IDUM,'LOWER LIMIT OUTPUT',.FALSE.,IRTFLG)
       IF (IRTFLG .NE. 0) GOTO 9000

C      CONFIDENCE INTERVAL
       CALL RDPRMI(N,IDUM,NLOOP,ILOOP,'NUMBER OF FILES ADDED')
       CALL RDPRM(ALPHA,NLOOP,ILOOP,'ERROR PROBABILITY IN %')
       CALL CONF(N,ALPHA,LUN1,LUN2,LUN3,LUN4,NSAM,NROW)
       GOTO 9000

C      OPERATION	------------------------------------------- 'EP'
C      SECOND INPUT FILE CONTAINING THE VARIANCE
4      IF(FCHAR(4:5).EQ.'TT')  THEN
C
	  CALL OPFIL(.TRUE.,FILNAM,LUN1,'O',NSAM,NROW,NSLICE,
     &  	     IDUM,'FIRST AVERAGE',.FALSE.,IRTFLG)
	  IF (IRTFLG .NE. 0) GOTO 9000

	  CALL OPFIL(.TRUE.,FILNAM,LUN2,'O',NSAM,NROW,NSLICE,
     &  	     IDUM,'FIRST VARIANCE',.FALSE.,IRTFLG)
	  IF (IRTFLG .NE. 0) GOTO 9000

          CALL RDPRMI(N1,IDUMP,NLOOP,ILOOP,'NUMBER OF IMAGES AVERAGED')

	  CALL OPFIL(.TRUE.,FILNAM,LUN3,'O',NSAM,NROW,NSLICE,
     &  	     IDUM,'SECOND AVERAGE',.FALSE.,IRTFLG)
	  IF (IRTFLG .NE. 0) GOTO 9000

	  CALL OPFIL(.TRUE.,FILNAM,LUN4,'O',NSAM,NROW,NSLICE,
     &  	     IDUM,'SECOND VARIANCE',.FALSE.,IRTFLG)
	  IF (IRTFLG .NE. 0) GOTO 9000

          CALL RDPRMI(N2,IDUMP,NLOOP,ILOOP,'NUMBER OF IMAGES AVERAGED')
									
	  CALL OPFIL(.TRUE.,FILNAM,LUN5,'U',NSAM,NROW,NSLICE,
     &  	     IDUM,'SIGNIFICANCE',.FALSE.,IRTFLG)
	  IF (IRTFLG .NE. 0) GOTO 9000
	  IF (IFORM .LT. 1)  THEN
             CALL ERRT(2,'T_TEST ',NE)
             GOTO 9000
          ENDIF

          CALL  TTEST(LUN1,LUN2,LUN3,LUN4,LUN5,N1,N2,
     &       A0(1),A0(NSAM+1),A0(2*NSAM+1),A0(3*NSAM+1),A0(4*NSAM+1),
     &       NSAM,NROW,NSLICE)
          CLOSE(LUN5)
          GOTO 9000

        ELSE
	  CALL OPFIL(.TRUE.,FILNAM,LUN2,'O',NSAM2,NROW2,NSLIC2,
     &  	     IDUM,'VARIANCE',.FALSE.,IRTFLG)
	  IF (IRTFLG .NE. 0) GOTO 9000
          IF (NSLIC2 .NE. 1) GOTO 9600
          NROW3 = NROW2
          NSAM3 = NSAM2
          NSAM  = NSAM2
          NROW  = NROW2
          IFORM = 1
	  CALL OPFIL(.TRUE.,FILNAM,LUN3,'U',NSAM3,NROW3,1,
     &  	     IDUM,'OUTPUT',.FALSE.,IRTFLG)
	  IF (IRTFLG .NE. 0) GOTO 9000

C         ERROR PROBABILITY
          CALL RDPRMI(N,IDUM,NLOOP,ILOOP,'NUMBER OF FILES ADDED')
          CALL RDPRM(A,NLOOP,ILOOP,'MAGNITUDE OF CONFIDENCE INTERVAL')
          CALL PROBER(A,N,LUN2,LUN3,NSAM,NROW,NZERO)
	  IF (NZERO.GT.0)  WRITE(NOUT,401)  NZERO
401	  FORMAT('  WARNING ! ',I10,' NEGATIVE VALUES ENCOUNTERED')
        ENDIF
        GOTO 9000

C       INCONSISTENT PICTURE DIMENSIONS
9200    IER = 1
        GOTO 9900

C       OPERATION NOT USED ON VOLUMES
9600    IER = 42

9900    CALL ERRT(IER,'CONF1',NE)

9000    CLOSE(LUN1)
        CLOSE(LUN2)
        CLOSE(LUN3)
        CLOSE(LUN4)

        RETURN
        END
