C++*********************************************************************
C
C $$ COOL2.FOR
C
C **************************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK            *
C *  COPYRIGHT (C)1981,1987, WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH 			   *
C **************************************************************************


      SUBROUTINE     COOL2(D,NPREV,N,NREM,ISIGN)
      DIMENSION      D(1)

      TWOPI = 6.2831853072*FLOAT(ISIGN)
      IP0   = 2
      IP1  = IP0*NPREV
      IP4  = IP1*N
      IP5  = IP4*NREM
      IP2  = IP1
      NPART= N

   10 IF(NPART-2)50,30,20
   20 NPART = NPART/4
      GO TO 10
C -- 	DO A FOURIER TRANSFORM OF LENGHT TWO
   30 IP3 = IP2*2

      DO  I1 = 1, IP1, IP0
      DO  I5 = I1,IP5, IP3
      J0 = I5
      J1 = J0 + IP2
      TEMPR = D(J1)
      TEMPI = D(J1+1)
      D(J1) = D(J0) - TEMPR
      D(J1+1)=D(J0+1)-TEMPI
      D(J0) = D(J0) + TEMPR
      D(J0+1)=D(J0+1)+TEMPI
      ENDDO
      ENDDO
      GO TO 140
C --    DO A FOURIER TRANSFORM OF LENGHT FOUR (FROM BIT RESERVED ORDER)

   50 IP3 = IP2*4
      THETA = TWOPI/FLOAT(IP3/IP1)
      SINTH = SIN(THETA/2.)
      WSTPR = -2.*SINTH*SINTH
C --  COS(THETA-1) , FOR ACCURACY
      WSTPI = SIN(THETA)
      WR = 1.
      WI = 0.

      DO I2 = 1, IP2, IP1
      IF (I2-1) 70, 70, 60
   60 W2R = WR*WR - WI*WI
      W2I = 2.*WR*WI
      W3R = W2R*WR - W2I*WI
      W3I = W2R*WI + W2I*WR

   70 I1MAX = I2 + IP1 - IP0
      DO I1 = I2, I1MAX, IP0
      DO I5 = I1, IP5,   IP3
      J0 = I5
      J1 = J0 + IP2
      J2 = J1 + IP2
      J3 = J2 + IP2
      IF (I2-1) 90, 90, 80
C --  APPLY THE PHASE SHIFT FACTORS

   80 TEMPR=D(J1)
      D(J1)=W2R*TEMPR-W2I*D(J1+1)
      D(J1+1) = W2R*D(J1+1) + W2I*TEMPR
      TEMPR = D(J2)
      D(J2) = WR*TEMPR - WI*D(J2+1)
      D(J2+1) = WR*D(J2+1) + WI*TEMPR
      TEMPR   = D(J3)
      D(J3)   = W3R*TEMPR  - W3I*D(J3+1)
      D(J3+1) = W3R*D(J3+1)+ W3I*TEMPR

   90 T0R = D(J0) + D(J1)
      T0I = D(J0+1) + D(J1+1)
      T1R = D(J0)   - D(J1)
      T1I = D(J0+1) - D(J1+1)
      T2R = D(J2)   + D(J3)
      T2I = D(J2+1) + D(J3+1)
      T3R = D(J2)   - D(J3)
      T3I = D(J2+1) - D(J3+1)
      D(J0)   = T0R + T2R
      D(J0+1) = T0I + T2I
      D(J2)   = T0R - T2R
      D(J2+1) = T0I - T2I
      IF (ISIGN) 100, 100, 110
  100 T3R = -T3R
      T3I = -T3I
  110 D(J1) = T1R - T3I
      D(J1+1) = T1I + T3R
      D(J3) = T1R + T3I
      D(J3+1) = T1I - T3R
      ENDDO
      ENDDO
      TEMPR = WR
      WR = WSTPR*TEMPR - WSTPI*WI + TEMPR
      WI = WSTPR*WI + WSTPI*TEMPR + WI
      ENDDO
  140 IP2=IP3
      IF (IP3-IP4) 50, 150, 150
  150 RETURN
      END
