
C++*********************************************************************
C
C  COPY1.FOR                  REMOVED FROM UTIL2 JULY 96 AL
C
C **********************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK        *
C *  COPYRIGHT (C)1981,1987, WADSWORTH CENTER FOR LABORATORIES AND     *
C *    RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201 *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS *
C *    OR USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN        *
C *    APPROVAL OF THE CENTER FOR LABORATORIES AND RESEARCH.           *
C **********************************************************************
C
C  COPY1(MAXDIM)
C
C  PARAMETERS:      MAXDIM         MAX LENGTH FOR UNLABELED COMMON
C
C        1         2         3         4         5         6         7
C23456789012345678901234567890123456789012345678901234567890123456789012
C--*********************************************************************

        SUBROUTINE COPY1(MAXDIM)

	INCLUDE 'CMBLOCK.INC'
CNO_SAVE

        CHARACTER *81   FILNAM,FILOLD,FILNEW
        COMMON /COMMUN/ FILNAM,FILOLD,FILNEW

	PARAMETER       (NFROM=13)
	PARAMETER       (NTO=11)
        CHARACTER *2    FROM(NFROM), TO(NTO)
        CHARACTER       NULL

	DATA FROM/'AS','MR','PD','RA','SF',
     &            'SH','TE','VA','LU','EM',
     &            'SC','TR','PE'/ 
  
	DATA   TO/'AS','BR','MR','PO','RA',
     &            'SF','TA','TI','VA','VV',   
     &            'SG'/   

	NULL   = CHAR(0)
	LUN1   = 8
	LUN2   = 10
	IFORM  = 1
	IERR   = 100

C       TEST THE FUNC FIRST
	IF (FCHAR(4:4) .EQ. ' ') THEN
C         STANDARD COPY
	  CALL COPYD(IRTFLG)
	  GOTO 9000

	ELSEIF (FCHAR(4:6) .EQ. 'FIX') THEN
C         USE COPY TO FIX A MALFORMED STACK
	  CALL STACKFIX(IRTFLG)
	  GOTO 9000

	ELSEIF (FCHAR(4:5) .EQ. 'TO') THEN
C         OPERATION ----------- COPY TO ------------------------ 'CP TO' 
          IC = 7
          DO  IFUNC = 1, NTO
            IF (FCHAR(IC:IC+1) .EQ. TO(IFUNC)) THEN

C             COPY FSPIDER FORMAT TO FOREIGN FORMAT
	      IF (FCHAR(IC:IC+2) .NE. 'MRC'      .AND.
     &            FCHAR(IC:IC+2) .NE. 'SF3'      .AND.
     &            FCHAR(IC:IC+2) .NE. 'VAX') THEN
C               OPEN INPUT FILE
#ifdef SP_VMS
                IF (FCHAR(IC:IC+1) .NE. 'TI' .AND.
     &              FCHAR(IC:IC+2) .NE. 'RAW') THEN
#endif
	          CALL OPFIL(.TRUE.,FILNAM,LUN1,'O',NSAM1,NROW1,
     &                NSLICE1,IDUM1,'INPUT',.TRUE.,IRTFLG)
#ifdef SP_VMS
	        ENDIF
#endif
	        IF (IRTFLG .NE. 0) GOTO 9000
	        IF (NSAM1 .GT. MAXDIM) THEN
                   CALL ERRT(9,'COPY1 ',NE)
                   GOTO 9000
                ENDIF
	      ENDIF

              GOTO (20,21,22,23,24,25,26,27,28,29,30)IFUNC
            ENDIF
          ENDDO

C	  NO SUCH COPY FUNCTION
          WRITE(NOUT,*) '**** NO SUCH CP OPERATION, CHECK MENU'
          CALL ERRT(100,'COPY1',NERRD)
	  RETURN

	ELSEIF (FCHAR(4:7) .EQ. 'FROM') THEN
C         OPERATION ----------- COPY FROM ------------------- 'CP FROM' 
C         COPY FROM FOREIGN FORMAT TO SPIDER
          IC = 9
          DO  IFUNC = 1, NFROM
            IF (FCHAR(IC:IC+1) .EQ. FROM(IFUNC)) THEN
              GOTO (50,51,52,53,54,55,56,57,58,59,60,61,62)IFUNC
            ENDIF
          ENDDO

C	  NO SUCH COPY FUNCTION
          WRITE(NOUT,*) '**** NO SUCH CP OPERATION, CHECK MENU'
          CALL ERRT(100,'COPY1',NERRD)
	  RETURN

        ELSE
C         OLD COPY OPERATION
          GOTO 9922
        ENDIF


C	--------------- CP TO OPERATIONS -----------------------------

C       COPY SPIDER IMAGE FILE INTO EDITABLE IMAGE ------ 'CP TO ASCII'
20      CALL COPYE(LUN1,LUN2,NSAM1,NROW1,NSLICE1)
        GOTO 9000

C       COPY 3D SPIDER FILE TO BRIX FORMAT-----------------'CP TO BRIX'
21      CALL COPYBRIX(LUN1,LUN2,NSAM1,NROW1,NSLICE1)
        GOTO 9000

C       MRC'S FORMAT FOR TRANSFERING TO CAMBRIDGE --------- 'CP TO MRC'
C       COPY FROM SPIDER IMAGE FILE INTO MRC FORMAT
22      CALL COPYMRC(LUN1,LUN2)
        GOTO 9000

C       SPIDER IMAGE TO POSTSCRIPT IMAGE (8 BIT) --------- 'CP TO POST'
23      CALL COPYPOS(LUN1,LUN2,NSAM1, NROW1, NSLICE1)
        GOTO 9000

C       COPY SPIDER IMAGE FILE INTO RAW IMAGE FILE -------- 'CP TO RAW'
24      CALL COPYU(LUN1,LUN2,NSAM1,NROW1,NSLICE1,IC)
        GOTO 9000

C       COPY 3D FOURIER TRANSFORM TO SIMPLE FORMAT -------- 'CP TO SF3'
25      CALL COPYFSIMPLE(LUN1,LUN2)
        GOTO 9000

C       TO TARGA FORMAT USING SGI  ---------------------- 'CP TO TARGA'
26      CALL SPITOSGI(LUN1,LUN2,NSAM1,NROW1,NSLICE1,1,IRTFLG)
        GOTO 9000

#ifdef SP_VMS
C	'CP TO TIFF' does not exist in VAX version
27	WRITE(NOUT,*)' *** CP TO TIFF NOT AVAILABLE ON VAX'
        CALL ERRT(100,'COPY1',NERRD)
	GOTO 9000
#else
C        CONVERT FROM SPIDER FORMAT TO TIFF FORMAT ------- 'CP TO TIFF'
27	 CALL SPDTOTIFF(LUN1,LUN2,NSAM1,NROW1,NSLICE1,IRTFLG)
         GOTO 9000
#endif

C       COPY UNIX SPIDER FILE TO VAX SPIDER   ------------- 'CP TO VAX'
28      CALL COPYVAX(LUN1,LUN2,LUN3)
        GOTO 9000

C       COPY UNIX IMAGE FILE INTO VOXEL-VIEW FILES --------- 'CP TO VV'
29      CALL UNIXTOVV(LUN1,LUN2,0,255,NSAM1,NROW1,NSLICE1,IRTFLG)
        GOTO 9000

C       COPY UNIX IMAGE FILE INTO SGI FILES --------------- 'CP TO SGI'
30      CALL SPITOSGI(LUN1,LUN2,NSAM1,NROW1,NSLICE1,0,IRTFLG)
        GOTO 9000

C	--------------- CP FROM OPERATIONS ----------------------------

C       EDITABLE IMAGE FILE TO SPIDER IMAGE FILE ------ 'CP FROM ASCII'
50      CALL COPYF(LUN1,LUN2)
        GOTO 9000

C       MRC'S FORMAT TO SPIDER -------------------------- 'CP FROM MRC'
C       COPY FROM MRC FORMAT INTO SPIDER IMAGE FILE
51      CALL COPYMRC(LUN1,LUN2)
        GOTO 9000

C       COPY A PDB FILE INTO SPIDER VOLUME FILE --------- 'CP FROM PDB'
52      CALL READPDB(MAXDIM) 
        GOTO 9000

C       COPY RAW IMAGE FILE INTO SPIDER IMAGE FILE ------ 'CP FROM RAW'
53      CALL RAWTOSPIDER(LUN1,LUN2,IRTFLG)
        GOTO 9000

C       3D FOURIER TRANSFORM FROM SIMPLE FORMAT --------- 'CP FROM SF3'
54      CALL COPYFSIMPLE(LUN1,LUN2)
        GOTO 9000

C       SHORT HEADER FILE TO REGULAR HEADER FILE ------ 'CP FROM SHORT'
55      CALL COPYSHORT(LUN1,LUN2)
        GOTO 9000

C       COPY FROM TERMINAL INTO SPIDER IMAGE FILE ------- 'CPFROM TERM'
56      CALL COPYR(LUN2)
        GOTO 9000
          
C       COPY VAX SPIDER TO UNIX SPIDER ------------------ 'CP FROM VAX'
57      FILOLD = NULL
        FILNEW = NULL
#ifdef SP_VMS
        CALL COPYU(LUN1,LUN2,NSAM,NROW,NSLICE,IC)
#else
        CALL VAXTOUNIX(FILOLD,FILNEW,LUN1,LUN2,IRTFLG)
#endif
        GOTO 9000

C       COPY TWO ILUMINATION LEVEL IMAGES INTO A MERGED THIRD IMAGE
C			--------------------------------- 'CP FROM LUM'	
58      CALL ADJUST(LUN1,LUN2,LUN3,IRTFLG)
        GOTO 9000

C       EIKONIX SCAN PROGRAMS (REMOVED 1994)
59      WRITE(NOUT,*)'*** EIKONIX SUBROUTINES NO LONGER SUPPORTED'
        CALL ERRT(IER,'COPY1 ',NE)
        GOTO 9000

C       COPY FROM EM-FORMAT TO SPIDER FORMAT ------------- 'CP FROM EM'
60      CALL COPYEM(LUN1,LUN2)
        GOTO 9000

C       COPY FROM MICRO D TAPE FORMAT TO SPIDER  --------- 'CP FROM TR'
61      CALL COPYMDTR(LUN1,LUN2)
        GOTO 9000

C       COPY FROM MICRO D ONDISK FORMAT TO SPIDER  ------- 'CP FROM PE'
62      CALL COPYPDS(LUN1,LUN2)
        GOTO 9000

9000    CLOSE(LUN1)
        CLOSE(LUN2)

        IFOUND = 1
        RETURN



C       ----------- OLD 'CP' OPERATIONS   (Changed in Sept. 96 by liy)
9922    IF (FCHAR(4:5) .EQ. 'SC') THEN
C         EIKONIX SCAN PROGRAMS (REMOVED 1994)
          WRITE(NOUT,*)'**** EIKONIX SUBROUTINES NO LONGER SUPPORTED'
          CALL ERRT(100,'COPY1 ',NE)
          RETURN

        ELSEIF (FCHAR(4:7) .EQ. 'BRIX') THEN
C         COPY 3D SPIDER FILE TO BRIX FORMAT
          WRITE(NOUT,*) '**** Use <CP TO BRIX> instead ****'
          CALL ERRT(100,'COPY1 ',NE)
          RETURN

        ELSEIF (FCHAR(4:6) .EQ. 'SF3') THEN
C         COPY 3D FOURIER TRANSFORM TO AND FROM SIMPLE FORMAT
          WRITE(NOUT,*)'**** Use <CP TO or FROM SF3> instead ****'
          CALL ERRT(100,'COPY1 ',NE)
          RETURN

        ELSEIF (FCHAR(4:5) .EQ. 'SH') THEN
C         COPY SHORT HEADER FILE TO REGULAR HEADER FILE
          WRITE(NOUT,*)'**** Use <CP FROM SH> instead ****'
          CALL ERRT(100,'COPY1 ',NE)
          RETURN

        ELSEIF (FCHAR(4:4) .EQ. 'L') THEN
C         COPY TWO ILUMINATION LEVEL IMAGES INTO A MERGED THIRD IMAGE
          WRITE(NOUT,*)'**** Use <CP FROM LUM> instead ****'
          CALL ERRT(100,'COPY1 ',NE)
          RETURN

        ELSEIF (FCHAR(4:6) .EQ. 'RAW') THEN
C         COPY RAW IMAGE FILE INTO SPIDER IMAGE FILE
          WRITE(NOUT,*)'**** Use <CP FROM RAW> instead ****'
          CALL ERRT(100,'COPY1 ',NE)
          RETURN

        ELSEIF (FCHAR(4:4) .EQ. 'R') THEN
C         COPY FROM TERMINAL INTO SPIDER IMAGE FILE
          WRITE(NOUT,*)'**** Use <CP FROM TERM> instead ****'
          CALL ERRT(100,'COPY1 ',NE)
          RETURN

        ELSEIF (FCHAR(4:4) .EQ. 'W') THEN
C         OBSOLETE IMAGE INPUT/OUTPUT REMOVED DEC 89 AL
          WRITE(NOUT,*) 'USE "CP F" INSTEAD'
          CALL ERRT(100,'COPY1 ',NE)
          RETURN
          
        ELSEIF (FCHAR(4:5) .EQ. 'EM') THEN
C         COPY FROM EM-FORMAT TO SPIDER FORMAT
          WRITE(NOUT,*)'**** Use <CP FROM EM> instead ****'
          CALL ERRT(100,'COPY1 ',NE)
          RETURN

        ELSEIF (FCHAR(4:5) .EQ. 'EF' .OR. FCHAR(4:5) .EQ. 'VF') THEN
          WRITE(NOUT,*) 'USE "CP E" INSTEAD'
          CALL ERRT(100,'COPY1 ',NE)
          RETURN

        ELSEIF (FCHAR(4:5) .EQ. 'PO') THEN
C         COPY FROM SPIDER IMAGE TO POSTSCRIPT IMAGE (8 BIT)
          WRITE(NOUT,*)'**** Use <CP TO PO> instead ****'
          CALL ERRT(100,'COPY1 ',NE)
          RETURN

        ELSEIF (FCHAR(4:5) .EQ. 'JP') THEN
C         COPIES FROM JP'S FORMAT INTO SPIDER IMAGE FILE
          WRITE(NOUT,*)'**** THIS COMMAND NO LONGER SUPPORTED'
          CALL ERRT(100,'COPY1 ',NE)
          RETURN

        ELSEIF (FCHAR(4:6) .EQ.'MRC') THEN
C         MRC'S FORMAT FOR TRANSFERING TO CAMBRIDGE (CP MRC)
C         COPY FROM MRC FORMAT INTO SPIDER IMAGE FILE
          WRITE(NOUT,*)'**** Use <CP TO or FROM MRC> instead ****'
          CALL ERRT(100,'COPY1 ',NE)
          RETURN

        ELSEIF (FCHAR(4:5) .EQ. 'U8' .OR. FCHAR(4:6) .EQ. 'U-8'
     &          .OR. FCHAR(4:5) .EQ. 'U8n' ) THEN
C         COPY SPIDER IMAGE FILE INTO UNIX SPIDER IMAGE FILE
          WRITE(NOUT,*)'**** Use <CP TO RAW> instead ****'
          CALL ERRT(100,'COPY1 ',NE)
          RETURN

        ELSEIF (FCHAR(4:4) .EQ. 'U') THEN
C         COPY SPIDER IMAGE FILE INTO UNIX SPIDER IMAGE FILE
          WRITE(NOUT,*)'**** Use <CP FROM VAX> instead ****'
          CALL ERRT(100,'COPY1 ',NE)
          RETURN

        ELSEIF (FCHAR(4:4) .EQ. 'TIFF') THEN
C         COPY TARGA IMAGE FILE INTO UNIX SPIDER IMAGE FILE
          WRITE(NOUT,*)'**** Use <CP TO TIFF> instead ****'
          CALL ERRT(100,'COPY1 ',NE)
          RETURN

        ELSEIF (FCHAR(4:4) .EQ. 'T') THEN
C         COPY TARGA IMAGE FILE INTO UNIX SPIDER IMAGE FILE
          WRITE(NOUT,*)'**** Use <CP TO TARGA or TARGAV> instead ****'
          CALL ERRT(100,'COPY1 ',NE)
          RETURN

        ELSEIF (FCHAR(4:5) .EQ. 'VV') THEN
C         COPY UNIX IMAGE FILE INTO VOXEL-VIEW FILES
          WRITE(NOUT,*)'**** Use <CP TO VV> instead ****'
          CALL ERRT(100,'COPY1 ',NE)
          RETURN

        ELSEIF (FCHAR(4:4) .EQ. 'V') THEN
C         COPY UNIX IMAGE FILE INTO VAX SPIDER IMAGE FILE
          WRITE(NOUT,*)'**** Use <CP TO VAX> instead ****'
          CALL ERRT(100,'COPY1 ',NE)
          RETURN

        ELSEIF (FCHAR(4:4) .EQ. 'F') THEN
C         COPY EDITABLE IMAGE FILE INTO SPIDER IMAGE FILE
          WRITE(NOUT,*)'**** Use <CP FROM ASC> instead ****'
          CALL ERRT(100,'COPY1 ',NE)
          RETURN

       ELSEIF (FCHAR(4:6) .EQ. 'PDB') THEN
C         COPY A PDB FILE INTO SPIDER VOLUME FILE
          WRITE(NOUT,*)'**** Use <CP FROM PDB> instead ****'
          CALL ERRT(100,'COPY1 ',NE)
          RETURN

        ELSE IF (FCHAR(4:4).EQ.'I') THEN
C         TRAP FOR 'CP I' ROUTINE, SIXEL IMAGE OUTPUT
          WRITE(NOUT,*)'**** THIS COMMAND NO LONGER SUPPORTED'
          CALL ERRT(100,'COPY1 ',NE)
          RETURN

        ELSE IF (FCHAR(4:4).EQ.'E') THEN
C         TRAP FOR 'CP E', COPY SPIDER IMAGE FILE INTO EDITABLE IMAGE
          WRITE(NOUT,*)'**** Use <CP TO ASC> instead ****'
          CALL ERRT(100,'COPY1 ',NE)
          RETURN

        ELSE
          WRITE(NOUT,*)
     &     '**** NO SUCH OPERATION'
          CALL ERRT(100,'COPY1 ',NE)
          RETURN
        ENDIF

        END
