
C++*********************************************************************
C
C COPYD.FOR -- CREATED 23 DEC 87 al
C
C **********************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK            *
C *  COPYRIGHT (C)1981,1987, WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH 			   *
C **********************************************************************
C
C  COPYD(IRTFLG)
C
C  PURPOSE:  COPY A SPIDER IMAGE FILE TO ANOTHER FILE
C 
C  PARAMETERS:       IRTFLG       ERROR FLAG
C
C  NOTES:   NEEDS TO SET BUF(26) IN STACK
C
C        0         2         3         4         5         6         7     
C23456789 123456789 123456789 123456789 123456789 123456789 123456789 12
C--*********************************************************************

        SUBROUTINE COPYD(IRTFLG)

        INCLUDE 'CMBLOCK.INC'
CNO_SAVE

        CHARACTER *81   FILNAM
        COMMON /COMMUN/ FILNAM
        COMMON /LUNARA/ LUNARA(100),LUNSTK(100)
        COMMON /IOERR/  IERR
        COMMON          VALUES(256),BUF(256)

        DATA NBUFSIZ/17000/

	LUNIN  = 14
	LUNOUT = 15

C	GET NAME OF INPUT FILE
10      NSTACKIN = -1
        CALL OPFIL(.TRUE.,FILNAM,LUNIN,'OLD',NSAM,NROW,NSLICE,
     &             NSTACKIN,'INPUT',.TRUE.,IRTFLG) 
	IF (IRTFLG .NE. 0) RETURN

C	OPEN OUTPUT FILE, KEEP INPUT FILE DATE, TIME AND TITLE
        IRTFLG    = -9 
        NSTACKOUT = -1           
        IF (NSTACKIN .GT. 0) NSTACKOUT = NSTACKIN
        CALL OPFIL(.TRUE.,FILNAM,LUNOUT,'UNK',NSAM,NROW,NSLICE,
     &             NSTACKOUT,'OUTPUT',.TRUE.,IRTFLG) 
	IF (IRTFLG .EQ. -1) GOTO 10
	IF (IRTFLG .NE. 0) RETURN

	IF (NSTACKIN .GE. 0 .AND. NSTACKOUT .GE. 0) THEN
C	   DUPLICATE WHOLE STACK FILE RECORD BY RECORD INCLUDING HEADER
           WRITE(NOUT,*)
     &           ' PLEASE IGNORE ANY ARRAY OVERFLOW ERROR MESSAGE'
           LUNARA(LUNIN)  = 0
           LUNSTK(LUNIN)  = 0
           LUNARA(LUNOUT) = 0
           LUNSTK(LUNOUT) = 0
           IREC           = 0
           IERR           = 0
           DO WHILE (IERR .EQ. 0)
              IREC = IREC + 1
              CALL REDLIN(LUNIN,BUF,NSAM,IREC)
	      IF (IERR .EQ. 0) THEN
                 CALL WRTLIN(LUNOUT,BUF,NSAM,IREC)
              ENDIF
	   END DO

        ELSEIF (NSTACKIN .GE. 0 .AND. NSTACKOUT .LT. 0) THEN
           CALL ERRT(101,'CAN NOT COPY A WHOLE STACK TO AN IMAGE',NE)
           GOTO 999

	ELSE
C	  IMAGE TO STACKED IMAGE OR STACKED IMAGE TO IMAGE

C         RETRIEVE HEADER VARIABLES FROM OLD FILE
	  CALL REDHED(LUNIN,BUF,NBUFSIZ,NSAM,0,IRTFLG)
          IF (IRTFLG .NE. 0) GOTO 999

C         ALTER NECESSARY HEADER VALUES SUCH AS: (BUF=24)
	  BUF(24) = 0.0
          IF (NSTACKOUT .GT. -2) BUF(24) = NSTACKOUT
C         SET IMUSED  (BUF=25)
	  BUF(25) = 1.0

C         PLACE ALTERED HEADER INTO NEW IMAGE FILE
	  CALL WRTHED(LUNOUT,BUF,NSAM,IRTFLG)
          IF (IRTFLG .NE. 0) GOTO 999
    
C         FIGURE OUT NUMBER OF DATA RECORDS TO BE COPIED
	  CALL TOTREC(NSAM,NROW,NSLICE,IEND)

C         COPY THE DESIRED NUMBER OF DATA RECORDS
          DO  I = 1,IEND
             CALL REDLIN(LUNIN,BUF,NSAM,I)
             CALL WRTLIN(LUNOUT,BUF,NSAM,I)
          ENDDO

       ENDIF
       IRTFLG = 0

999    CLOSE(LUNIN)
       CLOSE(LUNOUT)

       RETURN
       END
