
C++*************************************************************************
C
C $$ COPYE.FOR -- CREATED JULY 17 1989 al                     
C
C **************************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK            *
C *  COPYRIGHT (C)1981,1987, WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH 			   *
C **************************************************************************
C
C $$ COPYE(LUN1,LUN2,NSAM,NROW,NSLICE)
C
C    PURPOSE:   COPIES A SPIDER IMAGE FILE INTO AN EDITABLE IMAGE FILE
C
C    PARAMETERS:   LUN       INPUT FILE UNIT NUMBER
C                  LUN2      OUTPUT FILE UNIT NUMBER
C                  NSAM      SAMPLES PER LINE IN IMAGE
C                  NROW      NO. OF ROWS IN IMAGE
C                  NSLICE    NO. OF SLICES IN IMAGE
C--*************************************************************************

	SUBROUTINE COPYE(LUN1,LUN2,NSAM,NROW,NSLICE)

	COMMON BUF(1)
        COMMON /COMMUN/ FILNAM
        INCLUDE 'CMBLOCK.INC'

        CHARACTER *81  FILNAM
	CHARACTER *60  FMT,FORMIN
        CHARACTER *15  FMTDEF
        CHARACTER * 1  NULL

        DATA FMTDEF /'(6(1X,1PG12.4))'/

        NULL=CHAR(0)

10      CALL FILERD(FILNAM,NLET,NULL,'OUTPUT',IRTFLG)
        IF (IRTFLG .NE. 0) RETURN

12      CALL FILCAN(FILNAM,NLET,NULL,NULL,FILNAM,DATEXC,IRTFLG)
        IF (IRTFLG .NE. 0) GOTO 10
   
        OPEN(LUN2,FILE=FILNAM,FORM='FORMATTED',STATUS='NEW')

20      CALL RDPRMC(FORMIN,NC,.TRUE.,
     &  'ENTER FORMAT DESCRIPTION (OR <CR> FOR 6(1X,G12.4))',
     &  NULL,IRTFLG)
        IF (IRTFLG .NE. 0) THEN
           CLOSE(LUN2)
           GOTO 20
        ENDIF

	IF (NC .GT. 58) THEN
          WRITE(NOUT,*) ' *** FORMAT LENGTH MUST BE <59 CHARACTERS.'
	  GOTO 20

        ELSEIF (NC .EQ. 0) THEN
C         USE DEFAULT FORMAT
          FMT(1:60) = FMTDEF

        ELSE
C         SET OUTPUT FORMAT
          FMT(1:60) = '(' // FORMIN(1:58) // ')'
        ENDIF

        IRECT = NROW * NSLICE

        WRITE(LUN2,*) NSAM,NROW,NSLICE

	DO  I=1,IRECT
          CALL REDLIN(LUN1,BUF,NSAM,I)
          WRITE(LUN2,FMT)(BUF(K),K=1,NSAM)
	ENDDO

	CLOSE(LUN1)
	CLOSE(LUN2)

	RETURN
        END

