
C++*************************************************************************
C
C    COPYF.FOR -- CREATED JULY 17 1989 al                     
C
C **************************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK            *
C *  COPYRIGHT (C)1981,1987, WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH 			   *
C **************************************************************************
C
C    COPYF(LUN1,LUN2)
C
C    PURPOSE:   COPIES AN EDITABLE IMAGE FILE INTO A SPIDER IMAGE FILE
C
C    PARAMETERS:   LUN1      INPUT FILE UNIT NUMBER
C                  LUN2      OUTPUT FILE UNIT NUMBER
C--*************************************************************************

	SUBROUTINE COPYF(LUN1,LUN2)

	COMMON BUF(1)
        COMMON /COMMUN/ FILNAM

        INCLUDE 'CMBLOCK.INC'

        CHARACTER *81  FILNAM
        CHARACTER * 1  NULL,ANSW
        LOGICAL        EX

        NULL=CHAR(0)

10      CALL FILERD(FILNAM,NLET,NULL,'EDITABLE IMAGE INPUT',IRTFLG)
        IF (IRTFLG .NE. 0) RETURN

        CALL FILCAN(FILNAM,NLET,NULL,NULL,FILNAM,DATEXC,IRTFLG)
        IF (IRTFLG .NE. 0) GOTO 10

        INQUIRE(FILE=FILNAM,ERR=9000,EXIST=EX)
        IF (.NOT. EX) THEN
           WRITE(NOUT,*) '*** NON-EXISTANT FILE: ',FILNAM(1:NLET)
           GOTO 9000
        ENDIF

        CLOSE(LUN1)
        OPEN(LUN1,FILE=FILNAM,FORM='FORMATTED',STATUS='OLD',ERR=9000)

12      CALL RDPRMC(ANSW,NC,.TRUE.,
     &     'ARE NSAM, NROW AND NSLICE IN FIRST LINE OF FILE?',
     &     NULL,IRTFLG)

        IF (IRTFLG .EQ. -1) THEN
           GOTO 10

        ELSEIF (NC .EQ. 0 .OR. ANSW .EQ. 'Y') THEN
C          CAN GET NSAM OUT OF FILE
           READ(LUN1,*,IOSTAT=IOS) NSAM,NROW,NSLICE
           IBCNT = IBCNT + 1
           IF (IOS .NE. 0) THEN
             WRITE(NOUT,*) '*** ERROR READING FILE'
             CLOSE(LUN1)
             RETURN
           ENDIF

        ELSE
C          ASK USER FOR NSAM, ETC.
15         CALL RDPRIS(NSAM,NROW,NLOOP,ILOOP,'ENTER NSAM & NROW:',IRT)
           IF (IRT .EQ. -1) GOTO 10
           CALL RDPRIS(NSLICE,NDUM,NLOOP,ILOOP,'ENTER NSLICE:',IRT)
           IF (IRT .EQ. -1) GOTO 15
        ENDIF

        IF (NSLICE .LE. 0) NSLICE = 1

20      IFORM = 1
        IF (NSLICE .GT. 1) IFORM = 3
        MAXIM = 0
        CALL OPFIL(.TRUE.,FILNAM,LUN2,'U',NSAM,NROW,NSLICE,
     &             MAXIM,'OUTPUT',.FALSE.,IRTFLG)
        IF (IRTFLG .NE. 0) THEN
           CLOSE(LUN1)
           GOTO 12
        ENDIF

        IRECT = NROW * NSLICE

	DO I=1,IRECT
C          IOSTAT NEEDED FOR PARTIAL LINES
           READ(LUN1,*,IOSTAT=IOS) (BUF(J),J=1,NSAM)
           IBCNT = IBCNT + 1
           CALL WRTLIN(LUN2,BUF,NSAM,I)
        ENDDO

	CLOSE(LUN1)
	CLOSE(LUN2)
	RETURN

9000    CALL ERRT(4,'COPYF',NE)
        RETURN

        END


