
C ++********************************************************************
C
C COPYMRC                     modified for F90 ----- yl         10/22/97
C
C **********************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK            *
C *  COPYRIGHT (C)1981,1993, WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH                            *
C **********************************************************************
C 
C COPYMRC(LUNSPI,LUNMRC)
C                                                                      
C PURPOSE: CONVERTS SPIDER IMAGES TO OR FROM MRC FORMAT
C
C	THE MRC FILE IS OPENED IN BINARY FORMAT.
C	THE DATA IN THE FILE WAS WRITTEN IN BYTE FORMAT AS FOLLOW:
C	 MODE   0 : IMAGE STORED AS INTEGER*1  
C               1 : IMAGE STORED AS INTEGER*2
C               2 : IMAGE STORED AS REALS
C
C        0         2         3         4         5         6         7
C23456789012345678901234567890123456789012345678901234567890123456789012
C***********************************************************************

         SUBROUTINE COPYMRC(LUNSPI,LUNMRC)

         INCLUDE 'CMBLOCK.INC'

CNO_SAVE
	 COMMON /LUNARA/ LUNARA(100),LUNSTK(100)
C        RUN-TIME ALLOCATION SPECIFIC CODE LINE FOLLOWS
#ifdef SP_NT
         INTEGER LOCLUN
#else
         INTEGER * 8     LOCLUN
#endif

         LOGICAL USEINLN
         COMMON /LUNARB/ LOCLUN(100),NSAMLUN(100),NWORDLUN(100),USEINLN

         PARAMETER       (NBUFSIZ = 17008)
         COMMON /IOBUF/  BUF(NBUFSIZ)

         LOGICAL         EXIST  
         CHARACTER *81   FILNAM,MRCFILE
	 CHARACTER *5	 MRCEXC
         CHARACTER       NULL 
	
         NULL  = CHAR(0)
	
         IF (FCHAR(4:6) .EQ. 'TO')   GOTO 1000

C        COPY FROM MRC TO SPIDER FILE FORMAT ------------------FROM MRC
C        SET IRTFLG TO ALLOW FILE EXTENSION ON INPUT
         IRTFLG = 9
	 LENEXC = LEN(DATEXC)
	 MRCEXC(1:LENEXC) = DATEXC(1:LENEXC)
         CALL FILERD(MRCFILE,NCHAR,MRCEXC,'MRC INPUT',IRTFLG)
         IF (IRTFLG .EQ. -1) GOTO 9999
  
C        OPEN FOR READ / WRITE
#ifdef SP_VMS
         OPEN(UNIT=LUNMRC,FILE=MRCFILE,STATUS='OLD',
     &       RECORDTYPE='FIXED', ACCESS='DIRECT', IOSTAT=IER)
C        IF (IER .NE. 0) CALL LIB$SIGNAL(%VAL(IER))
#else
         LENOPN = 1024
#ifdef __osf__
C        RECL IS IN UNITS OF FLOATS ON OSF 
         LENOPN = 256
#endif
C        RECL IS IN 4 BYTES
         OPEN(LUNMRC,FILE=MRCFILE,STATUS='OLD',ACCESS='DIRECT',
     &        FORM='UNFORMATTED',RECL=LENOPN,IOSTAT=IER)
#endif
        IF (IER .NE. 0) THEN        
           WRITE(NOUT,*) '*** ERROR OPENING FILE: ',MRCFILE 
           CALL ERRT(100,'IMOPEN',NE)
           RETURN
        ENDIF
	
        LUNARA(LUNMRC) = 0
        LUNSTK(LUNMRC) = 0
        LOCLUN(LUNMRC) = 0

C	READ THE MRC HEADER	
        CALL REDLIN(LUNMRC,BUF,256,1)
 
C	PARSE THE MRC HEADER	
        CALL REDHEDMRC(BUF,NSAM,NROW,NSLICE,MODE,FMIN,FMAX,AV)

C       OPEN SPIDER OUTPUT FILE	
        IFORM  = 1
        IF (NSLICE .GT. 1) IFORM = 3
        CALL OPFIL(.TRUE.,FILNAM,LUNSPI,'U',NSAM,NROW,NSLICE,
     &             IDUM,'SPIDER OUTPUT',.FALSE.,IRTFLG)
        IF (IRTFLG .EQ. -1) GOTO 9999

C       EXTRACT DATA FROM MRC FILE AFTER HEADER & PUT IN SPIDER FILE
        IOFFSET = 1024
        NBYTES  = NSAM * NROW * NSLICE 
        IF (MODE .GT. 0) NBYTES = NBYTES * MODE * 2
        NBYTES  = NBYTES + IOFFSET
        IF (MODE .EQ. 0) THEN
           INMODE  = 8
        ELSEIF (MODE .EQ. 1) THEN
           INMODE = 16
        ELSEIF (MODE .EQ. 2) THEN
           INMODE = 32
        ELSE
 	   WRITE(NOUT,*)'THIS MODE ',MODE, 'CAN NOT BE COPIED TO SPIDER' 
           CALL ERRT(100,'COPYMRC',NE)
           RETURN
        ENDIF

        CALL RAWTOSPI(LUNMRC,IOFFSET,LUNSPI,NSAM,NBYTES,
     &               INMODE,.FALSE.,IOFFSET,1,IRTFLG)

C       SET IMAMI IN SPIDER FILE, FILE TYPE UNCHANGED
        CALL SETPRM(LUNSPI,NSAM,NROW,0,0,0,'U')

        GOTO 9999

	

C       MRC MRC MRC MRC MRC MRC MRC MRC MRC MRC MRC MRC MRC MRC MRC MRC  
C       COPY FROM SPIDER TO MRC FILE FORMAT -------------------- TO MRC

1000    CALL OPFIL(.TRUE.,FILNAM,LUNSPI,'O',NSAM,NROW,NSLICE,
     &             IDUM,'SPIDER INPUT',.FALSE.,IRTFLG)
        IF (IRTFLG .EQ. -1) GOTO 9999

C       SET IRTFLG TO ALLOW FILE EXTENSION IN INPUT
        IRTFLG = 9
	LENEXC = LEN(DATEXC)
	MRCEXC(1:LENEXC) = DATEXC(1:LENEXC)
        CALL FILERD(MRCFILE,NCHAR,MRCEXC,'MRC OUTPUT',IRTFLG)
        IF (IRTFLG .EQ. -1) THEN
           CLOSE(LUNSPI)
           GOTO 1000
        ENDIF

C	OPEN A NEW FILE FOR THE MRC FORMAT
C	OPEN FILE WITH A RECORD LENGTH OF 256 FLOATS)
	
C       OPEN NEW 8 BIT SEQUENTIAL OUTPUT FILE
C        OPEN(LUNMRC,FILE=MRCFILE,ACCESS='SEQUENTIAL',IOSTAT=IER,
C     &      STATUS='UNKNOWN',FORM='FORMATTED',CARRIAGECONTROL='NONE')
        OPEN(LUNMRC,FILE=MRCFILE,ACCESS='DIRECT',IOSTAT=IER,
     &      RECL=1,STATUS='UNKNOWN',FORM='UNFORMATTED')
	IF (IER.NE.0) GOTO 9999 

C	CREATE A NEW HEADER FOR THE MRC FILE
C	WRITE HEADER. (NOTE: FMIN, FMAX, AV ARE SAME AS SPIDER IMAGE)
        CALL WRTHEDMRC(MRCFILE, NSAM, NROW, NSLICE,
     &                 LUNMRC,BUF,FMIN,FMAX,AV,2,IRTFLG)
        IF (IRTFLG .NE. 0) GOTO 9999

C	READ THE IMAGE ROW BY ROW, CONSTRUCT A RECORD OF
C	256 FLOATS (1024 BYTES) THEN WRITE IT IN THE MRC FILE.

C       MRCGO IS POINTER TO LOCATION OF MRC BUFFER IN BUF
        MRCGO  = NSAM + 1
C       K IS POINTER TO CURRENT NUMBER OF PIXELS IN MRC BUFFER
        DO  I = 1,NROW * NSLICE
C          READ EACH RECORD OF 32 BIT UNIX SPIDER INPUT FILE   
           CALL REDLIN(LUNSPI,BUF,NSAM,I)

C          CONVERT FLOATING POINT NUMBERS TO -128...127 LOGICAL *1
           DO J=1,NSAM
C            PUT IT OUT TO FILE
            WRITE(LUNMRC,ERR=9999)BUF(J)
           ENDDO
        ENDDO
	
9999    CLOSE(LUNSPI)
        CLOSE(LUNMRC)

        RETURN
        END



