
	SUBROUTINE COPYPDS(LUN1,LUN)

C PROGRAM TO CONVERT PERKIN ELMER SCANSALOT FILE TO SPIDER FORMAT.
C AUTHOR M.RADERMACHER 10/94

        INCLUDE   'CMBLOCK.INC'

        PARAMETER (NSIZE  = 10000)
	COMMON /COMMUN/FILNAM,IMGFILE,HDRFILE
	COMMON IBUF(NSIZE),BUF(NSIZE),DBUF(NSIZE)
        INTEGER*2 IBUF
        CHARACTER*40 TEXT,BLANK  
	CHARACTER *81 INPUTN,IMGFILE,HDRFILE,FILNAM
	CHARACTER *4  EXTENP
	CHARACTER*1   NULL,SCANDIR,TRADE
        REAL*8 ADD,DGAIN,SUM,DBUF
        LOGICAL TDFLAG,IFNS

C THIS STATEMENT IS TO TRANSFER ID FROM SCAN FILE TO SPIDER COMMENT.
        EQUIVALENCE (ITIT,TEXT)
	
#ifdef __osf__
	WRITE(NOUT,*) '*** COPYPDS DOES NOT WORK ON THIS MACHINE'
        CALL ERRT(100,'COPYPDS',NE)
	RETURN
#else
C	STOP COMPLAINT OF NO PATH TO NEXT STATEMENT ON OSF MACHINE.
        CONTINUE

        NULL=CHAR(0)

	CALL FILERD(INPUTN,NLET,NULL,'SCAN INPUT',IRTFLG)
	IF (IRTFLG .NE. 0) RETURN 

C CREATE PERKIN ELMER STYLE IMAGE NAME:
        EXTENP = 'IMG'
        CALL FILCAN(IMGFILE,NLET,NULL,NULL,INPUTN,EXTENP,IRTFLG)

C CREATE PERKIN ELMER STYLE HEADER FILE NAME:
        EXTENP = 'HDR'
        CALL FILCAN(HDRFILE,NLET,NULL,NULL,INPUTN,EXTENP,IRTFLG)

C OPEN HEADER FILE (WHICH IS READABLE ASCII):        

        OPEN(UNIT=LUN,STATUS='UNKNOWN',FILE=HDRFILE(1:NLET),ERR=998)

C FIRST LINE CONTAINS IDENTIFIER:
        READ(LUN,300) TEXT
300     FORMAT(19X,A40)

C SECOND LINE CONTAINS X-DIMENSION
        READ(LUN,301) NSAM
301     FORMAT(24X,I5)
	
C THIRD LINE CONTAINS Y-DIMENSION
        READ(LUN,301) NROW

C THESE LINES CONTAIN SCAN SPECIFICS, THEY ARE SKIPPED HERE.
        READ(LUN,300) BLANK
        READ(LUN,300) BLANK
        READ(LUN,300) BLANK
        READ(LUN,300) BLANK

C THE STEP SIZES IN X AND Y MAY BECOME INTERESTING.
        READ(LUN,301) ISTEPX
        READ(LUN,301) ISTEPY
        READ(LUN,302) SCANDIR
C IF THE SCANNING WENT IN Y-DIRECTION, INTERCHANGE NSAM AND NROW.
        IF(SCANDIR.EQ.'Y') THEN
          II=NSAM
          NSAM=NROW
          NROW=II
        ENDIF
302     FORMAT(28X,A1)
        CLOSE(LUN)

        IF (NSAM .GT. NSIZE) THEN
          WRITE(NOUT,444) NSAM, NSIZE
444       FORMAT(' NSAM = ',I5,' IS BIGGER THAN PARAMETER NSIZE =',I5)
          WRITE(NOUT,445)
445       FORMAT(' CHANGE PARAMETER NSIZE IN COPYPDS FILE')
          CALL ERRT(100,'COPYPDS',NE)
          RETURN
        ENDIF

	IFNS=MOD(NSAM,2).EQ.0

C NOW OPEN IMAGE FILE:

C       NSAM IS EVEN
	IF (IFNS)THEN
           OPEN(UNIT=LUN,FILE=IMGFILE(1:NLET),STATUS='OLD',
     &     ACCESS='DIRECT',RECL=2*NSAM,FORM='UNFORMATTED',ERR=999)
	ELSE
C       NSAM IS ODD
           OPEN(UNIT=LUN,FILE=IMGFILE(1:NLET),STATUS='OLD',
     &     ACCESS='DIRECT',RECL=2*NSAM+2,FORM='UNFORMATTED',ERR=999)
	ENDIF

C       ASK FOR SPIDER OUTPUT FILE NAME:
	CALL FILERD(FILNAM,NLET,NULL,'OUTPUT',IRTFLG)
	IF (IRTFLG .NE. 0) RETURN 

C CHECK IF SCAN WAS DONE IN DENSITY MODE OR TRANSMISSION MODE.
C IF IT WAS DONE IN TRANSMITION MODE THEN ASK FOR CONVERTION PARAMETERS.

1       CALL RDPRMC(TRADE,NCHAR,.TRUE.,'(D)ENSITY, (T)RANSMISSION$',
     $       NULL,IRT)
        IF (TRADE.NE.'D'.AND.TRADE.NE.'T')  THEN
         WRITE(NOUT,102) 
102      FORMAT(1X,/' THERE IS NO DEFAULT FOR TRANSMISSION OR DENSITY'
     $   /' SO PLEASE ENTER EITHER  D  OR  T  '/)
         GOTO 1
        ENDIF
        IF (TRADE.EQ.'D') TDFLAG=.FALSE.
        IF (TRADE.EQ.'T') TDFLAG=.TRUE.
        IF(TDFLAG) THEN
         WRITE(NOUT,101)
101      FORMAT(' YOU CHOSE TRANSMISSION, PLEASE JUDGE IF THE',/1X
     $   ,'RESULTS MAKE SENSE. IF YOU ADJUSTED THE MICROD ACCORDING'/1X
     $   ,'TO SPECIFICATIONS, YOU HAVE A GAIN FACTOR OF 5',/1X)
         CALL RDPRM(GAIN,NLOOP,ILOOP,'ENTER GAIN FACTOR')
         IF(GAIN.EQ.0) DGAIN=1.
         DGAIN = 1/GAIN
        ENDIF

        CALL RDPRMI(IRED,IDUM,NLOOP,
     $     ILOOP,'REDUCTION FACTOR (0 IF NO RED.)')
        IF(IRED.EQ.0) IRED=1
        NSAMR=NSAM/IRED
        NROWR=NROW/IRED
	NSLICE=1
	IFORM=1
	CALL OPENF(FILNAM,LUN1,NSAMR,NROWR,'UNKNOWN',NF,NSLICE)

C CLEAR BUFFER:
        DO  L=1,NSAM
          DBUF(L)=0.
	ENDDO

C ICOUNT IS INPUT LINE COUNTER, ILINE OUTPUT LINE COUNTER.
C ILINE IS INCREASED EVERY IRED INPUT LINES.
        ICOUNT=0
        ILINE=0
        DO I1=1,NROW 
          ICOUNT=ICOUNT+1
C READ A LINE

c         READ(LUN,REC=I1,END=200) (IBUF(I),I=1,NSAM) put next 2 lines
          READ(LUN,REC=I1,IOSTAT=IER) (IBUF(I),I=1,NSAM)
	  IF(IER .LT. 0) THEN
C	     END OF FILE, NO ERROR
	     GOTO 200
	  ELSE
	    IF(IER .GT. 0) THEN
	       WRITE(NOUT,*) ' ERROR READING IBUF IN COPYPDS'
	       CALL ERRT(100,'COPYPDS',NE)
	    END IF
	  END IF

C CONVERT IT TO FLOATS:
          DO K=1,NSAM
            IBUF(K)=ISHFTC(IBUF(K),8,16)
            ADD=DBLE(IBUF(K))/800.
            IF(TDFLAG) THEN
              IF(ADD.LE.10D-5) ADD=10D-5
              ADD=-DLOG10(ADD*DGAIN)
            ENDIF

            DBUF(K)=DBUF(K)+ADD 
	  ENDDO

          IF(ICOUNT.EQ.IRED) THEN
             ILINE=ILINE+1
             DO  LL=1,NSAMR
                SUM=0
                DO  LLL=1,IRED
                 SUM=SUM+DBUF(LLL+(LL-1)*IRED)
		ENDDO
               BUF(LL)=SUM/DBLE(IRED*IRED)
	     ENDDO
C WRITE IT:
	     CALL WRTLIN(LUN1,BUF,NSAMR,ILINE)
             DO  LL=1,NSAM
                DBUF(LL)=0.0
	     ENDDO
             ICOUNT=0
          ENDIF
	ENDDO

200     IF(I1.LT.NROW) THEN
           WRITE(NOUT,201) I1,NROW
201        FORMAT(1X,'PDS FILE HAD ONLY         ',I5,' LINES', 
     $           /1X,'LINE NUMBER PARAMETER WAS ',I5,' LINES')
        ENDIF

C THIS IS LEFT AS AN EXAMPLE OF HOW TO PUT MORE INFO INTO SPIDER 
C FILE HEADER.
C        IRTFLG=1
C        XNROW=NROW
C800	CALL SETLAB(LUN1,NSAM,BUF,2,1,XNROW,'U',IRTFLG) 

C CLOSE EVERYTHING AND RETURN
	CLOSE(LUN1)      
        CLOSE (LUN)
	RETURN

998     WRITE(NOUT,*) '*** ERROR OPENING PERKIN ELMER HEADER FILE'
        CALL ERRT(100,'COPYPDS',NE)
        RETURN

999	WRITE(NOUT,*) '*** ERROR OPENING PERKIN ELMER IMAGE FILE'
        CALL ERRT(100,'COPYPDS',NE)
   	RETURN

C from line 23: ifdef __osf__
#endif

	END
 
