
C********************************************************************
C
C       CONVERTS A SPIDER IMAGE TO A ASCII POSTSCRIPT FILE
C       ALTERED FOR SPIDER FEB 90 al
C	MODIFIED FOR F90    --- yl 	10/22/97
c
C        0         2         3         4         5         6         7     
C23456789 123456789 123456789 123456789 123456789 123456789 123456789 12
C--------------------------------------------------------------------

        SUBROUTINE COPYPOS(LUNIM,LUNPOS,NSAM,NROW,NSLICE)

        INCLUDE        'CMBLOCK.INC'

        PARAMETER      (NSAMAX = 32000)
        COMMON         FARRAY(NSAMAX),BBUF(NSAMAX)

        COMMON /COMMUN/ FILNAM,PSFILE,LINE

        LOGICAL ONSUN,ONUNIX,ONSGI,ONOSF
        COMMON /OPSYS/ ONSUN,ONUNIX,ONSGI,ONOSF,MEMALLOCABLE

        INTEGER*1      BBUF
	CHARACTER *120 LINE
	CHARACTER *80  FILNAM,PSFILE
        CHARACTER      YN,NULL
	REAL	       LENGTH,WIDTH
        LOGICAL        FLIP

        DATA FLTZER/10E-30/

        NULL   = CHAR(0)

5	NLET1 = LNBLNK(FILNAM)-1
        IF (IMAMI .NE. 1)CALL NORM3(LUNIM,NSAM,NROW,NSLICE,FMAX,FMIN,AV)

        IF ((FMAX - FMIN) .LT. FLTZER) THEN
           WRITE(NOUT,*) ' *** BLANK FILE SKIPPED'
           RETURN

        ELSEIF (NSAM .GT. NSAMAX) THEN
C          NSAMAX BUFFER OVERFLOW
           WRITE(NOUT,*) ' *** NSAM TOO LARGE IN COPYPOS'
           CALL ERRT(100,'COPYPOS',NE)
           RETURN
        ENDIF

8       CALL FILERD(PSFILE,NLET,NULL,'POSTSCRIPT OUTPUT',IRTFLG)
        IF (IRTFLG .EQ. -1) RETURN
        CALL FILCAN(PSFILE,NLET,NULL,NULL,PSFILE,DATEXC,IRTFLG)
	NLET2 = NLET

#ifdef SP_SUN4
	OPEN(LUNPOS,FILE = PSFILE,FORM = 'FORMATTED',STATUS = 'NEW',
     &       IOSTAT = IER)
#else
	OPEN(LUNPOS,FILE = PSFILE,FORM = 'FORMATTED',STATUS = 'NEW',
C     &       CARRIAGECONTROL='LIST',IOSTAT = IER)
     &       IOSTAT = IER)
#endif
C        IF (IER .NE. 0) GOTO 8
	
	WRITE(NOUT,1150) FMIN,FMAX
1150	FORMAT(/'  Density range: ',G12.4,'...',G12.4)

	AMIN = FMIN
	AMAX = FMAX
	WRITE(NOUT,900)
900     FORMAT('  (To reverse contrast, make max < min.)')
        CALL RDPRM2S(AMIN,AMAX,NLOOP,ILOOP,
     &     'Enter min. and max. densities for thresholding (or <CR>)',
     &     IRTFLG)
        IF (IRTFLG .EQ. -1) GOTO 8

	IF (AMIN .EQ. AMAX) THEN
	    AMIN  = FMIN
	    AMAX  = FMAX
            FLIP = .FALSE.

	ELSEIF (AMIN .GT. AMAX) THEN
            FLIP  = .TRUE.
	    FTEMP = AMIN
	    AMIN  = AMAX
	    AMAX  = FTEMP 
	ENDIF	
    
3	SCALE = 255.0 / (AMAX-AMIN)
	WRITE(NOUT,1151) AMIN, AMAX
1151	FORMAT(/,'  Density values set: ',G12.4,'....',G12.4)

	ISKIP   = 1
	NX0     = NSAM
	NY0     = NROW
        RATIM   = FLOAT(NX0) / FLOAT(ISKIP)
        RATPA   = FLOAT(NY0) * 18.0 / 23.0
	IF (RATIM .GE. RATPA ) THEN
	    WIDTH = 18.0
	ELSE
	    WIDTH = 23.0 * FLOAT(NX0 / ISKIP) / FLOAT(NY0)
	ENDIF
	LENGTH = WIDTH * FLOAT(NY0) / FLOAT(NX0 / ISKIP)

	WRITE(NOUT,1600) WIDTH, WIDTH/2.54, LENGTH, LENGTH/2.54
1600	FORMAT('  Default image size is ',F5.2,' cm (',
     &     F5.2,' in) by ', F5.2,' cm (',F5.2,' in)')

        CALL RDPRM(QWIDTH,NOOP,ILOOP,
     &      'Enter desired width in cm (OR <CR>)')
        IF (QWIDTH .LE. 0.0) QWIDTH = WIDTH
	QLENGTH = QWIDTH * FLOAT(NY0) / FLOAT(NX0)

	IF (QWIDTH  .NE. 0 .AND. QWIDTH .LT. WIDTH .AND.
     &      QLENGTH .LE. LENGTH) WIDTH = QWIDTH
        WRITE(NOUT,902) WIDTH
902     FORMAT('  Selected width: ',F5.2,' cm')

        CALL RDPRMI(IDBG,NDUM,NOOP,ILOOP,
     &  'Enter background value 0 (black) - 255 (white), (-1 - skip)')

        WRITE(LUNPOS,94)PSFILE(1:NLET2)
 94     FORMAT(
     &     '%!PS-Adobe-2.0 EPSF-2.0',/,
     &     '%%Title:',A,/,
     &     '%%Creator: SPIDER copypos (CP PO)',/,
     &     '%%Pages: 1',/,
     &     '%%DocumentFonts:',/,
     &     '%%EndComments',/,
     &     '%%EndProlog',/)
      
        WRITE(LUNPOS,95)
95      FORMAT(
     &     '% remember original state',/,
     &     ' /origstate save def',/)

        WRITE(LUNPOS,96)
96      FORMAT(' ',
     &     '% build a temporary dictionary',/,
     &     ' 20 dict begin',/)
     
        WRITE(LUNPOS,97)
97      FORMAT(
     &     ' /Helvetica findfont ',/,
     &     ' 12 scalefont setfont ',/)

	DO IZ = 1,NSLICE
C           LOOP THROUGH EACH SLICE OF THE IMAGE
	    WRITE(LUNPOS,*) ' 52 112 moveto '

            IF (NSLICE .GT. 1) THEN
               WRITE(LUNPOS,90) IZ
90             FORMAT('  (Slice ',I4,10X,'-- X -->) show ')
            ENDIF

	    WRITE(LUNPOS,*) ' 55 98 moveto '
            WRITE(LUNPOS,91) FILNAM(1:NLET1),DATEXC(1:3),PSFILE(1:NLET2)
91          FORMAT(' ( Image: ',A,'.',A,'  Postscript: ',A,') show')

	    CALL COPYPOS2(LUNPOS,0.75,1.7,WIDTH,NX0,NY0)

	    DO IY =  1, NROW
               CALL REDLIN(LUNIM,FARRAY,NSAM,IY)
	       CALL COPYPOS3(LUNPOS,SCALE,AMIN,AMAX,FLIP,NX0,IDBG)
	    END DO

	    IF (NSLICE .GT. 1) WRITE(NOUT,*) ' Slice:',IZ
	    WRITE(LUNPOS,*) ' showpage'
	ENDDO

	WRITE(LUNPOS,*) '% stop using temporary dictionary'
	WRITE(LUNPOS,*) ' end'
	WRITE(LUNPOS,*) ' '

	WRITE(LUNPOS,*) '% restore original state'
	WRITE(LUNPOS,*) ' origstate restore'
	WRITE(LUNPOS,*) ' '

	WRITE(LUNPOS,*) '%%Trailer'
	WRITE(LUNPOS,*) ' '
                           
        CLOSE(LUNIM)
	CLOSE(LUNPOS)

        CALL RDPRMC(YN,NA,.TRUE.,'PRINT NOW? (Y/N)',NULL,IRTFLG)

        IF (YN .NE. 'N' .AND. YN .NE. 'n') THEN
C         THIS WILL HAVE TO BE ALTERED AT DIFFERENT SITES!!!! 

          WRITE(NOUT,*) ' WARNING: SITE SPECIFIC COMMAND IN COPYPOS'
          IF (ONUNIX) THEN
            LINE = 'lpr -h ' // PSFILE
          ELSE
            LINE = 'PRINT/NOFLAG/QUE=SPIDER_POST_QUE ' // PSFILE
          ENDIF
          CALL CSVMS(LINE,IERR)
          WRITE(NOUT,*) ' '
        ENDIF

        RETURN  
	END

