C++************************************************************************
C
C  COPYPOS3.FOR -- FEB 90 
C
C **************************************************************************
C *  AUTHOR: A. LEITH                                                      *
C *  COPYRIGHT (C)1990, WADSWORTH CENTER FOR LABORATORIES AND RESEARCH    *
C *    NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.              *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH                            *
C **************************************************************************
C
C   COPYPOS3(LUNPOS,SCALE,AMIN,AMAX,FLIP,NX,IDBG)
C
C   PURPOSE:      CONVERTS A LINE FROM SPIDER IMAGE FILE TO A
C                 POSTSCRIPT (8 BIT NORMALIZED) READABLE FORMAT 
C
C   CALLED BY:    COPYPOS
C
C   CALLS:        
C          
C--*************************************************************************

       SUBROUTINE COPYPOS3(LUNPOS,SCALE,AMIN,AMAX,FLIP,NX,IDBG)

       LOGICAL ONSUN,ONUNIX,ONSGI,ONOSF
       COMMON /OPSYS/ ONSUN,ONUNIX,ONSGI,ONOSF,MEMALLOCABLE

       PARAMETER      (NSAMAX = 32000)
       COMMON         FARRAY(NSAMAX),BBUF(NSAMAX)
 
       INTEGER*1           BVALUE,BBUF,BVAL(4),BVAL4
       EQUIVALENCE    (BVALUE,IVAL), (BVAL, IVAL), (BVAL4,BVAL(4))
       LOGICAL        FLIP

C      OUTPUT ONE LINE OF DATA

       DO IX = 1,NX
          FVAL = FARRAY(IX)
          IF (FVAL .GT. AMAX) THEN
             RVAL = 255.0
          ELSEIF (FVAL .LT. AMIN) THEN
             RVAL = 0.0
          ELSE
             RVAL = (FVAL - AMIN) * SCALE
          ENDIF

C         GREATER OF (0 AND (THE SMALLER OF RVAL AND 255))
          IVAL = MAX0(0,MIN1(RVAL, 255.))

          IF (FLIP)   THEN
             IVAL = 255 - IVAL
             IF (IDBG.GE.0 .AND. IVAL.EQ.255)  IVAL = IDBG
          ELSE
             IF (IDBG.GE.0 .AND. IVAL.EQ.0)   IVAL = IDBG
          ENDIF

          IF (ONUNIX .AND. .NOT. ONOSF) THEN    
             BBUF(IX) = BVAL(4)
          ELSE
C            VAX  USES OTHER BYTE ORDERING
             BBUF(IX) = BVALUE
          ENDIF

C         BVALUE = IVAL   ! through equivalence

        ENDDO

        WRITE(LUNPOS,'(1X,64Z2.2)') (BBUF(IX),IX=1,NX)

	RETURN
        END
