

C++************************************************************************
C
C  COPYU.FOR  -- CREATED MAR 89
C
C **************************************************************************
C *  AUTHOR: A. LEITH                                                      *
C *  COPYRIGHT (C)1989 , WADSWORTH CENTER FOR LABORATORIES AND RESEARCH    *
C *    NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.              *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH 			   *
C **************************************************************************
C
C   COPYU(LUNO,LUNN)
C
C   PURPOSE:      CONVERT VAX SPIDER IMAGE FILES TO UNIX READABLE FORMAT
C
C   CALLED BY:    UTIL2
C
C   CALLS:        GETVAX    FILERD     GETV16
C          
C--*************************************************************************

#ifdef SP_VMS

      SUBROUTINE COPYU(LUNO,LUNN,NSAM,NROW,NSLICE,IC)

      INCLUDE 'CMBLOCK.INC'

      COMMON /COMMUN/ FILOLD,FILNEW

      CHARACTER * 81 FILOLD,FILNEW
      CHARACTER      NULL
      LOGICAL        HEADER,NORMAL
      CHARACTER*1    ANS

      NULL = CHAR(0)

10    CALL FILERD(FILOLD,NLET,NULL,'VAX INPUT',IRTFLG)
      IF (IRTFLG .NE. 0) RETURN

      CALL FILCAN(FILOLD,NLET,NULL,NULL,FILOLD,DATEXC,IRTFLG)
      IF (IRTFLG .NE. 0) RETURN

      CALL FILERD(FILNEW,NLET,NULL,'UNIX OUTPUT',IRTFLG)
      IF (IRTFLG .EQ. -1) GOTO 10
      IF (IRTFLG .NE. 0) RETURN

      CALL FILCAN(FILNEW,NLET,NULL,NULL,FILNEW,DATEXC,IRTFLG)
      IF (IRTFLG .NE. 0) RETURN

      IF (FCHAR(IC:IC+2) .EQ. 'RAW') THEN
	 HEADER = .FALSE.
	 NORMAL = .FALSE.
	
         CALL RDPRMC(ANS,NA,.TRUE.,
     &      'DO YOU WANT TO NORMALIZE THE OUTPUT TO 0-255? (Y/N)',
     &	     NULL,IRT)
C        8 BIT UNIX SPIDER OUTPUT WITH NO NORMALIZATION
         IF (ANS .NE. 'N' .AND. ANS .NE. 'n') NORMAL = .TRUE.

         CALL RDPRMC(ANS,NA,.TRUE.,
     &      'DO YOU WANT TO KEEP THE HEADER? (N/Y)',NULL,IRT)
C        8 BIT UNIX RAW HEADERLESS
         IF (ANS .EQ. 'Y' .OR. ANS .EQ. 'y') HEADER = .TRUE.

	 IF (.NOT. NORMAL) THEN
	     MODE = -8
	 ELSE IF (NORMAL .AND. HEADER) THEN
	     MODE = 8
	 ELSE IF (NORMAL .AND. (.NOT.HEADER)) THEN
	     MODE = 88
	 ELSE
	     WRITE(NOUT,*) 'IT IS NOT A SPIDER FORMAT'
	 ENDIF

         CALL GETV16(FILOLD,FILNEW,LUNO,LUNN,MODE,IRTFLG)

      ELSE
         CALL GETVAX(FILOLD,FILNEW,LUNO,LUNN,IRTFLG)
      ENDIF

      RETURN
      END

#else

      SUBROUTINE COPYU(LUNO,LUNN,NSAM,NROW,NSLICE,IC)
CNO_SAVE

      INCLUDE 'CMBLOCK.INC'

      COMMON /COMMUN/ FILNAM,FILNEW,COMLIN

      CHARACTER *160 COMLIN
      CHARACTER * 81 FILNAM,FILOLD,FILNEW
      CHARACTER      NULL
      LOGICAL        HEADER,NORMAL,ASKPAD
      CHARACTER * 1  ANS

      NULL = CHAR(0)

      IF (FCHAR(IC:IC+3) .EQ. 'RAW') THEN
C       RAW OUTPUT --------------------------------------------- TO RAW
	FILOLD = FILNAM
        FILNEW = NULL
	HEADER = .FALSE.
	NORMAL = .FALSE.
	ASKPAD = .TRUE.
	
        CALL RDPRMC(ANS,NA,.TRUE.,
     &    'DO YOU WANT TO NORMALIZE THE OUTPUT TO 0-255? (Y/N)',
     &	   NULL,IRT)
C       8 BIT UNIX SPIDER OUTPUT WITH NO NORMALIZATION
        IF (ANS .NE. 'N' .AND. ANS .NE. 'n') NORMAL = .TRUE.

        CALL RDPRMC(ANS,NA,.TRUE.,
     &     'DO YOU WANT TO KEEP THE HEADER? (N/Y)', NULL,IRT)
C       8 BIT UNIX RAW HEADERLESS
        IF (ANS .EQ. 'Y' .OR. ANS .EQ. 'y') HEADER = .TRUE.

        CALL UNIXTOUNIX8(FILOLD,FILNEW,LUNO,LUNN,0,255,NSAM,NROW,
     &               NSLICE,HEADER,NORMAL,ASKPAD,IRTFLG)
      ENDIF


C     CLOSE INPUT AND OUTPUT FILES
9000  CLOSE(LUNO)
      CLOSE(LUNN)

      RETURN
      END
#endif
