
C++*************************************************************************
C
C COPYVAX.FOR                         
C
C **************************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK            *
C *  COPYRIGHT (C)1981,1987, WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH 			   *
C **************************************************************************
C
C  COPYVAX
C
C  PURPOSE:  UNIX TO VAX DATA FILE CONVERSION (WORKS ON VAX/VMS ONLY)
C
C        0         2         3         4         5         6         7     
C23456789 123456789 123456789 123456789 123456789 123456789 123456789 12
C--*********************************************************************

#ifdef SP_VMS

      SUBROUTINE COPYVAX(LUNO,LUNN,LUNF)

      INCLUDE 'COMMON1:CMBLOCK.INC'

      COMMON /COMMUN/ FILOLD,FILNEW

      CHARACTER * 81 FILOLD,FILNEW
      CHARACTER      NULL
      LOGICAL        EX, DUMPED
      CHARACTER * 1  ANS

      DATA NULL/0/

C     GET FILENAME FOR EXISTING UNIX SPIDER IMAGE FILE
      DUMPED = .TRUE.
10       CALL RDPRMC(ANS,NA,.TRUE.,
     &    'IS THE INPUT FILE A UNIX 8-BIT FILE(Y/N or <CR>)?',
     &	   NULL,IRT)
C        8 BIT UNIX DUMPED FILE
         IF (ANS .NE. 'Y' .AND. ANS .NE. 'y') DUMPED = .FALSE.

      IF (DUMPED) THEN
         CALL FILERD(FILOLD,NLETU,NULL,'UNIX DUMPED DATA',IRTFLG)
      ELSE
         CALL FILERD(FILOLD,NLETU,NULL,'UNIX SPIDER DATA',IRTFLG)
      ENDIF
      IF (IRTFLG .NE. 0) RETURN

      CALL FILCAN(FILOLD,NLETU,NULL,NULL,FILOLD,DATEXC,IRTFLG)
      IF (IRTFLG .NE. 0) GOTO 10

C     SEE IF UNIX DATA FILE EXISTS
      INQUIRE(FILE=FILOLD,IOSTAT=IOERR,EXIST=EX)

      IF (.NOT. EX) THEN
C          ERROR -- FILE DOES NOT EXIST
           CALL ERRT(18,'COPYVAX',NE)
           RETURN

      ELSEIF (IOERR) THEN
C          ERROR OPENING FILE
           CALL ERRT(4,'COPYVAX',NE)
           RETURN
      ENDIF
  

C     GET FILENAME FOR NEW VAX SPIDER IMAGE FILE
      CALL FILERD(FILNEW,NLET,NULL,'NEW VAX DATA',IRTFLG)
      IF (IRTFLG .EQ. -1) GOTO 10
      IF (IRTFLG .NE. 0) RETURN
      CALL FILCAN(FILNEW,NLETV,NULL,NULL,FILNEW,DATEXC,IRTFLG)

      IF (DUMPED) THEN

         CALL GETDUMP(FILOLD(:NLETU),FILNEW(:NLETV),LUNO,
     &        LUNN,LUNF,IRTFLG)
      ELSE
         CALL GETUNX(FILOLD(:NLETU),FILNEW(:NLETV),LUNO,
     &        LUNN,LUNF,IRTFLG)

      ENDIF

      RETURN
      END



#else

      SUBROUTINE COPYVAX(LUNO,LUNN,LUNF)

      INCLUDE 'CMBLOCK.INC'

      WRITE(NOUT,*) '*** THIS ROUTINE ONLY AVAILABLE ON VAX/VMS SPIDER.'
 
      RETURN
      END
#endif
