C++*********************************************************************
C
C CORR1.F                                       REWRITTEN AUG 96 PP
C
C **********************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK        *
C *  COPYRIGHT (C)1981, 1996 HEALTH RESEARCH INCORPORATED, ALBANY, NY  * 
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO HEALTH         *
C *    RESEARCH INC. AND ARE NOT TO BE DISCLOSED TO OTHERS             *
C *    OR USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN        *
C *    APPROVAL OF HEALTH RESEARCH INC.                                *
C **********************************************************************
C
C--*********************************************************************

        SUBROUTINE CORR1(MAXDIM)

	INCLUDE 'CMBLOCK.INC'
CNO_SAVE

	PARAMETER       (LENBUF=8000)
        COMMON          OPENBUF(LENBUF),BUF(1)
        DIMENSION       Q(1)
        POINTER         (IPQ,Q) 
        CHARACTER *81	FILNAM1,FILNAM2
        CHARACTER *1	NULL
	PARAMETER       (NFUNC=3)
        CHARACTER *2	FUNC(NFUNC)
        LOGICAL		ACASE, RUNTIME, BOTH_INC

        DATA            FUNC/'AC',  'CC',  'CN'/
        DATA            LUN1,LUN2,LUN3/21,22,23/

        NULL   = CHAR(0)
 
C       DETERMINE IFUNC
        DO  IFUNC = 1,NFUNC
          IF (FCHAR(1:2) .EQ. FUNC(IFUNC)(1:2)) THEN
            GOTO 1111
          ENDIF
        END DO
C       OPERATION NOT HERE, RETURN TO CALLER
        RETURN 


1111	CONTINUE
C       CATCH EXCEPTIONS
C       ---------------------------------------------------------- CC C
	IF(FCHAR(1:4).EQ.'CC C')  THEN
	   CALL  CCC(MAXDIM)
	   RETURN
C       --------------------------------------------------------- AC MS
	ELSEIF(FCHAR(1:5).EQ.'AC MS')  THEN
	   CALL  MACF(MAXDIM)
	   RETURN
	ENDIF

C       -------------------------------------------------------- OTHER 
C       OPEN FIRST INPUT FILE, FOURIER INPUT ALLOWED 
	CALL OPFIL(.TRUE.,FILNAM1,LUN1,'O',NSAM1,NROW1,NSLICE1,
     &             IDUM,'INPUT',.TRUE.,IRTFLG)
        IF (IRTFLG .EQ. -1) RETURN

        IF (FCHAR(4:4).EQ.'N' .AND. IFORM.LT.0) THEN
C          NO STATISTICS IN FILE, CAN NOT NORMALIZE OUTPUT
           WRITE(NOUT,*) 
     &        '*** CAN NOT NORMALIZE OUTPUT - FILE LACKS STATISTICS.'
           CALL ERRT(2,'CORR1',NE)
	   CLOSE(LUN1)
	   RETURN

        ELSEIF (FCHAR(4:4).EQ.'N')  THEN
	   IMAMI1=IMAMI
	   SIG1   = SIG
        ENDIF
	IFORM1 = IFORM

C       CALCULATE DIMENSIONS
	IF (IFORM1.GT.0)  THEN
	   LS1=NSAM1+2-MOD(NSAM1,2)
	   LREC1=NSAM1
	   IFORM3=IFORM1
	   NSAM3=NSAM1
	ELSE
	   LS1=NSAM1
	   LREC1=NSAM1
	   NSAM1=NSAM1-MOD(-IFORM1,10)
	   IF (IFORM1.GT.-20)  THEN
	      IFORM3=1
	   ELSE
	      IFORM3=3
	   ENDIF
	   NSAM3=NSAM1
	ENDIF

	IF (FCHAR(1:2) .EQ. 'AC') THEN
C          AUTO CORRELATION WANTED
           ACASE  = .TRUE.
	   IFORM2 = IFORM1
        ELSE 
C          GET NAME FOR SECOND INPUT FILE
           CALL FILERD(FILNAM2,NLET,NULL,'REFERENCE',IRTFLG)
           IF (IRTFLG .EQ. -1) THEN
              CLOSE(LUN1)
              GOTO 1111
           ENDIF
           IF (FILNAM1 .EQ. FILNAM2) THEN
C             FILENAMES ARE SAME, AUTOCORRELATION WANTED
              ACASE  = .TRUE.
	      IFORM2 = IFORM1
           ELSE
C             OPEN SECOND INPUT FILE, FOURIER INPUT ALLOWED 
              CALL OPFIL(.FALSE.,FILNAM2,LUN2,'O',NSAM2,NROW2,NSLICE2,
     &                IDUM,NULL,.TRUE.,IRTFLG)
	      IFORM2 = IFORM
              ACASE  = .FALSE.
              IF (FCHAR(4:4) .EQ. 'N' .AND. IFORM .LT. 0) THEN
C                NO STATISTICS IN FILE, CAN NOT NORMALIZE OUTPUT
                 WRITE(NOUT,*) 
     &          '*** CAN NOT NORMALIZE OUTPUT - FILE LACKS STATISTICS.'
                 CALL ERRT(2,'CORR1',NE)
		 CLOSE(LUN1)
		 CLOSE(LUN2)
                 RETURN
              ELSEIF(FCHAR(4:4).EQ.'N')  THEN
	         IMAMI2=IMAMI
                 SIG2=SIG
              ENDIF
C             CALCULATE DIMENSIONS
	      IF (IFORM2.GT.0)  THEN
		 LS2=NSAM2+2-MOD(NSAM2,2)
	      ELSE
		 LS2=NSAM2
		 NSAM2=NSAM2-MOD(-IFORM2,10)
	      ENDIF
C             CHECK THAT DIMENSIONS ARE THE SAME FOR BOTH FILES
              IF (NSAM1   .NE. NSAM2 .OR. NROW1 .NE. NROW2 .OR.
     &            NSLICE1 .NE. NSLICE2) THEN
C                 ERROR. IMAGES DO NOT HAVE SAME DIMENSIONS
                  CALL ERRT(1,'CORR1',NE)
		  CLOSE(LUN1)
		  CLOSE(LUN2)
                  RETURN
              ENDIF
           ENDIF
        ENDIF

C       MEMORY
	IF (.NOT. ACASE .AND. IFORM2 .GT. 0)  THEN
	   MEMWANT=2*(NSAM1+2-MOD(NSAM1,2))*NROW1*NSLICE1
           CALL CHKMEM(MEMWANT,BUF,MAXDIM-LENBUF,RUNTIME,IPQ,IRTFLG)
	   IF (IRTFLG .EQ. 0 .OR. LS1 .LT. LENBUF)  THEN
	      BOTH_INC = .TRUE.
	      K1=1
	      K2=K1+(NSAM1+2-MOD(NSAM1,2))*NROW1*NSLICE1
	      GOTO  1001
	   ENDIF
	ELSE
	   MEMWANT=(NSAM1+2-MOD(NSAM1,2))*(NROW1*NSLICE1+1)
           CALL CHKMEM(MEMWANT,BUF,MAXDIM-LENBUF,RUNTIME,IPQ,IRTFLG)
	   IF (IRTFLG.EQ.0 .OR. LS1 .LT. LENBUF)  THEN
	      BOTH_INC=.FALSE.
	      K1=1
	      K2=1
	      KB=K1+(NSAM1+2-MOD(NSAM1,2))*NROW1*NSLICE1
	      GOTO  1001
	   ENDIF
	ENDIF

C       NO MEMORY
	CALL ERRT(6,FCHAR(1:4),NE)
	CLOSE(LUN1)
    	CLOSE(LUN2)
	RETURN

1001	CONTINUE

	IF (.NOT.ACASE .AND. IFORM2 .GT. 0)  THEN
C          PROCESS LUN2
	   DO   J=1,NROW2*NSLICE2
	   CALL  REDLIN(LUN2,Q(K2+(J-1)*LS2),NSAM2,J)
	   ENDDO
	   IF (FCHAR(4:4).EQ.'N'.AND.IMAMI2.NE.1)
     &	      CALL NRMS(Q(K2),LS2,NSAM2,NROW2,NSLICE2,SIG2)
	   INV=+1
	   IF (IFORM2.EQ.1)  THEN
	      CALL FMRS_2(Q(K2),NSAM2,NROW2,INV)
	   ELSE
	      CALL FMRS_3(Q(K2),NSAM2,NROW2,NSLICE2,INV)
	   ENDIF
           IF (INV.EQ.0)  THEN
              CALL ERRT(38,FCHAR(1:2),NE)
             RETURN
           ENDIF
        ENDIF

C       READ IN  LUN1
	DO   J=1,NROW1*NSLICE1
	CALL  REDLIN(LUN1,Q(K1+(J-1)*LS1),LREC1,J)
	ENDDO
	CLOSE(LUN1)
	IF (FCHAR(4:4).EQ.'N'.AND.IMAMI1.NE.1)
     &	   CALL NRMS(Q(K1),LS1,NSAM1,NROW1,NSLICE1,SIG1)
	IF (IFORM1.GT.0)  THEN
C          NON-FOURIER INPUT
           INV=+1
	   IF (IFORM1.EQ.1)  THEN
	      CALL FMRS_2(Q(K1),NSAM1,NROW1,INV)
	   ELSE
	      CALL FMRS_3(Q(K1),NSAM1,NROW1,NSLICE1,INV)
	   ENDIF
           IF (INV .EQ. 0)  THEN
              CALL ERRT(38,FCHAR(1:2),NE)
	      IF (.NOT.ACASE)  CLOSE(LUN2)
	      CLOSE(LUN1)
              RETURN
           ENDIF
        ENDIF
C
	IF (FCHAR(4:4).EQ.'N')  THEN
	   Q(K1)=0.0
	   Q(K1+1)=0.0
	ENDIF
C
	IF (ACASE)  THEN
	  IF (NSLICE1.LE.1)  THEN
	    CALL ACRS_2(Q(K1),Q(K1),NSAM1,NROW1)
	  ELSE
	    CALL ACRS_3(Q(K1),Q(K1),NSAM1,NROW1,NSLICE1)
	  ENDIF
	ELSEIF (FCHAR(1:2) .EQ. 'CC')  THEN
	  IF (NSLICE1.LE.1)  THEN
	    IF (BOTH_INC)  THEN
	    CALL CCRS_2(Q(K1),Q(K2),Q(K1),NSAM1,NROW1)
	    ELSE
	    CALL CCRD_2(LUN2,Q(K1),Q(KB),Q(K1),NSAM1,NROW1)
	    ENDIF
	  ELSE
	    IF (BOTH_INC)  THEN
	       CALL CCRS_3(Q(K1),Q(K2),Q(K1),NSAM1,NROW1,NSLICE1)
	    ELSE
	       CALL CCRD_3(LUN2,Q(K1),Q(KB),Q(K1),NSAM1,NROW1,NSLICE1)
	    ENDIF
	  ENDIF
	ELSEIF(FCHAR(1:2) .EQ. 'CN')  THEN
	  IF (NSLICE1.LE.1)  THEN
	    IF (BOTH_INC)  THEN
	    CALL  CNRS_2(Q(K1),Q(K2),Q(K1),NSAM1,NROW1)
	    ELSE
	    CALL  CNRD_2(LUN2,Q(K1),Q(KB),Q(K1),NSAM1,NROW1)
	    ENDIF
	  ELSE
	    IF(BOTH_INC)  THEN
	    CALL  CNRS_3(Q(K1),Q(K2),Q(K1),NSAM1,NROW1,NSLICE1)
	    ELSE
	    CALL  CNRD_3(LUN2,Q(K1),Q(KB),Q(K1),NSAM1,NROW1,NSLICE1)
	    ENDIF
	  ENDIF
	ENDIF
	IF (.NOT.ACASE)  CLOSE(LUN2)
	IF (ACASE)  SIG2=SIG1
        IF (FCHAR(4:4) .EQ. 'N') THEN
C           NORMALIZATION ROUTINE HERE
	    FAN = 1.0/(NSAM1*NROW1*FLOAT(NSLICE1)-1.0)/SIG1/SIG2
	    DO  I=0,LS1*NROW1*NSLICE1-1
	    Q(K1+I)=Q(K1+I)*FAN
	    ENDDO
        ENDIF
	IFORM = IFORM3
	CALL OPFIL(.TRUE.,FILNAM1,LUN3,'U',NSAM3,NROW1,NSLICE1,
     &             IDUM,'OUTPUT',.TRUE.,IRTFLG)
        IF (IRTFLG .EQ. -1) RETURN
	DO   J=1,NROW1*NSLICE1
	CALL  WRTLIN(LUN3,Q(K1+(J-1)*LS1),NSAM1,J)
	ENDDO

	CLOSE(LUN3)
        IF (RUNTIME)  CALL ALLOCIT(0,RUNTIME,IPQ,'CORR1',IRTFLG)

        RETURN
	END
