C *NAME* = COUPE.FOR                   31-JAN-86      13:23:05                  
C----------------------------------=*=----------------------------------        
C           COPYRIGHT 1986 - JEAN-PIERRE BRETAUDIERE                            
C THE UNIVERSITY OF TEXAS HEALTH SCIENCE CENTER AT HOUSTON                      
C MEDICAL SCHOOL - DEPARTMENT OF PATHOLOGY AND LABORATORY MEDICINE              
C P.O. BOX 20708, HOUSTON, TX 77225.                                            
C DISCLAIMER: NO GUARANTEES OF PERFORMANCE ACCOMPANY THIS SOFTWARE,             
C NOR IS ANY RESPONSIBILITY ASSUMED ON THE PART OF THE AUTHOR                   
C OR THE INSTITUTION.  ALL THE SOFTWARE HAS BEEN TESTED EXTENSIVELY             
C AND EVERY EFFORT HAS BEEN MADE TO INSURE ITS RELIABILITY.                     
C THE FOLLOWING SOFTWARE MAY NOT BE COMMUNICATED TO A THIRD PARTY               
C UNDER ANY FORM WITHOUT WRITTEN PERMISSION OF THE AUTHOR.                      
C PLEASE REPORT ANY BUG(S) TO JPB AT (713) 792 52 00.                           
C OR THRU ARPANET AT  ......!rice!ots!ut-path!suprim                            
C*--------------------------------------------------------------------*         
C*                                                                    *         
C*                                                                    *         
C*      INITIAL DENDROGRAM CHARACTERIZED BY NKLA SUMMITS IS TRUN-     *         
C*      CATED INTO KPART FINAL CLASSES.  OBJECTS ARE ASSIGNED         *         
C*      TO THE NEW CLASSES.                                           *         
C*                                                                    *         
C*      INPUT:                                                        *         
C*                                                                    *         
C*      ICARD,NKLA,KPART,PK(NKLA),LA(NKLA),LB(NKLA) (CF,CHAVA)        *         
C*                                                                    *         
C*      OUTPUT:                                                       *         
C*      KLAS(ICARD)      = NEW CLASSIFICATION CONTAINING KPART CLASSES*         
C*      IV(NKLA)         = ASSIGNMENT OF OLD CLASSES TO NEW CLASSES   *         
C*      NT(NKLA)         = SIZES OF THE KPART CLASSES                 *         
C*                                                                    *         
C*      WORKING ARRAY ... IW(NKLA)                                    *         
C*                                                                    *         
C==10.16.80                                                           *         
C==01.13.86                                                           *         
C*--------------------------------------------------------------------*         
      SUBROUTINE COUPE (ICARD,NKLA,KPART, PK,LA,LB,IV,KLAS,NT, IW)              
C                                                                               
      DIMENSION IV(NKLA),LA(NKLA),LB(NKLA),KLAS(ICARD),PK(NKLA),                
     #          NT(NKLA),IW(NKLA)                                               
      JDEB  = NKLA + 1                                                          
      JFIN  = 2*NKLA - 1                                                        
C                                                                               
C......... INDICATOR IV(NKLA) OF THE AGGREGATION IN KPART CLASSES               
C                                                                               
        DO   L = 1,NKLA                                                       
      IV(L) = 0 
	ENDDO                                                                
        DO   J = JDEB,JFIN                                                    
      NT(1) = J                                                                 
      KPT   = 0                                                                 
      JI    = 1                                                                 
   20   IF (NT(JI) .GT. NKLA)          GO TO  30                                
      K     = NT(JI)                                                            
      KPT   = KPT + 1                                                           
      IW(KPT)= K                                                                
      JI    = JI - 1                                                            
                                       GO TO  40                                
   30 IJ    = JI + 1                                                            
      NI    = NT(JI) - JDEB + 1                                                 
      NT(IJ)= LA(NI)                                                            
      NT(JI)= LB(NI)                                                            
      JI    = JI + 1                                                            
   40   IF (JI .NE. 0)                 GO TO  20                                
        IF (J .GT. JFIN-KPART+1)       GO TO  60                                
        DO   KK = 1,KPT                                                       
      JPP   = IW(KK)                                                            
      IV(JPP)= J                                                                
	ENDDO
   60 I1    = IW(1)                                                             
      I2    = IW(KPT)                                                           
   	ENDDO
      KKK   = 1                                                                 
      NKLA1 = NKLA - 1                                                          
        DO 110  IL1 = 1,NKLA1                                                   
        IF (IV(IL1) .EQ. 0)            GO TO  90                                
        IF (IV(IL1) .LT. KKK)          GO TO  110                               
      IV1   = IV(IL1)                                                           
      IV(IL1)= KKK                                                              
      IL3   = IL1 + 1                                                           
        DO 80  IL2 = IL3,NKLA                                                   
        IF (IV(IL2) .NE. IV1)          GO TO  80                                
      IV(IL2)= IV(IL1)                                                          
   80   CONTINUE                                                                
                                       GO TO  100                               
   90 IV(IL1)= KKK                                                              
  100 KKK   = KKK + 1                                                           
  110   CONTINUE                                                                
        IF (IV(NKLA) .EQ. 0)           IV(NKLA) = KKK                           
         RETURN                                                                 
         END                                                                    
