	SUBROUTINE CRITER (N,C,NCRT,CRT,AREA3)

        PARAMETER (NN=999, NF=10, KX=10)

	INTEGER C,NCRT(*)
	REAL U(KX,NN),CRT(*),AREA3(*),NFIP
        REAL XDUM(NN,NF), RDUM(80)

        COMMON RDUM,XDUM,U

C U     : MEMBERSHIP FUNCTIONS (INPUT)
C NN,KX : DIMENSIONS IN THE MAIN PROGRAM
C N,C   : NUMBER OF PATTERNS AND CLUSTERS
C NCRT  : VECTOR OF NU_OF_CRITERIA+1 INTEGERS (13) (INPUT)
C         NCRT(1) IS THE NUMBER OF CRITERIA IN THE PRESENT
C         EXECUTION (NCRT(1) <= NU_OF_CRITERIA).
C CRT   : VECTOR OF NU_OF_CRITERIA+1 REALS (OUTPUT)
C	  CRT(i) IS THE VALUE OF THE CRITERIUM SPECIFIED
C	  IN NCRT(i), i=2,3,...,13
C AREA3 : WORKING AREA OF 4*NN+3*KX REALS

        DO  I=1,13
           CRT(I)=0
	ENDDO

	A=2.                     
C       Entropy coefficient 


	CALL PREVIO(N,C,A,F,ENTROP,SUM,AREA3)
	DO 13 M=2,NCRT(1)+1
	GOTO (1,2,3,4,5,6,7,8,9,10,11,11) NCRT(M)

1	CR=F/N  			     
C       Partition coefficient (+) 
	GOTO 13

2	CR=-ENTROP/N                         
C       Classification entropy (-) 
	GOTO 13

3	PE=0.                                
C       Proportion exponent (+) 
	PROD=FACTOR(C)
	DO  J=1,N
	 SUMA1=0.
	 JT=J+NN
	 DO  I=1,INT(AREA3(JT))
	  DELTA=(1.-I*AREA3(J))**(C-1.)
	  IF (I.LT.13) THEN
	   FACT=FACTOR(I)*FACTOR(C-I)
	   DELTA=DELTA*PROD/FACT
	   DELTA=DELTA*(-1.**(I+1.))
	  ELSE DELTA=0.
	  ENDIF          
	 SUMA1=SUMA1+DELTA	  	 	
	 ENDDO
	 SUMA1=LOG(ABS(SUMA1+1.E-4))/LOG(2.)
	PE=PE+SUMA1
	ENDDO
	CR=-PE
	GOTO 13
C
4	CR=SUM/N                             
C       2ndMAX/MIN  (-) 
	GOTO 13
C
5	CR=(C*(F/N-1.))/(C-1.)               
C       Non fuzzyness index (+) 
	GOTO 13	
C
6	NFIP=0.                              
C       Non fuzzyness index P (+) 
	DO  J=1,C
	DO  L=J+1,C
	 SUM1=0.
	 SUM2=0.
	 DO  I=1,N
	  SUM1=SUM1+AMIN1(U(J,I),U(L,I))
	  SUM2=SUM2+AMAX1(U(J,I),U(L,I))
	 ENDDO
	 DELTA=1.-SUM1/SUM2
	NFIP=NFIP+DELTA
	ENDDO
	ENDDO
	CR=2.*NFIP/(C*(C-1.))
        GOTO 13
C
C7	CR=1.-(C*(F/N-1.))/(C-1.)            
C       F'  (-) 
7	GOTO 13
C
8	CR=-ENTROP/(N-C) 		     
C       H'  (-) 
	GOTO 13

C9	CR=-ENTROP*LOG(A)/(N-LOG(FLOAT(C)))  
C       H'' (-) 
9	GOTO 13
C
c 	CR=1.+ENTROP*LOG(A)/(N-LOG(FLOAT(C))) 
C       1 - H'' (+) 
10 	GOTO 13
C	
11	LCE=2*NN
	LRI=LCE+NN
	LSU=LRI+NN
	LCO=LSU+KX
	LRM=LCO+KX
        DO  I=1,N         
C        Relacion entre los 2 primeros maximos 
	 BMAX1=0.
	 BMAX2=0.
	 IT=I+LCE
	 DO  J=1,C
	  IF (U(J,I).GT.BMAX1) THEN
	   BMAX2=BMAX1
	   BMAX1=U(J,I)
	   AREA3(IT)=J
	  ELSE 
	   IF (U(J,I).GT.BMAX2) BMAX2=U(J,I)
	  END IF
	 ENDDO
	AREA3(LRI+I)=BMAX2/BMAX1
	ENDDO
C
	DO J=1,C         
C        Relacion media para cada cluster 	
 	 AREA3(J+LSU)=0.
	 AREA3(J+LCO)=0.
	ENDDO
	DO  I=1,N
	 IT=I+LCE
	 IH=I+LRI
	 JT=INT(AREA3(IT))+LSU
	 JH=INT(AREA3(IT))+LCO
	 AREA3(JT)=AREA3(JT)+AREA3(IH)
	 AREA3(JH)=AREA3(JH)+1
	ENDDO
 	DO  J=1,C
	IF (AREA3(J+LCO).GT.0) THEN            
C           CHECK FOR 0-ELEMENTS CLUSTERS
            AREA3(J+LRM)=AREA3(J+LSU)/AREA3(J+LCO)   
                               ELSE
            AREA3(J+LRM)=0.
        ENDIF
	ENDDO
	IF (NCRT(M).EQ.11) THEN                 
C        2ndMAX/1ndMAX  (+) 
	 BMAX3=0.
	 DO  J=1,C
 	  BMAX3=AMAX1(BMAX3,AREA3(J+LRM))
	 ENDDO
	 CR=-LOG(BMAX3)/LOG(10.)
	ELSE                                    
C        Mean of means  (+) 
	 SUMT=0.
	 DO  J=1,C
	  SUMT=SUMT+AREA3(J+LRM)
	 ENDDO
	 SUMT=SUMT/C
	 CR=-LOG(SUMT)/LOG(10.)
	END IF


13 	CRT(M)=CRT(M)+CR
C
	END

