C++************************************************************************
C
C $$ CROSRMG_D.FOR
C
C **************************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK            *
C *  COPYRIGHT (C)1981,1987, WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *  THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR       *
C *  LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR    *
C *  USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF     *
C *  THE CENTER FOR LABORATORIES AND RESEARCH                              *
C **************************************************************************
C
C
C
C23456789012345678901234567890123456789012345678901234567890123456789012
C--************************************************************************
C
C $$ CROSRMG_D.FOR
C
	SUBROUTINE  CROSRMG_D
     &   (CIRC1,CIRC2,LCIRC,NRING,
#ifdef SP_MP
     &   T_,Q_,
#else
     &   T,Q,
#endif
     &   MAXRIN,NUMR,QN,TOT,TT)
C
C  INPUT - Fourier transforms of rings!!!
C  First set is conjugated (mirrored)
C  CIRC1 already multiplied by weights!!
C
	INTEGER*2  NUMR(3,NRING),MAXRIN,NUMR3I,NUMR2I,CMP
	DIMENSION  CIRC1(LCIRC),CIRC2(LCIRC)
	DOUBLE PRECISION  TT(*)
#ifdef SP_MP
C  CONSULT  1024 with alprbs
	DIMENSION  T(1024)
	DOUBLE PRECISION  Q(1024),T_,Q_
#else
	DIMENSION  T(MAXRIN)
	DOUBLE PRECISION  Q(MAXRIN)
#endif
	DOUBLE PRECISION  QN,T7(-3:3)
CNO_SAVE
	IP=MAXRIN
#ifdef SP_LIBFFT
#else
	IP=-LOG2_P(IP)
#endif
C
	DO    J=1,MAXRIN
	Q(J)=0.0D0
	ENDDO
C
	DO    I=1,NRING
	NUMR3I=NUMR(3,I)
	NUMR2I=NUMR(2,I)
C
	T(1)=(CIRC1(NUMR2I))*CIRC2(NUMR2I)
	IF(NUMR3I.EQ.MAXRIN)  THEN
	T(2)=(CIRC1(NUMR2I+1))*CIRC2(NUMR2I+1)
	DO    J=3,MAXRIN,2
	JC=J+NUMR2I-1
	T(J)=(CIRC1(JC))*CIRC2(JC)-(CIRC1(JC+1))*CIRC2(JC+1)
	T(J+1)=-(CIRC1(JC))*CIRC2(JC+1)-(CIRC1(JC+1))*CIRC2(JC)
	ENDDO
	DO    J=1,MAXRIN
	Q(J)=Q(J)+T(J)
	ENDDO
	ELSE
	T(NUMR3I+1)=(CIRC1(NUMR2I+1))*CIRC2(NUMR2I+1)
	T(2)=0.0
	DO    J=3,NUMR3I,2
	JC=J+NUMR2I-1
	T(J)=(CIRC1(JC))*CIRC2(JC)-(CIRC1(JC+1))*CIRC2(JC+1)
	T(J+1)=-(CIRC1(JC))*CIRC2(JC+1)-(CIRC1(JC+1))*CIRC2(JC)
	ENDDO
C  ###
	DO    J=1,NUMR3I+1
	Q(J)=Q(J)+T(J)
	ENDDO
	ENDIF
	ENDDO
C
#ifdef SP_LIBFFT
	INV=-1
	LDA=1
	Q(MAXRIN+1)=Q(2)
	Q(2)=0.0
	Q(MAXRIN+2)=0.0
	CALL  ZDFFT1DU(INV,IP,Q,LDA,TT)
C skip the normalization, divide the maximum instead.
C	CALL  DSCAL1D(IP,1.0D0/DBLE(FLOAT(IP)),Q,LDA)
#else
	CALL  FFTR_D(Q,IP)
#endif
C
	QN=-1.0D20
	DO    J=1,MAXRIN
	IF(Q(J).GE.QN)  THEN
	QN=Q(J)
	JTOT=J
	ENDIF
	ENDDO
#ifdef SP_LIBFFT
	QN=QN/MAXRIN
#endif
	DO    K=-3,3
C
C Use of additional variable to convert type
C
        CMP = JTOT+K+MAXRIN-1
        J=MOD(CMP,MAXRIN)+1
	T7(K)=Q(J)
	ENDDO
	CALL  PRB1D(T7,7,POS)
	TOT=FLOAT(JTOT)+POS
	END
