C++************************************************************************
C
C $$ CROSRNG_F.FOR
C
C **************************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK            *
C *  COPYRIGHT (C)1981,1987, WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *  THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR       *
C *  LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR    *
C *  USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF     *
C *  THE CENTER FOR LABORATORIES AND RESEARCH   			   *
C **************************************************************************
C
C
C
C23456789012345678901234567890123456789012345678901234567890123456789012
C--************************************************************************
C
C $$ CROSRNG_F.FOR
C
         SUBROUTINE  CROSRNG_F
     &   (CIRC1,CIRC2,LCIRC,NRING,T,Q,MAXRIN,JACUP,NUMR,QN,TOT,MODE)
C
C  INPUT - Fourier transforms of rings!!!
C
         INTEGER*2  NUMR(3,NRING),MAXRIN,CMP
         DIMENSION  CIRC1(LCIRC),CIRC2(LCIRC)
         DOUBLE PRECISION  T(MAXRIN),Q(MAXRIN)
         DOUBLE PRECISION  QN,QT,PI,T7(-3:3)
         CHARACTER*1  MODE
CNO_SAVE
         PI=4.0*DATAN(1.0D0)
         IF(MODE.EQ.'F')  PI=2*PI
         IP=MAXRIN
         IP=-LOG2_P(IP)
C
         DO    J=1,MAXRIN
         Q(J)=0.0D0
	 ENDDO
C
         DO    I=1,NRING
         WR=REAL(NUMR(1,I))*PI/REAL(NUMR(3,I))
     &   *REAL(MAXRIN)/REAL(NUMR(3,I))
C
         T(1)=DBLE(CIRC1(NUMR(2,I)))*CIRC2(NUMR(2,I))
         IF(NUMR(3,I).EQ.MAXRIN)  THEN
         T(2)=DBLE(CIRC1(NUMR(2,I)+1))*CIRC2(NUMR(2,I)+1)
         DO    J=3,MAXRIN,2
         JC=J+NUMR(2,I)-1
         T(J)=DBLE(CIRC1(JC))*CIRC2(JC)+DBLE(CIRC1(JC+1))*CIRC2(JC+1)
      T(J+1)=-DBLE(CIRC1(JC))*CIRC2(JC+1)+DBLE(CIRC1(JC+1))*CIRC2(JC)
	 ENDDO
         DO    J=1,MAXRIN
         Q(J)=Q(J)+T(J)*WR
	 ENDDO
         ELSE
         T(NUMR(3,I)+1)=DBLE(CIRC1(NUMR(2,I)+1))*CIRC2(NUMR(2,I)+1)/2.0
         T(2)=0.0
         DO    J=3,NUMR(3,I),2
         JC=J+NUMR(2,I)-1
         T(J)=DBLE(CIRC1(JC))*CIRC2(JC)+DBLE(CIRC1(JC+1))*CIRC2(JC+1)
      T(J+1)=-DBLE(CIRC1(JC))*CIRC2(JC+1)+DBLE(CIRC1(JC+1))*CIRC2(JC)
	 ENDDO
C###
         DO    J=1,NUMR(3,I)+1
         Q(J)=Q(J)+T(J)*WR
	 ENDDO
         ENDIF
	 ENDDO
C
         CALL  FFTR_D(Q,IP)
C
         QN=-1.0D20
         DO    J=1,MAXRIN
         IF(Q(J).GE.QN)  THEN
         QN=Q(J)
         JTOT=J
         ENDIF
	 ENDDO
C
         DO    K=-3,3
         CMP = JTOT+K+MAXRIN-1
         J=MOD(CMP,MAXRIN)+1
         T7(K)=Q(J)
	 ENDDO
         CALL  PRB1D(T7,7,POS)
         TOT=REAL(JTOT)+POS
         END
