C++************************************************************************
C
C $$ CROSRNG_M.FOR
C
C **************************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK            *
C *  COPYRIGHT (C)1981,1987, WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *  THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR       *
C *  LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR    *
C *  USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF     *
C *  THE CENTER FOR LABORATORIES AND RESEARCH                              *
C **************************************************************************
C
C
C
C23456789012345678901234567890123456789012345678901234567890123456789012
C--************************************************************************
C
C $$ CROSRNG_M.FOR
C
	SUBROUTINE  CROSRNG_M
     &   (CIRC1,CIRC2,LCIRC,NRING,
#ifdef SP_MP
     &   T_,Q_,
#else
     &   T,Q,
#endif
     &   MAXRIN,NUMR,QN,TOT,QM,TMT,TT)
C
C  INPUT - Fourier transforms of rings!!!
C  CIRC1 already multiplied by weights!!
C
	INTEGER*2  NUMR(3,NRING),MAXRIN,NUMR3I,NUMR2I,CMP
	DIMENSION  CIRC1(LCIRC),CIRC2(LCIRC)
	DOUBLE PRECISION  TT(*)
#ifdef SP_MP
C  CONSULT  1024 with alprbs
	DOUBLE PRECISION  Q(1024),T(1024),T_,Q_
#else
	DOUBLE PRECISION  T(MAXRIN),Q(MAXRIN)
#endif
	DOUBLE PRECISION  QN,QM,QT,PI,T7(-3:3)
CNO_SAVE
	IP=MAXRIN
#ifdef SP_LIBFFT
#else
	IP=-LOG2_P(IP)
#endif
C
	DO   J=1,MAXRIN
C C - straight  = CIRC1*CONJG(CIRC2)
	Q(J)=0.0D0
C T - mirrored  = CONJG(CIRC1)*CONJG(CIRC2)
	T(J)=0.0D0
	ENDDO
C
	DO    I=1,NRING
	NUMR3I=NUMR(3,I)
	NUMR2I=NUMR(2,I)
C
	T1=CIRC1(NUMR2I)*CIRC2(NUMR2I)
	Q(1)=Q(1)+T1
	T(1)=T(1)+T1
C
	IF(NUMR3I.EQ.MAXRIN)  THEN
	T1=CIRC1(NUMR2I+1)*CIRC2(NUMR2I+1)
	Q(2)=Q(2)+T1
	T(2)=T(2)+T1
C
	ELSE
	T1=CIRC1(NUMR2I+1)*CIRC2(NUMR2I+1)
	Q(NUMR3I+1)=Q(NUMR3I+1)+T1
C###
	ENDIF
C
	DO   J=3,NUMR3I,2
	JC=J+NUMR2I-1
	C1=CIRC1(JC)
	C2=CIRC1(JC+1)
	T1=C1*CIRC2(JC)
	T2=C2*CIRC2(JC+1)
	T3=C1*CIRC2(JC+1)
	T4=C2*CIRC2(JC)
	Q(J)=Q(J)+T1+T2
	Q(J+1)=Q(J+1)-T3+T4
	T(J)=T(J)+T1-T2
	T(J+1)=T(J+1)-T3-T4
	ENDDO
	ENDDO
C  STRAIGHT
#ifdef SP_LIBFFT
	INV=-1
	LDA=1
	Q(MAXRIN+1)=Q(2)
	Q(2)=0.0
	Q(MAXRIN+2)=0.0
	CALL  ZDFFT1DU(INV,IP,Q,LDA,TT)
C skip the normalization, divide the maximum instead.
C	CALL  DSCAL1D(IP,1.0D0/DBLE(FLOAT(IP)),Q,LDA)
#else
	CALL  FFTR_D(Q,IP)
#endif
C
	QN=-1.0D20
	DO    J=1,MAXRIN
	IF(Q(J).GE.QN)  THEN
	QN=Q(J)
	JTOT=J
	ENDIF
	ENDDO
#ifdef SP_LIBFFT
	QN=QN/MAXRIN
#endif
C
	DO    K=-3,3
        CMP = JTOT+K+MAXRIN-1
        J=MOD(CMP,MAXRIN)+1
	T7(K)=Q(J)
	ENDDO
	CALL  PRB1D(T7,7,POS)
	TOT=FLOAT(JTOT)+POS
C  MIRRORED
#ifdef SP_LIBFFT
 	T(MAXRIN+1)=T(2)
	T(2)=0.0
	T(MAXRIN+2)=0.0
	CALL  ZDFFT1DU(INV,IP,T,LDA,TT)
C skip the normalization, divide the maximum instead.
C	CALL  DSCAL1D(IP,1.0D0/DBLE(FLOAT(IP)),T,LDA)
#else
	CALL  FFTR_D(T,IP)
#endif
C
	QM=-1.0D20
	DO    J=1,MAXRIN
	IF(T(J).GE.QM)  THEN
	QM=T(J)
	JTOT=J
	ENDIF
	ENDDO
#ifdef SP_LIBFFT
	QM=QM/MAXRIN
#endif
C
	DO    K=-3,3
        CMP = JTOT+K+MAXRIN-1
        J=MOD(CMP,MAXRIN)+1
	T7(K)=T(J)
	ENDDO
	CALL  PRB1D(T7,7,POS)
	TMT=FLOAT(JTOT)+POS
	END
