C++************************************************************************
C
C $$ CRSFN2.FOR
C
C **************************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK            *
C *  COPYRIGHT (C)1981,1987, WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *  THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR       *
C *  LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR    *
C *  USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF     *
C *  THE CENTER FOR LABORATORIES AND RESEARCH   			   *
C **************************************************************************
C
C
C
C--************************************************************************
C
C $$ CRSFN2.FOR
C
         SUBROUTINE  CRSFN2(X,Y,O,NSAM,NROW,WRK)
C
C  Calculates circular croscorrelation, non-power-of-two dimensions
C  Input - X,Y Fourier transforms
C  Output -  O=F(X*conjg(Y))
C
C  WRK(MAX0(NSAM,NROW))
C
         DIMENSION  X(NSAM,NROW),Y(NSAM,NROW),O(NSAM,NROW),WRK(*)
         LOGICAL  IFNS,IFNR
CNO_SAVE
C
         IFNS=MOD(NSAM,2).EQ.0
         IFNR=MOD(NROW,2).EQ.0
C
C     INS=1
C     CALL  Fmr_2(X,NSAM,NROW,WRK,INS)
C     IF(INS.EQ.0)  RETURN
C     CALL  Fmr_2(Y,NSAM,NROW,WRK,INS)
C
         I=NSAM/2-1
         DO   J=1,NROW
           CALL  MLC(X(3,J),Y(3,J),O(3,J),I)
	 ENDDO
C
         IF(IFNS)  THEN
         DO    I=1,2
          DO    J=2,NROW/2
           KJ=2*J-1
           OT=-X(I,KJ)*Y(I,KJ+1)+X(I,KJ+1)*Y(I,KJ)
           O(I,KJ)=X(I,KJ)*Y(I,KJ)+X(I,KJ+1)*Y(I,KJ+1)
           O(I,KJ+1)=OT
	  ENDDO
         IF(.NOT.IFNR)  THEN
         OT=-X(I,NROW)*Y(I,2)+X(I,2)*Y(I,NROW)
         O(I,NROW)=X(I,NROW)*Y(I,NROW)+X(I,2)*Y(I,2)
         O(I,2)=OT
         ENDIF
	 ENDDO
         O(2,1)=X(2,1)*Y(2,1)
         IF(IFNR)  THEN
         O(1,2)=X(1,2)*Y(1,2)
         O(2,2)=X(2,2)*Y(2,2)
         ENDIF
C
         ELSE
C
         DO    J=2,NROW/2
          KJ=2*J-1
          OT=-X(1,KJ)*Y(1,KJ+1)+X(1,KJ+1)*Y(1,KJ)
          O(1,KJ)=X(1,KJ)*Y(1,KJ)+X(1,KJ+1)*Y(1,KJ+1)
          O(1,KJ+1)=OT
	 ENDDO
         IF(IFNR)  THEN
         O(1,2)=X(1,2)*Y(1,2)
         ELSE
         OT=-X(1,NROW)*Y(1,2)+X(1,2)*Y(1,NROW)
         O(1,NROW)=X(1,NROW)*Y(1,NROW)+X(1,2)*Y(1,2)
         O(1,2)=OT
         ENDIF
         DO    J=1,NROW
          OT=-X(NSAM,J)*Y(2,J)+X(2,J)*Y(NSAM,J)
          O(NSAM,J)=X(NSAM,J)*Y(NSAM,J)+X(2,J)*Y(2,J)
          O(2,J)=OT
	 ENDDO
         ENDIF
         O(1,1)=X(1,1)*Y(1,1)
C
         INS=-1
         CALL  FMR_2(O,NSAM,NROW,WRK,INS)
C
         NR2=NROW/2
         NS2=NSAM/2
         IF(IFNS.AND.IFNR)  THEN
         DO    J=1,NR2
          JJ=J+NR2
          DO    I=1,NS2
           II=I+NS2
           Q=O(I,J)
           O(I,J)=O(II,JJ)
           O(II,JJ)=Q
           Q=O(I,JJ)
           O(I,JJ)=O(II,J)
           O(II,J)=Q
	  ENDDO
	  ENDDO
         ELSEIF(.NOT.IFNS .AND. .NOT.IFNR)  THEN
         K=0
         DO    I=1,NS2+1
          K=K+1
          WRK(K)=O(I,NR2+1)
	 ENDDO
         DO    J=1,NR2
          K=K+1
          WRK(K)=O(NS2+1,J)
	 ENDDO
         DO  23  J=1,NR2+1
          DO    I=1,NS2
           O(I,J+NR2)=O(I+NS2+1,J)
	  ENDDO
         IF(J.EQ.NR2+1)  GOTO  23
         DO    I=1,NS2+1
          O(I+NS2,J)=O(I,J+NR2+1)
	 ENDDO
23       CONTINUE
         DO    J=1,NR2
          DO    I=1,NS2
           O(I+NS2,J+NR2)=O(I,J)
           O(I,J)=O(I+NS2+1,J+NR2+1)
	  ENDDO
	 ENDDO
         K=0
         DO    I=1,NS2+1
          K=K+1
          O(I+NS2,NROW)=WRK(K)
	 ENDDO
         DO   J=1,NR2
          K=K+1
          O(NSAM,J+NR2)=WRK(K)
	 ENDDO
C
         ELSEIF(.NOT.IFNS .AND.IFNR)  THEN
         DO   J=1,NR2
          WRK(J)=O(NS2+1,J)
	 ENDDO
C
         DO  52  I=1,NS2+1
          DO    J=1,NR2
           O(I+NS2,J)=O(I,J+NR2)
	  ENDDO
         IF(I.EQ.NS2+1)  GOTO  52
         DO   J=1,NR2
          O(I,J+NR2)=O(I+NS2+1,J)
	 ENDDO
52       CONTINUE
         DO    J=1,NR2
          DO    I=1,NS2
           O(I+NS2,J+NR2)=O(I,J)
           O(I,J)=O(I+NS2+1,J+NR2)
	  ENDDO
	 ENDDO
         DO    J=1,NR2
           O(NSAM,J+NR2)=WRK(J)
	 ENDDO
C
         ELSEIF(IFNS .AND. .NOT.IFNR)  THEN
         DO    I=1,NS2
           WRK(I)=O(I,NR2+1)
	 ENDDO
C
         DO  62  J=1,NR2+1
          DO  I=1,NS2
           O(I,J+NR2)=O(I+NS2,J)
	  ENDDO
         IF(J.EQ.NR2+1)  GOTO  62
         DO  I=1,NS2
           O(I+NS2,J)=O(I,J+NR2+1)
	 ENDDO
62       CONTINUE
         DO    I=1,NS2
          DO    J=1,NR2
           O(I+NS2,J+NR2)=O(I,J)
           O(I,J)=O(I+NS2,J+NR2+1)
	  ENDDO
	 ENDDO
         DO    I=1,NS2
           O(I+NS2,NROW)=WRK(I)
	 ENDDO
         ENDIF
C
C  Normalize
         SCL=1.0/(FLOAT(NSAM)*FLOAT(NROW))
         DO    J=1,NROW
          DO    I=1,NSAM
      	    O(I,J)=O(I,J)*SCL
	  ENDDO
	 ENDDO
         END
