C++*************************************************************************
C
C    CSGET.FOR  -- CREATED DEC 84
C                  REWRITTEN SEPT 86 al
C                  ISYMBL ADDED NOV 86 al
C                  3-D ADAPTED FEB 86 al
C                  ERROR NOTICES DIVERTED TO FOR001.DAT APRIL 87  al
C                  ADDED NEW TEXT CONTOURS FEB 88 al
C                  MARKER = 6 ADDED JUNE 88 al
C                  LIMFIL ADDED AUG 88 al
C                  CAN RECOVER DELETED CONTOURS JULY 89 AL
C **************************************************************************
C *  AUTHOR: R. BANERJEE                                                   *
C *  COPYRIGHT (C)1985 , WADSWORTH CENTER FOR LABORATORIES AND             *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH  			   *
C **************************************************************************
C
C $$ CSGET(ICNTR,NSIZE,DATA,NDATA,LUN,IRTFLG)
C
C    PURPOSE:  TO READ CONTOUR DATA FROM A CONTOUR STORAGE FILE 
C
C    PARAMETERS:
C        ICNTR          CONTOUR NO. SPECIFIED BY THE CALLER
C        NSIZE          SIZE OF THE ARRAY DATA WHERE CONTOUR POINTS
C                       WILL BE RETURNED
C        DATA(3,NDATA)  ARRAY CONTAINING THE CO-ORDINATES OF CONTOURS
C        NDATA          NO. OF POINTS IN THE  CONTOUR 
C        LUN            LOGICAL UNIT NUMBER TO BE ASSIGNED TO FILNAM.
C        IRTFLG         ERROR RETURN FLAG.
C                       (IRTFLG = 0   NORMAL RETURN,  IRTFLG = 1    ERROR 
C
C    VARIABLES:
C        MPT            ISHAP,MARKER, PENTYPE AND LINE TYPE ( IN COMMON)
C        ISYMBL         CONTOUR TEXT MARKER (IN COMMON)
C        ZCOO           Z- COORDINATE FOR THE CONTOUR (IN COMMON)
C        CBUF           BUFFER FOR READING THE DATA       
C        IRECLN         RECORD LENGTH (IN COMMON)
C
C   CALLS:              REDLIN
C
C   CALLED BY:          SSGET     AND MANY SUBROUTINES
C
C--********************************************************************

	SUBROUTINE CSGET(ICNTR,NSIZE,DATA,NDATA,LUN,IRTFLG)

        INCLUDE 'CONSTG.INC'
        COMMON /UNITS/LUNDOC,NIN,NOUT

        DIMENSION       DATA(3,NSIZE)
        INTEGER     * 2 ISMPLI(2)
        CHARACTER   * 4 CDATA
        EQUIVALENCE     (FSMPLI,ISMPLI),(FSJIFP,ISJIFP),(CDATA,FDATA)
        LOGICAL         DEBUG

        DATA  LUNERR/0/
C       LUNERR USED TO AVOID CRASHING GRAPHICS MODE TERMINALS

C..       GET FILE POSITION INFO FROM THE CONTROL RECORD 
          IF (ICNTR .LE. 0) THEN
             IRTFLG = 1
             NDATA = 0
             WRITE(LUNERR,101) ICNTR
  101        FORMAT(' *** REQUESTS INVALID CONTOUR:',I7)
             RETURN
          ENDIF

C****************** DEBUG
C          DEBUG = .FALSE.

          ISTREC = CONTRL(1,ICNTR)
          MINREC = 5 + NDTCTL
          IF (ISTREC .LT. MINREC) THEN
C..           MAY BE A DELETED RECORD
              WRITE(LUNERR,104) ICNTR,ISTREC,MINREC,ISTSUF,
     &        LSTREC,LSTSUF
  104         FORMAT(' REQUESTS DELETED CONTOUR=',I8,/,
     &        'ISTREC,MINREC,ISTSUF,LSTREC,LSTSUF:',5I5)
              IF (IRTFLG. NE. -999) THEN
                 NDATA = 0
                 IRTFLG = 1
                 RETURN
              ELSE
C                SPECIAL CASE TO RECOVER DELETED CONTOURS
                 ISTREC = - ISTREC
              ENDIF
          ENDIF

          ISTSUF = CONTRL(2,ICNTR) 
          LSTREC = CONTRL(3,ICNTR) 
          LSTSUF = CONTRL(4,ICNTR) 
          ZCOO   = CONTRL(6,ICNTR) 
          FSJIFP = CONTRL(5,ICNTR)

          IF (IFRMCS .EQ. -6 .AND. ISJIFP .LT. 0) THEN
C            NEW STYLE TEXT CONTOUR
             KSJ    = ABS(ISJIFP)

C..          COMPUTE TEXT ANGLE,SIZE,JUSTIFICATION,INTENSITY,FONT,& COLOR
             ITANGL = KSJ / 1000000
             KSJ    = KSJ - ITANGL * 1000000
             ITSIZE = KSJ / 10000
             KSJ    = KSJ - ITSIZE * 10000
             JUST   = KSJ / 1000
C            KJUST IS NECESSARY TO PREVENT INTEGER OVERFLOW
             KJUST  = JUST 
             KJUST  = KJUST * 1000
             KSJ    = KSJ - KJUST
             INTEN  = KSJ / 100
             KSJ    = KSJ - INTEN * 100
             IFON   = KSJ / 10
             IPEN   = KSJ - IFON * 10
             MARK   = -2

C***************************** DEBUG
C             IF (ICNTR .LT. 60) THEN
C               DEBUG = .TRUE.
C               FSJIFP = CONTRL(5,ICNTR)
C               WRITE(LUNERR,24)ICNTR,ISJIFP,MARK,FSJIFP
C24             FORMAT(' IN CSGET;ICNTR,ISJIFP,MARK,FSJIFP:',/,
C     &         3I8,G11.3/)
C               ICLOD = ICLOD + 1
C             ENDIF
C****************************************************

          ELSEIF (IFRMCS .EQ. 6) THEN
C            OLD STYLE TEXT CONTOUR CONTAINING FILE
             FSMPLI = CONTRL(5,ICNTR)
             ISYMBL = ISMPLI(1)
             MPTT   = ISMPLI(2)
             CALL SSPARM(MPTT,IRTFLG)

          ELSE
C..          FIND OUT THE VALUE OF SHAPE,MARKER,PEN,LINTP,INTEN
             MPT   = FSJIFP
             IT    = MPT
             LIMFIL= IT / 100000
             IT    = IT - 100000 * LIMFIL
             ISHAP = IT / 10000
             IT    = IT - 10000 * ISHAP
             MARK  = IT / 1000
             IT    = IT - 1000 * MARK
             IPEN  = IT / 100
             IT    = IT - 100 * IPEN
             LINTP = IT / 10
             INTEN = IT - 10 * LINTP
          ENDIF

          THREED = .FALSE.
          IF (IFRMCS .EQ. 4 .AND. (MARK .EQ. 1 .OR. MARK .EQ. 6))
     &        THREED = .TRUE.

C***************************** DEBUG
C          WRITE(LUNERR,24)ICNTR,MPT
C  24      FORMAT(' IN CSGET;IFRMCS,ICNTR,MPT:',6I6)
C****************************************************
 
        IF (ISTREC .NE. LSRECD) THEN
C..        READ THE ISTREC,IF ISTREC IS NOT THE LAST RECORD READ/WRITTEN
           K1 = ISTREC - 1
           CALL REDLIN(LUN,CBUF,IRECLN,K1)
           LSRECD = ISTREC
        ENDIF
        ICUREC = ISTREC

        MAXSUF = IRECLN 
        J      = ISTSUF
        KDATA  = 1

        NVAL  = (LSTREC - ISTREC) * IRECLN + (LSTSUF - ISTSUF + 1)
        NDATA = NVAL / 2
        IF (THREED) NDATA = NVAL / 3
        IF (NDATA .GT. NSIZE) THEN
C..          THERE IS NOT ENOUGH ROOM IN THE DATA ARRAY
             IRTFLG = 1
             WRITE(LUNERR,*)' DATA ARRAY FULL, CONTOUR TRUNCATED'
C..          FIND LENGTH OF DATA THAT WILL FIT IN THE ARRAY
             LSTREC = ISTREC
             J = ISTSUF
             DO  I = 1, NSIZE
               J = J + 1
               IF (J .GT. IRECLN) THEN
                  J = 1
                  LSTREC = LSTREC + 1
               ENDIF
	     ENDDO
             LSTSUF = J - 1
          ENDIF


C..     READ THE DATA POINTS AND CHECK IF RECORD LENGTH HAS EXCEEDED
 4001   IF (J .GT. MAXSUF) THEN
C           RECORD LENGTH HAS BEEN EXCEEDED, READ NEXT RECORD 
            ICUREC = ICUREC + 1
            MM1 = ICUREC - 1  
            CALL REDLIN(LUN,CBUF,IRECLN,MM1)
            J = 1
          ENDIF
C..       PUT DATA INTO DATA ARRAY
          DATA(1,KDATA) = CBUF(J)
          J = J + 1

          IF (J .GT. MAXSUF) THEN
C..         READ NEXT RECORD 
            ICUREC = ICUREC + 1
            MM1 = ICUREC - 1  
            CALL REDLIN(LUN,CBUF,IRECLN,MM1)
            J = 1
          ENDIF
          DATA(2,KDATA) = CBUF (J)
          J = J + 1

          IF (THREED) THEN
            IF (J .GT. MAXSUF) THEN
C..           READ THE NEXT RECORD 
              ICUREC = ICUREC + 1
              MM1 = ICUREC - 1  
              CALL REDLIN(LUN,CBUF,IRECLN,MM1)
              J = 1
            ENDIF
            DATA(3,KDATA) = CBUF(J)
            J = J + 1
          ENDIF     
           KDATA = KDATA + 1
 
       IF ((J .LE. LSTSUF) .OR. (ICUREC .LT. LSTREC)) GOTO 4001
 
C..     UPDATE THE NO. OF DATA POINTS
        NDATA = KDATA - 1
        LSRECD = ICUREC

C***************************** DEBUG
C         IF (DEBUG) THEN
C            NCHAR = DATA(1,2)
C            FDATA = DATA(2,2)
C            WRITE(0,6111) (DATA(1,1),DATA(2,1),DATA(1,2),DATA(2,2))
C6111        FORMAT(' DATA:',4G11.3)
C            WRITE(0,6599) MARK,NDATA,NCHAR,CDATA
C6599        FORMAT(' CSGET;MARK,NDATA,NCHAR,CDATA:',
C     &      3I4,':',A4,':')
C            DEBUG = .FALSE.
C         ENDIF
C
C        ITEST = CONTRL(4,NOBIN)
C        WRITE(LUNERR,999)ISTREC,ISTSUF,LSTREC,LSTSUF,ITEST,MPT
C  999   FORMAT(' 1R,1SUF,LASTR,LASTS,=,MPT:',7I6)
C******************************************

C..     SET GOOD ERROR RETURN
        IRTFLG = 0

      RETURN
      END

