
C++***********************************************************************
C
C  CSGTBN.FOR  -- CREATED DEC 84
C
C **************************************************************************
C *  AUTHOR: R. BANERJEE                                                   *
C *  COPYRIGHT (C)1984 , WADSWORTH CENTER FOR LABORATORIES AND             *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH  			   *
C **************************************************************************
C
C $$ CSGTBN:    TO GET A CELL FROM A LINKED LIST
C
C      CSGTBN(ARANAM,AVAIL,NDIM1,NDIM2,ISTAVL,LSTAVL,NOBIN)
C
C      ARANAM     NAME OF THE ARRAY WHERE LIST IS STORED
C
C      AVAIL(NDIM1,NDIM2)  THIS IS THE ARRAY WHERE LIST IS STORED
C
C      ISTAVL     THE NEXT AVAILABLE LOCATION IN THE LIST
C
C      LSTAVL     THE HIGHEST NO. OF CELLS USED SO FAR
C
C      NOBIN     THE LOCATION OF CELL RETURNED TO CALLER
C
C      CALLED BY:      SSPUSH     CSPUSH
C
C      CALLS:          none
C
C--********************************************************************
C
C
	SUBROUTINE CSGTBN(ARANAM,AVAIL,NDIM1,NDIM2,ISTAVL,LSTAVL,NOBIN)
C
        COMMON /UNITS/ LUNDOC,NIN,NOUT,NECHO,IFOUND,NPROC,NDAT 
C..
C..     ONLY THE UNIT COMMON IS USED TO SEND 
C..     ERROR MESSAGES TO THE TERMINAL
C..
        DIMENSION AVAIL(NDIM1,NDIM2)
        CHARACTER * 6 ARANAM
C..
C..     ISTAVL CONTAINS THE LOCATION OF NEXT AVAILABLE CELL
C..     ASIGN THAT TO NOBIN AFTER CHECKING FOR VALID RANGE
C..
        IF (ISTAVL .GT. NDIM2) THEN
           WRITE(NOUT,100)ARANAM
  100      FORMAT(1X,'NO MORE ROOM IN THE ARRAY ',A6)
           NOBIN = 0
           RETURN
        ENDIF
C..
        IF (ISTAVL .LE. 0) THEN
           WRITE(NOUT,101) ISTAVL,ARANAM
  101      FORMAT(1X,'UN-ACCEPTABLE VALUE OF CELL NO. = ',I8,
     &     ' IN ARRAY  ',A6) 
           NOBIN = 0 
           RETURN
        ENDIF
C..
        NOBIN = ISTAVL
C..
C..     CHECK IF THE CONTENTS OF THE CELL CONTAINS A NEGATIVE NO.
C..     WHICH MEANS THAT THIS WILL BE THE POINTER TO NEXT AVAILABLE
C..     CELL.
C..
        IF (AVAIL(1,ISTAVL) .LT. 0) THEN
           ISTAVL = - AVAIL(1,ISTAVL)
           AVAIL(1,NOBIN)  = 0
        ELSE
C..
C..     OTHERWISE THE NEXT CELL WILL BE THE NEXT ONE IN THE ARRAY
C..
           ISTAVL = ISTAVL + 1
           AVAIL(1,ISTAVL) = 0
       ENDIF
C..
C..    IF THE CURRENT BIN BEING USED IS HIGHER THAN THE LAST ONE
C..    THEN UPDATE THE LAST BIN NO.
C.. 
       IF (NOBIN .GT. LSTAVL) THEN
          LSTAVL = NOBIN
       ENDIF
C.. 
      RETURN
      END

