
C++*******************************************************************
C
C CSGTTX.FOR  -- CREATED DEC 84
C
C **************************************************************************
C *  AUTHOR: R. BANERJEE                                                   *
C *  COPYRIGHT (C)1984 , WADSWORTH CENTER FOR LABORATORIES AND             *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH  			   *
C **************************************************************************
C
C $$ CSGTTX(LINE,NCHAR,LUN,NF,ITEXT)
C
C    PURPOSE:  TO READ TEXT FROM A CONTOUR STORAGE FILE 
C
C    PARAMETERS:
C        LINE      160 CHARACTERS WHERE THE LINE OF TEXT WILL BE RECOVERED
C        NCHAR     NO. OF CHARACTERS IN THE TEXT 
C        LUN       LOGICAL UNIT NUMBER TO BE ASSIGNED TO FILNAM.
C        NF        ERROR RETURN FLAG.
C                  NF = 0    NORMAL RETURN
C                  NF = 1    ERROR RETURN
C        ITEXT     THE NO. OF THE TEXT TO BE READ
C
C    VARIABLES:
C        ISJIFP    ANGLE, SIZE, JUSTIVICATION, INTENSITY, FONT, AND PEN TYPE
C        XPOS      X-CO-ORDINATE OF TEXT
C        YPOS      Y-CO-ORDINATE OF TEXT
C        CBUF      BUFFER FOR READING TEXT
C        IRECLN    RECORD LENGTH.
C        
C        NOTE     THE FILE IS ALREADY OPENED BY CALLER
C                 CALLER SHOULD READ JOFP,XPOS,YPOS FROM COMMON AFTER
C                 CALLING THIS ROUTINE.
C
C
C    CALLED BY:    CNTERM    CNGOUL   CNTEKT   CNLEXI   CNRAST     ??
C
C    CALLS:        REDLIN
C
C--********************************************************************

	SUBROUTINE CSGTTX(LINE,NCHAR,LUN,NF,ITEXT)

        INCLUDE 'CONSTG.INC'
        COMMON /UNITS/ LUNDOC,NIN,NOUT

        INTEGER     * 4    KSJ,KSJT,KJUST
        CHARACTER   * 8196 TXTARA
        CHARACTER   * 160  LINE
        EQUIVALENCE        (CBUF(1), TXTARA(1:1)),(ISJIFP,FSJIFP)

C..     SET GOOD ERROR RETURN
        NF = 0

C..       NOW GET THE TXTCTR RECORD 
C..       IF ITEXT < 0 THEN ERROR
          IF (ITEXT .LE. 0) THEN
             WRITE(NOUT,101) ITEXT
  101        FORMAT(' REQUESTS AN INVALID TEXT:',I8) 
             NF = 1
             RETURN
          ENDIF

          IFRSUF = TXTCTR(1,ITEXT)
C..       CHECK IF DELETED TEXT OR NOT

          IF (IFRSUF .LT. 1) THEN
              WRITE(NOUT,*) ' REQUESTS A NONEXISTENT TEXT' 
              NCHAR = 0
              RETURN
          ENDIF
C..   
          ITOSUF = TXTCTR(2,ITEXT)
          FSJIFP = TXTCTR(3,ITEXT) 
          KSJ    = ISJIFP

C..       COMPUTE ANGLE,SIZE,JUSTIFICATION,INTENSITY,FONT, AND COLOUR OF TEXT
          ITANGL = KSJ / 1000000
          KSJ    = KSJ - ITANGL * 1000000
          ITSIZE = KSJ / 10000
          KSJ    = KSJ - ITSIZE * 10000
          JUST   = KSJ / 1000
C         KJUST IS NECESSARY TO PREVENT INTEGER OVERFLOW
          KJUST  = JUST 
          KJUST  = KJUST * 1000
          KSJ    = KSJ - KJUST
          INTEN  = KSJ / 100
          KSJ    = KSJ - INTEN * 100
          IFON   = KSJ / 10
          IPEN   = KSJ - IFON * 10
          XPOS = TXTCTR(4,ITEXT) 
          YPOS = TXTCTR(5,ITEXT) 

C..     READ THE 4TH REC,ONLY IF 4TH REC IS NOT THE LAST RECORD READ/WRITTEN
        IF (LSRECD .NE. 4) CALL REDLIN(LUN,CBUF,IRECLN,3)

        MAXSUF = IRECLN * 4
        J      = IFRSUF
        KTEXT  = 1

C..     READ THE TEXT ONE CHARACTER AT A TIME
 4001   IF (J .GT. MAXSUF) THEN
C           RECORD LENGTH HAS BEEN EXCEEDED,  FLAG ERROR AND RETURN
            NF = 1
            WRITE(NOUT,103)J,MAXSUF
  103       FORMAT(' TXTCTR ARRAY REFERRING TO WRONG SUFFIX ',I8,
     &       ' > RECORD LENGTH ',I5)
            RETURN
          ENDIF

C..       STORE TEXT  IN LINE
          IF (KTEXT .GT. 160) THEN
             WRITE(NOUT,*) ' SPACE EXCEEDED IN TEXT RECEIVING ARRAY'
             NF = 1
             KTEXT = 161
             GOTO 4101
          ENDIF
          LINE (KTEXT:KTEXT) = TXTARA(J:J)
          J = J + 1   
          KTEXT = KTEXT + 1
          IF ( J .LE. ITOSUF) GOTO 4001

C..       UPDATE THE NCHAR AND LAST RECORD READ
4101      NCHAR = KTEXT - 1  
          LSRECD = 4

      RETURN
      END

