
C++************************************************************************
C
C  CSLICE.FOR
C                                             FILE NAMES LENGTHENED
C **************************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK            *
C *  COPYRIGHT (C)1981,1987, WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH 			   *
C **************************************************************************
C
C  CSLICE:     SELECT CENTRAL SLICE OF A 3-D IMAGE WITH ARBITRARY
C		        AZIMUTH AND INCLINATION.
C
C--*******************************************************************

	SUBROUTINE CSLICE

	COMMON ADUM(80),A0(1270)
	COMMON /UNITS/LUN,NIN,NOUT,NECHO,IFOUND,NPROC,NDAT

	COMMON /MASTER/ NSAMC,NROWC,IREC,NLABEL,IFORM,IMAMI,FMAX,FMIN,
     1                  AV,SIG,IHIST
	COMMON /BATCH/ IBCNT,NLOOP,IABSLP,ILOOP

	DIMENSION       BUF(1)
	EQUIVALENCE     (A0(520),BUF)
        COMMON /COMMUN/ FILNAM,FILOUT

        CHARACTER *81 FILNAM,FILOUT
        CHARACTER *1  NULL
        
	DATA LUNI/7/,LUNO/6/,PI/3.14159/

        NULL=CHAR(0)

	IERR=0

	CALL FILERD(FILNAM,NLET,NULL,'INPUT ',IRTFLG)
        IF (IRTFLG .NE. 0) RETURN

	CALL OPENF(FILNAM,LUNI,NSAM,NROW,'OLD',NF,NSLICE)
	IF(IFORM.NE.3)IERR=2
	IF(NF.EQ.1)IERR=4
	IF(IERR.NE.0)GOTO 8000
	NROW3=NROW*NSLICE
C	IF(IMAMI.EQ.0)CALL NORM(LUNI,NSAM,NROW3,FMAX,FMIN,AV)
	CALL FILERD(FILOUT,NLET,NULL,'OUTPUT',IRTFLG)
        IF (IRTFLG .NE. 0) GOTO 9000

	IFORM = 1
	S3 = SQRT(3.)
	MAXREC=NROW*NSLICE
	NSAM2=NSAM*S3+0.5
	NROW2=NROW*S3+0.5
	NSAMH=NSAM2/2+1
	NROWH=NROW2/2+1
	CALL OPENF(FILOUT,LUNO,NSAM2,NROW2,'UNKNOWN',NF,1)
	IF(NF.EQ.1)IERR=4
	IF(IERR.NE.0)GOTO 8000
	CALL RDPRM(PHI,NLOOP,ILOOP,'AZIMUTH')
	CALL RDPRM(THETA,NLOOP,ILOOP,'INCLINATION')


	PHI = PHI*PI/180.
	THETA = THETA*PI/180.
C	KXM = NSAM/2+1
C	KYM = NROW/2+1
C	KZM = NSLICE/2+1
	CALL RDPRMI(KXM,KYM,NLOOP,ILOOP,'ENTER X,Y POSITION')
	CALL RDPRMI(KZM,NDUM,NLOOP,ILOOP,'ENTER Z POSITION')
	SPHI = SIN(PHI)
	CPHI = COS(PHI)
	STHETA = SIN(THETA)
	CTHETA = COS(THETA)
	XFACT = CTHETA*SPHI
	YFACT = CTHETA*CPHI

C  DIMENSIONS OF 2-D FILE ARE NSAM2 BY NROW2

	DO IY=1,NROW2
	DO 200 IX=1,NSAM2
	X = KXM+((FLOAT(IX-NSAMH))*CPHI)+((FLOAT(IY-NROWH))*XFACT)
	Y = KYM-((FLOAT(IX-NSAMH))*SPHI)+((FLOAT(IY-NROWH))*YFACT)
	Z = KZM+(FLOAT(IY-NROWH))*STHETA

C  DETERMINE THE 8 SURROUNDING COEFFICIENTS

	KXBOT = X
	KXTOP = KXBOT+1
	XDEC = X-(FLOAT(KXBOT))
	XREM = 1.-XDEC

	KYBOT = Y
	KYTOP = KYBOT+1
	YDEC = Y-(FLOAT(KYBOT))
	YREM = 1.-YDEC

	KZBOT = Z
	KZTOP = KZBOT+1
	ZDEC = Z-(FLOAT(KZBOT))
	ZREM = 1.-ZDEC


C   CHECK IF COORDINATES ARE INSIDE THE VOLUME;  CONTINUE IF THEY ARE,
C   OTHERWISE, SET = 0.


	IF(KXTOP.LE.NSAM.AND.KYTOP.LE.NROW.AND.KZTOP.LE.NSLICE.AND.
     1     KXBOT.GE.1.AND.KYBOT.GE.1.AND.KZBOT.GE.1)GOTO 100
	BUF(IX) = FMIN
	GOTO 200


100	IREC1=(KZBOT-1)*NROW+KYBOT
	IF(IREC1.GT.MAXREC)IERR=7
	IF(IERR.NE.0)GOTO 8000
	CALL REDLIN(LUNI,A0,NSAM,IREC1)
	PT1 = A0(KXBOT)
	PT2 = A0(KXTOP)


	IREC2=(KZBOT-1)*NROW+KYTOP
	IF(IREC2.GT.MAXREC)IERR=7
	IF(IERR.NE.0)GOTO 8000
	CALL REDLIN(LUNI,A0,NSAM,IREC2)
	PT3 = A0(KXBOT)
	PT4 = A0(KXTOP)


	IREC3=(KZTOP-1)*NROW+KYBOT
	IF(IREC3.GT.MAXREC)IERR=7
	IF(IERR.NE.0)GOTO 8000
	CALL REDLIN(LUNI,A0,NSAM,IREC3)
	PT5 = A0(KXBOT)
	PT6 = A0(KXTOP)


	IREC4=(KZTOP-1)*NROW+KYTOP
	IF(IREC4.GT.MAXREC)IERR=7
	IF(IERR.NE.0)GOTO 8000
	CALL REDLIN(LUNI,A0,NSAM,IREC4)
	PT7 = A0(KXBOT)
	PT8 = A0(KXTOP)


C	WRITE(4,8888)PT1,PT2,PT3,PT4,PT5,PT6,PT7,PT8
C8888	FORMAT(' PTS 1-8 = ',8F7.3)

C    INTERPOLATE

	BUF(IX) = ZREM*(XDEC*(YREM*PT2+YDEC*PT4)+
     1         XREM*(YREM*PT1+YDEC*PT3))+
     2         ZDEC*(XDEC*(YREM*PT6+YDEC*PT8)+
     3         XREM*(YREM*PT5+YDEC*PT7))


200	CONTINUE
	CALL WRTLIN(LUNO,BUF,NSAM2,IY)
	ENDDO
	GOTO 9000

8000	CALL ERRT(IERR,'CSLICE',NE)

9000	CLOSE(LUNO)
	CLOSE(LUNI)
        RETURN
	END
