 
C++************************************************************************
C
C CSOTCD.FOR  -- CREATED JAN 85
C
C **************************************************************************
C *  AUTHOR: R. BANERJEE                                                   *
C *  COPYRIGHT (C)1985 , WADSWORTH CENTER FOR LABORATORIES AND             *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH  			   *
C **************************************************************************
C
C    CSOTCD   
C
C    PURPOSE:  TO FIND THE OUTCODE FOR A POINT WITH RESPECT TO THE 
C              CLIPPING WINDOW.
C              THE CODE IS LOGICAL ARRAY OF LENGTH 4
C              1ST INDEX = TRUE   IF THE POINT IS ABOVE WINDOW
C              2ND INDEX = TRUE   IF THE POINT IS BELOW WINDOW
C              3RD INDEX = TRUE   IF THE POINT IS TO RIGHT OF WINDOW
C              4TH INDEX = TRUE   IF THE POINT IS TO LEFT OF WINDOW
C              FOR DETAILS REFER TO:
C              FUNDAMENTALS OF INTERACTIVE COMPUTER GRAPHICS,
C              J.D.FOLEY AND A.VAN DAM ;PAGES 146-149 
C
C    CSOTCD(X,Y,XMIN,XMAX,YMIN,YMAX,OUTCOD)
C
C       X,Y    CO-ORDINATE OF POINT P
C 
C
C       XMIN,YMIN  CO-ORDINATE OF BOTTOM LEFT CORNER OF WINDOW
C
C       XMAX,YMAX  CO-ORDINATE OF TOP RIGHT CORENR OF WINDOW
C
C       OUTCOD   LOGICAL ARRAY OF CODES AS DISCUSSED ABOVE.
C
C       CALLED BY:     CSCLIP
C
C       CALLS:         NONE
C
C--********************************************************************

       SUBROUTINE CSOTCD(X,Y,XMIN,XMAX,YMIN,YMAX,OUTCOD)
 
       LOGICAL OUTCOD(4)
 
C..    MAKE ALL THE CODE FALSE
       DO I = 1,4
          OUTCOD(I) = .FALSE.
       ENDDO
 
C..    CHECK IF ABOVE WINDOW
       IF (Y .GT. YMAX) OUTCOD(1) = .TRUE.
 
C..    CHECK IF BELOW WINDOW
       IF (Y .LT. YMIN) OUTCOD(2) = .TRUE.
 
C..    CHECK IF TO THE RIGHT OF WINDOW
       IF (X .GT. XMAX) OUTCOD(3) = .TRUE.
 
C..    CHECK IF TO THE LEFT OF  WINDOW
       IF (X .LT. XMIN) OUTCOD(4) = .TRUE.
 
	RETURN
	END
