
C++*************************************************************************
C
C    CSPUSH.FOR  -- CREATED DEC 84
C                   ALTERED BY al SEPT 85 SO THAT IT CAN BE USED TO PUSH
C                   SCALED DATA INTO SCALED FILE ALSO.  NDATA <0 IS USED
C                   AS A FLAG FOR THIS FEATURE 
C                   ALSO ALTERED TO CORRECT BUG WITH ALTERED DATA IN FIRST
C                   PART OF A NEW CONTOUR WHICH NEEDS RESCALING
C                   CONTOUR DIRECTION DETERMINER ADDED AUG 86 al
C                   3-D ADAPTED DEC 86 al
C                   ISHAP ADDED AUG 87 al
C                   DATAT REMOVED AUG 87 al
C                   OPEN CONTOUR DIR. CHECK REMOVED FEB 88 al
C **************************************************************************
C *  AUTHOR: R. BANERJEE                                                   *
C *  COPYRIGHT (C)1984 , WADSWORTH CENTER FOR LABORATORIES AND             *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH  			   *
C **************************************************************************
C
C    CSPUSH(LUN,DATA,NDATA,NF,ISTFLG,ICNTR)
C
C    PURPOSE:  TO PUSH THE CONTOUR DATA INTO A CONTOUR STORAGE FILE 
C              AND UPDATE THE CONTROL ARRAY
C
C    PARAMETERS:
C
C        DATA(3,NDATA)  ARRAY CONTAINING THE CO-ORDINATES OF CONTOURS
C        NDATA          NO. OF POINTS 
C**                     IF  <0 THEN FILE IS ALREADY SCALED TO SAME
C                       VALUE AS INCOMING DATA
C        LUN            LOGICAL UNIT NUMBER TO BE ASSIGNED TO FILNAM.
C        NF             ERROR RETURN FLAG.
C                         NF = 0    NORMAL RETURN
C                         NF = 1    ERROR RETURN
C                         NF = 2    FILE IS SCALED, NEEDS TO BE RECOVERED
C        ISTFLG         FLAG FOR BUFFER STORAGE
C                         ISTFLG = 0 STORE THE BUFFER ONLY WHEN IT IS FULL
C                         ISTFLG = 1 STORE THE BUFFER EVEN IF IT IS NOT FULL
C        ICNTR          NUMBER OF THE CONTOUR (RETURNED TO CALLER)
C  
C     VARIABLES:
C        IRECLN         RECORD LENGTH.
C        CBUF           BUFFER FOR READING THE DATA       
C        ISYMBL         CONTOUR TEXT SYMBOL
C        MPT            MARKER, PENTYPE AND LINE TYPE ( IN COMMON)
C        NCNTRS         TOTAL NO. OF CONTOURS IN THE FILE
C        ZCOO           Z- COORDINATE FOR THE CONTOUR (IN COMMON)
C
C        NOTE     THE FILE IS ALREADY OPENED BY CALLER
C                 CALLER SHOULD ASSIGN MPT AND ZCOO BEFORE CALLING
C                 THIS ROUTINE.
C                 THE LAST CALL TO THIS ROUTINE SHOULD BE ALWAYS
C                 MADE WITH ISTFLG = 1.   
C
C        THE FOLLOWING VARIABLES IN THE COMMON BLOCK ARE USED
C        IN THIS PROGRAM.
C        XMAX,XMIN,YMAX,YMIN, SCALE
C
C        IF SCALE > 0 THEN A CHECK IS MADE TO MAKE SURE THAT
C                     THE DATA POINTS FALL WITHIN THE LIMITING
C                     VALUES XMAX-XMIN AND YMAX-YMIN.
C****al
C                     IF NDATA <0 THEN  DATA BEING PUSHED IS ASSUMED TO 
C                     ALREADY BE SCALED SIMILARLY TO DATA IN FILE.  BUT IT
C                     IS CHECKED FOR VALUES OUTSIDE SCALING RANGE (0-1)
C                     TO INDICATE ERRORS.
C            
C        CALLS:       REDLIN,  WRTLIN,  CSGTBN
C
C        CALLED BY:   SSPUSH   SSTRA   CNTHIN  DPROFL  DENDRO
C                     HISTOG   XTEST   (AND MANY OTHERS)
C
C--***********************************************************************

      SUBROUTINE CSPUSH(LUN,DATA,NDATA,NF,ISTFLG,ICNTR)

      INCLUDE 'CONSTG.INC'

      COMMON /UNITS/LUNDOC,NIN,NOUT
      COMMON /IOERR/IERR

        CHARACTER * 1     NULL
        INTEGER   * 2     ISMPLI(2)
        EQUIVALENCE       (ISMPLI(1),FSMPLI),(ISJIFP,FSJIFP)
        CHARACTER * 80    LINE
        CHARACTER * 4     CDATA
        PARAMETER         (NSIZE = 2000)
        DIMENSION         DATA(3,NSIZE)
        LOGICAL           DEBUG
        EQUIVALENCE       (FDATA,CDATA)

	NULL=CHAR(0)
 

C       SET GOOD ERROR RETURN
        NF = 0

C       CHECK WHETHER THERE IS ROOM IN THE FILE
        IF (NCNTRS .GE. MAXCNT) THEN
           WRITE(NOUT,*) '*** NO MORE ROOM IN CNT FILE'
           NF = 1
           RETURN

        ELSEIF (MARK .EQ. -2) THEN
C         NEW STYLE TEXT CONTOUR
          JDATA = 1
        ELSE
          JDATA = NDATA
        ENDIF

C*************************** DEBUG    
        DEBUG = .FALSE.
        IF (NDATA .LT. 6 .AND. ICSPR .EQ. 3) DEBUG = .TRUE.
C***************************************
        

C       CHECK WHETHER THE FILE IS ALREADY SCALED 
        IF (SCALE .EQ. 0.0) THEN
C          THE FILE IS NOT SCALED, SO UPDATE THE XMAX,XMIN,YMAX,YMIN VALUES

           DO  K1= 1,JDATA
              X2  = DATA(1,K1)
              Y2  = DATA(2,K1)
              IF (X2 .GT. XMAX) XMAX = X2
              IF (X2 .LT. XMIN) XMIN = X2
              IF (Y2 .GT. YMAX) YMAX = Y2
              IF (Y2 .LT. YMIN) YMIN = Y2
           ENDDO

        ELSE IF (NDATA .LT. 0) THEN


C           THE FILE AND THE DATA TO BE PUSHED INTO IT HAVE SAME SCALE
C           CHECK ALL DATA VALUES TO ENSURE THEY ARE WITHIN SCALING
C           RANGE (0-1)

C           RESET VALUE OF NDATA
            NDATA = 0 - NDATA 
            DO  K1=1,NDATA
               XVAL = DATA(1,K1)
               YVAL = DATA(2,K1)
        
               IF ((XVAL .LT. 0.0) .OR. (XVAL .GT. 1.0)) THEN
                  NF = 1
                  WRITE(NOUT,1011) XVAL
 1011             FORMAT(' ERROR: PUSHING X=',F8.1,' INTO SCALED'/)
                  RETURN
               ELSEIF ((YVAL .LT. 0.0) .OR. (YVAL .GT. 1.0)) THEN
                  NF = 1
                  WRITE(NOUT,1012) YVAL
 1012             FORMAT(' ERROR: PUSHING Y=',F8.1,' INTO SCALED'/)
                  RETURN
               ENDIF
            ENDDO

        ELSE  
C           THE FILE IS SCALED, CHECK THAT ALL DATA VALUES ARE
C           WITHIN RANGE, AND SCALE THEM
  
            SCALE1 = 1.0 / SCALE

            DO  K1=1,JDATA
              X2  = DATA(1,K1)
              Y2  = DATA(2,K1)

              IF ((X2 .LT. XMIN) .OR. (X2 .GT. XMAX) .OR.
     &            (Y2 .LT. YMIN) .OR. (Y2 .GT. YMAX)) THEN

                  NF = 2
C**      al       IT NEEDS TO RECOVER ORIGINAL DATA, RESET PREVIOUS
C**               POINTS ON THIS CONTOUR BEFORE LEAVING THIS SUBROUTINE
                  K1M1 = K1 - 1
                  DO  I= 1,K1M1
                     DATA(1,I) = DATA(1,I) * SCALE + XMIN
                     DATA(2,I) = DATA(2,I) * SCALE + YMIN
                  ENDDO
                  RETURN
              ENDIF

              DATA(1,K1) = (X2 - XMIN) * SCALE1
              DATA(2,K1) = (Y2 - YMIN) * SCALE1
            ENDDO
        ENDIF


C       READ THE MAXREC, IF MAXREC IS NOT LAST RECORD READ/WRITTEN
   66   IF (MAXREC .NE. LSRECD .AND. NCNTRS .GT. 0) THEN
           IERR = 0
           CALL REDLIN(LUN,CBUF,IRECLN,MAXREC-1)
           IF (IERR .NE. 0) THEN
               K1 = MAXREC - 1
               WRITE(NOUT,*)
     &             '*** IN CSPUSH, CNT REDLIN ERROR ON NREC: ',K1
           ENDIF 
        ENDIF

C       INITIALIZE THE STARTING RECORD POSITION   
        ISTREC = MAXREC
        ISTSUF = NDTSUF
        MAXSUF = IRECLN 
        J      = ISTSUF
        KDATA  = 1

        THREED = .FALSE.
        IF (IFRMCS .EQ. 4 .AND. (MARK .EQ. 1 .OR. MARK .EQ. 6))
     &      THREED = .TRUE.

 4001   IF (J .GT. MAXSUF) THEN
C           RECORD LENGTH WILL BE EXCEEDED. STORE THE CURRENT RECORD 
            MM1 = MAXREC - 1  
            CALL WRTLIN(LUN,CBUF,IRECLN,MM1)
            MAXREC = MAXREC + 1
            J = 1
         ENDIF

C         STORE DATA
          CBUF (J) = DATA(1,KDATA)
          J = J + 1

          IF (J .GT. MAXSUF) THEN
C           STORE THE CURRENT RECORD 
            MM1 = MAXREC - 1  
            CALL WRTLIN(LUN,CBUF,IRECLN,MM1)
            MAXREC = MAXREC + 1
            J = 1
          ENDIF
          CBUF (J) = DATA(2,KDATA)
          J = J + 1

          IF (THREED) THEN
C            3-D CONTOUR
             IF (J .GT. MAXSUF) THEN
C              STORE THE CURRENT RECORD 
               MM1 = MAXREC - 1  
               CALL WRTLIN(LUN,CBUF,IRECLN,MM1)
               MAXREC = MAXREC + 1
               J = 1
             ENDIF
             CBUF (J) = DATA(3,KDATA)
             J = J + 1
          ENDIF
          KDATA = KDATA + 1
          IF ( KDATA .LE. NDATA) GOTO 4001

C         UPDATE THE ENDING RECORD POSITIONS
 4101     LSTREC = MAXREC
          LSTSUF = J - 1

C         IF ISTFLG IS SET THEN STORE THE RECORD
          IF (ISTFLG .EQ. 1) THEN
             MM1 = MAXREC - 1
             CALL WRTLIN(LUN,CBUF,IRECLN,MM1)
          ENDIF

C         NOW UPDATE THE CONTROL RECORD, GET A CELL NO. FROM THE CONTROL ARRAY
          CALL CSGTBN('CONTRL',CONTRL,6,IMAXCT,ISTCON,LSTCON,NOBIN)

C         IF NOBIN < 0 THEN ERROR
          IF (NOBIN .LE. 0) THEN
             NF = 1
             WRITE(NOUT,103) NOBIN
  103        FORMAT(' *** UN-ACCEPTABLE BIN:',I5,' IN CSPUSH.')
             ICNTR = 0 
             RETURN
          ENDIF

          ICNTR = NOBIN
          CONTRL(1,NOBIN) = ISTREC
          CONTRL(2,NOBIN) = ISTSUF
          CONTRL(3,NOBIN) = LSTREC
          CONTRL(4,NOBIN) = LSTSUF

          IF (MARK .EQ. -2) THEN
C           NEW STYLE TEXT CONTOUR
            ISJIFP = -(ITANGL *1000000 + ITSIZE * 10000 + JUST * 1000 + 
     &               INTEN  * 100     + IFON   * 10    + IPEN)
            CONTRL(5,NOBIN) = FSJIFP

C ****************  DEBUG
C            IF (ICLOD .LT. 6) THEN
C              NCHAR = DATA(1,2)
C              FDATA = DATA(2,2)
C              D1    = DATA(1,1)
C              D2    = DATA(2,1)
C              WRITE(0,9115) D1,D2,NCHAR,CDATA
C9115          FORMAT(' CSPUSH; LOC,NCHAR,DATA: (',F7.2,',',F7.2,')',
C     &                  I5,':',A4,':')
C
C              IF((ISTSUF  ).LE.MAXSUF) D1 = CBUF(ISTSUF)
C              IF((ISTSUF+1).LE.MAXSUF) D2 = CBUF(ISTSUF+1)
C              IF((ISTSUF+2).LE.MAXSUF) NCHAR = CBUF(ISTSUF+2)
C              IF((ISTSUF+3).LE.MAXSUF) FDATA = CBUF(ISTSUF+3)
C
C              WRITE(0,915) D1,D2,NCHAR,CDATA
C915           FORMAT(' CSPUSH; LOCC,NCHAR,DATA:(',F7.2,',',F7.2,')',
C     &                  I5,':',A4,':')
C
C              WRITE(0,9140)ISTREC,ISTSUF,LSTREC,LSTSUF
C9140          FORMAT(' CSPUSH; 1REC,1SUF..LREC,LSUF:',2I5,'..',2I5)
C              WRITE(0,9977) NOBIN,MARK,ISJIFP
C9977          FORMAT(' CSPUSH; NOBIN,MARK,ISJIFP:',2I6,I10)
C              ICLOD = ICLOD + 1
C            ENDIF
C**********************************

          ELSE
C            CONSTRUCT MPT FROM MARK,IPEN,LINTP & INTEN
            MPT = LIMFIL * 100000 + ISHAP * 10000 + MARK * 1000 +
     &            IPEN * 100 + LINTP * 10 + INTEN
            IF (IFRMCS .EQ. 6 .AND. MARK .EQ. 2) THEN
C             THIS IS A TEXT CONTOUR SO STORE THE SYMBOL
              ISMPLI(1) = ISYMBL
              ISMPLI(2) = MPT
              CONTRL(5,NOBIN) = FSMPLI
            ELSE
              CONTRL(5,NOBIN) = MPT
            ENDIF
          ENDIF
          CONTRL(6,NOBIN) = ZCOO

C         UPDATE THE NDTSUF AND LSRECD FOR NEXT WRITE
          NDTSUF = J 

          IF (NDTSUF .GT. MAXSUF) THEN
C           RECORD LENGTH HAS BEEN EXCEEDED 
C           STORE THE CURRENT RECORD ONLY IF NOT STORED PREVIOUSLY
            IF (ISTFLG .EQ. 0) THEN
               MM1 = MAXREC - 1  
               CALL WRTLIN(LUN,CBUF,IRECLN,MM1)
            ENDIF

            MAXREC = MAXREC + 1
            NDTSUF = 1
         ENDIF

C         UPDATE THE CONTOUR COUNTER AND LAST RECORD READ
          NCNTRS = NCNTRS + 1
          LSRECD = MAXREC

      RETURN
      END
