
C++************************************************************************
C
C    CSRECV.FOR  -- CREATED DEC 84
C                   MODIFIED JULY 86 al
C                   ADAPTED FOR 3-D FEB 87 al
C                   ADAPTED FOR NEW TEXT CONTOUR FEB 88 al
C **************************************************************************
C *  AUTHOR: R. BANERJEE                                                   *
C *  COPYRIGHT (C)1984 , WADSWORTH CENTER FOR LABORATORIES AND             *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH  			   *
C **************************************************************************
C
C $$ CSRECV(LUN)
C
C    PURPOSE:  TO RECOVER UNSCALED CONTOUR DATA FROM A SCALED CONTOUR
C              FILE. DELETED CONTOUR OR TEXT ARE NOT RECOVERED.
C              THE FILE IS RETURNED TO UNSCALED STATUS AFTER THIS 
C              OPERATION.
C
C    PARAMETERS:
C        LUN            LOGICAL UNIT NUMBER TO BE ASSIGNED TO FILNAM.
C
C    VARIABLES: 
C        CBUF           FOR READING THE DATA
C        IRECLN         RECORD LENGTH
C
C    CALLS:             
C
C    CALLED BY:         SSPUSH
C
C--********************************************************************

	SUBROUTINE CSRECV(LUN)

        COMMON /UNITS/LUNDOC,NIN,NOUT
        INCLUDE 'CONSTG.INC'

C..     IF THE FILE IS NOT SCALED THEN RETURN
        IF (SCALE .EQ. 0.0) THEN
           WRITE(NOUT,*) 'FILE NOT SCALED. REQUEST IGNORED'
           RETURN
        ENDIF 

C..     SINCE FILE HAS BEEN SCALED ONCE, WE ONLY HAVE TO DO 1 PASS.
C..     FIRST PASS USE SCALE TO GET TO THE ORIGINAL X-VAL,Y-VAL
C..     THEN UPDATE THE XMAX,YMAX ETC.

        XMINPR = XMIN
        YMINPR = YMIN
        XMAX   = -9.99E20
        XMIN   = -XMAX
        YMAX   = XMAX
        YMIN   = XMIN
        DO 1001 K2 = 1, LSTCON

           ISTREC = CONTRL(1,K2)
           IF (ISTREC .GT. 0) THEN
C..           PROCESS EXISTING CONTOURS ONLY
              ISTSUF = CONTRL(2,K2)
              LSTREC = CONTRL(3,K2)
              LSTSUF = CONTRL(4,K2)

C*            DETERMINE IF THIS IS A TEXT OR 3-D CONTOUR 
              THREED = .FALSE.

C**JAN 93al              IF (IFRMCS .EQ. -6 .AND. CONTRL(5,ICNTR) .LT. 0.) THEN
              IF (IFRMCS .EQ. -6 .AND. CONTRL(5,K2) .LT. 0.) THEN
C                NEW STYLE TEXT CONTOUR, DATA 2... CONTAINS CHAR.
                 LSTREC = ISTREC
                 LSTSUF = ISTSUF

              ELSEIF (IFRMCS .EQ. 4) THEN
C                3-D CONTOUR CONTAINING FILE
                 MPT    = CONTRL(5,K2)
                 MARK = MOD(MPT/1000,10)
                 IF (MARK .EQ. 1 .OR. MARK .EQ. 6) THREED = .TRUE.
              ENDIF
              IRECD = ISTREC

C..           READ THE IRECD-TH REC, ONLY IF IT IS NOT THE LAST RECORD READ
              IF (LSRECD .NE. IRECD) THEN
C..               STORE THE BUFFER BEFORE READING ANOTHER RECORD
                  IRECM1 = LSRECD - 1
                  CALL WRTLIN(LUN,CBUF,IRECLN,IRECM1)
                  IRECM1 = IRECD - 1
                  CALL REDLIN(LUN,CBUF,IRECLN,IRECM1)
                  LSRECD = IRECD 
              ENDIF

              J = ISTSUF
 4001         CONTINUE
                 XDAT = CBUF(J) 
                 XDAT = XDAT * SCALE + XMINPR
                 CBUF(J)   = XDAT
C..              UPDATE THE VALUE OF XMAX, XMIN ETC.
                 IF (XDAT .GT. XMAX) XMAX = XDAT
                 IF (XDAT .LT. XMIN) XMIN = XDAT
                 IF (J .EQ. IRECLN) THEN
C..                 THE CBUFF IS COMPLETLY COPIED SO NEED TO READ ANOTHER ONE.
C..                 STORE THE BUFFER BEFORE READING ANOTHER RECORD
                    IRECM1 = IRECD - 1
                    CALL WRTLIN(LUN,CBUF,IRECLN,IRECM1)
                    IRECD = IRECD + 1
                    IRECM1 = IRECD - 1
                    CALL REDLIN(LUN,CBUF,IRECLN,IRECM1)
                    LSRECD = IRECD
                    IF (IRECD .GT. LSTREC) GOTO 1001
                    J = 0
                 ENDIF
                 J = J + 1

                 YDAT = CBUF(J)
                 YDAT = YDAT * SCALE + YMINPR
                 CBUF(J) = YDAT
                 IF (YDAT .GT. YMAX) YMAX = YDAT
                 IF (YDAT .LT. YMIN) YMIN = YDAT     
                 IF (J .EQ. IRECLN) THEN
C..                 THE CBUFF IS COMPLETLY COPIED SO NEED TO READ ANOTHER ONE.
C..                 STORE THE BUFFER BEFORE READING ANOTHER RECORD
                    IRECM1 = IRECD - 1
                    CALL WRTLIN(LUN,CBUF,IRECLN,IRECM1)
                    IRECD = IRECD + 1
                    IRECM1 = IRECD - 1
                    CALL REDLIN(LUN,CBUF,IRECLN,IRECM1)
                    LSRECD = IRECD
                    IF (IRECD .GT. LSTREC) GOTO 1001
                    J = 0
                 ENDIF
                 J = J + 1

                 IF (THREED) THEN
                   IF (J .EQ. IRECLN) THEN
C..                   THE CBUFF IS COMPLETLY COPIED SO READ ANOTHER ONE.
                      IF (LSTREC .GT. IRECD) THEN
C..                     STORE THE BUFFER BEFORE READING ANOTHER RECORD
                        IRECM1 = IRECD - 1
                        CALL WRTLIN(LUN,CBUF,IRECLN,IRECM1)
                        IRECD = IRECD + 1
                        IRECM1 = IRECD - 1
                        CALL REDLIN(LUN,CBUF,IRECLN,IRECM1)
                        LSRECD = IRECD
                        IF (IRECD .GT. LSTREC) GOTO 1001
                        J = 0
                      ENDIF
                   ENDIF
                   J = J + 1
                 ENDIF

C..              CHECK IF WE HAVE REACHED THE END OF CONTOUR DATA
                 IF ((IRECD .LT. LSTREC) .OR. 
     &               (J .LE. LSTSUF)) GOTO 4001
             ENDIF
 1001    CONTINUE

C..      STORE THE LAST RECORD READ TO BE SURE THAT THE DATA IS UPDATED
         IRECM1 = LSRECD - 1
         CALL WRTLIN(LUN,CBUF,IRECLN,IRECM1)

C..      COMPARE THE TEXT POSITIONS NOW
         DO J = 1,LSTTXT
            IF (TXTCTR(1,J) .GT. 0) THEN
C..            PROCESSING ONLY VALID TEXT
               XPOS = TXTCTR(4,J)
               YPOS = TXTCTR(5,J)
               XPOS = XPOS * SCALE + XMINPR
               YPOS = YPOS * SCALE + YMINPR
               TXTCTR(4,J) = XPOS
               TXTCTR(5,J) = YPOS
               IF (XPOS .GT. XMAX) XMAX = XPOS
               IF (XPOS .LT. XMIN) XMIN = XPOS
               IF (YPOS .GT. YMAX) YMAX = YPOS
               IF (YPOS .LT. YMIN) YMIN = YPOS
            ENDIF
	 ENDDO

C..     THE XMAX,XMIN, YMAX, YMIN ARE CORRECT AND FILE IS UNSCALED

        SCALE = 0.0
        WRITE(NOUT,*) 'ORIGINAL DATA RECOVERED'

      RETURN
      END


