
C***************************************************************************
C
C    CSTRAP.FOR  -- CREATED MAY 87
C
C **************************************************************************
C *  AUTHOR: ARDEAN LEITH                                                  *
C *  COPYRIGHT (C)1987 , WADSWORTH CENTER FOR LABORATORIES AND             *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH  			   *
C **************************************************************************
C
C    CSTRAP(LUNCS)
C
C    PURPOSE:  PUT ALL VOLATILE DATA INTO CNT FILE SO IT CAN
C              NOT BE LOST.  A MERGER OF CSCLOS,CSRDCT, AND CSOPEN
C
C    PARAMETERS:  
C        LUNCS        LOGICAL UNIT NUMBER TO CONTOUR STORAGE FILE
C
C    VARIABLES:
C        CBUF         BUFFER FOR WRITING THE DATA (IN COMMON BLOCK)      
C        IRECLN       RECORD LENGTH. (COMMON BLOCK)
C
C--********************************************************************

	SUBROUTINE CSTRAP(LUNCS)

        INCLUDE 'CONSTG.INC'

        COMMON /UNITS/LUNDOC,NIN,NOUT,NECHO,IFOUND,NPROC,NDAT

        LOGICAL FILOPN

C       CHECK WHETHER THE FILE IS OPEN
        INQUIRE(UNIT=LUNCS,OPENED=FILOPN)
        IF (.NOT.(FILOPN)) RETURN

C       PUT VARIABLES INTO CBUF FOR THE FIRST RECORD OF CNT FILE
        CBUF(1)  = MAXCNT
        CBUF(2)  = MAXTXT
        CBUF(3)  = MAXREC
        CBUF(4)  = NDTSUF
        CBUF(5)  = NTXSUF
        CBUF(6)  = IFRMCS
        CBUF(7)  = SCALE
        CBUF(8)  = XMAX
        CBUF(9)  = XMIN
        CBUF(10) = YMAX
        CBUF(11) = YMIN
        CBUF(12) = ICOMP
        CBUF(13) = NDTCTL
        CBUF(14) = NCNTRS
        CBUF(15) = ISTCON
        CBUF(16) = LSTCON
        CBUF(17) = ISTTXT
        CBUF(18) = LSTTXT
        CBUF(19) = NTXT
        CBUF(20) = PIXPCM
        CBUF(21) = LENCOR
        CBUF(22) = LENCNT

        CALL WRTLIN(LUNCS,CBUF,IRECLN,0)

        IF (NTXT .GT. 0) THEN
C         TRANSFER TEXT CONTROL DATA TO RECORD NO 3
          J = 0
          DO  I = 1, MAXTXT
            DO  K = 1, 5
               J = J + 1
               CBUF(J) = TXTCTR(K,I)
            ENDDO
          ENDDO
          CALL WRTLIN(LUNCS,CBUF,IRECLN,2)
        ENDIF

C       TRANFER CONTOUR CONTROL DATA
C       TRANSFER RECORD NOS. 5 THRU NDTCTL + 4 FROM ARRAY  CONTRL
C       FIRST CALCULATE MAXIMUM VALID NUMBERS MAXSUF STORED IN ONE RECORD
C       THEN TRANSFER ONE RECORD AT A TIME AND COPY MAXSUF NUMBERS FROM 
C       THE CONTROL ARRAY TO THE FILE.

        NREC   = 4
        MAXSUF = IRECLN / 6
        MAXSUF = MAXSUF * 6
        J = 0
        DO  I = 1, MAXCNT
          DO  K = 1, 6
            J = J + 1
            IF (J .GT. MAXSUF) THEN 
               CALL WRTLIN(LUNCS,CBUF,IRECLN,NREC)
               NREC = NREC + 1
               J = 1
            ENDIF
            CBUF(J) = CONTRL(K,I)
          ENDDO
        ENDDO

        CALL WRTLIN(LUNCS,CBUF,IRECLN,NREC)
        LSRECD = NREC+1

      RETURN
      END

