#ifdef SP_DISTRIB
      SUBROUTINE CTFFIL
      COMMON /UNITS/LUNC,NIN,NOUT
      WRITE(NOUT,*) 'DUMMY CALL: CTFFIL'
      RETURN
      END
#else

C*******************************************************************
C  GENERATE A CTF FILTER
C*******************************************************************
	SUBROUTINE CTFFIL(IRTFLG)
#ifdef SP_UNIX
        INCLUDE 'CMBLOCK.INC'
#else
        INCLUDE 'COMMON1:CMBLOCK.INC'
#endif

	REAL LAMBDA,KS,KF
	DIMENSION F2(512)
        DATA PI/3.1415926535/
	CHARACTER OUTNAME*81,NULL

	NULL=CHAR(0)
	LUN2=10
	CALL RDPRMI(NSAM,NROW,NLOOP,ILOOP,'FILE DIM NSAM $')
	CALL RDPRM(SPMAX,NLOOP,ILOOP,'MAX. SP. FREQ. [A-1]  $')
	CALL RDPRM(X,NLOOP,ILOOP,'DEFOCUS [A] $')
	CALL RDPRM(A2,NLOOP,ILOOP,'AMPLITUDE CONTRAST [RAD] $')
	CALL RDPRM(LAMBDA,NLOOP,ILOOP,'WAVELENGTH [A] $')
	CALL RDPRM(CS,NLOOP,ILOOP,' SPHERICAL ABBERATION CS [MM] $')
	CS=CS*1.0E07
	KS=SPMAX/FLOAT(NSAM)
	GATE=0.08

	DO 1000 J=1,NSAM
	KF=FLOAT(J)*KS
	X1=PI*(0.5*CS*LAMBDA**3*KF**4-X*LAMBDA*KF**2)-A2
	F1=SIN(X1)
	IF (F1 .GT. GATE) THEN
	   F2(J)=-1
	ELSE
	IF (F1 .LT. -1.*GATE) THEN
	F2(J)=1
	ELSE
	F2(J)=0
	ENDIF
	ENDIF
1000	CONTINUE
	CALL FILERD(OUTNAME,NLET,NULL,'FILTER',IRTFLG)
	CALL OPENF(OUTNAME,LUN2,NSAM,1,'UNKNOWN',NF,1)
	CALL WRTLIN(LUN2,F2,NSAM,1)
	CLOSE(LUN2)
	RETURN
        END
#endif
