
C   KNOWN BUG: IF YOU ASK FOR AXES IT FOULS UP SCALING !!!!1

C++*************************************************************************
C
C   D3DPLT.FOR
C
C **************************************************************************
C *  AUTHOR:  ArDean Leith                                                 *
C *  PART OF SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK    *
C *  COPYRIGHT (C)1987 , WADSWORTH CENTER FOR LABORATORIES AND             *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH 			   *
C **************************************************************************
C
C    D3DPLT(FILNM,LUN,NSAM,NROW,MAXDIM)
C
C    PURPOSE:       THIS SUBROUTINE MAKES A PERSPECTIVE THREE-
C                   DIMENSIONAL PLOT WITH HIDDEN LINES REMOVED.
C
C    PARAMETERS:    IMFILE   IMAGE FILE NAME
C                   EXTEN    EXTENSION FOR CNT FILE
C                   LUN      LOGICAL UNIT NUMBER OF IMAGE FILE
C                   NSAM     NUMBER OF SAMPLES PER ROW
C                   NROW     NUMBER OF ROWS
C                   MAXDIM   MAXIMUM BUFFER SPACE
C
C--*******************************************************************

      SUBROUTINE D3DPLT(EXTEN,LUN,NSAM,NROW,NSLICE,MAXDIMT)

      COMMON BDUM(6000),BUF(1)

      COMMON/UNITS/LUNC,NIN,NOUT,NECHO,IFOUND,NPROC,NDAT
      COMMON /MASTER/ NSAMC,NROWC,IREC,NLABEL,IFORM,IMAMI,FMAX,FMIN,
     1  AV,SIG,IHIST
  
      INCLUDE 'CONSTG.INC'

      CHARACTER *(*) EXTEN
      CHARACTER * 81 CSFILE
      CHARACTER * 8  DISP
      CHARACTER * 4  ANSW
      CHARACTER * 1  NULL
      LOGICAL        PLOTNG
       
      DATA     XMINT/0./,XLNTH/-6./,YLNTH/-2.0/

      NULL   = CHAR(0)

      MAXDIM = MAXDIMT - 10000
      IF (MAXDIM .GT. 8000000) MAXDIM = 8000000
 
C     SET ICSPR TO AVOID FILE OPENING DETAILS PRINTOUT
      ICSPR  = -2
C     SET NON-SERIAL SECTION FLAG
      SERSEC = .FALSE.
      LABAH  = .TRUE.

C     CNT FILE DISPLAY OUTPUT UNIT
      LUNCS  = 11

401   DISP   = 'UNK'
      MAXCNT = 4500
      IF (MAXCNT .GE. IMAXCT) MAXCNT = IMAXCT - 1

C     OPEN A CNT FILE FOR OUTPUT
      CALL CNFILE(CSFILE,NLETC,'CONTOUR',DISP,EXTEN,LUNCS,IRT)
      IF (IRT .EQ. -1) RETURN
       
      IERR = 0
      DO  I = 1,MAXDIM - 7000
        BUF(I) = .99
      ENDDO

      NSAM2  = NSAM + 2
      NGOP   = 0
      NG1OP  = -3
      N1     = -NSAM
      SCLMAX = ABS(YLNTH)
      XMAXT  = NSAM

      NSKIP = 1
1000  CALL RDPRIS(NSKIP,IDUM,NLOOP,ILOOP,
     &   'ENTER SKIPPING FACTOR OR <CR> FOR NO SKIP',IRTFLG)
      IF (IRTFLG .EQ. -1) RETURN

      SCALFC = 1
1002  CALL RDPRM2S(SCALFC,-1,NLOOP,ILOOP,
     &   'ENTER SCALE FACTOR OR <CR> FOR NO SCALING',IRTFLG)
      IF (IRTFLG .EQ. -1) GOTO 1000

      SCLMAX = SCLMAX*SCALFC

C     SUBTRACT FROM MAXDIM, BUFFER SPACE FOR THE X AND Y ARRAYS.
C     THEN, DIVIDE REMAINING CORE INTO SIX PARTS.
C     THE ADDITIONAL '80' IS DUE TO AN EXTRA 40 BUFFER SPACES
C     FOUND AT THE END OF ARRAYS XG AND G.

200   NRES2 = (MAXDIM + 80 - 2 * NSAM2) / 6
      NRES  = NRES2 - 2
      NX    = 1 + NSAM2
      NXG   = NX + NSAM2
      NG    = NXG + NRES2 - 40
      NXH   = NG + NRES2 - 40
      NH    = NXH + NRES2
      NXG1  = NH + NRES2
      NG1   = NXG1 + NRES2

C     BUF(1)    CORRESPONDS TO Y.
C     BUF(NX)   CORRESPONDS TO X.
C     BUF(NXG)  CORRESPONDS TO XG.
C     BUF(NG)   CORRESPONDS TO G.
C     BUF(NXH)  CORRESPONDS TO XH.
C     BUF(NH)   CORRESPONDS TO H.
C     BUF(NXG1) CORRESPONDS TO XG1.
C     BUF(NG1)  CORRESPONDS TO G1.

C     INSERT X-COORDINATES.
      DO  I = NX,NX+NSAM
        BUF(I) =I-NX
      ENDDO

      PLOTNG = .FALSE.
1022  CALL RDPRMC(ANSW,NC,.TRUE.,
     & 'DO YOU WANT A PLOT OF MINIMA ALSO? (N/Y)',NULL,IRTFLG)
      IF (IRTFLG .EQ. -1) GOTO 1002
      IF (ANSW(:1) .EQ. 'Y') PLOTNG = .TRUE.

      ANSW(:1) = 'N'
      CALL RDPRMC(ANSW,NC,.TRUE.,
     &   'DO YOU WANT A COORDINATE SYSTEM? (N/Y)',NULL,IRTFLG)
      IF (IRTFLG .EQ. -1) GOTO 1022
      IF (ANSW(:1) .EQ. 'Y') THEN
         ANSW(:1) = 'N'
         WRITE(NOUT,*) ' SORRY, COORDINATE SYTEM NOT AVAILABLE YET'
C**         XLNTH = ABS(XLNTH)
C**         YLNTH = ABS(YLNTH)
      ENDIF
      PXLNTH = ABS(XLNTH)
      PYLNTH = ABS(YLNTH)

C     SEARCH FOR MAX AND MIN IF NOT YET AVAILABLE.
      IF (IMAMI.EQ.0) CALL NORM3(LUN,NSAM,NROW,NSLICE,FMAX,FMIN,AV)

      DELTAX = FLOAT(NSAM) / ABS(XLNTH)
      DELTAY = (FMAX - FMIN) / SCLMAX
      IF(DELTAY .EQ. 0.0) THEN
        CALL ERRT(5,'D3DPLT',NE)
        GOTO 8888
      ENDIF

C     READ IN AND PLOT EVERY NSKIPTH ROW.

      DO  I = 1,NROW,NSKIP
        CALL REDLIN(LUN,BUF,NSAM,I)
        DO  K=1,NSAM
          BUF(K)=BUF(K)-FMIN
	ENDDO

        CALL DHIDE(BUF(NX),BUF(1),BUF(NXG),BUF(NG),BUF(NXH),
     1    BUF(NH),NGOP,NRES,NSAM,NROW/NSKIP,XLNTH,YLNTH,XMINT,DELTAX,
     2    FMIN,DELTAY,XMAXT,LUNCS)
        IF (NRES .LE. 0) THEN
          CALL ERRT(6,'D3DPLT',NE)
          GO TO 20
        ENDIF

        IF (PLOTNG) CALL DHIDE(BUF(NX),BUF(1),BUF(NXG1),BUF(NG1),
     &     BUF(NXH), BUF(NH),NG1OP,NRES,N1,0,XLNTH,YLNTH,XMINT,
     &     DELTAX,FMIN,DELTAY,XMAXT,LUNCS)

      ENDDO

20    WRITE(NOUT,9045) CSFILE(1:NLETC)
9045  FORMAT(/,' GRAPH PLACED IN: ',A,/)

C     SCALE THE META-FILE, IF ISERCH = 0 THEN SCALING IS DONE BY ONE PASS
      ISERCH = 0
      CALL CSSCALT(LUNCS,ISERCH)

C     CLOSE THE META-FILE 
      CALL CSTRAP(LUNCS)
8888  CLOSE(LUNCS)

      RETURN
      END

