
C++*********************************************************************
C
C DATTIMTIT.F   -- REMOVED FROM OPEN3.F
C
C **********************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK        *
C *  COPYRIGHT (C)1981,1987, WADSWORTH CENTER FOR LABORATORIES AND     *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.  *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS *
C *    OR USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN        *
C *    APPROVAL OF THE CENTER FOR LABORATORIES AND RESEARCH            *
C **********************************************************************
C
C    DATTIMTIT(BUF,DAT,TIM,TITL)
C
C    PURPOSE:       .
C
C    PARAMETERS:
C
C23456789 123456789 123456789 123456789 123456789 123456789 123456789 12
C--*********************************************************************

	SUBROUTINE DATTIMTIT(BUF,RECOVER,NEWDAT,LENTIT,IRTFLG)

        INCLUDE 'CMBLOCK.INC'
        INCLUDE 'LABLOCK.INC'
CNO_SAVE

        DIMENSION      BUF(1)
        CHARACTER * 1  NULL
        LOGICAL        RECOVER,NEWDAT
        DIMENSION      ZBUF(45)
        CHARACTER *180 CLINE
        EQUIVALENCE    (CLINE,ZBUF)

	NULL=CHAR(0)

        IF (RECOVER) THEN
C          RECOVER DATE, TIME & TITLE FROM CLINE

C          MOVE ALPHA-NUMERIC PART OF BUF TO ZBUF FOR CLINE ACCESS
           DO  I = 1,45 
              ZBUF(I) = BUF(I+211) 
           ENDDO

#if defined(__osf__) && defined(osf_ieee)
C          ALPHA OSF UNIX WITH IEEE TYPE DATA SPECIFIC CODE FOLLOWS
C          NOTE THAT ALPHA-NUMERICAL DATA (ABCD) WILL BE WRITTEN (DCBA)
           call FLIPBYTES(CLINE,180,IRTFLG)
C          END ALPHA OSF UNIX WITH IEEE TYPE DATA SPECIFIC CODE 
#endif 

C          READ DATE, TIME & TITLE FROM HEADER
           CDAT    = CLINE(1:9) // ' '
           CTIM    = CLINE(13:20) 
           CTIT    = CLINE(21:180)
           LENTIT  = MAX(0,(INDEX(CTIT,NULL)-1))

        ELSE
C          SET DATE, TIME & TITLE IN CLINE

C          PUT CURRENT DATE AND TIME INTO THIS IMAGE HEADER
           IF (NEWDAT) THEN
              CALL DATE(CDAT)
              CALL TIME(CTIM)
           ENDIF

C          DATE TAKES 2 & 1/4 FLOATING POINT VARIABLES IN BUF (9 CHAR)
           CLINE(1:12)  = CDAT(1:9) // '   '

C          TIME TAKES 2 FLOATING POINT VARIABLES IN BUF (8 CHAR.)
           CLINE(13:20) = CTIM(1:8)

C          TITLE TAKES 40 FLOATING POINT VARIABLES IN BUF (160 CHAR)
           CLINE(21:180) = CTIT(1:160)
           LENTIT        = lnblnk(CTIT)
           LOCNULL       = INDEX(CTIT,NULL)
           IF (LOCNULL .GT. 0 .AND. LOCNULL .LT. LENTIT) THEN
              LENTIT     = LOCNULL -1
           ENDIF

#if defined(__osf__) && defined(osf_ieee)    
C          ALPHA OSF UNIX WITH IEEE TYPE DATA SPECIFIC CODE FOLLOWS
           CALL FLIPBYTES(CLINE,180,IRTFLG)
c          END ALPHA OSF UNIX WITH IEEE TYPE DATA SPECIFIC CODE
#endif

C          COPY CLINE STUFF INTO BUF
           DO  I = 1,45 
              BUF(I+211) = ZBUF(I)
           ENDDO
        ENDIF
        IRTFLG = 0

        RETURN
	END


