
C++************************************************************************
C
C   DCHIST                                         I4 UPDATED FEB 88 al
C                                               AXIS ALTERED JULY 88 al
C                                             LONG FILE NAMES FEB 89 al
C **************************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.                             *
C *  COPYRIGHT (C)1981,1987, WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH 			   *
C **************************************************************************
C
C   DCHIST(DOCF1,LUN)
C
C   PURPOSE: CREATES HISTOGRAM CONTOUR FILE FROM A DOC FILE
C
C--*******************************************************************

	SUBROUTINE DCHIST(DOCF1,LUN)

        INCLUDE 'CMBLOCK.INC'
CNO_SAVE
        INCLUDE 'CONSTG.INC'

        PARAMETER (MAXREG=7)
        PARAMETER (MAXKEY=1500)
        PARAMETER (NSIZE = 2000)

	COMMON A(20),BUF(1500),IFREQ(660),DATA(3,NSIZE),
     $         DBUF(MAXREG,MAXKEY)

        CHARACTER*(*) DOCF1
	DIMENSION     PLIST(10)
        CHARACTER*80  CSFLNM
        CHARACTER*8   DISP
        CHARACTER*3   CSEXT

	NOPEN = 0
	NSW   = 1
        CALL RDPRMI(KEY1,KEY2,NLOOP,ILOOP,'FIRST & LAST KEY NUMBERS')
        IF (KEY2 .GT. MAXKEY) THEN 
           WRITE(NOUT,102)
102        FORMAT(' ENDING KEY TOO LARGE, YOU MIGHT CONSIDER',/
     &       ' TO ASK YOUR PROGRAMMER, IF HE MIGHT BE SO'/
     &       ' KIND TO CHANGE THE PARAMETERS IN DCHIST.F')
           RETURN
        ENDIF

	CALL RDPRMI(ICOL,IDUM,NLOOP,ILOOP,
     &             'COLUMN # IN DOC. FILE USED FOR HISTOGRAM')

        CALL RDPRM2(SXMIN,XINT,NLOOP,ILOOP,
     &             'STARTING X VALUE, INTERVAL')

97      CALL RDPRM2(SXMAX,FDUM,NLOOP,ILOOP,
     &             'X-RANGE (ENDING X VALUE)')

C       READ DOCUMENT FILE:

        IF (ICOL .GT. NREG) NREG=ICOL
        ILINE = 0
        DO  I=KEY1,KEY2
          CALL UNSDAL(DOCF1,NOPEN,NDOC,I,PLIST,NREG,
     $      DBUF,MAXKEY,MAXREG,NKEY,LERR)
	  NOPEN=1
          IF (LERR .EQ. 0) THEN
             ILINE       = ILINE + 1
cc             NKEY(ILINE) = I
             BUF(I)      = PLIST(ICOL)
          ENDIF
          WRITE(NOUT,101) (PLIST(II),II=1,NREG)
101       FORMAT(' ',7F12.6)
        ENDDO
        CLOSE(NDOC)

C       CALCULATE HISTOGRAM:

C       FIND NUMBER OF BINS
        FNBIN = (SXMAX - SXMIN) / XINT
        NBIN  = FNBIN
        IF (FLOAT(NBIN) .LT. FNBIN) NBIN = NBIN + 1
        NBIN  = MIN(660,NBIN)

        DO I = 1,NBIN
           IFREQ(I) = 0
        ENDDO

        MAXBIN = 0
        ICN  = 0
        ICM  = 0
        ICC  = 0
        DO L=KEY1,KEY2
          IDIV = INT((BUF(L) - SXMIN) / XINT) + 1
          IF (IDIV .LT. 0) THEN
            ICN=ICN+1
          ELSEIF (IDIV .GT. NBIN) THEN
            ICM=ICM+1
          ELSE
            ICC=ICC+1
            NFREQ = IFREQ(IDIV) + 1
            IF (NFREQ .GT. MAXBIN) MAXBIN = NFREQ
            IFREQ(IDIV) = NFREQ
          ENDIF
        ENDDO

        WRITE(NOUT,111) ICC,ICN,ICM
111     FORMAT(' VALUES USED IN HISTOGRAM: ',I4,
     $     ' VALUES OUTSIDE LOWER END: ',I4,' UPPER END: ',I4)
        WRITE(NOUT,113) 
113     FORMAT('0INTERVAL:',14X,'NUMBER IN INTERVAL')

        DO L=1,NBIN
          F1 = (L - 1) * XINT + SXMIN
          F2 = L * XINT + SXMIN
          WRITE (NOUT,11) F1,F2,IFREQ(L)
11        FORMAT(1X,F12.4,' TO ',F12.4,2X,I4)
        ENDDO


C       INITIALIZE CNT PLOT METAFILE PARAMETERS
C       CENTER TEXT
        JUST   = 1   
C       HORIZONTAL TEXT
        ITANGL = 0   
        IFON   = 0   
        IPEN   = 0   
        LINTP  = 0   
        ITSIZE = 24  

        ICSPR  = -3
        LABAH  = .TRUE.
C       REVERS = .FALSE.
        LUNCS  = 21
        MAXCNT = 1000
        MAXTXT = 1000
        ITFLG  = 0
        DISP   = 'UNK'
        IRECLN = 1080

        WRITE(CSEXT(1:3),8898) DATEXC(1:3)
8898    FORMAT(A3)

C       GET NAME OF METAFILE AND OPEN IT UP
        CALL CNFILE(CSFLNM,NLETC,'.PLOT FILE NAME',DISP,
     &     CSEXT,LUNCS,IRTFLG)
        IF ( IRTFLG .EQ. -1) GOTO 97

        SYMIN = 0.0
        SYMAX = MAXBIN
        CALL CSAXIS('Y',SYMIN,SYMAX,0.0,0.0,120.0,100.0,YFACTR,LUNCS,
     &              IRTFLG)
        CALL CSAXIS('X',SXMIN,SXMAX,0.0,0.0,120.0,100.0,XFACTR,LUNCS,
     &              IRTFLG)

C       TRANSFER DATA FOR PLOT:

        X     = 0.0
        XPLUS = XINT  * XFACTR
        DO  L=1,NBIN
          KK = (L-1) * 3 + 1
          Y  = IFREQ(L) * YFACTR
          DATA(1,KK) = X 
          DATA(2,KK) = Y

          X = X + XPLUS
          DATA(1,KK+1) = X
          DATA(2,KK+1) = Y

          DATA(1,KK+2) = X
          DATA(2,KK+2) = 0.0
        ENDDO

        NDATA = 3 * NBIN
        CALL CSPUSH(LUNCS,DATA,NDATA,NF,1,ICNTR)

900     ISERCH = 0
        CALL CSSCALT(LUNCS,ISERCH)
        CALL CSTRAP(LUNCS)

        CLOSE(LUNCS)

        WRITE(NOUT,9045) CSFLNM(1:NLETC)
9045    FORMAT(/,' GRAPH PLACED IN: ',A)

        RETURN
        END

C**************************** NOT NEEDED
C       ADD DUMMY CHAR AT LOWER LEFT TO HELP SCALING OF TEXT ON AXIS
C        XPOS = -24.0
C        YPOS = -12.0
C        LABEL(1:1) = ' '
C        CALL CSPSTX(LABEL,1,LUNCS,NF,1,ITEXT)
C***************************************************
