C++************************************************************************
C
C  DEFO003.F
C
C **************************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK            *
C *  COPYRIGHT (C)1981,1987, WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *  THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR       *
C *  LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR    *
C *  USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF     *
C *  THE CENTER FOR LABORATORIES AND RESEARCH   			   *
C **************************************************************************
C     DEFO003(INUM,N,KFR,A,NSAM,SPMAX,LUN1,IRTFLG)
C
C  PURPOSE: SEARCH THE MINIMUM
C
C  PARAMETERS:
C     INUM  : POSITION OF THE IMAGE IN THE SERIES
C     N     : NUMBER OF MINIMUM
C     KFR   : ARRAY OF SP. FREQ. POINTS OF MINIMUM
C     NSAM  : DIMENSION OF IMAGE
C     SPMAX : MAX. OF SP. FREQUENCE
C     LUN1:
C     IRTLFG:
C	
C23456789012345678901234567890123456789012345678901234567890123456789012
C--************************************************************************

	SUBROUTINE DEFO003(INUM,N,KFR,A,NSAM,SPMAX,LUN1,IRTFLG)

        INCLUDE 'CMBLOCK.INC' 

	DIMENSION A(*),B(20)
	REAL      KFR(*)

	CHARACTER*81   IMFILE
	COMMON /IMFILE/IMFILE

        COMMON BUF(1)

	CHARACTER *1 CHO,NULL
	LOGICAL      FLAG
	NULL=CHAR(0)
	FLAG = .TRUE.
        MAXIM = 0
	CALL OPFIL(.TRUE.,IMFILE,LUN1,'O',NSAM,NROW,NSLICE,
     &             MAXIM,'IMAGE', .FALSE.,IRTFLG)
	IF (IRTFLG .NE. 0) RETURN

	WRITE(NOUT,10)NSAM,NROW
10	FORMAT(' FILE"S DIMENSION:', I5,' X',I5)
	IF (INUM .EQ. 1) THEN
	   CALL RDPRM(SPMAX,NLOOP,ILOOP,'MAXIMUM SP. FREQ [A-1]')
	ENDIF
20	WRITE(NOUT,25)
25	FORMAT(' SEARCHING FOR MINIMA')
	CALL RDPRMI(NEIB,NDUM,NLOOP,ILOOP,
     &            ' SEARCH NEIGHBOUR AREA[POINT]')
	NLIST=1
	CALL REDLIN(LUN1,BUF,NSAM,NLIST)
        SC=SPMAX/FLOAT(NSAM)
	ICOUNT=0
	DO I=1,NSAM-1
	   BX=BUF(I)
	   IF (BX .LT. BUF(I+1)) THEN
	   DO J=I,I-NEIB,-1
              IF(BX .GT. BUF(J)) THEN
	      FLAG=.FALSE.
	   ENDIF
        ENDDO
	DO J=I,I+NEIB
           IF(BX .GT. BUF(J)) THEN
	      FLAG=.FALSE.
	   ENDIF
	ENDDO
        IF (FLAG) THEN
	  ICOUNT=ICOUNT+1
C   FIT INTO PARABOLIC
C   Y=A1+A2*X+A3*X**2
C   A3=[(Y1-Y3)(X2-X3)-(Y2-Y3)(X1-X3)]/[(X1^2-X3^2)(X2-X3)-(X2^2-X3^2)(X1-X3)]
C   A2=[(Y1-Y3)(X2^2-X3^2)-(Y2-Y3)(X1^2-X3^2)]/[(X1-X3)(X2^2-X3^2)-(X2-X3)
C      *(X1^2-X3^2)]
C   A1=[(Y1X3^2-Y3X1^2)(X2X3^2-X3X2^2)-(Y2X3^2-Y3X2^2)(X1X3^2-X3X1^2)]/
C  [(X3^2-X1^2)(X2X3^2-X3X2^2)-(X3^2-X2^2)(X1X3^2-X3X1^2)]
C   XMIN=-0.5A2/A3
C   YMIN=A1-0.25A2^2/A3

	X1=FLOAT(I-1)
	X2=FLOAT(I)
	X3=FLOAT(I+1)
	Y1=BUF(I-1)
	Y2=BUF(I)
	Y3=BUF(I+1)
	A1=((Y1*X3**2-Y3*X1**2)*(X2*X3**2-X3*X2**2)-
     &     (Y2*X3**2-Y3*X2**2)*
     &  (X1*X3**2-X3*X1**2))
	A1=A1/((X3**2-X1**2)*(X2*X3**2-X3*X2**2)-(X3**2-X2**2)*
     &  (X1*X3**2-X3*
     &  X1**2))
        A2=((Y1-Y3)*(X2**2-X3**2)-(Y2-Y3)*(X1**2-X3**2))
	A2=A2/((X1-X3)*(X2**2-X3**2)-(X2-X3)*(X1**2-X3**2))
        A3=((Y1-Y3)*(X2-X3)-(Y2-Y3)*(X1-X3))
	A3=A3/((X1**2-X3**2)*(X2-X3)-(X2**2-X3**2)*(X1-X3))
	A(ICOUNT)=A1-0.25*A2**2/A3
	     KFR(ICOUNT)=-0.5*A2/A3
	  ELSE
	     FLAG=.TRUE.
	  ENDIF	
	ENDIF
	ENDDO

	WRITE(NOUT,50)
50	FORMAT(' IMAGE HAS FOLLOWING MINIMA')
	N=ICOUNT
	DO I=1,ICOUNT
C	   B(I)=ABS(FLOAT(KFR(I)))*SC
	   B(I)=ABS(KFR(I))*SC
	   WRITE(NOUT,*) '#',I,KFR(I),B(I),'(A-1)','   A=',A(I)
	ENDDO
	CALL RDPRMC(CHO,NC,.TRUE.,' CHANGE SEARCHING NEIGHBOUR (Y/N)',
     &              NULL,IRT)
	IF (CHO .EQ. 'Y' .OR. CHO .EQ. 'y') GOTO 20

	CLOSE(LUN1)
	IRTFLG = 0

	RETURN
	END
