C++*******************************************************************
C
C DEFOCUS.FOR
C
C **************************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK            *
C *  COPYRIGHT (C)1981,1987, WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH                            *
C **************************************************************************
C
C   DEFOCUS(IRTFLG)
C
C   PURPOSE:  CALCULATE THE DEFOCUS AND AMPLITUDE CONTRAST COMPONENT 
C             USING LEAST SQUARES METHOD
C
C   PARAMETERS:
C      KFR : ARRAY OF ALL THE MINIMUM FOR ONE IMAGE
C      A : AMPLITUDE OF ALL MINIMA      
C      NP : NUMBER OF MINIMUS CHOSEN FOR EACH IMAGE
C      KP : ARRAY OF SP. FREQ. POINTS OF MINIMUS
C      NA : ARRAY OF ABBERATION COORESPONDING TO EACH MINIMUS
C      NUM : NUMBER OF IMAGE IN THE SERIES
C
C--*******************************************************************

        SUBROUTINE DEFOCUS(IRTFLG)

        INCLUDE 'CMBLOCK.INC'
CNO_SAVE        

        REAL    KFR,KP,NA
        COMMON /COMMUN/KFR(20),A(20),NP(20), KP(20,20),NA(20,20)
 
        CHARACTER*1 NULL

        NULL=CHAR(0)
        IRTFLG=0
        LUN1=8
        CALL RDPRMI(NUM,NDUM,NLOOP,ILOOP,
     $            'HOW MANY IMAGES IN THE SERIES')

        WRITE(NOUT,*)' INPUT IMAGE IN SEQUENCE'
        DO  I=1,NUM
           WRITE(NOUT,*)'# ',I,'   IMAGE'
           CALL DEFO003(I,N,KFR,A,NSAM,SPMAX,LUN1,IRTFLG)
           IF (IRTFLG .NE. 0) RETURN
           CALL RDPRMI(NP(I),NDUM,NLOOP,ILOOP,
     $            'HOW MANY POINTS DO YOU WANT?')
           IF (NUM .EQ. 1 .AND. NP(1) .EQ. 0) RETURN
           DO  J=1,NP(I)
              WRITE(NOUT,8)J
8             FORMAT(' POINT #',I2)
              CALL RDPRM2(KP(I,J),NA(I,J),NLOOP,ILOOP,
     &           'SP. FREQ. POINTS/ABBERATION(PI)')
        
	   ENDDO
	ENDDO
        IF (NUM .GT. 1) THEN
           WRITE(NOUT,*) ' ENTER CONSTRAINTS: '
           WRITE(NOUT,*) '           (1) SAME AMPLITUDE,'
           WRITE(NOUT,*)
     $     '           (2) SAME AMPLITUDE AND DEFINE DEFOCUS INTERVAL,'
           WRITE(NOUT,*) '           (3) SAME DEFOCUS'     
           CALL RDPRMI(NCONSTRAIN, NDUM,NLOOP,ILOOP,
     $        'CONSTRAINTS: (1), (2) OR (3)')
           IF (NCONSTRAIN .EQ. 3) THEN
              WRITE(*,*) '***NO PROGRAM NOW'
              CALL ERRT(100,'DEFOCUS',NE)
              RETURN
           ELSEIF (NCONSTRAIN .EQ. 2) THEN
              CALL DEFO001(NUM,NP,KP,NA,NSAM,SPMAX)
           ELSE
              IF (NUM .GT. 11) THEN
                 CALL DEFO2001(NUM,NP,KP,NA,NSAM,SPMAX)
              ELSE
                 CALL DEFO1001(NUM,NP,KP,NA,NSAM,SPMAX)
              ENDIF
           ENDIF
        ELSE
C	   SINGLE INPUT FILE CASE
           CALL DEFO1001(NUM,NP,KP,NA,NSAM,SPMAX)
        ENDIF

        RETURN
        END
