C++*************************************************************************
C
C    DELETF.FOR     REMOVED AND ALTERED CODE FROM UTIL1 DEC 88 al
C **************************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK            *
C *  COPYRIGHT (C)1981,1987, WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH 			   *
C **************************************************************************
C
C    DELETF(FILNAM,LUN)
C
C    PARAMETERS:     FILNAM    CHAR. VARIABLE FOR FILENAME (EMPTY)
C                    LUN       UNIT FOR FILE OPENING
C
C    PURPOSE:        DELETE SPIDER FILE(S)
C
C **************************************************************************

        SUBROUTINE DELETF(FILNAM,LUN)

        INCLUDE 'CMBLOCK.INC'
CNO_SAVE

        COMMON  BUF(1)

        CHARACTER *(*) FILNAM
        CHARACTER *81  FILN
        CHARACTER *6   PROMPT
        CHARACTER *5   PROMPTS
        CHARACTER *8   FMT2
        CHARACTER *5   FMT
        CHARACTER *1   NULL

        LOGICAL        GOTIMAGE,ISDIGI

        DATA FMT    /'(I  )'/
        DATA FMT2   /'(I  .  )'/
        DATA PROMPT /'DELETE'/
        DATA PROMPTS/'FIRST'/

        NULL = CHAR(0)

200     IF (FCHAR(4:4) .EQ. 'A') THEN
           WRITE(NOUT,903) 
903        FORMAT(/,' WARNING, YOU ARE DELETING WHOLE FILE SERIES!'/)
           CALL FILERD(FILNAM,NLET,NULL,PROMPTS,IRTFLG)
           IF (IRTFLG .NE. 0 .OR. FILNAM(1:1) .EQ. '*') RETURN

C          MULTIPLE FILE DELETION
           IDIG = 0

           DO  I=NLET,1,-1
             IF (FILNAM(I:I) .LT. '0' .OR. FILNAM(I:I) .GT. '9')GOTO 11
             IDIG = IDIG + 1
           ENDDO
           GOTO 999

C          PRESERVE I INDEX FOR USE BELOW!
11         WRITE(FMT(3:4),8000,ERR=999) IDIG
           FMT2(3:4) = FMT(3:4)
           FMT2(6:7) = FMT(3:4)
8000       FORMAT(I2)
           READ(FILNAM(I+1:NLET),FMT,ERR=999) IFILE
           LASTFI = 10**IDIG - 1

        ELSE
           CALL FILERD(FILNAM,NLET,NULL,PROMPT,IRTFLG)
           IF (IRTFLG .NE. 0 .OR. FILNAM(1:1) .EQ. '*') RETURN
C          SINGLE FILE DELETION WANTED
           IFILE = 1
           LASTFI = 1
        ENDIF

        IFIRST = IFILE

        FILN  = FILNAM(1:NLET) // '.' // DATEXC(1:3) // NULL
        NLETA = NLET + 4

	NOFIND = 0

20      CONTINUE
        ILOC = INDEX(FILNAM,'@')      
        GOTIMAGE = (FILNAM(1:1) .EQ. '_' .AND. 
     &             ILOC .LT. NLET .AND. 
     &             ISDIGI(FILNAM(ILOC+1:ILOC+1)))

        IF (ILOC .GT. 0 .AND. GOTIMAGE) THEN
C          DELETE IMAGE IN A PLAIN (NOT-INLINED) IMAGE STACK
           MAXIM = 0
           CALL OPFIL(.FALSE.,FILNAM,LUN,'O',NSAM,NROW,NSLICE,
     &                MAXIM,' ',.TRUE.,IRTFLG)
           IF (IRTFLG .NE. 0)  RETURN

           CALL REDHED(LUN,BUF,17000,NSAM,0,IRTFLG)
C          SET UNUSED FLAG FOR THIS STACKED IMAGE
           BUF(25) = 0.0
           CALL WRTHED(LUN,BUF,NSAM,IRTFLG)
           IF (N_VERBOSE .EQ. 1) 
     &         WRITE(NOUT,*) 'DELETED STACKED IMAGE: ', FILNAM(1:NLET)
           RETURN

        ELSEIF (FILNAM(1:1) .EQ. '_') THEN
C          INLINED BUFFER DELETE WANTED, GET BUFFER NUMBER
           CALL INLNBUF(FILNAM,NLET,NUMBUF,IRTFLG)

C          FREE UP THE INLINE BUFFER (DEALLOCATES IF NECESSARY)
           CALL OPENINLN(LUN,NUMBUF,.TRUE.,0,0,.FALSE.,IRTFLG)

           IF (N_VERBOSE .EQ. 1 .AND. IRTFLG .EQ. 0)
     &        WRITE(NOUT,*) 'DELETED INLINE FILE: ',FILNAM(1:NLET)
           RETURN

        ELSE
C          DESTROY THE FILE          
           OPEN(LUN,FILE=FILN,STATUS='OLD',IOSTAT=IER)
           IF (IER .EQ. 0) CLOSE(LUN,STATUS='DELETE',IOSTAT=IER)
        ENDIF

        IF (IER .EQ. 0) THEN
           IF (N_VERBOSE .EQ. 1)WRITE(NOUT,*) 'DELETED: ',FILN(1:NLETA)
           NOFIND = 0
        
        ELSE
           WRITE(NOUT,*) 'NO SUCH FILE: ',FILN(1:NLETA)
           IF (IFILE .EQ. IFIRST) NOFIND = 10
           NOFIND = NOFIND + 1
        ENDIF

        IF (IFILE .LT. LASTFI .AND. NOFIND .LT. 10) THEN
C          DELETE NEXT FILE IN SERIES
           IFILE = IFILE + 1
           WRITE(FILN(I+1:NLET),FMT2,ERR=999) IFILE
           GOTO 20
        ENDIF
           
999     WRITE(NOUT,*) ' '
        END

CCC UNUSED ------------------
CCC          TWO UNIX SPECIFIC CODE LINES FOLLOW
CCC          LINE = '\rm ' // FILNAM
CCC          CALL CSVMS(LINE,JSTAT)
CCCendif
