C++*******************************************************************
C
C DENOV.FOR
C
C **************************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK            *
C *  COPYRIGHT (C)1981,1987, WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH 			   *
C **************************************************************************
C
C  DENOV(LUN1,LUN2,NSAM,NROW
C
C         LUN1    LOGICAL UNIT NUMBER OF FILE
C         LUN2    LOGICAL UNIT NUMBER OF FILE
C         NSAM    NUMBER OF SAMPLES
C         NROW    NUMBER OF ROWS
C         FMAX    MAXIMUM
C         FMIN    MINIMUM
C
C--*******************************************************************

	SUBROUTINE DENOV(LUN1,LUN2,NSAM,NROW,NSLICE)

	COMMON DARRAY(1)

        INCLUDE 'CMBLOCK.INC'

        IF (IMAMI.NE.1) CALL NORM3(LUN1,NSAM,NROW,NSLICE,FMAX,FMIN,AV)
        DIFF = FMAX - FMIN
        IF (DIFF .EQ. 0.0) THEN
           CALL ERRT(101,'ZERO DENSITY RANGE',NE)
           RETURN
        ENDIF

  	WRITE(NOUT,20)FMIN,FMAX,FMIN
20	FORMAT(' FMIN = ',G10.3,'  FMAX = ',G10.3, '  OFFSET = ',G10.3)
	CALL RDPRM(SCAL,NLOOP,ILOOP,'ENTER SCALING FACTOR')
	CALL RDPRM(OFFS,NLOOP,ILOOP,'ENTER OFFSET')
        OFF = FMIN + OFFS

	DO I=1,NROW*NSLICE
	   CALL REDLIN(LUN1,DARRAY,NSAM,I)
	   DO  K=1,NSAM
	      DARRAY(K)=AMOD((DARRAY(K)-OFF)*SCAL,DIFF)
	   ENDDO
	   CALL WRTLIN(LUN2,DARRAY,NSAM,I)
	ENDDO

	RETURN
	END
