C ++********************************************************************
C
C
C **********************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK        *
C *  COPYRIGHT (C)    , WADSWORTH CENTER FOR LABORATORIES AND          *
C *    RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201 *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS *
C *    OR USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN        *
C *    APPROVAL OF THE CENTER FOR LABORATORIES AND RESEARCH.           *
C **********************************************************************
C                                                                      *
C     SUBROUTINE TO CALCULATE THE INTERPOINT DISTANCES
C     OF THE 2-DIMENSIONAL VECTORS GIVEN IN XLO. THE
C     RESULT IS STORED IN THE UPPER RIGHT TRIANGLE OF
C     THE NXN MATRIX DIST. (N=NUMBER OF POINTS IN XLO )
C
C     M.RADERMACHER 13.OCT.82
C     UPDATED TO I4 6/88
C
C **********************************************************************

      SUBROUTINE DIST2D(XLO,N,DIST)

      COMMON /DIM1/MAXIM,MAXFAC,MAXLO,NDIST
      INTEGER MAXIM,MAXFAC,MAXLO,N
      DIMENSION DIST(1),XLO(MAXIM,MAXLO)

      IOFF=0
      DO  K=1,N-1
         IN=(K-1)*N-IOFF
         IOFF=IOFF+K
         DO  L=K+1,N
            IN=IN+1
            DIS=0.
            DO  LL=1,2
               D=XLO(K,LL)-XLO(L,LL)
               D=D*D
               DIS=DIS+D
	    ENDDO
            DIS=SQRT(DIS)
            DIST(IN)=DIS
	 ENDDO
      ENDDO


C     WRITE(6,10)((XLO(K,J),K=1,N),J=1,2)
C10   FORMAT(' ',<MIN(N,10)>E12.4)
C     WRITE(6,12)
C12   FORMAT('  DISTANCES:')
C     WRITE(6,11)((DIST(K),K=1,IN)
C11   FORMAT(' ',<MIN(N,10)>E12.4)

      RETURN
      END



