C ++********************************************************************
C
C
C **********************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK        *
C *  COPYRIGHT (C)    , WADSWORTH CENTER FOR LABORATORIES AND          *
C *    RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201 *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS *
C *    OR USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN        *
C *    APPROVAL OF THE CENTER FOR LABORATORIES AND RESEARCH.           *
C **********************************************************************
C                                                                      *
C     CHECK FOR EXACTLY EQUAL DATA VECTORS AND EXCLUDE THEM FROM 
C     FURTHER ANALYSIS. REORDER THE VECTORS.
C     HIDIM   ARRAY WITH DISTANCES
C     NF      NUMBER OF FACTORS (COMPONENTS) USED
C     NIM     NUMBER OF IMAGES
C     NAME    NAMES OF VECTORS
C     BUF     ONLY USED AS AUXILIARY BUFFER
C **********************************************************************

	SUBROUTINE DISTTST(HIDIM,NF,NIM,NAME,BUF,DMAX)

      INCLUDE 'CMBLOCK.INC'

      COMMON /DIM1/MAXIM,MAXFAC,MAXLO,NDIST
      DIMENSION BUF(MAXIM),HIDIM(MAXIM,MAXFAC)
      CHARACTER*4 NAME(MAXIM)
      CHARACTER *24  FMT1,FMT2

C                12 3456789012345 678901234
      DATA FMT1/'(''HIDIM BEFORE'',  F10.2)'/
      DATA FMT2/'(''HIDIM AFTER '',  F10.2)'/

        DMAX=0.
        CALL RDPRM(TH,NLOOP,ILOOP,'LOWER THRESHOLD FOR DISTANCES')
        IF (TH .EQ. 0) THEN
           WRITE(NOUT,*) ' DISTANCE THRESHOLD IS 0, NO RESORTING'
           RETURN
        ENDIF

C       CLEAR BUF
	DO  K=1,NIM
	BUF(K)=0.
	ENDDO

        ITEMP = MIN(NF,10)
        WRITE(FMT1(17:18),8000) ITEMP
8000    FORMAT(I2)
        WRITE(NDAT,FMT1) ((HIDIM(K,L),L=1,NF),K=1,NIM)

C       WRITE(NDAT,107) ((HIDIM(K,L),L=1,NF),K=1,NIM)
C107    FORMAT(' HIDIM BEFORE',<MIN(NF,10)>F10.2)

C  CHECK FOR IDENTICAL VECTORS, SET BUF(I) TO 1 WHERE IDENTITIES ARE FOUND
	DO  K=1,NIM-1
	DO 2 L=K+1,NIM
	IF(BUF(L).EQ.1) GOTO 2
        DIS=0.
	DO  I=1,NF
	D=HIDIM(K,I)-HIDIM(L,I)
	D=D*D
	DIS=DIS+D
	ENDDO
        DIS=SQRT(DIS)
        IF(DIS.GT.DMAX) DMAX=D
	IF(DIS.GT.TH) GOTO 2
	WRITE(NDAT,10) NAME(K),NAME(L)
10      FORMAT(' IMAGES ',A4,2X,A4,' IDENTICAL. SECOND REMOVED')
        BUF(L)=1.
2	CONTINUE
	ENDDO
	IZ=0

C   REORDER VERCTORS AND NAMES
	DO 4 K=1,NIM
	   IF(BUF(K).EQ.1) GOTO 4
	   IZ=IZ+1
           IF(NIM.EQ.0) WRITE(NOUT,*)NIM
	   DO  I=1,NF
              IF(NIM.EQ.0) WRITE(NOUT,*)NIM
              HIDIM(IZ,I)=HIDIM(K,I)
              IF(NIM.EQ.0) WRITE(NOUT,*)NIM
	   ENDDO
           NAME(IZ)=NAME(K)
4       CONTINUE
	NIM=IZ

        WRITE(FMT2(17:18),8000) ITEMP
        WRITE(NDAT,FMT2) ((HIDIM(K,L),L=1,NF),K=1,NIM)

C       WRITE(NDAT,108) ((HIDIM(K,L),L=1,NF),K=1,NIM)
C108    FORMAT(' HIDIM AFTER',<MIN(NF,10)>F10.2)

	RETURN
	END

