
C++*************************************************************************
C
C DOCCOM.F                 REMOVED FROM UNSDAL.F SEPT 96 AL
C
C **************************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK            *
C *  COPYRIGHT (C)1981,1987, WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH 			   *
C **************************************************************************
C
C  DOCCOM(DOCNAM,NDOC,IKEY,PLIST,NLIST,LERR)
C
C  PURPOSE:  RECOVERS LINE OF REGISTERS FROM  A COMMENT KEY LINE 
C
C  PARAMETERS:
C         DOCNAM        DOC. FILE NAME INCLUDING EXTENSION        (SENT)
C         NDOC          LOGICAL UNIT FOR DOC FILE                 (SENT)
C         IKEY          KEY FOR LINE OF REGISTERS RETURNED 
C                           IN PLIST                              (SENT)
C         PLIST         ARRAY TO HOLD OUTPUT FROM KEY IKEY    (RETURNED)
C         NLIST         NUMBER OF REGISTERS TO BE RETRIEVED 
C                       FROM THE LINE (1ST VALUE RETRIEVED ON 
C                       EACH LINE IS NOT A REGISTER)              (SENT)
C         IRTFLG        ERROR FLAG (O IS NORMAL RETURN)       (RETURNED)
C
C  TYPICAL DOC COMMENT KEY FILE LINE:
C        KEY #REGS/LINE    VALUES ........
C  COL: 123456789 123456789 123456789 123456789 123456789 1234565789
C        ; COMMENT KEY LINE FOLLOWS
C        ; 1 4   20.070000   17.379999   17.379999   17.379999
C
C--********************************************************************

        SUBROUTINE DOCCOM(DOCNAM,NDOC,IKEY,PLIST,NLIST,IRTFLG)

	INCLUDE 'CMBLOCK.INC' 
CNO_SAVE

	DIMENSION       PLIST(*)
	CHARACTER *(*)  DOCNAM
        CHARACTER *80   RECLIN
	LOGICAL         NEWFILE

C       RECORD NO-PRINT FLAG
        NPR = IRTFLG

C       SET ERROR RETURN FLAG
	IRTFLG = 1

	IF (NLIST .LE. 0) THEN
	   WRITE(NOUT,*) '*** NUMBER OF REGISTERS NOT SPECIFIED'
           CALL ERRT(100,'RDDOCA2Q',NE)
	   RETURN
        ELSEIF (IKEY .GT. 0) THEN
C          DO NOT  DESIRE A COMMENTED KEY
	   WRITE(NOUT,*) '*** DID NOT REQUEST COMMENT KEY'
           CALL ERRT(100,'RDDOCA2Q',NE)
	   RETURN
        ELSEIF (IKEY .LT. -999) THEN
	   WRITE(NOUT,*) '*** ILLEGAL COMMENT KEY NUMBER: ',IKEY
           CALL ERRT(100,'RDDOCA2Q',NE)
	   RETURN
        ENDIF
        IKEYT = -IKEY

C       OPEN THE DOC FILE USING EXTENSION FROM DOCNAM
        CALL OPENDOC(DOCNAM,.FALSE.,NLET,NDOC,.FALSE.,
     &               .TRUE.,.TRUE.,.TRUE.,NEWFILE,NPR)
        IF (NPR .NE. 0) GOTO 999
 
C -------------------------------------------------------

C       READ NEXT LINE FROM DOC FILE
10	READ (NDOC,91,END=20) RECLIN
91      FORMAT(A80)

        IF (RECLIN(2:2) .EQ. ';')THEN
C          COMMENT LINE FOUND
           READ(RECLIN(3:80),92,IOSTAT=IERR) 
     &          KEYGOT,NREGPL,(PLIST(K),K=1,NREGPL)
92         FORMAT(I3,I2,6F12.6)

           IF (IERR .NE. 0) THEN
C             NOT A COMMENT KEY
	      GOTO 10

           ELSEIF (KEYGOT .EQ. IKEYT) THEN
C             DESIRED COMMENT KEY FOUND
              IRTFLG = 0
              CLOSE(NDOC)
              RETURN
            ENDIF
        ENDIF

C       READ NEXT LINE OF DOC FILE
	GOTO 10

C ---------------------------------------------------------------

C       END OF DOCUMENT FILE FOUND WITOUT COMMENT KEY

20      WRITE(NOUT,90) IKEYT
90	FORMAT(' *** COMMENT KEY: ',I3,' NOT FOUND')
        CALL ERRT(100,'RDDOCA2Q',NE)
        RETURN

999     CALL ERRT(100,'RDDOCA2Q',NE)
  	CLOSE(NDOC)

        RETURN
	END


