
C++*************************************************************************
C
C  DPROFD.FOR -- CREATED JAN 87
C                MODIFIED JUNE 87
C
C **************************************************************************
C *  AUTHOR:  A. LEITH                                                     *
C *  PART OF SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK    *
C *  COPYRIGHT (C)1987 , WADSWORTH CENTER FOR LABORATORIES AND             *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH 			   *
C **************************************************************************
C
C    DPROFD(DOFILE,NLETD,CSFILE,NLETC,DBUF,MAXREG,MAXKEY,NKEY,LUNCS)
C
C    PARAMETERS:
C         DOFILE    DOC FILE NAME
C         NLETD     NO. OF LETTERS IN DOC FILE NAME
C         CSFILE    CNT FILE NAME
C         NLETC     NO. OF LETTERS IN CNT FILE NAME
C         DBUF      ARRAY FOR DOC FILE CONTENTS
C         MAXREG    DIMENSION OF REGISTERS IN DOC FILE
C         MAXKEY    DIMENSION OF KEYS IN DOC FILE 
C         NKEY      NO. OF KEYS IN DOC FILE
C         LUNCS     OUTPUT UNIT FOR CNT FILE
C
C    PURPOSE:       PREPARES PLOT METAFILE FROM SELECTED COLUMNS OF A
C                   DOCUMENT FILE.
C
C    CALLS:         RDPRAI     RDPRIS    CSAXIS    CSPUSH    CSPSTX
C                   CSSCALT     CSTRAP
C
C    CALLED BY:     PLOT1
C
C--*******************************************************************

      SUBROUTINE DPROFD(DOFILE,NLETD,CSFILE,NLETC,DBUF,MAXREG,
     &                  MAXKEY,NKEY,LUNCS,IRTFLG)

      INCLUDE 'CONSTG.INC'
      INCLUDE 'CMBLOCK.INC'

      COMMON /POLY/  HOLES,REVERS
C     BE SURE THE BLANK COMMON HAS SPACE FOR DBUF AFTER DATA IN CALLER
      COMMON         DATA
      
      CHARACTER *(*) DOFILE,CSFILE
      CHARACTER * 80 LINE,LABEL
      CHARACTER * 1  NULL,TYPE
      CHARACTER * 4  FMT1

      PARAMETER      (NTOTL = 100)
      PARAMETER      (NSIZE = 2000)
      DIMENSION      DATA(3,NSIZE),DBUF(MAXREG,MAXKEY)
      DIMENSION      ILIST(NTOTL)
      INTEGER        IKEY
      LOGICAL        VSKEY,DEBUG,ERRI2
C                123456
      DATA FMT1/'(I )'/ 
     
      DATA MININT/-32768/,MAXINT/32767/,FLTMIN/-10E30/,FLTZER/10E-30/,
     &     FLTMAX/10E30/

      NTOTLN = NTOTL
      NULL   = CHAR(0)

      DEBUG  = .FALSE.

C     CALLING PGM. RECOVERS DATA FROM DOC FILE

   13   NLIST = 6
        WRITE(NOUT,99)
   99   FORMAT('0',
     &    'ASSIGN COLUMN(S) OF REGISTER(S) TO BE PLOTTED ON Y AXIS',
     &    ' AND THE COLUMN OF ',/,
     &    ' REGISTERS TO BE PLOTTED ON THE',
     &    ' X AXIS.  IF THE COLUMN FOR THE X AXIS IS ZERO,',/,
     &    ' THEN THE COLUMN OF REGISTERS IS PLOTTED VERSUS REGISTER ',
     &    'KEY.'/)

        NSW = 1
        CALL RDPRAI(ILIST,NTOTL,NLIST,1,6,
     &     'ENTER REGISTER NUMBER(S) FOR Y AXIS',NULL,IRTFLG)
        IF (IRTFLG .EQ. -1) RETURN

        IXREG = 1
   14   CALL RDPRIS(IXREG,IDUM,NLOOP,ILOOP,
     &     'ENTER REGISTER NUMBER FOR X AXIS',IRTFLG)
        IF (IRTFLG .EQ. -1) GOTO 13
        IF (ERRI2(IXREG,IDUM,1,0,MAXREG,IDUM,IDUM)) GOTO 14
        VSKEY = .FALSE.
        IF (IXREG .EQ. 0) VSKEY = .TRUE.

        IGO = 1
        ISTOP = NKEY
   15   CALL RDPRIS(IGO,ISTOP,NLOOP,ILOOP,
     &  'ENTER INITIAL AND FINAL KEY NUMBERS',IRTFLG)
        IF (IRTFLG .EQ. -1) GOTO 14
        IF (ERRI2(IGO,ISTOP,2,1,NKEY,IGO,NKEY)) GOTO 15
        
C       GO THRU ALL Y REGISTERS TO FIND SYMIN AND SYMAX
        SYMIN = FLTMAX
        SYMAX = FLTMIN
        DO 20 N = 1,NLIST
           IYREG = ILIST(N) + 1
           IK   = 1
   22      CONTINUE
              IF (IK .GT. NKEY) GOTO 20
              IKEY = DBUF(1,IK)
              IF (IKEY .GE. IGO) THEN
                IF (IKEY .GT. ISTOP) GOTO 20
                VAL = DBUF(IYREG,IK)
                IF (VAL .LT. SYMIN) SYMIN = VAL
                IF (VAL .GT. SYMAX) SYMAX = VAL
              ENDIF
              IK = IK + 1
            GOTO 22
   20   CONTINUE
   
        IF (VSKEY) THEN
           SXMIN = IGO
           SXMAX = ISTOP
        ELSE
C          GO THRU X REGISTER TO FIND SXMIN AND SXMAX
           SXMIN  = FLTMAX
           SXMAX  = FLTMIN
           IXREG  = IXREG + 1
           IK     = 1
   28      CONTINUE
              IF (IK .GT. NKEY) GOTO 30
              IKEY = DBUF(1,IK)
              IF (IKEY .GE. IGO) THEN
                IF (IKEY .GT. ISTOP) GOTO 30
                VAL = DBUF(IXREG,IK)
                IF (VAL .LT. SXMIN) SXMIN = VAL
                IF (VAL .GT. SXMAX) SXMAX = VAL
              ENDIF
              IK = IK + 1
            GOTO 28
        ENDIF
   30   CONTINUE


C       SET TEXT CHARACTARISTICS FOR AXES (IN COMMON)
        ITANGL = 0
        ITSIZE = 32
        JUST   = 0
        INTEN  = 9
        IFON   = 0
        IPEN   = 0

C       CALCULATE SCALING AND DRAW AXES
        TYPE = 'Y'
        CALL CSAXIS(TYPE,SYMIN,SYMAX,0.0,0.0,120.0,100.0,YFACTR,
     &                  LUNCS,IRTFLG)

        TYPE = 'X'
        CALL CSAXIS(TYPE,SXMIN,SXMAX,0.0,0.0,120.0,100.0,XFACTR,
     &                  LUNCS,IRTFLG)

C       GO THRU  REGISTERS AND PLOT CONTENTS

        DO  N = 1,NLIST
           IYREG = ILIST(N) + 1
           LINTP = MOD(N-1,10)
C**        IPEN  = MOD(N,10)
           IPEN  = 0
           NDATA = 0
           IK    = 1
   42      CONTINUE
              IF (IK .GT. NKEY) GOTO 46
              IKEY = DBUF(1,IK)
              IF (IKEY .GE. IGO) THEN
                IF (IKEY .GT. ISTOP) GOTO 46
                NDATA = NDATA + 1
                DATA(2,NDATA) = (DBUF(IYREG,IK) - SYMIN) * YFACTR
                IF (VSKEY) THEN
                   DATA(1,NDATA) = (IKEY - SXMIN) * XFACTR
                ELSE
                   DATA(1,NDATA) = (DBUF(IXREG,IK) - SXMIN) * XFACTR
                ENDIF
                IF (NDATA .GE. NSIZE) THEN
C                  ARRAY FULL
                   XLAST = DATA(1,NDATA)
                   YLAST = DATA(2,NDATA)
                   CALL CSPUSH(LUNCS,DATA,NDATA,NF,1,ICNTR)
                   DATA(1,1) = XLAST
                   DATA(2,1) = YLAST
                   NDATA = 1
                ENDIF
              ENDIF
              IK = IK + 1
           GOTO 42
   46      CONTINUE
           CALL CSPUSH(LUNCS,DATA,NDATA,NF,1,ICNTR)

   	ENDDO
C       SET TEXT CHARACTARISTICS AGAIN FOR LABEL
        ITANGL = 0
        ITSIZE = 32
        JUST   = 0
        INTEN  = 9
        IFON   = 0
        IPEN   = 0

C       ADD DUMMY CHAR AT LOWER RIGHT TO HELP SCALING OF TEXT ON LABEL
        XPOS = (SXMAX - SXMIN) * XFACTR + 4.0
        YPOS = -12.0
        LABEL(1:1) = ' '
        CALL CSPSTX(LABEL,1,LUNCS,NF,0,ITEXT)

C       ADD DUMMY CHAR AT LOWER LEFT TO HELP SCALING OF TEXT ON AXIS
        XPOS = -24.0
        YPOS = -12.0
        LABEL(1:1) = ' '
        CALL CSPSTX(LABEL,1,LUNCS,NF,1,ITEXT)

C       PUT CNT AND DOC FILENAME AT TOP
        NC = NLETC + NLETD + 12
        LINE = CSFILE(:NLETC) // '      '// DOFILE(:NLETD) // '      ' 

C       PUT UP TO 6 REG NUMBERS ON TOP OF PLOT
        IF (NLIST .EQ. 1) THEN
          LINE(NC+1:NC+5) = 'REG: '
          NC = NC + 5
        ELSE
          LINE(NC+1:NC+6) = 'REGS: '
          NC = NC + 6
        ENDIF

        DO  I = 1,NLIST
          L    = ILIST(I)
          LENT = MAX(4,NUMDIG(L,1))

C         WRITE Y REG NUMBER
          WRITE(FMT1(3:3),8009) L
8009      FORMAT(I1)
          WRITE(LINE(NC+1:NC+LENT),FMT1,ERR=60) L

C**       WRITE(LINE(NC+1:NC+LENT),8003,ERR=60) L
C**8003   FORMAT(I<LENT>)

          LINE(NC+LENT+1:NC+LENT+2) = ', '
          NC = NC + LENT + 2
   60     CONTINUE
       ENDDO
           

       LINE(NC-1:NC+2) = ' VS '
       IF (VSKEY) THEN
          LINE(NC+3:NC+5) = 'KEY'
          NC = NC + 5
       ELSE
          L    = IXREG - 1
          LENT = MAX(4,NUMDIG(L,1))

C         WRITE X REG NUMBER
          WRITE(FMT1(3:3),8009) L
	  WRITE(LINE(NC+1:NC+LENT),FMT1,ERR=9999) L
c--          WRITE(LINE(NC+1:NC+LENT),FMT1,ERR=60) L
C**       WRITE(LINE(NC+3:NC+LENT+2),8003,ERR=9999) L
          NC   = NC + LENT + 2
       ENDIF

       YPOS = 114.0
       XPOS = -2.0
       CALL CSPSTX(LINE,NC,LUNCS,NF,1,ITEXT)

 9999  CONTINUE

C..    SCALE THE META-FILE, IF ISERCH = 0 THEN SCALING IS DONE BY ONE PASS
       ISERCH = 0
       CALL CSSCALT(LUNCS,ISERCH)

C      STORE ALL CONTROL DATA
       CALL CSTRAP(LUNCS)

       WRITE(NOUT,9045) CSFILE
9045   FORMAT(/' GRAPH PLACED IN: ',A)

C..    CLOSE THE META-FILE 
       CLOSE(LUNCS)

      RETURN
      END


