
C++************************************************************************
C
C    DRIV1
C
C **************************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK            *
C *  COPYRIGHT (C)1981,1993, WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH 			   *
C **************************************************************************
C
C   DRIV1(MAXDIM)
C
C   PURPOSE:   A MAIN DRIVER FOR ROUTINES REMOVED FROM DRIVER IN MAR 93
C
C   PARAMETERS: MAXDIM     MAX LENGTH OF COMMON BUFFER
C
C23456789 123456789 123456789 123456789 123456789 123456789 123456789 12
C--*********************************************************************

        SUBROUTINE DRIV1(MAXDIM)

CNO_SAVE
        INCLUDE 'CMBLOCK.INC'

        CHARACTER *1   NULL,SWITCH,DINDEX
        COMMON /DRIV1_COM/ NUMREP,T1,DINDEX

        LOGICAL ONSUN,ONUNIX,ONSGI,ONOSF
        COMMON /OPSYS/ ONSUN,ONUNIX,ONSGI,ONOSF,MEMALLOCABLE

	PARAMETER      (NMENU=12)
        CHARACTER *2   MENU(NMENU)

        CHARACTER *81  FILNAM,DIRNAM,LINE
        CHARACTER *7   EXTEN
        DIMENSION      SAVE(103)
        INTEGER        HRS,MIN,SEC
        CHARACTER * 9  ENVVAR

        DATA ENVVAR/'SPMAN_DIR'/

        DATA MENU/'NC','VM','ME','CK','TM',
     &            'SR','RR','FR','PO','SA',
     &            'VO','MD'/

        NULL   = CHAR(0)

C       CARRY OUT THE OPERATION
        IFUNC = 0
        DO I = 1,NMENU
           IF (MENU(I)(1:2) .EQ. FCHAR(1:2)) THEN
              IFUNC = I
              GOTO 10
           ENDIF
        ENDDO
10      CONTINUE

        IF (IFUNC .LE. 0) RETURN

        GOTO  (  100,  200,   300,  400,  500,
     &           600,  700,   800,  900, 1000,
     &          1100, 1200), IFUNC

C      NEW FILE EXTENSION -- NEW EXTENSION ------------------------- NC
       CLOSE(NDAT)
C      GET THE PROJECT AND DATA EXTENSION
100    IRTFLG = -999
       CALL RDPRMC(EXTEN,NC,.TRUE.,'ENTER PROJECT/DATA EXTENSION',
     &             NULL,IRTFLG)

C      MAKE SURE PROJECT EXTENSION IS VALID
       IF (NC .LT. 3 .OR. IRTFLG .NE. 0) THEN
          WRITE(NOUT,*) '*** EXTENSION MUST BE 3 CHARACTERS'
          GOTO 100
       ENDIF

       PRJEXC(1:3) = EXTEN(1:3)

       IF (EXTEN(4:4) .NE. '/') THEN
          DATEXC(1:3) = PRJEXC(1:3)
       ELSE
          DATEXC(1:3) = EXTEN(5:7)
       ENDIF
       GOTO 5000


C      SYSTEM CALL ------------------------------------------------- VM
C      VMS SPAWN COMMANDS
200    CALL VMS
       GOTO 5000


C      MENU LISTING ------------------------------------------------ ME
C      MENU LISTING FROM MANUAL CHAPTER "ME.MAN"  ('ME')
300    CONTINUE

       IF (ONUNIX) THEN
C        READ IN THE ENVIRONMENT VARIABLE 'SPMAN_DIR'.
         CALL MYGETENV(ENVVAR,DIRNAM,NCHAR,
     &                 'DIR_CONTAINING_SPIDER_MANUALS',IRTFLG)
         IF (IRTFLG .NE. 0) GOTO 5000

C        SPMAN IS DEFINED OK
         LINE = DIRNAM(1:NCHAR) // '/me.man' // NULL
         CALL NUMENU(LINE,33,20,65,IRTFLG)
       ELSE
C        ON VAX NOW
         CALL NUMENU('SPMAN_DIR:ME.MAN',33,20,65,IRTFLG)
       ENDIF
       GOTO 5000

C      CHECKPOINT OPERATION ---------------------------------------- CK
C      WRITE OUT CURRENT OPERATION AND CURRENT ITERATION NUMBER.
400    IF (NTRACE.NE.0) THEN
          WRITE(ITI,9020) FCHAR(1:NALPH)
9020      FORMAT(1X,A)
          IF (IABSLP.NE.0) WRITE(ITI,9040) DINDEX,IABSLP
9040      FORMAT(1X,A,' = ',I4)
        ENDIF
	GOTO 5000

C       TIME OPERATION --------------------------------------------- TM
C       GET THE NUMBER OF SECONDS SINCE LAST TM, AND COMPUTE HOURS, 
C       MIN, & SEC
500     TIM  = SECNDS(T1)
	HRS  = INT(TIM/3600.)
	HOUR = HRS*3600.
	MIN  = INT((TIM-HOUR)/60.)
	SEC  = TIM-HOUR-MIN*60.

	WRITE(NDAT,9240)HRS,MIN,SEC
9240	FORMAT(' TIME: ',I2,' HOURS  ',I2,' MINUTES  ',I2,' SECONDS')
	GOTO 5000

C       SAVE REGISTERS --------------------------------------------- SR
600     CALL RDPRMC(SWITCH,NALPH,.TRUE.,'(S)AVE OR (U)NSAVE',NULL,IRT)
	IF (IRT .NE. 0 .OR. NALPH .EQ. 0) GOTO 600
	IF (SWITCH .EQ. 'S' .OR. SWITCH .EQ. 's') THEN
C          SAVE THE REGISTERS
	   DO I = 1, 103
	     SAVE(I) = PARAM(I)
           ENDDO

	ELSEIF (SWITCH .EQ. 'U' .OR. SWITCH .EQ. 'u') THEN
C          UNSAVE THE REGISTERS
	   DO I = 1, 103
	     PARAM(I) = SAVE(I)
           ENDDO

        ELSE
            WRITE(NOUT,*) '*** UNKNOWN SR OPTION'
            GOTO 600
        ENDIF
	GOTO 5000


C       READ REGISTER ---------------------------------------------- RR
700     CALL READRQ(FCHAR,NUMREP,ILOOP)
        GOTO 5000

C       FILE READ - READ IN A FILE NAME FOR BATCH RUNS ------------- FR
800     CALL FILERD(FILNAM,NLET1,NULL,'INPUT',IRTFLG)
        IF (FCHAR(4:4) .EQ. 'T') THEN
C          TEST OF FILENAME SUBSTITUTION MECHANISM
           IRTFLG = -999
           CALL RDPRMC(LINE,NLET2,.FALSE.,'CORRECT NAME',NULL,IRTFLG)
           IF (IRTFLG .EQ. 0 .AND. 
     &         FILNAM(1:NLET1) .NE. LINE(1:NLET2)) THEN
              WRITE(NOUT,*) '*** ERROR IN FILENAME FORMATION!!!'
              CALL ERRT(100,'DRIV1',NE)
           ENDIF
        ENDIF

	GOTO 5000

C       MAKE POEM (USUALLY DUMMIED OUT) ---------------------------- PO
900     CALL POEM
	GOTO 5000


C       SUM ALIGNMENTS -------------------------------------------- SA
1000    IF (FCHAR(4:4) .EQ. 'P') THEN
          CALL SUMALI(.TRUE.)
        ELSE
          CALL SUMALI(.FALSE.)
        ENDIF
	GOTO 5000

C       ------------------------------------------------------------ VO
1100    CALL CHKINPQ('EA,RA,TA,MD,CEUL,FITP,GZ,GZD$',FCHAR(4:),JCALL)
        GOTO 
     $  (1101,1102,1103,1104,1105,1107,1108,1109,1110) JCALL     

1101    CALL VECTOP
        GOTO 5000

1102    CALL VOEA(MAXDIM)
        GOTO 5000

1103    CALL VORA(MAXDIM)
        GOTO 5000

1104    CALL VOTA(MAXDIM)
        GOTO 5000

1105    CALL VOMD(MAXDIM)
        GOTO 5000

1107    CALL COMBEUL1(16,17)
        GOTO 5000

1108    CALL CALLFITPLANE(16)
        GOTO 5000

1109    CALL MRGETZ
        GOTO 5000

1110    CALL MRGETZD(16,17)
        GOTO 5000

C       SET MODE -------------------------------------------------- MO
1200    CALL SETMODE
        GOTO 5000

5000    RETURN
        END

