
C++************************************************************************
C
C    DRIV2
C
C **************************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK            *
C *  COPYRIGHT (C)1981,1993, WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH 			   *
C **************************************************************************
C
C   DRIV2(MAXDIM)
C
C   PURPOSE:   A MAIN DRIVER FOR ROUTINES REMOVED FROM DRIVER IN MAR 93
C              CONTAINSSOME NEW ROUTINES RECENTLY ADDED
C
C   PARAMETERS: MAXDIM     MAX LENGTH OF COMMON BUFFER
C
C23456789 123456789 123456789 123456789 123456789 123456789 123456789 12
C--*********************************************************************

        SUBROUTINE DRIV2(MAXDIM)

	INCLUDE 'CMBLOCK.INC' 
CNO_SAVE

	PARAMETER      (NMENU=3)
        CHARACTER *2   MENU(NMENU)

        CHARACTER *81  FILNAM
        CHARACTER *1   NULL

        DATA MENU/'TV','WT','SE'/

        NULL   = CHAR(0)
        LUNIN  = 12
        LUNOUT = 13

C       SELECT THE OPERATION
        IFUNC = 0
        DO I = 1,NMENU
           IF (MENU(I) .EQ. FCHAR(1:2)) IFUNC = I
        ENDDO
        IF (IFUNC .LE. 0) RETURN
        GOTO  (100, 200, 300), IFUNC

100	WRITE(NOUT,*) '*** NO TV ROUTINES LEFT IN SPIDER'
        CALL ERRT(100,'DRIV2',NE)
        GOTO 5000

200	CONTINUE
C       INTERACTIVE LATTICE REFLECTION PICKING -------------------WT TV
        CALL TVWN3(MAXDIM)
        GOTO 5000


300	CONTINUE
C       SEED FILL -------------------------------------------------SE 
C       OPEN INPUT FILE, NO FOURIER INPUT ALLOWED 
201	CALL OPFIL(.TRUE.,FILNAM,LUNIN,'O',NSAM1,NROW1,NSLICE1,
     &             IDUM,'INPUT',.FALSE.,IRTFLG)
        IF (IRTFLG .NE. 0) GOTO 5000

        IF (NSLICE1 .GT. 1) THEN
          CALL ERRT(101,'CAN NOT USE 3-D FILES',NE)
          GOTO 5000

        ELSEIF ((2 * NSAM1 * NROW1 + 4) .GE. MAXDIM) THEN
          CALL ERRT(9,'DRIV2 ',NE)
          GOTO 5000
        ENDIF
        FMIN1 = FMIN
        IF (IMAMI .NE. 1) 
     &      CALL NORM3(LUNIN,NSAM1,NROW1,NSLICE1,FMAX1,FMIN1,AVR1)

C       OPEN THE OUTPUT FILE
        IFORM = 1
202     CALL OPFIL(.TRUE.,FILNAM,LUNOUT,'U',NSAM1,NROW1,NSLICE1,
     &             IDUM,'OUTPUT',.FALSE.,IRTFLG)
        IF (IRTFLG .EQ. -1) THEN
           CLOSE(LUNIN)
           GOTO 201
        ENDIF
        IF (IRTFLG .NE. 0) GOTO 5000
 
        CALL SEEDFILL(LUNIN,LUNOUT,NSAM1,NROW1,FMIN1,MAXDIM,IRTFLG)
        CLOSE(LUNOUT)
        IF (IRTFLG .EQ. -1)  GOTO 202
        CLOSE(LUNIN)
        GOTO 5000

5000    RETURN
        END     


