
C++************************************************************************
C
C    DRIV3
C
C **************************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK            *
C *  COPYRIGHT (C)1981,1993, WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH 			   *
C **************************************************************************
C
C   DRIV3(MAXDIM)
C
C   PURPOSE:   A MAIN DRIVER FOR ROUTINES REMOVED FROM DRIVER IN MAR 93
C              CONTAINS ROUTINES ACCESSING DOC FILES ONLY
C
C   PARAMETERS: MAXDIM     MAX LENGTH OF COMMON BUFFER
C
C23456789 123456789 123456789 123456789 123456789 123456789 123456789 12
C--*********************************************************************

        SUBROUTINE DRIV3(MAXDIM)
          
	INCLUDE 'CMBLOCK.INC' 
CNO_SAVE

        PARAMETER      (NMENU=3)
        CHARACTER *2   MENU(NMENU)
        CHARACTER *81  FILNAM
        CHARACTER *1   NULL

        DATA  MENU/'SD','UD','LD'/
        DATA  NDOC/4/,NDOC2/33/

        NULL = CHAR(0)

C       MAKE SURE ALL OF FCHAR IS UPPERCASE
        CALL SSUPCAS(FCHAR)

C       CARRY OUT THE OPERATION
        IFUNC = 0
        DO I = 1,NMENU
           IF (MENU(I) .EQ. FCHAR(1:2)) IFUNC = I
        ENDDO
        IF (IFUNC .LE. 0) RETURN
        GOTO (100, 200, 300), IFUNC

C       SAVE DOC ------------------------------------------------ SD **

100  	IF (FCHAR(4:5) .EQ. 'SH') THEN
C          RANDOMLY SHUFFLE LINES IN DOCFILE --------------- SD SHUFFLE
           CALL SHUFFLEDOC(MAXDIM)

        ELSEIF (FCHAR(4:4) .EQ. 'S') THEN
C          SORT DOC FILE ---------------------------------------- SD S
           CALL SORTDOC(MAXDIM)

        ELSEIF (FCHAR(4:4) .EQ. 'C') THEN
C          SAVE DOC CLUSTER FILE -------------------------------- SD C
C          TRANSFER COORDINATES FROM CLUSTER FILE TO DOCUMENT
           CALL RDCLUS

        ELSEIF (FCHAR(4:4) .EQ. 'N') THEN
C          SAVE DOC NONLINEAR MAPPING -------------------------- SD NLM
C          TRANSFER COORDINATES FROM NLM 2D FILE TO DOCUMENT
           CALL NLMCONV(11,12)

        ELSE
C          SAVE DOC -------------------------------------------- SD
C          GET DOC FILENAME
	   CALL FILERD(FILNAM,NLETD,NULL,'DOCUMENT',IRTFLG)
           IF (IRTFLG .EQ. -1) GOTO 5000

C          MERGE FILNAM WITH DATEXC
           CALL FILCAN(FILNAM,NLETT,NULL,NULL,FILNAM,DATEXC,IRTFLG)
           IF (IRTFLG .NE. 0) GOTO 5000
           CALL SAVDOCQ(FILNAM,NLETT,IRTFLG) 
        ENDIF
        GOTO 5000


C       UNSAVE DOCUMENT ---------------------------------------- UD ???

200	IF (FCHAR(4:4) .EQ. 'I') THEN
C          UNSAVE DOCUMENT - IN CORE --------------------------- UD IC?
	   CALL FILERD(FILNAM,NLETD,NULL,'DOCUMENT',IRTFLG)
           IF (IRTFLG .EQ. -1) GOTO 5000

C          MERGE FILNAM WITH DATEXC
           CALL FILCAN(FILNAM,NLETT,NULL,NULL,FILNAM,DATEXC,IRTFLG)
           IF (IRTFLG .NE. 0) GOTO 5000

	   CALL RDDOCA2Q(FILNAM,NDOC)

        ELSEIF (FCHAR(4:4) .EQ. 'N') THEN
C          UNSAVE DOCUMENT KEYCOUNT --------------------------- UD N?
	   CALL FILERD(FILNAM,NLETD,NULL,'DOCUMENT',IRTFLG)
           IF (IRTFLG .EQ. -1) GOTO 5000

C          MERGE FILNAM WITH DATEXC
           CALL FILCAN(FILNAM,NLETT,NULL,NULL,FILNAM,DATEXC,IRTFLG)
           IF (IRTFLG .NE. 0) GOTO 5000

	   CALL RDDOCN(FILNAM,NDOC)
        ELSE
C          UNSAVE DOCUMENT - REGULAR ---------------------------- UD
           CALL RDDOCQ(FCHAR,NDOC2,NULL)
        ENDIF
	GOTO 5000


C       LIST DOCUMENT FILE --------------------------------------- LD
300     CALL FILERD(FILNAM,NLETD,NULL,'DOCUMENT',IRTFLG)
	IF (IRTFLG .NE. 0) GOTO 5000
	CALL FILCAN(FILNAM,NFIL,NULL,NULL,FILNAM,DATEXC,IER)
  
C	LATER TO BE SWITCHED BY COPT
	ISEQ = 0  
	CALL LISTDC(FCHAR,FILNAM,NFIL,NDOC,ISEQ)
	GOTO 5000

5000    RETURN
	END

