C++************************************************************************
C
C $$ DSFS.FOR
C
C **************************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK            *
C *  COPYRIGHT (C)1981,1987, WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *  THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR       *
C *  LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR    *
C *  USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF     *
C *  THE CENTER FOR LABORATORIES AND RESEARCH   			   *
C **************************************************************************
C
C23456789012345678901234567890123456789012345678901234567890123456789012
C--************************************************************************

         SUBROUTINE DSFS(MAXMEM)

C   DSFS                                 09/07/93
C    DISTANCES BETWEEN PROJECTIONS.
C    BUFFER ON THE DISK IN THE 'SCRATCH.FILE'
C    SWITCHES BETWEEN "IN CORE" AND "ON DISK" VERSION,
C     SCRATCH.FILE PRODUCED IN EITHER CASE ...
C
C    WHEN IN THE OUTPUT DOCUMENT FILE N POINTS TO I+NIMA,
C    WHERE NIMA IS NUMBER OF REFERENCE PROJECTIONS,
C    THEN THE REFERENCE PROJECTION HAS TO BE MIRRORED
C    AND ITS EULERIAN ANGLES MODIFIED AS FOLLOWS:
C    I      :      THETA       PHI
C    I+NIMA :     180-THETA  180+PHI
C    AND PSI FROM THE OUTPUT DOCUMENT FILE  ->  180+PSI.
C
C     SUBROUTINE DSFS(MAXMEM)
C     SUBROUTINE  DSFS_P(BUF,ILIST,NILMAX,ILIP,NIPMAX,NIDI,
C     SUBROUTINE  NORMAS(X,NS1,NS2,NR1,NR2,IR1,IR2)
C     SUBROUTINE  ALPRBS
C     SUBROUTINE  ALRQ
C     SUBROUTINE  CROSRNG
C     SUBROUTINE  CROSRMG
C     SUBROUTINE  FRNG(CIRC,LCIRC,NUMR,NRING)
C     SUBROUTINE PRB1D(B,NPOINT,POS)
C     SUBROUTINE  FFTR_D(X,NV)
C     SUBROUTINE  FFTC_D(BR,BI,LN,KS)
C     FUNCTION  ANGMR(RKK,MODE)
C     FUNCTION  LOG2_P(N)

         PARAMETER  (NILMAX=21000,NIPMAX=20000)
         INCLUDE 'CMBLOCK.INC'
         DIMENSION BFC(1)
         POINTER   (IPQ,BFC) 
         LOGICAL         RUNTIME
         COMMON  DUMMY(80),BUF(1024),ILIST(NILMAX),ILIP(NIPMAX),Q(1)
         COMMON  /F_SPEC/  FINPAT,FIPROJ,FINPIC,NLET,NLEP
         CHARACTER*80  FINPIC,FIPROJ,FINPAT
         INTEGER*2  MAXRIN
         INTEGER*2  NUMR(3,480)
         CHARACTER*1  MODE,ASK,NULL
         LOGICAL  IN_CORE
         EQUIVALENCE  (Q,NUMR)
         DATA  INPIC/77/
CNO_SAVE
         NULL=CHAR(0)

C  ASK FOR DATA FILE
C
         NMAX=NILMAX
         CALL  FILSEQP(FINPAT,NLET,ILIST,NMAX,NIMA,
     &   'ENTER TEMPLATE FOR 2-D REFERENCE PROJECTIONS NAME',IRTFLG)
C  NIMA - total number of images

         CALL  FILGET(FINPAT,FINPIC,NLET,ILIST(1),INTFLG)
         CALL  OPENFB(BUF,FINPIC,INPIC,NSAM,NROW,'O',NF,NSL)
         IF (NF.NE.2)  THEN
            WRITE(NOUT,*)  ' FILE NOT FOUND'
            RETURN
         ENDIF
         CLOSE(INPIC)

         CALL  RDPRMI(MR,NR,NLOOP,ILOOP,'FIRST AND LAST RING')
         CALL  RDPRMI(ISKIP,NDUMP,NLOOP,ILOOP,'SKIP')
         ISKIP=MAX0(1,ISKIP)
7981     CONTINUE

C     NA=1
C     CALL  RDPRMC(ASK,NA,.TRUE.,'(F)ULL OR (H)ALF CIRCLE',NULL,IRT)
C     IF(ASK.EQ.'F')  THEN
         MODE='F'
C     ELSEIF(ASK.EQ.'H')  THEN
C        MODE='H'
C     ELSE
C        RETURN
C     ENDIF
C     CALL  RDPRMI(JACUP,NDUMP,NLOOP,ILOOP,
C     & 'Precision of peak location (0..100)$')
C     JACUP=MAX0(0,MIN0(100,JACUP))

         JACUP=0
      	CALL  RDPRMC(ASK,NA,.TRUE.,
     &	'SCRATCH FILE EXISTS (Y/N/W)?',NULL,IRT)
C
         NRING=0
         DO    I=MR,NR,ISKIP
         NRING=NRING+1
         NUMR(1,NRING)=I
	 ENDDO

C Calculation of actual dimension of an image to be interpolated
C 2*(# of rings)+(0'th element)+2*(margin of 1)
C
         NRA=MIN0(((NSAM-1)/2)*2+1,((NROW-1)/2)*2+1,2*NR+3)
         LSAM=NSAM
         LROW=NROW
         NSAM=NRA
         NROW=NRA
         CALL  ALPRBS(NUMR,NRING,LCIRC,MODE)
         NMAX=NIPMAX
         CALL  FILSEQP(FIPROJ,NLEP,ILIP,NMAX,NIDI,
     &   'ENTER TEMPLATE FOR 2-D EXPERIMENTAL PROJECTIONS NAME',IRTFLG)
C  NIDI - number of images to check distances
C
C
C   memory division
C     NUMR        1
C     CIRC        2
C A: X                 3
C    BUFIN             4
C    WORK              5
C          B:
C             CIROLD   4
C             TEMP     6
C             TOTMIN   61
C             TOTMIR   62
C             TOT      63
C             TMT      64
C             TT       65
C             WR       66
C             BFC      7
C
         MAXRIN=NUMR(3,NRING)
         K1=1
         K2=IPALIGN64(K1+(3*NRING+1)/2)
         K7=IPALIGN64(K2+LCIRC)
         K3A=K7
         K41A=IPALIGN64(K3A+NSAM*NROW)
         K4A=IPALIGN64(K41A+LSAM)
         K5A=K4A
         K3B=K5A
         K4B=K3B
         K5B=IPALIGN64(K4B+LCIRC)
         K6B=K5B
#ifdef SP_MP
        K61=K6B
#else
        K61=IPALIGN64(K6B+MAXRIN*4)
#endif

         K62=IPALIGN64(K61+2*NIMA)
         K63=IPALIGN64(K62+2*NIMA)
         K64=IPALIGN64(K63+NIMA)
         K65=IPALIGN64(K64+NIMA)
#ifdef SP_LIBFFT
         K66=IPALIGN64(K65+(LCIRC+15)*2)
#else
         K66=K65
#endif

         K7B=IPALIGN64(K66+NRING)
        MEMTOT=NILMAX+1200+MAX0(K5A,K7B)
	MEMBUF=LCIRC*NIMA
        CALL ALLOCIT(MEMBUF,RUNTIME,IPQ,'DSFS',IRTFLG)
	IF(MEMTOT.LE.MAXMEM.AND.RUNTIME)  THEN
C
            WRITE (NOUT,2500)  MAXMEM , MEMTOT
2500        FORMAT (/,'  Alignment of projections, in-core version.',
     #              /,'  Memory: available ',I8,',  required ',I8,/)
            IN_CORE=.TRUE.
         ELSE
            K8B=K8B-LCIRC*NIMA
            MEMTOT=NILMAX+1200+MAX0(K5A,K8B)
            IF (MEMTOT .LE. MAXMEM)  THEN
               WRITE (NOUT,2501)  MAXMEM , MEMTOT
2501           FORMAT (/,
     #'  Alignment of projections, on-disk version (scratch.file used).'
     #   ,/,'  Memory: available ',I8,',  required ',I8,/)
              IN_CORE=.FALSE.
            ELSE
               IF (RUNTIME) CALL ALLOCIT(0,RUNTIME,IPQ,'DSFS',IRTFLG)
               WRITE(NOUT,*)  '  Sorry, not enough memory !'
               RETURN
           ENDIF
         ENDIF

         CALL  DSFS_P(BUF,ILIST,NILMAX,ILIP,NIPMAX,NIDI,
     &      NSAM,NROW,LSAM,LROW,NIMA,
     &      NRING,LCIRC,MAXRIN,JACUP,NUMR,
     &      Q(K2),Q(K3A),Q(K41A),Q(K4B),
     &      Q(K6B),Q(K61),Q(K62),Q(K63),Q(K64),Q(K65),Q(K66),
     &          BFC,
     &   MODE,ASK,IN_CORE,NOUT)
        IF(RUNTIME) CALL ALLOCIT(0,RUNTIME,IPQ,'DSFS',IRTFLG)
         WRITE (NOUT,2600)
2600     FORMAT (/ ' ',80('-')//' ',
     #          'END OF COMPUTATION',//' ',80('-')/)
         END
