C++************************************************************************
C
C $$ DSFS_P.FOR
C
C **************************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK            *
C *  COPYRIGHT (C)1981,1987, WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *  THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR       *
C *  LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR    *
C *  USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF     *
C *  THE CENTER FOR LABORATORIES AND RESEARCH   			   *
C **************************************************************************
C
C
C
C23456789012345678901234567890123456789012345678901234567890123456789012
C--************************************************************************

         SUBROUTINE  DSFS_P(BUF,ILIST,NILMAX,ILIP,NIPMAX,NIDI,
     &   NSAM,NROW,LSAM,LROW,NIMA,
     &   NRING,LCIRC,MAXRIN,JACUP,NUMR,
     &   CIRC,X,BUFIN,CIROLD,
#ifdef SP_MP
     &   TEMP_,
#else
     &   TEMP,
#endif
     &   TOTMIN,TOTMIR,TOT,TMT,TT,WR,BFC,MODE,ASK,IN_CORE,NOUT)
         PARAMETER  (NLIST=4)
         INTEGER*2  MAXRIN,MAXRI
         DIMENSION  X(NSAM,NROW),BUFIN(LSAM),BFC(LCIRC,NIMA)
         DIMENSION  CIRC(LCIRC),CIROLD(LCIRC)
         INTEGER*2  NUMR(3,NRING)
#ifdef SP_MP
	DOUBLE PRECISION TEMP_
#else
	DOUBLE PRECISION TEMP(MAXRIN,2)
#endif
	DOUBLE PRECISION TT(*)
	DIMENSION  WR(NRING)
	DOUBLE PRECISION TOTMIN(NIMA),TOTMIR(NIMA),EAV
	DIMENSION  TOT(NIMA),TMT(NIMA)
	DIMENSION  ILIST(NILMAX),ILIP(NIPMAX),DLIST(NLIST),BUF(1024)
	COMMON  /F_SPEC/  FINPAT,FIPROJ,FINPIC,NLET,NLEP
	CHARACTER*80  FINPIC,FIPROJ,FINPAT
	COMMON  /MXR/  MAXRI
	CHARACTER*1  MODE,ASK
	LOGICAL  IN_CORE
	DATA  INPIC/77/,NDOC/55/,NSCF/50/
CNO_SAVE
C
C  order of processing:
C 1 - calculate waights for rings in RINGWE, sore in WR
C 2 - convert each reference image to rings, do the FFTs
C     for all the rings, apply weights to the rings, store it in BFC.
C     In addition, highest frequency for all the ring except
C     maxring are divided by 2.
C 3 - convert each input image to rings, do the FFTs,
C     compare each input image with all the reference images
C     using CROSRNG_M.  It checks both straight and mirrored
C     position by calculating X*CONJG(Y) and CONJG(X)*CONJG(Y)
C     Since Y were pre-weighted the results is already correct.
C
	CALL  RINGWE(WR,NUMR,NRING,MAXRIN)
#ifdef SP_LIBFFT
	IP=MAXRIN
	CALL  DZFFT1DUI(IP,TT)
#endif

         MAXRI=MAXRIN
         LQ=LROW/2+1
         LR1=(NROW-1)/2
         LR2=LQ+LR1
         LR1=LQ-LR1
         LQ=LSAM/2+1
         LS1=(NSAM-1)/2
         LS2=LQ+LS1
         LS1=LQ-LS1

#ifdef SP_MP
	IF(.NOT.IN_CORE) THEN
	ITI=mp_numthreads()
	call  mp_destroy()
	call  mp_set_numthreads(2)
	ENDIF
#endif
c find max element on  ILIST
	MAXIMA=ILIST(1)
	DO  IMI=1,NIMA
	MAXIMA=MAX(MAXIMA,ILIST(IMI))
	ENDDO
	IF(ASK.EQ.'Y')  GOTO  7751
C
	IF(ASK.EQ.'W'.OR..NOT.IN_CORE) OPEN(NSCF,FILE='scratch.file',
     &     STATUS='UNKNOWN',FORM='UNFORMATTED')
C
	DO   K1=1,NIMA
         CALL  FILGET(FINPAT,FINPIC,NLET,ILIST(K1),INTFLAG)
         CALL  OPENFB(BUF,FINPIC,INPIC,LSAM,LROW,'O',NF,NSL)
         IF(NF.NE.2)  THEN
         WRITE(NOUT,2032)  FINPIC
2032     FORMAT(' File not found ',A80,/,' Operation abandoned')
         RETURN
         ENDIF
	DO    K2=LR1,LR2
         CALL  REDLIN(INPIC,BUFIN,LSAM,K2)
	DO    K3=LS1,LS2
         X(K3-LS1+1,K2-LR1+1)=BUFIN(K3)
	ENDDO
	ENDDO
	CLOSE(INPIC)
C
C  Normalize under the mask
C
	CALL NORMAS(X,-NSAM/2,NSAM/2,-NROW/2,NROW/2,
     &   NUMR,NUMR(1,NRING))
C
	CALL  ALRQ(X,NSAM,NROW,NUMR,CIRC,LCIRC,NRING,MODE,K1)
	CALL  FRNG(CIRC,LCIRC,NUMR,NRING)
	CALL  APPLYW(CIRC,LCIRC,NUMR,WR,NRING,MAXRIN)
C
	IF(ASK.EQ.'W'.OR..NOT.IN_CORE)  WRITE(NSCF)  CIRC
         IF(IN_CORE)  THEN
c$doacross local(i)
         DO I=1,LCIRC
         BFC(I,K1)=CIRC(I)
         ENDDO
         ENDIF
	 ENDDO
	IF(ASK.EQ.'W'.OR..NOT.IN_CORE) CLOSE(NSCF)
7751     CONTINUE
         IF(.NOT.IN_CORE.OR.ASK.EQ.'Y')
     &         OPEN(NSCF,FILE='scratch.file',
     &        STATUS='OLD',FORM='UNFORMATTED')
         IF(ASK.EQ.'Y')  THEN
            DO  J=1,NIMA
               READ(NSCF)  (BFC(I,J),I=1,LCIRC)
            ENDDO
            CLOSE(NSCF)
         ENDIF
C
         DO  ITI=1,NIDI
         CALL  FILGET(FIPROJ,FINPIC,NLEP,ILIP(ITI),INTFLAG)
         CALL  OPENFB(BUF,FINPIC,INPIC,LSAM,LROW,'O',NF,NSL)
         IF(NF.NE.2)  THEN
         WRITE(NOUT,2032)  FIPROJ
         RETURN
         ENDIF
         DO    K2=LR1,LR2
            CALL  REDLIN(INPIC,BUFIN,LSAM,K2)
            DO    K3=LS1,LS2
         X(K3-LS1+1,K2-LR1+1)=BUFIN(K3)
	    ENDDO
    	 ENDDO
	CLOSE(INPIC)
C  Normalize under the mask
	CALL NORMAS(X,-NSAM/2,NSAM/2,-NROW/2,NROW/2,
     &      NUMR,NUMR(1,NRING))
	CALL  ALRQ(X,NSAM,NROW,NUMR,CIROLD,LCIRC,NRING,MODE,ITI)
	CALL  FRNG(CIROLD,LCIRC,NUMR,NRING)
         EAV=-1.0D20
         IF(IN_CORE)  THEN
c$doacross local(imi)
         DO   IMI=1,NIMA
	CALL  CROSRNG_M
     &		(BFC(1,IMI),CIROLD,LCIRC,NRING,
#ifdef SP_MP
     &			TEMP_,TEMP_,
#else
     &			TEMP,TEMP(1,2),
#endif
     &	MAXRIN,NUMR,TOTMIN(IMI),TOT(IMI),TOTMIR(IMI),TMT(IMI),TT)
	 ENDDO
         ELSE
         REWIND  NSCF
         DO    IMI=1,NIMA
         READ(NSCF)  CIRC
           CALL  CROSRNG_M
     &   (CIRC,CIROLD,LCIRC,NRING,
#ifdef SP_MP
     &			TEMP_,TEMP_,
#else
     &			TEMP,TEMP(1,2),
#endif
     &	MAXRIN,NUMR,TOTMIN(IMI),TOT(IMI),TOTMIR(IMI),TMT(IMI),TT)
	 ENDDO
         ENDIF
C
         DO   IMI=1,NIMA
         IF(TOTMIN(IMI).GE.EAV.AND.TOTMIN(IMI).GT.TOTMIR(IMI))  THEN
         EAV=TOTMIN(IMI)
         IDI=IMI
         RANG=TOT(IMI)
         ELSEIF(TOTMIR(IMI).GE.EAV)  THEN
         EAV=TOTMIR(IMI)
         IDI=IMI+MAXIMA
         RANG=TMT(IMI)
         ENDIF
	 ENDDO
C .....................................................................
         DLIST(1)=ITI
         DLIST(2)=IDI
         DLIST(3)=EAV
         DLIST(4)=ANGMOR(RANG,MODE)
         CALL  SAVD(NDOC,DLIST,NLIST,IRTFLG)
	 ENDDO
         CALL  SAVDC
         CLOSE(NDOC)
#ifdef SP_MP
	IF(.NOT.IN_CORE) THEN
	call  mp_destroy()
	call  mp_set_numthreads(ITI)
	ENDIF
#endif
C     close(nscf,dispose='delete')
         IF(.NOT.IN_CORE)  CLOSE(NSCF)
         END
