
C++************************************************************************
C
C    EHIST.FOR
C                                       FILENAMES LENGTHENED JAN 89 al
C                                       REMOVED RHIST AUG 96 al
C **************************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK            *
C *  COPYRIGHT (C)1981,1987, WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH 			   *
C **************************************************************************
C
C    EHIST(FILNAM,LUN1,LUN2,NSAM,NROW)
C
C    PURPOSE:      HISTOGRAM EQUALIZATION
C
C    PARAMETERS:
C        FILNAM    NAME OF FILE
C        LUN1      LOGICAL UNIT NUMBER OF FILE
C        LUN2      LOGICAL UNIT NUMBER OF FILE
C        NSAM      NUMBER OF SAMPLES
C        NROW      NUMBER OF ROWS
C
C--************************************************************************

      SUBROUTINE EHIST(FILNAM,LUN1,LUN2,NSAM,NROW,NSLICE)

      COMMON IPLOT(128),BUF(1)
      COMMON /MASTER/ NSAMC,NROWC,IREC,NLABEL,IFORM,IMAMI,FMAX,FMIN,
     1                AV,SIG,IHIST
      COMMON/UNITS/ LUN,NIN,NOUT,NECHO,IFOUND,NPROC,NDAT

      CHARACTER *(*) FILNAM
      CHARACTER      NULL,ANS
      LOGICAL        MAPOUT,HISOUT

      NULL   =  CHAR(0)

      MAPOUT = .FALSE.
      HISOUT = .FALSE.
      CALL RDPRMC(ANS,NC,.TRUE.,
     &   'MAPPING FUNCTION AND HISTOGRAM PRINTOUT? (Y/N)',NULL,IRTFLG)
      IF (IRTFLG .NE. 0) RETURN

      IF (ANS .NE. 'N') THEN
        MAPOUT = .TRUE.
        HISOUT = .TRUE.
      ENDIF

C     FIND HISTOGRAM OF IMAGE
      CALL HIST(LUN1,NSAM,NSLICE,NROW,0,0,.FALSE.)


C     FIND CUMULATIVE DISTRIBUTION (HISTOGRAM MAPPING FUNCTION)
      DO K = 2,128
          BUF(NSAM+K) = BUF(NSAM+K)+BUF(NSAM+K-1)
      ENDDO

      IF (MAPOUT) THEN
C       PRINT HISTOGRAM MAPPING FUNCTION IN RESULTS FILE
        CALL PDATES(FILNAM,0)
        WRITE(NDAT,*) ' HISTOGRAM MAPPING FUNCTION'
        CALL GRAPHS(BUF(NSAM+1),128,1)
      ENDIF

C     HMIN IS MIN OF CUMULATIVE FUNCTION, HMAX IS MAX (TOTAL # OF PIXELS)
      HMIN = BUF(NSAM+1)
      HMAX = HMIN
      DO  K = 1,128
         HB = BUF(NSAM+K)
         IF (HB .LT. HMIN) HMIN = HB
         IF (HB .GT. HMAX) HMAX = HB
      ENDDO

      VAL = 2.0 / (HMAX-HMIN)
      DO  K = 1,128
        BUF(NSAM+K) = (BUF(NSAM+K) - HMIN) * VAL
      ENDDO

C     HINC IS INCREMENT OF ORIGINAL IMAGE RANGE CORRESPOINDING TO 1 HISTOGRAM UNIT
      HINC = (FMAX-FMIN) / 127.0
      AV   = 0.0
      FAC  = (-FMIN/HINC)+ 1.5
      HINCR = 1.0 / HINC

C     CONVERT IMAGE VALUES TO MAPPED VALUES
      DO  I = 1,NROW
         CALL REDLIN(LUN1,BUF,NSAM,I)
         DO  K = 1,NSAM

C          MAP IMAGE VALUE TO RANGE 1...128
C**           MAP  = (BUF(K)-FMIN)/HINC +1.5
           MAP  = BUF(K) * HINCR + FAC

C          REPLACE IMAGE VALUE BY HISTOGRAM MAPPED VALUE
           T      = BUF(NSAM+MAP)
           AV     = AV+T
           BUF(K) = T
	 ENDDO
         CALL WRTLIN(LUN2,BUF,NSAM,I)
      ENDDO


C     SET IMAGE HEADER FOR NEW IMAGE CONTENTS
      AV    = AV/(FLOAT(NSAM)*FLOAT(NROW))
      IHIST = 0
      FMAX  = 2.
      FMIN  = 0.
      SIG   = -1.
      CALL SETPRM(LUN2,NSAM,NROW,FMAX,FMIN,AV,'U')

C     PRINT HISTOGRAM IN RESULTS FILE IF DESIRED
      IF (HISOUT) CALL HIST(LUN2,NSAM,NROW,NSLICE,0,0,.FALSE.)

      RETURN
      END
