C++************************************************************************
C
C $$ ENFR_2.FOR
C
C **************************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK            *
C *  COPYRIGHT (C)1981,1987, WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *  THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR       *
C *  LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR    *
C *  USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF     *
C *  THE CENTER FOR LABORATORIES AND RESEARCH   			   *
C **************************************************************************
C
C
C
C--************************************************************************
C
C $$ ENFR_2.FOR
C
	DOUBLE PRECISION FUNCTION ENFR_2(A,LSD,NSAM,NROW)
C
C  Energy in Fourier space
C
	DIMENSION  A(LSD,NROW)
	DOUBLE PRECISION  ENFR
CNO_SAVE
	ISBD=2*MOD(NSAM+1,2)
	IRBD=MOD(NROW,2)
	ENFR=0.0D0
	DO    J=1,NROW
	DO    I=3,LSD-ISBD
	ENFR=ENFR+A(I,J)*DBLE(A(I,J))
	ENDDO
	ENDDO
	DO    J=2,NROW/2+IRBD
	ENFR=ENFR+A(1,J)*DBLE(A(1,J))+A(2,J)*DBLE(A(2,J))
	ENDDO
	IF(MOD(NSAM,2).EQ.0) THEN
	DO    J=2,NROW/2+IRBD
	ENFR=ENFR+A(LSD-1,J)*DBLE(A(LSD-1,J))+A(LSD,J)*DBLE(A(LSD,J))
	ENDDO
	ENDIF
	ENFR=2*ENFR
	ENFR=ENFR+A(1,1)*DBLE(A(1,1))
	IF(MOD(NROW,2).EQ.0) ENFR=ENFR+A(1,NROW/2+1)*DBLE(A(1,NROW/2+1))
	IF(MOD(NSAM,2).EQ.0) THEN
	ENFR=ENFR+A(LSD-1,1)*DBLE(A(LSD-1,1))
	IF(MOD(NROW,2).EQ.0) ENFR=ENFR+
     &		A(LSD-1,NROW/2+1)*DBLE(A(LSD-1,NROW/2+1))
	ENDIF
	ENFR_2=ENFR/FLOAT(NSAM*NROW)
	END
