C
C----------------------------------------------------------------------         
C
C $$ EPUR4 (IDIM,ICARD, X,Y,ID, MOD, PEX, KP,KLIC,KODE,NOR,NID,IMP) 
C 
C   POINTS WHICH FALL BEYOND PEX STANDARD DEVIATIONS ARE COLLAPSED ONTO         
C   THE FRAME OF THE GRAPH.                                                     
C   OUTPUT: THE KP MODIFIED POINTS HAVE THEIR INDICES IN KLIC()                 
C   IF THERE ARE MORE THAN 264 POINTS ON THE FRAME THE GRAPH IS ABORTED         
C   IF MOD=1 LABELS HAVE A1 FORMAT - IF MOD=4 LABELS HAVE A4 FORMAT             
C   WARNING : X(*) ET Y(*) ARE DESTROYED IF KP .NE. 0                           
C
C   CALLED BY: HPLAN    HISMAP HISMAP4
C 
C   REMOVED FROM HPLAN.FOR FILE APRIL 89 al
C
C----------------------------------------------------------------------         
C ID(IDIM,NID)  12/7/93     	<ML
C
C      SUBROUTINE  EPUR4 (IDIM,ICARD, X,Y,ID, MOD, PEX, KP,KLIC,KODE,NOR,
C     #  NID, IMP)                                                      
        SUBROUTINE  EPUR4 (IDIM,ICARD,X,Y,ID,MOD,PEX,KP,KLIC,KODE,IMP)

        CHARACTER * 4 ID(IDIM), IDA(3), LBLAN
        REAL * 4      X(IDIM), Y(IDIM), U, V, SEUIL
        INTEGER       KLIC(371),nid
        DATA  SEUIL / 1.0 E-07 /
        DATA LBLAN/'    '/

	nid = 1
        IF (PEX .LE. 0.0) RETURN
        KODE  = 0
        N1    = ICARD + 1
        IF (N1 .GT. IDIM) GOTO  100                               
        X(N1) = 0.0
        Y(N1) = 0.0
C        IF( NOR .NE. 1) N1 = ICARD     
C 12/7/93  <ML
        N1 = ICARD
        SX    = 0.0
        SY    = 0.0
        DO   I = 1,ICARD                                                      
          SX    = SX + X(I)*X(I)
          SY    = SY + Y(I)*Y(I)
        END DO
        SX    = SQRT(SX/FLOAT(ICARD))
        SY    = SQRT(SY/FLOAT(ICARD))
        PX    = PEX*SX 
        PY    = PEX*SY
        KP    = 0 
        PIN   = PEX + 20.0
        DO  I = 1, ICARD                                                      
          IF (ABS(X(I)) .GT. PX .OR. ABS(Y(I)) .GT. PY) THEN
            KP    = KP + 1 
            IF (MOD.NE.1 .AND. KP .EQ. 1) THEN
               WRITE(IMP,120)  PEX 
               WRITE(IMP,130)
            END IF
            IF (KP .GT. 264) GOTO  100                               
            KLIC(KP) = I 
            DO  K = 1, 3
              IDA(K) = LBLAN
              IF( NID .GE. K ) IDA(K) = ID(I)
            END DO
            IF (MOD .NE. 1) WRITE(IMP,110) (IDA(L),L=1,3),X(I),Y(I)
            X(I)  = X(I) / PIN
            Y(I)  = Y(I) / PIN 
          END IF
        END DO

        IF (KP .NE. 0)  THEN
          IF (MOD .EQ. 4) WRITE(IMP,130)
          CALL BORNS (N1,Y,YMIN,YMAX)
          CALL BORNS (N1,X,XMIN,XMAX)
          IF (XMIN .EQ. 0.) XMIN = SEUIL
          IF (XMAX .EQ. 0.) XMAX = SEUIL 
          T1    = YMAX / XMAX
          T2    = YMAX / XMIN 
          T3    = YMIN / XMIN
          T4    = YMIN / XMAX
          DO  K = 1, KP 
            KLK = KLIC(K)
            U = X(KLK)  
            V = Y(KLK)  
            IF (U .EQ. 0.) U = SEUIL
            T = V / U 
            A = YMAX 
            IF(U .GT. 0.0 .AND.(T4.LT.T .AND. T.LT.T1)) THEN
              A = XMAX  
              U = A 
              V = A * T
            ELSEIF (U .LT. 0.0 .AND.(T2.LT.T .AND. T.LT.T3)) THEN
              A = XMIN 
              U = A 
              V = A * T
            ELSE
              IF (V .LT. 0.) A = YMIN 
              V = A
              IF (T .EQ. 0.) T = SEUIL
              U = A / T
            END IF
                   
            IF( V .GT. YMAX) V = YMAX 
            IF( U .GT. XMAX) U = XMAX  
            X(KLK) = U  
            Y(KLK) = V 
          END DO
          IF (KP.NE.0 .AND. MOD.EQ.1) WRITE(IMP,140)  KP , PEX
        END IF
90      CONTINUE
        RETURN                                                                  

100     KODE  = 1
110     FORMAT (' ',' *',3A4,1X,'*',2(F13.5,8X,'*') )
120     FORMAT (///' ' ,      25X,'WARNING'  ,//' ', 
     #          'THE FOLLOWING POINTS ARE LOCATED BEYOND' ,F5.1,
     #          '  STANDARD DEVIATIONS FROM THE ORIGIN',/' ','THEY ARE',
     #          ' POSITIONED ON THE EDGES OF THE MAP'// )
130      FORMAT (' ',29(' *') )
140      FORMAT (' ',5X, I4, ' POINTS LOCATED BEYOND',F5.1,
     #           'STANDARD DEVIATIONS ARE POSITIONED ON',
     #           ' THE EDGES OF THE MAP')
        RETURN                                                                  
        END                                                                     
