
C++*************************************************************************
C
C $$ ERRF2.FOR-- CREATED JULY 15 1987
C
C **************************************************************************
C *  AUTHOR:  ARDEAN LEITH
C *  PART OF SPIDER - MODULAR IMAGE PROCESSING SYSTEM.                     *
C *  COPYRIGHT (C)1987 , WADSWORTH CENTER FOR LABORATORIES AND             *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH 			   *
C **************************************************************************
C
C $$ ERRF2(FNUM1,FNUM2,NVAL,FLOW1,FHI1,FLOW2,FHI2)
C
C    PARAMETERS:    NVAL         NUMBER OF VALUES TO BE CHECKED
C                   FNUM1        FIRST VALUE
C                   FNUM2        SECOND VALUE
C                   FLOW1        LOWEST VALUE FOR  FNUM1
C                   FHI1         HIGHEST VALUE FOR FNUM1
C                   FLOW2        LOWEST VALUE FOR  FNUM2
C                   FHI2         HIGHEST VALUE FOR FNUM2
C
C    CALLED BY:     CSAXIS
C
C        0         2         3         4         5         6         7
C23456789 123456789 123456789 123456789 123456789 123456789 123456789 12
C--*********************************************************************

       LOGICAL FUNCTION  ERRF2(FNUM1,FNUM2,NVAL,FLOW1,FHI1,FLOW2,FHI2)

       COMMON /UNITS/ LUNDOC,NIN,NOUT,NECHO,IFOUND,NPROC,NDAT
        

        ERRF2 = .TRUE.
        IF (FNUM1 .LT. FLOW1 .OR. FNUM1 .GT. FHI1) THEN
            WRITE(NOUT,92)FLOW1,FHI1
   92       FORMAT(' ERROR, FIRST INPUT RANGE: (',1PG11.3,'....',
     &               1PG11.3,')',/)
            RETURN
        ENDIF

        IF (NVAL .GE. 2 .AND. (FNUM2 .LT. FLOW2 .OR. FNUM2 .GT. FHI2)) 
     &      THEN
            WRITE(NOUT,97) FLOW2,FHI2
   97       FORMAT(' ERROR, SECOND INPUT RANGE: (',1PG11.3,'....',
     &               1PG11.3,')',/)
            RETURN
        ENDIF

        ERRF2 = .FALSE.

        RETURN
        END
