
C++*************************************************************************
C
C ERRT.F                                 ALTERED OUTPUT UNITS SEPT 97 al
C
C **********************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK            *
C *  COPYRIGHT (C)1981,1987, WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH 			   *
C **********************************************************************
C
C  ERRT(IERR,PROG,NE)
C
C  PURPOSE:      WRITE OUT AN ERROR MESSAGE
C 
C  PARAMETERS:   IERR    ERROR CODE NUMBER
C                PROG    STRING ALPHANUMERIC CHARACTERS CONTAINING
C                        PROGRAM NAME OR ERROR MESSAGE (IF IERR IS
C                        EQUAL TO 101)
C                NE      FLAG THAT CAN BE USED FOR DIFFERENT PROGRAM 
C                        ACTIONS ON RETURN OF ERRT (NO LONGER USED)
C
C23456789012345678901234567890123456789012345678901234567890123456789012
C--*********************************************************************

       SUBROUTINE ERRT(IERR,PROG,NE)

       INCLUDE 'CMBLOCK.INC' 

       CHARACTER *(*) PROG
       CHARACTER *43  MESG
CNO_SAVE

C      FOLLOWING COMMON BLOCKS ARE USED BY THIS MODULE
C      COMMON /UNITS/, /PARAM/ , /FUNCTION/

       NE = 1

      IF (IERR .EQ. 16) THEN

C         FIRST CHECK FOR BAD INPUT ERROR CODE, PRINT ERROR MESSAGE 
          WRITE(NOUT,116)
116       FORMAT(' .BAD INPUT PARAMETER(S). RE-ENTER: ')
          GOTO 2201

      ELSEIF (IERR .EQ. 100) THEN

C         SKIP MESSAGE OUTPUT
          GOTO 2201

      ELSEIF (IERR .EQ. 101) THEN

C         PROCESS ERROR CODE OF 101 FOR PROG = ERROR MESSAGE
C         WRITE TO TERMINAL AND RESULTS FILE

          WRITE(NDAT,901) PROG
          WRITE(6,901)    PROG
901       FORMAT(' *** ERROR: ',A/)

C         SKIP USUAL MESSAGE OUTPUT
          GOTO 2201

       ELSEIF (IERR .GT. 42) THEN
C         PROCESS ERROR CODE > 42
          MESG = 'UNIDENTIFIED,'
          GOTO 50
       ENDIF

C      PROCESS ALL OTHER ERROR CODES (1 - 42)

       GOTO (1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,
     &       21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,36,37,
     &       38,39,40,41,42), IERR

1         MESG = 'INCONSISTENT PICTURE DIMENSIONS'
          GOTO 50

2         MESG = 'OPERATION NOT CONSISTENT WITH DATA FORMAT'
          GOTO 50

3         MESG = 'ROWLENGTH TOO LARGE FOR BUFFER'
          GOTO 50

4         MESG = 'OPENING FILE'
          GOTO 50

5         MESG = 'NORMALIZING DATA'
          GOTO 50

6         MESG = 'INSUFFICIENT BUFFER SPACE'
          GOTO 50

7         MESG = 'I/O RECORD NUMBER OUT OF LIMITS'
          GOTO 50

8         MESG = 'NO HISTOGRAM DATA FOUND IN FILE'
          GOTO 50

9         MESG = 'LABEL SPACE INSUFFICIENT'
          GOTO 50

10        MESG = 'DIMENSIONS NOT POWER OF TWO'
          GOTO 50

11        MESG = 'PICTURE DIMENSIONS EXCEED FRAME'
          GOTO 50

12        MESG = 'READING FILE'
          GOTO 50

13        MESG = 'INITIALIZING TAPE'
          GOTO 50

14        MESG = 'INCONSISTENT INPUT PARAMETERS'
          GOTO 50

15        MESG = 'FILE IS WRITE PROTECTED'
          GOTO 50

16        CONTINUE
C..       THIS ERROR ALREADY PROCESSED BEFORE
          GOTO 50

17        MESG = 'END-OF-FILE ON INPUT'
          GOTO 50

18        MESG = 'FILE DOES NOT EXIST'
          GOTO 50

19        MESG = 'TOO MANY FILE NUMBERS ENTERED'
          GOTO 50

20        MESG = 'NOT DEFINED...'
          GOTO 50

21        MESG = 'NUMBER OF PROCEEDURES EXCEEDS MAXPRC'
          GOTO 50

22        MESG = 'TOO MANY PROCEDURES'
          GOTO 50

23        MESG = 'UNKNOWN OPTION'
          GOTO 50

24        MESG = 'SLICE NUMBER OUT OF BOUNDS'
          GOTO 50

25        MESG = 'NOT CONTAINED IN TABLE'
          GOTO 50

26        MESG = 'UNDEFINED ERROR'
          GOTO 50

27        MESG = 'UNABLE TO CONSTRUCT FILE NAME'
          GOTO 50

28        MESG = 'NUMBER OF PROJECTIONS TOO LARGE'
          GOTO 50

29        MESG = 'POOR PHASES'
          GOTO 50

30        MESG = 'TMPARY FULL, SHORTEN YOUR FILENAMES?'
          GOTO 50

31        MESG = 'PARAMETER VALUE OUT OF LEGAL RANGE'
          GOTO 50

32        MESG = 'PROGRAM TRAP'
          GOTO 50

33        MESG = 'ACCURACY NOT ACHIEVED'
          GOTO 50

34        MESG = 'OVERFLOW PROTECTION'
          GOTO 50

35        MESG = 'EXIT ERROR'
          GOTO 50

36        MESG = 'ILLEGAL ARGUMENT RANGE'
          GOTO 50

37        MESG = 'ONLY FIXED IMAGE SIZE ALLOWED'
          GOTO 50

38        MESG = 'DIMENSION IS A PRODUCT OF A PRIME NUMBER > 23'
          GOTO 50

39        MESG = 'COMMAND NOT SUPPORTED FOR THIS FILE FORMAT'
          GOTO 50

40        MESG = 'CONFLICT OF DATA FORMATS'
          GOTO 50

41        MESG = 'COMMAND TEMPORARILY DISABLED'
          GOTO 50

42        MESG = 'CAN NOT USE THIS OPERATION ON VOLUMES'
          GOTO 50


C         WRITE TO TERMINAL AND RESULTS FILE
50        WRITE(6,900)    MESG,IERR,PROG
          WRITE(NDAT,900) MESG,IERR,PROG
900       FORMAT(' *** ERROR: ',A,'#',I3,' SUBROUTINE: ',A,' ***'/)


2201      IF (IPROC .NE. 0 .OR. COPT .EQ. 'B') THEN
C            IN BATCH MODE, MUST STOP IMMEDIATELY
             CALL ENDIT('TERMINATED ON ERROR IN BATCH MODE',.FALSE.)
             STOP '*** FATAL ERROR ENCOUNTERED IN BATCH MODE'
          ENDIF

C         SET REGISTER 10 EQUAL TO 1. SO THAT YOU CAN TEST AND ABORT 
C         THE PROGRAM IF NECESSARY WITHIN A SUBROUTINE
          PARAM(10) = 1.0
     
      RETURN
      END
