
C++*************************************************** 12/11/79 1/11/81 VAX
C
C EVALNQ.FOR                  ADAPTED FROM EVALN.FOR FOR CHAR AUG 89 al
C
C **********************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK            *
C *  COPYRIGHT (C)1981,1987, WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH 			   *
C **********************************************************************
C
C EVALN(EXPR,LENGTH,VALUE,IFLAG)
C
C PURPOSE:   EVALUATES EXPRESSIONS, RETURNS VALUE
C
C23456789012345678901234567890123456789012345678901234567890123456789012
C--*********************************************************************

	SUBROUTINE EVALNQ(EXPR,LEN,VALUE,IFLAG)

CNO_STATIC

        COMMON /UNITS/  LUNC,NIN,NOUT,NECHO,IFOUND,NPROC,NDAT
	COMMON /PARAM/  PARAM(103),NSEL(10)
        CHARACTER *80   FCHAR
	COMMON/FUNCTION/FCHAR

	DIMENSION      VAL(9)
        CHARACTER *(*) EXPR
        CHARACTER *81  EXPR1,POLISH,STACK
        CHARACTER      CTEMP,NEXT,JCHAR,CTEMP1,CTEMM1

C       NXT NEEDS TO BE INTEGER*2 TO EXTRACT CORRECT PORTION OF TIME STRING 
C       FOR RANDOM GENERATOR:
	INTEGER*2      NXT(4)
	CHARACTER*8    CNXT
	EQUIVALENCE    (NXT,CNXT)
	LOGICAL        GFLAG,ISDIGI

        DATA PI/3.141592654/,GFLAG/.FALSE./

C       SET ERROR RETURN
        IFLAG = -1
 
	NM = 0

	DO  I=1,81
          EXPR1(I:I)=' '
          STACK(I:I)=' '
          POLISH(I:I)=' '
        ENDDO

C IT IS ASSUMED THAT EXPRESSION CONTAINS NO BLANKS
 	IF (EXPR(1:3) .EQ. 'PAD') NM=1
 	IF (EXPR(1:3) .EQ. 'SIN') NM=2
 	IF (EXPR(1:3) .EQ. 'EXP') NM=3
 	IF (EXPR(1:3) .EQ. 'LOG') NM=4
 	IF (EXPR(1:3) .EQ. 'COS') NM=5
 	IF (EXPR(1:3) .EQ. 'SQR') NM=6  
 	IF (EXPR(1:3) .EQ. 'MOD') NM=7
 	IF (EXPR(1:3) .EQ. 'INT') NM=8
 	IF (EXPR(1:3) .EQ. 'ABS') NM=9
 	IF (EXPR(1:3) .EQ. 'ATA') NM=10 
 	IF (EXPR(1:3) .EQ. 'ASI') NM=11 
 	IF (EXPR(1:3) .EQ. 'ACO') NM=12 
 	IF (EXPR(1:2) .EQ. 'LN')  NM=13 
 	IF (EXPR(1:3) .EQ. 'RAN')  NM=14

	DO  J=1,9
           VAL(J)=0.0
        ENDDO

	K    = 1
	J    = 1
	FRAC = 1.0
	NINT = 10
	I    = 0
	IF (NM .NE. 0) I = 3

C       FOR NON 3 LETTER CALLS:
        IF (EXPR(1:4) .EQ. 'SQRT') I = 4
        IF (NM.EQ.13) I = 2

C       -------------- loop ----------------------------------------
40	I = I + 1
	IF (I .GT. LEN) GOTO 41

	IUMIN = 1
	CTEMP = EXPR(I:I)
	IF (CTEMP.EQ.'(' .OR. CTEMP.EQ.')') THEN
           EXPR1(K:K) = EXPR(I:I)
           K = K + 1
           GOTO 41
        ENDIF

C       IF CURRENT CHAR. IS NOT START OF OPERATOR STRING, AND IS NOT "X", AND 
C       IS NOT "," AND NOT "." AND IS NOT A DIGIT THEN RETURN

	IF (NRQ(CTEMP) .NE. -1 .AND. CTEMP .NE. '.'  .AND. 
     &      CTEMP      .NE. 'X'.AND. CTEMP .NE. ','  .AND.
     &     (.NOT. ISDIGI(CTEMP))) RETURN

	IF (EXPR(I:I+1) .EQ. '**') THEN
C          SUBSTITUTE "@" OPERATOR FOR "**" SEQUENCE
           EXPR1(K:K) = '@'
           K = K+1
           I = I+1
           GOTO 41
        ENDIF

C       CHECK FOR MINUS SIGN AT FIRST CHAR, OR A MINUS SIGN IN FIRST CHAR.
C       FOLLOWED BY A FUNCTION STRING, OR A OPERATION FOLLOWED BY A MINUS 
C       SIGN AND A "."
C       OR AN OPERATION FOLLOWED BY A MINUS SIGN, THEN AN X, THEN A DIGIT.

        IF (CTEMP .EQ. '-') THEN
C         A MINUS SIGN
          CTEMP1 = EXPR(I+1:I+1)
          CTEMM1 = EXPR(I-1:I-1)
          IF ((I .EQ. 1) .OR. 
     &        (NM .NE. 0. AND. I .EQ. 5) .OR.
     &        (NRQ(CTEMM1) .EQ. -1 .AND. CTEMP1 .EQ. '.') .OR. 
 
     &        (I .NE. 1 .AND. NRQ(CTEMM1) .EQ. -1 .AND.
     &        (ISDIGI(CTEMP1) .OR. CTEMP1 .EQ. 'X'))) THEN

             I     = I + 1
             IUMIN = -1
             CTEMP = EXPR(I:I)
           ENDIF
        ENDIF

        IF (CTEMP .EQ. '.') THEN
C          IS DECIMAL POINT 
           I = I+1
           IF (.NOT. ISDIGI(EXPR(I:I)) .AND. EXPR(I:I) .NE. 'E') RETURN
           FRAC  = 0.1
           NINT  = 1

	ELSEIF (CTEMP.NE.'X'.AND. .NOT. ISDIGI(CTEMP)) THEN
C          IS NEITHER A DIGIT NOR AN X
           EXPR1(K:K) = EXPR(I:I)
           K = K + 1
           GOTO 41

        ELSEIF (CTEMP .EQ. 'X') THEN
C          EVALUATE REGISTER
           READ(EXPR(I+1:I+1),30) IVAL
           IF (ISDIGI(EXPR(I+2:I+2))) THEN
C            HAVE 2ND DIGIT FOR REGISTER NUMBER
             READ(EXPR(I+2:I+2),30) IVAL1
             IVAL = 10*IVAL+IVAL1
             I    = I+1
           ENDIF
           VAL(J) = PARAM(IVAL+1)*IUMIN

           WRITE(EXPR1(K:K),30) J

           K = K+1
           I = I+1
           J = J+1
           GOTO 41
        ENDIF

C       MUST BE A DIGIT
        ITEMP3 = 0

C       PROCESSING A NUMBER IN A LOOP
23      READ(EXPR(I:I),30) ITEMP
	VAL(J) = NINT*VAL(J)+ITEMP*FRAC
	IF (FRAC .NE. 1.) FRAC = FRAC / 10.
        IF ((I+1) .GT. LEN) GOTO 28

	IF (.NOT. ISDIGI(EXPR(I+1:I+1))) THEN
C          THIS DIGIT IS NOT FOLLOWED BY A ANOTHER DIGIT

           IF (EXPR(I+1:I+1) .EQ. 'E') THEN
C             NUMBER CONTAINS EXPONTIAL NOTATION NOW
              IF((I+2) .LE. LEN .AND.(
     &           EXPR(I+2:I+2) .EQ. '-' .OR. 
     &           EXPR(I+2:I+2) .EQ. '+' .OR.
     &           ISDIGI(EXPR(I+2:I+2)))) THEN
C                HAS >= 1 DIGIT AFTER THE E
                 I       = I + 2
                 IEXPGO  = I 
                 DO WHILE (I+1 .LE. LEN .AND. ISDIGI(EXPR(I+1:I+1)))
                    I = I + 1
                 ENDDO
C                END OF DIGITS AFTER E, EVALUATE THE EXPONENT
                 READ(EXPR(IEXPGO:I),*) ITEMP3    
              ELSE
                 I = I + 1
              ENDIF
C             EVALUATE THE NUMBER NOW
              GOTO 28
           ENDIF
C          IF NOT A DECIMAL POINT THEN EVALUATE THE NUMBER NOW
           IF (EXPR(I+1:I+1) .NE. '.') GOTO 28

           IF (.NOT. ISDIGI(EXPR(I+2:I+2))) THEN
C             CHAR. AFTER . IS NOT A DIGIT, EVALUATE THE NUMBER NOW
              I = I + 1
              GOTO 28
           ENDIF
           I     = I + 2
           FRAC  = 0.1
           NINT  = 1
           IF (.NOT. ISDIGI(EXPR(I:I))) GOTO 28
        ELSE
C          PROCESS NEXT DIGIT IN NUMBER
           I = I + 1
        ENDIF
        GOTO 23
C       END OF NUMBER PROCESSING LOOP


C       EVALUATE THE NUMBER
28	FRAC   = 1.
	NINT   = 10
	VAL(J) = VAL(J)*IUMIN
        IF (ITEMP3 .NE. 0) THEN
C          USE EXPONENTIAL VALUE HERE
           VAL(J) = VAL(J) * (10.0 ** ITEMP3)
        ENDIF

        WRITE(JCHAR,30) J
30	FORMAT(I1)
	EXPR1(K:K) = JCHAR
	J = J+1
	K = K+1


41	IF (I .LT. LEN) GOTO 40
C       --------------------- end loop ------------------------


	EXPR1(K:K) = ')'
	NCHAR2 = K+1
	IPNT  = 1
	ITOP  = 1
	STACK(1:1)='('
	IRANK = 0
	I     = 0

4	NEXT = EXPR1(IPNT:IPNT)
	IPNT = IPNT+1
	IF (IPNT .GT. NCHAR2) THEN
C          CHANGED TO MAKE MOD(X,Y) WORK
           IF ((NM.NE.7 .OR. ITOP.NE.0) .AND. 
     &         (ITOP.NE.0 .OR. IRANK.NE.1)) RETURN
           J = 1
           GOTO 24
        ENDIF

	IF (ITOP .LT. 1) RETURN

7	IF (NFQ(NEXT) .LE. NGQ(STACK(ITOP:ITOP))) THEN
          IF (NFQ(NEXT).NE. NGQ(STACK(ITOP:ITOP))) THEN
             I = I + 1
             POLISH(I:I) = STACK(ITOP:ITOP)
             IRANK       = IRANK+NRQ(STACK(ITOP:ITOP))
             IF (IRANK .LE. 0) RETURN
             ITOP = ITOP - 1
             GOTO 7
          ENDIF
          ITOP = ITOP - 1

        ELSE
          ITOP = ITOP+1
          STACK(ITOP:ITOP) = NEXT
        ENDIF
        GOTO 4


24	DO 13 N=1,I
           CTEMP=POLISH(N:N)
           IF (NRQ(CTEMP).NE.-1) GOTO 13

           READ(POLISH(N-2:N-2),30) ITEMP1
           READ(POLISH(N-1:N-1),30) ITEMP2

           IF (CTEMP.EQ.'+') THEN
             TEMP=VAL(ITEMP1)+VAL(ITEMP2)

           ELSEIF (CTEMP.EQ.'-') THEN
             TEMP=VAL(ITEMP1)-VAL(ITEMP2)

           ELSEIF (CTEMP.EQ.'*') THEN
             TEMP=VAL(ITEMP1)*VAL(ITEMP2)

           ELSEIF (CTEMP.EQ.'/') THEN
              IF(VAL(ITEMP2).EQ. 0.) THEN
                 WRITE(NOUT,*) ' *** DIVISION BY ZERO'
                 RETURN
              ENDIF
              TEMP=VAL(ITEMP1)/VAL(ITEMP2)

           ELSEIF(VAL(ITEMP1).LT.0.) THEN
              IV=VAL(ITEMP2)
              DIF=ABS(VAL(ITEMP2)-IV)
              IF(DIF.LT.0.001) THEN
                 TEMP=VAL(ITEMP1)**IV
              ELSE
                 WRITE(NOUT,*) ' *** UNDEFINED EXPONENTIATION'
                 RETURN
              ENDIF
           ELSE
              TEMP=VAL(ITEMP1)**VAL(ITEMP2)
           ENDIF

           VAL(ITEMP1)=TEMP

           DO  L=N-1,I-2
             POLISH(L:L)=POLISH(L+2:L+2)
           ENDDO

           I=I-2
           GOTO 24
13	CONTINUE

	VALUE=VAL(1)
C       SET CORRECT ERROR RETURN
	IF(NM.EQ.0) THEN
          IFLAG=0
          RETURN
        ENDIF

	GOTO(110,120,130,140,150,160,170,180,190,
     &		195,196,197,198,199),NM

110	IVAL = VALUE+0.5
	IF (VALUE.LT.0.) IVAL=VALUE-0.5
   	NPOW=LOG2(IVAL)
	VALUE = 2**NPOW
	IFLAG = 0
	RETURN

120	VALUE = VALUE/180.*PI  
c**     CHANGED TO DEGREES 7/89 MR
        VALUE = SIN(VALUE)
	IFLAG = 0
	RETURN

130	VALUE = EXP(VALUE)
	IFLAG = 0
	RETURN

140	IF (VALUE.LE.0.)RETURN
	VALUE = ALOG10(VALUE)
	IFLAG = 0
	RETURN

150	VALUE =  VALUE/180.*PI  
C       CHANGED TO DEGREES 7/89 MR
        VALUE = COS(VALUE)
	IFLAG = 0
	RETURN

160	IF (VALUE.LT.0.) RETURN
	VALUE = SQRT(VALUE)
	IFLAG = 0
	RETURN

170	VALU2 = VAL(2)
        VALUE = MOD(VALUE,VALU2)
	IFLAG = 0
        RETURN

180	VALUE = INT(VALUE)
	IFLAG = 0
	RETURN

190	IF (VALUE.LT.0.0) VALUE = -VALUE
	IFLAG = 0
	RETURN

195	VALUE = ATAN(VALUE)        
C       ADDED ON 8/27/86 BY NAIK
        VALUE = VALUE/PI*180.
	IFLAG = 0
	RETURN

196     IF (ABS(VALUE).GT.1) RETURN
        VALUE = ASIN(VALUE)
        VALUE = VALUE/PI*180.
        IFLAG = 0
        RETURN

197     IF (ABS(VALUE).GT.1) RETURN
        IFLAG = 0
        VALUE = ACOS(VALUE)
        VALUE = VALUE/PI*180.
        IFLAG = 0
        RETURN

198	IF (VALUE.LE.0.)RETURN
	VALUE = ALOG(VALUE)
	IFLAG = 0
	RETURN

199	CALL TIME(CNXT)
	KST   = NXT(4)
C       HAVE TO INITIALIZE EVERY TIME, OTHERWISE MO COMMAND CAN 
C       CHANGE GFLAG
        CALL MRAND(OUT,KST,GFLAG,NOUT) 
	CALL  GETRAND(OUT)
	VALUE = OUT
	IFLAG = 0
	RETURN

	END
