
C++*************************************************************************
C
C $$ EXPRESSQ.FOR                         
C                            FILENAMES LENGTHENED JAN 89 al
C
C **************************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK            *
C *  COPYRIGHT (C)1981,1987, WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH 			   *
C **************************************************************************
C
C  $$ EXPRESSQ(STRING,NCHAR,VAL1,VAL2)
C
C     PURPOSE:     RETURNS TRUE AND EVALUATES ONE OR TWO REGISTER 
C                  EXPRESSIONS IF "X" OCCURS IN INPUT LINE.  OTHERWISE 
C                  RETURNS FALSE.
C                  
C
C     PARAMETERS: STRING        INPUT STRING
C                 NCHAR         NO. OF CHARS IN INPUT STRING
C                 VAL1          FIRST RETURNED VALUE
C                 VAL2          SECOND RETURNED VALUE
C
C--*******************************************************************

	LOGICAL FUNCTION EXPRESSQ(STRING,NCHAR,VAL1,VAL2)

	INCLUDE 'CMBLOCK.INC' 

	LOGICAL        COMMA

        CHARACTER *(*) STRING
        CHARACTER *80  SQSTR
        CHARACTER      ST

	EXPRESSQ = .FALSE.
	COMMA    = .FALSE.

C       DETERMINE IF INPUT LINE CONTAINS A REGISTER "X"
        IX = INDEX(STRING(1:NCHAR),'X')
        IF (IX .LE. 0) RETURN

C*      ADDED MAY 10 1990 al
        VAL2 = 0.0

C       FIND FIRST REGISTER EXPRESSION STRING BETWEEN START AND COMMA OR 
C       BETWEEN START AND FIRST SEMICOLON OR BETWEEN START AND FINISH

C       ZERO THE SQUEEZED SUB-STRING
	ICOUNT = 0
        SQSTR  = CHAR(0)

	DO  I=1,NCHAR
           IC = I
           ST = STRING(I:I)

           IF (ST .EQ. ';') THEN
              GOTO 15

           ELSEIF (ST .EQ. ',') THEN
              COMMA =.TRUE.
              GOTO 15

           ELSEIF (ST .NE. ' ') THEN
C             SQUEEZE BLANKS OUT OF EXPRESSION
              ICOUNT = ICOUNT + 1
              SQSTR(ICOUNT:ICOUNT) = ST
           ENDIF
	ENDDO

C       EVALUATE THE REGISTER EXPRESSION IN THIS SUB-STRING
15      CALL EVALNQ(SQSTR(1:ICOUNT),ICOUNT,VAL1,IFLAG)

	IF (IFLAG .NE. 0)THEN
           WRITE(NOUT,*) ' *** INVALID REGISTER EXPRESSION IN INPUT'
           RETURN
	ENDIF
	EXPRESSQ = .TRUE.

C       IF NO COMMA FOUND THEN THERE IS NO MORE INPUT TO BE CHECKED
	IF (.NOT. COMMA) RETURN


C       ZERO THE SQUEEZED SUB-STRING
	ICOUNT2 = 0
        SQSTR   = CHAR(0)

	DO I = IC+1,NCHAR

           ST = STRING(I:I)
           IF (ST .EQ. ';' .OR. ST .EQ. ',') GOTO 22
           IF (ST .NE. ' ') THEN
C             SQUEEZE BLANKS OUT OF EXPRESSION
              ICOUNT2 = ICOUNT2 + 1
              SQSTR(ICOUNT2:ICOUNT2) = ST
           ENDIF
        ENDDO

C       EVALUATE THE REGISTER EXPRESSION IN THIS SUB-STRING
22      CALL EVALNQ(SQSTR,ICOUNT2,VAL2,IFLAG)
	IF (IFLAG .NE. 0) THEN
           WRITE(NOUT,*) 
     &       '*** INVALID 2ND REGISTER EXPRESSION IN INPUT'
           EXPRESSQ = .FALSE.
           RETURN
	ENDIF

	EXPRESSQ = .TRUE.

        RETURN
	END

