
C++**********************************************************************
C
C EXPRQ.F                     ADAPTED FROM EXPR.FOR FOR CHAR. AUG 89 al
C
C **************************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK            *
C *  COPYRIGHT (C)1981,1987, WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH 			   *
C **************************************************************************
C
C    EXPRQ(OLDSTR,L,VALUE,IFLAG)
C
C    PURPOSE:    SUBROUTINE TO EVALUATE GENERAL ARITHMETIC EXPRESSION
C
C **************************************************************************

	SUBROUTINE EXPRQ(OLDSTR,L1,VALUE,IFLAG)

        CHARACTER *(*) OLDSTR
        CHARACTER *80  NEWSTR
        CHARACTER      CCHAR
        LOGICAL * 1    BYTSTR(80)
        LOGICAL * 1    BCHAR
        EQUIVALENCE    (BCHAR,CCHAR)
        LOGICAL        DEBUG

	COMMON /UNITS/ LUN,NIN,NOUT
	COMMON /DOLOOP/IALPHA(26)
	COMMON /PARAM/ PARAM(103),NSEL(10)

	IFLAG = 0
	VALUE = 0.0

	CALL SHRINKQ(OLDSTR(1:L1),L1,NEWSTR,L2)

C**********************************88
C        DEBUG = .FALSE.
C        IF (NEWSTR(1:1) .EQ. '4' ) DEBUG = .TRUE.
C        DO 1 I=1,L2
C           CCHAR = NEWSTR(I:I)
C           BYTSTR(I) = BCHAR
C1       CONTINUE
C******************************

	IF (L2 .LE. 3 .AND. NEWSTR(1:1) .EQ. 'X') THEN
C          EXPRESSION STARTS WITH 'X' AND HAS LENGTH 2 OR 3, IT CONSISTS
C          OF A SINGLE REGISTER - EVALUATE
           IF (L1 .EQ. 2) THEN
             READ(NEWSTR(2:2),605,IOSTAT=IER) ITEMP
605          FORMAT(I1)
           ELSE
             READ(NEWSTR(2:3),606,IOSTAT=IER) ITEMP
606          FORMAT(I2)
           ENDIF
           IF (IER .NE. 0) THEN
C             ERROR CONVERTING REGISTER TO INTEGER
              IFLAG = -1
              RETURN
           ENDIF
           VALUE=PARAM(ITEMP+1)

        ELSEIF( L1 .EQ. 1 .AND. NEWSTR(:1) .GE. 'A') THEN

C          EXPRESSION HAS LENGTH 1, AND IT'S NOT A NUMBER, INTERPRET
C          AS A DO-LOOP INDEX - EVALUATE IT!

           IDX   = ICHAR(NEWSTR(1:1)) - 64
           VALUE = IALPHA(IDX)
           IF (IALPHA(IDX) .EQ. 0) IFLAG = -1

        ELSEIF (NEWSTR(:1) .EQ.'P' .AND. L1 .LE. 3) THEN

C          EXPRESSION STARTS WITH 'P', AND HAS LENGTH 2 OR 3, IT IS A
C          SYMBOLIC REFERENCE - GET IT!
C          CURRENTLY NOT IMPLEMENTED
           IFLAG = -1

        ELSE
C          IF NONE OF THE ABOVE APPLIES, WE HAVE A TRUE ARITHMETIC EXPRESSION!
C           IF (DEBUG) THEN
C             CALL EVALN(BYTSTR,L1,VALUE,IFLAG)
C           ELSE
             CALL EVALNQ(NEWSTR,L1,VALUE,IFLAG)
C           ENDIF
        ENDIF

	RETURN
	END
