C
C $$ F3MR.FOR
C
C **************************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK            *
C *  COPYRIGHT (C)1981,1987, WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *  THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR       *
C *  LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR    *
C *  USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF     *
C *  THE CENTER FOR LABORATORIES AND RESEARCH   			   *
C **************************************************************************
C  For order of elements see fmr_1.
C
C
C--************************************************************************
C
C $$ F3MR.FOR
C
#ifdef SP_MP
	SUBROUTINE F3MR(A,NSAM,NROW,NSLICE,INV,DUMMY)	
	DIMENSION A(NSAM,NROW,NSLICE),WORK(2048),DUMMY(*)
C
	LOGICAL*1 IFND,IFNR
CNO_SAVE
	IF(MAX0(NSAM,2*NROW,2*NSLICE).GT.2048)  THEN
	CALL  ERRT(6,' F3MR ',NE)
	INV=0
	RETURN
	ENDIF
#else
	SUBROUTINE F3MR(A,NSAM,NROW,NSLICE,INV,WORK)	
	DIMENSION A(NSAM,NROW,NSLICE),WORK(*)
C
	LOGICAL*1 IFND,IFNR
#endif
c
	NDR=INV*NSAM*NROW
c
        IFNR=MOD(NROW,2).EQ.0
	IFND=MOD(NSAM,2).EQ.0
	IF(IFND)  THEN
	LBD=2
	ELSE
	LBD=1
	ENDIF
	IF(IFNR) THEN
	LBR=2
	ELSE
	LBR=1
	ENDIF
C
	IF(INV.LT.0)  GOTO  2
C
	DO   I=1,NSLICE
	CALL FMR_2(A(1,1,I),NSAM,NROW,WORK,INV)
	IF(INV.EQ.0)  RETURN
	ENDDO 
C
2	CONTINUE
c$doacross local(j,i,k,work),share(invt)
	do    J=1,LBR
	do    I=1,LBD
	do    K=1,nslice
	work(nslice+k)=a(i,j,k)
	enddo
	INVT=INV
	call fmr_1(work(nslice+1),nslice,work,invt)
	do    K=1,nslice
	a(i,j,k)=work(nslice+k)
	enddo
	ENDDO
	ENDDO
	IF(INVT.EQ.0)  THEN
        INV=0
        RETURN
        ENDIF
c
c$doacross local(i,j),share(invt)
	DO    I=1,LBD
	DO    J=3,NROW-1,2
	INVT=NDR
	CALL FFTMCF(A(I,J,1),A(I,J+1,1),NSLICE,NSLICE,NSLICE,INVT)
	ENDDO
	INVT=NDR
	IF(.NOT.IFNR)  CALL FFTMCF
     &		(A(I,NROW,1),A(I,2,1),NSLICE,NSLICE,NSLICE,INVT)
	ENDDO
	IF(INVT.EQ.0)  THEN
        INV=0
        RETURN
        ENDIF
c
c$doacross local(j,i),share(invt)
	DO    J=1,NROW
	DO    I=3,NSAM-1,2
	INVT=NDR
	CALL FFTMCF(A(I,J,1),A(I+1,J,1),NSLICE,NSLICE,NSLICE,INVT)
	ENDDO
	INVT=NDR
	IF(.NOT.IFND)  CALL FFTMCF
     &		(A(NSAM,J,1),A(2,J,1),NSLICE,NSLICE,NSLICE,INVT)
	ENDDO
	IF(INVT.EQ.0)  THEN
        INV=0
        RETURN
        ENDIF
	IF(INV.EQ.1) RETURN
C NORMALIZE FOR INVERSE
	Q=1.0/FLOAT(NSLICE)
c$doacross local(k,j,i)
	DO    K=1,NSLICE
	DO    J=1,NROW
	DO    I=LBD+1,NSAM
	A(I,J,K)=A(I,J,K)*Q
	ENDDO
	ENDDO
	DO    J=LBR+1,NROW
	DO    I=1,LBD
	A(I,J,K)=A(I,J,K)*Q
	ENDDO
	ENDDO
	ENDDO
C
	DO    I=1,NSLICE
	CALL FMR_2(A(1,1,I),NSAM,NROW,WORK,INV)
	IF(INV.EQ.0)  RETURN
	ENDDO
	END
