C++************************************************************************
C
C $$ FALB_P.FOR
C
C **************************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK            *
C *  COPYRIGHT (C)1981,1987, WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *  THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR       *
C *  LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR    *
C *  USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF     *
C *  THE CENTER FOR LABORATORIES AND RESEARCH   			   *
C **************************************************************************
C
C
C
C--************************************************************************
C
C $$ FALB_P.FOR
C
         SUBROUTINE  FALB_P(BUF,ILIST,NSAM,NROW,LSAM,LROW,NIMA,
     &   NRING,LCIRC,MAXRIN,JACUP,NUMR,
     &   CIRC,X,WORK,BUFIN,ROT,CIROLD,CIRNEW,CIRTMP,
     &   TEMP,EC,DIST,MODE,NOUT)
         PARAMETER  (NLIST=5)
         INTEGER*2  MAXRIN,MAXRI
         DIMENSION  X(NSAM,NROW),BUFIN(LSAM),WORK(*)
         DIMENSION  CIRC(LCIRC,NIMA)
         DIMENSION  CIROLD(LCIRC),CIRNEW(LCIRC),CIRTMP(LCIRC)
         INTEGER*2  NUMR(3,NRING)
         DOUBLE PRECISION TEMP(MAXRIN,2)
         DOUBLE PRECISION ENER,TOTMIN,SOLD,SNEW,EAV,EC(NIMA)
         DIMENSION  DIST(NIMA)
         DIMENSION  ILIST(NIMA),DLIST(NLIST),BUF(1024),ROT(NIMA)
         CHARACTER*80  FINPIC
         CHARACTER*80  FINPAT
         COMMON  /F_SPEC/  FINPAT,NLET,FINPIC
         COMMON  /MXR/  MAXRI
         LOGICAL*1  CH_ANG
         CHARACTER*1  MODE
         CHARACTER*8  ZEIT
         DATA  INPIC/77/,NDOC/55/
CNO_SAVE
C
         MAXRI=MAXRIN
C
         LQ=LROW/2+1
         LR1=(NROW-1)/2
         LR2=LQ+LR1
         LR1=LQ-LR1
         LQ=LSAM/2+1
         LS1=(NSAM-1)/2
         LS2=LQ+LS1
         LS1=LQ-LS1
         DO    K1=1,NIMA
         CALL  FILGET(FINPAT,FINPIC,NLET,ILIST(K1),INTFLAG)
         CALL  OPENFB(BUF,FINPIC,INPIC,LSAM,LROW,'O',NF,NSL)
         IF(NF.NE.2)  THEN
         WRITE(NOUT,2032)  FINPIC
2032     FORMAT(' File not found ',A80,/,' Operation abandoned')
         RETURN
         ENDIF
         DO    K2=LR1,LR2
         CALL  REDLIN(INPIC,BUFIN,LSAM,K2)
         DO    K3=LS1,LS2
         X(K3-LS1+1,K2-LR1+1)=BUFIN(K3)
	 ENDDO
	 ENDDO
	
         CLOSE(INPIC)
C
         CALL  ALRQ(X,NSAM,NROW,NUMR,CIRC(1,K1),LCIRC,NRING,MODE,K1)
         CALL  FOURING(CIRC(1,K1),LCIRC,NUMR,NRING,EC(K1),MODE)
	 ENDDO
C
C  Build first average
C
         CALL  TIME(ZEIT)
         ISEED=MOD(ICHAR(ZEIT(4:4))+100*ICHAR(ZEIT(5:5))+
     &   1000*ICHAR(ZEIT(7:7))+10000*ICHAR(ZEIT(8:8)),340189)
C
C  Two estimation of initial average are used
C  Only one !!!  11/06/91
C
         DO    ICR=1,1
C
C  DIST  is used here for the random choosing of images
C
         DO    IMI=1,NIMA
         DIST(IMI)=0.0
	 ENDDO
         IMI=MIN0(NIMA,MAX0(1,INT(RAND_P(ISEED)*NIMA+0.5)))
C
         DO    I=1,LCIRC
         CIROLD(I)=CIRC(I,IMI)
	 ENDDO
         ROT(IMI)=1
         DO    KTN=2,NIMA
C
804      M=MIN0(NIMA,MAX0(1,INT(RAND_P(ISEED)+0.5)))
         IMI=0
         DO  809  I=1,NIMA
         IF(DIST(I).EQ.1.0)  GOTO  809
         IMI=IMI+1
         IF(IMI.EQ.M)  GOTO  810
809      CONTINUE
         GOTO  804
810      IMI=I
         DIST(IMI)=1.0
C
         CALL  CROSRNG
     &   (CIROLD,CIRC(1,IMI),LCIRC,NRING,TEMP,TEMP(1,2),
     &   MAXRIN,JACUP,NUMR,TOTMIN,TOT,MODE)
         ROT(IMI)=TOT
         CALL  UPDTC
     &   (CIROLD,CIRC(1,IMI),LCIRC,NRING,NUMR,TOT,MAXRIN,KTN)
	 ENDDO
C
         SOLD=ENER(CIROLD,LCIRC,NRING,NUMR,MODE)
         WRITE(NOUT,2037)  ICR,SOLD
2037     FORMAT(' Random approximation #',I1,' Squared sum =',1PE12.5)
         IF(ICR.EQ.1)  THEN
         DO    I=1,LCIRC
          CIRNEW(I)=CIROLD(I)
	 ENDDO
         ELSE
         CALL  CROSRNG
     &   (CIROLD,CIRNEW,LCIRC,NRING,TEMP,TEMP(1,2),
     &   MAXRIN,JACUP,NUMR,TOTMIN,TOT,MODE)
         CALL  UPDTC(CIROLD,CIRNEW,LCIRC,NRING,NUMR,TOT,MAXRIN,2)
         SOLD=ENER(CIROLD,LCIRC,NRING,NUMR,MODE)
         WRITE(NOUT,2038)  SOLD
2038     FORMAT(' Initial average. Squared sum =',1PE12.5)
         DO    IMI=1,NIMA
          ROT(IMI)=0
	 ENDDO
         ENDIF
	 ENDDO
C     PRINT  *,SOLD*FLOAT(NIMA)/(NIMA-1)
C     PRINT  2001,(ANG(ROT(J),MODE),J=1,NIMA)
2001     FORMAT(8(1X,F8.3))
C
C  Iterations to get better approximation
C
         ITER=0
901      CONTINUE
         ITER=ITER+1
         CH_ANG=.FALSE.
C
         DO    IMI=1,NIMA
         CALL  OUTRNG
     & (CIROLD,CIRC(1,IMI),CIRTMP,LCIRC,NRING,NUMR,ROT(IMI),MAXRIN,NIMA)
         CALL  CROSRNG
     &   (CIRTMP,CIRC(1,IMI),LCIRC,NRING,TEMP,TEMP(1,2),
     &   MAXRIN,JACUP,NUMR,TOTMIN,TOT,MODE)
         IF(ROT(IMI).NE.TOT)  THEN
         CH_ANG=.TRUE.
         ROT(IMI)=TOT
         ENDIF
      CALL  UPDTC(CIRNEW,CIRC(1,IMI),LCIRC,NRING,NUMR,TOT,MAXRIN,IMI)
	 ENDDO
         SNEW=ENER(CIRNEW,LCIRC,NRING,NUMR,MODE)
         WRITE(NOUT,2030)  ITER,SNEW
2030     FORMAT('  Iteration #',I4,'  New squared sum =',1PE12.5)
         IF(SNEW.GE.SOLD.AND.CH_ANG)  THEN
         DO  I=1,LCIRC 
          CIROLD(I)=CIRNEW(I)
	 ENDDO
         SOLD=SNEW
         GOTO  901
         ENDIF
         WRITE(NOUT,2001)  (ANG(ROT(J),MODE),J=1,NIMA)
         DLIST(5)=1.0
         DO   IMI=1,NIMA
C  Calculate distances
         CALL  OUTRNG
     & (CIROLD,CIRC(1,IMI),CIRTMP,LCIRC,NRING,NUMR,ROT(IMI),MAXRIN,NIMA)
         CALL  CROSRNG
     &   (CIRTMP,CIRC(1,IMI),LCIRC,NRING,TEMP,TEMP(1,2),
     &   MAXRIN,JACUP,NUMR,TOTMIN,TOT,MODE)
         EAV=ENER(CIRTMP,LCIRC,NRING,NUMR,MODE)
         DLIST(1)=IMI
         DLIST(2)=ILIST(IMI)
         DLIST(3)=ANG(ROT(IMI),MODE)
         DLIST(4)=EAV+EC(IMI)-2.0*TOTMIN
         CALL  SAVD(NDOC,DLIST,NLIST,IRTFLG)
	 ENDDO
         CALL  SAVDC
         CLOSE(NDOC)
         END
