
C-**********************************************************************
C
C     USED IN FUZZY CLASSIFICATION
C
C     CALLED BY:   FCMTST
C
C-**********************************************************************
C
C   X     : PATTERN MATRIX
C   V     : CLUSTER CENTER MATRIX
C   U     : MEMBERSHIP FUNCTION MATRIX (OUTPUT)
C   MN,MP,MC : DIMENSIONS OF MATRICES X,V AND U IN DE MAIN PROGRAM
C   N,IP,IC  : NUMBERS OF PATTERNS, FEATURES AND CLUSTERS
C   AM    : DEGREE OF FUZZYNESS (USUALY 2.)
C   MAXIT : MAXIMUM NUMBER OF ITERATIONS ALLOWED
C   EPSIL : ACCURACY (USUALY .001)
C   ITER  : NUMBER OF ITERATIONS (OUPUT)
C 
C-jmc
C
C   The inicialization is done in fcmtest over the clusters centers
C
C   The stopping criterium is on the clusters centers coordinates. If
C   ANY of these coordinates changes by more than Epsil it iterates over
C   again
C
C-jmc end
C-**********************************************************************

      SUBROUTINE FCM(N,IP,IC,AM,MAXIT,EPSIL,ITER)

       PARAMETER (MN=999,MP=10,MC=10)  


      REAL   CONST,X(MN,MP),V(MC,MP),U(MC,MN),RDUM(80)
      DOUBLE PRECISION   SUMU,SUMUX,SUM,DIST
      COMMON RDUM,X,U,V
C
        CONST=1./(1.-AM)
C
        DO  ITER=1,MAXIT
C
        AJU=0.
C       UPDATE THE MEMBERSHIP MATRIX
C
        IF  (ITER.EQ.1) AJU=EPSIL
        DO 6 K=1,N
C
        DO  I=1,IC
           U(I,K)=0.
           DO  L=1,IP
            U(I,K)=U(I,K)+(X(K,L)-V(I,L))*(X(K,L)-V(I,L))
	   ENDDO
           IF (U(I,K).EQ.0.) THEN 
             DO  J=1,IC
              U(J,K)=0.
	     ENDDO
             U(I,K)=1.
             GOTO 6
           ENDIF
	ENDDO
        SUM=0.
        DO  J=1,IC
          IF ((U(J,K).NE.0.).AND.(U(J,K).NE.1.))
     +          U(J,K)=U(J,K)**CONST
        SUM=SUM+U(J,K)
	ENDDO
        DO  I=1,IC
         U(I,K)=U(I,K)/SUM
	ENDDO
6     CONTINUE
C
C     COMPUTE CLUSTER CENTRES
C
        DO  I=1,IC
           SUMU=0.
           DO  K=1,N
           IF ((U(I,K).NE.0.).AND.(U(I,K).NE.1.))
     +           SUMU=SUMU+U(I,K)**AM
	   ENDDO
           DO  L=1,IP
             SUMUX=0.
             DO  K=1,N
             IF ((U(I,K).NE.0.).AND.(U(I,K).NE.1.))
     +             SUMUX=SUMUX+(U(I,K)**AM)*X(K,L)
	     ENDDO
             ANOR=SUMUX/SUMU
C
C               UPDATE VNORM 
C
                BNORM=ABS(V(I,L)-ANOR)
                IF (BNORM.GT.AJU) AJU=BNORM
           V(I,L)=ANOR
	   ENDDO
	ENDDO
        IF (AJU.LE.EPSIL) RETURN
       ENDDO
C
       ITER=ITER-1
C
       RETURN
       END
