
C-**********************************************************************
C
C     USED IN FUZZY CLASSIFICATION
C
C     CALLED BY:    SCLASF
C
C-**********************************************************************

      SUBROUTINE FCMTST(DLIS,NAITEM,NFACT,NCLU,NOUP,LFACT,KV)

      INCLUDE 'CMBLOCK.INC'
CNO_SAVE

      PARAMETER    (IN=999,NC=10,INF=10)

C     DLIS IS IN COMMON IOBUF
      INTEGER      DLIS(IN),KV(INF)

C     FCM USES THE COMMON ALSO
      COMMON       RDUM(80),X(IN,INF),U(NC,IN),V(NC,INF),
     &             KLAS(IN),IWORK(IN)

      INTEGER      C
      REAL         PK(NC),M
      CHARACTER *1 NULL,ANS

      NULL = CHAR(0)

      N  = NAITEM
      NF = NFACT
      C  = NCLU

       CALL RDPRM2(M,EPSIL,NLOOP,ILOOP,
     * ' FUZZY EXPONENT (1, INF.), EPSILON TO STOP ITERATION')
       CALL RDPRMI(MAXIT,JDUM,NLOOP,ILOOP,
     *             ' MAXIMUM NUMBER OF ITERATIONS ANYWAY =')
       CALL RDPRM(RTHR,NLOOP,ILOOP, 
     *             ' THRESHOLD FOR HARD-PARTITION TRANSFORMATION')

       WRITE (NOUT,1040) N,NF,LFACT,(KV(I),I=1,INF),M,EPSIL,
     *                   MAXIT,C,RTHR

      WRITE (NDAT,1040) N,NF,LFACT,(KV(I),I=1,INF),M,EPSIL,
     *                   MAXIT,C,RTHR
1040  FORMAT (//,' NUMBER OF ITEMS/IMAGES = '
     * ,I5,/,' TOTAL NUMBER OF FACTORS IN CLAS.= ',I2,
     * ' , NUMBER IN IMC= ',I2,/,
     * ' FACTORS USED= ',10I2,/,
     * ' FUZZY PARAMETER = ',F3.1,2X
     * ,' , EPSILON = ',F10.7,2X,/,
     * ' , MAXIMUM ITERATIONS = ',I4,/
     * ,' NUMBER OF CLUSTERS = ',I2,' , THRESHOLD = ',F10.7)

      CALL RDPRMC(ANS,NCHAR,.TRUE.,
     &     ' INPUT INITIAL CLUSTERS CENTERS? (Y/N)',NULL,IRTFLG)

      IF ((ANS .EQ. 'Y') .OR. (ANS .EQ. 'y')) THEN

          DO  I=1,C
             WRITE (NOUT,530) I
530          FORMAT (/, ' CLUSTER NUMBER = ', I2)
             CALL RDPRMI (IDUMP,JDUMP,NLOOP,ILOOP, 
     *       'CORRESPONDING CLUSTER CENTER (IMAGE NUMBER = SEED)')
                 DO  KK=1,N
                    IF (IDUMP.EQ.DLIS(KK)) JDUMP=KK
		 ENDDO
                 DO  II=1,INF
                    V(I,II)=X(JDUMP,II)
		 ENDDO
	  ENDDO
         ELSE

             DO  I=1,C
                DO  II=1,INF
                   V(I,II)=X(I,II)
		ENDDO
	     ENDDO

      ENDIF

C     CALL FUZZY-C-MEANS
      CALL FCM(NAITEM,NFACT,NCLU,M,MAXIT,EPSIL,ITER)

      WRITE (NDAT,110)
110   FORMAT (/,' THE MEMBERSHIP MATRIX ',//,
     *          '   ELEMENT, PERTENENCE, DECISSION, MAX.PERTENCE',//) 
      DO  I=1,N
         RMAXC=0.
         RCCOUNT=0.
         DO  J=1,C
            IF (U(J,I).GT.RMAXC) THEN
               RMAXC=U(J,I)
               RCCOUNT=J
            ENDIF
	 ENDDO
            IF (RMAXC.LT.RTHR) RCCOUNT=0
            KLAS(I)=RCCOUNT+0.5
            WRITE (NDAT,7000) DLIS(I), (U(KK,I), KK=1,C), RCCOUNT,RMAXC
7000        FORMAT (3X,I4,3X,30(F5.2,2X))
      ENDDO

      WRITE (NDAT,120) 
120   FORMAT (/,' THE CLUSTER CENTRES ',//)

C     CLUSTER CENTRES 
      DO  I=1,C
        WRITE (NDAT,'(I3,30(3X,F10.8))') I,(V(I,J),J=1,NF)
      ENDDO

      WRITE (NDAT,121) 
121   FORMAT (/,' TOTAL NUMBER OF ELEMENTS PER CLUSTER (WEIGHT)',//)


      DO  J=1,C
         PK(J)=0.
         DO  I=1,N
            IF (KLAS(I).EQ.J) PK(J)=PK(J)+1.
	 ENDDO
      ENDDO

      DO  I=1,C
         WRITE (NDAT,'(I3,I10)')I,INT(PK(I))
      ENDDO

      WRITE (NDAT,122) 
122   FORMAT (/,' LISTING OF ELEMENTS PER CLUSTER',//)

      DO  I=1,C
        IAUXI=0
        DO  J=1,N
            IF (KLAS(J).EQ.I) THEN 
               IAUXI=IAUXI+1
               IWORK(IAUXI)=DLIS(J)
            ENDIF  
	ENDDO
         WRITE (NDAT,'(/,2X,I4,/)')I
         WRITE (NDAT,'(10(2X,I4))') (IWORK(K), K=1,IAUXI)
      ENDDO

C     WRITE THE CLUSTER FILE TO BE USED BY OTHER PROGRAMS

      WRITE (NOUP) NAITEM, LFACT, NCLU, NFACT, (KV(K), K=1, NFACT)
      WRITE (NOUP) (KLAS(I), I=1,NAITEM), (DLIS(I), I=1,NAITEM),
     *             (PK(L), L=1, NCLU), ((V(L,J),L=1,NCLU), J=1,NFACT)
       
      WRITE (NOUT,*) 
      WRITE (NOUT,*) ' THE NUMBER OF ITERATIONS WAS = ',ITER
      WRITE (NDAT,*) 
      WRITE (NDAT,*) ' THE NUMBER OF ITERATIONS WAS = ',ITER

9999  CONTINUE
      RETURN
      END

