C++*******************************************************************
C
C $$ FFILTS.FOR 
C
C **************************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK            *
C *  COPYRIGHT (C)1981,1987, WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH 			   *
C **************************************************************************
C
C
C $$ FFILTS:
C
C      CALL FFILTS(LUN,NSAM,NROW,NSLICE,NSAMO)
C        LUN         LOGICAL UNIT NUMBER OF FOURIER FILE TO BE FILTERED
C        NSAM,NROW,NSLICE   DIMENSIONS OF FOURIER FILE
C        NSAMO              DIMENSION  OF CORRESPONDING REAL-SPACE FILE
C  
C--*******************************************************************
C
C
	SUBROUTINE FFILTS(LUN,LUNO,NSAM,NROW,NSLICE,NSAMO)
	COMMON DUMMY(80),B(1)
	COMPLEX CB(1)
	INCLUDE 'CMBLOCK.INC' 
	CHARACTER*81  FILNAM
	CHARACTER*1   NULL
	EQUIVALENCE  (CB,B)
	DATA LUNF/27/
        NULL=CHAR(0)
CNO_SAVE
C --
951     WRITE(NOUT,1009)
1009    FORMAT
     &    (' 1 - LOW-PASS,       2 - HIGH-PASS',/,
     &     ' 3 - GAUSS LOW-PASS, 4 - GAUSS HIGH-PASS',/,
     &     ' 5 - FERMI LOW-PASS, 6 - FERMI HIGH-PASS',/,
     &     ' 7 - BUTER LOW-PASS, 8 - BUTER HIGH-PASS',/,
     &     ' 9 - REMEZ')

        CALL RDPRMI(IOPT,IDUM,NLOOP,ILOOP,'Filter type (1-9)')
	IF(IOPT.LT.1.OR.IOPT.GT.9)  GOTO  951
C REMEZ FILTER
C
	IF(IOPT.EQ.9)  THEN
	    CALL  FILERD(FILNAM,NLETI,NULL,'FILTER',IRTFLG)
	    IF(IRTFLG.EQ.-1)  RETURN
	    CALL  OPENF(FILNAM,LUNF,NS1,NR1,'O',NF,NSL1)
	    IF(NF.EQ.1)  THEN
	    NER=4
	    GOTO  881
	    ENDIF
	    IF(IFORM.GT.0 .OR.
     & 		NS1.NE.NSAM.OR.NR1.NE.NROW.OR.NSL1.NE.NSLICE) THEN
	    NER=2
	    GOTO  881
	    ENDIF
C
	NS2=NSAM/2
	DO    K=1,NSLICE
	    DO    J=1,NROW
		NR=(K-1)*NROW+J
		CALL  REDLIN(LUN,CB,NSAM,NR )
		CALL  REDLIN(LUNF,CB(NS2+1),NSAM,NR)
		DO    I=1,NSAM/2
		CB(I)=CB(I)*CB(I+NS2)
		ENDDO
		CALL  WRTLIN(LUNO,CB,NSAM,NR)
	    ENDDO
	ENDDO
	GOTO  882
881	CALL  ERRT(NER,'FF ',NE)
882	CLOSE(LUNF)
	RETURN
	ENDIF
C
C Butterworth filter
	if(IOPT.EQ.7.OR.IOPT.EQ.8)  THEN
              EPS=0.882
              AA=10.624
C
             CALL RDPRM2(FP,FS,NLOOP,ILOOP,
     &       'PASS-BAND FREQUENCY & STOP-BAND FREQUENCY??')
C
             ORD=2.*ALOG10(EPS/SQRT(AA**2-1.0))
             ORD=ORD/ALOG10(FP/FS)
             PARM1=FP/(EPS)**(2./ORD)
C
             GO TO 5768
	ENDIF

c
C OTHER FILTERS
c
952	CALL  RDPRM(PARM1,NLOOP,ILOOP,'FILTER RADIUS')
	IF(PARM1.LT.0.0.OR.PARM1.GT.0.5)  PARM1=0.5*PARM1/(NSAMO/2)
C FERMI DISTRIBUTION FILTER ********************
	IF(IOPT.EQ.5.OR.IOPT.EQ.6)  THEN
C
	 CALL RDPRM(TEMP,NLOOP,ILOOP,'TEMPERATURE(0=CUTOFF)')
C
C  EXPONENTIAL FOR HIGH-PASS OPTION
	 IF(IOPT.EQ.6) TEMP=-TEMP
	ENDIF
5768	NS2=NSAM/2
	NR2=NROW/2
	NL2=NSLICE/2
	X1=FLOAT(NSAMO/2)**2
	Y1=FLOAT(NR2)**2
	Z1=FLOAT(NL2)**2
	PARM=PARM1**2
C
	DO    K=1,NSLICE
	IZ=K-1
	IF(IZ.GT.NL2)  IZ=IZ-NSLICE
	DO    J=1,NROW
	IY=J-1
	IF(IY.GT.NR2)  IY=IY-NROW
	NR=J+(K-1)*NROW
	CALL  REDLIN(LUN,B,NSAM,NR )
	DO  2  I=1,NS2
	IX=I-1
	GOTO(100,200,300,400,500,500,600,700),IOPT
C LOWPASS ********************************
100	IF(0.25*(FLOAT(IX*IX)/X1+FLOAT(IY*IY)/Y1+FLOAT(IZ*IZ)/Z1)
     &	       .GT. PARM)  CB(I)=0.0
	GOTO  2
C
C HIGH PASS ******************
C
200	IF((IX.NE.0 .OR. IY.NE.0 .OR. IZ.NE.0) .AND.
     &  0.25*(FLOAT(IX*IX)/X1+FLOAT(IY*IY)/Y1+FLOAT(IZ*IZ)/Z1)
     &	       .LE. PARM)  CB(I)=0.0
	GOTO  2
C
C GAUSSIAN LOW PASS ***************************
C
300	CB(I)=CB(I)*EXP(-0.25*(
     &	  FLOAT(IX*IX)/X1+FLOAT(IY*IY)/Y1+FLOAT(IZ*IZ)/Z1)/(2.*PARM))
	GOTO  2
C
C GAUSSIAN HIGH PASS ********************************
C
400	IF(IX.NE.0 .OR. IY.NE.0 .OR. IZ.NE.0)
     &	CB(I)=CB(I)*(1.0-EXP(-0.25*(
     &	FLOAT(IX*IX)/X1+FLOAT(IY*IY)/Y1+FLOAT(IZ*IZ)/Z1)/(2.*PARM)))
	GOTO  2
C
C FERMI DISTRIBUTION FILTER ********************
C
500	ARG=(0.5*SQRT(
     &	FLOAT(IX*IX)/X1+FLOAT(IY*IY)/Y1+FLOAT(IZ*IZ)/Z1)-PARM1)/TEMP
	ARG=AMIN1(AMAX1(ARG,-10.0),10.0)
	IF(IOPT.EQ.6.AND.IX.NE.0.AND.IY.NE.0.AND.IZ.NE.0)GOTO 2
	CB(I)=CB(I)*(1.0/(1.0+EXP(ARG)))
	GOTO 2
C BUTTERWORTH  LOWPASS FILTER **********************
C
600	ARG=0.5*SQRT(
     &	FLOAT(IX*IX)/X1+FLOAT(IY*IY)/Y1+FLOAT(IZ*IZ)/Z1)
	CB(I)=CB(I)*SQRT(1.0/(1.0+(ARG/PARM1)**ORD))
	GOTO 2
C
C BUTTERWORTH HIGHPASS FILTER *********************
C
700     IF(IX.NE.0 .OR. IY.NE.0 .OR.IZ.NE.0)THEN
        ARG=0.5*SQRT(
     &	FLOAT(IX*IX)/X1+FLOAT(IY*IY)/Y1+FLOAT(IZ*IZ)/Z1)
	CB(I)=CB(I)*(1.0-SQRT(1.0/(1.0+(ARG/PARM1)**ORD)))
	ENDIF
C
2	CONTINUE
	CALL  WRTLIN(LUNO,B,NSAM,NR)
	ENDDO
	ENDDO
	END
