C++*************************************************************************
C
C    FILCAD.FOR -- CREATED JAN 23 1989
C                  REPLACES FILCOD.FOR     USES LONG FILE NAMES
C
C **************************************************************************
C    AUTHOR:  ARDEAN LEITH
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK            *
C *  COPYRIGHT (C)1981,1987, WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH 			   *
C **************************************************************************
C
C     FILCAD(FILNAM,FILPAT,NUMRET,IRTFLG)
C
C     PURPOSE:   CONVERTS ALL DIGITS AT END OF FILE NAME INTO INTEGER -- 
C                E.G., PIC064 WILL RESULT IN:  NUMRET = 64.
C                AND RETURNS A PATTERN FOR THE FILE NAME, ALSO.
C                OFTEN USED WITH CALL FILGET(FILPAT,FILNAM,NLET,INUM,IRTFLG)
C                TO CREATE A SERIES OF FILES
C
C     PARAMETERS:
C	 FILNAM	   CHAR. VARIABLE HOLDING INPUT FILE NAME   (INPUT)
C	 FILPAT    CHAR. VARIABLE HOLDING FILE NAME PATTERN (RETURNED)
C	 NUMRET    INTEGER VARIABLE TO RETURN NUMBER        (RETURNED)
C        IRTFLG    ERROR FLAG (0 IS NORMAL)                 (RETURNED)
C
C--*******************************************************************

      SUBROUTINE FILCAD(FILNAM,FILPAT,NUMRET,IRTFLG)

        COMMON /UNITS/LUN,NIN,NOUT,NECHO

        CHARACTER *(*) FILNAM,FILPAT
        CHARACTER  * 9  DIGITS,ASTS
        CHARACTER  * 4  FMT2
        CHARACTER  * 1  NULL,CHARI

        DATA ASTS  /'*********'/
        DATA DIGITS/'123456789'/
        DATA FMT2/'(I )'/
        NULL=CHAR(0)

        NLET = INDEX(FILNAM,NULL) - 1

C       GO BACKWARDS THRU FILENAME TO LOCATE DIGITS
        DO I=NLET,1,-1
          CHARI = FILNAM(I:I)
          IF (CHARI .LT. '0' .OR. CHARI .GT. '9' ) GOTO 11
        ENDDO

11      IGO     = I + 1
        NDIGITS = NLET - IGO + 1

        IF (NDIGITS .LE. 0 .OR. NDIGITS .GE. 9) THEN
12         WRITE(NOUT,*) ' *** ILLEGAL FILE NUMBER'
           IRTFLG = 1
           RETURN
        ENDIF           

        FMT2(3:3) = DIGITS(NDIGITS:NDIGITS)

        READ(FILNAM(IGO:NLET),FMT2,ERR=12) NUMRET

        FILPAT  = FILNAM(1:IGO-1) // ASTS(1:NDIGITS) // NULL

        IRTFLG  = 0

        RETURN
        END
