
C++************************************************************************
C
C $$ FILCAN.FOR -- ADAPTED FROM FILCON.FOR OCT 88 al
C                                          LONG FILNAMES
C **************************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK            *
C *  COPYRIGHT (C)1981,1987, WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH 			   *
C **************************************************************************
C
C $ CALL FILCAN(FILNAM,NF,DEV,DIR,MASTER,EXTEN,IER)
C
C   PURPOSE: constructs file name from character strings that contain
C            1) device ,2) directory name, 3) master file name and 
C            4) file extension.
C            This subroutine is installation-dependent. It is written 
C            for the file-naming conventions of the VAX/VMS operating
C            system.
C
C            The file name has the following format:
C	         <dev>:[<dir>]<master>.<exten>
C
C  PARAMETERS:  FILNAM   COMPLETE FILE NAME           (RETURNED)
C               NLET     LENGTH OF COMPLETE FILE NAME (RETURNED)
C               DEV      DEVICE NAME                  (RECEIVED)
C               DIR      DIRECTORY NAME               (RECEIVED)
C               MASTER   MASTER FILE NAME             (RECEIVED)
C               EXTEN    EXTENSION NAME               (RECEIVED)
C               IER      ERROR FLAG (0 IS NORMAL)
C
C ************************************************************************

	SUBROUTINE FILCAN(FILNAM,NLET,DEV,DIR,MASTER,EXTEN,IER)

	COMMON/UNITS/LUN,NIN,NOUT

        CHARACTER *(*)  FILNAM,DEV,DIR,MASTER,EXTEN
        CHARACTER *81   MASTMP
        CHARACTER * 1   NULL

        NULL = CHAR(0)
    
C       SAVE MASTER IN CASE FILNAM IS SAME AS MASTER
C       NULL OUT THE COMPLETE FILE NAME
#ifdef __osf__
        NP = INDEX(MASTER,NULL) - 1
        IF (NP .LT. 0) NP = LEN(MASTER)
	MASTMP = MASTER(1:NP) // NULL
	NLET = LEN(FILNAM)
	FILNAM(1:1) = NULL
#else
	MASTMP = MASTER // NULL
	FILNAM = NULL
#endif

	IER  = 0
C       ZERO THE RETURNED FILE NAME LENGTH
	NLET = 0      

        INDNUL = INDEX(DEV,NULL)
        IF (INDNUL .GT. 1 .OR. 
     &     (INDNUL .EQ. 0  .AND. LEN(DEV) .GT. 1)) THEN
C          DEVICE PROVIDED
           CALL LONGER(FILNAM,NLET,DEV,IRTFLG)
           ILOC = 1
           IF (IRTFLG .EQ. 1) GOTO 799
           CALL LONGER(FILNAM,NLET,':',IRTFLG)
           ILOC = 2
           IF (IRTFLG .EQ. 1) GOTO 799
        ENDIF

        INDNUL = INDEX(DIR,NULL)
        IF (INDNUL .GT. 1 .OR. 
     &     (INDNUL .EQ. 0  .AND. LEN(DIR) .GT. 1)) THEN
C          DIRECTORY PROVIDED
           CALL LONGER(FILNAM,NLET,'[',IRTFLG)
           ILOC = 3
           IF (IRTFLG .EQ. 1) GOTO 799
           CALL LONGER(FILNAM,NLET,DIR,IRTFLG)
           ILOC = 4
           IF (IRTFLG .EQ. 1) GOTO 799
           CALL LONGER(FILNAM,NLET,']',IRTFLG)
           ILOC = 5
           IF (IRTFLG .EQ. 1) GOTO 799
        ENDIF

        CALL LONGER(FILNAM,NLET,MASTMP,IRTFLG)
        ILOC = 6
        IF (IRTFLG .EQ. 1) GOTO 799

        INDNUL = INDEX(EXTEN,NULL)
        IF (INDNUL .GT. 1 .OR. 
     &     (INDNUL .EQ. 0  .AND. LEN(EXTEN) .GT. 1)) THEN
C          EXTENSION PROVIDED IN CALL

C          PUT DOT FOR EXTENSION IN FILENAME
           CALL LONGER(FILNAM,NLET,'.',IRTFLG)
           ILOC = 7
           IF (IRTFLG .EQ. 1) GOTO 799

C          PUT EXTENSION IN FILENAME
           CALL LONGER(FILNAM,NLET,EXTEN,IRTFLG)
           ILOC = 8
           IF (IRTFLG .EQ. 1) GOTO 799
        ENDIF

C       NORMAL RETURN
	RETURN  

799	WRITE(NOUT,51) ILOC,MASTMP
51	FORMAT(' *** ',I1,' CAN NOT CONSTRUCT FILENAME FROM: ',A)
	IER = 1
	RETURN

	END

