C++*************************************************************************
C
C FILDAT.FOR -- CREATED DEC 87 al
C
C **************************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK            *
C *  COPYRIGHT (C)1981,1987, WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH 			   *
C **************************************************************************
C
C    FILDAT(LUN,NSAM)
C
C    PARAMETERS:     LUN       LOGICAL UNIT FOR FILE (ALREADY OPENED)
C
C    CALLED BY:      FILGEN    UTIL1
C
C    NOTE:   THE HEADER RECORD(S) OF THE FILE CONTAINS THE FOLLOWING 
C            BUFFER POSITIONS WHICH CAN BE RETRIEVED (AMONG OTHERS)
C                          7  FMAXD = IMAGE MAXIMUM
C                          8  FMIND = IMAGE MINIMUM
C			   9  AVD   = IMAGE AVERAGE
C                         10  SIG   = STANDARD DEVIATION (SQ. ROOT OF VARIANCE)
C                         11  IHIST = UNUSED
C                         14  IANGLE= FLAG INDICATING THAT TILT ANGLES STORED
C                         15  PHI   = TILT ANGLE
C                         16  THETA = TILT ANGLE
C                         17  PSI   = TILT ANGLE
C                         18  XOFF  = X OFFSET
C                         19  YOFF  = Y OFFSET
C                         20  ZOFF  = Z OFFSET
C                         21  SCALE = SCALE
C                         30  KANGLE= FLAG INDICATING THAT MORE ANGLES STORED
C                         31  PHI2  = PHI OF SECOND EULER ROTATION
C                         32  THETA2= THETA OF SECOND EULER ROTATION
C                         33  PSI2  = PSI OF SECOND EULER ROTATION
C                         34  PHI1  = PHI OF FIRST EULER ROTATION
C                         35  THETA1= THETA OF FIRST EULER ROTATION
C                         36  PSI1  = PSI OF FIRST EULER ROTATION
C
C--*************************************************************************

	   SUBROUTINE FILDAT(LUN,NSAM)

           INCLUDE 'CMBLOCK.INC'
           INCLUDE 'LABLOCK.INC'

           COMMON        ADUM(80),BUF(1)
           DIMENSION     VALUE(1)
           INTEGER       NUMBER(20)
	   INTEGER       ILOW,IHI,IRTFLG
           CHARACTER * 1 CDUM
	
           PARAMETER (PI=3.14159)

           WRITE(NOUT,446) FMIN,FMAX,AV,SIG
446	   FORMAT(6X,'FMIN= ',G10.3,3X,'FMAX= ',G10.3,3X,
     &        'AV=   ',G10.3,3X,'SIG=  ',G10.3)

           IF (IANGLE .GT. 0) WRITE(NOUT,447)PHI,THETA,PSI
447        FORMAT(6X,'PHI=  ',G10.3,3X,'THETA=',G10.3,3X,'PSI=',
     &        G10.3) 

           WRITE(NOUT,448) XOFF,YOFF,ZOFF
448        FORMAT(6X,'XOFF= ',G10.3,3X,'YOFF= ',G10.3,3X,'ZOFF= ',
     &        G10.3/)

           IF (SCALE .NE. 0) WRITE(NOUT,449) SCALE
449        FORMAT(6X,'SCALE=  ',G10.3)

           IF (KANGLE .GT. 0) WRITE(NOUT,450) PHI2,THETA2,PSI2
450        FORMAT(6X,'PHI2= ',G10.3,3X,'THETA2=',G10.3,3X,'PSI2=',
     &        G10.3) 

           IF (KANGLE .EQ. 2) WRITE(NOUT,451) PHI1,THETA1,PSI1
451        FORMAT(6X,'PHI1= ',G10.3,3X,'THETA1=',G10.3,3X,'PSI1=',
     &        G10.3) 

        IF (NSEL(1) .GT. 0) THEN
C         REGISTERS SPECIFIED

          NUMT = 20
	  ILOW = 1
	  IHI  = 256
          CALL RDPRAI(NUMBER,20,NUMT,ILOW,IHI,
     $        'ENTER NUMBER(S) OF HEADER LOCATION TO BE RETRIEVED',
     $        CDUM,IRTFLG)

          IF (NUMBER(1) .EQ. 0) WRITE(NOUT,900)
900          FORMAT(/,' SOME HEADER POSITIONS WHICH CAN BE RETRIEVED:'
     &           ,/,'      7  FMAX   = IMAGE MAXIMUM',/,
     &              '      8  FMIN   = IMAGE MINIMUM',/,
     &              '      9  AVD    = IMAGE AVERAGE',/,
     &              '     10  SIG    = IMAGE STANDARD DEVIATION',/,
     &              '     14  IANGLE = TILT ANGLES STORED FLAG',/,
     &              '     15  PHI    = TILT ANGLE',/,
     &              '     16  THETA  = TILT ANGLE',/,
     &              '     17  PSI    = TILT ANGLE',/,
     &              '     18  XOFF   = X OFFSET',/,
     &              '     19  YOFF   = Y OFFSET',/,
     &              '     20  ZOFF   = Z OFFSET',/,
     &              '     21  SCALE  = SCALE',/)

          DO I = 1,NUMT
             NPAR  = NSEL(I)
             IBUF1 = NUMBER(I)
             IF (IBUF1 .NE. 0 .AND.
     &           NPAR .GE. 1 .AND. NPAR .LE. 103) THEN
C               PLACE A HEADER VALUE INTO PARAMETER(NPAR)

                CALL GETLAB(LUN,NSAM,BUF,IBUF1,1,VALUE,IRTFLG)
                IF (IRTFLG .EQ. 0) THEN      
                   PARAM(NPAR) = VALUE(1)
                   NPM1 = NPAR - 1
                   WRITE(NOUT,*) 'PARAMETER: ',NPM1,' SET TO:',VALUE
                ENDIF
             ENDIF
          ENDDO
          WRITE(NOUT,*) ' '
        ENDIF

        RETURN
	END
