C++*************************************************************************
C
C FILGEN.FOR                 ALTERED NOV 87 FOR NEW FILE FORMAT al
C                             LONG FILENAMES ADDED DEC 88 al
C **************************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK            *
C *  COPYRIGHT (C)1981,1987, WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH 			   *
C **************************************************************************
C
C    FILGEN(FILNAM,LUN1)
C
C    PARAMETERS:     FILNAM    CHAR. VARIABLE FOR FILE NAME
C                    NLET      NUMBER OF CHARS. IN FILE NAME
C                    LUN1      LOGICAL UNIT NUMBER FOR OPENING FILES
C
C--*************************************************************************

	SUBROUTINE FILGEN(FILNAM,NLET,LUN1)

        INCLUDE 'CMBLOCK.INC'

        LOGICAL        NOFIND
        CHARACTER *(*) FILNAM
        CHARACTER *8   FMT2
        CHARACTER *5   FMT

        DATA FMT    /'(I  )'/
        DATA FMT2   /'(I  .  )'/

C       IDIG IS NUMBER OF CONSECUTIVE DIGITS AT END OF THE FIRST FILE NAME
        IDIG = 0
        DO I=NLET,1,-1
             IF (FILNAM(I:I) .LT. '0' .OR. FILNAM(I:I) .GT. '9')GOTO 11
             IDIG = IDIG + 1
        ENDDO

11      IF (IDIG .LE. 0) THEN
C         SPECIAL CASE FOR NO DIGITS AT END OF FILE-NAME
          CALL OPENF(FILNAM,LUN1,NSAM1,NROW1,'OLD',NF,NDUM)

          IF (NF .NE. 1) THEN
C            FILE FOUND. PRINT OUT FILE INFORMATION USING FILDAT
             CALL FILDAT(LUN1,NSAM1)
             CLOSE(LUN1)
          ENDIF
          RETURN
        ENDIF


        WRITE(FMT(3:4),8000,ERR=999) IDIG
        FMT2(3:4) = FMT(3:4)
        FMT2(6:7) = FMT(3:4)
8000    FORMAT(I2)
        READ(FILNAM(I+1:NLET),FMT,ERR=999) IFIRST
        LASTFI = 10**IDIG - 1

20      IFOUND = 0
	NOFIND= .TRUE.
        NUMNOT = 0
C       NUMNOT COUNTS HOW MANY SUCCESSIVE FILES HAVE NOT BEEN FOUND

	K1=1
	K2=0
	DO  IFILE = IFIRST,LASTFI
C         CREATE NEXT FILE NAME
          WRITE(FILNAM(I+1:NLET),FMT2,ERR=999) IFILE

          CALL OPENF(FILNAM,LUN1,NSAM1,NROW1,'OLD',NF,NDUM)

          IF (NF.NE.1) THEN
C            FILE FOUND. PRINT OUT FILE INFORMATION USING FILDAT
C            THIS MULTIPLE LISTING CAN NOT SET PARAMETER VALUES

             CALL FILDAT(LUN1,NSAM1)
	     NOFIND=.FALSE.
             NUMNOT = 0
             CLOSE(LUN1)

           ELSE
C            FILE NOT FOUND
             NUMNOT = NUMNOT +1
             IF (NUMNOT .GT. 10) THEN
C               STOP AFTER 10 NON-EXISTING FILES
                IFOUND = 1
                IF (NOFIND) WRITE(NOUT,*) '*** NO SUCH FILES'
                WRITE(NOUT,*) ' '
                RETURN
             ENDIF
           ENDIF
        END DO

        IF (NOFIND) WRITE(NOUT,*) '*** NO SUCH FILES'
        WRITE(NOUT,*) ' '
        RETURN
           
999     WRITE(NOUT,*) '*** ERROR IN FILENAME OR PGM.'
        RETURN

        END
