C++*************************************************************************
C
C    FILGET.FOR  -- CREATED JAN 89
C                               
C **************************************************************************
C *  AUTHOR: A. LEITH
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK            *
C *  COPYRIGHT (C)1989, WADSWORTH CENTER FOR LABORATORIES AND              *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH 			   *
C **************************************************************************
C
C    FILGET
C
C    PURPOSE:        USED AFTER FILSEQ TO CREATE NEXT FILENAME FROM 
C                    FILE-NAME TEMPLATE AND ARRAY OF FILE NUMBERS.
C                    ANALGOUS TO FILNUM.FOR
C
C    PARAMETERS:     FILPAT    CHAR. FILE NAME PATTERN          (NEEDED)
C                    FILNAM    CHAR. FILE NAME                (RETURNED)
C                    NLET      NUMBER OF LETTERS IN FILE NAME   (NEEDED)
C                    INUM      FILE NUMBER                      (NEEDED)
C                    IRTFLG    ERROR FLAG (0 IS NORMAL)       (RETURNED)
C
C--*************************************************************************

	SUBROUTINE FILGET(FILPAT,FILNAM,NLET,INUM,IRTFLG)

        INCLUDE 'CMBLOCK.INC'

CNO_SAVE
        
        CHARACTER *(*) FILNAM,FILPAT
        CHARACTER *8   FMT
        LOGICAL        ISDIGI, HASAST

        DATA FMT  /'(I  .  )'/

C       SUBSTITUTE FOR STRINGS WITHIN {...} PORTION(S) OF THE FILE NAME
        CALL FILNAMSUB(FILPAT,NLET,.FALSE.,0,IRTFLG)
        IF (IRTFLG .NE. 0) RETURN

C       FIND LOCATION OF FIRST * IN FILPAT
        LENP = INDEX(FILPAT,'*')

        IF (LENP .LE. 0) THEN
C          NO ASTERICKS IN NAME PATTERN. ACCEPT IT ANYWAY, USING DIGIT.
           LENAST = 0
           I      = NLET
           DO WHILE (I .GT. 0 .AND. ISDIGI(FILPAT(I:I))) 
              I      = I - 1
              LENAST = LENAST + 1
           ENDDO 

C          FIND NUMBER OF DIGITS IN FILE NUMBER. 
C          DO NOT MAKE IT EQUAL LENAST
           NUMI = NUMDIG(INUM,1)
        ELSE
C          FIND NUMBER OF * IN FILPAT
           LENAST = NLET - LENP + 1

C          FIND NUMBER OF DIGITS IN FILE NUMBER. IF LESS THAN LENAST
C          MAKE IT EQUAL LENAST

           NUMI = NUMDIG(INUM,LENAST)
        ENDIF

C       FIND 1ST CHAR IN FILPAT THAT WILL BE ALTERED
        IGO = NLET - NUMI + 1

        IF (IGO .LE. 1) THEN
         WRITE(NOUT,90) INUM
90       FORMAT(' *** FILE NUMBER:',I8,' DESTROYS FILE PATTERN.')
         IRTFLG = 1
         RETURN

        ELSEIF (IGO .LT. LENP) THEN
         WRITE(NOUT,91) INUM
91       FORMAT(' WARNING, FILE NUMBER:',I8,' MAY ALTER FILE PATTERN.')
        ENDIF

11      WRITE(FMT(3:4),8000,ERR=999) NUMI
        FMT(6:7) = FMT(3:4)
8000    FORMAT(I2)

        FILNAM = FILPAT

C       CREATE NEXT FILE NAME
        WRITE(FILNAM(IGO:NLET),FMT,ERR=999) INUM
        IRTFLG = 0
        RETURN
           
999     WRITE(NOUT,*) ' *** ERROR IN FILENAME'
        IRTFLG = 1
        RETURN
        END


