
C**************************************************************************
C
C   FILSLI.FOR  -- CREATED OCT 90
C **************************************************************************
C *  AUTHOR: ArDean Leith 
C *  COPYRIGHT (C)1990 , WADSWORTH CENTER FOR LABORATORIES AND RESEARCH    *
C *    NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.              *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH  			   *
C **************************************************************************
C
C      FILSLI(LUNIM,BUF,NSAM,NREC1,NREC2,THLEV,SLICE)  
C
C      PURPOSE:     READS SPIDER PICTURE FILES SLICES INTO SLICE ARRAY 
C
C      PARAMETERS:  
C
C      CALLED BY:   
C
C      CALLS:       REDLIN 
C
C      CALLED BY:   CONINT
C
C--********************************************************************

         SUBROUTINE FILSLI(LUNIM,BUF,NSAM,NREC1,NREC2,THRESH,
     &                     THLEV,SLICE)
 
         INTEGER   * 2  SLICE(*)
         DIMENSION      BUF(*)
         LOGICAL        THRESH

C        READ THE SPIDER FILE INTO SLICE ARRAY

         IPTR = 0 

         IF (THRESH) THEN
           DO  I = NREC1,NREC2
             CALL REDLIN(LUNIM,BUF,NSAM,I)

             DO  J = 1,NSAM
               IPTR = IPTR + 1

               IF (BUF(J) .GT. THLEV) THEN
C                 VOXEL IS ABOVE THRESHOLD
                  SLICE(IPTR) = -1
               ELSE
                  SLICE(IPTR) = 0
               ENDIF
             END DO
           END DO

         ELSE

           DO  I = NREC1,NREC2
             CALL REDLIN(LUNIM,BUF,NSAM,I)

             DO  J = 1,NSAM
               IPTR = IPTR + 1
               SLICE(IPTR) = BUF(J)
             END DO
           END DO

         ENDIF

         RETURN
         END
    
