C++*******************************************************************
C
C $$ FILT3_P.FOR 
C
C **************************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK            *
C *  COPYRIGHT (C)1981,1987, WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH 			   *
C **************************************************************************
C
C
C $$ FILT3_P:
C
C      CALL FILT3_P(LUN,NSAM,NROW,NSLICE)
C        LUN         LOGICAL UNIT NUMBER OF FOURIER FILE TO BE FILTERED
C        NSAM,NROW,NSLICE   DIMENSIONS OF CORRESPONDING REAL-SPACE FILE
C  
C--*******************************************************************
C
C
      SUBROUTINE FILT3_P(LUN,NSAM,NROW,NSLICE)
      COMMON DUMMY(80),B(1)
	INCLUDE 'CMBLOCK.INC' 
	CHARACTER*81  FILNAM
	CHARACTER*1   NULL
	DATA LUNF/27/
        NULL=CHAR(0)
CNO_SAVE
C --
951     WRITE(NOUT,1009)
1009    FORMAT
     &    (' 1 - LOW-PASS,       2 - HIGH-PASS',/,
     &     ' 3 - GAUSS LOW-PASS, 4 - GAUSS HIGH-PASS',/,
     &     ' 5 - FERMI LOW-PASS, 6 - FERMI HIGH-PASS',/,
     &     ' 7 - BUTER LOW-PASS, 8 - BUTER HIGH-PASS',/,
     &     ' 9 - REMEZ')

        CALL RDPRMI(IOPT,IDUM,NLOOP,ILOOP,'Filter type (1-9)')
	IF(IOPT.LT.1.OR.IOPT.GT.9)  GOTO  951
C REMEZ FILTER
C
	IF(IOPT.EQ.9)  THEN
	    CALL  FILERD(FILNAM,NLETI,NULL,'FILTER',IRTFLG)
	    IF(IRTFLG.EQ.-1)  RETURN
	    CALL  OPENF(FILNAM,LUNF,NS1,NR1,'OLD',NF,NSL1)
	    IF(NF.EQ.1)  THEN
	    NER=4
	    GOTO  881
	    ENDIF
	    IF(IFORM.NE.-7 .OR.
     & 		NS1.NE.NSAM.OR.NR1.NE.NROW.OR.NSL1.NE.NSLICE) THEN
	    NER=2
	    GOTO  881
	    ENDIF
C
	DO    K=1,NSLICE
	    DO    J=1,NROW
		NR=(K-1)*NROW+J
		CALL  REDLIN(LUN,B,NSAM,NR )
		CALL  REDLIN(LUNF,B(NSAM+1),NSAM,NR)
		IF(J.LT.3)  THEN
		  IF(K.LT.3)  THEN
		    B(1)=B(1)*B(NSAM+1)
		    B(2)=B(2)*B(NSAM+2)
		  ELSE
		      IF(MOD(K-1,2).EQ.0)  THEN
			IF(J.EQ.1)  THEN
			Z1=B(NSAM+1)
			Z2=B(NSAM+2)
			ELSE
			Z3=B(NSAM+1)
			Z4=B(NSAM+2)
			ENDIF
		      ENDIF
		    IF(J.EQ.1)  THEN
		    B(1)=B(1)*Z1
		    B(2)=B(2)*Z2
		    ELSE
		    B(1)=B(1)*Z3
		    B(2)=B(2)*Z4
		    ENDIF
		  ENDIF      
		ELSE
		      IF(MOD(J-1,2).EQ.0)  THEN
			Y1=B(NSAM+1)
			Y2=B(NSAM+2)
		      ENDIF
		    B(1)=B(1)*Y1
		    B(2)=B(2)*Y2
		ENDIF      
		    DO    I=3,NSAM,2
		    B(I)=B(I)*B(NSAM+I)
		    B(I+1)=B(I+1)*B(NSAM+I)
		    ENDDO
		CALL  WRTLIN(LUN,B,NSAM,NR)
	    ENDDO
	ENDDO
	GOTO  882
881	CALL  ERRT(NER,'FILT2 ',NE)
882	CLOSE(LUNF)
	RETURN
	ENDIF
C
C butterworth filter
	if(IOPT.EQ.7.OR.IOPT.EQ.8)  THEN
              EPS=0.882
              AA=10.624
C
             CALL RDPRM2(FP,FS,NLOOP,ILOOP,
     &       'PASS-BAND FREQUENCY & STOP-BAND FREQUENCY??')
C
             ORD=2.*ALOG10(EPS/SQRT(AA**2-1.0))
             ORD=ORD/ALOG10(FP/FS)
             PARM1=FP/(EPS)**(2./ORD)
C
             GO TO 5768
	Endif

c
C OTHER FILTERS
c
952	CALL  RDPRM(PARM1,NLOOP,ILOOP,'FILTER RADIUS$')
	IF(PARM1.LT.0.0  .OR.  PARM1.GT.0.5)  PARM1=0.5*PARM1/(NSAM/2+1)
C FERMI DISTRIBUTION FILTER ********************
	IF(IOPT.EQ.5.OR.IOPT.EQ.6)  THEN
C
	CALL RDPRM(TEMP,NLOOP,ILOOP,'TEMPERATURE(0=CUTOFF)$')
C
C  EXPONENTIAL FOR HIGH-PASS OPTION
	IF(IOPT.EQ.6) TEMP=-TEMP
	ENDIF
C
5768	NS2=NSAM/2
	NR2=NROW/2
	NL2=NSLICE/2
	X1=FLOAT(NSAM)**2
	Y1=FLOAT(NROW)**2
	Z1=FLOAT(NSLICE)**2
	PARM=PARM1**2
C
	DO    K=1,NSLICE
	K1=K-1
	DO    J=1,NROW
	J1=J-1
	NR=(K-1)*NROW+J
	CALL  REDLIN(LUN,B,NSAM,NR )
	DO  2  I=1,NSAM
	IF(I.LT.3)  THEN
	    IX=(I-1)*NS2
		IF(J.LT.3)  THEN
		IY=J1*NR2
		    IF(K.LT.3)  THEN
		    IZ=K1*NL2
		    GOTO  3
		    ELSE
		    IZ=K1/2
		    GOTO  3
		    ENDIF
		ELSE
		IY=J1/2
		IZ=K1
		IF(IZ.GT.NL2)  IZ=IZ-NSLICE
		GOTO  3
		ENDIF
	ELSE
	    IX=(I-1)/2
	    IY=J1
	    IF(IY.GT.NR2)  IY=IY-NROW
	    IZ=K1
	    IF(IZ.GT.NL2)  IZ=IZ-NSLICE
	ENDIF
 3	CONTINUE
      GOTO(100,200,300,400,500,500,600,700),IOPT
C LOWPASS ********************************
100   IF(FLOAT(IX*IX)/X1+FLOAT(IY*IY)/Y1+FLOAT(IZ*IZ)/Z1
     &	       .GT. PARM)  B(I)=0.0
	GOTO  2
C
C HIGH PASS ******************
C
200   IF((IX.NE.0 .OR. IY.NE.0 .OR. IZ.NE.0) .AND.
     &  FLOAT(IX*IX)/X1+FLOAT(IY*IY)/Y1+FLOAT(IZ*IZ)/Z1
     &	       .LE. PARM)  B(I)=0.0
	GOTO  2
C
C GAUSSIAN LOW PASS ***************************
C
300   B(I)=B(I)*EXP(-(
     &	  FLOAT(IX*IX)/X1+FLOAT(IY*IY)/Y1+FLOAT(IZ*IZ)/Z1)/PARM)
	GOTO  2
C
C GAUSSIAN HIGH PASS ********************************
C
400   IF(IX.NE.0 .OR. IY.NE.0 .OR. IZ.NE.0)
     & B(I)=B(I)*(1.0-EXP(-(
     & FLOAT(IX*IX)/X1+FLOAT(IY*IY)/Y1+FLOAT(IZ*IZ)/Z1)/PARM))
	GOTO  2
C
C FERMI DISTRIBUTION FILTER ********************
C
500	ARG=(SQRT(
     &	  FLOAT(IX*IX)/X1+FLOAT(IY*IY)/Y1+FLOAT(IZ*IZ)/Z1)-PARM1)/TEMP
	ARG=AMIN1(AMAX1(ARG,-10.0),10.0)
	IF(IOPT.EQ.6 .AND. IX.NE.0 .AND. IY.NE.0 .AND. IZ.NE.0)goto 2
	B(I)=B(I)*(1.0/(1.0+EXP(ARG)))
	goto 2
C BUTTERWORTH  LOWPASS FILTER **********************
C
600     ARG=SQRT(
     &    FLOAT(IX*IX)/X1+FLOAT(IY*IY)/Y1+FLOAT(IZ*IZ)/Z1)
        B(I)=B(I)*SQRT(1.0/(1.0+(ARG/PARM1)**ORD))
        GOTO 2
C
C BUTTERWORTH HIGIPASS FILTER *********************
C
700     IF(IX.NE.0 .OR. IY.NE.0 .OR.IZ.NE.0)THEN
        ARG=SQRT(
     &    FLOAT(IX*IX)/X1+FLOAT(IY*IY)/Y1+FLOAT(IZ*IZ)/Z1)
        B(I)=B(I)*(1.0-SQRT(1.0/(1.0+(ARG/PARM1)**ORD)))
        ENDIF
c
2	CONTINUE
	CALL  WRTLIN(LUN,B,NSAM,NR)
	ENDDO	
	ENDDO
      END
