
C++************************************************************************
C
C FILTDOC.FOR
C
C **************************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK            *
C *  COPYRIGHT (C)1981,1987, WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH                            *
C **************************************************************************
C
C--*******************************************************************
C
	SUBROUTINE  FILTDOC(LUN1,LUN2,NSAM,NROW,NSLICE,MAXMEM)
        INCLUDE 'CMBLOCK.INC' 
        COMMON       BUF(1)
        DIMENSION    Q(1)
        POINTER      (IPQ,Q) 
        LOGICAL      RUNTIME
	CHARACTER*80  FINDOC
	CHARACTER*1 NULL
CNO_SAVE
	NULL=CHAR(0)
	ISPACE=NSAM+2-MOD(NSAM,2)
	LBS=0.75*MAX0(ISPACE,NROW,NSLICE)
	MEMNEED=ISPACE*NROW*NSLICE+LBS
	CALL CHKMEM(MEMNEED,BUF,MAXMEM,RUNTIME,IPQ,IRTFLG)
        IF(IRTFLG.NE.0)  THEN
          CALL ERRT(6,'FD',NE)
          CLOSE(LUN1)
          CLOSE(LUN2)
	  RETURN
	ENDIF
          IB=1
          DO    K=1,NSLICE
          DO    J=1,NROW
          NR=J+(K-1)*NROW
          CALL  REDLIN(LUN1,Q(IB),NSAM,NR)
          IB=IB+ISPACE
	  ENDDO
	  ENDDO
          CLOSE(LUN1)
C
        CALL  FILERD(FINDOC,NLETI,NULL,'Filter doc',IRTFLG)
	LBD=ISPACE*NROW*NSLICE+1
         K=-1
         K2=1
         NAC=0
801	LERR=-1
	K=K+1
	KP1=K+1
	IF(K.GT.LBS) GOTO  802
         CALL  UNSAV(FINDOC,K,LUN1,KP1,Q(LBD+K),1,LERR,K2)
	IF(LERR.EQ.0)  GOTO 801
802	CLOSE(LUN1)
	IF(K-1.LT.LBS)  THEN
	DO   I=K-1,LBS
	Q(LBD+K)=0.0
	ENDDO
	ENDIF
 	INV=+1
 	IF(NSLICE.LE.1)  THEN
            CALL  FMRS_2(Q,NSAM,NROW,INV)
 	ELSE
            CALL  FMRS_3(Q,NSAM,NROW,NSLICE,INV)
	ENDIF
C
c$doacross local(k,j,i,iz,iy,ix,ir,lb,rr,dd,fr)
	DO    K=1,NSLICE
        IZ=K-1
        IF(IZ.GT.NSLICE/2)  IZ=IZ-NSLICE
	DO    J=1,NROW
        IY=J-1
        IF(IY.GT.NROW/2)  IY=IY-NROW
	DO    I=1,ISPACE,2
	IX=(I-1)/2
	RR=SQRT(FLOAT(IX*IX+IY*IY+IZ*IZ))
	IR=IFIX(RR)
	DD=RR-FLOAT(IR)
	FR=(1.0-DD)*Q(IR+LBD)+DD*Q(IR+LBD+1)
C	IR=JNINT(SQRT(FLOAT(IX*IX+IY*IY+IZ*IZ)))+LBD
	LB=I+((J-1)+(K-1)*NROW)*ISPACE
	Q(LB)=Q(LB)*FR	
	Q(LB+1)=Q(LB+1)*FR	
	ENDDO
	ENDDO
	ENDDO
C
	INV=-1
 	IF(NSLICE.LE.1)  THEN
            CALL  FMRS_2(Q,NSAM,NROW,INV)
 	ELSE
            CALL  FMRS_3(Q,NSAM,NROW,NSLICE,INV)
	ENDIF
          IB=1
          DO    K=1,NSLICE
          DO    J=1,NROW
          NR=J+(K-1)*NROW
          CALL  WRTLIN(LUN2,Q(IB),NSAM,NR)
          IB=IB+ISPACE
	  ENDDO
	  ENDDO
          CLOSE(LUN2)
	IF(RUNTIME)     CALL ALLOCIT(0,RUNTIME,IPQ,'FD',IRTFLG)
	END	
