
C++************************************************************************
C
C  FINDLBQ.F -- ADAPTED FOR CHAR.          AUG 89 al
C               MERGED WITH SEARCHQ STUFF  SEPT 97 al
C               ADDED IFLEVEL              DEC. 97 al
C
C **************************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK            *
C *  COPYRIGHT (C)1981,1987, WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH 			   *
C **************************************************************************
C
C  FINDLBQ(WANTLABEL,IDO,DOLABEL,IDOFLG,IFLEVEL,IRTFLG)
C
C  PARAMETERS:
C        WANTLABEL      LABEL WE ARE SEARCHING FOR                (SENT)
C        IDO            INSIDE DO-LOOP NOW IF == 1                (SENT)
C	 DOLABEL        CURRENT DO-LOOP LABEL                     (SENT)
C	 IDOFLG		0, IF CURRENT DO-LOOP LABEL IS NOT PASSED (RET.)
C			1, IF PASS CURRENT DO-LOOP LABEL - MUST POP
C			   DO-LOOP STACK IN DRIVER
C        IFLEVEL        IF CLAUSE NESTING LEVEL            (SENT & RET.) 
C        IRTFLG		ERROR NUMBER ZERO IS NORMAL               (RET.)
C
C--*******************************************************************

	SUBROUTINE FINDLBQ(WANTLABEL,IDO,DOLABEL,IDOFLG,IFLEVEL,IRTFLG)

CNO_SAVE

        INCLUDE 'CMBLOCK.INC'

        CHARACTER *(*) WANTLABEL,DOLABEL
        CHARACTER *80  ANSW
        LOGICAL        KEEPGO

	IDOFLG  = 0
        KEEPGO  = .TRUE.
        NEEDEND = 1

C       KEEP READING AND DISCARDING LINES FROM INPUT AS NEEDED
        DO WHILE (KEEPGO) 
           ANSW(4:4) = ' '

C          READ ANSWER STRING
10         READ(NIN,80,IOSTAT=IOS) ANSW
80         FORMAT(A80)

C          INCREMENT BATCH COUNTER
	   IBCNT = IBCNT + 1

           IF (IOS .NE. 0) THEN
              WRITE(NOUT,91) WANTLABEL
 91           FORMAT(' *** GOTO DESTINATION NEVER FOUND: ',A)
              CALL ERRT(100,'FINDLBQ',NE)
              IRTFLG = 1
              RETURN
           ENDIF

C          FIND LAST NON-BLANK            
           NCHAR = lnblnk(ANSW)

C          REMOVE BLANKS FROM INPUT STRING
           CALL SHRINKQ(ANSW,80,ANSW,NCHAR)

C          IGNORE ANY COMMENTS AT END OF INPUT STRING
           ISEMICOL = INDEX(ANSW(1:NCHAR),';')
           IF (ISEMICOL .GT. 0) THEN
              ANSW(ISEMICOL:NCHAR) = CHAR(0)
              NCHAR = ISEMICOL - 1
           ENDIF
           IF (NCHAR .LE. 0) GOTO 777

C          CONVERT INPUT STRING TO ALL UPPER CASE
           CALL SSUPCAS(ANSW(1:NCHAR))

C          SEE IF INPUT LINE CONTAINS 'THEN'
           IIFTHEN = INDEX(ANSW(1:NCHAR),'THEN')

C          FIND LAST NON-BLANK IN WANTLABEL            
           LENLB = lnblnk(WANTLABEL)

C          FIND LAST NON-BLANK IN ANSW            
           LENANSW = lnblnk(ANSW)
           LENT    = INDEX(ANSW,CHAR(0)) - 1
           IF (LENT .GT. 0) LENANSW = MIN(LENANSW,LENT)

           IF (ANSW(1:2) .EQ. 'LB' .AND.
     &         ANSW(:LENANSW) .EQ. WANTLABEL(:LENLB)) THEN
C              HUNTING FOR 'LB??' AND FOUND IT, HALT INPUT
               KEEPGO = .FALSE.

           ELSEIF (WANTLABEL(1:2) .EQ. 'LB' .AND.
     &             ANSW(1:2) .EQ. 'IF') THEN
C              HUNTING FOR 'LB..' AND FOUND A NEW IF CLAUSE
               NEEDEND = NEEDEND + 1

           ELSEIF (WANTLABEL(1:2) .EQ. 'LB' .AND.
     &             ANSW(1:5) .EQ. 'ENDIF') THEN
C              HUNTING FOR 'LB..' AND FOUND A 'END IF' 
               NEEDEND = NEEDEND - 1
               IF (NEEDEND .LE. 1) THEN
                  IFLEVEL = IFLEVEL - 1
               ENDIF

           ELSEIF (WANTLABEL .EQ. 'ELSE' .AND.
     &             ANSW(1:4) .EQ. 'ELSE') THEN
C              HUNTING FOR 'ELSE' AND FOUND IT
C              IF NOT A NESTED ELSE, RETURN TO CALLER
               IF (NEEDEND .LE. 1)  KEEPGO = .FALSE.

           ELSEIF (WANTLABEL .EQ. 'ELSE' .AND.
     &             ANSW(1:5) .EQ. 'ENDIF') THEN
C              HUNTING FOR 'ELSE' AND FOUND ENDIF

C              IF NOT A NESTED ENDIF, RETURN TO CALLER
               IF (NEEDEND .LE. 1) THEN
                  KEEPGO  = .FALSE.
                  IFLEVEL = IFLEVEL - 1
               ENDIF

C              IF NESTED ENDIF KEEP READING INPUT
               NEEDEND = NEEDEND - 1

           ELSEIF (WANTLABEL .EQ. 'ENDIF' .AND.
     &             ANSW(1:2) .EQ. 'IF') THEN
C              HUNTING FOR 'ENDIF' AND FOUND A NESTED IF
               NEEDEND = NEEDEND + 1

           ELSEIF (WANTLABEL .EQ. 'ENDIF' .AND.
     &             ANSW(1:5) .EQ. 'ENDIF') THEN
C              HUNTING FOR 'ENDIF' AND FOUND ENDIF

C              IF NOT A NESTED ENDIF, RETURN TO CALLER
               IF (NEEDEND .LE. 1) THEN
                  KEEPGO  = .FALSE.
                  IFLEVEL = IFLEVEL - 1
               ENDIF

C              IF NESTED ENDIF KEEP READING INPUT
               NEEDEND = NEEDEND - 1

           ELSEIF (WANTLABEL .EQ. 'ELSE' .AND.
     &             ANSW(1:2) .EQ. 'IF'   .AND.
     &             IIFTHEN .GT. 5 ) THEN
C              HUNTING FOR 'ELSE' AND FOUND IF...THEN
C              THIS IS A NESTED IF,  KEEP READING INPUT
               NEEDEND = NEEDEND + 1
           ENDIF

C          SET IDOFLG IF WE PASS BY CURRENT DO-LOOP LABEL
	   IF (KEEPGO .AND. IDO .EQ. 1 .AND. ANSW(1:2) .EQ. 'LB' .AND.
     &         ANSW(3:4) .EQ. DOLABEL(1:2)) IDOFLG = 1

 777       CONTINUE
        ENDDO

C       FOUND DESIRED LABEL OR ENDIF CAN RETURN NOW
        IRTFLG = 0

C       SIMULATE ECHO OF OPERATION TO RESULTS FILE
        FCHAR  = ANSW
 	WRITE(NDAT,90) ANSW
 90     FORMAT(' .OPERATION:',5X,A)

        RETURN
	END
