

C       AUTHOR: M.RADERMACHER  
                                               
	SUBROUTINE FITPLANE(VN,VL,AM,BM,X,Y,Z,A,B,C,N) 
                        
        INCLUDE 'CMBLOCK.INC'                                             

        DIMENSION X(N),Y(N),Z(N),AM(3,N),BM(3,4),VL(N),VN(3)            
        DOUBLE PRECISION SQ1,SQ2                                        

        IF (N.LT.3) THEN                                                 
           WRITE(NOUT,*) '*** INSUFFICIENT NUMBER OF POINTS SPECIFIED.'        
           RETURN                                                          
        ENDIF
                                                           
        IT=0                                                            
        EPS1=0.01                                                       
        EPS=0.0001                                                      
        A=1                                                             
        B=1                                                             
        Y13=Y(1)-Y(3)                                                   
        Y23=Y(2)-Y(3)                                                   
        Z13=Z(1)-Z(3)                                                   
        Z23=Z(2)-Z(3)                                                   
        X13=X(1)-X(3)                                                   
        X23=X(2)-X(3)                                                   
        ANENNER=(X23*Y13-X13*Y23)                                       
        IF (ANENNER.NE.0) A=(Z23*Y13-Z13*Y23)/ANENNER                    
        BNENNER=Y23*X13-Y13*X23                                         
        IF (BNENNER.NE.0) B=(Z23*X13-Z13*X23)/BNENNER                    
        C=Z(1)-A*X(1)-B*Y(1)
                                            
        WRITE(NOUT,100) A,B,C                                           
100     FORMAT(' START VALUES: A=',F12.4,' B=',F12.4,' C=',F12.4)     
500     IT=IT+1                                                         
        DO  I=1,N                                                      
           AM(1,I)=X(I)                                                    
           AM(2,I)=Y(I)                                                    
           AM(3,I)=1.                                                      
           VL(I)=Z(I)-(A*X(I)+B*Y(I)+C)                                    
	ENDDO
                                                        
        DO  I=1,3                                                      
           DO  K=1,3                                                      
              BM(I,K)=0                                                       
              DO  L=1,N                                                      
                 BM(I,K)=BM(I,K)+AM(I,L)*AM(K,L)                                 
	      ENDDO
	   ENDDO
	ENDDO
                                                       
        DO  I=1,3                                                      
           VN(I)=0                                                         
           DO  J=1,N                                                      
              VN(I)=VN(I)+AM(I,J)*VL(J)                                       
	   ENDDO	
	ENDDO
                                                      
        DO  I=1,3                                                      
           BM(I,4)=VN(I)                                                   
	ENDDO
                                                       
        WRITE(NOUT,600) (X(LL),Y(LL),Z(LL),VL(LL),LL=1,N)               
600     FORMAT(1X,'X,Y,Z,VL: ',4(E12.4,1X))                             
        WRITE(NOUT,700) ((AM(LL,MM),LL=1,3),MM=1,N)                     
700     FORMAT(' A: ',3(E12.4,1X))                                      
        WRITE(NOUT,800) ((BM(LL,MM),LL=1,3),MM=1,4)                     
800     FORMAT(' B: ',3(E12.4,1X))
                                      
        CALL MIRCOL(3,1,4,BM,EPS,VL,IRTFLG)                          
        IF (IRTFLG .NE. 0) THEN
           WRITE(NOUT,*) '*** MRFITPLANE MATRIX ILL-CONDITIONED'               
           RETURN  
        ENDIF
                                                        
        A=A+VL(1)                                                       
        B=B+VL(2)                                                       
        C=C+VL(3)                                                       
        SQ1=0                                                           
        DO  I=1,N                                                      
           SQ1=SQ1+VL(I)**2                                                
	ENDDO
        SQ2=0                                                           
        DO  I=1,3                                                      
           SQ2=SQ2+VN(I)*VL(I)                                             
	ENDDO
                                                       
        SQ1=SQ1-SQ2                                                     
        WRITE(NOUT,400) A,B,C,SQ1                                       
400     FORMAT('  NEW VALUES: A=',                                    
     $     F12.4,' B=',F12.4,' C=',F12.4,' SQAURES SUM:',E12.4)            
        IF (SQ1.GT.EPS1 .AND. IT.LT.20) GOTO 500                           

        RETURN 
        END                                                             
