C++*********************************************************************
C
C $$ FIXRL.FOR
C
C **************************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK            *
C *  COPYRIGHT (C)1981,1987, WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH 			   *
C **************************************************************************


      SUBROUTINE    FIXRL(D,N,NREM,ISIGN,IFORM)
      DIMENSION     D(1)

      TWOPI = 6.283185307*FLOAT(ISIGN)
      IP0 = 2
      IP1 = IP0*(N/2)
      IP2 = IP1*NREM
      IF (IFORM) 10, 60, 60

   10 J1 = IP1 + 1
      D(2) = D(J1)
      J1 = J1 + IP0
      I2MIN = IP1 + 1
      DO  I2 = I2MIN, IP2, IP1
      D(I2) = D(J1)
      J1 = J1 + IP0
      IF (N-2) 40, 40, 20
   20 I1MIN = I2 + IP0
      I1MAX = I2 + IP1 - IP0
      DO  I1 = I1MIN, I1MAX, IP0
      D(I1) = D(J1)
      D(I1+1)=D(J1+1)
      J1 = J1 + IP0
      ENDDO
   40 D(I2+1) = D(J1)
      J1 = J1 + IP0
      ENDDO

   60 DO 80 I2 = 1, IP2, IP1
      TEMPR = D(I2)
      D(I2) = D(I2) + D(I2+1)
      D(I2+1)=TEMPR - D(I2+1)
      IF (IFORM) 70, 80, 80
   70 D(I2)  = D(I2)/2.
      D(I2+1)= D(I2+1)/2.
   80 CONTINUE   

      IF (N-2) 170, 170, 90
   90 THETA = TWOPI/FLOAT(N)
      SINTH = SIN(THETA/2.)
      ZSTPR = -2.*SINTH*SINTH
      ZSTPI = SIN(THETA)
      ZR = (1.-ZSTPI)/2.
      ZI = (1.+ZSTPR)/2.
      IF (IFORM) 100, 110, 110
  100 ZR = 1. - ZR
      ZI = -ZI
  110 I1MIN = IP0 + 1
      I1MAX = IP0*(N/4) + 1

      DO  I1 = I1MIN, I1MAX, IP0
      DO 150 I2 = I1, IP2, IP1
      I2CNJ = N + IP0 - 2*I1 + I2
      IF (I2-I2CNJ) 140, 120, 120
  120 IF (ISIGN*(2*IFORM+1)) 130, 150, 150
  130 D(I2+1) = -D(I2+1)
      GO TO 150
  140 DIFR = D(I2)   - D(I2CNJ)
      DIFI = D(I2+1) + D(I2CNJ+1)
      TEMPR= DIFR*ZR - DIFI*ZI
      TEMPI= DIFR*ZI + DIFI*ZR
      D(I2)= D(I2)   - TEMPR
      D(I2+1) = D(I2+1) - TEMPI
      D(I2CNJ)= D(I2CNJ)+ TEMPR
      D(I2CNJ+1) = D(I2CNJ+1) - TEMPI
  150 CONTINUE
      TEMPR = ZR - 0.5
      ZR = ZSTPR*TEMPR - ZSTPI*ZI + ZR
      ZI = ZSTPR*ZI + ZSTPI*TEMPR + ZI
      ENDDO
  170 IF (IFORM) 240, 180, 180
  180 I2 = IP2 + 1
      I1 = I2
      J1 = IP0*(N/2+1)*NREM + 1
      GO TO 220
  190 D(J1)  = D(I1)
      D(J1+1)= D(I1+1)
      I1 = I1 - IP0
      J1 = J1 - IP0
  200 IF (I2-I1) 190, 210, 210
  210 D(J1) = D(I1)
      D(J1+1) = 0.
  220 I2 = I2 - IP1
      J1 = J1 - IP0
      D(J1) = D(I2+1)
      D(J1+1) = 0.
      I1 = I1 - IP0
      J1 = J1 - IP0
      IF (I2-1) 230, 230, 200
  230 D(2) = 0.
  240 RETURN
      END
