C++************************************************************************
C
C $$ FMRS_2.FOR
C
C **************************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK            *
C *  COPYRIGHT (C)1981,1987, WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *  THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR       *
C *  LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR    *
C *  USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF     *
C *  THE CENTER FOR LABORATORIES AND RESEARCH   			   *
C **************************************************************************
C  Order of elements:
C
C
C--************************************************************************
C
C $$ FMRS_2.FOR
C
         SUBROUTINE  FMRS_2(X,NSAM,NROW,INV)
         DIMENSION  X(*)
CNO_SAVE	
#ifdef SP_LIBFFT
C The same common appears in FMRS_3
	PARAMETER  (LC=40000)
	COMMON /LIBFFT_D/  COEFF(LC)
	IF(NSAM+15+2*(NROW+15).GT.LC)  THEN
	CALL  ERRT(6,'FMRS_2 ',NE)
	RETURN
	ENDIF
	LDA=NSAM+2-MOD(NSAM,2)
	CALL  SCFFT2DUI(NSAM,NROW,COEFF)
	IF(INV.GT.0)  THEN
	CALL  SCFFT2DU(INV,NSAM,NROW,X,LDA,COEFF)
	ELSE
	CALL  CSFFT2DU(INV,NSAM,NROW,X,LDA,COEFF)
	CALL  SSCAL2D(NSAM,NROW,(1.0/FLOAT(NSAM)/FLOAT(NROW)),X,LDA)
	ENDIF
#else
C Have to change NSAM
	LDA=NSAM+2-MOD(NSAM,2)
        CALL  FMRS_2R(X,LDA,NSAM,NROW,INV)
#endif
	END
