C
C++************************************************************************
C
C $$ FMRS_3.FOR
C
C **************************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK            *
C *  COPYRIGHT (C)1981,1987, WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *  THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR       *
C *  LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR    *
C *  USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF     *
C *  THE CENTER FOR LABORATORIES AND RESEARCH   			   *
C **************************************************************************
C  For order of elements see fmr_1.
C
C
C--************************************************************************
C
C $$ FMRS_3.FOR
C
	SUBROUTINE FMRS_3(A,NSAM,NROW,NSLICE,INV)	
	DIMENSION A(*)
CNO_SAVE
#ifdef SP_LIBFFT
C The same common appears in FMRS_2
	PARAMETER  (LC=40000)
	COMMON /LIBFFT_D/  COEFF(LC)
	IF(NSAM+15+2*(NROW+15)+2*(NSLICE+15).GT.LC)  THEN
	CALL  ERRT(6,'FMRS_3 ',NE)
	RETURN
	ENDIF
	LDA=NSAM+2-MOD(NSAM,2)
	CALL  SCFFT3DUI(NSAM,NROW,NSLICE,COEFF)
	IF(INV.GT.0)  THEN
	CALL  SCFFT3DU(INV,NSAM,NROW,NSLICE,A,LDA,NROW,COEFF)
	ELSE
	CALL  CSFFT3DU(INV,NSAM,NROW,NSLICE,A,LDA,NROW,COEFF)
	CALL  SSCAL3D(NSAM,NROW,NSLICE,
     &	(1.0/FLOAT(NSAM)/FLOAT(NROW)/FLOAT(NSLICE)),A,LDA,NROW)
	ENDIF
#else
C Have to change NSAM
	LDA=NSAM+2-MOD(NSAM,2)
	CALL FMRS_3R(A,LDA,NSAM,NROW,NSLICE,INV)
#endif
	END
C
