C
C++************************************************************************
C
C $$ FMRS_3DR.FOR
C
C **************************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK            *
C *  COPYRIGHT (C)1981,1987, WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *  THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR       *
C *  LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR    *
C *  USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF     *
C *  THE CENTER FOR LABORATORIES AND RESEARCH   			   *
C **************************************************************************
C  For order of elements see fmr_1.
C
C
C--************************************************************************
C
C $$ FMRS_3DR.FOR
C
	SUBROUTINE FMRS_3DR(LUN1,LUN2,A,A2,B,H1,H2,BUF,
     &		NNNN,NSAM,NROW,NSLICE,INV)	
	DIMENSION A(NNNN,NROW),A2(NSAM,NROW),B(NNNN,NSLICE),BUF(*)
	DIMENSION H1(NROW,NSLICE),H2(NROW,NSLICE)
C
	LOGICAL*1 IFNS,IFND
CNO_SAVE
c
	NDR=INV*NNNN*NROW
C
	IF(INV) 2,2,1
C
1	CONTINUE
c******************************************************************************
c********forward************forward**************forward***********************
c******************************************************************************
C
C
        DO    I=1,NSLICE
        DO    I1=1,NROW
        K=(I-1)*NROW+I1
        CALL  REDLIN(LUN1,A(1,I1),NSAM,K)
	ENDDO
c
        CALL  FMRS_2(A,NSAM,NROW,INV)
        IF(INV.EQ.0)  RETURN
c
        DO    I1=1,NROW
        K=(I-1)*NROW+I1
        CALL  WRTLIN(LUN2,A(1,I1),NNNN,K)
	ENDDO
	ENDDO
C
	CLOSE(LUN1)
C
        DO    I=1,NROW
        DO    I1=1,NSLICE
        K=(I1-1)*NROW+I
        CALL  REDLIN(LUN2,B(1,I1),NNNN,K)
	ENDDO
c
c$doacross local(i1),share(nnnnt)
        DO    I1=1,NNNN,2
	NNNNT=NNNN
	CALL  FFTMCF(B(I1,1),B(I1+1,1),NSLICE,NSLICE,NSLICE,NNNNT)
	ENDDO
	IF(NNNNT.EQ.0)  THEN
	INV=0
	RETURN
	ENDIF
c
        DO  I1=1,NSLICE
        K=(I1-1)*NROW+I
        CALL  WRTLIN(LUN2,B(1,I1),NNNN,K)
	ENDDO
	ENDDO
	RETURN
c******************************************************************************
c************inverse**********inverse************inverse***********************
c******************************************************************************
c
2	CONTINUE
	IFNS=MOD(NSAM,2).EQ.0
	IFND=MOD(NROW,2).EQ.0
C NORMALIZE FOR INVERSE
	Q=1/FLOAT(NSLICE)
C
        DO    I=1,NROW
        DO    I1=1,NSLICE
        K=(I1-1)*NROW+I
        CALL  REDLIN(LUN1,B(1,I1),NNNN,K)
	ENDDO
c
c$doacross local(i1),share(nnnnt)
        DO    I1=1,NNNN,2
	NNNNT=-NNNN
	CALL  FFTMCF(B(I1,1),B(I1+1,1),NSLICE,NSLICE,NSLICE,NNNNT)
	ENDDO
	IF(NNNNT.EQ.0)  THEN
	INV=0
	RETURN
	ENDIF
C
	IF(I.LT.NROW/2+1)  THEN
		DO    K=1,NSLICE
		H1(2*(I-1)+1,K)=B(1,K)
		H1(2*(I-1)+2,K)=B(2,K)
		ENDDO
		IF(IFNS)  THEN
		DO    K=1,NSLICE
		H2(2*(I-1)+1,K)=B(NNNN-1,K)
		H2(2*(I-1)+2,K)=B(NNNN,K)
		ENDDO
		ENDIF
	ELSEIF(I.EQ.NROW/2+1)  THEN
		IF(IFND)  THEN
		DO    K=1,NSLICE
		H1(2,K)=B(1,K)
		ENDDO
		ELSE
		DO    K=1,NSLICE
		H1(2*(I-1)+1,K)=B(1,K)
		H1(2,K)=B(2,K)
		ENDDO
		ENDIF
		IF(IFNS)  THEN
			IF(IFND)  THEN
			DO    K=1,NSLICE
			H2(2,K)=B(NNNN-1,K)
			ENDDO
			ELSE
			DO    K=1,NSLICE
			H2(2*(I-1)+1,K)=B(NNNN-1,K)
			H2(2,K)=B(NNNN,K)
			ENDDO
			ENDIF
		ENDIF
	ELSE
C REMAINING ENTRIES ARE MIRRORED AND ARE SKIPPED
	ENDIF
C
	IF(.NOT.IFNS)  THEN
	DO    I1=1,NSLICE
	B(2,I1)=B(NNNN,I1)
	ENDDO
	ENDIF
C
        DO    I1=1,NSLICE
        K=(I1-1)*NROW+I
        CALL  WRTLIN(LUN2,B(1,I1),NSAM,K)
	ENDDO
	ENDDO
C
C	CLOSE(LUN1)
C
        DO    I=1,NSLICE
        DO    I1=1,NROW
        K=(I-1)*NROW+I1
        CALL  REDLIN(LUN2,A2(1,I1),NSAM,K)
	ENDDO
C
	DO    I1=1,NROW
	A2(1,I1)=H1(I1,I)
	ENDDO
	IF(IFNS)  THEN
	DO    I1=1,NROW
	A2(2,I1)=H2(I1,I)
	ENDDO
	ENDIF
c$doacross  local(k,i1)
	DO    K=1,NROW
	DO    I1=1,NSAM
	A2(I1,K)=A2(I1,K)*Q
	ENDDO
	ENDDO
C
        CALL  FMR_2(A2,NSAM,NROW,WORK,INV)
        IF(INV.EQ.0)  RETURN
C
        DO    I1=1,NROW
        K=(I-1)*NROW+I1
        CALL  WRTLIN(LUN2,A2(1,I1),NSAM,K)
	ENDDO
	ENDDO
	END
