C++*********************************************************************
C
C    FOUR1.F                                                   08/22/96
C
C **********************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK        *
C *  COPYRIGHT (C)1981,1987, WADSWORTH CENTER FOR LABORATORIES AND     *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.  *
C *  THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR   *
C *  LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR*
C *  USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF *
C *  THE CENTER FOR LABORATORIES AND RESEARCH                          *
C **********************************************************************
C
C--*********************************************************************

	SUBROUTINE FOUR1(MAXMEM)

        INCLUDE 'CMBLOCK.INC' 
CNO_SAVE

        PARAMETER (NFUNC=12)
        CHARACTER *2  FUNC(NFUNC)

        CHARACTER *81  FILNAM 
        COMMON /COMMUN/FILNAM

        CHARACTER *1  NULL 
        DIMENSION     VALUES(6)

        DATA FUNC/'FQ','FT', 'FF', 'FL', 'FP', 
     1            'EF','PW', 'RF', 'CF', 'GF', 'RD','FD'/
        DATA  LUN1,LUN2,LUNF,LUN3 /21,22,23,24/

        NULL   = CHAR(0)
        MAXIM  = 0

C                 FQ, FT, FF, FL, FP, EF, PW, RF, CF, GF, RD, FD 
        DO IFUNC = 1,NFUNC
            IF (FCHAR(1:2) .EQ. FUNC(IFUNC)) THEN
              GOTO ( 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12), (IFUNC)
            ENDIF
        ENDDO
C       OPERATION NOT IN FOUR1, RETURN TO SPIDER
        RETURN

C ---------------------- QUICK FILTERING ------------------------- 'FQ'
1       CALL FOUR1A(MAXMEM)
        RETURN

C ---------------------- FOURIER TRANSFORM ----------------------- 'FT'
2       CALL FOUR1C(MAXMEM)
        RETURN

C ---------------------- FOURIER FILTER -------------------------- 'FF'

C	APPLIES FILTERS TO 2-D OR 3-D FOURIER TRANSFORMS.
3       IF (FCHAR(4:7) .EQ. 'PLOT') THEN
           CALL FILTPLOT(MAXMEM)
           RETURN
        ENDIF
        CALL OPFIL(.TRUE.,FILNAM,LUN1,'O',NSAM,NROW,NSLICE,
     &		   MAXIM,'INPUT',.TRUE.,IRTFLG)
	IF (IRTFLG .NE. 0)  THEN
           CALL ERRT(4,'FF',NE)
           RETURN
        ENDIF

        IF (IFORM.NE.-11 .AND. IFORM.NE.-12 .AND.
     &	    IFORM.NE.-21 .AND. IFORM.NE.-22) THEN
	   CALL ERRT(2,'FF',NE)
	   CLOSE(LUN1)
	   RETURN
	ENDIF
        IF (FCHAR(4:4) .EQ. 'S') THEN
	   CALL  ERRT(41,'FF S',NE)
C          CALL FSHADO(LUN1,NSAM,NROW)
        ELSEIF (FCHAR(4:4).EQ.'L' .OR. FCHAR(4:4).EQ.'B') THEN
	   CALL  ERRT(41,'FF L/B',NE)
C          CALL FILTB(LUN1,NSAM,NROW)
        ELSE
	   NSAMO = NSAM-MOD(-IFORM,10)
           CALL OPFIL(.TRUE.,FILNAM,LUN2,'U',NSAM,NROW,NSLICE,
     &		   MAXIM,'OUTPUT',.TRUE.,IRTFLG)
	   IF (IRTFLG .NE. 0)  THEN
              CLOSE(LUN1)
              CALL ERRT(4,'FF',NE)
              RETURN
           ENDIF
           CALL FFILTS(LUN1,LUN2,NSAM,NROW,NSLICE,NSAMO)
        ENDIF
        CLOSE(LUN1)
        CLOSE(LUN2)
        RETURN	

C ---------------------- FOURIER LISTING ------------------------- 'FL'
C 	LISTS MODULI AND PHASES OF 2-D FOURIER TRANSFORMATION.
4       CONTINUE
	CALL  ERRT(41,'FL',NE)
	RETURN

C ---------------------- FOURIER INTERPOLATION ------------------- 'FP'
5       CALL FOUR1A_FP(MAXMEM)
        RETURN

c --------------- EXTRACT FOURIER -------------------------------- 'EF'
C	EXTRACTS CENTRAL SECTION FROM 3-D FOURIER UNDER ARBITRARY ANGLES.
6       CONTINUE
	CALL  ERRT(41,'EF',NE)
	RETURN

C ---------------------- POWER SPECTRUM -------------------------- 'PW'
7       CALL FOUR1B(MAXMEM)
        RETURN

C ---------------------- R-FACTOR -------------------------------- 'RF'
C	COMPUTES VARIOUS MEASURES OF PROXIMITY BETWEEN 2 GIVEN 
C       TRANSFORMS
8       IF (FCHAR(4:4) .EQ. '3') THEN
           CALL PR3D(MAXMEM)
        ELSEIF (FCHAR(4:5) .EQ. 'SN') THEN
           CALL SSNR(MAXMEM)
        ELSE
           CALL RFACTSDO(MAXMEM)
        ENDIF
        RETURN

C ---------------------- CONSTRUCT FOURIER ----------------------- 'CF'
C	CONSTRUCT FOURIER FILE FROM AMPLITUDES & PHASES OF REFLECTIONS.
9       CONTINUE
	CALL  ERRT(41,'CF',NE)
	RETURN

C ---------------------- GENERAL FILTER -------------------------- 'GF'
C       FOR QUASI-OPTICAL FOURIER FILTRATION 
10      CONTINUE
	CALL  ERRT(41,'GF',NE)
	RETURN

C ---------------------- REDUCE TRANSFORM ------------------------ 'RD'
C	GENERATES REDUCED FOURIER TRANSFORM FROM MASKED FOURIER
11      CONTINUE
	CALL  ERRT(41,'RD',NE)
	RETURN

C ------------- FILTER ACCORDING TO A DOCUMENT FILE ------------- 'FD'

12      CALL OPFIL(.TRUE.,FILNAM,LUN1,'O',NSAM,NROW,NSLICE,
     &		     MAXIM,'INPUT',.FALSE.,IRTFLG)
	IF (IRTFLG .NE. 0)  THEN
           CALL ERRT(4,'FD',NE)
           RETURN
        ENDIF
        MAXIM = 0
        CALL OPFIL(.TRUE.,FILNAM,LUN2,'U',NSAM,NROW,NSLICE,
     &		     MAXIM,'OUTPUT',.FALSE.,IRTFLG)
	IF (IRTFLG .NE. 0)  THEN
           CALL ERRT(4,'FD',NE)
           CLOSE(LUN1)
           RETURN
        ENDIF
	CALL  FILTDOC(LUN1,LUN2,NSAM,NROW,NSLICE,MAXMEM)

        RETURN	
        END
