C++*********************************************************************
C
C     FOUR1A.F
C	
C **********************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK        *
C *  COPYRIGHT (C)1981,1987, WADSWORTH CENTER FOR LABORATORIES AND     *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.  *
C *  THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR   *
C *  LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR*
C *  USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF *
C *  THE CENTER FOR LABORATORIES AND RESEARCH                          *
C **********************************************************************
C
C       'FQ' : QUICK FILTERING (IN CORE, 2-D OR 3-D, AS NEED BE)
C       APPLIES FOURIER FILTERS TO 2-D OR 3-D REAL PICTURES
C
C--*********************************************************************

	SUBROUTINE FOUR1A(MAXMEM)

        INCLUDE 'CMBLOCK.INC' 
        COMMON /COMMUN/ FILNAM,FILFIL
        CHARACTER *81   FILNAM,FILFIL
        COMMON          BUF(1)
        DIMENSION       Q(1)
        POINTER         (IPQ,Q) 
        LOGICAL		RUNTIME
        CHARACTER *1    NULL

        DATA  LUN1,LUN2/21,22/

CNO_SAVE		
        NULL   = CHAR(0)
100	CALL OPFIL(.TRUE.,FILNAM,LUN1,'O',NSAM,NROW,NSLICE,
     &  	   IDUM,'INPUT',.FALSE.,IRTFLG)
	IF (IRTFLG .NE. 0) RETURN
        IF (IFORM .NE.1 .AND. IFORM.NE.3) THEN
	   CLOSE(LUN1)
	   RETURN
	ENDIF

	CALL FILERD(FILNAM,NLETI,NULL,'OUTPUT',IRTFLG)
	IF (IRTFLG .EQ. -1) GOTO 999
        NSLICE = MAX0(1,NSLICE)
C	IOPT IS RETURNED BY RDPRMI. SET TO START LOOP    ML.
        IOPT = 0
        DO WHILE (IOPT .LT. 1 .OR. IOPT .GT. 8)
          WRITE(NOUT,1009)
 1009     FORMAT
     &    (' 1 - LOW-PASS,       2 - HIGH-PASS',/,
     &     ' 3 - GAUSS LOW-PASS, 4 - GAUSS HIGH-PASS',/,
     &     ' 5 - FERMI LOW-PASS, 6 - FERMI HIGH-PASS',/,
     &     ' 7 - BUTER LOW-PASS, 8 - BUTER HIGH-PASS')
          CALL RDPRMI(IOPT,IDUM,NLOOP,ILOOP,'FILTER TYPE (1-8)')
        ENDDO
C
	IF (FCHAR(4:5) .EQ. 'NP')  THEN
	    N2S = NSAM
            N2R = NROW
            N2L = NSLICE
        ELSE
           N2S = 2*NSAM
           N2R = 2*NROW
	   IF (NSLICE.GT.1)  THEN
	     N2L = 2*NSLICE
	   ELSE
	     N2L=1
           ENDIF
	ENDIF
	LSD=N2S+2-MOD(N2S,2)
	MEMNEED=LSD*N2R*N2L
	CALL CHKMEM(MEMNEED,BUF,MAXMEM,RUNTIME,IPQ,IRTFLG)
	IF (IRTFLG.NE.0.AND.FCHAR(4:5).EQ.'NP')  THEN
             CALL  ERRT(6,'FOUR1 ',NE)
             GOTO 999
	ELSEIF(IRTFLG.NE.0.AND.FCHAR(4:5).NE.'NP')  THEN
	     N2S = NSAM
	     N2R = NROW
	     N2L = NSLICE
	     LSD=N2S+2-MOD(N2S,2)
	     MEMNEED=LSD*N2R*N2L
	     WRITE(NOUT,*)
	     CALL CHKMEM(MEMNEED,BUF,MAXMEM,RUNTIME,IPQ,IRTFLG)
	     IF(IRTFLG.NE.0)  THEN
		CALL  ERRT(6,'FOUR1 ',NE)
		GOTO 999
	     ENDIF
	     WRITE(NOUT,*)
     &         ' WARNING! BUFFER TO SMALL TO PAD YOUR IMAGE',
     &         ' WITH THE AVERAGE. RESULT CAN BE INCORRECT'
	ENDIF
        IF (IFORM.EQ.3)  THEN
           WRITE(NOUT,30111)  N2S,N2R,N2L
        ELSE
           WRITE(NOUT,30111)  N2S,N2R
        ENDIF
30111   FORMAT(' DIMENSIONS USED: ',3I6)
	CALL OPFIL(.FALSE.,FILNAM,LUN2,'U',NSAM,NROW,NSLICE,
     &		   IDUM,'OUTPUT',.FALSE.,IRTFLG)
	IF (IRTFLG. NE. 0) GOTO 999
        IF (IFORM.EQ.1)  THEN
           CALL  FQ_Q(LUN1,LUN2,Q,LSD,N2S,N2R,NSAM,NROW,IOPT)
        ELSE
           CALL FQ3_P(LUN1,LUN2,Q,LSD,
     &                N2S,N2R,N2L,NSAM,NROW,NSLICE,IOPT)
        ENDIF

        IF (RUNTIME)  CALL ALLOCIT(0,RUNTIME,IPQ,'FQ',IRTFLG)
	IF (IOPT.LT.0) THEN
	   CALL ERRT(38,'FQ',NE)
	ENDIF

999     CLOSE(LUN1)
        CLOSE(LUN2)
        RETURN
        END
	
