
C++*********************************************************************
C
C    FOUR1A_FP.FOR
C
C **********************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK        *
C *  COPYRIGHT (C)1981,1987, WADSWORTH CENTER FOR LABORATORIES AND     *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.  *
C *  THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR   *
C *  LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR*
C *  USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF *
C *  THE CENTER FOR LABORATORIES AND RESEARCH                          *
C **********************************************************************
C
C       'FP' : FOURIER INTERPOLATION 
C	CREATES INTERPOLATED PICTURE MF*NSAM BY MF*NROW
C       (WHERE MF IS MAGNIFICATION FACTOR) OF A NSAM BY NROW PICTURE
C       WORKS FOR 2D AND 3D
C
C       NSAM, NROW AND NSLICE HAVE TO BE EVEN
C
C--*********************************************************************

        SUBROUTINE FOUR1A_FP(MAXMEM)

        INCLUDE 'CMBLOCK.INC' 

        COMMON        BUF(1) 
        DIMENSION     Q(1)
        POINTER       (IPQ,Q) 
        LOGICAL       RUNTIME 
        CHARACTER *81 FILNAM
        CHARACTER *1  NULL

        DATA  LUN1,LUN2/9,10/
CNO_SAVE

        NULL   = CHAR(0)
        NSLICE = 1
        NE     = 0
	
600	CALL OPFIL(.TRUE.,FILNAM,LUN1,'O',NSAM,NROW,NSLICE,
     &		   IDUM,'INPUT',.FALSE.,IRTFLG)
	NSLICE=MAX0(NSLICE,1)
	IF (IRTFLG .NE. 0) RETURN

	CALL FILERD(FILNAM,NLET,NULL,'OUTPUT',IRTFLG)
        CALL RDPRMI(MGN,MGR,NLOOP,ILOOP,
     &              'MAGNIFICATION FACTOR FOR COLUMNS & ROWS')
	MGN=MAX0(2,MGN)
	MGR=MAX0(2,MGR)
	IF (NSLICE.GT.1)  THEN
C          3D FILE
	   CALL RDPRMI(MGS,NSAMN,NLOOP,ILOOP,
     &         'MAGNIFICATION FACTOR FOR SLICES')
	   MGS=MAX0(2,MGS)
	   IF (MOD(NSAM,2).NE.0 .OR. MOD(NROW,2).NE.0 
     &          .OR. MOD(NSLICE,2).NE.0)  THEN
	      CLOSE(LUN1)
	      CALL ERRT(1,'FP ',IE)
	      RETURN
	   ENDIF

	ELSE
	   MGS=1
	   IF (MOD(NSAM,2).NE.0 .OR. MOD(NROW,2).NE.0)  THEN
	      CLOSE(LUN1)
	      CALL ERRT(1,'FP ',IE)
	      RETURN
	   ENDIF
	ENDIF

	NSAMN=MGN*NSAM
	NROWN=MGR*NROW
	NSLICEN=MGS*NSLICE

	MEMWANT=NSAMN*NROWN*NSLICEN+MAX0(NSAMN,2*NROWN,2*NSLICEN)
	CALL CHKMEM(MEMWANT ,Buf,MAXMEM,RUNTIME,IPQ,IRTFLG)
	
        IF(IRTFLG.EQ.0)  THEN  
          CALL OPENF(FILNAM,LUN2,NSAMN,NROWN,'UNKNOWN',NF,NSLICEN)
	  IF (IRTFLG .NE. 0) RETURN
          DO   J = 1, NROW*NSLICE
             CALL REDLIN(LUN1,Q(1+(J-1)*NSAM),NSAM,J)
          END DO
	  CLOSE(LUN1)

	  IF (NSLICE.EQ.1)  THEN
             CALL  FINT(Q,Q,NSAM,NROW,NSAMN,NROWN,Q(1+NSAMN*NROWN))
	  ELSE
	     CALL  FINT3(Q,Q, NSAM,NROW,NSLICE,NSAMN,NROWN,NSLICEN,
     &                   Q(1+NSAMN*NROWN*NSLICEN))
	  ENDIF
          DO  J = 1,NROWN*NSLICEN
             CALL WRTLIN(LUN2,Q(1+(J-1)*NSAMN),NSAMN,J)
          ENDDO

          CLOSE(LUN2) 
          IF(RUNTIME) CALL ALLOCIT(0,RUNTIME,IPQ,'FP',IRTFLG) 
        ELSE
C         NOT ENOUGH MEMORY
          CALL  ERRT(6,'FOUR1A_FP',NE)
        ENDIF
        RETURN	
        END
	
