C++*********************************************************************
C
C    FOUR1B.FOR
C
C	
C **********************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK        *
C *  COPYRIGHT (C)1981,1987, WADSWORTH CENTER FOR LABORATORIES AND     *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.  *
C *  THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR   *
C *  LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR*
C *  USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF *
C *  THE CENTER FOR LABORATORIES AND RESEARCH                          *
C **********************************************************************
C
C  PURPOSE: CALCULATES POWER SPECTRUM
C
C--*********************************************************************

	SUBROUTINE FOUR1B(MAXMEM)
C ----------------------- POWER SPECTRUM ------------------------ 'PW'
        INCLUDE 'CMBLOCK.INC'
	COMMON	BUF(1)
        DIMENSION	Q(1)
	POINTER (IPQ,Q)
        LOGICAL      RUNTIME
        COMMON /COMMUN/ FILNAM
        CHARACTER *81 FILNAM 
        CHARACTER *1  NULL 
	DATA LUN1,LUN2/21,22/
CNO_SAVE		
        NULL   = CHAR(0)
C       FOURIER MODULI FROM COMPLEX FOURIER TRANSFORM 
C       ON DISK FOR 2-D OR 3-D PICTURES.
	CALL OPFIL(.TRUE.,FILNAM,LUN1,'O',NSAM,NROW,NSLICE,
     &		   IDUM,'INPUT',.TRUE.,IRTFLG)
	IF (IRTFLG .NE. 0)  THEN
           CALL ERRT(4,'PW',NE)
           RETURN
        ENDIF
C    FOURIER INPUT 2D & 3D
          NSLICE = MAX0(1,NSLICE)
	  IFI=IFORM
          IF(IFORM.EQ.1)  THEN
                IF(MOD(NSAM,2).EQ.0)  THEN
                LS=NSAM+2
                ELSE
                LS=NSAM+1
                ENDIF
		IRL=NSAM
		MEMNEED=LS*NROW
          ELSEIF(IFORM.EQ.3)  THEN
                IF(MOD(NSAM,2).EQ.0)  THEN
                LS=NSAM+2
                ELSE
                LS=NSAM+1
                ENDIF
		IRL=NSAM
		MEMNEED=LS*NROW*NSLICE
          ELSEIF(IFORM.EQ.-11)  THEN
		IFORM=1
                LS=NSAM
		IRL=NSAM
                NSAM=NSAM-1
		MEMNEED=LS*NROW
          ELSEIF(IFORM.EQ.-12)  THEN
		IFORM=1
                LS=NSAM
		IRL=NSAM
                NSAM=NSAM-2
		MEMNEED=LS*NROW
          ELSEIF(IFORM.EQ.-21)  THEN
		IFORM=3
                LS=NSAM
		IRL=NSAM
                NSAM=NSAM-1
		MEMNEED=LS*NROW*NSLICE
          ELSEIF(IFORM.EQ.-22)  THEN
		IFORM=3
                LS=NSAM
		IRL=NSAM
                NSAM=NSAM-2
		MEMNEED=LS*NROW*NSLICE
          ELSE
                CALL ERRT(2,'FT',NE)
		CLOSE(LUN1)
                RETURN
          ENDIF
	  CALL OPFIL(.TRUE.,FILNAM,LUN2,'N',NSAM,NROW,NSLICE,
     &		       IDUM,'OUTPUT',.FALSE.,IRTFLG)
	      IF (IRTFLG .NE. 0)  THEN
              CALL ERRT(4,'PW',NE)
              CLOSE(LUN1)
              RETURN
              ENDIF
      CALL CHKMEM(MEMNEED,BUF,MAXMEM,RUNTIME,IPQ,IRTFLG)
	IF(IRTFLG.EQ.0)  THEN
	  IB=1
	  DO   K=1,NSLICE
	  DO   J=1,NROW
	  NR=J+(K-1)*NROW
	  CALL  REDLIN(LUN1,Q(IB),IRL,NR)
	  IB=IB+LS
	  ENDDO
	  ENDDO
	  CLOSE(LUN1)
	  IF(IFI .GT. 0) THEN
C     REAL INPUT 2D & 3D
	   INV=+1
           IF(NSLICE.EQ.1)  THEN
	   CALL  FMRS_2(Q,NSAM,NROW,INV)
	   ELSE
	   CALL  FMRS_3(Q,NSAM,NROW,NSLICE,INV)
	   ENDIF
	   IF(INV.EQ.0)  THEN
		CALL  ERRT(38,'PW',NE)
		CLOSE(LUN1)
		CLOSE(LUN2)
		RETURN
	   ENDIF
	  ENDIF
          IF(NSLICE.EQ.1)  THEN
           CALL PW2S(Q,NSAM,NROW,FCHAR(4:4))
	  ELSE
           CALL PW3S(Q,NSAM,NROW,NSLICE,FCHAR(4:4))
          ENDIF
	  IB=1
	  DO    K=1,NSLICE
	  DO    J=1,NROW
	  NR=J+(K-1)*NROW
	  CALL  WRTLIN(LUN2,Q(IB),NSAM,NR)
	  IB=IB+LS
	  ENDDO
	  ENDDO
	  CLOSE(LUN1)
	  CLOSE(LUN2)
	IF(RUNTIME)	CALL ALLOCIT(0,RUNTIME,IPQ,'PW',IRTFLG)
        ELSEIF(IFI.GT.0)  THEN
C  REAL INPUT FOR ON DISK VERSION NOT SUPPORTED
              CALL ERRT(6,'PW',NE)
              CLOSE(LUN1)
              CLOSE(LUN2)
              RETURN
	ELSE
C  ON DISK VERSION
	MEMNEED=LS+NSAM
      CALL CHKMEM(MEMNEED,BUF,MAXMEM,RUNTIME,IPQ,IRTFLG)
	 IF(IRTFLG.EQ.0)  THEN
	  IF(IFORM.EQ.1)  THEN
	  CALL  PW2SD(LUN1,LUN2,Q,NSAM,NROW,FCHAR(4:4))
	  ELSE
	  CALL  PW3SD(LUN1,LUN2,Q,NSAM,NROW,NSLICE,FCHAR(4:4))
	  ENDIF
	  CLOSE(LUN1)
	  CLOSE(LUN2)
	IF(RUNTIME)	CALL ALLOCIT(0,RUNTIME,IPQ,'PW',IRTFLG)
	 ELSE
              CALL ERRT(6,'PW',NE)
              CLOSE(LUN1)
              CLOSE(LUN2)
	 ENDIF
        ENDIF
        END
