C++*********************************************************************
C
C     FOUR1C.FOR
C	
C **********************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK        *
C *  COPYRIGHT (C)1981,1987, WADSWORTH CENTER FOR LABORATORIES AND     *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.  *
C *  THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR   *
C *  LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR*
C *  USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF *
C *  THE CENTER FOR LABORATORIES AND RESEARCH                          *
C **********************************************************************
C
C  FOUR1C(MAXMEM)
C
C  PURPOSE:  FOURIER TRANSFORMS A 2-D OR 3-D IMAGE.
C
C--*********************************************************************

	SUBROUTINE FOUR1C(MAXMEM)

        INCLUDE 'CMBLOCK.INC' 
        COMMON          BUF(1)
        DIMENSION       Q(1)
        POINTER         (IPQ,Q) 
        LOGICAL         RUNTIME
        CHARACTER*81	FILNAM
        COMMON /COMMUN/ FILNAM
        DIMENSION	VALUES(5)
        CHARACTER*1	NULL
        CHARACTER*2	CFORM

        DATA  LUN1,LUN2/21,22/
CNO_SAVE 

        NULL   = CHAR(0)
	CALL OPFIL(.TRUE.,FILNAM,LUN1,'O',NSAM,NROW,NSLICE,
     &		   IDUM,'INPUT',.TRUE.,IRTFLG)
	IF (IRTFLG .NE. 0)  THEN
           CALL ERRT(4,'FT',NE)
           RETURN
        ENDIF
        INV=ISIGN(1,IFORM)
        IF(IFORM.EQ.1)  THEN
                IF(MOD(NSAM,2).EQ.0)  THEN
                CFORM(1:2)='E2'
                IFORM=-12
                LS=NSAM+2
                ELSE
                IFORM=-11
                CFORM(1:2)='O2'
                LS=NSAM+1
                ENDIF
		MEMNEED=LS*NROW
        ELSEIF(IFORM.EQ.3)  THEN
                IF(MOD(NSAM,2).EQ.0)  THEN
                CFORM(1:2)='E3'
                IFORM=-22
                LS=NSAM+2
                ELSE
                IFORM=-21
                CFORM(1:2)='O3'
                LS=NSAM+1
                ENDIF
		MEMNEED=LS*NROW*NSLICE
        ELSEIF(IFORM.EQ.-11)  THEN
                CFORM(1:2)='R2'
		IFORM=1
                LS=NSAM-1
		MEMNEED=NSAM*NROW
        ELSEIF(IFORM.EQ.-12)  THEN
                CFORM(1:2)='R2'
		IFORM=1
                LS=NSAM-2
		MEMNEED=NSAM*NROW
        ELSEIF(IFORM.EQ.-21)  THEN
                CFORM(1:2)='R3'
		IFORM=3
                LS=NSAM-1
		MEMNEED=NSAM*NROW*NSLICE
        ELSEIF(IFORM.EQ.-22)  THEN
                CFORM(1:2)='R3'
		IFORM=3
                LS=NSAM-2
		MEMNEED=NSAM*NROW*NSLICE
        ELSE
                CALL ERRT(2,'FT',NE)
		CLOSE(LUN1)
                RETURN
        ENDIF
	ISPACE = MAX0(NSAM,LS)
	ISAM   = MIN0(NSAM,LS)
	CALL OPFIL(.TRUE.,FILNAM,LUN2,'N',LS,NROW,NSLICE,
     &		   IDUM,'OUTPUT',.TRUE.,IRTFLG)
	IF (IRTFLG .NE. 0)  THEN
           CALL ERRT(4,'FT',NE)
	   CLOSE(LUN1)
           RETURN
        ENDIF
        
C       DO NOT STOP IN ALLOCATION FAILS
        IRTFLG = -9
	CALL CHKMEM(MEMNEED,BUF,MAXMEM,RUNTIME,IPQ,IRTFLG)
        IF (IRTFLG .EQ. 0)  THEN
	  IB=1
	  DO  K=1,NSLICE
	     DO  J=1,NROW
	        NR=J+(K-1)*NROW
	        CALL  REDLIN(LUN1,Q(IB),NSAM,NR)
    	        IB=IB+ISPACE
             ENDDO
          ENDDO

	  CLOSE(LUN1)
	  IF (IFORM .EQ. 3 .OR. IFORM .LT. -20)  THEN
	    CALL FMRS_3(Q,ISAM,NROW,NSLICE,INV)
	  ELSE
	    CALL FMRS_2(Q,ISAM,NROW,INV)
	  ENDIF
          IF (INV .EQ. 0)THEN
             CALL ERRT(38,'FT',NE)
	     CLOSE(LUN1)
             CLOSE(LUN2)
             RETURN
          ELSE
	     IB=1
	     DO  K=1,NSLICE
	        DO  J=1,NROW
	           NR = J+(K-1)*NROW
	           CALL  WRTLIN(LUN2,Q(IB),LS,NR)
	           IB = IB+ISPACE
                ENDDO
             ENDDO
	  ENDIF
	ELSE
C         ESTIMATE MEMORY FOR ON-DISK VERSION
	  IF (NSLICE .LE. 1)  THEN
C            2D FFT ----------------------------------------
	     NC=2
55	     LR=ISPACE/NC
	     IF (MOD(ISPACE,K) .NE. 0)  LR=LR+1
             LR=LR/2
             LR=LR*2
             IF (LR.LT.2.OR.(INV.LT.0 .AND. LR.LT.4))  THEN
	        CALL  ERRT(6,'FT',NE)
	        CLOSE(LUN1)
	        CLOSE(LUN2)
	        RETURN
	     ENDIF
	     MEMNEED=ISPACE+LR*NROW
	     IRTFLG=-9
	     CALL CHKMEM(MEMNEED,BUF,MAXMEM,RUNTIME,IPQ,IRTFLG)
	     IF (IRTFLG.NE.0)  THEN
	        NC = NC+1
	        GOTO  55
	    ELSE
        	WRITE(NOUT,*)
     &           ' ** WARNING: SLOW ON-DISK VERSION OF FFT USED.'
        	CALL  FMRS_2D(LUN1,LUN2,Q,ISAM,NROW,LR,INV)
            ENDIF
	  ELSE
C           3D FFT -----------------------------------------
C           FOR 3D BUFFER NEEDED IS FIXED
	    LT1=ISPACE*MAX0(NROW,NSLICE)
	    LT2=LT1+NROW*NSLICE
	    IF(MOD(NSAM,2).EQ.0)  THEN
	       LT3=LT2+NROW*NSLICE
	    ELSE
	       LT3=LT2
	    ENDIF
	    MEMNEED=LT3+MAX0(NSAM,2*NROW)
	    CALL CHKMEM(MEMNEED,BUF,MAXMEM,RUNTIME,IPQ,IRTFLG)
            IF (IRTFLG .EQ. 0)  THEN
                WRITE(NOUT,*)
     &           ' **  WARNING !   SLOW ON-DISK VERSION OF FFT USED.'
	         CALL FMRS_3D(LUN1,LUN2,Q,ISAM,NROW,NSLICE,INV)	
	    ELSE
           	CALL ERRT(6,'FT',NE)
		CLOSE(LUN1)
		CLOSE(LUN2)
		RETURN
	    ENDIF
	  ENDIF
	ENDIF
C
	IF(INV.GT.0)  THEN
C*********************DEC 87 al
C       VALUE(1) SETS IANGLE
        VALUES(1) = 1.0      
        VALUES(2) = 0.0
        VALUES(3) = 0.0
C       NEGATIVE IRTFLG SUPRESSES PRINT-OUT
        IRTFLG    = -1       
C       SINCE SETPRM USES UNLABELED COMMON FOR BUF THIS SHOULD BE OK
        CALL SETLAB(LUN2,LS,BUF,14,3,VALUES,CFORM,IRTFLG)
C       SET SCALE
        VALUES(1) = 0.0     
        IRTFLG    = -1       
        CALL SETLAB(LUN2,LS,BUF,21,1,VALUES,'U',IRTFLG)
C       FILE NOT SEARCHED FOR MIN-MAX
        VALUES(1) = 0.0      
        IRTFLG    = -1      
        CALL SETLAB(LUN2,LS,BUF, 6,1,VALUES,'U',IRTFLG)
C********************************************
	ENDIF
        CLOSE(LUN2)
        IF (RUNTIME) CALL ALLOCIT(0,RUNTIME,IPQ,'FT',IRTFLG)

        RETURN
	END
