C++*******************************************************************
C
C $$ FQ3_P.FOR 
C           
C **************************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK            *
C *  COPYRIGHT (C)1981,1987, WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH 			   *
C **************************************************************************
C
C
C $$ FQ3_P: QUICK FILTERING OF THE REAL-SPACE FILE BY IN-CORE FFT
C
C      CALL FQ3_P(LUN,LUNF,B,N2S,N2R,N2L,NSAM,NROW,NSLICE,IOPT)
C        LUN         LOGICAL UNIT NUMBER OF REAL-SPACE FILE TO BE FILTERED
C        LUNO        LOGICAL UNIT NUMBER OF REAL-SPACE OUTPUT FILE 
C        IOPT        TYPE OF THE FILTER
C	 B   	     BUFFER
C        NSAM,NROW,NSLICE   DIMENSIONS OF REAL-SPACE FILE
C        N2S=2*NSAM
C        N2R=2*NROW
C	 N2L=2*NSLICE
C  
C--*******************************************************************
C
C
	SUBROUTINE FQ3_P
     &	(LUN,LUNO,B,LSD,N2S,N2R,N2L,NSAM,NROW,NSLICE,IOPT)
	INCLUDE 'CMBLOCK.INC'
	DIMENSION  B(LSD,N2R,N2L)
	DOUBLE PRECISION  AVE
CNO_SAVE
C  READ  IMAGE
C
	DO    K=1,NSLICE
	DO    I=1,NROW
	NR=(K-1)*NROW+I
	CALL  REDLIN(LUN,B(1,I,K),NSAM,NR)
	ENDDO
	ENDDO
C
C  AVERAGE PADDING
C
	IF(N2S.NE.NSAM.AND.N2R.NE.NROW.AND.N2L.NE.NSLICE)  THEN
	AVE=0.0
c$doacross local(i,j,k),reduction(ave)
	DO    K=1,NSLICE
	DO    J=1,NROW
	DO    I=1,NSAM
	AVE=AVE+B(I,J,K)
	ENDDO
	ENDDO
	ENDDO
	AVE=AVE/FLOAT(NSAM)/FLOAT(NROW)/FLOAT(NSLICE)
c$doacross local(i,j,k)
	DO    K=1,NSLICE
	DO    J=1,N2R
	DO    I=NSAM+1,N2S
	B(I,J,K)=AVE
	ENDDO
	ENDDO
	DO    J=NROW+1,N2R
	DO    I=1,NSAM
	B(I,J,K)=AVE
	ENDDO
	ENDDO
	ENDDO
c$doacross local(i,j,k)
	DO    K=NSLICE+1,N2L
	DO    J=1,N2R
	DO    I=1,NSAM
	B(I,J,K)=AVE
	ENDDO
	ENDDO
	ENDDO
	ENDIF
C
	INV=1
	CALL  FMRS_3(B,N2S,N2R,N2L,INV)
	IF(INV.EQ.0)THEN
	IOPT=-1
	RETURN
	ENDIF
C
C BUTTERWORTH FILTER***********************
C
	IF(IOPT.EQ.7.OR.IOPT.EQ.8)  THEN
	      EPS=0.882
	      AA=10.624
	     CALL RDPRM2(FP,FS,NLOOP,ILOOP,
     &       'PASS-BAND FREQUENCY & STOP-BAND FREQUENCY??')
	     ORD=2.*ALOG10(EPS/SQRT(AA**2-1.0))
	     ORD=ORD/ALOG10(FP/FS)
	     PARM1=FP/(EPS)**(2./ORD)
C
	ELSEIF(IOPT.GE.1.OR.IOPT.LE.6)  THEN
c
	 CALL  RDPRM(PARM1,NLOOP,ILOOP,'FILTER RADIUS')
	 IF(PARM1.LT.0.0.OR.PARM1.GT.0.5)  PARM1=0.5*PARM1/(NSAM/2)
C
C FERMI DISTRIBUTION FILTER ********************
	  IF(IOPT.EQ.5.OR.IOPT.EQ.6)  THEN
C
	    CALL RDPRM(TEMP,NLOOP,ILOOP,'TEMPERATURE(0=CUTOFF)$')
C
C  EXPONENTIAL FOR HIGH-PASS OPTION
	    IF(IOPT.EQ.6) TEMP=-TEMP
	  ENDIF
        ENDIF
C
	NR2=N2R/2
	NL2=N2L/2
	X1=FLOAT(NSAM/2)**2
	Y1=FLOAT(NR2)**2
	Z1=FLOAT(NL2)**2
	PARM=PARM1**2
C
c$doacross local(i,j,k,ix,iy,iz,f)
	DO    K=1,N2L
	IZ=K-1
	IF(IZ.GT.NL2)  IZ=IZ-N2L
	DO    J=1,N2R
	IY=J-1
	IF(IY.GT.NR2)  IY=IY-N2R
	DO  2  I=1,LSD,2
	IX=(I-1)/2
	GOTO(100,200,300,400,500,500,600,700),IOPT
C LOWPASS ********************************
100   IF(0.25*(FLOAT(IX*IX)/X1+FLOAT(IY*IY)/Y1+FLOAT(IZ*IZ)/Z1)
     &	       .GT. PARM)  THEN
	B(I,J,K)=0.0
	B(I+1,J,K)=0.0
	ENDIF
	GOTO  2
C
C HIGH PASS ******************
C
200   IF((IX.NE.0 .OR. IY.NE.0 .OR.IZ.NE.0) .AND.
     &  0.25*(FLOAT(IX*IX)/X1+FLOAT(IY*IY)/Y1+FLOAT(IZ*IZ)/Z1)
     &	       .LE. PARM)  THEN
	B(I,J,K)=0.0
	B(I+1,J,K)=0.0
	ENDIF
	GOTO  2
C
C GAUSSIAN LOW PASS ***************************
C
300	F=EXP(-0.25*(
     &	  FLOAT(IX*IX)/X1+FLOAT(IY*IY)/Y1+FLOAT(IZ*IZ)/Z1)/(2.*PARM))
	B(I,J,K)=B(I,J,K)*F
	B(I+1,J,K)=B(I+1,J,K)*F
	GOTO  2
C
C GAUSSIAN HIGH PASS ********************************
C
400   IF(IX.NE.0 .OR. IY.NE.0 .OR.IZ.NE.0)  THEN
	F=(1.0-EXP(-0.25*(
     & FLOAT(IX*IX)/X1+FLOAT(IY*IY)/Y1+FLOAT(IZ*IZ)/Z1)/(2.*PARM)))
	B(I,J,K)=B(I,J,K)*F
	B(I+1,J,K)=B(I+1,J,K)*F
	ENDIF
	GOTO  2
C
C FERMI DISTRIBUTION FILTER ********************
C
500	F=(0.5*SQRT(
     &	  FLOAT(IX*IX)/X1+FLOAT(IY*IY)/Y1+FLOAT(IZ*IZ)/Z1)-PARM1)/TEMP
	F=AMIN1(AMAX1(F,-10.0),10.0)
	IF(IOPT.EQ.6 .AND. IX.NE.0 .AND.IY.NE.0 .AND. IZ.NE.0)  GOTO 2
	F=(1.0/(1.0+EXP(F)))
	B(I,J,K)=B(I,J,K)*F
	B(I+1,J,K)=B(I+1,J,K)*F
	GO TO 2
c
C BUTTERWORTH  LOWPASS FILTER **********************
C
600     F=0.5*SQRT(
     &	  FLOAT(IX*IX)/X1+FLOAT(IY*IY)/Y1+FLOAT(IZ*IZ)/Z1)
	F=SQRT(1.0/(1.0+(F/PARM1)**ORD))
	B(I,J,K)=B(I,J,K)*F
	B(I+1,J,K)=B(I+1,J,K)*F
	GO TO 2
C
C BUTTERWORTH HIGIPASS FILTER *********************
C
700 	IF(IX.NE.0 .OR. IY.NE.0 .OR.IZ.NE.0)THEN
	F=0.5*SQRT(
     &	  FLOAT(IX*IX)/X1+FLOAT(IY*IY)/Y1+FLOAT(IZ*IZ)/Z1)
	F=(1.0-SQRT(1.0/(1.0+(F/PARM1)**ORD)))
	B(I,J,K)=B(I,J,K)*F
	B(I+1,J,K)=B(I+1,J,K)*F
	ENDIF
C
2	CONTINUE
	ENDDO
	ENDDO
C
C  WRITE  IMAGE
C
	INV=-1
	CALL  FMRS_3(B,N2S,N2R,N2L,INV)
	IF(INV.EQ.0)THEN
	CALL ERRT(38,'FQ',NE)
	RETURN
	ENDIF
	DO    K=1,NSLICE
	DO    I=1,NROW
	NR=(K-1)*NROW+I
	CALL  WRTLIN(LUNO,B(1,I,K),NSAM,NR)
	ENDDO
	ENDDO
	END
