
C++*************************************************************************
C
C  FROMTOQ.FOR               ADAPTED FROM FROMTO.FOR FOR CHAR. AUG 89 al
C
C **************************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK            *
C *  COPYRIGHT (C)1981,1987, WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH 			   *
C **************************************************************************
C
C FROMTOQ(STRING,NCHAR,BRAC,KET,ILIST,RLIST,NLIST,NPARG)
C
C PARAMETERS:    STRING     INPUT STRING          (MAY BE ALTERED)
C                NCHAR      CHARS. IN STRING      (MAY BE ALTERED)
C                BRAC       START DELIMITER       (INPUT)
C                KET        END   DELIMITER       (INPUT)
C                ILIST      INPUT LIST            (RETURNED)
C                RLIST      OUTPUT LIST           (RETURNED)
C                NLIST      NO. IN LISTS          (RETURNED)
C                NPARG      MAX. LIST LENGTH      (INPUT)
C
C--*********************************************************************

       SUBROUTINE FROMTOQ(STRING,NCHAR,BRAC,KET,ILIST,RLIST,NLIST,NPARG)

        INCLUDE 'CMBLOCK.INC'

        CHARACTER *(*) STRING
        CHARACTER      BRAC,KET

        REAL           RLIST(NPARG)
        INTEGER        ILIST(NPARG)

	NLIST = 0

        IBRAC = INDEX(STRING(1:NCHAR),BRAC)
        IKET  = INDEX(STRING(1:NCHAR),KET)

	IF (IBRAC .EQ.0 .OR. IKET .EQ. 0 .OR. IBRAC .GT. IKET) RETURN

C       NS, NE ARE START AND END OF SUBSTRING CONTAINING REGISTERS
	NS   = IBRAC + 1
	NE   = IKET  - 1
        NLEN = NE - NS + 1

C       RETRIEVE REGISTER LIST FROM BRACKETED STRING
C       TRANSLATE OPERATION STRING TO UPPER CASE NOW
        CALL SSUPCAS(STRING(NS:NE))
	CALL CHKSTRQ(STRING(NS:NE),NLEN,'I',NSEL,DUM,NLIST,IER)

C       FIRST CHECK FOR MAXIMUM ARGUMENT COUNT
	IF (NLIST .GT. NPARG) THEN
	   WRITE(NOUT,*) '*** MAX ARGUMENTS FOR PROCEDURE:',NPARG
	   CALL ERRT(16,'FROMTOQ',NE)
	ENDIF

C       ALTER NCHAR TO STOP FURTHER PROCESSING OF BRACKETED SUBSTRING
        NCHAR = lnblnk(STRING(1:IBRAC-1)) + 1

	DO I=1,NPARG
          IF (NSEL(I) .NE. 0) THEN
             ILIST(I) = NSEL(I)
             RLIST(I) = PARAM(ILIST(I))
             NLIST    = I
          ELSE
             RETURN
          ENDIF
        ENDDO

        RETURN
        END

