C++************************************************************************
C
C    GALI.FOR
C
C **************************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK            *
C *  COPYRIGHT (C)1981,1987, WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *  THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR       *
C *  LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR    *
C *  USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF     *
C *  THE CENTER FOR LABORATORIES AND RESEARCH                              *
C **************************************************************************
C
C   GALI.FOR
C
C         SUBROUTINE GALI(MAXMEM)
C         SUBROUTINE  GALI_P(LSD,NSAM,NROW,NSI,ILIST,NIMA,MODE,JACUP,
C         SUBROUTINE  GETIMA_Q(X,LSD,NSAM,NROW,IMI,Q)
C         SUBROUTINE  ALROSI_Q(A,ATMP,B,C,REFER,LSD,NSAM,NROW,NSI,
C         SUBROUTINE  ALROSF_Q(A,ATMP,B,C,REFER,LSD,NSAM,NROW,NSI,
C         SUBROUTINE  RTQS_Q(X,OUT,LSD,NSAM,NROW,THETA,SHXI,SHYI)
C         SUBROUTINE  CROSRNG_Q
C         SUBROUTINE  SHFI_Q(X,OUT,LSD,NSAM,NROW,ISHX,ISHY)
C         SUBROUTINE  BLOB_Q(X,LSD,NSAM,NROW,NR)
C         SUBROUTINE  FINDMX_Q(D,LSD,NSAM,NROW,NSI,CMX,SX,SY)
C        SUBROUTINE  ALRQ_Q
C        SUBROUTINE  ALPRBS_Q(NUMR,NRING,LCIRC,MODE)
C        SUBROUTINE  FOURING_Q(CIRC,LCIRC,NUMR,NRING,EO,MODE)
C         SUBROUTINE  RTQ_Q(X,OUT,LSD,NSAM,NROW,THETA)
C         SUBROUTINE  CENT_Q(X,LSD,NSAM,NROW,SNS,SNR)
C         SUBROUTINE  OUTIM_Q(X,LSD,NSAM,NROW,IT)
C         SUBROUTINE  FMRS_1(X,N,INV)
C        SUBROUTINE  FMRS_1D(X,N,INV)
C      FUNCTION  QUADRI_Q(XX, YY, LSD, NXDATA, NYDATA, FDATA)
C
C--************************************************************************

         SUBROUTINE GALI(MAXMEM)

         PARAMETER  (NILMAX=10000)
         INTEGER*2  NUMR(3,480) 
         INCLUDE 'CMBLOCK.INC'  
C        INCLUDE '/net/ithaca/usr1/spider/src/CMBLOCK.INC'
         COMMON  DUMMY(80),BUF(1024),ILIST(NILMAX),KAF(1)
         EQUIVALENCE  (KAF,NUMR) 
         DIMENSION Q(1)
         POINTER   (IPQ,Q) 
         LOGICAL         RUNTIME 
         
C be careful with the common, it has to agree with 64 bits...
C watch for NILMAX, it's in getima, outim and outpr.
         COMMON  /FISPEC/
     &   FINPAT,FINPIC,DOCFIL,OUTIMA,OUTDOC,NLET,NLETI,NLIMA,NLDOC
         CHARACTER*80  FINPAT,FINPIC,DOCFIL,OUTIMA,OUTDOC
         COMMON /MXR/ MAXRIN
         INTEGER*2  MAXRIN
         CHARACTER*1  NULL,MODE
         COMMON  /CORE/  INCORE
         LOGICAL  INCORE
         DATA  INPIC/77/
CNO_SAVE
 
         NULL=CHAR(0)
 
C  ASK FOR DATA FILE
 
         CALL  FILERD(FINPAT,NLET,NULL,
     &   'Enter template for 2-D image name',IRTFLG)
 
         CALL  FILERD(DOCFIL,NLETI,NULL,'Selection doc',IRTFLG)
         K=0
         K2=1
         NIMA=0
778      LERR=-1
         IF(NIMA.EQ.NILMAX)  THEN
         WRITE(NOUT,*) '  Too many images, list truncated'
         GOTO  779
         ENDIF
         KP1=K+1
         CALL  UNSAV(DOCFIL,K,INPIC,KP1,BUF,1,LERR,K2)
         IF(LERR.EQ.0)  THEN
         NIMA=NIMA+1
         ILIST(NIMA)=BUF(1)
         K=K+1
         GOTO  778
         ENDIF
779      CLOSE(INPIC)
         IF(NIMA.GT.0)  THEN
         WRITE(NOUT,2001) NIMA
2001     FORMAT('  Number of images =',i5)
         ELSE
         WRITE(NOUT,*)  '  No images !'
         RETURN
         ENDIF
         CALL  FILGET(FINPAT,FINPIC,NLET,ILIST(1),INTFLG)
         CALL  OPENFB(BUF,FINPIC,INPIC,NSAM,NROW,'O',NF,NSL)
         IF(NF.NE.2)  THEN
         CALL ERRT(4,'AP SR ',NE)
         RETURN
         ENDIF
         CLOSE(INPIC)
C
	LSD=NSAM+2-MOD(NSAM,2)
C
         CALL  RDPRMI(NSI,NR,NLOOP,ILOOP,'EXPECTED SIZE OF THE OBJECT')
         IF(NSI.GE.NSAM)  THEN
         WRITE(NOUT,*) ' Object size cannot be larger than window size'
         NSI=NSAM-2
         WRITE(NOUT,*) ' Object size set to',NSI
         ENDIF
         NSI=MAX0(1,NSAM-NSI)
C
         CALL  RDPRMI(MR,NR,NLOOP,ILOOP,'FIRST AND LAST RING')
         IF(NR.GT.NSAM/2-1)  THEN
         NR=NSAM/2-1
         WRITE(NOUT,*)  ' Last ring limited to ',NR
         ENDIF
         MR=MAX0(2,MIN0(NR,MR))
         ISKIP=1
         MODE='F'
         NRING=0
         DO    I=MR,NR,ISKIP
         NRING=NRING+1
         NUMR(1,NRING)=I
	 ENDDO
C
         CALL  ALPRBS_Q(NUMR,NRING,LCIRC,MODE)
         MAXRIN=NUMR(3,NRING)-2
C
C templates for output files
C
         CALL  FILERD(OUTIMA,NLIMA,NULL,
     &   'Enter template for output',IRTFLG)
         CALL  FILERD(OUTDOC,NLDOC,NULL,
     &   'Enter template for output doc',IRTFLG)
C
C     CALL  RDPRMI(JACUP,NDUMP,NLOOP,ILOOP,
C     & 'Precision of peak location (0..100)$')
C     JACUP=MAX0(0,MIN0(100,JACUP))
         JACUP=0
C
C   memory division    K
C       numr           1  !int*2
C       image          2
C       para           3
C       WRK            4
C       A              5
C       B              6
C       C              7
C       D              8
C       refer          9
C       refern        10
C       refertmp      11
C       temp          12  !double precision
C       a_circ        13
C       refer_circ    14
C       E             15
C
C
C K1 not used
        K1=-1
        K2=1
        K3=IPALIGN64(K2+NIMA)
        K4=IPALIGN64(K3+3*NIMA)
        K5=IPALIGN64(K4+MAX0(NSAM,2*NROW))
        K6=IPALIGN64(K5+LSD*NROW)
        K7=IPALIGN64(K6+LSD*NROW)
        K8=IPALIGN64(K7+LSD*NROW)
        K9=IPALIGN64(K8+LSD*NROW)
        K10=IPALIGN64(K9+LSD*NROW)
        K11=IPALIGN64(K10+LSD*NROW)
        K12=IPALIGN64(K11+LSD*NROW)
        K13=IPALIGN64(K12+4*(MAXRIN+2))
        K14=IPALIGN64(K13+LCIRC)
        K15=IPALIGN64(K14+LCIRC)
        K16=IPALIGN64(K15+LSD*NROW)
        L_MAINBUF=K16
        INCORE=.FALSE.
        MEMTOT=L_MAINBUF+NSAM*NROW*NIMA
        
        CALL CHKMEM(MEMTOT, KAF, (MAXMEM-(NILMAX+1024+80)), 
     &              RUNTIME,IPQ,IRTFLG)
        IF(IRTFLG.EQ.0) THEN
           IF (.NOT. RUNTIME)  THEN
           
C             COULD NOT HAVE DYNAMIC MEMORY. TRY COMMON BLOCK.     
              K1=1
              K2=IPALIGN64(K1+(3*NRING+3)/2)
              K3=IPALIGN64(K2+NIMA)
              K4=IPALIGN64(K3+3*NIMA)
              K5=IPALIGN64(K4+MAX0(NSAM,2*NROW))
              K6=IPALIGN64(K5+LSD*NROW)
              K7=IPALIGN64(K6+LSD*NROW)
              K8=IPALIGN64(K7+LSD*NROW)
              K9=IPALIGN64(K8+LSD*NROW)
              K10=IPALIGN64(K9+LSD*NROW)
              K11=IPALIGN64(K10+LSD*NROW)
              K12=IPALIGN64(K11+LSD*NROW)
              K13=IPALIGN64(K12+4*(MAXRIN+2))
              K14=IPALIGN64(K13+LCIRC)
              K15=IPALIGN64(K14+LCIRC)
              K16=IPALIGN64(K15+LSD*NROW)
              L_MAINBUF=K16
              INCORE=.FALSE.
              MEMTOT=1200+L_MAINBUF+NSAM*NROW*NIMA
              
              CALL CHKMEM(MEMTOT, KAF, (MAXMEM-(NILMAX+1024+80)), 
     &              RUNTIME,IPQ,IRTFLG)
              IF(IRTFLG.EQ.0) THEN 
C                ENOUGH MEMORY IN COMMON BLOCK.
                 WRITE (NOUT,2500)  MAXMEM , MEMTOT
                 WRITE(NOUT,*)  '   ***  In-core version  ***'
                 DO  IMI=1,NIMA     
                     CALL GETIMA_Q(Q(L_MAINBUF+NSAM*NROW*(IMI-1)),
     $                        NSAM,NSAM,NROW,IMI,Q)
                 ENDDO     
                 INCORE=.TRUE.
              END IF
           ELSE
C             RUNTIME IS TRUE. DYNAMIC MEM. ALLOCATION.
              WRITE (NOUT,2500)  MAXMEM , MEMTOT
              WRITE(NOUT,*)  '   ***  In-core version  ***'
              DO  IMI=1,NIMA     
                 CALL GETIMA_Q(Q(L_MAINBUF+NSAM*NROW*(IMI-1)),
     $                        NSAM,NSAM,NROW,IMI,Q)
              ENDDO        
              INCORE=.TRUE.
           END IF  
        END IF
        IF(.NOT.INCORE) THEN
C          REDUCE MEMORY. COULD NOT ALLOCATE DYN. MEM OR COMMON
C          BLOCK MEMORY

           MEMTOT=MEMTOT-NSAM*NROW*NIMA
           CALL CHKMEM(MEMTOT, KAF, (MAXMEM-(NILMAX+1024+80)), 
     &              RUNTIME,IPQ,IRTFLG)
           IF(IRTFLG.EQ.0) THEN
              WRITE (NOUT,2500)  MAXMEM , MEMTOT
           ELSE
              CALL ERRT(6,'AP SR ',NE)
              RETURN
           ENDIF 
        END IF
        
         CALL  GALI_P(LSD,NSAM,NROW,NSI,ILIST,NIMA,MODE,JACUP,
     &			Q(K4),Q(K5),Q(K6),Q(K7),Q(K8),Q(K15),Q(K9),
     &			Q(K10),Q(K11),Q(K2),Q(K3),
     &			Q(K13),Q(K14),LCIRC,
     &			NUMR,NRING,MAXRIN,Q(K12),Q(K16),
     &			NR,NOUT)

         IF (RUNTIME) CALL ALLOCIT(0,RUNTIME,IPQ,'GALI',IRTFLG)
      
         WRITE (NOUT,2600)
         RETURN
2500     FORMAT (/,' MEMORY RESERVATION: YOU HAVE',
     #   ' RESERVED ',I8,',  YOU NEED  ',I8 / )
2600     FORMAT (/' ',80('-')//' ',' Alignment,  ',
     #   'end of computation',//' ',80('-')/)
     
         END
