C++************************************************************************
C
C $$ GALI_P.FOR
C
C **************************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK            *
C *  COPYRIGHT (C)1981,1987, WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *  THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR       *
C *  LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR    *
C *  USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF     *
C *  THE CENTER FOR LABORATORIES AND RESEARCH                              *
C **************************************************************************
C
C
C
C23456789012345678901234567890123456789012345678901234567890123456789012
C--************************************************************************
C
C $$ GALI_P.FOR
C
         SUBROUTINE  GALI_P(LSD,NSAM,NROW,NSI,ILIST,NIMA,MODE,JACUP,
     &		WRK,A,B,C,D,E,REFER,
     &		REFERN,REFERTMP,IMAGE,PARA,
     &		A_CIRC,REFER_CIRC,LCIRC,
     &		NUMR,NRING,MAXRIN,TEMP,QM,
     &		NR,NOUT)
         DIMENSION  ILIST(NIMA)
      DIMENSION  REFER(LSD,NROW),REFERN(LSD,NROW),REFERTMP(LSD,NROW)
         DIMENSION  WRK(*),E(LSD,NROW)
         DIMENSION  A(LSD,NROW),B(LSD,NROW),C(LSD,NROW),D(LSD,NROW)
         DIMENSION  PARA(3,NIMA),QM(1)
         LOGICAL  CHANGE,NOCHANGE
         LOGICAL  IMAGE(NIMA)
         INTEGER*2  NUMR(3,NRING),MAXRIN
         DOUBLE PRECISION  TEMP(MAXRIN+2,2),FNRM,DNRM
         DIMENSION  A_CIRC(LCIRC),REFER_CIRC(LCIRC)
         CHARACTER*8  ZEIT
         CHARACTER*1  MODE
C -------------------------
c	PARAMETER  (LBUF=2050)
c	COMMON  /I_LIBFFT/  INIT,COEFF(LBUF)
c	LOGICAL  INIT
C -------------------------
         DATA  ZERO/0.0/
CNO_SAVE
C
         NSNR=LSD*NROW
C
C  Prepare 'blob'  to center input images ....
C
         CALL  BLOB_Q(D,LSD,NSAM,NROW,NR)
c	INIT=.TRUE.
         INS=1
         CALL  FMRS_2(D,NSAM,NROW,INS)
c	INIT=.FALSE.
         IF(INS.EQ.0)  THEN
	CALL    ERRT(38,'AP SR',NE)
         RETURN
         ENDIF
C
C  Build first average
C
C
         CALL  TIME(ZEIT)
         ISEED=MOD(ICHAR(ZEIT(4:4))+100*ICHAR(ZEIT(5:5))
     &   +1000*ICHAR(ZEIT(7:7))+10000*ICHAR(ZEIT(8:8)),340189)
C
C  IMAGE  is used here for the random selection of images
C
         DO    IMI=1,NIMA
         IMAGE(IMI)=.FALSE.
	 ENDDO
         IMI=MIN0(NIMA,MAX0(1,INT(RAND_P(ISEED)*NIMA+0.5)))
C
         IMAGE(IMI)=.TRUE.
         PARA(1,IMI)=0.0
         PARA(2,IMI)=0.0
         PARA(3,IMI)=0.0
         CALL GETIMA_Q(A,LSD,NSAM,NROW,IMI,QM)
         CALL COP(A,B,NSNR)
         INS=1
         CALL  FMRS_2(B,NSAM,NROW,INS)
C
C  d - blob; b-current image; c-ccf.
C
         CALL  CCRS_2R(D,B,C,LSD/2,NSAM,NROW)
         CALL  FINDMX_Q(C,LSD,NSAM,NROW,NSI,CMX1,SX1,SY1)
C
         ISX1=SX1
         ISY1=SY1
         PARA(2,IMI)=ISX1
         PARA(3,IMI)=ISY1
         CALL  SHFI_Q(A,REFERN,LSD,NSAM,NROW,ISX1,ISY1)
c	print  *,' First image with blob',imi,isx1,isy1
         CALL  COP(REFERN,REFER,NSNR)
         CALL  ALRQ_Q
     &   (REFER,LSD,NSAM,NROW,NUMR,REFER_CIRC,LCIRC,NRING,MODE,IPIC)
         CALL  FOURING_Q
     &   (REFER_CIRC,LCIRC,NUMR,NRING,TEMP,MODE)
         INS=1
         CALL  FMRS_2(REFER,NSAM,NROW,INS)

C
C  go through all the remaining images.
C
         CHANGE=.FALSE.
         DO    KTN=2,NIMA
C
804      M=MIN0(NIMA,MAX0(1,INT(RAND_P(ISEED)*(NIMA-KTN+1)+0.5)))
         IMI=0
         DO  809  I=1,NIMA
         IF(IMAGE(I))  GOTO  809
         IMI=IMI+1
         IF(IMI.EQ.M)  GOTO  810
809      CONTINUE
         GOTO  804
810      IMI=I
         IMAGE(IMI)=.TRUE.
C
         CALL  GETIMA_Q(A,LSD,NSAM,NROW,IMI,QM)
         CALL COP(A,B,NSNR)
         INS=1
         CALL  FMRS_2(B,NSAM,NROW,INS)
C
C  d - blob; b-current image; c-ccf.
C
         CALL  CCRS_2R(D,B,C,LSD/2,NSAM,NROW)
         CALL  FINDMX_Q(C,LSD,NSAM,NROW,NSI,CMX1,SX1,SY1)
C
         ISX1=SX1
         ISY1=SY1
         PARA(1,IMI)=0.0
         PARA(2,IMI)=ISX1
         PARA(3,IMI)=ISY1
         CALL  SHFI_Q(A,B,LSD,NSAM,NROW,ISX1,ISY1)
Cc     print  *,' Next image with blob',imi,isx1,isy1
C
C run rotation-shift alignment
C
C
C  input:  three real images, a, b and refern
C  output: b - real aligned image, para - udated parameters
C          nochange=.true. - no change in the position of the image
C
         CALL  ALROSI_Q(A,B,D,C,REFER,LSD,NSAM,NROW,NSI,
     &   WRK,PARA(1,IMI),NOCHANGE,
     &   A_CIRC,REFER_CIRC,LCIRC,JACUP,NUMR,NRING,MAXRIN,TEMP,MODE,KTN)
         IF(.NOT.NOCHANGE)  CHANGE=.TRUE.
C
C  add image to the reference
C
         CALL  UPDTF(REFERN,B,NSNR,KTN)
	 ENDDO
C
C  correct center
C
         CALL  CENT_Q(REFERN,LSD,NSAM,NROW,XS,YS)
         XS=XS-NSAM/2-1
         YS=YS-NROW/2-1
Cc    print *, '  Center correction  ',xs,ys
         CALL  RTQS_Q(REFERN,REFER,LSD,NSAM,NROW,ZERO,-XS,-YS)
         DO    IMI=1,NIMA
         PARA(2,IMI)=PARA(2,IMI)-XS
         PARA(3,IMI)=PARA(3,IMI)-YS
	 ENDDO
C
         CALL  OUTIM_Q(REFER,LSD,NSAM,NROW,1)
         CALL  OUTPR(PARA,NIMA,1)
         TEMP(1,1)=FNRM(REFER,NSNR)
         I=1
         WRITE(NOUT,5091)  I,TEMP(1,1)
5091     FORMAT('  Iteration #',i5,'     Sum of squares=',1pd12.5)
C
C  if no changes terminate
C
         IF(.NOT.CHANGE)  GOTO  9901
C!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
C  refine the alignment
C!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
C
         ITER=0
         DNRM=0.0D0
991      CHANGE=.FALSE.
         ITER=ITER+1
c$doacross local(j,i)
         DO    J=1,NROW
         DO    I=1,LSD
          REFERN(I,J)=0.0
	 ENDDO
	 ENDDO
c$doacross local(imi)
         DO    IMI=1,NIMA
         IMAGE(IMI)=.FALSE.
	 ENDDO
C
         DO    KTN=1,NIMA
C
904      M=MIN0(NIMA,MAX0(1,INT(RAND_P(ISEED)*(NIMA-KTN+1)+0.5)))
         IMI=0
         DO  909  I=1,NIMA
         IF(IMAGE(I))  GOTO  909
         IMI=IMI+1
         IF(IMI.EQ.M)  GOTO  910
909      CONTINUE
         GOTO  904
910      IMI=I
         IMAGE(IMI)=.TRUE.
C
Cc      print *,' Image  #  ',imi
         CALL  GETIMA_Q(A,LSD,NSAM,NROW,IMI,QM)
	CALL  RTQS_Q
     &	(A,C,LSD,NSAM,NROW,PARA(1,IMI),PARA(2,IMI),PARA(3,IMI))
C
C subtract the image from the reference
         CALL  SUBAF(REFER,C,REFERTMP,NSNR,NIMA)
         CALL  COP(REFERTMP,E,NSNR)
C
C run rotation-shift alignment
C
C  input:  two real images, b and refer
C  output: c - real aligned image, para - udated parameters
C          nochange=.true. - no change in the position of the image
C
         CALL  ALROSF_Q(A,C,D,B,REFERTMP,LSD,NSAM,NROW,NSI,
     &   WRK,PARA(1,IMI),NOCHANGE,
     &   A_CIRC,REFER_CIRC,LCIRC,JACUP,NUMR,NRING,MAXRIN,TEMP,MODE)
         IF(.NOT.NOCHANGE)  THEN
         CHANGE=.TRUE.
C
C  add image to the reference
C
         CALL  UPDF(E,C,REFER,NSNR,NIMA)
         ENDIF
         CALL  UPDTF(REFERN,C,NSNR,KTN)
	 ENDDO
C
C  correct center
C
         CALL  CENT_Q(REFERN,LSD,NSAM,NROW,XS,YS)
         XS=XS-NSAM/2-1
         YS=YS-NROW/2-1
         CALL  RTQS_Q(REFERN,REFER,LSD,NSAM,NROW,ZERO,-XS,-YS)
c$doacross local(imi)
         DO    IMI=1,NIMA
         PARA(2,IMI)=PARA(2,IMI)-XS
         PARA(3,IMI)=PARA(3,IMI)-YS
	 ENDDO
C
         CALL  OUTIM_Q(REFER,LSD,NSAM,NROW,ITER+1)
         CALL  OUTPR(PARA,NIMA,ITER+1)
         TEMP(1,1)=FNRM(REFER,NSNR)
         WRITE(NOUT,5091)  ITER+1,TEMP(1,1)
         IF(TEMP(1,1).GE.DNRM)  THEN
         DNRM=TEMP(1,1)
         IF(CHANGE)  GOTO  991
         ENDIF
C
9901     CONTINUE
         END
