C++************************************************************************
C
C $$ GAMMLN.FOR
C
C
C **************************************************************************
C *                                                                        *
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK            *
C *  COPYRIGHT (C)1981,1987, WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *  THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR       *
C *  LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR    *
C *  USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF     *
C *  THE CENTER FOR LABORATORIES AND RESEARCH   			   *
C **************************************************************************
C
C	RETURNS THE VALUE ln(XX) FOR XX > 0. FULL ACCURACY IS 
C	OBTAINED FOR  0 < XX < 1, THE REFLECTION FORMULA CAN BE USED
C       FIRST.
C
C23456789012345678901234567890123456789012345678901234567890123456789012
C--************************************************************************
C
C
        DOUBLE PRECISION FUNCTION GAMMLN(XX)

        DOUBLE PRECISION COF(6), STP, HALF, ONE, FPF, TMP, SER
        DOUBLE PRECISION X, XX
        INTEGER J
CNO_SAVE

        DATA COF, STP/76.18009173D0, -86.50532033D0, 24.01409822D0,
     &          -1.231739516D0, .120858003D-2, -.536382D-5, 
     &          2.50662827465D0/
        DATA HALF, ONE, FPF/0.5D0, 1.0D0, 5.5D0/

        X = XX - ONE
        TMP = X + FPF
        TMP = (X + HALF) * DLOG(TMP) - TMP
        SER = ONE
        DO J = 1, 6
          X = X + ONE
          SER = SER + COF(J) / X
        END DO
        GAMMLN = TMP + DLOG(STP * SER)
        END 

