
C***********************************************************************
C
C  GDSTRT.FOR        CREATED JULY 85 
C
C***********************************************************************
C      AUTHOR:   ARDEAN LEITH
C      COPYRIGHT (C) 1985,1987, WADSWORTH CENTER FOR LABORATORIES AND 
C      RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY, 12201
C***********************************************************************
C
C       GDSTRT
C
C       PURPOSE:   CONTAINS THE PLOTTING COMMANDS FOR GOULD 
C                  COLORWRITER PLOTTER.  THESE COMMANDS ARE THE SAME
C                  AS HPGL COMMANDS.
C
C       ENTRY POINTS ARE:
C
C             GDSTRT(IPLUN)
C                  WHERE IPLUN IS THE UNIT NO.
C    
C             GDMOVE(IPLUN,XI,YI)
C                  WHERE  WHERE PEN IS MOVED TO XI,YI WITHOUT DRAWING
C
C             GDDRAW(IPLUN,XI,YI)
C                  WHERE  A LINE IS DRAWN FROM CURRENT PEN POSITION
C                         TO XI,YI 
C
C             GDEND(IPLUN)
C                  TO END A PLOTTING SEQUENCE
C  
C             GDPEN(IPLUN,IPEN)
C                  TO CHANGE PENS, IPEN IS PEN NUMBER (1-10)
C
C             GDFONT(IPLUN,IFONT)
C                  TO CHANGE CHAR. FONTS
C
C             GDLINE(IPLUN,LINTYP)
C                  TO CHANGE LINE TYPE, LINTYP IS LINE TYPE (1-10)
C
C             GDGO(IPLUN) 
C                  INITIALIZES PLOTTER
C
C             GDHAND(IPLUN) 
C                  HANDSHAKE FOR PLOTTER BUFFER
C
C             GDDOWN(IPLUN)
C                  PUTS PEN ON PAPER
C
C             GDTEXT(IPLUN,TEXT)
C                  PRINTS TEXT
C
C             GDHALT(IPLUN)
C                  STOPS PLOTTER
C
C      CALLED BY:   CNGOUL    SSGOUL
C 
C      CALLS:       nil
C
C--*****************************************************************

        SUBROUTINE GDSTRT(IPLUN)

C       SUBROUTINE TO START GOULD COLORWRITER PLOTTER

        CHARACTER * 1   ESC,NULL,CTRLC,CH,CTRLW,ENQ,ACK,CR,CHARQ,ANS
        CHARACTER * 80  TXLINE
        CHARACTER * 15  FMT

        DATA FMT/'(3H LB,A   ,A1)'/
C        DATA CTRLW,CTRLC,ENQ,ACK,CR,NULL,ESC/23,3,125,126,13,0,27/

        CTRLW  = CHAR(23)
        CTRLC  = CHAR(3)
        ENQ    = CHAR(125)
        ACK    = CHAR(126)
        CR     = CHAR(13)
        NULL   = CHAR(0)
        ESC    = CHAR(27)

        LASSIZ = 0.0
        LASANG = 999999

C       INITIALIZES PLOTTER HANDSHAKE
C       <ESC I> IS FOR HANDSHAKE MODE 2, BLOCKSIZE=4400, 
C       ENABLE CHAR IS "}", ACKNOWLEDGE IS "~", 10TH CHAR OF HANDSHAKE 
C       STRING IS <CR>

        WRITE(IPLUN,140) ESC
 140    FORMAT(' ',A1,'.I4400;125;126;13:')

C       SET EXTENDED OUTPUT AND HANDSHAKE MODE AT DEFAULT
        WRITE(IPLUN,141) ESC
 141    FORMAT(' ',A1,'.N:')

C**************************
C        WRITE(IPLUN,9311)
C 9311   FORMAT(' DUE TO PLOTTER FAILURE YOU MUST ENTER THE ',
C     &         ' HANDSHAKE ~ AND <CR>',/,
C     &         ' TO CONTINUE WHENEVER THE PLOTTER OUTPUT STOPS.'/)
C************************************************

        RETURN


        ENTRY GDGO(IPLUN)
C         ACTIVATES PLOTTER
          WRITE(IPLUN,190) ESC
 190      FORMAT(' ',A1,'.Y:')
        RETURN


        ENTRY GDHAND(IPLUN)
C         ACTIVATES HANDSHAKE TO ENSURE BUFFER AVAILABLE
  200     WRITE(IPLUN,150)ENQ
  150     FORMAT(' ',A1)
          READ(IPLUN,151)ANS
  151     FORMAT(A80)
          IF(ANS .NE. ACK) GO TO 200
        RETURN

        ENTRY GDWIND(IPLUN,WXMIN,WYMIN,WXMAX,WYMAX)
C         SETS OUTPUT WINDOW
          IX1 = WXMIN
          IY1 = WYMIN
          IX2 = WXMAX
          IY2 = WYMAX
          WRITE(IPLUN,1145) IX1,IY1,IX2,IY2
1145      FORMAT(' IW',3(I6,','),I6,';')
        RETURN
         
        ENTRY GDDOWN(IPLUN)
C         PUTS PEN ON PAPER
          WRITE(IPLUN,169)
  169     FORMAT(' PD;')
        RETURN


        ENTRY GDDRAW(IPLUN,XI,YI)
C         DRAW LINE
          IX = INT(XI)
          IY = INT(YI)
          WRITE(IPLUN,195)IX,IY
  195     FORMAT(' PA',I5,',',I5,';')
        RETURN


        ENTRY GDPEN(IPLUN,IPEN) 
C         CHANGES PEN COLOR, I THINK PEN=0 STORES PEN IN HOLDER
          NPEN = IPEN + 1
          IF(NPEN .LT. 0 .OR. NPEN .GT. 10) NPEN = 1
          WRITE(IPLUN,191)NPEN
  191     FORMAT(' PU;SP',I2,';')
        RETURN


        ENTRY GDFONT(IPLUN,IFONT)
C         SETS CHARACTER FONTS
C         (PRESENTLY ALL FONTS ARE CONVERTED TO STANDARD)
          WRITE(IPLUN,197)
  197     FORMAT(' CS;')
        RETURN


        ENTRY GDTEXT(IPLUN,TXLINE,ICHAR)
C         PLOTTER TO ALPHA MODE, WRITES TEXT, END TEXT 

          WRITE(FMT(9:11),8000,ERR=1010) ICHAR
8000      FORMAT(I3)
          WRITE(IPLUN,FMT) TXLINE(1:ICHAR),CTRLC

C*********** OLD
C          WRITE(IPLUN,193) TXLINE(1:ICHAR),CTRLC
C  193     FORMAT(' LB',A<ICHAR>,A1)
C************************
1010      RETURN

        ENTRY GDMOVE(IPLUN,XI,YI)
C         MOVE PEN
          IX=INT(XI)
          IY=INT(YI)
          WRITE(IPLUN,194)IX,IY
  194     FORMAT(' PU;PA',I5,',',I5,';')
        RETURN


        ENTRY GDLINE(IPLUN,ISYMBT)
C         SELECT LINE SYMBOL
          ISYMB = ISYMBT + 1
          GOTO (400,401,402,403,404,405,406,407,408,409),ISYMB

C            PLAIN LINE
  400     WRITE(IPLUN,500)
  500     FORMAT(' SM;LT;')
          RETURN

C            DOTTED LINE
  401     WRITE(IPLUN,501)
  501     FORMAT(' LT1,.3;')
          RETURN

C           DASHED LINE
  402     WRITE(IPLUN,502)
  502     FORMAT(' LT2,.6;')
          RETURN

C           DASH DOT LINE
  403     WRITE(IPLUN,503)
  503     FORMAT(' SM;LT4,2;')
          RETURN

C           LONG DASH LINE
  404     WRITE(IPLUN,504)
  504     FORMAT(' SM;LT3,1.3;')
          RETURN

C           LONG DASH, SHORT DASH LINE
  405     WRITE(IPLUN,505)
  505     FORMAT(' SM;LT6,2;')
          RETURN

C           0 SYMBOL LINE
  406     WRITE(IPLUN,506)
  506     FORMAT(' LT;SI.10,.09;CS0;SM0;')
          RETURN

C           PLUS SYMBOL LINE
  407     WRITE(IPLUN,507)
  507     FORMAT(' LT;SI.18,.18;CS0;SM+;')
          RETURN

C           BOX SYMBOL LINE
  408     CH = CHAR(124)
          WRITE(IPLUN,508)CH
  508     FORMAT(' LT;SI.09,.13;CS7;SM',A1,';')
          RETURN

C           X SYMBOL LINE
  409     WRITE(IPLUN,509)
  509     FORMAT(' LT;SI.10,.10;CS0;SMX;')
          RETURN

        ENTRY GDHALT(IPLUN)
C         END PLOTTER USE
          WRITE(IPLUN,139)ESC
  139     FORMAT(' SP;',A1,'.Z:')
          RETURN

        ENTRY GDEND(IPLUN)
C         END PLOTTER USE
          WRITE(IPLUN,122)ESC,CTRLW,ESC
  122     FORMAT(' SP;',A1,'.',A1,A1,'.Z:')
          RETURN


        ENTRY GDSIZE(IPLUN,ITSIZE)
C         SET TEXT SIZE,  DEFAULT SIZE IS 0.75%SCALE X 1.5%SCALE
          W = FLOAT(ITSIZE) / 32
          H = FLOAT(ITSIZE) / 16
          WRITE(IPLUN,300)W,H
  300     FORMAT(' SR',F6.1,',',F6.1,';')
        RETURN


        ENTRY GDTANG(IPLUN,ITANGL)
C         SET TEXT ANGLE,  DEFAULT ANGLE IS HORIZONTAL 
          RISE = ATAN(FLOAT(ITANGL))
          LASANG = ITANGL
C         SET TEXT ANGLE
          WRITE(IPLUN,301) RISE
        RETURN


        ENTRY GDTEX(IPLUN,TXLINE,ICHAR,XI,YI,ITSIZE,ITANGL,JUST)

          IF (ITSIZE .NE. LASSIZ) THEN
C           SET TEXT SIZE,  DEFAULT SIZE IS 0.75%SCALE X 1.5%SCALE

            W = (FLOAT(ITSIZE) / 32) * 0.85
            H = (FLOAT(ITSIZE) / 16) * 0.85

C           W = FLOAT(ITSIZE) / 32
C           H = FLOAT(ITSIZE) / 16
            WRITE(IPLUN,300)W,H
            LASSIZ = ITSIZE
          ENDIF

          IF (ITANGL .NE. LASANG) THEN
             RISE   = ATAN(FLOAT(ITANGL))
             LASANG = ITANGL
C            SET TEXT ANGLE
             WRITE(IPLUN,301) RISE
301          FORMAT(' DI 1.',F7.2,';')
          ENDIF

C         MOVE PEN TO JUSTIFICATION POINT
          IX=INT(XI)
          IY=INT(YI)
          WRITE(IPLUN,194)IX,IY

C         JUSTIFY LOCATION
          YJ = -0.5
          IF (JUST .EQ. 0) THEN
C            LEFT JUSTIFIED TEXT
             XJ = 0.0
          ELSE IF (JUST .EQ. 1) THEN
C            CENTERED TEXT
             XJ =  - (FLOAT(ICHAR) / 2)
          ELSE
C            RIGHT JUSTIFIED TEXT
             XJ = -ICHAR
          ENDIF
          WRITE(IPLUN,303) XJ,YJ
  303     FORMAT(' CP',F6.1,',',F6.1,';')

C         SWITCH PLOTTER TO ALPHA MODE, WRITE TEXT, END ALPHA MODE

          WRITE(FMT(9:11),8000,ERR=1011) ICHAR
          WRITE(IPLUN,FMT) TXLINE(1:ICHAR),CTRLC

C*******************88DEBUG
C          WRITE(88,8900,ERR=9038)TXLINE(:ICHAR),ICHAR,IX,IY,XJ,YJ,
C     &          ITSIZE,ITANGL,JUST,W,H
C8900      FORMAT(' TXLINE,ICHAR,IX, IY, XJ, YJ,ITSIZ,IT<,JUST,W,H',/,
C     &           1X,A<ICHAR>,I3,2I7,2F8.2,3I5,2F6.2)
C          WRITE(IPLUN,9036)
C9036      FORMAT(' OC;')
C          READ(IPLUN,*,ERR= 9038)IXQ,IYQ,IPQ,CHARQ
C          WRITE(88,9039,ERR=9038)IXQ,IYQ,IPQ
C9039      FORMAT(' IXQ,IYQ,IPQ:',3I7/)
9038      CONTINUE
C*****************************

1011     RETURN

        END

