
C++************************************************************************
C
C    GETANG.FOR -- CREATED NOV 87  BY ArDean Leith
C                  MODIFIED SEPT 90 al  to add lunara modification
C                  MODIFED  SEPT 95 al  TO REMOVED LASLAB USE ON UNIX
C                  REMOVED SHORT LABEL STUFF AUG 96 al
C
C **************************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK            *
C *  COPYRIGHT (C)1987 , WADSWORTH CENTER FOR LABORATORIES AND             *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH	                           *
C **************************************************************************
C
C       GETANG(LUN,NSAM,BUF,IBUF1,NBUF,VALUE,IRTFLG)
C
C       PURPOSE:    THIS SUBROUTINE RETRIEVES VARIABLES SUCH AS TILT ANGLES
C                   FROM THE LABEL OR SHORT OR LONG LABEL FORMAT FILES
C                   BY BUFFER POSITION NUMBER
C
C       PARAMETERS:
C         
C             LUN          LOGICAL UNIT NUMBER OF FILE
C             NSAM         NUMBER OF SAMPLES IN FILE
C             BUF          BUFFER FOR USE IN READING FILE
C             IBUF1        FIRST BUFFER POSITION TO BE RETRIEVED
C             NBUF         NUMBER OF BUFFER POSITIONS TO BE RETRIEVED
C             VALUES       ARRAY FOR BUFFER VALUES RETRIEVED
C             IRTFLG       ERROR FLAG
C
C--*******************************************************************
  
        SUBROUTINE GETANG(LUN,NSAM,BUF,IBUF1,NBUF,VALUES,IRTFLG)

        DIMENSION VALUES(*),BUF(*)

C       SPIDER NO LONGER HAS SHORT LABEL FILES (USE CP SHORT)
        CALL GETLAB(LUN,NSAM,BUF,IBUF1,NBUF,VALUES,IRTFLG)

        RETURN
        END

