C++************************************************************************
C
C  ROTQS.FOR                               
C
C **********************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.    AUTHOR: J.FRANK      *
C *  COPYRIGHT (C)1985, 1996 HEALTH RESEARCH INCORPORATED, ALBANY, NY. *
C * THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO HEALTH            *
C * RESEARCH INC. AND ARE NOT TO BE DISCLOSED TO OTHERS OR USED        *
C * FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF       *
C * HEALTH RESEARCH INC.                                               *
C **********************************************************************
C
C   GETDOCDAT(PROMPT,ASKNAME,DOCNAM,LUNDOC,GETSIZE,MAXXT,MAXYT,
C             IPQ,IRTFLG)
C
C   PARAMETERS:
C       PROMPT      PROMPT FOR DOCFILE NAME                     (SENT)
C       ASKNAME     LOGICAL VARIABLE TO ASK FOR DOCNAM          (SENT)
C       DOCNAM      DOC. FILE NAME                           (SENT/RET.)
C       LUNDOC      I/0 UNIT                                    (SENT)
C       GETSIZE     LOGICAL VARIABLE TO ASK FOR ARRAY SIZE      (SENT)
C       MAXXT       COL. IN ARRAY IPQ                        (SENT/RET.)
C       MAXYT       ROWS IN ARRAY IPQ                        (SENT/RET.)
C       IPQ         POINTER TO ARRAY                            (RET.)
C       IRTFLG      ERROR FLAG (0 IS NORMAL)                    (RET.)
C
C23456789 123456789 123456789 123456789 123456789 123456789 123456789 12
C--*********************************************************************

        SUBROUTINE GETDOCDAT(PROMPT,ASKNAME,DOCNAM,LUNDOC,GETSIZE,MAXXT,
     &                       MAXYT,IPQ,IRTFLG)

C DO NOT COMPILE WITH STATIC
CNO_SAVE

        INCLUDE 'CMBLOCK.INC' 

        CHARACTER *(*) DOCNAM,PROMPT
        LOGICAL        GETSIZE,RUNTIME,ASKNAME
        DIMENSION      PBUF(1)
        POINTER        (IPQ,PBUF) 

        IRTFLG = 1

        IF (ASKNAME) THEN
C          INPUT DOCUMENT FILENAME 
           NF = 9         
           CALL FILERD(DOCNAM,NLETD,DATEXC,PROMPT,NF)
           IF (NF .NE. 0) RETURN
        ENDIF

        IF (GETSIZE) THEN
C          FIND MAXY & MAXY BY READING DOC FILE
           CALL DOCINFO(DOCNAM,LUNDOC,MAXY,MAXX,.TRUE.,IRTFLG)
           IF (IRTFLG .NE. 0) THEN
              CALL ERRT(100,'GETDOCINFO',NE)
              RETURN
           ENDIF
           MAXX = MAXX + 1
           IF (MAXXT .GT. 0) MAXX = MIN(MAXX,MAXXT)
           IF (MAXYT .GT. 0) MAXY = MIN(MAXY,MAXYT)
        ELSE
C          USE MAXX & MAXY SENT BY CALLING PROGRAM
           MAXX = MAXXT
           MAXY = MAXYT
        ENDIF

        MAXTOT = MAXY * MAXX
        CALL CHKMEM(MAXTOT,PBUF,0,RUNTIME,IPQ,IRTFLG)
        IF (IRTFLG .NE. 0) RETURN
        IF (.NOT. RUNTIME) THEN
           CALL ERRT(101,'ONLY IMPLEMENTED WITH ALLOCABLE MEMORY',NE)
           RETURN
        ENDIF
  
        IKEY  = 1
        ICALL = 0
C       RECOVER DOC FILE CONTENTS
        CALL UNSDAL(DOCNAM,ICALL,LUNDOC,IKEY,PLIST,1,PBUF,
     &              MAXY,MAXX,NKEY,IRTFLG)
        CLOSE(LUNDOC)
        IF (IRTFLG .NE. 0) THEN
           CALL ERRT(100,'GETDOCINFO',NE)
           RETURN
        ENDIF

        IRTFLG = 0
        RETURN
        END
