 
 
#ifdef SP_UNIX 
 
C   THIS ROUTINE SPECIFIC TO VAX SPIDER AND IS NOT 
C       USED AT UNIX SITES
 
       SUBROUTINE getdump
 
       COMMON /UNITS/LUNC,NIN,NOUT
 
       WRITE(NOUT,*) 'DUMMY CALL: getdump'
       RETURN
       END
 
#else
 

C++************************************************************************
C
C $$ GETDUMP.FOR  -- ADAPTED FROM GETVAX.FOR FEB 91 al
C
C **************************************************************************
C *  COPYRIGHT (C)1989,WADSWORTH CENTER FOR LABORATORIES AND               *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH 			   *
C **************************************************************************
C
C $$ GETDUMP(FILOLD,FILVAX,LUNO,LUNN,IRTFLG)
C
C    PURPOSE:       TO CONVERT A UNIX DUMPED 8 BIT IMAGE FILE TO 
C                   VAX FORMAT
C
C    PARAMETERS:
C        FILOLD     UNIX FORMAT FILE NAME 
C        FILVAX     VAX  FORMAT FILE NAME 
C        LUNO       LOGICAL UNIT NUMBER TO BE ASSIGNED TO FILOLD.
C        LUNN       LOGICAL UNIT NUMBER TO BE ASSIGNED TO FILVAX
C        LUNF       LOGICAL UNIT NUMBER TO BE ASSIGNED TO TEMP FILE.
C        IRTFLG     ERROR RETURN FLAG. (0 IS NORMAL)
C
C    VARIABLES:   IFORM  = FILE TYPE SPECIFIER. 
C
C    NOTES:      CREATES AND DESTROYS FILES NAMED DUMP_TEMP.FDL
C                AND TEMP_DATA.JNK WHICH IT USES IN THE CONVERSION.
C
C        0         2         3         4         5         6         7     
C23456789 123456789 123456789 123456789 123456789 123456789 123456789 12
C--*********************************************************************

	SUBROUTINE GETDUMP(FILOLD,FILVAX,LUNO,LUNN,LUNF,IRTFLG)

#ifdef SP_UNIX
        INCLUDE 'CMBLOCK.INC'
#else
        INCLUDE 'COMMON1:CMBLOCK.INC'
#endif
        COMMON /LUNARA/ LUNARA(100),LASLAB

        PARAMETER  (NSAMAX = 32000)
	COMMON     BUF(NSAMAX),LBUF(4*NSAMAX),COMLIN,VALUES(4)
       
        CHARACTER *(*) FILOLD,FILVAX
        CHARACTER *160 COMLIN
        CHARACTER * 1  NULL
        CHARACTER * 1  ANS

        LOGICAL   * 1  LBUF
	LOGICAL        EX,ERRI2,DIV4

        DATA NULL/0/

C       SET FLAG FOR ERRONEOUS RETURN
        IRTFLG = 1

        NSAM = 512
        NROW = 0
10      CALL RDPRIS(NSAM,NROW,NLOOP,ILOOP,'ENTER NSAM AND NROW',IRTLFG)
        IF (IRTFLG .EQ. -1) RETURN
        IF (NROW .EQ. 0) NROW = NSAM
        IF (ERRI2(NSAM,NROW,2,1,NSAMAX,1,NSAMAX)) GOTO 10

        DIV4 = .TRUE.
        IF (MOD(NSAM,4) .NE. 0) THEN
C           CAN NOT CONVERT THIS IMAGE YET??
            DIV4 = .FALSE.
            WRITE(NOUT,*)
     &      ' *** MAY ONLY WORK IF NSAM IS EVENLY DIVISIBLE BY FOUR?'
        ENDIF

11      NSLICE = 1
        CALL RDPRIS(NSLICE,IDUM,NLOOP,ILOOP,'ENTER NSLICE',IRTLFG)
        IF (IRTFLG .EQ. -1) GOTO 10
        IF (ERRI2(NSLICE,IDUM,1,1,NSAMAX,0,0)) GOTO 11

C       CREATE TEMPORARY .FDL FILE FOR FILE TYPE CONVERSION
        OPEN(LUNF,FILE='DUMP_TEMP.FDL',FORM='FORMATTED',STATUS='NEW')
        NBYTPR = NSAM 
        WRITE(LUNF,93) NBYTPR 
93      FORMAT('RECORD',/,
     &         '      FORMAT              FIXED',/,
     &         '      CARRIAGE_CONTROL    NONE ',/,
     &         '      SIZE               ',I6)

        CLOSE(LUNF)

C       USE TEMPORARY .FDL FILE TO CONVERT RECORD LENGTH
        COMLIN = '$EXCHANGE /NETWORK /FDL=DUMP_TEMP '// FILOLD //
     &           ' DUMP_DATA.JNK' // NULL
        CALL CSVMS(COMLIN,IERR)

C       DELETE THE TEMPORARY FILE TYPE CONVERSION FILE
        COMLIN = '$DELETE /NOCONFIRM DUMP_TEMP.FDL.*' // NULL
        CALL CSVMS(COMLIN,IERR)

C       OPEN THE DIRECT ACCESS 8 BIT VAX FILE 
        OPEN(LUNO,FILE='DUMP_DATA.JNK',STATUS='OLD',
     &       RECORDTYPE='FIXED',ACCESS='DIRECT',ERR=9999)
        LUNARA(LUNO) = 1

C       OPEN THE SPIDER FILE
        DO I = LEN(FILVAX),1,-1
          IF (FILVAX(I:I) .EQ. '.') GOTO 30
        ENDDO
30      FILVAX(I:) = NULL

        IFORM = 1
        IF (NSLICE .GT. 1) IFORM = 3

        CALL OPENF(FILVAX,LUNN,NSAM,NROW,'N',NF,NSLICE)
        IF (NF .NE. 2) RETURN

C          UNIX FILE IS 8 BIT, WANT 32 BIT VAX FILE ------------------------

           IRECN = NROW * NSLICE

        IF (.NOT. DIV4) THEN
C          X IS NOT A MULTIPLE OF 4

           INBUF   = NSAM
           IOUTBUF = 0
           IRECT   = 0

           DO IPT = 1, NSAM*NROW*NSLICE
             INBUF = INBUF + 1
             IF (INBUF .GT. NSAM) THEN
               IRECT = IRECT + 1
               CALL REDLIN8(LUNO,LBUF,NSAM,IRECT)
               INBUF = 0
             ENDIF

             IOUTBUF = IOUTBUF + 1
             IVAL = LBUF(INBUF)
             IF (IVAL .LT. 0) IVAL = IVAL + 256
             BUF(IOUTBUF) = IVAL

             IF (IOUTBUF .GE. NSAM) THEN
C              WRITE VAX FORMATTED OUTPUT
               CALL WRTLIN(LUNN,BUF,NSAM,I)
               IOUTBUF = 0
             ENDIF
          ENDDO     
               
        ELSE
C          CONVERT ALL POSITIONS IN THE FILE
           DO I = 1,IRECN

C            READ UNIX FORMATTED INPUT
             CALL REDLIN8(LUNO,LBUF,NSAM,I)

             DO J = 1,NSAM
                IVAL = LBUF(J)
                IF (IVAL .LT. 0) IVAL = IVAL + 256
                BUF(J) = IVAL
             ENDDO

C            WRITE VAX FORMATTED OUTPUT
             CALL WRTLIN(LUNN,BUF,NSAM,I)
           ENDDO

        ENDIF

C       SET FLAG FOR NORMAL RETURN	
        IRTFLG = 0

        CALL RDPRMC(ANS,NA,.TRUE.,
     &    'NORMALIZED THE OUTPUT TO 0-255(Y/N or <CR>)?',
     &	   NULL,IRT)
C       8 BIT UNIX DUMPED NORMALIZED FILE
        IF (ANS .EQ. 'Y' .OR. ANS .EQ. 'y') THEN
C         FILE NOT SEARCHED FOR MIN-MAX
          VALUES(1) =   1.0
          VALUES(2) = 255.0
          VALUES(3) =   0.0
          IRTFLG    = -1
          CALL SETLAB(LUNN,NSAM,BUF, 6,3,VALUES,'U',IRTFLG)
        ENDIF

9999    CLOSE(LUNO)
        COMLIN = '$DELETE /NOCONFIRM DUMP_DATA.JNK.*' // NULL
        CALL CSVMS(COMLIN,IERR)
        CLOSE(LUNN)

        RETURN
	END

C********************** FUTURE *******************************
C        IF (MOD(NSAM,4) .NE. 0) THEN
C           NREC = NROW * NSLICE
CC          I = INPUT RECORD, J = OUTPUT RECORD, 
CC          K = INPUT POINTER, L = OUTPUT POINTER
C           I = 0
C           J = 0
C           K = NSAM + 1       
C           L = 0
C
C50         IF (J .LE. NREC) THEN
CC              MORE LINES NEEDED FOR OUTPUT
C              IF (K .GT. NSAM) THEN
CC                INPUT BUFFER EMPTY, MUST READ ANOTHER INPUT LINE
C                 I = I + 1
C                 CALL REDLIN8(LUNO,LBUF,NSAM,I)
C                 K = 0
C              ENDIF
C             
C              K = K + 1
C              IVAL = LBUF(K)
C              IF (IVAL .LT. 0) IVAL = IVAL + 256
C              L = L + 1
C              BUF(L) = IVAL
C              IF (L .GE. NSAM) THEN
CC                OUTPUT BUFFER FULL, PUT OUTPUT RECORD IN FILE
C                 J = J + 1
C                 CALL WRTLIN(LUNN,BUF,NSAM,J)
C                 L = 0
C              ENDIF
CC              GOTO 50
C           ENDIF                 
C**********************************
 
#endif
 
