	SUBROUTINE 
     $  GETF3(LUN,FBUF,NDIM,NROW,NSLICE,IIX,IIY,IIZ,QR,QI,IREADO,CON,*)
        INCLUDE 'CMBLOCK.INC'
C
c Subroutine to read a three-dimensional Fourier transform from disk.
c This program is adapted from GET3_P. It is checked if the line needed
c is in the current Fourier buffer. If yes, only the value is returned inside
c QR,QI , if not, the needed line is read from disk. 
C                                                      5/13/91 M.Radermacher
c
C      LUN         LOGICAL UNIT NUMBER OF 3D FOURIER
C      FBUF        BUFFER FOR ONE LINE OF THE 3D FOURIER
C      NDIM        (=NSAM) X-DIMENSION OF FOURIER
C      NROW        Y-DIMENSION
C      NSLICE      Z-DIMENSION
C      IX,IY,IZ    FOURIER COORDINATES WHERE VALUE IS TO BE PUT
C      QR          REAL PART OF COMPLEX FOURIER COEFFICIENT
C      QI          IMAG. PART OF COMPLEX FOURIER COEFFICIENT
C      IREADO      VARIABLE TO SAVE NUMBER OF LAST PROCESSED RECORD
C
	DIMENSION  FBUF(NDIM)
C
        CON=1
        IX=IIX
        IY=IIY
        IZ=IIZ
        IF(IX.EQ.0.OR.IX.EQ.NDIM/2) THEN
            IF(IY.LT.0) THEN
                 IY=-IY
                 IZ=-IZ
                 CON=-1.
C              WRITE(NOUT,101) IIX,IIY,IIZ,IX,IY,IZ
               ELSEIF(IY.EQ.0.AND.IZ.LT.0) THEN
                 IY=-IY
                 IZ=-IZ
                 CON=-1.
C              WRITE(NOUT,101) IIX,IIY,IIZ,IX,IY,IZ
            ENDIF
            IF(IY.EQ.NROW/2.AND.IZ.LT.0) THEN
               IZ=-IZ
               CON=-1.*CON
C             WRITE(NOUT,101) IIX,IIY,IIZ,IX,IY,IZ
            ENDIF
         ENDIF
101      FORMAT(1X,'COEFFICIENT ( ',I5,',',I5,',',I5,' )',
     $   'REPLACED BY CONJ. OF COEFFICIENT ( ',I5,',',I5,',',I5,' )')
	IF(IX.EQ.0) THEN
		IF(IY.EQ.0)  THEN
			IF(IZ.EQ.0)  THEN
                        IREAD=1
                        CALL READF3(LUN,NDIM,FBUF,V,1,IREAD,IREADO)
                        QR=V
                        QI=0
C			GET3_P=CMPLX(A(1,1,1),0.0)
			RETURN
			ELSEIF(IZ.EQ.NSLICE/2)  THEN
                        IREAD=NROW+1
                        CALL READF3(LUN,NDIM,FBUF,V,1,IREAD,IREADO)
                        QR=V
                        QI=0.
C			GET3_P=CMPLX(A(1,1,2),0.0)
			RETURN
			ELSEIF(IZ.LT.0)  THEN
C			PRINT *,
C     *           ' OUT OF BOUNDARY, IX=IY=0, IZ<0'
C                        WRITE(NOUT,100) IX,IY,IZ,iix,iiy,iiz
			RETURN 1
			ELSE
			ISLICE=2*IZ+1
                        IREAD=(ISLICE-1)*NROW+1
                        CALL READF3(LUN,NDIM,FBUF,V,1,IREAD,IREADO)
                        QR=V
                        IREAD=ISLICE*NROW+1
                        CALL READF3(LUN,NDIM,FBUF,V,1,IREAD,IREADO)
                        QI=V*CON
C			GET3_P=CMPLX(A(1,1,ISLICE),A(1,1,ISLICE+1))
			ENDIF
		ELSEIF(IY.EQ.NROW/2)  THEN
			IF(IZ.EQ.0)  THEN
                        IREAD=2
                        CALL READF3(LUN,NDIM,FBUF,V,1,IREAD,IREADO)
                        QR=V
                        QI=0
C			GET3_P=CMPLX(A(1,2,1),0.0)
			RETURN
			ELSEIF(IZ.EQ.NSLICE/2)  THEN
                        IREAD=NROW+2
                        CALL READF3(LUN,NDIM,FBUF,V,1,IREAD,IREADO)
                        QR=V
                        QI=0.
C			GET3_P=CMPLX(A(1,2,2),0.0)
			RETURN
			ELSEIF(IZ.LT.0)  THEN
C			PRINT *,
C     *           ' OUT OF BOUNDARY, IX=0, IY=NROW/2, IZ<0'
C                        WRITE(NOUT,100) IX,IY,IZ,iix,iiy,iiz
			RETURN 1
			ELSE
			ISLICE=2*IZ+1
                        IREAD=(ISLICE-1)*NROW+2
                        CALL READF3(LUN,NDIM,FBUF,V,1,IREAD,IREADO)
                        QR=V
                        IREAD=ISLICE*NROW+2
                        CALL READF3(LUN,NDIM,FBUF,V,1,IREAD,IREADO)
                        QI=V*CON
C			GET3_P=CMPLX(A(1,2,ISLICE),A(1,2,ISLICE+1))
			ENDIF
		ELSEIF(IY.LT.0)  THEN
C		PRINT *,' OUT OF BOUNDARY, IX=0, IY<0'
C                        WRITE(NOUT,100) IX,IY,IZ,iix,iiy,iiz
		RETURN 1
		ELSE
		IROW=2*IY+1
		ISLICE=IZ+1
		IF(IZ.LT.0)  ISLICE=ISLICE+NSLICE
                IREAD=(ISLICE-1)*NROW+IROW
                CALL READF3(LUN,NDIM,FBUF,V,1,IREAD,IREADO)
                QR=V
                IREAD=IREAD+1
                CALL READF3(LUN,NDIM,FBUF,V,1,IREAD,IREADO)
                QI=V*CON
C		GET3_P=CMPLX(A(1,IROW,ISLICE),A(1,IROW+1,ISLICE))
		RETURN
		ENDIF
	ELSEIF(IX.EQ.NDIM/2)  THEN
		IF(IY.EQ.0)  THEN
			IF(IZ.EQ.0)  THEN
                        IREAD=1
                        CALL READF3(LUN,NDIM,FBUF,V,2,IREAD,IREADO)
                        QR=V
                        QI=0.
C			GET3_P=CMPLX(A(2,1,1),0.0)
			RETURN
			ELSEIF(IZ.EQ.NSLICE/2)  THEN
                        IREAD=NROW+1
                        CALL READF3(LUN,NDIM,FBUF,V,2,IREAD,IREADO)
                        QR=V
                        QI=0.
C			GET3_P=CMPLX(A(2,1,2),0.0)
			RETURN
			ELSEIF(IZ.LT.0)  THEN
C			PRINT *,
C     *           ' OUT OF BOUNDARY, IX=NDIM/2, IY=0, IZ<0'
C                        WRITE(NOUT,100) IX,IY,IZ,iix,iiy,iiz
			RETURN 1
			ELSE
			ISLICE=2*IZ+1
                        IREAD=(ISLICE-1)*NROW+1
                        CALL READF3(LUN,NDIM,FBUF,V,2,IREAD,IREADO)
                        QR=V
                        IREAD=ISLICE*NROW+1
                        CALL READF3(LUN,NDIM,FBUF,V,2,IREAD,IREADO)
                        QI=V*CON
c			GET3_P=CMPLX(A(2,1,ISLICE),A(2,1,ISLICE+1))
			ENDIF
		ELSEIF(IY.EQ.NROW/2)  THEN
			IF(IZ.EQ.0)  THEN
                        IREAD=2
                        CALL READF3(LUN,NDIM,FBUF,V,2,IREAD,IREADO)
                        QR=V
                        QI=0
C			GET3_P=CMPLX(A(2,2,1),0.0)
			RETURN
			ELSEIF(IZ.EQ.NSLICE/2)  THEN
                        IREAD=NROW+2
                        CALL READF3(LUN,NDIM,FBUF,V,2,IREAD,IREADO)
                        QR=V
                        QI=0.
C			GET3_P=CMPLX(A(2,2,2),0.0)
			RETURN
			ELSEIF(IZ.LT.0)  THEN
C			PRINT *,
C     *           ' OUT OF BOUNDARY, IX=NDIM/2, IY=NROW/2, IZ<0'
C                        WRITE(NOUT,100) IX,IY,IZ,iix,iiy,iiz
			RETURN 1
			ELSE
			ISLICE=2*IZ+1
                        IREAD=(ISLICE-1)*NROW+2
                        CALL READF3(LUN,NDIM,FBUF,V,2,IREAD,IREADO)
                        QR=V
                        IREAD=ISLICE*NROW+2
                        CALL READF3(LUN,NDIM,FBUF,V,2,IREAD,IREADO)
                        QI=V*CON
C			GET3_P=CMPLX(A(2,2,ISLICE),A(2,2,ISLICE+1))
			ENDIF
		ELSEIF(IY.LT.0)  THEN
C		PRINT *,' OUT OF BOUNDARY, IX=NDIM/2, IY<0'
C                        WRITE(NOUT,100) IX,IY,IZ,iix,iiy,iiz
		RETURN 1
		ELSE
		IROW=2*IY+1
		ISLICE=IZ+1
		IF(IZ.LT.0)  ISLICE=ISLICE+NSLICE
                IREAD=(ISLICE-1)*NROW+IROW
                CALL READF3(LUN,NDIM,FBUF,V,2,IREAD,IREADO)
                QR=V
                IREAD=IREAD+1
                CALL READF3(LUN,NDIM,FBUF,V,2,IREAD,IREADO)
                QI=V*CON
C		GET3_P=CMPLX(A(2,IROW,ISLICE),A(2,IROW+1,ISLICE))
		RETURN
		ENDIF
	ELSEIF(IX.LT.0)  THEN
C	PRINT *,' OUT OF BOUNDARY, IX<0'
C                        WRITE(NOUT,100) IX,IY,IZ,iix,iiy,iiz
	RETURN 1
	ELSE
	IDIM=2*IX+1
	IROW=IY+1
	IF(IY.LT.0) IROW=IROW+NROW
	ISLICE=IZ+1
	IF(IZ.LT.0) ISLICE=ISLICE+NSLICE
        IREAD=(ISLICE-1)*NROW+IROW
        CALL READF3(LUN,NDIM,FBUF,V,IDIM,IREAD,IREADO)
        QR=V
        CALL READF3(LUN,NDIM,FBUF,V,IDIM+1,IREAD,IREADO)
        QI=V*CON
C	GET3_P=CMPLX(A(IDIM,IROW,ISLICE),A(IDIM+1,IROW,ISLICE))
	ENDIF
100     FORMAT(1X,'IX=',I4,' IY=',I4,' IZ=',I4,
     $ '( iix=',i4,' iiy=',i4,' iiz=',i4,' )')
	END
