 
 
#ifdef SP_UNIX 
 
C   THIS ROUTINE SPECIFIC TO VAX SPIDER AND IS NOT 
C       USED AT UNIX SITES
 
       SUBROUTINE getunx
 
       COMMON /UNITS/LUNC,NIN,NOUT
 
       WRITE(NOUT,*) 'DUMMY CALL: getunx'
       RETURN
       END
 
#else
 

C++************************************************************************
C
C  GETUNX.FOR  -- ADAPTED FROM GETVAX.FOR FEB 91 al
C
C **************************************************************************
C *  COPYRIGHT (C)1989,WADSWORTH CENTER FOR LABORATORIES AND               *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH 			   *
C **************************************************************************
C
C    GETUNX(FILOLD,FILNEW,LUNO,LUNN,IRTFLG)
C
C    PURPOSE:       TO CONVERT A UNIX SPIDER CONVERTIBLE IMAGE FILE TO 
C                   VAX FORMAT
C
C    PARAMETERS:
C        FILOLD     UNIX FORMAT FILE NAME 
C        FILNEW     VAX  FORMAT FILE NAME 
C        LUNO       LOGICAL UNIT NUMBER TO BE ASSIGNED TO FILOLD.
C        LUNN       LOGICAL UNIT NUMBER TO BE ASSIGNED TO FILNEW
C        LUNF       LOGICAL UNIT NUMBER TO BE ASSIGNED TO TEMP FILE.
C        IRTFLG     ERROR RETURN FLAG. (0 IS NORMAL)
C
C    VARIABLES:   IFORM  = FILE TYPE SPECIFIER. 
C                        = +3    3-D IMAGE
C	                 = +1    2-D IMAGE
C                        = -1    2-D FOURIER TRANSFORM
C                        = -3    3-D FOURIER TRANSFORM
C                        = +8    8 BIT BLACK AND WHITE IMAGE
C                        = 11    8 BIT COLOR IMAGE
C
C    NOTES:      USES A FILE NAMED SPIDER_TOVAX.FDL FOR FILE CONVERSION 
C                INFO CREATES AND DESTROYS A FILE NAMED SPIDER_TEMP.FDL
C                WHICH IT USES IN THE CONVERSION.
C
C        0         2         3         4         5         6         7     
C23456789 123456789 123456789 123456789 123456789 123456789 123456789 12
C--*********************************************************************

	SUBROUTINE GETUNX(FILOLD,FILNEW,LUNO,LUNN,LUNF,IRTFLG)

#ifdef SP_UNIX
        INCLUDE 'CMBLOCK.INC'
#else
        INCLUDE 'COMMON1:CMBLOCK.INC'
#endif
        COMMON /LUNARA/ LUNARA(100),LASLAB

        PARAMETER  (NSAMAX = 32000)
	COMMON     BUF(NSAMAX),I1BUF(4*NSAMAX),COMLIN
       
        CHARACTER *(*) FILOLD,FILNEW
        CHARACTER *160 COMLIN
        CHARACTER * 1  NULL

        CHARACTER *47  COMMAND

        LOGICAL   * 1  I1BUF
	LOGICAL   EX

C**********DEBUG
C        CHARACTER *180 CLINE
C        EQUIVALENCE    (BUF(212),CLINE)
c**        CHARACTER *37  COMMAND
C**************************8

        DATA NULL/0/
C                     123456789 123456789 123456789 123456789 1234567
        DATA COMMAND/'$EXCHANGE /NETWORK /FDL=SPMAN_DIR:SPIDER_TOVAX '/

C       SET FLAG FOR ERRONEOUS RETURN
        IRTFLG = 1
       
C       CONVERT UNIX FILE TO A FIXED RECORD LENGTH OF 256 TO READ HEADER

        COMLIN = COMMAND // FILOLD //'  '// FILNEW // NULL
        CALL CSVMS(COMLIN,IERR)

C       RETRIEVE NECESSARY HEADER INFO (LONG LABEL CONTAINS >=256 * 4 BYTES) 

        OPEN(LUNN,FILE=FILNEW,STATUS='OLD',RECORDTYPE='FIXED',
     &              READONLY,ACCESS='DIRECT',ERR=9999)

        LUNARA(LUNN) = 0
        CALL REDLIN(LUNN,BUF,256,1)
        CLOSE(LUNN)

        NSAMO   = UNIX32(BUF(12))
        NROWO   = UNIX32(BUF(2))
        NSLICEO = UNIX32(BUF(1))
        IF (NSLICEO .LT. 0) NSLICEO = -NSLICEO

        IRECO     = UNIX32(BUF(3))
        NHISTRECO = UNIX32(BUF(4))
        IFORMO    = UNIX32(BUF(5))
        LABRECO   = UNIX32(BUF(13))
        LENBYTO   = UNIX32(BUF(23))

C****** DEBUG
C         WRITE(NOUT,*) ' NSAM: ',   NSAMO,  ' NROW: ',   NROWO
C         WRITE(NOUT,*) ' NSLICE: ', NSLICEO,' IFORM: ',  IFORMO
C         WRITE(NOUT,*) ' LABRECO: ',LABRECO,' LENBYTO: ',LENBYTO
C         WRITE(NOUT,*) ' IRECO: ',  IRECO,  ' NHISTRECO:', NHISTRECO
C         WRITE(NOUT,*) ' CLINE( 1:40): ',  CLINE(1:40)
C         WRITE(NOUT,*) ' CLINE(41:80): ',  CLINE(41:80)
C************

        IF (IRECO .LE. 0) THEN
            WRITE(NOUT,*) ' *** INVALID IREC:',IRECO
            RETURN

        ELSEIF (NSAMO .LE. 0) THEN
            WRITE(NOUT,*) ' *** INVALID NSAM:',NSAMO
            RETURN
        ENDIF

C       CREATE TEMPORARY .FDL FILE FOR ACTUAL CONVERSION
        OPEN(LUNF,FILE='SPIDER_TEMP.FDL',FORM='FORMATTED',STATUS='NEW')

        NBYTPR = NSAMO * 4
        WRITE(LUNF,93) NBYTPR
93      FORMAT('RECORD',/,
     &         '      FORMAT              FIXED',/,
     &         '      CARRIAGE_CONTROL    NONE ',/,
     &         '      SIZE               ',I6)

        CLOSE(LUNF)

C       USE TEMPORARY .FDL FILE TO CONVERT TO ACTUAL RECORD LENGTH
        COMLIN = COMMAND(1:24) // 'SPIDER_TEMP ' // FILOLD // 
     &           ' ' // FILNEW // NULL
        CALL CSVMS(COMLIN,IERR)

C       DELETE THE TEMPORARY FILE TYPE CONVERSION FILE
        COMLIN = '$DELETE /NOCONFIRM SPIDER_TEMP.FDL.*' // NULL
        CALL CSVMS(COMLIN,IERR)

C       OPEN THE NEW DIRECT ACCESS VAX FILE 
        OPEN(LUNN,FILE=FILNEW,STATUS='OLD',RECORDTYPE='FIXED',
     &       ACCESS='DIRECT',ERR=9999)


        IFORMN = IFORMO

        IF (IFORMO .GT. 6) THEN
C          UNIX FILE IS 8 BIT -----------------------------------------------

           WRITE(NOUT,*) '8 BIT CONVERSION NOT IMPLEMENTED YET'
           WRITE(NOUT,*) ' '


        ELSEIF (IFORMO .LE. 6 .AND. IFORMN .LE. 6) THEN
C          UNIX FILE IS 32 BIT, WANT 32 BIT VAX FILE ------------------------

C          CONVERT FLOATING POINT POSITIONS IN HEADER BUF
           DO J = 1,211
              BUF(J) = UNIX32(BUF(J))
           ENDDO


C          ON VAX NSLICE IS NEGATIVE FOR LONG HEADER FILES (NO LONGER - ON UNIX)
           BUF(1) = -NSLICEO

C          HISTOGRAM LABEL OFTEN WILL NOT CONVERT IF EMPTY
           IRECN  = NROWO * NSLICEO
           BUF(3) = IRECN

C          REPLACE THE HEADER BACK IN THE NEW FILE
           ILOC = 1
           DO  I = 1,LABRECO
             CALL WRTLIN(LUNN,BUF(ILOC),NSAMO,I)
             ILOC = ILOC + NSAMO
           ENDDO


           LUNARA(LUNN) = LABRECO

C****** DEBUG
C        INQUIRE(UNIT=LUNN,RECL=NSAMTEMP)
C        WRITE(NOUT,*) ' RECORD LENGTH IN NEW FILE: ',  NSAMTEMP
C        WRITE(NOUT,*) ' NSLICEO ',  NSLICEO
C        WRITE(NOUT,*) ' BUF(1): ',  BUF(1)
C        WRITE(NOUT,*) ' lunara (lunn) ',  LUNARA(LUNN)
C************

C          CONVERT ALL POSITIONS IN THE FILE
           DO I = 1,IRECN

C            READ UNIX FORMATTED INPUT
             CALL REDLIN(LUNN,BUF,NSAMO,I)

C            CONVERT EACH POSITION IN BUF
             DO J = 1,NSAMO
               BUF(J) = UNIX32(BUF(J))
             ENDDO

C            WRITE VAX FORMATTED OUTPUT
             CALL WRTLIN(LUNN,BUF,NSAMO,I)
           ENDDO


        ELSEIF (IFORMO .LE. 6 .AND. IFORMN .EQ. 8) THEN
C          UNIX FILE IS 32 BIT, WANT 8 BIT VAX FILE ------------------------

           WRITE(NOUT,*) '8 BIT CONVERSION NOT IMPLEMENTED YET'
           WRITE(NOUT,*) ' '
        ENDIF


        ITEMP = LABRECO + IRECN

        IF (NSLICEO .GT. 1) THEN
           WRITE(NOUT,99) NSAMO,NROWO,NSLICEO,ITEMP
99       FORMAT('  IMAGE: (',I4,',',I4,',',I4,')   TOTAL RECORDS:',I6,/)

        ELSE
           WRITE(NOUT,98) NSAMO,NROWO,ITEMP
98         FORMAT('  IMAGE: (',I4,',',I4,')     TOTAL RECORDS:',I6,/)
        ENDIF


C       SET FLAG FOR NORMAL RETURN	
        IRTFLG = 0

C*************** DEBUG
C        IFORM = IFORMO
C        write(6,*) ' normalizing with norm3'
C        CALL NORM3(LUNN,NSAMO,NROWO,1,FMAX,FMIN,AV)
C        CALL QSTAT(LUNN,LUND,NSAMO,NROWO,NSLICEO)
C*********************8

9999    CLOSE(LUNO)
        CLOSE(LUNN)

        RETURN
	END
 
#endif
 
