 
 
#ifdef SP_UNIX 
 
C   THIS ROUTINE SPECIFIC TO VAX SPIDER AND IS NOT 
C       USED AT UNIX SITES
 
       SUBROUTINE getv16
 
       COMMON /UNITS/LUNC,NIN,NOUT
 
       WRITE(NOUT,*) 'DUMMY CALL: getv16'
       RETURN
       END
 
#else
 

C++************************************************************************
C
C GETV16.FOR  -- ADAPTED FROM OPENF.FOR MARCH 89 al
C
C **************************************************************************
C *  COPYRIGHT (C)1989       WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH 			   *
C **************************************************************************
C
C    GETV16(FILOLD,FILNEW,LUNO,LUNN,MODE,IRTFLG)
C
C    PURPOSE:       TO CONVERT A VAX IMAGE FILE TO SUN UNIX FORMAT
C
C    PARAMETERS:
C        FILOLD     VAX FORMAT FILE NAME 
C        FILNEW     UNIX  FORMAT FILE NAME 
C        LUNO       LOGICAL UNIT NUMBER TO BE ASSIGNED TO FILOLD.
C        LUNN       LOGICAL UNIT NUMBER TO BE ASSIGNED TO FILNEW
C        MODE       TYPE OF OUTPUT FILE (8 OR 16 BIT INTEGERS)
C        IRTFLG     ERROR RETURN FLAG. (0 IS NORMAL)
C
C    VARIABLES:   IFORM  = FILE TYPE SPECIFIER. 
C                        = +3    3-D IMAGE
C	                 = +1    2-D IMAGE
C                        = -1    2-D FOURIER TRANSFORM
C                        = -3    3-D FOURIER TRANSFORM
C                        = +8    8 BIT BLACK AND WHITE IMAGE
C                        = 11    8 BIT COLOR IMAGE
C                        = 16   16 BIT BLACK AND WHITE IMAGE
C
C        0         2         3         4         5         6         7     
C23456789012345678901234567890123456789012345678901234567890123456789012
C--*********************************************************************

	SUBROUTINE GETV16(FILOLD,FILNEW,LUNO,LUNN,MODE,IRTFLG)

#ifdef SP_UNIX
        INCLUDE 'CMBLOCK.INC'
#else
        INCLUDE 'COMMON1:CMBLOCK.INC'
#endif

	COMMON BUFO,LBUF
        COMMON /LUNARA/ LUNARA(100),LASLAB

        CHARACTER *(*)   FILOLD,FILNEW
        CHARACTER *81    FILTMP
        CHARACTER * 1    NULL,ANS
        REAL             BUFO(16000)
        INTEGER   * 2    I2VAL
        LOGICAL   * 1    LBUF(32000),LVAL(2),LVAL1,LVAL2
	LOGICAL          EX,ONEPAD,HEADER

        EQUIVALENCE      (LVAL,I2VAL),(LVAL1,LVAL(1))
        EQUIVALENCE      (LVAL2,LVAL(2))

        NULL = CHAR(0)

C       SET FLAG FOR ERRONEOUS RETURN
        IRTFLG = 1
       
	INQUIRE(FILE=FILOLD,IOSTAT=IOERR,EXIST=EX,RECL=LENOLD)
C       LENOLD IS NUMBER OF 32 BIT NUMBERS IN EACH RECORD
        LENOLD = LENOLD / 4

	IF (IOERR .OR. .NOT. EX) THEN
C          ERROR -- FILE DOES NOT EXIST, BUT IS BEING OPENED WITH 'OLD'
           WRITE(NOUT,2051) FILOLD
2051       FORMAT(' *** NOT FOUND: ',A)
           RETURN
        ENDIF

C       RETRIEVE ALL LABEL INFO (LONG LABEL CONTAINS >= 256 * 4 BYTES. 
C       WHICH MAY BE SPREAD OVER SEVERAL RECORDS)
1000    OPEN(LUNO,FILE=FILOLD,ACCESS='DIRECT',IOSTAT=IER,
     &       STATUS='OLD',RECORDTYPE='FIXED',FORM='UNFORMATTED')

        IF (IER .NE. 0) THEN
           WRITE(NOUT,900) FILOLD
           RETURN
        ENDIF

        LUNARA(LUNO) = 1
        I = -1
        J = 1

3       I = I + 1
        CALL REDLIN(LUNO,BUFO(J),LENOLD,I)
        J = J + LENOLD
        IF (LENOLD * (I+1) .LT. 256) GOTO 3

C       SET VAX FILE LABEL LENGTH
        LABRECV = 256 / LENOLD
        IF(MOD(256,LENOLD) .NE. 0) LABRECV = LABRECV + 1
        LUNARA(LUNO) = LABRECV

        NSLICE = BUFO(1)
        IF (NSLICE .GE. 0) THEN
C          SHORT LABEL FILE
           WRITE(NOUT,*) 'NSLICE:' ,NSLICE
           WRITE(NOUT,*)'SHORT LABEL CONVERSION NOT IMPLEMENTED'
           RETURN
        ENDIF
        NSLICE = IABS(NSLICE)

        NROW     = BUFO(2)
        IFORM    = BUFO(5)
        IF (BUFO(5) .LT. 0.0) IFORM = BUFO(5)-0.5
        NHISTREC = BUFO(4)+0.5
        IHIST    = BUFO(11)+0.5

C       IN LONG LABEL FILES THE NUMBER OF PIXELS IN EACH RECORD IS IN BUFO(12)
C       FOR 8 OR 16 BIT DATA THE LAST 1 OR 3 BYTES OF EACH DATA RECORD MAY 
C       BE EMPTY

C       NSAM IS NUMBER OF PIXELS IN EACH RECORD
C       LENOLD IS NUMBER OF FLOATING POINT NUMBERS IN EACH RECORD OF VAX FILE

        NSAM = BUFO(12)
C       MAKE SURE BUF(12) CONTAINS NSAM
        IF (NSAM .LE. 0) THEN
           NSAM = LENOLD
           BUFO(12) = NSAM
        ENDIF

        IMAMI = BUFO(6)
        IF (IMAMI .EQ. 0) THEN
C          MUST NORMALIZE INPUT IMAGE FIRST
           CLOSE(LUNO)
           ITD = INDEX(FILOLD,'.') - 1
           FILTMP = FILOLD(1:ITD) // CHAR(0)
           CALL OPENF(FILTMP,LUNO,NSAM,NROW,'OLD',NF,NSLICE)
           CALL NORM3(LUNO,NSAM,NROW,NSLICE,FMAX,FMIN,AV)
           CLOSE(LUNO)
           GOTO 1000

        ELSE
           FMIN = BUFO(8)
           FMAX = BUFO(7)
        ENDIF

        HEADER = .TRUE.
        IF (MODE .EQ. 88) THEN
C          DO NOT WANT HEADER
           MODE = 8
           HEADER = .FALSE.
        ENDIF

        IF (MODE .EQ. 8 .OR. MODE .EQ. -8) THEN
C          WANT 8 BIT INTEGER UNIX FILE
           LENBYT  = NSAM
           BUFO(5) = 8
           NMIN    = 0
           NMAX    = 255

           NSAMRE  = MOD(NSAM,4)
           CALL RDPRMC(ANS,NC,.TRUE.,
     &     'PAD TO INCREMENT OF 4 IF NECESSARY? (Y/N)',NULL,IRTFLG)
           IF (IRTFLG .NE. 0) RETURN

           IF (NSAMRE .NE. 0) THEN
              IF (ANS(1:1) .NE. 'N' .OR. NC .EQ. 0) THEN
C                WANT TO PAD
                 NSAM     = NSAM + (4-NSAMRE)
                 LENBYT   = NSAM
                 BUFO(12) = NSAM
              ENDIF
           ENDIF

           IF (MODE .EQ. 8) THEN
             FN    = (NMAX - NMIN) / (FMAX - FMIN)
             FNCON = NMIN - FN * FMIN

           ELSEIF (MODE .EQ. -8) THEN
             IF (FMAX .GT. 255) THEN
C              CAN NOT USE THIS FOR 8 BIT OUTPUT
               WRITE(NOUT,*) ' FMAX:',FMAX,
     &              'TOO LARGE FOR 8 BIT UN-NORMALIZED OUTPUT'
               CLOSE(LUNO)
               RETURN
             ENDIF
             FN    = 1.0
             FNCON = 0.0
           ENDIF
  
        ELSEIF (MODE .EQ. 16 .OR. MODE .EQ. -16) THEN
C          FOR 16 BIT INTEGER UNIX FILES
           LENBYT  = NSAM * 2
           BUFO(5) = 16
           NMIN    = 0
           NMAX    = 2**15

           IF (MODE .EQ. 16) THEN
             FN    = (NMAX - NMIN) / (FMAX - FMIN)
             FNCON = NMIN - FN * FMIN
             NMAX  = 2048

           ELSE
             FN      = 1.0
             FNCON   = 0
             NMAX    = 4095
           ENDIF
        ENDIF

        BUFO(8)  = NMIN
        BUFO(7)  = NMAX
        BUFO(9)  = BUFO(9)  * FN + FNCON
        BUFO(10) = BUFO(10) * FN + FNCON

C       FIND NUMBER OF RECORDS IN THE LABEL
        LABRECS = 1024 / LENBYT
        IF (MOD(1024,LENBYT) .NE. 0) LABRECS = LABRECS + 1

C       FIND TOTAL NUMBER OF BYTES IN UNIX FILE LABEL
        LABBYT   = LABRECS * LENBYT
        BUFO(22) = LABBYT
        BUFO(13) = LABRECS 
        BUFO(23) = LENBYT
                
C       FIND NUMBER OF RECORDS EXPECTED IN FILE
        CALL TOTREC(NSAM,NROW,NSLICE,IEND)
        WRITE(NOUT,*) 'IMAGE AND FOLLOWING RECORDS:',IEND
        
C       CONVERT FLOATING POINT PORTION OF LONG LABEL TO UNIX IEEE FORMAT
        DO 100 I=1,211
100     CALL VAX32(BUFO(I))


C       OPEN NEW UNIX  FILE
        OPEN(LUNN,FILE=FILNEW,ACCESS='DIRECT',RECL=256,IOSTAT=IER,
     &       STATUS='NEW',FORM='UNFORMATTED')

        IF (IER .NE. 0) THEN
           WRITE(NOUT,900) FILNEW
900        FORMAT(' *** ERROR OPENING: ',A)
           RETURN
        ENDIF

        IF (.NOT. HEADER) THEN
C          SKIP HEADER IN NEW FILE (FOR USE WITH PIXAR, ETC)
           LUNARA(LUNN) = 0
           LABRECS      = 0
           LABBYT       = 0
           L            = 0
           K            = 0
           GOTO 4444
        ENDIF


C       PLACE LABEL IN NEW UNIX FILE
        LUNARA(LUNN) = 1
        CALL WRTLIN(LUNN,BUFO,256,0)

        L    = 0
        K    = LABBYT - 1024
        ONEPAD = .TRUE.
1213    IF (K .GE. 1024) THEN
C          NEED ANOTHER RECORD FOR LABEL PADDING
           IF (ONEPAD) THEN
C             FILL PADDING PART OF LABEL WITH BLANKS
              DO 1212 II = 1025,LABBYT
1212          LBUF(II) = 0
              ONEPAD = .FALSE.
           ENDIF
            L = L + 1
            CALL WRTLIN8(LUNN,LBUF,1024,L)
            K = K - 1024
            GOTO 1213            
        ENDIF

C       ZERO BUFFER FOR ANY PADDING
4444    LBUF(NSAM+1) = 0
        LBUF(NSAM+2) = 0
        LBUF(NSAM+3) = 0

        WRITE(6,*) ' LABEL RECORDS:',LABRECS,' IMAGE RECORDS: ',IEND

        IF (MODE .EQ. 16 .OR. MODE .EQ. -16) THEN
C         WANT 16 BIT INTEGER FILE
         
          DO 220 I = 1,IEND
C           READ EACH RECORD OF VAX FILE

            CALL REDLIN(LUNO,BUFO,LENOLD,I)
C           CONVERT FLOATING POINT NUMBERS TO 0...4095 INTEGERS 

            DO 222 J=1,NSAM
              K = K + 1

C****************DEBUG
              FFF = BUFO(J) * FN + FNCON
              IF (FFF .GE. 4096) THEN
                 WRITE(6,*)' OUT OF RANGE!!  FVAL:',FFF
                 WRITE(6,*)'IEND,I,J,L: ', IEND,I,J,L
                 STOP
              ENDIF
              I2VAL = FFF
C*************************88
C*            I2VAL = BUFO(J) * FN + FNCON

              LBUF(K) = LVAL1
              IF (K .EQ. 1024) THEN
C                RECORD IS FULL
                 L = L + 1
                 CALL WRTLIN8(LUNN,LBUF,1024,L)
                 K = 0
              ENDIF

              K = K + 1
              LBUF(K) = LVAL1

              IF (K .EQ. 1024) THEN
C                RECORD IS FULL
                 L = L + 1
                 CALL WRTLIN8(LUNN,LBUF,1024,L)
                 K = 0
              ENDIF

222         CONTINUE
 
220       CONTINUE
          IF (K .GT. 0) THEN
C            RECORD STILL HAS PIXELS
             L = L + 1
             CALL WRTLIN8(LUNN,LBUF,K,L)
          ENDIF


        ELSEIF (MODE .EQ. 8 .OR. MODE .EQ. -8) THEN
C         WANT 8 BIT INTEGER FILE

          DO 230 I = 1,IEND
C           READ EACH RECORD OF VAX FILE
            CALL REDLIN(LUNO,BUFO,LENOLD,I)

C           CONVERT FLOATING POINT NUMBERS TO -128...127 LOGICAL *1

            DO 232 J=1,NSAM
              K       = K + 1
              I2VAL   = BUFO(J) * FN + FNCON
              LBUF(K) = LVAL1
              IF (K .EQ. 1024) THEN
C                RECORD IS FULL
                 L = L + 1
                 CALL WRTLIN8(LUNN,LBUF,1024,L)
                 K = 0
              ENDIF
232         CONTINUE
 
230       CONTINUE
          IF (K .GT. 0) THEN
C            RECORD STILL HAS PIXELS
             L = L + 1
             CALL WRTLIN8(LUNN,LBUF,K,L)
          ENDIF
        ENDIF


        IF (NSLICE .GT. 1) THEN
          WRITE(NOUT,2099) NSAM,NROW,NSLICE,LABBYT
2099      FORMAT('  IMAGE SIZE: (',I4,',',I4,',',I4,')  LABEL BYTES:',
     &    I6,/)

        ELSE
          WRITE(NOUT,2098) NSAM,NROW,LABBYT
2098      FORMAT('  IMAGE SIZE: (',I4,',',I4')  LABEL BYTES:',I6,/)
        ENDIF


C       SET FLAG FOR NORMAL RETURN	
        IRTFLG = 0
        RETURN
	END


 
#endif
 
