 
 
#ifdef SP_UNIX 
 
C   THIS ROUTINE SPECIFIC TO VAX SPIDER AND IS NOT 
C       USED AT UNIX SITES
 
       SUBROUTINE getvax
 
       COMMON /UNITS/LUNC,NIN,NOUT
 
       WRITE(NOUT,*) 'DUMMY CALL: getvax'
       RETURN
       END
 
#else
 

C++************************************************************************
C
C $$ GETVAX.FOR  -- ADAPTED FROM OPENF.FOR FEB 88 al
C
C **************************************************************************
C *  COPYRIGHT (C)1989       WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH 			   *
C **************************************************************************
C
C $$ GETVAX
C
C    PURPOSE:       TO CONVERT A VAX IMAGE FILE TO SUN UNIX FORMAT
C
C    PARAMETERS:
C        FILOLD     VAX FORMAT FILE NAME 
C        LUNO       LOGICAL UNIT NUMBER TO BE ASSIGNED TO FILOLD.
C        FILNEW     SUN  FORMAT FILE NAME 
C        LUNN       LOGICAL UNIT NUMBER TO BE ASSIGNED TO FILNEW
C        IRTFLG     ERROR RETURN FLAG. (0 IS NORMAL)
C
C    VARIABLES:   IFORM  = FILE TYPE SPECIFIER. 
C                        = +3    3-D IMAGE
C	                 = +1    2-D IMAGE
C                        = -1    2-D FOURIER TRANSFORM
C                        = -3    3-D FOURIER TRANSFORM
C                        = +8    8 BIT BLACK AND WHITE IMAGE
C                        = 11    8 BIT COLOR IMAGE
C
C--********************************************************************

	SUBROUTINE GETVAX(FILOLD,FILNEW,LUNO,LUNN,IRTFLG)

#ifdef SP_UNIX
        INCLUDE 'CMBLOCK.INC'
#else
        INCLUDE 'COMMON1:CMBLOCK.INC'
#endif

        COMMON /LUNARA/ LUNARA(100),LASLAB
	COMMON BUFO(17000)
               
        CHARACTER *(*) FILOLD,FILNEW
        CHARACTER * 1  NULL
	LOGICAL        EX

	DATA LENLAB/256/

        NULL = CHAR(0)

C       SET FLAG FOR ERRONEOUS RETURN
        IRTFLG = 1
       
	INQUIRE(FILE=FILOLD,IOSTAT=IOERR,EXIST=EX,RECL=LENLAB4)
        LENREC = LENLAB4 / 4

	IF (IOERR .OR. .NOT. EX) THEN
C          ERROR -- FILE DOES NOT EXIST, BUT IS BEING OPENED WITH 'OLD'
           CALL ERRT(18,'GETVAX',NE)
           RETURN
        ENDIF

C       RETRIEVE ALL LABEL INFO (LONG LABEL CONTAINS >=256 * 4 BYTES) 
        OPEN(LUNO,FILE=FILOLD,ACCESS='DIRECT',ERR=9999,
     &       STATUS='OLD',RECORDTYPE='FIXED',FORM='UNFORMATTED')

        LUNARA(LUNO) = 1
        I = -1
        J = 1

3       I = I + 1
        CALL REDLIN(LUNO,BUFO(J),LENREC,I)
        J = J + LENREC
        IF (LENREC * (I+1) .LT. 256) GOTO 3

        NSLICE = BUFO(1)
        IF (NSLICE .EQ. 0) THEN
C          FIX UP OLD LABELS NSLICE
           BUFO(1) = -1
           NSLICE  = 1

        ELSEIF (NSLICE .GT. 0) THEN
C           OLD SPIDER SHORT LABEL FILE
            WRITE(NOUT,*) '*** SHORT LABEL CONVERSION NOT IMPLEMENTED'
            CALL ERRT(2,'GETVAX',NE)
            RETURN
        ELSE
            NSLICE = -NSLICE
        ENDIF

C       IN LONG LABEL FILES THE PIXELS IN EACH RECORD IS IN BUFO(12)
        NROW   = BUFO(2)
        IFORM  = BUFO(5)
        IF (BUFO(5) .LT. 0.0) IFORM = BUFO(5)-0.5
        NHISTREC = BUFO(4)+0.5
        IHIST  = BUFO(11)+0.5

C       FIND NUMBER OF FLOATING POINT VALUES IN EACH RECORD (LENREC)
        IF (IFORM .EQ. 8 .OR. IFORM .EQ. 11) THEN
C          FOR 8 BIT FILES
           NSAM   = BUFO(12)
           LENREC = NSAM / 4
           IF ((LENREC * 4) .LT. NSAM) LENREC = LENREC + 1
        ELSE
C         FOR NORMAL 32 BIT SPIDER FILES
          NSAM   = LENREC
          LENREC = NSAM
        ENDIF

        LENREC4  = LENREC
        NHISTREC   = BUFO(4)+0.5
                
C       MAKE SURE BUF(12) CONTAINS NSAM
        IF (BUFO(12) .LE. 0) BUFO(12) = NSAM

C       FIND NUMBER OF RECORDS IN THE HEADER LABEL
        LABRECS  = 256 / NSAM
        IF(MOD(256,NSAM) .NE. 0) LABRECS = LABRECS + 1
        BUFO(13) = LABRECS

        LABBYT   = LABRECS * NSAM * 4
        BUFO(22) = LABBYT

C       CONVERT FLOATING POINT PORTION OF LONG LABEL
        DO I=1,211
           CALL VAX32(BUFO(I))
        ENDDO

C       OPEN NEW FILE FOR UNIX VERSION
        OPEN(LUNN,FILE=FILNEW,ACCESS='DIRECT',RECL=LENREC,ERR=9999,
     &       STATUS='NEW',RECORDTYPE='FIXED',FORM='UNFORMATTED')

C       PLACE LABEL IN NEW UNIX FILE
        LUNARA(LUNN) = 1
        I = -1
        J = 1

13      I = I + 1
        CALL WRTLIN(LUNN,BUFO(J),LENREC,I)
        J = J + LENREC
        IF (LENREC * (I+1) .LT. 256) GOTO 13

C       RESET LUNARA FOR IMAGE PORTION OF FILE IO
        LUNARA(LUNO) = LABRECS
        LUNARA(LUNN) = LABRECS

C       FIND NUMBER OF IMAGE RECORDS EXPECTED IN FILE (IEND)
        CALL TOTREC(NSAM,NROW,NSLICE,IEND)

        DO 200 I = 1,IEND

C         READ EACH RECORD OF VAX FILE
          CALL REDLIN(LUNO,BUFO,LENREC,I)

C         CONVERT FLOATING POINT NUMBERS TO SUN FORMAT
          DO J=1,LENREC
            CALL VAX32(BUFO(J))
          ENDDO

C         WRITE RECORD TO SUN FILE
          CALL WRTLIN(LUNN,BUFO,LENREC,I)
200     CONTINUE

        IF (NSLICE .GT. 1) THEN
           WRITE(NOUT,2099) NSAM,NROW,NSLICE,LABBYT
2099       FORMAT('  IMAGE SIZE: (',I4,',',I4,',',I4,')',
     &            '    LABEL BYTES:',I6,/)
        ELSE
           WRITE(NOUT,2098) NSAM,NROW,LABBYT
2098       FORMAT('  IMAGE SIZE: (',I4,',',I4,')',
     &            '    LABEL BYTES:',I6,/)
        ENDIF


C       SET FLAG FOR NORMAL RETURN	
        IRTFLG = 0
        RETURN


9999    WRITE(NOUT,*) '*** ERROR OPENING FILE'
        CALL ERRT(50,'GETVAX',NE)

        RETURN
	END

 
#endif
 
