 
 
#ifdef SP_UNIX 
 
C   THIS ROUTINE SPECIFIC TO VAX SPIDER AND IS NOT 
C       USED AT UNIX SITES
 
       SUBROUTINE gongon
 
       COMMON /UNITS/LUNC,NIN,NOUT
 
       WRITE(NOUT,*) 'DUMMY CALL: gongon'
       RETURN
       END
 
#else
 
C $$ GONGON.FOR

C    CALLED BY:  LXGOLD

C--------------------------------------------------------------

C...GONGON - Modifed from JGONEULT.FOR on May 20 1987 by A. Leith at
C...          NYSDOH, ALBANY to calculate angles one by one instead
C...          of taking input from a file.
C...GONEUL - Convert goniometer angles THETA and PHI to Eulerian angles
C...         ALPHA, BETA and GAMMA.
C...Mark Rould  29DEC84
C...Theta is angle of tilt (around tilt axis.) (Y-axis)
C...Phi is angle around microscope axis (counterclockwise, as usual.) (Z-axis)

      SUBROUTINE GONGON(THETAD,PHID,ALPHAD,BETAD,GAMMAD,IRTFLG)
      COMMON /UNITS/LUNC,NIN,NOUT,NECHO,IFOUND,NPROC,NDAT

      CHARACTER*10 TITLE
      DIMENSION ROT( 3, 3), EROT( 3, 3)
      DATA TOL ERROR / 0.001 /
      DEGTORAD = 3.141592653589793 / 180.

      THETA = THETAD * DEGTORAD
      PHI   = PHID   * DEGTORAD
      TAU   = 0
C*    CALL GONIOM( THETA, PHI, TAU, ROT)
      CALL GONGON2( THETA, PHI, TAU, ROT)

      SINB = -ROT(3,1)
      COSB = SQRT( 1 - SINB * SINB )
      IF ( COSB .EQ. 0.0 ) THEN
         WRITE(NOUT,905)
905      FORMAT(' ERROR IN GONGON: Cannot complete. COSB = 0.'//)
         IRTFLG = 1
         RETURN
      ENDIF
      COSA = ROT(1,1) / COSB
      SINA = ROT(2,1) / COSB
      COSC = ROT(3,3) / COSB
      SINC = ROT(3,2) / COSB
      ERROR = GONGON6( COSA, SINA, COSB, SINB,COSC, SINC, ROT)
      IF ( ERROR .GT. TOL ERROR ) THEN
         WRITE(NOUT,906)
906      FORMAT(' Tolerable error exceeded.'//)
         IRTFLG = 1
         RETURN
      ENDIF
      ALPHA = GONGON5( SINA, COSA)
      BETA  = GONGON5( SINB, COSB)
      GAMMA = GONGON5( SINC, COSC)
C*    CALL EULER( ALPHA, BETA, GAMMA, EROT, 1. ,1., 1.)
      CALL GONGON3( ALPHA, BETA, GAMMA, EROT, 1. ,1., 1.)
      ALPHAD=ALPHA/DEGTORAD
      BETAD =BETA /DEGTORAD
      GAMMAD=GAMMA/DEGTORAD
      IF(ALPHAD.GT.180.)ALPHAD=ALPHAD-360.
      IF(BETAD.GT.180.) BETAD =BETAD -360.
      IF(GAMMAD.GT.180.)GAMMAD=GAMMAD-360.
      IRTFLG = 0
      RETURN
      END

C------------------------------------------------------------------------------

      FUNCTION GONGON6( CA, SA, CB, SB, CC, SC, R)

C*    OLD NAME: FUNCTION COMPARE GONIOM EULER( CA, SA, CB, SB, CC, SC, R)

      DIMENSION R( 3, 3)
      DIF = 0.
      DIF = DIF + ABS( R(1,2) - (-SA*CC+CA*SB*SC) )
      DIF = DIF + ABS( R(1,3) - (SA*SC+CA*SB*CC) )
      DIF = DIF + ABS( R(2,2) - (CA*CC+SA*SB*SC) )
      DIF = DIF + ABS( R(2,3) - (-CA*SC+SA*SB*CC) )
      GONGON6 = DIF
      RETURN
      END
C------------------------------------------------------------------------------

      FUNCTION GONGON5( Y, X)

C*    OLD NAME:      FUNCTION ARCTAN( Y, X)

      PI = 3.141592653589793
      IF ( X .NE. 0.0 ) THEN
        GONGON5 = ATAN2( Y, X)
      ELSE
        IF ( Y .EQ. 0.0 ) THEN
          GONGON5 = 0.0
        ELSE
          IF ( Y .LT. 0.0 ) THEN
            GONGON5 = -PI/2.
          ELSE
            GONGON5 = PI/2.
          END IF
        END IF
      END IF
      IF ( GONGON5 .LT. 0.0 ) GONGON5 = GONGON5 + 2.*PI
      RETURN
      END

C--------------------------------------------------------------------

      SUBROUTINE GONGON3( ALPHA, BETA, GAMMA, ROT, DIAG1, DIAG2, DIAG3)

C*  OLD NAME:  SUBROUTINE EULER( ALPHA, BETA, GAMMA, ROT, DIAG1, DIAG2, DIAG3)
C...Converts rotation angles to Euler matrix
C...Adapted from ALIGNXYZ.FOR from MRC
C...Alpha is rotation about Z, Beta about Y, and Gamma about X.
      DIMENSION ROT( 3, 3), A( 3, 3), B( 3, 3), G( 3, 3), TEMP( 3, 3)
C...
      DO I = 1, 3
        DO J = 1, 3
          A( I, J) = 0.
          B( I, J) = 0.
          G( I, J) = 0.
        END DO
      END DO
C...
      SA = SIN( ALPHA)
      SB = SIN( BETA)
      SG = SIN( GAMMA)
      CA = COS( ALPHA)
      CB = COS( BETA)
      CG = COS( GAMMA)
C...Alpha is rotation about Z-axis (Positive angle from X-axis to Y-axis)
      A(1,1) = CA
      A(1,2) = -SA
      A(2,1) = SA
      A(2,2) = CA
      A(3,3) = DIAG1
C...Beta is rotation about Y-axis (Positive angle from Z-axis to X-axis)
      B(1,1) = CB
      B(1,3) = SB
      B(3,1) = -SB
      B(3,3) = CB
      B(2,2) = DIAG2
C...Gamma is rotation about X-axis (Positive angle from Y-axis to Z-axis)
      G(1,1) = DIAG3
      G(2,2) = CG
      G(2,3) = -SG
      G(3,2) = SG
      G(3,3) = CG
C...
C*    CALL MULTMATMAT( A, B, TEMP)
      CALL GONGON4( A, B, TEMP)
      CALL GONGON4( TEMP, G, ROT)
      RETURN
      END

C------------------------------------------------------------------------------

      SUBROUTINE GONGON4( A, B, AB)

C*    OLD NAME:  SUBROUTINE MULTMATMAT( A, B, AB)

C...Multiply matrix A by matrix B to give matrix AB.
      DIMENSION A( 3, 3), B( 3, 3), AB( 3, 3)
      DO I = 1, 3
        DO J = 1, 3
          AB( I, J) = 0.
          DO K = 1, 3
            AB( I, J) = AB( I, J) + A( I, K) * B( K, J)
          END DO
        END DO
      END DO
      RETURN
      END

C------------------------------------------------------------------------------

      SUBROUTINE GONGON2( THETA, PHI, TAU, ROT)

C*    OLD NAME:      SUBROUTINE GONIOM( THETA, PHI, TAU, ROT)

      DIMENSION ROT( 3, 3), T( 3, 3), P( 3, 3), TA( 3, 3), TEMP( 3, 3)
      DO I = 1, 3
        DO J = 1, 3
          T( I, J) = 0.
          P( I, J) = 0.
          TA( I, J) = 0.
        END DO
      END DO
      CT = COS( THETA)
      ST = SIN( THETA)
      CP = COS( PHI)
      SP = SIN( PHI)
      CTAU = COS( TAU)
      STAU = SIN( TAU)
C...THETA (in rads) is rotation about X-axis (right-hand rule.)
      T(1,1) = 1.
      T(2,2) = CT
      T(3,3) = CT
      T(3,2) = ST
      T(2,3) = -ST
C...PHI (in rads) is rotation about Z-axis.
      P(3,3) = 1.
      P(1,1) = CP
      P(2,2) = CP
      P(2,1) = SP
      P(1,2) = -SP
C...TAU (in rads) is rotation about Z-axis.
      TA(3,3) = 1.
      TA(1,1) = CTAU
      TA(2,2) = CTAU
      TA(2,1) = STAU
      TA(1,2) = -STAU
C...
C...Note that rotation of PHI about the Z-axis is applied first,
C...followed by rotation of THETA about the Y-axis, followed by rotation
C...of TAU about the Z-axis;  However, in
C...forming the composite matrix representing the complete operation,
C...the constituent matrices are multiplied in reverse order, ie,
C...ROT = TAU * THETA * PHI, in accordance with the rules of composition of
C...functions.
      CALL GONGON4( TA, T, TEMP)
      CALL GONGON4( TEMP, P, ROT)
      RETURN
      END

 
#endif
 
