
C**************************************************************************
C
C   GOTBRANCH.FOR  -- CREATED OCT 90
C **************************************************************************
C *  AUTHOR: ArDean Leith 
C *  COPYRIGHT (C)1990 , WADSWORTH CENTER FOR LABORATORIES AND RESEARCH    *
C *    NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.              *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH  			   *
C **************************************************************************
C
C      GOTBRANCH(NCLUS,NOW,IEQUIV,NEQUIV,NEQMAX,IRTFLG)
C
C      PURPOSE:      SETS BRANCH CONNECTIVITY ARRAY  
C
C      PARAMETERS:  
C
C      CALLED BY:    CCONECT
C
C      CALLS:       
C
C23456789012345678901234567890123456789012345678901234567890123456789012
C--********************************************************************

      SUBROUTINE GOTBRANCH(NCLUS,NOW,IEQUIV,NEQUIV,NEQMAX,IRTFLG)

      COMMON /UNITS/LUN,NIN,NOUT

      INTEGER  IEQUIV(2,*)

      NOWMIN = MIN(NCLUS,NOW)
      NOWMAX = MAX(NCLUS,NOW)

      DO I = 1,NEQUIV
 
C       CHECK IF ALREADY HAVE RECORDED THIS Y IN NEQUIV
        IF (IEQUIV(2,I) .EQ. NOWMIN .AND.
     &      IEQUIV(1,I) .EQ. NOWMAX) RETURN
      END DO

c**********************************
C**      WRITE(NOUT,*) ' NOW,NCLUS: ',NOW,NCLUS
c**********************************

      NEQUIV = NEQUIV + 1
      IERR   = 0
      IF (NEQUIV .GT. NEQMAX) THEN
C        RAN OUT OF SPACE IN IEQUIV ARRAY
         IF (IERR .LE. 1) THEN
            WRITE(NOUT,*) '*** BRANCH LIMIT (NEQMAX) IS:', NEQMAX
            WRITE(NOUT,*) ' OUTPUT IS JUNK !!!!!!!!!!!!!!!'
            IERR = IERR + 1
         ENDIF             
         IRTFLG = 1
         RETURN
      ENDIF

      IEQUIV(1,NEQUIV) = NOWMAX
      IEQUIV(2,NEQUIV) = NOWMIN

      IRTFLG = 0

      RETURN
      END
