C++*******************************************************************
C
C $$ GSORT.FOR
C
C **************************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK            *
C *  COPYRIGHT (C)1981,1987, WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH 			   *
C **************************************************************************
C
C
C $$ GSORT:    SORT PROGRAM
C
C       SINGLETON SORT PROGRAM TO ORDER B,C,D,E AND  
C       F USING A AS A KEY.  AS OF THE PRESENT TIME (FEB. 1971) THIS IS
C       THE FASTEST GENERAL PURPOSE SORTING METHOD KNOWN.
C
C       CALL GSORT(A,B,C,D,E,F,N)
C
C--*******************************************************************
C
C
      SUBROUTINE GSORT ( A, B, C,D,E,F,N)
      REAL E(1),F(1)
      INTEGER A(1),B(1),C(1),D(1),X,T,TT,Y,Z
C
C     SINGLETON SORT PROGRAM TO ORDER B AND C USING A AS A KEY
C     AS OF THE PRESENT TIME (FEB. 1971) THIS IS THE FASTEST GENERAL
C     PURPOSE SORTING METHOD KNOWN.
C MODIFIED VERSION . J.FRANK, NOV. 1978
C
      INTEGER IL(16), IU(16)
CNO_SAVE
C
      M = 1
      I = 1
      J = N
    5 IF (I .GE. J) GO TO 70
C
C     ORDER THE TWO ENDS AND THE MIDDLE
C
   10 K = I
      IJ = (I + J)/2
      T = A(IJ)
      IF (A(I) .LE. T) GO TO 20
      A(IJ) = A(I)
      A(I) = T
      T = A(IJ)
      X = B(I)
      B(I) = B(IJ)
      B(IJ) = X
      Y = C(I)
      C(I) = C(IJ)
      C(IJ) = Y
      Z = D(I)
      D(I) = D(IJ)
      D(IJ) = Z
      ES = E(I)
      E(I) = E(IJ)
      E(IJ) = ES
      FS = F(I)
      F(I) = F(IJ)
      F(IJ) = FS
   20 L = J
      IF (A(J) .GE. T) GO TO 40
      IF (A(J) .LT. A(I)) GO TO 25
      A(IJ) = A(J)
      A(J) = T
      T = A(IJ)
      X = B(IJ)
      B(IJ) = B(J)
      B(J) = X
      Y = C(IJ)
      C(IJ) = C(J)
      C(J) = Y
      Z = D(IJ)
      D(IJ) = D(J)
      D(J) = Z
      ES = E(IJ)
      E(IJ) = E(J)
      E(J) = ES
      FS = F(IJ)
      F(IJ) = F(J)
      F(J) = FS
      GO TO 40
   25 A(IJ) = A(I)
      A(I) = A(J)
      A(J) = T
      T = A(IJ)
      X = B(J)
      B(J) = B(IJ)
      B(IJ) = B(I)
      B(I) = X
      Y = C(J)
      C(J) = C(IJ)
      C(IJ) = C(I)
      C(I) = Y
       Z = D(J)
      D(J ) = D(IJ)
      D(IJ) = D(I)
      D(I) = Z
      ES = E(J)
      E(J) = E(IJ)
      E(IJ) = ES
      FS = F(J)
      F(J) = F(IJ)
      F(IJ) = FS
      GO TO 40
C
C     SPLIT THE SEQUENCE BETWEEN I AND J INTO TWO SEQUENCES.  THAT
C     SEQUENCE BETWEEN I AND L WILL CONTAIN ONLY ELEMENTS LESS THAN OR
C     EQUAL TO T, WHILE THAT BETWEEN K AND J WILL CONTAIN ONLY ELEMENTS
C     GREATER THAN T.
C
   30 A(L) = A(K)
      A(K) = TT
      X = B(L)
      B(L) = B(K)
      B(K) = X
      Y = C(L)
      C(L) = C(K)
      C(K) = Y
      Z = D(L)
      D(L) = D(K)
      D(K) = Z
      ES = E(L)
      E(L) = E(K)
      E(K) = ES
      FS = F(L)
      F(L) = F(K)
      F(K) = FS
   40 L = L - 1
      IF (A(L) .GT. T) GO TO 40
      TT = A(L)
   50 K = K + 1
      IF (A(K) .LT. T) GO TO 50
      IF (K .LE. L) GO TO 30
C
C     SAVE THE END POINTS OF THE LONGER SEQUENCE IN IL AND IU, AND SORT
C     THE SHORTER SEQUENCE.
C
      IF (L - I .LE. J - K) GO TO 60
      IL(M) = I
      IU(M) = L
      I = K
      M = M + 1
      GO TO 80
   60 IL(M) = K
      IU(M) = J
      J = L
      M = M + 1
      GO TO 80
C
C     RETRIEVE END POINTS PREVIOUSLY SAVED AND SORT BETWEEN THEM.
C
   70 M = M - 1
      IF (M .EQ. 0) RETURN
      I = IL(M)
      J = IU(M)
C
C     IF THE SEQUENCE IS LONGER THAN 11 OR IS THE FIRST SEQUENCE, SORT
C     BY SPLITTING RECURSIVELY.
C
   80 IF (J - I .GE. 11) GO TO 10
      IF (I .EQ. 1) GO TO 5
C
C     IF THE SEQUENCE IS 11 OR LESS LONG, SORT IT BY A SHELLSORT.
C
      I = I - 1
   90 I = I + 1
      IF (I .EQ. J) GO TO 70
      T = A(I + 1)
      IF (A(I) .LE. T) GO TO 90
      X = B(I+1)
      Y = C(I+1)
      Z = D(I+1)
      ES = E(I+1)
      FS = F(I+1)
      K = I
  100 A(K+1) = A(K)
      B(K+1) = B(K)
      C(K+1) = C(K)
      D(K+1) = D(K)
      E(K+1) = E(K)
      F(K+1) = F(K)
      K = K - 1
      IF (T .LT. A(K)) GO TO 100
      A(K+1) = T
      B(K+1) = X
      C(K+1) = Y
      D(K+1) = Z
      E(K+1) = ES
      F(K+1) = FS
      GO TO 90
C
      END
