
C++************************************************************************
C
C  HCLS.FOR
C
C **************************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK            *
C *  COPYRIGHT (C)1981,1987, WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *  THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR       *
C *  LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR    *
C *  USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF     *
C *  THE CENTER FOR LABORATORIES AND RESEARCH   			   *
C **************************************************************************
C
C--************************************************************************

         SUBROUTINE HCLS(MAXMEM)
          INCLUDE 'CMBLOCK.INC' 
         DIMENSION Q(1)
         POINTER   (IPQ,Q) 
         LOGICAL   RUNTIME
         COMMON  DUMMY(8),KAF(1)
         EQUIVALENCE  (INUM,KAF)
C        IMP - OUTPUT USED IN CHAVA
         COMMON  /ENSOR/  LMP,IMP
C
         CHARACTER*81  CLUSTI,FILPAT
         CHARACTER*140 CLUST
         CHARACTER*1  NULL
         INTEGER ICODE,ITYPE,ONE_1
CNO_SAVE
         NULL=CHAR(0)
         IMP=NDAT

         ONE_1 = 1
         CALL  RDPRMI(ITYPE,I, NLOOP,ILOOP,
     $        'ENTER DATA FILENAME TYPE (SEQ(1), IMC(2) or PIX(3))')
         CALL  RDPRMI(ICODE,I,NLOOP,ILOOP,
     $        'ENTER COORDINATES FILE CODE')
         IF (ITYPE .EQ. 1) THEN
           FILPAT(1:3) = 'SEQ'
         ELSE IF(ITYPE .EQ. 2) THEN
           FILPAT(1:3) = 'IMC'
         ELSE
           FILPAT(1:3) = 'PIX'
         END IF
         IF(ICODE .GE. 1000) THEN
           FILPAT(4:11) = '****'//NULL//NULL//NULL//NULL
           NLET = 7
         ELSE
           FILPAT(4:11) = '***'//NULL//NULL//NULL//NULL//NULL
           NLET = 6
         END IF

         IRTFLG = 0
         CALL FILGET(FILPAT, CLUSTI, NLET, ICODE, IRTFLG)
         IF (IRTFLG .NE. 0) RETURN
         CALL  FILCAN(CLUST,NF,NULL,NULL,CLUSTI,DATEXC,IER)
         IF (IER .NE. 0) RETURN

C
C  ONLY NEW VERSION OF CLUSTER FILE ALLOWED

         OPEN(FILE=CLUST,UNIT=111,STATUS='OLD',FORM='UNFORMATTED')
         READ(111)  NKLA,NFAC

         WRITE(NOUT,33)  NKLA,NFAC
33       FORMAT('   Number of objects and number of factors',
     &   ' in image coordinates file:',/,2I10)
C
         MAXFAC=NFAC
         MAXFA=NFAC
	 MINFAC=1
         CALL  RDPRAI(INUM,NFAC,MAXFA,MINFAC,MAXFAC,
     &	          'FACTOR NUMBERS',NULL,IER)
     
C         DIMENSION  W(MAXFA),COO(NFAC),COB(NFAC),INUM(MAXFA)

         K_INUM=1
	  
         K_W=1 
         K_COO=IPALIGN64(K_W+MAXFA)
         K_COB=IPALIGN64(K_COO+NFAC)
	 
C        CALCULATE NUMBER OF FACTORS
         MDIM=NKLA*(NKLA-1)/2
         JFIN=2*NKLA-1

         MEMD=IPALIGN64(K_COB+NFAC)
         MEMPK=IPALIGN64(MEMD+MDIM)
         MEMVAL=IPALIGN64(MEMPK+JFIN)
         MEMIDK=IPALIGN64(MEMVAL+JFIN)
         MEMLA=IPALIGN64(MEMIDK+NKLA)
         MEMLB=IPALIGN64(MEMLA+NKLA)
         MEMNT=IPALIGN64(MEMLB+NKLA)
         MEMNO=IPALIGN64(MEMNT+JFIN)
         MEMTOT=IPALIGN64(MEMNO+JFIN)
         MEMNUM=MEMD
         MEMIV=IPALIGN64(MEMNUM+NKLA)
         MEMIW=IPALIGN64(MEMIV+NKLA)
         MEMV=IPALIGN64(MEMIW+NKLA)
         MEMW=IPALIGN64(MEMV+NKLA)
         MEMTOT=MAX0(MEMTOT,IPALIGN64(MEMW+NKLA))
	 
         CALL CHKMEM(MEMTOT, KAF, MAXMEM-8,RUNTIME,IPQ,IRTFLG)
	 IF (IRTFLG.EQ.0) THEN
            IF (RUNTIME)  THEN
               WRITE (NOUT,2500)  MEMTOT
2500           FORMAT (/ ' DYNAMICAL MEMORY ALLOCATION:  YOU HAVE',
     #                   ' RESERVED ',I9 / )
            ELSE 
		K_INUM=1
		K_W=IPALIGN64(K_INUM+MAXFA)
		K_COO=IPALIGN64(K_W+MAXFA)
		K_COB=IPALIGN64(K_COO+NFAC)
	 
C              CALCULATE NUMBER OF FACTORS
		MDIM=NKLA*(NKLA-1)/2
		JFIN=2*NKLA-1

		MEMD=IPALIGN64(K_COB+NFAC)
		MEMPK=IPALIGN64(MEMD+MDIM)
		MEMVAL=IPALIGN64(MEMPK+JFIN)
		MEMIDK=IPALIGN64(MEMVAL+JFIN)
		MEMLA=IPALIGN64(MEMIDK+NKLA)
		MEMLB=IPALIGN64(MEMLA+NKLA)
		MEMNT=IPALIGN64(MEMLB+NKLA)
		MEMNO=IPALIGN64(MEMNT+JFIN)
		MEMTOT=IPALIGN64(MEMNO+JFIN)
		MEMNUM=MEMD
		MEMIV=IPALIGN64(MEMNUM+NKLA)
		MEMIW=IPALIGN64(MEMIV+NKLA)
		MEMV=IPALIGN64(MEMIW+NKLA)
		MEMW=IPALIGN64(MEMV+NKLA)
		MEMTOT=MAX0(MEMTOT,IPALIGN64(MEMW+NKLA))
	     
	       IF (MEMTOT.LT.(MAXMEM-8))  THEN
                  WRITE (NOUT,2501)  MAXMEM , MEMTOT
2501              FORMAT (/ ' MEMORY RESERVATION:  YOU HAVE',
     #              ' RESERVED ',I9,',  YOU NEED  ',I9 / )  
     
                  IPQ = %LOC(KAF)
	       ELSE
                 WRITE (NOUT,2520)   MEMTOT
2520             FORMAT (/ ' IMPOSSIBLE. SHOULD NOT BE HERE',
     #           ' HCLS.F MEMTOT= ',I9 / )
	       END IF
            END IF
	    
            DO  I=0,MAXFA-1
               Q(K_W+I)=1.0
            END DO

            DO    I=0,MAXFA-1
               CALL  RDPRM(W1,NLOOP,ILOOP,'FACTOR WEIGHT')
               IF(W1.EQ.0.0)  GOTO  201
               Q(K_W+I)=W1
	    ENDDO

201         WRITE(NOUT,*) ' FACTOR WEIGHTS USED:'
            WRITE(NOUT,23)  (Q(K_W+I),I=0,MAXFA-1)
23          FORMAT(10(1X,G10.3))
            CALL  HCLP(NKLA,MDIM,JFIN,
     &         Q(K_W),INUM,Q(K_COO),Q(K_COB),MAXFA,NFAC,
     &         Q(MEMD),Q(MEMPK),Q(MEMVAL),Q(MEMIDK),
     &         Q(MEMLA),Q(MEMLB),Q(MEMNT),
     &         Q(MEMNO),Q(MEMNUM),Q(MEMIV),Q(MEMIW),Q(MEMV),
     &         Q(MEMW))
 
            IF (RUNTIME) CALL ALLOCIT(0,RUNTIME,IPQ,'HCLS',IRTFLG) 
	    
            WRITE (NDAT,2600)
2600        FORMAT (//' ',80('-')//' ',28X,
     #           'END OF HIERARCHICAL CLUSTERING',/, 80('-'))
         ELSE
            WRITE(NOUT,*)
     &      ' *** BUFFER TOO SMALL - PROGRAM CANNOT BE RUN!'
            CALL ERRT(100,'HCLS',NE)
         ENDIF
         END
