
C----------------------------------------------------------------------
C   HISMAP.FOR
C   PREPARES PLOT METAFILE 
C
C   ADAPTED FROM HPLAN.FOR  ON NOV 8 1986 BY al
C   BORDERS CHANGED TO SOLID LINES FEB 88 al
C----------------------------------------------------------------------         
C   GRAPH OF ICARD POINTS WITH NLIGN-ROWS, AND NPAGE-PAGES                      
C   (IF NLIGN=0, AUTOMATIC DETERMINATION OF NLIGN. NPAGE = 1 TO 8)              
C   WARNING: NPAGE MAY NOT BE MORE THAN 3 WITH MODE 1.                          
C   COORDINATES X(*) FOR HORIZONTAL AXIS JX, Y(*) FOR VERTICAL AXIS JY          
C   LABELS ARE IN ID(*), FORMAT A1 IF MOD=1, FORMAT A4 IF MOD=4               
C   POINTS AT MORE THAN PEX STANDARD DEVIATIONS ARE POSITIONED ON THE           
C   EDGES OF THE GRAPH (SUBROUTINE EPUR4).                                      
C   IF NOR=1 THE ORIGIN IS ADDED TO THE POINTS TO BE DISPLAYED.                 
C   WARNING:  X(*), Y(*), ID(ICARD+1) ARE DESTROYED UPON RETURN.                
C   GRAPH IS ABORTED IF MORE THAN 264 POINTS ARE ON THE EDGES,                 
C   THE FIRST NHID HIDDEN POINTS ARE PRINTED WITH THEIR COORDINATES.         
C
C   CALLS:      EPUR4       BORNS   
C               CNFILE      CSPUSH   CSPSTX     CSTRAP    CSSCALT
C
C   CALLED BY:  SGRAF1,  nlmrealstrt
C
C   NOTE 12/7/93			<ML
C		IT SEEMS THAT HISMAP IS CALLED ALWAYS WITH 
C		NOR = 1 AND NID = 1.
C		SO CHANGE THE SOFTWARE TO REFLECT THAT.
C
C        1         2         3         4         5         6         7
C23456789012345678901234567890123456789012345678901234567890123456789012
C****************************************************************************

       SUBROUTINE HISMAP(IDIM,ICARD,JX,JY,X,Y,ID,MOD,NLIGN,NPAGE,PEX,
     &                   IMP,NBAND,EXTEN,FILEIT)     

       INCLUDE        'CONSTG.INC'
CNO_SAVE

       COMMON /UNITS/LUNDUM,NIN,NOUT

       CHARACTER *(*) EXTEN

       PARAMETER      (NSIZE=2000)
       CHARACTER * 81 CSFILE,LINE
       CHARACTER * 4  KLAC
       COMMON /COMMUN/DATA(3,NSIZE),CSFILE,LINE,KLAC(371)

       PARAMETER      (NHID=200)
       COMMON /IOBUF/ LD1(NHID),LD2(NHID), EX(48), KLIC(371) 

       CHARACTER * 4  LA(8),NA(8)
       CHARACTER * 1  MA(8)
       INTEGER        FPAGE,FL,FC
       REAL           X(IDIM),Y(IDIM),KKO,LLO,IREM,EY
       CHARACTER * 4  ID(IDIM),LDA,LDA2,LDB,LDB2
       CHARACTER * 7  DISP
       CHARACTER * 4  CK4,IKLAC
       CHARACTER * 1  NULL,CK1
       EQUIVALENCE    (CK4,IKLAC)
       CHARACTER *4   CDATA
       EQUIVALENCE    (CDATA,FDATA)
       LOGICAL        FILEIT

       DATA MA/'-',' ','|','|','.','+',':','^'/
       DATA NA/'----','    ','|   ','   |',' .  ',' +  ',':   ',' ^  '/ 
       DATA LDA2/'    '/,LDB2/'    '/

       NULL = CHAR(0)

       IF (FILEIT) THEN
C        PLOT META-FILE WANTED

c        DO NOT PRINT FILE SPECIFICS
         ICSPR  = -2

C        DO NOT ASK FOR FILE TITLE
         ITFLG  =  0

C        DON'T CHECK FOR COUNTER-CLOCKWISE CONTOURS
C        REVERS = .FALSE. (NOT DEFINED ANYWHERE)
         LABAH  = .TRUE.
         LUN    = 10

C        SET MAXIMUM NO. OF CONTOURS TO 4000 (I HOPE THIS IS ENOUGH)
         MAXCNT = 4000

C        SET RECORD LENGTH 
         IRECLN = 2048
         DISP   = 'UNKNOWN'

C        SET FILE TYPE TO -6 TO DENOTE PRESENCE OF NEW TEXT CONTOURS
         IFRMCS = -6

C        SET LINE AND TEXT PARAMETERS
         IPEN   = 0
         INTEN  = 9
         ITANGL = 0
         ITSIZE = 24
         IORN   = 0
         IFON   = 0
         ZCOO   = 0.0
       ENDIF

       IF (NPAGE .EQ. 0) NPAGE = 1                                
       REWIND NBAND
       N1 = ICARD + 1                   

C      CHECK TO SEE THAT NUMBER OF POINTS IS NOT EXCESSIVE
       IF (N1 .GT. IDIM) WRITE (IMP,1130)                         
 1130  FORMAT (/' ','(DIMENSION ERROR IN SUBROUTINE HISMAP )'/)          

       WRITE (IMP,1110)  ICARD, JX, JY, JX, JY
 1110  FORMAT (///' ',25X,'MAP OF'                 ,I6, '  POINTS' ,
     &   ' ON AXES'       ,I2,'  AND'  , I2,/' ',130('-')//,' ',30X,
     &   'AXIS',I2,'  /HORIZONTAL' ,10X, 'AXIS',I2,'  /VERTICAL' //)

C      FIND POINTS ON BOUNDARY OF MAP
       CALL EPUR4(IDIM,ICARD, X,Y,ID, MOD, PEX, KP, KLIC,KODE,IMP)
       IF (KODE .EQ. 1) THEN
          CALL ERRT(101,
     &     '*** MAP ABORTED, MORE THAN 264 POINTS ON FRAME',IDUM)
         RETURN     
       ENDIF

C      SET SPECIAL SYMBOLS ACCORDING TO MODE
       DO K = 1,8                                                          
         IF (MOD .EQ. 1) THEN
           LA(K) = MA(K)
         ELSE
           LA(K) = NA(K)                           
         ENDIF
       ENDDO

       ID(N1) = LA(6)
       X(N1)  = 0.0
       Y(N1)  = 0.0

   20  CALL BORNS (N1,X,XMINT,XMAXT)
       CALL BORNS (N1,Y,YMINT,YMAXT)              
                                 
C      FIND NUMBER OF POSITIONS ON A LINE OF A PAGE (K1)
       IF (MOD .EQ. 1) THEN
         K1 = 123    
       ELSEIF (MOD .EQ. 4) THEN
         K1 =  30   
       END IF

C      FIND TOTAL NUMBER OF POSITIONS ON A LINE                              
       KFIN  = K1 * NPAGE         
       NL    = NLIGN
       FC    = KFIN
       FPAGE = NPAGE

C      FIND DEFAULT NUMBER OF LINES
       IF (NL .EQ. 0) THEN
         NL    = ((YMAXT - YMINT) / (XMAXT - XMINT)) * FPAGE * 74.0
       END IF       

   30  IF (NL .LE. 12) NL = 12 
       FL    = NL
       S     = (XMAXT - XMINT) / FC    
       T     = (YMAXT - YMINT) / FL         
       NINT  = 5 * NPAGE + 1         
       ESPX  = FC / (5.0 * FPAGE)

       DO  J = 1,NINT      
C        FIND X AXIS LABELS

         EX(J) = XMINT + S * ESPX * FLOAT(J-1) 
       ENDDO

       KKO   = 0.50001 - (XMINT / S)
       LLO   = 0.50001 + ABS(YMAXT / T)

       DO   I = 1,N1 
C        SCALE EACH POINT TO FIT PAGE

         K     = (X(I) - XMINT) / S + 0.500001                   
         L     = (YMAXT - Y(I)) / T + 0.500001

C        PUT SCALED POINT IN X,Y
         IF (K .EQ. 0) K = 1 
         IF (L .EQ. 0) L = 1                                    
         X(I)  = K + 0.0001                             
         Y(I)  = L + 0.0001 
       ENDDO                  

       J     = 0
       DO   LL = 1,NL
C        PREPARE EACH LINE,   EY IS Y AXIS LABEL

         EY    = YMAXT - T * FLOAT(LL-1)           

         DO  KK = 1,KFIN
C          FILL OUTPUT LINE WITH BLANKS EXCEPT FOR FIRST, LAST, ETC. LINE
           KLIC(KK) = 0             
           KLAC(KK) = LA(2)                                   
           IF (LL .EQ. 1 .OR. LL .EQ. NL)    KLAC(KK) = LA(1)      
           IF (KK .EQ. KKO .OR. LL .EQ. LLO) KLAC(KK) = LA(5)
         ENDDO 

         KLAC(1)        = LA(3)        
         KLAC(KFIN)     = LA(4)      
         KLAC(KFIN + 1) = LA(2) 
         KLIC(KFIN + 1) = 0  
         KLIC(KFIN+2)   = 0 
  
         DO  I = 1,N1
C          PUT EACH POINT ID ON THE PAGE MAP, KLIC(K) HOLDS POINT ID

           L     = Y(I)  
           IF (L .EQ. LL) THEN
             K     = X(I) 
             IF (KLIC(K) .EQ. 0) THEN
                KLIC(K) = I  
             ELSE
                IK    = KLIC(K)   
                J     = J + 1

C	        for pixel map, obviously, nhid=200 is not enough.  <ML
                IF ((MOD .NE. 1 .OR. J .GT. 100) .AND. J .LE. NHID) THEN
                  LD1(J) = IK 
                  LD2(J) = I
                ENDIF
             ENDIF
           ENDIF
         ENDDO

         DO KK = 1,KFIN
C          PUT CORRECT SYMBOLS ON THE OUTPUT LINE

           IK = KLIC(KK)                                      
           IF (IK .NE. 0) THEN
              IF (MOD .EQ. 1) THEN
                 DO IT = 1,4
                    IF (ID(IK)(IT:IT) .NE. ' ' .AND. 
     &                  ID(IK)(IT:IT) .NE. CHAR(0)) THEN
                       KLAC(KK) = ID(IK)(IT:IT) // '   ' 
                    ENDIF 
                 ENDDO 
              ELSE
                 KLAC(KK) = ID(IK)
              ENDIF
           ENDIF
         ENDDO

         KFI1 = KFIN + 1        

C        WRITE OUTPUT LINE TO TEMP FILE       
         WRITE (NBAND)  EY, (KLAC(K), K=1,KFI1)                   
       ENDDO

       KB    = 0 
       KBB   = 1 
       IPUSH = 0

C      PRINT EACH PAGE
       DO   KPT = 1,NPAGE  
         REWIND NBAND          
         IF (FILEIT) THEN
C          GET FILE NAME FOR THIS PAGE
           CALL CNFILE(CSFILE,NLETC,
     &       'ENTER NAME FOR THIS MAP PAGE',DISP,EXTEN,LUN,IRTFLG)
           IF (IRTFLG .EQ. -1) RETURN

C          PUT FILENAME AT BOTTEM
           YPOS  = - 12.0
           XPOS  = 0.0
           CALL CSPSTX(CSFILE,NLETC,LUN,NF,0,ITEXT)

C          PUT DUMMY CHAR AT LOWER LEFT TO AVOID CLIPPING Y AXIS LABELS
           XPOS  = -14.0
           YPOS  = -14.0
           CK1   = ' '
           NCHAR = 1
           CALL CSPSTX(CK1,NCHAR,LUN,NF,1,ITEXT)
         ENDIF

         KA    = KB + 1   
         KB    = KA + K1 - 1                              
         IF( KB .EQ. KFIN .AND. KPT .GT. 1)  KB = KFIN + 1 
         KAA   = KBB + 1 
         KBB   = KAA + 4 

         IF (FILEIT) THEN
C          PUT IN FRAME AND X=0 Y=0 AXES

           INTEN = 9
           IF (MOD .EQ. 1) THEN
C            SINGLE CHAR. SYMBOLS
             IT = 1

C            X3 IS X COORD OF RIGHT SIDE OF FRAME
             X3 = KB - KA + 1

           ELSE
C            4 CHAR. SYMBOLS
             IT = 4
             X3 = (KB - KA + 1) * 4 + 3
           ENDIF

           NDATA     = 5
           DATA(1,1) = 2.0
           DATA(2,1) = 1.0
           DATA(1,2) = DATA(1,1)
           DATA(2,2) = NL
           DATA(1,3) = X3 + 1.0

           DATA(2,3) = NL
           DATA(1,4) = X3 + 1.0
           DATA(2,4) = 1.0
           DATA(1,5) = 2.0
           DATA(2,5) = 1.0

           LINTP     = 0
           MARK      = 0
           IPEN      = 0
           CALL CSPUSH(LUN,DATA,NDATA,NF,0,ICNTR)        
  
C          PUT IN Y=0 AXIS
           NDATA     = 2
           DATA(2,1) = NL - LLO + 1
           DATA(1,2) = X3
           DATA(2,2) = NL - LLO + 1
           CALL CSPUSH(LUN,DATA,NDATA,NF,0,ICNTR)        

C          PUT IN X=0 AXIS
           DATA(1,1) = (KKO - KA) * IT + IT + 1.0
           DATA(2,1) = 1.0
C          DATA(1,2) = DATA(1,1)
           DATA(1,2) = (KKO - KA) * IT + IT + 1.0
           DATA(2,2) = NL
           CALL CSPUSH(LUN,DATA,NDATA,NF,1,ICNTR)        
         ENDIF

C        RIGHT JUSTIFY Y AXIS LABELS
         LINTP = 1
         JUST  = 2
         NDATA = 1

         DO   LL = 1,NL 
C          PRINT EACH LINE ON THIS PAGE,  GET THE LINE FROM TEMPORARY FILE
           READ (NBAND)  EY, (KLAC(K), K=1,KFI1)          

           IREM = LL - 5 * (LL / 5)

           IF (FILEIT .AND. IREM .EQ. 0) THEN

C            PUT Y AXIS LABEL ON MAP IN METAFILE EVERY FIVE LINES
             YPOS = NL - LL + 1
             XPOS = -3.0
             MARK = 0
             WRITE(LINE(1:6),8801) EY
 8801        FORMAT(F6.3)
             CALL CSPSTX(LINE(1:6),6,LUN,NF,1,ITEXT)

C            PUT IN TICK MARK ON Y AXIS
             DATA(1,1) = -.5
             DATA(2,1) =  YPOS 
             DATA(1,2) =  0.0  
             DATA(2,2) =  YPOS
             CALL CSPUSH(LUN,DATA,2,NF,1,ICNTR)
           ENDIF

C          SET Y VALUE OF DATA POSITION
           DATA(2,1) = NL - LL + 1

           IF (MOD .EQ. 1) THEN
C            SYMBOL IS ONLY ONE CHAR. LONG

             IF (KPT .EQ. 1) THEN
                WRITE(IMP,1010) EY, (KLAC(K),K=KA,KB)
 1010           FORMAT (' ',F8.2,1X,123A1)                  
             ELSE
                WRITE(IMP,1030) (KLAC(K),K=KA,KB)    
 1030           FORMAT (' ',130A1)
             ENDIF

             IF (FILEIT) THEN
               DO K = KA,KB
                 IKLAC = KLAC(K)
                 IF (IKLAC .EQ. LA(3)) IKLAC = LA(7)

                 CK1 = IKLAC(1:1)

                 IF (CK1 .NE. ' ' .AND. CK1 .NE. '.' .AND. 
     &               CK1 .NE. '-' .AND. CK1 .NE. ':' .AND.
     &               CK1 .NE. '+') THEN

C                  HAVE A TEXT CONTOUR SYMBOL TO PLACE ON MAP
                   DATA(1,1)  = K - KA + 1
                   DATA(1,2)  = 1
                   CDATA      = CK1 // NULL // NULL // NULL
                   DATA(2,2)  = FDATA
                   MARK       = -2

                   CALL CSPUSH(LUN,DATA,2,NF,1,ICNTR)
                 ENDIF
               ENDDO
             ENDIF

           ELSE
C            SYMBOL IS 4 CHAR. LONG
             IF (KPT .EQ. 1) THEN
                WRITE (IMP,1020) EY,(KLAC(K),K=KA,KB) 
 1020           FORMAT (' ',F8.2,1X,31A4)             
             ELSE
                WRITE (IMP,1040) (KLAC(K),K=KA,KB)    
 1040           FORMAT (' ',32A4)
             ENDIF

             IF (FILEIT) THEN
               DO  K = KA,KB
                 IKLAC = KLAC(K)
                 IF (IKLAC .EQ. LA(3) .OR. IKLAC .EQ. LA(4)) IKLAC=LA(7)  
C                CK4 IS EQUIVALENCED TO IKLAC
                 IF     (CK4(1:4) .NE. '    ' .AND. CK4(1:4) .NE. '  . '
     &             .AND. CK4(1:4) .NE. '----' .AND. CK4(1:4) .NE. ':   '
     &             .AND. CK4(1:4) .NE. '   :' .AND. CK4(1:4) .NE. ' .  '
     &             .AND. CK4(1:4) .NE. ' +  ') THEN

C                  HAVE A TEXT CONTOUR ID TO PLACE ON MAP
                   DATA(1,1)  = K - KA + 1
                   DATA(1,2)  = 4
                   CDATA(1:4) = CK4
                   DATA(2,2)  = FDATA
                   MARK       = -2

                   CALL CSPUSH(LUN,DATA,2,NF,1,ICNTR)
                 ENDIF
               ENDDO
             ENDIF
           ENDIF
  	 ENDDO

C        WRITE X AXIS LABELS
         JUST      = 1
         MARK      = 0
         YPOS      = -5.0
         DATA(2,1) = -1.0
         DATA(2,2) = -2.0

         IF (KPT .EQ. 1) THEN
C          PAGE ONE

           WRITE(IMP,1050) (EX(K),K=1,6)     
 1050      FORMAT (' ',2X,5(F10.4,14X),F10.4)         

           IF (FILEIT) THEN
C            PUT IN CONTOUR META-FILE
             DO  I = 1,6
               XPOS = (I - 1) * ((K1 * IT) / 5.0)
               WRITE(LINE,8805) EX(I)
 8805          FORMAT(F8.3)
               CALL CSPSTX(LINE,8,LUN,NF,1,ITEXT)

C              PUT IN TICK MARK ON X AXIS
               DATA(1,1) =  XPOS + 1
               DATA(1,2) =  DATA(1,1)
               CALL CSPUSH(LUN,DATA,2,NF,1,ICNTR)
             ENDDO
           ENDIF

         ELSE IF (KPT .GT. 1) THEN
           WRITE (IMP,1060) (EX(K),K= KAA,KBB)
 1060      FORMAT (' ',18X,4(F10.4,14X),F10.4) 
           IF (FILEIT) THEN
             DO  I = KAA,KBB
               XPOS = (I - KAA + 1) * ((K1 * IT) / 4.0)
               WRITE(LINE,8805) EX(I)
               CALL CSPSTX(LINE,8,LUN,NF,1,ITEXT)

C              PUT IN TICK MARK ON AXIS
               DATA(1,1) = XPOS
               DATA(1,2) = XPOS
               CALL CSPUSH(LUN,DATA,2,NF,1,ICNTR)
             ENDDO
           ENDIF
         ENDIF

         IF (KPT .LT. NPAGE) THEN
C           NEW PAGE
            WRITE (IMP,*) '1'
         ENDIF

         IF (FILEIT) THEN
C          SCALE THE META-FILE, USING ONE PASS (ISERCH = 0)

           WRITE(NOUT,*) 'SCALING CONTOUR META-FILE NOW'
           ISERCH = 0
           CALL CSSCALT(LUN,ISERCH)

C          CLOSE THE META-FILE 
           CALL CSTRAP(LUN)
           CLOSE(LUN)
         ENDIF
       ENDDO

C      CHECK IF THERE ARE STACKED UP POINTS
       IF (J .EQ. 0 .OR. MOD .EQ. 1) GO TO  150                               

C      GIVE DATA ON HIDDEN (STACKED) POINTS
       WRITE (IMP,1070) NHID
 1070  FORMAT(//,' ',50X,'PILED POINTS     ( MAXIMUM OF ',I3,' )/',/,    
     &       ' ',2(' POINT',5X,'*',4X,'ABSCISSA',9X,'*',6X,'ORDINATE',
     &     7X,'*',10X)/,
     &     '   VISABLE',2X,'*',4X,'APPROXIM.',8X,'*',6X,'APPROXIM.',6X,
     &     '*',11X,'HIDDEN',4X,'*',4X,'APPROXIM.',8X,'*',6X,
     &     'APPROXIM.',6X,'*')

C      DRAW LINE ACROSS PAGE
       WRITE (IMP,1080)
 1080  FORMAT (' ',2(28(' *'),10X) )

       LTOT = MIN0(J,NHID)     
       DO  L = 1, LTOT
         IK    = LD1(L)      
         I     = LD2(L)      
         LDA   = ID(IK)    
         LDB   = ID(I)
         XD1   = X(IK) * S + XMINT                     
         YD1   = YMAXT - Y(IK) * T          
         XD2   = X(I) * S + XMINT           
         YD2   = YMAXT - Y(I) * T           
         WRITE(IMP,1090) LDA,LDA2,XD1,YD1,LDB,LDB2,XD2,YD2   
 1090    FORMAT(' ',2(' *' ,2A4,' *',2(F13.3,8X,'*'),10X)  ) 
       ENDDO          

C      DRAW LINE ACROSS PAGE
       WRITE(IMP,1080)
 150   CONTINUE                                            

       IF (J .NE. 0) WRITE(IMP,1100) J        
 1100  FORMAT(/ ' ',' NUMBER OF STACKED POINTS   ='     ,I5, /)

       RETURN                                                                  
       END                                                                     
