C++************************************************************************
C
C $$ HISTC.FOR
C
C **************************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK            *
C *  COPYRIGHT (C)1981,1987, WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *  THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR       *
C *  LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR    *
C *  USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF     *
C *  THE CENTER FOR LABORATORIES AND RESEARCH   			   *
C **************************************************************************
C
C
C
C--************************************************************************
C
C $$ HISTC.FOR
C
         SUBROUTINE  HISTC(XR,XI,H1,H2,IFP,N,N1,LENH,ITRMAX,NOUT)
         DIMENSION  XR(N),XI(N1),H1(3*LENH),H2(3*LENH)
         LOGICAL*1 IFP(N1)
         COMMON  /PARTR/  RXR,XRMI
         DIMENSION  AK(2),P(3,2),Y(3)
         DIMENSION PR(2),PRR(2),PBAR(2)
         EXTERNAL  FH
CNO_SAVE
         XRMI=XR(1)
         XRMA=XRMI
         AVR=XRMI
         SR=XRMI**2
         DO    I=2,N
         AVR=AVR+XR(I)
         SR=SR+XR(I)**2
         XRMI=AMIN1(XRMI,XR(I))
         XRMA=AMAX1(XRMA,XR(I))
	 ENDDO
C     ximi=amin1(ximi,xi(i))
C1    xima=amax1(xima,xi(i))
         NT1=0
         XIMI=1.E23
         XIMA=-XIMI
         AVI=0.0
         SI=0.0
         DO    I=1,N1
         IF(IFP(I))  THEN
         NT1=NT1+1
         AVI=AVI+XI(I)
         SI=SI+XI(I)**2
         ENDIF
	 ENDDO
         RXR=XRMA-XRMI
C     rxi=xima-ximi
         AVR=AVR/N
         AVI=AVI/NT1
         SR=SQRT((SR-N*AVR*AVR)/(N-1))
         SI=SQRT((SI-NT1*AVI*AVI)/(NT1-1))
         DO    I=1,3*LENH
          H1(I)=0
	 ENDDO
         DO    I=1,N
         L=INT((XR(I)-XRMI)/RXR*(LENH-1)+LENH+1)
         H1(L)=H1(L)+1
	 ENDDO
         DO    I=1,3*LENH
          H1(I)=H1(I)*FLOAT(NT1)/FLOAT(N)
	 ENDDO
C
         A=SR/SI
         P(1,1)=0.9*A
         P(2,1)=A
         P(3,1)=1.1*A
         B=AVR-A*AVI
         P(1,2)=-B
         P(2,2)=B
         P(3,2)=3*B
C
         DO    I=1,3
         AK(1)=P(I,1)
         AK(2)=P(I,2)
         Y(I)=FH(AK)
	 ENDDO
         WRITE(NOUT,205)  A,B,Y(2)
205      FORMAT(' The transformation is  A*x + B',/,
     &   ' Initial parameters   A =',1pe12.5,'   B =',1pe12.5,/,
     &   ' Initial chi-square     =',1pe12.5)
C
         N2=2
         EPS=0.0001
         CALL  AMOEBA(P,Y,N2,EPS,FH,ITER,ITRMAX,PR,PRR,PBAR)
         WRITE(NOUT,206)  ITER,P(2,1),P(2,2),Y(2)
206      FORMAT(' Minimum was found in ',i3,' iterations.',/,
     &   ' Parameters found     A =',1pe12.5,'   B =',1pe12.5,/,
     &   ' Final   chi-square     =',1pe12.5)
C     do  6  i=1,4
C6    print  203,(p(i,j),j=1,3)
C203  format(3(3x,e12.5))
C
         DO    I=1,N1
           XI(I)=XI(I)*P(2,1)+P(2,2)
	 ENDDO
         END
