C++************************************************************************
C
C $$ HISTE.FOR
C
C **************************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK            *
C *  COPYRIGHT (C)1981,1987, WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *  THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR       *
C *  LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR    *
C *  USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF     *
C *  THE CENTER FOR LABORATORIES AND RESEARCH   			   *
C **************************************************************************
C
C
C
C--************************************************************************
C
C $$ HISTE.FOR
C
         SUBROUTINE HISTE(MAXMEM)
         INCLUDE 'CMBLOCK.INC'
         COMMON Q(1)
         CHARACTER *81 FILNAM
         CHARACTER *1  NULL
         COMMON /POINTERS/  NSR1,LENH,K1,K2,K4,K5,K6,K7
C
         DATA  LUN1,LUN2,LUN3,LUN4/8,9,10,11/
CNO_SAVE
         NULL=CHAR(0)
C
         CALL FILERD(FILNAM,NLETI,NULL,'Reference image',IRTFLG)
         IF (IRTFLG .EQ. -1) GOTO 5
         CALL OPENF(FILNAM,LUN1,NSAM,NROW,'O',NF,NSLICE)
         GOTO (130,110),NF
110      IF(IFORM.LT.1) GOTO 145
         CALL FILERD(FILNAM,NLETI,NULL,'Image to correct',IRTFLG)
         IF (IRTFLG .EQ. -1) GOTO 5
         CALL OPENF(FILNAM,LUN2,NSAM1,NROW1,'O',NF,NSLICE1)
         GOTO (130,111),NF
111      IF(IFORM.LT.1) GOTO 145
         CALL FILERD(FILNAM,NLETI,NULL,
     &   'Mask for the image to correct',IRTFLG)
         IF (IRTFLG .EQ. -1) GOTO 5
         CALL OPENF(FILNAM,LUN4,NSAM2,NROW2,'O',NF,NSLICE2)
         GOTO (130,112),NF
112      IF(IFORM.LT.1) GOTO 145
         IF(NSAM1.NE.NSAM2.OR.
     &   NROW1.NE.NROW2.OR.NSLICE1.NE.NSLICE2) GOTO 145
         CALL FILERD(FILNAM,NLETO,NULL,'OUTPUT',IRTFLG)
         IF (IRTFLG .EQ. -1) GOTO 5
         CALL OPENF(FILNAM,LUN3,NSAM1,NROW1,'UNKNOWN',NF,NSLICE1)
         GOTO (130,951),NF
951      CONTINUE
C     CALL  RDPRMI(LENH,ITRMAX,NLOOP,ILOOP,
C     & 'Histogram length, maximum number of iterations')
         NSR=NSAM*NROW*NSLICE
         NSR1=NSAM1*NROW1*NSLICE1
C     if(lenh.eq.0) lenh=min0(nsr/16,nsr1/16,256)
C     if(itrmax.eq.0)  itrmax=100
         LENH=MIN0(NSR/16,NSR1/16,256)
         ITRMAX=100
C
C  MEMORY
C
         K1=1
         K2=K1+NSR
         K4=K2+NSR1
         K5=K4+LENH*3
         K6=K5+LENH*3
         K7=K6+(NSR1+3)/4
         MEMTOT=K7
         WRITE(NOUT,1010)   MEMTOT
1010     FORMAT(' Memory needed=',I8)
         IF(MEMTOT.GT.MAXMEM)  THEN
         CALL  ERRT(6,'Hist  ',NE)
         GOTO  5
         ENDIF
         DO    J=1,NROW*NSLICE
           CALL  REDLIN(LUN1,Q(K1+(J-1)*NSAM),NSAM,J)
	 ENDDO
         CLOSE(LUN1)
         DO    J=1,NROW1*NSLICE1
           CALL  REDLIN(LUN4,Q(K2+(J-1)*NSAM1),NSAM1,J)
	 ENDDO
         CLOSE(LUN4)
         CALL  CONVL(Q(K2),Q(K7),NSR1)
         DO    J=1,NROW1*NSLICE1
           CALL  REDLIN(LUN2,Q(K2+(J-1)*NSAM1),NSAM1,J)
	 ENDDO
         CLOSE(LUN2)
C
         CALL  HISTC
     &   (Q(K1),Q(K2),Q(K4),Q(K5),Q(K7),NSR,NSR1,LENH,ITRMAX,NOUT)
         DO    J=1,NROW1*NSLICE1
          CALL  WRTLIN(LUN3,Q(K2+(J-1)*NSAM1),NSAM1,J)
	 ENDDO
         CLOSE(LUN3)
         RETURN
C
5        CLOSE(LUN1)
         CLOSE(LUN2)
         RETURN
130      CALL ERRT(4,'CE FIT  ',NE)
         GOTO 5
145      CALL ERRT(2,'CE FIT  ',NE)
         GOTO 5
         END
