C++************************************************************************
C
C $$ HISTODC.FOR
C
C **************************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK            *
C *  COPYRIGHT (C)1981,1987, WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *  THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR       *
C *  LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR    *
C *  USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF     *
C *  THE CENTER FOR LABORATORIES AND RESEARCH   			   *
C **************************************************************************
C
C
C
C--************************************************************************
C
C $$ HISTODC.FOR
C
	SUBROUTINE  HISTODC(XR,H1,H2,N,LENH)
	INCLUDE 'CMBLOCK.INC'
	DIMENSION  XR(N),H1(LENH),H2(LENH)
CNO_SAVE
C  Generate Gaussian distribution - this will be expected distribution
C   of pixel values AFTER the transformation.
	SPI=0.0
	DO    I=1,LENH
	X=6.0*FLOAT(I-1)/FLOAT(LENH-1)-3.0
	H1(I)=EXP(-X*X/2.0)
	SPI=SPI+H1(I)
	ENDDO
	DO    I=1,LENH
	H1(I)=H1(I)/SPI
	ENDDO
C
	XRMI=XR(1)
	XRMA=XRMI
	DO    I=2,N
	XRMI=AMIN1(XRMI,XR(I))
	XRMA=AMAX1(XRMA,XR(I))
	ENDDO
C   B
	CHIMIN=1.0E23
	DO    B=-XRMI+1.0,XRMA,1.0
	CHI2=FHODT(B,N,LENH,XR,H1,H2,A,C)
	IF(CHI2.LT.CHIMIN)  THEN
	CHIMIN=CHI2
	AM=A
	BM=B
	CM=C
	ENDIF
	ENDDO
C
         WRITE(NOUT,206)  AM,BM,CM,CHIMIN
206      FORMAT(' The transformation is  A*(ALOG10(x+B)+C)',/,
     &   ' Parameters found     A =',1pe12.5,'   B =',1pe12.5,
     &   '   C =',1pe12.5,/,
     &   ' Chi-square     =',1pe12.5)
C
         IF(NSEL(1).NE.0)  PARAM(NSEL(1))=A
         IF(NSEL(2).NE.0)  PARAM(NSEL(2))=B
         IF(NSEL(3).NE.0)  PARAM(NSEL(3))=C
         END
