C++*************************************************************************
C
C  IMTOVOL.FOR -- CREATED JUL 96 al
C
C **************************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK            *
C *  COPYRIGHT (C)1981,1996, WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH                            *
C **************************************************************************
C
C  IMTOVOL(LUNIM,NSAM,NROW,NSLICE,LUNVOL,FMINT,FMAXT, MAXDIM)
C
C  PURPOSE:  CONVERTS IMAGES TO VOLUME ASSUMING THAT THE IMAGE
C            VALUE IS DEPTH.  VOLUME IS BINARY CONTAINING 0 AND 1
C
C        0         2         3         4         5         6         7     
C23456789 123456789 123456789 123456789 123456789 123456789 123456789 12
C--*********************************************************************


       SUBROUTINE IMTOVOL(LUNIM,NSAM,NROW,NSLICE,LUNVOL,FMINT,FMAXT,
     &                    MAXDIM)

       INCLUDE 'CMBLOCK.INC'

        COMMON       FIMBUF(4096)
        DIMENSION    VOLBUF(1)
        POINTER      (IPVOLBUF,VOLBUF) 
        LOGICAL      RUNTIME

       MEMWANT = NSAM * NROW * NSLICE + 1024
C      RUN TIME ALLOCATE MEMORY
       CALL ALLOCIT(MEMWANT,RUNTIME,IPVOLBUF,'PP V',IRTFLG)
       IF (.NOT.RUNTIME)  THEN
C          NOT ENOUGH MEMORY
           CALL ERRT(6,'PP V',NE)
           GOTO 999
       ENDIF

C      ZERO THE WHOLE VOLUME
       DO I = 1,NSAM * NROW * NSLICE
          VOLBUF(I) = 0.0
       ENDDO

C      FIND CONVERSION FACTOR FROM IMAGE MIN..MAX  TO DEPTH (SLICE)
       FACT = (FLOAT(NSLICE - 1) / (FMAXT - FMINT))      

C      FIND PIXELS PER SLICE
       IPPSL = NSAM * NROW

       NSLICEM1 = NSLICE - 1

       DO IROW = 1,NROW
C         READ IMAGE ROW
          CALL REDLIN(LUNIM,FIMBUF,NSAM,IROW)
          ICON1 = (IROW - 1) * NSAM

C         CONVERT IMAGE VALUE TO DEPTH (SLICE) FOR EACH PIXEL
          DO ISAM = 1,NSAM

C            INVERT THE SLICES SO TOP IS UP
             ISLICEM1 = NSLICEM1 - (FIMBUF(ISAM) - FMINT) * FACT
             ICON2    = ICON1 + ISAM

C            SET THE PIXEL AT THAT LOCATION TO 1.0 FOR ALL SLICES BELOW
             DO ISLICE = ISLICEM1, NSLICEM1           
                VOLBUF(ISLICE * IPPSL + ICON2) = 1.0
             ENDDO
          ENDDO
       ENDDo
    
C      SAVE THE VOLUME BUFFER  
       ILOC = 1 
       DO IREC = 1, NROW * NSLICE
          CALL WRTLIN(LUNVOL,VOLBUF(ILOC),NSAM,IREC)
          ILOC = ILOC + NSAM
       ENDDO

999    CONTINUE
       CLOSE(LUNVOL)
       CLOSE(LUNIM)

       RETURN
       END
