 
#ifdef SP_VMS 
 
C   THIS ROUTINE SPECIFIC TO UNIX SPIDER AND IS NOT 
C       USED AT VAX SITES
 
       SUBROUTINE inilun
 
       COMMON /UNITS/LUNC,NIN,NOUT
 
       WRITE(NOUT,*) 'DUMMY CALL: inilun'
       RETURN
       END
 
#else
 

C UNIX SPECIFIC

C ++********************************************************************
C
C INILUN.F
C
C **********************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK        *
C *  COPYRIGHT (C)    , WADSWORTH CENTER FOR LABORATORIES AND          *
C *    RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201 *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS *
C *    OR USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN        *
C *    APPROVAL OF THE CENTER FOR LABORATORIES AND RESEARCH.           *
C **********************************************************************
C
C   INILUN
C
C   SUBROUTINE TO INITIALIZE THE INPUT OUTPUT LOGICAL UNIT NUMBERS
C   AND SET MAXIMUM SIZE OF UNLABELED COMMON WORKSPACE
C                                                                      
C        0         2         3         4         5         6         7
C23456789012345678901234567890123456789012345678901234567890123456789012
C***********************************************************************
       
	SUBROUTINE INILUN(NIN,NOUT,NECHO,ITI,ITIN,NTERM,NDAT,MAXDIM)

#ifdef SP_DISTRIB 

C       IF YOUR SYSTEM COMPLAINS ABOUT LACK OF SWAP SPACE WHEN YOU
C       TRY TO RUN SPIDER, YOU CAN INCREASE SYSTEM SWAP SPACE, 
C       KILL SOME UNNECESSARY PROCESSES THAT YOU ARE RUNNING,
C       OR DECREASE THE MEMORY NEEDED BY SPIDER.  ALTER MAXDI
C       BELOW TO DECREASE MEMORY.  (MANY ROUTINES NOW USE RUN-TIME
C       ALLOCATION OF MEMORY WHICH IS INDEPENDENT OF THE COMMON
C       BUFFER SIZE)
 
C       FOR MACHINES WITH 64 MB RAM, REQUEST LESS THAN 64 MB
CC      PARAMETER (MAXDI =15000000)

C       FOR MACHINES WITH 32 MB RAM, REQUEST LESS THAN 32 MB
        PARAMETER (MAXDI = 7000000)

C       FOR MACHINES WITH 16 MB RAM, REQUEST LESS THAN 16 MB
CC      PARAMETER (MAXDI = 3500000)

#else   
C       SPACE RESERVATION USED AT ALBANY, REQUESTS 16 MB. EXCEPT
C       ON ONYX WHERE WE REQUEST 20 MB.  (MANY MEMORY HUNGRY
C       ROUTINES NOW ALLOCATE THEIR OWN MEMORY AT RUN-TIME, ON UNIX)
C       WE USUALLY > 80 MB RAM AVAILABLE ON ALBANY MACHINES

#ifdef SP_MP
        PARAMETER (MAXDI = 50000000)
#else
        PARAMETER (MAXDI = 50000000)
#endif
#endif

        COMMON   BUF(MAXDI)

C       SET SIZE OF COMMON BUFFER
        MAXDIM = MAXDI

C       TEMP IS NEEDED TO OVERCOME SOME OPTIMIZER LOSS OF BUF SETTING
        TEMP   = BUF(MAXDIM)

	NIN   = NTERM
	NOUT  = 6
	NECHO = NOUT
	ITI   = NOUT
	ITIN  = 5

        RETURN
	END
 
#endif
 
