C++*************************************************************************
C
C    INLNBUF.FOR     AUG 14, 1995 ARDEAN LEITH
C
C **************************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK            *
C *  COPYRIGHT (C)1981,1987, WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH 			   *
C **************************************************************************
C
C    INLNBUF(FILNAM,NLET,NUMBUF,IRTFLG)
C
C    PARAMETERS:     FILNAM    CHAR. VARIABLE FOR FILENAME  (SENT)
C                    NLET      LENGTH OF INLINE FILE NAME   (RETURNED)
C                    NUMBUF    INLINE BUFFER NUMBER         (RETURNED)
C                    IRTFLG
C
C    PURPOSE:        RETRIEVE INLINE BUFFER NUMBER FROM FILENAME
C
C **************************************************************************

        SUBROUTINE INLNBUF(FILNAM,NLET,NUMBUF,IRTFLG)

        COMMON /UNITS/LUNC,NIN,NOUT,NECHO,IFOUND,NPROC,NDAT

        CHARACTER *(*) FILNAM
        LOGICAL        ISDIGI
        CHARACTER *4   FMT

C       FORMAT FOR INTERNAL READ/WRITE
        DATA FMT/'(I )'/

C       SET ERROR AND NON-INLINE BUFFER RETURN VALUES
        IRTFLG = 1
        NUMBUF = 0

        IF (FILNAM(1:1) .EQ. '_') THEN
C          INLINED FILE WANTED, EXTRACT BUFFER NUMBER
           LENF = LEN(FILNAM)
           IGO  = 0
           DO I =2,LENF
             IF (ISDIGI(FILNAM(I:I))) THEN
                 IF (IGO .EQ. 0) IGO = I
                 IEND = I
             ELSE
                 IF (IGO .GT. 0) GOTO 10
             ENDIF
           ENDDO

10         CONTINUE

           IF (IGO .EQ. 0) THEN 
            WRITE(NOUT,94) FILNAM
94           FORMAT('*** INVALID INLINE FILE: ',A)
             CALL ERRT(100,'INLNBUF',NE)
             RETURN
           ENDIF

           IDIG = IEND - IGO + 1
           IF (IDIG .LE. 0 .OR. IDIG .GT. 9) THEN
C            ZERO, OR MORE THAN 9 DIGITS AFTER _!!!
             WRITE(NOUT,94) FILNAM
             CALL ERRT(100,'INLNBUF',NE)
             RETURN
           ENDIF

           WRITE(FMT(3:3),80) IDIG
 80        FORMAT(I1)

           READ(FILNAM(IGO:IEND),FMT,IOSTAT=IER) NUMBUF

           IF (IER .NE. 0) THEN
              WRITE(NOUT,94) FILNAM
              CALL ERRT(100,'INLNBUF',NE)
              RETURN
           ENDIF
           IRTFLG = 0
           NLET   = IEND
        ELSE
C          NOT AN INLINE FILE
           NUMBUF = 0
           IRTFLG = 0
        ENDIF

        RETURN
        END

