C++*********************************************************************
C
C  INQUIREIF1.F                                  NEW ROUTINE  SEPT 97 al
C                                
C **********************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.    AUTHOR: J.FRANK      *
C *  COPYRIGHT (C)1985, 1996 HEALTH RESEARCH INCORPORATED, ALBANY, NY. *
C * THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO HEALTH            *
C * RESEARCH INC. AND ARE NOT TO BE DISCLOSED TO OTHERS OR USED        *
C * FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF       *
C * HEALTH RESEARCH INC.                                               *
C **********************************************************************
C
C   INQUIREIF1    DETERMINES IF A FILE EXISTS
C
C--*********************************************************************

        SUBROUTINE INQUIREIF1(LUN,FILNAM,BUF,NBUFSIZ,EX,ISOPEN,LUNOP,
     7                        INLNED,IMGNUM,IRTFLG)

CNO_SAVE

        INCLUDE 'CMBLOCK.INC' 
 
C       DO NOT CHANGE NUMINLN WITHOUT SEARCH FOR OTHER OCCURANCES!
        PARAMETER       (NUMINLN = 9)
#ifdef SP_NT
        INTEGER LOCBUF
#else
        INTEGER * 8     LOCBUF
#endif
        COMMON /LUNARC/ LOCBUF(NUMINLN), NWORDBUF(NUMINLN), 
     &                  NSAMBUF(NUMINLN),IRECBUF(NUMINLN),
     &                  LABRECBUF(NUMINLN)

        COMMON /LUNARA/ LUNARA(100),LUNSTK(100)

        DIMENSION       BUF(*)
        CHARACTER *(*)  FILNAM
        CHARACTER       NULL,FIRSTC
        LOGICAL         EX,ISOPEN,STACKOPN

        NULL    = CHAR(0)

        NLET    = lnblnk(FILNAM)
        FIRSTC  = FILNAM(1:1)
        ILOCAT  = INDEX(FILNAM,'@')
        NAMEND  = NLET
        IF (ILOCAT .GT. 1) NAMEND = ILOCAT - 1
        EX      = .FALSE.
        ISOPEN  = .FALSE.
        INLNED  = 0
        IMGNUM  = 0

        IF (FIRSTC .NE. '_' .AND. ILOCAT .LE. 0) THEN
C          NO LEADING '_' AND NO '@' MEANS THAT IT IS A REGULAR 
C          FILE_BASED NON-STACK IMAGE OR OTHER FILE (SUCH AS A
C          DOCUMENT FILE)

C          SEE IF THIS FILE EXISTS, (RETURNS EX, ISOPEN, LUNOP)
           INQUIRE(FILE=FILNAM(1:NAMEND),EXIST=EX,OPENED=ISOPEN,
     &             NUMBER=LUNOP,ERR=999)

           RETURN

        ELSEIF (FIRSTC .NE. '_') THEN
C          NO LEADING '_' MEANS FILE_BASED STACK OR OVERALL STACK 

C          CHECK TO SEE IF IMAGE EXISTS IN THIS EXISTING STACK
C          SET IFOUND TO DECREASE OPENING OUTPUT INFO
           IFOUND = -4

C          A BARE STACK FILE IS OK
           MAXIM  = -1
           CALL OPFIL(.FALSE.,FILNAM,LUN,'Z',NSAM,NROW,NSLICE,
     &              MAXIM,' ',.TRUE.,IRTFLG)
           IF (IRTFLG .EQ. 0) EX = .TRUE.
           IFOUND = 0
           CLOSE(LUN)
           RETURN

        ELSEIF (FIRSTC .EQ. '_') THEN
C          INLINE IMAGE FILE OR OVERALL INLINE STACK ACCESS WANTED

C          RETRIVE INLINE BUFFER NUMBER FROM FILE NAME
           CALL INLNBUF(FILNAM,NLET,INLNED,IRTFLG)
           IF (IRTFLG .NE. 0)  RETURN

C          SEE IF INLINE STACK EXISTS NOW
           STACKOPN = (NSAMBUF(INLNED) .GT. 0)
           IF (.NOT. STACKOPN) RETURN

C          HAVE EXISTING INLINE BUFFER, TIE IT TO LUN & GET NSAM
C          NEED TO OVERRIDE ERRT IN OPENINLN
           CALL OPENINLN(LUN,INLNED,.FALSE.,NSAM,0,.FALSE.,IRTFLG)
C          IRTFLG WILL BE SET IF INLINE FILE DOES NOT EXIST
           IF (IRTFLG .NE. 0)  RETURN

           IF (ILOCAT .EQ. 0) THEN
C              SIMPLE INLINE IMAGE OR OVERALL INLINE STACK
               EX = .TRUE.
               RETURN
           ENDIF                 

C          FIND IMAGE NUMBER WITHIN STACK 
           READ(FILNAM(ILOCAT+1:),*,IOSTAT=IER) IMGNUM
           IF (IER .NE. 0) THEN
              CALL ERRT(101,'UNABLE TO INTERPRET IMAGE NUMBER',NE)
              RETURN
           ENDIF

C          SET OFFSET INTO LUNSTK, ALL IMAGES SHOULD HAVE IREC 
C          SAME AS THE HEADER          
           LUNARA(LUN) = LABRECBUF(INLNED)
           LUNSTK(LUN) = (IMGNUM-1)* IRECBUF(INLNED) + LUNARA(LUN)

C          GET SPECIFIED IMAGE HEADER FROM STACK LOCATION
           CALL REDHED(LUN,BUF,NBUFSIZ,NSAM,1,IRTFLG)
           IF (IRTFLG .NE. 0) THEN
C             THIS IMAGE DOES NOT EXIST
              RETURN
           ENDIF

C          SEE IF QUERIED IMAGE IS IN THE STACK
           IMUSED = BUF(25)
           IF (IMUSED .GT. 0) EX = .TRUE.
        ENDIF

        RETURN



999     WRITE(NOUT,*)'*** ERROR INQUIRING ABOUT FILE: ',FILNAM(1:NLET)
        CALL ERRT(100,' ',NE)
        EX = .FALSE.
        RETURN

        END




