C++*********************************************************************
C
C  INQUIREREG.F                                  NEW ROUTINE  JAN 98 al
C                                
C **********************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.    AUTHOR: J.FRANK      *
C *  COPYRIGHT (C)1985, 1996 HEALTH RESEARCH INCORPORATED, ALBANY, NY. *
C * THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO HEALTH            *
C * RESEARCH INC. AND ARE NOT TO BE DISCLOSED TO OTHERS OR USED        *
C * FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF       *
C * HEALTH RESEARCH INC.                                               *
C **********************************************************************
C
C   INQUIREIF    DETERMINES IF A REGISTER VALUE IS CORRECT
C
C   PARAMETERS:  SAYIT    LOGICAL FLAG TO LIST ERROR
C                SHUDSTOP LOGICAL FLAGE TO STOP IF WRONG IN BATCH
C                IRTFLG   ERROR FLAG
C                         -1 IS ABORT INPUT
C                          0  IS NORMAL
C                          1 INQUIRY WAS NOT AS EXPECTED
C
C--*********************************************************************

        SUBROUTINE INQUIREREG(SAYIT,SHUDSTOP,IRTFLG)
CNO_SAVE

        INCLUDE 'CMBLOCK.INC' 
 
        LOGICAL        SAYIT,SHUDSTOP

        IRTFLG = 1

        CALL RDPRM2S(REG,VALUE,NLOOP,ILOOP,
     &               'REGISTER & ITS REQUIRED VALUE',IRTFLG)
        IF (IRTFLG .EQ. -1) RETURN

        IREG = REG + 1.5
        IF (IREG .LT. 1 .OR. IREG .GT. 103) THEN
C          REGISTER OUT OF RANGE
           CALL ERRT(101,'REGISTER OUT OF RANGE: 0...102',NE)
           RETURN
        ENDIF

        IF (PARAM(IREG) .NE. VALUE) THEN
C          REGISTER NOT CORRECT
           IF (SHUDSTOP) THEN
               CALL ERRT(101,'REGISTER VALUE INCORRECT',NE)
           ELSE
               IF (SAYIT) WRITE(NOUT,*) 'REGISTER VALUE INCORRECT!'
               WRITE(NOUT,*) 'REGISTER VALUE INCORRECT'
           ENDIF
           RETURN
        ENDIF

        IRTFLG = 0
        WRITE(NOUT,*) ' '

        RETURN
        END





