
C************************************************************************
C
C     USED IN FUZZY CLASSIFICATION
C
C     CALLED BY:  GKSM
C
C************************************************************************

      SUBROUTINE INVDET (SF,ISF,IA,N,DET)
      REAL SF(IA,1),ISF(IA,1)

C     SF  : POSITIVE DEFINITE OF ORDER N
C     ISF : INVERSE MATRIX
C     DET : SQRT OF DETERMINANT
C
      DET=1.
C
C     CHOLESKY REDUCTION
C
      DO  K=1,N
         DO  I=1,K-1
            DO  J=1,I-1
            SF(K,I)=SF(K,I)-SF(I,J)*SF(K,J)
	    ENDDO
            SF(K,I)=SF(K,I)/SF(I,I)
         SF(I,K)=SF(K,I)
	 ENDDO
         DO  J=1,K-1
          SF(K,K)=SF(K,K)-SF(K,J)*SF(K,J)
	 ENDDO
C
         IF (SF(K,K).GT.0) THEN
                 SF(K,K)=SQRT(SF(K,K))
            ELSE 
                 SF(K,K)=0
         ENDIF
C
         DET=DET*SF(K,K)
         IF (DET.EQ.0) RETURN
C
      ENDDO
C
C     INVERSES OF L AND L-TRANSPOSE
C
      DO  K=N,1,-1
         SF(K,K)=1./SF(K,K)
         DO  I=K-1,1,-1
            SF(K,I)=0.
            DO  J=I+1,K
            SF(K,I)=SF(K,I)+SF(I,J)*SF(J,K)
	    ENDDO
            SF(K,I)=-SF(K,I)/SF(I,I)
      	SF(I,K)=SF(K,I)
      	ENDDO
      ENDDO
C
C     INVERSE OF SF
C
      DO  I=1,N
      DO  J=I,N
         ISF(I,J)=0.   
         DO  K=J,N
         ISF(I,J)=ISF(I,J)+SF(I,K)*SF(K,J)
	 ENDDO
      ISF(J,I)=ISF(I,J)
      ENDDO
      ENDDO
	
C
      RETURN
      END

