C
C	 RETURNS A NORMALLY DISTRIBUTED DEVIATE WITH ZERO MEAN AND UNIT
C	 VARIANCE USING UNIFORM_DEVIATE AS THE SOURCE OF THE UNIFORM
C	 DEVIATE FOR THE GENERATION OF THE GAUSSIAN
C
C	 UNIFORM_DEVIATE IS ASSUMED TO BE BETWEEN 0.0 AND 1.0
C
C	 BASED ON ABRAMOWITZ AND STEGEN P 953 AND 933
C
C	 SDF 27-SEP-89
C
C........................................................................
 	
        SUBROUTINE INVGDIST(UNIFORM_DEVIATE, GAUSSIAN_DEVIATE)

        INCLUDE 'CMBLOCK.INC'

        DOUBLE PRECISION C0,C1,C2,D1,D2,D3
 	PARAMETER (C0 = 2.515517)
 	PARAMETER (C1 = 0.802853)
 	PARAMETER (C2 = 0.010328)
 	PARAMETER (D1 = 1.432788)
 	PARAMETER (D2 = 0.189269)
 	PARAMETER (D3 = 0.001308)
 
 	REAL*4 UNIFORM_DEVIATE, GAUSSIAN_DEVIATE
 	DOUBLE PRECISION  T, A, B
 
 	IF (UNIFORM_DEVIATE .GE. 0.0
     1      .AND. UNIFORM_DEVIATE .LE. 1.0) THEN	    
 	    T = DSQRT(-2.0*DLOG(UNIFORM_DEVIATE+1.0D-20))
 	    A = C0 + T*(C1 + C2*T)
 	    B = 1.0 + T*(D1 + T*(D2 + D3*T))
 	    GAUSSIAN_DEVIATE = T-(A/B)
 	ELSE
 	   WRITE(NOUT,
     1    '('' INVGDIST: ERROR - UNIFORM_DEVIATE OUT OF RANGE  '',G)')
     1	     UNIFORM_DEVIATE 
 	    CALL ERRT(100,'INVGDIST',NE)
 	END IF
 	
 	RETURN
 	END
