
C++*************************************************************************
C
C LISTDC.FOR                                        REWRITTEN DEC 89 al
C
C **************************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK            *
C *  COPYRIGHT (C)1981,1987, WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH 			   *
C **************************************************************************
C
C  LISTDC(FCHAR,DOCNAM,DUM,NDOC,ISEQ)
C
C  PURPOSE:       LIST DOCUMENT FILE TO RESULTS FILE OR TERMINAL 
C                 WITH HEADINGS
C
C  PARAMETERS:    FCHAR     80 CHARACTER LINE STARTING WITH LD   (SENT)
C                 DOCNAM    DOCUMENT FILE NAME WITH EXTENSION    (SENT)
C                 DUM       UNUSED
C                 NDOC      LOGICAL UNIT NUMBER                  (SENT)
C                 ISEQ      INDICATES WHETHER THE FILE HAS 
C                           SEQUENTIAL(ISEQ=1)
C                           OR RANDOM (ISEQ=0) KEY ORDER         (SENT)
C
C  NOTE:          ALLOWABLE LENGTH OF EACH HEADING IS 8.
C
C--*************************************************************************

	SUBROUTINE LISTDC(FCHAR,DOCNAM,DUM,NDOC,ISEQ)

	COMMON /UNITS/LUN,NIN,NOUT,NECHO,IFOUND,NPROC,NDAT
        COMMON /COMMUN/ RECLIN,HEADE,DLIST

	DIMENSION       DLIST(10)
        CHARACTER * (*) DOCNAM,FCHAR
        CHARACTER * 80  RECLIN,HEADE,DOC
        CHARACTER * 1   NULL
	LOGICAL EX,ADDEXT,ISOLDFILE,GETNAME,APPEND,MESSAGE,NEWFILE

	DATA MAXHD/8/
        NULL=CHAR(0)

	NDEV = NDAT
C       DEFAULT PRINTING DEVICE IS LP

        HEADE = ' ' // NULL

C       OPEN THE DOC FILE
        DOC = DOCNAM
	
c           CALL OPENDOC(DOCNAM,.TRUE.,NLET,NDOC,.FALSE.,
c     &                  .TRUE.,.TRUE.,.TRUE.,NEWFILE,LERR)
c     
     
	CALL OPENDOC(DOC, .FALSE., NLET, NDOC, .FALSE., .TRUE.,
     &                      .FALSE., .FALSE., NEWFILE, IRTFLG)
        IF (IRTFLG .NE. 0) RETURN

C       INDXF KEEPS TRACK OF POSITION IN LD LINE
C       INDXH IS THE NUMBER OF HEADINGS 

	INDXH = 0
	INDXF = 3
	IF (FCHAR(4:4) .EQ. 'T') THEN
            INDXF = 5
            NDEV  = NOUT
        ENDIF

10	LEN=0
C       SEARCH FOR A ' CHARACTER IN THE OPERATION STRING

11	INDXF = INDXF + 1
        IF (FCHAR(INDXF:INDXF) .NE. CHAR(39)) THEN
C          CONTINUE UNTIL ' FOUND OR END OF STRING
           IF (INDXF .LT. 80) GOTO 11

        ELSE
C          START OF A NEW HEADING
           INDXH = INDXH + 1
           IF (INDXH .GT. MAXHD) THEN
             WRITE(NOUT,*) ' *** SYNTAX ERROR, TOO MANY HEADINGS'
             CLOSE(NDOC)
             RETURN
           ENDIF
           INDXF = INDXF + 1
C          ITEMP IS PRESENT POINTER TO STRING LOCATION
           ITEMP = INDXF

30	   IF (FCHAR(ITEMP:ITEMP) .EQ. CHAR(39)) THEN
C            REACHED END OF THIS HEADING
             IF (LEN .GT. 8) LEN = 8
             IGO = (INDXH - 1) * 10 + 1
             HEADE(IGO:IGO+9) = FCHAR(INDXF:INDXF+LEN-1)
             INDXF = ITEMP
             IF (INDXF .LT. 80) GOTO 10

           ELSE
C            STILL IN PRESENT HEADING
             LEN   = LEN + 1
             ITEMP = ITEMP + 1
             GOTO 30
           ENDIF
        ENDIF

C       FINISHED WITH ALL HEADINGS
        IF (INDXH .EQ. 0) THEN
           WRITE(NOUT,*) '*** DEFAULTS TO 2 COLUMNS WITHOUT HEADINGS'
           INDXH = 2
        ENDIF
	READ(NDOC,175,END=300) RECLIN

	WRITE(NDEV,70) RECLIN(1:80)
70	FORMAT(//1X,A)

	WRITE(NDEV,75) HEADE (1:10),HEADE(11:20),HEADE(21:30),
     &                 HEADE(31:40),HEADE(41:50),HEADE(51:60),
     &                 HEADE(61:70),HEADE(71:80)
75	FORMAT(/,'  KEY   ',8(A10,1X)/)

	NFIRST = 0
	MIN    = 1000000
	MAX    = 1

150	READ(NDOC,175,END=300) RECLIN
175	FORMAT(A)

	IF (RECLIN(2:2) .EQ. ';') GOTO 150
        IF (RECLIN(5:5) . EQ. ' ') THEN
           READ (RECLIN(:4),180) NKEY
180	   FORMAT(I4)
        ELSE
           READ (RECLIN(:5),680) NKEY
680	   FORMAT(I5)
        ENDIF

        IF (NKEY .NE. -99) THEN
C          NOT A CONTINUATION LINE            
           IF (NKEY .LT. MIN) MIN = NKEY
           IF (NKEY .GT. MAX) MAX = NKEY
        ENDIF
	GOTO 150


300	REWIND NDOC
	IF (FCHAR(5:5) .EQ. 'T') LERR = -1
   
C       NOPEN=1 MEANS DOCUMENT FILE IS ALREADY ASSIGNED (FOR UNSAV)
C       NOPEN<0 MEANS DO NOT WRITE ERROR MESSAGES FROM UNSAV


	DO I = MIN,MAX
           NOPEN  = -1
           CALL UNSAV(DOCNAM,NOPEN,NDOC,I,DLIST,INDXH,LERR,ISEQ)
           IF (LERR .NE. 0. AND. NFIRST .EQ. 0) GOTO 8200
           IF (LERR .EQ. 0) THEN
             NFIRST=1
             WRITE(NDEV,400) I,(DLIST(K),K=1,INDXH)
400	     FORMAT(I5,2X,8(F10.6,1X))
           ENDIF
        ENDDO

        WRITE(NOUT,*) ' '

8200	CLOSE(NDOC)

	LERR=0
9000	RETURN

	END

