
C++************************************************************************
C
C    LISTIT.FOR             REWRITTEN & REMOVED FROM OPENPIC AUG 96 al      
C                           LONG FILENAMES DEC 88 al
C
C **************************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK            *
C *  COPYRIGHT (C)1981,1987, WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH 			   *
C **************************************************************************
C
C    LISTIT()
C
C    PURPOSE:   TO LIST CONTENTS OF SELECTED IMAGE ELEMENTS 
C
C    PARAMETERS:
C         FILNAM     FILE NAME (ONLY USED FOR TITLE)
C         LUN        LOGICAL UNIT NUMBER OF FILE
C         NSAM,NROW  IMAGE DIMENSIONS
C         NSLICE     IMAGE DIMENSIONS SLICES
C         DOCPRNT    PRINT TO DOC FILE
C         TERMPRNT   PRINT TO TERMINAL
C                    OTHERWISE PRINT TO RESULTS FILE
C
C        0         2         3         4         5         6         7     
C--*********************************************************************

	SUBROUTINE LISTIT(FILNAM,LUN,NSAM,NROW,NSLICE,DOCPRNT,TERMPRNT)

	PARAMETER (NBUF=16000)

	INCLUDE 'CMBLOCK.INC' 
CNO_SAVE

	COMMON           IROW(NBUF),ICOL(NBUF),ISLI(NBUF)
	COMMON           IBUF(NBUF),AOUT(NBUF),JOUT(NBUF),A0(1)
        COMPLEX          BCOM(1)
        EQUIVALENCE      (A0,BCOM)
        CHARACTER *81    DOCNAM
        COMMON /COMMUN/  DOCNAM

        CHARACTER *(*)   FILNAM
        CHARACTER *1     NULL,ANS,OTYPE,FTYPE
        LOGICAL          INTPRNT, DOCPRNT, TERMPRNT, PHAMPRNT
        REAL             DLIST(10)

        DATA NDOC   /76/

        NULL = CHAR(0)

        NLET = INDEX(FILNAM,NULL) - 1

C       DETERMINE OUTPUT OPTION
	NLIS     =  NDAT
        IF (TERMPRNT) NLIS = NOUT
        INTPRNT = .FALSE.

        IF (DOCPRNT) THEN
C           GET NAME FOR DOC FILE
            CALL FILERD(DOCNAM,NLETD,NULL,'OUTPUT DOC FILE',IRTFLG)
            A0(1) = 0
C           OPEN THE DOC FILE NOW
            NRUN  = 0
            CALL SAVDN1(NDOC,DOCNAM,AO,0,NRUN,0)
            NRUN  = 1
            WRITE(NDOC,90)  FILNAM(1:NLET)
 90         FORMAT(' ; FROM IMAGE FILE: ',A)
        ELSE
            WRITE(NLIS,91)  FILNAM(1:NLET)
 91         FORMAT(' -------- LISTING FROM IMAGE FILE: ',A)
        ENDIF

C       SET FOR ALL COLUMS, ROWS, FIRST SLICE ONLY
        NIROW   = 0
        NICOL   = 0
        NISLI   = 1
        ISLI(1) = 1

        CALL RDPRMC(OTYPE,NCHAR,.TRUE.,
     &    'HEADER, PIXEL, ROW, COLUMN, IMAGE, OR WINDOW (H/P/R/C/I/W)',
     &     NULL,IRTFLG)

        IF (OTYPE .EQ. 'H') THEN
C          WANT HEADER ONLY
           NICOL = NBUF
           CALL RDPRAI(ICOL,NBUF,NICOL,1,256,
     &              'ENTER HEADER POSITION(S)', NULL,IRTFLG)

        ELSEIF (OTYPE .EQ. 'P') THEN
C          WANT ONE PIXEL ONLY
           CALL RDPRIS(IROW(1),ICOL(1),NLOOP,ILOOP,
     &        'ENTER COLUMN & ROW',IRTFLG)
           NIROW = 1
           NICOL = 1
        ELSEIF (OTYPE .EQ. 'R') THEN
C          WANT ONE ROW ONLY
           NIROW = NBUF
           CALL RDPRAI(IROW,NBUF,NIROW,1,NROW,'ENTER ROW(S)',
     &                 NULL,IRTFLG)
           DO I = 1,NSAM
              ICOL(I) = I
           ENDDO
           NICOL = NSAM
        ELSEIF (OTYPE .EQ. 'C') THEN
C          WANT ONE COL. ONLY
           NICOL = NBUF
           CALL RDPRAI(ICOL,NBUF,NICOL,1,NSAM,'ENTER COLUMN(S)',
     &                 NULL,IRTFLG)
           DO I = 1,NROW
              IROW(I) = I
           ENDDO
           NIROW = NROW
        ELSEIF (OTYPE .EQ. 'I' .AND. NSLICE .GT. 1) THEN
C          WANT ONE IMAGE. ONLY
           NISLI = NBUF
           CALL RDPRAI(ISLI,NBUF,NISLI,1,NSLICE,'ENTER SLICE(S)',
     &          NULL,IRTFLG)
           DO I = 1,NROW
              IROW(I) = I
           ENDDO
           NIROW = NROW
           DO I = 1,NSAM
              ICOL(I) = I
           ENDDO
           NICOL = NSAM
        ELSEIF (OTYPE .EQ. 'W') THEN
C          WANT WINDOW FROM IMAGE
           NICOL = NBUF
           CALL RDPRAI(ICOL,NBUF,NICOL,1,NSAM,'ENTER COLUMNS(S)',
     &                 NULL,IRTFLG)
           NIROW = NBUF
           CALL RDPRAI(IROW,NBUF,NIROW,1,NROW,'ENTER ROW(S)',
     &                 NULL,IRTFLG)
           IF (NSLICE .GT. 1) THEN
C             MAY WANT MORE THAN ONE SLICE
              NISLI = NBUF
              CALL RDPRAI(ISLI,NBUF,NISLI,1,NSLICE,'ENTER SLICE(S)',
     &                    NULL,IRTFLG)
           ENDIF
        ENDIF            

        IF (.NOT. DOCPRNT .AND. IFORM .GT. 0 .AND.
     &      OTYPE .NE. 'H') THEN
           CALL RDPRMC(FTYPE,NCHAR,.TRUE.,
     &         'FLOATING POINT OR INTEGER FORMAT OUTPUT (F/I)', 
     &          NULL,IRTFLG)
           IF (FTYPE .EQ. 'I') INTPRNT = .TRUE.
        ENDIF

        PHAMPRNT = .FALSE.
        IF (IFORM .LT. 0 .AND. OTYPE .NE. 'H') THEN
C          FOURIER FILE
           CALL RDPRMC(ANS,NCHAR,.TRUE.,
     &          'PHASE & MODULI LISTING? (Y/N)', NULL,IRTFLG)
           IF (ANS .NE. 'N') PHAMPRNT = .TRUE.
        ENDIF

        IF (OTYPE .EQ. 'H') THEN
C         PRINT OUT HEADER STUFF
C         READ ALL HEADER POSITIONS INTO A0 BUFFER
          CALL REDHED(LUN,A0,NBUF,NSAM,0,IRTFLG)
          IF (IRTFLG .NE. 0) GOTO 999

          IF (DOCPRNT) THEN
C           SAVE IN DOC FILE, DO NOT APPEND
            WRITE(NDOC,94)  
 94         FORMAT(' ; FILE HEADER VALUES ---------------------')

             DO I = 1, NICOL
                DLIST(1) = ICOL(I)
                DLIST(2) = A0(I)
                CALL SAVDN1(NDOC,DOCNAM,DLIST,2,NRUN,0)
             ENDDO
          ELSE
C            FLOATING POINT HEADER LISTING
             WRITE(NLIS,*) ' '
             WRITE(NLIS,*) 'FILE HEADER VALUES -----------------'

             WRITE(NLIS,302) (A0(ICOL(J)),J=1,NICOL)
302          FORMAT(5(1X,G12.4))
          ENDIF
          GOTO 999
        ENDIF

        IF (PHAMPRNT) THEN
           IF (DOCPRNT) THEN
              WRITE(NDOC,95)  
 95           FORMAT(' ; LISTING OF FOURIER MODULI AND PHASES ------')
           ELSE
              WRITE(NLIS,*) ' '
              WRITE(NLIS,*)
     &             'LISTING OF FOURIER MODULI AND PHASES ------'
           ENDIF
        ELSE
           IF (DOCPRNT) THEN
              WRITE(NDOC,96)  
 96           FORMAT(' ; LISTING OF FILE VALUES ------')
           ELSE
              WRITE(NLIS,*) ' '
              WRITE(NLIS,*)
     &               'LISTING OF FILE VALUES ------'
           ENDIF
        ENDIF

C       FOR EACH SLICE IN THE REQUESTED LISTING
        DO  KSLICE = 1, NISLI
           ISLICET = ISLI(KSLICE)
      
C          FOR EACH ROW IN THE REQUESTED LISTING
           DO  KROW = 1,NIROW
              IROWT = IROW(KROW)

C             RECOVER THE IMAGE ROW
              IROWNOW = (ISLICET - 1) * NROW + IROWT
              CALL REDLIN(LUN,A0,NSAM,IROWNOW)

              IF (DOCPRNT) THEN
C                OUTPUT TO DOC FILE
                 WRITE(NDOC,902) ISLICET,IROWT
 902             FORMAT(' ;    SLICE: ',I5,'   ROW: ',I5)
              ELSE
                 WRITE(NLIS,903) ISLICET,IROWT
 903             FORMAT(' SLICE: ',I5,'   ROW: ',I5)
              ENDIF

C             GET THE PIXELS WANTED FROM THIS LINE, PUT IN AOUT
              IVALS = 0
              DO KSAM = 1,NICOL
                 IVALS = IVALS + 1
                 JOUT(IVALS) = ICOL(KSAM)
                 AOUT(IVALS) = A0(ICOL(KSAM))
              ENDDO

              IF (PHAMPRNT) THEN
C                WANT PHASE & MODULI FOR FOURIER
                 ANGF  = 180./3.14159
                 IVALS = 0
                 DO KSAM = 1,NICOL
                    IF (KSAM .LT. NSAM / 2) THEN
                       L  = ICOL(KSAM)
                       BR = A0(2*(L-1)+1)
                       BI = A0(2*L)
                       AM = SQRT(BI**2+BR**2)
                       PH = 0.0
                       IF (BI .NE. 0. .OR. BR .NE. 0.) 
     &                     PH = ATAN2(BI,BR)*ANGF
                       IVALS       = IVALS + 1
                       AOUT(IVALS) = AM
                       JOUT(IVALS) = ICOL(KSAM)
                       IVALS       = IVALS + 1
                       AOUT(IVALS) = PH
                    ENDIF
                 ENDDO
              ENDIF

              IF (DOCPRNT) THEN
C                PRINT INTO DOC FILE ONLY
                 DO I = 1, IVALS 
                    DLIST(1) = JOUT(I)
                    DLIST(2) = AOUT(I)
                    DLIST(3) = JOUT(I)
                    DLIST(4) = IROWT
                    DLIST(5) = ISLICET
                    CALL SAVDN1(NDOC,DOCNAM,DLIST,5,NRUN,0)
                 ENDDO
              ELSEIF (INTPRNT) THEN
C                PRINT AS INTEGERS
                 DO  J=1,IVALS
                    IBUF(J) = AOUT(J)
                 ENDDO

                 WRITE(NLIS,602)(IBUF(J),J=1,IVALS)
602              FORMAT(10(1X,I10.6))
              ELSE
C                FLOATING POINT LISTING 
                 WRITE(NLIS,106)(AOUT(J),J=1,IVALS)
 106             FORMAT(5G12.4)
              ENDIF
           ENDDO
        ENDDO
        IF (.NOT. DOCPRNT) WRITE(NLIS,*) ' '

999     CONTINUE
        IF (DOCPRNT) CLOSE(NDOC)

       RETURN
       END


