
C++************************************************************************
C
C    LISTITR.FOR                      FILENAMES DEC 88 al
C                                     RENAMED FROM OPNPICP, SEP 96 al
C
C **************************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK            *
C *  COPYRIGHT (C)1981,1987, WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH 			   *
C **************************************************************************
C
C    LISTITR(FILNAM,LUN,NSAM,NROW,NSLICE)
C
C    PURPOSE:   TO PLACE SPIECIFED IMAGE LOCATIONS IN SPECIFIED
C               REGISTERS
C
C    PARAMETERS:
C         FILNAM     FILE NAME 
C         LUN        LOGICAL UNIT NUMBER OF FILE
C         NSAM,NROW  IMAGE DIMENSIONS
C         NSLICE     IMAGE DIMENSION
C
C    DESCRIPTION:  
C
C        0         2         3         4         5         6         7     
C23456789012345678901234567890123456789012345678901234567890123456789012
C--*********************************************************************

	SUBROUTINE LISTITR(FILNAM,LUN,NSAM,NROW,NSLICE)

	PARAMETER (NBUF=100)
                             
	INCLUDE 'CMBLOCK.INC' 
CNO_SAVE
        COMMON  /COMMUN/ PROMPT
	COMMON   ISAM(NBUF),IROW(NBUF),A0(1)

        CHARACTER *(*) FILNAM
        CHARACTER *29  PROMPT
        CHARACTER *1   NULL,ANS

        NULL = CHAR(0)

C                 123456789012345678901234567890
        PROMPT = 'ENTER X-COORDINATES (MAX 20)'
        NUM = 20
        CALL RDPRAI(ISAM,NBUF,NUM,1,NSAM,PROMPT,NULL,IRTFLG)

        PROMPT = 'ENTER Y-COORDINATES (MAX 20)'
        NUM = 20
        CALL RDPRAI(IROW,NBUF,NUM,1,NROW,PROMPT,NULL,IRTFLG)

        ITREC = NROW * NSLICE

        DO K =1,NUM
            IF (IROW(K) .GT .ITREC .OR. ISAM(K) .GT. NSAM) THEN
C              POINT OUTSIDE OF IMAGE 
               CALL ERRT(7,'LISTITR',NE)
               RETURN
            ENDIF

            CALL REDLIN(LUN,A0,NSAM,IROW(K))
            IND = ISAM(K)
            KK  = NSEL(K)

            IF (KK .NE. 0) THEN
               PARAM(KK) = A0(IND)
            ELSE
               WRITE(NOUT,*) 
     &            '*** MORE COORDINATES THAN REGISTERS ENTERED'
               CALL ERRT(100,'LISTITR',NE)
               RETURN
            ENDIF
        ENDDO

        NLET = INDEX(FILNAM,NULL) - 1
        WRITE(NDAT,110) FILNAM(1:NLET)
110     FORMAT(' FILE: ',A)

        WRITE(NDAT,106) 
     &     (ISAM(K),IROW(K),(NSEL(K)-1),PARAM(NSEL(K)),K=1,NUM)
 106    FORMAT(' X = ',I4,'  Y = ',I4,'    X',I2,' = ',G12.4)

        RETURN
	END


