
C++************************************************************************
C
C LKUPDC.FOR
C                                  LONG FILE NAMES FEB 89 al
C                                  MAJOR BUGS FIXED -- SEPT 92 al
C **************************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK            *
C *  COPYRIGHT (C)1981,1987, WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH 			   *
C **************************************************************************
C
C  FUNCTION LKUPDC(ISYMB,IBUF)
C
C  PURPOSE:   LKUPDC RETURNS AN INTEGER LOOKED UP IN DOCUMENT FILE 
C             DOCNAM.  DOCNAM IS SOLICITED IN THE INITIALIZATION CALL
C             WHICH IS: CALL LKUPDC(0,IBUF)
C             DOC FILE FORMAT:  REG 1 IS IMAGE NUMBER
C                                 REG 2 IS ASCII SYMBOL
C                                 (KEY IS MEANINGLESS)
C             NOTE: 10-SEPT-92 al.  I HAVE REWRITTEN THIS TO WORK THE
C             WAY THE DOCUMENTATION SAYS IT WILL WORK. I AM AWARE THAT
C             IT IS NOT EFFECIENT OR ELEGANT!
C
C  CALLS:     UNSDAL
C
C        0         2         3         4         5         6         7
C23456789012345678901234567890123456789012345678901234567890123456789012
C--*********************************************************************

	INTEGER   FUNCTION LKUPDC(ISYMB,IBUF)

	INCLUDE 'CMBLOCK.INC' 

C       MAXIMUM NUMBER OF REGISTERS PER KEY
        PARAMETER (MAXREG=7)
C       MAXIMUM NUMBER OF KEYS
        PARAMETER (MAXKEY=1000)
C       DBUF = DOCUMENT BUFFER FOR DOCUMENT CORE IMAGE
        COMMON /DOC_BUF/ DBUF(MAXREG,MAXKEY)

        DIMENSION     FDUM(MAXREG)
	INTEGER       ISYMB,IBUF(1)

	CHARACTER *80 DOCNAM
        CHARACTER     NULL

        DATA NDOC/16/

        NULL = CHAR(0)

	IF (ISYMB .LE. 0) THEN
C          RECOVER DOC FILE IN DBUF AND STORE IN IBUF

C          FIND DOC FILE NAME
           CALL FILERD(DOCNAM,NLET,NULL,'DOC FILE NAME',IRTFLG)

C          ADD EXTENSION TO FILE NAME
           CALL FILCAN(DOCNAM,NLET,NULL,NULL,DOCNAM,DATEXC,IRTFLG)

C          RETRIEVE DBUF FROM DOC FILE
           NLIST = 2
           CALL UNSDAL(DOCNAM,ICALL,NDOC,1,FDUM,NLIST,
     &                 DBUF,MAXKEY,MAXREG,NKEY,LERR)

C          REORDER DBUF TO USE REG 1 AS THE KEY IN IBUF
           DO I = 1,NKEY
              ITEMP = DBUF(1,I)
              IBUF(ITEMP) = DBUF(2,I)
           ENDDO                 
        ENDIF

	LKUPDC = IBUF(ISYMB)

        RETURN
	END
