
C-*************************************************************************
C
C       USED IN FUZZY CLASSIFICATION
C
C       CALLED BY: CRTEST
C
C-************************************************************************
C
C X   : PATTERN MATRIX (INPUT)
C R   : CRITERIA MATRIX OF KX ROWS AND NCT COLUMNS (OUTPUT)
C NN,NF,KX : DIMENSIONS IN THE MAIN PROGRAM ASSOCIATED WITH
C            NUMBER OF PATTERN, FEATURES AND CLUSTER
C XB,V,U   : WORKING AREA OF FCM SUBROUTINE (SEE FCM PROGRAM)
C AREA1 : WORKING AREA OF 2*NN INTEGERS
C AREA2 : WORKING AREA OF 6*KX+KX*KX+MAXBT*MAXINC OF REALS. WHERE
C         MAXBT AND MAXINC ARE THE MAXIMUM NUMBER OF BOOTSTRAPS
C         AND INICIALIZATIONS FROM THE MAIN PROGRAM
C AREA3 : WORKING AREA OF 4*NN+3*KX OF REALS (SEE CRITER PROGRAM)
C RD : WORKING AREA OF GKSM SUBROUTINE (SEE GK PROGRAM)
C
C VARIABLES IN COMMON BLOCK (INPUT)
C
C N,F  : NUMBER OF PATTERNS AND FEATURES
C KMIN,KMAX : INTERVAL FOR CLUSTER SEARCH
C PB, INIC  : NUMBER OF BOOTSTRAPS AND INICIALIZATIONS
C AM,MAXIT,EPSIL : FUZZY PARAMETERS (SEE FCM PROGRAM)
C A,B  : COEFICIENTS OF PARTITION INDEX (SEE SENTENCE C20)
C METRIC  : SELECT FCM (METRIC=0) OR GKSM
C NCRT  : VECTOR WHERE WE SPECIFY CRITERIA. NCRT(1) IS THE
C         NUMBER OF CRITERIA AND NCRT(2 to 13) ARE NUMBERS
C	  OF CRITERIA
C CRT   : VECTOR WHICH ACCUMULATES THE VALUE OF EACH CRITERIUM
C	  SPECIFIED IN NCRT
C
C-***************************************************************************

        SUBROUTINE M_J(N,JF,R,RD,AREA1,AREA2,AREA3)

        INCLUDE 'CMBLOCK.INC'

	PARAMETER (KX=10,NCT=13)
	INTEGER   AREA1(*)
        REAL      R(KX,NCT),RD(KX),AREA2(*),AREA3(*)

C       THIS COMMON IS ALSO USED BY CALLER (CRTEST.F)
	PARAMETER (NN=999,NF=10,IDIM=4*NN+3*KX)
        COMMON RDUM(80),XB(NN,NF),U(KX,NN),V(KX,NF),
     +         KMIN,KMAX,PB,INIC,AM,MAXIT,EPSIL,A,B,
     +         METRIC,NCRT(NCT),CRT(NCT),AREA1DUM(2*NN),
     +         AREA2DUM(6*NF+NF*NF+500*100),AREA3DUM(IDIM),
     +         RDUM1(KX,NCT),X(NN,NF)

        REAL    RT(NCT)
	INTEGER C,PB,PASO,CONST

        DO  I=1,N
           DO  J=1,JF
              X(I,J)=XB(I,J)
	   ENDDO
	ENDDO

	IWK=KX
	IINW=IWK+KX
	IINM=IINW+KX
	ISI=IINM+KX
	IXT=ISI+KX
	IWE=IXT+KX*KX
	LAB=NN

	CONST=PB*INIC

 	DO  C=KMIN,KMAX
        WRITE (*,*)C

	LM=1
	AREA2(C)=0.
	AREA2(IWK+C)=0.
C	MK(C)=0.
C	WK(C)=0.
	RAL=577+C
	DO  L=2,NCT
	  CRT(L)=0.
	ENDDO

	DO  NBOOT=1,PB

C	GENERAR BOOTSTRAP     (PB - VECES)

	IF (NBOOT.EQ.1) THEN
	  DO  I=1,N
 	   AREA1(I)=I
	  ENDDO
C1	   ALEA(I)=I
	  GOTO 2
	END IF
	CALL RANDOM (RAL,N,AREA1)          
2	DO  I=1,N
	DO  J=1,JF
	 XB(I,J)=X(AREA1(I),J)
	ENDDO
	ENDDO
C3	 XB(I,J)=X(ALEA(I),J)

	DO  K=1,INIC

C	INICIALIZACIONES  (INIC - VECES)

	PASO=K+N/C
	IF (METRIC.EQ.0) THEN

	I=1
	LI=2
	DO  J=1,C
	DO  L=1,JF
	 V(J,L)=X(I,L)
	ENDDO
	I=I+PASO
	IF (I.GT.N) THEN
	 I=LI
	 LI=LI+1
	END IF
	ENDDO
	CALL FCM(N,JF,C,AM,MAXIT,EPSIL,ITER)
	ELSE

	DO  J=1,C
	 RD(J)=1.
	ENDDO
C	ITER=K*PASO
	CALL GKSM (RD,N,JF,C,AM,MAXIT,EPSIL,ITER)

	END IF

C	OTROS CRITERIOS

	IF (NCRT(1).NE.0) 
     +      CALL CRITER(N,C,NCRT,CRT,AREA3)

C	HARD K-MEANS BASADO EN FCM (METRIC=O) OR GK

	DO  I=1,N
	 BMAX=U(1,I)
	 IT=LAB+I
	 AREA1(IT)=1
C	 LABEL(I)=1
	 DO  J=2,C
	  IF (U(J,I).GT.BMAX) THEN
	   AREA1(IT)=J
C	   LABEL(I)=J
	   BMAX=U(J,I) 
	  END IF
	 ENDDO
	ENDDO

C	WITHIN - CLUSTER SCATTER : M

	DO  I=1,N
	IT=LAB+I
	DO  J=1,C
	 IF (AREA1(IT).EQ.J) THEN
C	 IF (LABEL(I).EQ.J) THEN
	  DO  L=1,JF
	   AREA2(C)=AREA2(C)+(XB(I,L)-V(J,L))**2.
	  ENDDO
C7	   MK(C)=MK(C)+(XB(I,L)-V(J,L))*(XB(I,L)-V(J,L))
	 END IF
	ENDDO	
	ENDDO

C	WITHIN AND BETWEEN CLUSTER DISTANCES : W

	DO  J=1,C
	IT=ISI+J
	 AREA2(IT)=0.
C	 SI(J)=0.
	 CI=0.
	 DO  I=1,N
	  IF (AREA1(LAB+I).EQ.J) THEN
C	  IF (LABEL(I).EQ.J) THEN
	   DO  L=1,JF
	     AREA2(IT)=AREA2(IT)+ABS(XB(I,L)-V(J,L))
	   ENDDO
C	    SI(J)=SI(J)+ABS(XB(I,L)-V(J,L))
	   CI=CI+1.
	  END IF
	 ENDDO
         IF (CI.EQ.0) THEN 
                           AREA2 (IT)=0
                      ELSE 
                           AREA2 (IT)= AREA2(IT)/CI
         ENDIF
	ENDDO
C11	 SI(J)=SI(J)/CI
C
C
	DO  J=1,C-1
	JT=(J-1)*KX+IXT
	DO  I=J+1,C
	IT=JT+I
	  AREA2(IT)=0.
C	  T(J,I)=0.
	  DO  L=1,JF
	    AREA2(IT)=AREA2(IT)+(V(J,L)-V(I,L))**2.
	  ENDDO
C12	  T(J,I)=T(J,I)+(V(J,L)-V(I,L))*(V(J,L)-V(I,L))
	  AREA2(IT)=SQRT(AREA2(IT))
C	  T(J,I)=SQRT(T(J,I))
	  IH=(I-1)*KX+IXT
	  JH=IH+J
	  AREA2(JH)=AREA2(IT)
	ENDDO
	ENDDO
C13	  T(I,J)=T(J,I)


	IM=IWE+LM
	DO  J=1,C
	JH=(J-1)*KX+IXT
	IH=ISI+J
	 RI=0.
	 DO  I=1,C
	 JI=JH+I
	 IT=ISI+I
	  IF (I.NE.J) RI=AMAX1(RI,(AREA2(IT)+AREA2(IH))/AREA2(JI))
C	  IF (I.NE.J) RI=AMAX1(RI,(SI(I)+SI(J))/T(J,I))
	 ENDDO
	AREA2(IM)=AREA2(IM)+RI
	ENDDO
C	WE(LM)=WE(LM)+RI
	AREA2(IM)=AREA2(IM)/C
C	WE(LM)=WE(LM)/C	
	IH=IWK+C
	AREA2(IH)=AREA2(IH)+AREA2(IM) 
C	WK(C)=WK(C)+WE(LM)
	LM=LM+1
	ENDDO	
	ENDDO
C       ITERACIONES Y BOOTSTRAP


	IT=IWK+C
	AREA2(IT)=AREA2(IT)/CONST
C	WK(C)=WK(C)/CONST
	DELTA=0.
	DO  LM=1,INT(CONST)
	IH=IWE+LM
	DELTA=DELTA+(AREA2(IH)-AREA2(IT))*(AREA2(IH)-AREA2(IT))
	ENDDO
C17	DELTA=DELTA+(WE(LM)-WK(C))*(WE(LM)-WK(C))
	DELTA=SQRT(DELTA/CONST)
	IT=IINW+C
	AREA2(IT)=2.*DELTA/SQRT(1.*CONST)
C	INW(C)=2.*DELTA/SQRT(1.*CONST)
	AREA2(C)=AREA2(C)/(CONST*N)
C	MK(C)=MK(C)/(CONST*N)

	IF (NCRT(1).NE.0) THEN
	 DO  L=1,NCRT(1)
C200	 R(C,NCRT(L+1))=CRT(L+1)/CONST
	 R(C,NCRT(L+1))=CRT(L+1)
	 ENDDO
	END IF

	ENDDO
C       CLUSTER


	DO  C=KMIN,KMAX-1
	IT=IINM+C
	AREA2(IT)=ABS(AREA2(C+1)-AREA2(C))	
	ENDDO


	DO  C=KMIN,KMAX-1
          IT=IINW+C
          IH=IINM+C
	  R(C,NCT)=A*AREA2(IT)+B*AREA2(IH)
	ENDDO

	RETURN
	END
