C++************************************************************************
C
C $$ MACF_P.FOR
C
C **************************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK            *
C *  COPYRIGHT (C)1981,1987, WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *  THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR       *
C *  LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR    *
C *  USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF     *
C *  THE CENTER FOR LABORATORIES AND RESEARCH   			   *
C **************************************************************************
C
C
C
C--************************************************************************
C
C $$ MACF_P.FOR
C
         SUBROUTINE  MACF_P(LUN1,LUN2,NSAM,NROW,X,LSD,IRA,MODE)
         INCLUDE 'CMBLOCK.INC'
C
         DIMENSION         X(LSD,2*NROW)
         DOUBLE PRECISION  AVE
         CHARACTER*1         MODE
CNO_SAVE
         R=IRA
         NS2=NSAM/2+1
         NR2=NROW/2+1
         DO    J=1,NROW
          CALL  REDLIN(LUN1,X(1,J),NSAM,J)
	 ENDDO
c$doacross local(j,i)
         DO    J=1,2*NROW
         DO    I=NSAM+1,2*NSAM
           X(I,J)=0.0
	 ENDDO	 
	 ENDDO
c$doacross local(j,i)
         DO    J=NROW+1,2*NROW
         DO    I=1,NSAM
           X(I,J)=0.0
	 ENDDO
	 ENDDO
         AVE=0.0
         ILE=0
         DO    J=1,NROW
         A=FLOAT(J-NR2)**2
         DO    I=1,NSAM
         TR=SQRT(FLOAT(I-NS2)**2+A)
         IF(TR.GT.R)  THEN
         X(I,J)=0.0
         ELSE
         AVE=AVE+X(I,J)
         ILE=ILE+1
         ENDIF
	 ENDDO
	 ENDDO
         AVE=AVE/ILE
c$doacross local(j,i,a,tr)
         DO    J=1,NROW
         A=FLOAT(J-NR2)**2
         DO    I=1,NSAM
         TR=SQRT(FLOAT(I-NS2)**2+A)
         IF(TR.LE.R)  X(I,J)=X(I,J)-AVE
	 ENDDO
	 ENDDO 
C     CALL  AUTCOR(X,2*NSAM,2*NROW)
C
         INS=1
         CALL  FMRS_2(X,2*NSAM,2*NROW,INS)
         IF(INS.EQ.0)  THEN
         CALL ERRT(38,'AC MS ',NE)
         RETURN
         ENDIF
         CALL  ACRS_2(X,X,2*NSAM,2*NROW)
C
         IF (MODE .EQ. 'F')  THEN
         NRL=1
         NRU=2*NROW
         NSL=1
         NSU=2*NSAM
         ELSE
         NRL=NR2
         NRU=NROW+NR2-1
         NSL=NS2
         NSU=NSAM+NS2-1
         ENDIF
C
c$doacross local(j,i,qt,a,t,m)
         DO    J=NRL,NRU
         QT=FLOAT(J-(NROW+1))**2
         DO    I=NSL,NSU
         A=SQRT(FLOAT(I-(NSAM+1))**2+QT)/2.0
         IF(A.EQ.0.0)  THEN
         X(I,J)=X(I,J)/NINT(3.1415926*R*R)*ILE
         ELSE
         IF(R.GT.A)  THEN
         T=2.0*ATAN(SQRT((R/A)**2-1.0))
         M=NINT(R*R*(T-SIN(T)))
C
C  NORMALIZATION IS APPLIED TO THESE AC COEFF. WHICH WERE
C  ESTIMATED FROM AT LEAST  5 PIXELS
C  OTHERWISE AC COEFFS. ARE SET TO ZERO.
C
         IF(M.GE.5)  THEN
         X(I,J)=X(I,J)/FLOAT(M)*ILE
         ELSE
         X(I,J)=0.0
         ENDIF
         ELSE
         X(I,J)=0.0
         ENDIF
         ENDIF
	 ENDDO	
	 ENDDO
         IF (MODE .EQ. 'F')  THEN
         DO    J=1,2*NROW
          CALL  WRTLIN(LUN2,X(1,J),2*NSAM,J)
	 ENDDO
         ELSE
         DO    J=NR2,NROW+NR2-1
          CALL  WRTLIN(LUN2,X(NS2,J),NSAM,J-NR2+1)
	 ENDDO
         ENDIF
         END
