
C**************************************************************************
C
C  MAPIM.FOR  -- CREATED OCT 90
C **************************************************************************
C *  AUTHOR: ArDean Leith 
C *  COPYRIGHT (C)1990 , WADSWORTH CENTER FOR LABORATORIES AND RESEARCH    *
C *    NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.              *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH  			   *
C **************************************************************************
C
C      MAPIM(LUNIN,LUNOUT,NSAM,NREC1,NREC2,TABLE,NMAX,BUF,IRTFLG) 
C
C      PURPOSE:  APPLIES A LOOKUP TABLE TO EACH COLUMN OF AN IMAGE 
C                FOR ALL RECORDS FROM NREC1 TO NREC2.  THE 
C                LOOK-UP-TABLE IS A FLOATING POINT TABLE.  IF OLD-
C                VALUE IS 1 THEN NEW-VALUE IS SET TO TABLE(1), ETC.
C                NO ERROR CHECKING IS DONE (TO SAVE TIME) !!!!!!! 
C
C      PARAMETERS:  
C
C      CALLED BY:  CONINT 
C
C      CALLS:      REDLIN      WRTLIN   
C
C23456789012345678901234567890123456789012345678901234567890123456789012
C--*********************************************************************

       SUBROUTINE MAPIM(LUNIN,LUNOUT,NSAM,NREC1,NREC2,TABLE,NMAX,
     &                  BUF,IRTFLG)

       DIMENSION TABLE(*),BUF(*)

C      GO THRU THE STACK SLICE BY SLICE AND MAKE REPLACEMENTS FROM TABLE
         
       DO IREC = NREC1,NREC2
          CALL REDLIN(LUNIN,BUF,NSAM,IREC)

          DO ICOL = 1,NSAM
C            CHECK THIS VOXEL FOR REPLACEMENT
             IT = BUF(ICOL)
             IF (IT .GT. 0)  BUF(ICOL) = TABLE(IT) 
          END DO

          CALL WRTLIN(LUNOUT,BUF,NSAM,IREC)
       END DO

       RETURN
       END
