
#ifdef SP_DISTRIB 
 
C   THIS ROUTINE SPECIFIC TO WADSWORTH LABS AND IS NOT 
C       DISTRIBUTED TO OUTSIDE SITES
 
       SUBROUTINE marker
 
       COMMON /UNITS/LUNC,NIN,NOUT
 
       WRITE(NOUT,*) 'DUMMY CALL: marker'
       RETURN
       END
 
#else
 

C++********************************************************* 9/27/79
C
C  MARKER
C
C--*******************************************************************

	SUBROUTINE MARKER

	COMMON /UNITS/LUN,NIN,NOUT,NECHO,IFOUND,NPROC,NDAT
	COMMON /PARAM/ PARAM(103),NS1,NS2
        COMMON    /BATCH/IBCNT,NLOOP,IABSLP,ILOOP
        INTEGER          IBCNT,NLOOP,IABSLP,ILOOP

	INTEGER X(10),X0(10),Y(10),Y0(10)
	REAL    L(10),A(10),MU,MU1,P(51),LCAP,MU2

	DATA NPHI/51/,PHITST/0.02/,PI/3.14159/,PHIMAX/0.2/
	DATA NITERM/5/

C PHIMAX EQUIVALENT TO +/- 10 DEGREES INITIAL SEARCHING RANGE
	NPAR = 0
	CALL PDATES('*** MARKER',0)
	WRITE(NOUT,9)
9	FORMAT(/' *** ENTER REFERENCE PARTICLE FIRST!'/)
11	FORMAT(/' PARTICLE NUMBER',I2,' :')
10	NPAR = NPAR+1
	WRITE(NOUT,11)(NPAR-1)
	CALL RDPRMI(X0(NPAR),Y0(NPAR),NLOOP,ILOOP,
     $        'NORMAL PROJECTION COOS')
	IF (X0(NPAR).EQ.0.AND.Y0(NPAR).EQ.0)GOTO 50
	CALL RDPRMI(X(NPAR),Y(NPAR),NLOOP,ILOOP,
     $        'TILTED PROJECTION COOS')
	GOTO 10

C COMPUTE RELATIVE COORDINATES WITH RESPECT TO PARTICLE ZERO.  ALSO,
C LENGTHS AND AZIMUTHS.

50	NPAR = NPAR-1
	IF(NDAT.EQ.NOUT)GOTO 59
	WRITE(NDAT,51)
	WRITE(NDAT,52)
51	FORMAT(' ABSOLUTE MARKER COORDINTES ENTERED:'/)
52	FORMAT(' PARTICLE NO.    NORMAL(X,Y)       TILTED(X,Y)',
     1          'LENGTH   ANGLE'/)
	DO 55 I = 1,NPAR
	WRITE(NDAT,56)(I-1),X0(I),Y0(I),X(I),Y(I)
55	CONTINUE
56	FORMAT(I12,4X,2I6,7X,2I6,5X,F7.2,5X,F7.2)
59	IF(NDAT.NE.NOUT)WRITE(NDAT,57)
	IF(NDAT.NE.NOUT)WRITE(NDAT,52)
57	FORMAT(/' RELATIVE MARKER COORDINATES ENTERED :'/)
	DO 60 IPAR=2,NPAR
	X(IPAR) = X(IPAR)-X(1)
	Y(IPAR) = Y(IPAR)-Y(1)
	X0(IPAR) = X0(IPAR)-X0(1)
	Y0(IPAR) = Y0(IPAR)-Y0(1)

	XTEMP = X(IPAR)
	YTEMP = Y(IPAR)

	L(IPAR) = SQRT(XTEMP**2+YTEMP**2)
	A(IPAR) = ATAN2(YTEMP,XTEMP)
	A360 = A(IPAR)*180./PI
  	WRITE(NOUT,56)(IPAR-1),X0(IPAR),Y0(IPAR),X(IPAR),Y(IPAR),
     1      L(IPAR),A360
	IF (NOUT.NE.NDAT)
     1     WRITE(NDAT,56)(IPAR-1),X0(IPAR),Y0(IPAR),X(IPAR),Y(IPAR),
     2 L(IPAR),A360
60	CONTINUE
	C = 1.
	NITER = 1
	PHIPRV = PHIMAX

C COMPUTE VECTOR CROSS PRODUCT

	PHIOFF = 0.
80	PMIN = 1.E20
  	PHIM = PHIMAX/C
	DPHI = 2*PHIM/(NPHI-1)
	WRITE(NDAT,81)
     1     NITER,(-PHIM*180./PI),(PHIM*180./PI),(DPHI*180./PI)
81	FORMAT(' ITERATION NO.',I2,'  SEARCHING RANGE',2F8.4,
     1    '  INCREMENT',F8.4,' DEGREES')
	DO 200 IPHI=1,NPHI
	PHI = -PHIM+(IPHI-1)*DPHI+ PHIOFF
	P(IPHI) = 0.
	MU2 = X0(2)-L(2)*COS(A(2)-PHI)
	XI2 = Y0(2)-L(2)*SIN(A(2)-PHI)
	DO 150 I=3,NPAR
	MU = X0(I)-L(I)*COS(A(I)-PHI)
	XI = Y0(I)-L(I)*SIN(A(I)-PHI)
	P(IPHI) = P(IPHI)+(MU2*XI-XI2*MU)**2
150	CONTINUE
	IF(P(IPHI).GE.PMIN)GOTO 200
	PMIN = P(IPHI)
	IPHIM = IPHI
	PHIMIN = PHI
200	CONTINUE
	CALL GRAPHS(P,NPHI,1)
	PHI360 = PHIMIN*180./PI
	IF(NDAT.NE.NOUT)WRITE(NDAT,201)NITER,PHI360,PMIN
	WRITE(NOUT,201)NITER,PHI360,PMIN
201	FORMAT(' AZIMUTH  AFTER',I2,' ITERATIONS',F7.2,
     1        ' DEGREES.  P = ',G12.2)
	IF(ABS(PHIPRV-PHIMIN).LT.PHITST)GOTO 300
	PHIOFF = PHIMIN
	NITER = NITER+1
	IF(NITER.GT.NITERM)GOTO 500
	PHIPRV = PHIMIN
C IF MINIMUM IS FOUND ON EITHER SIDE OF ANGULAR RANGE, REPEAT
C WITHOUT SCALE EXPANSION IN SHIFTED RANGE.
	IF(IPHIM.EQ.1.OR.IPHIM.EQ.NPHI) GOTO 80
	C = C*FLOAT(NPHI)/4.
	GOTO 80
C  THE OPTIMUM ROTATION OF THE TILTED MICROGRAPH WITH RESPECT TO
C   THE NORMAL  IS PHIMIN
C    NNOW CALCULATE ASMUTH AND TILT(THATA)
300	CONTINUE
	ASMUTH=0.
	DO 350 I=2,NPAR
	XTMP=X(I)
	X0TMP=X0(I)
	YTMP=Y(I)
	Y0TMP=Y0(I)
	AI=ATAN2(YTMP,XTMP)
	LT=SQRT(XTMP*XTMP+YTMP*YTMP)
C   ROTATE TILTED MICROGRAPH
	XTMP=LT*COS(AI+PHIMIN)
	YTMP=LT*SIN(AI+PHI)
	ASMU=-ATAN((X0TMP-XTMP)/(Y0TMP-YTMP))
	TASMU=ASMU*180./3.14159
	WRITE(NOUT,390)I,TASMU
390	FORMAT('       I=',I3,'  ASMUTH(I)' ,G12.3)
	ASMUTH=ASMUTH+ASMU
350	CONTINUE
	ASMUTH=ASMUTH/(NPAR-1)
	TAS=ASMUTH*180./3.151459
C    CALCULATE TILT BASE ON THE AVERAGE ASMUTH
	THATA=0.
	DO 450 I=2,NPAR
	XTMP=X(I)
	X0TMP=X0(I)
	YTMP=Y(I)
	Y0TMP=Y0(I)
	LT=SQRT(XTMP*XTMP+YTMP*YTMP)
	LN=SQRT(X0TMP*X0TMP+Y0TMP*Y0TMP)
	FNUM=LT*SIN(ATAN2(YTMP,XTMP)-ASMUTH)
	FDOM=LN*SIN(ATAN2(Y0TMP,X0TMP)-ASMUTH)
	ARCCOS=0.
	IF(ABS(FDOM).LT.ABS(FNUM))GO TO 430
C CALL ARCTRG(FNUM/FDOM,ARCSIN,ARCCOS,IERR) !ARCTRG REPLACED BY NAIK 10/2/86
        ARCCOS = ACOS(FNUM/FDOM)
430	THA=ARCCOS*180./3.1514159

	WRITE(NOUT,490)I,TAS,THA,FNUM,FDOM,XTMP,YTMP,X0TMP,Y0TMP
490	FORMAT('  I,ASMUTH,THATA(I):',2G12.3,I3,/,
     1         '    FNUM,FDOM,XTMP,YTMP,X0TMP,Y0TMP:',6(2X,G12.3))

	THATA=THATA+ARCCOS
450	CONTINUE
	THATA=THATA/(NPAR-1)
	PARAM(NS1)=ASMUTH
	PARAM(NS2)=THATA
	THATST=THATA*180./3.14159
	WRITE(NOUT,590)ASMUTH,THATST
590	FORMAT('       ASMUTH,THATA:',2(3X,G12.3))
	RETURN
500	CONTINUE
	WRITE(NOUT,501)NITERM
	WRITE(NDAT,501)NITERM
501	FORMAT(' *** ERROR .. CAN T FIND MINIMUM IN ',I2,' TRYS')

	RETURN
	END
 
#endif
 
