 
C++********************************************************************
C
C  MASK.FOR
C
C **************************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK            *
C *  COPYRIGHT (C)1981 , DIVISION OF LABORATORIES AND                      *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE DIVISION OF    *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE DIVISION OF LABORATORIES AND RESEARCH			   *
C **************************************************************************
C
C   MASK(LUNI,LUNO,NSAM,NROW,B)
C
C   PARAMETERS:
C        LUNI               LOGICAL UNIT NUMBER OF INPUT FILE
C        LUNO               LOGICAL UNIT NUMBER OF OUTPUT FILE
C        NSAM,NROW,NSLICE   DIMENSIONS OF FILE
C        B		    AVERAGE OF INPUT FILE
C
C--********************************************************************

        SUBROUTINE MASK(LUNI,LUNO,NSAM,NROW,NSLICE,B)

        INCLUDE 'CMBLOCK.INC' 
CNO_SAVE

        COMMON           BUF(1)

        CHARACTER * 1    ANS1,NULL,ANS
	DOUBLE PRECISION DAV,AVC

1      IF (FCHAR(4:4) .EQ. 'L') THEN
C        MASK A LINE ACROSS IMAGE
         IF (NSLICE .GT. 1) THEN
C           3-D FILE
            CALL RDPRMI(NSLICER,NDUM,NLOOP,ILOOP,'ENTER SLICE NUMBER')
         ELSE
            NSLICER = 1
         ENDIF

         CALL RDPRMI(NROWR,NDUM,NLOOP,ILOOP,
     &        'ENTER LINE NUMBER TO BE MASKED')

	 CALL RDPRM(B,NLOOP,ILOOP,'ENTER BACKGROUND')
         IRECT = (NSLICER - 1) * NROW + NROWR

         DO I = 1,NROW*NSLICE
            CALL REDLIN(LUNI,BUF,NSAM,I)
            IF (I .EQ. IRECT) THEN
               DO J = 1,NSAM
                 BUF(J) = B
               ENDDO
            ENDIF
            CALL WRTLIN(LUNO,BUF,NSAM,I)
         ENDDO
               
C        TELL LABEL THAT FMIN & FMAX ARE NOT CALCULATED YET
         CALL SETPRM(LUNO,NSAM,NROW,0.0,0.0,0.0,'U')

         RETURN          

      ELSE
         RAD  = 0.0
         RADI = 0.0
         CALL RDPRM2S(RAD,RADI,NLOOP,ILOOP,'OUTER & INNER RADII',IRTFLG)
         IF (IRTFLG .NE. 0) RETURN
C        FOR INNER ONLY MASKING, SET OUTER RADIUS TO HUSGE VALUE
         IF (RAD .EQ. 0) RAD = NSAM * 20
      ENDIF

        CALL RDPRMC(ANS1,NCHAR,.TRUE.,
     &     '(D)ISK, (G)AUSSIAN EDGE, OR (T)RUE GAUSSIAN',
     &     NULL,IRTFLG)
        IF (IRTFLG .NE. 0) GOTO 1


C       BACKGROUND CHOICES:

C	DAV	BACKGROUND IS SET EQUAL TO THE AVERAGE OF THE
C		IMAGE BEFORE MASKING
C	PREC AV	BACKGROUND IS SET EQUAL TO THE AVERAGE OF THE
C		IMAGE AREA PASSED BY THE MASK
C	CIRCUMF	BACKGROUND IS SET EQUAL TO THE AVERAGE OF THE 
C		PIXELS ALONG THE MASK'S CIRCUMFERENCE
C	EXTERNAL  BACKGROUND IS SET TO A VALUE SUPPLIED EXTERNALLY

	CALL RDPRMC(ANS,NCHAR,.TRUE.,
     &   '(A)V, (P)REC AV, (C)IRCUMF, OR (E)XTERNAL',NULL,IRTFLG)

	IF (ANS .EQ. 'E') CALL RDPRM(B,NLOOP,ILOOP,'ENTER BACKGROUND')

        CALL RDPRMI(NSAMR,NROWR,NLOOP,ILOOP,
     &              'MASK CENTER COOS (NSAM, NROW)')
        IF (NSLICE .GT. 1) THEN
           CALL RDPRMI(NSLICER,NDUMP,NLOOP,ILOOP,
     &                 'MASK CENTER COOS (NSLICE)')
        ELSE
           NSLICER = 1
	ENDIF

C       ALTHOUGH THE MASK CENTER COORDINATES MAY BE OUTSIDE THE IMAGE
C       ITSELF, CHECK TO BE SURE THAT THE RADIUS IS LARGE ENOUGH SO
C       THAT THE MASK WILL AT LEAST HAVE AN EFFECT ON THE IMAGE.
C       (APPLIES ONLY TO EXCLUSIVE OUTSIDE MASKING)

        IF (RAD .GT. 0) THEN
C          POSITIVE OUTER RADIUS GIVEN
           CKSAM1 = NSAMR + RAD
	   IF (CKSAM1  .LT. 0.0) GOTO 60
	   CKSAM2 = NSAMR - RAD - NSAM
	   IF (CKSAM2  .GE. 0.0) GOTO 60
	   CKROW1 = NROWR+RAD
	   IF (CKROW1  .LT. 0.0) GOTO 60
	   CKROW2 = NROWR - RAD - NROW
	   IF (CKROW2  .GE. 0.0) GOTO 60
	   CKSLIC1 = NSLICER + RAD
	   IF (CKSLIC1 .LT. 0.0) GOTO 60
	   CKSLIC2 = NSLICER - RAD-NSLICE
	   IF (CKSLIC2 .GE. 0.0) GOTO 60

        ELSEIF (RAD .LE. 0.0) THEN
C          FOR INNER ONLY MASKING, SET OUTER RADIUS TO HUGE VALUE
           RAD = NSAM * 20
        ENDIF

        RAD2  = RAD**2
        RADI2 = RADI**2
	RAD2P = (RAD+1)**2

C       RAD2P IS USED TO DEFINE A NON-EMPTY SET OF POINTS
C       ALONG THE MASK'S CIRCUMFERENCE

        IF (ANS .EQ. 'P' .OR. ANS .EQ. 'C') THEN
C          "P" OR "C" OPTION
           DAV   = 0.0
	   FNAV  = 0.0
	   AVC   = 0.0
	   FNAVC = 0.0
           DO  J = 1,NSLICE
             FI2 = FLOAT(J-NSLICER)**2
             DO  I = 1,NROW
               FI1 = FLOAT(I-NROWR)**2+FI2
               CALL REDLIN(LUNI,BUF,NSAM,I+(J-1)*NROW)
               DO  K = 1,NSAM
                 CRAD2 = FI1 + FLOAT(K-NSAMR)**2
                 IF (CRAD2 .LE. RAD2 .AND. CRAD2 .GE. RADI2) THEN
                   DAV  = DAV + BUF(K)
                   FNAV = FNAV + 1.0
                 ENDIF

C                PROVISION FOR CIRCUMFERENCE OPTION

                 IF (ANS .EQ. 'C' .AND. 
     &              CRAD2 .GE. RAD2 .AND. CRAD2 .LE. RAD2P) THEN
                    AVC   = AVC + BUF(K)
                    FNAVC = FNAVC + 1.0
                 ENDIF
	       ENDDO
	    ENDDO
	  ENDDO

           DAV = DAV / FNAV
	   B   = DAV
	   IF (ANS .EQ. 'C')THEN
              B = AVC / FNAVC
              WRITE(NOUT,21) B
21            FORMAT(' AVERAGE ALONG CIRCUMFERENCE ',G12.4)
	   ENDIF
        ENDIF

C       GAUSSIAN OR STRAIGHT CUTOFF (DISK) ...

        IF (ANS1 .NE. 'G' .AND. ANS1 .NE. 'T') THEN
C          DISK MASKING

           DO  J = 1,NSLICE
             FI2 = FLOAT(J-NSLICER)**2
             DO  I = 1,NROW
               FI1 = FLOAT(I-NROWR)**2+FI2
               CALL REDLIN(LUNI,BUF,NSAM,I+(J-1)*NROW)
               DO  K = 1,NSAM
                 CRAD2 = FI1 + FLOAT(K-NSAMR)**2
                 IF (CRAD2.GT.RAD2.OR.CRAD2.LT.RADI2) BUF(K) = B
               ENDDO
               CALL WRTLIN(LUNO,BUF,NSAM,I+(J-1)*NROW)
	     ENDDO
	   ENDDO

        ELSE IF (ANS1 .EQ. 'G' ) THEN
C          GAUSSIAN EDGE MASKING

80         IF (NSLICE .GT. 1)  THEN
              WRITE(NOUT,*) '*** Sorry, option not supported for 3-D'
              CALL ERRT(100,'MASK',IER)
              RETURN
	   ENDIF

	   CALL RDPRM(HW,NLOOP,ILOOP,'HALFWIDTH')
	   SWITCHY = 1.0
	   SWITCHX = 1.0
	   IF (FCHAR(4:4) .EQ. 'X') SWITCHX = 0.0
           IF (FCHAR(4:4) .EQ. 'Y') SWITCHY = 0.0
           HW = -1./(HW**2)
           DO  I = 1,NROW
              FI1 = FLOAT(I-NROWR)**2 *SWITCHX
              CALL REDLIN(LUNI,BUF,NSAM,I)
              DO 90 K = 1,NSAM
                 CRAD2 = FI1 + SWITCHY*FLOAT(K-NSAMR)**2
                 IF (CRAD2.LE.RAD2.AND.CRAD2.GE.RADI2) GOTO 90
                 SRAD2  = SQRT(CRAD2)
                 BUF(K) = B+(BUF(K)-B)*(EXP(HW*(SRAD2-RAD)**2)
     &			    +EXP(HW*(SRAD2-RADI)**2))
90           CONTINUE
             CALL WRTLIN(LUNO,BUF,NSAM,I)
	   ENDDO

        ELSE IF (ANS1 .EQ. 'T' ) THEN
C          TRUE GAUSSIAN MASKING

200        HW =-1.0 / (RAD**2)
           DO  J = 1,NSLICE
             FI2 = FLOAT(J-NSLICER)**2
             DO  I = 1,NROW
               FI1 = FLOAT(I-NROWR)**2+FI2
               CALL REDLIN(LUNI,BUF,NSAM,I+(J-1)*NROW)
               DO K=1,NSAM
                 CRAD2  = FI1+FLOAT(K-NSAMR)**2
                 BUF(K) = B+(BUF(K)-B)*EXP(HW*CRAD2)
               ENDDO
	   CALL WRTLIN(LUNO,BUF,NSAM,I+(J-1)*NROW)
	     ENDDO
	   ENDDO
        ENDIF

C       SET FILE STATISTICS TO BE UNDETERMINED
        CALL SETPRM(LUNO,NSAM,NROW,0.0,0.0,0.0,'U')
        RETURN


60	WRITE(NOUT,61)
61	FORMAT(' *** MASK OUTSIDE IMAGE; NO ACTION TAKEN')
	RETURN
        END

