C++**********************************************************************
C
C MASKMU.FOR
C
C **************************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK            *
C *  COPYRIGHT (C)1981,1987, WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH 			   *
C **************************************************************************
C
C  JMC, 10/30/86 CHANGED TO ACCEPT 3-D FILES
C
C  MASKMU:
C
C  PARAMETERS:     LUN1 LOGICAL UNIT NUMBER OF MASK
C                  LUN2 LOGICAL UNIT NUMBER OF IMAGE TO BE MASKED
C
C-**************************************************************************

	SUBROUTINE MASKMU(LUN1,LUN2,NSAM,NROW,NSLICE)

	COMMON   BUF(1)
	INCLUDE 'CMBLOCK.INC' 
CNO_SAVE
        NTOTAL=NROW*NSLICE

	IF (FCHAR(4:4) .EQ. 'C') GOTO 150

	CALL RDPRM(BACK,NLOOP,ILOOP,'ENTER BACKGROUND')

	DO  I =1,NTOTAL
      	   CALL REDLIN(LUN1,BUF,NSAM,I)
	   CALL REDLIN(LUN2,BUF(NSAM+1),NSAM,I)
	   DO  K=1,NSAM
	      IF (BUF(K) .LT. 0.5) BUF(NSAM+K)=BACK
           ENDDO
	   CALL WRTLIN(LUN2,BUF(NSAM+1),NSAM,I)
        ENDDO
	RETURN

C       OPTION FOR CONTINUOUS-VALUED MASKS ('MM C')

150	IF (IMAMI.NE.1) THEN
          CALL NORM3 (LUN2,NSAM,NROW,NSLICE,FMAX,FMIN,AV)      
        ENDIF

	DO I=1,NTOTAL
           CALL REDLIN(LUN1,BUF,NSAM,I)
	   CALL REDLIN(LUN2,BUF(NSAM+1),NSAM,I)
	   DO    K=1,NSAM
  	      BUF(NSAM+K)=(BUF(NSAM+K)-AV)*BUF(K) + AV
           ENDDO
           CALL WRTLIN(LUN2,BUF(NSAM+1),NSAM,I)
        ENDDO

	RETURN
	END
