
C++*************************************************************************
C
C $$ MENULU.FOR                         
C                                   REWRITTEN JUNE 90 al
C **************************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK            *
C *  COPYRIGHT (C)1981,1987, WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH 			   *
C **************************************************************************
C
C  $$ MENULU(FUNC,N,STRING,NST)
C
C     PURPOSE:        IF OERATION TRACE IS TURNED ON THIS ROUTINE ECHOES THE
C                     HEADER LINE FROM THE MANUAL CHAPTER FOR EACH
C                     COMMAND WHEN THE OPERATION IS USED.
C
C     PARAMETERS:     FUNC        OPERATION
C                                 (INPUT TO MENULU)
C                     N           NUMBER OF CHARS. IN FUNC
C                                 (INPUT TO MENULU)
C                     STRING      HEADING LINE FROM "FUNC.MAN"
C                                 (RETURNED BY MENULU)
C                     NST         NUMBER OF CHARACTERS IN HEADING LINE
C                                 (RETURNED BY MENULU)
C
C--*******************************************************************


	SUBROUTINE MENULU(FUNC,N,STRING,NST)

        CHARACTER *(*) FUNC,STRING
	CHARACTER *80  UPFUNC
	INTEGER        N
        CHARACTER *81  FILNAM
        CHARACTER *10  FILN
        CHARACTER *4   EXT
        CHARACTER      NULL

	LOGICAL        EX

	DATA FILN/'SPMAN_DIR:'/
	DATA EXT/'.MAN'/

        NULL  = CHAR(0)
        NST   = 0
        LINES = 0

	IF (FUNC(N+1:N+1) .NE. ' ') RETURN

C       MAKE A COPY OF THE FUNC STRING THAT WE CAN CONVERT TO UPCASE
C       DON'T WANT TO CHANGE THE ORIGINAL AND CONFUSE CALLER.
	UPFUNC(1:N) = FUNC(1:N)
	CALL SSUPCAS(UPFUNC)

        FILNAM = FILN // UPFUNC(1:N) // EXT // NULL
	INQUIRE(FILE=FILNAM,EXIST=EX,ERR=999)

	IF (EX) THEN
           OPEN(FILE=FILNAM,UNIT=10,STATUS='OLD',ERR=999)
15         READ(10,20,ERR=999) STRING
20	   FORMAT(A80)
           LINES = LINES + 1
           LENS = LEN(STRING)
           IF (LENS .LE. 0) RETURN
           DO  I = LENS, 1, -1
             IF (STRING .NE. ' ' .AND. STRING(I:I) .NE. NULL) THEN
                NST = I
                RETURN
             ENDIF
	   ENDDO
           IF (LINES .LT. 10) GOTO 15
           CLOSE(10)
        ENDIF

999     RETURN
	END


