      SUBROUTINE MIRQBXS(A,LUN,RO,IR,FR,IP,IKONT)
C      SIMPLE BACKPROJECTION 
C
C      JULY , 1980, M.RADERMACHER
C
C     M.RADERMACHER,W.HOPPE PROC.INT.CONGR.EL.MICR.TORONTO 1978
C     VOL.1,P218-219; EUROP.CONGR.EL.MICR.1980,VOL1,132-133.
C
      IMPLICIT INTEGER (D)
C     SUMMATION EINER PROJEKTION IN SCHICHT IZ
      DIMENSION PH(2,2),IND(2,2),FR(1),IR(1),IP(1),RO(1),A(1)
	COMMON /UNITS/LUNC,NIN,NOUT,NECHO,IFOUND,NPROC,NDAT
C---------------------------------------------------------------------
C     BEDEUTUNG DER VARIABLEN:
C     RO    SCHICHT DER ZU REKONSTRUIERENDEN OBJEKTVERTEILUNG
C     PH    HILFSMATRIX ZUR INTERPOLATION DER PROJEKTIONSWERTE
C     IND   INDEXVEKTOR ZU PH
C     DRX,DRY,DRZ   DIMENSIONEN DER OBJEKTVERTEILUNG
C     DPX,DPY       DIMENSIONEN DER PROJEKTION
C     XEP,YEP       EINHEITEN DER PROJEKTION
C     XE,YE,ZE      EINHEITEN DER OBJEKTVERTEILUNG
C     IZ            SCHICHTNUMMER
C     GAM           KEGELOEFFNUNGSWINKEL
C     PHI           AZIMUTWINKEL
C______________________________________________________________________
C
C     VERWENDETE DREHMATRIX (GLEICHE WIE IN RHPROJ):
C     COS(GAM)COS(PHI)  COS(GAM) SIN(PHI) -SIN(GAM)
C    -SIN(PHI)          COS(PHI)                0
C
C_______________________________________________________________________
      IF (IKONT.NE.0) WRITE(NDAT,3001)(IR(J),J=1,10),
     $(FR(J),J=1,10),(IP(J),J=1,10)
C OBJEKTDATEN:
C DIMENSIONS:
      DRX=IR(1)
      DRY=IR(2)
      DRZ=IR(3)
C SAMPLING UNIT RELATIVE TO PROJECTION SAMPLING UNIT (DEF.=1)
      IF (FR(1).EQ.0.) FR(1)=1.
      XE=1/FR(1)
      YE=1/FR(1)
      ZE=1/FR(1)
      IA=IR(4)
       IE=IR(5)
      ISTEP=IR(6)

C PROJEKTIONSDATEN:
C DIMENSIONS:
      DPX=IP(1)
      DPY=IP(2)
C TILT ANGLES:
      GAM1=FR(4)
      PHI1=FR(5)
C SAMPLING UNIT:
      XEP=1
      YEP=1
C IDRUCK AND IKONT ARE PARAMETERS TO GUIDE CONTROL OUTPUT
      IDRUCK=0
      PI=3.14159265
      PHI=PHI1*PI/180
      GAM=GAM1*PI/180
C CALCULATE CENTER OF 3D VOLUME AND PROJECTIONS:
      DXR=DRX/2+1
      DYR=DRY/2+1
      DZR=DRZ/2+1
      DXP=DPX/2+1
      DYP=DPY/2+1
      CPHI=COS(PHI)
      SPHI=SIN(PHI)
      CGAM=COS(GAM)
      SGAM=SIN(GAM)
      IF(IKONT.EQ.1) WRITE(NDAT,140) CPHI,SPHI,CGAM,SGAM
C*****BERECHNUNG DES PROJEKTIONSPUNKTES (LL,MM) ZUM OBJEKTPUNKT (I,K,IZ)
      IS0=DRY
      WRITE(NDAT,100) IA,IE,ISTEP,DRX,DRY,DRZ,XE,YE,ZE,DPX,DPY,XEP,
     $YEP,GAM1,PHI1,FR(1)
       DO  IZ=IA,IE,ISTEP
      IF((IZ.GT.1).AND.IKONT.NE.1.OR.(PHI.LT.0..OR.PHI.GT.30.))
     $  IDRUCK=1
200    CONTINUE
      IF(IZ.EQ.IA.OR.IZ.EQ.IE) WRITE (NDAT,120) IS,IRED,IZ,GAM1,PHI1
      IS=(IZ-1)*IS0
      DO  I=1,DRY
      IRED=IS+I
      DO  J=1,DRX
        RO(J)=0.
      ENDDO
      CALL REDLIN(LUN,RO,DRX,IRED)
      DO  K=1,DRX
      RX=(K-DXR)*CGAM*CPHI*XE/XEP+(I-DYR)*YE/XEP*CGAM*SPHI-(IZ-DZR)*ZE
     $/XEP*SGAM
      RX=RX+DXP
      RY=-(K-DXR)*XE/YEP*SPHI+(I-DYR)*CPHI*YE/YEP
      RY=RY+DYP
      LL=INT(RX)
      MM=INT(RY)
C*****INDEXBERECHNUNG DER INTERPOLATIONSPUNKTE
      XD=(RX-LL)/XEP
      YD=(RY-MM)/YEP
C*****PRUEFUNG OB PUNKT AUF PROJEKTION
C     PUNKT AUSSERHALB DER PROJEKTION?
      IF((LL.LT.1).OR.(MM.LT.1).OR.(LL.GT.DPX).OR.(MM.GT.DPY)) GOTO 50
C***** MM LETZTE ZEILE DES FELDES?
C_______________________________________________________________________
      IF(MM.EQ.DPY)YD=0.
C*****  INTERPOLATION
      IND(1,1)=(MM-1)*DPX+LL
      IND(1,2)=(MM-1)*DPX+LL+1
      IND(2,1)=MM*DPX+LL
      IND(2,2)=MM*DPX+LL+1
11    PH(1,1)=A(IND(1,1))
      PH(1,2)=A(IND(1,2))
      IF(MM.EQ.DPY) GOTO 1002
      PH(2,1)=A(IND(2,1))
      PH(2,2)=A(IND(2,2))
1002  IF(MM.LT.DPY) GOTO 1003
      PH(2,1)=0.
      PH(2,2)=0.
1003  XIN1=PH(1,1)+(PH(1,2)-PH(1,1))*XD
      XIN2=PH(2,1)+(PH(2,2)-PH(2,1))*XD
 22   YIN=XIN1+(XIN2-XIN1)*YD
C*****OBJEKTPUNKTBERECHNUNG
      IDX=(I-1)*DRX+K+IS0
      RO(K)=RO(K)+YIN
      IF(IKONT.GT.1) WRITE(NDAT,3000)RX,LL,XD,RY,MM,YD,IND,PH,YIN,IDX,K
      GOTO 60
50    CONTINUE
110   FORMAT(' SUBSCRIPT OUTSIDE RANGE LL=',I4,' MM=',I4,2(' ',F7.3))
60    CONTINUE
      ENDDO
      CALL WRTLIN(LUN,RO,DRX,IRED)
      ENDDO
      ENDDO
1000  CONTINUE
3001  FORMAT(' MIRQBXS DATA:'/1X,'OBJECT IR:',10I4,/1X,'FR:',10F12.3/
     $1X,'PROJECTION',' IP:',10I4)
100   FORMAT('  RECONSTRUCTION SLICE',I4,' TO',I4,' STEP',I4/1X,
     $'OBJECT DATA'/1X,
     $'DIMENSIONS:',10X,'X:',I4,10X,'Y:',I4,10X,'Z:',I4/18X,'DELTAX:',
     $E11.4,12X,'DELTAY:',E11.4,12X,'DELTAZ:',E11.4,/1X,
     $'PROJECTION DATA'
     $/1X,'DIMENSIONS:',10X,'X:',I4,10X,'Y:',I4,10X,'DELTAX:',E11.4,
     $10X,'DELTAY:',E11.4/1X,'ANGLE:',10X,'GAMMA:',E11.4,10X,'PHI:',
     $E11.4,/1X,'ENLARGEMENT:',E11.4)
140   FORMAT(' PHI: COS ',E11.4,'  SIN ',E11.4/1X,' GAMMA COS ',E11.4
     $,'  SIN ',E11.4)
3000  FORMAT(' RX=',E11.4,' LL=',I4,'  XD=',E11.4/1X,' RY=',E11.4,
     $' MM=',I4,'  YD=',E11.4/' INDEXVEKTOR:'/1X,4I5/' HILFSVEKTOR:'/
     $1X,4E11.4/1X,'  YIN=',E11.4,5X,'INDX=',I5,5X,'K=',I5)
120   FORMAT(' ',2I8,'  SLICE:',I4,
     $'  THETA:',F8.2,'  PHI:',F8.2,' DEGREE')
      RETURN
      END
