C ++********************************************************************
C
C **********************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.    AUTHOR: J.FRANK      *
C *  COPYRIGHT (C)1985, 1996 HEALTH RESEARCH INCORPORATED, ALBANY, NY. *
C * THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO HEALTH            *
C * RESEARCH INC. AND ARE NOT TO BE DISCLOSED TO OTHERS OR USED        *
C * FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF       *
C * HEALTH RESEARCH INC.                                               *
C **********************************************************************
C
C SUBROUTINE MLINE TO CREATE A LINE DEFINED BY TWO END POINTS
C
C	MLINE(LUN,NSAM,NROW,RP)
C
C	LUN	  : LOGICAL UNIT NUMBER
C	NSAM,NROW : FILE DIMENSIONS
C	RP	  : VALUE TO BE CORRECTED
C
C****************************************************************************

	SUBROUTINE MLINE(LUN,NSAM,NROW,RP)

	INCLUDE 'CMBLOCK.INC' 

	COMMON BUF(1)

	CALL RDPRMI(IX1,IY1,NLOOP,ILOOP,
     &             'ENTER COORDINATES OF FIRST  POINT')
	CALL RDPRMI(IX2,IY2,NLOOP,ILOOP,
     &             'ENTER COORDINATES OF SECOND POINT')

	IF (IY1 .LE. IY2) GOTO 11

	IG=IX1
	IX1=IX2
	IX2=IG
	IG=IY1
	IY1=IY2
	IY2=IG

11	CONTINUE
	ISTART=MAX0(1,IY1)
	IEND=MIN0(NROW,IY2)
	IF(ISTART.GT.NROW.OR.IEND.LE.0) GOTO 9000

	IF (IY1.EQ.IY2) GOTO 200

	DO 20 I=ISTART,IEND
	IF(IX1.GT.IX2) GOTO 21

	IX0=IX1 + IFIX( (FLOAT(IX2-IX1)/FLOAT(IY2-IY1))*FLOAT(I-IY1)+0.5 )
	GOTO 22
21	IX0=IX1 + IFIX( (FLOAT(IX2-IX1)/FLOAT(IY2-IY1))*FLOAT(I-IY1)-0.5 )
22	CONTINUE
	IF(IX0.LE.0.OR.IX0.GT.NSAM) GOTO 20

	CALL REDLIN(LUN,BUF,NSAM,I)
	BUF(IX0)=RP
	CALL WRTLIN(LUN,BUF,NSAM,I)
20	CONTINUE
	RETURN

200	CONTINUE
	IF(IX1.LE.IX2) GOTO 201
	IG=IX1
	IX1=IX2
	IX2=IG
201	CONTINUE

	ISTART=MAX0(1,IX1)
	IEND=MIN0(NSAM,IX2)
	IF(ISTART.GT.NSAM.OR.IEND.LE.0) GOTO 9000

	CALL REDLIN(LUN,BUF,NSAM,IY1)
	DO  I=ISTART,IEND
	BUF(I) = RP
	ENDDO
	CALL WRTLIN(LUN,BUF,NSAM,IY1)

	RETURN

9000	CALL ERRT(14,'MLINE ',NF)
	RETURN
	END
