
C++************************************************************************
C
C MODEL3.F                         FILENAMES LENGTHENED DEC 7 88 al
C                                  CHAR. VARIABLES AUG 89 al
C                                  REWRITTEN APIRL 97 al
C **************************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK            *
C *  COPYRIGHT (C)1981,1987, WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH 			   *
C **************************************************************************
C
C    MODEL3(LUN1,NDOC,FILNAM,NSAM,NROW,NSLICE)
C
C    PURPOSE:   PREPARES 3-D MODEL DENSITY DISTRIBUTIONS
C
C    PARAMETERS:       LUN1        LOGICAL UNIT NUMBER OF VOLUME FILE
C                      NDOC        LOGICAL UNIT NUMBER OF DOCUMENT FILE
C                      FILNAM      NAME OF VOLUME FILE
C                      NSAM,NROW,NSLICE   DIMENSIONS OF FILE
C
C UPDATED 9/17/85 J.F. 2/9/88 DOCUMENT FILE OPTION
C
C23456789012345678901234567890123456789012345678901234567890123456789012
C--********************************************************************

	SUBROUTINE MODEL3(LUN1,NDOC,FILNAM,NSAM,NROW,NSLICE)

        INCLUDE 'CMBLOCK.INC'
CNO_SAVE

	PARAMETER (MAXSIN=50)
	PARAMETER (MAXSPH=300)
        REAL FWA(4)

        COMMON /COMMUN/ADUM(80),DOCNAM

	COMMON  NX(MAXSIN),NY(MAXSIN),CX(MAXSIN), NZ(MAXSIN),
     &   ZZ(MAXSPH),YY(MAXSPH),XX(MAXSPH),FL2(MAXSPH),FL22(MAXSPH),
     &   RAD1(MAXSPH), RAD2(MAXSPH), RAD12(MAXSPH), RAD22(MAXSPH),
     &   DENS(MAXSPH), A0(2048)

        INTEGER*2      ITIMN(5)
        CHARACTER*10   CITIMN
        EQUIVALENCE    (ITIMN,CITIMN)

	LOGICAL        LDOC,GETOLD,GFLAG
        CHARACTER *(*) FILNAM
        CHARACTER *81  DOCNAM
        CHARACTER *4   ANS
        CHARACTER *1   NULL,GA,YN

	DATA TWOPI/6.283184/,AMIN/-10E30/,AMAX/10E30/
      
        NULL = CHAR(0)

	XOFF = 0.
	YOFF = 0.
	ZOFF = 0.

       WRITE(NOUT,100)
 100   FORMAT(
     &      ' .MENU: (B)LANK    -- CONSTANT DENSITY VOLUME'/
     &      '        (C)YLINDER -- SET OF CYLINDERS'/
     &      '        (H)ELIX    -- HELIX OF SPHERES'/
     &      '        (HA)       -- HELIX OF SPHERES, ADD DENSITIES'/
     &      '        (NUM)BERS  -- LINE NUMBERS'/
     &      '        (Q)UICK    -- RANDOM UNIFORM STATISTICS'/
     &      '        (R)ANDOM   -- RANDOM UNIFORM STATISTICS'/
     &      '        (S)INE     -- SET OF SINE WAVES'/
     &      '        (SP)HERE   -- SET OF SPHERES'/
     &      '        (SPA)      -- SET OF SPHERES, ADD DENSITIES'/
     &      '        (SPV)      -- SET OF SPHERES, VARIABLE DENSITIES'/
     &      '        (T)EST     -- 3D SINE WAVE'/
     &      '        (W)EDGE    -- DENSITY WEDGE'/)

	CALL RDPRMC(ANS,NCHAR,.TRUE.,
     $      'B/C/H/HA/NUM/Q/R/S/SP/SPA/SPV/T/W', NULL,IRT)

	CALL CHKINPQ('T,S,SP,SPA,SPV,W,Q,B,H,HA,C,NUM,R$',
     &              ANS(:NCHAR),ICALL)

	GOTO(5500,200,300,2000,2000,2000,1500,3700,4100,2600,2600,
     &       4600,6000,7000) ,ICALL

C TEST & SINE WAVES *************************************** TEST & SINE

  200 NS    = 1
      CX(1) = 1.0
      NX(1) = 2
      NY(1) = 2
      NZ(1) = 2
      GOTO 1100

  300 CALL RDPRMI(NS,IDUM,NLOOP,ILOOP,'NUMBER OF SINE WAVES')
      IF (NS .GT. MAXSIN) THEN
         WRITE(NOUT,400)MAXSIN
  400    FORMAT(' *** BUFFER SPACE RESTRICTED TO ',I3,' SINE WAVES')
         NS = MAXSIN
      ENDIF

      AV = 0.0
      DO I = 1,NS
         NVAL = 4
         CALL RDPRAF(FWA,4,NVAL,AMIN,AMAX,
     $       'REL. AMPL., SPATIAL FREQUENCY(KX,KY,KZ)',NULL,IRTFLG)
         CX(I) = FWA(1)
         NX(I) = FWA(2)
         NY(I) = FWA(3)
         NZ(I) = FWA(4)

  700    FORMAT(F8.2,3I4)
         AV = AV + CX(I)
      ENDDO

      DO  I = 1,NS
         CX(I) = CX(I) * 2.0 / AV
         WRITE(NECHO, 900)I,CX(I),NX(I),NY(I),NZ(I)
  900    FORMAT(1X,I5,F5.2,3I6)
      ENDDO

 1100 CONTINUE

      DO L = 1,NSLICE
         PHASEZ = FLOAT(L-1)*TWOPI/FLOAT(NSLICE)                 
         DO I=1,NROW
           PHASE = FLOAT(I-1)*TWOPI/FLOAT(NROW)
           DO J=1,NSAM
             A0(J) = 0.
             DO K = 1,NS
             A0(J)=CX(K)*SIN(FLOAT(J-1)*TWOPI*FLOAT(NX(K))/FLOAT(NSAM)
     &              +PHASE*FLOAT(NY(K))+PHASEZ*FLOAT(NZ(K)))+A0(J)
             ENDDO
           ENDDO
           CALL WRTLIN(LUN1,A0,NSAM,I+(L-1)*NROW)
        ENDDO
      ENDDO
      RETURN

C WEDGE ********************************************************* WEDGE

 1500  SCF = 2./FLOAT(NROW+NSAM+NSLICE)
       DO  L= 1,NSLICE
         FI = FLOAT(L) *SCF
         DO  I=1,NROW
           FI = FI + SCF*FLOAT(I)
           DO  J = 1,NSAM
             A0(J) = FI + SCF*FLOAT(J)
 	   ENDDO
           CALL WRTLIN(LUN1,A0,NSAM,(L-1)*NROW+I)
 	 ENDDO
       ENDDO

      RETURN

C SPHERES ***************************************************** SPHERES

 2000   GETOLD = .FALSE.
        CALL RDPRMC(YN,NCHAR,.TRUE.,
     &        'GET COORDINATES FROM DOCUMENT FILE (Y/N)',NULL,IRTFLG)
        IF (IRTFLG .EQ. -1) RETURN

        LDOC = .FALSE.
        IF (YN .NE. 'N') THEN
C          USE DOC FILE FOR COORDINATES
           LDOC  = .TRUE.
           NOPEN = 0
           CALL FILERD(DOCNAM,NLET,NULL,'DOCUMENT',IRTFLG)
           IF (IRTFLG .EQ. -1) RETURN
           CALL RDPRMI(NNSPH,IREG,NLOOP,ILOOP,
     &          'NUMBER OF SPHERES, STARTING COL. FOR X,Y,Z')

           NVAL = 3
           CALL RDPRAF(ADUM,3,NVAL,AMIN,AMAX,'X,Y, & Z  OFFSETS',
     &           NULL,IRTFLG)

           XOFF = ADUM(1)
           YOFF = ADUM(2)
           ZOFF = ADUM(3)
	ENDIF


        GETOLD = .FALSE.
        IF (ANS(1:3) .EQ. 'SPV') THEN
C          VARIABLE SPHERE DENSITIES READ FROM DOC FILE
           IDEN = 1
           IF (ANS(4:4) .EQ. 'A') GETOLD = .TRUE.
        ELSE
C          ALL SPHERES WILL HAVE SAME DENSITIES
           IDEN = 0
           CALL RDPRM(AMQ, NLOOP, ILOOP, 
     &        'ENTER MASS VALUE PER VOXEL (DEFAULT = 2.0)')
           IF (AMQ .EQ. 0.0) AMQ = 2.0     
c          DEFAULT VALUE 2.0 
        ENDIF
        NSPH = 0
C       THE DEFAULT COORDINATES OF THE ALL THE SPHERES ARE CENTER.

        DO  L = 1, MAXSPH
           RAD1(L)  = 0.0
           RAD12(L) = 0.0
           RAD2(L)  = 0.0
           RAD22(L) = 0.0
           XX(L) = NSAM/2 + 1
           YY(L) = NROW/2 + 1
           ZZ(L) = NSLICE/2 + 1
        ENDDO
		
 	CALL RDPRM2(RAD2(1),RAD1(1),
     &       NLOOP,ILOOP,'OUTER AND INNER RADII OF SPHERES')

C       CHANGED 10/12/88 MR
C       FIND HOW MANY RADII HAVE TO BE READ FROM DOCUMENT FILE:
	NSPH = 1
        IRAD = 0
        IF (RAD2(1) .LT. 0) IRAD = 1
        IF (RAD1(1) .LT. 0) IRAD = 2

2200	RAD2(NSPH)   = RAD2(1)
	RAD1(NSPH)   = RAD1(1)

C       'SPA' OPTION -- ADD MASSES WHERE SPHERES OVERLAP
C       'SP'  OPTION -- LET SPHERES INTERPENETRATE

	SWITCH = 0.0
	IF (ANS(3:3) .EQ. 'A') SWITCH = 1.0

	IF (LDOC) THEN
           CALL UNSAV(DOCNAM,NOPEN,NDOC,NSPH,CX,IREG+2+IRAD+IDEN,
     &                LERR,1)  
c          SEQUENTIAL READ SPECIFIED FOR DOC FILE
           NOPEN   = 1
           ADUM(1) = CX(IREG)
           ADUM(2) = CX(IREG+1)
           ADUM(3) = CX(IREG+2)
           IF (IRAD.GT.0) RAD2(NSPH) = CX(IREG+3)
           IF (IRAD.GT.1) RAD1(NSPH) = CX(IREG+4)
           IF (IDEN.GT.0) DENS(NSPH) = CX(IREG+3+IRAD)
           WRITE(NOUT,2400)NSPH,(ADUM(K),K=1,3)
	ELSE
	
           NVAL = 3
           CALL RDPRAF(ADUM,3,NVAL,AMIN,AMAX,'X,Y,Z',NULL,IRTFLG)

C*         ALTERED SO DOES NOT ACCEPT LAST 0.0,0.0,0,0 al june 88
           IF (ADUM(1).EQ.0..AND.ADUM(2).EQ.0..AND.ADUM(3).EQ.0.)THEN
              NSPH = NSPH - 1
              IF (NSPH .EQ. 0) RETURN
              GOTO 3000
           ENDIF
           WRITE(NECHO,2400) NSPH,(ADUM(K),K=1,3)
 2400      FORMAT(I4,3F12.6)
	ENDIF

        RAD22(NSPH) = RAD2(NSPH)**2
        RAD12(NSPH) = RAD1(NSPH)**2
	XX(NSPH)    = ADUM(1)+XOFF
	YY(NSPH)    = ADUM(2)+YOFF
	ZZ(NSPH)    = ADUM(3)+ZOFF
 
        IF (ZZ(NSPH)+RAD2(NSPH) .GT. NSLICE .OR.
     1      ZZ(NSPH)-RAD2(NSPH) .LT. 0      .OR.
     2      YY(NSPH)+RAD2(NSPH) .GT. NROW   .OR.
     3      YY(NSPH)-RAD2(NSPH) .LT. 0      .OR.
     4      XX(NSPH)+RAD2(NSPH) .GT. NSAM   .OR.
     5      XX(NSPH)-RAD2(NSPH) .LT. 0)      WRITE(NOUT,2450)NSPH

 2450   FORMAT(' *** SPHERE ',I3,' WILL BE TRUNCATED')
	IF (NSPH.EQ.NNSPH) GOTO 3000       
	IF (NSPH .EQ. MAXSPH) THEN
	   WRITE(NOUT,2500)MAXSPH
 2500	   FORMAT(' ** NUMBER OF SPHERES LIMITED TO',I3)
	   GOTO 3000
	ENDIF
	NSPH = NSPH+1
	GOTO 2200

C SPHERES ARRANGED ON HELIX ********************************** SPHERES

 2600   CONTINUE
        GETOLD = .FALSE.
        CALL RDPRM(AMQ, NLOOP, ILOOP, 
     &      'ENTER MASS VALUE PER VOXEL (DEFAULT = 2.0)')
        IF (AMQ .EQ. 0.0) AMQ = 2.0

        DO L = 1, MAXSPH
           RAD1(L)  = 0.0
           RAD12(L) = 0.0
           RAD2(L)  = 0.0
           RAD22(L) = 0.0
        ENDDO

	CALL RDPRM2(RAD2(1),RHEL,
     1       NLOOP,ILOOP,'SPHERE RADIUS, HELIX RADIUS')
	RAD1(1)=RHEL
        DO  L = 1, MAXSPH
           RAD12(L) = RAD1(1)**2
           RAD22(L) = RAD2(1)**2
        ENDDO
 
	CALL RDPRMI(NSPH,NTURN,NLOOP,ILOOP,'NO. OF SPHERES, NO. OF TURNS')
	DO N=1,NSPH
           XX(N)=NSAM/2+1 + RHEL*COS(TWOPI*FLOAT(N-1)/FLOAT(NTURN))
           YY(N)=FLOAT(N-1)*FLOAT(NROW)/FLOAT(NSPH)
           ZZ(N)=NSLICE/2+1 + RHEL*SIN(TWOPI*FLOAT(N-1)/FLOAT(NTURN))
        ENDDO

 3000 IF (NSPH.EQ.0) NSPH=1
      DO L1 = 1, NSLICE
         DO  N = 1, NSPH
           FL2(N) = (L1-ZZ(N))**2
         ENDDO

         DO L2 = 1, NROW
           DO N  =1, NSPH
              FL22(N) = FL2(N) + (L2-YY(N))**2
           ENDDO

           IF (GETOLD) THEN
C             WANT TO ADD NEW SPERES TO EXISTING FILE
              CALL REDLIN(LUN1,A0,NSAM,(L1-1)*NROW+L2)
           ENDIF

           DO L3 = 1, NSAM
             IF (.NOT. GETOLD) A0(L3) = 0.0

             DO N=1, NSPH
               RAD44 = RAD2(N)**2
               RAD41 = RAD1(N)**2
               IF (IDEN .GT. 0) AMQ = DENS(N)
               XYZ = FL22(N) + (L3-XX(N))**2
               IF (XYZ .GE. RAD41  .AND.  XYZ .LE. RAD44)
     &           A0(L3)= AMQ + A0(L3)*SWITCH    
C                NAIK GENERAL AMQ NOT 2
             ENDDO
           ENDDO
           CALL WRTLIN(LUN1,A0,NSAM,(L1-1)*NROW+L2)
         ENDDO
      ENDDO
      RETURN

C RANDOM DISTRIBUTION ***************************************** RANDOM

 3700 CALL TIME(CITIMN)
      IST   = ITIMN(4)
      KST   = ITIMN(3)
      CALL RDPRMC(GA,NCHAR,.TRUE.,'GAUSSIAN DISTRIBUTION.? (Y/N)',
     &            NULL,IRTFLG)
      IF (IRTFLG .EQ. -1) RETURN
      
      GFLAG = .FALSE.
      IF (GA .EQ. 'Y') THEN
	GFLAG = .TRUE.
	NOR   = MOD(INT(ITIMN(2)),2046)
	CALL RDPRM2(XM,SD,NLOOP,ILOOP,
     &            'MEAN AND STANDARD DEVIATION OF GAUSSIAN DIST.')
      ENDIF

      DO L = 1,NSLICE
        DO I = 1,NROW
          DO K = 1,NSAM
            IF (GFLAG) THEN
               A0(K) = RANN(XM,SD,NOR)
            ELSE
               A0(K) = RAN(IST)
            ENDIF
          ENDDO
          CALL WRTLIN(LUN1,A0,NSAM,I+(L-1)*NROW)
        ENDDO
      ENDDO

      RETURN

C QUICK RANDOM DISTRIBUTION ************************************* QUICK

7000  CALL TIME(CITIMN)
      IST   = ITIMN(4)
      KST   = ITIMN(3)
      GFLAG = .FALSE.

      CALL RDPRMC(GA,NCHAR,.TRUE.,'GAUSSIAN DISTRIBUTION.? (Y/N)',
     &            NULL,IRTFLG)
      IF (IRTFLG .EQ. -1) RETURN
      IF (GA .EQ. 'Y') THEN 
         GFLAG = .TRUE.
         ADD   = 0.0
         WRITE(NOUT,7011)
7011     FORMAT(
     $/,' BY DEFAULT GAUSSIAN DIST. WITH 0 MEAN AND STAND. DEV. 1.'
     $/,' YOU MAY CHANGE THIS BY MULTIPLYING WITH F AND ADDING C:'
     $/,' NEW_VALUE=OLD_VALUE*F+C')

         CALL RDPRM2(ADD,FMUL,NLOOP,ILOOP,'ENTER C, F (DEF=0,1)')
         IF (FMUL .EQ. 0) FMUL=1.
      ELSE
        WRITE(NOUT,7012)
7012    FORMAT(' ENTER SCALING VALUES:  NEW_VALUE = OLD_VALUE * F + C')
        CALL RDPRM2(ADD,FMUL,NLOOP,ILOOP,'ENTER C, F (DEFAULTS = 0,1)')
        IF (FMUL .EQ. 0) FMUL = 1.0
      ENDIF

C     INITIALIZE RANDOM GENERATOR 
      CALL MRAND(OUT,KST,GFLAG,NOUT)

C     WARM UP:
      DO I=1,2000
         CALL GETRAND(OUT)
      ENDDO

      DO L = 1,NSLICE
        DO I = 1,NROW
          DO K = 1,NSAM
            CALL GETRAND(OUT)
            A0(K) = OUT * FMUL + ADD
          ENDDO
          CALL WRTLIN(LUN1,A0,NSAM,I+(L-1)*NROW)
        ENDDO
      ENDDO

      RETURN

C BLANK (CONSTANT DENSITY) ************************************** BLANK

 4100 CALL RDPRM(BACK,NLOOP,ILOOP,'BACKGROUND CONSTANT')
      DO L=1,NSLICE
        DO I=1,NROW
          DO K=1,NSAM
            A0(K) = BACK
          ENDDO
          CALL WRTLIN(LUN1,A0,NSAM,I+(L-1)*NROW)
        ENDDO
      ENDDO

      RETURN

C CYLINDERS (INTERPENETRATING) ****************************** CYLINDERS

C CLEAR VOLUME FIRST (SET VOLUME BACKGROUND)

 4600 CALL RDPRM(BVAL,NLOOP,ILOOP,'VALUE OF VOLUME BACKGROUND')
      DO  K=1,NSAM
        A0(K) = BVAL
      ENDDO

      DO  L=1,NSLICE
        I1=(L-1)*NROW
        DO  I=1,NROW
          CALL WRTLIN(LUN1,A0,NSAM,I1+I)
        ENDDO
      ENDDO

 5000 WRITE(NOUT,*) 'YOU HAVE A CHOICE OF 3 CYLINDER AXES.'
      CALL RDPRMC(YN,NA,.TRUE.,
     &            'CHOOSE X, Y, Z (OR Q TO END CYLINDER ENTRY)',
     $            NULL,IRTFLG)
      IF (YN .NE. 'X' .AND. YN .NE. 'Y' .AND. YN .NE. 'Z') RETURN 

      CALL RDPRM2(RADC,HT,NLOOP,ILOOP,'RADIUS, HEIGHT')
      IF (RADC .EQ. 0.0) RETURN
      IF (HT   .EQ. 0.0) RETURN
      HT = HT / 2.0
      CALL RDPRM2(XH,YH,NLOOP,ILOOP,'X & Y COORDINATES OF CENTER')
      CALL RDPRM2(ZH,VALUE,NLOOP,ILOOP,'Z COORDINATE, DENSITY')

C ****************** CYLINDER AXIS ALONG Y ***********
      IF (YN .EQ. 'Y') THEN 
         NSL1  = ZH-RADC-0.5
         NSL2  = ZH+RADC+0.5
         IF (NSL1.LT.1) NSL1=1
         IF (NSL2.GT.NSLICE) NSL2=NSLICE
         NX1   = XH-RADC-0.5
         NX2   = XH+RADC+0.5
         IF (NX1.LT.1) NX1=1
         IF (NX2.GT.NSAM) NX2=NSAM
         NY1   = YH-HT-0.5
         NY2   = YH+HT+0.5
         IF (NY1.LT.1) NY1=1
         IF (NY2.GT.NROW) NY2=NROW
         RAD44 = RADC**2
         DO L=NSL1,NSL2
           I1 = (L-1)*NROW
           Z2 =( FLOAT(L)-ZH)**2
           DO I=NY1,NY2
             CALL REDLIN(LUN1,A0,NSAM,I+I1)
             DO K=NX1,NX2
                IF ((FLOAT(K)-XH)**2+Z2.LE.RAD44) A0(K) = VALUE                 
             ENDDO
             CALL WRTLIN(LUN1,A0,NSAM,I1+I)
           ENDDO
         ENDDO
      ENDIF
 
C ****************** CYLINDER AXIS ALONG Z ***********
      IF (YN .EQ. 'Z') THEN 

         NSL1  = ZH-HT-0.5
         NSL2  = ZH+HT+0.5
         IF (NSL1 .LT.1) NSL1=1
         IF (NSL2 .GT. NSLICE) NSL2=NSLICE
         NX1   = XH-RADC-0.5
         NX2   = XH+RADC+0.5
         IF (NX1 .LT.1) NX1=1
         IF (NX2 .GT. NSAM) NX2=NSAM
         NY1   = YH-RADC-0.5
         NY2   = YH+RADC+0.5
         IF( NY1 .LT.1) NY1=1
         IF (NY2 .GT. NROW) NY2=NROW
         RAD44 = RADC**2

         DO L=NSL1,NSL2
           I1 = (L-1)*NROW
           DO I=NY1,NY2
             CALL REDLIN(LUN1,A0,NSAM,I+I1)
             Y2 = (FLOAT(I)-YH)**2
             DO  K=NX1,NX2
                IF((FLOAT(K)-XH)**2+Y2.LE.RAD44) A0(K) = VALUE 
             ENDDO                
             CALL WRTLIN(LUN1,A0,NSAM,I1+I)
           ENDDO
         ENDDO
      ENDIF

C ****************** CYLINDER AXIS ALONG X ***********
      IF (YN .EQ. 'X') THEN 
         NSL1  = ZH-RADC-0.5
         NSL2  = ZH+RADC+0.5
         IF (NSL1.LT.1) NSL1=1
         IF (NSL2.GT.NSLICE) NSL2=NSLICE
         NX1   = XH-HT-0.5
         NX2   = XH+HT+0.5
         IF (NX1.LT.1) NX1=1
         IF (NX2.GT.NSAM) NX2=NSAM
         NY1   = YH-RADC-0.5
         NY2   = YH+RADC+0.5
         IF (NY1.LT.1) NY1=1
         IF (NY2.GT.NROW) NY2=NROW
         RAD44 = RADC**2
         DO L=NSL1,NSL2
            I1=(L-1)*NROW
            Z2=(FLOAT(L)-ZH)**2
            DO I=NY1,NY2
               Y2=(FLOAT(I)-YH)**2
               IF (Z2+Y2 .LE. RAD44) THEN
                  CALL REDLIN(LUN1,A0,NSAM,I+I1)
                  DO  K=NX1,NX2
                     A0(K) = VALUE                 
                  ENDDO
                CALL WRTLIN(LUN1,A0,NSAM,I1+I)
              ENDIF
           ENDDO
         ENDDO
      ENDIF
      GOTO 5000

C PUT NUMBERS INTO VOLUME:************************************ NUMBERS

 6000 CALL RDPRMI(IPOS,IDUM,NLOOP,ILOOP,'POSITION IN LINE')
      CALL RDPRM(SCALE,NLOOP,ILOOP,'SCALING FACTOR')
      SUM = 0.0
      DO L=1,NSLICE
        DO I=1,NROW
          DO K=1,NSAM
            A0(K) = 0.0
          ENDDO
          A0(IPOS) = FLOAT((L-1)*NROW+I)*SCALE
          SUM      = SUM+A0(IPOS)
          CALL WRTLIN(LUN1,A0,NSAM,I+(L-1)*NROW)
        ENDDO
      ENDDO

      CALL RDPRMC(ANS,NCHAR,.TRUE.,'NUMBER PIXELS IN LINE? (Y/N)',
     &              NULL,IRT)
      IF (ANS(1:1) .EQ. 'Y') THEN
        CALL RDPRMI(ISLIC,ILINE,NLOOP,ILOOP,'SLICE NUMBER, LINE NUMBER')
        CALL RDPRM(SCALE2,NLOOP,ILOOP,'SCALING FACTOR')
        ILL = (ISLIC-1) * NROW + ILINE
        CALL REDLIN(LUN1,A0,NSAM,ILL)
        DO  I=1,NSAM
           A0(I) = FLOAT(I) * SCALE2
           SUM   = SUM + A0(I)
        ENDDO
        SUM = SUM - FLOAT(IPOS)*SCALE
        CALL WRTLIN(LUN1,A0,NSAM,ILL)
      ENDIF
      RETURN


 5500 WRITE(NOUT,*) '*** UNIDENTIFIED OPTION'
      CALL ERRT(100,'MODEL3',NE)

      RETURN
      END

