
C ++********************************************************************
C                                                                      *
C MODELH                                                               *
C                                                                      *
C **********************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.    AUTHOR: J.FRANK      *
C *  COPYRIGHT (C)1985, 1996 HEALTH RESEARCH INCORPORATED, ALBANY, NY. *
C * THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO HEALTH            *
C * RESEARCH INC. AND ARE NOT TO BE DISCLOSED TO OTHERS OR USED        *
C * FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF       *
C * HEALTH RESEARCH INC.                                               *
C **********************************************************************
C  
C   MODELH(LUN1,NSAM,NROW,NSLICE)                                                             *
C
C23456789012345678901234567890123456789012345678901234567890123456789012
C***********************************************************************

	SUBROUTINE MODELH(LUN1,NSAM,NROW,NSLICE)

	INCLUDE 'CMBLOCK.INC' 
CNO_SAVE

        PARAMETER      (NBUFSIZ = 17008)
        COMMON /IOBUF/ BUF(NBUFSIZ)

	COMMON         NSEQ(100),XOFF(100),YOFF(100),ZOFF(100),
     &                 COO(3,5000),DENS(5000)

	DIMENSION     COOT(3),DLIST(12),ANG(3)
	REAL          LENGTH,L12,L13,L23
	INTEGER       ILOW,IHI,IRTFLG
        CHARACTER * 1 NULL,CDUM,ANS
	
	DATA PI/3.14159/,AMIN/-10E30/,AMAX/10E30/

        NULL = CHAR(0)

	IF (LUN1.EQ.0) GOTO 30

	CALL RDPRM(HGHT,NLOOP,ILOOP,'HEIGHT')
	CALL RDPRM(RAD,NLOOP,ILOOP,'RADIUS')
	IF (FCHAR(6:6) .EQ. 'F')GOTO 25

        NVAL = 3
        CALL RDPRAF(BUF,3,NVAL,AMIN,AMAX,'ALPHA, BETA, GAMMA',
     &           NULL,IRTFLG)
 
	ANG(1)=-BUF(1)*PI/180.
	ANG(2)=-BUF(2)*PI/180.
	ANG(3)=-BUF(3)*PI/180.

25	CALL RDPRMC(ANS,NCHAR,.TRUE.,
     &     '(C)LEAR VOLUME OR (N)O CLEAR? (C/N)',NULL,IRTFLG)

	IF (ANS .NE. 'N') THEN
C          CLEAR THE VOLUME
           DO  K=1,NSAM
	      BUF(K)=0.
	   ENDDO

           NTOT=NROW*NSLICE
           DO  I=1,NTOT
	      CALL WRTLIN(LUN1,BUF,NSAM,I)
	   ENDDO
        ENDIF

30	RAD2=RAD**2
	I1=SQRT(0.25*HGHT**2+RAD2)+0.5
	K1=I1
	L1=I1
	NSEQM=1

	IF (FCHAR(6:6) .EQ. 'F') THEN
           NCYL  = 100
	   ILOW = 0
	   IHI = 100
           CALL RDPRAI(NSEQ,100 ,NCYL,ILOW,IHI,
     $         '.ENTER SEQUENCE: ', CDUM,IRTFLG)
        ENDIF
        I=0

66      NVAL = 3
        CALL RDPRAF(BUF,3,NVAL,AMIN,AMAX,'ENTER NEXT COO TRIPLE',
     &           NULL,IRTFLG)
	IF (BUF(1).EQ.0..AND.BUF(2).EQ.0..AND.BUF(3).EQ.0.) GOTO 7
	I=I+1
	XOFF(I)=BUF(1)
	YOFF(I)=BUF(2)
	ZOFF(I)=BUF(3)
	IF (FCHAR(6:6) .EQ. 'F') GOTO 66

7	CONTINUE

C       PICK OUT THREE CYLINDERS AT A TIME TO COMPUTE ANGLE OF 
C       MIDDLE ONE
	IF (FCHAR(6:6) .NE. 'F') NCYL=3

	DO ICYL=2,NCYL-1
C       DEFAULT ASSIGNMENTS FOR COOS
 	IXOFF=XOFF(1)
	IYOFF=YOFF(1)
	IZOFF=ZOFF(1)
	IF (FCHAR(6:6) .NE. 'F') GOTO 90
	ICYL1=NSEQ(ICYL-1)
	ICYL2=NSEQ(ICYL)
	ICYL3=NSEQ(ICYL+1)
	IF (ICYL.EQ.2)GOTO 80
	DELX01=DELX12
	DELY01=DELY12
	DELZ01=DELZ12
80	DELX12=XOFF(ICYL2)-XOFF(ICYL1)
	DELY12=YOFF(ICYL2)-YOFF(ICYL1)
	DELZ12=ZOFF(ICYL2)-ZOFF(ICYL1)
	DELX23=XOFF(ICYL3)-XOFF(ICYL2)
	DELY23=YOFF(ICYL3)-YOFF(ICYL2)
	DELZ23=ZOFF(ICYL3)-ZOFF(ICYL2)
	DELX13=XOFF(ICYL3)-XOFF(ICYL1)
	DELY13=YOFF(ICYL3)-YOFF(ICYL1)
	DELZ13=ZOFF(ICYL3)-ZOFF(ICYL1)
	IF(ICYL.GT.2)
     1  A=DELZ12*(DELY01+DELY12) - DELY12*(DELZ01+DELZ12)
	B=DELX12*(DELZ01+DELZ12) - DELZ12*(DELX01+DELX12)
	C=DELY12*(DELX01+DELX12) - DELX12*(DELY01+DELY12)
	D=DELY23*DELZ12 - DELZ23*DELY12
	E=DELZ23*DELX12 - DELX23*DELZ12
	FF=DELX23*DELY12 - DELY23*DELX12
	L12=DELX12**2 + DELY12**2 + DELZ12**2
	L13=DELX13**2 + DELY13**2 + DELZ13**2
	L23=DELX23**2 + DELY23**2 + DELZ23**2
	LENGTH=SQRT(L23)
	THETA=ACOS((L23+L12-L13)/(2*SQRT(L23)*SQRT(L12)))
	DELTA=ASIN(E/SQRT(D**2 + E**2 + FF**2))
	PSI=999.
	IF (ICYL.GT.2)
     1  PSI=ACOS((A*D+B*E+C*FF)/(SQRT(D**2+E**2+FF**2)*
     2      SQRT(A**2+B**2+C**2)))
	IF (A*DELX23+B*DELY23+C*DELZ23.GT.0.0)PSI=-PSI
	IXOFF=XOFF(ICYL2)
	IYOFF=YOFF(ICYL2)
	IZOFF=ZOFF(ICYL2)
	A1=DELZ12*DELX13-DELX12*DELZ13
	A2=DELY12*DELZ13-DELZ12*DELY13
	ANG(1)=0.
	IF (.NOT.(A1.EQ.0.0.AND.A2.EQ.0.0))ANG(1)=ATAN2(A1,A2)
	IF (ANG(1).GT.PI/2)ANG(1)=ANG(1)-PI
	IF (ANG(1).LT.-PI/2)ANG(1)=ANG(1)+PI
	ANG(3)=0.

C       FOR CYLINDERS ONLY GAMMA=0
	B1=DELX12*DELZ13-DELZ12*DELX13
	B2=DELY13*DELX12-DELX13*DELY12
	ANG(2)=0.
	IF (.NOT.(B1.EQ.0.0.AND.B2.EQ.0.))ANG(2)=ATAN2(B1,B2)
90	IC=0
	IF (LUN1.EQ.0)GOTO 900
	DO  L=-L1,L1
           DO  I=-I1,I1
              DO  K=-K1,K1
                 IC=IC+1
                 COO(1,IC)=K
                 COO(2,IC)=I
                 COO(3,IC)=L
              ENDDO	
	   ENDDO	
	ENDDO

	DO  NE=1,3
          ANGLE=ANG(NE)
C         INITIALIZE ROTATION MATRIX ROUTINE
          DUM=COOROT(1,NCO,ANGLE,0)
          DO  N=1,IC
            DO  NCO=1,3
              COOT(NCO)=COO(NCO,N)
	    ENDDO
            DO  NCO=1,3
              COO(NCO,N)=COOT(1)*COOROT(1,NCO,ANGLE,NE)
     1           +COOT(2)*COOROT(2,NCO,ANGLE,NE)
     2           +COOT(3)*COOROT(3,NCO,ANGLE,NE)
	    ENDDO
	  ENDDO
	ENDDO

	DO N=1,IC
           DENS(N)=0.0
           IF (ABS(COO(3,N)).GT.HGHT/2.) GOTO 600
           IF (COO(1,N)**2+COO(2,N)**2.GT.RAD2) GOTO 600
           DENS(N)=1.
600	   CONTINUE
        ENDDO

	IC1=0
	IPREV=0
	DO L=-L1,L1
           IF (L+IZOFF.LT.1.OR.L+IZOFF.GT.NSLICE) GOTO 800
           IOFF=(L-1+IZOFF)*NROW
           DO  I=-I1,I1
              IF (I+IYOFF.LT.1.OR.I+IYOFF.GT.NROW) GOTO 770
              IOFF1=IOFF+I+IYOFF
              DO K=-K1,K1
                 IC1=IC1+1
                 IF (DENS(IC1).LT.1.0)GOTO 750
                 IF (IPREV.EQ.IOFF1)GOTO 730

C                EMPTY CURRENT BUFFER BEFORE PROCEEDING
                 IF (IPREV.NE.0) CALL WRTLIN(LUN1,BUF,NSAM,IPREV)
                 CALL REDLIN(LUN1,BUF,NSAM,IOFF1)
                 IPREV=IOFF1
730              KCUR=K+IXOFF
                 IF(KCUR.LT.1.OR.KCUR.GT.NSAM) GOTO 750
                 BUF(KCUR)=DENS(IC1)
750	         CONTINUE
              ENDDO
770	      CONTINUE
           ENDDO
800	   CONTINUE
        ENDDO

C       EMPTY LAST BUFFER
	CALL WRTLIN(LUN1,BUF,NSAM,IPREV)

900	CONTINUE
C       PUT COOS AND ANGLES INTO DOCUMENT FILE
	IF (FCHAR(6:6) .NE. 'F') GOTO 1000
	DLIST(1)=ICYL
	DLIST(2)=ICYL2
	DLIST(3)=XOFF(ICYL2)
	DLIST(4)=YOFF(ICYL2)
	DLIST(5)=ZOFF(ICYL2)
	DLIST(6)=ANG(1)*180./PI
	DLIST(7)=ANG(2)*180./PI
	DLIST(8)=ANG(3)*180./PI
	DLIST(9)=LENGTH
	DLIST(10)=THETA*180./PI
	DLIST(11)=DELTA*180./PI
	IF (ICYL.GT.2) DLIST(12)=PSI*180./PI
	NDOC=20
	CALL SAVD(NDOC,DLIST,12,IRTFLG)
1000	CONTINUE
        ENDDO


	RETURN
	END
