
C++************************************************************** 3/4/81
C
C  MONT.FOR                               LONG FILNAMES JAN 89 al
C                                         REWRITTEN MAY 1996 al
C
C **********************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK        *
C *  COPYRIGHT (C)1985, 1996 HEALTH RESEARCH INCORPORATED, ALBANY, NY  *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO HEALTH         *
C *    RESEARCH INC. AND ARE NOT TO BE DISCLOSED TO OTHERS             *
C *    OR USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN        *
C *    APPROVAL OF HEALTH RESEARCH INC.                                *
C **********************************************************************
C
C    MONT:    SUBROUTINE FOR MAKING GENERAL MONTAGE FROM FILE SERIES
C
C***********************************************************************

	SUBROUTINE MONT(MAXDIM)

        INCLUDE 'CMBLOCK.INC'

        COMMON /COMMUN/ NUMBER(600),FILNAM,FILOUT,FILPAT

	COMMON BUF(1)

        LOGICAL        NORMLZ, PUTOUT
	CHARACTER *81  FILNAM,FILOUT,FILPAT
	CHARACTER *1   NULL

        DATA LUN,LUNO/9,10/

        NULL = CHAR(0)

C       GET FILENAME PATTERN, NUMBERS
        CALL FILSEQP(FILPAT,NLET,NUMBER,400,NUMTOT, 
     $     'FILE PREFIX OR TEMPLATE (EG. PIC****)' ,IRTFLG)
     
        IF (IRTFLG .NE. 0) RETURN

C       CREATE FIRST FILENAME
        CALL FILGET(FILPAT,FILNAM,NLET,NUMBER(1),IRTFLG)
        IF (IRTFLG .NE. 0) RETURN

C       OPEN FIRST FILE
        CALL OPFIL(.FALSE.,FILNAM,LUN,'O',NSAM,NROW,NSLICE,
     &             IDUM,'INPUT',.FALSE.,IRTFLG)
        IF (IRTFLG .NE. 0) RETURN
        IF (IFORM .EQ. 3) THEN
           WRITE(NOUT,*) 'WARNING: CAN ONLY USE FIRST SLICE OF VOLUME'
        ENDIF

        WRITE(NOUT,97) FMIN,FMAX
97      FORMAT(' FIRST IMAGE RANGE: ',G11.3,' ... ',G11.3,/)

	IF (FCHAR(4:4) .EQ. 'S') THEN
           NORMLZ = .TRUE.
           IF (IMAMI.NE.1) CALL NORM3(LUN,NSAM,NROW,NSLICE,FMAX,FMIN,AV)
           FMINT = FMIN
           SCT   = 0.0
           IF (FMAX .NE. FMIN) SCT = 2.0 / (FMAX-FMIN)
        ELSE
           NORMLZ = .FALSE.
        ENDIF

	CALL RDPRMI(NPR,MAR,NLOOP,ILOOP,
     &      'ENTER NUMBER OF IMAGES PER ROW, MARGIN WIDTH')

10      CALL RDPRM(BACK,NLOOP,ILOOP,'ENTER MARGIN VALUE')
	IF (FCHAR(4:4) .EQ. 'S' .AND. 
     &     (BACK .LT. 0.0 .OR. BACK .GT. 2.0)) THEN
           WRITE(NOUT,*) 'MARGIN VALUE MUST BE IN RANGE 0.0 ... 2.0)'
           CALL ERRT(100,'MONT',NE)
           GOTO 10
        ENDIF

C       FIND SIZE OF OUTPUT MONTAGE (MARGINS ALL AROUND)
	NSAMO   = NSAM * NPR + MAR *(NPR + 1)
	NUMROW  = NUMTOT / NPR + 1
	IF ((NUMTOT / NPR) * NPR .EQ. NUMTOT) NUMROW = NUMTOT / NPR
	NROWO   = NROW * NUMROW + MAR * ( NUMROW + 1)
        NUMMARS = NUMROW + 1

C       OPENF, NORM AND SETPRM WILL USE COMMON BUFFER IF NEEDED
        IPAD = 256 + NSAM
 
        IF (IPAD + (NROWO * (NROW + MAR)) .GT. MAXDIM) THEN
C          INSUFFICIENT MEMORY
           CALL ERRT(6,'MONT',NE)
           GOTO 999
        ENDIF
                  
C       OPEN OUTPUT FILE
        IFORM = 1
        CALL OPFIL(.TRUE.,FILOUT,LUNO,'N',NSAMO,NROWO,1,
     &             IDUM,'OUTPUT',.FALSE.,IRTFLG)
        IF (IRTFLG .NE. 0) GOTO 999
          
C       FILL HORIZONTAL MARGIN ROWS IN FILE
        IROW = 1
        IF (MAR .GT. 0) THEN
C          FILL BUFFER WITH BACKGROUND FIRST
           DO J = 1, NSAMO
              BUF(IPAD + J) = BACK
           ENDDO

C          PLACE MARGIN ROWS IN FILE
           DO M = 1, NUMMARS
C             PLACE MAR ROWS OF BUFFER IN FILE
              DO I = 1,MAR
                 CALL WRTLIN(LUNO,BUF(IPAD+1),NSAMO,IROW)
                 IROW = IROW + 1
              ENDDO
             IROW = IROW + NROW
           ENDDO
        ENDIF

C       READ IN IMAGE ROWS               
        IPICONROW = NPR
        IROWO     = MAR 

        DO IFIL = 1,NUMTOT
C          FIRST FILE ALREADY OPEN!
	   IF (IFIL .NE. 1) THEN
C             OPEN THE NEW INPUT FILE
              CLOSE(LUN)
              CALL FILGET(FILPAT,FILNAM,NLET,NUMBER(IFIL),IRTFLG)

              CALL OPFIL(.FALSE.,FILNAM,LUN,'O',NSAMN,NROWN,NSLICE,
     &             IDUM,'UNUSED',.FALSE.,IRTFLG)
              IF (IRTFLG .NE. 0) GOTO 998

              IF (NSAMN .NE. NSAM .OR. NROWN .NE. NROW) THEN
C                INCONSISTENT IMAGE SIZES
                 WRITE(NOUT,*)'*** THIS IMAGE HAS DIFFERENT SIZE!'
                 CALL ERRT(100,'MONT',NE)
                 GOTO 998
              ELSEIF (NORMLZ) THEN
                 IF (IMAMI .NE. 1) 
     &              CALL NORM3(LUN,NSAM,NROW,NSLICE,FMAX,FMIN,AV)
                 FMINT = FMIN
                 SCT   = 0.0
                 IF (FMAX.NE.FMIN) SCT = 2./(FMAX-FMIN)
              ENDIF
	   ENDIF

	   IPICONROW = IPICONROW + 1
C          START NEW ROW IF NECESSARY
	   IF (IPICONROW .GT. NPR)  IPICONROW = 1

           PUTOUT = .TRUE.

C          PUT IN VERTICAL LEFT MARGIN
	   NSTART = IPAD + 1
	   DO IROW = 1, NROW
              DO ISAM = NSTART, NSTART + MAR - 1
                 BUF(ISAM) = BACK
              ENDDO
              NSTART = NSTART + NSAMO
	   ENDDO
      
C          READ ROWS FROM FILE
	   DO  IROW = 1,NROW
C             COMPUTE CURRENT BUFFER POSITION
              NSTART = IPAD + (IPICONROW - 1) * (NSAM + MAR) + MAR + 1 +
     &                 (IROW -1) * NSAMO
              CALL REDLIN(LUN,BUF(NSTART),NSAM,IROW)
              IF (NORMLZ) THEN
                 DO  K = NSTART ,NSTART+NSAM-1
                    BUF(K) = (BUF(K) - FMINT) * SCT
                 ENDDO
              ENDIF

C             ADD VERTICAL MARGIN TO RIGHT
              DO J = NSTART+NSAM, NSTART+NSAM+MAR
                 BUF(J) = BACK
              ENDDO
	   ENDDO

           IF (IPICONROW .EQ. NPR) THEN
C             OUTPUT THIS ROW OF IMAGES
              ISTART = IPAD + 1
              DO IROWT = 1, NROW
	         CALL WRTLIN(LUNO,BUF(ISTART),NSAMO,IROWO + IROWT)
                 ISTART = ISTART + NSAMO
              ENDDO
              IROWO  = IROWO + NROW + MAR 
              PUTOUT = .FALSE.
           ENDIF
        ENDDO

        IF (PUTOUT) THEN
C          OUTPUT REMAINING PARTIAL ROW OF IMAGES

C          MUST FILL REMAINING PART OF BUFFER WITH BACKGROUND
           ISTART =  IPICONROW  * (NSAM + MAR) + MAR + 1
           NVALS  = NSAMO - ISTART
           DO IROWT = 1, NROW 
              DO ISAMO = IPAD + ISTART, IPAD + ISTART + NVALS
	         BUF(ISAMO) = BACK
              ENDDO
              ISTART = ISTART + NSAMO
           ENDDO

C          PUT OUT THE ROW OF IMAGES 
           ISTART = IPAD + 1
           DO IROWT = 1, NROW
	      CALL WRTLIN(LUNO,BUF(ISTART),NSAMO,IROWO + IROWT)
              ISTART = ISTART + NSAMO
           ENDDO
        ENDIF

998     CLOSE(LUNO)
999     CLOSE(LUN)
	RETURN
	END

