      SUBROUTINE MR2TO3D(P3D, PRJ, ANGLE, ERRX, ERRY, ERRZ)

C **************************************************************
C CALCULATES, USING LINEAR REGRESSION AND ASSUMING A SINGLE
C TILT AXIS THROUGH THE Y AXIS, THE X, Y, AND Z COORDS OF THE
C MARKERS.
C INPUT:
C     PRJ(2,LS,LV)= COORDS OF MARKER IN PROJECTIONS
C     ANGLE(3,LV)= ANGLES TILTED ABOUT Z,Y,Z
C COMMON INPUT:
C     NUMPT(LV)= MAX INDEX OF POINT USED IN EACH VIEW
C     PTACTIVE(LS,LV)= BOOLEAN ARRAY HOLDING WHETHER A POINT IS IN
C           VIEW OR NOT.
C     NTVW= TOTAL NUMBER OF VIEWS
C     NTPT= TOTAL NUMBER OF MARKERS
C OUTPUT:
C     P3D(3,LS)= COORDS OF POINTS IN 3-D SPACE


        PARAMETER (LV=300)
        PARAMETER (LS=100)
        PARAMETER (MAXREG=7)
        PARAMETER (MAXKEY=100)
        PARAMETER (MAXLOOP=999)
        REAL MAXPER
        PARAMETER (MAXPER=1.0e-6)

      LOGICAL*1   PTACTIVE(LS,LV),PARAMQ(4)
      COMMON /GENERAL/PTACTIVE,NUMPTS(LV),NTVW,NTPT,CIR(2),PARAMQ

      DIMENSION   P3D(3,LS)
      DIMENSION   PRJ(2,LS,LV), ANGLE(3,LV), NUMPT(LV)
      DIMENSION   XPR(LV), YPR(LV)
CNO_SAVE
c
      ERRX=0.0
      ERRY=0.0
      ERRZ=0.0
c
C PREPARE ARRAYS FOR REGRESSION. 
      DO 100 I=1,NTPT
        YSUM=0
        NYSUM=0
        NDATA=0
        DO  J=1,NTVW
          IF (PTACTIVE(I,J)) THEN
            YSUM=YSUM+PRJ(2,I,J)
            NYSUM=NYSUM+1
c            IF (ABS(SIN(ANGLE(2,J))) .GT. 0.001 ) THEN
c              NDATA=NDATA+1
c              XPR(NDATA)= 1/TAN(ANGLE(2,J))
c              YPR(NDATA)= PRJ(1,I,J)/SIN(ANGLE(2,J))
            IF (ABS(COS(ANGLE(2,J))) .GT. 0.001 ) THEN
              NDATA=NDATA+1
              XPR(NDATA)=-TAN(ANGLE(2,J))
              YPR(NDATA)= PRJ(1,I,J)/COS(ANGLE(2,J))
            ENDIF
          ENDIF
	ENDDO
	if(ndata.eq.0)  then
	  do    j=1,3
	    p3d(j,i)=0.0
	  enddo
	  goto  100
	endif
        X=0
        ZN=0
        CALL MRRLINE(XPR,YPR,NDATA,LV,ZN,X,ERZ,ERX,STER)
c        P3D(1,I)=X
c        P3D(3,I)=-ZN
        P3D(1,I)=zn
        P3D(3,I)=x
        YNSUM=NYSUM
        YAVE=YSUM/YNSUM
        P3D(2,I)=YAVE
        SSQY=0.0
        DO  K=1,NTVW
         IF(PTACTIVE(I,K)) SSQY=SSQY+((PRJ(2,I,K)-YAVE)**2)/NYSUM
	ENDDO
C
        ERRY=ERRY+SQRT(SSQY)
        ERRZ=ERRZ+ERZ
        ERRX=ERRX+ERX
 100  CONTINUE
      END
