C++************************************************************************
C
C    MRALI.FOR
C
C **************************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK            *
C *  COPYRIGHT (C)1981,1987, WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *  THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR       *
C *  LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR    *
C *  USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF     *
C *  THE CENTER FOR LABORATORIES AND RESEARCH                              *
C **************************************************************************
C
C   MRALI.FOR
C
C         SUBROUTINE MRALI(MAXMEM)
C         SUBROUTINE  MRALI_P(NSAM,NROW,ILIST,NIMA,MODE,JACUP,
C      SUBROUTINE  ALROSI(A,ATMP,B,C,REFER,NSAM,NROW,WRK,PARA,NOCHANGE,
C      SUBROUTINE  ALROSF(A,ATMP,B,C,REFER,NSAM,NROW,WRK,PARA,NOCHANGE,
C         SUBROUTINE  RTQS(X,OUT,NSAM,NROW,THETA,SHXI,SHYI)
C         SUBROUTINE  SHFI_2(X,OUT,NSAM,NROW,ISHX,ISHY)
C         SUBROUTINE SUMAP(
C         SUBROUTINE  FINDMX_F(D,NSAM,NROW,CMX,SX,SY,JACUP)
C         SUBROUTINE  CROSRNG_F
C
C--************************************************************************

         SUBROUTINE MRALI(MAXMEM)
         PARAMETER  (NILMAX=1000)
         INTEGER*2  NUMR(3,480)
         INCLUDE 'CMBLOCK.INC' 
         COMMON  BUF(1024),ILIST(NILMAX),NUMR,BAF(1)
         DIMENSION Q(1)
         POINTER   (IPQ,Q) 
         LOGICAL         RUNTIME
C be careful with the common, it has to agree with 64 bits...
         COMMON  /FISPEC/  FINPAT,FINPIC,DOCFIL,NLET,NLETI
         CHARACTER*80  FINPAT,FINPIC,DOCFIL
         COMMON /MXR/ MAXRIN
         INTEGER*2  MAXRIN
         CHARACTER*1  NULL,MODE
         DATA  INPIC/77/
CNO_SAVE
          NULL=CHAR(0)
C  ASK FOR DATA FILE
         CALL  FILERD(FINPAT,NLET,NULL,
     &   'Enter template for 2-D reference image name',IRTFLG)
         CALL  FILERD(DOCFIL,NLETI,NULL,'Selection doc',IRTFLG)
         K=0
         K2=1
         NIMA=0
778      LERR=-1
         IF(NIMA.EQ.NILMAX)  THEN
         WRITE(NOUT,*) '  Too many images, list truncated'
         GOTO  779
         ENDIF
         KP1=K+1
         CALL  UNSAV(DOCFIL,K,INPIC,KP1,BUF,1,LERR,K2)
         IF(LERR.EQ.0)  THEN
         NIMA=NIMA+1
         ILIST(NIMA)=BUF(1)
         K=K+1
         GOTO  778
         ENDIF
779      CLOSE(INPIC)
         IF(NIMA.GT.0)  THEN
         WRITE(NOUT,2001) NIMA
2001     FORMAT('  Number of images =',i5)
         ELSE
         WRITE(NOUT,*)  '  No images !'
         RETURN
         ENDIF
         CALL  FILGET(FINPAT,FINPIC,NLET,ILIST(1),INTFLG)
         CALL  OPENFB(BUF,FINPIC,INPIC,NSAM,NROW,'O',NF,NSL)
         IF(NF.NE.2)  THEN
         CALL ERRT(4,'AP SR ',NE)
         RETURN
         ENDIF
         CLOSE(INPIC)
C
         CALL  RDPRMI(NSI,NR,NLOOP,ILOOP,'EXPECTED SIZE OF THE OBJECT')
         IF(NSI.GE.NSAM)  THEN
         WRITE(NOUT,*) ' Object size cannot be larger than window size'
         NSI=NSAM-2
         WRITE(NOUT,*) ' Object size set to',NSI
         ENDIF
         NSI=MAX0(1,NSAM-NSI)
C
         CALL  RDPRMI(MR,NR,NLOOP,ILOOP,'FIRST AND LAST RING')
         IF(NR.GT.NSAM/2-1)  THEN
         NR=NSAM/2-1
         WRITE(NOUT,*)  ' Last ring limited to ',NR
         ENDIF
         MR=MAX0(2,MIN0(NR,MR))
         ISKIP=1
         MODE='F'
         NRING=0
         DO  I=MR,NR,ISKIP
         NRING=NRING+1
         NUMR(1,NRING)=I
	 ENDDO
C
         CALL  ALPRBS(NUMR,NRING,LCIRC,MODE)
         MAXRIN=NUMR(3,NRING)
C
C
C     CALL  RDPRMI(JACUP,NDUMP,NLOOP,ILOOP,
C     & 'Precision of peak location (0..100)$')
C     JACUP=MAX0(0,MIN0(100,JACUP))
         JACUP=0
C
C   memory division    K
C       numr           1  !int*2
C                      2
C       para           3
C       WRK            4
C       A              5
C       B              6
C       C              7
C       D              8
C                      9
C                     10
C                     11
C       temp          12  !double precision
C       a_circ        13
C       refer_circ    14
C                     15
C       qm            16
C
C
C K1 not used
        K1=-1
        K2=1
         K3=K2
         K4=IPALIGN64(K3+3)
         K5=IPALIGN64(K4+MAX0(NSAM,2*NROW))
         K6=IPALIGN64(K5+NSAM*NROW)
         K7=IPALIGN64(K6+NSAM*NROW)
         K8=IPALIGN64(K7+NSAM*NROW)
         K9=IPALIGN64(K8+NSAM*NROW)
         K10=K9
         K11=K10
         K12=K11
         K13=IPALIGN64(K12+4*MAXRIN)
         K14=IPALIGN64(K13+LCIRC)
         K15=IPALIGN64(K14+LCIRC*NIMA)
         K16=K15
         L_MAINBUF=K16
        MEMTOT=L_MAINBUF+NSAM*NROW*NIMA
	MAXM=MAXMEM-1024-NILMAX-3*480/2
        CALL CHKMEM(MEMTOT,BAF,MAXM,RUNTIME,IPQ,IRTFLG)
             IF(IRTFLG.NE.0)  THEN
                CLOSE(INPIC)
                CALL  ERRT(6,'MRALI',NE)
                RETURN
              ENDIF
         WRITE (NOUT,2500)  MEMTOT
         DO  IMI=1,NIMA
         L=ILIST(IMI)
         NULL=CHAR(0)
         CALL  FILGET(FINPAT,FINPIC,NLET,L,INTFLAG)
         CALL  OPENFB(BUF,FINPIC,INPIC,NSAMT,NROWT,'O',NF,NSL)
         IF(NF.NE.2)  THEN
         WRITE(NOUT,*)  ' FILE NOT FOUND:',FINPIC
         RETURN
         ENDIF
         DO    J=1,NROW
         CALL  REDLIN(INPIC,Q(L_MAINBUF+NSAM*NROW*(IMI-1)+(J-1)*NSAM),
     &		NSAM,J)
      	 ENDDO
         CLOSE(INPIC)
C         CALL GETIMA(Q(L_MAINBUF+NSAM*NROW*(IMI-1)),NSAM,NROW,IMI)
         ENDDO
C
C NIMA number of the reference images
C
         CALL  MRALI_P(NSAM,NROW,NSI,NIMA,MODE,JACUP,
     &   	Q(K4),Q(K5),Q(K6),Q(K7),Q(K8),Q(K3),
     &		Q(K13),Q(K14),LCIRC,
     &   	NUMR,NRING,MAXRIN,Q(K12),Q(K16),
     &   	NR)
C
      IF(RUNTIME)  CALL ALLOCIT(0,RUNTIME,IPQ,'MRALI',IRTFLG)
         WRITE (NOUT,2600)
         RETURN
2500     FORMAT (/,' MEMORY RESERVATION: YOU HAVE',
     #   ' ALLOCATED ',I8)
2600     FORMAT (/' ',80('-')//' ',' Mult-reference alignment,  ',
     #   'end of computation',//' ',80('-')/)
         END
