      SUBROUTINE MRALIGN(XYPTS,PRJ,ANGLE,SHIFT,SCALE,PTACTIVE,ls)
C
C ***********************************************************
C TAKES IMAGES XYPTS AND TRANSFORMS THEM BY ROTATING ABOUT THE
C GEOMETRICAL CENTER (NOT CENTER OF MASS) AND TRANSLATING IT
C BY SHFT.
C
C INPUT:
C     XYPTS(2,LS,LV)= COORDS OF POINTS TO BE TRANSFORMED
C     ANGLE(3,LV)= EULER ANGLES. ANGLE(2) IS TILT AND ANGLE(1) IS
C                  FINAL ROTATION CORRECTION (APPLIED HERE)
C     SHIFT(2,LV)= SHIFT (X,Y) THAT THE IMAGE MUST UNDERGO
C     SCALE(LV)= MULTIPLICATIVE SCALING FACTOR
C COMMON INPUT:
C     NUMPTS(LV)= MAXIMUM INDEX OF POINTS USED IN AN IMAGE
C     NTVW= TOTAL NUMBER OF VIEWS IN SERIES
C     NTPT= TOTAL NUMBER OF DISTINCT MARKERS USED
C     CIR(2)= COORDS OF CENTER OF IMAGE
C
C OUTPUT:
C     PRJ(2,LS,LV)= COORDS OF CORRECTED POINTS
      LOGICAL*1   PTACTIVE(LS)
      DIMENSION   XYPTS(2,LS), PRJ(2,LS)
      DIMENSION   SHIFT(2)
CNO_SAVE
C
        CA = COS(ANGLE)
        SA = SIN(ANGLE)
C
C     Image center (CIR) WAS already subtracted in MRGETINFO.
C     ROTATION IS MEANT TO BE AROUND THE CENTER OF THE IMAGE
C     NOT AROUND THE CORNER OR CENTER OF MASS
C    _                 _   _
C    X' = Scale*R(psi)*X + Shift
C
        DO  IPT=1,ls
	if(ptactive(ipt))  then
c
c  this provision will make it work for prj == xypts
	qt=XYPTS(1,IPT)
      PRJ(1,IPT)= SCALE*( qt*CA + XYPTS(2,IPT)*SA) + SHIFT(1)
      PRJ(2,IPT)= SCALE*(-qt*SA + XYPTS(2,IPT)*CA) + SHIFT(2)
	endif
	ENDDO
      END
