      SUBROUTINE MRCENTI(ARPTI,CVPT,ptactive,ls)
C
C ****************************************************************
C    TAKES THE RAW, UNCENTERED POINTS RRPT AND RVPT AND RETURNS
C    THEIR POINTS COORDS WITH RESPECT TO THE CENTER OF MASS OF
C    THE POINTS TO BE USED, GIVEN BY PTACTIVE. THESE POINTS CAN
C    BE USED TO CALCULATE THE ROTATIONAL MISALIGNMENT, THE SCALE
C    FACTORS AND EVENTUALLY THE SHIFT. ASSUMES ALL POINTS TO BE
C    USED CAN BE FOUND IN REFERENCE AND VIEW TO BE ALIGNED.
C
C    This is used only in the first, rough centration
C
C INPUT:
C     ARPTR(2,LS,LV)= ARRAY OF POINTS FOR REF IMAGE
C     IREF= INDEX OF REFERENCE VIEW
C     ARPTI(2,LS,LV)= ARRAY OF POINTS FOR IMAGE
C     IMAGE= INDEX OF VIEW TO BE REFINED
C     TILT= TILT ANGLE OF IMAGE (RADIANS)
C     P3D(3,LS)= COORDS OF MARKERS IN 3-D
C
C COMMON INPUT:
C     PTACTIVE(LS,LV)= BOOLEAN ARRAY REFERENCING POINTS TO BE USED
C          (ie. CAN BE FOUND IN VPT VIEW) .TRUE. IF USED
C     NUMPTS(LV)= MAXIMUM INDEX OF POINTS TO BE USED
C
C OUTPUT:
C     RPT(3,LS)= COORDS OF POINTS IN REFERENCE IMAGE WITH RESPECT
C          TO CENTER OF MASS OF POINTS TO BE USED
C     VPT(3,LS)= COORDS OF POINTS IN VIEW TO BE ALIGNED WITH RESPECT
C          TO CENTER OF MASS OF POINTS TO BE USED
C     CRPT(3)= CENTER OF MASS OF REFERENCE IN ORIGINAL COORDS
C     CVPT(3)= CENTER OF MASS OF VIEW IN ORIGINAL COORDS

      LOGICAL*1   PTACTIVE(LS)
      DIMENSION   ARPTI(2,LS), CVPT(3)
CNO_SAVE
C       SET POINT COUNTER AND SUMS TO ZERO
      N=0
      DO  J=1,3
        CVPT(J)=0.0
      ENDDO
C       IF POINT BEING USED, ADD IT IN
      DO  I=1,LS
        IF(PTACTIVE(I)) THEN
          N=N+1
          DO  M=1,2
            CVPT(M)=CVPT(M)+ARPTI(M,I)
	  ENDDO
	ENDIF
      ENDDO
C
C       DIVIDE TO GET CENTER OF MASS
      DO  J=1,3
        CVPT(J)=CVPT(J)/N
      ENDDO
      END
