
C
C     SUBROUTINE TO CALCULATE THE FIRST AND SECOND DERIVATION
C     OF THE SQUARED DEVIATION BETWEEN THE DISTANCES IN THE
C     N-DIMENSIONAL SPACE AND THE 2-DIMENSIONAL PLANE. IN
C     Y1 AND Y2 THE ITERATIVE CORRECTIONS FOR THE 2-D VECTORS
C     ARE RETURNED.
C
C     M.RADERMACHER 13.OCT.82
C     UPDATED TO I4 6/88
C 


      SUBROUTINE MRDEV(DISTH,DISTL,XLO,N,IND,SUM,Y1,Y2,EXP)


      INCLUDE 'CMBLOCK.INC'

      COMMON /DIM1/MAXIM,MAXFAC,MAXLO,NDIST
       INTEGER MAXIM,MAXFAC,MAXLO
      DIMENSION DISTH(1),DISTL(1),XLO(MAXIM,MAXLO)

      I4=1
      SEC1=0.
      SEC2=0.
      ESUM=0.
      SUM1=0.
      SUM2=0.
C  
C     FIRST PART
C
C     A) FIRST DERIVATION
C
      IOFF=0.
      DO  I=1,IND-1
       IOFF=IOFF+I
      ENDDO
      IN=I4*(IND-1)*N-IOFF
      DO  J=IND+1,N
      IN=IN+1
      DH=DISTH(IN)
      IF(DH.EQ.0) DH=1.E-5
      DHE=DH**EXP
      A1=DH-DISTL(IN)
      A2=DHE*DISTL(IN)
C     IF(ABS(A2).LT.0.00001) WRITE(NOUT,200) IND,J
      IF(ABS(A2).LT.0.000001) A2=0.000001*SIGN(1.,A2)
      A31=XLO(IND,1)-XLO(J,1)
      A32=XLO(IND,2)-XLO(J,2)
C      WRITE(NDAT,10) IN,IND,J,A1,A2,A31,A32
10    FORMAT(' MRDEV IN,IND,J,A1,A2,A31,A32',3I4,4E12.4)
      FACT=A1/A2
      SUM1=SUM1+FACT*A31
      SUM2=SUM2+FACT*A32
C   
C     B) SECOND DERIVATION
C
      DZ=DISTL(IN)
      IF(DZ.LT.0.000001) WRITE(NOUT,201) J,IND,DZ
      IF(DZ.LT.0.000001) DZ=0.000001
      F1=A1/DZ+1
      F21=A31*A31/DZ
      F22=A32*A32/DZ
      SEC1=SEC1+(A1-F1*F21)/A2
      SEC2=SEC2+(A1-F1*F22)/ A2
      ENDDO
C
C     SECOND PART OF THE DERIVATIONS
C
C     A) FIRSTDERIVATION
C
      IOFF=0
      DO  J=1,IND-1
      IN=(J-1)*N-IOFF
      IOFF=IOFF+J
      IN=IN+IND-J
      DH=DISTH(IN)
      IF(DH.EQ.0) DH=1.E-5
      DHE=DH**EXP
      A1=DH-DISTL(IN)
      A2=DHE*DISTL(IN)
C     IF(ABS(A2).LT.0.000001) WRITE(NOUT,200) IND,J
      IF(ABS(A2).LT.0.000001) A2=0.000001*SIGN(1.,A2)
      A31=XLO(IND,1)-XLO(J,1)
      A32=XLO(IND,2)-XLO(J,2)
      FACT=A1/A2
      SUM1=SUM1+FACT*A31
      SUM2=SUM2+FACT*A32
C
C     B) SECOND DERIVATION
C
      DZ=DISTL(IN)
      IF(DZ.LT.0.0) WRITE(NDAT,201) J,IND,DZ
      IF(DZ.LT.0.000001) DZ=0.000001
      F1=A1/DZ+1
      F21=A31*A31/DZ
      F22=A32*A32/DZ
      SEC1=SEC1+(A1-F1*F21)/A2
      SEC2=SEC2+(A1-F1*F22)/A2
C      WRITE(NDAT,11) IN,IND,J,F1,F21,F22
11    FORMAT(' MRDEV IN,IND,J,F1,F21,F22',3I4,3E12.4)
      ENDDO
      SUM1=SUM1/SUM*(-2)
      SUM2=SUM2/SUM*(-2)
      SEC1=SEC1/SUM*(-2)
      SEC2=SEC2/SUM*(-2)
      SEC1=ABS(SEC1)
      SEC2=ABS(SEC2)
      IF(SEC1.LT.0.0000001)SEC1=0.0000001
      IF(SEC2.LT.0.0000001)SEC2=0.0000001
      Y1=SUM1/SEC1
      Y2=SUM2/SEC2
C     WRITE(NDAT,111) SUM,SUM1,SUM2,SEC1,SEC2,
C    $Y1,Y2,IND
111   FORMAT(' MRDEV SUM,SUM1,SUM2,SEC1,SEC2,Y1,Y2,IND'/1X,
     $7E12.4,I5)
200   FORMAT(' ','A2<0.00001 FOR IND,J=',2I5)
201   FORMAT(' DIST(I,J)<0.00001 FOR I,J=',2I5,'DZ=',E10.3)
      RETURN
      END



