      SUBROUTINE MRERR(DISTH,DISTL,SUM,N,E,EX)
C
C     SUBROUTINE TO CALCULATE THE MEAN SQUARE DEVIATION
C     BETWEEN THE DISTANCES IN THE 2-DIMENSIONAL AND
C     N-DIMENSIONAL VECTOR SPACE.
C
C     PART OF THE PROGRAMS FOR NONLINEAR MAPPING
C     M. RADERMACHER 
C      INPUT:   DIST    SQUARE MATRIX WITH THE 2- AND N-
C                       DIMENSIONAL DISTANCES
C               SUM     SUM OF THE DISTANCES IN N-DIMENSIONAL
C                       SPACE
C               N       DIMENSION OF DIST
C      OUTPUT:  E       MEAN SQUARE DEVIATION
C
      IMPLICIT INTEGER   (I,J,K,L,M,N)
      COMMON /DIM1/MAXIM,MAXFAC,MAXLO,NDIST
       INTEGER MAXIM,MAXFAC,MAXLO,N
      DIMENSION DISTH(1),DISTL(1)
      I4=1
      E=0.
      IG=I4*(N-1)*N/2
      DO  K=1,IG
      F=DISTH(K)-DISTL(K)
      DD=DISTH(K)
      IF(DD.LE.1.0E-5) DD=1.
      DD=DD**EX
      F=F*F/DD
      E=E+F
      ENDDO
      E=E/SUM
C     WRITE(NOUT,10)E
10    FORMAT('  ERROR=',E12.4)
      RETURN
      END
