#ifdef SP_DISTRIB 
 
C   THIS ROUTINE SPECIFIC TO WADSWORTH LABS AND IS NOT 
C       DISTRIBUTED TO OUTSIDE SITES
 
       SUBROUTINE mrgaus2
 
       COMMON /UNITS/LUNC,NIN,NOUT
 
       WRITE(NOUT,*) 'DUMMY CALL: mrgaus2'
       RETURN
       END
 
#else
 
      SUBROUTINE
     $ MRGAUS2(A0,S,A,X0,Y0,X,Y,FL,W,F,R,IND,IAUS)
C
C     SUBROUTINE TO CALCULATE THE GAUSS-FUNCTION OVER A TWO-DIMENSIONAL
C     AREA (IND=0). FOR IND=1 ADDITIONALLY THE DERIVATIVES BY
C     X0,Y0 (CENTER); S (HALFWIDTH); A0 (AMPLITUDE); A ELLIPTIC PARAMETER
C     ARE CALCULATED.
C     INPUT: X,Y - COORDINATES; W - MEASUREMENTS AT X,Y ;
C     OUTPUT: FL - DIFFERENCE BETWEEN MEASUREMENT AND FUNCTION
C             F  - FUNCTION AT X,Y 
C             R  - ARRAY CONTAINING DERIVATIVES
C     FUNCTION: F=A0/(2PI*SX**2*SY**2)*EXP(-(X-X0)**2/2*SX**2)
C                                     *EXP(-(Y-Y0)**2/2*SY**2)
C
C     FEB. 1985, M.RADERMACHER
C
      DIMENSION R(6)
      IF(IAUS.GT.0) WRITE(6,777) A0,A,S,X0,Y0,X,Y
777   FORMAT(1H ,'MRGAUS2:',7F10.3)
      PI=3.14159265
      SQPI=SQRT(PI)
      F=A0*EXP(-(A*A*(X-X0)**2+(Y-Y0)**2)/(2.*S**2))
      FL=W-F
      IF(IAUS.GT.0) WRITE(6,1) F,W,FL
1     FORMAT(1H ,'F=',E11.4,'W=',E11.4,'FL=',E11.4)
      IF(IND.EQ.0)RETURN
C DERIVATIVE WITH RESPECT TO A0
      R(1)=F/A0
C DERIVATIVE WITH RESPECT TO  A
      R(2)=-F*(A*(X-X0)**2)/(S*S)
C DERIVATIVE WITH RESPECT TO S
      R(3)=F*(A*A*(X-X0)**2+(Y-Y0)**2)/(S**3)
C DERIVATIVE WITH RESPECT TO X0
      R(4)=F*(A*A*(X-X0))/(S*S)
C DERIVATIVE WITH RESPECT TO Y0
      R(5)=F*(Y-Y0)/(S*S)
      RETURN
      END
 
#endif
 
