      SUBROUTINE   MRK3(MAXDIM)

C ************************************************
C ALIGNS A 3D MODEL TO A REFERENCE 3D MODEL, BOTH CREATED
C FROM OUTPUT FILES CREATED BY MKRALIGN. FINDS ALL
C PARAMETERS TO TRANSFORM ONE MODEL TO ANOTHER (SCALE,
C PHI, THETA, PSI) AND WILL CALCULATE THE NEW
C PARAMETERS FOR THE DATA SET ASSOCIATED WITH THE MODEL.

      INCLUDE     'CMBLOCK.INC'
      PARAMETER (LS=100)
      PARAMETER (MAXREG=7)
      PARAMETER (MAXKEY=100)

      COMMON /GENERAL/  NTPT,CIR(2)

      DIMENSION         P3D1(3,LS), P3DREF(3,LS)
      DIMENSION         CGV(3), CGR(3)
      DIMENSION         SHIFT(3)
      DIMENSION         ROT(3,3)

      CHARACTER*1       NULL
      CHARACTER*10      ANS

      DATA PI/3.141592654/
CNO_SAVE
C
C           GET REFERENCE 3D MODEL
C     POINTS IN FILES ARE ALREADY ABOUT THE CENTER OF GRAVITY

      WRITE(NOUT,*)'GETTING REFERENCE 3D MODEL...'
      CALL MRGET3D(P3DREF)
      NTOLD=NTPT
      WRITE(NOUT,*)'GETTING 3D MODEL TO BE ALIGNED...'
      CALL MRGET3D(P3D1)
      IF(NTOLD.NE.NTPT)  THEN
        WRITE(NOUT,*) ' Different number of 3D points in doc files.'
	RETURN
      ENDIF

C           CENTER POINTS ABOUT CENTER OF GRAVITY, GET COORDS
C           OF CENTER OF GRAVITY FOR EACH IMAGE

      CALL MRCG3(P3D1,CGV)
      CALL MRCG3(P3DREF,CGR)
	write(nout,1001)  cgv
1001	format(' Center of gravity of set to be aligned ',/,
     &		3(3x,1pe10.3))
	write(nout,1002)  cgr
1002	format(' Center of gravity of reference set',/,
     &		3(3x,1pe10.3))
	write(nout,1003)
1003	format(//
     &	'  Warning !  Both centers of gravity should be zero.',/,
     &  '             They are not corrected in this program.')

      CALL MRQUATER(P3DREF,P3D1,ROT)
      CALL MRROTATE(ROT,PHI,THETA,PSI)
      CALL MRSCALE3(P3DREF,P3D1,SCALE)
      CALL MRERROR(p3dref,p3d1,ntpt,PHI,THETA,PSI,SHIFT,SCALE,nout)
      CALL MRDOCCOR(SCALE,SHIFT,PSI,THETA,PHI)
      CALL MRNEWANGLE(PSI,THETA,PHI)
      END
