
#ifdef SP_DISTRIB 
 
C   THIS ROUTINE SPECIFIC TO WADSWORTH LABS AND IS NOT 
C       DISTRIBUTED TO OUTSIDE SITES
 
       SUBROUTINE mrmat2
 
       COMMON /UNITS/LUNC,NIN,NOUT
 
       WRITE(NOUT,*) 'DUMMY CALL: mrmat2'
       RETURN
       END
 
#else
 
      SUBROUTINE MRMAT2(IG,X0,Y0,A0,A,HS,EPS,IAUS)

C     SOLUTION OF THE LINEAR LEAST SQUARE FIT
C     SEPT , 1980, M.RADERMACHER

      COMMON /LSQG2/ISTOP,W(100),X(100),Y(100),AR(5,100),R(5),B(5,100),
     &   FL(100),ERG(5),FFF(100)
      COMMON /UNITS/LUNC,NIN,NOUT,NECHO,IFOUND,NPROC,NDAT
      IT=0
      WRITE(NOUT,888) IG,X0,Y0,A0,A,HS,EPS,IAUS
888   FORMAT(' MRMAT:',I3,6F10.2,I2)
      IKONV=0
      S=0.
   
C     START OF THE ITERATION

100   IT=IT+1
      S=0.

C     CALCULATION OF THE MATRICE B

      DO 1 LL=1,IG
      CALL MRGAUS2(A0,HS,A,X0,Y0,X(LL),Y(LL),FL(LL),W(LL),F,R,1,IAUS
     $)
       S=S+FL(LL)*FL(LL)
       IF(IAUS.GT.0) WRITE(NOUT,130) S
      DO 3 M=1,5
3     B(M,LL)=R(M)
      IF(IAUS.GT.0)WRITE(NOUT,200) K,L,LL,(B(M,LL),M=1,5)
200   FORMAT(' K,L,LL,B(M,LL):',3I4,5E11.4)
1     CONTINUE
      ZS=S
      IF(IAUS.GT.1) WRITE(NOUT,190) B
190   FORMAT(' B:'/1X,25(6E11.4/1X))

C     SET THE VALUES OF THE SYMMETRICAL MATRICE A EQUAL 0

      DO 4 K=1,6
      DO 5 L=1,5
5     AR(L,K)=0.
4     CONTINUE

C     CALCULATION OF THE SYMMETRICAL MATRICE A OF THE LINEAR
C     EQUATION SYSTEM.

      DO 6 K=1,5
      DO 7 L=1,5
      DO 8 LL=1,IG
8     AR(L,K)=AR(L,K)+B(K,LL)*B(L,LL)
7     CONTINUE
6     CONTINUE
      DO 9 K=1,5
      DO 10 L=1,IG
10    AR(K,6)=AR(K,6)+B(K,L)*FL(L)
9     CONTINUE
      IF(IT.GT.100) GOTO 13
13    CONTINUE
      IF (IAUS.GT.0) WRITE(NOUT,140) ((AR(I,K),K=1,6),I=1,5)
140   FORMAT(' AR',/1X,6E11.4)

C     SOLUTION OF THE LINEAR EQATION SYSTEM

      EPS2=0.000001
      CALL MIRCOL(5,1,6,AR,EPS2,ERG,IRTFLG)
      IF (IRTFLG .NE. 0) THEN
         WRITE(NOUT,180)
180      FORMAT(' *** SORRY, MATRIX ILL CONDITIONED')
         RETURN
      ENDIF
    
C     SAVE THE RESULTS OF THE LAST ITERATION

      ZA0=A0
      ZA=A
      ZHS=HS
      ZX0=X0
      ZY0=Y0

C     ADD THE CORRECTION TO THE FITTED PARAMETERS

      A0=A0+ERG(1)*0.2
      A=A+ERG(2)*.2
      HS=HS+ERG(3)*0.2
      X0=X0+ERG(4)*.2
      Y0=Y0+ERG(5)*.2
      WRITE(NOUT,150) ERG
150   FORMAT(' ERG:',5E11.4)
      WRITE(NOUT,160) A0,A,HS,X0,Y0
160   FORMAT(' A0,A,HS,X0,Y0',5E11.4)

C     CACULATION OF THE SQUARE SUM

50    S=0.
      DO 11 LL=1,IG
      CALL MRGAUS2(A0,HS,A,X0,Y0,X(LL),Y(LL),FL(LL),W(LL),F,R,0,IAUS
     $)
      FFF(LL)=F
      S=S+FL(LL)*FL(LL)
11    CONTINUE
      WRITE(NOUT,130) S
130   FORMAT(' SQUARE SUM:',E11.4)
      IF(IAUS.NE.0) WRITE(NOUT,310)
      IF(IAUS.NE.0) CALL MRNRM2(FFF,IG,20.,S0,1,1)
      IF(IAUS.NE.0) CALL MRKUR2(FFF,IG,S0,1)

C     CHECK THE SQUARE SUM. IF THE LAST SUM IS GREATER THE THE
C     SUM BEFORE RESTORE THE OLD PARAMETERS AND STOP THE ITERATIONS.

      IF(IKONV.EQ.1.)GOTO 55
      IF(S.LT.ZS.OR.IT.LT.2.OR.ISTOP.EQ.0)GOTO 51
      IKONV=1
      A0=ZA0
      A=ZA
      HS=ZHS
      X0=ZX0
      Y0=ZY0
      GOTO 50
51    IF((S.GT.EPS.AND.IT.LT.100).OR.IT.EQ.1) GOTO 100
55    WRITE(NOUT,350) IT
350   FORMAT(' ',I2,' ITERATIONEN')
      IAUS2=1
C      IF(JCHECK('!').EQ.0) GOTO 777
      CALL MRNRM2(W,IG,20.,S0,1,IAUS2)
      WRITE(NOUT,300)
300   FORMAT(' PEAK:')
      CALL MRKUR2(W,IG,S0,IAUS2)
      WRITE(NOUT,310)
310   FORMAT(' AUSGLEICHSKURVE:')
      CALL MRNRM2(FFF,IG,20.,S0,1,IAUS2)
      CALL MRKUR2(FFF,IG,S0,IAUS2)
777   CONTINUE
      DY=SQRT(S/(19*AR(5,5)))
      WRITE(NOUT,320) X0,Y0
320   FORMAT(' X0=',E11.4,'  Y0=',E11.4)
      RETURN
      END
 
#endif
 
