      SUBROUTINE MRPROJ(P3D, PRJ, ANGLE)
C
C *****************************************************
C MAKES PSUEDO-PROJ FROM 3-D DATA TO COMPARE WITH REAL
C PROJECTIONS.
C
C INPUT:
C     P3D(3,LS)= POINTS IN 3 COORDS
C     ANGLE(3,LV)= EULER ANGLES OF IMAGES (2 BEING TILT)
C COMMON INPUT:
C     NTPT= NUMBER TOTAL MARKERS
C     NTVW= NUMBER OF VIEWS
C     CIR(2)= COORDS OF CENTER OF IMAGE
C OUTPUT:
C     PRJ(2,LS,LV)= COORDS OF MARKERS IN PROJECTION. Z DATA INCLUDED
C        FOR COMPLETENESS
        PARAMETER (LV=300)
        PARAMETER (LS=100)
        PARAMETER (MAXREG=7)
        PARAMETER (MAXKEY=100)
        PARAMETER (MAXLOOP=999)
        REAL MAXPER
        PARAMETER (MAXPER=1.0e-6)
      LOGICAL*1   PTACTIVE(LS,LV),PARAMQ(4)
      COMMON /GENERAL/PTACTIVE,NUMPTS(LV),NTVW,NTPT,CIR(2),PARAMQ
      DIMENSION   P3D(3,LS), PRJ(2,LS,LV), ANGLE(3,LV)
CNO_SAVE
C ROTATE ABOUT Y, Z2 (THETA, PSI)
      DO  IVIEW=1,NTVW
        CY=COS(ANGLE(2,IVIEW))
        SY=SIN(ANGLE(2,IVIEW))
        DO  I=1,NTPT
          PRJ(1,I,IVIEW)=P3D(1,I)*CY - P3D(3,I)*SY
          PRJ(2,I,IVIEW)=P3D(2,I)
	ENDDO
      ENDDO
      END
