C++************************************************************************
C
C    MRQLI.FOR
C
C **************************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK            *
C *  COPYRIGHT (C)1981,1987, WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *  THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR       *
C *  LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR    *
C *  USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF     *
C *  THE CENTER FOR LABORATORIES AND RESEARCH                              *
C **************************************************************************
C
C   MRQLI.FOR
C
C        SUBROUTINE MRQLI(MAXMEM)
C         SUBROUTINE  MRQLI_P(ILIST,NSAM,NROW,NSI,NIMA,MODE,
C        SUBROUTINE  CROSRNG_D
C        SUBROUTINE  CROSRMG_D
C        SUBROUTINE  FOURING_M(CIRC,LCIRC,NUMR,NRING)
C        SUBROUTINE  ALRQ_M
C	CALL NORMAS(A,-NSAM/2,NSAM/2,-NROW/2,NROW/2,
C	CALL  ALRQ(A,NSAM,NROW,NUMR,REFER_CIRC(1,IMI),
C	CALL  FOURING
C
C--************************************************************************

	SUBROUTINE MRQLI(MAXMEM)
	PARAMETER  (NILMAX=10000)
	INTEGER*2  NUMR(3,480)
	INCLUDE 'CMBLOCK.INC' 
	COMMON  BUF(1024),ILIST(NILMAX),NUMR,BAF(1)
	DIMENSION Q(1)
	POINTER   (IPQ,Q) 
	LOGICAL         RUNTIME
C be careful with the common, it has to agree with 64 bits...
	COMMON  /FISPEC/  FINPAT,FINPIC,DOCFIL,NLET,NLETI
	CHARACTER*80  FINPAT,FINPIC,DOCFIL
	COMMON /MXR/ MAXRIN
	INTEGER*2  MAXRIN
	CHARACTER*1  NULL,MODE
	DATA  INPIC/77/
CNO_SAVE
	NULL=CHAR(0)
C  ASK FOR DATA FILE
	CALL  FILERD(FINPAT,NLET,NULL,
     &   'Enter template for 2-D reference image name',IRTFLG)
	CALL  FILERD(DOCFIL,NLETI,NULL,'Selection doc',IRTFLG)
         K=0
         K2=1
         NIMA=0
778      LERR=-1
         IF(NIMA.EQ.NILMAX)  THEN
         WRITE(NOUT,*) '  Too many images, list truncated'
         GOTO  779
         ENDIF
         KP1=K+1
         CALL  UNSAV(DOCFIL,K,INPIC,KP1,BUF,1,LERR,K2)
         IF(LERR.EQ.0)  THEN
         NIMA=NIMA+1
         ILIST(NIMA)=BUF(1)
         K=K+1
         GOTO  778
         ENDIF
779      CLOSE(INPIC)
         IF(NIMA.GT.0)  THEN
         WRITE(NOUT,2001) NIMA
2001     FORMAT('  Number of images =',i5)
         ELSE
         WRITE(NOUT,*)  '  No images !'
         RETURN
         ENDIF
         CALL  FILGET(FINPAT,FINPIC,NLET,ILIST(1),INTFLG)
         CALL  OPENFB(BUF,FINPIC,INPIC,NSAM,NROW,'O',NF,NSL)
         IF(NF.NE.2)  THEN
         CALL ERRT(4,'AP MQ ',NE)
         RETURN
         ENDIF
         CLOSE(INPIC)
C
	CALL  RDPRMI(NSI,NR,NLOOP,ILOOP,'EXPECTED SIZE OF THE OBJECT')
	IF(NSI.GE.NSAM)  THEN
         WRITE(NOUT,*) ' Object size cannot be larger than window size'
         NSI=NSAM
         WRITE(NOUT,*) ' Object size set to',NSI
	ENDIF
	NSI=MAX0(0,NSAM-NSI)/2
	LTR=(2*NSI+1)**2
	WRITE(NOUT,*) ' Shifts will be in the range +/-',NSI
C
         CALL  RDPRMI(MR,NR,NLOOP,ILOOP,'FIRST AND LAST RING')
         IF(NR.GT.NSAM/2-1)  THEN
         NR=NSAM/2-1
         WRITE(NOUT,*)  ' Last ring limited to ',NR
         ENDIF
         MR=MAX0(2,MIN0(NR,MR))
         ISKIP=1
         MODE='F'
         NRING=0
         DO    I=MR,NR,ISKIP
         NRING=NRING+1
         NUMR(1,NRING)=I
	 ENDDO
C
         CALL  ALPRBS(NUMR,NRING,LCIRC,MODE)
         MAXRIN=NUMR(3,NRING)
C
C   memory division    K
C       numr           1  !int*2
C       a              2
C       a_circ         3
C       refer_circ     4
C       rotmp          5 
C       fit            6  !double precision *9
C       tt             7  !double precision 
C       wr             8  
C       tota           9 !double precision 
C       tot           10
C       tmta          11 !double precision 
C       tmt           12
C       temp          15   !double precision (not in MP)
C
C
C K1 not used
        K1=-1
        K2=1
         K3=IPALIGN64(K2+NSAM*NROW)
         K4=IPALIGN64(K3+LCIRC)
         K5=IPALIGN64(K4+LCIRC*NIMA)
         K6=IPALIGN64(K5+9)
         K7=IPALIGN64(K6+9*2)
#ifdef SP_LIBFFT
         K8=IPALIGN64(K7+(LCIRC+15)*2)
#else
         K8=K7
#endif
         K9=IPALIGN64(K8+NRING)
         K10=IPALIGN64(K9+NIMA*2)
         K11=IPALIGN64(K10+NIMA)
         K12=IPALIGN64(K11+NIMA*2)
         K13=IPALIGN64(K12+NIMA)
         K14=K13
         K15=K14
#ifdef SP_MP
         K16=K15
#else
         K16=IPALIGN64(K15+4*MAXRIN)
#endif
        MEMTOT=K16
        MAXM=MAXMEM-1024-NILMAX-3*480/2
        CALL CHKMEM(MEMTOT,BAF,MAXM,RUNTIME,IPQ,IRTFLG)
              IF(IRTFLG.NE.0)  THEN
                CLOSE(INPIC)
                CALL  ERRT(6,'AP MQ',NE)
                RETURN
              ENDIF
	WRITE (NOUT,2500)  MEMTOT
C
C NIMA number of the reference images
C
         CALL  MRQLI_P(ILIST,NSAM,NROW,NSI,NIMA,MODE,
     &          Q(K2),Q(K3),Q(K4),
     &          Q(K5),Q(K6),Q(K7),Q(K8),
     &          Q(K9),Q(K10),Q(K11),Q(K12),
     &          Q(K15),
     &          LCIRC,NUMR,NRING,MAXRIN)
C
      IF(RUNTIME)  CALL ALLOCIT(0,RUNTIME,IPQ,'AP MQ',IRTFLG)
         WRITE (NOUT,2600)
         RETURN
2500     FORMAT (/,' MEMORY RESERVATION: YOU HAVE',
     #   ' ALLOCATED ',I8)
2600     FORMAT (/' ',80('-')//' ',' Multi-reference alignment,  ',
     #   'end of computation',//' ',80('-')/)
         END
