C
C++************************************************************************
C
C $$ MRQLI_P.FOR
C
C **************************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK            *
C *  COPYRIGHT (C)1981,1987, WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *  THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR       *
C *  LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR    *
C *  USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF     *
C *  THE CENTER FOR LABORATORIES AND RESEARCH                              *
C **************************************************************************
C
C
C
C23456789012345678901234567890123456789012345678901234567890123456789012
C--************************************************************************
C
C $$ MRQLI_P.FOR
C
         SUBROUTINE  MRQLI_P(ILIST,NSAM,NROW,NSI,NIMA,MODE,
     &   A,A_CIRC,REFER_CIRC,
     &	 ROTMP,FIT,TT,WR,
     &	 TOTA,TOT,TMTA,TMT,
#ifdef SP_MP
     &   TEMP_,
#else
     &   TEMP,
#endif
     &   LCIRC,NUMR,NRING,MAXRIN)
        PARAMETER (NDLI=7)
        COMMON  BUF(1024)
        DIMENSION DLIST(NDLI)
	INCLUDE 'CMBLOCK.INC'
        DIMENSION  A(NSAM,NROW),WRK(1),ILIST(NIMA)
        INTEGER*2  NUMR(3,NRING),MAXRIN
#ifdef SP_MP
	DOUBLE PRECISION TEMP_
#else
	DOUBLE PRECISION TEMP(MAXRIN,2)
#endif
	DOUBLE PRECISION TT(*)
	DIMENSION  WR(NRING)
	DIMENSION  A_CIRC(LCIRC),REFER_CIRC(LCIRC,NIMA)
	DOUBLE PRECISION  TOTA(NIMA),TMTA(NIMA)
	DIMENSION  TOT(NIMA),TMT(NIMA)
	DIMENSION  ROTMP(-1:1,-1:1)
	DOUBLE PRECISION  QT,QM,PEAK,FIT(-1:1,-1:1)
        CHARACTER*1  MODE,NULL
        COMMON  /FISPEC/  FINPAT,FINPIC,DOCFIL,NLET,NLETI
        CHARACTER*80  FINPAT,FINPIC,DOCFIL
        DATA  NDOC/56/,INDOC/57/,INPIC/58/
C -------------------------
CNO_SAVE
	CALL  RINGWE(WR,NUMR,NRING,MAXRIN)
#ifdef SP_LIBFFT
	IP=MAXRIN
	CALL  DZFFT1DUI(IP,TT)
#endif
C
	NSNR=NSAM*NROW
	LO=2*NSI+1
	LT=LO*LO
C  Calculate dimensions for NORMAS
	NSB=-NSAM/2
	NSE=-NSB-1+MOD(NSAM,2)
	NRB=-NROW/2
	NRE=-NRB-1+MOD(NROW,2)
C
C PREPARE REFERENCES
C
C do it for all the reference images
	DO    IMI=1,NIMA
	L=ILIST(IMI)
	NULL=CHAR(0)
	CALL  FILGET(FINPAT,FINPIC,NLET,L,INTFLAG)
	CALL  OPENFB(BUF,FINPIC,INPIC,NSAMT,NROWT,'O',NF,NSL)
         IF(NF.NE.2)  THEN
         WRITE(NOUT,*)  ' FILE NOT FOUND:',FINPIC
         RETURN
         ENDIF
	DO    J=1,NROW
	CALL  REDLIN(INPIC,A(1,J),NSAM,J)
	ENDDO
	CLOSE(INPIC)
C
C  Normalize under the mask
C
	CALL NORMAS(A,NSB,NSE,NRB,NRE,NUMR,NUMR(1,NRING))
	CALL  ALRQ(A,NSAM,NROW,NUMR,REFER_CIRC(1,IMI),
     &		LCIRC,NRING,MODE,IPIC)
	CALL  FRNG(REFER_CIRC(1,IMI),LCIRC,NUMR,NRING)
	CALL  APPLYW(REFER_CIRC(1,IMI),LCIRC,NUMR,WR,NRING,MAXRIN)
	ENDDO
c find max element on  ILIST
	MAXIMA=ILIST(1)
	DO  IMI=1,NIMA
	MAXIMA=MAX(MAXIMA,ILIST(IMI))
	ENDDO
C!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
C  alignment
C!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
C
C  images to be aligned
        NULL=CHAR(0)
	CALL  FILERD(FINPAT,NLET,NULL,
     &   'Enter template for 2-D image name',IRTFLG)
	CALL  FILERD(DOCFIL,NLETI,NULL,'Selection doc',IRTFLG)
	K=0
	K2=1
	IMI=0
878      LERR=-1
         KP1=K+1
	CALL  UNSAV(DOCFIL,K,INDOC,KP1,WRK,1,LERR,K2)
	IF(LERR.EQ.0)  THEN
	IMI=IMI+1
C
	LIM=WRK(1)
	NULL=CHAR(0)
	CALL  FILGET(FINPAT,FINPIC,NLET,LIM,INTFLAG)
	CALL  OPENFB(BUF,FINPIC,INPIC,NSAMT,NROWT,'O',NF,NSL)
         IF(NF.NE.2)  THEN
         WRITE(NOUT,*)  ' FILE NOT FOUND:',FINPIC
         RETURN
         ENDIF
        IF(NSAMT.NE.NSAM.OR.NROWT.NE.NROW)  THEN
        CALL ERRT(1,'AP MQ',NE)
        CLOSE(INPIC)
	RETURN
	ENDIF
	DO    J=1,NROW
	CALL  REDLIN(INPIC,A(1,J),NSAM,J)
	ENDDO
	CLOSE(INPIC)
        DLIST(5)=-1.0E23
	QT=-1.0D23
	QM=-1.0D23
c go through centers
	DO    JT=-NSI,NSI
	CNR2=NROW/2+1+JT
	DO    IT=-NSI,NSI
	CNS2=NSAM/2+1+IT
C
C  Normalize under the mask
C
	CALL NORMAS(A,NSB-IT,NSE-IT,NRB-JT,NRE-JT,NUMR,NUMR(1,NRING))
	CALL  ALRQ_M
     &   (A,NSAM,NROW,CNS2,CNR2,NUMR,A_CIRC,LCIRC,NRING,MODE)
	CALL  FRNG(A_CIRC,LCIRC,NUMR,NRING)
c$doacross local(ir)
	DO    IR=1,NIMA
	CALL  CROSRNG_M
     &		(REFER_CIRC(1,IR),A_CIRC,LCIRC,NRING,
#ifdef SP_MP
     &			TEMP_,TEMP_,
#else
     &			TEMP,TEMP(1,2),
#endif
     &		MAXRIN,NUMR,TOTA(IR),TOT(IR),TMTA(IR),TMT(IR),TT)
	ENDDO 
C  END-OF-LOOP 1 OVER REFERENCE IMAGES
	DO    IR=1,NIMA
	IF(TOTA(IR).GE.QT)  THEN
	QT=TOTA(IR)
	IBE=IR
	ISX=IT
	ISY=JT
	D4=ANG(TOT(IR),MODE)
	D6=ILIST(IR)
	ENDIF
	IF(TMTA(IR).GE.QM)  THEN
	QM=TMTA(IR)
	IME=IR
	IMX=IT
	IMY=JT
	E4=ANG(TMT(IR),MODE)
	E6=ILIST(IR)
	ENDIF
	ENDDO
	ENDDO
	ENDDO
C TRY TO INTERPOLATE
	IF(QT.GT.QM)  THEN
        DLIST(2)=D6
	IF(IABS(ISX).NE.NSI.AND.IABS(ISY).NE.NSI)  THEN
C  HAVE TO FIND NEIGHBOURING VALUES
	FIT(0,0)=QT
	ROTMP(0,0)=D4
	DO     JT=-1,1
	DO     IT=-1,1
	IF(IT.NE.0 .OR. JT.NE.0) THEN
	CNR2=NROW/2+1+JT+ISY
	CNS2=NSAM/2+1+IT+ISX
	CALL NORMAS(A,
     &	NSB-(IT+ISX),NSE-(IT+ISX),NRB-(JT+ISY),NRE-(JT+ISY),
     &	NUMR,NUMR(1,NRING))
	CALL  ALRQ_M
     &   (A,NSAM,NROW,CNS2,CNR2,NUMR,A_CIRC,LCIRC,NRING,MODE)
	CALL  FRNG(A_CIRC,LCIRC,NUMR,NRING)
	CALL  CROSRNG_D
     &		(REFER_CIRC(1,IBE),A_CIRC,LCIRC,NRING,
#ifdef SP_MP
     &			TEMP_,TEMP_,
#else
     &			TEMP,TEMP(1,2),
#endif
     &		MAXRIN,NUMR,FIT(IT,JT),ROTMP(IT,JT),TT)
	ROTMP(IT,JT)=ANG(ROTMP(IT,JT),MODE)
	ENDIF
	ENDDO
	ENDDO
C make all the angles in ROTMP similar to the central one
C  (problem of modulus 360 degs)
C  It is assumed that angles have range (-180,180), as given by ANG()
	DIPX=ROTMP(0,0)
	DO     JT=-1,1
	DO     IT=-1,1
	IF(IT.NE.0 .OR. JT.NE.0) THEN
	IF(ABS(ROTMP(IT,JT)-DIPX).GE.180.0) THEN
	IF(ROTMP(IT,JT).GT.0.0)  THEN
	ROTMP(IT,JT)=ROTMP(IT,JT)-360.0
	ELSE
	ROTMP(IT,JT)=ROTMP(IT,JT)+360.0
	ENDIF
	ENDIF
	ENDIF
	ENDDO
	ENDDO
	CALL  PARABLD(FIT,SX,SY,PEAK)
C CHECK WHETHER INTERPOLATION IS OK.
	IF(ABS(SX).LT.1.0 .AND. ABS(SY).LT.1.0)  THEN
	IQX=IFIX(SX+1.0)
	DIPX=SX+1-IQX
	IQY=IFIX(SY+1.0)
	DIPY=SY+1-IQY
	IQX=IQX-1
	IQY=IQY-1
	D4=
     1     +ROTMP(IQX,IQY)+DIPY*(ROTMP(IQX,IQY+1)-ROTMP(IQX,IQY))
     2     +DIPX*(ROTMP(IQX+1,IQY)-ROTMP(IQX,IQY)
     3          +DIPY*(ROTMP(IQX+1,IQY+1)-ROTMP(IQX+1,IQY)
     4          -ROTMP(IQX,IQY+1)+ROTMP(IQX,IQY)))
	SX=SX+ISX
	SY=SY+ISY
	D5=PEAK
	ELSE
C INTERPOLATION FAILED
	D5=QT
	SX=ISX
	SY=ISY
	ENDIF
	ELSE
	D5=QT
	SX=ISX
	SY=ISY
	ENDIF
	ELSE
        DLIST(2)=E6+MAXIMA
C INTERPOLATE FOR MIRRORED
	IF(IABS(IMX).NE.NSI.AND.IABS(IMY).NE.NSI)  THEN
C  HAVE TO FIND NEIGHBOURING VALUES
	FIT(0,0)=QM
	ROTMP(0,0)=E4
	DO     JT=-1,1
	DO     IT=-1,1
	IF(IT.NE.0 .OR. JT.NE.0) THEN
	CNR2=NROW/2+1+JT+IMY
	CNS2=NSAM/2+1+IT+IMX
	CALL NORMAS(A,
     &	NSB-(IT+IMX),NSE-(IT+IMX),NRB-(JT+IMY),NRE-(JT+IMY),
     &	NUMR,NUMR(1,NRING))
	CALL  ALRQ_M
     &   (A,NSAM,NROW,CNS2,CNR2,NUMR,A_CIRC,LCIRC,NRING,MODE)
	CALL  FRNG(A_CIRC,LCIRC,NUMR,NRING)
	CALL  CROSRMG_D
     &		(REFER_CIRC(1,IME),A_CIRC,LCIRC,NRING,
#ifdef SP_MP
     &			TEMP_,TEMP_,
#else
     &			TEMP,TEMP(1,2),
#endif
     &		MAXRIN,NUMR,FIT(IT,JT),ROTMP(IT,JT),TT)
	ROTMP(IT,JT)=ANG(ROTMP(IT,JT),MODE)
	ENDIF
	ENDDO
	ENDDO
C make all the angles in ROTMP similar to the central one
C  (problem of modulus 360 degs)
C  It is assumed that angles have range (-180,180), as given by ANG()
	DIPX=ROTMP(0,0)
	DO     JT=-1,1
	DO     IT=-1,1
	IF(IT.NE.0 .OR. JT.NE.0) THEN
	IF(ABS(ROTMP(IT,JT)-DIPX).GE.180.0) THEN
	IF(ROTMP(IT,JT).GT.0.0)  THEN
	ROTMP(IT,JT)=ROTMP(IT,JT)-360.0
	ELSE
	ROTMP(IT,JT)=ROTMP(IT,JT)+360.0
	ENDIF
	ENDIF
	ENDIF
	ENDDO
	ENDDO
	CALL  PARABLD(FIT,SX,SY,PEAK)
C CHECK WHETHER INTERPOLATION IS OK.
	IF(ABS(SX).LT.1.0 .AND. ABS(SY).LT.1.0)  THEN
	IQX=IFIX(SX+1.0)
	DIPX=SX+1-IQX
	IQY=IFIX(SY+1.0)
	DIPY=SY+1-IQY
	IQX=IQX-1
	IQY=IQY-1
	D4=
     1     +ROTMP(IQX,IQY)+DIPY*(ROTMP(IQX,IQY+1)-ROTMP(IQX,IQY))
     2     +DIPX*(ROTMP(IQX+1,IQY)-ROTMP(IQX,IQY)
     3          +DIPY*(ROTMP(IQX+1,IQY+1)-ROTMP(IQX+1,IQY)
     4          -ROTMP(IQX,IQY+1)+ROTMP(IQX,IQY)))
	SX=SX+IMX
	SY=SY+IMY
	D5=PEAK
C INTERPOLATION FAILED
	SX=IMX
	SY=IMY
	D4=E4
	D5=QM
	ENDIF
	ELSE
	SX=IMX
	SY=IMY
	D4=E4
	D5=QM
	ENDIF
	ENDIF
C
	SX=-SX
	SY=-SY
C  Now have to change order of shift&rotation.
C  In this program image is shifted first, rotated second.
C  In RT SQ it is rotation first, shift second.
C  This part corresponds to SA P.
	CO=COSD(D4)
	SO=-SIND(D4)
	XSHSUM=SX*CO-SY*SO
	YSHSUM=SX*SO+SY*CO
C output (in DLIST position is increased by 1, #1 is the key).
c 1 - Number of the most similar reference projection.
c 2 - Not-normalized correlation coefficient.
c 3 - Psi angle. (in=plane rotation)
c 4 - SX
c 5 - SY
c 6 - input image number.
        DLIST(3)=D5
        DLIST(4)=D4
        DLIST(5)=XSHSUM
        DLIST(6)=YSHSUM
        DLIST(7)=LIM
        DLIST(1)=IMI
        CALL  SAVD(NDOC,DLIST,NDLI,IRTFLG)
C---------------------------------------------------------------------
	K=K+1
	GOTO  878
	ENDIF
879	CLOSE(INDOC)
	CLOSE(NDOC)
        CALL  SAVDC
	END
