
C++*************************************************************************
C
C MRREFL.FOR                             FILENAMES LENGTHENED JAN 89 al
C
C **************************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.                             *
C *  COPYRIGHT (C)1981,1987, WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH 			   *
C **************************************************************************
C
C       MRREFL
C
C--*******************************************************************

	SUBROUTINE MRREFL

        INCLUDE 'CMBLOCK.INC'

        COMMON ADUM(80),BUF(500)
        COMMON /COMMUN/ FNAM,OUTP

        CHARACTER *81 FNAM,OUTP
        CHARACTER *1  NULL

        NULL=CHAR(0)

	LUN1 = 11
	LUN2 = 12

	CALL FILERD(FNAM,NLET,NULL,'INPUT',IRTFLG)
        IF (IRTFLG .NE. 0) RETURN
	CALL FILERD(OUTP,NLET,NULL,'OUTPUT',IRTFLG)
        IF (IRTFLG .NE. 0) RETURN

        CALL RDPRM(FCT,NLOOP,ILOOP,'INTERPOLATION FACTOR OF INPUT')
  	CALL RDPRM2(BETA,FBET,NLOOP,ILOOP,'ILLUMIN. ANGLE, INTENSITY')
	CALL RDPRM(DIF,NLOOP,ILOOP,'MIX FACTOR')
	IF (FCT.EQ.0) FCT=1.
	NSLICE=1
	CALL OPENF(FNAM,LUN1,NSAM,NROW,'OLD',NF1,NSLICE)
	CALL OPENF(OUTP,LUN2,NSAM,NROW,'UNKNOWN',NF2,NSLICE)
	PI   = 3.142
	BETA = BETA/180*PI
	SB   = SIN(BETA)
	CB   = COS(BETA)
C       ERROR: THIS WILL NOT WORK ON SHORT IMAGES SHOULD USE REDHED al
	CALL REDLIN(LUN1,BUF,NSAM,0)
	FMIN = BUF(8)
	FMAX = BUF(7)
	CALL NORM3(LUN1,NSAM,NROW,NSLICE,FMAX,FMIN,AV)
	DO L=1,NROW-1
	   CALL REDLIN(LUN1,BUF,NSAM,L)
	   CALL REDLIN(LUN1,BUF(NSAM+1),NSAM,L+1)
	   NNEW = 2*NSAM
           BUF(NNEW+NSAM)=0.
	
           DO I=1,NSAM-1
              BUF(NNEW+I)=0.
              I1=I
              I2=I+1
              I3=I+NSAM
              A1=BUF(I1)-FMIN
              A2=BUF(I2)-FMIN
              A3=BUF(I3)-FMIN
              IF(A1.LE.0.001) GOTO 2
              IF(A2.LE.0.001) GOTO 2
              IF(A3.LE.0.001) GOTO 2
              AD=DIF*(A1+A2+A3)/(3*(FMAX-FMIN))
              XX=(A1-A2)*FCT
              YY=(A1-A3)*FCT
C             INCIDENT SECOND LIGHT VECTOR:
              XS=CB
              YS=0
              ZS=SB
              XS2=XS*XS
              ZS2=ZS*ZS
              SABS=SQRT(XS2+ZS2)

              X2=XX*XX
              Y2=YY*YY
              CABS=SQRT(X2+Y2+1)
              CS=1./CABS
              SI=CS
              R=ABS(A1)
C             SPECULAR REFLECTION:
C             N*L:      
              XS1=XX*XS+ZS
              RX=2*XX*XS1-XS
              RY=2*YY*XS1-YS
              RZ=2*1*XS1-ZS
C             INTENSITY IN Z-COMPONENT, WHICH IS THE ONE ONE SEES:
              IF(RZ.LT.0) THEN
                 RIZ=0
              ELSE
                 RIZ=RZ/SQRT(RX*RX+RY*RY+RZ*RZ)
              ENDIF         
      
              BUF(NNEW+I)=SI-AD+DIF+RIZ*FBET
2	      CONTINUE
           ENDDO
           BUF(NNEW+NSAM)=0.
           CALL WRTLIN(LUN2,BUF(NNEW+1),NSAM,L)
        ENDDO

	DO  I=1,NSAM
           BUF(I)=0.0
        ENDDO
  
        CALL WRTLIN(LUN2,BUF(1),NSAM,NROW)
	CLOSE(11)
	CLOSE(12)

	RETURN
	END

