      SUBROUTINE MRREPLACE(LUN1,LUN2)
C 
C SUBROUTINE TO REPLACE THE 3D FOURIER TRANSFORM IN THE RANGE OF 
C MEASURED DATA (+- ALPHA FOR SINGLE AXIS TILTING, OUTSIDE THE
C MISSING CONE FOR CONICAL DATA).
C PART OF MODULAR POCS IN SPIDER. 
C THE PROGRAM USES THE SIMPLE 3D FOURIER FORMAT (-9)
C M.R. DEC.91
C
C CHANGED TO 'NEW' 3D FOURIER FORMAT, MAI 97, M.R.
C 
      INCLUDE 'CMBLOCK.INC'
      PARAMETER (LINDIM=2050)
      COMMON DUMMY(80),FBUFW(LINDIM),FBUFD(LINDIM)
      COMMON /COMMUN/ FIL1,FIL2
      CHARACTER*81 FIL1,FIL2
      CHARACTER*1 NULL,SC
      LOGICAL SFLAG,CFLAG,nflag
      NULL=CHAR(0)
      PI=3.141593
      DTOR=1/180.*PI
      WRITE(NOUT,*) 'THIS FILE WILL BE OVERWRITTEN:'
      CALL FILERD(FIL1,NLET,NULL,'WORK',IRTFLG)
      IF(FIL1(1:1).EQ.'*') RETURN
      CALL OPENFB(FBUFW,FIL1,LUN1,NSAMSW,NROWW,'OLD',IER,NSLICEW)
c      IF(IFORM.NE.-9) THEN
c      WRITE(NOUT,100) IFORM
100   FORMAT(1X,'INPUT1 HAS WRONG FORMAT, IFORM=',I3,'  MUST BE -9')
c      RETURN
c      ENDIF
      IF(NSAMSW.GT.LINDIM) THEN 
      WRITE(NOUT,105) LINDIM
105   FORMAT(1X,'SORRY, X-DIMENSION TOO LARGE, MAXIMUM IS ',I6)
      RETURN
      ENDIF
      CALL FILERD(FIL2,NLET,NULL,'DATA ',IRTFLG)
c      IF(IFORM.NE.-9) THEN
c      WRITE(NOUT,101) IFORM
c101   FORMAT(1X,'INPUT2 HAS WRONG FORMAT, IFORM=',I3,'  MUST BE -9')
c      CLOSE(LUN1)
c      RETURN
c      ENDIF
      IF(FIL1(1:1).EQ.'*') THEN
      CLOSE(LUN1)
      RETURN
      ENDIF
      CALL OPENFB(FBUFD,FIL2,LUN2,NSAMD,NROWD,'OLD',IER,NSLICED)
      IF(NSAMD.NE.NSAMSW.OR.NROWD.NE.NROWW.OR.NSLICED.NE.NSLICEW) THEN
      CLOSE(LUN1)
      CLOSE(LUN2)
      WRITE(NOUT,*) 'INCONSISTENT VOLUME DIMENSIONS'
      RETURN
      ENDIF
      NA=1
110   CALL RDPRMC(SC,NA,.TRUE.,
     $ '(S)SINGLE AXIS OR (C)ONICAL, (N)TN reduction$',NULL,IRT)
      SFLAG=.FALSE.
      CFLAG=.FALSE.
      nflag=.false.
      IF (SC.EQ.'S') SFLAG=.TRUE.
      IF (SC.EQ.'C'.or.sc.eq.'N') CFLAG=.TRUE.
      if(sc.eq.'N') nflag=.true.
      IF(.NOT.SFLAG.AND..NOT.CFLAG) THEN
      WRITE(NOUT,*) 
     $'Try answering this question again, THANKS'
      GOTO 110
      ENDIF

      if(nflag) then
          if((nsamd-2).ne.nrowd) then
           write(nout,*) 'implemented only for square projections'
           close(lun1)
           close(lun2)
           return
          endif
       call rdprm(fact,nloop,iloop,
     $ 'factor for zero range calculation (def=0.875)$')
       if(fact.le.0) fact=0.875
       factl=(fact/pi)**2
      endif
      IF(SFLAG) THEN 
C CORRECTION: DALPHU is lower tilt angle, DALPHL is higher tilt
c             angle. Sign is chaged to make it consistent with 
c             what comes from the microscope.
       CALL RDPRM2(DALPHU,DALPHL,NLOOP,ILOOP,
     $'LOWER,UPPER TILT ANGLE$')
       DALPHU=-DALPHU
       DALPHL=-DALPHL
      ENDIF

      IF(CFLAG) THEN 
      CALL RDPRM2(DALPHL,rmax,NLOOP,ILOOP,
     $'TILT ANGLE$')
      DALPHU=DALPHL 
      ENDIF

      ALPHL=DALPHL*DTOR
      ALPHU=DALPHU*DTOR
      cosalp2=cos(alphl)**2
      IREADO=0
      NS2=NSLICEW/2
      NR2=NROWW/2

C DO THE REPLACE FOR SINGLE AXIS:
      BORDERU=1024
      BORDERL=1024
      SU=SIN(ALPHU)
      SL=SIN(ALPHL)
      IF(SU.NE.0) BORDERU=COS(ALPHU)/SU
      IF(SL.NE.0) BORDERL=COS(ALPHL)/SL
      IXA=1
      DO  L=1,NSLICEW
      LZ=L-NSLICEW/2-1
      IF(LZ.GE.0) XBORDER=ABS(LZ*BORDERU)
      IF(LZ.LT.0) XBORDER=ABS(LZ*BORDERL)
      RAD2=XBORDER*XBORDER
      IXB=XBORDER+1+.5
      IXB=2*IXB-1
c      LINEZ=(L-1)*NROWW
      LLZ=LZ
      IF(LZ.EQ.-NS2) LLZ=-LZ
       if(nflag) then 
       rad2=factl*llz*llz 
       endif
      DO   K=1,NROWW
      KY=K-NROWW/2-1
      RY2=KY*KY
c      LINE=LINEZ+K
      KKY=KY
      IF(KKY.EQ.-NR2) KKY=-KKY
C
      LINE=LINE3DF(KKY,LLZ,NROWW,NSLICEW)
      CALL REDLIN(LUN1,FBUFW,NSAMSW,LINE)
      CALL REDLIN(LUN2,FBUFD,NSAMD,LINE)
      
      IF(SFLAG) IXA=IXB
      DO 13 I=IXA,NSAMSW,2
C FOR CONICAL TILTS MAKE A CIRCLE:
       IF(CFLAG) THEN
         RX=INT(I/2.)
         RX2=RX*RX
         if(nflag)rx2=rx2*cosalp2
         RAD=RY2+RX2
         IF(NSAMSW.LE.10) WRITE(NOUT,401) RX,RX2,RY2,RAD,RAD2
401      FORMAT(' RX,RX2,RY2,RAD,RAD2:',5F12.4)

         IF(RAD.LT.RAD2) GOTO 13
       ENDIF
      FBUFW(I)=FBUFD(I)
      FBUFW(I+1)=FBUFD(I+1)
13    CONTINUE
      IF(NSAMSW.LE.10)WRITE(NOUT,400) 
     $KY,LZ,LINE,IXB,(FBUFW(LL),LL=1,NSAMSW)
400   FORMAT(1X,'Ky:',I3,' LZ:',I3,' li:',i3,' IXB:',I3,
     $/' B:',10(1X,E10.4))
      CALL WRTLIN(LUN1,FBUFW,NSAMSW,LINE)
      ENDDO
      ENDDO
      CLOSE(LUN1)
      CLOSE(LUN2)
      RETURN
      END

C     -----------------------------------------------------------------


      INTEGER FUNCTION LINE3DF(KY,KZ,NROW,NSLICE)
      
C     FUNCTION TO FIND A LINE IN THE CURRENT (5/97) 3D FOURIER TRANSFORM
C     IN SPIDER
C     AUTHOR: M.RADERMACHER, 5/97 
      
      LINZ    = (KZ+NSLICE)
      LINZ2   = MOD(LINZ,NSLICE)
      LINZ3   = LINZ2*NROW
     
      LINE    = (KY + NROW) 
      LINE2   = MOD(LINE,NROW)
      LINE3   = LINZ3+LINE2+1
      LINE3DF = LINE3

      RETURN
      END

