      SUBROUTINE MRRLINE(X,Y,NDATA,NDIM,A,B,SIGA,SIGB,CHI2)
C
C     CALCULATES THE LINEAR REGRESSION WITHOUT WEIGHTING
C     SOLVES FOR Y=A+BX (VARIABLE NAMES CORRESPOND)
C     SIGA AND SIGB ARE PROBABLY UNCERTAINTIES RETURNED, ALONG
C     WITH RETURNING A AND B.
C     X AND Y ARE DATA INPUT ARRAYS OF SIZE NDATA
C
      DIMENSION X(NDIM),Y(NDIM)
CNO_SAVE
C
      SX=0.
      SY=0.
      ST2=0.
      B=0.
      DO  I=1,NDATA
        SX=SX+X(I)
        SY=SY+Y(I)
      ENDDO
      SS=FLOAT(NDATA)
      SXOSS=SX/SS
      DO  I=1,NDATA
        T=X(I)-SXOSS
        ST2=ST2+T*T
        B=B+T*Y(I)
      ENDDO
      B=B/ST2
      A=(SY-SX*B)/SS
      SIGA=SQRT((1.+SX*SX/(SS*ST2))/SS)
      SIGB=SQRT(1./ST2)
      CHI2=0.
      DO  I=1,NDATA
        CHI2=CHI2+(Y(I)-A-B*X(I))**2
      ENDDO
      SIGDAT=SQRT(CHI2/(NDATA-2))
      SIGA=SIGA*SIGDAT
      SIGB=SIGB*SIGDAT
      END
