      SUBROUTINE MRROTATE(ROT, PHI, THETA, PSI)

C *********************************************************
C   TAKES IN ROTATION MATRIX AND RETURNS THE ANGLES USED TO
C    UNDO THAT MATRIX, USING EULER ANGLES.  ROTATION DONE
C    ABOUT Z(PHI), THEN NEW Y(THETA), THEN NEW Z(PSI).
C    OUTPUTS ANGLES TO CHANGE, IN ORDER, TO MATCH VPT TO RPT.
C
C INPUT:
C     ROT(3,3) = ROTATION MATRIX
C OUTPUT
C     PHI, THETA, PSI = ANGLES IN RADIANS
C
C *********************************************************
        INCLUDE 'CMBLOCK.INC'
      DIMENSION ROT(3,3)
      DOUBLE PRECISION  R3(3,3)
	data  deps/1.0d-7/
CNO_SAVE
c
	DO    I=1,3
	DO   J=1,3
	R3(I,J)=ROT(I,J)
	ENDDO
	ENDDO
c<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
c  Limit precision
	do    j=1,3
	do    i=1,3
	if(dabs(r3(i,j)).lt.deps)  r3(i,j)=0.0d0
	if(r3(i,j)-1.0d0.gt.-deps)  r3(i,j)=1.0d0
	if(r3(i,j)+1.0d0.lt.deps)  r3(i,j)=-1.0d0
	enddo	
	enddo
	if(r3(3,3).eq.1.0)  then
	theta=0.0
	psi=0.0
	if(r3(1,1).eq.0.0)  then
	phi=dasind(r3(1,2))
	else
	phi=datan2d(r3(1,2),r3(1,1))
	endif
	elseif(r3(3,3).eq.-1.0)  then
	theta=180.0
	psi=0.0
	if(r3(1,1).eq.0.0)  then
	phi=dasind(-r3(1,2))
	else
	phi=datan2d(-r3(1,2),-r3(1,1))
	endif
	else
	theta=dacosd(r3(3,3))
	st=dsign(1.0d0,DBLE(theta))
		if(r3(3,1).eq.0.0)  then
			if(st.ne.dsign(1.0d0,r3(3,2)))  then
			phi=270.0
			else
			phi=90.0
			endif
		else
       		phi=datan2d(r3(3,2)*st,r3(3,1)*st)
		endif
		if(r3(1,3).eq.0.0)  then
			if(st.ne.dsign(1.0d0,r3(2,3)))  then
			psi=270.0
			else
			psi=90.0
			endif
		else
		psi=datan2d(r3(2,3)*st,-r3(1,3)*st)
		endif
	endif
	if(psi.lt.0.0)  psi=psi+360.0
	if(theta.lt.0.0)  theta=theta+360.0
	if(phi.lt.0.0)  phi=phi+360.0
	 theta=THETA * 3.141592654/180
	 phi=phi* 3.141592654/180
	 psi=psi * 3.141592654/180
      END
