      SUBROUTINE MRSCALE(RPT, VPT, IVIEW, SCALEI)
C
C ************************************************************
C     COMPUTES THE SCALE FACTOR OF VPT WITH RESPECT TO RPT, USING ONLY
C     POINTS THEY HAVE IN COMMON. THIS THEN MUST BE APPLIED TO VPT
C     TO MAKE IT FIT TO RPT
C
C     USES ROOT OF RATIO BETWEEN SUM OF SQUARES OF COORDS OF RPT/VPT.
C
C INPUT:
C     RPT(3,LS)= COORDS OF POINTS IN REFERENCE VIEW
C     VPT(3,LS)= COORDS OF POINTS IN VIEW TO BE ADJUSTED
C     IVIEW= INDEX OF VIEW TO BE REFINED
C COMMON INPUT:
C     PTACTIVE(LS,LV)= BOOLEAN ARRAY REFERENCING POINTS TO BE USED
C          (ie. CAN BE FOUND IN VPT VIEW) .TRUE. IF USED
C     NUMPT(LV)= MAXIMUM INDEX OF POINTS USED IN VPT
C OUTPUT:
C     SCALEI= SCALE FACTOR OF VPT VIEW WITH RESPECT TO RPT VIEW
C

        PARAMETER (LV=300)
        PARAMETER (LS=100)
        PARAMETER (MAXREG=7)
        PARAMETER (MAXKEY=100)
        PARAMETER (MAXLOOP=999)
        REAL MAXPER
        PARAMETER (MAXPER=1.0e-6)
      LOGICAL*1   PTACTIVE(LS,LV),PARAMQ(4)
      COMMON /GENERAL/PTACTIVE,NUMPTS(LV),NTVW,NTPT,CIR(2),PARAMQ
      DIMENSION    RPT(2,LS), VPT(2,LS), SCALEI(LV)
	DOUBLE PRECISION  RSUM,VSUM
CNO_SAVE
C
      RSUM=0.0
      VSUM=0.0
C       SUMS UP THE SQUARES OF THE COORDS
      DO  M=1,NUMPTS(IVIEW)
        IF(PTACTIVE(M,IVIEW)) THEN
          RSUM=RSUM+RPT(1,M)*DBLE(RPT(1,M))
     &			+RPT(2,M)*DBLE(RPT(2,M))
          VSUM=VSUM+VPT(1,M)*DBLE(VPT(1,M))
     &			+VPT(2,M)*DBLE(VPT(2,M))
	ENDIF
      ENDDO
      SCALEI(IVIEW)=DSQRT(RSUM/VSUM)
      END
