      SUBROUTINE MRSCALE3(RPT, VPT, SCALEI)
C
C ************************************************************
C     COMPUTES THE SCALE FACTOR OF VPT WITH RESPECT TO RPT, USING ONLY
C     POINTS THEY HAVE IN COMMON. THIS THEN MUST BE APPLIED TO VPT
C     TO MAKE IT FIT TO RPT
C
C     USES ROOT OF RATIO BETWEEN SUM OF SQUARES OF COORDS OF RPT/VPT.
C
C INPUT:
C     RPT(3,LS)= COORDS OF POINTS IN REFERENCE VIEW
C     VPT(3,LS)= COORDS OF POINTS IN VIEW TO BE ADJUSTED
C COMMON INPUT:
C     NTPT = NUMBER OF POINTS
C OUTPUT:
C     SCALEI= SCALE FACTOR OF VPT VIEW WITH RESPECT TO RPT VIEW
C

        PARAMETER (LS=100)
      COMMON /GENERAL/NTPT,CIR(2)
      DIMENSION    RPT(3,LS), VPT(3,LS)
	DOUBLE PRECISION  RSUM,VSUM
CNO_SAVE
C
      RSUM=0.0d0
      VSUM=0.0d0
C       SUMS UP THE SQUARES OF THE COORDS
      DO  M=1,NTPT
          RSUM=RSUM+RPT(1,M)*DBLE(RPT(1,M))
     &      +RPT(2,M)*DBLE(RPT(2,M))+RPT(3,M)*DBLE(RPT(3,M))
          VSUM=VSUM+VPT(1,M)*DBLE(VPT(1,M))
     &	+VPT(2,M)*DBLE(VPT(2,M))+VPT(3,M)*DBLE(VPT(3,M))
      ENDDO
      SCALEI=DSQRT(RSUM/VSUM)
      END
