      SUBROUTINE MRTHETA(RPT,VPT,IVIEW,P3D,THETA)
C
C           CALCULATES THETA ANGLE DIFFERENCE BETWEEN
C           TWO VIEWS OF APPROXIMATELY THE SAME THETA
C           returns new theta, not the difference !
C
C INPUT:
C     XYPTS(2,LS,LV) = ARRAY OF POINTS TO BE CHECKED
C     IVIEW = INDEX OF IMAGE TO BE CHECKED
C     P3D(3,LS) = 3-D MODEL
C     SCALE = DIFFERENCE IN SCALE BETWEEN IMAGES
C     PSI = IN-PLANE CORRECTION
C     THETA = TILT ANGLE OF IVIEW
C OUTPUT:
C     THETA = TILT DIFFERENCE
C

        PARAMETER (LV=300)
        PARAMETER (LS=100)
        PARAMETER (MAXREG=7)
        PARAMETER (MAXKEY=100)
        PARAMETER (MAXLOOP=999)
        REAL MAXPER
        PARAMETER (MAXPER=1.0e-6)
      LOGICAL*1   PTACTIVE(LS,LV),PARAMQ(4)
      COMMON /GENERAL/PTACTIVE,NUMPTS(LV),NTVW,NTPT,CIR(2),PARAMQ
      DIMENSION   RPT(2,LS),VPT(2,LS),P3D(3,LS)
      DIMENSION   CPJ(2,LS),CXY(2,LS)
CNO_SAVE
C
      SY=SIN(THETA)
      CY=COS(THETA)
C
C           COMPUTE PROJECTION WITH X-Z POINTS AND VIEW WITH X
C           SO CAN GET COMMON CENTER OF MASS X.
      DO  I=1,NUMPTS(IVIEW)
	  if(ptactive(i,iview))  then
          CPJ(1,I) = P3D(1,I)*SY + P3D(3,I)*CY
          CPJ(2,I) = RPT(1,I)
          CXY(2,I) = VPT(1,I)
	  endif
      ENDDO
C
      DO  I=1,NUMPTS(IVIEW)
C           COMPUTE VIEW WITH X-Z POINTS
	  if(ptactive(i,iview))  then
        TOTD2 = CPJ(1,I)**2 + CPJ(2,I)**2
        TMPZ2 = TOTD2 - (CXY(2,I)**2)
        TMPZ = 0.0
        IF(TMPZ2 .GT. 0.0) TMPZ = SQRT(TMPZ2)
        CXY(1,I) = SIGN(TMPZ,CPJ(1,I))
	  endif
      ENDDO
C
      CALL MRANG2(CPJ,CXY,IVIEW,THDIF)
      THETA=THETA-THDIF
      END
