

C                                LONG FILE NAMES FEB 89 al
C SUBROUTINE TO CALCULATE THE STANDART DEVIATION OF IMAGES FROM AN
C AVERAGE IMAGE INSIDE A GIVEN MASK
C AUG.85 M.RADERMACHER

C CONTAINS LONGEST UNLABELED COMMON IN SPIDER


	SUBROUTINE MRVARI(MAXDIM)

        PARAMETER (MDIM=1024,MDIST=2000)

        INCLUDE 'CMBLOCK.INC'

	COMMON SPACE(MDIM),EUKL(MDIST),VARI(MDIST),BUF(1)
        COMMON /COMMUN/ FNPR,FNPR2,MSK,AVG,FILPAT,FILDUM

        CHARACTER *81 FNPR,FNPR2,MSK,AVG,FILPAT,FILDUM
        CHARACTER     NULL
        DIMENSION DLIST(6),IP(3),KOUNTER(2,101)
        INTEGER ICOUNT

        DATA KOUNTER/202*0./
        NULL=CHAR(0)

        LUN1=12
        LUN2=13
        LUN3=14
        NDOC=15
C
C  GET NAMES OF MASK-FILE AND AVERAGE-FILE
        CALL FILERD(MSK,NLET,NULL,'MASK',IRTFLG)
        IF (IRTFLG .NE. 0) RETURN
        CALL FILERD(AVG,NLET,NULL,'AVERAGE',IRTFLG)        
        IF (IRTFLG .NE. 0) RETURN
C  READ MASK AND AVERAGE INTO CORE
        CALL OPENF(MSK,LUN1,NSAM,NROW,'OLD',NF,NDUM)
        IF(NSAM.GT.MDIM) THEN
        CLOSE(LUN1)
        CALL ERRT(101,'IMAGE DIMENSIONS TOO LARGE',NE)
        RETURN
        ENDIF        
        NCHKX=NSAM
        NCHKY=NROW
        CALL OPENF(AVG,LUN2,NSAM,NROW,'OLD',NF,NDUM)        
        IF (NCHKY.NE.NROW.OR.NCHKX.NE.NSAM) 
     $     CALL ERRT(101,'DIMENSIONS INCONSISTENT ',NE)

        NMASK=NSAM*NROW
        NAVER=2*NMASK
        IF(3*NMASK.GT.MAXDIM-2*MDIST-MDIM)  THEN
          CALL ERRT(6,'MRVARI',NE)
          CLOSE(LUN1)
          CLOSE(LUN2)
          RETURN
        ENDIF
        DO  I=1,NROW
        INDM=NMASK+(I-1)*NSAM+1
        INDA=NAVER+(I-1)*NSAM+1
        CALL REDLIN(LUN1,BUF(INDM),NSAM,I)
        CALL REDLIN(LUN2,BUF(INDA),NSAM,I)
	ENDDO
        CLOSE(LUN1)
        CLOSE(LUN2)
C  GET THE NAMES OF FILES CONTAINING THE IMAGES
        CALL FILERD(FNPR,NLET1,NULL,'FIRST IMAGE',IRTFLG)
        CALL FILERD(FNPR2,NLET,NULL,'LAST IMAGE',IRTFLG)
        CALL RDPRM(PIN,NLOOP,ILOOP,'VARIANCE INTERVALS IN % ')
        IF(PIN.EQ.0.) PIN=100.

        CALL FILCAD(FNPR,FILPAT,N1,IRTFLG)
        CALL FILCAD(FNPR2,FILDUM,N2,IRTFLG)
        IF(N2.GE.MDIST) THEN
        WRITE(NOUT,500) MDIST
500     FORMAT(1X,'**** WARNING **** FILE LIST TRUNCATED AT',I6)
        N2=MDIST
        ENDIF
200     CONTINUE
C  CLEAR VARIANCE ARRAY
        DO  K=1,N2
        EUKL(K)=0
        VARI(K)=0.
	ENDDO
        VARMAX=0.
        EUKMAX=0.
C  LOOP OVER THE IMAGES:
        DO 10 K=N1,N2
        CALL FILGET(FILPAT,FNPR,NLET1,K,IRTFLG)
        IF (IRTFLG .NE. 0) RETURN
300     CALL OPENF(FNPR,LUN3,NSAM,NROW,'OLD',NF,NDUM)
        IF (NF.NE.2) THEN
49        WRITE (NOUT,50) (FNPR(I:I),I=1,NLET1)
50        FORMAT('  DOES NOT EXIST, OR ARRAY NOT REAL: ',80A1)
          GOTO 10
        ENDIF
400     CONTINUE
        CALL REDLIN(LUN3,BUF,NSAM,0)
C  CHECK LABEL OF PROJECTION FILE (FILE HAS TO BE TYPE REAL)
        IP(1)=BUF(1)
        IP(2)=BUF(2)
        IP(3)=BUF(5)
        IF(IP(3).LT.0) GOTO 49
C INITIALIZE ICOUNT TO COUNT PIXELS IN MASK:
        ICOUNT=0
        VAR=0
C CALCULATE THE STANDARD DEVIATION OF THE CURRENT IMAGE:
	DO  I =1,NROW
	CALL REDLIN(LUN3,BUF,NSAM,I)
	DO 51 KK=1,NSAM
        INDM=NMASK+(I-1)*NSAM
        INDA=NAVER+(I-1)*NSAM
	IF(BUF(INDM+KK).LT.0.5) GOTO 51
        ICOUNT=ICOUNT+1
C FORMULA USED FOR VARIANCE SEE: HJ BARTSCH,MATHEMATISCHE FORMELN,
C       BUCH- UND ZEIT-VERLAGSGESELLSCHAFT, KOELN, 1970
        VAR=VAR+(BUF(KK)-BUF(INDA+KK))**2
51	CONTINUE
	ENDDO
        EUKL(K)=SQRT(VAR)
        IF(EUKMAX.LT.EUKL(K)) EUKMAX=EUKL(K)
        VAR=VAR/FLOAT(ICOUNT-1)
        IF(VARMAX.LT.VAR) VARMAX=VAR
        VARI(K)=VAR

        WRITE(NOUT,999) VAR,(FNPR(II:II),II=1,NLET1)
999     FORMAT(' VARIANCE= ',E10.4,'  OF IMAGE: ',80A1)

        CLOSE(LUN3)
10      CONTINUE
        WRITE(NOUT,998) ICOUNT
998     FORMAT(' NUMBER OF POINTS IN MASK: ',I5)     
C CREATE INTERVAL INDEX: 
        DIV=PIN/100.
        TENP=VARMAX*DIV
        TENPE=EUKMAX*DIV
        DO  I=N1,N2
        IF(VARI(I).EQ.0) THEN 
        DLIST(1)=I
        DLIST(2)=0.
        DLIST(3)=5000
        DLIST(4)=0
        DLIST(5)=5000
        DLIST(6)=0
        ELSE
        INDEX=VARI(I)/TENP+1
        INDEXE=EUKL(I)/TENPE+1
	DLIST(1) = I
	DLIST(2) = VARI(I)
	DLIST(3) = INDEX 
        DLIST(4) = EUKL(I)
        DLIST(5) = INDEXE
        DLIST(6)=1
        KOUNTER(1,INDEX)=KOUNTER(1,INDEX)+1
        KOUNTER(2,INDEXE)=KOUNTER(2,INDEXE)+1
        ENDIF
	CALL SAVD(NDOC,DLIST,6,IRTFLG)
	ENDDO
        ICLASS=1/DIV+1
        WRITE(NOUT,55)
55      FORMAT(' NUMBER OF IMAGES IN CLASSES:'/1X,
     $  'CLASS   VARIANCE  CUMUL.   EUKLIDEAN   CUMUL.')
        KU1=0
        KU2=0
        DO  K=1,ICLASS
        KU1=KU1+KOUNTER(1,K)
        KU2=KU2+KOUNTER(2,K)
        WRITE(NOUT,54) K,KOUNTER(1,K),KU1,KOUNTER(2,K),KU2
54      FORMAT(' ',1X,I4,4X,I4,8X,I4,5X,I4,8X,I4)
	ENDDO
        CALL SAVDC
        CLOSE(NDOC)
        END
 
