
C++************************************************************************
C
C MULF3.FOR
C
C **************************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK            *
C *  COPYRIGHT (C)1981,1987, WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *  THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR       *
C *  LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR    *
C *  USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF     *
C *  THE CENTER FOR LABORATORIES AND RESEARCH   			   *
C **************************************************************************
C
C
C
C--************************************************************************

         SUBROUTINE MULF3(LUN2,LUN1,A1,A2,B1,B2,NSAM,NROW,NSLICE,SIGT)

        DIMENSION  A1(NSAM),A2(NSAM),B1(NSAM),B2(NSAM)
        COMPLEX  QT
	LOGICAL*1 IFND,IFNS,IFNR,CJG

#ifdef SP_SUN4
        INTEGER INCG
#else
	INTEGER*1  INCG
#endif
CNO_SAVE

        IFNR=MOD(NROW,2).EQ.0
        IFND=MOD(NSAM,2).EQ.0
        IFNS=MOD(NSLICE,2).EQ.0
	IF(IFND)  THEN
	LBD=2
	ELSE
	LBD=1
	ENDIF
	IF(IFNR)  THEN
	LBR=2
	ELSE
	LBR=1
	ENDIF
	IF(IFNS)  THEN
	LBS=2
	ELSE
	LBS=1
	ENDIF
	CJG=SIGT.EQ.-2.0
	IF(CJG)  THEN
	INCG=-1
	ELSE
	INCG=+1
	ENDIF
	LNS=(NSAM-2)/2
C
         DO    K=1,LBS
         DO    J=1,LBR
 	NR1=J+(K-1)*NROW
         CALL  REDLIN(LUN2,A1,NSAM,NR1)
         CALL  REDLIN(LUN1,B1,NSAM,NR1)
	DO    I=1,LBD
          A1(I)=A1(I)*B1(I)
	ENDDO
	IF(CJG)  THEN
         CALL  MLC(A1(3),B1(3),A1(3),LNS)
	ELSE
         CALL  MLS(A1(3),B1(3),A1(3),LNS)
	ENDIF
	IF(.NOT.IFND)  THEN
	QT=CMPLX(A1(NSAM),A1(2))*CMPLX(B1(NSAM),INCG*B1(2))
 	A1(NSAM)=REAL(QT)
        A1(2)=AIMAG(QT)
	ENDIF
        CALL  WRTLIN(LUN2,A1,NSAM,NR1)
	ENDDO
	ENDDO
C
C	DO  3  J=1,LBR
	J=1
C	DO  4  K=3,NSLICE-1,2
3	K=3
4	NR1=J+(K-1)*NROW
	NR2=J+K*NROW
	ASSIGN  501  TO LABA
	GOTO  1955
501	CONTINUE
	K=K+2
	IF(K.LE.NSLICE-1)  GOTO  4
C4       CONTINUE
	IF(.NOT.IFNS)  THEN
	NR1=J+(NSLICE-1)*NROW
	NR2=J+NROW
	ASSIGN  502  TO LABA
	GOTO  1955
502	CONTINUE
	ENDIF
	J=J+1
	IF(J.LE.LBR) GOTO 3
C3	CONTINUE
C In what follows can't use do-loops because indexes are lost
c  after jump to 1955, so explicit do-loops used instead.
C	DO  7  K=1,NSLICE
	K=1
C	DO  8  J=3,NROW-1,2
7	J=3
8	NR1=J+(K-1)*NROW
	NR2=J+1+(K-1)*NROW
	ASSIGN  503  TO LABA
	GOTO  1955
503     CONTINUE
C8       CONTINUE
	J=J+2
	IF(J.LE.NROW-1)  GOTO  8
	IF(.NOT.IFNR)  THEN
	NR1=NROW+(K-1)*NROW
	NR2=2+(K-1)*NROW
	ASSIGN  504  TO LABA
	GOTO  1955
504	CONTINUE
	ENDIF
	K=K+1
	IF(K.LE.NSLICE)  GOTO  7
C7       CONTINUE
	RETURN
C
1955	CONTINUE
         CALL  REDLIN(LUN1,B1,NSAM,NR1)
         CALL  REDLIN(LUN1,B2,NSAM,NR2)
         CALL  REDLIN(LUN2,A1,NSAM,NR1)
         CALL  REDLIN(LUN2,A2,NSAM,NR2)
	DO    I=1,LBD
	QT=CMPLX(A1(I),A2(I))*CMPLX(B1(I),INCG*B2(I))
 	A1(I)=REAL(QT)
        A2(I)=AIMAG(QT)
	ENDDO
	IF(CJG)  THEN
	CALL  MLC(A1(3),B1(3),A1(3),LNS)
        CALL  MLC(A2(3),B2(3),A2(3),LNS)
	ELSE
	CALL  MLS(A1(3),B1(3),A1(3),LNS)
        CALL  MLS(A2(3),B2(3),A2(3),LNS)
	ENDIF
	IF(.NOT.IFND)  THEN
	QT=CMPLX(A1(NSAM),A1(2))*CMPLX(B1(NSAM),INCG*B1(2))
 	A1(NSAM)=REAL(QT)
        A1(2)=AIMAG(QT)
	QT=CMPLX(A2(NSAM),A2(2))*CMPLX(B2(NSAM),INCG*B2(2))
 	A2(NSAM)=REAL(QT)
        A2(2)=AIMAG(QT)
	ENDIF
	CALL  WRTLIN(LUN2,A2,NSAM,NR2)
	CALL  WRTLIN(LUN2,A1,NSAM,NR1)
	GOTO  LABA
C
	END
