
C++************************************************************************
C
C MYGETENV
C
C **************************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK            *
C *  COPYRIGHT (C)1981,1994, WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH 			   *
C **************************************************************************
C
C   MYGETENV(INPUT,OUTPUT,MESSAGE,IRTFLG)
C
C   PURPOSE:   RETRIEVES AN ENVIRONMENTAL VARIABLE
C
C   PARAMETERS:   INPUT     NAME OF ENVIRONMENTAL VARIABLE   (SENT)
C                 OUTPUT    VALUE OF ENVIRONMENTAL VARIABLE  (RETURNED)
C                 NCHAR     NUMBER OF CHARACTERS IN OUTPUT   (RETURNED)
C                 MESSAGE   ERROR MESSAGE                    (SENT)
C                 ITRFLG    ERROR FLAG   (0 IS NORMAL)       (RETURNED)
C
C23456789 123456789 123456789 123456789 123456789 123456789 123456789 12
C--*********************************************************************

        SUBROUTINE MYGETENV(INPUT,OUTPUT,NCHAR,MESSAGE,IRTFLG)

	INCLUDE 'CMBLOCK.INC' 

        CHARACTER *(*) INPUT, OUTPUT, MESSAGE

        IRTFLG = 0

C       READ IN THE ENVIRONMENT VARIABLE 'SPMAN_DIR'.
        CALL GETENV(INPUT,OUTPUT)

        NCHAR = lnblnk(OUTPUT)

        IF (NCHAR .LE. 0 .OR. NCHAR .GT. 74) THEN
           WRITE(NOUT,*) '*** UNDEFINED ENVIRONMENTAL VARIABLE:',INPUT
           WRITE(NOUT,*) 'PUT DEFINITION IN YOUR STARTUP FILE.  E.G.'
           WRITE(NOUT,*) 'FOR C SHELL, ADD FOLLWING TO .cshrc FILE '
           WRITE(NOUT,*) 'setenv ',INPUT,' ',MESSAGE
           WRITE(NOUT,*) 'PLEASE NOTE TRAILING / IN THE PATH'

           IRTFLG = 1
           RETURN
        ENDIF


        RETURN
        END

