C++*******************************************************************
C
C $$ NORM.FOR                            DATE LAST MODIFIED: 10/12/84
C
C **************************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK            *
C *  COPYRIGHT (C)1981,1987, WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH 			   *
C **************************************************************************
C
C
C $$ NORM:
C
C...   CALL NORM(LUN,NSAM,NROW,FMAXD,FMIND,AVD)
C...     LUN          LOGICAL UNIT NUMBER OF IMAGE
C...     NSAM,NROW    DIMENSIONS OF IMAGE
C
C...   RETURNED PARAMETERS:
C...     FMAXD         MAXIMUM OF IMAGE
C...     FMIND         MINIMUM OF IMAGE
C...     AVD           AVERAGE OF IMAGE
C
C...   SUBROUTINE CALLS:
C
C...     REDLIN :     READ A LINE FROM BUFFER BUF
C...     SETPRM :     SET PARAMETERS AND UPDATE LABEL IN FILE
C
C--*******************************************************************

      SUBROUTINE NORM(LUN,NSAM,NROW,FMAXC,FMINC,AVD)

      COMMON BUF(1)

#ifdef SP_UNIX
      INCLUDE 'CMBLOCK.INC' 
#else
      INCLUDE 'COMMON1:CMBLOCK.INC' 
#endif
CNO_SAVE
      DOUBLE  PRECISION DAV,DAV2
 
C...  INITIALIZE FMAX, FMIN, DAV & DAV2

      FMAX = - 0.999E20
      FMIN = - FMAX
      DAV  = 0.
      DAV2 = 0.

C...  FOR ALL RECORDS IN THE FILE

      DO 1001 I = 1,NROW

C...     READ A LINE FROM THE BUFFER      
         CALL REDLIN(LUN,BUF,NSAM,I)

C...     FOR ALL SAMPLES

         DO 1002 K = 1,NSAM

C...        CALCULATE THE MAX, MIN, AVERAGE AND VARIANCE
            B    = BUF(K)
            FMAX = AMAX1(B,FMAX)
            FMIN = AMIN1(B,FMIN)
            DAV  = DAV+B
	    DAV2 = DAV2+B*DBLE(B)
1002     CONTINUE
1001  CONTINUE

      FNALL = FLOAT(NSAM)*FLOAT(NROW)
      AVD   = DAV/FNALL

      AV   = AVD
      FMAXC = FMAX
      FMINC = FMIN

      SIG = DSQRT((DAV2-DAV*DAV/FNALL)/DBLE(FNALL-1.0))

C...  NOTE THAT VARIABLES AV,FMAX,FMIN,SIG ARE NOW UPDATED IN THE COMMON
C...  SET LABEL PARAMETERS AND UPDATE THEM WITH UNCHANGED DATA TYPE

      CALL SETPRM(LUN,NSAM,NROW,FMAX,FMIN,AVD,'U')
      END
