C++*******************************************************************
C
C $$ NORMM.FOR
C
C **************************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK            *
C *  COPYRIGHT (C)1981,1987, WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH 			   *
C **************************************************************************
C
C
C $$ NORMM(LUN,LUNM,NSAM,NROW,FMAX,FMIN,AV)
C
C    PARAMETERS:
C        LUN          LOGICAL UNIT NUMBER OF IMAGE
C	 LUNM	      LOGICAL UNIT NUMBER OF MASK
C        NSAM,NROW    DIMENSIONS OF IMAGE
C        NSLICE
C        FMAX         MAXIMUM OF IMAGE
C        FMIN         MINIMUM OF IMAGE
C        AV           AVERAGE OF IMAGE
C
C--*******************************************************************

      SUBROUTINE NORMM(LUN,LUNM,NSAM,NROW,nslice,FMAX,FMIN,AV,NPOINT)

      COMMON BUF(1)
      COMMON /MASTER/NSAMC,NROWC,IREC,NLABEL,IFORM,IMAMI,FMAXC,FMINC,
     1               AVC,SIG,IHIST
      COMMON /UNITS/LUNC,NIN,NOUT
      DOUBLE PRECISION DAV,DAV2
      LOGICAL  SETMIN
CNO_SAVE
      DAV    = 0.
      DAV2   = 0.
      SETMIN=.TRUE.
      NPOINT = 0
      DO  I = 1,NROW*nslice
         CALL REDLIN(LUN,BUF,NSAM,I)
         CALL REDLIN(LUNM,BUF(NSAM+1),NSAM,I)
         DO 20 K = 1,NSAM
            IF(BUF(NSAM+K)-0.5)  20,21,21
21          B      = BUF(K)
            IF(SETMIN)  THEN
            FMAX   = B
            FMIN   = FMAX
            SETMIN=.FALSE.
            ENDIF
            NPOINT = NPOINT+1
            FMAX   = AMAX1(B,FMAX)
            FMIN   = AMIN1(B,FMIN)
            DAV    = DAV+B
            DAV2   = DAV2+B*DBLE(B)
20       CONTINUE
      ENDDO
      FNALL = NPOINT
      AV    = DAV/FNALL
      AVC   = AV
      FMAXC = FMAX
      FMINC = FMIN
      SIG   = DSQRT((DAV2-DAV*DAV/FNALL)/DBLE(FNALL-1.0))
      END
