C
C----------------------------------=*=----------------------------------        
C *NAME* = NOYAU.FOR                   31-JAN-86      13:23:08                  
C           COPYRIGHT 1986 - JEAN-PIERRE BRETAUDIERE                            
C THE UNIVERSITY OF TEXAS HEALTH SCIENCE CENTER AT HOUSTON                      
C MEDICAL SCHOOL - DEPARTMENT OF PATHOLOGY AND LABORATORY MEDICINE              
C P.O. BOX 20708, HOUSTON, TX 77225.                                            
C DISCLAIMER: NO GUARANTEES OF PERFORMANCE ACCOMPANY THIS SOFTWARE,             
C NOR IS ANY RESPONSIBILITY ASSUMED ON THE PART OF THE AUTHOR                   
C OR THE INSTITUTION.  ALL THE SOFTWARE HAS BEEN TESTED EXTENSIVELY             
C AND EVERY EFFORT HAS BEEN MADE TO INSURE ITS RELIABILITY.                     
C THE FOLLOWING SOFTWARE MAY NOT BE COMMUNICATED TO A THIRD PARTY               
C UNDER ANY FORM WITHOUT WRITTEN PERMISSION OF THE AUTHOR.                      
C PLEASE REPORT ANY BUG(S) TO JPB AT (713) 792 52 00.                           
C OR THRU ARPANET AT  ......!rice!ots!ut-path!suprim                            
C*--------------------------------------------------------------------*         
C*                                                                    *         
C          CLASSIFICATION ACCORDING TO FACTORIAL COORDINATES          *         
C......... INPUT  ...  DATA AND WEIGHTS IN /NGUS/ UNFORMATTED         *         
C N2DIM     = SUP (NKLA, 2*NCLAS)                                     *         
C KDIM      = SUP (ICARD, NCLAS**NBASE, 2*NKLA - 1)                   *         
C MDIM      = SUP (NKLA*(NKLA-1)/2)                                   *         
C LDIM      = SUP (NKLA)                                              *         
C L2DIM     = SUP (2*NKLA - 1)                                        *         
C NFAC      = NUMBER OF COORDINATES IN RECORD FOLLOWED BY WEIGHT      *         
C KFAC      = NUMBER OF COORDINATES USED FOR CALCULATION              *         
C ICARD     = NUMBER OF OBJECTS TO BE CLASSIFIED                      *         
C NBASE NITER NCLAS NKLA ... PARAMETERS DEFINED IN SUBROUTINE PARST   *         
C......... WORKING ARRAYS  GT(*,*) D(*) KLAS(*) CI(*) U(*) JV(*) JW(*)*         
C           U(), JV(), JW() EQUIVALENCED TO D()                       *         
C   ROUTINES CALLED ... PARST, DEUCL, CHAVA, ARBRE, COUPE               *         
C                                                                    *         
C   DENDRO CALL ADDED NOV 86 al TO PLOT DENDROGRAM 
C
C*--------------------------------------------------------------------*         

      SUBROUTINE NOYAU (N2DIM,KDIM,MDIM,LDIM,L2DIM,NFAC,KFAC,ICARD,KV,          
     #                           NBASE, NITER, NCLAS, NKLA, IDI,                
     #                           KLAS, D, U, JV, JW, IDK, CI, GT,               
     #     NUM,LA,LB,IV,IW,V,W,NT,VAL,PK,NO,NGUS,NGRI, MODE)
C                                                                               

        COMMON    /BATCH/IBCNT,NLOOP,IABSLP,ILOOP
        INTEGER          IBCNT,NLOOP,IABSLP,ILOOP

      COMMON / ENSOR / LEC,IMP                                                  
      DIMENSION GT(N2DIM,KFAC),D(MDIM),KLAS(ICARD),CI(NFAC),IDI(ICARD),         
     #          U(KDIM), JV(KDIM), JW(KDIM), IDK(NKLA)                         
      DIMENSION NUM(LDIM),LA(LDIM),LB(LDIM),NT(L2DIM),VAL(L2DIM),               
     # PK(L2DIM),NO(L2DIM),IV(LDIM),W(LDIM),IW(LDIM),V(LDIM)                    
      DIMENSION KV(16)   
      CHARACTER * 1  NULL,ANS

      DATA NDOC/10/
      NULL=CHAR(0)

 
C.......... AGGREGATION AROUND MOBILE CENTERS AND STABLE CLUSTERING             
                                                                               
      CALL PARST (N2DIM,KDIM,NFAC,ICARD,KFAC,NBASE,NITER,NCLAS,NKLA,            
     #                        KLAS,JW,U,CI,JV,GT, KFIN,NGUS,NGRI )              
                                                                               
C.......... HIERARCHICAL CLASSIFICATION OF THE CLUSTER GRAVITY                  
C           CENTERS ACCORDING TO THE VARIANCE CRITERION (WARD)                  


C------------------------------------------------------------------
C IMPORTANT CHANGE: LIMIT HERE THE NUMBER OF CLUSTERS TO BE USED
C IN THE HAC. 8/25/86

	WRITE(IMP,1111)(KLAS(K),K=1,ICARD)
1111	FORMAT(20I5)

	CALL RDPRM(PERC,NLOOP,ILOOP,
     $      'PERC. FOR CLASS CUTOFF(0=NO CUTOFF)')

	IF (PERC.NE.0.0) THEN
          NTH=0.01*PERC*FLOAT(ICARD)+0.5
          DO  I=1,NKLA
            IF (JV(I) .LT. NTH) THEN
              NKLA = I-1
              GOTO 1100
            ENDIF
	  ENDDO
        ENDIF

1100	CONTINUE

C---------------------------------------------------------------
        IF (NKLA .GT. KFIN) NKLA = KFIN                              
        MCARD = NKLA * (NKLA-1) / 2                              
        CALL DEUCL (N2DIM,NKLA,MCARD,ICARD,KFAC,NFAC,            
     #            KLAS, D, GT, PK, CI, NGUS)
C
        JFIN  = 2 * NKLA - 1                                
        CALL CHAVA (NKLA, MCARD, JFIN,                       
     #            D, IDK, PK, VAL, LA, LB, NT, NO, NGRI, MODE, 0)                  
                                                                               
C.......... SAVE CLASSIFICATION ON NGRI                                         
                                                                               
      CALL REW(NGRI,0)                                                         
      WRITE (NGRI)  ICARD, NFAC, NKLA, KFAC, (KV(K), K=1, KFAC)                 
      WRITE (NGRI) (KLAS(I), I=1,ICARD), (IDI(I), I=1,ICARD),                   
     #             (PK(L),L=1,NKLA), ((GT(L,J),L=1,NKLA),J=1,KFAC)              
                                                                               
C.......... CLASSIFICATION TREE OF THE NKLA CENTERS                             
                                                                               
      CALL RDPRMC(ANS,NA,.TRUE.,
     &  'DO YOU WANT DENDROGRAM PLOT FILE? (Y/T/N)',NULL,IRT)

      IF (ANS .EQ. 'T' .OR. ANS .EQ. 't') THEN
         CALL DENDRO2(NKLA, JFIN, VAL, LA, LB, PK, IDK,
     &               NO,NUM,NT,IV,IW,V,W,VMIN,VMAX)             

      ELSEIF (ANS .NE. 'N' .AND. ANS .NE. 'n') THEN
         CALL DENDRO(NKLA, JFIN, VAL, LA, LB, PK, IDK,
     &               NO,NUM,NT,IV,IW,V,W,VMIN,VMAX)             

      ELSE
         CALL ARBRE(NKLA, JFIN, VAL, LA, LB, PK, IDK,   
     &               NO,NUM,NT,IV,IW,V,W,VMIN,VMAX)
      ENDIF

C     CAN LIST THE DENDORGRAM IN DOCUMENT FILE IF DESIRED
      CALL RDPRMC(ANS,NA,.TRUE.,
     &  'DO YOU WANT DENDROGRAM DOC FILE? (Y/N)',NULL,IRT)

      IF (ANS .NE. 'N' .AND. ANS .NE. 'n') THEN
         JDEB = NKLA + 1
         CALL DENLST(NDOC,VMIN,VMAX,NKLA,V,NUM,IRTFLG)
      ENDIF

C     CAN LIST THE DENDORGRAM IN DOCUMENT FILE FOR WEB TO PLOT IF DESIRED---liy
      CALL RDPRMC(ANS,NA,.TRUE.,
     &  'DO YOU WANT THE CLUSTER DOC FILE? (Y/N)',NULL,IRT)

      IF (ANS .NE. 'N' .AND. ANS .NE. 'n') THEN
         JDEB = NKLA + 1
         CALL CLUSTERLST(NDOC,VMIN,VMAX,NKLA,V,NUM,
     &         ICARD,KLAS,IDI,IRTFLG)
      ENDIF

C.... SUCCESSIVE TRUNCATIONS OF THE CLASS. TREE OUTPUT RESULTS TO NGRI 
                                                                               
      KPART = NKLA - 1                                                          
      DO   KPRO = 2,KPART                                                   
         CALL COUPE (ICARD,NKLA,KPRO, PK,LA,LB,IV,KLAS,NT, IW)                     
         WRITE (NGRI)  (IV(J), J=1,NKLA)                                           
      ENDDO

      RETURN                                                                 
      END

