
C++*************************************************************************
C
C    NUMENU.FOR                         
C
C **************************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK            *
C *  COPYRIGHT (C)1981,1987, WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH 			   *
C **************************************************************************
C
C    NUMENU(DOCFIL,LUNDOC,ISKIP,IEND,IRTFLG)
C
C    PURPOSE:  READ THE ME.MAN DOCUMENTATION FILE AND DISPLAY 
C              CONTENTS ON TERMINAL
C
C    PARAMETERS:
C                  DOCFIL    DOCUMENT FILENAME WITH EXTENSION
C                  LUNDOC    UNIT TO BE USED FOR OPENING THE DOCUMENT FILE
C
C    CALLED BY:    DRIVER
C
C    CALLS:        RDPRMC
C
C        0         2         3         4         5         6         7     
C23456789 123456789 123456789 123456789 123456789 123456789 123456789 12
C--*******************************************************************

      SUBROUTINE NUMENU(DOCFIL,LUNDOC,ISKIP,IEND,IRTFLG)
       
      COMMON /UNITS/ LUNC,NIN,NOUT

C     NLIN IS NUMMBER OF LINES PER SCREEN
      PARAMETER      (NLIN = 22)

      CHARACTER *(*) DOCFIL
      CHARACTER * 80 LINE
      CHARACTER * 1  ANSW,NULL

      NULL  = CHAR(0)

11    CONTINUE
      OPEN(LUNDOC,FILE=DOCFIL,STATUS='OLD',IOSTAT=IOS)
      IF (IOS .NE. 0) THEN
C         REPORT ERROR AND RETURN
          WRITE(NOUT,90) DOCFIL,LUNDOC
90        FORMAT(' *** ERROR OPENING FILE: ',A,' ON UNIT: ',I2,/)
          RETURN
      ENDIF

C     SKIP ISKIP LINES AT TOP OF THE FILE     
      IF (ISKIP .GT. 0) THEN
         DO  I = 1, ISKIP
           READ(LUNDOC,80,END=79) LINE
80         FORMAT(A)
        ENDDO
      ENDIF


C     READ NEXT NLIN LINES FROM FILE AND LIST ON TERMINAL

35    DO I = 1, NLIN
         READ(LUNDOC,80,END=79) LINE
77       WRITE(NOUT,92) LINE(1:IEND)
92       FORMAT(1X,A)
      ENDDO
      WRITE(NOUT,*) ' '

C..   GET CONTINUATION REPLY FROM USER
      CALL RDPRMC(ANSW,NC,.TRUE.,
     &  '         <CR> to continue or Q to stop listing',NULL,IRTFLG)

C     CONTINUE UNTIL * INPUT
      IF (IRTFLG .NE. -1 .AND. ANSW .NE. '*' .AND. 
     &    ANSW .NE. 'Q'  .AND. ANSW .NE. 'q' .AND.
     &    ANSW .NE. 'E'  .AND. ANSW .NE. 'e' .AND.
     &    ANSW .NE. 'S'  .AND. ANSW .NE. 's' ) GOTO 35

79    CLOSE(LUNDOC)
      RETURN
      END

