
C++*********************************************************************
C
C OPENALL.F   -- ADAPTED FROM OPEN3.FOR OCT 88 al
C             -- LONG FILENAMES al
C             -- STACKS ADDED 96 al
C             -- REWRITTEN WITH OPENFIL 96 al
C             -- REWRITTEN WITH OPENINSTK 97 al
C             -- REWRITTEN WITH OPENSTK 98 al
C             -- RENAMED FROM OPENFB JAN 98 al
C
C **********************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK        *
C *  COPYRIGHT (C)1981,1987, WADSWORTH CENTER FOR LABORATORIES AND     *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.  *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS *
C *    OR USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN        *
C *    APPROVAL OF THE CENTER FOR LABORATORIES AND RESEARCH            *
C **********************************************************************
C
C    OPENALL(BUF,FILNAM,LUN,NSAM,NROW,NSLICE,DISP,NF)
C
C    PURPOSE:       TO OPEN A NEW OR  EXISTING DATA FILE FOR RANDOM 
C                   ACCESS READING/WRITING.
C
C    PARAMETERS:
C        BUF        WORKING BUFFER FOR READ/WRITE                 (SENT)
C        FILNAM     CHARACTER ARRAY, CONTAINING FILE NAME         (SENT)
C        LUN        LOGICAL UNIT NUMBER FOR FILNAM.               (SENT)
C        NSAM,NROW  DIMENSIONS OF FILE                       (SENT/RET.)
C        DISP(1:1)  SEE OPFIL.F                                   (SENT) 
C        NF         ERROR RETURN FLAG.                       (SENT/RET.)
C                   NF = 2    NORMAL RETURN
C                   NF = 1    ERROR RETURN
C        NSLICE     NUMBER OF PLANES                         (SENT/RET.)
C
C    COMMON VARIABLES: SEE OPFIL.F 
C
C     CALL TREE:       SEE OPFIL.F
C
C23456789 123456789 123456789 123456789 123456789 123456789 123456789 12
C--*********************************************************************

	SUBROUTINE OPENALL(BUF,FILNAM,LUN,NSAM,NROW,NSLICE,DISP,NF)

        INCLUDE 'CMBLOCK.INC'
        INCLUDE 'LABLOCK.INC'
CNO_SAVE

        COMMON /LUNARA/  LUNARA(100),LUNSTK(100)

        COMMON /STACKCOM/NSTACK

        DIMENSION        BUF(*)
        CHARACTER *(*)   FILNAM,DISP

C       MAKE SURE THE STACK OFFSET IS ALWAYS ZEROED
        LUNSTK(LUN) = 0

        IF (INDEX(FILNAM,'@') .EQ. 0) THEN
C          NOT AN IMAGE STACK (MAY BE AN INLINE FILE).  NOTE:
C          THIS IS THE PATH FOR 'REGULAR' SPIDER IMAGE FILES.
           NSTACK = -2
	   CALL OPENFIL(BUF,FILNAM,LUN,NSAM,NROW,NSLICE,NSTACK,
     &                  IMUSED,DISP(1:1),NF)
           IF (NSTACK .GE. 0 ) THEN 
C             BARE STACK REFERENCE NOT ALLOWED WITHOUT '@'
              CALL ERRT(101,'STACK INDICATOR (@) MISSING',NE)
              NF = 1
           ENDIF
           RETURN

        ELSEIF (FILNAM(1:1) .EQ. '_') THEN
C           INLINE IMAGE STACK ACCESS WANTED
            NIMAG  = 0
            CALL OPENINSTK(BUF,FILNAM,LUN,NSAM,NROW,NSLICE,NIMAG,
     &                     IFORM,DISP(1:1),NF)
C           NOTE: OPENINSTK RETURNS NSTACK VALUE IN COMMON
            RETURN

        ELSE
C          WANT TO ACCESS AN FILE BASED IMAGE STACK
           CALL OPENSTK(BUF,FILNAM,LUN,NSAM,NROW,NSLICE,NIMAG,
     &                  IFORM,DISP(1:1),IRTFLG)
C          NOTE: OPENSTK RETURNS NSTACK VALUE IN COMMON
           NF = 1
           IF (IRTFLG .EQ. 0) NF = 2
        ENDIF

        RETURN
        END


