
C++************************************************************************
C
C OPENDOC.F               
C
C **************************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK            *
C *  COPYRIGHT (C)1981,1987, WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH 			   *
C **************************************************************************
C
C OPENDOC:    SUBROUTINE TO OPEN DOCUMENT FILE 
C
C OPENDOC(DOCNAM,ADDEXT,NLET,NDOC,GETNAME,
C        ISOLDFILE,APPEND,MESSAGE,NEWFILE,IRTFLG)
C
C PARAMETERS:     DOCNAM        NAME OF DOC FILE             SENT
C                 ADDEXT        LOGICAL FLAG TO ADD .EXT     SENT
C                 NLET          NO. OF CHAR. IN DOCNAM       RETURNED
C                 NDOC          UNIT FOR DOC FILE            SENT
C                 GETNAME       FLAG TO REQUEST NAME         SENT
C                 ISOLDFILE     FLAG THAT FILE IS EXISTING   SENT
C                 APPEND        FLAG TO OPEN FILE AS APPEND  SENT
C                 MESSAGE       FLAG TO WRITE COMMENT        SENT
C                 NEWFILE       FLAG THAT FILE WAS NEW       RETURNED
C	          IRTFLG        ERROR FLAG (0 IS NORMAL)     RETURNED
C
C--*******************************************************************
		
        SUBROUTINE OPENDOC(DOCNAM,ADDEXT,NLET,NDOC,GETNAME,
     &                     ISOLDFILE,APPEND,MESSAGE,NEWFILE,IRTFLG)

	INCLUDE 'CMBLOCK.INC' 
 
	CHARACTER *(*) DOCNAM
        CHARACTER *9   CDATT
        CHARACTER *8   CTIMT
        CHARACTER      NULL
	LOGICAL        EX,ADDEXT,ISOLDFILE,GETNAME,APPEND,MESSAGE
        LOGICAL        SAYOPEN,ISOPEN,NEWFILE

        NULL = CHAR(0)

        SAYOPEN = .TRUE.
        IF (IRTFLG .EQ. -9) SAYOPEN = .FALSE.

        IF (GETNAME) THEN
          CALL FILERD(DOCNAM,NLET,NULL,'DOCUMENT',IRTFLG)
          IF (IRTFLG .EQ. -1) RETURN
        ELSE
          NLET = INDEX(DOCNAM,NULL) -1
          IF (NLET .LT. 0) NLET = LEN(DOCNAM)
        ENDIF
        IRTFLG = 2

        IF (ADDEXT) THEN
C          MERGE DOCNAM WITH DATEXC
           CALL FILCAN(DOCNAM,NLET,NULL,NULL,DOCNAM,DATEXC,IRTFLG)
           IF (IRTFLG .NE. 0) RETURN
        ENDIF

C       SEE IF FILE EXISTS
        INQUIRE(FILE=DOCNAM,EXIST=EX,OPENED=ISOPEN,NUMBER=LUNOP,
     &          IOSTAT=IOS)

        IF (IOS .NE. 0) THEN
          CALL ERRT(100,' ',NE)
	  WRITE(NOUT,*)'*** ERROR INQUIRING DOC FILE: ',DOCNAM(1:NLET)
          RETURN
        ENDIF
        NEWFILE = .NOT. EX

        IF (ISOLDFILE .AND. .NOT. EX) THEN
C          OLD DOC FILE SHOULD EXIST FOR READING, BUT DOES NOT!
           CALL ERRT(100,' ',NE)
	   WRITE(NOUT,*) '*** DOC FILE DOES NOT EXIST: ',DOCNAM(1:NLET)
           RETURN

        ELSEIF (ISOLDFILE .AND. EX) THEN
C          SEE IF FILE IS ALREADY OPEN
           IF (ISOPEN) THEN
              CLOSE(LUNOP)
	      WRITE(NOUT,*) 'FILE ALREADY OPEN, HAS BEEN CLOSED!'
           ENDIF

C          OPEN EXISTING DOC FILE FOR READING
           OPEN(UNIT=NDOC,FILE=DOCNAM,STATUS='OLD',IOSTAT=IOS)
 
        ELSEIF (.NOT. ISOLDFILE .AND. EX) THEN
C          OPEN EXISTING EXISTING DOC FILE FOR WRITING
           IF (APPEND) THEN
#ifdef SP_F90
              OPEN(UNIT=NDOC,FILE=DOCNAM,STATUS='OLD',
     &            ACCESS="SEQUENTIAL",POSITION="APPEND",IOSTAT=IOS)
#else
              OPEN(UNIT=NDOC,FILE=DOCNAM,STATUS='OLD',
     &            ACCESS="APPEND",IOSTAT=IOS)
#endif
           ELSE
              OPEN(UNIT=NDOC,FILE=DOCNAM,STATUS='OLD',
     &            ACCESS='SEQUENTIAL',IOSTAT=IOS)
           ENDIF

        ELSEIF (.NOT. ISOLDFILE) THEN
C          OPEN NEW DOC FILE FOR WRITING 
           OPEN(UNIT=NDOC,FILE=DOCNAM,STATUS='UNKNOWN',IOSTAT=IOS)

        ENDIF

        IF (IOS .NE. 0) THEN
          CALL ERRT(100,' ',NE)
	  WRITE(NOUT,*) '*** ERROR OPENING DOC FILE: ',DOCNAM(1:NLET)
          RETURN
        ENDIF

        IF (.NOT. ISOLDFILE .AND. MESSAGE) THEN
C          WRITE HEADER INTO FILE
	   CALL DATE(CDATT)
	   CALL TIME(CTIMT)
           WRITE(NDOC,90) PRJEXC(1:3),DATEXC(1:3),
     &                     CDATT,CTIMT,DOCNAM(1:NLET)
 90        FORMAT(' ;' ,A,'/',A,3X,A,' AT ',A,3X,A)
        ENDIF

        IF (SAYOPEN) WRITE(NOUT,*) 'OPENED DOC FILE: ', DOCNAM(1:NLET)

        IRTFLG = 0

	RETURN
	END
