
C++*********************************************************************
C
C OPENGETHDR.F   -- REMOVED FROM OPENFB.F al.                  
C                                           
C **********************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.    AUTHOR: J.FRANK      *
C *  COPYRIGHT (C)1985, 1996 HEALTH RESEARCH INCORPORATED, ALBANY, NY. *
C * THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO HEALTH            *
C * RESEARCH INC. AND ARE NOT TO BE DISCLOSED TO OTHERS OR USED        *
C * FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF       *
C * HEALTH RESEARCH INC.                                               *
C **********************************************************************
C
C    OPENGETHDR(BUF,NSAM,NROW,NSLICE,NSTACK,ITYPE,LABBYT,IMUSED,LENTIT)
C
C    PURPOSE:       TO OPEN A NEW OR EXISTING INLINE STACK.
C
C    PARAMETERS:
C        BUF        HEADER BUFFER FROM FILE                     (SENT)
C        NSAM,NROW  DIMENSIONS OF FILE                          (RET.)
C        NSLICE     NUMBER OF PLANES                            (RET.)
C        NSTACK     NUMBER OF IMAGES ALLOWED IN NEW STACK       (RET.)
C        ITYPE      IFORM                                       (RET.)                    
C        LABBYT     HEADER LENGTH                               (RET.)
C        IMUSED     IMUSED                                      (RET.)
C        LENTIT     TITLE LENGTH                                (RET.)
C
C  COMMON VARIABLES:
C        MANY
C
C23456789 123456789 123456789 123456789 123456789 123456789 123456789 12
C--*********************************************************************

      SUBROUTINE OPENGETHDR(BUF,NSAM,NROW,NSLICE,NSTACK,ITYPE,
     &                      LABREC,LABBYT,LENBYT,IMUSED,LENTIT)

CNO_SAVE
C     MOST VARIABLES ARE PASSED BACK IN COMMON BLOCKS
      INCLUDE 'CMBLOCK.INC'
      INCLUDE 'LABLOCK.INC'

      DIMENSION BUF(*)

C     RECOVER IMAGE PARAMETERS FROM SPECIFIC IMAGE HEADER

      NSLICE   = ABS(BUF(1)) + 0.5
      NROW     = BUF(2)
      IREC     = BUF(3)

C     BUF(4) USED TO CONTAIN NHISTREC (UNUSED NOW)
      NHISTREC = 0

C     BUF(5) IS IFORM OR ITYPE
      ITYPE    = BUF(5) + 0.5
      IF (BUF(5) .LT. 0.0) ITYPE = BUF(5) - 0.5
      IF (IABS(ITYPE) .EQ. 1) NSLICE = 1

      IMAMI    = BUF(6) + 0.5
      FMAX     = BUF(7)
      FMIN     = BUF(8)
      AV       = BUF(9)
      SIG      = BUF(10)
      NSAM     = BUF(12)
      LABREC   = BUF(13)
      IHIST    = 0
      IANGLE   = BUF(14)
      PHI      = BUF(15)
      THETA    = BUF(16)
      PSI      = BUF(17)
      XOFF     = BUF(18)
      YOFF     = BUF(19)
      ZOFF     = BUF(20)
      SCALE    = BUF(21)
      LABBYT   = BUF(22)
      LENBYT   = BUF(23)

      IF (BUF(24) .GT. 0) THEN
C        IS A STACK FILE, RETURN MAX. NO. OF USED IMAGES IN NSTACK
         NSTACK   = BUF(26)
      ELSE
C        NOT A STACK, RETURN -2
         NSTACK   = -2
      ENDIF

      IMUSED   = BUF(25)
      KANGLE   = BUF(30)
      PHI2     = BUF(31)
      THETA2   = BUF(32)
      PSI2     = BUF(33)
      PHI1     = BUF(34)
      THETA1   = BUF(35)
      PSI1     = BUF(36)

      DO I = 1,64
         HDR_VALS(I) = BUF(36+I)
      ENDDO

C     GET CURRENT DATE AND TIME FROM BUF
      CALL DATTIMTIT(BUF,.TRUE.,.FALSE.,LENTIT,IRTFLG)

      RETURN
      END
