
C++*********************************************************************
C
C OPENINFO.F   -- NEW 2 December 97 AUTHOR: ARDEAN LEITH

C **********************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK        *
C *  COPYRIGHT (C)1981,1987, WADSWORTH CENTER FOR LABORATORIES AND     *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.  *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS *
C *    OR USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN        *
C *    APPROVAL OF THE CENTER FOR LABORATORIES AND RESEARCH            *
C **********************************************************************
C
C    OPENINFO(NSAM,NROW,NSLICE,IMGNUM,NSTACK,LENTIT,DSP,IRTFLG)
C
C    PURPOSE:       TO PRINT FILE OPENING INFO.
C
C    PARAMETERS:
C        FILNAM     CHARACTER ARRAY, CONTAINING FILE NAME         (SENT)
C        NLET       LENGTH OF FILE NAME                           (SENT)
C        NSAM,NROW  DIMENSIONS OF FILE                       (SENT/RET.)
C        NSLICE     DIMENSIONS OF FILE                       (SENT/RET.)
C        IMGNUM     IMAGE NUMBER                             (SENT/RET.) 
C                   0           OVERALL STACK
C                   >0          GIVES NUMBER
C        NSTACK     FILE STACK SPECIFIER.                    (SENT/RET.) 
C                   -2          NOT A STACK
C                   >=0         EMPTY (BARE) STACK
C                   -1          STACK
C        LENTIT     LENGTH OF TITLE                          (SENT)
C        DSP        OLD OR NEW                               (SENT)
C        LABBYT     NUMBER OF BYTES IN HEADER                (SENT)
C        IRTFLG     ERROR RETURN FLAG.                       (RETURNED)
C                   IRTFLG = 0    NORMAL RETURN
C                   IRTFLG = 1    ERROR RETURN
C
C23456789 123456789 123456789 123456789 123456789 123456789 123456789 12
C--*********************************************************************

        SUBROUTINE OPENINFO(FILNM,NLET,NSAM,NROW,NSLICE,IMGNUM,NSTACK, 
     &                      LENTIT,DSP,LABBYT,IRTFLG)

CNO_SAVE

        LOGICAL SILENT
        COMMON  /IPRTT/  IPRTT,NTRACE,NALPH,N_VERBOSE,N_MOSAIC,SILENT
        COMMON  /UNITS/  LUNC,NIN,NOUT,NECHO,IFOUND,NPROC,NDAT
        COMMON /PARAM/   PARAM(103),NSEL(20)
        COMMON /MASTER/  NSAMC,NROWC,IREC,NHISTREC,IFORM,IMAMI,
     &                   FMAX,FMIN,AV,SIG,IHIST,IPROT
        CHARACTER *4     DATEXC,PRJEXC
        CHARACTER *10    CDAT
        CHARACTER *8     CTIM
        CHARACTER *160   CTIT
        COMMON /MASTER1/ DATEXC,PRJEXC,CDAT,CTIM,CTIT


        CHARACTER *(*)   FILNM
        CHARACTER * 1    DSP
        CHARACTER * 2    TYPE

        IF (IFORM .EQ. -2) THEN
            TYPE = 'P '
        ELSEIF (ITYPE .EQ. -9) THEN
            TYPE = 'FS'
        ELSEIF (IFORM .EQ. -11) THEN
            TYPE = 'O2'
        ELSEIF (IFORM .EQ. -12) THEN
            TYPE = 'E2'
        ELSEIF (IFORM .EQ. -21) THEN
            TYPE = 'O3'
        ELSEIF (IFORM .EQ. -22) THEN
            TYPE = 'E3'
	ELSEIF (IFORM .EQ. 0)  THEN
            TYPE = 'D '
        ELSEIF (IFORM .EQ. 1 .AND. NSTACK .GE. 0)  THEN
            TYPE = 'S2'
        ELSEIF (IFORM .EQ. 3 .AND. NSTACK .GE. 0)  THEN
            TYPE = 'S3'
        ELSEIF (IFORM .EQ. 3)  THEN
            TYPE = 'R3'
        ELSE
            TYPE = 'R '
        ENDIF

	IF (N_VERBOSE .EQ. 1 .AND. IFOUND .NE. -4) THEN
C         PRINT STACK OPENING INFORMATION

          LENT = LENTIT * NLET
          IF (LENTIT .LE. 0 .AND. NLET .GT. 0) THEN
C            FILENAME BUT NO TITLE
             WRITE(NOUT,*) FILNM(:NLET)

          ELSE IF (LENT .GT. 0 .AND. LENT .LT. 70) THEN
C            HAS FILENAME AND TITLE THAT FIT ON ONE LINE
             WRITE(NOUT,*) FILNM(:NLET),'     /',CTIT(:LENTIT)

          ELSEIF (LENT .GT. 0) THEN
C            FILENAME AND TITLE DO NOT FIT ON SINGLE LINE
             IF (NLET .GT. 0) WRITE(NOUT,*) FILNM(:NLET)
             LENT = MIN(80,LENTIT)
             WRITE(NOUT,*) CTIT(1:LENT)
             IF (LENTIT .GT. 80)  WRITE(NOUT,*) CTIT(81:LENTIT)
          ENDIF

         IF (IMGNUM .GT. 0 .AND. NSLICE .GT. 1) THEN
             WRITE(NOUT,90) TYPE,NSAM,NROW,NSLICE,IMGNUM,CDAT,CTIM,DSP
90  	     FORMAT(' (',A,')',3I5,' (@',I6,')  CREATED ',A,' AT ',A,
     &               2X,A)
          ELSE IF (IMGNUM .GT. 0) THEN
             WRITE(NOUT,91)TYPE,NSAM,NROW,IMGNUM,CDAT,CTIM,DSP
91           FORMAT(' (',A,')',2I5,' (@',I6,')  CREATED ',A,' AT ',A,
     &              2X,A)
          ELSE IF (NSLICE .GT. 1) THEN
             WRITE(NOUT,92) TYPE,NSAM,NROW,NSLICE,CDAT,CTIM,DSP,
     &                        LABBYT
92  	     FORMAT(' (',A,')',3I5,' CREATED ',A,' AT ',A,2X,A,
     &             ' HEADER BYTES:',I5)

          ELSE
             WRITE(NOUT,93)TYPE,NSAM,NROW,CDAT,CTIM,DSP,LABBYT
93           FORMAT(' (',A,')',2I5,' CREATED ',A,' AT ',A,2X,A,
     &             ' HEADER BYTES:',I5)
          ENDIF
        ENDIF

C       SET REGISTER VALUES AS NEEDED
        PARAM(2) = NSAM
	PARAM(3) = NROW
	PARAM(4) = FMAX
	PARAM(5) = FMIN
	PARAM(6) = AV
	PARAM(7) = SIG
	PARAM(8) = NSLICE
        PARAM(9) = NSTACK

        IRTFLG   = 0

        RETURN
        END
