
C++************************************************************************
C
C OPRINT.FOR                        FILENAMES LENGTHENED DEC 8 88 al
C
C **************************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK            *
C *  COPYRIGHT (C)1981,1987, WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH 			   *
C **************************************************************************
C
C    OPRINT(FILNAM,LUN,NSAM,NROW)
C
C    PURPOSE:   TO MAKE VISIBLE GRAYTONE DISPLAY OF IMAGE USING
C               OVERPRINTING ON THE LINE PRINTER. HAS 16 DIFFERENT
C               "HALF-TONE" CELLS AVALIBLE AT 16 DIFFERENT DENSITIES
C
C    PARAMETERS:
C         FILNAM     FILE NAME (ONLY FOR TITLE)
C         LUN        LOGICAL UNIT NUMBER
C         NSAM,NROW  IMAGE DIMENSIONS
C         OPT        OUTPUT OPTION
C
C        0         2         3         4         5         6         7     
C23456789012345678901234567890123456789012345678901234567890123456789012
C--*******************************************************************

      SUBROUTINE OPRINT(FILNAM,LUN,NSAM,NROW,NSLICE,OPT)

      IMPLICIT INTEGER (A-Z)

      COMMON          RBUF(1)
      COMMON /COMMUN/ OLINE
      COMMON /UNITS/  LUNC,NIN,NOUT,NECHO,IFOUND,NPROC,NDAT
      COMMON /MASTER/ NSAMC,NROWC,IREC,NLABEL,IFORM,IMAMI,RMAX,RMIN,
     1                AV,SIG,IHIST

      REAL             RMIN,RMAX,SCALE,R,AV,RBUF
      INTEGER          WIDTH
      CHARACTER *130   OLINE
      CHARACTER *(*)   FILNAM
      CHARACTER *1     OPT,FRAME,MINUS,ANS,Y,TI,BLANK,TAB(5,15),NULL

      DATA BLANK/' '/,WIDTH/128/,Y/'Y'/,TI/'T'/,MINUS/'-'/,FRAME/'I'/
      DATA TAB/5*' ',')',4*' ','M',4*' ','Z',4*' ','X',
     1  4*' ','E',4*' ','=',4*' ','O','-',3*' ','O','=',3*' ','O','+',
     2 'I',2*' ','O','-','N',2*' ','O','+','I','=',' ','O','X','I','-',
     3 ' ','O','X','I','C','H','O','X','I','C','H'/

C     TAB ARRAY CHANGED 9/7/81 TO P.R.SMITH'S SET OF SYMBOLS

      NULL   = CHAR(0)

      STRSAM = 1
      NDEV   = NDAT
      IF (OPT .EQ. 'T') NDEV = 6
      EXPF   = 1.0

      CALL RDPRMC(ANS,NCHAR,.TRUE.,'CONTOURING? (Y/N)',NULL,IRTFLG)
      IF (NCHAR .EQ. 0) ANS = 'Y'
      IF (ANS .EQ. 'Y' .OR. ANS .EQ. 'y') THEN
         CALL RDPRMI(NCON,NDUM,NLOOP,ILOOP,'NUMBER OF LEVELS')
         EXPF = NCON
      ENDIF

1     PASS = 0
      IF (IMAMI .NE. 1) CALL NORM3(LUN,NSAM,NROW,NSLICE,RMAX,RMIN,AV)

800   CONTINUE
      PASS = PASS + 1

C     BLANK THE OUTPUT LINE
      DO I = 1,WIDTH
        OLINE(I:I) = BLANK
      ENDDO

      NUMREM = NSAM-STRSAM+1
      PSIZ   = MIN0(NUMREM,WIDTH)
      BSIZ   = (WIDTH-PSIZ)/2
9     SCALE  = 15./(RMAX-RMIN)*EXPF
      PSIZ   = MIN0(NSAM,WIDTH)

      CALL PDATES(FILNAM,1)

C     PUT FRAME IN THE OUTPUT LINE
      DO  I=1,PSIZ
         OLINE(I:I) = MINUS
      ENDDO

C     PRINT THE TOP OF THE IMAGE FRAME
      WRITE(NDEV,99) FRAME,(OLINE(L:L),L=1,PSIZ),FRAME

      DO  I = 1,NROW
C        READ LINE OF IMAGE
         CALL REDLIN(LUN,RBUF,NSAM,I)

         DO 20 K = 1,5
C          EACH LINE IS PRINTED 5 TIMES USING DIFFERENT SYMBOLS

           DO  J = 1,PSIZ
             I1 = STRSAM+J-1
C            CHOOSE DESIRED SYMBOL FOR THIS INTENSITY AND OVERPRINT LEVEL
             VAL = (RBUF(I1)-RMIN)*SCALE+1
             IF (ANS .EQ. 'Y') VAL = MOD(VAL,16)+1
             OLINE(J:J) = TAB(K,VAL)
	   ENDDO

           IF (K .EQ. 1) THEN
C            FIRST OF 5 PRINTS ON THIS LINE
             WRITE(NDEV,99) FRAME,(OLINE(L:L),L=1,PSIZ),FRAME
99           FORMAT(' ',130A1)

           ELSE
C            2ND.. 4TH OVERPRINT 
             DO  J=1,PSIZ
               IF (OLINE(J:J) .NE. BLANK) THEN
                  WRITE(NDEV,98) BLANK,(OLINE(L:L),L=1,PSIZ),BLANK
98                FORMAT('+',130A1)
                  GOTO 20
               ENDIF
	     ENDDO
           ENDIF
20       CONTINUE
      ENDDO

      STRSAM = STRSAM+PSIZ

C     PUT LOWER IMAGE FRAME IN THE OUTPUT LINE
      DO I = 1,PSIZ
         OLINE(I:I) = MINUS
      ENDDO

C     PRINT LOWER FRAME
      WRITE(NDEV,99) FRAME,(OLINE(L:L),L=1,PSIZ),FRAME
      IF (STRSAM.LT.NSAM) GOTO 800

900   CONTINUE
      IF (OPT .EQ. 'T') RETURN

      RETURN
      END
