C++************************************************************************
C
C $$ ORMD.FOR
C
C **************************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK            *
C *  COPYRIGHT (C)1981,1987, WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *  THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR       *
C *  LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR    *
C *  USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF     *
C *  THE CENTER FOR LABORATORIES AND RESEARCH   			   *
C **************************************************************************
C
C
C
C23456789012345678901234567890123456789012345678901234567890123456789012
C--************************************************************************
C
C $$ ORMD.FOR
C
	SUBROUTINE ORMD(MAXMEM)
	INCLUDE 'CMBLOCK.INC'
	PARAMETER  (MRING=480)
	COMMON  DUMMY(80),BUF(1024),Q(1)
	COMMON  /F_SPEC/  FINPAT,NLET,FINPIC
	CHARACTER*80  FINPIC,FINPAT
	INTEGER*2  MAXRIN
	INTEGER*2  NUMR(3,MRING)
	COMMON /MXR/ MAXRIN
	CHARACTER*1  MODE,ASK,NULL
C         EQUIVALENCE  (Q,NUMR)
	DATA  INPIC/77/,INREF/76/
CNO_SAVE
	NULL=CHAR(0)
C
C  ASK FOR DATA FILES
C
	CALL  FILERD(FINPIC,NLET,NULL,'Input',IRTFLG)
C
	CALL  OPENFB(BUF,FINPIC,INPIC,NSAM,NROW,'O',NF,NSL)
	IF(NF.NE.2)  THEN
	WRITE(NOUT,*)  ' File not found'
	RETURN
	ENDIF
C
	CALL  FILERD(FINPIC,NLET,NULL,'Reference',IRTFLG)
C
	CALL  OPENFB(BUF,FINPIC,INREF,NSAM,NROW,'O',NF,NSL)
	IF(NF.NE.2)  THEN
	WRITE(NOUT,*)  ' File not found'
	CLOSE(INPIC)
	RETURN
	ENDIF
C
	CALL  RDPRMI(MR,NR,NLOOP,ILOOP,'FIRST AND LAST RING')
	CALL  RDPRMI(ISKIP,NDUMP,NLOOP,ILOOP,'SKIP')
	ISKIP=MAX0(1,ISKIP)
C
	NA=1
	CALL  RDPRMC(ASK,NA,.TRUE.,'(F)ULL OR (H)ALF CIRCLE',NULL,IRT)
	IF(ASK.EQ.'H')  THEN
	MODE='H'
	ELSE
	MODE='F'
	ENDIF
	IF(FCHAR(5:5).EQ.'M') THEN
	CALL  RDPRMI(NPEAK,NDUMP,NLOOP,ILOOP,'Number of peaks')
	NPEAK=MAX0(1,NPEAK)
	ELSE
	NPEAK=1
	ENDIF
C
	NRING=0
	DO    I=MR,NR,ISKIP
	NRING=NRING+1
	IF(NRING.GT.MRING)  THEN
	CALL ERRT(31,'OR 2',IE)
	CLOSE(INPIC)
	CLOSE(INREF)
	RETURN
	ENDIF
	NUMR(1,NRING)=I
	ENDDO
C
C Calculation of actual dimension of an image to be interpolated
C 2*(# of rings)+(0'th element)+2*(margin of 1)
C
         NRA=MIN0(((NSAM-1)/2)*2+1,((NROW-1)/2)*2+1,2*NR+3)
         LSAM=NSAM
         LROW=NROW
         NSAM=NRA
         NROW=NRA
         CALL  ALPRBS(NUMR,NRING,LCIRC,MODE)
C
C   memory division
C     NUMR        1
C     CIRC        2
C A: X                 3
C    BUFIN             4
C          B:
C             CIROLD   4
C             TEMP     6
C
         MAXRIN=NUMR(3,NRING)
         K1=1
c         K2=K1+(3*NRING+3)/2
         K2=K1
         K7=IPALIGN64(K2+LCIRC)
         K41A=IPALIGN64(K7+NSAM*NROW)
         K4B=IPALIGN64(K41A+LSAM)
         K6B=IPALIGN64(K4B+LCIRC)
         K7B=IPALIGN64(K6B+MAXRIN*4)
         K8B=K7B+4*NPEAK
         MEMTOT=1200+K8B
C
	IF (MEMTOT .LE. MAXMEM)  THEN
         CALL  ORMD_P(NSAM,NROW,LSAM,LROW,
     &   NRING,LCIRC,MAXRIN,NUMR,
     &   Q(K2),Q(K7),Q(K41A),Q(K4B),
     &   Q(K6B),Q(K7B),NPEAK,MODE,INPIC,INREF)
	ELSE
         WRITE (NOUT,2500)  MAXMEM , MEMTOT
2500     FORMAT (/,'  MEMORY RESERVATION: YOU HAVE',
     #   ' RESERVED ',I8,',  YOU NEED  ',I8 / )
	CALL ERRT(6,'OR 2',IE)
	CLOSE(INPIC)
	CLOSE(INREF)
	ENDIF
	END
