C++************************************************************************
C
C $$ ORMD_P.FOR
C
C **************************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK            *
C *  COPYRIGHT (C)1981,1987, WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *  THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR       *
C *  LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR    *
C *  USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF     *
C *  THE CENTER FOR LABORATORIES AND RESEARCH   			   *
C **************************************************************************
C
C
C
C23456789012345678901234567890123456789012345678901234567890123456789012
C--************************************************************************
C
C $$ ORMD_P.FOR
C
	SUBROUTINE  ORMD_P(NSAM,NROW,LSAM,LROW,
     &   NRING,LCIRC,MAXRIN,NUMR,
     &   CIRC,X,BUFIN,CIROLD,
     &   TEMP,PEAK,NPEAK,MODE,INPIC,INREF)
	INCLUDE 'CMBLOCK.INC'
        PARAMETER (NDLI=3)
        DIMENSION DLIST(NDLI)
	INTEGER*2  MAXRIN,CMP
	DIMENSION  X(NSAM,NROW),BUFIN(LSAM)
	DIMENSION  CIRC(LCIRC),CIROLD(LCIRC)
	INTEGER*2  NUMR(3,NRING)
	DOUBLE PRECISION TEMP(MAXRIN,2),PEAK(2,NPEAK)
	DOUBLE PRECISION TOTMIN,EAV,TOTMIR,T7(-3:3)
	CHARACTER*1  MODE
	DATA  NDOC/56/
CNO_SAVE
	JACUP=0
C
	LQ=LROW/2+1
	LR1=(NROW-1)/2
 	LR2=LQ+LR1
	LR1=LQ-LR1
	LQ=LSAM/2+1
	LS1=(NSAM-1)/2
	LS2=LQ+LS1
	LS1=LQ-LS1
C
	DO    K2=LR1,LR2
	CALL  REDLIN(INPIC,BUFIN,LSAM,K2)
	DO    K3=LS1,LS2
	X(K3-LS1+1,K2-LR1+1)=BUFIN(K3)
	ENDDO
	ENDDO
	CLOSE(INPIC)
C
C  Normalize under the mask
C
	CALL NORMAS(X,-NSAM/2,NSAM/2,-NROW/2,NROW/2,
     &   NUMR,NUMR(1,NRING))
C
	CALL  ALRQ(X,NSAM,NROW,NUMR,CIRC,LCIRC,NRING,MODE,K3)
	CALL  FOURING(CIRC,LCIRC,NUMR,NRING,EAV,MODE)
C
	DO    K2=LR1,LR2
	CALL  REDLIN(INREF,BUFIN,LSAM,K2)
	DO    K3=LS1,LS2
 	X(K3-LS1+1,K2-LR1+1)=BUFIN(K3)
	ENDDO
	ENDDO
	CLOSE(INREF)
C
C  Normalize under the mask
C
	CALL NORMAS(X,-NSAM/2,NSAM/2,-NROW/2,NROW/2,
     &   NUMR,NUMR(1,NRING))
C
	CALL  ALRQ(X,NSAM,NROW,NUMR,CIROLD,LCIRC,NRING,MODE,K3)
	CALL  FOURING(CIROLD,LCIRC,NUMR,NRING,EAV,MODE)
C
	CALL  CROSRNG
     &   (CIRC,CIROLD,LCIRC,NRING,TEMP,TEMP(1,2),
     &   MAXRIN,JACUP,NUMR,TOTMIN,TOT,MODE)
C  Find specified number of peaks
	DO  K2=1,NPEAK
	PEAK(1,K2)=-1.0D20
	PEAK(2,K2)=-1.0
	ENDDO
	DO    J=1,MAXRIN
        CMP = J+MAXRIN-1
        J2=MOD(CMP,MAXRIN)+1
        CMP = J+MAXRIN-2
        J1=MOD(CMP,MAXRIN)+1
        CMP = J+MAXRIN
        J3=MOD(CMP,MAXRIN)+1
	IF(TEMP(J2,2).GT.TEMP(J1,2) .AND. TEMP(J2,2).GT.TEMP(J3,2)) THEN
		DO  K2=1,NPEAK
		IF(TEMP(J2,2).GT.PEAK(1,K2))  THEN
			IF(NPEAK.GT.1)  THEN
			DO  K3=NPEAK,K2+1,-1
			PEAK(1,K3)=PEAK(1,K3-1)
			PEAK(2,K3)=PEAK(2,K3-1)
			ENDDO
			ENDIF
		PEAK(1,K2)=TEMP(J2,2)
		PEAK(2,K2)=J
		GOTO 1209
		ENDIF
		ENDDO
1209		CONTINUE
	ENDIF
	ENDDO
C  Convert to angles and do the interpolation
	DO  K2=1,NPEAK
	JTOT=PEAK(2,K2)
	NPT=K2-1
	IF(JTOT.EQ.-1)  GOTO  1409
	DO  K3=-3,3
        CMP = JTOT+K3+MAXRIN-1
        J=MOD(CMP,MAXRIN)+1
	T7(K3)=TEMP(J,2)
	ENDDO
	CALL  PRB1D(T7,7,POS)
	PEAK(1,K2)=PEAK(1,K2)/MAXRIN/NRING
	RANG=PEAK(2,K2)+POS
	PEAK(2,K2)=ANGMOR(RANG,MODE)
	IF(FCHAR(5:5).EQ.'M')  THEN
	DLIST(1)=K2
	DLIST(2)=PEAK(2,K2)
	DLIST(3)=PEAK(1,K2)
	CALL  SAVD(NDOC,DLIST,NDLI,IRTFLG)
	ENDIF
	WRITE(NOUT,2700)  PEAK(2,K2),PEAK(1,K2)
2700	FORMAT('    Angle = ',F10.4,'    Peak = ',G12.5)
	ENDDO
1409	CONTINUE
	IF(FCHAR(5:5).EQ.'M')  THEN
c  Multiple peaks
        CLOSE(NDOC)
        CALL  SAVDC
C  First register is the number of peaks saved
	IF(NSEL(1).NE.0) PARAM(NSEL(1))=NPT
	ELSE
C  One peak
C  First register is the angle, second the peak value
	IF(NSEL(1).NE.0) PARAM(NSEL(1))=PEAK(2,1)
	IF(NSEL(2).NE.0) PARAM(NSEL(2))=PEAK(1,1)
	ENDIF
	END
