
C 
C  PROGRAM TO CALCULATE MORE THEN ONE ANGLE IN THE ROTATIONAL ORIENTATION
C  PROGRAM (ORNTS)
C
C  VARIABLES:  A1,A2      BUFFER ADDRESS
C              N          DIMENSION OF THE CURVE
C              TLIST      ARRAY FOR VALUES OF MAXIMA
C              JLIST      ARRAY FOR INDICES OF MAXIMA
C              NP         NUMBER OF PEAKS
C              RKEY       ARRAY ( DIMENSION N ) USED FOR SORTING
C              DUM          "          "          "   "    "
C FEB.85  MR
C
C-*************************************************************************

      SUBROUTINE ORPKS(A1,A2,N,TLIST,JLIST,NP,RKEY,DUM)

      COMMON /PARAM/PARAM(103),NSEL(10)
      COMMON/FUNCTION/FCHAR
      COMMON /CMAX/CRVMAX,CRVMIN
      COMMON /BATCH/IBCNT,NLOOP,IABSLP,ILOOP
      COMMON /UNITS/LUN,NIN,NOUT,NECHO,IFOUND,NPROC,NDAT
      COMMON /MASTER/ NSAMC,NROWC,IREC,NLABEL,IFORM,IMAMI,FMAX,FMIN,
     1 AV,SIG,IHIST
      COMMON BUF(1)

      INTEGER       A1,A2
      REAL          MU1,MU2,W(20),RA(20)
      DIMENSION     TLIST(1),JLIST(1),RKEY(1),DUM(1)
      CHARACTER *80 FCHAR

      DATA PI/3.141593/,W/.1,19*1./


C     FIND ALL LOCAL MAXIMA BETWEEN INDEX 2 AND N-1:

       CALL RDPRMI(NP,IDUM,NLOOP,ILOOP,'NUMBER OF PEAKS')
       RCP=1./FLOAT(N)
       KK=0
       DO 1 K=2,N-1
         T=BUF(A1+K)
         IF (T.LT.BUF(A1+K-1).OR.T.LT.BUF(A1+K+1)) GOTO 1
         KK=KK+1
         TLIST(KK)=T
         JLIST(KK)=K
         WRITE(NOUT,100) T,K
100      FORMAT(1X,'PEAK FOUND:',F12.4,I5)
1      CONTINUE

C  LOOK IF THERE IS A MAXIMUM AT THE EDGE OF THE CURVE

       T1=BUF(A1+1)
       IF (T1.LT.BUF(A1+2).OR.T1.LT.BUF(A1+N)) GOTO 2
       KK=KK+1
       TLIST(KK)=T1
       JLIST(KK)=1
2      CONTINUE
       T1=BUF(A1+N)
       IF (T1.LT.BUF(A1+1).OR.T1.LT.BUF(A1+N-1)) GOTO 3
       KK=KK+1
       TLIST(KK)=T1
       JLIST(KK)=N
3      CONTINUE

C  NOW TLIST CONTAINS THE PEAKHEIGTHS AND JLIST THE INDICES
C  SORT THEM:

       IF (KK.LT.NP) NP=KK
C       WRITE(NOUT,101)(TLIST(LL),JLIST(LL),LL=1,KK)
101    FORMAT(' TLIST,JLIST:',F12.4,I5)
       DO  I=1,N
         RKEY(I)=TLIST(I)
       ENDDO
       CALL SORTZ(RKEY,DUM,TLIST,JLIST,KK)
C       WRITE(NOUT,102)
102    FORMAT(' AFTER SORTING')
C       WRITE(NOUT,101)(TLIST(LL),JLIST(LL),LL=1,KK)

C  DO PARABOLIC FITS

C       WRITE(3,82)(BUF(LL+A1),LL=1,N)
       DO  K=1,NP
       KP=KK-K+1
       T1 = TLIST(KP)
       J=JLIST(KP)
       IF (J+3.LE.N.AND.J-3.GE.1)GOTO 75
C CIRCULAR CONTINUATION. IT IS ASSUMED THAT THIS CONTINUATION IS
C ONLY NECESSARY IN ACF PASS.
	DO  I=N+1,N+3
	  BUF(A1+I)= BUF(A1+I-N)
	ENDDO
	DO  I=-2,0
	  BUF(A1+I)=BUF(A1+I+N)
	ENDDO
C
C PARABOLIC FIT ESTIMATION
75	CALL PARAB1(BUF(A1+J-3),7,POS1)
	POS=POS1+J-1
C	WRITE(NDAT,7599)(BUF(A1+J-4+LL),LL=1,7),POS1,POS
7599	FORMAT(9G12.4)
	THETA1= (POS*RCP-0.5)*PI
	IF (FCHAR(4:4) .EQ. 'F') THETA1=THETA1*2.
	THETD1= THETA1*180./PI
      WRITE(NDAT,81) THETD1
81    FORMAT(/' ANGLE BETWEEN PICTURES ',
     1 F8.1,'DEGREES'/)
 82   FORMAT(1X,10E12.3)
      IF (NOUT .NE. NDAT) WRITE(NOUT,83) THETD1
83    FORMAT(' ROTATION ANGLE ',F8.1,' DEGREES')
      IF (NSEL(K) .NE. 0) PARAM(NSEL(K)) = THETD1

      ENDDO
      CALL GRAPHO(BUF(A1+1),N,1,0.)
      END
