

C A new level of density, store it and if necessary, write it out as 
C 3-d non-overlapping boxes of 8*8*8 values
C Original logic by Alwyn Jones, a long time ago.
C Modified as library routine, new brick format, Morten Kjeldgaard, Nov 1993
c=======================================================================

      SUBROUTINE PAGED (OLUN, RHOSEC, SLICES, IX, IY, NX, NY, 
     &                  ILEV, INUM, ERR)

#ifndef SP_SUN4
      IMPLICIT     NONE
#endif
      INTEGER      OLUN, IX, IY, NX, NY, ERR
      REAL         RHOSEC(IY, IX), SLICES(8,IX*IY)

      COMMON      /PAGEDC/ FMT
      CHARACTER*4 FMT

      INTEGER     I, ICT, I1, ILEV, J, JCT, J1, J2, J3, K, K1, K2, K3 
      INTEGER     VALUE, INUM
      CHARACTER*1 RECORD(512)
      INTEGER*2   IREC(256)
      EQUIVALENCE (RECORD, IREC) 

      ERR = 0

      I1  = MOD (ILEV,8)
      IF (I1 .EQ. 0) I1 = 8
      ICT = 0

      IF (ILEV .NE. 0) THEN
         DO I=1,IY
            DO J=1,IX
               ICT = ICT+1
               SLICES(I1,ICT) = RHOSEC(I,J)
            ENDDO
         ENDDO
      ENDIF

C     PICK OUT OUR NON-OVERLAPPING BRICKS?
      IF (I1 .NE. 8 .AND. ILEV .NE. 0) RETURN

      VALUE = 0
C     LOOP OVER POSSIBLE Y-PAGES
      DO J=1,NY
         J1 = (J-1)*8+1
         J2 =   J  *8

C        LOOP OVER POSSIBLE X-PAGES
         DO K=1,NX
            K1 = (K-1)*8+1
            K2 =   K  *8
            ICT = 0

C           LOOP OVER Z-LEVELS
            DO I=1,8

C              LOOP OVER Y-INDECES OF CURRENT PAGE
               DO J3=J1,J2
                  JCT = (J3-1)*IX+K1-1

C                 LOOP OVER X-INDECES OF CURRENT PAGE
                  DO K3=K1,K2
                     ICT = ICT+1
                     JCT = JCT+1

C                    IF EITHER DIRECTION OVER EDGE, PACK RECORD
                     IF (J3 .GT. IY  .OR.  K3 .GT. IX 
     $                    .OR. I .GT. I1)  THEN
                        RECORD(ICT) = CHAR(0)
                     ELSE
                        RECORD(ICT) = CHAR(INT(SLICES(I,JCT)))
                     END IF
                  ENDDO
               ENDDO
            ENDDO

            INUM = INUM+1

            IF (FMT .EQ. 'OLD') THEN
               CALL BYTSWP (IREC)
               WRITE (OLUN, REC=INUM, IOSTAT=ERR) IREC
            ELSE
               WRITE (OLUN, REC=INUM, IOSTAT=ERR) RECORD
            ENDIF

         ENDDO
      ENDDO

      RETURN
      END
