
C++****************************************************** VAX 9/25/81
C
C PARABL.FOR
C
C **************************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK            *
C *  COPYRIGHT (C)1981, DIVISION OF LABORATORIES AND                       *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH 			   *
C **************************************************************************
C
C PARABL  9/25/81 : PARABOLIC FIT TO 3 BY 3 PEAK NEIGHBORHOOD
C
C THE FORMULA FOR PARABOLOID TO BE FIITED INTO THE NINE POINTS IS:
C
C	F = C1 + C2*Y + C3*Y**2 + C4*X + C5*XY + C6*X**2
C
C THE VALUES OF THE COEFFICIENTS C1 - C6 ON THE BASIS OF THE
C NINE POINTS AROUND THE PEAK, AS EVALUATED BY ALTRAN:
C
C--*************************************************************************

	SUBROUTINE PARABL(Z,XSH,YSH,PEAKV)

	REAL Z(3,3)
CNO_SAVE

	C1 = (26.*Z(1,1) - Z(1,2) + 2*Z(1,3) - Z(2,1) - 19.*Z(2,2)
     1     -7.*Z(2,3) + 2.*Z(3,1) - 7.*Z(3,2) + 14.*Z(3,3))/9.
C
	C2 = (8.* Z(1,1) - 8.*Z(1,2) + 5.*Z(2,1) - 8.*Z(2,2) + 3.*Z(2,3)
     1     +2.*Z(3,1) - 8.*Z(3,2) + 6.*Z(3,3))/(-6.)
C
	C3 = (Z(1,1) - 2.*Z(1,2) + Z(1,3) + Z(2,1) -2.*Z(2,2)
     1     + Z(2,3) + Z(3,1) - 2.*Z(3,2) + Z(3,3))/6.
C
	C4 = (8.*Z(1,1) + 5.*Z(1,2) + 2.*Z(1,3) -8.*Z(2,1) -8.*Z(2,2)
     1     - 8.*Z(2,3) + 3.*Z(3,2) + 6.*Z(3,3))/(-6.)
C
	C5 = (Z(1,1) - Z(1,3) - Z(3,1) + Z(3,3))/4.
C
	C6 = (Z(1,1) + Z(1,2) + Z(1,3) - 2.*Z(2,1) - 2.*Z(2,2)
     1     -2.*Z(2,3) + Z(3,1) + Z(3,2) + Z(3,3))/6.

C THE PEAK COORDINATES OF THE PARABOLOID CAN NOW BE EVALUATED AS:

	YSH=0.
	XSH=0.
	DENOM=4.*C3*C6 - C5*C5
	IF (DENOM.EQ.0.) RETURN
	YSH=(C4*C5 - 2.*C2*C6) /DENOM-2.
	XSH=(C2*C5 - 2.*C4*C3) /DENOM-2.
	PEAKV= 4.*C1*C3*C6 - C1*C5*C5 -C2*C2*C6 + C2*C4*C5 - C4*C4*C3
	PEAKV=PEAKV/DENOM
C       LIMIT INTERPLATION TO +/- 1. RANGE
	IF (YSH.LT.-1.)YSH=-1.
	IF (YSH.GT.+1.)YSH=+1.
	IF (XSH.LT.-1.)XSH=-1.
	IF (XSH.GT.+1.)XSH=+1.

        RETURN
	END
