C *NAME* = PARST.FOR                   31-JAN-86      13:23:09                  
C----------------------------------=*=----------------------------------        
C           COPYRIGHT 1986 - JEAN-PIERRE BRETAUDIERE                            
C THE UNIVERSITY OF TEXAS HEALTH SCIENCE CENTER AT HOUSTON                      
C MEDICAL SCHOOL - DEPARTMENT OF PATHOLOGY AND LABORATORY MEDICINE              
C P.O. BOX 20708, HOUSTON, TX 77225.                                            
C DISCLAIMER: NO GUARANTEES OF PERFORMANCE ACCOMPANY THIS SOFTWARE,             
C NOR IS ANY RESPONSIBILITY ASSUMED ON THE PART OF THE AUTHOR                   
C OR THE INSTITUTION.  ALL THE SOFTWARE HAS BEEN TESTED EXTENSIVELY             
C AND EVERY EFFORT HAS BEEN MADE TO INSURE ITS RELIABILITY.                     
C THE FOLLOWING SOFTWARE MAY NOT BE COMMUNICATED TO A THIRD PARTY               
C UNDER ANY FORM WITHOUT WRITTEN PERMISSION OF THE AUTHOR.                      
C PLEASE REPORT ANY BUG(S) TO JPB AT (713) 792 52 00.                           
C OR THRU ARPANET AT  ......!rice!ots!ut-path!suprim                            
C*--------------------------------------------------------------------*         
C*                                                                    *         
C     CLUSTERING OF ICARD OBJECTS CHARACTERIZED BY KFAC COORDINATES.  *         
C NKLA CLUSTERS ARE DETERMINED.  THE NKLA-1 FIRST CLUSTERS            *         
C CONTAIN THE MOST STABLE OBJECTS AS OBTAINED FROM THE NBASE          *         
C BASIC PARTITIONS.  EACH BASIC PARTITION IS GENERATED BY NITER       *         
C ITERATIONS AROUND NCLAS SEED-OBJECTS RANDOMLY DRAWN.  THE           *         
C SEED OBJECTS ARE REPLACED AFTER THE FIRST ITERATION BY THE          *         
C GRAVITY CENTERS OF THE GENERATED CLASSES.                           *         
C    INPUT  ..... DATA IN (NGUS) UNFORMATTED                          *         
C ICARD     = NUMBER OF OBJECTS TO BE CLUSTERED                       *         
C KFAC      = NUMBER PF COORDINATES FOR THE OBJECTS                   *         
C NBASE     = NUMBER OF BASIC PARTITIONS                              *         
C NITER     = NUMBER OF ITERATIONS FOR EACH BASIC PARTITION           *         
C NCLAS     = NUMBER OF CLASSES FOR EACH BASIC PARTITION              *         
C NKLA      = FINAL NUMBER OF CLUSTERS  ... LES NKLA-1 PREMIERES      *         
C             CONTIENDRONT  LES INDIVIDUS LES PLUS STABLES            *         
C N2DIM     = MAJORANT DE  2*NCLAS                                    *         
C KDIM      = MAJORANT DE  MAX (ICARD , NCLAS ** NBASE)               *         
C    OUTPUT   ..... NUMBER AND COORDINATES OF SEED-OBJECTS            *         
C KLAS(ICARD)= CLASS NUMBER OF EACH OBJECT                            *         
C    AND, IF NBASE.GT.1                                               *         
C KFIN       = NUMBER OF FINAL CLUSTERS NOT EMPTY                     *         
C JV(KFIN)   = SIZES RANKED IN DESCENDING ORDER OF THE                *         
C              STABLE CLUSTERS                                        *         
C     WORKING ARRAYS  CI(KFAC),JW(KDIM),G(N2DIM,KFAC)                 *         
C PROGRAMS CALLED SEN3A, SHELK, RETIR, OUVRE, CLAST, STABK.           *         
C*                                                                    *         
C==01.14.81                                                           *         
C==01.12.81                                                           *         
C*--------------------------------------------------------------------*         
      SUBROUTINE PARST (N2DIM,KDIM,NFAC,ICARD,KFAC,NBASE,NITER,NCLAS,           
     #                        NKLA,KLAS,JW,U,CI,JV, G, KFIN ,NGUS,NBAND)        
C                                                                               
      DIMENSION KLAS(ICARD),CI(NFAC),G(N2DIM,KFAC)                              
      DIMENSION U(KDIM), JV(KDIM), JW(KDIM)                                     
      COMMON / ENSOR / LEC,IMP                                                  
      NSTAB = NKLA - 1                                                          
      WRITE (IMP,1000)  ICARD , KFAC                                            
      IF (NBASE .GT. 1)  WRITE (IMP,2000) NKLA,NSTAB,NBASE,NITER,NCLAS          
C                                                                               
C.......... EXHAUSTIVE RANDOM DRAWING OF THE SEED-OBJECTS                       
C           FOR THE NBASE PARTITION                                             
C                                                                               
      KGERM = NCLAS*NBASE                                                       
      CALL RETIR ( ICARD, KLAS, KGERM, JV )                                     
C                                                                               
C.......... COPY OVER ALL SEED-OBJECTS ON NBAND                                 
C                                                                               
      CALL REW(NGUS, 0)                                                         
      REWIND NBAND                                                              
        DO   I = 1,ICARD                                                      
      READ (NGUS)  (CI(KF), KF=1,KFAC)                                          
        DO   M = 1,KGERM                                                      
      IF (JV(M) .EQ. I)        WRITE (NBAND) I, (CI(KF),KF=1,KFAC)              
        ENDDO      
	ENDDO
C                                                                               
C.......... BIG LOOP OVER THE BASIC PARTITIONS N=1,NBASE                        
C                                                                               
      KG1   = 1                                                                 
        DO 100 N = 1,NBASE                                                      
      KG2   = KG1 + NCLAS - 1                                                   
      WRITE (IMP,3000)  (JV(LL), LL=KG1,KG2)                                    
      J     = 0                                                                 
C                                                                               
C.......... SEED-OBJECTS TABLE FOR PARTITION NUMBER N                           
C                                                                               
      REWIND NBAND                                                              
        DO   L = 1,KGERM                                                      
      READ (NBAND)  I , (CI(KF), KF=1,KFAC)                                     
        DO 40  LL = KG1,KG2                                                     
        IF (JV(LL) .NE. I)             GO TO  40                                
      J     = J + 1                                                             
        DO   KF = 1,KFAC                                                      
          G(J,KF)= CI(KF)                                                           
	ENDDO
   40   CONTINUE                                                                
	ENDDO
C                                                                               
C.......... GENERATION OF PARTITION N BY NITER ITERATIONS.                      
C           UPDATE CENTERS AND CLASS NUMBERS OF OBJECTS.                        
C                                                                               
        DO   NIT = 1,NITER                                                    
      CALL CLAST (N2DIM,NFAC,ICARD,KFAC,NCLAS,G,JW,CI,U,NGUS)                   
      	ENDDO
      WRITE (IMP,4000) NITER                                                    
      WRITE (IMP,5000) (U(J), J=1,NCLAS)                                        
        IF (N .GT. 1)                  GO TO  80                                
        DO   I = 1,ICARD                                                      
      KLAS(I)= JW(I)                                                            
        ENDDO
        IF (NBASE .NE. 1)              GO TO  100                               
      KFIN  = NCLAS                                                             
      NKLA  = NCLAS                                                             
         RETURN                                                                 
   80   CONTINUE                                                                
        DO   I = 1,ICARD                                                      
      KLAS(I)= KLAS(I) + (JW(I) - 1)*NCLAS**(N-1)                               
      	ENDDO
C                                                                               
C.......... END OF BASIC PARTITION NUMBER N                                     
C                                                                               
  100 KG1   = KG1 + NCLAS                                                       
C                                                                               
C.......... GENERATION OF THE STABLE CLUSTERING WITH NKLA CLUSTERS              
C                                                                               
      KTOT  = NCLAS ** NBASE                                                    
      CALL STABK (ICARD,NKLA,KLAS,U,JV,JW,KTOT,KFIN,NIND)                       
      PCT   = 100.0*NIND/FLOAT(ICARD)                                           
      WRITE (IMP,6000)  KTOT                                                    
      WRITE (IMP,7000)  (JV(K), K=1,KFIN)                                       
      WRITE (IMP,8000)  (U(K), K=1,KFIN)                                        
      WRITE (IMP,9000)  NKLA, NIND, PCT                                         
 1000 FORMAT ('1',25X,'CLUSTERING BY AGGREGATION AROUND MOBILE CENTERS',/       
     #        //,25X,'PARTITION OF' ,I7,'  OBJECT CHARACTERIZED'  ,             
     #    ' BY' ,I5,'  CARTESIAN COORDINATES'    /' ',132('-') //)              
 2000 FORMAT (                                                                  
     #   ' ',10X,'   PARTITION CONTAINS'  ,I5,'  CLASSES' /' ',10X,             
     #   'THE',I5,' FIRST CONTAINS THE MOST STABLE OBJECTS IN THE',             
     #   I5,'  BASIC PARTITIONS'  /' ',10X,                                     
     #   'EACH PARTITION IS GENERATED BY',I5,'  ITERATIONS',                    
     #  ' AROUND'    ,I5,'  SEED-OBJECTS DRAWN AT RANDOM'    /// )              
 3000 FORMAT (/' ',10X,'CONSTRUCTION OF A PARTITION',                           
     #                  ' WITH SEED-OBJECTS',10I6)                              
 4000 FORMAT (' ',20X,'SIZE OF CLUSTERS AFTER',I4,' ITERATIONS')                
 5000 FORMAT (' ',71X,10F6.0 )                                                  
 6000 FORMAT (//' ',10X,'SIZE OF THE',I6,' CLUSTERS FROM THE',                   
     #        ' CROSSED-PARTITION',/,10X,'FOLLOWED BY THE',                    
     #        'CUMULATIVE PERCENTAGES.')                                        
 7000 FORMAT (' ',/' ',20I6)                                                    
 8000 FORMAT (' ',/' ',20F6.1)                                                  
 9000 FORMAT (//,10X,'SIZE OF RESIDUAL CLUSTER   (NUMBER',I4,                   
     # ' )=',I6,///,47X,'PERCENTENTAGE =',F9.2,//' ',132('-')/)                 
         RETURN                                                                 
         END                                                                    
