C
C++************************************************************************
C
C   
C
C **************************************************************************
C *  AUTHOR :                                                              *
C *  COPYRIGHT (C)1987 , WADSWORTH CENTER FOR LABORATORIES AND             *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH                            *
C **************************************************************************
C
C
C	AUTHOR: MAHIEDDINE LADJADJ          11/1/93
C
C	NFAC 	NUMBER OF EIGENVECTORS REQUESTED
C       NUMIM	NUMBER OF IMAGES
C	NPIX    NUMBER OF PIXELS PER IMAGE
C	LSAV	SEQUENTIAL IMAGE FILE (INPUT)
C	LIMA    IMAGE COORDINATE FILE (OUTPUT)
C
C	S(,) HAS THE EIGENVECTORS (COLUMN)  OF X'X AND D() HAS THE
C       EIGENVALUES. X(I,*)= U() J=1,JTOT W/ I=1,ITOT
C
C         
C--*********************************************************************

        SUBROUTINE PCA_COORX(NFAC,KB,NPIX,NUMIM,S,D,TRACE,PJ,SOM, 
     &             CO, U, W, LSAV, LIMA, LPIX, LUV, MADAR)


        DIMENSION S(NPIX,KB), D(NPIX), CO(NPIX), PJ(NPIX),
     &            U(NPIX), W(NFAC)
        INTEGER LUV(NUMIM), MADAR(NPIX)
CNO_SAVE
        CALL REW(LSAV,  1)
        CALL REW(LIMA,  1)
        
        DO  J  =  1, NPIX
          CO(J)  =  0.0
        END DO

        DO I  =  1, NUMIM
          READ(LSAV) (U(J),  J = 1, NPIX),  PIA,  PVAR,  INO
C
C       COORDINATES  TO ORIGIN FOR THE ROWS
C       [W] = [X -<X>].[EIGENVECTORS]   MATRIX NOTATION. 
C       <Xi> AVERAGE VALUE OF PIXELS = SUM (Xij), j=1, numim
C
          DO  K  =  1, NFAC                                                   
            W(K)   =  0.0 
            DO J  =  1, NPIX
              W(K)   =  W(K)  +  (U(J) - PJ(J)/NUMIM) * S(J, K)
            END DO
          END DO

C
C       DISTANCES TO ORIGIN FOR THE ROWS                    
C
          DOR    =  0.0   
          DO J  =  1, NPIX
            DOR  =  DOR  +  (U(J) - PJ(J))**2
          END DO

          WRITE(LIMA) (W(K), K = 1, NFAC), PJ(J), DOR, INO, LUV(I)
        END DO
C
C       COORDINATES  FOR THE COLS
C
        DO J  =  1, NPIX
          DO K  =  1, NFAC 
C           if the images have some cross-correlation (i.e; (part of) one
C           image is the same as (part of) another), one of the factors
C           will be 0 (so a negative eigenvalue may exist).
C
C
C1          include the next line in the working version of this routine.
C2          delete comment 1 and 2
c           D(K) = AMAX1(D(K), 1.0E - 9)
            W(K) = S(J, K) * SQRT(D(K))            
          END DO
c          WRITE(LPIX) (W(K),  K = 1, NFAC),  PJ(J),  CO(J), MADAR(J)
          WRITE(LPIX) (W(K),K = 1, NFAC), PJ(J), CO(J), INO, MADAR(J)
        END DO
        END
