
C
C++************************************************************************
C
C           SUBROUTINE PCA_INCOR3
C
C **************************************************************************
C *  AUTHOR :                                                              *
C *  COPYRIGHT (C)1987 , WADSWORTH CENTER FOR LABORATORIES AND             *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH                            *
C **************************************************************************
C
C
C	AUTHOR: MAHIEDDINE LADJADJ          11/1/93
C
C
C       ITOT	NUMBER OF IMAGES
C	JTOT    NUMBER OF PIXELS PER IMAGE
C       JACT    NUMBER OF ACTIVE IMAGES
C	NFAC 	NUMBER OF EIGENVECTORS REQUESTED
C	LSAV	SEQUENTIAL IMAGE FILE (INPUT)
C	LUV	LOGICAL UTILITY VECTOR (1 = ACTIVE,  0 = INACTIVE)
C
C         
C--*********************************************************************
        
        SUBROUTINE PCA_INCOR3(ITOT, JTOT, JACT, NFAC, S, D, U,
     &                          PJ, TRACE, SOM, LSAV, LUV)


        REAL          S(JTOT,JTOT), D(JTOT), U(JTOT), PJ(JTOT)
        INTEGER       LUV(ITOT)
        CHARACTER * 1 ANS, NULL
        INTEGER       NCHAR,IRTFLG
CNO_SAVE                               
                        
        DO J  =  1, JTOT
          PJ(J)  =  0.0
        END DO
        DO J  =  1, JTOT
          DO JJ  =  1, J
            S(J, JJ) =  0.0
          END DO
        END DO

        CALL REW ( LSAV,  1)
        SOM    =  0.0
C
C       READ ALL THE IMAGES.
C
        DO  I  =  1, ITOT
          IF(LUV(I) .EQ. 0)  THEN
C
C           INACTIVE IMAGE, SKIP IT.
C
            READ(LSAV)
          ELSE
C
C           ACTIVE IMAGE. READ THE WHOLE IMAGE IN U() ARRAY.
C	    THE 2D IMAGE WAS STORED AS A 1D ARRAY. SEE JPMSK1.FOR ROUTINE.
C
C	    WE HAVE AN ARRAY X(ITOT,JTOT). EACH IMAGE IS ONE LONG ROW U()
C           IN THE X ARRAY. X(I,*) = U().
C
            READ (LSAV)  (U(J), J = 1, JTOT),  PIA,  VAR,  IDPIXL
C
C           NOTE 
C           PIA = SUM OF ALL THE PIXEL VALUES (.GT. 0.5) IN ONE IMAGE.
C           PIA = SUM OF U(K), K=1,JTOT.
C           SOM IS THE SUM OF ALL THE PIXEL VALUES IN ALL THE IMAGES.
C           note: som = sum of pj(j)   (j=1,jtot)
C
            SOM  =  SOM  +  PIA
C                                                      
C           PJ(K) IS THE SUM OF ENTRIES IN ONE COLUMN OF X ARRAY.
C
            DO  J = 1, JTOT
              PJ(J)  =  PJ(J)  +  U(J)
            END DO
C
C           WE ARE ASSUMING THAT THE ARRAY IS SYMMETRICAL.
C	    COMPUTE  S(JTOT,JTOT) = X'. X WHERE X' IS X TRANSPOSE.
C
            DO J  =  1, JTOT
              DO JJ  =  1, J
                S(J, JJ) =  S(J, JJ)  +  ( U(J) * U(JJ) )
              END DO
            END DO
          END IF        
        END DO
C
C       ALL THE IMAGES HAVE BEEN READ.
C	THE S ARRAY IS THE COVARIANCE MATRIX.
C
        DO  J  =  1, JTOT
          DO  JJ  =  1, J
            S(J, JJ) = (S(J, JJ) - (PJ(J) * PJ(JJ)) /ITOT) 
            S(JJ, J)  =  S(J, JJ)                                 
          END DO
        END DO

C
C       THE "trace" OF A MATRIX IS THE SUM OF THE ELEMENTS IN ITS DIAGONAL
C       trace = sum a(ii) i=1,max.
C
        TRACE  =  0.0
        DO J  =  1, JTOT
          TRACE  =  TRACE  +  S(J, J)
        END DO
C
C       DIAGONALISATION: EIGENVALUES AND EIGENVECTORS ARE COMPUTED.
C       ON RETURN FROM VPROP ROUTINE,
C       D() HOLDS THE EIGENVALUES WHILE S() HOLDS THE CORRESPONDING 
C	EIGENVECTORS.
C
        CALL VPROP (JTOT,  JTOT,  S,  D,  U,  KODE)

        IF (KODE  .NE.  0)  THEN
          WRITE (6, 1000)  KODE
1000      FORMAT('*** FATAL ERROR IN DIAGONALIZATION. KODE=',I4)
          STOP 'abnormal termination'
        ENDIF
        END
