#ifdef SP_DISTRIB 
 
C   THIS ROUTINE SPECIFIC TO WADSWORTH LABS AND IS NOT 
C       DISTRIBUTED TO OUTSIDE SITES
 
       SUBROUTINE pca_remake
 
       COMMON /UNITS/LUNC,NIN,NOUT
 
       WRITE(NOUT,*) 'DUMMY CALL: pca_remake'
       RETURN
       END
 
#else
 
C++************************************************************************
C
C
C **************************************************************************
C *  AUTHOR :  MAHIEDDINE LADJADJ                                          *
C *  COPYRIGHT (C)1987 , WADSWORTH CENTER FOR LABORATORIES AND             *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH                            *
C **************************************************************************
C
C 
C
C RECONSTITUTES  IMAGES USING COORDINATES STORED IN FILES (IMC***, PIX***)
C
C NIMA          NUMBER OF ACTIVE IMAGES
C NPIX          NUMBER OF ACTIVE PIXELS
C NFAC          NUMBER OF FACTORS USED IN THE ANALYSIS
C SUMP          TOTAL WEIGHT
C PIA           AVERAGE OF RECONSTITUTED IMAGE (SUPPLIED)
C RIM(NPIX)     OUTPUT IMAGE
C CP(NPIX,NFAC) PIXEL COOS AS NEEDED BY SRIPE
C CI(NFAC)      IMAGE COOS
C D(NFAC)       EIGENVALUES AS NEEDED BY SRIPE
C PJ(I)         AVERAGE OF INDIVIDUEL IMAGE.
C SDV(I)        STANDARD DEVIATION
C
C++************************************************************************
  
        SUBROUTINE PCA_REMAKE(J, NIMA, NPIX, NF, NV, NFAC,
     &                     PIA, RIM, CP, CI, D, PJ, ADD_AVRG)

        DIMENSION RIM(NPIX), CP(NPIX,NFAC), CI(NIMA,NFAC), D(NFAC)
        DIMENSION PJ(NPIX), NV(NF)
        REAL SUM
#ifdef SP_UNIX
        INCLUDE 'CMBLOCK.INC'
#else
        INCLUDE 'COMMON1:CMBLOCK.INC'
#endif
        CHARACTER *1 ADD_AVRG
CNO_SAVE
        SUM = 0
C
C LOOP OVER ALL PIXELS
C
        DO I = 1, NPIX
c
c	put back the averages to the original data if(pca_avrg)=true
c
          IF(ADD_AVRG.EQ.'Y') THEN
            RIM(I)  =  PJ(I)
          ELSE
            RIM(I) = 0
          END IF
          DO L = 1, NF
            K  =  NV(L)
            RIM(I)  =  RIM(I) + CP(I, K) * CI(J, K) / SQRT(D(K))
          END DO
          SUM = SUM + RIM(I)
        END DO
        PIA = SUM / FLOAT(NPIX)
        END
 
#endif
 
