C
C++************************************************************************
C
C    SUBROUTINE PCAXPROD   
C
C **************************************************************************
C *  AUTHOR :                                                              *
C *  COPYRIGHT (C)1987 , WADSWORTH CENTER FOR LABORATORIES AND             *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH                            *
C **************************************************************************
C
C
C	AUTHOR: MAHIEDDINE LADJADJ          11/1/93
C
C
C       ITOT	NUMBER OF IMAGES
C	JTOT    NUMBER OF PIXELS PER IMAGE
C       JACT    NUMBER OF ACTIVE IMAGES
C	NFAC 	NUMBER OF EIGENVECTORS REQUESTED
C	LSAV	SEQUENTIAL IMAGE FILE (INPUT)
C	LUV	LOGICAL UTILITY VECTOR (1 = ACTIVE,  0 = INACTIVE)
C       SDV     STANDARD DEVIATIONS         
C
C--*********************************************************************

        SUBROUTINE PCAXPROD(ITOT, JTOT, JACT, NFAC, S, D,
     &                         U, TRACE, SOM, LSAV, LUV)
                                                  
        REAL S(JTOT,JTOT), D(JTOT), U(JTOT)
        INTEGER LUV(ITOT),IRTFLG,NCHAR
        CHARACTER * 1  ANS,NULL
CNO_SAVE
        DO J  =  1, JTOT
          DO JJ  =  1, J
            S(J, JJ) =  0.0
          END DO
        END DO

        CALL REW ( LSAV,  1)
        SOM    =  0.0
C
C       READ ALL THE IMAGES.
C
        DO  I  =  1, ITOT
          IF(LUV(I) .EQ. 0)  THEN
C
C           INACTIVE IMAGE, SKIP IT.
C
            READ(LSAV)
          ELSE
C
C           ACTIVE IMAGE. READ THE WHOLE IMAGE IN U() ARRAY.
C	    THE 2D IMAGE WAS STORED AS A 1D ARRAY. SEE JPMSK1 ROUTINE.
C           THE 1D IMAGE WAS TRANSPOSED BY PCAXPOSE ROUTINE.
C	    WE HAVE AN ARRAY X(ITOT,JTOT). EACH IMAGE IS ONE LONG ROW U()
C           IN THE X ARRAY. X(I,*) = U().
C	    read a record and forget the other entries of the record
            READ (LSAV)  (U(J), J = 1, JTOT)
C
C           WE ARE ASSUMING THAT THE ARRAY IS SYMMETRICAL.
C	    COMPUTE  S(JTOT,JTOT) = X'. X WHERE X' IS X TRANSPOSE.
C
            DO J  =  1, JTOT
              DO JJ  =  1, J
                S(J, JJ) =  S(J, JJ)  +  ( U(J) * U(JJ) )
              END DO
            END DO
          END IF        
        END DO

C	COPY THE RIGHT TRIANGLE SIDE.
        DO  J  =  1, JTOT
          DO  JJ  =  1, J 
            S(JJ, J)  =  S(J, JJ)
          END DO
        END DO
C
C       ALL THE IMAGES HAVE BEEN READ.
C
C       THE "trace" OF A MATRIX IS THE SUM OF THE ELEMENTS IN ITS DIAGONAL
C       trace = sum a(i,i) i=1,max.
C
        TRACE  =  0.0
        DO J  =  1, JTOT
          TRACE  =  TRACE  +  S(J, J)
        END DO

C
C       DIAGONALISATION: EIGENVALUES AND EIGENVECTORS ARE COMPUTED.
C       ON RETURN FROM VPROP ROUTINE,
C       D() HOLDS THE EIGENVALUES WHILE S() HOLDS THE CORRESPONDING 
C	EIGENVECTORS.
C
        CALL VPROP (JTOT,  JTOT,  S,  D,  U,  KODE)

        IF (KODE  .NE.  0)  THEN
          WRITE (6, 1000)  KODE
1000      FORMAT('*** FATAL ERROR IN DIAGONALIZATION. KODE=',I4)
          STOP 'abnormal termination'
        ENDIF
        END
