
C++*******************************************************************
C
C $$ PICKSL.FOR
C
C **************************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK            *
C *  COPYRIGHT (C)1981,1987, WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH 			   *
C **************************************************************************
C
C $$ PICKSL:   PICK SLICE FROM 3-D DENSITY FILE AND STORE IT IN 
C              A 2-D FILE.
C
C    PICKSL(LUN2,LUN3,NSAM,NROW,NSLICE)
C
C	  LUN2		        LOGICAL UNIT NUMBER 
C 	  LUN3		        LOGICAL UNIT NUMBER
C	  NSAM,NROW,NSLICE	DIMENSIONS OF 3-D FILE
C
C--*******************************************************************

      SUBROUTINE PICKSL(LUN3,LUN2,NSAM,NROW,NSLICE)

      INCLUDE 'CMBLOCK.INC'

      COMMON BUF(1)

      CALL RDPRMI(ISLICE,IDUM,NLOOP,ILOOP,'SLICE NUMBER')
      IF (ISLICE .LE .0 .OR. ISLICE .GT. NSLICE) THEN
         CALL ERRT(24,'PICKSL',NE)
         RETURN
      ENDIF

      NREC1 = (ISLICE-1)*NROW+1
      NREC2 = NREC1 + NROW-1

      DO I = NREC1,NREC2
        CALL REDLIN(LUN3,BUF,NSAM,I)
        CALL WRTLIN(LUN2,BUF,NSAM,I-NREC1+1)
      ENDDO

      RETURN
      END

