
C ++************************************************************************
C
C PICKSV
C
C **************************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK            *
C *  COPYRIGHT (C)1981,1988, WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH                            *
C **************************************************************************
C                                                                          *
C  $$  PICKSV
C
C      PURPOSE: PICKS A X OR Y SLICE OUT OF A 3-D VOLUME FILE
C
C        0         2         3         4         5         6         7
C23456789012345678901234567890123456789012345678901234567890123456789012
C***************************************************************************

	SUBROUTINE PICKSV(LUN3,LUN2,NSAM,NROW,NSLICE)

        INCLUDE 'CMBLOCK.INC'

	COMMON BUF(1)

	IF (FCHAR(4:4) .NE. 'X') THEN

          CALL RDPRMI(IROW,IDUM,NLOOP,ILOOP,'Y-SLICE NUMBER')
          IF (IROW .LE. 0 .OR. IROW .GT. NROW) THEN
            CALL ERRT(24,'PICKSV',NE)
            RETURN
          ENDIF

          DO ISLICE=1,NSLICE
            IRECT = (ISLICE-1)*NROW+IROW
            CALL REDLIN(LUN3,BUF,NSAM,IRECT)
            CALL WRTLIN(LUN2,BUF,NSAM,ISLICE)
          ENDDO

        ELSE

          CALL RDPRMI(ISAM,IDUM,NLOOP,ILOOP,'X-SLICE NUMBER')
          IF (ISAM .LE. 0 .OR. ISAM .GT. NSAM) THEN
            CALL ERRT(24,'PICKSV',NE)
            RETURN
          ENDIF

          DO ISLICE=1,NSLICE
            IRECT = (ISLICE-1)*NROW
            DO I=1,NROW
              CALL REDLIN(LUN3,BUF,NSAM,IRECT+I)
              BUF(NSAM+I) = BUF(ISAM)
            ENDDO
            CALL WRTLIN(LUN2,BUF(NSAM+1),NROW,ISLICE)
          ENDDO
        ENDIF

        RETURN
	END
