C++************************************************************************
C
C $$ PJ3Q.FOR
C
C **************************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK            *
C *  COPYRIGHT (C)1981,1987, WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *  THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR       *
C *  LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR    *
C *  USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF     *
C *  THE CENTER FOR LABORATORIES AND RESEARCH   			   *
C **************************************************************************
C
C
C
C--************************************************************************
C
C $$ PJ3Q.FOR
C
         SUBROUTINE PJ3Q(MAXMEM)
         INCLUDE 'CMBLOCK.INC'
         COMMON  /F_SPEC/  FINPAT,FINPIC,FINDOC,NLET,NLETI
         CHARACTER*80  FINPIC,FINFO
         CHARACTER*80  FINPAT,FINDOC
         CHARACTER*1  NULL
        COMMON       BUF(1024),BAF(1)
        DIMENSION    Q(1)
        POINTER      (IPQ,Q) 
        LOGICAL         RUNTIME
         COMMON /PAR/  LDPX,LDPY,LDPZ
C
         DATA  INPIC/99/
CNO_SAVE
         NULL=CHAR(0)
C
C  N - linear dimension of projections and restored cube
C  NANG - number of angles (projections)
C
         CALL  FILERD(FINPAT,NLETI,NULL,'3-D',ITRFLG)
         IF(IRTFLG.EQ.-1)  RETURN
         CALL  OPENFB(BUF,FINPAT,INPIC,NSAM,NROW,'O',NF,NSLICE)
         IF(NF.NE.2)  RETURN

         CALL  RDPRM(RI,NLOOP,ILOOP,'Radius of the object')
C
         LDPX=NSAM/2+1
         LDPY=NROW/2+1
         LDPZ=NSLICE/2+1
C
#ifdef SP_MP
	NUMTH=mp_numthreads()
#else
	NUMTH=1
#endif
	K_IPCUBE=1
	K_BCKE=K_IPCUBE+5*MAX0(NSAM,NROW,NSLICE)**2
C         K_BCKE=K_IPCUBE+5*NN
	K_PROJ=K_BCKE+NSAM*NROW*NSLICE
	K_ANG=K_PROJ+NSAM*NROW*NUMTH
	MEMTOT=K_ANG+3*NUMTH
C	WRITE(NOUT,1001)  MEMTOT
C1001	FORMAT(/'  Projection program, memory needed - ',I8,/)
	MAXM=MAXMEM-1024
        CALL CHKMEM(MEMTOT,BAF,MAXM,RUNTIME,IPQ,IRTFLG)
	     IF(IRTFLG.NE.0)  THEN
		CLOSE(INPIC)
                CALL  ERRT(6,'PJ 3Q ',NE)
		RETURN
	      ENDIF
C
         CALL  PREPCUB_Q
     &   (Q(K_BCKE),NSAM,NROW,NSLICE,BUF,NN,NMAT,Q(K_IPCUBE),RI,INPIC)
C
C         CALL  MOVIPC(Q(K_BCKE),Q(K_IPCUBE+5*NN),NMAT)
C
         CALL  FILERD(FINDOC,NLETI,NULL,'Selection doc',IRTFLG)
         CALL  FILERD(FINPIC,NLETI,NULL,'Angles doc',IRTFLG)
         NMAX=0
         CALL  FILSEQP(FINPAT,NLET,ILIST,NMAX,NIMA,
     &   'Enter template for 2-D projection',IRTFLG)
         CALL  WRITPRO
     1   (Q(K_PROJ),NSAM,NROW,NUMTH,Q(K_BCKE),
     2    Q(K_ANG),NMAT,Q(K_IPCUBE),NN,RI)
         IF(RUNTIME)  CALL ALLOCIT(0,RUNTIME,IPQ,'PJ 3Q',IRTFLG)
         END

