C++************************************************************************
C
C $$ PKSR3.FOR
C
C **************************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK            *
C *  COPYRIGHT (C)1981,1987, WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *  THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR       *
C *  LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR    *
C *  USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF     *
C *  THE CENTER FOR LABORATORIES AND RESEARCH   			   *
C **************************************************************************
C
C
C
C23456789012345678901234567890123456789012345678901234567890123456789012
C--************************************************************************
C
C $$ PKSR3.FOR
C
         SUBROUTINE  PKSR3(LUN,Q,NSAM,NROW,NSLICE,
     &   NSA1,NSA2,NRO1,NRO2,NSL1,NSL2,SGN,PEAK,NPC,RPC,ML,NMAX)
         DIMENSION  Q(NSAM,NROW,-1:1),NPC(3,ML),RPC(3,ML),PEAK(ML)
         DIMENSION  LX(-1:1),LY(-1:1),LZ(-1:1),LS(-1:1)
         LOGICAL   T,NEGV
C         EQUIVALENCE  (LX(-1),IXM),(LX(0),I),(LX(1),IXP)
C         EQUIVALENCE  (LY(-1),IYM),(LY(0),J),(LY(1),IYP)
CNO_SAVE
         NMAX=0
         DO  1  L=NSL1,NSL2
         IF(L.EQ.NSL1)  THEN
         DO   J=-1,1
           LZ(J)=J
	 ENDDO
         DO    J=-1,1
         LSJ=MOD(L+J-1+NSLICE,NSLICE)+1
         CALL RDSL_P(LUN,Q(1,1,J),NSAM,NROW,LSJ)
	 ENDDO
         DO  MZ=-1,1
         DO  MY=1,NROW
         DO  MX=1,NSAM
         Q(MX,MY,MZ)=Q(MX,MY,MZ)*SGN
         ENDDO
         ENDDO
         ENDDO
         ELSE
C  l>nsl1
         J=MOD(L-1-NSL1,3)-1
         LSJ=MOD(L+NSLICE,NSLICE)+1
         CALL RDSL_P(LUN,Q(1,1,J),NSAM,NROW,LSJ)
         DO  MY=1,NROW
         DO  MX=1,NSAM
         Q(MX,MY,J)=Q(MX,MY,J)*SGN
         ENDDO
         ENDDO
C rotate numbering of slices
         DO  J=-1,1
         LZ(J)=LZ(J)+1
         IF(LZ(J).EQ.+2)  LZ(J)=-1
         ENDDO
         ENDIF
C
         DO  1  J=NRO1,NRO2
C         IYM=MOD(J-2+NROW,NROW)+1
C         IYP=MOD(J+NROW,NROW)+1
         LY(-1)=MOD(J-2+NROW,NROW)+1
         LY(1)=MOD(J+NROW,NROW)+1
         LY(0)=J
         DO  1  I=NSA1,NSA2
C         IXM=MOD(I-2+NSAM,NSAM)+1
C         IXP=MOD(I+NSAM,NSAM)+1
         LX(-1)=MOD(I-2+NSAM,NSAM)+1
         LX(1)=MOD(I+NSAM,NSAM)+1
         LX(0)=I
         T=.TRUE.
         QC=Q(I,J,LZ(0))
         DO    JZ=-1,1
         DO    JY=-1,1
         DO    JX=-1,1
         IF(QC.LT.Q(LX(JX),LY(JY),LZ(JZ)))  T=.FALSE.
	 ENDDO	 
	 ENDDO	 
	 ENDDO
         IF(T)  THEN
         IF(NMAX.EQ.0)  THEN
         NMAX=1
         PEAK(1)=QC
         NPC(1,1)=I
         NPC(2,1)=J
         NPC(3,1)=L
C get center of gravity
         NN=1
         ASSIGN  501 TO LABA
         GOTO  5505
501      CONTINUE
         ELSE
         DO    N=NMAX,1,-1
         IF(QC.LT.PEAK(N)) THEN
         NN=N+1
         GOTO  22
         ENDIF
	 ENDDO
         NN=1
22       CONTINUE
C no place for more peaks
         IF(NN.GT.ML)  GOTO 1
         DO    M=MIN0(NMAX+1,ML),NN+1,-1
         PEAK(M)=PEAK(M-1)
         DO  MM=1,3
         NPC(MM,M)=NPC(MM,M-1)
         RPC(MM,M)=RPC(MM,M-1)
         ENDDO
	 ENDDO
         PEAK(NN)=QC
         NPC(1,NN)=I
         NPC(2,NN)=J
         NPC(3,NN)=L
C get center of gravity
         ASSIGN  502 TO LABA
         GOTO  5505
502      CONTINUE
         NMAX=MIN0(NMAX+1,ML)
         ENDIF
         ENDIF
1        CONTINUE
         RETURN
C  procedure to get the center of gravity in 3x3x3 box
5505     NEGV=.FALSE.
         RSUM=0.0
         RX=0.0
         RY=0.0
         RZ=0.0
         DO    JZ=-1,1
         DO    JY=-1,1
         DO    JX=-1,1
         QC=Q(LX(JX),LY(JY),LZ(JZ))
         IF(QC.LT.0.0)  THEN
         NEGV=.TRUE.
         RX=0.0
         RY=0.0
         RZ=0.0
         GOTO  42
         ENDIF
         RX=RX+(I+JX)*QC
         RY=RY+(J+JY)*QC
         RZ=RZ+(L+JZ)*QC
         RSUM=RSUM+QC
	 ENDDO	 
	 ENDDO	 
	 ENDDO
42       IF(RSUM.NE.0.0)  THEN
         RPC(1,NN)=RX/RSUM
         RPC(2,NN)=RY/RSUM
         RPC(3,NN)=RZ/RSUM
         ELSE
         RPC(1,NN)=0.0
         RPC(2,NN)=0.0
         RPC(3,NN)=0.0
         ENDIF
         GOTO  LABA
         END
