
C++**************************************************** 6/23/80  2/5/81  VAX
C
C    PLOT1.FOR                          CNINT.FOR CALLS ADDED JAN 86 al
C                                       CS DRIVERS ALTERED NOV 86 al
C                                       PROFILE PGMS ALTERED JAN 86 al
C                                       VERSATEC CALLS REMOVED MAR 90 al
C                                       CONVERTED TO SUBROUTINE JULY 87 al
C                                       FILENAME CONVERSION NOV 88 al
C
C	CHANGED BY MAHIEDDINE LADJADJ     4/30/93
C
C
C **************************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK            *
C *  COPYRIGHT (C)1981,1987, WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH 			   *
C **************************************************************************
C
C       PLOT1(MAXDIM)
C
C       COMMANDS:
C       CO              CONTOURS A SPIDER IMAGE FILE IN CNT FILE 
C       CO CSVT         CONTOURS A SPIDER IMAGE FILE IN CNT FILE AND DISPLAYS
C       CO S            CONTOURS A SPIDER IMAGE FILE INTO STERECON FILES
C       PF              PROFILES A SPIDER IMAGE FILE IN CNT FILE 
C       PL              PLOTS CONTENTS OF DOC FILE   IN CNT FILE 
C       CS DI, CS DI VT PLOTS CNT FILE ON VT125 OR VT240 TERM
C       CS VTH          PLOTS CNT FILE ON DEC VT TERM. AND GIVES HARD COPY
C       CS DI LX        PLOTS CNT FILE ON LEXIDATA TERM
C       CS DI GD        PLOTS CNT FILE ON GOULD PLOTTER
C       CS DI TX        PLOTS CNT FILE ON TEKTRONIX PLOTTER
C       CS DI RA        PLOTS CNT FILE ON RASTER TECH TERM
C       CS DI PL        TRANSLATES CNT FILE TO HPGL AND PLACES IN FILE
C       CS DI P0        TRANSLATES CNT FILE TO POSTSCRIPT AND PLACES IN FILE
C       CS MV           TRANSFERS CONTOURS TO A MOVIE.BYU MOSAIC FILE FROM SLICE
C       CS MVVT         TRANSFERS TO MOVIE.BYU FILE AND DISPLAYS ON VT
C       CS PLA          CONVERTS MOVIE.BYU FILE TO A PLATE TYPE MOVIE.BYU FILE
C       CS TH           THINS NUMBER OF POINTS IN A CNT FILE
C
C       CALLS:          FILERD   OPENF    ERRT    CNFILE    CHKINPQ   CNINT
C                       RDPRMI   CNINT3   DPROFL  UNSDAL    DPROFD    DCHIST
C                       CNMOV    CNTERM   CNGOUL  CNTEKT    TMHARD
C                       TMEND    CNLEXI   CNRAST  SSPLAT
C
C       CALLED BY:      DRIVER
C
C        0         2         3         4         5         6         7
C23456789012345678901234567890123456789012345678901234567890123456789012
C--*********************************************************************

      SUBROUTINE PLOT1(MAXDIM)

      PARAMETER (NFUNC  = 4)
      PARAMETER (MAXREG = 7)
      PARAMETER (MAXKEY = 5000)
      PARAMETER (NSIZE  = 2000)

      INCLUDE 'CMBLOCK.INC'
      INCLUDE 'CONSTG.INC'

C     DATA IS IN BLANK COMMON FOR USE IN DPROFD
      COMMON DATA(3,NSIZE),DBUF(MAXREG,MAXKEY)

C     COMMON FOR CONTOUR PLOTS
      COMMON /CONT/SCLFAC

C     COMMON /COMMUN/ IS USED IN CNINT3!

      DIMENSION      PLIST(7)
      LOGICAL        DISPL8
      CHARACTER * 2  FUNC(NFUNC)
      CHARACTER * 81 CSFILE,IMFILE,DOFILE
      CHARACTER * 8  DISP
      CHARACTER * 1  NULL,ANSW

      DATA FUNC/'CO',  'PF',   'PL',  'CS'/
      DATA MININT/-32768/, MAXINT/32767/
      DATA LUNCS /20/, LUN1/8/, LUNDOC/11/, LUNPOST/12/

        NULL = CHAR(0)
        
C       SET ICSPR TO AVOID FILE OPENING DETAILS PRINTOUT
        ICSPR  = -2

C       SET NON-SERIAL SECTION FLAG
        SERSEC = .FALSE.
        LABAH  = .TRUE.

C       IFUNCS:   CO  PF   PL  CS

C       FIND THE FUNCTION NUMBER
7	DO IFUNC = 1, NFUNC
          IF (FCHAR(1:2) .EQ. FUNC(IFUNC)) THEN
            GOTO (1, 2, 3, 4), IFUNC
          END IF
        ENDDO
C       FUNCTION NOT IN PLOT1
        RETURN

C ----------------------- IMAGE CONTOURING -------------------------'CO'

C       THE NEW CONTOURING PGMS MUST OPEN THEIR OWN FILES
1       IF (FCHAR(4:4) .EQ. 'S') THEN

C         STERECON 3-D FILE READING CONTOURING PGM. (NOT DISTRIBUTED)
          DISPL8 = .FALSE.
          CALL CNINT4(DATEXC,DISPL8,MAXDIM)
          GOTO 9000
	ENDIF

C       CONTOUR A SPIDER IMAGE INTO A CNT CONTOUR FILE. DIPLAY OPTIONAL
        DISPL8  = .FALSE.
        IF (INDEX(FCHAR,'V') .GT. 0) DISPL8 = .TRUE. 

C       SKIP TITLE QUESTION
        ITFLG   = 0

C       ASK FOR NUMBER OF CONTOURS
        MAXCNT  = 0
        DISP    = 'UNK'
        ICNTFMT = 0
        CALL CNFILE(CSFILE,NLETC,'NEW CONTOUR',
     &                DISP,DATEXC,LUNCS,IRTFLG)
        IF ( IRTFLG .EQ. -1) GOTO 9700

C       TRACE CONTOURS INTO CNT FILE
        CALL CNINT3(LUNCS,DISPL8,MAXDIM)

C       GIVE IMMEDIATE POSTSCRIPT PLOT (IF DESIRED)
        CALL RDPRMC(ANSW,NA,.TRUE.,
     &       'SHOW POSTSCRIPT MENU NOW? (Y/N)',NULL,IRTFLG)
        IF (ANSW .NE. 'N' .AND. ANSW .NE. 'n') THEN
           CALL CNDISP(CSFILE,NULL,.TRUE.,.FALSE.,LUNCS,LUNPOST,IRTFLG)
        ENDIF
        GOTO 9000

C      ----------------- PROFILE ACROSS IMAGE-----------------------'PF'

2      IF (FCHAR(4:4) .EQ. 'D') THEN
         WRITE(NOUT,*) '*** OPERATION CHANGED TO "PL" OR "PL V".'
         GOTO 9700
       ENDIF

C      OPEN A SPIDER IMAGE TYPE FILE AS INPUT
10     CALL OPFIL(.TRUE.,IMFILE,LUN1,'O',NSAM1,NROW1,NSLICE1,IFORM,
     &             'IMAGE',.FALSE.,IRTFLG)
       IF (IRTFLG .NE. 0) GOTO 9700

       IF (NSAM1 .GT. MAXDIM) THEN
         CALL ERRT(9,'PLOT1',NE)
         GOTO 9700 
       ENDIF

C       PLACE A PROFILE ACROSS AN IMAGE FILE IN A CNT FILE
        MAXCNT  = 2000
        DISP    = 'NEW'
        ICNTFMT = 1
        CALL CNFILE(CSFILE,NLETC,'CONTOUR',DISP,DATEXC,LUNCS,IRTFLG)
        IF ( IRTFLG .EQ. -1) GOTO 9700
        CALL DPROFL(IMFILE,NLETI,CSFILE,NLETC,LUN1,LUNCS,NSAM1,NROW1)

C       GIVE IMMEDIATE POSTSCRIPT PLOT (IF DESIRED)
        CALL RDPRMC(ANSW,NA,.TRUE.,'PRINT NOW? (Y/N)',NULL,IRTFLG)
        IF (ANSW .NE. 'N' .AND. ANSW .NE. 'n') THEN
           CALL CNDISP(CSFILE,NULL,.TRUE.,.TRUE.,LUNCS,LUNPOST,IRTFLG)
        ENDIF
        GOTO 9000

C      ----------------- DOC. FILE PLOT --------------------------  'PL'

C       OPEN A DOCUMENT FILE AS INPUT
3       CALL FILERD(DOFILE,NLETD,NULL,'DOCUMENT',IRTFLG)
        IF (IRTFLG .NE. 0) GOTO 9700

C       ADD EXTENSION TO FILE NAME
        CALL FILCAN(DOFILE,NLETD,NULL,NULL,DOFILE,DATEXC,IRTFLG)
        IF (IRTFLG .NE. 0) GOTO 9700

C       PLOTS CREATED FROM DOCUMENT FILES:
        CALL CHKINPQ('CS,HI,FIT$',FCHAR(4:),KCALL)
        GOTO (401,401,404,406) KCALL

401     DISP    = 'NEW'
        MAXCNT  = 2000
        ICNTFMT = 1

C       PLACE PLOT OF DOC REGISTER CONTENTS VS DOC REGISTER IN A CNT FILE
        CALL CNFILE(CSFILE,NLETC,'CONTOUR ',DISP,DATEXC,LUNCS,IRTFLG)
        IF ( IRTFLG .EQ. -1) GOTO 9700

C       OPEN DOC FILE FOR INPUT
        IOP = 0
        CALL UNSDAL(DOFILE,IOP,LUNDOC,1,PLIST,1,DBUF,
     &              MAXKEY,MAXREG,NKEY,LER)
        CALL DPROFD(DOFILE,NLETD,CSFILE,NLETC,DBUF,
     &              MAXREG,MAXKEY,NKEY,LUNCS,IRTFLG)
        CLOSE(LUNDOC)
        IF (IRTFLG .EQ. -1) THEN
           CLOSE(LUNCS)
           GOTO 401
        ENDIF

C       GIVE IMMEDIATE POSTSCRIPT PLOT (IF DESIRED)
        CALL RDPRMC(ANSW,NA,.TRUE.,'PRINT NOW? (Y/N)',NULL,IRTFLG)
        IF (ANSW .NE. 'N' .AND. ANSW .NE. 'n') THEN
          CALL CNDISP(CSFILE,NULL,.TRUE.,.TRUE.,LUNCS,LUNPOST,IRTFLG)
        ENDIF
        GOTO 9000

404     ICNTFMT = 1
        CALL DCHIST(DOFILE,LUN1)
        GOTO 9000

406     CONTINUE
C       OPEN DOC FILE FOR INPUT
        IOP = 0
        CALL UNSDAL(DOFILE,IOP,LUNDOC,1,PLIST,1,DBUF,MAXKEY,MAXREG,
     &               NKEY,LER)
        CLOSE(LUNDOC)
        CALL POLLSQ(DBUF,MAXREG,MAXKEY,LUNDOC)
        GOTO 9000                      

C      -------------- SHOW CONTOOR PLOT --------------------------  'CS'

4       IF (FCHAR(7:8). EQ. 'PO') THEN
C          USE POSTSCRIPT INTERFACE TO OPEN FILE
           GOTO 609
        ENDIF

C       OPEN AN EXISTING CNT FILE AS INPUT
        ISEL   = 1
        CALL CNFILE(CSFILE,NLETC,'CONTOUR','OLD',DATEXC,LUNCS,IRTFLG)
        IF ( IRTFLG .EQ. -1) GOTO 9700

        CALL CHKINPQ('MV,MVVT,DI',FCHAR(4:),NCALL)
        GOTO    (599,501,502,600) NCALL


C       CONVERT A CNT CONTURE FILE TO A MOVIE.BYU FILE
C       DO NOT PLOT CONTOURS DURING CONVERSION
501     DISPL8 = .FALSE.
        CALL CNMOV(LUNCS,DISPL8)
        GOTO 9000

C       PLOT CONTOURS ON VT125 DURING CONVERSION
502     DISPL8 = .TRUE.
        CALL CNMOV(LUNCS,DISPL8)
        GOTO 9000

C       UNKNOWN COMMAND
599     WRITE(NOUT,*) '*** UNKNOWN OPERATION IN PLOT1.'
        GOTO 9700

C       FIND DISPLAY DEVICE
600     CALL CHKINPQ('VT, GD,VTH, PL, PO$',FCHAR(7:),NCALL)
        GOTO    (601,601,602,604,607,609),NCALL

C       DISPLAY ON DEC TERMINAL
601     CALL CNTERM(NULL,DATEXC,LUNCS,ISEL,IRTFLG)
        GOTO 9700

C       DISPLAY ON HPGL PLOTTER
602     CALL CNGOUL(NULL,DATEXC,LUNCS,ISEL,.FALSE.,.FALSE.,IRTFLG)
        GOTO 9700

C       DISPLAY ON DEC TERMINAL WITH HARDCOPY
604     CALL CNTERM(NULL,DATEXC,LUNCS,ISEL,IRTFLG)
        CALL TMHARD(NOUT)
        CALL TMEND(NOUT)
        GOTO 9700

C       GOULD (HPGL) PLOTTER
607     CALL CNGOUL(NULL,DATEXC,LUNCS,ISEL,.FALSE.,.TRUE.,IRTFLG)
        GOTO 9700

C       POSTSCRIPT PLOTTER INTERFACE
609     CALL CNDISP(NULL,NULL,.FALSE.,.FALSE.,LUNCS,LUNPOST,IRTFLG)
        GOTO 9700

9700    CLOSE(LUNCS)
9000	CLOSE(LUN1)
        CLOSE(LUNPOST)

        RETURN
	END
