C++*******************************************************************
C
C $$ POLFIT.FOR
C
C **************************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK            *
C *  COPYRIGHT (C)1981,1987, WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH 			   *
C **************************************************************************
C
C
C $$ POLFIT:  MAKES LEAST SQUARES FIT EXPERIMENTAL DATA IN
C             X(N),Y(N) USING A POLYNOMIAL OF ARBITRARY ORDER>1
C
C	CALL POLFIT(X,Y,NORD,N,C)
C	  X	A REAL ARRAY DIMENSIONED N CONTAINING THE ABSCISSAE
C	  Y	A REAL ARRAY DIMENSIONED N CONTAINING THE FUNCTION VALUES
C         NORD  ORDER OF POLYNOMIAL. NORD<N.
C	  C	A REAL ARRAY CONTAINING THE NORD+1 COEFFICIENTS OF THE
C	  	POLYNOMIAL IN INCREASING ORDER
C
C--*******************************************************************
C
C
	SUBROUTINE POLFIT(X,Y,NORD,N,C)
	DIMENSION X(1),Y(1),C(1),SUM(10),SUMY(10),A(100)
      COMMON ADUM(80),A
      NSUM = 2*NORD+1
      NEXP = 2*NORD
      NORD1 = NORD+1
      I2 = NORD1*NORD1
	DO  I=1,NSUM
	SUMY(I) = 0.
	SUM(I)=0.
	ENDDO
	SUM(1) = N
	DO  I=1,N
	DO  IEXP=1,NEXP
	  SUM(IEXP+1)=SUM(IEXP+1)+X(I)**IEXP
	ENDDO
	SUMY(1) = SUMY(1)+Y(I)
	DO  NY=2,NORD1
	  SUMY(NY)=SUMY(NY)+Y(I)*X(I)**(NY-1)
	ENDDO
	ENDDO
C
C NOW CONSTRUCT MATRIX
C
	DO  K=1,NORD1
	DO  I=1,NORD1
       I1 = (I-1)*NORD1
       A(I1+K) = SUM(K+I-1)
	ENDDO
	A(I2+K)=SUMY(K)
	ENDDO
	CALL SOLVE(A,NORD1,NORD1)
	DO  K=1,NORD1
	 C(K)=A(I2+K)
	ENDDO
	RETURN
	END
