
C ++********************************************************************
C
C POLLSQ.F
C
C **********************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK        *
C *  COPYRIGHT (C)1985, 1996 HEALTH RESEARCH INCORPORATED, ALBANY, NY  *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO HEALTH         *
C *    RESEARCH INC. AND ARE NOT TO BE DISCLOSED TO OTHERS             *
C *    OR USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN        *
C *    APPROVAL OF HEALTH RESEARCH INC.                                *
C **********************************************************************
C                                                                      
C  PROGRAM TO FIT A POLYNOM TO NUMBERS IN A DOCUMENT FILE READ
C  BEFORE CALLING THIS PROGRAM WITH UNSDAL INTO DBUF.
C  MAXIMUM ORDER OF POLYNOM IS 10
C  10/14/87 MR.
C                                                                      
C***********************************************************************

	SUBROUTINE POLLSQ(DBUF,MAXREG,MAXKEY,NDOC)

        INCLUDE 'CMBLOCK.INC'

        COMMON     DUM(80),BUF(1)
        CHARACTER  YN,NULL
        DIMENSION  REG(3)
        DIMENSION  DBUF(MAXREG,MAXKEY),C(11)

        NULL=CHAR(0)

        CALL RDPRMI(KEY1,KEY2,NLOOP,ILOOP,'FIRST, LAST KEY NUMBER')
	CALL RDPRMI(IABS,IORD,NLOOP,ILOOP,
     $             'COLUMN #S FOR ABSCISSA, ORDINATE (0=KEY)')
        CALL RDPRM2(SX,SY,NLOOP,ILOOP,'SCALEX, SCALEY (DEF=1)')
        IF (SCALEX.EQ.0) SCALEX=1.
        IF (SCALEY.EQ.0) SCALEY=1.
        CALL RDPRMI(NORD,IDUM,NLOOP,ILOOP,
     $              'ORDER OF POLYNOM (1-10, DEF=1)')
        IF(NORD.EQ.0.)NORD=1

C  ICREASE IABS & IORD BY 1 BECAUSE DBUF(1,*) CONTAINS KEY, FOLLOWED BY
C  REGISTERS 

        IABS=IABS+1
        IORD=IORD+1

C  STORE COORDINATES INTO ARRAYS. X IN BUF(1)... , Y IN BUF(IOFF+1)...

        ILINE=0                          
        IDO=1  
        IOFF=KEY2-KEY1+1
        DO  I=KEY1,KEY2        
           BUF(IDO)=DBUF(IABS,I)*SCALEX
           BUF(IDO+IOFF)=DBUF(IORD,I)*SCALEY
           IDO=IDO+1
	ENDDO
        WRITE(NOUT,101) (BUF(L),BUF(IOFF+L),L=1,IOFF)
101     FORMAT(' ',2E12.4)

C  POLFIT DOES THE LEAST SQUARE FIT, INCLUDING THE CREATION OF THE
C  MATRIX SYSTEM. RESULT RETURNED IN C(1).. C(NORD+1). IOFF IS DIMENSION
C  OF ARRAYS CONTAINING X AND Y
 
        CALL POLFIT(BUF(1),BUF(IOFF+1),NORD,IOFF,C)
 
C       STORE RESULT INTO REGISTER (MAXIMUM 10 I.E. POLYNOM ORDER 9)

        ILAST=MAX(10,NORD+1)
        DO  K=1,ILAST
          PARAM(NSEL(K))=C(K)                  
	ENDDO

C       WRITE OUT RESULTS

        WRITE(NOUT,100) (C(I),I=1,NORD+1) 
100     FORMAT(' RESULTING POLYNOM:'/1X,              
     $   E12.4,' + ',E12.4,' *X + '
     $  ,E12.4,' *X**2 + '
     $  ,E12.4,' *X**3 + '
     $  ,E12.4,' *X**4 + '
     $  ,E12.4,' *X**5 + '/1X
     $  ,E12.4,' *X**6 + '
     $  ,E12.4,' *X**7 + '
     $  ,E12.4,' *X**8 + '
     $  ,E12.4,' *X**9 + '
     $  ,E12.4,' *X**10 + ')
 
C       HERE WOULD FOLLOW THE GENERATION OF A PLOT.
C       CURRENTLY A DOCUMENT FILE CAN BE CREATED, THAT CAN BE PLOTTED LATER.
        CALL RDPRMC(YN,NCHAR,.TRUE.,
     $     'CREATE OUTPUT DOCUMENT FILE (Y/N)',NULL,IRTFLG)
        IF (YN.NE.'Y') RETURN

        CALL RDPRM2(XA,XE,NLOOP,ILOOP,'X FROM, TO')
        CALL RDPRM(XIN,NLOOP,ILOOP,'IN INTERVALS OF')
        NPOINT=(XE-XA)/XIN+1.
        X=XA
        DO  I=1,NPOINT
           POLY=C(1)
           DO  K=1,NORD
             POLY=POLY+C(K+1)*X**K
	   ENDDO
 
C          OUTPUT INTO DOCUMENT FILE:
           REG(1)=I
           REG(2)=X
           REG(3)=POLY
           CALL SAVD(NDOC,REG,3,IRTFLG)
           X=X+XIN
	ENDDO
       
        CALL SAVDC
        CLOSE(NDOC)
        RETURN
        END

