C++************************************************************************
C
C $$ PR3DB.FOR
C
C **************************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK            *
C *  COPYRIGHT (C)1981,1987, WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *  THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR       *
C *  LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR    *
C *  USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF     *
C *  THE CENTER FOR LABORATORIES AND RESEARCH                              *
C **************************************************************************
C TO CALCULATE THE 3-D PHASE RESIDUE OUTSIDE MISSING CONE, PR OF FOURIER
C RINGS(RADIUS, DIRECTION RELATIVE TO Z) AND OF FOURIER SHELLS(RADIUS) IS
C CALCULATED. 
C23456789012345678901234567890123456789012345678901234567890123456789012
C--************************************************************************
C
C $$ PR3DB.FOR
C
	SUBROUTINE PR3DB(A,B,PR,AMP,CSUM1,LR,CSUM,CSUM2,
     &  AVSUM,LSD,NSAM,NROW,NSLICE,DSCALE,NSCALE,SCALE1,SSANG,
     &  INC,Y1,WI,SER)
	DIMENSION A(LSD,NROW,NSLICE),B(LSD,NROW,NSLICE)
	DIMENSION PR(NSCALE,INC),AMP(NSCALE,INC),AVSUM(NSCALE,INC)
	DIMENSION CSUM1(INC),CSUM2(INC),LR(INC)
	DIMENSION CSUM(INC)
	CHARACTER*1 SER
CNO_SAVE
C
	PI=4.0*ATAN(1.00)
	ZANG=(90-SSANG)*PI/180.0
        ND2=NSAM/2
        NR2=NROW/2
        NS2=NSLICE/2
C
	DO  L=1,INC
	LR(L)=0
	CSUM(L)=0.0
	CSUM1(L)=0.0
	CSUM2(L)=0.0
	DO  NSC=1,NSCALE
	PR(NSC,L)=0.0
	AVSUM(NSC,L)=0.0
	AMP(NSC,L)=0.0
	ENDDO
	ENDDO
C
	DO 4 K=1,NSLICE
	IIK=(K-1)
	IF(IIK.GT.NS2)IIK=IIK-NSLICE
	PK=(FLOAT(IIK)/FLOAT(NS2))**2
	DO 4 J=1,NROW
	IIJ=(J-1)
	IF(IIJ.GT.NR2)IIJ=IIJ-NROW
	PJ=(FLOAT(IIJ)/FLOAT(NR2))**2
	DO 41 I=1,LSD,2
	III=(I-1)/2
C skip Hermitian related values
	IF(IIJ.EQ.0 .AND. IIK.EQ.0 .AND. III.LE.0)  GOTO 41
	PII=(FLOAT(III)/FLOAT(ND2))**2
	R=SQRT(PII+PJ+PK)*0.5
        R1=SQRT(PII+PK)*0.5    
	IF(R.GE.0.5)  GO TO 4
	IF(SER.EQ.'C')THEN
	FI=ACOS(SQRT(PK)/R)
	ELSE
	FI=ACOS(SQRT(PK)/R1)
	ENDIF
	IF(ZANG.NE.0.)THEN
	  IF(FI.LT.ZANG)  GO TO 4
	ENDIF
	L=MIN0(MAX0(INT(R*Y1/WI)+1,1),INC)
	LR(L)=LR(L)+1
	IF(A(I,J,K).NE.0.0)THEN
          PHA=ATAN2(A(I+1,J,K),A(I,J,K))*180./PI
          ELSE
          PHA=0
        ENDIF 
	IF(B(I,J,K).NE.0.0)THEN
          PHB=ATAN2(B(I+1,J,K),B(I,J,K))*180./PI
          ELSE
          PHB=0
        ENDIF 
	DPH=PHA-PHB
	IF(DPH.GT.180.0)  DPH=360.0-DPH
	IF(DPH.LT.-180.0) DPH=360.0+DPH
C
	QA=SQRT(A(I,J,K)**2+A(I+1,J,K)**2)
	QB=SQRT(B(I,J,K)**2+B(I+1,J,K)**2)
C
	CSUM(L)=CSUM(L)+A(I,J,K)*B(I,J,K)+A(I+1,J,K)*B(I+1,J,K)
	CSUM1(L)=CSUM1(L)+QA*QA
	CSUM2(L)=CSUM2(L)+QB*QB
C SCALES
	DPH=DPH*DPH
	DO  NSC=1,NSCALE
	SCALE=SCALE1+(NSC-1)*DSCALE
	QBS=QB*SCALE
	AVSUM(NSC,L)=AVSUM(NSC,L)+ABS(QA-QBS)
	PR(NSC,L)=PR(NSC,L)+((QA+QBS)/2.)*DPH
	AMP(NSC,L)=AMP(NSC,L)+((QA+QBS)/2.)
	ENDDO
41	CONTINUE
4	CONTINUE
	END
