
C++************************************************************************
C
C PROJ3.FOR  
C                                       LONG FILENAMES JAN 23 89 al
C **************************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK            *
C *  COPYRIGHT (C)1981,1987, WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH 			   *
C **************************************************************************
C
C    PROJ3(LUN3,LUNP,MAXDIM,IER)
C
C    PURPOSE:      COMPUTES THE PROJECTION OF A 3-D ARRAY IN ARBITRARY
C                  DIRECTION. ADOPTED FROM MICHAEL RADERMACHER'S 
C                  MRPROJ 11/6/83.
C
C    PARAMETERS:
C
C--********************************************************************

        SUBROUTINE PROJ3(LUN3,LUNP,MAXDIM,IER,OPTTH)

	COMMON    ADUM(80),BUF(1)
	REAL      DPO(3),DP(3),XP(2),X(3),DM(3,3)
	INTEGER   IROW,INDP,MAXDIM,MA,IMA
        CHARACTER *81 FILNAM
        CHARACTER *1  NULL
        COMMON /COMMUN/ FILNAM
        LOGICAL OPTTH

	INCLUDE 'CMBLOCK.INC'

	DATA PI/3.14159265/
        NULL = CHAR(0)

	IER=1
	CALL FILERD(FILNAM,NLET,NULL,'THREED',IRTFLG)
	IF(IRTFLG .NE. 0) RETURN
	CALL OPENF(FILNAM,LUN3,NSAM,NROW,'OLD',NF,NSLICE)
	IF (NF .NE. 2) GOTO 9300
	IF (IFORM .NE. 3) GOTO 9100

        IF(OPTTH) CALL RDPRM2(THRU,THRL,NLOOP,ILOOP,
     $             'UPPER,LOWER THRESHOLD')

	CALL RDPRMI(NSAMP,NROWP,NLOOP,ILOOP,'PROJECTION SAMPLE DIM.')
        IF (NROWP.EQ.0) THEN
	NROWP=NSAMP*(FLOAT(NROW)/FLOAT(NSAM))
        ENDIF
	IF (NSAMP .EQ. 0) GOTO 9200


	CALL FILERD(FILNAM,NLET,NULL,'OUTPUT',IRTFLG)
	IF(IRTFLG .NE. 0) RETURN

	IFORM = 1
	CALL OPENF(FILNAM,LUNP,NSAMP,NROWP,'UNKNOWN',NF,1)
	IF (NF .NE. 2) GOTO 9300

	IER = 0
	CALL RDPRM(PHI,NLOOP,ILOOP,'AZIMUTH ANGLE (PHI)$')
	CALL RDPRM(THETA,NLOOP,ILOOP,'TILT ANGLE (THETA)$')
	PHIR=PHI*PI/180.
	THETAR=THETA*PI/180.

C FOLLOWING ARE INCREMENTS THAT WERE IN THE ORIGINAL PROGRAM
C ON THE SCALE OF THE OBJECT.
	DX=1.
	DY=1.
	DZ=1.
	DXP=1.
	DYP=1.

	DP(1)=FLOAT(NSAMP)/2.
	DP(2)=FLOAT(NROWP)/2.
	DPO(1)=FLOAT(NSAM)/2.
	DPO(2)=FLOAT(NROW)/2.
	DPO(3)=FLOAT(NSLICE)/2.

C CALCULATE THE DIRECTION OF PROJECTION AND PROJECTION PLANE.

	CPHI=COS(PHIR)
	SPHI=SIN(PHIR)
	CTHE=COS(THETAR)
	STHE=SIN(THETAR)

	DM(1,1)=CPHI*CTHE
	DM(2,1)=SPHI*CTHE
	DM(3,1)=-STHE
	DM(1,2)=-SPHI
	DM(2,2)=CPHI
	DM(3,2)=0.0
	DM(1,3)=CPHI*STHE
	DM(2,3)=SPHI*STHE
	DM(3,3)=CTHE
	WRITE(NOUT,200)(DM(I,3),I=1,3)
  200	FORMAT(' ** DIRECTION OF PROJECTION : ',3F8.3)

C       MOVED DOWN HERE TO AVOID COMMON BUFFER COLLISION JAN 88 al
c**	MA=FLOAT(NSAMP)*FLOAT(NROWP)+0.5      28 mar 89 al TRY THIS ????
        MA=FLOAT(NSAMP)*FLOAT(NROWP+2) +0.5

	DO  IMA = 1, MA
        BUF(IMA) = 0.
	ENDDO


C COMPUTATION OF THE PROJECTION POINT

        IROW = 0                                 
	X(3) =-DZ
	DO  I1= 1, NSLICE
	X(3)=X(3)+DZ
	X(2)=-DY

	DO  I2 = 1, NROW
	X(2)=X(2)+DY
	X(1)=-DX
C	IROW=FLOAT(I1-1)*FLOAT(NROW)+I2+0.5
        IROW = IROW + 1                             
	CALL REDLIN(LUN3, BUF, NSAM, IROW)          
C	READ(LUN3'IROW+1)(BUF(K),K=1,NSAM)

	DO 400 I3 = 1, NSAM
	X(1) = X(1)+DX
	XP(1)=0.0
	XP(2)=0.0

	DO  I4 = 1, 3
	XP(1)=XP(1)+(X(I4)-DPO(I4))*DM(I4,1)
  	XP(2)=XP(2)+(X(I4)-DPO(I4))*DM(I4,2)
	ENDDO
	XP(1)=XP(1)+DP(1)
	XP(2)=XP(2)+DP(2)

	IF (XP(1) .LT. 0.0  .OR.  XP(1) .GT. NSAMP-DXP  .OR.
     1      XP(2) .LT. 0.0  .OR.  XP(2) .GT. NROWP-DYP)  GO TO 400

	ZWX =XP(1)
C	ZWX =XP(1)/DXP
	ZWY =XP(2)
C	ZWY =XP(2)/DYP
	IPX =IFIX(ZWX)
	IPY =IFIX(ZWY)
	DIPX=ZWX-FLOAT(IPX)
	DIPY=ZWY-FLOAT(IPY)
	W=BUF(I3)
C
C THRESHOLD OPTION:
C
        IF(OPTTH) THEN
           IF(W.LT.THRL) W=0.
           IF(W.GT.THRU) W=0.
        ENDIF
       
C	INDP=FLOAT(IPX)+1+FLOAT(IPY)*FLOAT(NSAMP) + NSAM+0.5
C       INDP = 1 + NSAM + IPY*NSAMP + IPX     !NAIK 5/23/86
        INDP = NSAMP
        INDP = INDP*IPY + IPX + NSAM + 1
	BUF(INDP)=BUF(INDP)+(1.0-DIPX)*(1.0-DIPY)*W
	BUF(INDP+1)=BUF(INDP+1)+DIPX*(1.0-DIPY)*W
	INDP=INDP+NSAMP
	BUF(INDP)=BUF(INDP)+(1.0-DIPX)*DIPY*W
	BUF(INDP+1)=BUF(INDP+1)+DIPX*DIPY*W
  400	CONTINUE
	ENDDO
	ENDDO

C NOW STORE PROJECTION ARRAY INTO FILE
	DO  I = 1, NROWP
C	INDP=FLOAT(I-1)*FLOAT(NSAMP)+1+NSAM+0.5
C       INDP = (I-1)*NSAMP + NSAM + 1               
        INDP = NSAMP
        INDP = INDP*(I-1) + NSAM + 1
	CALL WRTLIN(LUNP, BUF(INDP), NSAMP, I)
	ENDDO

	CLOSE(UNIT=LUN3)
	CLOSE(UNIT=LUNP)
	RETURN

9100	CALL ERRT(2,'PROJ3 ',NE)
	RETURN

9200	CALL ERRT(31,'PROJ3 ',NE)
	RETURN

9300	CALL ERRT(4,'PROJ3 ',NE)
	RETURN

	END

