C ++********************************************************************
C
C **********************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.    AUTHOR: J.FRANK      *
C *  COPYRIGHT (C)1985, 1996 HEALTH RESEARCH INCORPORATED, ALBANY, NY. *
C * THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO HEALTH            *
C * RESEARCH INC. AND ARE NOT TO BE DISCLOSED TO OTHERS OR USED        *
C * FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF       *
C * HEALTH RESEARCH INC.                                               *
C **********************************************************************
C
C PTTERN(LUN,NSAM,NROW,FMAX,FMIN)
C
C PURPOSE:  TO CREATE PATTERNS
C
C PARAMETERS:  LUN :	LOGICAL UNIT NUMBER
C	       NSAM,NROW : FILE DIMENSIONS
C              FMAX,FMIN : FILE MIN & MAX
C
C***************************************************************************

	SUBROUTINE PTTERN(LUN,NSAM,NROW,FMAX,FMIN)

        CHARACTER * 3 CODE
        CHARACTER     NULL,YN

        NULL = CHAR(0)

1	CONTINUE

        IF (FMAX .EQ. FMIN) FMAX = FMIN + 2
        CODE(1:3)='   '

	CALL RDPRMC(CODE,NCHAR,.TRUE., 'ENTER CODE (P,L,C,T,R,S)',
     &              NULL,IRTFLG)

	JMP  = 0
	RP   = FMAX
	IDIM = 2

	DO I=1,3
          IF (CODE(I:I) .EQ. 'S') RP   = FMIN
          IF (CODE(I:I) .EQ. 'L') IDIM = 1
          IF (CODE(I:I) .EQ. 'J') IDIM = -1
          IF (CODE(I:I) .EQ. 'P') JMP  = 1
          IF (CODE(I:I) .EQ. 'C') JMP  = 3
          IF (CODE(I:I) .EQ. 'T') JMP  = 4
          IF (CODE(I:I) .EQ. 'R') JMP  = 5
        ENDDO

	IF (IDIM .EQ. 1 .AND. JMP .EQ. 0) JMP = 2
	IF (JMP  .EQ. 0) GOTO 9001

	GOTO (101,102,103,104,105) ,JMP

C       POINT
101	CALL MPOINT(LUN,NSAM,NROW,RP)
	GOTO 9000

C       LINE
102	CALL MLINE(LUN,NSAM,NROW,RP)
	GOTO 9000

C       CIRCLE
103	CALL MCIRCL(LUN,NSAM,NROW,RP,IDIM)
	GOTO 9000

C       TRIANGLE
104	CALL MTRIAN(LUN,NSAM,NROW,RP,IDIM)
	GOTO 9000

C       RECTANGLE
105	CALL MRECTL(LUN,NSAM,NROW,RP,IDIM)
	GOTO 9000


C       ERROR HANDLING,UNKNOWN OPTION
9001	CALL ERRT(23,'PTTERN',NF)

9000	CALL RDPRMC(YN,NCHAR,.TRUE.,'CONTINUE? (Y/N)',NULL,IRTFLG)
	IF (YN .NE. 'N') GOTO 1

	RETURN
	END
