
C++*********************************************************************
C
C PUTPT2.FOR                         
C
C **********************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK        *
C *  COPYRIGHT (C)1985, 1996 HEALTH RESEARCH INCORPORATED, ALBANY,NY   *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO HEALTH         *
C *    RESEARCH INC. AND ARE NOT TO BE DISCLOSED TO OTHERS             *
C *    OR USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN        *
C *    APPROVAL OF HEALTH RESEARCH INC.                                *
C **********************************************************************
C
C PUTPT2(LUN2,NDOC,NSAM,NROW)
C
C PURPOSE:  SUPERPOSE ONTO AN IMAGE, 
C	    PIXELS IN LOCATIONS READ FROM  DOCUMENT FILE    
C            
C PARAMETERS: LUN2	        LOGICAL UNIT NUMBER OF I/O FILE
C	      NDOC	        LOGICAL UNIT NUMBER OF DOCUMENT FILE
C	      NSAM,NROW,NSLICE  DIMENSIONS OF INPUT FILE
C
C--*********************************************************************
 
	SUBROUTINE PUTPT2(LUN2,NDOC,NSAM,NROW,NSLICE)

C       DOC FIL CAN ONLY CONTAIN 9999 KEYS NOW
	PARAMETER (MAXPEAK=9999)
	COMMON NPEAK(MAXPEAK),BUF(4096)

	INCLUDE 'CMBLOCK.INC' 

        CHARACTER *81 SEQNAM,DOCNAM,FILNAM
	COMMON /COMMUN/SEQNAM,DOCNAM,FILNAM

	DIMENSION     PLIST(10)
        CHARACTER     NULL
        INTEGER       ILIST(3)

        NULL  = CHAR(0)

        DATA AMIN/-10E30/,AMAX/10E30/

	CALL FILERD(DOCNAM,NLETD,NULL,'DOCUMENT',IRTFLG)
	IF (IRTFLG .NE. 0) RETURN

        IF (IFORM .EQ. 3) THEN
           NVAL = 3
           CALL RDPRAI(ILIST,3,NVAL,0,7,'X-COL, Y-COL, Z-COL',
     &           NULL,IRTFLG)
	   IF (IRTFLG .NE. 0) RETURN
           NCOLX = ILIST(1)
           NCOLY = ILIST(2)
           NCOLZ = ILIST(3)
        ELSE
	   CALL RDPRMI(NCOLX,NCOLY,NLOOP,ILOOP,'X-COL, Y-COL')
           NCOLZ = 0
        ENDIF

C       NCOLP IS COLUMN OF DOC FILE CONTAINING PEAK HEIGHT (INTENSITY)
        CALL RDPRM2(COLP,HEIGHT,NLOOP,ILOOP,
     &     'INTENSITY COLUMN (& INTENSITY IF NOT IN COL. OF DOC FILE)')
        NCOLP = 0
        IF (COLP .GT. 0) THEN
           NCOLP = COLP
        ELSEIF (COLP .LT. 0) THEN
           HEIGHT = -COLP
        ENDIF

        IF (IFORM .EQ. 3) THEN
           NVAL = 3
           CALL RDPRAF(BUF,3,NVAL,AMIN,AMAX,
     &                 'X-FACTOR, Y-FACTOR, Z-FACTOR', NULL,IRTFLG)
 	   IF (IRTFLG .NE. 0) RETURN
           XFACT = BUF(1)
           YFACT = BUF(2)
           ZFACT = BUF(3)

           NVAL = 3
           CALL RDPRAF(BUF,3,NVAL,AMIN,AMAX,
     &                 'X-OFFSET, Y-OFFSET, Z-OFFSET', NULL,IRTFLG)
 	   IF (IRTFLG .NE. 0) RETURN
           XOFF = BUF(1)
           YOFF = BUF(2)
           ZOFF = BUF(3)

        ELSE
	   CALL RDPRM2(XFACT,YFACT,NLOOP,ILOOP,'X-FACTOR, Y-FACTOR')
	   CALL RDPRM2(XOFF,YOFF,NLOOP,ILOOP,'X-OFFSET, Y-OFFSET')
           ZOFF = 0.0
        ENDIF

	IF (XFACT .EQ. 0.0) XFACT = 1.0
	IF (YFACT .EQ. 0.0) YFACT = 1.0
	IF (ZFACT .EQ. 0.0) ZFACT = 1.0

	NVALU = MAX0(NCOLX,NCOLY,NCOLZ)
        NVALU = MAX0(NVALU,NCOLP)
        NUM   = MAXPEAK

        CALL RDPRAI(NPEAK,MAXPEAK,NUM,0,99999,'ENTER KEY NUMBERS',
     &              NULL,IRTFLG)
        IF (IRTFLG .NE. 0) RETURN

        NOPEN  = 0
        NUMSET = 0
	DO  I=1,NUM
C          GET COORDS FROM DOCUMENT FILE

           CALL UNSAV(DOCNAM,NOPEN,NDOC,NPEAK(I),PLIST,NVALU,LERR,1)
           IF (LERR .NE. 0) GOTO 9300
           NOPEN = 1

           IF (NCOLX.EQ.0) THEN
              IXCOR = NPEAK(I) * XFACT - XOFF
           ELSE
              IXCOR = PLIST(NCOLX) * XFACT + 0.5 - XOFF
           ENDIF

           IYCOR = PLIST(NCOLY) * YFACT + 0.5 - SIGN(1.,YFACT) * YOFF
           IF (YFACT .LT. 0.0) IYCOR = NROW + IYCOR

           IF (IFORM .EQ. 3) THEN
              IZCOR = PLIST(NCOLZ) * ZFACT + 0.5 - SIGN(1.,ZFACT) * ZOFF
           ELSE
              IZCOR = 1
           ENDIF

           IF ((IXCOR .GT. NSAM   .OR. IXCOR .LE. 0) .OR.
     &         (IYCOR .GT. NROW   .OR. IYCOR .LE. 0) .OR.
     &         (IZCOR .GT. NSLICE .OR. IZCOR .LE. 0)) THEN
               WRITE(NOUT,721) NPEAK(I),IXCOR,IYCOR,IZCOR
721            FORMAT(' *** LOCATION: ',I4,' : (',I5,',',I5,',',I5,
     &                ') OUTSIDE IMAGE, CONTINUING')
           ELSE
              IREC = (IZCOR -1) * NSAM * NROW + IYCOR
              CALL REDLIN(LUN2,BUF,NSAM,IREC)
              IF (NCOLP .GE. 1)  HEIGHT = PLIST(NCOLP)

              BUF(IXCOR) = HEIGHT
              CALL WRTLIN(LUN2,BUF,NSAM,IREC)
              NUMSET = NUMSET + 1
           ENDIF
        ENDDO

9300    WRITE(NOUT,90) NUMSET
 90     FORMAT(' NUMBER OF LOCATIONS SET: ',I4)

        IF (NUMSET .GT. 0) THEN
C          SET FMIN, FMAX AS UNDETERMINED
           CALL SETPRM(LUN2,NSAM,NROW,0.0,0.0,0.0,'U')
        ENDIF
        
        CLOSE(LUN2)
	RETURN
	END
