C
C++************************************************************************
C
C $$ PW3SDR.FOR
C
C **************************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK            *
C *  COPYRIGHT (C)1981,1987, WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *  THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR       *
C *  LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR    *
C *  USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF     *
C *  THE CENTER FOR LABORATORIES AND RESEARCH                              *
C **************************************************************************
C
C
C
C--************************************************************************
C
C $$ PW3SDR.FOR
C
	SUBROUTINE  PW3SDR(LUN1,LUN2,Q,T,NNNN,NSAM,NROW,NSLICE,MODE)
	DIMENSION   Q(NNNN),T(NSAM)
	CHARACTER*1  MODE
	LOGICAL*1 IFND,IFNL
CNO_SAVE
	IFND=MOD(NROW,2).EQ.0
	IFNL=MOD(NSLICE,2).EQ.0
	NSC=NSAM/2+1
C
	SCL=2.0/FLOAT(NSAM)/FLOAT(NROW)/FLOAT(NSLICE)
	DO    K=1,NSLICE
	DO    J=1,NROW
	NR=J+(K-1)*NROW
	CALL  REDLIN(LUN1,Q,NNNN,NR)
C
	DO    I=NNNN-1,1,-2
	Q(NNNN-1-(NNNN-1-I)/2)=
     &		SCL*SQRT(Q(I+1)*Q(I+1)+Q(I)*Q(I))
        ENDDO
	IF(MODE.EQ.'L')  CALL  AL10(Q(NSAM/2),NSAM/2)
	Q(1)=Q(NNNN-1)
	CALL  WRTLIN(LUN2,Q,NSAM,NR)
	ENDDO
	ENDDO
C
	DO    K=1,NSLICE
	DO    J=1,NROW/2
	JJ=J+NROW/2+MOD(NROW,2)
	NR=J+(K-1)*NROW
	NRJ=JJ+(K-1)*NROW
	CALL  REDLIN(LUN2,Q,NSAM,NR)
	CALL  REDLIN(LUN2,T,NSAM,NRJ)
	CALL  WRTLIN(LUN2,Q,NSAM,NRJ)
	CALL  WRTLIN(LUN2,T,NSAM,NR)
	ENDDO
	ENDDO
C
	IF(.NOT.IFND)  THEN
	DO    K=1,NSLICE
	NR=NROW/2+1+(K-1)*NROW
	CALL  REDLIN(LUN2,T,NSAM,NR)
	DO    J=NROW/2+1,NROW-1
	NR=J+(K-1)*NROW
	NRJ=J+1+(K-1)*NROW
	CALL  REDLIN(LUN2,Q,NSAM,NRJ)
	CALL  WRTLIN(LUN2,Q,NSAM,NR)
	ENDDO
	NR=NROW+(K-1)*NROW
	CALL  WRTLIN(LUN2,T,NSAM,NR)
	ENDDO
	ENDIF	
C
	DO    K=1,NSLICE/2
	KK=K+NSLICE/2+MOD(NSLICE,2)
	DO   J=1,NROW
	NR=J+(K-1)*NROW
	NRK=J+(KK-1)*NROW
	CALL  REDLIN(LUN2,Q,NSAM,NR)
	CALL  REDLIN(LUN2,T,NSAM,NRK)
	CALL  WRTLIN(LUN2,Q,NSAM,NRK)
	CALL  WRTLIN(LUN2,T,NSAM,NR)
	ENDDO
	ENDDO
C
	IF(.NOT.IFNL)  THEN
	DO    J=1,NROW
	NR=J+(NSLICE/2)*NROW
	CALL  REDLIN(LUN2,T,NSAM,NR)
	DO    K=NSLICE/2+1,NSLICE-1
	NR=K+(K-1)*NROW
	NRK=K+K*NROW
	CALL  REDLIN(LUN2,Q,NSAM,NRK)
	CALL  WRTLIN(LUN2,Q,NSAM,NR)
	ENDDO
	NR=J+(NSLICE-1)*NROW
	CALL  WRTLIN(LUN2,T,NSAM,NR)
	ENDDO
	ENDIF	
C
	NSC=NNNN/2-1
	NSL=NSLICE/2
	IF(IFND)  THEN
	IF(IFNL)  THEN
	KB=2
	CALL  REDLIN(LUN2,Q,NSAM,1)
	DO    I=2,NSC
	II=NNNN-I
	Q(I)=Q(II)
	ENDDO
	CALL  WRTLIN(LUN2,Q,NSAM,1)
	ELSE
	KB=1
	ENDIF
	JB=2
	DO    K=KB,NSLICE
	KK=NSLICE-K+KB
	NR=1+(K-1)*NROW
	NRK=1+(KK-1)*NROW
	CALL  REDLIN(LUN2,Q,NSAM,NR)
	CALL  REDLIN(LUN2,T,NSAM,NRK)
	Q(1)=T(1)
	DO    I=2,NSC
	II=NNNN-I
	Q(I)=T(II)
	ENDDO
	CALL  WRTLIN(LUN2,Q,NSAM,NR)
	ENDDO
	ELSE
	JB=1
	ENDIF
	IF(IFNL)  THEN
	KB=2
	DO    J=JB,NROW
	JJ=NROW-J+JB
	CALL  REDLIN(LUN2,Q,NSAM,J)
	CALL  REDLIN(LUN2,T,NSAM,JJ)
	Q(1)=T(1)
	DO    I=2,NSC
	II=NNNN-I
	Q(I)=Q(II)
	ENDDO
	CALL  WRTLIN(LUN2,Q,NSAM,J)	
	ENDDO
	ELSE
	KB=1
	ENDIF
	DO    K=KB,NSLICE
	KK=NSLICE-K+KB
	DO    J=JB,NROW
	JJ=NROW-J+JB
	NR=J+(K-1)*NROW
	NRJ=JJ+(KK-1)*NROW
	CALL  REDLIN(LUN2,Q,NSAM,NR)
	CALL  REDLIN(LUN2,T,NSAM,NRJ)
	Q(1)=T(1)
	DO    I=2,NSC
	II=NNNN-I
	Q(I)=Q(II)
	ENDDO
	CALL  WRTLIN(LUN2,Q,NSAM,NR)	
	ENDDO
	ENDDO
C
C
C         IF(MODE.NE.'L')  Q(NSAM/2+1,NROW/1+1,NSLICE/2+1)=0.0
C
	END
