C++************************************************************************
C
C    QSTAT.FOR                          LONG FILE NAMES JAN 89 al
C
C **************************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK            *
C *  COPYRIGHT (C)1981,1987, WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH 			   *
C **************************************************************************
C
C    QSTAT(LUN,LUNM,NSAM,NROW,NSLICE)
C
C    PARAMETERS:   FILNAM       FILE NAME
C                  LUN          LOGICAL UNIT NUMBER OF IMAGE
C                  LUNM         LOGICAL UNIT NUMBER OF MASK
C                  NSAM,NROW    X & Y DIMENSIONS OF IMAGE
C                  NSLICE       Z DIMENSION  OF IMAGE
C                  NSTACK       STACK/MAXIM INDICATOR
C
C--*******************************************************************

      SUBROUTINE QSTAT(FILNAM,LUN,LUNM,NSAM,NROW,NSLICE,NSTACK)

CNO_SAVE
      INCLUDE 'CMBLOCK.INC'

      PARAMETER     (NBUFSIZ=17000)
      COMMON /COMMUN/ BUFF(NBUFSIZ)

      CHARACTER *(*)   FILNAM
      CHARACTER *81    FILNAMM
      CHARACTER        NULL

      NULL = CHAR(0)

      IF (FCHAR(4:4) .EQ. 'M') THEN
C        STATISTICS ON A MASK 
	 IF (NSTACK .GE. 0)  THEN
	     CALL ERRT(101,'THIS OPERATION NOT STACK AWARE YET',NE)
             RETURN
         ENDIF

         NSTACK1 = 0
         CALL OPFIL(.TRUE.,FILNAMM,LUNM,'O',NSAM1,NROW1,NSLICE1,
     &             NSTACK1,'MASK',.FALSE.,IRTFLG)
         IF (IRTFLG .NE. 0) RETURN
         IF (IFORM .LT. 1) THEN
            CALL ERRT(2,'QSTAT  ',NE)
            CLOSE(LUNM)
            RETURN
	 ELSEIF (NSAM1  .NE. NSAM   .OR. NROW1 .NE. NROW .OR. 
     &           NSLICE .NE. NSLICE1)  THEN
	     CALL ERRT(1,'QSTAT  ',NE)
	     CLOSE(LUNM)
	     RETURN
	 ENDIF

         CALL NORMM(LUN,LUNM,NSAM,NROW,NSLICE,FMAX,FMIN,AV,NPOINT)
         CLOSE (LUNM)
         nlet=20
         WRITE(NOUT,99) FILNAM(1:NLET)
99       FORMAT(' STATISTICS RELATING TO MASK: ',A)
         WRITE(NOUT,98)  NPOINT
98       FORMAT(' NUMBER OF POINTS: ',I8)

         CALL REPORTSTAT(FMIN,FMAX,AV,SIG)


      ELSE
C        FIND STATISTICS ON THIS IMAGE

C        START WITH FIRST IMAGE
         MAXIM  = NSTACK
         NIMAGE = 1

10       CALL NEXTIMG(BUFF,FILNAM,LUN,NSAM,NROW,NSLICE,
     &               NIMAGE,.TRUE.,IFORM,'Z',IRTFLG)

         IF (IRTFLG .EQ. 0) THEN
C           IMAGE FOUND BY NEXTIMG (MAY BE FIRST OR ONLY IMAGE)
            IF (IMAMI .NE. 1) 
     &         CALL NORM3(LUN,NSAM,NROW,NSLICE,FMAX,FMIN,AV)

            CALL REPORTSTAT(FMIN,FMAX,AV,SIG)
C           TRY NEXT IMAGE IN STACK
            NIMAGE = NIMAGE + 1
C           TRY NEXT IMAGE IF THIS IS A STACK AND THERE IS ONE
            IF (MAXIM .GT. 0 .AND. NIMAGE .LE. MAXIM) GOTO 10
          ENDIF
      ENDIF

      RETURN
      END

C     --------------- REPORTSTAT -----------------------------------
      SUBROUTINE REPORTSTAT(FMINT,FMAXT,AVT,SIGT)

CNO_SAVE
      INCLUDE 'CMBLOCK.INC'

      WRITE(NOUT,90) FMINT,FMAXT,AVT,SIGT
90    FORMAT(' FMIN =', G10.3,'  FMAX =', G10.3,'  AV =', G12.5,
     &       '  SIG =', G12.5)

      IF (NSEL(1) .NE. 0) THEN
          PARAM(NSEL(1)) = FMAXT
          PARAM(NSEL(2)) = FMINT
          PARAM(NSEL(3)) = AVT
          PARAM(NSEL(4)) = SIGT
      ELSE
          PARAM(4) = FMAXT
          PARAM(5) = FMINT
          PARAM(6) = AVT
          PARAM(7) = SIGT
      ENDIF

      RETURN
      END
