C++************************************************************************
C
C RADAVI.F
C
C **************************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK            *
C *  COPYRIGHT (C)1981,1987, WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *  THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR       *
C *  LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR    *
C *  USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF     *
C *  THE CENTER FOR LABORATORIES AND RESEARCH   			   *
C **************************************************************************
C
C  RADAVI.F
C
C23456789012345678901234567890123456789012345678901234567890123456789012
C--************************************************************************

         SUBROUTINE RADAVI(LUN1,LUN2,NSAM1,NROW1,MAXDIM)

         COMMON BUF(1)

         IRMAX = MIN0(NSAM1/2,NROW1/2)
         CALL CRCSE1(LUN1,BUF,NSAM1,NROW1,
     &               BUF(NSAM1+1),BUF(NSAM1+IRMAX+1),IRMAX)
C         ASUM = 0
C         DO I=1,IRMAX
C            ASUM=ASUM+BUF(I+NSAM1)
C         ENDDO
C         AVA = ASUM/FLOAT(IRMAX)
C Place outside of the circle (in the corners) last elemnt, not the
C  average
         AVA=BUF(IRMAX+NSAM1)
         DO I=1,NROW1
            KI = I-NROW1/2-1
            KI=KI*KI
            DO K=1,NSAM1
               KK  = K-NSAM1/2-1
               R   = SQRT(FLOAT(KI)+FLOAT(KK*KK))+1.0
               IR  = INT(R)
               IF (IR .LT. IRMAX) THEN
                  BUF(K) = BUF(IR+NSAM1)+(BUF(IR+1+NSAM1)-
     &                     BUF(IR+NSAM1))*(R-IR)
               ELSE
                  BUF(K) = AVA
               ENDIF
            ENDDO
            CALL WRTLIN(LUN2,BUF,NSAM1,I)
         ENDDO

         END
 
