C++*******************************************************************
C
C $$ RAMP.FOR
C
C
C **************************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK            *
C *  COPYRIGHT (C)1981,1987, WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH 			   *
C **************************************************************************
C
C
C $$ RAMP:    REMOVE LINEAR DENSITY VARIATION
C
C      THIS SUBROUTINE WILL REMOVE OVERALL LINEAR DENSITY VARIATION
C      FROM IMAGE.
C
C      CALL RAMP(LUN,NSAM,NROW)
C        LUN          LOGICAL UNIT NUMBER OF IMAGE FILE
C        NSAM,NROW    IMAGE DIMENSIONS
C
C      CODING:  PROGRAM FINDS COEFFICIENTS A,B,C OF A PLANE A*K+B*I+C
C               THAT IS THEN SUBTRACTED FROM IMAGE SO THAT TREND-FREE
C               IMAGE REMAINS.  COEFFICIENTS A,B,C ARE PRINTED OUT.
C
C--*******************************************************************

      SUBROUTINE RAMP(LUN1,NSAM,NROW)

      INCLUDE 'CMBLOCK.INC'

      COMMON Q(1)
      CHARACTER *81 FILNAM
      CHARACTER *1  NULL
      DATA  LUN2/9/
CNO_SAVE
	NULL=CHAR(0)
      CALL FILERD(FILNAM,NLETO,NULL,'OUTPUT',IRTFLG)
      IF (IRTFLG .EQ. -1) THEN
        CALL ERRT(4,'RAMP',NE)
        RETURN
      END IF
      CALL OPENF(FILNAM,LUN2,NSAM,NROW,'UNKNOWN',NF,1)
      IF(NF .EQ. 1) THEN
        CALL ERRT(4,'RAMP',NE)
      ELSE
        CALL  RAMP_P(LUN1,LUN2,Q,NSAM,NROW,NOUT)
        CLOSE(LUN1)
        CLOSE(LUN2)
      END IF
      END
