
C++*************************************************************************
C
C  RAWTOSPIDER.FOR -- CREATED JUL 95 al
C
C **************************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK            *
C *  COPYRIGHT (C)1981,1995, WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH 			   *
C **************************************************************************
C
C  RAWTOSPIDER(LUNOLD,LUNNEW,IRTFLG)
C
C  PURPOSE:  CONVERTS RAW INTEGER IMAGES TO SPIDER FORMAT
C
C        0         2         3         4         5         6         7     
C23456789 123456789 123456789 123456789 123456789 123456789 123456789 12
C--*********************************************************************

       SUBROUTINE RAWTOSPIDER(LUNOLD,LUNNEW,IRTFLG)

       INCLUDE 'CMBLOCK.INC'
CNO_SAVE

C      RUN-TIME ALLOCATION SPECIFIC CODE LINE FOLLOWS
#ifdef SP_NT
       INTEGER LOCLUN
#else
       INTEGER * 8     LOCLUN
#endif

       LOGICAL USEINLN
       COMMON /LUNARB/  LOCLUN(100),NSAMLUN(100),NWORDLUN(100),USEINLN
       COMMON /LUNARA/  LUNARA(100),LUNSTK(100)

 
       CHARACTER * 81   FILOLD,FILNEW,EXTEN
       COMMON /COMMUN/  FILOLD,FILNEW,EXTEN

       CHARACTER        NULL,CDUM,ANS
       LOGICAL          EX,FOLD
       INTEGER          IARRAY(3)
 
       NULL = CHAR(0)
C      GET FILENAME FOR EXISTING RAW IMAGE FILE

8      INMODE = 8
       CALL RDPRIS(INMODE,NDUM,NLOOP,ILOOP,
     &    'ENTER BITS / PIXEL IN INPUT IMAGE (8, 16 OR 32)',IRTFLG)
       IF (IRTFLG .EQ. -1) RETURN

C      ACCEPT EXTENSION FROM INPUT 
10     IRTFLG = 9
       EXTEN  = NULL

       IF (INMODE .EQ. 8) THEN
          CALL FILERD(FILOLD,NLETU,EXTEN,'EXISTING 8-BIT RAW',IRTFLG)

       ELSE IF (INMODE .EQ. 16) THEN
          CALL FILERD(FILOLD,NLETU,EXTEN,'EXISTING 16-BIT RAW',IRTFLG)

       ELSE IF (INMODE .EQ. 32) THEN
          CALL FILERD(FILOLD,NLETU,EXTEN,'EXISTING 32-BIT RAW',IRTFLG)

       ELSE
          WRITE(NOUT,*) '*** PGM ERROR, INMODE MUST BE (8,16,OR 32)!'
          CALL ERRT(100,'RAWTOSPIDER',NE)
          RETURN
       ENDIF
       IF (IRTFLG .NE. 0) GOTO 8

C      SEE IF RAW DATA FILE EXISTS
       IF (EXTEN(1:1) .EQ. NULL) THEN
           CALL FILCAN(FILOLD,NLETO,NULL,NULL,FILOLD,DATEXC,IRTFLG)
       ENDIF
       INQUIRE(FILE=FILOLD,IOSTAT=IOERR,EXIST=EX)
       IRTFLG = 1

       IF (.NOT. EX) THEN
C         ERROR -- FILE DOES NOT EXIST
          WRITE(NOUT,90) FILOLD
90        FORMAT(' *** NOT FOUND: ',A)
          CALL ERRT(100,'RAWTOSPIDER',NE)
          RETURN

       ELSEIF (IOERR .NE. 0) THEN
C         ERROR FINDING FILE
          WRITE(NOUT,91) FILOLD
91        FORMAT(' *** INQUIRY ERROR FOR: ',A)
          CALL ERRT(100,'RAWTOSPIDER',NE)
          RETURN
       ENDIF

20      INUM = 3
        CALL RDPRAI(IARRAY,3,INUM,1,32000,
     &     'ENTER COLUMNS, ROWS & SLICES',CDUM,IRTFLG)
        IF (IRTFLG .EQ. -1) GOTO 10
         
        IF (INUM .LT. 1) THEN
           CALL ERRT(31,'RAWTOSPIDER',NE)
           GOTO 20
        ELSE
           NSAM = IARRAY(1)
           IF (INUM .LT. 2) THEN
              NROW = NSAM
              NSLICE = 1
           ELSE
              NROW = IARRAY(2)
              IF (INUM .LT. 3) THEN
                 NSLICE = 1
              ELSE
                 NSLICE = IARRAY(3)
              ENDIF
           ENDIF
        ENDIF

22     IOFFSET = 0
       CALL RDPRIS(IOFFSET,NDUM,NLOOP,ILOOP,
     &    'ENTER HEADER BYTES TO BE SKIPPED',IRTFLG)
       IF (IRTFLG .EQ. -1) THEN
           CLOSE(LUNOLD)
           GOTO 20
       ENDIF

       IF (INMODE .EQ. 8) THEN
           IDIV = 1

       ELSE IF (INMODE .EQ. 16) THEN
           IDIV    = 2
           ISIGB   = 1

23         CALL RDPRIS(ISIGB,NDUM,NLOOP,ILOOP,
     &        'ENTER MOST SIGNIFICANT BYTE (1 OR 2)',IRTFLG)
           IF (IRTFLG .EQ. -1) GOTO 22
           IF (ISIGB .NE. 1 .AND. ISIGB .NE. 2) THEN
              CALL ERRT(16,'RAWTOSPIDER',NE)
              GOTO 23
           ENDIF

           FOLD = .FALSE.
           CALL RDPRMC(ANS,NCHAR,.TRUE.,'FOLD NEGATIVES? (N/Y)',
     &                 CDUM,IRTFLG)
           IF (IRTFLG .EQ. -1) GOTO 23
           IF (ANS .EQ. 'Y' .OR. ANS .EQ. 'y') FOLD = .TRUE.

       ELSEIF (INMODE .EQ. 32) THEN
           IDIV    = 4
       ENDIF

C      CODE IS INVOLVED IF HEADER IS NOT SAME WORD LENGTH AS DATA

C      OPEN THE EXISTING RAW FILE
       LENREC = 64
       LENOPN = 64
#ifdef __osf__
       LENOPN = LENOPN / 4 
#endif 
       OPEN(LUNOLD,FILE=FILOLD,STATUS='OLD',IOSTAT=IOERR,
     &      FORM='UNFORMATTED',ACCESS='DIRECT',RECL=LENOPN)

       IF (IOERR .NE. 0) THEN
C         ERROR FINDING/OPENING FILE
          WRITE(NOUT,92) FILOLD
92        FORMAT(' *** ERROR OPENING: ',A)
          CALL ERRT(100,'RAWTOSPIDER',NE)
          RETURN
       ENDIF
       LUNARA(LUNOLD) = 0
       LUNSTK(LUNOLD) = 0
       LOCLUN(LUNOLD) = 0

C      OPEN NEW OUTPUT SPIDER IMAGE FILE WITH SPECIFIED SIZE
C      32 BIT REAL SPIDER IMAGE OUTPUT
       IFORM  = 1
       IF (NSLICE .GT. 1) IFORM = 3 
       CALL OPFIL(.TRUE.,FILNEW,LUNNEW,'U',NSAM,NROW,NSLICE,
     &            IDUM,'NEW SPIDER IMAGE',.FALSE.,IRTFLG)
       IF (IRTFLG .EQ. -1) GOTO 22
       IF (IRTFLG .NE. 0) GOTO 9999

       NBYTES = NSAM * NROW * NSLICE * IDIV + IOFFSET
       CALL RAWTOSPI(LUNOLD,LENREC,LUNNEW,NSAM,NBYTES,
     &                 INMODE,FOLD,IOFFSET,ISIGB,IRTFLG)

9999   CLOSE(LUNOLD)
       CLOSE(LUNNEW)

       RETURN
       END
     

C ------------------------- RAWTOSPI ----------------------------------


       SUBROUTINE RAWTOSPI(LUNOLD,LENREC,LUNNEW,NSAM,NBYTES,
     &                     INMODE,FOLD,IOFFSET,ISIGB,IRTFLG)

       INCLUDE 'CMBLOCK.INC'
CNO_SAVE

       COMMON           INBUF,FBUF
       INTEGER * 1      INBUF(64000)
       DIMENSION        FBUF(16000)

       CHARACTER        NULL
       LOGICAL          FOLD

       INTEGER * 1      I1VAL(4)
       INTEGER * 4      I4VAL
       EQUIVALENCE      (I4VAL,I1VAL(1))
       EQUIVALENCE      (FVAL,I1VAL(1))
 
       NULL = CHAR(0)
C      CLEAN THE BUFFER, THIS ASSUMED THE INTENSITIES IN THE RAW IMAGE 
C      ARE ALL POSITIVE NUMBERS				---- liy
       DO I = 1, 4
	  I1VAL(I) = 0
       ENDDO

C      NGOT IS POINTER TO CURRENT NUMBER OF IMAGE BYTES OUTPUT
       NGOT   = 0
C      NLOC IS POINTER TO CURRENT INPUT BUFFER POSITION
       NLOC   = LENREC
       NPUT   = 0
C      IROW IS NUMBER OF OUTPUT RECORD
       IROW   = 0
C      BYTE POINTER FOR 16 & 32 BIT INPUT
       IBITE  = 0
C      CURRENT INPUT RECORD
       IRECIN         = 1

       DO WHILE (NGOT .LT. NBYTES)

C        POINT TO CURRENT INPUT BUFFER VALUE
         NLOC = NLOC + 1

         IF (NLOC .GT. LENREC) THEN
C            READ NEXT RECORD FROM INPUT FILE (AS BYTES)
             LENREC = MIN(LENREC,(NBYTES-NGOT))
             CALL REDLIN8(LUNOLD,INBUF,LENREC,IRECIN,IRTFLG)
             IF (IRTFLG .NE. 0) THEN
                WRITE(NOUT,*) '*** ERROR READING INPUT AT NGOT:',NGOT
                CALL ERRT(100,'RAWTOSPIDER',NE)
                RETURN
             ENDIF
             IRECIN = IRECIN + 1
             NLOC   = 1
         ENDIF

C        POINT TO CURRENT CUMULATIVE PIXEL
         NGOT = NGOT + 1

         IF (NGOT .GT. IOFFSET) THEN
C           AFTER HEADER
            IF (INMODE .EQ. 8) THEN
C               INPUT IS 8 BIT ------------------------------- 8 BIT IN
C               CONVERT TO 32 BIT FLOATING POINT 
                NPUT = NPUT + 1
                IVAL = INBUF(NLOC)
                IF (IVAL .LT. 0) IVAL = 256 + IVAL
                FBUF(NPUT) = IVAL

            ELSE IF (INMODE .EQ. 16) THEN
C               INPUT IS 16 BIT ----------------------------- 16 BIT IN
C               CONVERT TO 32 BIT FLOATING POINT 
                IBITE = IBITE + 1
                IF (ISIGB .EQ. 1 .AND. IBITE .EQ. 1) THEN
                   I1VAL(3) = INBUF(NLOC)
                ELSE IF (ISIGB .EQ. 1 .AND. IBITE .EQ. 2) THEN
                   I1VAL(4) = INBUF(NLOC)
                ELSE IF (IBITE .EQ. 1) THEN
                   I1VAL(4) = INBUF(NLOC)
                ELSE IF (IBITE .EQ. 2) THEN
                    I1VAL(3) = INBUF(NLOC)
                ENDIF                 
                IF (IBITE .EQ. 2) THEN
C                  PUT OUT COMPLETED VALUE
                   IF (FOLD) THEN
                      IF (I4VAL .LE. 32767) THEN
                         I4VAL = I4VAL + 32768
                      ELSE
                         I4VAL = I4VAL - 32768
                      ENDIF
                   ENDIF
                   NPUT       = NPUT + 1
                   FBUF(NPUT) = I4VAL
                   IBITE      = 0
                ENDIF

            ELSE IF (INMODE .EQ. 32) THEN
C               INPUT IS 32 BIT ---------------------------- 32 BIT IN
C               CONVERT TO 32 BIT FLOATING POINT 
                IBITE = IBITE + 1
                I1VAL(IBITE) = INBUF(NLOC)
                IF (IBITE .GE. 4) THEN
                   NPUT = NPUT + 1
                   FBUF(NPUT) = FVAL
                   IBITE = 0
                ENDIF

            ENDIF

            IF (NPUT .EQ. NSAM) THEN
C               PUT OUT COMPLETED RECORD
                IROW = IROW + 1
                CALL WRTLIN(LUNNEW,FBUF,NSAM,IROW)
                NPUT = 0
             ENDIF
         ENDIF
      ENDDO

      IF (NPUT .GT. 0) THEN
C        PUT OUT COMPLETED RECORD
         IROW = IROW + 1
         CALL WRTLIN(LUNNEW,FBUF,NSAM,IROW)
      ENDIF

C     SET NO ERROR FLAG
      IRTFLG = 0

      RETURN
      END
        
C dd if=avg000.dat of=tes032.dat count=16384 bs=1
C tail +1025c avg000.dat > tes032.dat

