C++*************************************************************************
C
C $$ RCONV.FOR
C                                        LONG FILENAMES JAN 89 al
C **************************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK            *
C *  COPYRIGHT (C)1981,1987, WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH 			   *
C **************************************************************************
C
C $$ RCONV:
C
C      CALL RCONV(LUN1,LUN2,LUNP,NSAM,NROW,NSLICE,MODE,MBUF)
C        LUN1        LOGICAL UNIT NUMBER OF FILE
C        LUN2        LOGICAL UNIT NUMBER OF FILE
C        LUNP        LOGICAL UNIT NUMBER OF FILE
C        NSAM,NROW,NSLICE   DIMENSIONS OF FILE
C        MODE
C        MBUF
C
C--*******************************************************************


      SUBROUTINE RCONV(LUN1,LUN2,LUNP,NSAM,NROW,NSLICE,MODE,MBUF)
	INCLUDE 'CMBLOCK.INC'
      COMMON	Q(1)
      COMMON /COMMUN/ FILEP
	DOUBLE PRECISION A
      CHARACTER *81 FILEP
      CHARACTER *1  NULL
CNO_SAVE
C
      NULL=CHAR(0)
C
      IF(MODE.NE.1) then
	WRITE(NOUT,*) ' OPTION NOT YET IMPLEMENTED'
      RETURN
	endif

C OPTIONS WITH MODE .GT.1 RESERVED FOR STANDARD PSFS
C TO BE IMPLEMENTED LATER
      CALL FILERD(FILEP,NLET,NULL,'PSF IN',IRTFLG)
      IF(NSLICE.EQ.1)  THEN
C-----------------------------------------------------------
C * NEW PSF, INPUT FROM CONSOLE OR INPUT STREAM EXPECTED,
C   PSF NOT TO BE SAVED
C
C # NEW PSF, INPUT AS BEFORE, BUT PSF TO BE SAVED
      IF(FILEP(1:1).NE.'*' .AND. FILEP(1:1).NE.'#') GOTO 100
      IF(FILEP(1:1).EQ.'*') GOTO 405

40    CALL FILERD(FILEP,NLETO,NULL,'PSFOUT',IRTFLG)
405   CALL RDPRMI(NSPRD,NDUM,NLOOP,ILOOP,'PSF WIDTH')
c  Memory available ?
	NSPRDH = NSPRD/2
	K_Q = 1
	K_B = K_Q+NSPRD*NSAM
	K_PSF=K_B+NSAM
      MUBUF = K_PSF+NSPRD**2
      IF(MUBUF.GT.MBUF) THEN 
      CALL ERRT(3,'RCONV',NE)
      RETURN
      ENDIF
c
	IOUT = 1
      IFORM = 0
      IF(FILEP(1:1).EQ.'*') GOTO 42
      CALL OPENF(FILEP,LUNP,NSPRD,NSPRD,'UNKNOWN',NF,1)
      IF(NF.EQ.1) GOTO 105
      IOUT = 2
42    NSPRD1 = NSPRD/2 + 1
      NSPRD2 = NSPRD1 + 1
      NSPRDS =NSPRD*NSPRD
      WRITE(NOUT,43) NSPRD1,NSPRD
      IF(NPROC.NE.0) WRITE(NPROC,43) NSPRD
43    FORMAT(' ENTER PSF MATRIX(',I2,' ROWS AND COLUMNS ')
      A = 0.
      DO  I = 1,NSPRD
      I1 = (I-1)* NSPRD+1
      I2 = I1 + NSPRD - 1
      READ(NIN,*)       (Q(K_PSF+K-1),K=I1,I2)
      WRITE(NECHO,436)  (Q(K_PSF+K-1),K=I1,I2)
      IF(NPROC.NE.0) WRITE(NPROC,436)   (Q(K_PSF+K-1),K=I1,I2)
436   FORMAT(5X,15F5.1)
      DO  K = I1,I2
      A = A + Q(K_PSF+K-1)
      ENDDO
      ENDDO

C NORMALIZE IF POSSIBLE
      IF(A.NE.0.) GOTO 46
      A = 1.
      WRITE(NOUT,465)
465   FORMAT(' *** PSF CANNOT BE NORMALIZED')
46    DO 48 I = 1,NSPRD
      LL=(I-1)*NSPRD         
      I1=LL+1
      DO  KK=1,NSPRD
      II=LL+KK
      Q(K_PSF+II-1) = Q(K_PSF+II-1)/A
      ENDDO
      GOTO(48,475),IOUT
475   CALL WRTLIN(LUNP,Q(K_PSF+I1-1),NSPRD,I)
48    CONTINUE
      GOTO 150

100   CALL OPENF(FILEP,LUNP,NSPRD,NSPRD,'OLD',NF,NDUM)
      GOTO(105,110),NF
105   CALL ERRT(4,'RCONV',NE)
      RETURN

110     continue
C Memory
	K_Q = 1
	K_B = K_Q+NSPRD*NSAM
	K_PSF=K_B+NSAM
      MUBUF = K_PSF+NSPRD**2
      IF(MUBUF.GT.MBUF) THEN
      CALL ERRT(3,'RCONV',NE)
      RETURN
	ENDIF
c
	DO  I = 1,NSPRD
       I1 = (I-1)*NSPRD + 1
       CALL REDLIN(LUNP,Q(K_PSF+I1-1),NSPRD,I)
        ENDDO
150   CLOSE(LUNP)
c
C WRITE OUT PSF FOR VERIFICATION
1905  WRITE(NOUT,191)
191   FORMAT(' PSF IN EFFECT'/)
      K1 = 1
      K2 = K1+NSPRD-1
      DO  I = 1,NSPRD
      WRITE(NOUT,192)   (Q(K_PSF+K-1),K=K1,K2)
      K1 = K1+NSPRD
      K2 = K2+NSPRD
      ENDDO
192   FORMAT(1X,15F5.2)
C------------------------------------------------------------
	NQ=NSPRD/2
	CALL  RCNV2_P(LUN1,LUN2,Q(K_B),Q(K_Q),NSAM,NROW,Q(K_PSF),NQ)
C------------------------------------------------------------
	ELSE
C 3-D REAL CONVOLUTION WITH PSF READ FROM THE FILE
	CALL OPENF(FILEP,LUNP,NSPRD,NSPRD,'OLD',NF,NSPRD)
      GOTO(105,810),NF

810   IF(NSAM*NROW*NSPRD+NSAM+NSPRD**3.GT.MBUF) THEN
      CALL ERRT(3,'RCONV',NE)
      RETURN
      ENDIF
      DO    K=1,NSPRD
      DO  I = 1,NSPRD
	NR=(K-1)*NSPRD+I
        I1 = (K-1)*NSPRD*NSPRD+(I-1)*NSPRD + 1
        CALL REDLIN(LUNP,Q(I1),NSPRD,NR)
      ENDDO
      ENDDO
850   CLOSE(LUNP)
      WRITE(NOUT,191)
	K1=1
	K2=NSPRD
	DO    K=1,NSPRD
	WRITE(NOUT,*)  K
	DO    I=1,NSPRD
	WRITE(NOUT,892)  (Q(J),J=K1,K2)
	K1=K1+NSPRD
	K2=K2+NSPRD
	ENDDO
	ENDDO
892	FORMAT(9(1X,1PE10.3))
C
	K1=NSPRD*NSPRD*NSPRD
	CALL  RCNV3_P(LUN1,LUN2,
     &	Q(NSAM*NROW*NSPRD+K1+1),Q(K1+1),NSAM,NROW,NSLICE,Q,NSPRD)
      ENDIF	
      END
