
C++************************************************************************
C
C RDDOCN.F   ADAPTED FROM RDDOCA2Q.F FEB 97 BY ArDean Leith
C
C **************************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK            *
C *  COPYRIGHT (C)1981,1987, WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH 			   *
C **************************************************************************
C
C   RDDOCN(DOCNAM,NDOC)
C
C   PURPOSE:  FINDS NUMBER OF COLUMNS AND KEYS IN DOC FILES. CAN
C             SET THESE VALUES IN REGISTERS GIVEN COMMAND LINE
C   
C   PARAMETERS:   DOCNAM    FILE NAME                   (SENT)
C                 NDOC      LUN FOR DOC FILE            (SENT)
C
C   USAGE:        UD N,X11,X12
C
C   CALLS:    
C
C--*******************************************************************

	SUBROUTINE RDDOCN(DOCNAM,NDOC)

	INCLUDE 'CMBLOCK.INC' 
CNO_SAVE

        CHARACTER *(*) DOCNAM
        LOGICAL        ISDIGI

C       FIND MAXKEYS BY READING DOC FILE TO GET MAX KEY NUMBER
        CALL DOCINFO(DOCNAM,NDOC,MAXKEYS,MAXCOLS,.TRUE.,IRTFLG)
        IF (IRTFLG .NE. 0) THEN
           CALL ERRT(100,'RDDOCN',NE)
           RETURN
        ENDIF

C       IF 'X' PRESENT SET DESIRED REGISTER TO MAXKEYS

        KGO = INDEX(FCHAR,'X')

        IF (KGO .GT. 5 .AND. NALPH .GE. 6) THEN
C          HAVE REGISTER TO BE SET
             
           KLEN = 3
           IF (((KGO + 2) .GT. NALPH) .OR. 
     &         (.NOT. ISDIGI(FCHAR(KGO+2:KGO+2)))) KLEN = 2
           CALL CHKSTRQ(FCHAR(KGO:NALPH),KLEN,'I',IREG,DUM,NREGS,IER)

           IF (IREG .GT. 1 .AND. IREG .LT. 100) THEN
C             SET THIS REGISTER TO MAXKEYS
              PARAM(IREG) = MAXKEYS
           ELSE
C             CAN ONLY HAVE 100 REGISTERS
              WRITE(NOUT,*) '*** REGISTERS: 0..99  GOT: ',IREG
           ENDIF

           IF ((KGO + KLEN + 1) .LT. NALPH) THEN
C             MAY WANT TO SET SECOND REGISTER WITH MAXCOLS
              KGO = INDEX(FCHAR(KGO + KLEN + 1:NALPH),'X') + KGO + KLEN

              KLEN = 3
              IF (((KGO + 2) .GT. NALPH) .OR. 
     &           (.NOT. ISDIGI(FCHAR(KGO+2:KGO+2)))) KLEN = 2
              CALL CHKSTRQ(FCHAR(KGO:NALPH),KLEN,'I',IREG,DUM,NREGS,IER)

              IF (IREG .GT. 1 .AND. IREG .LT. 100) THEN
C                SET THIS REGISTER TO MAXCOLS
                 PARAM(IREG) = MAXCOLS
              ELSE
C                CAN ONLY HAVE 100 REGISTERS
                 WRITE(NOUT,*) '*** REGISTERS: 0..99  GOT: ',IREG
              ENDIF
           ENDIF
        ENDIF

        WRITE(NOUT,*) ' '
	RETURN
	END

