
C++************************************************************************
C
C RDDOCQ.FOR
C                                         LONG FILE NAMES FEB 89 al
C                                         CHAR VARIABLES AUG 89 al
C                                         DOC FILE LEFT OPEN NOV 89 al
C **************************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK            *
C *  COPYRIGHT (C)1981,1987, WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH 			   *
C **************************************************************************
C
C  RDDOCQ(CFUNC,NDOC,CDUM)
C
C  PURPOSE:  SUBROUTINE TO UNSAVE SPECIFIED REGISTERS, SOLICITS FILENAME
C            REGISTERS ARE SPECIFED ON COMMAND LINE.
C
C  PARAMETERS:    CFUNC   OPERATION READ INTO DRIVER           (SENT)
C                 NDOC    LUN NUMBER OF FILE                   (SENT)
C                 CDUM    UNUSED
C
C  USAGE:         UD      RETRIEVES A LINE OF REGISTERS FROM DOC FILE
C                 UD S    SEQUENTIAL RETRIEVE
C                 UD E    CLOSES THE LAST DOC. FILE OPENED WITH UD
C
C
C  CALLS          UNSAV
C
C        0         2         3         4         5         6         7     
C23456789012345678901234567890123456789012345678901234567890123456789012
C--*********************************************************************

	SUBROUTINE RDDOCQ(CFUNC,NDOC,CDUM)

        COMMON /COMMUN/ DOCNAM,DOC,RECLIN
	COMMON /UNITS/LUN,NIN,NOUT
	COMMON /PARAM/PARAM(103)
	COMMON /DOLOOP/IALPHA(26)
	COMMON /MASTER/NSAM,NROW,IREC,NLABEL,IFORM,IMAMI,FMAX,FMIN,
     &                 AV,SIG,IHIST

        CHARACTER *(*) CFUNC,CDUM
        CHARACTER *81  DOCNAM,DOC,OLDNAM
        CHARACTER *80  RECLIN
        CHARACTER *1   NULL,DINDEX,CCHAR
	DIMENSION      ILIST(20),SAV(20),DUMSAV(20)
	LOGICAL        NEWFILE,ISCHAR

	DATA NZERO/-99/,LUNOLD/0/

        NULL        = CHAR(0)
        OLDNAM(1:1) = NULL


        IF (CFUNC(4:4) .EQ. 'E') THEN
C          ENDS USE OF THIS DOC FILE
           CLOSE(NDOC)
           OLDNAM = NULL
           LUNOLD = 0
           RETURN
        ENDIF

C       CHECK IF FIRST ENTRY IS A REGISTER OR AN INTEGER.
C       ND = -9 MEANS TOO MANY REGISTERS SPECIFIED
C       NFIRST = 0, WRITE HEADING FROM DOC FILE TO NOUT SINCE 
C                   THIS IS THE FIRST TIME THROUGH

	ND     = -9
	SAV(1) = -9.0
	NFIRST =  0

	DO J=2,20
           SAV(J) = 0.0
        ENDDO

	K1=4
	IF (CFUNC(4:4) .EQ. 'S') K1 = 6

    	DO K = K1,80
C         CHECK FOR , OR X
	  IF (CFUNC(K:K) .EQ. ',' .OR. CFUNC(K:K).EQ. 'X') GOTO 1414
        END DO
	CALL ERRT(16,'RDDOCQ',NE)
	RETURN

1414	IF (CFUNC(K:K) .EQ. 'X') THEN
C          FIRST ENTRY IS A REGISTER.
           K = INDEX(CFUNC(K1:),',') + K1 - 1
           CALL CHKSTRQ(CFUNC(K1:),K-4,'I',KLIST,DUM,KNLIST,IER)
	   DLIST = PARAM(KLIST)

        ELSEIF(ISCHAR(CFUNC(K-1:K-1)).AND. CFUNC(K-1:K-1) .NE. 'X') THEN
C          FIRST ENTRY IS A DO LOOP INDEX, PUT ITS VALUE INTO DLIST.
           DINDEX = CFUNC(K-1:K-1)
           IDX    = ICHAR(DINDEX) - 64
           DLIST  = IALPHA(IDX)
           CALL CHKSTRQ(CFUNC(K+1:),79-K,'I',ILIST,DUM,NLIST,IER)

        ELSE
C          ENTRY IS A NUMBER
           CALL CHKNUMQ(CFUNC(K1:),K-K1,'I',NUM,FNUM,IER)
           IF (IER .NE. 0) THEN
             CALL ERRT(16,'RDDOCQ ',NE)
             RETURN
           ENDIF

           DLIST = NUM
        ENDIF

        CALL CHKSTRQ(CFUNC(K+1:),79-K,'I',ILIST,DUM,NLIST,IER)
    	IF (IER .NE. 0) THEN
           CALL ERRT(16,'RDDOCQ ',NE)
           RETURN
        ENDIF

C       GET DOC FILE NAME
	CALL FILERD(DOC,NLET,NULL,'DOCUMENT',IRTFLG)
        IF (IRTFLG .NE. 0) RETURN

        IF (DOC .NE. OLDNAM .OR. NDOC .NE. LUNOLD) THEN
C         DIFFERENT DOC FILE OR DIFFERENT LUN FOR DOC FILE
          CLOSE(LUNOLD)
          LUNOLD = 0
          OLDNAM = NULL
          LENOLD = 0

C         OPEN THE DOC FILE
          DOCNAM = DOC
          CALL OPENDOC(DOCNAM,.TRUE.,NLET,NDOC,.FALSE.,
     &                 .TRUE.,.TRUE.,.TRUE.,NEWFILE,IER)
          IF (IER .NE. 0) RETURN

          OLDNAM = DOC
          LUNOLD = NDOC
          LENOLD = NLET
        ENDIF

	IF (CFUNC(4:4) .EQ. 'S') THEN
C          USE SEQUENTIAL SEARCH MODE
           IKEY = DLIST
           CALL UNSAV(DOCNAM,1,NDOC,IKEY,SAV(2),NLIST,LERR,1)

           DO  K=1,NLIST
             K1        = ILIST(K)
             PARAM(K1) = SAV(K+1)
           END DO
           GOTO 9999
        ENDIF

C       NOTE THAT WE CAN RETRIEVE COMMENT KEY LINES (;KEY)
C       BY UD -5,X5,X10,X15,....
C	THIS RETRIEVES THE LAST LINE WITH COMMENT KEY 5.
C	ML      6/24/94

        IF (DLIST .LT. 0) THEN
          KEYSIGN = -1
          DLIST = -DLIST
        ELSE
          KEYSIGN = 1
        END IF
	IKEY = DLIST+.5

1510	READ(NDOC,1518,END=1595) RECLIN
1518	FORMAT(A80)

	IF (RECLIN(2:2) .EQ. ';') THEN 
C          COMMENT LINE ENCOUNTERED. 
           IF (NFIRST .EQ. 0) THEN
C             FIRST SEMI (COMMENT LINE), SO WRITE OUT HEADING
              WRITE(NOUT,100) RECLIN(1:65)
100           FORMAT(A)
              NFIRST = 1
              GOTO 1510
           ENDIF
           IF (KEYSIGN .EQ. 1) THEN
C             READ ANOTHER LINE
              GOTO 1510
           ELSE
C            RECOVER A COMMENTED OUT LINE.
c            however, it could be another header if there no "key"
             IF(RECLIN(5:5).LT.'0' .OR. RECLIN(5:5).GT.'9') GOTO 1510
             CONTINUE
           END IF 
        ELSE
C          NOT A COMMENT. BUT WE ARE TRYING TO RETRIEVE A COMMENTED
C	   OUT KEY.
           IF (KEYSIGN .EQ. -1) GOTO 1510
        ENDIF

        IF (RECLIN(5:5) .EQ. ' ') THEN
c         continuation line 
          READ(RECLIN,1520) NDUM,NDUMB2,(DUMSAV(J),J=2,NDUMB2+1)          
1520	  FORMAT(I4,I2,6F12.6)
        ELSE
c         beginning of the line stored.
          IF (KEYSIGN .EQ. -1) THEN
	  
C           retrieval of commented out line.
            READ(RECLIN,1621) CCHAR,NDUM,NDUMB2,(DUMSAV(J),J=2,NDUMB2+1)
1621	    FORMAT(1X,A1,I3,I2,6F12.6) 
          ELSE
            READ(RECLIN,1620) NDUM,NDUMB2,(DUMSAV(J),J=2,NDUMB2+1)
1620	    FORMAT(I5,I2,6F12.6)
          END IF
        ENDIF

C	IF NOT THE DESIRED KEY GOTO 1510
	IF (NDUM .NE. IKEY) GOTO 1510    
	SAV(1) = -9.
	ND     = NDUMB2
c       I think it would be more general to do if(nlist.gt.nd). ML
	IF (NLIST .GT. 6) THEN
C          CONTINUATION LINE(S) ARE USED FOR THIS KEY
           K2 = NLIST - 6
           IF (K2 .LT. 6) GOTO 1580

           DO  K=7,NLIST,6
             READ(NDOC,1518)RECLIN
             IF (RECLIN(2:2) .EQ. ';') GOTO 1510

             IF (RECLIN(5:5) .EQ. ' ') THEN
C              THREE DIGIT KEYS
               READ(RECLIN,1520)NDUM,NDUMB2,
     &            (DUMSAV(NSIX),NSIX=K,K+NDUMB2-1)    
             ELSE
C              FOUR DIGIT KEYS
               READ(RECLIN,1620)NDUM,NDUMB2,
     &            (DUMSAV(NSIX),NSIX=K,K+NDUMB2-1)    
             ENDIF
             IF (NDUM .EQ. NZERO) THEN
                K2 = NLIST-K-5
                IF (K2 .EQ. 0) GOTO 1591
                IF (K2 .LT. 6) GOTO 1580
             ELSE
                BACKSPACE NDOC
                GOTO 1510
             ENDIF
	   ENDDO
        ENDIF
	IF (ND .LT. NLIST) GOTO 1510
	GOTO 1591


1580	READ(NDOC,1518) RECLIN
	IF (RECLIN(2:2) .EQ. ';') GOTO 1510
	JNUM = NLIST-K2+2
        IF (RECLIN(5:5) .EQ. ' ') THEN
          READ(RECLIN,1520)NDUM,NDUMB2,
     &    (DUMSAV(J),J=JNUM,JNUM+NDUMB2-1)
        ELSE
          READ(RECLIN,1620)NDUM,NDUMB2,
     &    (DUMSAV(J),J=JNUM,JNUM+NDUMB2-1)
        ENDIF
	IF (NDUM .EQ. NZERO) GOTO 1590
	BACKSPACE NDOC
	GOTO 1510

1590	ND = ND+NDUMB2
	IF (ND .LT. NLIST) GOTO 1510

1591	SAV(1) = IKEY
	DO  K = 2,NLIST+1
          SAV(K) = DUMSAV(K)
        END DO
	GOTO 1510



C       END OF DOCUMENT FILE LINES -------------------------

1595	IF (SAV(1) .NE. -9.) THEN
C         SUCCESSFUL RECOVERY OF KEY 
          DO K=1,NLIST
            K1        = ILIST(K)
            PARAM(K1) = SAV(K+1)
          END DO

        ELSEIF (ND. NE. -9) THEN
           WRITE(NOUT,*) ' *** TOO MANY REGISTERS SPECIFIED'
           CALL ERRT(12,'RDDOCQ',NE)

        ELSE
           WRITE(NOUT,*) ' KEY NOT FOUND'
           CALL ERRT(12,'RDDOCQ',NE)
        ENDIF

C**	CLOSE(NDOC)  (NOT CLOSED NOW)
9999    REWIND(NDOC)

	RETURN
	END


