
C++*************************************************************************
C
C  RDPR.F -- CREATED 2/8/90 al 
C         -- CONVERTED FROM READCH DEC 96 TO RATIONALIZE COMMENTS al
C         -- F90 CHANGES OCT. 97 al
C
C **********************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.    AUTHOR: J.FRANK      *
C *  COPYRIGHT (C)1985, 1996 HEALTH RESEARCH INCORPORATED, ALBANY, NY. *
C * THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO HEALTH            *
C * RESEARCH INC. AND ARE NOT TO BE DISCLOSED TO OTHERS OR USED        *
C * FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF       *
C * HEALTH RESEARCH INC.                                               *
C **********************************************************************
C
C    RDPR(PROMPT,NCHAR,ANS,UPPER,SAYIT,IRTFLG)
C
C    PURPOSE: READ AN ALPHANUMERIC STRING, 
C
C    PARAMETERS:    PROMPT    INPUT PROMPT                (SENT)
C                   NCHAR     LAST NON_BLANK CHAR IN RESPONSE (RETURNED)
C                   ANS       USER RESPONSE               (RETURNED)
C                   UPPER     CONVERT TO UPPERCASE        (SENT)
C                   SAYIT     LIST PROMPT OUTPUT          (SENT)
C                   IRTFLG    RETURN FLAG (0 IS NORMAL)   (RETURNED)
C
C    CALLED BY:     MANY SPIDER INPUT ROUTINES
C
C    NOTE:          THIS ROUTINE WAS ADDED BECAUSE THE Q FORMAT DOES NOT
C                   WORK THE SAME IN FORTRAN 77.  BY REPLACING THIS SINGLE 
C                   ROUTINE WITH A FORTRAN 77 COMPATIBLE SUBSTITUTE
C                   Q FORMAT INPUT CAN BE AVOIDED IN SPIDER.
C                   WILL SKIP lines WHICH START WITH ; (SPIDER COMMENT)
C
C	3/29/93	    MAHIEDDINE LADJADJ -- CHANGED TO ADD ON-LINE HELP
C
C23456789012345678901234567890123456789012345678901234567890123456789012
C--*********************************************************************

      SUBROUTINE RDPR(PROMPT,NCHAR,ANS,UPPER,SAYIT,IRTFLG)

      INCLUDE 'CMBLOCK.INC'

CNO_SAVE

      CHARACTER *(*) PROMPT, ANS
      LOGICAL        UPPER,IS_HELP,SAYIT

      IDOL = INDEX(PROMPT,'$') - 1
      IF (IDOL .LE. 0) IDOL = LEN(PROMPT)

10    CONTINUE
#ifdef SP_F90
      IF (SAYIT) WRITE(NOUT,90,ADVANCE='NO') PROMPT(1:IDOL)
 90   FORMAT(' .',A,': ')
#else
      IF (SAYIT) WRITE(NOUT,90) PROMPT(1:IDOL)
 90   FORMAT($,' .',A,': ')
#endif

#ifdef SP_VMS
C     NON-PORTABLE VAX FORTRAN Q READ
      READ(NIN,80,END=79) NCHAR,ANS
  80  FORMAT(Q,A80)
#else
C     READ ANSWER STRING
      READ(NIN,80) ANS
80    FORMAT(A80)
#endif

C     UPDATE THE BATCH COUNTER
      IBCNT = IBCNT + 1

C     FIND LAST NON-BLANK (Q WOULD KEEP TRAILING BLANKS)           
      NCHAR = lnblnk(ANS)
      IF (NCHAR .LE. 0) RETURN

#ifndef SP_NT
C     HELP IS NOT AVAILABLE YET ON NT VERSION
      IF (COPT .EQ. 'I') THEN
C        M LADJADJ.  ONLY IN INTERACTIVE MODE, DO WE CALL HELP
         IANS = INDEX(ANS(:NCHAR),'?')

C	 CHECK_THIS_OUT WILL RETURN IS_HELP = .TRUE. IF ANS()='HELP'
         CALL CHECK_THIS_OUT(ANS,NCHAR,'HELP',4,IS_HELP)
         IF ((IANS .GT. 0) .OR. IS_HELP ) THEN
            CALL MHELP(PROMPT,IANS,ANS,NCHAR,IS_HELP)
C           READ ANOTHER INPUT LINE
            GOTO 10            
         ENDIF
      ENDIF
#endif

C     CONVERT INPUT STRING TO ALL UPPER CASE IF DESIRED
      IF (UPPER) CALL SSUPCAS(ANS(1:NCHAR))

C     SEE IF THIS IS A COMMENT ONLY LINE
      ISEMI   = INDEX(ANS(1:NCHAR),';')
      IF (ISEMI .GT. 1) ILNBLNK = lnblnk(ANS(1:ISEMI-1))

C     SEE IF ONLY ; OR ONLY BLANKS BEFORE SEMICOLON
      IF (ISEMI .EQ. 1 .OR.
     &   (ISEMI .GT. 1 .AND. ILNBLNK .EQ. 0)) THEN

C        ECHO COMMENT (IF DESIRED) AND READ ANOTHER INPUT LINE
	 IF (NECHO .NE. 0) WRITE(NECHO,91) ANS(1:NCHAR)
	 IF (NPROC .NE. 0) WRITE(NPROC,91) ANS(1:NCHAR)
91       FORMAT(A)

C        READ ANOTHER INPUT LINE
         GOTO 10         
      ENDIF

C     SET NORMAL RETURN FLAG
      IRTFLG = 0
      RETURN


#ifdef SP_VMS
C       RETURN OR STOP (IN BATCH)  ON END_OF_FILE
 79     CALL ERRT(17,'RDPR',NE)
        NCHAR  = 0
        IRTFLG = 1
        RETURN
#endif

	END
