
C++************************************************************************
C
C $$ RDPRAF.FOR -- CREATED JULY 91 FROM RDPRAI
C
C **************************************************************************
C *  AUTHOR:   ArDean Leith                                                *
C *  COPYRIGHT (C)1986 , WADSWORTH CENTER FOR LABORATORIES AND             *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH  			   *
C **************************************************************************
C
C    RDPRAF(FLIST,NMAX,NUMBER,FLOW,HI,PROMPT,HELPFI,IRTFLG)
C
C    PURPOSE:  READ AN ALPHANUMERIC STRING, CHECK FOR ANY SPECIAL OPERATION,
C              RETURNS ARRAY OF REALS, THE NUMBER OF VALUES, OR A
C              FLAG  TO INDICATE THAT ONE SHOULD RETURN TO PREVIOUS QUESTION.
C              CHECKS TO SEE THAT VALUES ARE WITHIN SPECIFIED RANGE.
C
C              ALLOWABLE STRINGS           NUMBERS ENTERED IN ARRAY
C                 1.0,2,83.,66E1           1, 2, 8, 660
C                 1.0 2 83. 66E1           1, 2, 8, 660
C
C    PARAMETERS : FLIST     ARRAY FOR ANSWERS
C                 NMAX      MAX LENGTH OF ARRAY
C                 NUMBER    ON ENTRY IS MAX NUMBER OF ANSWERS TO BE RETURNED!!
C                            (<0 ON ENTRY IS FLAG TO ACCEPT NULL RESPONSE)
C                           ON RETURN IS NUMBER OF ANSWERS ACTUALLY RETURNED
C                 FLOW      BOTTEM OF RANGE (CAN'T BE BELOW THIS)
C                 HI        TOP OF RANGE (CAN'T BE ABOVE THIS)
C                 PROMPT    SOLICITATION MESSAGE
C                 HELPFI    NAME OF RELEVANT HELP FILE (OR NULL)
C                 IRTFLG    RETURN FLAG (0 IS NORMAL, -1 IS GOTO
C                              PREVIOUS QUESTION)
C      
C    CALLED BY:   
C
C    CALLS:       RDPRMC
C
C    NOTE: CAN PERFORM REGISTER SUBSTITUTION NOW al
C
C--************************************************************************

        SUBROUTINE RDPRAF(FLIST,NMAX,NUMBER,FLOW,HI,PROMPT,
     &             HELPFI,IRTFLG)        

        INCLUDE 'CMBLOCK.INC'

        DIMENSION       FLIST(NMAX)
        CHARACTER *(*)  PROMPT,HELPFI
        CHARACTER * 160 ANS
	CHARACTER * 1   NULL,A
        LOGICAL         SKIP,REGSUB

        NULL = CHAR(0)

C       A NEGATIVE NUMBER INPUT IS A FLAG THAT NULL INPUT IS ACCEPTABLE
        IF (NUMBER .LT. 0) THEN
          NVAL = -NUMBER
          SKIP = .TRUE.
        ELSE
          SKIP = .FALSE.
          NVAL = NUMBER
        ENDIF

C       DODO PROOF THE INPUT
        IF (NVAL .LE. 0)    NVAL = 1
        IF (NVAL .GT. NMAX) NVAL = NMAX

C..     GET INPUT LINE
20      CALL RDPRMC(ANS,NCHAR,.TRUE.,PROMPT,HELPFI,IRTFLG)
        IF (IRTFLG .EQ. -1) RETURN
        IRTFLG = 0

        IF (ANS(NCHAR:NCHAR) .EQ. ',') THEN
C         INPUT CONTINUATION LINE
          CALL RDPRMC(ANS(NCHAR+1:),NCHAR2,.TRUE.,
     &    'ENTER NEXT LINE OF INPUT',NULL,IRTFLG)
          IF (IRTFLG .EQ. -1) GOTO 20
          NCHAR = NCHAR + NCHAR2
        ENDIF

        NUMBER = 0
        I      = 0

   50   I = I + 1
C       CHECK TO SEE IF WE HAVE RUN OUT OF INPUT CHAR.
        IF (I .GT. NCHAR) THEN
          IF (NUMBER .EQ. 0 .AND. SKIP) THEN
C           GOT NULL INPUT WHERE IT IS ALLOWED AS AN INPUT
C           RETURN A FLAG THAT NULL ANSWER ACCEPTED
            IRTFLG = 3
            RETURN

          ELSE IF (NUMBER .EQ. 0) THEN
C           DIDN'T GET ANY NUMBERS IN INPUT
            WRITE(NOUT,94)
   94       FORMAT(' ERROR: NEEDS AT LEAST ONE INPUT VALUE'/)
            GOTO 20
            
          ELSE
C           END OF INPUT
            RETURN
          ENDIF
        ENDIF

        A = ANS(I:I)
C       CONTINUE CHECKING CHAR. UNTIL WE GET A NON BLANK CHAR.
        IF (A .EQ. ' ' .OR. A .EQ. ',' .OR. 
     &      A .EQ. '(' .OR. A .EQ. ')' ) GOTO 50

C       HAVE GOT FIRST CHAR IN NUMBER WHICH IS NON BLANK
        I1 = I
        REGSUB = .FALSE.

        IF (A .EQ. 'X' .OR. A .EQ. 'x') THEN
C          WANT A REGISTER SUBSTITUTION
           REGSUB = .TRUE.
           ANS(I:I) = ' '
               
 490       I = I + 1
           IF (I .GT. NCHAR) GOTO 70
           A = ANS(I:I)

C          IF HAVE A BLANK SPACE AFTER X. CONTINUE TO READ CHAR.
           IF (A .EQ. ' ') GOTO 490
C          IF NO MORE CHAR. OR NON DIGIT CHAR. HAVE INVALID INPUT
           IF( A .LT. '0' .OR. A .GT. '9') GOTO 70

        ENDIF
     

   54   IF (A .NE. ' ' .AND. A .NE. ',') THEN
C          INPUT CHAR. IS NOT END OF A INPUT VALUE, MAY HAVE VALID DIGIT?

           I = I + 1
C          CHECK TO SEE IF WE HAVE REACHED END OF INPUT
           IF (I .GT. NCHAR) GOTO 53
           A = ANS(I:I)
           GOTO 54
        ENDIF
 

C       FIND NUMBER OF CHAR. IN NUMBER
   53   I2 = I - 1
   55   N  = I2 - I1 + 1

C       CONVERT NUMBER TO REAL FORMAT
        NUMBER = NUMBER + 1
        IF (N .LE. 0) GOTO 70

        READ(ANS(I1:I2),*,ERR=70) FNUM1

        IF (REGSUB) THEN
C          FIND REGISTER CONTENTS
           IF (FNUM1 .LT. 1 .OR. FNUM1 .GT. 100) THEN
C             IMPROPER REGISTER NUMBER  
              WRITE(NOUT,920) FNUM1
920           FORMAT(' *** IMPROPER REGISTER: ',1PG11.3)
              GOTO 20
           ENDIF
           INUM1 = FNUM1
           FNUM1 = PARAM(INUM1 + 1)
        ENDIF

        IF (FNUM1 .LT. FLOW .OR. FNUM1 .GT. HI) THEN
           WRITE(NOUT,92)NUMBER,FLOW,HI
   92      FORMAT(' ERROR: INPUT ',I4,' OUT OF RANGE (',
     &            1PG12.3,'...',1PG12.3,')',/)
           GOTO 20
        ENDIF

        FLIST(NUMBER) = FNUM1

C       GET ANY REMAINING NUMBERS FROM THE INPUT STRING
        IF (NUMBER .LT. NVAL) GOTO 50       

        RETURN


C       UNKNOWN ERROR SOMEWHERE IN INPUT
   70   WRITE(NOUT,*) 'SYNTAX ERROR: ',ANS(1:I)
        GOTO 20

        END
       
