
C++************************************************************************ 
C
C   RDPRIS.FOR                ALTERED RDPRI  JULY 87 TO ADD IRTFLG al
C                             BUG IN IBUF ACCESS FIXED NOV 94 al      
C **************************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK            *
C *  COPYRIGHT (C)1981,1987, WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH 			   *
C **************************************************************************
C
C   RDPRIS(I1,I2,NLOOPD,ILOOPD,STRING,IRTFLG)
C
C   PURPOSE:    READ INTEGER(S)
C
C   PARAMETERS:
C        I1       FIRST INTEGER ENTERED (RETURNED TO CALLING PROGRAM)
C        I2       SECOND INTEGER ENTERED (RETURNED TO CALLING PROGRAM)
C        NLOOPD   NLOOP (USED IN BATCH)
C        ILOOPD   ILOOP (USED IN BATCH)
C        STRING   SOLICITATION MESSAGE
C        IRTFLG   RETURN FLAG (0 IS NORMAL,  -1 IS GOTO PREVIOUS QUESTION)
C                             (1 IS ABNORMAL, 3 IS NULL ANSWER ACCEPTED)
C
C  CALLS:         CHKSTRQ     ERRT   EXPRESSQ
C
C  NOTE:          RDPRIS DOES NOT ALTER RECEIVED VALUE OF I1 OR I2 IF
C                 IT RECEIVES NULL INPUT.
C
C        0         2         3         4         5         6         7
C23456789012345678901234567890123456789012345678901234567890123456789012
C--*********************************************************************

      SUBROUTINE RDPRIS(I1,I2,NLOOPD,ILOOPD,PROMPT,IRTFLG)

      INCLUDE        'CMBLOCK.INC' 
CNO_SAVE

      CHARACTER *(*)  PROMPT
      CHARACTER *80   ANSW
      LOGICAL         EXPRESSQ
      PARAMETER       (MAXB = 80)
      DIMENSION       IBUF(MAXB)

      SAVE            IBUF

C     DO NOT ZERO THE RETURNED VALUES (DIFFERENT FROM NORMAL SPIDER METHOD)

      NOFF = 1

 1400 CALL RDPR(PROMPT,NCHAR,ANSW,.TRUE.,.TRUE.,IRTFLG)

      IF (ANSW(1:1) .EQ. '^' .OR. ANSW(2:2) .EQ. '^') THEN
C        RETURN FLAG FOR GOING BACK TO PREVIOUS QUESTION
         IRTFLG = -1
         RETURN

      ELSEIF (NCHAR .LE. 0 .OR. ANSW(:1) .EQ. '$') THEN
C        NULL ANSWER RECEIVED, LEAVE BOTH INPUTS UNALTERED
         IRTFLG = 3
         GOTO 2300
      ENDIF
      IRTFLG = 0

      IF (EXPRESSQ(ANSW,NCHAR,VAL1,VAL2)) THEN
C        INPUT CONTAINS A REGISTER EXPRESSION
         I1 = VAL1 + 0.5
         IF (VAL1 .LT. 0.) I1 = VAL1 - 0.5
         I2 = VAL2 + 0.5
         IF (VAL2 .LT. 0.) I2 = VAL2 - 0.5

      ELSE
C        NO REGISTERS IN INPUT 
         CALL CHKSTRQ(ANSW,NCHAR,'I',IBUF(NOFF),DUM,INUM,IER)
         IF (IER .NE. 0) THEN
            CALL ERRT(16,'    ',NE)
            GOTO 1400
         ENDIF

         IF ((INUM .EQ. 1 .AND. NOFF .EQ. 1).OR.ANSW(1:1) .EQ. '(') THEN
            I1 = IBUF(1)
            IF (INUM .NE. 1) I2 = IBUF(2)

         ELSE
            NOFF  = NOFF + INUM
            IF (NOFF-1 .LT. NLOOPD*2)  GOTO 1400

C           ERROR OUTPUT ADDED 11/30/94 al
            IF ((2*ILOOPD) .GT. MAXB) THEN
               CALL ERRT(101,'PGM ERROR: 2ILOOPD > MAXB IN RDPRIS',NE)
            ENDIF
            I1    = IBUF(2*ILOOPD - 1)
            I2    = IBUF(2*ILOOPD)
         ENDIF
      ENDIF

 2300 IF (NECHO .NE .0) WRITE(NECHO,2400) I1,I2
      IF (NPROC .NE. 0) WRITE(NPROC,2400) I1,I2
 2400 FORMAT(5X,2(1X,I7))

      RETURN
      END



