C ++********************************************************************
C                                                                      *
C **********************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.    AUTHOR: J.FRANK      *
C *  COPYRIGHT (C)1985, 1996 HEALTH RESEARCH INCORPORATED, ALBANY, NY. *
C * THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO HEALTH            *
C * RESEARCH INC. AND ARE NOT TO BE DISCLOSED TO OTHERS OR USED        *
C * FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF       *
C * HEALTH RESEARCH INC.                                               *
C **********************************************************************
C
C***********************************************************************

   	SUBROUTINE RDPRJ(FINCTF,FINPAT,FINANG,
     1			FINSEL,NLETCTF,NLETPAT,NLETANG,
     2			N,NANG,NMAT,ANG,LB,CB,BCKW,PROJ,
     3                  IPCUBE,NN,PM,RI,CTF,WORK)

        INCLUDE   'CMBLOCK.INC'

	CHARACTER*80  FINCTF,FINPAT,FINANG,FINSEL,FINFO
	CHARACTER*1   NULL,DATEXTD(4)	
	COMMON        DUMMY(80),BUF(1024)
	COMMON /PAR/  LDP,NM,LDPNM
	DIMENSION     ANG(3,NANG),PM(9,NANG),LB(NANG),IPCUBE(5,NN)
	DIMENSION     CB(N,N,N),BCKW(N,N,N),CTF(N,N,N)
	DIMENSION     PROJ(N,N)
	DIMENSION     WORK(1000)

	DATA  INPIC/76/,INPROJ/75/

CNO_SAVE
C-------------------------------------------------------------
C       INITIALIZE THE WORKING VOLUME TO ZERO
C-------------------------------------------------------------
C$DOACROSS LOCAL(K,J,I)
	DO     K=1,N
	   DO     J=1,N
	      DO     I=1,N
 	         BCKW(I,J,K)=0.0
	      ENDDO
	   ENDDO
	ENDDO

C-------------------------------------------------------------
C           GET THE FILE INFORMATION OF ANGLES DOCUMENT
C-------------------------------------------------------------
	FINFO=FINANG(1:NLETANG)//'.'//DATEXC(1:3)
	OPEN(77,FILE=FINFO,STATUS='OLD')
	READ(77,*)

	K2=1
	DO KLT=1,NANG
C-------------------------------------------
C 	   READ THE SELECTION FILE AND GET THE FILE NUMBERS
C-------------------------------------------
	   LERR=-1
	   K=KLT-1
	   CALL  UNSAV(FINSEL,K,INPIC,KLT,QQQ,1,LERR,K2)
	   IF (LERR.EQ.0)  THEN
	      IMAGE=QQQ
C-------------------------------------------------------------
C	      GET THE FILE NAME FROM THE PATTERN
C             NANGC: CURRENT POSITION IN THE ANGLE LIST
C-------------------------------------------------------------
	      CALL  FILGET(FINPAT,FINFO,NLETPAT,IMAGE,INTFLAG)
C-------------------------------------------------------------
C	      OPEN THE FILE AND CHECK WHETHER IT EXISTS
C-------------------------------------------------------------
	      CALL  OPENFB(BUF,FINFO,INPROJ,LSAM,LROW,'O',NF,NSL)
	      IF (NF.NE.2)  THEN
	         WRITE(NOUT,90)   FINPIC
90	         FORMAT(' FILE NOT FOUND ',A,/,' OPERATION ABANDONED')
	         RETURN
	      ENDIF
	      IF (LSAM.NE.N)  THEN
                 CALL ERRT(1,'BP CTF',NE)
                 RETURN
	      ENDIF
	      DO K2=1,N
                 CALL  REDLIN(INPROJ,PROJ(1,K2),N,K2)
	      ENDDO
	      CLOSE(INPROJ)
C-------------------------------------------------------------
C             READ ANGLES FROM THE DOCUMENT FILE.
C             ORDER IN THE DOCUMENT FILE IS PSI, THETA, PHI AND 
C             ANGLES ARE IN DEGREES!
C             IN ANG ARRAY IT IS OTHER WAY AROUND
C-------------------------------------------------------------
	      MIM=0
105	      READ(77,110,END=120)  MAM,ANG(3,KLT),ANG(2,KLT),ANG(1,KLT)
	      IF (MAM.NE.IMAGE)  GOTO  105
	      GOTO  130

110	      FORMAT(I5,2X,3F12.1)
120	      REWIND 77
	      MIM=MIM+1
	      IF (MIM.EQ.2)  THEN
	         WRITE(NOUT,*) ' SOMETHING WRONG IN ANGLES DOC FILE !'
	         STOP
	      ENDIF
	      READ(77,*)
	      GOTO  105

130	      CONTINUE
	      WRITE(NOUT,140) KLT,(ANG(J,KLT),J=3,1,-1)
140	      FORMAT(' PROJECTION # ',I6,
     &	             ': PSI=',F6.1,' THETA=',F6.1,' PHI=',F6.1)
	   ELSE
	      CLOSE(INPIC)
	      CLOSE(77)
	      RETURN
	   ENDIF
C-------------------------------------------------------------
C	   BACK PROJECT THE PROJECTION TO THE WORKING VOLUME
C-------------------------------------------------------------	
	   CALL  RPRQ(N,PROJ,BCKW,IPCUBE,NN,
     &          ANG(1,KLT),ANG(2,KLT),ANG(3,KLT),PM(1,KLT),RI)
	ENDDO

	CLOSE(INPIC)
	CLOSE(77)
C-------------------------------------------------------------
C 	SUBTRACT AVERAGE ON THE SPHERE
C-------------------------------------------------------------
	CALL SUBSP(BCKW,NMAT,IPCUBE,NN)
C-------------------------------------------------------------
C	CALCULATE THE FOURIER TRANSFORM
C-------------------------------------------------------------
	INV=1
	CALL F3MR(BCKW,N,N,N,INV,WORK)
C-------------------------------------------------------------	
C	READ THE CTF PARAMETERS
C-------------------------------------------------------------
C-------------------------------------------------------------
C	    OPEN THE FILE AND CHECK WHETHER IT EXISTS
C-------------------------------------------------------------
	CALL  OPENFB(BUF,FINCTF,INPROJ,LSAM,LROW,'O',NF,NSL)
	IF (NF.NE.2)  THEN
	   WRITE(NOUT,90)   FINCTF
	   RETURN
	ENDIF
	IF (IFORM.NE.-21.AND.IFORM.NE.-22)  THEN
	   CALL ERRT(2,'BP CTF',NE)
	   CLOSE(INPROJ)
	   RETURN
	ENDIF

	IF (IFORM.EQ.-21)  THEN
           LS=LSAM-1
        ELSEIF (IFORM.EQ.-22)  THEN
           LS=LSAM-2
	ENDIF
	IF (LS.NE.N.OR.LROW.NE.N.OR.NSL.NE.N)  THEN
	   CALL  ERRT(1,'BP CTF',NE)
	   CLOSE(INPROJ)
	   RETURN
	ENDIF
	CALL  GETCTF(INPROJ,CTF,CTF,LSAM,N,WORK)

C-------------------------------------------------------------
C	MODIFY THE WORKING VOLUME BY CTF AND ADD IT TO CB
C-------------------------------------------------------------
C$DOACROSS LOCAL(K,J,I)
	DO     K=1,N
	   DO     J=1,N
	      DO     I=1,N
 	         CB(I,J,K)=CB(I,J,K)+BCKW(I,J,K)*CTF(I,J,K)
	      ENDDO
	   ENDDO
	ENDDO

C       COMPRESS ANGLES - IT CHANGES NANG !!
        CALL  HIANG(ANG,NANG,PM,LB)

        RETURN
        END
