
C++************************************************************************
C
C RDPRM.FOR
C
C **************************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK            *
C *  COPYRIGHT (C)1981,1987, WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH 			   *
C **************************************************************************
C
C    RDPRM(REALNO,NLOOPD,ILOOPD,PROMPT)
C
C    PURPOSE:      READ A FLOATING POINT NUMBER
C
C    PARAMETERS:   REALNO   REAL NUMBER RETURNED
C                  NLOOPD   NLOOP (USED IN BATCH)
C                  ILOOPD   ILOOP (USED IN BATCH)
C                  PROMPT   SOLICITATION MESSAGE
C
C    CALLS:        CHKSTR   CHECK STRING 
C                  ERRT     REPORT ERROR MESSAGE   
C                  EXPRESSQ 
C--*******************************************************************

      SUBROUTINE RDPRM(REALNO,NLOOPD,ILOOPD,PROMPT)

      INCLUDE         'CMBLOCK.INC' 
CNO_SAVE
       
      CHARACTER *(*) PROMPT
      CHARACTER *80  ANSW
      LOGICAL        EXPRESSQ
      PARAMETER      (MAXB = 999)
      DIMENSION      BUF(MAXB)

      SAVE           BUF

      NOFF = 1

 1400 CALL RDPR(PROMPT,NCHAR,ANSW,.TRUE.,.TRUE.,IRTFLG)

      IF (.NOT. EXPRESSQ(ANSW,NCHAR,REALNO,DUM)) THEN
C        NO REGISTER EXPRESSION 
         CALL CHKSTRQ(ANSW,NCHAR,'R',N1,BUF(NOFF),INUM,IER)
         IF (IER .NE. 0) THEN
            CALL ERRT(16,'RDPRM ',NE)
            GOTO 1400
         ENDIF

         IF (ANSW(1:1) .EQ. '(') THEN
            REALNO = BUF(1)
         ELSE
            NOFF  = NOFF + INUM
            IF ((NOFF - 1) .LT. NLOOPD) GO TO 1400

            REALNO = BUF(ILOOPD)
         ENDIF
      ENDIF

      IF (NECHO .NE. 0) WRITE(NECHO,2300) REALNO
      IF (NPROC .NE. 0) WRITE(NPROC,2300) REALNO
 2300 FORMAT(5X,G14.3)

      RETURN
      END

C      IF (ILOOPD .LE. 0 .OR. ILOOPD .GT. MAXB) THEN
CC         ARRAY OUT OF BOUNDS
C          CALL ERRT(6,'RDPRM',NE)
C          RETURN
C      ENDIF          
