
C++**************************************************************** 10/29/79
C
C RDPRM2.FOR
C
C **************************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK            *
C *  COPYRIGHT (C)1981,1987, WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH 			   *
C **************************************************************************
C
C    RDPRM2(F1,F2,NLOOPD,ILOOPD,PROMPT)
C    
C    PURPOSE:     READ A PAIR OF FLOATING POINT NUMBERS
C
C    PARAMETERS:
C        F1       FIRST NUMBER ENTERED  (RETURNED TO CALLING PROGRAM)
C        F2       SECOND NUMBER ENTERED (RETURNED TO CALLING PROGRAM)
C        NLOOPD   NLOOP (USED IN BATCH)
C        ILOOPD   ILOOP (USED IN BATCH)
C        PROMPT   SOLICITATION MESSAGE
C
C--*******************************************************************

      SUBROUTINE    RDPRM2(F1,F2,NLOOPD,ILOOPD,PROMPT)

      INCLUDE        'CMBLOCK.INC'
CNO_SAVE

      CHARACTER *(*) PROMPT
      CHARACTER *80  ANSW

      PARAMETER      (MAXB = 80)
      DIMENSION      BUF(MAXB)
      LOGICAL        EXPRESSQ

      SAVE           BUF

      BUF(2) = 0.0
      NOFF     = 1

1400  CALL RDPR(PROMPT,NCHAR,ANSW,.TRUE.,.TRUE.,IRTFLG)

      IF (.NOT. EXPRESSQ(ANSW,NCHAR,F1,F2)) THEN
C        NO REGISTERS IN INPUT
         CALL CHKSTRQ(ANSW,NCHAR,'R',IBUF,BUF(NOFF),INUM,IER)
         IF((INUM .EQ. 1 .AND. NOFF .EQ. 1).OR. ANSW(1:1).EQ. '(') THEN
            F1    = BUF(1)
            F2    = BUF(2)
         ELSE
            NOFF  = NOFF + INUM
            IF (NOFF-1 .LT. NLOOPD*2) GOTO 1400
            F1 = BUF(2*ILOOPD-1)
            F2 = BUF(2*ILOOPD)
         ENDIF
      ENDIF
 
 2000 WRITE(NECHO,2050) F1,F2
      IF (NPROC .NE. 0) WRITE(NPROC,2050) F1,F2
 2050 FORMAT(5X,2(1X,G14.3))

      RETURN
      END

