
C++*********************************************************************
C
C RDPRM2S.FOR
C
C **************************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK            *
C *  COPYRIGHT (C)1981,1987, WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH 			   *
C **************************************************************************
C
C RDPRM2S(F1,F2,N,NCUR,PROMPT,IRTFLG)
C
C PURPOSE:        READ A PAIR OF FLOATING POINT NUMBERS
C
C PARAMETERS:
C        F1       FIRST NUMBER ENTERED (RETURNED TO CALLING PROGRAM)
C        F2       SECOND NUMBER ENTERED (RETURNED TO CALLING PROGRAM)
C        N        NLOOP (USED IN BATCH)
C        NCUR     ILOOP (USED IN BATCH)
C        PROMPT   SOLICITATION MESSAGE
C        IRTFLG   ERROR RETURN FLAG
C
C CALLED BY:    CNINT      CNINT3
C
C NOTE: DOES NOT ALTER RECEIVED VALUES FOR F1 OR F2 (UNLIKE SPIDER)
C
C--*******************************************************************

      SUBROUTINE    RDPRM2S(F1,F2,NLOOPD,ILOOPD,PROMPT,IRTFLG)

      INCLUDE        'CMBLOCK.INC'
CNO_SAVE

      CHARACTER *(*) PROMPT
      CHARACTER *80  ANSW
      PARAMETER      (MAXB = 80)
      DIMENSION      BUF(MAXB)
      LOGICAL        EXPRESSQ

      SAVE           BUF

      NOFF = 1

1400  CALL RDPR(PROMPT,NCHAR,ANSW,.TRUE.,.TRUE.,IRTFLG)

      IF (ANSW(1:1) .EQ. '^' .OR. ANSW(2:2) .EQ. '^') THEN
C        RETURN FLAG FOR GOING BACK TO PREVIOUS QUESTION
         IRTFLG = -1
         RETURN

      ELSEIF (NCHAR .LE. 0) THEN
C        NULL ANSWER RECEIVED, LEAVE BOTH INPUTS UNALTERED
         IRTFLG = 3
         GOTO 2000
      ENDIF
      IRTFLG = 0

      IF (.NOT. EXPRESSQ(ANSW,NCHAR,F1,F2)) THEN
C        NO REGISTERS IN INPUT
         CALL CHKSTRQ(ANSW,NCHAR,'R',IBUF,BUF(NOFF),INUM,IER)
         IF((INUM .EQ. 1 .AND. NOFF .EQ. 1).OR. ANSW(1:1).EQ. '(') THEN
            F1 = BUF(1)
            IF (INUM .NE. 1) F2 = BUF(2)
         ELSE
            NOFF  = NOFF + INUM
            IF (NOFF-1 .LT. NLOOPD*2) GOTO 1400

C           ERROR OUTPUT ADDED 11/30/94 al
            IF ((2*ILOOPD) .GT. MAXB) THEN
               CALL ERRT(101,'PGM ERROR: 2ILOOPD > MAXB IN RDPRM2S',NE)
            ENDIF
            F1 = BUF(2*ILOOPD-1)
            F2 = BUF(2*ILOOPD)
         ENDIF
      ENDIF
 
 2000 IF (NECHO .NE .0) WRITE(NECHO,2050) F1,F2
      IF (NPROC .NE. 0) WRITE(NPROC,2050) F1,F2
 2050 FORMAT(5X,2(1X,G14.3))

      RETURN
      END

