
C++*************************************************************************
C
C    RDPRMC.FOR -- CREATED 8/15/89 al FROM RDPRMB.FOR
C
C **************************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK            *
C *  COPYRIGHT (C)1981,1987, WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH 			   *
C **************************************************************************
C
C  RDPRMC(ANS,NCHAR,STRIP,PROMPT,CDUM,IRTFLG)
C
C  PURPOSE: READ AN ALPHANUMERIC STRING, CHECK FOR ANY SPECIAL OPERATION,
C           RETURN STRING MINUS ANY LEADING OR TRAILING BLANKS, AND NUMBER
C           OF CHARACTERS IN STRING AND A ERROR FLAG.  NORMALLY CONVERTS
C           INPUT TO UPPER CASE.
C
C  PARAMETERS:  ANS       ANSWER
C               NCHAR     NUMBER OF CHARACTERS IN THE ANSWER
C               STRIP     LOGICAL FLAG TO STRIP BLANKS FROM ANS
C               PROMPT    SOLICITATION MESSAGE
C               CDUM      (UNUSED)
C               IRTFLG    RETURN FLAG (0 IS NORMAL, -1 IS GOTO PREVIOUS
C                              QUESTION, 1 IS END-OF_FILE ON INPUT
C                              -999 DOES NOT CONVERT INPUT TO UPPERCASE
C
C  CALLED BY:   MANY SPIDER ROUTINES
C
C  CALLS:       MENULU  
C
C--*******************************************************************

        SUBROUTINE RDPRMC(ANS,NCHAR,STRIP,PROMPT,CDUM,IRTFLG)

CNO_SAVE
	INCLUDE 'CMBLOCK.INC' 

        CHARACTER *(*) ANS,PROMPT,CDUM
        CHARACTER * 81 ANST
        CHARACTER * 75 QUOTE
        LOGICAL        UPPER,STRIP,SAYIT

C       SEE IF WANT TO KEEP LOWER CASE INPUT UNALTERED
        UPPER = (IRTFLG .NE. -999)

C       MOVE BLANKS TO THE ANSWER STRING, NECESSARY FOR SOME SPIDER CODE
        LENA = LEN(ANS)
        ANS(1:LENA) = ' '
    
C       PRINT PROMPT, READ ANSWER STRING, SKIP COMMENTS
        SAYIT = .NOT. SILENT
        CALL RDPR(PROMPT,NCHAR,ANST,UPPER,SAYIT,IRTFLG)
        IF (IRTFLG .NE. 0) RETURN

C       IF NULL ANSWER STRING, RETURN ZERO LENGTH ANSWER
        IF (NCHAR .LE. 0) RETURN

        IF (STRIP) THEN
C         REMOVE LEADING AND TRAILING BLANKS AND NULLS
          I2 = lnblnk(ANST(1:NCHAR))
          IF (I2 .LE. 0) THEN
C            ANSWER IS ALL BLANKS, TREAT AS A NULL ANSWER
             NCHAR = 0
             RETURN
          ENDIF

          DO  I1 = 1,I2
             IF (ANST(I1:I1) .NE. ' ') GOTO 60
          ENDDO

   60     CONTINUE
C         I1 IS STARTING CHAR NO. OF NONBLANK ANSWER, I2 IS ENDING CHAR NO.
          NCHAR  = I2 - I1 + 1

C         SET RETURNED ANSWER, TRUNCATE TO FIT LENGTH OF ANS IN CALL
          IF (NCHAR .GT. LENA) NCHAR = LENA
          ANS(1:NCHAR) = ANST(I1:I2)

        ELSE
C         DO NOT REMOVE LEADING AND TRAILING BLANKS
          IF (NCHAR .GT. LENA) NCHAR = LENA
          ANS(1:NCHAR) = ANST(1:NCHAR)
        ENDIF

	IF (NTRACE .GE. 0 .OR. PROMPT(1:2) .NE. 'OP') THEN
C          TRACE TURNED OFF, JUST ECHO THE ANSWERS 
           IF (.NOT. SILENT) WRITE(NECHO,91) ANS(1:NCHAR)
 91   	   FORMAT(5X,A)

        ELSE
C          TRACE TURNED ON, ECHO THE ANSWER AND MENU QUOTE
C          LOOKS FOR UPPER CASE VERSION OF ANS TO MATCH .MAN FILENAME
           CALL MENULU(ANS,2,QUOTE,NQUOT)
           IF (NQUOT .GT. 0) THEN
              NQUOT = MIN(NQUOT,50)
              WRITE(NECHO,94) ANS(1:NCHAR), QUOTE(1:NQUOT)
 94           FORMAT(5X,A,' --  ',A)
           ELSE
              WRITE(NECHO,91) ANS(1:NCHAR)
           ENDIF
        ENDIF

C       IF A LOG FILE EXISTS WRITE THE ANSWER STRING THERE
	IF (NPROC .NE. 0) WRITE(NPROC,93) ANS(1:NCHAR)
93      FORMAT(A)

        IF (ANS(1:1) .EQ. '^' .AND. NCHAR .EQ. 1) IRTFLG = -1

        RETURN
	END

