C**************************************************************************
C $$ READPDB.FOR
C **************************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK            *
C *  COPYRIGHT (C)1981,1987, WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH 			   *
C **************************************************************************
C*******************************************
C*
C*
C* READ PDB FILE, GET COORDINATES,
C* GENERATE A 3-D SPIDER FORMAT VOLUME
C*
C********************************************
	SUBROUTINE READPDB(MAXMEM)
	
        INCLUDE 'CMBLOCK.INC'  
	COMMON ADUM(2048),KAF(1) 
        DIMENSION BUF(1)
        POINTER   (IPQ,BUF) 
        LOGICAL   RUNTIME 
        CHARACTER *81 PDBFILE, SPIDERFILE,RECLIN,HEAD*10, NULL*1,ATOM*3
	LOGICAL EX,ZNUM
CNO_SAVE
C
	ZNUM=.FALSE.
	NATOM=0
	TMASS=0.0
   	NULL=CHAR(0)
        LUN1=8
	LUN2=10
	XMAX=-9999.9
	XMIN=9999.9
	YMAX=-9999.9
	YMIN=9999.9
	ZMAX=-9999.9
	ZMIN=9999.9
	
C5       WRITE(NOUT,6)
C6	FORMAT(' INPUT PDB FILE: ',$)
C        READ(NIN,10)PDBFILE
C10	FORMAT(A80)

C       READ IN FILE NAME TEMPLATE
5       IRTFLG=-999
	CALL RDPRMC(PDBFILE,NLET,.TRUE.,'INPUT PDB FILE:',NULL,IRTFLG)
        IF (IRTFLG .EQ. -1) RETURN
 
        INQUIRE(FILE=PDBFILE,EXIST=EX)
        IF(.NOT. EX) THEN
	   WRITE(NOUT,12)PDBFILE 
12	   FORMAT('FILE',A20,' NOT EXIT.')
     	   GOTO 5
	ENDIF
	OPEN(LUN1,FILE=PDBFILE,STATUS='OLD')
15	READ(LUN1,20) RECLIN
20	FORMAT(A80)


C*******GET MIN AND MAX OF X,Y,Z
C       AND CALCULATE OFFSET

35	IF(RECLIN(1:4) .EQ. 'ATOM') THEN
	   READ(RECLIN,50) HEAD,ATOM,X,Y,Z,OCCUPANCY,TEMPERATURE
	   IF(OCCUPANCY .GT. 1 ) ZNUM=.TRUE.
	   XMAX=AMAX1(XMAX,X)
	   XMIN=AMIN1(XMIN,X)
	   YMAX=AMAX1(YMAX,Y)
	   YMIN=AMIN1(YMIN,Y)
	   ZMAX=AMAX1(ZMAX,Z)
	   ZMIN=AMIN1(ZMIN,Z)
	   GOTO 15
	ELSEIF(RECLIN(1:3) .NE. 'END') THEN
	   GOTO 15
	ENDIF
C    SET CELL DIMENSION

	SX=(XMAX-XMIN)+3.0
	SY=(YMAX-YMIN)+3.0
	SZ=(ZMAX-ZMIN)+3.0
	WRITE(NOUT,*)'CELL SIZE ',SX,SY,SZ
C
	REWIND   LUN1
C
C*******INPUT SAMPLE SIZE
	CALL RDPRM(PIXEL,NLOOP,ILOOP,'PIXEL SIZE [A]')
	NX=NINT(SX/PIXEL)+1
	NY=NINT(SY/PIXEL)+1
	NZ=NINT(SZ/PIXEL)+1
        CALL  RDPRMI(NX,NY,NLOOP,ILOOP,' VOLUME NSAM, NROW')
        CALL  RDPRMI(NZ,I,NLOOP,ILOOP,' VOLUME NSLICE')
	MEMWANT=NX*NY*NZ

	
        CALL CHKMEM(MEMWANT, KAF, MAXMEM-(2048), 
     &	            RUNTIME,IPQ,IRTFLG)
	IF(IRTFLG.NE.0) THEN 
	   CLOSE(LUN1)
	   WRITE(NOUT,*)' VOLUME IS TOO LARGE, INCREASE PIXEL SIZE.'
	   RETURN
	ENDIF
	
	I=NX/2+1
	XOFFSET=PIXEL*I
	I=NY/2+1
	YOFFSET=PIXEL*I
	I=NZ/2+1
	ZOFFSET=PIXEL*I
	
C       CHECK IF THE VOLUME IS LARGE ENOUGH TO CONTAIN THE OBJECT

        IF(XMIN .LT. (-1.*XOFFSET) .OR. YMIN .LT. (-1.*YOFFSET)
     &         .OR. ZMIN .LT. (-1.*ZOFFSET)) THEN
            CLOSE(LUN1)
            WRITE(NOUT,*)' VOLUME IS TOO SMALL TO CONTAIN THE OBJECT.'
            RETURN
        ENDIF
 
        TMPX=FLOAT(NX-1)*PIXEL-XOFFSET
        TMPY=FLOAT(NY-1)*PIXEL-YOFFSET
        TMPZ=FLOAT(NZ-1)*PIXEL-ZOFFSET
        IF(XMAX .GT. TMPX .OR. YMAX .GT. TMPY
     &        .OR. ZMAX .GT. TMPZ) THEN
           CLOSE(LUN1)
           WRITE(NOUT,*)' VOLUME IS TOO SMALL TO CONTAIN THE OBJECT.'
           RETURN
        ENDIF


	DO I=1,NX*NY*NZ
	   BUF(I)=0.0
	ENDDO

	CALL FILERD(SPIDERFILE,NLET,NULL,'SPIDER OUTPUT',IRTFLG)
        IFORM=3
	CALL OPENFB(ADUM,SPIDERFILE,LUN2,NX,NY,'UNKNOWN',NF,NZ)
	IF(NF .EQ. 1) RETURN
	
C*******READ IN ATOMS

40	CONTINUE
	READ(LUN1,20)RECLIN
	IF(RECLIN(1:4) .EQ. 'ATOM' ) THEN
 	   READ(RECLIN,50)HEAD,ATOM,X,Y,Z,OCCUPANCY,TEMPERATURE
50	   FORMAT(A6,5X,1X,A3,2X,3X,1X,1X,4X,1X,3X,3F8.3,2F6.2)	
C	   WRITE(NOUT,*)'ATOM #',NATOM,'  ',ATOM,' AT ',X,Y,Z,
C    &                    OCCUPANCY,TEMPERATURE
	    IF(.NOT. ZNUM) THEN
		IF(ATOM(2:2) .EQ. 'H') THEN
		VATOM=1.0
		ELSEIF(ATOM(2:2) .EQ. 'C') THEN
		VATOM=6.0
		ELSEIF(ATOM(2:2) .EQ. 'N') THEN
		VATOM=7.0
		ELSEIF(ATOM(2:2) .EQ. 'O') THEN
		VATOM=8.0
	        ELSEIF(ATOM(2:2) .EQ. 'S') THEN
		VATOM=16.0
		ELSEIF(ATOM(2:2) .EQ. 'P') THEN
		VATOM=15.0
		ELSEIF(ATOM(2:2) .EQ. 'X' .AND. ATOM(1:3) .EQ. 'OXT') THEN
C******         TRNA THREE PRIME TERMINAL
		VATOM=8.0
		ELSE
		WRITE(NOUT, *) 'SPECIAL ATOM ENCOUNT AT'
	        WRITE(NOUT,*) RECLIN 
	        CLOSE(LUN1)
                CLOSE(LUN2)
        	RETURN
		ENDIF
C	    VATOM=VATOM*OCCUPANCY
	    ELSE 
	    VATOM=OCCUPANCY
	    ENDIF
/* COORDINATE SYSTEM IS DIFFERENT IN O AND SPIDER */
	     W=X
	     X=Y
	     Y=W
	     Z=-Z
C******* TRILINEAR INTERPOLATION
	     IX=IFIX((X+XOFFSET)/PIXEL)
	     AX=(X+XOFFSET)/PIXEL-FLOAT(IX)
	     IY=IFIX((Y+YOFFSET)/PIXEL)
	     AY=(Y+YOFFSET)/PIXEL-FLOAT(IY)
	     IZ=IFIX((Z+ZOFFSET)/PIXEL)
	     AZ=(Z+ZOFFSET)/PIXEL-FLOAT(IZ)	     
             BUF(((IZ-1)*NY+(IY-1))*NX+IX)=
     &            BUF(((IZ-1)*NY+(IY-1))*NX+IX)+
     &            VATOM*(1.-AX)*(1.-AY)*(1.-AZ)
             BUF(((IZ)*NY+(IY-1))*NX+IX)=
     &            BUF(((IZ)*NY+(IY-1))*NX+IX)+
     &            VATOM*(1.-AX)*(1.-AY)*(AZ)
             BUF(((IZ-1)*NY+(IY))*NX+IX)=
     &            BUF(((IZ-1)*NY+(IY))*NX+IX)+
     &            VATOM*(1.-AX)*(AY)*(1.-AZ)
             BUF(((IZ)*NY+(IY))*NX+IX)=
     &            BUF(((IZ)*NY+(IY))*NX+IX)+
     &            VATOM*(1.-AX)*(AY)*(AZ)
             BUF(((IZ-1)*NY+(IY-1))*NX+IX+1)=
     &            BUF(((IZ-1)*NY+(IY-1))*NX+
     &            IX+1)+VATOM*AX*(1.-AY)*(1.-AZ)
             BUF(((IZ)*NY+(IY-1))*NX+IX+1)=
     &            BUF(((IZ)*NY+(IY-1))*NX+IX+1)+
     &            VATOM*(AX)*(1.-AY)*(AZ)
             BUF(((IZ-1)*NY+(IY))*NX+IX+1)=
     &            BUF(((IZ-1)*NY+(IY))*NX+IX+1)+
     &            VATOM*(AX)*(AY)*(1.-AZ)
             BUF(((IZ)*NY+(IY))*NX+IX+1)=
     &            BUF(((IZ)*NY+(IY))*NX+IX+1)+
     &            VATOM*(AX)*(AY)*(AZ)
 
             NATOM=NATOM+1
	     TMASS=TMASS+VATOM
	     GOTO 40
	  ELSEIF(RECLIN(1:3) .NE. 'END') THEN
	     GOTO 40
	  ELSE
	  DO   I=1,NZ
	     DO   J=1,NY
 	       CALL WRTLIN(LUN2,BUF(1+(I-1)*NY*NX+(J-1)*NX),NX,(I-1)*NY+J)
	     ENDDO
	  ENDDO
	  CLOSE(LUN1)
          CALL SETPRM(LUN2,NX,NY,0,0,0,'R3')
          CLOSE(LUN2)
	  WRITE(NOUT,8701)  NATOM,TMASS
8701	  FORMAT(2X,'NUMBER OF ATOMS PLACED =',I8,'  TOTAL MASS =',1PE10.3)
	ENDIF 
	
        IF (RUNTIME) CALL ALLOCIT(0,RUNTIME,IPQ,'CP PDB',IRTFLG) 
	END
