
C++************************************************************************
C
C READPQ.FOR      
C                   ADAPTED FROM READP.FOR FOR CHAR. AUG 89 al
C
C **************************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK            *
C *  COPYRIGHT (C)1981,1987, WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH 			   *
C **************************************************************************
C
C    READPQ(STRING)
C
C    PURPOSE:          PARSES REGISTER LIST FROM OPERATION LINE.  PLACES
C                      REGISTER NUMBERS (UP TO 10 NUMBERS) IN NSEL
C
C    PARAMETERS:       STRING    OPERATION STRING
C
C--*******************************************************************

      SUBROUTINE READPQ(STRING)

      COMMON /PARAM/PARAM(103),NSEL(10)
      COMMON /IPRTT/IPRTT,NTRACE,NALPH

      CHARACTER *(*) STRING
      CHARACTER *77  STRING1

      LOGICAL ISDIGI

C     NALPH CONTAINS TOTAL LENGTH OF OPERATION STRING.

C     ZERO THE REGISTER LIST IN NSEL
      DO  I = 1,10
         NSEL(I) = 0.0
      ENDDO

C     FIND END OF STRING
      IEND = NALPH

      DO I=NALPH,1,-1
        IF (STRING(I:I) .EQ. ';' .OR. STRING(I:I) .EQ. ']') THEN
          IEND = I-1
          GOTO 12
        ENDIF
      ENDDO

C     FIND START OF POSSIBLE REGISTERS IN STRING
12    DO I = 1,IEND
           IF ((STRING(I:I) .EQ. 'x' .OR. STRING(I:I) .EQ. 'X') .AND.
     &         ((I + 1) .LE. IEND .AND. ISDIGI(STRING(I+1:I+1))))  THEN
              GOTO 14
           ENDIF
      ENDDO
C     IF NO REGISTERS IN STRING RETURN
      RETURN

14    CALL SHRINKQ(STRING(I:IEND),IEND-I+1,STRING1,NSTRING)
      CALL SSUPCAS(STRING1(1:NSTRING))
      CALL CHKSTRQ(STRING1(1:NSTRING),NSTRING,'I',NSEL,DUM,INUM,IER)

      RETURN
      END
