         SUBROUTINE RECDUM(NIMA,NPIX,NF,NV,NFAC,SUMP,
     &             FMAX,FMIN,PIA,SIG,IDIFF, RIM,CP,CI,D,WI,WP)
C
C
C   RECONSTITUTES DUMMY IMAGES USING USER-SUPPLIED COORDINATES
C
C   NIMA  		NUMBER OF ACTIVE IMAGES
C   NPIX   		NUMBER OF ACTIVE PIXELS
C   NFAC    		NUMBER OF FACTORS USED IN THE ANALYSIS
C   SUMP     		TOTAL WEIGHT
C   FMAX, FMIN 		MAXIMUM, MINIMUM OF RECONSTITUTED IMAGE
C   PIA			AVERAGE OF RECONSTITUTED IMAGE (SUPPLIED)
C   SIG			STANDARD DEVIATION OF RECONSTITUTED IMAGE
C   IDIFF    		FLAG INDICATING THE TYPE OF IMAGE
C 	=1    		COMPUTE DIFFERENTIAL IMAGE (0-FACTOR NOT ADDED)
C       =0		COMPUTE TOTAL IMAGE (0-FACTOR IMAGE ADDED)
C       =-1    		COMPUTE IMPORTANCE IOMAGE (AS DIFFERENTIAL BUT
C			NO WEIGHTING USED)
C   RIM(NPIX)		OUTPUT IMAGE
C   CP(NPIX,NFAC)	PIXEL COOS AS NEEDED BY SRIPE
C   CI(NFAC)		IMAGE COOS
C   D(NFAC)		EIGENVALUES AS NEEDED BY SRIPE
C   WP(NPIX)		PIXEL WEIGHTS
C   WI(NIMA)		IMAGE WEIGHTS (ACTIVE+INACTIVE)
C
         DIMENSION RIM(NPIX), CP(NPIX,NFAC), CI(NFAC), D(NFAC)
         DIMENSION WP(NPIX), WI(NIMA), NV(NF)
CNO_SAVE
         IF (IDIFF .GE. 0) THEN
           WIAVG = 0.0
           DO  J = 1, NIMA
             WIAVG = WIAVG + WI(J)
           END DO
           WIAVG = WIAVG / FLOAT(NIMA)
         END IF

         FMIN = 10000
         FMAX = -FMIN
         PIA = 0
         DELTA = 1. - FLOAT(IDIFF)

         DO I = 1, NPIX
           RIM(I) = 0.0
           DO L = 1, NF
             K = NV(L)
             RIM(I) = RIM(I) + CP(I,K) * CI(K) / SQRT(D(K))
           END DO
           IF (IDIFF .GE. 0) THEN
             RIM(I) = WP(I) * WIAVG * (DELTA + RIM(I)) * SUMP
           END IF

           IF (RIM(I) .GT .FMAX) FMAX = RIM(I)
           IF (RIM(I) .LT .FMIN) FMIN = RIM(I)
           PIA = PIA + RIM(I)
         END DO
         PIA = PIA / FLOAT(NPIX)

         RETURN
         END
