
C++*********************************************************************
C
C REDHED  --                                       NEW AUGUST 1996 al
C
C **********************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK        *
C *  COPYRIGHT (C)1981,1987, WADSWORTH CENTER FOR LABORATORIES AND     *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.  *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS *
C *    OR USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN        *
C *    APPROVAL OF THE CENTER FOR LABORATORIES AND RESEARCH            *
C **********************************************************************
C
C    REDHED(LUN,BUF,NBUFSIZ,NSAM,IRTFLG) 
C
C    PURPOSE: READ IN HEADER RECORDS FOR A SPIDER FILE      
C
C    PARAMETERS:  LUN      UNIT NUMBER             (SENT)
C                 BUF      BUFFER                  (SENT & RETURNED)
C                 NBUFSIZ  BUFFER SIZE             (SENT)
C                 NSAM     ROW LENGTH              (SENT)
C                 NOSTOP   NO ERRT CALL IF == 1    (SENT)
C                 IRTFLG   ERROR FLAG (O = OK)     (RETURNED)    
C
C23456789 123456789 123456789 123456789 123456789 123456789 123456789 12
C--*********************************************************************

	SUBROUTINE REDHED(LUN,BUF,NBUFSIZ,NSAM,NOSTOP,IRTFLG)

        INCLUDE 'CMBLOCK.INC'
CNO_SAVE

        COMMON /LUNARA/ LUNARA(100),LUNSTK(100)

        REAL            BUF(NSAM)
        COMMON /IOERR/  IERR

C       SET ERROR RETURN
        IRTFLG = 1

C       THE NUMBER OF HEADER RECORDS IS IN LUNARA
        LABREC = LUNARA(LUN)

        IF (LABREC .LE. 0) THEN
C         CALCULATE DEFAUT LABEL RECORD LENGTH
          LENBYT = NSAM * 4
          LABREC = 1024 / LENBYT
          IF (MOD(1024,LENBYT) .NE. 0) LABREC = LABREC + 1
        ENDIF

        IF ((LABREC * NSAM) .GT. NBUFSIZ) THEN
C          BUFFER OVERRUN
           CALL ERRT(6,'REDHED',NE)
           GOTO 999
        ENDIF

C       SET NO OFFSET FOR HEADER IN LUNARA
 	LUNARA(LUN) = 0

C       READ IN HEADER RECORDS
        IERR = 0
        ILOC = 1
        DO I = 1,LABREC
           CALL REDLIN(LUN,BUF(ILOC),NSAM,I)
           IF (IERR .NE. 0) THEN
               IF (NOSTOP .NE. 1)
     &            WRITE(NOUT,*) '*** I/O ERROR: ',IERR,
     &                          ' WHILE READING FILE HEADER'
               IF (NOSTOP .NE. 1) CALL ERRT(100,'REDHED',NE)
               GOTO 999
            ENDIF
            ILOC = ILOC + NSAM
        ENDDO

        IRTFLG = 0

C       REPLACE HEADER OFFSET IN LUNARA	    
999     LUNARA(LUN) = LABREC

        RETURN
        END
