
C	PROGRAM TO DESIGN THE REMEZ FILTER
C
        SUBROUTINE REMEZP(MAXDIM)
        INCLUDE 'CMBLOCK.INC'
        COMMON A(80),BUF(1024),ROT(29,29,29),BQ(1)
        DIMENSION    Q(1)
        POINTER      (IPQ,Q) 
        LOGICAL	RUNTIME
C  CHANGES IN COMMON LENGTH SHOULD BE CONSULTED WITH
C  SUBROUTINES CONTAINING ARRAY ROT:
C    ROT_P, ROT3_P, INF_P, INF3_P, INFD3_P, OPSF_P, OPSF3_P
C
	DOUBLE PRECISION  ROT
	DIMENSION         H(66)
	CHARACTER*81      FILNAM
	CHARACTER*1       NULL,WHAT

	DATA  NFREQ/128/,IDIM/33/,LUN/9/
CNO_SAVE
        NULL=CHAR(0)

C  LENRO - MEMORY RESERVED IN COMMON BY ROT AND OTHERS
	LENRO=80+1024+2*29**3 
111     CALL RDPRMI(NFILT,IDUM,NLOOP,ILOOP,
     &	'IMPULSE RESPONSE LENGTH')
	NFILT=2*(NFILT/2)+1
	NFCNS=NFILT/2+1
	IF(NFCNS.GT.29)  GOTO 111
	CALL  RMZ_P(H,NFILT)
        CALL RDPRMC(WHAT,NCHAR,.TRUE.,
     &	'PLOT FREQUENCY RESPONSE (Y/N)',NULL,IRTFLG)

	IF (WHAT .EQ. 'Y')  THEN
      DO    J=1,NFREQ
        BUF(J)=0.0
      ENDDO
      BUF(1)=H(NFCNS)
      KK=NFCNS-1
      DO    J=KK,1,-1
      K=NFREQ-KK+J
      JJ=KK-J+2
      BUF(JJ)=H(J)
      BUF(K)=H(J)
      ENDDO
         NV=LOG2(NFREQ)
         CALL  FFTR_Q(BUF,NV)
C 50 SCALING FACTOR FOR PICTURE
      DELF=50
      NF2=NFREQ/2+1
      W=BUF(2)
      K=1
      DO    J=3,NFREQ,2
      K=K+1
      BUF(K)=BUF(J)
      ENDDO
      BUF(NF2)=W
	LR=NFREQ/((IDIM-1)*2)
	IF(LR.GT.1)  THEN
	K=1
	DO    J=2,NF2-1,LR
	K=K+1
	Z=0.0
	DO    M=1,LR
 	  Z=Z+BUF(J+M-1)
	ENDDO
 	BUF(K)=Z/FLOAT(LR)
	ENDDO
	BUF(IDIM)=BUF(NF2)
	ENDIF
	DO    J=1,IDIM
          BUF(J)=BUF(J)*DELF
	ENDDO
	BMA=BUF(1)
	BMI=BMA
	DO    J=2,IDIM
	BMA=AMAX1(BMA,BUF(J))
	BMI=AMIN1(BMI,BUF(J))
	ENDDO
	T=(BMA-BMI)/50.0
	DO    J=1,IDIM
	  BUF(J)=(BUF(J)-BMI)/T
	ENDDO
         WRITE(NOUT,606)
 606      FORMAT(//15X,'***** FREQUENCY RESPONSE *****')
        CALL MRKUR3(BUF,IDIM,0.,0,60)
        ENDIF
 222    CALL RDPRMC(WHAT,NCHAR,.TRUE.,
     &	'DO YOU LIKE YOUR FILTER (Y/N)',NULL,IRTFLG)
	IF (WHAT .EQ. 'Y')  THEN
	CALL  FILERD(FILNAM,NLET,NULL,'FILTER',IRTFLG)
	IF(IRTFLG.EQ.-1)  RETURN
333	WRITE(NOUT,788)
788	FORMAT(' DIMENSIONS OF RESULTING FILTER IN FOURIER SPACE'/
     &	' IF 0 THEN POINT SPREAD FUNCTION IS STORED'/
     &  ' TO BE USED FOR REAL SPACE FILTRATION WITH RC COMMAND') 
	CALL  RDPRMI(NSAM,NROW,NLOOP,ILOOP,
     &	  '(NSAM,NROW)')
	IF(NSAM.EQ.0)  THEN
789	CALL  RDPRMI(IPSF,NDUM,NLOOP,ILOOP,
     &		'PRODUCE 2-D OR 3-D PSF? (2/3)')
	IF(IPSF.NE.2.AND.IPSF.NE.3)  GOTO  789
C PSF TO BE USED IN RC
	IF(IPSF.EQ.3)  THEN
	IFORM=3
	NFIL3=NFILT
	ELSE
	IFORM=1
	NFIL3=1
	ENDIF
	CALL  OPENF(FILNAM,LUN,NFILT,NFILT,'UNKNOWN',IRTFLG,NFIL3)
	IF(IRTFLG.EQ.-1)  THEN
	CALL  ERRT(4,'REMEZ ',NE)
	RETURN
	ENDIF
	IF(IPSF.EQ.2)  THEN
	CALL  ROT_P(H,NFCNS,ROT)
	CALL  OPSF_P(LUN,ROT,NFCNS,BQ,NFILT)
	ELSE
	CALL  ROT3_P(H,NFCNS,ROT)
	CALL  OPSF3_P(LUN,ROT,NFCNS,BQ,NFILT)
	ENDIF
	CLOSE(LUN)
	RETURN
	ENDIF	
	CALL  RDPRMI(NSLICE,NDUM,NLOOP,ILOOP,
     &	  'NUMBER OF SLICES (IF 0 THEN 2-D FILTER), (NSLICE)')
	NSLICE=MAX0(NSLICE,1)
C
	IF(MOD(NSAM,2).EQ.0)  THEN
	 IF(NSLICE.EQ.1)  THEN
	 IFORM=-12
	 ELSE
	 IFORM=-22
	 ENDIF
	ELSE
	 IF(NSLICE.EQ.1)  THEN
	 IFORM=-11
	 ELSE
	 IFORM=-21
	 ENDIF
	ENDIF
	LRCL=NSAM+2-MOD(NSAM,2)
C
	MEMWANT=LRCL*NROW*NSLICE
	CALL CHKMEM(MEMWANT,BQ,MAXDIM-LENRO,RUNTIME,IPQ,IRTFLG)
	IF(IRTFLG.NE.0)  THEN
		CALL  ERRT(6,'REMEZ ',NE)
		GOTO  333
	ENDIF
	CALL  OPENF(FILNAM,LUN,LRCL,NROW,'UNKNOWN',IRTFLG,NSLICE)
	IF(IRTFLG.EQ.-1)  THEN
	CALL  ERRT(4,'REMEZ ',NE)
	ELSE
	  INV=+1
	  IF(NSLICE.EQ.1)  THEN
	    CALL  ROT_P(H,NFCNS,ROT)
	    CALL  INF_Q(Q,LRCL,NSAM,NROW,ROT,NFCNS)
	    CALL  FMRS_2(Q,NSAM,NROW,INV)
	  ELSE
	    CALL  ROT3_P(H,NFCNS,ROT)
            CALL  INF3_P(Q,LRCL,NSAM,NROW,NSLICE,ROT,NFCNS)
	    CALL  FMRS_3(Q,NSAM,NROW,NSLICE,INV)
	  ENDIF
		DO    K=1,NROW*NSLICE
		  CALL WRTLIN(LUN,Q(1+(K-1)*LRCL),LRCL,K)
		ENDDO
	   CLOSE(LUN)  
	   RETURN
	 ENDIF
	ELSEIF (WHAT .EQ. 'N') THEN
	GOTO  111
	ELSE
	WRITE(NOUT,*)  'YOU BETTER MAKE UP YOUR MIND'
	GOTO  222
        ENDIF
        END
