c***********************************************************
C       reconstruction from a focus series with CTF correction
c
C  Reprojections 3D, Richardson's method, 
c  reconstruction kept in the square to introduce other constraints.
c  Average outside the window is subtracted
c  min, max relate to the projections
C  Symmetries imposed ...
c                             Interpolation changed !
c  corrections applied on the volume side.
C                                                     04/22/97
c************************************************************
	SUBROUTINE REPC(MAXMEM)
C
c        SUBROUTINE RDPRJ(FINCTF,FINPAT,FINANG,
c        SUBROUTINE  GETCTF(LUNI,BCTF,CTF,LSAM,N,WORK)
c        SUBROUTINE  REPR32_Q
c        SUBROUTINE  SUBSP(BCKE,NMAT,IPCUBE,NN)
c	SUBROUTINE  REDPRQ
c	SUBROUTINE  RPRQ(N,B,CUBE,IPCUBE,NN,PHI,THETA,PSI,DM,RI)
c	SUBROUTINE  PREPCUB_S(N,NN,IPCUBE,RI)
c	SUBROUTINE  BCKCQ(CUBE,LTC,DM,B,N,IPCUBE,NN)
c	SUBROUTINE  PRJCQ(CUBE,LTC,DM,B,N,IPCUBE,NN)
c	SUBROUTINE  smt3_q(t,ala,X,y,NSAM,NROW,nslice,ipcube,nn)
c-	subroutine   domin3_s(sq,NMAT,ipcube,nn,tmin)
c-	subroutine   domax3_s(sq,NMAT,ipcube,nn,tmax)
c	subroutine  docors3_s(BCKE,bcn,n,NMAT,ipcube,nn,ala,ANGS)
c-	subroutine  bmax_c(BCKE,NMAT,ipcube,nn,bmax)
c-	subroutine  bmin_c(BCKE,NMAT,ipcube,nn,bmin)
c	subroutine  fmax_q(x,map,n,xmax)
c	subroutine  fmin_q(x,map,n,xmin)
c
	PARAMETER  (NSETMAX=10)
	PARAMETER  (LIPC=65000)
	PARAMETER  (NSYMM=60)
        INCLUDE  'CMBLOCK.INC'
	CHARACTER*80  FINCTF(NSETMAX),FINPAT(NSETMAX),FINANG(NSETMAX),
     &			FINSEL(NSETMAX)
	DIMENSION    NLETCTF(NSETMAX),NLETPAT(NSETMAX),NLETANG(NSETMAX)
	CHARACTER*80  PROMPT,FINPIC
	CHARACTER*1   NULL,ANS,DATEXTD(4)
	CHARACTER*3   CHD
	DIMENSION  NANG(NSETMAX)
	COMMON  DUMMY(80),BUF(1024),IPCUBE(5,LIPC),SYM(3,NSYMM),BAF(1)
	COMMON  /DIMREC/  IDIMREC
c----------------------------------------------------------
c	parameters used in RPRJQ
c----------------------------------------------------------
	COMMON /PAR/  LDP,NM,LDPNM
	DIMENSION WORK(1000)
C
	DIMENSION Q(1)
	POINTER   (IPQ,Q) 
	LOGICAL         RUNTIME 
C
	DATA  INPIC,INPROJ/10,12/
CNO_SAVE
	NULL=CHAR(0)
c This is 3D reconstruction
	IDIMREC=3
c------------------------------------------------
c	   numth: number of processors
c------------------------------------------------
#ifdef SP_MP
	NUMTH=mp_numthreads()
#else
	NUMTH=1
#endif
	IUNIT=NOUT
c--------------------------------------------
C  NUMD number of defocus sets
c--------------------------------------------
	CALL RDPRMI(NUMD,N,NLOOP,ILOOP,
     &   'NUMBER OF DEFOCUS SETS IN THE SERIES')
	IF(NUMD.GT.NSETMAX)  THEN
	CALL  ERRT(31,'BP CTF',NE)
	RETURN
	ENDIF
c------------------------------------------------
c          get the radius of reconstruction (RI)
c------------------------------------------------
	CALL  RDPRM(RI,NLOOP,ILOOP,'Radius of reconstructed object')
c--------------------------------------------------------
c          check the symetry
c----------------------------------------------------------
	CALL RDPRMC(ANS,NLETI,.TRUE.,
     $	'Does your volume have symmetries ?',NULL,IRT)
	IF(ANS.EQ.'Y')  then
	CALL  FILERD(FINPIC,NLETI,NULL,'Symmetries ang doc',IRTFLG)
	K=0
	K2=1
	NSYM=0
100	LERR=-1
        IF(NSYM.EQ.NSYMM)  THEN
            WRITE(NOUT,*) '  Too many images, list truncated'
            GOTO  679
        ENDIF
	KP1=K+1
	CALL  UNSAV(FINPIC,K,INPIC,KP1,SYM(1,NSYM+1),3,LERR,K2)
	IF(LERR.EQ.0)  THEN
	NSYM=NSYM+1
	K=K+1
	GOTO  100
	ENDIF
679	CLOSE(INPIC)
	WRITE(NOUT,200) NSYM
200	FORMAT(/,'  Number of symmetries =',I5,/)
	ELSE
	NSYM=0
	ENDIF
c--------------------------------------------
c read information of the series
c--------------------------------------------
c--------------------------------------------
c 	loop for the data set
c---------------------------------------------
	NANGMAX=0
	DO    INUM=1,NUMD
	NULL=CHAR(0)
	WRITE(CHD,201)  INUM
201	FORMAT(I3)
	PROMPT='Enter template for 2-D image (#'//CHD//' series)'
c-------------------------------------------
c 	get the file pattern for image files
c------------------------------------------- 
	CALL  FILERD(FINPAT(INUM),NLETPAT(INUM),NULL,PROMPT,IRTFLG)
c-------------------------------------------
c 	get the name of the selection document file
c-------------------------------------------
 	CALL  FILERD(FINSEL(INUM),NLET1,NULL,'Selection doc',IRTFLG)
        K=0
        K2=1
        NANG(INUM)=0
778     LERR=-1
c        IF(NANG(INUM).EQ.NILMAX)  THEN
c            WRITE(NOUT,*) '  Too many images, list truncated'
c            GOTO  779
c        ENDIF
        KP1=K+1
        CALL  UNSAV(FINSEL(INUM),K,INPIC,KP1,BUF,1,LERR,K2)
	IF(K.EQ.0)  FINSEL(INUM)=FINSEL(INUM)(1:NLET1)//CHAR(0)
        IF(LERR.EQ.0)  THEN
           NANG(INUM)=NANG(INUM)+1
           ILIST=BUF(1)
           K=K+1
           GOTO  778
        ENDIF
779     CLOSE(INPIC)
        WRITE(NOUT,2001) INUM,NANG(INUM)
2001    FORMAT('Series ',I2,'  Number of images =',I5)
	NANGMAX=MAX0(NANGMAX,NANG(INUM))
C Get a name for angular doc file
 	CALL  FILERD(FINANG(INUM),NLETANG(INUM),NULL,'Angular doc',IRTFLG)
C Get a name for CTF file
	CALL  FILERD(FINCTF(INUM),NLETCTF(INUM),NULL,'CTF',IRTFLG)
c----------------------------------------------
c if this the first set, get the file dimension
c get the radius of reconstruction
c assign the memory
c----------------------------------------------
	IF(INUM.EQ.1)  THEN
        CALL  FILGET(FINPAT(1),FINPIC,NLETPAT(1),ILIST,INTFLG)
        CALL  OPENFB(BUF,FINPIC,INPIC,NSAM,NROW,'O',NF,NSL)
        	IF (NF .NE. 2)  THEN
           	CALL ERRT(4,'BP CTF ',NE)
           	RETURN
        	ENDIF
        	CLOSE(INPIC)
C--------------------------------------------
C  N - linear dimension of projections and restored cube
C---------------------------------------------
	N=NSAM
c-------------------------------------------------------------
c       end of section for the first set
c-------------------------------------------------------------
	ENDIF
	ENDDO
c----------------------------------------------
c       parameters used in RPRJQ
c----------------------------------------------
	M=N
	NMAT=N*N*N
	NM=(N-M)/2
	LDP=M/2+1
	LDPNM=LDP+NM
	CALL  PREPCUB_S(N,NN,IPCUBE,RI)
	IF(NN.GT.LIPC)  THEN
	CALL  ERRT(31,'BP CTF',NE)
	RETURN
	ENDIF
c------------------------------------------------
c          ASSIGN MEMORY SPACE
c--------------------------------------------------
	K_ANG=1
	K_PM=K_ANG+3*NANGMAX
	K_LB=K_PM+9*NANGMAX*NUMD
	K_PROJ=K_LB+NANGMAX*NUMD
C CTF volume has to be converted from old FT format to the new one.
C  it will overlap next memory allocation, so the next one (BCKI)
C  cannot be used in RDPRJ
	K_CTF=K_PROJ+N*N*NUMTH
	K_BCKI=K_CTF+NMAT*NUMD
	K_BCKW=K_BCKI+NMAT
	K_BCKT=K_BCKW+NMAT
	K_BCKC=K_BCKT+NMAT
	K_CB=K_BCKC+NMAT
	MEMTOT=K_CB+NMAT
	CALL CHKMEM(MEMTOT,BAF,(MAXMEM-(8*LIPC+3*NSYMM+1024+80)), 
     &              RUNTIME,IPQ,IRTFLG)
		IF(IRTFLG.NE.0) THEN
		CALL  ERRT(6,'BP CTF',NE)
		RETURN
		ENDIF
c-------------------------------------------------------------
c	    initialize the CB
c-------------------------------------------------------------
c$doacross local(i)
	DO  I=1,NMAT
	  Q(K_CB+I-1)=0.0               
	ENDDO
	DO    INUM=1,NUMD
	CALL  RDPRJ(FINCTF(INUM),FINPAT(INUM),FINANG(INUM),
     1	FINSEL(INUM),NLETCTF(INUM),NLETPAT(INUM),NLETANG(INUM),
     2	N,NANG(INUM),NMAT,
     2	Q(K_ANG),Q(K_LB+(INUM-1)*NANGMAX),
     3	Q(K_CB),Q(K_BCKW),Q(K_PROJ),
     3  IPCUBE,NN,Q(K_PM+(INUM-1)*9*NANGMAX),RI,
     4  Q(K_CTF+(INUM-1)*NMAT),WORK)
	WRITE(NOUT,2027)  NANG(INUM)
	ENDDO
2027    FORMAT(5X,'Effective number of angles =',i6)
c-------------------------------------------------------------
c	inverse FT of CB
c-------------------------------------------------------------
	INV=-1
	CALL  F3MR(Q(K_CB),N,N,N,INV,WORK)
c-------------------------------------------------------------
c	Richardson's reconstruction program
c-------------------------------------------------------------
	NSYMT=MAX0(1,NSYM)
	CALL  REPR32_Q(Q(K_CB),Q(K_BCKW),Q(K_BCKC),Q(K_BCKT),
     1          Q(K_BCKI),Q(K_CTF),N,IPCUBE,NN,Q(K_PROJ),Q(K_LB),
     2          Q(K_PM),NANG,RI,
     3          SYM,NSYMT,NSYM,NUMTH,INPIC,
     4	        NANGMAX,NUMD,WORK)
	IF(RUNTIME)  CALL ALLOCIT(0,RUNTIME,IPQ,'BP CTF',IRTFLG)
	END
