c
c***************************************************************
c
c Richardson's reconstruction program
c
c****************************************************************
        SUBROUTINE  REPR32_Q
     1		(CB,BCKW,BCKC,BCKT,BCKI,
     2		CTF,N,IPCUBE,NN,PROJ,LB,
     3		PM,NANG,RI,
     4          SYM,NSYMT,NSYM,NUMTH,INPIC,
     5          NANGMAX,NUMD,WORK)
C NUMTH - numthreds for mp
        INCLUDE   'CMBLOCK.INC'
        DIMENSION   CB(N,N,N),BCKC(N,N,N),BCKW(N,N,N)
	DIMENSION   BCKT(N,N,N),BCKI(N,N,N),CTF(N,N,N,NUMD)
        DIMENSION   PROJ(N*N,NUMTH),NANG(NUMD),LB(NANGMAX,NUMD)
        DIMENSION   SYM(3,NSYMT),PM(9,NANGMAX,NUMD)
        DIMENSION   IPCUBE(5,NN)
        COMMON /PAR/  LDP,NM,LDPNM
        DIMENSION   WORK(1000)
C
        CHARACTER*1  NULL
        CHARACTER*80 FINPIC
C
CNO_SAVE
c
        NULL=CHAR(0)
c-------------------------------------------------------------
c	open a file for reconstructed volume
c-------------------------------------------------------------
	CALL  FILERD(FINPIC,NLETI,NULL,'Reconstructed 3-D',IrtFLG)
	IF(IRTFLG.EQ.-1)  return
	IFORM=3
 	CALL  OPENF(FINPIC,INPIC,N,N,'U',NF,N)
	IF(NF.NE.2)   return
c---------------------------------------------------------------
c	read parameters for iteration
c---------------------------------------------------------------
	CALL  RDPRM2(ALA,AIM,NLOOP,ILOOP,
     &   'Lambda, Correction limit')
	CALL  RDPRMI(MAXIT,MODE,NLOOP,ILOOP,
     &   'Iteration limit, Mode')
	CALL  RDPRM2(TMIN,TMAX,NLOOP,ILOOP,
     &   'Minimum, maximum')
        CALL  RDPRM(t,NLOOP,ILOOP,'Smoothing const (0.0-0.999)')
c---------------------------------------------------------------
c      change it to (zero,infinity) range
c---------------------------------------------------------------
        t=t/(1.0-t)
        NMAT=n*n*n
c------------------------------------------------------
c	initialize current and intermediate volume s
c------------------------------------------------------
c$doacross local(k,j,i)
        do    k=1,n
        do    j=1,n
        do    i=1,n
	BCKI(i,j,k)=0.0
	BCKC(i,j,k)=0.0
	enddo
	enddo
	enddo
c------------------------------------------------------
c	sqold:square of error, initialize it
c------------------------------------------------------
        sqold=1.e23
c------------------------------------------------------
c       start of iteration
c------------------------------------------------------
        ITER = 1
        WRITE(NOUT,30) ITER
        GOTO  900
999     ITER = ITER + 1
        WRITE(NOUT,30) ITER
30      FORMAT(/' ITERATION ',I5)
c------------------------------------------------------
c	Fourier Transform of current volume
c------------------------------------------------------
	INV=+1
	CALL  F3MR(BCKC,N,N,N,INV,WORK)
c------------------------------------------------------
c	initialize the intermediate volume
c------------------------------------------------------
c$doacross local(k,j,i)
	do    k=1,n
	do    j=1,n
	do    i=1,n
	BCKI(i,j,k)=0.0
	enddo
	enddo
	enddo
c------------------------------------------------------
c	loop for all the sets
c------------------------------------------------------
	DO    INUM=1,NUMD
c------------------------------------------------------
c	   initialize the temporary volume
c------------------------------------------------------
c$doacross local(k,j,i)
           do    k=1,n
           do    j=1,n
           do    i=1,n
	   BCKT(i,j,k)=0.0
	   enddo
	   enddo
	   enddo
c------------------------------------------------------
c	   modify the current volume by CTF
c	   result in working volume
c------------------------------------------------------
c$doacross local(k,j,i)
           do    k=1,n
           do    j=1,n
           do    i=1,n
	   BCKW(i,j,k)=BCKC(i,j,k)*CTF(i,j,k,INUM)
	   enddo
	   enddo
	   enddo
c------------------------------------------------------
c	   calculate the inverse FT of working volume
c------------------------------------------------------
	   INV=-1
	   CALL  F3MR(BCKW,N,N,N,INV,WORK)
c------------------------------------------------------
c          subtruct average on the sphere 
c          from working volume
c------------------------------------------------------
	   CALL  SUBSP(BCKW,NMAT,IPCUBE,NN)
c------------------------------------------------------
c          loop for projection
c          project the working volume 
c------------------------------------------------------
           DO    k=1,NANG(INUM),NUMTH
c------------------------------------------------------
c	      L_EN: the end number
c	      L_NUM: number of multiple processes
c------------------------------------------------------
              l_en=min0(NANG(INUM),k+numth-1)
              l_num=min0(NUMTH,NANG(INUM)-k+1)
c------------------------------------------------------
c	      initialize the projection arrays
c------------------------------------------------------
c$doacross local(i,j)
              do    j=1,l_num
              do    i=1,n*n
                PROJ(i,j)=0.0
	      enddo
	      enddo
c------------------------------------------------------
c	      calculate the projections of working volume
c------------------------------------------------------
c$doacross local(l_th),mp_schedtype=simple
              DO   l_th=1,l_num
		CALL  PRJCQ(BCKW,NMAT,PM(1,k+l_th-1,INUM),
     &                       PROJ(1,l_th),N,IPCUBE,NN)
     	      ENDDO
c------------------------------------------------------
c             calculate back-projection
c             result in temporary volume
c	      here BCKCQ itself is mp  
c------------------------------------------------------
              DO    l_th=1,l_num
c multiply projections by their weights
		if(LB(k+l_th-1,INUM).gt.1)  then
c$doacross local(i)
		do  i=1,n*n
		PROJ(i,l_th)=PROJ(i,l_th)*LB(k+l_th-1,INUM)
		enddo
		endif
c backproject
		CALL  BCKCQ(BCKT,NMAT,PM(1,k+l_th-1,INUM),
     &                       PROJ(1,l_th),N,IPCUBE,NN)
     	      ENDDO
c------------------------------------------------------	   
c	   end loop for projection	
c------------------------------------------------------
	   ENDDO
c------------------------------------------------------
c	   subtract average on the sphere of the temporary
c	   volume
c------------------------------------------------------
	   CALL  SUBSP(BCKT,NMAT,IPCUBE,NN)
c------------------------------------------------------
c	   calculate the FT of temporary volume
c------------------------------------------------------
	   INV=+1
	   CALL  F3MR(BCKT,N,N,N,INV,WORK)
c------------------------------------------------------
c	   modify the temporary volume by CTF
c------------------------------------------------------
c$doacross local(k,j,i)
           do    k=1,n
           do    j=1,n
           do    i=1,n
	   BCKT(i,j,k)=BCKT(i,j,k)*CTF(i,j,k,INUM)
	   enddo
	   enddo
	   enddo
c------------------------------------------------------
c	   add the temperary volume to intermediate volume
c------------------------------------------------------
c$doacross local(k,j,i)
           do    k=1,n
           do    j=1,n
           do    i=1,n
	   BCKI(i,j,k)=BCKI(i,j,k)+BCKT(i,j,k)
	   enddo
	   enddo
	   enddo
c------------------------------------------------------
c	end loop on sets
c------------------------------------------------------
	enddo
c------------------------------------------------------
c	   calculate the inverse FT of the intermediate volume
c------------------------------------------------------
	   INV=-1
	   CALL  F3MR(BCKI,N,N,N,INV,WORK)
c------------------------------------------------------
c	subtract average on the sphere from the intermediate
c	volume
c------------------------------------------------------
        CALL  SUBSP(BCKI,NMAT,IPCUBE,NN)
c------------------------------------------------------
c	inverse FT of current volume
c------------------------------------------------------
	INV=-1
	CALL  F3MR(BCKC,N,N,N,INV,WORK)
900     continue
c---------------------------------------------------------
c	smooth the current volume 
c---------------------------------------------------------
        if(MODE.eq.1.or.MODE.eq.3.or.MODE.eq.6.or.MODE.eq.8) 
     &          CALL  SMT3_Q(t,ALA,BCKC,BCKC,N,N,N,IPCUBE,NN)
c---------------------------------------------------------
c	SQ: square of the error
c---------------------------------------------------------
	SQ=0.0
        if(NSYM.eq.0)  then
c---------------------------------------------------------
c       NO SYMMETRIES
c---------------------------------------------------------
c---------------------------------------------------------
c	calculate the error inside the sphere
c---------------------------------------------------------
c$doacross local(kn,i,j,k,qt),reduction(sq)
        do    kn=1,nn
                j=ipcube(4,kn)
                k=ipcube(5,kn)
        do    i=ipcube(3,kn),ipcube(3,kn)+ipcube(2,kn)-ipcube(1,kn)
           QT=CB(i,j,k)-BCKI(i,j,k)
           SQ=SQ+QT*QT
c---------------------------------------------------------
c	update the current volume
c---------------------------------------------------------
	BCKC(i,j,k)=BCKC(i,j,k)+ALA*QT
	enddo
	enddo
        else
c---------------------------------------------------------
c  SYMMETRIES
c---------------------------------------------------------
c$doacross local(kn,i,j,k,qt),reduction(sq)
           do    kn=1,nn
              j=ipcube(4,kn)
              k=ipcube(5,kn)
              do    i=ipcube(3,kn),ipcube(3,kn)+ipcube(2,kn)-
     &                 ipcube(1,kn)
		QT=CB(i,j,k)-BCKI(i,j,k)
		SQ=SQ+QT*QT
		BCKI(i,j,k)=QT
	      enddo
	   enddo
	do    i=1,NSYM
	  CALL  DOCORS3_S(BCKC,BCKI,N,NMAT,IPCUBE,NN,ALA,SYM(1,I))
	enddo
c---------------------------------------------------------
c       end of symmetry section
c---------------------------------------------------------
        ENDIF
c---------------------------------------------------------
c  	subtract the average on the sphere from current
c       volume
c---------------------------------------------------------
	CALL  SUBSP(BCKC,NMAT,IPCUBE,NN)
c---------------------------------------------------------
c	report the error	
c---------------------------------------------------------
        write(nout,*) '  Squared correction of the structure ',SQ
c
		if(MODE.eq.0)  goto  821
	if(ITER.gt.1)  then
	if(MODE.eq.2.or.MODE.eq.3.or.MODE.eq.7.or.MODE.eq.8)  
c enforce min constraints
     &		 CALL   DOMIN3_S(BCKC,NMAT,IPCUBE,NN,TMIN)
c
	if(MODE.eq.5.or.MODE.eq.6.or.MODE.eq.7.or.MODE.eq.8) 
c enforce max constraints
     &		CALL   DOMAX3_S(BCKC,NMAT,IPCUBE,NN,TMAX)
        endif
821		continue
c---------------------------------------------------------	
c	check the iteration condition
c---------------------------------------------------------
	if(SQ.gt.AIM .and. ITER.lt.MAXIT)  then
             if(SQ.le.SQOLD)  then
                  SQOLD=SQ
c---------------------------------------------------------
c	          goto next iteration
c---------------------------------------------------------
                  goto  999
             endif
        endif
c---------------------------------------------------------
c	write the volume
c---------------------------------------------------------
	DO  I=1,N
	DO  J=1,N
	  CALL  WRTLIN(INPIC,BCKC(1,J,I),N,J+(I-1)*N)
	ENDDO
	ENDDO
	CLOSE(INPIC)
	END 
