C++************************************************************************
C
C REPR3_Q.FOR
C
C **************************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK            *
C *  COPYRIGHT (C)1981,1987, WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *  THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR       *
C *  LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR    *
C *  USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF     *
C *  THE CENTER FOR LABORATORIES AND RESEARCH                              *
C **************************************************************************
C
C
C
C23456789012345678901234567890123456789012345678901234567890123456789012
C--************************************************************************

	SUBROUTINE  REPR3_Q
     &	(CB,BCKE,BCKN,N,IPCUBE,NN,PROJ,MASK,DM,LB,NANG,IRI,ABA,
     &		SYM,NSYMT,NSYM,NUMTH,INPIC)
C NUMTH - numthreds for mp; =numthreads() for ONYX, otherwise=1.
        INCLUDE 'CMBLOCK.INC' 
	DIMENSION   CB(N),BCKE(N,n,n),BCKN(N,n,n),PROJ(N*N,NUMTH)
	DIMENSION   SYM(3,NSYMT),dm(9,nang)
	DIMENSION  IPCUBE(5,NN),LB(NANG)
	LOGICAL*1 MASK(N,N)
	DOUBLE PRECISION  ABA
	COMMON /PAR/  LDP,NM,LDPNM
	CHARACTER*1  ANS,NULL
	LOGICAL*1    ACTIVE_MIN, ACTIVE_MAX
CNO_SAVE
	NULL=CHAR(0)
	CALL  RDPRM2(ALA,aim,NLOOP,ILOOP,
     &   'LAMBDA, CORRECTION LIMIT')
	CALL  RDPRMI(MAXIT,MODE,NLOOP,ILOOP,
     &   'ITERATION LIMIT, MODE')
	CALL  RDPRM2(TMIN,TMAX,NLOOP,ILOOP,
     &   'MINIMUM, MAXIMUM')
	TMIN=TMIN-ABA
	TMAX=TMAX-ABA
	WRITE(NOUT,2059) TMIN,TMAX
2059	FORMAT(' MINIMUM AND MAXIMUM AFTER AVERAGE SUBTRACTION',/,
     &	2(5X,1PE10.3))
	CALL  RDPRM(T,NLOOP,ILOOP,'SMOOTHING CONST (0.0-0.999)')
C CHANGE IT TO (ZERO,INFINITY) RANGE
	T=T/(1.0-T)
c
c  prepare the logical mask for min-max
c
	r=iri*iri
	nc=n/2+1
c$doacross local(j,i,qt,xx)
	do    j=1,n
	qt=j-nc
	xx=qt*qt
	do    i=1,n
	qt=i-nc
	if(xx+qt*qt.lt.r)    then
	mask(i,j)=.true.
	else
	mask(i,j)=.false.
	endif
	enddo
	enddo
c
	nmat=n*n*n
	ltb=n*n
c$doacross local(k,j,i)
	do    k=1,n
	do    j=1,n
	do    i=1,n
	bcke(i,j,k)=0.0
	bckn(i,j,k)=0.0
	enddo
	enddo
	enddo
C
		active_min=.false.
		active_max=.false.
		sqold=1.e23
                ITER = 1
                   WRITE(NOUT,971) ITER
		goto  941
999             ITER = ITER + 1
                   WRITE(NOUT,971) ITER
971                FORMAT(/' ITERATION ',I5)
c$doacross local(k,j,i)
	do    k=1,n
	do    j=1,n
	do    i=1,n
	bcke(i,j,k)=0.0
	enddo
	enddo
	enddo
c
c   bckn -> proj -> bcke
c
	sbq=0.0
	gmin=1.0e23
	gmax=-1.0e23
c loop over projections
	do    k=1,nang,numth
	l_en=min0(nang,k+numth-1)
	l_num=min0(numth,nang-k+1)
c$doacross local(i,j)
	do    j=1,l_num
	do    i=1,ltb
	  proj(i,j)=0.0
	enddo
	enddo
c$doacross local(l_th),mp_schedtype=simple
	do  l_th=1,l_num
	call  prjcq(bckn,nmat,dm(1,k+l_th-1),proj(1,l_th),n,ipcube,nn)
	enddo
c  
	do  l_th=1,l_num
	if((mode.eq.2.or.mode.eq.3.or.mode.eq.7.or.mode.eq.8)
     &	.and. .not.active_min)  call  fmin_q(proj(1,l_th),mask,ltb,gmin)
	if((mode.eq.5.or.mode.eq.6.or.mode.eq.7.or.mode.eq.8) 
     &	.and. .not.active_max)  call  fmax_q(proj(1,l_th),mask,ltb,gmax)
	enddo
c
c here bckcq itself is mp  
	do  l_th=1,l_num
c multiply projections by their weights
	if(lb(k+l_th-1).gt.1)  then
c$doacross local(i)
	do  i=1,n*n
	proj(i,l_th)=proj(i,l_th)*lb(k+l_th-1)
	enddo
	endif
c backproject
	call  bckcq(bcke,nmat,dm(1,k+l_th-1),proj(1,l_th),n,ipcube,nn)
	enddo
	enddo
941	continue
	if(mode.eq.1.or.mode.eq.3.or.mode.eq.6.or.mode.eq.8) 
     &		call   smt3_q(t,ala,bckn,bckn,n,n,n,ipcube,nn)
	sq=0.0
	if(NSYM.eq.0)  then
	do    kn=1,nn
		j=ipcube(4,kn)
		k=ipcube(5,kn)
		call  redlin(inpic,cb,n,(k-1)*n+j)
	do    i=ipcube(3,kn),ipcube(3,kn)+ipcube(2,kn)-ipcube(1,kn)
		qt=cb(i)-bcke(i,j,k)
		sq=sq+qt*qt
		bckn(i,j,k)=bckn(i,j,k)+ala*qt
	enddo
	enddo
c
c  Corrected structure in bckn
c
	else
	do    kn=1,nn
		j=ipcube(4,kn)
		k=ipcube(5,kn)
		call  redlin(inpic,cb,n,(k-1)*n+j)
	do    i=ipcube(3,kn),ipcube(3,kn)+ipcube(2,kn)-ipcube(1,kn)
		qt=cb(i)-bcke(i,j,k)
		sq=sq+qt*qt
		bcke(i,j,k)=qt
	enddo
	enddo
	do    i=1,NSYM
	  call  docors3_s(bckn,bcke,n,nmat,ipcube,nn,ala,SYM(1,I))
	enddo
	ENDIF
	write(nout,*) '  Squared correction of the structure ',sq
c
		if(mode.eq.0)  goto  821
	if(ITER.gt.1)  then
	if((mode.eq.2.or.mode.eq.3.or.mode.eq.7.or.mode.eq.8)
     &		.and. .not.active_min)  then
		write(nout,2061) gmin
2061		format(' Minimum in projections =',1pe10.3) 
			if(gmin.lt.tmin)  then
			call  bmin_c(bckn,nmat,ipcube,nn,bmin)
			write(nout,2051)  bmin
2051	format(' Min constraint activated, value in 3D =',1pe10.3)
			active_min=.true.
			endif
	endif
c
	if((mode.eq.5.or.mode.eq.6.or.mode.eq.7.or.mode.eq.8) 
     &		.and. .not.active_max)  then
		write(nout,2062) gmax
2062		format(' Maximum in projections =',1pe10.3) 
			if(gmax.gt.tmax)  then
			call  bmax_c(bckn,nmat,ipcube,nn,bmax)
			write(nout,2052)  bmax
2052	format(' Max constraint activated, value in 3D =',1pe10.3)
			active_max=.true.
			endif
	endif
	endif
c enforce min constraints
	if(active_min)  call   domin3_s(bckn,nmat,ipcube,nn,bmin)
c enforce max constraints
	if(active_max)  call   domax3_s(bckn,nmat,ipcube,nn,bmax)
821		continue

801	if(sq.gt.aim .and. iter.lt.maxit)  then
	   if(sq.lt.sqold)  then
	      sqold=sq
	      goto  999
	   endif
	endif
        END         
