C++************************************************************************
C
C  REPS.FOR
C
C **************************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK            *
C *  COPYRIGHT (C)1981,1987, WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *  THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR       *
C *  LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR    *
C *  USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF     *
C *  THE CENTER FOR LABORATORIES AND RESEARCH   			   *
C **************************************************************************
C
C  Reprojections 3D, Richardson's method, 
C  reconstruction kept in the square to introduce other constraints.
C  Average outside the window is subtracted
C  min, max relate to the projections
C  Symmetries imposed ...
C                             Interpolation changed !
C  corrections applied on the volume side.
C                                                     01/10/94
C  Compression of angles - 08/14/96
C
C	  REPS(MAXMEM)
C
C	  REDPRQ
C	  RPRQ(N,B,CUBE,IPCUBE,NN,PHI,THETA,PSI,DM,RI)
C	  asta(x,n,ri,aba,klp)
C	  PREPCUB_s(N,NN,IPCUBE,RI)
C	  BCKCQ(CUBE,LTC,DM,B,N,IPCUBE,NN)
C	  PRJCQ(CUBE,LTC,DM,B,N,IPCUBE,NN)
C	  repr3_q
C	  smt3_q(t,ala,X,y,NSAM,NROW,nslice,ipcube,nn)
C-	  domin3_s(sq,nmat,ipcube,nn,tmin)
C-	  domax3_s(sq,nmat,ipcube,nn,tmax)
C	  docors3_s(bcke,bcn,n,nmat,ipcube,nn,ala,ANGS)
C-	  bmax_c(bcke,nmat,ipcube,nn,bmax)
C-	  bmin_c(bcke,nmat,ipcube,nn,bmin)
C	  fmax_q(x,map,n,xmax)
C	  fmin_q(x,map,n,xmin)
C
C23456789012345678901234567890123456789012345678901234567890123456789012
C--************************************************************************

	SUBROUTINE REPS(MAXMEM)

	PARAMETER  (NILMAX=10000)
	COMMON     DUMMY(80),BUF(1024),ILIST(NILMAX),Q(3)

        INCLUDE 'CMBLOCK.INC' 
	 
        DIMENSION QB(1)
        POINTER           (IPQ,QB) 
        LOGICAL           RUNTIME 
	COMMON  /F_SPEC/  FINPAT,NLET,FINPIC
	CHARACTER*80      FINPIC,FINFO,FINPAT
	CHARACTER*1       NULL,ANS
	COMMON /DIMREC/   IDIMREC
	COMMON /PAR/      LDP,NM,LDPNM
	DOUBLE PRECISION  ABA
CNO_SAVE

	DATA  INPIC/99/

	NULL = CHAR(0)

C       THIS IS 3D RECONSTRUCTION
	IDIMREC=3
 
C       N - LINEAR DIMENSION OF PROJECTIONS AND RESTORED CUBE
C       NANG - NUMBER OF ANGLES (PROJECTIONS)
 
	IUNIT=NOUT
 	CALL  FILERD(FINPAT,NLET,NULL,
     &	  'ENTER TEMPLATE FOR 2-D IMAGE',IRTFLG)
 	CALL  FILERD(FINPIC,NLETI,NULL,'SELECTION DOC',IRTFLG)
	K=0
	K2=1
	NANG=0
778	LERR=-1
	IF (NANG.EQ.NILMAX)  THEN
	    WRITE(NOUT,*) '  TOO MANY IMAGES, LIST TRUNCATED'
	    GOTO  779
	ENDIF
	KP1=K+1
	CALL  UNSAV(FINPIC,K,INPIC,KP1,BUF,1,LERR,K2)
	IF (LERR.EQ.0)  THEN
	   NANG=NANG+1
	   ILIST(NANG)=BUF(1)
	   K=K+1
	   GOTO  778
	ENDIF
779	CLOSE(INPIC)
	WRITE(NOUT,2001) NANG
2001	FORMAT('  NUMBER OF IMAGES =',I5)
C       NANG - TOTAL NUMBER OF IMAGES
        CALL  RDPRM(RI,NLOOP,ILOOP,'RADIUS OF RECONSTRUCTED OBJECT')
	IRI=RI
	CALL  FILERD(FINFO,NLET1,NULL,'ANGLES DOC',ITRFLG)
	FINFO=FINFO(1:NLET1)//'.'//DATEXC(1:3)
	OPEN(77,FILE=FINFO,STATUS='OLD')
	READ(77,*)

 	CALL  FILGET(FINPAT,FINPIC,NLET,ILIST(1),INTFLG)
 	CALL  OPENFB(BUF,FINPIC,INPIC,NSAM,NROW,'O',NF,NSL)
 	IF (NF .NE. 2)  THEN
           CALL ERRT(4,'BP RP ',NE)
 	   RETURN
	ENDIF
	CLOSE(INPIC)
	N=NSAM
 
	IN=N
	INANG=NANG
        M=N

        NM=(N-M)/2
        LDP=M/2+1
        LDPNM=LDP+NM

 	K_ANG=1
	K_SYM=K_ANG+3*NANG

	CALL RDPRMC (ANS, NLETI, .TRUE.,
     $     'DOES YOUR VOLUME HAVE SYMMETRIES? (Y/N)',NULL,IRT)
	IF (ANS.EQ.'Y')  THEN
 	   CALL  FILERD(FINPIC,NLETI,NULL,
     &         'SYMMETRIES ANGLES DOC',IRTFLG)
	   K=0
	   K2=1
	   NSYM=0
758	   LERR=-1
	   KP1=K+1
	   CALL  UNSAV(FINPIC,K,INPIC,KP1,Q,3,LERR,K2)
	   IF (LERR.EQ.0)  THEN
	      Q(K_SYM+3*NSYM)=Q(1)
	      Q(K_SYM+3*NSYM+1)=Q(2)
	      Q(K_SYM+3*NSYM+2)=Q(3)
	      NSYM=NSYM+1
	      K=K+1
	      GOTO  758
	   ENDIF
	   CLOSE(INPIC)
	   WRITE(NOUT,2021) NSYM
2021	   FORMAT(/,'  NUMBER OF SYMMETRIES:',I5,/)
	ELSE
	   NSYM=0
	ENDIF

 	K_DM=K_SYM+3*NSYM
	K_LB=K_DM+9*NANG
	K_MAP=K_LB+NANG

c	K_IPCUBE=K_MAP+(N*N*NANG+1)/2
	K_IPCUBE=K_MAP

	CALL  PREPCUB_s(N,NN,Q(K_IPCUBE),RI)
c!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
	NMAT=N*N*N

C       IN THIS VERSION TOTAL MEMORY IS THREE VOLUMES BCKN, BCKE AND CUBE
C       PLUS 2 2D PROJECTIONS.
C
C       CUBE - KEEPS BACK-PROJECTED ORIGINAL PROJECTIONS, READ FROM THE DISK
C       BCKE - WORKING VOLUME
C       BCKN - CURRENT RECONSTRUCTION

	K_PROJ=K_IPCUBE+5*NN
 
	K_X=1 
#ifdef SP_MP
	NUMTH=mp_numthreads()
#else
	NUMTH=1
#endif
	K_PRJE=K_X+N*N*NUMTH
C       IN THIS VERSION SIGMA IS ASSUMED TO BE PROPORTIONAL TO PROJ
C       AND THE CORRESPONDING ARRAY IS NOT USED ANYWHERE.
C	K_SIGMA=K_PRJE
C       PRJE WILL BE LOGICAL*1 MASK
	K_CB=K_PRJE+(N*N+3)/4
        K_BCKE=K_CB+NSAM
	K_BCKN=K_BCKE+NMAT
	MEMTOT=K_BCKN+NMAT
	WRITE(NOUT,1001)  MEMTOT
1001	FORMAT(//'  REPROJECTION PROGRAM FOR 3-D BACK-PROJECTION',/,
     &     '           MEMORY NEEDED - ',I8,/)
     
        CALL CHKMEM(MEMTOT, Q, MAXMEM-(NILMAX+1024+80), 
     &	            RUNTIME,IPQ,IRTFLG)
	IF(IRTFLG.NE.0) THEN 
	   WRITE(NOUT,1002)  MAXMEM
1002	   FORMAT(' *** SORRY, YOUR BUFFER LENGTH IS ONLY',I9,/,
     1        '  PROGRAM CANNOT BE RUN')
           CALL ERRT(100,'REPS',NERR)
	   RETURN
	ELSE
	   IF(.NOT. RUNTIME)  THEN
              K_X=K_PROJ 
#ifdef SP_MP
	      NUMTH=mp_numthreads()
#else
	      NUMTH=1
#endif
	      K_PRJE=K_X+N*N*NUMTH 
	      K_CB=K_PRJE+(N*N+3)/4
              K_BCKE=K_CB+NSAM
	      K_BCKN=K_BCKE+NMAT
	      MEMTOT=K_BCKN+NMAT
	      IPQ = %LOC(Q)
	   END IF
	ENDIF

	CALL  FILERD(FINPIC,NLETI,NULL,'RECONSTRUCTED 3-D',ITRFLG)
	IF  (IRTFLG .EQ. -1)  GOTO 9999
	IFORM = 3
 	CALL  OPENFB(BUF,FINPIC,INPIC,M,M,'UNKNOWN',NF,M)
	IF  (NF.NE.2)  GOTO 9999


	CALL  REDPRQ(N,NANG,QB(K_CB),
     1	   Q(K_PROJ),Q(K_ANG),ILIST,Q(K_IPCUBE),NN,Q(K_DM),
     2	   RI,ABA,NOUT,INPIC)
     
C       COMPRESS ANGLES - IT CHANGES NANG !!
	CALL  HIANG(Q(K_ANG),NANG,Q(K_DM),Q(K_LB))
	WRITE(NOUT,2027)  NANG
2027	FORMAT('     EFFECTIVE NUMBER OF ANGLES: ',I6)

	NSYMT=MAX0(1,NSYM)
	CALL  REPR3_Q
     1	  (QB(K_CB),QB(K_BCKE),QB(K_BCKN),N,Q(K_IPCUBE),NN,
     2     Q(K_PROJ),QB(K_PRJE),Q(K_DM),Q(K_LB),NANG,IRI,ABA,
     3     Q(K_SYM),NSYMT,NSYM,NUMTH,INPIC)
C
	DO  K=1,M*M
	   MI=(K-1)*M
   	   CALL  WRTLIN(INPIC,QB(K_BCKN+MI),M,K)
        ENDDO
        IF (RUNTIME) CALL ALLOCIT(0,RUNTIME,IPQ,'GALI',IRTFLG) 
	CLOSE(INPIC)

9999    CONTINUE
        RETURN
	END
