
C*---------------------------------------------------------------------*        
C    RGRI(ICARD,KFAC,NKLA,KLAS,IDI,PK,GT,IV,NGRI,NGUS)
C
C IMPORTANT CHANGE: NKLA IS REDUCED BEFORE DEUCL IS CALLED. THE ORIGINAL
C NUMBER OF CLUSTERS IS STORED IN NKLAO 
C
C** 2/6/86 J.F. READ CLUSTER FILE PRODUCED BY SCLASSY AND PRINT OUT
C LISTS OF CLASS MEMBERS, CENTERS OF GRAVITIES FOR EACH CLASS, AND
C RE-CLASSIFICATION LOOKUP TABLE
C
C----------------------------------------------------------------------

      SUBROUTINE RGRI(ICARD,KFAC,NKLA,KLAS,IDI,PK,GT,IV,NGRI,NGUS)

CNO_SAVE

      COMMON /ENSOR/ LEC, IMP

      DIMENSION        KLAS(ICARD), IDI(ICARD)
      DIMENSION        PK(NKLA), GT(NKLA, KFAC), IV(NKLA)

C     NUMBER OF MAJOR CLASSES TO BE ANALYSED IN TERMS OF DISPERSIONS
C     10/20/87 TEMPORARILY CHANGED TO 11 JF
      PARAMETER (NMAJ=11)

C     MAXIMUM NUMBER PER CLASS TO BE PRINTED
      PARAMETER (MAXPRT=1000)
	
C     MAX IOBUF SIZE IS:   PARAMETER        (NBUFSIZ = 17008)
      INTEGER          BELONG
      DIMENSION        COO(NMAJ)
      EQUIVALENCE      (COO,BELONG)
      COMMON /IOBUF/   DIST(NMAJ,NMAJ),BELONG(MAXPRT)

      DIMENSION         DISP(NMAJ),DELTA(3),NEXT(3)
                                                                               
        READ (NGRI) (KLAS(I), I=1,ICARD), (IDI(I), I=1,ICARD),
     #             (PK(L),L=1,NKLA), ((GT(L,J),L=1,NKLA),J=1,KFAC)

	NMAJOR = MIN0(NMAJ,NKLA)

C       LIST IMAGES BY CLASSES
	WRITE(IMP,13)
13	FORMAT(/' LIST OF CLASS MEMBERS'//,' CLASS'/)

	DO  K=1,NKLA
	   IKLA=0
           DO  I=1, ICARD
             IF(KLAS(I).EQ.K) THEN
                IKLA=IKLA+1
                BELONG(IKLA)=IDI(I)
             ENDIF
           END DO
	   IF (IKLA.EQ.0)GOTO 15
	   IF (IKLA.GT.MAXPRT) THEN
              WRITE(IMP,12)K,MAXPRT
12            FORMAT(I4,' *** MORE THAN ',I4,' IMAGES')
              GOTO 15
	   ENDIF

	   WRITE(IMP,11)K,(BELONG(I),I=1,IKLA)
11	   FORMAT(/I6,20I5,/(6X,20I5))
15	   CONTINUE
        END DO

C       LIST CLASS CENTER COORDINATES

	WRITE(IMP,1001)((IFAC),IFAC=1,KFAC)
1001	FORMAT(//' LIST OF CLASS CENTER COORDINATES'//,
     1           ' CLASS  SIZE',8(3X,I2,3X)/)
        DO N=1, NKLA                               
           WRITE(IMP, 1002) N, INT(PK(N)+0.5), (GT(N,IFAC),IFAC=1,KFAC)
 1002      FORMAT(2X,I4,3X,I4,3X,12(F7.4,1X))                 
        END DO

C       RE-CLASSIFICATION LOOKUP TABLE

	WRITE(IMP,1004)((I),I=1,NKLA)
1004	FORMAT(//' RE-CLASSIFICATION LOOKUP TABLE'/,' ORIGINAL CLASS'//,
     1         8X,(40I3))

        KPART = NKLA - 1                                            
        DO KPRO = 2,KPART                                   
           READ (NGRI)  (IV(J), J=1,NKLA)                
           WRITE(IMP, 1003) KPRO, (IV(J), J=1,NKLA) 
 1003      FORMAT(I6,2X,(40I3)) 
        END DO

C       COMPUTE CLASS DISPERSIONS AND INTERCLASS DISTANCES FOR THE NMAJOR
C       MAIN CLASSES
	CALL REW(NGUS,0)

C       CLEAR ARRAY DIST
	DO K=1,NMAJOR
           DISP(K)=0.0
           DO K1=1,NMAJOR
              DIST(K,K1)=0.0
  	   END  DO
        END DO

	DO I=1,ICARD
           READ(NGUS)(COO(IFAC),IFAC=1,KFAC)
           K=KLAS(I)
           IF (K .LE. NMAJOR) THEN
              DO IFAC=1,KFAC
                 DISP(K)=DISP(K)+(COO(IFAC)-GT(K,IFAC))**2
  	      END DO
           ENDIF
  	END DO

	DO K=1,NMAJOR
  	   DISP(K)=SQRT(DISP(K)/PK(K))
        END DO

C       COMPUTE INTERCLASS DISTANCES

	DO K=1,NMAJOR
           DO K1=1,NMAJOR
             IF (K1 .EQ. K) GOTO 80
             DO IFAC=1,KFAC
               DIST(K,K1)=DIST(K,K1)+(GT(K,IFAC)-GT(K1,IFAC))**2
  	     END DO
80	   END DO
        END DO

C       SCALE DISTANCES
	DO K=1,NMAJOR
           DO K1=1,NMAJOR
              DIST(K,K1)=SQRT(DIST(K,K1))
           END DO
        END DO

C       WRITE HEADING
        WRITE(IMP) ' '
	WRITE(IMP,1202)(I,I=1,10)
1202	FORMAT(' DISPERSIONS AND INTER-CLASS DISTANCES OF 10 LARGEST',
     1         ' CLUSTERS',//,
     2         ' CLASS      DISP         NEIGHBORS       ',10I7/)

C       FOR EACH CLUSTER, DETERMINE THE 3 CLOSEST NEIGHBORS

	DO K=1,NMAJOR
C          CLEAR TABLES
           DO J=1,3
              DELTA(J)=100000.
              NEXT(J)=0
           END DO

           DO K1=1,NMAJOR
             IF (K1 .EQ.K) GOTO 120
             IF (DIST(K,K1) .LT. DELTA(1)) THEN
		DELTA(3)=DELTA(2)
		DELTA(2)=DELTA(1)
		DELTA(1)=DIST(K,K1)
		NEXT(3)=NEXT(2)
		NEXT(2)=NEXT(1)
		NEXT(1)=K1
		GOTO 120
             ENDIF

             IF (DIST(K,K1) .LT. DELTA(2)) THEN
		DELTA(3)=DELTA(2)
		DELTA(2)=DIST(K,K1)
		NEXT(3)=NEXT(2)
		NEXT(2)=K1
		GOTO 120
             ENDIF

             IF (DIST(K,K1) .LT. DELTA(3)) THEN
		DELTA(3) =DIST(K,K1)
		NEXT(3)=K1
             ENDIF
120	   END DO

	   WRITE(IMP,1201)K,DISP(K),(NEXT(J),J=1,3),
     &                     (DIST(K,K1),K1=1,K-1)
1201	   FORMAT(8X,I4,3X,F7.4,5X,3I3,6X,10F7.4)

150      END DO

      RETURN
      END                                                                       

