

#ifdef SP_DISTRIB 
 
C   THIS ROUTINE SPECIFIC TO WADSWORTH LABS AND IS NOT 
C       DISTRIBUTED TO OUTSIDE SITES
 
       SUBROUTINE rhobck
 
       COMMON /UNITS/LUNC,NIN,NOUT
 
       WRITE(NOUT,*) 'DUMMY CALL: rhobck'
       RETURN
       END
 
#else
 

C++****************************************************************************
C
C RHOBCK:
C
C	CALL RHOBCK(A,B,EXTN,NN,NR,ND,IRO,CORRLN)
C	  A	     ARRAY, DIMENSION (ND,1), INPUT  (N.B.: ND MUST BE .GE.4)
C	  A(1,N)     ALTITUDE OF REFLECTION I.E. Z*
C	  A(2,N)     REAL PART OF AMPLITUDE
C	  A(3,N)     IMAGINARY PART OF AMPLITUDE
C	  A(4+ND...) USED AS A BUFFER DURING PROCESSING
C	  NN         NUMBER OF REFLECTIONS IN A
C	  B          ARRAY, DIMENSION (2,NR), OUTPUT
C		     B IS THE 1-D DISCRETE FT OUTPUT BY AVERAGING/
C		     INTERPOLATING THE INPUT VALUES IN A.
C	  IRO        OPTION SWITCH:
C			IRO=0: USE ALIASED SINC
C			IRO=1: USE CONTINUOUS SINC
C		     FOR AVERAGING/INTERPOLATING.
C		     IRO=2 NEEDS CORRLN SET (OTHERWISE CORRLN NOT USED).
C		     THIS IS A TRICK TO SET POORLY DEFINED COEFFICIENTS
C		     TO ZERO. USE ONLY IF YOU ARE WRITING AN ITERATIVE
C		     OPTIMIZER. IRO=2 NOT A NORMALLY VALID OPTION.
C
C
C  WARNING !!!!!!!!!!! XNR2 WAS UNDEFINED ON 15 FEB 94 al
C  I HAVE ALTERED ROUTINE TO DEFINE IT, AM NOT SURE THAT WHAT I DID IS
C  CORRECT?
C
C--*****************************************************************************

	SUBROUTINE RHOBCK(A,B,EXTN,NN,NR,ND,IRO,CORRLN,NXL,NYL,
     &                    DIRO,NTOP)

	REAL A(1),B(1),Q17(2)

	LOGICAL SWITCH,NSWTCH,DIRO,EVEN
	COMPLEX CP,CQ,CB
	EQUIVALENCE (Q17(1),AR,CQ),(Q17(2),AI)

        DATA RCONV/57.29578/

	SINC(X$) =SIN(X$)/(X$)
	SINCA(X$)=SIN(X$)/(SIN(X$/NR)*NR)

C	GENERATE WEIGHTING FACTORS

	SWITCH=IRO.EQ.1
	NSWTCH=IRO.NE.2
	DO 32 I=1,NR
	B(2*I-1)=0.
	B(2*I)=0.
32	CONTINUE
	IF(NN.LE.0)RETURN
	EVEN=MOD(NR,2).NE.0
	NR2=NR/2
	QVM=EXTN/FLOAT(NR)
	XNR=MIN0(NR2,NTOP)

C       ************ FEB 94 AL ****************
C	XNR=NR2/EXTN
	XNR2=NR2/EXTN
C       *********************************

	DO 1 I=1,NN
	NDJ=ND*(I-1)
	Z0=A(1+NDJ)
	W=0.
	WT=A(5+NDJ)
	IF(ABS(Z0).GT.XNR) GOTO5
	DO 2 J=1,NN
	Z=A(1+ND*(J-1))
	WT1=A(5+ND*(J-1))
	IF(ABS(Z).GT.XNR)GOTO2
	IF(Z.EQ.Z0)GOTO3
	W=W+SINC(3.1415926*(Z-Z0)/EXTN)*WT1
	GOTO 2

3	W=W+WT1
2	CONTINUE
	IF(W.EQ.0.)GOTO 5
	W=AMIN1(1.,WT/W)
	A(2+NDJ)=A(2+NDJ)*W
	A(3+NDJ)=A(3+NDJ)*W
5	A(4+NDJ)=W
1	CONTINUE

C	WEIGHTS AVAILABLE: NOW GENERATE THE TRANSFORM

	DO 4 I=1,NR
	Z=(MOD(I-1+NR2,NR)-NR2)/EXTN
	CP=(0.,0.)
	DMIN=1.E30
	DO 6 J=1,NN
	NDJ=ND*(J-1)
	IF(A(NDJ+4).EQ.0.)GOTO 6
	Z0=A(1+NDJ)/EXTN
	IF(ABS(Z0).GT.XNR2)GOTO 6
	DMIN=AMIN1(DMIN,ABS(Z0-Z))
	AR=A(2+NDJ)
	AI=A(3+NDJ)
	IF(Z0.EQ.Z)GOTO 7
	ZZ0=3.1415926*(Z0-Z)
	IF(SWITCH)GOTO 9
	Q=SINCA(ZZ0)
	IF(EVEN)GOTO 10
	CB=CMPLX(Q,0.)*CQ*CEXP(CMPLX(0.,-ZZ0*QVM))
	CP=CP+CB
	GOTO 6

9	Q=SINC(ZZ0)
10	CP=CP+CQ*CMPLX(Q,0.)
	GOTO 6

7	CP=CP+CQ
6	CONTINUE

	CQ=CP
	IF(NSWTCH)GOTO 8
	IF(DMIN.LT.CORRLN)GOTO 8
	AR=1.E-35
	AI=0.

8	B(1+2*(I-1))=AR
	B(2*I)=AI
4	CONTINUE
	IF(.NOT.DIRO)RETURN

	DO 26 I=1,NN
          NDJ=ND*(I-1)
          W=A(4+NDJ)
          IF(W.EQ.0.)GOTO 26
          A(2+NDJ)=A(2+NDJ)/W
          A(3+NDJ)=A(3+NDJ)/W
26	CONTINUE

	WRITE(10,20)NXL,NYL,NN,NR
200	FORMAT(8G12.4)
20	FORMAT(' 1WEIGHT PROCESSING FOR LINE (',2I4,'): ',I5,' DATA ',
     1 ' POINTS IN; ',I5,' POINTS OUT '//
     1 '    ALTS     AMPS ',6X,' PHASES      WEIGHT    OUTO    AMPS ',6X,
     1 ' PHASES '/)

21	FORMAT(1X,F8.2,2G12.4,F8.3,I8,2G12.4)
	NR21=NR/2
	NR2=NR-NR21
	NMAX=MAX0(NN,NR)
	IF(NMAX.LE.0)RETURN

	DO 22 I=1,NMAX
	I478=4*(I-1)
	IJ=2*MOD(I+NR2,NR)+1
	IJR=I-NR21
	IF(I.GT.NN)GOTO 23
	IF(I.GT.NR)GOTO 24
	AR=A(2+I478)
	AI=A(3+I478)
	XR=SQRT(AR*AR+AI*AI)
	IF(XR.LE.0.)AR=1.
	AR=ATAN2(AI,AR)*RCONV
	AR1=B(IJ)
	AI1=B(IJ+1)
	YR=SQRT(AR1*AR1+AI1*AI1)
	IF(YR.LE.0.)AR1=1.
	AR1=ATAN2(AI1,AR1)*RCONV
	WRITE(10,21)A(1+I478),XR,AR,A(4+I478),IJR,YR,AR1
	GOTO 22

23	AR1=B(IJ)
	AI1=B(IJ+1)
	YR=SQRT(AR1*AR1+AI1*AI1)
	IF(YR.LE.0)AR1=1.
	AR1=ATAN2(AI1,AR1)*RCONV
	WRITE(10,25)IJR,YR,AR1
25	FORMAT(41X,I8,2G12.4)
	GOTO 22

24	AR=A(2+I478)
	AI=A(3+I478)
	XR=SQRT(AR*AR+AI*AI)
	IF(XR.LE.0.)AR=1.
	AR=ATAN2(AI,AR)*RCONV
	WRITE(10,21)A(1+I478),XR,AR,A(4+I478)
22	CONTINUE
	RETURN

C       COMPRESS OUT THE ZERO AMPLITUDES FROM THE INPUT LIST

	ENTRY KMPZLT(A,MIN,MOUT,ND)
	MOUT=0
	DO 30 I=1,MIN
	INN=(I-1)*ND
	AR=A(2+INN)
	AI=A(3+INN)
	IF(AR.EQ.0..AND.AI.EQ.0.)GOTO 30
	MOUT=MOUT+1
	MNN=(MOUT-1)*ND
	DO 33 J=1,ND
33	A(J+MNN)=A(J+INN)
30	CONTINUE
	MMO=MIN-MOUT
	IF(MMO.LE.0)RETURN
	MNN=MOUT*ND+1
	INN=MIN*ND
	DO 31 I=MNN,INN
31	A(I)=0.

	RETURN
	END
 
#endif
 
