C-*******************************************************************
C
C     USED IN FUZZY CLASSIFICATION
C
C     CALLED BY: SCLASF
C
C-******************************************************************

      SUBROUTINE RO2TEST (DLIS,NAITEM,NFACT,NCLU,NOUP,LFACT,KV)
C
      PARAMETER (IN=100,NC=10,INF=10)
C
      INCLUDE 'CMBLOCK.INC'
      INTEGER C
      INTEGER   DLIS(IN),LB(IN),KLAS(IN),KV(INF)
      CHARACTER NAME*14,ANS*1,NAM*4
      REAL M,XD(IN,IN),U(IN,NC),X(IN,INF)
      REAL RDUMP(80),ACK(NC),PK(NC),V(NC,IN)
C
      COMMON RDUMP,X,XD,U,V 
C
C
      N=NAITEM
      C=NCLU
      NF=NFACT
C
       CALL RDPRM2 (M,EPSIL,NLOOP,ILOOP,
     * ' FUZZY EXPONENT (1, INF.), EPSILON TO STOP ITERATION $')
       CALL RDPRMI(MAXIT,JDUM,NLOOP,ILOOP,
     *             ' MAXIMUM NUMBER OF ITERATIONS ANYWAY = $')
       CALL RDPRM  (RTHR,NLOOP,ILOOP, 
     *             ' THRESHOLD FOR HARD-PARTITION TRANSFORMATION $')
C
C
       WRITE (NOUT,1040) N,NF,LFACT,(KV(I),I=1,INF),
     *                   M,EPSIL,MAXIT,NCLU,RTHR
C
       WRITE (NDAT,1040) N,NF,LFACT,(KV(I),I=1,INF),
     *                  M,EPSIL,MAXIT,NCLU,RTHR
C
1040  FORMAT (//,1X,'NUMBER OF ITEMS/IMAGES = '
     * ,I5,/,' TOTAL NUMBER OF FACTORS IN CLAS.= ',I2,
     * ' , NUMBER IN IMC= ',I2,/,
     * ' FACTORS USED= ',10I2,/,
     * ' FUZZY PARAMETER = ',F3.1,2X
     * ,' , EPSILON = ',F10.7,2X,/,
     * ' MAXIMUM ITERATIONS = ',I4,/
     * ,' NUMBER OF CLUSTERS = ',I2,' , THRESHOLD = ',F10.7)
C
      DO  I=1,N
      XD(I,I)=0.
      DO  J=I+1,N
         XD(I,J)=0.
         DO  L=1,NF
           XD(I,J)=XD(I,J)+(X(I,L)-X(J,L))**2.
	 ENDDO
         XD(I,J)=SQRT(XD(I,J))
      XD(J,I)=XD(I,J)
      ENDDO
      ENDDO
C
C
      CALL ROUB2 (XD,LB,U,N,C,M,EPSIL,MAXIT,ITER)
C
      WRITE (NDAT,110)
110   FORMAT (/,' THE MEMBERSHIP MATRIX ',//,
     * '     ELEMENT, HARD CLAS.,
     * PERTENENCE, DECISSION, MAX.PERTENENCE',//)
      DO  I=1,N
         RMAXC=0
         RCCOUNT=0
         DO  J=1,C
            ACK(J)=U(I,J)
            IF (ACK(J).GT.RMAXC) THEN
               RMAXC=ACK(J)
               RCCOUNT=J
            ENDIF
	 ENDDO
            IF (RMAXC.LT.RTHR) RCCOUNT=0
            KLAS(I)=RCCOUNT+0.5
            WRITE (NDAT,7000) DLIS(I), LB(I), 
     *             (ACK(KK), KK=1,C), RCCOUNT,RMAXC
7000        FORMAT (3X,I4,3X,I4,3X,30(F5.2,2X))
      ENDDO
C
      WRITE (NDAT,120) 
120   FORMAT (/,' THE CLUSTER CENTRES ',//)
C
C     CLUSTER CENTRES 
C
         DO  J=1,C
            PK(J)=0.
            SUM=0.
            DO  I=1,N
            IF (KLAS(I).EQ.J) PK(J)=PK(J)+1.
            SUM=SUM+U(I,J)
	    ENDDO
            DO  L=1,NF
               SCEN=0.
               DO  I=1,N
                 SCEN=SCEN+U(I,J)*X(I,L)
	       ENDDO
               V(J,L)=SCEN/SUM
	    ENDDO
	 ENDDO
C
      DO  I=1,C
        WRITE (NDAT,'(I3,30(3X,F10.8))') I,(V(I,J),J=1,NF)
      ENDDO
C
C
      WRITE (NDAT,121)
121   FORMAT (/,' NUMBER OF ELEMENTS PER CLUSTER (WEIGHT)',//)
C
C      DO 160 I=1,C
C         PK(I)=0.0
C         DO 161 J=1,N
C            IF (LB(J).EQ.I) PK(I)=PK(I)+1.
C161      CONTINUE
C160   CONTINUE
C
      DO  I=1,C
         WRITE (NDAT, '(I3,F10.5)') I,PK(I)
      ENDDO
C
C
C       WRITTING OF THE CLUSTER FILE TO BE USED BY OTHER PROGRAMS
C
C       WRITE (NOUP) NAITEM, LFACT, NCLU, NFACT, (KV(K), K=1, NFACT)
C       WRITE (NOUP) (LB(I), I=1,NAITEM), (DLIS(I), I=1,NAITEM),
C                    (PK(L), L=1, NAITEM), ((V(L,J),L=1,NCLU), J=1,NFACT)
C       
C
C
C
      WRITE (NOUT,*) 
      WRITE (NOUT,*) ' THE NUMBER OF ITERATIONS WAS = ',ITER
      WRITE (NDAT,*) 
      WRITE (NDAT,*) ' THE NUMBER OF ITERATIONS WAS = ',ITER
C
9999  CONTINUE
      END

