C++*******************************************************************
C
C $$ ROT.FOR	IMPORTANT: C O M P I L E  W I T H  "I4"  D E F A U L T !!
C
C **************************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK            *
C *  COPYRIGHT (C)1981,1987, WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH 			   *
C **************************************************************************
C
C
C $$ ROT:    ROTATE AN IMAGE
C
C     THIS SUBROUTINE WILL ROTATE AN IMAGE BY AN ARBITRARY ANGLE OF
C     DEGREE BETWEEN 0 AND 360.
C
C     CALL ROT(LUNI,LUNO,NSAM,NROWS,NROWE,NBUF,THETA,AV)
C       LUNI         LOGICAL UNIT NUMBER OF INPUT IMAGE
C       LUNO         LOGICAL UNIT NUMBER OF OUTPUT IMAGE
C       NSAM    	LENGTH OF AN IMAGE ROW
C	NROWS,NROWE	STARTING ROW, ENDING ROW OF IMAGE
C       NBUF         LENGTH OF BUFFER ARRAY AVAILABLE -- I4 !
C       THETA        ROTATION ANGLE IN RADIANS
C       AV           BACKGROUND VALUE TO BE USED. E.G., AVERAGE
C		     OF INPUT IMAGE
C
C     CODING:  IMAGE IS PROCESSED IN PATCHES.  FOR EACH PATCH, THE
C              POSITIONS OF THE NEW GRID POINTS IN THE OLD COORDINATE
C              SYSTEM ARE CALCULATED AND SORTED BY ASCENDING (OLD)
C              RECORD NUMBERS.  INTERPOLATION IS DONE BY USING THE
C              BILINEAR INTERPOLATION SCHEME.  EMPTY SPACES ARE FILLED
C              IN WITH THE AVERAGE VALUE.  
C              POSITIVE THETA: COUNTER-CLOCKWISE ROTATION
C                              (MATHEMATICALLY POSITIVE DIRECTION)
C
C--*******************************************************************
C
C
      SUBROUTINE ROT(LUNI,LUNO,NSAM,NROWS,NROWE,NBUF,THETA,AV)
      COMMON BUF(1)
      COMMON /UNITS/ LUN,NIN,NOUT,NECHO,IFOUND,NPROC,NDAT
      INTEGER A1,A2,A3,A4
      INTEGER   NBUF
      INTEGER LUNI,LUNO,NSAM,NROW,NREC1,JP1
      INTEGER NROWS,NROWE,NROWSI,NROWEI,IARG
      DATA PI/3.14159/
	I4(IARG)=IARG
      IF(THETA.NE.0.) GOTO 4
	IF(NROWS.EQ.1)NROWS1=0
	IE=NROWE
	DO  I=NROWS1,IE
	CALL REDLIN(LUNI,BUF,NSAM,I)
	CALL WRTLIN(LUNO,BUF,NSAM,I)
	ENDDO
      RETURN
4	NSAM4=NSAM
	NSAMH=NSAM/2
	NROWH=(I4(NROWE-NROWS)+1)/2
      NSAM1 = NSAMH +1
      NSAMM = NSAM4-1
	NROW4=NROWE-NROWS+1
      IF(THETA.EQ.PI) GOTO 500
      NPP = (NBUF-2*NSAM4)/4
C NPP -- NUMBER OF PIXELS THAT CAN BE SIMULTANEOUSLY HANDLED
C	 IN ONE PASS
	 NSEC = NPP/((NSAM4*4)/3)
C NSEC -- NUMBER OF LINES PER PASS
906   NPP = NSEC*NSAM4
       A1 = 2*NSAM4
C 1...A1  INPUT BUFFER
      JPREV = 0
      IPATCH = 0
      IF(THETA.GT.PI) THETA = -2.*PI+THETA
      IF(THETA.LT.-PI) THETA = 2.*PI+THETA
      COD = COS(THETA)
      SID = SIN(THETA)
      FNS = ABS(FLOAT(NSEC)/SID)
      FNSAM = NSAM
C     WRITE(NOUT,1) FNS,SID,COD
1     FORMAT(3F15.2,3I5,5F15.2)
      NBPL = AMIN1(FNS,FNSAM)+1.5
C DETERMINE LARGEST AND SMALLEST RECORD NUMBER
      XL1 = NSAM
      YL1 = NSEC
      XSM1 = 1
      YSM1 = 1
      IF(THETA.GT.0.) GOTO 5
      XL1 = 1
      XSM1 = NSAM
5      CONTINUE
      IF(ABS(THETA).LT.PI/2.) GOTO 9
      YL1 = 1
      YSM1 = NSEC
9     XL = XL1-NSAMH-1
      YL = YL1-NROWH-1
      IL = XL*SID + YL*COD +NROWH+1
      XSM = XSM1-NSAMH-1
      YSM = YSM1-NROWH-1
      ISM = XSM*SID + YSM*COD + NROWH+1
C MAXIMUM LENGTH OF BUFFER SECTION PER LINE
      NPPC = (IL-ISM+2)*NBPL
      IF(A1+4*NPPC.LE.NBUF) GOTO 905
      NSEC = NSEC-1
      GOTO 906
905   A2 = A1 + NPPC
C A1+1...A2  X (COLUMN INDEX) BUFFER
      A3 = A2 + NPPC
C A2+1...A3  Y (ROW INDEX) BUFFER
      A4 = A3 + NPPC
C A3+1...A4  POSITION BUFFER
C A4+1...A4+NPP  OUTPUT BUFFER
      IS = 1-NSEC
      IE = 0
      JPREV = 0
10    IPATCH = IPATCH+1
      IS = IS+NSEC
      IE = IE + NSEC
      IF(IE.GT.NROW4) IE = NROW4
C MARK POSITION BUFFER AS EMPTY
      DO  L = 1,NPPC
        BUF(A3+L) = -1001.
      ENDDO
      DO  I = IS,IE
      IST = (I-1)*NSAM4
      Y = I-NROWH-1
      YCOD = Y*COD + NROWH+1
      YSID = -Y*SID + NSAMH+1
      ISM = XSM*SID + FLOAT(IS-NROWH+1)*COD +NROWH+1
      DO  K = 1,NSAM4
C DETERMINE POSITION IN OLD COO SYSTEM
      X = K-NSAM1
      AI = X*SID+YCOD
      NAI = (INT(AI)-ISM)*NBPL
25    NAI = NAI+1
      IF(NAI.GT.NPPC) GOTO 400
      IF(BUF(A3+NAI).GT.-1000.) GOTO 25
30    BUF(A1+NAI) = X*COD + YSID 
      BUF(A2+NAI) = AI
      BUF(A3+NAI) = IST+K
C     WRITE(NDAT,1) BUF(A1+NAI),BUF(A2+NAI),BUF(A3+NAI),K,I,NAI,
C    1 X,Y,COD,SID,YSID
      ENDDO
      ENDDO
      DO  I = IS,IE
      IST = A4+(I-IS)*NSAM4
      DO  K = 1,NSAM4
        BUF(IST+K) = AV
      ENDDO      
      ENDDO

151   FORMAT(4I5,9F12.2)
      NS1 = 1
      NS2 = NSAM4+1
      NRECZ = ISM+I4(NROWS)-1
C      WRITE(NOUT,1234) NRECZ,ISM,NROWS
C1234   FORMAT(1H ,'NRECZ,ISM,NROWS:',3I8)
C 	NREC1=ISM
C     IF(ISM.LE.0) NRECZ = 1
	IF(ISM.LE.0)NRECZ=NROWS
      NOFF = (IPATCH-1)*NPP
      NREC1=NRECZ
      CALL REDLIN(LUNI,BUF(NS1),NSAM,NREC1)
      DO 200 L = 1,NPPC
      IF(BUF(A3+L).LT.-1000.) GOTO 200
      J = BUF(A2+L)
      IF(J.LT.1.OR.J.GE.NROW4) GOTO 200
      Y = BUF(A2+L) -J
      YREM = 1.-Y
      IF(J.EQ.JPREV) GOTO 180
      JPREV = J
C     JP1 = J+1
	JP1=J+1+I4(NROWS)-1
      CALL REDLIN(LUNI,BUF(NS2),NSAM,JP1)
C ALTERNATE INPUT BUFFER ADDRESS
      NS1P = NS1
      NS1 = NS2
      NS2 = NS1P
180   K = BUF(A1+L)
      N = BUF(A3+L)+.5 - NOFF
      IF(K.GT.0.AND.K.LE.NSAMM) GOTO 190
      BUF(A4+N) = AV
      GOTO 200
190   X = BUF(A1+L)-K
      XREM = 1.-X
	NS1K=NS1+K
	NS2K=NS2+K
      BUF(A4+N) = Y*(BUF(NS1K-1)*XREM + BUF(NS1K)*X)
     1           +YREM*(BUF(NS2K-1)*XREM + BUF(NS2K)*X)
C     IF(BUF(A4+N).LT.0.)
C     WRITE(NDAT,151) K,J,N,IPATCH,BUF(NS1+K-1),BUF(NS1+K),BUF(NS2+K-1),
C    2 BUF(NS2+K),X,XREM,Y,YREM,BUF(A4+N)
200   CONTINUE
      DO  I = IS,IE
      IADR = A4 + (I-IS)*NSAM4+1
      K1 = IADR
      K2 = K1+NSAM4-1
C     WRITE(NDAT,301)(BUF(K),K=K1,K2)
301   FORMAT(10F12.5)
	NROWSI=I4(NROWS)+I-1
      CALL WRTLIN(LUNO,BUF(IADR),NSAM,NROWSI)
      ENDDO
      IF(IE.LT.NROW4) GOTO 10
      RETURN
400   WRITE(NOUT,401)
401   FORMAT(' BUFFER SECTION ADDRESS VIOLATION')
      WRITE(NOUT,151) K,I,NAI,NPPC
      RETURN
500   NSAM2 = NSAMH-1
      DO  K = 1,NSAM4
        BUF(K) = AV
      ENDDO
      CALL WRTLIN(LUNO,BUF,NSAM,NROWS)
	IS=NROWS+1
	IE=NROWE
      DO  I =IS,IE
	NROWEI=I4(NROWE)-I+2
      CALL REDLIN(LUNI,BUF,NSAM,NROWEI)
      DO  K = 1,NSAM2
      BUF(NSAM4+NSAM1+K) = BUF(NSAM1-K)
      BUF(NSAM4+NSAM1-K) = BUF(NSAM1+K)
      ENDDO
      BUF(NSAM4+1) = AV
      BUF(NSAM4+NSAM1) = BUF(NSAM1)
	JP1=I
      CALL WRTLIN(LUNO,BUF(NSAM+1),NSAM,JP1)
      ENDDO
      END
