
C++*************************************************************************
C
C $$ ROT3.FOR                         
C
C **************************************************************************
C
C  $$ ROT3(LUNI,LUNO,NSAM,NROW,NSLICE,MAXDI4,AV1,IFANGL,ALPH,BETA,GAMA, 
C          IFSHIF,SHX,SHY,SHZ)
C
C     3-D ROTATION ACCORDING TO EULER ANGLES
C           
C     ANGLES ARE ACCORDING TO THE CONVENTION THAT THEY AGREE WITH WHAT 
C     YOU SEE IN THE SLICES
C     
C     IF IFANGL AND IFSHIF ARE EQUAL TO 1 THIS SOUBROUTINE DOES NOT ASK
C     FOR ANYTHING AND PROCREEDS WITH THE GIVEN DATA
C
C     (ALPH AND BETA ARE THE SAME THAN IN MICHAEL'S PROJECTION PROGRAM)
C     
C     10/27/86 J.M.CARAZO
C
C--*******************************************************************

      SUBROUTINE ROT3 (LUNI,LUNO,NSAM,NROW,NSLICE,MAXDI4,AV1,
     1 IFANGL,ALPH,BETA,GAMA, IFSHIF,SHX,SHY,SHZ)

      COMMON BUF (1)
      INCLUDE 'CMBLOCK.INC' 

      INTEGER MAXDI4
      REAL ALPH, BETA, GAMA, RADDEG
      CHARACTER NULL,ANS

      DATA PI/3.14159269/
      NULL=CHAR(0)

C     LUNI AND LUNO ARE MAIN INPUT/OUTPUT VOLUMES

C     ASK FOR TILTING ANGLES (IF IFANGL.NE.0)

      IF (IFANGL .NE. 1) THEN
         CALL RDPRM2(ALPH,BETA,NLOOP,ILOOP,'ALPHA, BETA$')
         CALL RDPRM (GAMA,NLOOP,ILOOP,'GAMMA$')
      ENDIF

      ALPH=ALPH*PI/180
      BETA=BETA*PI/180
      GAMA=GAMA*PI/180


      IF (IFSHIF .NE. 1) THEN
C        ASK FOR ROTATIONAL CENTER AND AVERAGE
         SHX=0
         SHY=0
         SHZ=0
         CALL RDPRM2(SHX,SHY,NLOOP,ILOOP,'SHIFT IN X-Y$')
         CALL RDPRM (SHZ,NLOOP,ILOOP,'SHIFT IN Z$')
 
         CALL RDPRMC(ANS,NC,.TRUE.,
     &   'CHANGE DEFAULT MEAN VALUE? (N/Y)$',NULL,IRT)
         IF (ANS .EQ. 'Y') THEN
            CALL RDPRM(AV1,NLOOP,ILOOP,'VALUE OUTSIDE$')
         ENDIF
      ENDIF

C     IT COPIES LUNI INTO LUNO 

      IF (LUNI .NE. LUNO) THEN
        DO  I=1, NROW*NSLICE
           CALL REDLIN (LUNI,BUF,NSAM,I)
           CALL WRTLIN (LUNO,BUF,NSAM,I)  
	ENDDO
      ENDIF


C     IT MAKES THE FIRST ROTATION AROUND Z

      IF (ABS(ALPH).LT.0.0001) GOTO 1000

      DO  ISLICE=1, NSLICE  
         NROWS=(ISLICE-1)*NROW+1
         NROWE= NROWS + NROW -1
         NROWSK=-1
         CALL ROT32 (LUNO,LUNO,NSAM,NROWS,NROWE,NROWSK,
     1                MAXDI4,ALPH,AV1,SHX,SHY)
      ENDDO



C     IT MAKES THE ROTATION AROUND Y AS BEFORE

 1000 IF (ABS(BETA).LT.0.0001) GOTO 1001  

      BETA=-BETA
      DO  IROW=1,NROW
         NROWS=IROW         
         NROWE=(NSLICE-1)*NROW+IROW
         NROWSK=-NROW
         CALL ROT32 (LUNO,LUNO,NSAM,NROWS,NROWE,NROWSK,
     1               MAXDI4,BETA,AV1,SHX,SHZ)
      ENDDO

 1001 CONTINUE

C     THIS MAKES THE LAST ROTATION AROUND Z 

      IF (ABS(GAMA).LT.0.0001) GOTO 1002 

      DO  ISLICE=1,NSLICE
         NROWS=(ISLICE-1)*NROW+1
         NROWE=NROWS+NROW-1
         NROWSK=-1
         CALL ROT32 (LUNO,LUNO,NSAM,NROWS,NROWE,NROWSK,
     1               MAXDI4,GAMA,AV1,SHX,SHY)
      ENDDO


 1002 CONTINUE

      RETURN   
      END




