C++************************************************************************
C
C $$ ROTS3.FOR
C
C **************************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK            *
C *  COPYRIGHT (C)1981,1987, WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *  THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR       *
C *  LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR    *
C *  USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF     *
C *  THE CENTER FOR LABORATORIES AND RESEARCH   			   *
C **************************************************************************
C
C
C
C23456789012345678901234567890123456789012345678901234567890123456789012
C--************************************************************************
C
C $$ ROTS3.FOR
C
         SUBROUTINE  ROTL3
     &   (LUN2,Q1,Q2,NSAM,NROW,NSLICE,X1,X2,ALPHA)
         DIMENSION  Q1(NSAM,NROW,NSLICE),Q2(NSAM)
         DIMENSION  X1(3),X2(3)
C	DIMENSION  IM(3)
         DOUBLE PRECISION  AV,R1(3,3),R2(3,3),R3(3,3),QR(3),DX,DY,DZ
C         EQUIVALENCE  (IM(1),IX),(IM(2),IY),(IM(3),IZ)
CNO_SAVE
C
	x=x2(1)-x1(1)
	y=x2(2)-x1(2)
	z=x2(3)-x1(3)
         IF(ALPHA.EQ.0.0.OR.(X.EQ.0.0.AND.Y.EQ.0.0.AND.Z.EQ.0.0)) THEN
         IBUF=0
         DO    IZ=1,NSLICE
         DO    IY=1,NROW
         IBUF=IBUF+1
         CALL  WRTLIN(LUN2,Q1(1,IY,IZ),NSAM,IBUF)
	 ENDDO
	 ENDDO
         RETURN
         ENDIF
C...
C     AV=0.0
C     DO  1  IZ=KLZ,KNZ
C     DO  1  IY=KLY,KNY
C     DO  1  IX=KLX,KNX
C1    AV=AV+Q1(IX,IY,IZ)
C     AV=AV/FLOAT(KNX-KLX+1)/FLOAT(KNY-KLY+1)/FLOAT(KNZ-KLZ+1)
C...
	psi=-atan2d(y,x)
	theta=atan2d(z,sqrt(x*x+y*y))
	call  bldr(r1,psi,theta,90.0)
	call  bldr(r2,0.0,alpha,0.0)
C  -1
C R   U(ALPHA) R
C
         DO    I=1,3
         DO    J=1,3
         R3(J,I)=0.0
         DO    K=1,3
         R3(J,I)=R3(J,I)+R2(K,I)*R1(J,K)
	 ENDDO
	 ENDDO
	 ENDDO
         DO    I=1,3
         DO    J=1,3
         R2(J,I)=0.0
         DO    K=1,3
         R2(J,I)=R2(J,I)+R1(I,K)*R3(J,K)
	 ENDDO
	 ENDDO
	 ENDDO
C
	IBUF=0
	DO    IZ=1,NSLICE
	ZZ=IZ-X1(3)
	DO    IY=1,NROW
	YY=IY-X1(2)
         DO  5  IX=1,NSAM
        XX=IX-X1(1)
C
C         DO  3  I3=1,3
C         QR(I3)=0.0
C         DO  3  I2=1,3
C3        QR(I3)=QR(I3)+R2(I2,I3)*IM(I2)
C
        QR(1)=R2(1,1)*XX+R2(2,1)*YY+R2(3,1)*ZZ
        QR(2)=R2(1,2)*XX+R2(2,2)*YY+R2(3,2)*ZZ
        QR(3)=R2(1,3)*XX+R2(2,3)*YY+R2(3,3)*ZZ
        QR(1)=QR(1)+X1(1)
        QR(2)=QR(2)+X1(2)
        QR(3)=QR(3)+X1(3)
C
         IOX=QR(1)
         DX=QR(1)-IOX
         DX=DMAX1(DX,1.0D-5)
         IOY=QR(2)
         DY=QR(2)-IOY
         DY=DMAX1(DY,1.0D-5)
         IOZ=QR(3)
         DZ=QR(3)-IOZ
         DZ=DMAX1(DZ,1.0D-5)
C
         IF(IOX.GE.1.AND.IOX.LT.NSAM)  THEN
         IF(IOY.GE.1.AND.IOY.LT.NROW)  THEN
         IF(IOZ.GE.1.AND.IOZ.LT.NSLICE)  THEN
C
C
C     Q2(IX)=
C     &  +(1-DX)*(1-DY)*(1-DZ)*Q1(IOX,IOY,IOZ)
C     &  +   DX *(1-DY)*(1-DZ)*Q1(IOX+1,IOY,IOZ)
C     &  +(1-DX)*   DY *(1-DZ)*Q1(IOX,IOY+1,IOZ)
C     &  +(1-DX)*(1-DY)*   DZ *Q1(IOX,IOY,IOZ+1)
C     &  +   DX *   DY *(1-DZ)*Q1(IOX+1,IOY+1,IOZ)
C     &  +   DX *(1-DY)*   DZ *Q1(IOX+1,IOY,IOZ+1)
C     &  +(1-DX)*   DY *   DZ *Q1(IOX,IOY+1,IOZ+1)
C     &  +   DX *   DY *   DZ *Q1(IOX+1,IOY+1,IOZ+1)
C
C faster version :
C
         A1 = Q1(IOX,IOY,IOZ)
         A2 = Q1(IOX+1,IOY,IOZ) - Q1(IOX,IOY,IOZ)
         A3 = Q1(IOX,IOY+1,IOZ) - Q1(IOX,IOY,IOZ)
         A4 = Q1(IOX,IOY,IOZ+1) - Q1(IOX,IOY,IOZ)
         A5 = Q1(IOX,IOY,IOZ) - Q1(IOX+1,IOY,IOZ) - Q1(IOX,IOY+1,IOZ)
     &   + Q1(IOX+1,IOY+1,IOZ)
         A6 = Q1(IOX,IOY,IOZ) - Q1(IOX+1,IOY,IOZ) - Q1(IOX,IOY,IOZ+1)
     &   + Q1(IOX+1,IOY,IOZ+1)
         A7 = Q1(IOX,IOY,IOZ) - Q1(IOX,IOY+1,IOZ) - Q1(IOX,IOY,IOZ+1)
     &   + Q1(IOX,IOY+1,IOZ+1)
         A8 = Q1(IOX+1,IOY,IOZ) + Q1(IOX,IOY+1,IOZ)+ Q1(IOX,IOY,IOZ+1)
     &   - Q1(IOX,IOY,IOZ)- Q1(IOX+1,IOY+1,IOZ) - Q1(IOX+1,IOY,IOZ+1)
     &   - Q1(IOX,IOY+1,IOZ+1) + Q1(IOX+1,IOY+1,IOZ+1)
         Q2(IX)= A1 + DZ*(A4 + A6*DX + (A7 + A8*DX)*DY) + A3*DY
     &   + DX*(A2 + A5*DY)
C**********************************************************
         GOTO  5
         ENDIF
         ENDIF
         ENDIF
C...
C     Q2(IX)=AV
         Q2(IX)=Q1(IX,IY,IZ)
5        CONTINUE
	IBUF=IBUF+1
	CALL  WRTLIN(LUN2,Q2,NSAM,IBUF)
	ENDDO
	ENDDO
	END
