C++************************************************************************
C
C  ROTQS.FOR                               
C
C **********************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.    AUTHOR: J.FRANK      *
C *  COPYRIGHT (C)1985, 1996 HEALTH RESEARCH INCORPORATED, ALBANY, NY. *
C * THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO HEALTH            *
C * RESEARCH INC. AND ARE NOT TO BE DISCLOSED TO OTHERS OR USED        *
C * FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF       *
C * HEALTH RESEARCH INC.                                               *
C **********************************************************************
C
C   ROTQS(MAXDIM,LUN1,LUN2,LUN3,FILNAM,FILNAMO,NSAM,NROW,NSLICE,
C         MAXIM,IRTFLG)
C
C23456789 123456789 123456789 123456789 123456789 123456789 123456789 12
C--*********************************************************************

      SUBROUTINE ROTQS(MAXDIM,LUN1,LUN2,LUN3,FILNAM,FILNAMO,
     &                 NSAM,NROW,NSLICE,MAXIM,IRTFLG)

CNO_SAVE

      INCLUDE 'CMBLOCK.INC'

      COMMON         BUF(1)

      DIMENSION      ILIST(4)
      CHARACTER *(*) FILNAM,FILNAMO
      CHARACTER *81  DOCNAM
      CHARACTER      NULL
      DIMENSION      PBUF(1)
      POINTER        (IPQ,PBUF) 

      NULL   = CHAR(0)
      IRTFLG = 1

C     FIND MEMORY NEEED 
      K1     = 1 + NSAM * NROW
      MEMTOT = K1 + NSAM

      IF (MEMTOT .GT. MAXDIM)  THEN
C        OVERFLOW WILL OCCUR
         CALL  ERRT(6,'ROTQS',NE)
         RETURN
      ENDIF

      IF (MAXIM .LT. 0) THEN
C        SINGLE IMAGE OPERATION
         CALL RDPRM2S(THETA,SCLI,NLOOP,ILOOP,
     &             'ROTATION ANGLE, SCALE',IRTFLG)
         IF (IRTFLG .NE. 0) RETURN

	 IF (SCLI .EQ. 0.0) SCLI = 1.0

	 CALL  RDPRM2S(SHXI,SHYI,NLOOP,ILOOP,
     &                'SHIFTS IN X AND Y',IRTLFG)
         IF (IRTFLG .NE. 0) RETURN

C        LOAD AND ROTATE SLICE BY SLICE
	 DO L=1,NSLICE
	   LB = (L-1)*NROW
	   DO J=1,NROW
	      CALL  REDLIN(LUN1,BUF(1+(J-1)*NSAM),NSAM,LB+J)
	   ENDDO
C          ROTATE THIS SLICE
	   CALL  ROT2QS(BUF,BUF(K1),NSAM,NROW,THETA,SCLI,SHXI,SHYI,LUN2,LB)
	 ENDDO

C        RESET FILE HEADER FOR ALTERATIONS IN STATISTICS
         CALL SETPRMB(BUF,LUN2,NSAM,IDUM,0.0,0.0,0.0,'U')
         IRTFLG = 0

      ELSE
C        WHOLE STACK OPERATION
         NUMB = 4
         CALL RDPRAI(ILIST,4,NUMB,1,6,
     &      'ENTER REG. NUMBERS FOR ANGLE, SCALE, X, & Y SHIFT',
     &      NULL,IRTFLG)
         IF (IRTFLG .NE. 0) RETURN

C        MAXX IS 1 + NUM OF REGISTERS SINCE PBUB CONTAINS KEY ALSO
         MAXX   = MAX(ILIST(1),ILIST(2),ILIST(3),ILIST(4)) + 1
         MAXY   = 0
         CALL GETDOCDAT('ANGLE/SCALE DOCUMENT',.TRUE.,DOCNAM,LUN3,
     &             .TRUE.,MAXX, MAXY,IPQ,IRTFLG)
         IF (IRTFLG .NE. 0) RETURN

         DO NIMAGE = 1,MAXIM

C           GET INPUT IMAGE FROM STACK            
            CALL NEXTIMG(BUF,FILNAM,LUN1,NSAM,NROW,NSLICE,
     &                   NIMAGE,.FALSE.,IFORM,'Z',IRTFLG)

            IF (IRTFLG .EQ. 0) THEN
C              CREATE OUTPUT IMAGE IN STACK
               CALL NEXTIMG(BUF,FILNAMO,LUN2,NSAM,NROW,NSLICE,
     &                      NIMAGE,.FALSE.,IFORM,'U',IRTFLG)

               IF (IRTFLG .EQ. 0) THEN
C                 OUTPUT IMAGE CREATED OK
                  THETA = PBUF((NIMAGE - 1) * MAXX + ILIST(1) + 1)
                  SCLI  = PBUF((NIMAGE - 1) * MAXX + ILIST(2) + 1)
                  SHXI  = PBUF((NIMAGE - 1) * MAXX + ILIST(3) + 1)
                  SHYI  = PBUF((NIMAGE - 1) * MAXX + ILIST(4) + 1)
	          IF (SCLI .EQ. 0.0) SCLI = 1.0

C                 LOAD AND ROTATE SLICE BY SLICE
	          DO L=1,NSLICE
	             LB = (L-1)*NROW
	             DO J=1,NROW
	                CALL  REDLIN(LUN1,BUF(1+(J-1)*NSAM),NSAM,LB+J)
	             ENDDO
              
	             CALL ROT2QS(BUF,BUF(K1),NSAM,NROW,
     &                           THETA,SCLI,SHXI,SHYI, LUN2,LB)
                  ENDDO

                  WRITE(NOUT,90) THETA,SCLI,SHXI,SHYI 
90                FORMAT(' ANGLE: ',G10.3,'  SCALE: ',G10.3,
     &                   '  SHIFTS(',G10.3,',',G10.3,')',/)

C                 RESET HEADER FOR ALTERATIONS IN STATISTICS
                  CALL SETPRMB(BUF,LUN2,NSAM,IDUM,0.0,0.0,0.0,'U')
               ENDIF
            ENDIF
         ENDDO
      ENDIF

      RETURN
      END

