C++************************************************************************
C
C $$ ROTS3.FOR
C
C **************************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK            *
C *  COPYRIGHT (C)1981,1987, WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *  THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR       *
C *  LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR    *
C *  USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF     *
C *  THE CENTER FOR LABORATORIES AND RESEARCH   			   *
C **************************************************************************
C
C
C
C23456789012345678901234567890123456789012345678901234567890123456789012
C--************************************************************************
C
C $$ ROTS3.FOR
C
         SUBROUTINE  ROTS3
     &   (LUN2,Q1,Q2,KLX,KNX,KLY,KNY,KLZ,KNZ,PSI,THETA,PHI)
         DIMENSION  Q1(KLX:KNX,KLY:KNY,KLZ:KNZ),Q2(KLX:KNX)
C         DIMENSION  IM(3)
         DOUBLE PRECISION  AV,RM(3,3),QR(3),DX,DY,DZ
C         EQUIVALENCE  (IM(1),IX),(IM(2),IY),(IM(3),IZ)
CNO_SAVE
C
         LEX=KNX-KLX+1
         IF(THETA.EQ.0.0.AND.PHI.EQ.0.0.AND.PSI.EQ.0.0)  THEN
         IBUF=0
         DO    IZ=KLZ,KNZ
         DO    IY=KLY,KNY
         IBUF=IBUF+1
         CALL  WRTLIN(LUN2,Q1(KLX,IY,IZ),LEX,IBUF)
	 ENDDO
	 ENDDO
         RETURN
         ENDIF
C...
C     AV=0.0
C     DO  1  IZ=KLZ,KNZ
C     DO  1  IY=KLY,KNY
C     DO  1  IX=KLX,KNX
C1    AV=AV+Q1(IX,IY,IZ)
C     AV=AV/FLOAT(KNX-KLX+1)/FLOAT(KNY-KLY+1)/FLOAT(KNZ-KLZ+1)
C...
C
	CALL BLDR(RM,PSI,THETA,PHI)
C
         IBUF=0
         DO    IZ=KLZ,KNZ
         DO    IY=KLY,KNY
C
         DO  5  IX=KLX,KNX
C
C         DO  3  I3=1,3
C         QR(I3)=0.0
C         DO  3  I2=1,3
C3        QR(I3)=QR(I3)+RM(I2,I3)*IM(I2)
C
        QR(1)=RM(1,1)*IX+RM(2,1)*IY+RM(3,1)*IZ
        QR(2)=RM(1,2)*IX+RM(2,2)*IY+RM(3,2)*IZ
        QR(3)=RM(1,3)*IX+RM(2,3)*IY+RM(3,3)*IZ
C
         IOX=QR(1)+FLOAT(1-KLX)
         DX=QR(1)+FLOAT(1-KLX)-IOX
         DX=DMAX1(DX,1.0D-5)
         IOX=IOX+KLX-1
         IOY=QR(2)+FLOAT(1-KLY)
         DY=QR(2)+FLOAT(1-KLY)-IOY
         DY=DMAX1(DY,1.0D-5)
         IOY=IOY+KLY-1
         IOZ=QR(3)+FLOAT(1-KLZ)
         DZ=QR(3)+FLOAT(1-KLZ)-IOZ
         DZ=DMAX1(DZ,1.0D-5)
         IOZ=IOZ+KLZ-1
C
         IF(IOX.GE.KLX.AND.IOX.LT.KNX)  THEN
         IF(IOY.GE.KLY.AND.IOY.LT.KNY)  THEN
         IF(IOZ.GE.KLZ.AND.IOZ.LT.KNZ)  THEN
C
C
C     Q2(IX)=
C     &  +(1-DX)*(1-DY)*(1-DZ)*Q1(IOX,IOY,IOZ)
C     &  +   DX *(1-DY)*(1-DZ)*Q1(IOX+1,IOY,IOZ)
C     &  +(1-DX)*   DY *(1-DZ)*Q1(IOX,IOY+1,IOZ)
C     &  +(1-DX)*(1-DY)*   DZ *Q1(IOX,IOY,IOZ+1)
C     &  +   DX *   DY *(1-DZ)*Q1(IOX+1,IOY+1,IOZ)
C     &  +   DX *(1-DY)*   DZ *Q1(IOX+1,IOY,IOZ+1)
C     &  +(1-DX)*   DY *   DZ *Q1(IOX,IOY+1,IOZ+1)
C     &  +   DX *   DY *   DZ *Q1(IOX+1,IOY+1,IOZ+1)
C
C faster version :
C
         A1 = Q1(IOX,IOY,IOZ)
         A2 = Q1(IOX+1,IOY,IOZ) - Q1(IOX,IOY,IOZ)
         A3 = Q1(IOX,IOY+1,IOZ) - Q1(IOX,IOY,IOZ)
         A4 = Q1(IOX,IOY,IOZ+1) - Q1(IOX,IOY,IOZ)
         A5 = Q1(IOX,IOY,IOZ) - Q1(IOX+1,IOY,IOZ) - Q1(IOX,IOY+1,IOZ)
     &   + Q1(IOX+1,IOY+1,IOZ)
         A6 = Q1(IOX,IOY,IOZ) - Q1(IOX+1,IOY,IOZ) - Q1(IOX,IOY,IOZ+1)
     &   + Q1(IOX+1,IOY,IOZ+1)
         A7 = Q1(IOX,IOY,IOZ) - Q1(IOX,IOY+1,IOZ) - Q1(IOX,IOY,IOZ+1)
     &   + Q1(IOX,IOY+1,IOZ+1)
         A8 = Q1(IOX+1,IOY,IOZ) + Q1(IOX,IOY+1,IOZ)+ Q1(IOX,IOY,IOZ+1)
     &   - Q1(IOX,IOY,IOZ)- Q1(IOX+1,IOY+1,IOZ) - Q1(IOX+1,IOY,IOZ+1)
     &   - Q1(IOX,IOY+1,IOZ+1) + Q1(IOX+1,IOY+1,IOZ+1)
         Q2(IX)= A1 + DZ*(A4 + A6*DX + (A7 + A8*DX)*DY) + A3*DY
     &   + DX*(A2 + A5*DY)
C**********************************************************
         GOTO  5
         ENDIF
         ENDIF
         ENDIF
C...
C     Q2(IX)=AV
         Q2(IX)=Q1(IX,IY,IZ)
5        CONTINUE
         IBUF=IBUF+1
         CALL  WRTLIN(LUN2,Q2,LEX,IBUF)
	 ENDDO
	 ENDDO
         END
