
C-***********************************************************************
C
C     USED IN FUZZY CLASSIFICATION
C
C     CALLED BY: RO2TEST
C
C-***********************************************************************

      SUBROUTINE ROUB2 (D,MU,U,N,C,M,EPSIL,MAXIT,ITER)

      PARAMETER (IN=600,IC=10)
      INTEGER C,FLAG,MU(IN)
      REAL M
      DIMENSION D(IN,1),U(IN,1),DIST(IC)

      EM=2./(M-1.)
C
C     STEP 1 : INITIAL PARTITION
C
      L=1
      DO  I=1,N
         MU(I)=L
         L=L+1
         IF (L.GT.C) L=1
      ENDDO
C
C     MAIN LOOP
C
      DO  ITER=1,MAXIT
C
C        STEP 2 : HARD DISTANCES AND MEMBERSHIP FUNCTIONS
C
         FLAG=0
         DO  K=1,N
            SUM=0.
            DO  J=1,C
               DIST(J)=0.
               S=0.
               DO  I=1,N
                  IF (MU(I).EQ.J) THEN
                     DIST(J)=DIST(J)+D(K,I)
                     S=S+1.
                  ENDIF
	       ENDDO
               DIST(J)=DIST(J)/S
               DIST(J)=(1./DIST(J))**EM
            SUM=SUM+DIST(J)
	    ENDDO
            DO  J=1,C
               AD=U(K,J)
               U(K,J)=DIST(J)/SUM
               IF (ABS(AD-U(K,J)).GT.EPSIL) FLAG=1
	ENDDO
	ENDDO
C
C        CHECK CONVERGENCE
C
         IF (FLAG.EQ.0) RETURN
C
C        UPDATE MU FUNCTIONS
C
         DO  K=1,N
            AMIN=1.E+7
            DO  J=1,C
               DIST(J)=0.
               DO  I=1,N
                IF (MU(I).EQ.J) DIST(J)=DIST(J)+(U(I,J)**M)*D(K,I)
	       ENDDO
               IF (DIST(J).LT.AMIN) THEN
                  AMIN=DIST(J)
                  MU(K)=J
               ENDIF
	    ENDDO
	ENDDO
C
C 
      ENDDO
      ITER=ITER-1
      RETURN
      END

