
C++*********************************************************************
C
C **********************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK            *
C *  COPYRIGHT (C)1981,1987, WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH 			   *
C **********************************************************************
C
c  Shift alignment  07/31/91, non-power-of-two dimensions
C     Subtraction of an image from the average.
c     Quadratic interpolation as an option.
c     Scratch file on the disk
C
c  Procedures called:
C     	SUBROUTINE  SAQB(MAXMEM)
C    	SUBROUTINE  SAQB_P(BUF,NSAM,NROW,NIMA,NGRP,JACUP,
C    	SUBROUTINE  SAQB_F(BUF,NSAM,NROW,NIMA,NGRP,JACUP,
C 	SUBROUTINE  UPDTF(C,A,N,IMI)
C	SUBROUTINE  COP(A,B,N)
C	SUBROUTINE  CRSM_2(X,Y,O,NSAM,NROW,WRK)
C	SUBROUTINE   MLC(X,Y,O,N)
C	SUBROUTINE  SHFC_2(X,Y,NSAM,NROW,WRK,SX,SY)
C	SUBROUTINE  SH180_2(X,Y,NSAM,NROW,WRK,SX,SY)
C	SUBROUTINE  SHFM_2(X,NSAM,NROW,WRK,SX,SY)
C	SUBROUTINE  CR180_2(X,Y,O,NSAM,NROW,WRK)
C	SUBROUTINE   MJC(X,Y,O,N)
C	SUBROUTINE  FMR_2(X,NSAM,NROW,WORK,INV)
C	SUBROUTINE  FMR_1(X,N,WORK,INV)
C       SUBROUTINE  FFTMCF (A,B,NTOT,N,NSPAN,ISN)
C	SUBROUTINE  FINDMX(D,NSAM,NROW,CMX,SX,SY,JACUP)
C	DOUBLE PRECISION FUNCTION ENFR_2(A,NSAM,NROW)
C       SUBROUTINE  RTQ(X,OUT,NSAM,NROW,THETA)
C       FUNCTION QUADRI(XX, YY, NXDATA, NYDATA, FDATA)
C
	SUBROUTINE SAQB(MAXMEM)
        INCLUDE 'CMBLOCK.INC'  
	COMMON  DUMMY(80),BUF(1024),KAF(1)
	DIMENSION Q(1)
	POINTER   (IPQ,Q) 
	LOGICAL         RUNTIME 
	COMMON  /FISPEC/  FINPAT,NLET,FINPIC,DOCFIL,NLETI
	CHARACTER*80  FINPAT,DOCFIL,FINPIC
	CHARACTER*1  NULL,FLIP
	DATA  INPIC/77/,NDOC/55/
CNO_SAVE
C       ASK FOR DATA FILE
        NULL=CHAR(0)
	CALL  FILERD(FINPAT,NLET,NULL,'INPUT',INTFLG)
 	CALL  OPENFB(BUF,FINPAT,INPIC,NSAM,NROW,'O',NF,NSL)
 	IF (NF.NE.2)  THEN
	   WRITE(NOUT,*)  ' *** No such file !'
	   CLOSE(INPIC)
           CALL ERRT(100,'SAQB',IERT)
	   RETURN
	ENDIF
	CLOSE(INPIC)
	CALL  FILERD(DOCFIL,NLETI,NULL,
     &		'DOCUMENT (WITH GROUP ASSIGNMENT)',IRTFLG)
	IF (IRTFLG.EQ.-1)  RETURN
	CALL  RDPRMI(NGRP,NIMA,NLOOP,ILOOP,'GROUP NUMBER')
	CALL  RDPRMC(FLIP,NA,.TRUE.,'CHECK 180 DEG POSITION (Y/N)',
     &      NULL,ITRFLG)

C	CALL  RDPRMI(JACUP,NDUMP,NLOOP,ILOOP,
C     &	         'PRECISION OF PEAK LOCATION (0..100)')
C	JACUP=MAX0(0,MIN0(100,JACUP))

	JACUP=0

	K=0
	K2=1
	NIMA=0
778	LERR=-1
	KP1=K+1
	CALL  UNSAV(DOCFIL,K,NDOC ,KP1,BUF,4,LERR,K2)
	IF(LERR.EQ.0)  THEN
	  IF(IFIX(BUF(4)).EQ.NGRP)  NIMA=NIMA+1
	  K=K+1
	  GOTO  778
	ENDIF
	IF(NIMA.EQ.0)  THEN
	  WRITE(NOUT,*)  ' *** Desired group not found !'
	  CLOSE(NDOC)
	  RETURN
        ENDIF
C
	LSD=NSAM+2-MOD(NSAM,2)
C
C   memory division    K
C       ---            1
C       X              9
C	CKOT	       2
C       SHIFT          3
C       ENER           4  !Double precision!
C       A              5
C       B              6
C       C              7
C       D              8
C       DIST           10
C       CNEW           11

	  K1=1
	  K9=K1
	  K2=IPALIGN64(K9+LSD*NROW*NIMA)
	  K3=IPALIGN64(K2+NIMA)
	  K4=IPALIGN64(K3+2*NIMA)
 	  K5=IPALIGN64(K4+2*NIMA)
	  K6=IPALIGN64(K5+LSD*NROW)   
	  K7=IPALIGN64(K6+LSD*NROW) 
	  K8=IPALIGN64(K7+LSD*NROW)
	  K10=IPALIGN64(K8+LSD*NROW)
	  K11=IPALIGN64(K10+NIMA)
	  K12=IPALIGN64(K11+LSD*NROW)
	  L2=K2
	  L3=L2
	 
	MEMTOT=1200+MAX0(K12,L3)
        CALL CHKMEM(MEMTOT, KAF, MAXMEM-(1024+80), 
     &	            RUNTIME,IPQ,IRTFLG)
	IF(IRTFLG.EQ.0) THEN 

	   IF (FLIP .EQ. 'Y')  THEN
    	      CALL  SAQB_P(BUF,LSD,NSAM,NROW,NIMA,NGRP,JACUP,
     &	             Q(K2),Q(K3),Q(K4),Q(K5),Q(K6),
     &	             Q(K7),Q(K8),Q(K9),Q(K10),Q(K11))
	   ELSE
    	      CALL  SAQB_F(BUF,LSD,NSAM,NROW,NIMA,NGRP,JACUP,
     &	             Q(K2),Q(K3),Q(K4),Q(K5),Q(K6),
     &	             Q(K7),Q(K8),Q(K9),Q(K10),Q(K11))
	   ENDIF
C
	   CALL  FILERD(FINPAT,NLET,NULL,'OUTPUT',INTFLG)
 	   CALL  OPENFB(BUF,FINPAT,INPIC,NSAM,NROW,'UNKNOWN',NF,NSL)
 	   IF (NF.NE.2)  THEN
	      CALL  ERRT(4,'SAQB  ',NE)
	      GOTO  5
	   ENDIF
	   INS = -1
	   CALL  FMRS_2(Q(K11),NSAM,NROW,INS)
 	   DO    J=1,NROW
	   CALL  WRTLIN(INPIC,Q(K11+(J-1)*LSD),NSAM,J)
	   ENDDO
5	   CLOSE(INPIC)
	   WRITE (NDAT,2600) 
           IF (RUNTIME) CALL ALLOCIT(0,RUNTIME,IPQ,'SAQB',IRTFLG) 
	ELSE
	   I=MAXMEM-1024-80
	   WRITE(NOUT,2700) MEMTOT,I
        ENDIF
	CLOSE(NDOC)
        RETURN
 2500 FORMAT (/,' MEMORY RESERVATION: YOU HAVE',              
     &    ' RESERVED ',I8,',  YOU NEED  ',I8 / )
 2600 FORMAT (/' ',80('-')//' ',' Shift alignment,  ',
     &      'end of computation',//' ',80('-')/)
 2700   FORMAT (/,' SAQB.F: SHIFT ALIGNMENT. MEMORY   ',              
     $       ' RESERVED: ',I8,',  NEEDED:  ',I8 / )
        END
