
C++*************************************************************************
C
C SAVD.FOR
C                                       ALTERED JAN 18 1988 al
C                                       LONG FILE NAMES JAN 88 al
C **************************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK            *
C *  COPYRIGHT (C)1981,1987, WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH 			   *
C **************************************************************************
C
C  SAVD(NDOC,DLIST,NLIST,IRTFLG)
C
C  PURPOSE: SAVE PARAMETERS IN DOCUMENT FILE, CALLED INSIDE A PROGRAM, 
C           SOLICITS FILENAME & OPEN DOC FILE ON FIRST CALL
C
C  PARAMETERS:
C       NDOC     LUN NUMBER OF FILE TO SAVE REGISTERS             (SENT)
C	DLIST    ARRAY CONTAINING FLOATING PT. NUMBERS            (SENT)
C                      TO BE SAVED.
C	NLIST    NUMBER OF ELEMENTS IN ARRAY                      (SENT)
c       IRTFLG   ERROR FLAG (0 IS NORMAL)                     (RETURNED)
C
C  NOTE:         HAS SAVDC ENTRY POINT!!!!
C
C--*************************************************************************

	SUBROUTINE SAVD(NDOC,DLIST,NLIST,IRTFLG)

	COMMON /UNITS/LUN,NIN,NOUT,NECHO,IFOUND,NPROC,NDAT
	COMMON /MASTER/NSAM,NROW,IREC,NLABEL,IFORM,IMAMI,FMAX,FMIN,
     &          AV,SIG,IHIST,IPROT

	DIMENSION     DLIST(*)
        CHARACTER *81 DOCNAM
        CHARACTER *1  NULL
	LOGICAL       EX,NEWFILE

	DATA          NRUN/0/

        NULL = CHAR(0)

	IF (NRUN .LE. 0) THEN
C         DOC FILE NOT OPENED YET
          NRUN = NRUN + 1

          CALL OPENDOC(DOCNAM,.TRUE.,NLET,NDOC,.TRUE.,
     &                 .FALSE.,.TRUE.,.TRUE.,NEWFILE,IRTFLG)
          IF (IRTFLG .NE. 0) RETURN

	  NUMFIL = NUMFIL+1
        ENDIF

        IGO    = 2
        LEFT   = NLIST - IGO + 1
	ICOUNT = MIN0(LEFT,6)

C       IKEY IS THE KEY NUMBER.
C       ICOUNT IS THE NUMBER OF REGISTERS (VALUES) IN THE LINE.

        IF (DLIST(1) .LT. 0.0) THEN
C         COMMENT KEY DESIRED
          IKEY = ABS(DLIST(1))
          IF (IKEY .GT. 999) THEN
             WRITE(NOUT,9999)IKEY
9999         FORMAT(' *** COMMENT KEY:',I6,' MUST BE < 1000'/)
             IRTFLG = 1
             RETURN
          ENDIF
          WRITE(NDOC,1491) IKEY,ICOUNT,(DLIST(K),K=2,ICOUNT+1)
1491	  FORMAT(' ;',I3,' ',I1,6G12.5)

        ELSE
C         REGULAR KEY DESIRED
C         number allowed raised to 99999.   ML 06/22/99
C
          IKEY = DLIST(1) + 0.5
          IF (IKEY .GT. 99999) THEN
             WRITE(NOUT,9932)IKEY
9932         FORMAT(' *** KEY:',I9,' MUST BE < 100000'/)
             IRTFLG = 1
             RETURN
          ENDIF

          WRITE(NDOC,1462) IKEY,ICOUNT,(DLIST(K),K=2,ICOUNT+1)
1462	  FORMAT(I5,' ',I1,6G12.5)
20        IGO = IGO + ICOUNT
          LEFT   = NLIST - IGO + 1
	  ICOUNT = MIN0(LEFT,6)

          IF (LEFT .GT. 0) THEN
C           CONTINUATION LINE OF REGISTERS PRESENT
            WRITE(NDOC,1469) ICOUNT,(DLIST(K),K=IGO,IGO+ICOUNT-1)
1469        FORMAT('  -99 ',I1,6G12.5)
            GOTO 20
          ENDIF
        ENDIF

        IRTFLG = 0
	RETURN

	ENTRY SAVDC
	NRUN = 0
	
	RETURN
	END

