
C++************************************************************************
C
C SAVDN1.FOR
C                                              LONG FILENAMES JAN 89 al
C **************************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK            *
C *  COPYRIGHT (C)1981,1987, WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH 			   *
C **************************************************************************
C
C    SAVDN1(NDOC,DOCNAM,DLIST,NLIST,NRUN,IAP)
C
C    PURPOSE:    SUBROUTINE TO SAVE PARAMETERS IN DOCUMENT FILE WHICH
C                MAY BE ALREADY OPENED, CALLED INSIDE A PROGRAM
C
C    PARAMETERS:   NDOC    LUN NUMBER OF FILE TO SAVE REGISTERS   (SENT)
C                  DOCNAM  NAME FOR DOC FILE 
C                              (SPIDER EXTENSION NOT NECESSARY)   (SENT)
C                  DLIST   ARRAY CONTAINING FLOATING PT. NUMBERS  (SENT)
C                                 TO BE SAVED.
C	           NLIST   NUMBER OF ELEMENTS IN ARRAY            (SENT)
C                  NRUN    0 IF FIRST CALL (OPENS FILE), ELSE 1   (SENT)
C                  IAP     1 IF OPEN/APPEND, 0 IF OPEN/REWIND     (SENT)
C
C--*******************************************************************

	SUBROUTINE SAVDN1(NDOC,DOCNAM,DLIST,NLIST,NRUN,IAP)

	COMMON /UNITS/LUN,NIN,NOUT,NECHO,IFOUND,NPROC,NDAT
	COMMON /MASTER/NSAM,NROW,IREC,NLABEL,IFORM,IMAMI,FMAX,FMIN,
     &                 AV,SIG,IHIST

	DIMENSION      DLIST(1)
	CHARACTER *(*) DOCNAM
	CHARACTER *1   NULL
	LOGICAL        ADDEXT,APPEND,NEWFILE                

        NULL = CHAR(0)

	IF (NRUN .LE. 0) THEN
C         FIRST CALL OF THIS ROUTINE

          ADDEXT = .TRUE.
          IF (INDEX(DOCNAM,'.') .NE. 0)  ADDEXT = .FALSE.

          APPEND = .TRUE.
          IF (IAP .EQ. 0) APPEND = .FALSE.

          CALL OPENDOC(DOCNAM,ADDEXT,NLET,NDOC,.FALSE.,
     &                 .FALSE.,APPEND,.TRUE.,NEWFILE,IRTFLG)
          IF (IRTFLG .NE. 0) RETURN

        ENDIF


        IKEY = DLIST(1)+.5

C       CAN OPEN FILE WITHOUT PUTTING DATA IN YET IF NLIST == 0
        IF (NLIST .EQ. 0) RETURN

        IF (NLIST .LE. 7) THEN
           ICOUNT = NLIST-1

C          IKEY IS THE KEY NUMBER.
C          ICOUNT IS THE NUMBER OF NUMBERS IN THAT LINE.

           WRITE(NDOC,1462)IKEY,ICOUNT,(DLIST(K),K=2,NLIST)
1462       FORMAT(I5,' ',I1,6G12.5)
           RETURN
        ENDIF

C       WRITE FIRST LINE INTO DOC FILE
        ICOUNT = 6
        WRITE(NDOC,1462) IKEY,ICOUNT,(DLIST(K),K=2,7)

C       FIND OUT IF THERE ARE MORE LINES
        K2 = NLIST-6
        IF (K2 .LT. 6) THEN
C          THIS IS A PARTIAL CONTINUATION LINE
           ICOUNT = K2-1
           WRITE(NDOC,1468)ICOUNT,(DLIST(J),J=NLIST-K2+2,NLIST)
           RETURN
        ENDIF

        DO  K=8,NLIST,6
C          WRITE NEXT FULL CONTINUATION LINE INTO DOC FILE
           WRITE(NDOC,1468) ICOUNT,(DLIST(NSIX),NSIX=K,K+5)
1468	   FORMAT('   -99',' ',I1,6G12.5)
           K2 = NLIST-K-5
           IF (K2 .LE. 0) RETURN
           IF (K2 .LT. 6) THEN
C            WRITE PARTIAL CONTINUATION LINE INTO DOC FILE
             ICOUNT = K2-1
             WRITE(NDOC,1468) ICOUNT,(DLIST(J),J=NLIST-K2+2,NLIST)
             RETURN
           ENDIF
        ENDDO

        RETURN
	END

