
C ***********************************************************************
C
C   SCLASSI(MAXMEM)
C
C   2/6/86 J.F. Spider CLASSification Interface routine
C
C   INTERFACES BETWEEN JP'S CLUSTERING/HAC PACKAGE AND SPIDER
C   LONG FILE NAMES FEB 89 al
C  
C   CALLED BY: UTIL1
C
C   CALL TREE: SCLASSI - RCLU    - RGRI     
C              SCLASSI - SCLASSY - SEMIS - NOYAU - PARST - RETIR - SEN3A  
C                                                - CLAST  
C                                                - STABK - SHELK   
C                                                - DEUCL  
C                                                - CHAVA 
C                                                - ARBRE
C                                                - DENDRO -
C                                                - COUPE
C
C ***********************************************************************

	SUBROUTINE SCLASSI(MAXMEM)

        INCLUDE 'CMBLOCK.INC' 
CNO_SAVE

        CHARACTER *81   CLUS,IMC,CLUSO,FILPAT,IMCO
        COMMON /COMMUN/ CLUS,IMC,CLUSO,IMCO,FILPAT

        PARAMETER       (LFA=16)
        CHARACTER       NULL
	INTEGER         KV(LFA),KKV(LFA)

        DATA MININT/-32000/,MAXINT/32000/
        DATA NKLA/100/

        NULL = CHAR(0)

        NGUS = 11
        NGRI = 12

        NNBASE=4
        NNITER=5
        NNCLAS=5
        CALL RDPRMI(NUM,IDUM,NLOOP,ILOOP,'INPUT FILE CODE')
        IF (NUM .GE. 1000) THEN
          FILPAT(1:11)= 'IMC****'//NULL//NULL//NULL//NULL
          NLET = 7
        ELSE
          FILPAT(1:11)= 'IMC***'//NULL//NULL//NULL//NULL//NULL
          NLET = 6
        ENDIF

        CALL FILGET(FILPAT,IMC,NLET,NUM,IRTFLG)
        IF (IRTFLG .NE. 0) RETURN
        CALL FILCAN(IMCO,NF,NULL,NULL,IMC,DATEXC,IER)

        CALL FILERD(CLUS,NLET,NULL,'CLUSTER',IRTFLG)
        IF (IRTFLG .NE. 0) RETURN
        CALL FILCAN(CLUSO,NF,NULL,NULL,CLUS,DATEXC,IER)

        KFACT = LFA
        CALL RDPRAI(KKV,LFA,KFACT,0,MAXINT,'FACTOR NUMBERS',
     &              NULL,IRTFLG)
        IF (IRTFLG .NE. 0) RETURN

        DO  II=1,KFACT
           KV(II)=KKV(II)
	ENDDO

        CALL RDPRMI(NITER,NCLAS,NLOOP,ILOOP,
     $              '# OF ITER./PART., # CENTERS/PART.')
        IF(NITER.EQ.0) NITER=NNITER
        IF  (NCLAS.EQ.0) NCLAS=NNCLAS

        CALL RDPRMI(NBASE,NDUM,NLOOP,ILOOP,' # OF PARTITIONS')
        IF (NBASE.EQ.0) NBASE=NNBASE

        CALL SCLASSY(NBASE,NITER,NCLAS,NKLA
     $              ,KFACT,NIN,NDAT,KV,IMCO,CLUSO,NGUS,NGRI,MAXMEM)

C       PRINT OUT LISTS OF CLUSTER MEMBERS, LIST OF CENTERS OF GRAVITY, 
C       AND RE-CLASSIFICATION LOOKUP TABLE

	CALL RCLU(NGRI,NGUS,MAXMEM)

        CLOSE(NGRI)
        CLOSE(NGUS)

        RETURN
        END

