C *NAME* = SEMIS.FOR                   31-JAN-86      13:23:12                  
C----------------------------------=*=----------------------------------        
C           COPYRIGHT 1986 - JEAN-PIERRE BRETAUDIERE                            
C THE UNIVERSITY OF TEXAS HEALTH SCIENCE CENTER AT HOUSTON                      
C MEDICAL SCHOOL - DEPARTMENT OF PATHOLOGY AND LABORATORY MEDICINE              
C P.O. BOX 20708, HOUSTON, TX 77225.                                            
C DISCLAIMER: NO GUARANTEES OF PERFORMANCE ACCOMPANY THIS SOFTWARE,             
C NOR IS ANY RESPONSIBILITY ASSUMED ON THE PART OF THE AUTHOR                   
C OR THE INSTITUTION.  ALL THE SOFTWARE HAS BEEN TESTED EXTENSIVELY             
C AND EVERY EFFORT HAS BEEN MADE TO INSURE ITS RELIABILITY.                     
C THE FOLLOWING SOFTWARE MAY NOT BE COMMUNICATED TO A THIRD PARTY               
C UNDER ANY FORM WITHOUT WRITTEN PERMISSION OF THE AUTHOR.                      
C PLEASE REPORT ANY BUG(S) TO JPB AT (713) 792 52 00.                           
C OR THRU ARPANET AT  ......!rice!ots!ut-path!suprim                            
C*--------------------------------------------------------------------*         
C* CLASSIFICATION OF OBJECTS ACCORDING TO THEIR FACTORIAL COORDINATES *         
C*                                                                    *         
C*  ROUTINES CALLED - NOYAU - PARST - RETIR - SEN3A                   *         
C*                                  - CLAST                           *         
C*                                  - STABK - SHELK                   *         
C*                          - DEUCL                                   *         
C*                          - CHAVA                                   *         
C*                          - ARBRE                                   *         
C*                          - COUPE                                   *         
C*                                                                    *         
C==02.09.81                                                           *         
C==01.11.86                                                           *         
C*--------------------------------------------------------------------*         
      SUBROUTINE SEMIS (Q, MAXMEM, NGUS, NGRI, MODE,                           
     #               ICARD, NFAC, KFAC, KV, NBASE, NITER, NCLAS, NKLA)          
C
      DIMENSION  Q(MAXMEM), KV(16)                                              
      COMMON  / ENSOR / LEC,IMP                                                 
C                                                                               
      WRITE (IMP,2000)                                                          
      WRITE(IMP, 2100)  (KV(K), K=1, KFAC)                                      
      WRITE(IMP, 2150)  NBASE, NITER, NCLAS, NKLA                               
        IF (KFAC .LE. 0)                 GO TO  50                              
C                                                                               
C......... MEMORY SEGMENTATION                                                  
C                                                                               
      N2DIM = MAX0 (NKLA, 2*NCLAS)                                              
      KDIM  = MAX0 (ICARD, NCLAS**NBASE)                                        
      KDIM  = MAX0 (KDIM,  2*NKLA - 1)                                          
      MDIM  = NKLA*(NKLA-1) / 2                                                 
      LDIM  = NKLA                                                              
      L2DIM = 2*NKLA - 1                                                        
C                                                                               
      NKLAS = 1 + ICARD                                                         
C     NKLAS = 1                                                                 
      ND    = NKLAS + ICARD                                                     
      NU    = ND + MDIM                                                         
      NJV   = NU + KDIM                                                         
      NJW   = NJV + KDIM                                                        
      NIDK  = NJW + KDIM                                                        
      NCI   = NIDK + NKLA                                                       
      NGT   = NCI + NFAC                                                        
      NNUM  = NGT + N2DIM*KFAC                                                  
      NLA   = NNUM + LDIM                                                       
      NLB   = NLA + LDIM                                                        
      NIV   = NLB + LDIM                                                        
      NIW   = NIV + LDIM                                                        
      NV    = NIW + LDIM                                                        
      NW    = NV + LDIM                                                         
      NNT   = NW + LDIM                                                         
      NVAL  = NNT + L2DIM                                                       
      NPK   = NVAL + L2DIM                                                      
      NNO   = NPK + L2DIM                                                       
      NFIN  = NNO + L2DIM                                                       
      WRITE (IMP,2500)  MAXMEM , NFIN                                           
        IF (NFIN .GT. MAXMEM)            GO TO  50                              
C                                                                               
C.......... CALL PRINCIPAL ROUTINE FOR CALCULATIONS                             
C                                                                               
      CALL NOYAU (N2DIM,KDIM,MDIM,LDIM,L2DIM,                                   
     #             NFAC,KFAC,ICARD,KV,NBASE,NITER,NCLAS,NKLA, Q(1),             
     #  Q(NKLAS),Q(ND),Q(NU),Q(NJV),Q(NJW),Q(NIDK),Q(NCI),Q(NGT),               
     #  Q(NNUM),Q(NLA),Q(NLB),Q(NIV),Q(NIW),Q(NV),Q(NW),                        
     #  Q(NNT),Q(NVAL),Q(NPK),Q(NNO) ,NGUS,NGRI, MODE)                          
   50 WRITE (IMP,2600)                                                          
 1000 FORMAT (20I4)                                                             
 2000 FORMAT ('1',52X,'STEP    ** CLASSY **'///1X,130('-'))                     
 2100 FORMAT (//1X,'SPECIFICATIONS FOR   CLASSY'/' ',10X,                       
     # 'FACTORS USED :',/' ',10X, 16I4)                                         
 2150 FORMAT(/' ',10X,'NBASE=',I4,5X,  'NITER=',I4,5X,                          
     # 'NCLAS=',I4,5X,'NKLA =',I4)                                              
 2500 FORMAT (/ ' ','MEMORY RESERVATION'       ,10X ,  'YOU HAVE',              
     #    ' RESERVED',I6,10X ,'YOU NEED'            ,I6 / )                     
 2600 FORMAT (//' ',130('-')//' ',48X,                                          
     #      'END OF STEP      ** CLASSY **',//' ',130('-'))                     
         RETURN                                                                 
         END                                                                    
