
C++************************************************************************
C
C SETMODE
C
C **************************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK            *
C *  COPYRIGHT (C)1981,1993, WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH 			   *
C **************************************************************************
C
C   SETMODE
C
C   PURPOSE:   CONTAINS CODE FOR SETTING MODE IN SPIDER 
C              REMOVED FROM DRIVER.FOR MAR 93 al
C
C23456789 123456789 123456789 123456789 123456789 123456789 123456789 12
C--*********************************************************************

        SUBROUTINE SETMODE

	INCLUDE 'CMBLOCK.INC' 

C       RUN-TIME ALLOCATION SPECIFIC CODE FOLLOWS

#ifdef SP_NT
        INTEGER         LOCLUN
#else
        INTEGER * 8     LOCLUN
#endif
        LOGICAL         USEINLN
        COMMON /LUNARB/ LOCLUN(100),NSAMLUN(100),NWORDLUN(100),USEINLN
        LOGICAL ONSUN,ONUNIX,ONSGI,ONOSF
        COMMON /OPSYS/ ONSUN,ONUNIX,ONSGI,ONOSF,MEMALLOCABLE

C       NUMBER OF OPERATIONS IN MODE MENU
        PARAMETER (IMOFNC = 13)

        CHARACTER * 10         MODE
        CHARACTER * 10         MOMENU(IMOFNC)
	CHARACTER * 1 	       NULL
	
        DATA MOMENU/'ME        ','STA       ',
     &              'TR ON     ','TR OFF    ',
     &              'OP ON     ','OP OFF    ',
     &              'VB ON     ','VB OFF    ',
     &              'MOSAIC ON ','MOSAIC OFF',
     &              'INLN BUFF ','SET MP    ',
     &              'SET MEM   '/

        DATA MPINUSE/0/
	NULL=CHAR(0)
C       MODE SWITCH OPERATION
C       READ IN THE MODE.  IF NOTHING TYPED IN, GET NEXT OPERATION
9400	CALL RDPRMC(MODE,NALPH,.TRUE.,'MODE',NULL,IRTFLG)
	IF (MODE(1:1).EQ.' ') RETURN
        CALL SSUPCAS(MODE)

C       LOOK THRU THE MENU OF MODES, AND GO TO THE APPROPRIATE ONE.
	DO I=1,IMOFNC
C          COPY MODE TO TEMP & UPCASE IT FOR COMPARISON...
           IF (MODE .EQ. MOMENU(I)(:10)) THEN
              GOTO (30, 35, 40, 45, 50, 45, 55, 60, 70, 75, 
     &              80, 85, 90),I
           ENDIF
        ENDDO
	WRITE(NOUT,*) '*** UNKNOWN MODE'
	GOTO 9400

C       MENU  ME
30      WRITE(NOUT,9610)
9610	FORMAT(/
     &	'  ME   '     ,T19, ' MODE MENU'/
     &	'  STA   '    ,T19, ' STATUS OF MODES '/
     &	'  TR ON     ',T19, ' TRACE ON '/
     &	'  TR OFF    ',T19, ' TRACE OFF '/
     &	'  OP ON     ',T19, ' SHOW OPERATION '/
     &	'  OP OFF    ',T19, ' SHOW OPERATION OFF '/
     &	'  VB ON     ',T19, ' VERBOSE ON '/
     &	'  VB OFF    ',T19, ' VERBOSE OFF '/
     &  '  MOSAIC ON ',T19, ' MOSAIC HELP ON'/
     &  '  MOSAIC OFF',T19, ' MOSAIC HELP OFF'/
     &  '  INLN BUFF ',T19, ' TOGGLE INCORE BUFFER ON/OFF')

#ifdef SP_MP
        WRITE(NOUT,9611)
9611	FORMAT(
     &  '  SET MP  '  ,T19, ' SET MAX. NO. OF PROCESSORS USED ')
#endif

        WRITE(NOUT,9612)
9612	FORMAT(
     &  '  SET MEM '  ,T19, ' SET MAX. BYTES ALLOCABLE MEMORY ')
      	WRITE(NOUT,*) ' '
	GOTO 5000


C       DETERMINE STATUS  STA
35      IF (NTRACE.EQ.1) WRITE(NOUT,9630) MOMENU(5)(:10)
	IF (NTRACE.EQ.0) WRITE(NOUT,9630) MOMENU(6)(:10)
	IF (NTRACE.LT.0) WRITE(NOUT,9630) MOMENU(7)(:10)
	IF (NTRACE.EQ.0) WRITE(NOUT,9630) MOMENU(8)(:10)
	IF (N_VERBOSE.EQ.1) WRITE(NOUT,9630) MOMENU(9)(:10)
	IF (N_VERBOSE.EQ.0) WRITE(NOUT,9630) MOMENU(10)(:10)
	IF (N_MOSAIC.EQ.1)  WRITE(NOUT,9630) MOMENU(11)(:10)
	IF (N_MOSAIC.EQ.0)  WRITE(NOUT,9630) MOMENU(12)(:10)
	IF (USEINLN)        WRITE(NOUT,*) 'INLN BUFF ON'
	IF (.NOT. USEINLN)  WRITE(NOUT,*) 'INLN BUFF OFF'

#ifdef SP_MP
        IF (MPINUSE .LE. 0) THEN
      	   WRITE(NOUT,*) 'NUMBER OF PROCESSORS USED:   ALL'
        ELSE
	   WRITE(NOUT,*) 'NUMBER OF PROCESSORS USED:',MPINUSE
        ENDIF
#endif

      	WRITE(NOUT,*) ' MAX. MB ALLOCABLE MEMORY: ',MEMALLOCABLE


9630	FORMAT(1X,A7)
	GOTO 9400

C       TRACE ON
40	NTRACE = 1
	GOTO 5000

C       TRACE OFF
45      NTRACE =  0
        GOTO 5000

50      NTRACE = -1
	GOTO 5000

C       SET VERBOSE FILE DATA
55      N_VERBOSE = 1
        GOTO 5000

C       SET VERBOSE FILE DATA
60      N_VERBOSE = 0
        GOTO 5000

C       SET USE OF MOSAIC ON
70      N_MOSAIC = 1
        GOTO 5000

C       SET USE OF MOSAIC OFF
75      N_MOSAIC = 0
        GOTO 5000

C	USER WANTS TO ALTER THE INCORE BUFFER 
C       ON VAX THIS IS LIMITED TO TWO ARRAYS IN A FIXED LENGTH OF SPACE
C       ON UNIX THIS CALL TOGGLES MEANING OF _FILES ONLY
80      CALL INITINLN(.TRUE.,IRTFLG)
        GOTO 5000

C       SET NUMBER OF PROCESSORS WANTED
85      CONTINUE
#ifdef SP_MP
        CALL RDPRIS(MPINUSE,IDUM,NLOOP,ILOOP,
     &             'NUMBER OF PROCESSORS REQUESTED',IRTFLG)
        IF (IRTFLG .NE. 0) RETURN

C       SET NUMBER OF PROCESSORS WITH SYSTEM CALL
	CALL  mp_destroy()
        CALL  mp_set_numthreads(MPINUSE)
#else
        WRITE(NOUT,*) '*** NOT COMPILED FOR MULTIPLE PROCESSORS' 
#endif
        GOTO 5000

C       SET ALLOCABLE MEMORY
90      CONTINUE
        CALL RDPRIS(MEMALLOCABLE,IDUM,NLOOP,ILOOP,
     &             'ALLOCABLE MEMORY (IN MEGABYTES)',IRTFLG)
        IF (IRTFLG .NE. 0) RETURN
        GOTO 5000

5000    RETURN
        END

