
C++*************************************************************************
C
C SETVAL.FOR            REMOVED FROM UTIL1 OCT 88 al
C                       LONG FILE NAMES FEB 89 al
C **************************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK            *
C *  COPYRIGHT (C)1981,1987, WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH 			   *
C **************************************************************************
C
C  SETVAL(FILNAM,LUN1)
C
C  PURPOSE:   SET PARTICULAR LABEL LOCATIONS TO SPECIFIED VALUES
C
C23456789 123456789 123456789 123456789 123456789 123456789 123456789 12
C--*********************************************************************

        SUBROUTINE SETVAL(FILNAM,LUN1)

	INCLUDE 'CMBLOCK.INC' 
CNO_SAVE
        CHARACTER *(*) FILNAM
        CHARACTER      SET,ANS,NULL
        DIMENSION      FARRAY(4)

        PARAMETER      (NMAX = 200)
        COMMON         ILIST(NMAX),FLIST(NMAX),A0(12000)

        DATA PI /3.14159/

        NULL = CHAR(0)

C       DISP OF "Z" WILL ALLOW CORRECTING STACK ERROR
10      MAXIM = 0
        CALL OPFIL(.FALSE.,FILNAM,LUN1,'Z',NSAM1,NROW1,NSLICE1,
     &             MAXIM,'XXXX',.FALSE.,IRTFLG)
        IF (IRTFLG .NE. 0) RETURN

    	CALL RDPRMC(SET,NCHAR,.TRUE.,
     &    '(A)NGLES, (BUF), (C)LEAR, OR (F)IX',NULL,IRTFLG)

        IF (SET .EQ. 'A') THEN
C          CHANGE THE TILT ANGLES ----------------------------------- A

           CALL RDPRMI(ILPOS,IDUM,NLOOP,ILOOP,'ANGLE SET 1, 2, OR 3')
           CALL RDPRM2(PHI,THETA,NLOOP,ILOOP,'ENTER PHI AND THETA')
           FARRAY(2) = PHI
           FARRAY(3) = THETA
           CALL RDPRM(PSI,NLOOP,ILOOP,'ENTER PSI')
           FARRAY(4) = PSI
           FARRAY(1) = 1.0
           IF (ILPOS.EQ.1) THEN
             LOCATION = 14
             NANG     = 4
             CALL SETLAB(LUN1,NSAM1,A0,LOCATION,NANG,FARRAY,'U',IRTFLG)

           ELSEIF (ILPOS .EQ. 2)THEN
              LOCATION = 30
              NANG     = 4
              CALL SETLAB(LUN1,NSAM1,A0,LOCATION,NANG,FARRAY,'U',IRTFLG)

           ELSEIF (ILPOS .EQ. 3)THEN
              FARRAY(1) = 2
              LOCATION  = 30
              NANG      = 1
              CALL SETLAB(LUN1,NSAM1,A0,LOCATION,NANG,FARRAY,'U',IRTFLG)
              LOCATION  = 34
              NANG      = 3
              CALL SETLAB(LUN1,NSAM1,A0,LOCATION,NANG,
     &                   FARRAY(2),'U',IRTFLG)
           ELSE
              CALL ERRT(101,'INCORRECT NUMBER FOR SET',NE)
              GOTO 9000
           ENDIF

        ELSEIF (SET .EQ. 'B') THEN
C          CHANGE A PARTICULAR BUFFER LOCATION IN THE FILE LABEL ----- B

1601       NVAL1 = NMAX
           CALL RDPRAI(ILIST,NMAX,NVAL1,1,1024,
     &       'ENTER NUMBER(S) OF HEADER LOCATION TO BE CHANGED',
     &       NULL,IRTFLG)
           IF (IRTFLG .EQ. -1) GOTO 10

           NVAL2 = NMAX
           CALL RDPRAF(FLIST,NMAX,NVAL2,-10E30,10E30,
     &       'ENTER NEW VALUE FOR EACH HEADER LOCATION CHANGED',
     &       NULL,IRTFLG)

           IF (IRTFLG .EQ. -1) GOTO 1601
           IF (NVAL2 .NE. NVAL1) THEN
               CALL ERRT(101,'INCORRECT NUMBER OF VALUES',NE)
               GOTO 9000
           ENDIF
              
           IF (IFORM .EQ. 8 .OR. IFORM .EQ. 11) THEN
C             FOR 8 BIT FILES
              LENREC = NSAM1 / 4
              IF ((LENREC * 4) .LT. NSAM1) LENREC = LENREC + 1
           ELSE
C             FOR NORMAL 32 BIT SPIDER FILES
              LENREC = NSAM1
           ENDIF

           DO I = 1,NVAL1
             CALL SETLAB(LUN1,LENREC,A0,ILIST(I),1,FLIST(I),'U',IRTFLG)
           ENDDO


        ELSEIF (SET .EQ. 'C') THEN
C          CLEAR ---------------------------------------------------- C

           SIG   = -1.0
           CALL SETPRM(LUN1,NSAM1,NROW1,0.0,0.0,0.0,'U')

        ELSEIF (SET .EQ. 'F') THEN
C          SET FMIN, FMAX, AV, AND S.D.

C          INPUT PHI AND THETA  TO BE STORED IN FMAX AND FMIN
           CALL RDPRM(FMAX,NLOOP,ILOOP,'ENTER IMAGE MAXIMUM')
           CALL RDPRM(FMIN,NLOOP,ILOOP,'ENTER IMAGE MINIMUM')
           CALL RDPRMC(ANS,NCHAR,.TRUE.,
     &           'AVERAGE AND STANDARD DEVIATION AVAILABLE (Y/N)',
     &           NULL,IRTFLG)

           IF (ANS .EQ. 'N') THEN
               CALL ERRT(101,'MUST PROVIDE AVERAGE AND S.D. NOW',NE)
               GOTO 9000
           ENDIF

           CALL RDPRM2(AV,SIG,NLOOP,ILOOP, 
     &               'ENTER AVERAGE, STANDARD DEVIATION')

           IF (IFORM .LT. 0) THEN
C             FOURIER
              FMAX = FMAX * PI / 180.0
              FMIN = FMIN * PI / 180.0
           ENDIF
           CALL SETPRM(LUN1,NSAM1,NROW1,FMAX,FMIN,AV,'U')

        ELSE
C          UNKNOWN OPTION ------------------------------------------- ?
           CALL ERRT(23,'SETVAL',NE)
           GOTO 9000
        ENDIF

9000    CONTINUE
        CLOSE(LUN1)
        RETURN
        END


