C
C ************************************************************************
C                                  LONG FILE NAMES FEB 89 al
C
C	PROGRAM TO DISPLAY CORRESPONDENCE ANALYSIS MAPS USING THE
C	NEW COORDINATE FILES
C
C   NOTES:
C
C      S -- SYMBOL PRINTED IS ONE CHARACTER LONG. ONE IS USED 
C           FOR EACH ACTIVE IMAGE, AND ANOTHER ONE FOR EACH INACTIVE
C           IMAGE
C      C -- SYMBOL PRINTED IS ONE CHARACTER LONG, AND IS LOOKED UP IN A
C           CLUSTER FILE
C
C      D -- SYMBOL PRINTED IS UP TO 4 CHARACTERS LONG, AND REPRESENTS
C           AN INTEGER LOOKED UP IN A DOCUMENT FILE UNDER KEY=ID
C
C      I -- SYMBOL PRINTED IS UP TO 4 CHARACTERS LONG, AND REPRESENTS
C           THE ORIGINAL IMAGE ID
C
C    CALLED BY:  UTIL1
C
C	CALLS :  SGRAF1  RDPRMC  RDPRMI FILGET FILCAN SEIGEN RDPRM
C
C    SGRAF1 ROUTINE MOVED TO SGRAF1.FOR APRIL 89 al
C
C *************************************************************************

	SUBROUTINE SGRAF(LUNS,LTMP,UNUSED,LUNE)
	
	INCLUDE   'CMBLOCK.INC'

	COMMON /COMMUN/ CLUSTI,CLUST,FILPATI,FILPATP,FILPATE
	COMMON          BUF(1)
        LOGICAL         UNUSED
	CHARACTER *81   CLUSTI(3),CLUST,FILPATI,FILPATP,FILPATE
        CHARACTER *80   TXT
        CHARACTER *1    SYMB
        CHARACTER       NULL,FOPT,LFLIP,ANS,PTYPE
	INTEGER         NDIM,NITEM,NFAC,NOC,NOR,NCHAR,IRTFLG,IMNO,NHOR,
     $                  NLET,NFCT1,NFCT2,NF,IER,LUNS,NPAGE,IDUM,NLINE,
     $                  FLIP,YFLIP,IT,NFILP,LC,LX,LY,LD,LK,LTMP,LUNE,
     $                  I1,I2,I,XFLIP
        REAL * 4        BUF,PEX
        CHARACTER * 4   CBUF(1)
	EQUIVALENCE     (CBUF,BUF)

        NULL = CHAR(0)

	FILPATI = 'IMC***'//NULL
        FILPATP = 'PIX***'//NULL
        FILPATE = 'EIG***'//NULL

        CALL RDPRMC(ANS,NCHAR,.TRUE.,'(I)MAGE OR (P)IXEL',NULL,IRTFLG)

	IF (ANS .EQ. 'I') THEN
            NFILE = 1

        ELSEIF (ANS .EQ. 'P') THEN
            NFILE = 2

        ELSE
c	    put  a default      < ML.
            NFILE = 1 
        ENDIF

	CALL RDPRMI(IMNO,NHOR,NLOOP,ILOOP,
     &             'COORDINATE FILE CODE, NO. OF HOR. PATCHES')
        NLET = 6
        CALL FILGET(FILPATI,CLUSTI(1),NLET,IMNO,IRTFLG)
        CALL FILGET(FILPATP,CLUSTI(2),NLET,IMNO,IRTFLG)
        CALL FILGET(FILPATE,CLUSTI(3),NLET,IMNO,IRTFLG)

 	CALL RDPRMI(NFCT1,NFCT2,NLOOP,ILOOP,
     &             'ENTER 2 FACTOR NUMBERS (e.g: 1,5)')

	CALL FILCAN(CLUST,NF,NULL,NULL,CLUSTI(NFILE),DATEXC,IER)
	OPEN(FILE=CLUST,UNIT=LUNS,STATUS='OLD',FORM='UNFORMATTED')

82        CALL RDPRMC(FOPT,NCHAR,.TRUE.,
     &         '(S)YMBOL, (A)SSIGN SYMBOL, (C)LASS, (D)OC, (I)D',
     &         NULL,IRTFLG)

	  IF (FOPT .EQ. 'S' .AND. ANS .EQ. 'I') THEN
81          IRTFLG = 0
            CALL RDPRMC(SYMB,NCHAR,.TRUE.,
     &         'ENTER 1 CHAR. SYMBOL FOR ACTIVE IMAGES',NULL,IRTFLG)
            IF (IRTFLG .GT. 0) GOTO 81

          ELSEIF(FOPT .NE.'A' .AND. FOPT .NE. 'I' .AND.
     &	     FOPT .NE.'C' .AND. FOPT .NE. 'D' ) THEN
             WRITE(NOUT,*) '*** INVALID INPUT,TRY AGAIN'
             GOTO 82
          ENDIF

          CALL RDPRMC(PTYPE,NCHAR,.TRUE.,
     &           'PREPARE CONTOUR METAFILE FOR MAP? (Y/N/O)'
     &           ,NULL,IRTFLG)

          IF (PTYPE .NE. 'Y') THEN
            CALL RDPRMI(NPAGE,IDUM,NLOOP,ILOOP,
     &                 'NUMBER OF PAGES (1,2,3) OR <CR>=1')

            NLINE = 0
            CALL RDPRMI(NLINE,IDUM,NLOOP,ILOOP,
     &                 'NUMBER OF LINES OR <CR>')
          ENDIF
          
        CALL RDPRM(PEX,NLOOP,ILOOP,'NUMBER OF SD OR <CR>=2.3')

        CALL RDPRMC(LFLIP,NCHAR,.TRUE.,
     &   '1=FLIP #1/ 2=FLIP #2/ 3=FLIP 1+2/ <CR>=NO FLIP',NULL,IRTFLG)

        IF (LFLIP .EQ. '1') THEN
C	  rotate coordinates around y axis
          XFLIP = -1.
          YFLIP = 1.

        ELSEIF (LFLIP .EQ. '2') THEN
c	  rotate coordinates around x axis
          XFLIP = 1.
          YFLIP = -1.

        ELSEIF (LFLIP .EQ. '3') THEN
c	  rotate coordinates around both axis
          XFLIP = -1.
          YFLIP = -1.

        ELSE
c	  no rotation of coordinates around any axis
          XFLIP = 1.
          YFLIP = 1.
        END IF

	CALL RDPRMC(TXT(3:80),NCHAR,.TRUE.,'TITLE',NULL,IRTFLG)
	TXT(1:2) = '  '
	READ(LUNS) NITEM,NFAC,NOC,NOR

C       CHECK FOR TRANSPOSE SWITCH
	IT = 1
	IF (NOC .LT. 0) THEN
	  TXT(1:1) = 'T'
	  IF (NFILE .EQ. 1) THEN
            NFILP = 2
	  ELSEIF (NFILE .EQ. 2) THEN
            NFILP = 1
          END IF
	  CALL FILCAN(CLUST,NF,NULL,NULL,CLUSTI(NFILE),DATEXC,IER)
	  OPEN(FILE=CLUST,UNIT=LUNS,STATUS='OLD',FORM='UNFORMATTED')
	  READ(LUNS) NITEM,NFAC,NOC,NOR
	  NOC = -NOC
	  IT  = -1
	ENDIF
                                                 
	OPEN(LTMP,STATUS='SCRATCH',FORM='UNFORMATTED')

	WRITE(NDAT,9001) IMNO
9001	FORMAT(/,' ** FILE CODE FOR IMC***, PIX***, EIG*** ',I3/)
	IF (FCHAR(6:6) .EQ. 'E') THEN
	   NFILE=3
C          OPEN EIGENVECTOR FILE
	   CALL FILCAN(CLUST,NF,NULL,NULL,CLUSTI(NFILE),DATEXC,IER)
	   OPEN(FILE=CLUST,UNIT=LUNE,STATUS='OLD',FORM='UNFORMATTED')
           CALL SEIGEN(LUNE,NDAT)
	   CLOSE(LUNE)
	ENDIF
                                                 
C       PRINT OUT PATCH MATRIX IF REQUESTED
	IF (NHOR .NE. 0) THEN
          I1 = 1
          I2 = NHOR
	  WRITE(NDAT,9003)
9003	  FORMAT(/,' P A T C H   C O D E   L O O K U P',//)
84	  WRITE(NDAT,9002) ((I),I=I1,I2)
9002	  FORMAT(/,1X,20I4)
          IF (I2 .GE. NITEM) GOTO 85
          I1 = I1+NHOR
          I2 = I2+NHOR
          IF (I2 .GT. NITEM) I2=NITEM
          GOTO 84
	ENDIF

85	NDIM = NITEM + 2
	LC = 1
	LX = LC + NFAC  + 1
	LY = LX + NDIM
	LD = LY + NDIM
	LK = LD + NDIM + 4
                                                 
	CALL SGRAF1(NDIM,NITEM,NFAC,NFCT1,NFCT2,LUNS,NDAT,LTMP,
     &              FOPT,NLINE,NPAGE,PEX,ANS,
     &              BUF(LC), BUF(LX), BUF(LY), CBUF(LD),BUF(LK),
     &              TXT,DATEXC,XFLIP,YFLIP,SYMB,PTYPE)

	CLOSE(LUNS)
	CLOSE(LTMP)

        RETURN
	END
