

C *NAME* = SHELK.FOR                   31-JAN-86      13:23:13                  
C----------------------------------=*=----------------------------------        
C           COPYRIGHT 1986 - JEAN-PIERRE BRETAUDIERE                            
C THE UNIVERSITY OF TEXAS HEALTH SCIENCE CENTER AT HOUSTON                      
C MEDICAL SCHOOL - DEPARTMENT OF PATHOLOGY AND LABORATORY MEDICINE              
C P.O. BOX 20708, HOUSTON, TX 77225.                                            
C DISCLAIMER: NO GUARANTEES OF PERFORMANCE ACCOMPANY THIS SOFTWARE,             
C NOR IS ANY RESPONSIBILITY ASSUMED ON THE PART OF THE AUTHOR                   
C OR THE INSTITUTION.  ALL THE SOFTWARE HAS BEEN TESTED EXTENSIVELY             
C AND EVERY EFFORT HAS BEEN MADE TO INSURE ITS RELIABILITY.                     
C THE FOLLOWING SOFTWARE MAY NOT BE COMMUNICATED TO A THIRD PARTY               
C UNDER ANY FORM WITHOUT WRITTEN PERMISSION OF THE AUTHOR.                      
C PLEASE REPORT ANY BUG(S) TO JPB AT (713) 792 52 00.                           
C OR THRU ARPANET AT  ......!rice!ots!ut-path!suprim                            
C*---------------------------------------------------------------------*        
C  SORT VECTOR X() IN ASCENDING ORDER                                  *        
C  WARNING: ORIGININAL VECTOR(X) GETS CLOBBERED UPON RETURN            *        
C  BUT THE ORIGINAL LOCATIONS ARE SAVED IN VECTOR KX()                 *        
C  REFERENCES   (1) J.BOOTHROYD/SHELLSORT ALGORITHM.201/COMM.ACM/VOL.6 *        
C  (1963),NO.8,PP.445/  (2) D.A.SHELL/A HIGH-SPEED SORTING PROCEDURE/  *        
C  COMM.ACM/VOL.2(1959),PP.30-32/                                      *        
C==07.06.80                                                            *        
C*---------------------------------------------------------------------*        
      SUBROUTINE  SHELK ( N, X, KX )                                            
      DIMENSION  X(N) , KX(N)                                                   
        DO   J = 1,N                                                          
      KX(J) = J                                                                 
   	ENDDO
      I     = 1                                                                 
   20 I     = I + I                                                             
        IF (I .LE. N)        GO TO  20                                          
      M     = I - 1                                                             
   30 M     = M / 2                                                             
        IF (M .EQ. 0)        GO TO  70                                          
      K     = N - M                                                             
        DO 60  J = 1,K                                                          
      JM    = J + M                                                             
   40 JM    = JM - M                                                            
        IF (JM .LE. 0)       GO TO  60                                          
      L     = JM + M                                                            
        IF (X(L) .GE. X(JM)) GO TO  60                                          
      PIV   = X(JM)                                                             
      X(JM) = X(L)                                                              
      X(L)  = PIV                                                               
      KPIV  = KX(JM)                                                            
      KX(JM)= KX(L)                                                             
      KX(L) = KPIV                                                              
                             GO TO  40                                          
   60   CONTINUE                                                                
                             GO TO  30                                          
   70   RETURN                                                                  
        END                                                                     
