C++*************************************************************************
C
C SHUFFLEDOC     M.RADERMACHER 5/95
C                REWRITTEN MAY 97 al                        
C
C **************************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK            *
C *  COPYRIGHT (C)1981,1987, WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH 			   *
C **************************************************************************
C
C SORTDOC(MAXDIM)
C
C PURPOSE:              SHUFFLES A DOCUMENT FILE
C                  
C PARAMETERS:           MAXDIM             
C
C CALLS:                UNSDAL
C--*************************************************************************

        SUBROUTINE SHUFFLEDOC(MAXDIM)

        INCLUDE 'CMBLOCK.INC'
CNO_SAVE

	COMMON        PLIST(16),BTUF(1)	

        CHARACTER *81 DOCF1
        CHARACTER     NULL
        INTEGER*2     NXT(4)
        CHARACTER*8   CNXT
        EQUIVALENCE   (NXT,CNXT)
	INTEGER       P1,P2,P3
        LOGICAL       GFLAG

        DATA          NDOC/23/
	
	NULL  = CHAR(0)

3333	CALL FILERD(DOCF1,NLET,NULL,'SOURCE DOCUMENT',IRTFLG)
	IF (IRTFLG .EQ. -1) RETURN

        CALL FILCAN(DOCF1,NLET,NULL,NULL,DOCF1,DATEXC,IRTFLG)
	IF (IRTFLG .NE. 0) RETURN

        CALL DOCINFO(DOCF1,NDOC,MAXKEYT,MAXREGT,.TRUE.,IRTFLG)
	IF (IRTFLG .NE. 0) RETURN 

        CALL RDPRMI(KEY1,KEY2,NLOOP,ILOOP,'FIRST, LAST KEY NUMBER')

        WRITE(NOUT,100)
100     FORMAT(' THE OUTPUT DOCFILE WILL HAVE THE FORMAT:'/
     &         ' NEWKEY, 4 OLDKEY, + 3 COLUMNS')

       	CALL RDPRMI(ICOL0,IDUM,NLOOP,ILOOP,
     &              'INPUT COLUMN FOR OUTPUT COL. 2')

	CALL RDPRMI(ICOL1,ICOL2,NLOOP,ILOOP,
     &              'INPUT COLUMN #s FOR OUTPUT COL. 3 AND 4')

C	THE SIZE OF MAXKEY IS IN REALITY MMKEY (ADD 10 FOR GOOD MEASURE)
	MMKEY    = MAX0(KEY1,KEY2) + 10
        IREGSRED = MAXREGT + 1
	P1       = 1
	P2       = P1 + IREGSRED * MAXKEYT 
	P3       = P2 + MMKEY 
	MEMNEED  = P3 + 4 * MMKEY
	IF (MEMNEED .GE. (MAXDIM -20)) THEN
	   WRITE(NOUT,414) MEMNEED, MAXDIM
414	   FORMAT('*** COMMON BLOCK MEM NEEDED: ',I7,
     &                 ' MEM AVAILABLE ONLY: ',I7)
           CALL ERRT(100,'SHUFFLEDOC',NE)
           RETURN
	ENDIF
	
        NREG  = ICOL2 
        IF (ICOL1 .GT. NREG)  NREG = ICOL1
        IF (ICOL0 .GT. NREG)  NREG  = ICOL0
        IRN   = KEY2 - KEY1 + 1
        IR1   = 0
        IR2   =     IRN
        IR3   = 2 * IRN

	ICALL = 0
        ILINE = 0
        DO I=KEY1,KEY2
           CALL UNSDAL(DOCF1,ICALL,NDOC,I,PLIST,NREG,
     &                BTUF(P1),MAXKEYT,IREGSRED,NKEYMAX,LERR)
           IF (LERR .NE. 0) GOTO 11
           ILINE                = ILINE + 1
           BTUF(P2+ILINE-1)     = I
           BTUF(P3+IR1+ILINE-1) = PLIST(ICOL0)
           BTUF(P3+IR2+ILINE-1) = PLIST(ICOL1)
           BTUF(P3+IR3+ILINE-1) = PLIST(ICOL2)
        ENDDO

11      CLOSE(NDOC)

C       DO THE SHUFFLING, BY RANDOM INTERCHANGE
	CALL TIME(CNXT)
	KST   = NXT(4)
        GFLAG = .FALSE.
        CALL MRAND(OUT,KST,GFLAG,NOUT) 

        DO  I=0,ILINE-1
C         CREATE RANDOM IVAL IN RANGE 1...ILINE
	  CALL  GETRAND(OUT)
	  IVAL              = OUT*FLOAT(ILINE-1)

          B1                = BTUF(P2+    IVAL) 
          B2                = BTUF(P3+IR1+IVAL)
          B3                = BTUF(P3+IR2+IVAL)
          B4                = BTUF(P3+IR3+IVAL)

          BTUF(P2    +IVAL) = BTUF(P2    +I) 
          BTUF(P3+IR1+IVAL) = BTUF(P3+IR1+I)
          BTUF(P3+IR2+IVAL) = BTUF(P3+IR2+I)
          BTUF(P3+IR3+IVAL) = BTUF(P3+IR3+I)

          BTUF(P2    +I)    = B1 
          BTUF(P3+IR1+I)    = B2
          BTUF(P3+IR2+I)    = B3
          BTUF(P3+IR3+I)    = B4
        ENDDO

        DO I=0,ILINE-1
           PLIST(1) = I + 1
           PLIST(2) = BTUF(P2    +I)
           PLIST(3) = BTUF(P3+IR1+I)
           PLIST(4) = BTUF(P3+IR2+I)
           PLIST(5) = BTUF(P3+IR3+I)
           CALL SAVD(NDOC,PLIST,5,IRTFLG)
        ENDDO

        CALL SAVDC
        CLOSE (NDOC)

        RETURN
	END
