 
 
#ifdef SP_UNIX 
 
C   THIS ROUTINE SPECIFIC TO VAX SPIDER AND IS NOT 
C       USED AT UNIX SITES
 
       SUBROUTINE sixout
 
       COMMON /UNITS/LUNC,NIN,NOUT
 
       WRITE(NOUT,*) 'DUMMY CALL: sixout'
       RETURN
       END
 
#else
 

C++*************************************************************************
C
C $$ SIXOUT.FOR
C
C **************************************************************************
C
C    Copyright 1983 P.R. Smith.
C    Extensively revised for SPIDER  July 24 1989 al
C
C **************************************************************************
C
C $$  SIXOUT(NSAMO,NROWO,NSAMI,NROWI,LUNI,LUNO)
C
C     PURPOSE:   DISPLAY PICTURE WITH SIXEL GRAPHICS
C
C     PARAMETERS:  
C                  NSAMO    OUTPUT IMAGE COLS.
C                  NROWO    OUTPUT IMAGE ROWS
C                  NROWI    INPUT IMAGE ROWS
C                  NSAMI    INPUT IMAGE COLS.
C                  LUNI     LOGICAL UNIT FOR INPUT FILE
C                  LUNO     LOGICAL UNIT FOR SIXEL OUTPUT FILE
C
C VARIABLES:
C                  IOP      FLAG FOR OUTPUT DEVICE AND PLOT SIZE
C                           0 IS VT 330
C                           1 IS LA 100
C                  FMIN     MINIMUM IMAGE DENSITY
C                  FMAX     MAXIMUM IMAGE DENSITY
C
C       NOTE: SIXPRT AND SIXFIN ARE ENTRIES IN SISXTRT
C
C--*******************************************************************

        SUBROUTINE SIXOUT(NSAMO,NROWO,NSAMI,NROWI,LUNI,LUNO)

#ifdef SP_UNIX
        INCLUDE 'CMBLOCK.INC'
#else
        INCLUDE 'COMMON1:CMBLOCK.INC'
#endif

        PARAMETER (MAXSAM=8000)

        COMMON /COMMUN/PB(2,532)
        COMMON BUFA(MAXSAM),BUFB(MAXSAM)

        INTEGER   *  2    PB
        CHARACTER * 81    SIXNAM
        CHARACTER *  9    CDATE
        CHARACTER *  1    NULL
        LOGICAL           USEBUFA

        NULL=CHAR(0)

C       OPEN FILE FOR SIXEL OUTPUT
        CALL FILERD(SIXNAM,NLETS,NULL,'SIXEL OUTPUT',IRTFLG)
        IF (IRTFLG .NE. 0) RETURN
        CALL FILCAN(SIXNAM,NLET,NULL,NULL,SIXNAM,DATEXC,IRTFLG)
        OPEN(LUNO,FILE=SIXNAM,STATUS='NEW',IOSTAT=IER,
     &       CARRIAGECONTROL='LIST')
        IF (IER .NE. 0) RETURN

C       SET OUTPUT IMAGE SIZE
        MCOL = NSAMI
        IF (MCOL .GT. 256) MCOL = 256

C       PRINT RANGE OF DATA AND PLOT SIZE
        RANGE = 1.0 / ABS(FMAX-FMIN)

        CALL DATE(CDATE)
        CALL TIME(CTIM)

        WRITE(LUNO,90) CTIT(1:40)
90      FORMAT(1X,A40)

        WRITE(LUNO,91) NSAMO,NROWO,CDATE,CTIM,FMIN,FMAX
91      FORMAT(' SIZE=(',I4,' X ',I4,')  ',A9,' AT ',A5,
     &         '  MIN & MAX =',G10.3,', ',G10.3/)

        CALL SIXSTRT(NOUT,LUNO)

C       PRINT TOP BORDER
        DO I=1,MCOL*2
          PB(1,I+1) = 0
          IF (MOD(I,20) .EQ. 0) THEN
            PB(2,I+1) = 14
          ELSE
            PB(2,I+1) = 10
          END IF
        END DO
        PB(1,1) = 0
        PB(2,1) = 0
        PB(1,MCOL*2+2) = 0
        PB(2,MCOL*2+2) = 0

C       PRINT TOP BORDER
        CALL SIXPRT(PB,MCOL*2+2) 

C       ENTER LOOP FOR EACH ROW OF DATA ARRAY
C       SET UP PRINTING SYMBOLS FOR ONE ROW OF DATA


        DO 15 I = 1,NROWI,2

C         READ NEXT LINE OF IMAGE INTO BUFFER "A"
          CALL REDLIN(LUNI,BUFA,NSAMI,I)

C         READ NEXT LINE OF IMAGE INTO BUFFER "B"
          IP1 = MIN(I+1,NROWI)
          CALL REDLIN(LUNI,BUFB,NSAMI,I)

          DO J = 1,MCOL
            JJ = 2*J
            JP1 = MIN(J+1,NSAMO)

C           FIND VALUE FOR THIS PIXEL
            Z  = BUFA(J)
            PB(1,JJ) = IMIN1(AMAX1(0.,10.*((Z-FMIN)*RANGE)),9.)

C           FIND AVERAGE OF CONSECUTIVE PIXELS ON FIRST LINE
            Z = (Z + BUFA(JP1)) * 0.5
            PB(1,JJ+1) = IMIN1(AMAX1(0.,10.*((Z-FMIN)*RANGE)),9.)

C           FIND VALUE FOR SECOND ROW PIXEL
            Z =  BUFB(J)
            PB(2,JJ)=IMIN1(AMAX1(0.,10.*((Z-FMIN)*RANGE)),9.)

C           FIND AVERAGE OF CONSECUTIVE PIXELS ON FIRST LINE
            Z = (BUFA(JP1) + Z) * 0.5
            PB(2,JJ+1)=IMIN1(AMAX1(0.,10.*((Z-FMIN)*RANGE)),9.)
          END DO

          PB(1,1)      = 11
          PB(1,JJ+2)   = 12

C         SET LEFT AND RIGHT BORDER PIXELS
          IF (MOD(I,10) .EQ. 0) THEN
            PB(2,1)    = 15
            PB(2,JJ+2) = 16
          ELSE
            PB(2,1)    = 11
            PB(2,JJ+2) = 12
          ENDIF

C         PRINT THIS ROW
          CALL SIXPRT(PB,MCOL*2+2)
15      CONTINUE


C       WRITE FINISH ROW
 16      DO I=1,MCOL*2
          PB(2,I+1) = 0
          IF (MOD(I,10) .EQ. 0) THEN
            PB(1,I+1) = 17
          ELSE
            PB(1,I+1) = 13
          ENDIF
        END DO
        PB(1,1) = 0
        PB(2,1) = 0
        PB(1,MCOL*2+2) = 0
        PB(2,MCOL*2+2) = 0

C       PRINT THE BOTTEM BORDER
        CALL SIXPRT(PB,MCOL*2+2) 

C       FINISH SIXEL FILE

        CALL SIXFIN
        RETURN
        END


 
#endif
 
