
C++*************************************************************************
C
C $$ SOLV2D.FOR
C
C **************************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK            *
C *  COPYRIGHT (C)1981,1987, WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH 			   *
C **************************************************************************
C
C	NFAC 	NUMBER OF EIGENVECTORS REQUESTED
C       NUMIM	NUMBER OF IMAGES
C       NACT    NUMBER OF ACTIVE IMAGES
C	NPIX    NUMBER OF PIXELS PER IMAGE
C	LSAV	SEQUENTIAL IMAGE FILE (INPUT)
C	LIMA    IMAGE COORDINATE FILE (OUTPUT)
C	LPIX    PIXEL COORDINATE FILE (OUTPUT)
C	LEIG	EIGENSTUFF FILE (OUTPUT)
C	LTMP	SCRATCH FILE
C
C       ALL FILES MUST BE UNFORMATTED!
C	Q	ARRAY OF FOUR - BYTE WORDS WITH DIMENSION MEM
C	LUV	LOGICAL UTILITY VECTOR (1 = ACTIVE,  0 = INACTIVE)
C 
C **************************************************************************

	SUBROUTINE SOLV2D(A,TST)

	DIMENSION A(2,3)
	COMMON /UNITS/ LUNC,NIN,NOUT,NECHO,IFOUND,NPROC,NDAT

	TST=0.
	D=A(1,1)*A(2,2)-A(1,2)*A(2,1)
	P=A(1,3)*A(2,2)-A(2,3)*A(1,2)
	Q=A(2,3)*A(1,1)-A(1,3)*A(2,1)
	IF(D.NE.0.)GO TO 3
	IF(P.EQ.0..AND.Q.EQ.0.)GO TO 7
	GO TO 6

3	IF (ABS(D).GE.(1.E-6)*ABS(P).AND.ABS(D).GE.(1.E-6)*ABS(Q))
     &      GO TO 5

6	CONTINUE
C       ********* DEBUG ***********
	WRITE(NDAT,95)D,P,Q,A(1,1),A(1,2),A(1,3),A(2,1),A(2,2),A(2,3)
95	FORMAT('  D,P,Q :',3(F14.6,3X)/
     1 '   A*,1          A*,2          A*,3'/
     2 '   ',3(F12.4,2X)/3(F12.4,2X))
C       ***********

	TST=1.
7	A(1,3)=0.
	A(2,3)=0.
	RETURN

5	A(1,3)=P/D
	A(2,3)=Q/D
	RETURN
	END
