C++*************************************************************************
C
C SORTDOC                                 FILE NAMES LENGTHENED FEB 89 al
C
C **************************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK            *
C *  COPYRIGHT (C)1981,1987, WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH 			   *
C **************************************************************************
C
C SORTDOC(MAXDIM)
C
C PURPOSE:              SORTS A DOC FILE,  SOLICITS DOC FILE NAME FOR
C                       INPUT AND OUTPUT
C
C PARAMETERS:           MAXDIM             UNUSED
C
C CALLS:                UNSDAL
C
C--*************************************************************************

        SUBROUTINE SORTDOC(MAXDIM)

C	PARAMETER (MAXKEY=10000)
C        PARAMETER (IDIMBUF=(4*MAXKEY+101))
        PARAMETER (MAXREG=7)

	COMMON /BATCH/IBCNT,NLOOP,IABSLP,ILOOP
	COMMON /UNITS/LUN,NIN,NOUT,NECHO,IFOUND,NPROC,NDAT

        CHARACTER *4     DATEXC,PRJEXC
        COMMON /MASTER1/ DATEXC,PRJEXC,CDAT,CTIM,CTIT

C	COMMON DUMMY(2048),PLIST(10),
C     &     BTUF(1)
Cc     &        	DBUF(MAXREG,MAXKEY),NKEY(MAXKEY),BUF(IDIMBUF)
C
C
C
C
C	MEMORY LAYOUT
C	                     P1 = 1
C	   QBUF(P1):	P1 - P2 = P1 + MAXKEY*(NREG+1) 
C			READ IN THE DATA FROM DOC FILE
C          QBUF(P2):	P2 - P3 = P2 + MAXKEY
C			ORIGINAL KEYS OF THE SORTED COLUMN
C	   QBUF(P3):	P3 - P4 = P3 + MAXKEY
C			SORT THIS COLUMN1
C	   QBUF(P4):	P4 - P5 = P4 + MAXKEY
C			COPY THIS COLUMN2 as sorted by column1
C	   QBUF(P5):	P5 - P6 = P5 + MAXKEY
C			COPY THIS COLUMN3 as sorted by column1
C	   P6: MAX SIZE OF MEMORY NEEDED.
C
	COMMON PLIST(10),QBUF(1)

        CHARACTER *81 DOCF1
	INTEGER P1,P2,P3,P4,P5,KEY0,BIGKEY,IGOGO
        CHARACTER     NULL
	EQUIVALENCE (IGOGO,GOGO)

        DATA  NDOC/23/
CNO_SAVE
	NULL=CHAR(0)
	NOPEN=0

3333	CALL FILERD(DOCF1,NLET,NULL,'SOURCE DOCUMENT',IRTFLG)
	IF(IRTFLG .EQ. -1) RETURN

        CALL FILCAN(DOCF1,NLET,NULL,NULL,DOCF1,DATEXC,IRTFLG)
	IF(IRTFLG .NE. 0) GOTO 3333

3334    CALL RDPRMI(KEY1,KEY2,NLOOP,ILOOP,'FIRST, LAST KEY NUMBER')
	IF(KEY1 .GT. KEY2) THEN
	   WRITE(NOUT,*) 'KEY1 ',KEY1,' GREATER THAN KEY2 ',KEY2 
	   GOTO 3334
	END IF
	
3335    CALL RDPRMI(ICOL,IDUM,NLOOP,ILOOP,'COLUMN # USED FOR SORTING')

        WRITE(NOUT,100)
100     FORMAT(' THE OUTPUT DOCFILE WILL HAVE THE FORMAT:'/
     &         ' NEWKEY, 4 OLDKEY, X USED FOR SORTING,COL.2,COL.3')

	CALL RDPRMI
     &      (ICL1,ICL2,NLOOP,ILOOP,'INPUT COLUMN # FOR COL.2, COL.3')
     
C        NREG=ICL2
C        IF(ICL1.GT.ICL2) NREG=ICL1
C        IF(ICOL.GT.NREG) NREG=ICOL
C        IRN=KEY2-KEY1+1
C        IR1=101
C        IR2=IRN+101
C        IR3=2*IRN+101
C        IR4=3*IRN+101
C        ILINE=0
C
CC	THE SIZE OF MAXKEY IS IN REALITY MMKEY (ADD 10 FOR GOOD MEASURE)
C	MMKEY=MAX0(KEY1,KEY2)+10
C	P1 = 1
C	P2 = P1 + MAXREG*MMKEY 
C	P3 = P2 + MMKEY 
C	JDIM = 4*MMKEY+101 + P3
C	IF (JDIM .GT. MAXDIM) THEN
C	  WRITE(NOUT,414) JDIM, MAXDIM
C414	  FORMAT('SORTDOC MEM NEEDED ',I4,'MEM AVAILABLE  ',I4)
C          RETURN
C	END IF
C	
C	BIGKEY = MAXKEY
C	IF(MAXKEY*MAXREG .GT. MAXDIM) THEN
C	   BIGKEY = MMKEY 
C	   IF (MMKEY*MAXREG .GT. MAXDIM) THEN
C	     WRITE(NOUT,422) MMKEY
C422	     FORMAT('SORTDOC: NOT ENOUGH MEMORY. MIN NEEDED ',I10)
C	     GOTO 12	
C	   END IF 
C	END IF
C

C	NREG: NUMBER OF COLUMNS TO BE READ FROM THE DOC FILE.
        IR1 = MAX0(ICL1,ICL2)
	NREG = MAX0(IR1,ICOL)
	IF ((NREG+1) .GT. MAXREG) THEN
	   WRITE(NOUT,*) ' ICOL .GT. MAXREG=',MAXREG
	   GOTO 3335
	END IF
	MAXKEY = KEY2
	
	P1 = 1
        P2 = P1 + MAXKEY * (NREG+1)
        P3 = P2 + MAXKEY
        P4 = P3 + MAXKEY
        P5 = P4 + MAXKEY
        P6 = P5 + MAXKEY
	IF (P6 .GT. MAXDIM) THEN
	     WRITE(NOUT,422) P6
422	     FORMAT('SORTDOC: NOT ENOUGH MEMORY. MIN NEEDED ',I10)
	     GOTO 12	
	END IF 
	
        ILINE=0 	
        DO I=KEY1,KEY2
C          CALL UNSDAL(DOCF1,NOPEN,NDOC,I,PLIST,NREG,
C     &                DBUF,MAXKEY,MAXREG,NKEY,LERR) 
C          CALL UNSDAL(DOCF1,NOPEN,NDOC,I,PLIST,NREG,
C     &                BTUF(P1),BIGKEY,MAXREG,KEY0,LERR)
C
C	
C	  WARNING: TO SAVE MEMORY, I AM RETRIEVING ONLY
C	          THE DATA COLUMNS NEEDED.(NOT ALL OF THEM)
C
          CALL UNSDAL(DOCF1,NOPEN,NDOC,I,PLIST,NREG,
     &                QBUF(P1),MAXKEY,NREG+1,KEY0,LERR)
          IF (LERR .NE. 0) THEN
	     WRITE(NOUT,410) DOCF1
410          FORMAT ('SORTDOC: ERROR READING DOCUMENT FILE  ',A80)
	     GOTO 12
	  END IF
          ILINE = ILINE + 1
	  IGOGO = I
          QBUF(P2+ILINE-1) = GOGO 
          QBUF(P3+ILINE-1) = PLIST(ICOL) 
          QBUF(P4+ILINE-1) = PLIST(ICL1) 
          QBUF(P5+ILINE-1) = PLIST(ICL2)


CC         WRITE(NOUT,400) I,(PLIST(K),K=1,NREG)
CC400      FORMAT(' INP:',I5,10F12.6)             
CC         NKEY(ILINE)=I
C	  IGOGO = I
C          BTUF(P2+ILINE-1)=GOGO
CC         BUF(IR1+ILINE-1)=PLIST(ICOL)
C          BTUF(P3+IR1+ILINE-1)=PLIST(ICOL)
CC         BUF(IR2+ILINE-1)=PLIST(ICL1)
C          BTUF(P3+IR2+ILINE-1)=PLIST(ICL1)
CC         BUF(IR3+ILINE-1)=PLIST(ICL2)
C          BTUF(P3+IR3+ILINE-1)=PLIST(ICL2)

        ENDDO

11      CLOSE(NDOC)

C	CALL SORTZ(BUF(IR1),BUF(IR2),BUF(IR3),NKEY,ILINE)
C	CALL SORTZ(BTUF(P3+IR1),BTUF(P3+IR2),BTUF(P3+IR3),BTUF(P2),ILINE)
	CALL SORTZ(QBUF(P3),QBUF(P4),QBUF(P5),QBUF(P2),ILINE)
	
        NOPEN=0
        DO I = 1,ILINE
           PLIST(1) = I 
	   GOGO = QBUF(P2+I-1)
           PLIST(2) = IGOGO
           PLIST(3) = QBUF(P3+I-1) 
           PLIST(4) = QBUF(P4+I-1) 
           PLIST(5) = QBUF(P5+I-1) 
           CALL SAVD(NDOC,PLIST,5,IRTFLG)
           NOPEN=1
        END DO

C        DO I = 1,ILINE
C           PLIST(1) = I 
CC           PLIST(2)=NKEY(I)
C	   GOGO=BTUF(P2+I-1)
C           PLIST(2)=IGOGO
CC           PLIST(3)=BUF(IR1+I-1)
C           PLIST(3)=BTUF(P3+IR1+I-1)
CC           PLIST(4)=BUF(IR2+I-1)
C           PLIST(4)=BTUF(P3+IR2+I-1)
CC           PLIST(5)=BUF(IR3+I-1)
C           PLIST(5)=BTUF(P3+IR3+I-1)
CC          WRITE(NOUT,300) (PLIST(K),K=1,4)
CC300       FORMAT(' OUTP:',4F12.6)
C           CALL SAVD(NDOC,PLIST,5,IRTFLG)
C           NOPEN=1
C        ENDDO

        CALL SAVDC
12      CLOSE (NDOC)
	END
