#if defined(SP_SUN4) || defined (SP_F90)
 
C   THIS ROUTINE DOES NOT COMPILE ON SUN
 
       SUBROUTINE spdtotiff
 
       COMMON /UNITS/LUNC,NIN,NOUT
 
       WRITE(NOUT,*) 'DUMMY CALL: spdtotiff'

       RETURN
       END
#else

C++************************************************************************
C
C  SPDTOTIFF.FOR  -- 
C                    CREATED, DEC 28, 94 al
C **************************************************************************
C *  COPYRIGHT (C)1989, WADSWORTH CENTER FOR LABORATORIES AND         	   *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH 			   *
C **************************************************************************
C
C    SPDTOTIFF(LUNO,LUNN,NSAM,NROW,NSLICE,IRTFLG)
C
C    PURPOSE:       TO CONVERT A SPIDER IMAGE FILE TO TIFF FORMAT
C                   RUNNING ON A UNIX MACHINE
C
C    PARAMETERS:
C        LUNO       LOGICAL UNIT NUMBER TO BE ASSIGNED TO FILOLD.
C        LUNN       LOGICAL UNIT NUMBER TO BE ASSIGNED TO FILNEW
C        IRTFLG     ERROR RETURN FLAG. (0 IS NORMAL)
C
C       TIFF TAGS -------------------------
C	TIFFTAG_IMAGEWIDTH		256
C	TIFFTAG_IMAGELENGTH		257
C	TIFFTAG_BITSPERSAMPLE		258
C	TIFFTAG_COMPRESSION		259
C	TIFFTAG_PHOTOMETRIC		262
C	TIFFTAG_STRIPOFFSETS		273
C	TIFFTAG_ROWSPERSTRIP		278
C	TIFFTAG_STRIPBYTECOUNTS		279
C	TIFFTAG_RESOLUTIONUNIT		296
C	
C--********************************************************************

	SUBROUTINE SPDTOTIFF(LUNO,LUNN,NSAM,NROW,NSLICE,IRTFLG)

CNO_SAVE
        INCLUDE 'CMBLOCK.INC'

        COMMON /LUNARA/LUNARA(100)
        COMMON /IOERR/ IERR
        CHARACTER *80  FILNAM,FILNEW,EXTEN
        COMMON /COMMUN/FILNAM,FILNEW,EXTEN

        REAL           BUFO
        INTEGER*1      LBUF
	COMMON         BUFO(17000),LBUF(1)
               
C	THE BUFFER FOR TIFF 
	INTEGER*2      TIFFINT(70),TIFFDAT(70)
	INTEGER*1      TIFFBYTE(140)
	EQUIVALENCE    (TIFFINT, TIFFBYTE)

        LOGICAL*1      LVAL
	REAL	       IPVAL,STREC,ENDREC
        CHARACTER * 1  NULL
	LOGICAL        EX
        INTEGER*1           LTEMP

C	SET THE TIFFINT INVARIANT HEADER
C       BYTE ORDER, VERSION(=42), OFFSET TO IFD, IFD COUNT
C       DIRECTORY ENTRIES: TAG #, TYPE(3=SHORT,4=LONG),
C                          LENGTH(4 BYTES),VALUE(4 BYTES)
	DATA TIFFDAT/19789,42,0,8,9, 
     1		       256,4,0,1,0,0,	257,4,0,1,0,0,
     1		       258,3,0,1,8,0,	259,3,0,1,1,0,
     1		       262,3,0,1,1,0,	273,4,0,1,0,1024,
     1		       278,4,0,1,0,0,	279,4,0,1,0,0,
     1		       296,3,0,1,3,0,	11*0/

        NULL = CHAR(0)

C	INITIALIZE THE TIFF HEADER WITH CONSTANT VALUES
	DO I=1,70
	   TIFFINT(I) = TIFFDAT(I)
	ENDDO
	    
C	CHECK THE FILE SIZE. IF IT IS TOO BIG, JUST RETURN
	IF ((NSAM .GT. 8192) .OR. (NROW .GT. 8192)) THEN
            WRITE(NOUT,*) ' *** IMAGE TOO LARGE'
            CALL ERRT(100,'SPDTOTIFF',NE)
	    RETURN
	ENDIF

C       CONVERT SPIDER HEADER TO TIFF HEADER           

C	TIFFTAG_IMAGEWIDTH		256
        TIFFINT(11) = NSAM

C	TIFFTAG_IMAGELENGTH		257
	TIFFINT(17) = NROW

C	TIFFTAG_STRIPOFFSETS		273
	TIFFINT(41) = 512

C	TIFFTAG_ROWSPERSTRIP		278
	TIFFINT(47) = NROW
	
C	TIFFTAG_STRIPBYTECOUNTS		279
	TIFFINT(52) = NSAM*NROW/65536.0
	TIFFINT(53) = NSAM*NROW
	
        IF (IMAMI .EQ. 0) THEN
C          NORMALIZE INPUT IMAGE FIRST
           CALL NORM3(LUNO,NSAM,NROW,NSLICE,FMAX,FMIN,AV)
        ENDIF

C	COMPUTE THE SCALE VALUE
	IPVAL = 255.0 / (FMAX - FMIN)

C       GET OUTPUT FILE NAME
        IRTFLG = 9
        EXTEN  = NULL
        CALL FILERD(FILNEW,NLET,EXTEN,'TIFF OUTPUT',IRTFLG)
        IF (IRTFLG .NE. 0) RETURN
        IF (EXTEN .EQ. NULL) THEN
            CALL FILCAN(FILNEW,NLET,NULL,NULL,FILNEW,DATEXC,IRTFLG)
        ENDIF
        IF (IRTFLG .NE. 0) RETURN

	INQUIRE(FILE=FILNEW,IOSTAT=IOERR,EXIST=EX)

C 	IF THE FILE WITH THIS NAME IS EXISTS, DELETE IT FIRST,
C	AND THEN REOPEN A NEW FILE.
C	IT WILL KEEP THE NEW FILE CLEAN AND HAS THE MINIMUM SIZE
	IF (EX) THEN
            IER = 0
            OPEN(LUNN,FILE=FILNEW,STATUS='OLD',DISPOSE='DELETE')
            CLOSE(LUNN,DISPOSE='DELETE',IOSTAT=IER)

            IF (IER .NE. 0) THEN
                CALL ERRT(101,'CAN NOT DELETE THE OLD FILE',IER)
                RETURN
            ENDIF
         ENDIF

C       OPEN NEW FILE FOR TIFF VERSION
        LENOPN = 1024
#ifdef __osf__
        LENOPN = 256
#endif
        LENREC = 1024
        OPEN(LUNN,FILE=FILNEW,ACCESS='DIRECT',RECL=LENOPN,IOSTAT=IFAIL,
     &       STATUS='NEW',RECORDTYPE='FIXED',FORM='UNFORMATTED')
        IF (IFAIL .NE. 0) THEN
           CALL ERRT(101,'CAN NOT OPEN TIFF OUTPUT FILE',NE)
           RETURN
        ENDIF

C	CHECK THE DATA IS AN IMAGE OR A VOLUME
C	IF IT IS AN IMAGE, CONVERT IT TO A TIFF FILE
C	IF IT IS A VOLUME, ASK THE USER WHICH SLICE SHOULD BE CONVERTED
	IF (ABS(NSLICE) .LE. 1) THEN
C	    IT IS AN IMAGE ....
	    ISLICE = 1
	ELSEIF (ABS(NSLICE) .GT. 1) THEN
C	    IT IS A VOLUME, ASK FOR THE SLICE NO. THAT WILL BE CONVERTED
	    CALL RDPRM(ISLICE,NLOOP, ILOOP, 'SLICE NUMBER')
            IF (IRTFLG .NE. 0) RETURN
	ENDIF

	STREC   = (ISLICE - 1) * NROW + 1
	ENDREC  = STREC + NROW - 1

C       PLACE HEADER IN NEW TIFF FILE
        LUNARA(LUNN) = 0
 

C	WRITE THE TIFF HEADER 
	DO K= 1, 140
           LBUF(K) = TIFFBYTE(K)
	ENDDO
  	DO K= 141, 512
             LBUF(K) = 0
  	ENDDO
#ifdef __osf__
C       FLIP BYTES IN HEADER
	DO K= 1, 512, 2
           LTEMP     = LBUF(K)
           LBUF(K)   = LBUF(K+1)
           LBUF(K+1) = LTEMP
	ENDDO
#endif

C       LBUF HAS 512 BYTES IN IT NOW FROM TIFF HEADER
        K       = 512
        IRECOUT = 0	    
        DO I = INT(STREC),INT(ENDREC)

C         READ EACH RECORD OF SPIDER FILE
          CALL REDLIN(LUNO,BUFO,NSAM,I)

          IF (IERR .NE. 0) THEN
             CALL ERRT(12,'SPDTOTIFF',NE)
             RETURN
          ENDIF

C         CONVERT FLOATING POINT NUMBERS TO BYTE
          DO J=1,NSAM
             IF (K .GE. LENREC) THEN
C               BUFFER IS FULL, PUT IT OUT TO FILE
                IRECOUT = IRECOUT + 1
                CALL WRTLIN8(LUNN,LBUF,LENREC,IRECOUT)
                K = 0
             ENDIF
             K       = K + 1
             LBUF(K) = (BUFO(J) - FMIN) * IPVAL
           ENDDO
        ENDDO

        IF (K .GT. 0) THEN
C          BUFFER STILL HAS PIXELS IN IT, PUT THEM OUT TO FILE
           IRECOUT = IRECOUT + 1
           CALL WRTLIN8(LUNN,LBUF,K,IRECOUT)
           IF (IRTFLG .NE. 0) RETURN
        ENDIF

C       SET FLAG FOR NORMAL RETURN	
        IRTFLG = 0

        RETURN
        END
 
#endif 
