C++************************************************************************
C
C $$ SPEAK3.FOR
C
C **************************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK            *
C *  COPYRIGHT (C)1981,1987, WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *  THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR       *
C *  LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR    *
C *  USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF     *
C *  THE CENTER FOR LABORATORIES AND RESEARCH   			   *
C **************************************************************************
C
C
C
C23456789012345678901234567890123456789012345678901234567890123456789012
C--************************************************************************
C
C $$ SPEAK3.FOR
C
         SUBROUTINE SPEAK3(FILNAM,LUN,NSAM,NROW,NSLICE,MAXDIM,OPT,NDOC)
C
C  SPEAK3(FILNAM,LUN,NSAM,NROW,NSLICE,MAXDIM,OPT,NDOC)
C
C  PURPOSE:    SEARCH FOR HIGHEST PEAKS IN 3-D DENSITY DISTRIBUTION
C
C       THIS SUBROUTINE SEARCHES FOR THE ML HIGHEST PEAKS IN THE (REAL)
C       VOLUME FILNAM AND PRINTS OUT POSITIONS AND VALUES OF THESE PEAKS.
C
C       CALL SPEAK3(FILNAM,LUN,NSAM,NROW,NSLICE,MAXDIM,OPT,NDOC)
C         FILNAM       LOGICAL*1 ARRAY, CONTAINING FILE NAME
C         LUN          LOGICAL UNIT NUMBER OF IMAGE
C         NSAM,NROW,NSLICE    DIMENSIONS OF VOLUME
C       MAXDIM      MAXIMUM BUFFER SPACE AVAILABLE
C       OPT  OUTPUT OPTION
C       OPT=' ' DEFAULT:NO DOCUMENT OUTPUT
C       OPT='X' (I.E.,REGISTER LIST FOLLOWING):NO DOCUMENT OUTPUT
C                 BUT OUTPUT OF POSITION & VALUE OF PEAK IN REGISTERS)
C       OPT='D'   DOCUMENT OUTPUT:NUMBER,POSITION, AND VALUE
C       OF PEAKS ARE WRITTEN INTO A DOCUMENT FILE
C       NDOC  LOGICAL UNIT NUMBER FOR DOCUMENT FILE
C
         INCLUDE 'CMBLOCK.INC'
         COMMON BUF(1)
C     dimension  peak(npeak),npc(3,npeak),rpc(3,npeak)
         DIMENSION  NCTR(3)
         EQUIVALENCE  (NXCTR,NCTR(1)),(NYCTR,NCTR(2)),(NZCTR,NCTR(3))
         INTEGER*4  IBUF(1)
         EQUIVALENCE  (BUF,IBUF)
CNO_SAVE
C     REGISTER POSITIONS 1= INTEGER X-SHIFT
C          2= INTEGER Y-SHIFT
C                          3= INTEGER Z-SHIFT
C                          4= FLOATING X-SHIFT (CENTER OF GRAVITY)
C                          5= FLOATING Y-SHIFT (CENTER OF GRAVITY)
C                          6= FLOATING Z-SHIFT (CENTER OF GRAVITY)
C          7= ABSOLUTE PEAK HEIGHT
C                          8= RATIO

         CHARACTER *(*) FILNAM
         CHARACTER      OPT,NULL,OPTB,OPTC
         LOGICAL        CGR

         NULL = CHAR(0)

         CALL RDPRMC(OPTB,NC,.TRUE.,'MAXIMA(+) OR MINIMA(-)?',NULL,IRT)
         IF (OPTB .EQ. '-') THEN
         SIGN=-1.0
         ELSE
         SIGN=+1.0
         ENDIF
         CALL RDPRMI(ML,NOR,NLOOP,ILOOP,
     &   'ENTER # OF PEAKS,CENTER ORIGIN OVERRIDE(0/1)')
         ML=MAX0(ML,1)
      CALL RDPRMC(OPTC,NC,.TRUE.,'CENTER OF GRAVITY CALCULATION(Y/N)?'
     $   ,NULL,IRT)
         IF (OPTC.EQ.'Y') THEN
         CGR=.TRUE.
         ELSE
         CGR=.FALSE.
         ENDIF
         IF(CGR) CALL RDPRM2(ELIPX,ELIPY,NLOOP,ILOOP,
     &   'X-Y RADIUS OF ELLIPSES')
         IF(CGR) CALL RDPRM (ELIPZ,NLOOP,ILOOP,'Z-RADIUS OF ELLIPSES')
         IF(MAXDIM.LT.3*NROW*NSAM+7*ML) THEN
         CALL ERRT(6,'SPEAK3',NE)
         RETURN
         ENDIF
         IF(NOR.NE.0)  THEN
         CALL RDPRMI(NXCTR,NYCTR,NLOOP,ILOOP,'X,Y ORIGIN COORDINATES')
         CALL RDPRMI(NZCTR,NDUM, NLOOP,ILOOP,'Z ORIGIN COORDINATE')
      CALL RDPRMI(NTAB,NDUM,  NLOOP,ILOOP,'ENTER PEAK NUMBER FOR RATIO')
         NTAB=MAX0(NTAB,1)
         IF(NTAB.GT.ML)   THEN
         CALL ERRT(25,'SPEAK3',NE)
         RETURN
         ENDIF
         ELSE
         NTAB=1
         NXCTR=NSAM/2+1
         NYCTR=NROW/2+1
         NZCTR=NSLICE/2+1
         ENDIF
C
         CALL RDPRMC(OPTB,NC,.TRUE.,'BOX SELECTION?(Y/N)',NULL,IRT)
         IF (OPTB .EQ. 'Y') THEN
         CALL RDPRMI(NSA1,NSA2,NLOOP,ILOOP,'LOWER, UPPER SAMPLE')
         CALL RDPRMI(NRO1,NRO2,NLOOP,ILOOP,'LOWER, UPPER ROW')
         CALL RDPRMI(NSL1,NSL2,NLOOP,ILOOP,'LOWER, UPPER SLICE')
         ELSE
         NSL1=1
         NSL2=NSLICE
         NRO1=1
         NRO2=NROW
         NSA1=1
         NSA2=NSAM
         ENDIF
C
         K1=1
         K2=K1+3*NSAM*NROW
         K3=K2+ML
         K4=K3+3*ML
         K5=K4+3*ML
         NMAX=0
         CALL  PKSR3(LUN,BUF(K1),NSAM,NROW,NSLICE,NSA1,NSA2,NRO1,NRO2,
     &   NSL1,NSL2,SIGN,BUF(K2),BUF(K3),BUF(K4),ML,NMAX)
C    &                peak,   npc,    rpc,   ML,NMAX)
C
         IF(NMAX.EQ.0)  THEN
         WRITE(NOUT,*)  ' No peaks found'
         RETURN
         ENDIF
C
C CENTER OF GRAVITY CALCULATION:
         IF(CGR) THEN
         CALL  CGR_3
     &   (LUN,BUF(K1),NSAM,NROW,NSLICE,ELIPX,ELIPY,ELIPZ,BUF(K3),
     &   RXCEN,RYCEN,RZCEN,RSUM)
         IF(RSUM.NE.0.0)  THEN
         WRITE(NOUT,298)
298      FORMAT(/
     &   '  The x,y,z coordinates of first peak replaced by the',/,
     &   ' center of gravity approximation within the area specified')
         BUF(K4)=RXCEN
         BUF(K4+1)=RYCEN
         BUF(K4+2)=RZCEN
         ELSE
         WRITE(NOUT,297)
297      FORMAT(/
     & '  Center of gravity approximation within the area specified',/,
     &   '  cannot be calculated - negative values encountered')
         ENDIF
         ENDIF
C
         CALL PDATES(FILNAM,0)
         CALL  ROUT(NOUT,NDOC,OPT,BUF(K2),IBUF(K3),BUF(K4),NCTR,ML,NTAB)
         IF (NSEL(1).NE.0)       PARAM(NSEL(1)) = IBUF(K3)
         IF (NSEL(2).NE.0)       PARAM(NSEL(2)) = IBUF(K3+1)
         IF (NSEL(3).NE.0)       PARAM(NSEL(3)) = IBUF(K3+2)
         IF (NSEL(4).NE.0)       PARAM(NSEL(4)) = BUF(K4)
         IF (NSEL(5).NE.0)       PARAM(NSEL(5)) = BUF(K4+1)
         IF (NSEL(6).NE.0)       PARAM(NSEL(6)) = BUF(K4+2)
         IF (NSEL(7).NE.0)       PARAM(NSEL(7)) = BUF(K2)
         END
