
C ++********************************************************************
C                                                                      *
C MAIN SPIDER SUBROUTINE                                               *
C                                                                      *
C **********************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.    AUTHOR: J.FRANK      *
C *  COPYRIGHT (C)1985, 1996 HEALTH RESEARCH INCORPORATED, ALBANY, NY. *
C * THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO HEALTH            *
C * RESEARCH INC. AND ARE NOT TO BE DISCLOSED TO OTHERS OR USED        *
C * FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF       *
C * HEALTH RESEARCH INC.                                               *
C **********************************************************************
C                                                                      *
C  DRIVER OF SPIDER IMAGE PROCESSING SYSTEM.   J. FRANK                *
C  PLEASE UPDATE VERSION STATEMENT (MARKED BY CHERE) EVERY TIME        *
C  THE VERSION IS CHANGED!                                             *
C  
C  LUN ASSIGNMENTS: LUN  USUAL   SOURCE  IN BATCH    SOURCE  SINK
C                   NIN      5    NTERM         1     NDISK  B* FILE 
C                   NUNIN    7                               B*X FILE
C                   NDISK    1
C                   NOUT     6    ITI           3     NDAT   OUTPUT
C                   NDAT     3                               RESULT
C                   NECHO    6    ITI           3     NDAT   ECHO
C                   ITI      6                               OUTPUT
C                   ITIN     5                               INPUT
C                   NTERM    5
C                   NPROC    1   NDISK          0     ?      NDISK
C
C                                                               *
C        0         2         3         4         5         6         7 *
C23456789012345678901234567890123456789012345678901234567890123456789012
C***********************************************************************

        INCLUDE 'CMBLOCK.INC'

C @@@@@@@@@@@@@@@@@@@@@ PARAMETER  INITIALIZATION @@@@@@@@@@@@@@@@@@@@@

C	MAXIMUM NESTING FOR PROCEDURES & DO LOOPS & IF...THEN CLAUSES
	PARAMETER (MAXPRC    = 12) 
	PARAMETER (MAXPRCNAM = 25) 

C	NUMBER OF OPERATIONS IN LOCAL-SUBMENU
	PARAMETER (NMENU1 = 7) 

C	MAX. LENGTH OF PROC. NAME PLUS ONE TERMINATING NULL CHARACTER 
	PARAMETER (NTN = 80)     

C	SIZE OF ARRAY FOR STORING PROCEDURE PARAMETER INPUT
	PARAMETER (MAXQSTRQ=2000)  

C	ONE PLUS THE MAXIMUM NUMBER OF REGISTERS PER KEY IN 'UD IC'
	PARAMETER (MAXREG=7)    

C	MAXIMUM NUMBER OF KEYS IN 'UD IC'
	PARAMETER (MAXKEY=9999) 

C	MAXIMUM NUMBER OF PROCEDURE REGISTER ARGUMENTS
	PARAMETER (NPARG=12)     

C       NNAME     LENGTH OF PROCEDURE FILENAMES IN BYTES
        PARAMETER (NNAME=80)

C @@@@@@@@@@@@@@@@@@@  DECLARATIONS @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@

	REAL      ARGSAV(NPARG)
	REAL      PSTACK(MAXPRC)
        REAL      PRAMSV(MAXPRC,103),CURPARAM(103)

        LOGICAL   USEELSE(MAXPRC)

	INTEGER   IDOSTK(5,MAXPRC),NARGSREC(MAXPRC),RDUMS(NPARG)
	INTEGER   LOOPSV(MAXPRC,6),IREGST(2)
	INTEGER   IARGSENT(NPARG,MAXPRC),IARGSREC(NPARG,MAXPRC)
#ifdef SP_VMS
	INTEGER   SYS$SETPRN
#endif
	LOGICAL   JUMP,EX,ISDIGI,ISCHAR,DELETIT

	CHARACTER *(MAXQSTRQ) QSTRQ
        CHARACTER *(NTN)      TNAMEM,TNAME
        CHARACTER *(NNAME)    PROCFL(MAXPRCNAM)
        CHARACTER *(NNAME)    RESULT,LOG,LOG1,BNAME
        CHARACTER *(NNAME)    FSTACK(MAXPRC),PNAMEC

        CHARACTER *160        MESG
        CHARACTER *80         FUNCNU,REFUNC,TREFUNC
	CHARACTER *40         CVERS
        CHARACTER * 2         MENU1(NMENU1)
        CHARACTER * 8         RESULM
        CHARACTER * 7         DOLOOP
	CHARACTER * 6         CSEND
	CHARACTER * 4         LOGM,LOG1M,LABEL,FMT
        CHARACTER * 3         LABLSV(MAXPRC),LDOSTK(MAXPRC)
        CHARACTER * 1         NULL,DINDEX,DUM,TCHAR

	LOGICAL        ONSUN,ONUNIX,ONSGI,ONOSF
        COMMON /OPSYS/ ONSUN,ONUNIX,ONSGI,ONOSF,MEMALLOCABLE

C       DBUF = DOCUMENT BUFFER FOR DOCUMENT IN-CORE IMAGE(S) 
	COMMON /DOC_BUF/ DBUF(MAXREG,MAXKEY,2)

        COMMON /DRIV1_COM/ NUMREP,T1,DINDEX

C       MAKE SURE FIRST SIZING OF IOBUF IS LARGE
        PARAMETER        (NBUFSIZ = 17008)
        COMMON /IOBUF/   BUF(NBUFSIZ)

C       MAKE SURE FIRST SIZING OF COMMUN IS LARGE
        PARAMETER        (NCOMSIZ = 8000)
        COMMON /COMMUN/  BUFC(NCOMSIZ)

C$$$$$$$$$$$$$$$$$$$$$$$$ VERSION INITIALIZATION $$$$$$$$$$$$$$$$$$$$$$$

        ONUNIX = .TRUE.
CHERE               123456789 123456789 123456789 123456789 
        DATA CVERS/'VERSION:  UNIX  5.0    ISSUED: 02/03/98'/ 
#ifndef __osf__
        ONSGI = .TRUE.
        ONOSF = .FALSE.
#else
        ONSGI = .FALSE.
        ONOSF = .TRUE.
#endif

C@@@@@@@@@@@@@@@@@@@@@@@@@@ DATA STATEMENTS @@@@@@@@@@@@@@@@@@@@@@@@@@@@

C       FORMAT FOR INTERNAL READ/WRITE
        DATA FMT/'(I )'/

	DATA CSEND/'SPI***'/
	DATA (QSTRQ(I:I),I=1,MAXQSTRQ)/MAXQSTRQ*'@'/,NSTART/1/

	DATA MENU1/'EN','DO','LB','EX','RE','IF','GO'/

	DATA NFILE/0/,IFILE/0/
	DATA ISTOP/0/,IBCNT/0/
	DATA DOLOOP/'DO LB##'/,NUMREP/1/,ILOOP/1/,NLOOP/1/ 

	DATA RESULM/'results '/
	DATA LOGM/'LOG '/

C       LOGICAL UNIT NUMBERS DEFINED HERE
	DATA NDAT/3/,NTERM/5/,NUNIN/7/,NDISK/1/,IFOUND/1/

	DATA IDOTOP,IDOFLG,IFLEVEL/1,0,0/
	DATA NTRACE/0/,N_VERBOSE/1/,N_MOSAIC/0/,IPRTT/0/,SILENT/.FALSE./
        DATA ONSUN/.FALSE./

C @@@@@@@@@@@@@@@@@@@@@@@@@@@  CODE @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@

        NULL = CHAR(0)
	RESULM(8:8)=CHAR(0)
	LOGM(4:4)=CHAR(0)

C       INITIALIZE DO_LOOP STACK
        DO  I=1,5
          IDOSTK(I,1)=1
        ENDDO

C       INITIALIZE LUNS.  
C       TO CREATE BATCH DRIVER ON VAX (DRIVERX) LINK WITH INILUNB, 
C       TO CREATE INTERACTIVE DRIVER (DRIVER) LINK WITH INILUNI.

	CALL INILUN(NIN,NOUT,NECHO,ITI,ITIN,NTERM,NDAT,MAXDIM)
	NPROC = 0

C       TIME TM IS ASSUMED AT BEGININNING OF RUN.  
	T1 = SECNDS(0.0)

C       ASSUMED MODE IS INTERACTIVE.
	COPT = 'I'

C       SET ERROR FLAG TO NONE
	PARAM(10)  = 0
C       PARAM(100) NO LONGER USED FOR ERROR FLAG BUT KEPT HERE ANYWAY?
	PARAM(100) = 0

C       INITIALIZE PROCFL & NUMPRC USED TO TRACK OF PROCEDURE LISTING:
C       PROCEDURES LISTED IN THE RESULTS FILE ON FIRST OCCURRENCE ONLY
	DO L1=1,MAXPRCNAM
           PROCFL(L1)(:NNAME) = ' '
        ENDDO
	NUMPRC = 0

C       GET THE DATE AND TIME
#ifdef SP_F90
	CALL DATE_AND_TIME(CDAT)
#else
        CALL DATE(CDAT)
        CALL TIME(CTIM)
#endif

C       PRINT OUT HEADING WITH VERSION AND RELEASE DATES
	WRITE(NOUT,9090)
9090    FORMAT(/,' \\__`O O''__/        SPIDER  --  COPYRIGHT 1993')
 
	WRITE(NOUT,9091)
9091    FORMAT(' ,__xXXXx___        HEALTH RESEARCH INC., ALBANY, NY.') 

        WRITE(NOUT,9092)
9092    FORMAT('  __xXXXx__')

	WRITE(NOUT,9093)CVERS
9093    FORMAT(' /  /xxx\\  \\        ',A)

	WRITE(NOUT,9094)CDAT,CTIM
9094    FORMAT('   /     \\          DATE:     ',A,'    AT  ',A,//)

        MAXDIMMB = MAXDIM / 1000000
        WRITE(NOUT,9095) MAXDIMMB
9095    FORMAT(' YOU HAVE           ',I5,' MB OF COMMON BLOCK MEMORY')

        NUMARG = 0
C       ONUNIX CAN GET DATEXC, START & RESCHEDULE BATCHES
        IF (ONUNIX) CALL INITUNIX(NUMARG,FCHAR,NALPH)
C       SET SIZE FOR INILINE BUFFER ON VAX
        CALL INITINLN(.FALSE.,IRTFLG)

        IF (NUMARG .LE. 0) THEN
C          GET THE PROJECT AND DATA EXTENSION FROM USER
           FCHAR(1:3) = 'NC'// CHAR(0)
           CALL DRIV1(MAXDIM)
        ENDIF

#ifdef SP_VMS
C       IF  LOG FILE EXISTS WITH SAME EXTENSION, ANOTHER PROCESS MAY
C       BE  RUNNING UNDER SAME PROJECT AND DATA EXTENSION - DON'T LET IT.
        CSEND(4:6) = PRJEXC(1:3)
        ISET = SYS$SETPRN(CSEND)
#endif

C       CREATE NAME FOR LOG FILE AND OPEN THE LOG FILE
	CALL FILCAN(LOG,NLET,NULL,NULL,LOGM,PRJEXC,IER) 
	IF (IER .NE. 0)
     &     STOP '*** SPIDER UNABLE TO CONSTRUCT LOG FILE NAME ***'
	NPROC = NDISK
#if defined(SP_SUN4) || defined (SP_F90)
	OPEN(NPROC,FILE=LOG,STATUS='UNKNOWN',IOSTAT=IER)
#else
	OPEN(NPROC,FILE=LOG,STATUS='UNKNOWN',CARRIAGECONTROL='LIST',
     &       IOSTAT=IER)
#endif

	IF (IER .NE. 0) 
     &     STOP '*** SPIDER UNABLE TO OPEN LOG FILE ***'

C       CREATE NAME FOR THE RESULTS FILE
	CALL FILCAN(RESULT,NRESUL,NULL,NULL,RESULM,PRJEXC,IER)  
	IF (IER .NE. 0) 
     &     STOP '*** SPIDER UNABLE TO CONSTRUCT RESULTS FILE NAME ***'

C       ON UNIX --- INCREMENT THE RESULTS FILE VERSION IF EXISTING
        IF (ONUNIX) THEN
           CALL NEXTVERSION(RESULT(1:11),RESULT,NDAT)
           OPEN(NDAT,FILE=RESULT,STATUS='UNKNOWN',IOSTAT=IER)
        ELSE
           OPEN(NDAT,FILE=RESULT,STATUS='NEW',IOSTAT=IER)
        ENDIF
	IF (IER .NE. 0) 
     &     STOP '*** SPIDER UNABLE TO OPEN RESULTS FILE ***'

C       PRINT OUT HEADING WITH VERSION AND RELEASE DATES
	WRITE(NDAT,9090)
	WRITE(NDAT,9091)
        WRITE(NDAT,9092)
	WRITE(NDAT,9093)CVERS
	WRITE(NDAT,9094)CDAT,CTIM

	WRITE(NDAT,9096) PRJEXC(1:3),DATEXC(1:3)
9096	FORMAT(/' PROJECT EXTENSION: ',A3,'   DATA EXTENSION: ',A3,/)

        WRITE(NDAT,9095) MAXDIMMB

        IF (MEMALLOCABLE .GT. 0) WRITE(NDAT,9097) MEMALLOCABLE
9097    FORMAT(' YOU HAVE REQUESTED ',I5,' MB OF RUN_TIME MEMORY'/)
 
C       SKIP OPERATION INPUT IF FIRST OPERATION ON COMMAND LINE
        IF (NUMARG .GT. 1) GOTO 5300
	GOTO 5000

C @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ OPERATION @@@@@@@@@@@@@@@@@@@@@@@@@@@@

C       GET THE OPERATION
5000	IRTFLG = -999
        CALL RDPRMC(FCHAR,NALPH,.TRUE.,'OPERATION',NULL,IRTFLG)

C       IF OPERATION IS A COMMENT OR NULL, IGNORE IT.
5100    IF (NALPH  .LT. 1 .OR. FCHAR(:1) .EQ. ';') GOTO 5000 

5300	IF (NTRACE .GT. 0) THEN
           WRITE(ITI,9020) FCHAR(1:NALPH)
9020       FORMAT(1X,A)
	   IF (IABSLP .NE. 0 .AND. DINDEX .NE. NULL .AND. 
     &         DINDEX .NE. ' ') WRITE(ITI,9040) DINDEX,IABSLP
9040       FORMAT(1X,A,' = ',I4)
        ENDIF

C       IF THE FIRST CHARACTER IS '@', GOTO PROCEDURE EVALUATION
	IF (FCHAR(:1) .EQ. '@') GOTO 5600

C       IF THE FIRST OR SECOND CHARACTER IS NEITHER A 
C       LETTER NOR A DIGIT, CONSIDER OPERATION AN EXPRESSION

	IF(((.NOT. ISCHAR(FCHAR(1:1)))   .AND.
     &      (.NOT. ISDIGI(FCHAR(1:1))))   .OR.
     &     ((.NOT. ISCHAR(FCHAR(2:2)))   .AND.
     &      (.NOT. ISDIGI(FCHAR(2:2))))) GOTO 6800

C       IF THE FIRST THREE CHARACTERS ARE LETTERS AND THE FORTH IS '('
C       THEN IT MUST BE AN ON-LINE FUNCTION CALL. GOTO EXPRESSION EVAL.
C       FCHAR(5:5) ALLOWS MIS-TYPING SQRT(...) FOR SQR(...)

        IF ((ISCHAR(FCHAR(1:1))) .AND. (ISCHAR(FCHAR(2:2))) .AND. 
     &      (ISCHAR(FCHAR(3:3))) .AND.
     &	    (FCHAR(4:4).EQ.'('   .OR. FCHAR(5:5).EQ.'(' )) GOTO 6800

C        IF THE OPERATION IS A REGISTER, GOTO EXPRESSION EVALUATOR.
C        (RECOGNIZED BY 'X<DIGIT>' OR 'X<DIGIT><DIGIT>')
        IF ((FCHAR(1:1) .EQ. 'X' .OR. FCHAR(1:1) .EQ. 'x') .AND.
     &      (ISDIGI(FCHAR(2:2)))) GOTO 6800

C       IF A LABEL 'LB<DIGIT> IS FOUND, AND A DO-LOOP IS IN EFFECT ...
	IF ((FCHAR(1:2).EQ.'LB' .OR. (FCHAR(1:2).EQ.'lb')) .AND. 
     &       IDO.EQ.1) GOTO 8800

C       IF A LABEL IS FOUND, AND NO DO-LOOP IS IN EFFECT ...
	IF ((FCHAR(1:2).EQ.'LB' .OR. (FCHAR(1:2).EQ.'lb')) .AND. 
     &       IDO.EQ.0) GOTO 5000

C       CHAR FOLLOWED BY 2 DIGITS IS OLD STYLE BATCH (B01) CALL
	IF (ISCHAR(FCHAR(1:1)) .AND.
     &      ISDIGI(FCHAR(2:2)) .AND. ISDIGI(FCHAR(3:3)) .AND.
     &      NALPH .EQ. 3) GOTO 5600

C       TRANSLATE OPERATION STRING TO UPPER CASE NOW
        CALL SSUPCAS(FCHAR)

C       TSWITCH IS MAIN SELECTION PROGRAM FOR OPERATIONS OUTSIDE MAIN
        CALL TSWITCH(IWHICH,ICOM,MAXDIM,IRTFLG)
	IF (IRTFLG .EQ. 0) THEN
C          OPERATION FOUND OUTSIDE OF SPIDER MAIN, GET NEXT OPERATION
           GOTO 5000
        ENDIF

C       OPERATION IS NOT IN OUTSIDE MENU. SEARCH LOCAL SUBMENU FOR
C       SPECIFIC LOOPING, IF, EN, ETC OPERATIONS
C       HANDLE LONG LOCAL 'OPERATIONS'
        IF (FCHAR(1:4) .EQ. 'ELSE')  GOTO 10798
        IF (FCHAR(1:5) .EQ. 'ENDIF') GOTO 10799

	DO IFUNC = 1, NMENU1
          IF (FCHAR(1:2) .EQ. MENU1(IFUNC)(1:2)) THEN
C           OP:     EN,   DO,   LB,   EX,    RE,    IF,    GO
            GOTO (8400, 8600, 8800, 8900, 10000, 10800, 10800), IFUNC
          ENDIF
        ENDDO

C       ANY REMAINING OPERATION IS ASSUMED TO BE ARITHMETIC EXPRESSION
6800	CALL SSUPCAS(FCHAR)
        CALL ARASQ(FCHAR,NALPH,IFLAG)
	IF (IFLAG .NE. 0)THEN
C          EXPRESSION IS NO GOOD - IF BATCH, TERMINATES
           MESG = 'UNDEFINED EXPRESSION: ' // FCHAR
           CALL ERRT(101,MESG,NE)
        ENDIF
	GOTO 5000

C       COMMON TERMINATE ON ERROR SEQUENCE IN PROCEDURE -------------
9999    CALL ENDIT('SHOULD NEVER GET HERE',.FALSE.)
	STOP '**** SHOULD NEVER GET HERE FATAL ERROR'


C       END HANDLING PROCEDURE ---------------------------------------
3600	REWIND NUNIN
	CLOSE(NIN)
	CLOSE(NUNIN)
	OPEN(NIN,FILE=BNAME,STATUS='UNKNOWN')

 	IF (LENQSTRQ .GE. 1) THEN
	   DO I = 1, LENQSTRQ
              QSTRQ(I:I) = '@'
           ENDDO
        ENDIF
	LENQSTRQ = 0
        NQSTRQ   = 0
        GOTO 5000

C @@@@@@@@@@@@@@@@@@@@@ PROCEDURE OR BATCH START @@@@@@@@@@@@@@@@@@@@@@

C       COMMAND MUST BE OLD PROCEDURE NAME OR BATCH FILE NAME ---------
C       SET FLAG FOR BATCH OR INTERACTIVE MODE WHEN THE PROCEDURE 
C       WAS CALLED

5600    IF (COPT .EQ. 'I') IPROC = 0
	IF (COPT .EQ. 'B') IPROC = 1

C       IF THIS IS FIRST PROCEDURE CALL, OR NEW PROCEDURE IS NOT BATCH, 
C       FILE OR CURRENT PROCEDURE IS A BATCH FILE, THEN  WE'RE OK.  
C       OTHERWISE WE HAVE PROCEDURE CALLING BATCH FILE, DON'T ALLOW IT

C       FCHAR(2:2) IS DIGIT FOR BATCH FILE, A LETTER FOR PROCEDURE FILE 
	IF (ISTOP .NE. 0 .AND. 
     &      (FCHAR(1:1) .EQ. 'B' .OR. FCHAR(1:1) .EQ.'b') .AND.
     &      ISDIGI(FCHAR(2:2)) .AND. ISDIGI(FCHAR(2:2))) THEN
           CALL ERRT(101,'PROCEDURE FILE CANNOT CALL BATCH FILE',NE)
C          THIS SHOULD ALWAYS HALT IN ERRT!!
           GOTO 9999
        ENDIF

C       FIND FIRST POSSIBLE CHARACTER IN FILENAME
	NFSTRT = 1
	IF (FCHAR(:1) .EQ. '@') NFSTRT = 2

C       COPY ARGUMENT LIST IF PRESENT -------------------------------
C       IF REGISTERS ARE FOUND, THEN NARGREG > 0
C       REGISTER LIST SAVED IN IARGSENT
        CALL FROMTOQ(FCHAR(NFSTRT:),NALPH,'[',']',IARGSENT(1,ISTOP+1),
     &               RDUMS,NARGREG,NPARG)

C       TNAME IS TEMP NAME TO SEE WHERE PROCEDURE EXISTS
C       TNAMEM NEEDS DELIMITER
        IF (ONUNIX .AND. FCHAR(:1) .EQ. '@') NALPH = NALPH - 1
        TNAMEM(1:NALPH+1) = FCHAR(NFSTRT:NFSTRT+NALPH-1) // NULL
        CALL FILCAN(TNAME,NTNAME,NULL,  NULL,TNAMEM,PRJEXC,IER)  
	IF (IER.NE.0) CALL ERRT(101,'FILENAME ??',NE)

C       PUT TNAME INTO BNAME, CREATE NAME OF TEMPORARY BATCH OR
C       PROCEDURE FILE BY PUTTING LETTER 'X' BEFORE PERIOD.
        BNAME = TNAME(1:NTNAME-4) // 'X' // 
     &          TNAME(NTNAME-3:NTNAME) // NULL

C       IF IT'S A BATCH FILE THE NAME IS CORRECT
C       IF NOT A BATCH FILE TRY USER'S DIRECTORY & PROJECT EXTENSION
C       PROCEDURE FILE

	INQUIRE(FILE=TNAME,EXIST=EX)
        IF (.NOT. EX) THEN
C         FILE DOESN'T EXIST - IF IT'S BATCH FILE GIVE ERROR MESSAGE
          IF (FCHAR(2:2) .LT. 'A') THEN
             MESG = 'PROCEDURE FILE DOES NOT EXIST: '// TNAME(1:NTNAME)
             CALL ERRT(101,MESG,NE)
             GOTO 5000
          ENDIF
          WRITE(NOUT,9045) TNAME 
9045      FORMAT(' NO LOCAL PROCEDURE FILE: ',A) 

C         OTHERWISE, TRY AGAIN UNDER 'PROC:*.SYS' IN PROC DIR.
C         SET FLAG INDICATING THAT WE DO HAVE A 'SYS' EXTENSION
C         7/10/88 PROC IS LOGICAL FOR DIRECTORY WHERE *.SYS FILES ARE al

          IF (ONUNIX) THEN
             CALL MYGETENV('SPPROC_DIR',TNAME,NCHART,
     &                     'dir-for-proc-files',IER)
             IF (IER .NE. 0) CALL ERRT(101,'NO ENVIRONMENT VAR',NE)
             TNAME = TNAME(:NCHART) // TNAMEM(:NALPH)// '.sys'// NULL
          ELSE 
             CALL FILCAN(TNAME,NTNAME,'PROC',NULL,TNAMEM,'SYS',IER)
          ENDIF
          IF (IER .NE. 0) CALL ERRT(101,'BAD FILENAME',NE)

          INQUIRE(FILE=TNAME,EXIST=EX)

          IF (.NOT. EX) THEN
C           THE *.SYS FILE DOES NOT EXIST. NOTIFY USER
5800        MESG = 'PROCEDURE FILE.SYS DOES NOT EXIST: ' // TNAME 
            CALL ERRT(101,MESG,NE)
            GOTO 5000
          ENDIF
        ENDIF

C       PUT IT ON THE STACK
C       INCREMENT PROCEDURE LEVEL COUNTER
        ISTOP=ISTOP+1
	IF (ISTOP .GT. MAXPRC) THEN
C          LIMIT IS MAXPRC PROCEDURES !! LET USER KNOW 
           WRITE(NOUT,6170) MAXPRC
6170       FORMAT(' *** PROCEDURE NESTING LEVEL (',I3,') EXCEEDED')
           CALL ERRT(101,'PROCEDURE NESTING LEVEL EXCEEDED',NE)
        ENDIF

C       OK- PNAMEC IS LAST USED PROCEDURE FILE-NEEDED FOR SOLICITATIONS.  
C       PUT THE NEW PROCEDURE FILE ON THE STACK
6200    FSTACK(ISTOP) = BNAME

C       SAVE THE REGISTERS FROM CALLING PROCEDURE
	DO I = 1, 103
          PRAMSV(ISTOP,I) = PARAM(I)
        ENDDO

C       SAVE DO-LOOP INFO
	LOOPSV(ISTOP,1)    = ILOOP
	LOOPSV(ISTOP,2)    = IABSLP
	LOOPSV(ISTOP,3)    = NUMREP
	LOOPSV(ISTOP,4)    = NLOOP
	LOOPSV(ISTOP,5)    = IDO
	LOOPSV(ISTOP,6)    = IDOTOP

	LABLSV(ISTOP)(1:2) = DOLOOP(6:7)
	LABLSV(ISTOP)(3:3) = DINDEX

C       RE-SET DO-LOOP INFO FOR PROCEDURE
	ILOOP  = 1
	IABSLP = 0
	NLOOP  = 0
	NUMREP = 1
	IDO    = 0

C       PUT THE ARGS ON THE STACK
C       PUT IBCNT ON STACK, IF IT ISN'T FIRST CALL, STACK OFFSET
	PSTACK(ISTOP)=IBCNT
	IF (ISTOP.GT.1) THEN
           PNAMEC(:NNAME) = FSTACK(ISTOP-1)(:NNAME)

C          OFFSET NOW EQUAL TO POINTER
           IWHERE = IBCNT
        ENDIF

        IF (COPT .EQ. 'I') THEN
C         WRITE IT, SINCE NOT ECHOED IN RESULTS FILE IN INTERACTIVE MODE
          WRITE(NDAT, 6320)
6320	  FORMAT(/,' .OPERATION:')
          WRITE(NDAT, 6340) FCHAR(1:80)
6340      FORMAT(5X,A)

C         WE'RE NOW IN BATCH MODE, WRITE OUT HEADING.
          COPT = 'B'
        ENDIF

	WRITE(NDAT, 6380) TNAME(1:NTNAME)
6380	FORMAT(/,' -- START OF: ',A,'    --')

C       RESET ERROR FLAGS FOR BATCH RUNS ONLY, SET THE LUNS
	IF (FCHAR(2:2) .LT. 'A') THEN
           PARAM(100) = 0
           PARAM(10)  = 0
        ENDIF

C       SET ALL THE LUNS, AND OPEN THE BATCH FILE.
C       CLOSE THE LOG FILE IF INTERACTIVE,
C       CLOSE THE PREVIOUS BATCH OR PROCEDURE IF BATCH,
C       LIST PROCEDURE FILE ON FIRST CALL ONLY.

1800	IBCNT = 0
	NIN   = 1
	NOUT  = NDAT
	NECHO = NDAT
	NPROC = 0

	CLOSE(NIN)
	OPEN(NIN,FILE=TNAME,STATUS='UNKNOWN')

C       IF THIS IS A PROCEDURE WITH NEW NAMING CONVENTION, THEN
C       FOLLOWING TEST FOR BATCH FILES CAN BE BYPASSED.

	IF ((FCHAR(1:1).NE.'@') .AND.
     &      (.NOT. ISCHAR(FCHAR(1:1)) .OR. 
     &       .NOT. ISCHAR(FCHAR(2:2)) .OR. 
     &       .NOT. ISDIGI(FCHAR(3:3)))) THEN

           IF (N_VERBOSE .EQ. 1) THEN
C             LIST BATCH FILE ON NDAT IF VERBOSE
              WRITE(NDAT,*) ' '
              IBCARD = 0

C             READ EACH LINE AND PUT IN RESULTS FILE
3940          READ(NIN, 3950, END = 3980) REFUNC
3950          FORMAT(A80)
              IBCARD = IBCARD + 1
              WRITE(NDAT,3960) IBCARD,REFUNC
3960          FORMAT(3X,I4,4X,A80)
              GOTO 3940
           ENDIF

3980       REWIND NIN
           GOTO 2100
        ENDIF

        IF (NUMPRC .GT. MAXPRCNAM) THEN
C          TOO MANY PROCEDURE NAMES
	   CALL ERRT(21,'SPIDER',NE)
	   GOTO 5000
	ENDIF
        
	DO L1 = 1, NUMPRC 
          IF (TNAME .EQ. PROCFL(L1)(:NNAME)) THEN
C           DELETE PREVIOUSLY USED "X" VERSION - CREATE NEW "X" VERSION
C           DON'T NEED TO COPY PROC FILE INTO RESULTS FILE

            CLOSE(NUNIN)
            CLOSE(NIN)
            OPEN(NIN,FILE=TNAME,STATUS='OLD')
            GOTO 2100
          ENDIF
        ENDDO

C       CLOSE BATCH FILE AND OPEN PROCEDURE FILE.
	CLOSE(NIN)
	OPEN(NIN,FILE=TNAME,STATUS='OLD')
        IF (N_VERBOSE .EQ. 1) THEN
C          WRITE OUT THE PROCEDURE OPERATIONS, IF VERBOSE
	   IPCARD = 0
	   WRITE(NDAT,*) ' '

2050	   READ(NIN,3950,END=2080) REFUNC
	   IPCARD = IPCARD + 1
	   WRITE(NDAT,3960) IPCARD, REFUNC
	   GOTO 2050
        ENDIF

2080	NUMPRC = NUMPRC + 1
        PROCFL(NUMPRC)(:NNAME) = TNAME
	REWIND NIN

C       CREATE TEMPORARY PROC FILES--ADD 'X' TO BNAME
C       NOTE: IPROC=0  CAME FROM INTERACTIVE MODE WHILE 
C       IPROC=1 CAME FROM BATCH

C       GENERALIZATION FOR SUBDIRECTORY USE
2100    DO ITX = NNAME,1,-1
          IF (BNAME(ITX:ITX) .EQ. '.') GOTO 2101
        ENDDO
2101    CONTINUE
        BNAME(ITX-1:ITX-1) = 'X'       
	OPEN(NUNIN,FILE=BNAME,STATUS='UNKNOWN')

C@@@@@@@@@@@@@@@@ READING PROCEDURE OR BATCH LINE @@@@@@@@@@@@@@@@@@@@@

C       IPCNT  IS POSITION IN CURRENT PROCEDURE
C       IWHERE IS POSITION IN LAST PROCEDURE
C       LENQSTRQ IS THE INDEX FOR THE QSTRQ ARRAY
	LENQSTRQ = 0
        NQSTRQ   = 0
	IPCNT    = 0
        IF (N_VERBOSE .EQ. 1) WRITE(NDAT,*) ' '

C                        1234567890123456789012345678901234567890
2200    FUNCNU(1:40)  = '                                        '
        FUNCNU(41:80) = '                                        '

        READ(NIN,2389,END=3600) REFUNC
C       FIND LAST NON-BLANK            
        NUMCHR = lnblnk(REFUNC)
	IPCNT  = IPCNT + 1

C       1/16/85 ----- COPY REGISTER ARGUMENT LIST IF PRESENT ----------

	IF (IPCNT .EQ. 1 )  NARGSREC(ISTOP) = 0
	IF (IPCNT .EQ. 1 .AND. REFUNC(:1) .EQ. '[' .AND. 
     &     (REFUNC(2:2) .EQ. 'X' .OR. REFUNC(2:2) .EQ. 'x') .AND.
     &      ISDIGI(REFUNC(3:3))) THEN
          REFUNC(2:2) = 'X'

          NLEN = NUMCHR
	  CALL FROMTOQ(REFUNC,NUMCHR,'[',']',IARGSREC(1,ISTOP),RDUMS,
     &                 NARGREG1,NPARG)
	  IF (NARGREG .NE. NARGREG1) THEN
	     WRITE(NOUT,*) 
     &       '*** REGISTER ARGUMENTS SENT TO PROCEDURE:',NARGREG,
     &                     ' <> ARGUMENTS IN PROCEDURE:',NARGREG1
	     CALL ERRT(101,'REGISTER ARGUMENTS SENT TO PROC. WRONG',NE)
	  ENDIF
C         STORE NUMBER OF CURRENT REGISTERS SENT TO THIS PROC.
          NARGSREC(ISTOP) = NARGREG1

C         UPDATE THIS PROCEDURES REGISTERS FROM CALLING'S REGISTERS
  	  DO I = 1, NARGREG
             PARAM(IARGSREC(I,ISTOP))=PRAMSV(ISTOP,IARGSENT(I,ISTOP))
          ENDDO

C         PUT SEMICOLON IN FRONT OF DUMMY ARGUMENT LIST = COMMENT NOW
          REFUNC(1:NLEN+1) = ';' // REFUNC(1:NLEN)
	  NUMCHR           = NLEN + 1
        
	ENDIF

        IF ((REFUNC(1:1) .EQ. 'P' .OR. REFUNC(1:1) .EQ. '<' .OR.
     &       REFUNC(1:1) .EQ. 'p') .AND. ISDIGI(REFUNC(2:2))) THEN
C          SYMBOLIC PARAMETER SUBSTITUTION NEEDED
           GOTO 2900

        ELSEIF (REFUNC(1:1) .NE. '?') THEN
C          NOT PROCEDURE QUESTION, SUBSTITUTE ENTIRE STRING
           WRITE(NUNIN,2301) REFUNC
2301       FORMAT(A80)
           GOTO 2200
        ENDIF

C ------  ? *********** ?  PROCEDURE QUESTION EVALUATION SECTION ------

	NUMCHR                = NUMCHR + 1
	REFUNC(NUMCHR:NUMCHR) = ' '
	IF (IPROC .EQ. 0) THEN
C           CAME FROM INTERACTIVE MODE, WRITE OUT ?---? AS PROMPT
            IGO   = INDEX(REFUNC(1:NUMCHR),'?')
            IEND  = INDEX(REFUNC(IGO+1:NUMCHR),'?') + IGO
	    WRITE(ITI,2330)  REFUNC(IGO:IEND)
2330	    FORMAT('$',A)
C           INPUT RESPONSE TO ?---? PROMPT

            READ(ITIN,2389) FUNCNU
C           FIND LAST NON-BLANK            
            NCHAR = lnblnk(FUNCNU)
	    GO TO 2820
        ENDIF
	CLOSE(NIN)

	OPEN(NIN,FILE=PNAMEC,STATUS='UNKNOWN')
	DO I = 1, IWHERE
          READ(NIN,90) DUM
        ENDDO

	IWHERE        = IWHERE + 1
	PSTACK(ISTOP) = IWHERE

        READ(NIN,2389) FUNCNU
2389    FORMAT(A)
C       FIND LAST NON-BLANK            
        NCHAR = lnblnk(FUNCNU)
        CLOSE(NIN)

        TCHAR = FUNCNU(NCHAR:NCHAR)
        CALL CHARINSIDE(FUNCNU(1:NCHAR),'{','}',.TRUE., 
     &                  IGOSUB,IENDSUB,NSUB)

	IF (FUNCNU(:1) .EQ. 'X' .OR. FUNCNU(:2) .EQ. 'X' .OR.
     &	    FUNCNU(:1) .EQ. 'x' .OR. FUNCNU(:2) .EQ. 'x') THEN
C          ADDED 11/8/79 FOR CASE WHEN A QUESTION IS ANSWERED 
C          WITH A REGISTER
           IF (FUNCNU(1:1) .EQ. 'x') FUNCNU(1:1) = 'X'
           IF (FUNCNU(2:2) .EQ. 'x') FUNCNU(2:2) = 'X'

	   CALL CHKSTRQ(FUNCNU,NCHAR,'I',IREGST,FDUM,INUM,IER)
	   IF (IER .NE. 0) THEN
             CALL ERRT(101,'#2 ERROR IN REGISTER SUBSTITUTION',NE)
           ENDIF

           IFN1 = ABS(IREGST(1))
           P1   = PRAMSV(ISTOP,IFN1)
           IF (IFN1 .LT. 0) P1 = -P1

           NCHAR = 13
           WRITE(FUNCNU(1:13),2620) P1
2620       FORMAT(2F13.6)

           IF (INUM .NE. 1) THEN
             IFN2  = ABS(IREGST(2))
             P2    = PRAMSV(ISTOP,IFN2)
             IF (IFN2 .LT. 0) P2 = -P2
             NCHAR = 26
             WRITE(FUNCNU(14:26),2620) P2
           ENDIF
           FUNCNU(NCHAR+1:80) = ' '

        ELSE
           IF (NSUB .GT. 0) THEN
C             NEW STYLE ({***??}) SUBTITUTION PATTERN
C             PASS THE CURRENT PARAM SET TO FILNAMSUB
	      DO I=1,103
                 CURPARAM(I) = PRAMSV(ISTOP,I)
              ENDDO
C             SUBSTITUTE FOR {***X??} IN THE FUNCNU STRING
              CALL FILNAMSUB(FUNCNU,NCHAR,.TRUE.,CURPARAM,IRTFLG)
              TCHAR = FUNCNU(NCHAR:NCHAR)
           ENDIF

           IF (NCHAR .GE. 3 .AND. ISDIGI(TCHAR)) THEN
C             ADDED 6/02/83 FOR A FILENAME TERMINATING WITH A REGISTER
              TCHAR = FUNCNU(NCHAR-1:NCHAR-1)
              IGO   = 0
              IF (TCHAR .EQ. 'X' .OR. TCHAR .EQ. 'x') THEN
C                CHANGE TO UPPERCASE, IF NECESSARY
                 IF (TCHAR .EQ. 'x') FUNCNU(NCHAR-1:NCHAR-1) = 'X'
                 IGO = NCHAR

              ELSEIF (ISDIGI(TCHAR)) THEN
                 TCHAR = FUNCNU(NCHAR-2:NCHAR-2)
                 IF (TCHAR .EQ. 'X' .OR. TCHAR .EQ. 'x') THEN
                    IF (TCHAR .EQ. 'x') FUNCNU(NCHAR-2:NCHAR-2) = 'X'
                    IGO = NCHAR - 1
                 ENDIF
              ENDIF

              IF (IGO .GT. 0) THEN
C                HAVE A REGISTER IN FILE NAME
                 READ(FUNCNU(IGO:NCHAR),8001,IOSTAT=IER) IREG
8001             FORMAT(I2)
                 IF (IER .NE. 0) THEN
C                   STOPS IN ERRT
                    CALL ERRT(101,
     &                 '#1 ERROR IN REGISTER SUBSTITUTION',NE)
                 ENDIF
                 IREG = IREG + 1
                 N1   = PRAMSV(ISTOP,IREG) + 0.5
C                PREPARE SUBSTITUTION PATTERN
                 FUNCNU(IGO-1:IGO+1) = '***'
                 NCHAR = IGO+1
                 CALL FILGET(FUNCNU,FUNCNU,NCHAR,N1,IER)
                 IF (IER .NE. 0) THEN
C                   STOPS IN ERRT
                    CALL ERRT(101,
     &                  '#1B ERROR IN REGISTER SUBSTITUTION',NE)
                 ENDIF
              ENDIF
           ENDIF
        ENDIF

        OPEN(NIN,FILE=TNAME,STATUS='UNKNOWN')

	DO K = 1, IPCNT
           READ(NIN,90) DUM
        ENDDO

2820	IF ((LENQSTRQ + NCHAR + NQSTRQ + 4) .GE. MAXQSTRQ) THEN
C          OVERUN OF QSTRQ ARRAY, (I ADDED SOME SLOP FOR USE OF NQSTRQ)
	   CALL ERRT(30,'SPIDER',NE)
	   GOTO 3600
	ENDIF

C       PLACE SYMBOLIC PARAMETER STRING IN Q ARRAY
        NQSTRQ = NQSTRQ   + 1
        IQGO   = LENQSTRQ + 1

C       FIND START AND END OF PARAMETER STRING IN INPUT (IF ANY)

        ISEMICOL = INDEX(REFUNC(1:NUMCHR),';')
        IF (ISEMICOL .GT. 0) THEN
C          POSSIBLE COMMENT PRESENT, IGNORE COMMENTS AFTER ?....? 
           CALL CHARINSIDE(REFUNC(1:NUMCHR),'?','?',.FALSE.,
     &                     IDUM,IQ2,NDUM)
           IF (ISEMICOL .GT. IQ2) NUMCHR = ISEMICOL - 1
        ENDIF
  
        CALL CHARINSIDE(REFUNC(1:NUMCHR),'<','>',.TRUE.,IP1,IP2,NCM1)

        QSTRQ(IQGO:IQGO) = '#'

        IF (NCM1 .LT. 0) THEN
C          NO <#> IN QUERY STRING, INVENT ONE FROM NQSTRQ
           NCM1 = NUMDIG(NQSTRQ,1) - 1
           WRITE(FMT(3:3),8002) NCM1 + 1
8002       FORMAT(I1)
           WRITE(QSTRQ(IQGO+1:IQGO+NCM1+1),FMT) NQSTRQ
        ELSE
C          <#> AVAILABLE IN QUERY STRING
           NCM1 = NCM1 - 1
           QSTRQ(IQGO+1:IQGO+1+NCM1) = REFUNC(IP1:IP2)
        ENDIF
        QSTRQ(IQGO+NCM1+2:IQGO+NCM1+2)       = '#'
        QSTRQ(IQGO+NCM1+3:IQGO+NCM1+3+NCHAR) = FUNCNU(1:NCHAR)
        LENQSTRQ = LENQSTRQ + NCM1 + 3 + NCHAR + 1
        QSTRQ(LENQSTRQ:LENQSTRQ+1) = '^#'

C       NO SUBSTITUTION -- COPY FROM PROCEDURE FILE
	WRITE(NUNIN,90) FUNCNU(1:NCHAR)
90      FORMAT(A,A)
	GOTO 2200

C ------  END OF ?*******?  PROCEDURE QUESTION EVALUATION SECTION -----


C ------  BEGIN SYMBOLIC PARAMETER SUBSTITUTION SECTION ---------------

C       IF FIRST TWO CHARACTERS ARE 'P' AND DIGIT OR '<' AND DIGIT 
C       ASSUME SYMBOLIC PARAMETER SUBSTITIUTION.

2900    IF (REFUNC(1:1) .EQ. 'P' .OR. REFUNC(1:1) .EQ. 'p') THEN
C          OLD STYLE 'P#' PARAMETER SUBSTITUTION
           WRITE(NOUT,*) '*** CONVERT TO <#> SYMBOLIC PARAMETERS'
           WRITE(NDAT,*) '*** CONVERT TO <#> SYMBOLIC PARAMETERS'
           MESG =  'OFFENDING INPUT: ' // REFUNC
           CALL ERRT(101,MESG,NE)
C          STOPS IN ERRT
           GOTO 9999
        ENDIF

        TREFUNC = REFUNC
C       FIND START AND END OF PARAMETER STRING IN INPUT 
        CALL CHARINSIDE(TREFUNC(1:NUMCHR),'<','>',.FALSE.,IP1,IP2,NCT)

        IP1     = INDEX(TREFUNC(1:NUMCHR),'<') 
        IP2     = INDEX(TREFUNC(1:NUMCHR),'>') 
        IF (IP1 .LT. 1 .OR. IP2 .LE. IP1) THEN
           MESG = 'UNDECIPHERABLE SYMBOLIC PARAMETER IN: ' //
     &            TREFUNC(:NUMCHR)
           CALL ERRT(101,MESG,NE)
           GOTO 9999
        ENDIF

C       SCAN THE QSTRQ ARRAY TO FIND STRING FOR SUBSTITUTION.
        TREFUNC(IP1:IP1) = '#'
        TREFUNC(IP2:IP2) = '#'
        IPQ1             = INDEX(QSTRQ(1:LENQSTRQ),TREFUNC(IP1:IP2))

        IF (IPQ1 .LE. 0) THEN
C          UNSUCCESSFUL SEARCH FOR THIS PARAMETER NUMBER -- NOTIFY USER
           WRITE(NDAT,*) 'STORED SYMBOLIC REFERENCES: ',
     &                   QSTRQ(1:LENQSTRQ)

           MESG = 'CAN NOT FIND SYMBOLIC REFERENCE FOR: ' //
     &            REFUNC(IP1:IP2)
           CALL ERRT(101,MESG,NE)
C          STOPS IN ERRT!!
	   GOTO 9999
        ENDIF

C       FOUND THIS PARAMETER NUMBER IN QSTRQ, COPY QSTRQ VALUE TO FUNCNU
        NGO        = INDEX(QSTRQ(IPQ1+1:LENQSTRQ),'#') + IPQ1 + 1
        NEND       = INDEX(QSTRQ(NGO:LENQSTRQ+1),'#')  + NGO - 3
        FUNCNU(1:) = QSTRQ(NGO:NEND) // NULL
        NOCHAR     = NEND - NGO + 1

C       REMOVE THE PARAMETER FROM THE INPUT STRING (FOR SIMPLICITY)       
        REFUNC(1:NUMCHR-IP2+1) = REFUNC(IP2+1:NUMCHR) // NULL
        NUMCHR                 = NUMCHR - IP2

	IF (NUMCHR .GT. 0 .AND. 
     &     (REFUNC(1:1) .EQ. 'X' .OR. REFUNC(1:1) .EQ. 'x')) THEN
C          CASE OF SYMBOLIC PARAMETER PLUS REGISTER SUBSTITUTION
C          (E.G.  <**>X**) CAN WANT A  FILENAME LIKE 
C          TST000,TST999,TST***,TST****,STX0,TST0X0,TSTX11, OR TST0X11

C          DETERMINE AMOUNT OF FUNCNU TO CHOP AWAY
           IX = 3

C          KLUDGE FOR FUNCNU INPUT LIKE TSTX0  AND TST0X0
           IF (ISDIGI(FUNCNU(NOCHAR:NOCHAR)) .AND.
     &        (FUNCNU(NOCHAR-1:NOCHAR-1) .EQ. 'X' .OR.
     &         FUNCNU(NOCHAR-1:NOCHAR-1) .EQ. 'x')) IX = 2

C          KLUDGE FOR FUNCNU INPUT LIKE: IMA99001 AND
C                     REFUNC INPUT LIKE: X0 (Altered Nov 92 al)
           IF (NUMCHR .EQ. 2 .AND. ISDIGI(REFUNC(2:2)) .AND.
     &        (REFUNC(1:1) .EQ. 'X' .OR. REFUNC(1:1) .EQ. 'x')) THEN
              REFUNC(3:3) = REFUNC(2:2)
              REFUNC(NUMCHR:NUMCHR) = '0'
              NUMCHR = 3
           ENDIF

           WRITE(NUNIN,90) FUNCNU(1:NOCHAR-IX),REFUNC(1:NUMCHR)

        ELSEIF (ISCHAR(REFUNC(NUMCHR:NUMCHR))) THEN 
C          DETERMINE IF OLD-STYLE LOOP INDEX SUBSTITUTION WANTED
C          NOTE: THIS FAILS WITH * BUT I AM NOT SURE OF SIDE-EFFECTS
C                SO I WILL LEAVE IT HERE! al
           IX = 0
           DO I = 1,(NUMCHR-1)
             IF ((REFUNC(I:I) .EQ. '0' .OR. REFUNC(I:I) .EQ. '*').AND. 
     &            ISCHAR(REFUNC(I+1:I+1))) IX = I + 1
           ENDDO

           IF (IX .GT. 0) THEN
C             SYMBOLIC PARAM. & LOOP INDEX SUBSTITUTION (E.G. '<*>**I')
              IF (NOCHAR .EQ. 3) IX = 0
C             DO NOT CHOP ANYTHING IF ONLY A SERIES PREFIX!
              WRITE(NUNIN,90) FUNCNU(1:NOCHAR-IX),REFUNC(1:NUMCHR)
           ELSE
              WRITE(NUNIN,90) FUNCNU(1:NOCHAR)
           ENDIF

        ELSE
C          IF NEITHER OF THE ABOVE, COPY WHOLE STRING
           WRITE(NUNIN,90) FUNCNU(1:NOCHAR)
	ENDIF 
	GOTO 2200

C @@@@@@@@@@@@@@@@@@@@ RETURN FROM PROCEDURE @@@@@@@@@@@@@@@@@@@@@@@@@@

C RETURN FROM PROCEDURE------------------------------------------- RE


C       ISTOP TELLS US HOW DEEPLY NESTED WE ARE.  POINTS TO CURRENT
C       TOP OF STACK, WHICH IS CURRENT PROCEDURE OR BATCH FILE.

10000   IF (COPT .EQ. 'I') THEN
           CALL ERRT(101,'OPERATION NOT ALLOWED IN INTERACTIVE MODE',NE)
           GOTO 5000
        ELSEIF (ISTOP .LE. 0) THEN
C          TOO MANY RETURNS, HALT IN ERRT
           CALL ERRT(101,'TOO MANY PROCEDURE RETURNS GIVEN',NE)
           GOTO 9999
	ENDIF

C       TAKE PROCEDURE OFF THE STACK, AND CLOSE IT UP

	IF (NARGSREC(ISTOP) .GT. 0) THEN
C           SAVE REGISTER VALUES SPECIFIED IN RECEIVED ARGUMENT LIST
	    DO I=1,NARGSREC(ISTOP)
               ARGSAV(I) = PARAM(IARGSREC(I,ISTOP))
            ENDDO
	ENDIF

C       RECOVER ORIGINAL SET OF REGISTERS FROM LOWER PROCEDURE LEVEL
	DO I=1,103
           PARAM(I) = PRAMSV(ISTOP,I)
        ENDDO

C       NOW OVERWRITE ORIGINAL REGISTERS PASSED ON TO PROCEDURE
	IF (NARGSREC(ISTOP) .GT. 0) THEN
	   DO I=1,NARGSREC(ISTOP)
              PARAM(IARGSENT(I,ISTOP)) = ARGSAV(I)
           ENDDO

	ENDIF

C       RETRIEVE DO-LOOP INFO
	ILOOP       = LOOPSV(ISTOP,1)
	IABSLP      = LOOPSV(ISTOP,2)
	NUMREP      = LOOPSV(ISTOP,3)
	NLOOP       = LOOPSV(ISTOP,4)
	IDO         = LOOPSV(ISTOP,5)
	IDOTOP      = LOOPSV(ISTOP,6)
	DOLOOP(6:7) = LABLSV(ISTOP)(1:2)
	DINDEX      = LABLSV(ISTOP)(3:3)
	IBCNT       = PSTACK(ISTOP)
	ISTOP       = ISTOP-1
	CLOSE(NIN)

C       MAKE DO LOOP VARIABLE AN INTEGER (E.G. A --> 1) (MAY 97)
	IDXT = ICHAR(DINDEX) - 64
C       IALPHA(LETTER CONVERTED TO NUMBER) CONTAINS IABSLP (MAY 97)
	IALPHA(IDXT) = IABSLP

C       TAKE 'X' OUT FOR PRINTING
        ITX = INDEX(BNAME,'X.')
	IF (ITX .LE. 0)  ITX = INDEX(BNAME,'x.')
        ITE = INDEX(BNAME,NULL) - 1
        IF (ITE .LE. 0) ITE = LEN(BNAME)

	WRITE(NDAT,10080) BNAME(1:ITX-1),BNAME(ITX+1:ITE)
10080	FORMAT(/,' END OF: ',A,A)
          
C       SIGNAL END OF CURRENT PROCEDURE OR BATCH
	IF (ISTOP .GT. 0) THEN
C          NEW BNAME IS NAME AT TOP OF STACK.
           BNAME(1:NNAME) = FSTACK(ISTOP)(1:NNAME)
	   OPEN(NIN,FILE=BNAME,STATUS='UNKNOWN')

C          OFFSET INPUT FOR SOLICITATIONS THAT WERE DONE BY
C          PROCEDURE CALLED BY THIS PROCEDURE
           IF (IBCNT .EQ. 0) GOTO 5000
	   DO I=1,IBCNT
              READ(NIN, 90) DUM
           ENDDO
	   GOTO 5000
	ENDIF

C        I DO NOT KNOW WHEN THIS WAS CUT OUT, I GUESS IT IS UNEEDED? al
C        IF THIS IS THE FIRST TIME THE FILE IS ACCESSED, THEN GO READ IT
C        AND SET IWHERE BACK TO 0
C        IF (IWHERE .GT. IBCNT) IBCNT = IWHERE
C        IWHERE = 0


C       IF LAST FILE WAS A BATCH FILE, THEN USER FORGOT 'EN'
        IF (BNAME(13:13).EQ.'B' .AND. ISDIGI(BNAME(14:14))) THEN
           CALL ERRT(101,'NO "EN"  ENCOUNTERED. TERMINATION ASSUMED',NE)
           GOTO 9999
        ENDIF

C        GO BACK TO INTERACTIVE MODE.  PUT ALL THE LUN'S BACK, AND
C        REOPEN THE LOG FILE, SINCE IT WAS CLOSED FOR BATCH, 
C        REDEFINE LUNS IF INTERACTIVE USE

	COPT  = 'I'
	IBCNT = 0
	NIN   = NTERM
        IF (ONUNIX) THEN
           NOUT  = 6
           NECHO = NOUT
        ELSE
	   NOUT  = NTERM
	   NECHO = NTERM
        ENDIF

	NPROC = NDISK

C       USE APPEND, SINCE WE WANT TO ADD ON TO FROM BEFORE
C       SAVE REGISTERS, GET THE OPTION
#if defined(SP_F90)
         OPEN(NPROC,FILE=LOG,STATUS='OLD',
     &        ACCESS="SEQUENTIAL",POSITION="APPEND")
#else

#if defined(SP_SUN4)
        OPEN(NPROC,FILE=LOG,STATUS='OLD',ACCESS='APPEND')
#else
        OPEN(NPROC,FILE=LOG,STATUS='OLD',ACCESS='APPEND',
     &       CARRIAGECONTROL='LIST')
#endif
#endif

	GOTO 5000

C@@@@@@@@@@@@@@@@@@@ OTHER LOCAL OPERATIONS @@@@@@@@@@@@@@@@@@@@@@@@@@@


C       END SPIDER. -------------------------------------------- EX,EN

8900    WRITE(NOUT,*) '*** ATTEMPTED TERMINATION ASSUMED'
8400	DELETIT = FCHAR(1:4) .EQ. 'EN D'
        CALL ENDIT('COMPLETED',DELETIT)
	STOP '**** SPIDER NORMAL STOP ****'



C START OF DO LOOP ------------------------------------------------ DO
C ILOOP COUNTS THE NUMBER OF TIMES WE'VE BEEN THRU THE LOOP
C NUMREP IS THE NUMBER OF REPETITIONS OF THE DO-LOOP.
C		ILOOP AND NUMREP ARE NEEDED FOR THE READ ROUTINES.
C IABSLP IS THE ACTUAL NUMBER OF THE ITERATION WE'RE DOING.
C NLOOP IS THE MAXIMUM ITERATION FOR THE LOOP  IDO=1 WHILE IN A DO LOOP 
C AND IDO=0 WHEN NOT IN A DO LOOP.  THIS ALLOWS THE USE OF A LABEL SUCH 
C AS LB1 EVEN WHEN NOT IN A DO LOOP.
C
C DOLOOP(6:7) HOLDS THE # FROM "DO LB#".
C THIS IS COMPARED WHEN A LABEL "LB#" IS ENCOUNTERED TO SEE IF THE 
C DO-LOOP SHOULD BE UPDATED OR IF THE LABEL SHOULD BE IGNORED.

8600    IF (COPT .EQ. 'I') THEN
          CALL ERRT(101,'OPERATION NOT ALLOWED IN INTERACTIVE MODE',NE)
          GOTO 5000
        ENDIF
        ILOOP  = 1
	IABSLP = 0 
	NLOOP  = 0
	IDO    = 1

        CALL SHRINKQ(FCHAR,80,FCHAR,NLET)
	DOLOOP(6:6) = FCHAR(5:5)

C       FCHAR(5:5) IS THE FIRST DIGIT OF THE LABEL, PUT IT IN DOLOOP
C       IS FCHAR(6:6) A DIGIT?  IF NOT, MAKE DOLOOP(7:7) A BLANK
C       IF YES, MAKE DOLOOP(7:7) = FCHAR(6:6)

	IF (ISDIGI(FCHAR(6:6))) THEN
	   DOLOOP(7:7) = FCHAR(6:6)
	   IWH = 8
	ELSE
	   DOLOOP(7:7) = ' '
	   IWH = 7
	ENDIF
        DINDEX = FCHAR(IWH-1:IWH-1)
        CALL SSUPCAS(DINDEX)

C       IWH POINTS TO THE EQUALS SIGN, AND IS USED AS AN OFFSET; 
C       DINDEX IS THE LOOP VARIABLE
C       PARSE OUT THE LOWER LIMIT OF THE DO LOOP

	DO 8700 I = 1, 5
          IF ((FCHAR(I+IWH:I+IWH) .EQ. 'X')
     &        .OR. (FCHAR(I+IWH:I+IWH) .EQ. 'x'))  GOTO 8700
          IF (.NOT. ISDIGI(FCHAR(I+IWH:I+IWH))) GOTO 8720
          INEXT = I
          READ(FCHAR(I+IWH:I+IWH),8660) ITEMP
8660      FORMAT(I1)
          IABSLP = IABSLP*10+ITEMP
8700	CONTINUE

C       IF ITS A REGISTER, SKIP FIRST CHARACTER
C       IS CHARACTER A DIGIT?
C       YES.  KEEP TRACK OF WHERE WE ARE IN STRING WITH INEXT, AND
C       DECODE THE DIGIT.  KEEP GOING UNTIL CHARACTER IS NOT A DIGIT.
C       LOWER LIMIT PUT IN IABSLP, SINCE THAT'S WHERE WE'LL START

C       IF THE LOWER LIMIT IS A REGISTER, PUT REGISTER VALUE IN IABLSP

C       SKIP THE COMMA, PARSE THE UPPER LIMIT OF THE DO LOOP
8720	IF ((FCHAR(IWH+1:IWH+1) .EQ. 'X')
     &      .OR. (FCHAR(IWH+1:IWH+1) .EQ. 'x')) IABSLP=PARAM(IABSLP+1)
	INEXT = INEXT + 1
	DO I = INEXT+1, INEXT+5
C         SAME AS ABOVE
          IF ((FCHAR(I+IWH:I+IWH) .NE. 'X')
     &        .AND. (FCHAR(I+IWH:I+IWH) .NE. 'x')) THEN
             IF (.NOT. ISDIGI(FCHAR(I+IWH:I+IWH))) GOTO 8760
             READ(FCHAR(I+IWH:I+IWH),8660) ITEMP
C            THE UPPER LIMIT IS PUT IN NLOOP
             NLOOP = NLOOP*10 + ITEMP
          ENDIF
 	END DO

C       IF THE UPPER LIMIT IS A REGISTER, PUT THE VALUE IN NLOOP
8760	IF ((FCHAR(IWH+INEXT+1:IWH+INEXT+1) .EQ. 'X')
     &      .OR. (FCHAR(IWH+INEXT+1:IWH+INEXT+1) .EQ. 'x'))
     &      NLOOP = PARAM(NLOOP+1)

C       NUMREP IS THE NUMBER OF TIMES THE LOOP IS PERFORMED
	NUMREP = NLOOP - IABSLP + 1

C       MAKE DO LOOP VARIABLE AN INTEGER (E.G. A --> 1)
	IDX = ICHAR(DINDEX) - 64

C       IALPHA(LETTER CONVERTED TO NUMBER) CONTAINS IABSLP
	IALPHA(IDX) = IABSLP

C       PUT IABSLP IN X0
	PARAM(1) = IABSLP

C       ADD THIS DO LOOP TO THE TOP OF THE STACK
	IDOTOP = IDOTOP + 1
	IF (IDOTOP .GT. MAXPRC) THEN
C          NESTING LEVEL IS MAXPRC.  IF EXCEEDED, LET THE USER KNOW.
C          HALTS IN ERRT
           WRITE(NOUT,6170) MAXPRC
           CALL ERRT(101,'PROCEDURE NESTING LEVEL EXCEEDED',NE)
           GOTO 9999
        ENDIF

C       SAVE ALL THE VALUES IN THE STACKS
	IDOSTK(1,IDOTOP)    = ILOOP
	IDOSTK(2,IDOTOP)    = IABSLP
	IDOSTK(3,IDOTOP)    = NUMREP
	IDOSTK(4,IDOTOP)    = NLOOP
	IDOSTK(5,IDOTOP)    = ISTOP
	LDOSTK(IDOTOP)(1:2) = DOLOOP(6:7)
	LDOSTK(IDOTOP)(3:3) = DINDEX

	GOTO 5000


C END OF DO LOOP -------------------------------------------------- LB
C       IF # IN LB# IS THE SAME AS CURRENT DO-LOOP, CONTINUE AS
C       USUAL AT THE END OF A DO-LOOP.  OTHERWISE, IGNORE THE LABEL
C       AND GO BACK TO OPERATION AND READ IN THE NEXT LINE.

8800    IF (COPT .EQ. 'I') GOTO 5000
        IF (FCHAR(3:4) .NE. LDOSTK(IDOTOP)(1:2)) GOTO 5000
C       MAKE SURE THE LABEL BEING HUNTED FOR IS IN CURRENT PROC.
        IF (ISTOP .NE. IDOSTK(5,IDOTOP)) GOTO 5000

C       NORMAL ENDING OF DO-LOOP
C       INCREASE THE NUMBER OF TIMES WE'VE BEEN THRU THE LOOP AS WELL
C       AS THE ACTUAL ITERATION VALUE OF THE LOOP
	ILOOP  = ILOOP  + 1
	IABSLP = IABSLP + 1

C       UPDATE X0
	PARAM(1) = IABSLP
	IF (IABSLP .LE. NLOOP) THEN
C         WE'RE NOT DONE YET
          REWIND NIN
          IBCNT               = 0
          IALPHA(IDX)         = IABSLP
          IDOSTK(1,IDOTOP)    = ILOOP
          IDOSTK(2,IDOTOP)    = IABSLP
          IDOSTK(3,IDOTOP)    = NUMREP
          IDOSTK(4,IDOTOP)    = NLOOP
          IDOSTK(5,IDOTOP)    = ISTOP
          LDOSTK(IDOTOP)(1:2) = DOLOOP(6:7)

C         FIND THE DOLOOP WE'RE WORKING ON, AND CONTINUE
          CALL SEARCHQ(DOLOOP,IER)
          IF (IER .NE. 0) THEN
C            SHOULD HALT IN ERRT
             CALL ERRT(101,'END-OF-FILE DURING DO-LOOP SEARCH',NE)
             GOTO 9999
          ENDIF

          IF (N_VERBOSE .EQ. 1) WRITE(NOUT, 8860) FCHAR(1:20),IABSLP
8860      FORMAT(5X,A20,'    / ',I5)

          GOTO 5000
        ENDIF

C       WE'RE DONE, RESET VALUES

8820	NUMREP = 1
	ILOOP  = 1

C       POP THE STACK, GET ALL THE VALUES BACK

	IDOTOP      = IDOTOP-1
	ILOOP       = IDOSTK(1,IDOTOP)
	IABSLP      = IDOSTK(2,IDOTOP)
	NUMREP      = IDOSTK(3,IDOTOP)
	NLOOP       = IDOSTK(4,IDOTOP)

	DOLOOP(6:7) = LDOSTK(IDOTOP)(1:2)
	DINDEX      = LDOSTK(IDOTOP)(3:3)
	IDX         = ICHAR(DINDEX) - 64
	IF (IDOTOP.EQ.1)IDO=0

C       PUT IABSLP IN X0
	PARAM(1) = IABSLP

C       IF POPPING THE STACK BECAUSE OF A LOGICAL IF JUMPING OUT OF
C       THE CURRENT DO-LOOP, GO BACK TO LOGICAL IF PROCESING.
	IF (IDOFLG .EQ. 1) GOTO 10870

C       GO TO THE TOP OF THE FILE, RESET IBCNT, WHICH TELLS US
C       HOW MANY LINES WE'VE READ IN, AND UPDATE THE STACK VALUES 
	GOTO 5000

 
C LOGICAL ELSE -------------------------------------------------- ELSE
10798   CONTINUE
        IF (IFLEVEL .GT. 0 .AND. .NOT. USEELSE(IFLEVEL)) THEN
C          DO NOT NEED TO PROCESS THESE OPERATIONS, SKIP THEM
C          KEEP READING INPUT LINES TILL CORRESPONDING ENDIF FOUND
	   CALL FINDLBQ('ENDIF',0,NULL,IDOFLG,IFLEVEL,IRTFLG)
        ELSE IF (USEELSE(IFLEVEL)) THEN
C          MUST USE THIS ELSE CLAUSE
           CONTINUE
        ENDIF
        GOTO 5000

C LOGICAL ENDIF ------------------------------------------------ ENDIF
10799   CONTINUE
        IFLEVEL = IFLEVEL - 1
        GOTO 5000
      

C LOGICAL IF -- OR GOTO---------------------------------------- IF/GOTO
10800   CALL LOGIFQ(FCHAR,LABEL,JUMP,IER)
        IF (IER .NE. 0) THEN
C          ERROR DETECTED, CAN NOT JUMP, (ERRT CALLED IN LOGIFQ)
           GOTO 5000
	ELSEIF (LABEL(1:4) .NE. 'ELSE' .AND.
     &         IER .EQ. 0 .AND. .NOT. JUMP) THEN
C          NO ERROR AND DO NOT WANT TO JUMP, CONTINUE AS NORMAL
           GOTO 5000
        ENDIF

        IF (LABEL(1:4) .EQ. 'ELSE') THEN
C          THIS IS AN IF....THEN....ELSE OPERATION
           IFLEVEL          = IFLEVEL + 1
           IF (IFLEVEL .GT. MAXPRC) THEN
C             USEELSE OVERFLOW, WILL HALT IN BATCH MODE IN ERRT
              CALL ERRT(101,'IF..ELSE NESTING LEVEL EXCEEDED',NE)
              GOTO 5000
           ENDIF
           USEELSE(IFLEVEL) = JUMP
           IF (.NOT. JUMP) GOTO 5000

C          'IF' IS FALSE JUMP TO CORRESPONDING ELSE OR ENDIF
C          DECREMENTS IFLEVEL ALSO
           CALL FINDLBQ('ELSE',IDO,LDOSTK(IDOTOP)(1:2),IDOFLG,
     &                  IFLEVEL,IRTFLG)
           GOTO 5000
        ENDIF

C       IF FIRST LABEL ELEMENT BLANK, LOGIFQ JUST SETS AN ARITHMETIC 
C       EXPRESSION.  NO NEED TO JUMP TO ANY LABEL.
        IF (LABEL(1:1) .EQ. ' ') GOTO 5000

	IF (LABEL(1:4) .NE. 'ELSE' .AND.
     &     .NOT. ISDIGI(LABEL(4:4))) LABEL(4:4) = ' '
C       MAKE SECOND DIGIT OF LB# A BLANK IN THIS CASE

C       KEEP READING INPUT LINES TILL LABEL IS FOUND
	CALL FINDLBQ(LABEL,IDO,LDOSTK(IDOTOP)(1:2),IDOFLG,
     &               IFLEVEL,IRTFLG)
C       ERRT CALLED IN FINDLBQ NOW, SO IT SHOULD HALT THERE

C       IF IDOFLG IS 1, WE HAVE PASSED BY CURRENT DO-LOOP LABEL AND
C       WE MUST POP THE DO-LOOP STACK
        IF (IDOFLG .EQ. 1) THEN
	   IF (COPT .EQ. 'I') THEN
              CALL ERRT(101,
     &           'OPERATION NOT ALLOWED IN INTERACTIVE MODE',NE)
              GOTO 5000
           ENDIF
           GOTO 8820
        ENDIF

10870	CONTINUE
C       RESET IDOFLG FOR NEXT TIME
	IDOFLG = 0

C       PROCESS THE OPERATION
	GOTO 5100

	END

