
#ifdef SP_VMS

      SUBROUTINE SPITOSGI(LUNO,LUNN,IRTFLG)

      INCLUDE 'CMBLOCK.INC'

      WRITE(NOUT,*) '*** ROUTINE NOT AVAILABLE ON VAX/VMS'
      CALL ERRT(100,'SPITOSGI',NE)
      RETURN
      END

#else

C++************************************************************************
C
C  SPITOSGI.F  -- CREATED JUL 97
C
C   Modified for F90	--- yl 	10/22/97
C
C **************************************************************************
C *  AUTHOR: A. LEITH                                                      *
C *  COPYRIGHT (C)1989 , WADSWORTH CENTER FOR LABORATORIES AND RESEARCH    *
C *    NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.              *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH 			   *
C **************************************************************************
C
C   SPITOSGI(LUNO,LUNN,NSAM,NROW,NSLICE,MODEOUT,IRTFLG)
C
C   PURPOSE:      CONVERT SPIDER IMAGE FILE TO SGI OR TARGA FORMAT
C
C   PARAMETERS:   MODEOUT       0 = SGI OUTPUT
C                               1 = TARGA OUTPUT
C
C   CALLED BY:    COPY1
C
C   CALLS:        
C          
C--*************************************************************************

	SUBROUTINE SPITOSGI(LUNO,LUNN,NSAM,NROW,NSLICE,MODEOUT,IRTFLG)

CNO_SAVE
        INCLUDE 'CMBLOCK.INC'

        REAL             BUFO(32000)
        INTEGER*1        LBUF(1024)
	COMMON           LBUF,BUFO

        CHARACTER *160   COMLIN
        CHARACTER *81    EXTEN,FILNEW
        COMMON/COMMUN/   EXTEN,FILNEW,COMLIN

        CHARACTER * 1    NULL,ANS
        DATA IDELAY/3/

        NULL   = CHAR(0)

        IF (NSLICE .NE. 1) THEN
           WRITE(NOUT,*)'WARNING: CONVERTER NOT TESTED FOR VOLUMES:'
        ENDIF
        IF (IMAMI .EQ. 0) THEN
C          NORMALIZE INPUT IMAGE FIRST
           CALL NORM3(LUNO,NSAM,NROW,NSLICE,FMAX,FMIN,AV)
        ENDIF
        
        FN    = (255 - 0) / (FMAX - FMIN)
        FNCON = 0 - FN * FMIN

C       ALLOW EXTENSION
        IRTFLG = 9
        EXTEN  = NULL
        IF (MODEOUT .EQ. 0) THEN
           CALL FILERD(FILNEW,NLET,EXTEN,'ENTER SGI OUTPUT',IRTFLG)
        ELSE
           CALL FILERD(FILNEW,NLET,EXTEN,'ENTER TARGA OUTPUT',IRTFLG)
        ENDIF
        IF (IRTFLG .NE. 0) RETURN
        IF (EXTEN .EQ. NULL) THEN
           CALL FILCAN(FILNEW,NLET,NULL,NULL,FILNEW,DATEXC,IRTFLG)
           IF (IRTFLG .NE. 0) RETURN
        ENDIF

C       OPEN TEMPORARY 8 BIT OUTPUT FILE
C        OPEN(LUNN,FILE='JUNK_RAW_RAW',ACCESS='SEQUENTIAL',IOSTAT=IER,
C     &      STATUS='UNKNOWN',FORM='FORMATTED',CARRIAGECONTROL='NONE')
        OPEN(LUNN,FILE='JUNK_RAW_RAW',ACCESS='DIRECT',IOSTAT=IER,
     &      RECL=1,STATUS='UNKNOWN',FORM='UNFORMATTED')
        IF (IER .NE. 0) THEN
           WRITE(NOUT,*) ' *** ERROR OPENING TEMP FILE: JUNK_RAW_RAW'
           RETURN
        ENDIF

        K      = 0
        DO  I = NROW,1,-1
C          READ EACH RECORD OF 32 BIT UNIX SPIDER INPUT FILE   
           CALL REDLIN(LUNO,BUFO,NSAM,I)

C          CONVERT FLOATING POINT NUMBERS TO -128...127 LOGICAL *1
           DO J=1,NSAM
             I2VAL   = BUFO(J) * FN + FNCON
             LBUF(1) = I2VAL
             CALL WRTSEQ8(LUNN,LBUF,1,IRTFLG)
             IF (IRTFLG .NE. 0) RETURN
           ENDDO
        ENDDO 

        CLOSE(LUNN)

        IF (MODEOUT .EQ. 0) THEN
C          SGI OUTPUT
           WRITE(COMLIN,8005) FILNEW(1:NLET),NSAM,NROW
8005       FORMAT('frombin JUNK_RAW_RAW ',A,' ',I6,' ',I6)
        ELSE
C          TARGA OUTPUT
           WRITE(COMLIN,8006) NSAM,NROW
8006       FORMAT('frombin JUNK_RAW_RAW JUNK_SGI_SGI ',I6,' ',I6)
        ENDIF
       CALL CSVMS(COMLIN,IERR)

C       FROMBIN FORKS PROCESSES WITHOUT WAITING SO I ADD
C       A DELAY HERE. (KLUDGY)
        CALL sleep(IDELAY)

C       REMOVE TEMPORARY 8 BIT RAW FILE
        COMLIN = '\\rm JUNK_RAW_RAW ' // NULL 
        CALL CSVMS(COMLIN,IERR)

        IF (MODEOUT .EQ. 1) THEN

C          CONVERT TO TARGA IMAGE FILE
C                         123456789 123456789 123456789 1234567
           COMLIN = 'totarga  JUNK_SGI_SGI ' // FILNEW(1:NLET) // NULL
           CALL CSVMS(COMLIN,IERR)

C          A SECOND DELAY HERE. (KLUDGY)
           CALL sleep(IDELAY)

C          REMOVE TEMPORARY 8 BIT RAW FILE
           COMLIN = '\\rm JUNK_SGI_SGI ' // NULL 
           CALL CSVMS(COMLIN,IERR)
        ENDIF
     
        RETURN
        END
#endif
