
C++************************************************************************
C
C SQUEEZ.FOR
C                                    LONG FILENAMES JAN89 al
C **************************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK            *
C *  COPYRIGHT (C)1981,1987, WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH 			   *
C **************************************************************************
C
C SQUEEZ(LUNI,LUNO,NSAM,NROW,IERR)
C
C **************************************************************************

	SUBROUTINE SQUEEZ(LUNI,LUNO,NSAM,NROW,NSLICE,IERR)

        INCLUDE 'CMBLOCK.INC'

	COMMON BUF(1)
	COMMON /COMMUN/ FILNAM

	CHARACTER *81 FILNAM
        CHARACTER *1  NULL
CNO_SAVE
        NULL = CHAR(0)

        IF (IMAMI .NE. 1) CALL NORM3(LUNI,NSAM,NROW,NSLICE,FMAX,FMIN,AV)

	IERR = 0
	CALL FILERD(FILNAM,NLET,NULL,'OUTPUT',IRTFLG)

	CALL RDPRM(ALPHA,NLOOP,ILOOP,'ANGLE BETWEEN UNIT VECTORS')
	IF (ALPHA.GE.90.0.OR.ALPHA.LE.0.0)  THEN
          CALL ERRT(101,'ANGLE MUST BE 0...90 DEGREES',NE)
          RETURN
	ENDIF

	CTG   = COSD(ALPHA)/SIND(ALPHA)
	NSAMO = NSAM + INT(ABS(CTG*NROW))

	CALL OPENF(FILNAM,LUNO,NSAMO,NROW,'UNKNOWN',NF,1)
        IF (NF .NE. 2) THEN
           IERR = 1
           CALL ERRT(4,'SQUEEZ',NE)
           RETURN
        ENDIF

	DO  I = 1,NROW
           CALL REDLIN(LUNI,BUF,NSAM,I)
           SH  = (I-1)*CTG
           KSH = SH
           EPS = SH-KSH
           DO  K = 1,NSAMO
              BUF(NSAM+K) = AV
	   ENDDO

           BUF(NSAM+1+KSH) = AV  * (1.-EPS) + BUF(1)*EPS

           DO  K = 2,NSAM
             BUF(NSAM+K+KSH) = BUF(K-1)*(1.-EPS) + BUF(K)*EPS
	   ENDDO

           IF (NSAM + KSH + 1 .LE. NSAMO) 
     &	      BUF(2*NSAM+KSH+1)=BUF(NSAM)*(1.-EPS) + AV * EPS
           CALL WRTLIN(LUNO,BUF(NSAM+1),NSAMO,I)
	ENDDO

	END
