C++*************************************************************************
C
C SSNRB.FOR
C
C **************************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK            *
C *  COPYRIGHT (C)1981-1995, WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH                            *
C **************************************************************************
C
C SSNRB:
C
C **************************************************************************
	SUBROUTINE  SSNRB(BUF,B,LR,RMSK,SIGNAL,FR,
     &	 SUMCMP,FA,INC,Y1,WI,ILIST,NANG,NNNN,NSAM,NROW,LUN9)
     
        INCLUDE 'CMBLOCK.INC'
        PARAMETER (NDLI=5)
	DIMENSION DLIST(NDLI)
	DIMENSION   B(NNNN,NROW),RMSK(NSAM,NROW),LR(INC)
	DOUBLE PRECISION SUMCMP(NNNN/2,NROW),SIGNAL(INC),FR(INC)
	DOUBLE COMPLEX FA(NNNN/2,NROW)
	DIMENSION  ILIST(NANG),BUF(1024)
	COMMON  /F_SPEC/  FINPAT,FINPIC,NLET
	CHARACTER*80  FINPAT,FINPIC
	CHARACTER*1 NULL
         DATA  LUNI/99/
CNO_SAVE
C
	NULL=CHAR(0)
	DO    J=1,NROW
	  CALL REDLIN(LUN9,RMSK(1,J),NSAM,J)
	ENDDO
	CLOSE(LUN9)
C --
C INITIALIZE THE SUMS
	DO    J=1,NROW
 	DO    I=1,NNNN/2
	SUMCMP(I,J)=0.0D0
	FA(I,J)=CMPLX(0.0,0.0)
	ENDDO
	ENDDO
C
         DO  2202  K=1,NANG
C READ ONE PROJECTION
         CALL  FILGET(FINPAT,FINPIC,NLET,ILIST(K),INTFLAG)
         CALL  OPENFB(BUF,FINPIC,LUNI,LSAM,LROW,'O',NF,NSL)
         IF(NF.NE.2)  THEN
         WRITE(NOUT,2032)  FINPIC
2032     FORMAT(' FILE SKIPPED ',A80)
         GOTO  2202
         ENDIF
C
C  READ  IMAGE
C
	DO    I=1,NROW
	  CALL  REDLIN(LUNI,B(1,I),NSAM,I)
	ENDDO
	CLOSE(LUNI)
c$doacross local(i,j)
	DO    J=1,NROW
	DO    I=1,NSAM
	  B(I,J)=B(I,J)*RMSK(I,J)
	ENDDO
	ENDDO
C
	INV=+1
        CALL  FMRS_2(B,NSAM,NROW,INV)
	IF(INV.NE.1)  THEN
	CLOSE(LUNI)
	CALL  ERRT(38,'FB',NE)
	RETURN
	ENDIF
C
c$doacross local(i,j,ix)
	DO    J=1,NROW
 	DO    I=1,NNNN,2
	IX=(I+1)/2
	FA(IX,J)=FA(IX,J)+CMPLX(B(I,J),B(I+1,J))
	SUMCMP(IX,J)=SUMCMP(IX,J)+
     &		B(I,J)*DBLE(B(I,J))+B(I+1,J)*DBLE(B(I+1,J))
	ENDDO
	ENDDO
2202	CONTINUE
C
	DO    L=1,INC
	SIGNAL(L)=0.0D0
	FR(L)=0.0D0
	LR(L)=0
	ENDDO

	DO 149 J=1,NROW
	JJ=J-1
	IF(JJ.GT.NROW/2)  JJ=NROW-JJ
	DO 149 I=1,NNNN/2
	IF(I.EQ.1.AND.JJ.LT.0) GOTO 149
	PII=0.5*SQRT((FLOAT(JJ)/FLOAT(NROW/2))**2+
     &		(FLOAT(I-1)/FLOAT(NSAM/2))**2)
	IF(PII.LE.0.5)  THEN
	L=MIN0(MAX0(INT(PII*Y1/WI),1),INC)
	LR(L)=LR(L)+1
	SIGNAL(L)=SIGNAL(L)+ABS(FA(I,J))**2
	FR(L)=FR(L)+SUMCMP(I,J)-ABS(FA(I,J))**2/NANG
	ENDIF
149	CONTINUE
C SAVE RESULTS
	DO   L=1,INC
	IF(LR(L).NE.0)  THEN
        DLIST(1)=L
	DLIST(2)=FLOAT(L-1)/FLOAT(INC-1)*0.5
        DLIST(3)=
     &	AMAX1(0.0,SNGL((FLOAT(NANG-1)/NANG)*SIGNAL(L)/FR(L))-1.0)
        DLIST(4)=LR(L)
	N1=LR(L)
	N2=(NANG-1)*LR(L)
	DLIST(5)=SQRT(2.*((N2+N1-2)*(1+2*DLIST(3))+N1*DLIST(3)**2)
     &		/FLOAT(N1*(N2-4)))
        CALL  SAVD(LUN9,DLIST,NDLI,IRTFLG)
	ENDIF
	ENDDO
	CLOSE(LUN9)
	CALL  SAVDC
	END
