 
C++*************************************************************************
C
C    SSPARM.FOR  -- CREATED FEB 88
C
C **************************************************************************
C *  AUTHOR: A. LEITH                                                      *
C *  COPYRIGHT (C)1988 , WADSWORTH CENTER FOR LABORATORIES AND             *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH 			   *
C **************************************************************************
C
C    SSPARM(MPTT)
C
C    PURPOSE:  FINDS PLOTTER CONTROL PARAMETERS FROM MPTT VALUE
C
C    PARAMETERS:  MPTT    MPT VALUE
C                 IRTFLG  ERROR RETURN FLAG
C    (IN COMMON)  MPT
C                 ISHAP
C                 IPEN
C                 INTEN
C                 MARK
C                 LINTP
C
C    CALLED BY:   SSLEXI3   SSTEKT3   SSTERM3   SSRAST3   SSGOUL3
C
C--*************************************************************************

        SUBROUTINE SSPARM(MPTT,IRTFLG)

        INCLUDE 'CONSTG.INC'

        MPT   = MPTT
        LIMFIL= MPT / 100000
        IT    = MPT - LIMFIL * 100000
        ISHAP = IT / 10000
        IT    = IT - ISHAP * 10000
        MARK  = IT / 1000
        IT    = IT - MARK * 1000
        IPEN  = IT / 100 
        IT    = IT - IPEN * 100
        LINTP = IT / 10
        INTEN = IT - LINTP * 10

        RETURN
        END
