
C++*************************************************************************
C
C    SSPUSH.FOR  -- CREATED DEC 84
C                   PEN, LINE TYPE, AND INTENSITY DEFAULTS
C                   CHANGED AUG 85 BY al
C                   VARIABLE SECTION THICKNESS ADDED BY al JAN 86
C                   STEREO ADAPTED JUNE 86 al
C                   REWRITTEN FOR FILE BASED INPUT JAN 98 al
C
C **************************************************************************
C *  AUTHOR: R. BANERJEE                                                   *
C *  COPYRIGHT (C)1985 , WADSWORTH CENTER FOR LABORATORIES AND             *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH  			   *
C **************************************************************************
C
C    SSPUSH(DATA,NDATA,NF)
C
C    PURPOSE:  TO WRITE THE CONTOUR DATA TO LUNSS
C
C    PARAMETERS:        
C        DATA(3,NDATA)  ARRAY CONTAINING THE CO-ORDINATES OF CONTOURS
C        NDATA          NO. OF POINTS 
C        NF             ERROR RETURN FLAG.(ZERO IS NORMAL)       (RET.)
C
C    VARIABLES:
C        ZCOO           Z- COORDINATE FOR THE CONTOUR (IN COMMON)
C        LUNSS          LOGICAL UNIT NUMBER  ASSIGNED TO STORAGE FILE.
C
C      CALLS:       
C
C      CALLED BY:      
C             
C--********************************************************************

	SUBROUTINE SSPUSH(DATA,NDATA,IRTFLG)

CNO_SAVE

        COMMON /UNITS/LUNDOC,NIN,NOUT,NECHO,IFOUND,NPROC,NDAT

        PARAMETER   (NSIZE = 2000)
        DIMENSION   DATA(3,NSIZE)

C---------------------------------------------------------
       PARAMETER       (KULIAH=20)
       CHARACTER * 4   CLASNM(KULIAH)
       COMMON /SSRECN/ NSEC,NPLAN,NCLAS,NCNT,
     &                 ISEC,IPLAN,ICLAS,ICNT,LUNSS,CLASNM
C---------------------------------------------------------

C       SET BAD ERROR RETURN
        IRTFLG = 1

C       CHECK WHETHER ISEC,IPLAN,ICLAS,ICNT ARE SPECIFIED OR NOT 
        IF ((ISEC .LE. 0) .OR. (ISEC .GT. NSEC)) THEN
           WRITE(NOUT,101) ISEC,NSEC
  101      FORMAT(' UN-ACCEPTABLE SECTION # = ',I5,
     &            ' should be between 1 and ',I5)
           RETURN
        ENDIF

        IF ((IPLAN .LE. 0) .OR. (IPLAN .GT. NPLAN)) THEN
           WRITE(NOUT,108) IPLAN,NPLAN
  108      FORMAT(' UN-ACCEPTABLE PLANE # = ',I5,
     &            ' should be between 1 and ',I5)
           RETURN
        ENDIF

        IF ((ICLAS .LE. 0) .OR. (ICLAS .GT. NCLAS)) THEN
           WRITE(NOUT,102) ICLAS,NCLAS
  102      FORMAT(' UN-ACCEPTABLE CLASS # = ',I5,
     &            ' should be between 1 and ',I5)
           RETURN
        ENDIF

        IF ((ICNT .LE. 0) .OR. (ICNT .GT. NCNT)) THEN
           WRITE(NOUT,103) ICNT,NCNT
  103      FORMAT(' UN-ACCEPTABLE CONTOUR # = ',I5,
     &            ' should be between 1 and ',I5)
           RETURN
        ENDIF

        
        ZCOO = ISEC
        ZERO = 0.0
        I3D  = 2
        WRITE(LUNSS,90)ISEC,IPLAN,CLASNM(ICLAS),ICNT,NDATA,I3D,ZCOO
   90   FORMAT(2I10,6X,A,3I10,F10.3)

        DO I = 1,NDATA
           WRITE(LUNSS,*) DATA(1,I),DATA(2,I),ZCOO
        ENDDO

        IRTFLG = 0

        RETURN
        END

