C *NAME* = STABK.FOR                   31-JAN-86      13:23:14                  
C----------------------------------=*=----------------------------------        
C           COPYRIGHT 1986 - JEAN-PIERRE BRETAUDIERE                            
C THE UNIVERSITY OF TEXAS HEALTH SCIENCE CENTER AT HOUSTON                      
C MEDICAL SCHOOL - DEPARTMENT OF PATHOLOGY AND LABORATORY MEDICINE              
C P.O. BOX 20708, HOUSTON, TX 77225.                                            
C DISCLAIMER: NO GUARANTEES OF PERFORMANCE ACCOMPANY THIS SOFTWARE,             
C NOR IS ANY RESPONSIBILITY ASSUMED ON THE PART OF THE AUTHOR                   
C OR THE INSTITUTION.  ALL THE SOFTWARE HAS BEEN TESTED EXTENSIVELY             
C AND EVERY EFFORT HAS BEEN MADE TO INSURE ITS RELIABILITY.                     
C THE FOLLOWING SOFTWARE MAY NOT BE COMMUNICATED TO A THIRD PARTY               
C UNDER ANY FORM WITHOUT WRITTEN PERMISSION OF THE AUTHOR.                      
C PLEASE REPORT ANY BUG(S) TO JPB AT (713) 792 52 00.                           
C OR THRU ARPANET AT  ......!rice!ots!ut-path!suprim                            
C*--------------------------------------------------------------------*         
C*                                                                    *         
C*      INPUT KLAS(ICARD) CONTAINS THE CROSSED-PARTITION WITH KTOT    *         
C*      CATEGORIES.  PRODUCT OF THE NBASE INITIAL PARTITIONS.         *         
C*      OUTPUT KLAS(ICARD) CONTAINS A PARTITION OF NKLA CLASSES.      *         
C*      THE (NKLA-1) FIRST CLASSES ARE COMPOSED OF STABLE OBJECTS IN  *         
C*      THE NBASE INITIAL PARTITIONS.  NIND OBJECTS IN THE LAST ONE.  *         
C*      WORKING ARRAYS U(*), IU(*), IV(*).                            *         
C*      DIMENSION KTOT = NCLAS ** NBASE.  OUTPUT, IU(1,...,KTOT)      *         
C*      CONTAINS THE SIZE OF THE STABLE CLASSES U(1,...,KFIN)         *         
C*      CUMULATIVE PERCENTAGES OF SIZE.                               *         
C*      SUBROUTINE CALLED ... SHELK                                   *         
C*                                                                    *         
C==06.07.80                                                           *         
C==01.12.86                                                           *         
C*--------------------------------------------------------------------*         
      SUBROUTINE STABK (ICARD, NKLA, KLAS, U, IU, IV, KTOT, KFIN,NIND)          
      DIMENSION  U(KTOT), IU(KTOT), IV(KTOT), KLAS(ICARD)                       
      COMMON  / ENSOR / LEC,IMP                                                 
C                                                                               
C  ...    THE SIZES OF THE CROSSED-PARTITION ARE IN U(*)                        
C                                                                               
        DO   K = 1,KTOT                                                       
      U(K) = 0.0                                                                
        ENDDO
        DO   I = 1,ICARD                                                      
      K     = KLAS(I)                                                           
      U(K)  = U(K) + 1.0                                                        
        ENDDO
C                                                                               
C ... THE MOST IMPORTANT (NKLA - 1) CLASSES ARE KEPT.  THE REMAINING            
C                                                                               
C     ARE IN NKLA.                                                              
      CALL SHELK (KTOT, U, IU )                                                 
        DO   K = 1,KTOT                                                       
      M     = IU(K)                                                             
      IV(M) = KTOT - K + 1                                                      
        ENDDO
        DO  I = 1,ICARD                                                       
      L     = KLAS(I)                                                           
      KO    = IV(L)                                                             
        IF (KO .GT. NKLA)              KO = NKLA                                
      KLAS(I)= KO
        ENDDO                                                             
        DO   K = 1,KTOT                                                       
      KS    = KTOT - K + 1                                                      
      IU(K) = U(KS) + 0.00001                                                   
        ENDDO
C                                                                               
C......... RESULTS OF THE CLASSIFICATION                                        
C                                                                               
      KFIN  = 0                                                                 
      NIND  = 0                                                                 
        DO   K = 1,KTOT                                                       
        IF (K .LT. NKLA)               NIND = NIND + IU(K)                      
        IF (IU(K) .LE. 0)              GO TO  70                                
      KFIN  = KFIN + 1                                                          
      U(K)  = 100.0*FLOAT(IU(K)) / FLOAT(ICARD)                                 
        ENDDO
   70   CONTINUE                                                                
      NIND  = ICARD - NIND                                                      
        DO   K = 2,KFIN                                                       
      U(K)  = U(K) + U(K-1)                                                     
        ENDDO
         RETURN                                                                 
         END                                                                    
