
C++************************************************************************
C
C STACK.FOR
C                                        LONG FILENAMES
C **************************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK            *
C *  COPYRIGHT (C)1981,1987, WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH 			   *
C **************************************************************************
C
C    STACK(LUNI,LUNO,OPTION)
C
C    PURPOSE:   STACK 2-D SLICES INTO 3-D IMAGE
C
C    PARAMETERS:
C	  LUNI	  LOGICAL UNIT NUMBER OF INPUT FILE
C	  LUNO	  LOGICAL UNIT NUMBER OF OUTPUT FILE
C	  OPTION  OPTION -- F(4)
C
C--*******************************************************************

	SUBROUTINE STACK(LUNI,LUNO,OPTION)

        INCLUDE 'CMBLOCK.INC' 
        COMMON /COMMUN/ FILNM1,FILNM2,FILENM,FILPAT,FILDUM
	COMMON ADUM(80),BUF(1)

        CHARACTER *(*) OPTION
        CHARACTER *81  FILNM1,FILNM2,FILENM,FILPAT,FILDUM
        CHARACTER *1   NULL
CNO_SAVE
	NULL=CHAR(0)

	IF (OPTION .EQ. 'R')GOTO 200
	CALL FILERD(FILNM1,NLETP,NULL,'FIRST',IRTFLG)
        IF (IRTFLG .NE. 0) RETURN

	CALL FILCAD(FILNM1,FILPAT,N1,IRTFLG)
        IF (IRTFLG .NE. 0) RETURN

	CALL FILERD(FILNM2,NLET,NULL,'LAST',IRTFLG)
        IF (IRTFLG .NE. 0) RETURN

	CALL FILCAD(FILNM2,FILDUM,N2,IRTFLG)
        IF (IRTFLG .NE. 0) RETURN
	NREC=N2-N1+1

  	CALL FILERD(FILENM,NLET,NULL,'OUTPUT',IRTFLG)
        IF (IRTFLG .NE. 0) RETURN

C       CALL OPEN TO FIND VALUES FOR NSAM,NROW

	IFOUND = -4
	CALL OPENF(FILNM1,LUNI,NSAM,NROW,'OLD',NF,NDUM)
	IF (IFORM.NE.1.AND.IFORM.NE.3)GOTO 9100
	IFOUND = 0
	CLOSE(LUNI)
	IFORM = 3

	CALL OPENF(FILENM,LUNO,NSAM,NROW,'UNKNOWN',NF,NREC)
	IF (NF.EQ.1) GOTO 9300
	IF (IFORM.NE.1.AND. IFORM.NE.3) GOTO 9100
	IFORM = 1

	DO  KREC=1,NREC
          CALL FILGET(FILPAT,FILNM2,NLETP,N1+KREC-1,IRTFLG)
          IF (IRTFLG .NE. 0) GOTO 9000

          CALL OPENF(FILNM2,LUNI,NSAM,NROW,'OLD',NF,NDUM)
          IF (IFORM.NE.1.AND.IFORM.NE.3) GOTO 9100
          IF (NF.EQ.1) GOTO 9300
          DO  KROW=1,NROW
            CALL REDLIN(LUNI,BUF,NSAM,KROW)
            KSL=(KREC-1)*NROW+KROW
            CALL WRTLIN(LUNO,BUF,NSAM,KSL)
	  ENDDO
          CLOSE(LUNI)
	ENDDO
	GOTO 9910


200     CALL FILERD(FILENM,NLET,NULL,'THREED',IRTFLG)
        IF (IRTFLG .NE. 0) RETURN
	CALL OPENF(FILENM,LUNO,NSAM,NROW,'OLD',NF,NSLICE)
	IF (IFORM.NE.1 .AND. IFORM.NE.3) GOTO 9100
	IF (NF.EQ.1) GOTO 9300

210	CALL FILERD(FILNM1,NLET,NULL,'INPUT ',IRTFLG)
	IF (IRTFLG .NE. 0) GOTO 9910
	CALL OPENF(FILNM1,LUNI,NSAMI,NROWI,'OLD',NF,NDUM)
	IF (IFORM.NE.1.AND.IFORM.NE.3)GOTO 9100
	IF (NF.EQ.1)GOTO 9300
	IF (NSAMI.NE.NSAM.OR.NROWI.NE.NROW)GOTO 9200
	CALL RDPRMI(ISLICE,IDUM,NLOOP,ILOOP,'SLICE NUMBER$')
	IF (ISLICE .GT. NSLICE) GOTO 9900

        DO  I=1,NROW
          CALL REDLIN(LUNI,BUF,NSAM,I)
          KSL=(ISLICE-1)*NROW+I
	  CALL WRTLIN(LUNO,BUF,NSAM,KSL)
	ENDDO
	CLOSE(LUNI)
	GOTO 210

9000	IER = 19
	GOTO 9900
9100	IER = 2
	GOTO 9900
9200	IER = 1
	GOTO 9900
9300	IER =4
	GOTO 9900

9900	CALL ERRT(IER,'STACK ',NE)

9910	CLOSE(LUNO)
	END

