
C++*********************************************************************
C
C STACKFIX.FOR -- CREATED 2 DEC 87 
C                                                  AUTHOR: ARDEAN LEITH
C **********************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.    AUTHOR: J.FRANK      *
C *  COPYRIGHT (C)1985, 1996 HEALTH RESEARCH INCORPORATED, ALBANY, NY. *
C * THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO HEALTH            *
C * RESEARCH INC. AND ARE NOT TO BE DISCLOSED TO OTHERS OR USED        *
C * FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF       *
C * HEALTH RESEARCH INC.                                               *
C **********************************************************************
C
C  STACKFIX(IRTFLG)
C
C  PURPOSE:     FIXES MALFORMED STACKS CREATED DURING 1997 THAT HAVE
C               UNUSED IMAGE RECORDS FOLLOWING OVERALL HEADER
C 
C  PARAMETERS:  IRTFLG       ERROR FLAG
C
C        0         2         3         4         5         6         7     
C23456789 123456789 123456789 123456789 123456789 123456789 123456789 12
C--*********************************************************************

        SUBROUTINE STACKFIX(IRTFLG)

        INCLUDE 'CMBLOCK.INC'
CNO_SAVE

        COMMON /COMMUN/ FILNAM
        COMMON /LUNARA/ LUNARA(100),LUNSTK(100)
        COMMON /IOERR/  IERR

        PARAMETER       (NBUFSIZT = 17000)
        COMMON          BUF(NBUFSIZT)
        CHARACTER *81   FILNAM
        CHARACTER *1    NULL
        LOGICAL         ISBARE

        DATA LUNIN,LUNOUT/14,15/

        NULL    = CHAR(0)
        NBUFSIZ = NBUFSIZT

C       FLAG FOR ACCEPTING MALFORMED STACKS
        IRTFLG = 88

10      CALL OPFIL(.TRUE.,FILNAM,LUNIN,'OLD',NSAM,NROW,NSLICE,
     &             NSTACKIN,'EXISTING MALFORMED STACK',.TRUE.,IRTFLG) 
	IF (IRTFLG .NE. 88) THEN
           CALL ERRT(101,'NOT A MALFORMED STACK',NE)
           RETURN
        ENDIF

        IF (NSTACKIN .EQ.-2) THEN
           CALL ERRT(101,'INPUT FILE IS NOT A STACK',NE)
           RETURN
        ENDIF

C	GET NAME FOR OUTPUT STACK FILE
        CALL FILERD(FILNAM,NLET,NULL,'NEW STACK',IRTFLG)
        IF (IRTFLG .NE. 0) THEN
           CLOSE (LUNIN)
           GOTO 10
        ENDIF

C	CHECK IF OUTPUT FILE IS A BARE STACK FILE
	IF (.NOT. ISBARE(FILNAM(1:NLET))) THEN
           CALL ERRT(101,'OUTPUT STACK MUST NOT HAVE AN IMAGE NO.',NE)
           GOTO 999
        ENDIF

C	OPEN OUTPUT STACK FILE, KEEP INPUT FILE DATE, TIME AND TITLE
        IRTFLG = -9
        CALL OPFIL(.FALSE.,FILNAM,LUNOUT,'NEW',NSAM,NROW,NSLICE,
     &             NSTACKOUT,'NEW OUTPUT STACK',.TRUE.,IRTFLG) 
	IF (IRTFLG .NE. 0) GOTO 999

C       READ OVERALL HEADER FROM OUTPUT STACK. 
        CALL REDHED(LUNOUT,BUF,NBUFSIZ,NSAM,0,IRTFLG)
        IF (IRTFLG .NE. 0) GOTO 999

C       FIND NUMBER OF RECORDS PER IMAGE
        IRECPIMG       = BUF(3)

C       SET LUNSTK FOR INPUT FILE TO FIRST VALID IMAGE HEADER RECORD
C       (SKIP THE UNUSED RECORDS AFTER OVERALL HEADER)
        LUNSTK(LUNIN)  = IRECPIMG - BUF(13)

C       COPY THE VALID IMAGE HEADERS AND RECORDS TO OUTPUT FILE
        IREC = 0
        IERR = 0
        DO WHILE (IERR .EQ. 0)
           IREC = IREC + 1
           CALL REDLIN(LUNIN,BUF,NSAM,IREC)
	   IF (IERR .EQ. 0) THEN
              CALL WRTLIN(LUNOUT,BUF,NSAM,IREC)
           ENDIF
	END DO

        WRITE(NOUT,*) ' RECORDS COPIED:', IREC - 1
        NIMAGE = (IREC - 1) / IRECPIMG
        WRITE(NOUT,*) ' IMAGES COPIED:', NIMAGE
        WRITE(NOUT,*) ' '

999     CLOSE(LUNIN)
        CLOSE(LUNOUT)

        RETURN
        END


C          WRITE(6,*)' READING RECORD: ',
C     &          IREC + LUNARA(LUNIN) + LUNSTK(LUNIN)
C             WRITE(6,*)' WRITING RECORD: ',
C    &          IREC + LUNARA(LUNOUT) + LUNSTK(LUNOUT)
C             write(6,*) ' '
