
C
C***************************************************************************
C
C
C **************************************************************************
C *  AUTHOR :                                                              *
C *  COPYRIGHT (C)1987 , WADSWORTH CENTER FOR LABORATORIES AND             *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH                            *
C **************************************************************************
C
C
C***************************************************************************
C

        SUBROUTINE STOCHA(JBASE,  NPIX,  NUMIM,  KFAC,  NITER, 
     &                    LUV, PJ,  S,  U,  TRACE,  SOMP,  V,  BB, 
     &                    D,  AD,  INB, NB, NTMP)

        DIMENSION  S(NPIX, JBASE), PJ(NPIX), U(NPIX), LUV(NUMIM), 
     &           BB(NPIX, JBASE),  V(NPIX),  D(NPIX),  AD(JBASE, JBASE)
        LOGICAL  S_ON_DISK, INB(JBASE),LDUM

C       NAR  =  CENTERING FREQUENCY

        DATA  EPS/1.0E - 4/, NAR/10/, KITER/8/
CNO_SAVE
        S_ON_DISK = .FALSE.
        TRACE  =  0  
        DO J  =  1, NPIX                                                        
          V(J)   =  0.0
          PJ(J)  =  0.0
        END DO
        CALL REW(NB,  1)
        SOMP  =  0.0 

C       CALCULATION OF WEIGHTS         
        DO I  =  1, NUMIM                                        
          READ(NB) (U(J), J = 1, NPIX),  PIA,  VAR,  INO

          IF(LUV(I) .NE. 0) THEN
            SOMP  =   SOMP  +  PIA                                              
            DO  J  =  1, NPIX
              PJ(J)  =  PJ(J)  +  U(J)                                    
            END DO

            DO J  =  1, NPIX

C             SET PROTECTION AGAINST UNDERFLOW
c              PJ(J) = AMAX1(PJ(J), 1.0E - 6)
              V(J)  =  V(J)  +  U(J) * U(J) / PIA
            END DO
          END IF
        END DO

        DO J  =  1, NPIX
          TRACE  =  TRACE  +  V(J) / PJ(J)
        END DO
        TRACE  =  TRACE  -  1.0 
        DO J  =  1, NPIX
          PJ(J)  =  PJ(J)/SOMP
        END DO
C
C
C	RANDOMIZE S MATRIX.
        DO J  =  1, NPIX
          DO L  =  1, JBASE
            S(J, L)  =  SEN3A(BID)
          END DO
        END DO
                                              
        CALL GSMOD (NPIX,  NPIX,  JBASE,  PJ,  S,  KR,  V)
        
        do  l = 1, jbase                    
          inb(l) = .true.
        END DO
        NIT = 0
	LDUM=.TRUE.
        DO WHILE (LDUM)
88        NIT = NIT + 1
          print * , ' Iteration #', nit  
          CALL ITPOW (NUMIM, NPIX, JBASE, NAR, PJ, S, BB, U, V, 
     &                SOMP, TRACE, NB, LUV, inb)

          IF(NIT. GE. KITER - 1) THEN
            IF((NIT.GT.KITER) .AND. (MOD(NIT - 12, 4) .NE. 0)) THEN
              CONTINUE
            ELSE
              jcase = 0
              do   l = 1, jbase
                if(inb(l))  jcase = jcase + 1
              END DO
              CALL CPROJ (NUMIM,  JBASE,  NPIX,  S,  v,  BB,  U,  AD, 
     &                      SOMP,  PJ,  NB,  LUV, jcase, inb)
              jcase = 0
              do l = 1, jbase
                if(inb(l))  then
                  jcase = jcase + 1
                  d(l) = v(jcase)
                endif
              END DO
              IF(S_ON_DISK)  THEN
                REWIND NTMP
                AVE = 1.0
                DO  L  =  1, KFAC
                  V(L)  =  0.0                             
C
C	U HAS TO HAVE THE AVERAGE SUBSTRATED AND PJ()=1
C
                  READ(NTMP) (U(J), J = 1, NPIX)
                  DO  J  =  1, NPIX
                   V(L)  =  V(L)  +  PJ(J) * S(J, L) * U(J)
                  END DO
                  if((1.0 - abs(v(l))).lt.eps)  then
                    inb(l) = .false.
                  else
                    AVE = amin1(AVE, ABS(V(L)))
                  endif
                END DO

                PRINT  501, AVE
501             FORMAT('   ***   Cosines of eigenvectors   *** ', /, 
     $	           '       Minimum cosine            =  ', F8.5)
                PRINT  502, (V(L), L = 1, KFAC)
502             FORMAT( 8(2X, F8.5))
                print  505, (inb(l), l = 1, jbase)
505             format(8(9x, l1))
    
                IF((1.0 - AVE).LT.EPS)  GOTO  80
              ENDIF

              REWIND NTMP
              DO L  =  1, JBASE
                WRITE(NTMP) (S(J, L), J = 1, NPIX)
              END DO
              S_ON_DISK = .TRUE.
            END IF
          END IF
        END DO

80      CONTINUE
        DO J = 1, NPIX                                      
          PJ(J)  =  PJ(J) * SOMP
        END DO

        END
