C++************************************************************************
C
C $$ SUBKMEANS.FOR
C
C **************************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK            *
C *  COPYRIGHT (C)1981,1987, WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *  THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR       *
C *  LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR    *
C *  USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF     *
C *  THE CENTER FOR LABORATORIES AND RESEARCH   			   *
C **************************************************************************
C
C
C
C $$ SUBKMEANS.FOR
C
C	W():	WEIGHTS TO BE USED PER OBJECT.
C	INUM():	FACTORS TO BE USED TO BE USED.
C	NFAC:	NUMBER OF FACTORS TO BE USED
C	NFTOT:	TOTAL NUMBER OF FACTORS USED FOR MULTIVARIATE STATISTICAL
C	 	ANALYSIS (MSA) I.E; CORAN OR PCA.
C	X()	DATA OBJECTS.
C	NOBJ	NUMBER OF OBJECTS.
C
C	CALLS:
C	  NEWKMEANS, FILSEQP, FILGET, SAVDN1, SAVD, SAVDC
C
C	NOTE: file on unit=111 is already open.
C             close the file on return from this routine.
C
C--************************************************************************

        SUBROUTINE  SUBKMEANS(X, CM, NIMI,IC, NC, WSS, AT, NOBJ, NFAC,
     &                        KCLASS, W, NFTOT, COO, INUM, BB, WW, DB,
     &                        X_DIM,USE_DISK,ISEED)

        INTEGER NLIST,NOBJ,NFAC,KCLASS,NFTOT,X_DIM
        DIMENSION  X(NFAC,X_DIM), CM(NFAC,KCLASS)
        DIMENSION  IC(NOBJ), NIMI(NOBJ), NC(KCLASS), WSS(KCLASS)
        DIMENSION  AT(NFAC),W(NFAC), COO(NFTOT), INUM(NFAC)
        PARAMETER  (NLIST = 3)
        DIMENSION  DLIST(NLIST)
        LOGICAL USE_DISK
        CHARACTER*80 FINPAT,FINP
        INTEGER*4 ILIST(1)
        INTEGER NMAX,J,NIMA,NLET,X42,IGRP,IAP,L,I
        DATA  NDOUT/55/
CNO_SAVE
C	SQUARE ROOTS OF THE WEIGHTS.
        DO J = 1, NFAC
          W(J) = SQRT(W(J))
        END DO
	IF(ISEED.EQ.0)  THEN
C	IC(NOBJ): ASSIGN A CLUSTER TO EACH OBJECT. 
        I = 1
        DO WHILE (I .LE. NOBJ)
          K = 1
          DO WHILE (K .LE. KCLASS)
            IC(I) = K
            K = K + 1
            I = I + 1
          END DO
        END DO
	ELSE
C  Random assignment
	T=1.0/FLOAT(KCLASS)
        I = 1
        DO WHILE (I .LE. NOBJ)
	Q=RAND_P(ISEED)
	QT=T
          K = 1
          DO WHILE (QT.LE.Q)
	  QT=QT+T 
          K = K + 1
          END DO
         IC(I) = K
         I = I + 1
        END DO
	
	ENDIF
C
C       NOBJ     : NUMBER OF OBJECTS
C       KCLASS   : NUMBER OF CLUSTERS
C       NFAC     : NUMBER OF (FACTORS) DIMENSION IN THE COORD. SYSTEM
C       X(M,L)   : COORDINATES OF EACH OBJECT
C       IC(M)    : CLUSTER TO WHICH OBJECT M BELONGS.
C       CM(L,N)  : COORDINATES OF THE CENTROIDS OF EACH CLUSTER.
C       WSS(N)   : SUM OF THE SQUARED DISTANCES OF ALL OBJECTS
C                  (IN A CLUSTER) TO THEIR CENTROID.
C       NC(N)     : NUMBER OF OBJECTS IN EACH CLUSTER.
C       D        : SUM OF E(N)
C                  (this has to be reduced after each new clustering)
C
        IDR = 0
        CALL  NEWKMEANS(NOBJ,NFAC,X,IC,KCLASS,CM,WSS,NC,D,IDR,
     $                  INUM,NIMI,W,COO,NFTOT,X_DIM,USE_DISK)

C
C  Calculate citeria ...
C
c$doacross if(nfac.ge.64), local(i)
	DO I = 1, NFAC
          AT(I) = 0.0
        END DO
        DO L = 1, NOBJ
c$doacross if(nfac.ge.64), local(i)
          DO I = 1, NFAC
            AT(I) = AT(I) + X(I,L)
          END DO
        END DO
c$doacross if(nfac.ge.64), local(i)
        DO I = 1, NFAC
          AT(I) = AT(I)/NOBJ
        END DO
        BB = 0.0
c$doacross if(nfac.ge.64), local(i,j),reduction(bb)
        DO I = 1, NFAC
          DO J = 1, KCLASS
            BB = BB + (CM(I,J) - AT(I))**2
          END DO
        END DO

C	REWIND THE UNIT=111
C	
        IF (USE_DISK) CALL REW(111,1)
	DO    I=1,KCLASS
 	  WSS(I)=0.0
	ENDDO
        DO L = 1, NOBJ
          IF(USE_DISK) THEN
            READ(111)   (COO(J), J = 1, NFTOT)
            DO J = 1, NFAC
              X(J,X_DIM) = W(J) * COO(INUM(J))
            END DO
            K = X_DIM
          ELSE
            K = L
          END IF
          WW = 0.0
c$doacross if(nfac.ge.64), local(i),reduction(ww)
          DO I = 1, NFAC
            WW = WW + (X(I,K) - CM(I,IC(L)))**2
          END DO
	WSS(IC(L))=WSS(IC(L))+WW
        END DO
          WW = 0.0
	DO    I=1,KCLASS
 	  WW=WW+WSS(I)
	ENDDO
C
C  Davis-Bouldin criterium
C
	DB=0.0
	DO    J=1,KCLASS
	RK=-1.0
	DO  6502  I=1,KCLASS
	IF(I.EQ.J)  GOTO  6502
	SMK=0.0
c$doacross if(nfac.ge.64), local(l),reduction(smk)
	DO    L=1,NFAC
 	  SMK=SMK+(CM(L,J)-CM(L,I))**2
	ENDDO
	RJK=(WSS(J)+WSS(I))/SMK
	RK=AMAX1(RK,RJK)
6502	CONTINUE
 	DB=DB+RK
	ENDDO
	DB=DB/K
C
C	WRITE THE OBJECTS IN EACH CLASS TO A FILE.
C                       

        NMAX = 0
        CALL  FILSEQP(FINPAT,NLET,ILIST,NMAX,NIMA,
     &                'TEMPLATE FILENAME (ex: SEL***)',IRTFLG)

C
C	LOOKING THROUGH IC(), PUT ALL OBJECTS BELONGING TO THE SAME
C	CLASS IN A FILE. 
C
        DO X42 = 1, KCLASS

C	  CREATE A FILENAME FOR CLASS X42
          CALL FILGET(FINPAT,FINP,NLET,X42,IRTFLG)

C	  NUMBER OF OBJECT IN THIS GROUP
          IGRP = 0
          NLS=2
	  DO I = 1, NOBJ
            IF (X42 .EQ. IC(I)) THEN

C             THE OBJECT BELONG TO CLASS X42, STORE IT.
              IGRP = IGRP + 1
              DLIST(1) = IGRP
              DLIST(2) = NIMI(I)
              IAP = 0
              CALL SAVDN1(NDOUT,FINP,DLIST,NLS,IGRP-1,IAP)
            END IF
	  END DO

C         CLOSE EACH CLASS FILE OPENED BY SAVDN1 ROUTINE.
          CLOSE(NDOUT)
	END DO
        DO I = 1, NOBJ
          DLIST(1) = I
          DLIST(2) = NIMI(I)
          DLIST(3) = IC(I)
44        CALL  SAVD(NDOUT, DLIST, NLIST, IRTFLG)
        END DO

        CALL  SAVDC
        CLOSE(NDOUT)
        CLOSE(111)
        END
