C++************************************************************************
C
C
C   $$SUBKMNS.FOR
C
C
C **************************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK            *
C *  COPYRIGHT (C)1981,1987, WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *  THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR       *
C *  LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR    *
C *  USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF     *
C *  THE CENTER FOR LABORATORIES AND RESEARCH   			   *
C **************************************************************************
C
C       PURPOSE:
C       THIS ROUTINE READS THE NAME OF THE FILE (IMC***, PIX***, EIG***)
C       TO GET THE NUMBER (AND THEIR COORDINATES) OF OBJECTS TO BE PARTITIONED
C
C       CALLS:
C	  FILERD, FILCAN, RDPRAI, RDPRM, RDPRMI, SUBKMEANS, PRNTXX
C
C
C--************************************************************************

        SUBROUTINE SUBKMNS(MAXMEM)
        INCLUDE 'CMBLOCK.INC'
         PARAMETER  (NUMAX=10000)
        COMMON    INUM(NUMAX),BAF(1)
C
        CHARACTER*81  FILPAT, EXTNAME, CLUSTI
        CHARACTER*140 CLUST
        CHARACTER*1  NULL
        CHARACTER*3  NAMEF
        REAL BB, WW
        INTEGER K_W,K_INUM,K_X, K_CM, NOBJ,
     $          K_IND, K_IC, K_NC, K_WSS, K_AT, K_COO, MEMTOT,
     $		NLET, KCLASS,NFAC, NFTOT,I,ITYPE,ICODE,X_DIM
        DIMENSION    Q(1)
        POINTER      (IPQ,Q) 
        LOGICAL         RUNTIME
        LOGICAL USE_DISK
CNO_SAVE
        NULL = CHAR(0)
        CALL  RDPRMI(ITYPE,I,NLOOP,ILOOP,
     $        'ENTER DATA FILENAME TYPE (SEQ(1), IMC(2) or PIX(3))')
        CALL  RDPRMI(ICODE,I,NLOOP,ILOOP,
     $        'ENTER COORDINATES FILE CODE')
	IF (ITYPE .EQ. 1) THEN
          FILPAT(1:3) = 'SEQ'
        ELSE IF(ITYPE .EQ. 2) THEN
          FILPAT(1:3) = 'IMC'
        ELSE
          FILPAT(1:3) = 'PIX'
        END IF
        IF(ICODE .GE. 1000) THEN
          FILPAT(4:11) = '****'//NULL//NULL//NULL//NULL 
          NLET = 7
        ELSE
          FILPAT(4:11) = '***'//NULL//NULL//NULL//NULL//NULL
          NLET = 6
        END IF

        IRTFLG = 0
        CALL FILGET(FILPAT, CLUSTI, NLET, ICODE, IRTFLG)
        IF (IRTFLG .NE. 0) RETURN
	NULL=CHAR(0)
        CALL  FILCAN(CLUST,NF,NULL, NULL, CLUSTI, DATEXC, IER)
        IF (IER .NE. 0) RETURN
C
C       ONLY NEW VERSION OF CLUSTER FILE ALLOWED
C	THE FILES READ ARE EITHER SEQ*, PIX* OR IMC*. TYPES
C	CREATED BY CORAN OR PCA.
C
        OPEN(FILE=CLUST, UNIT=111, STATUS='OLD', FORM='UNFORMATTED')
        READ(111)  NOBJ, NFTOT
        WRITE(NOUT, 33)  NOBJ, NFTOT, CLUST(1:NLET)
33      FORMAT(/,
     &        '   Number of objects and number of factors',2I10,/,
     &        '   in the file:',A80 )
        CALL  RDPRMI(KCLASS, I,NLOOP,ILOOP,'NUMBER OF CLASSES')
C
C       CALCULATE NUMBER OF FACTORS : NFAC (RETURNED BY RDPRAI)
C	SIZE OF INUM() = Q(K_INUM) ARRAY IS: NFAC
C       
        NFAC = NUMAX
        CALL RDPRAI( INUM, NUMAX, NFAC, 0,9999999,
     $               'FACTOR NUMBERS', NULL, IRTFLG)
C
C	SIZE OF W() = Q(K_W) ARRAY IS: NFAC
C
	K_W = 1
        K_CM = K_W + NFAC
        K_IC =  K_CM +  KCLASS * NFAC
        K_NC = K_IC + NOBJ
	K_NIMI=K_NC + KCLASS
        K_WSS = K_NIMI + NOBJ 
        K_AT = K_WSS + KCLASS
        K_COO = K_AT + NFAC
        K_X = K_COO + NFTOT
        MEMTOT = K_X + NFAC * NOBJ
        MAXM=MAXMEM-NUMAX
        CALL CHKMEM(MEMTOT,BAF,MAXM,RUNTIME,IPQ,IRTFLG)
        IF(IRTFLG.EQ.0)  THEN
C  ENOUGH SPACE
          USE_DISK = .FALSE.
          X_DIM = NOBJ
        ELSE
	  MEMTOT=K_X + NFAC
          CALL CHKMEM(MEMTOT,BAF,MAXM-NUMAX,RUNTIME,IPQ,IRTFLG)
          IF(IRTFLG.NE.0)  THEN
                CALL  ERRT(6,'CL KM',NE)
                RETURN
	  ELSE
C	  NOT EVERYTHING FITS IN MEMORY. USE DISK SPACE.
C	  COPY ONLY ONE LINE IN X(1)
	    USE_DISK = .TRUE.
            X_DIM = 1
            WRITE(NOUT, 2700)
2700        FORMAT
     &    ('  WARNING - SLOW ON-DISK VERSION USED')
	
          ENDIF
        ENDIF
C
        DO  I = 0, NFAC-1
          Q(K_W + I) = 1.0
        END DO       

        DO I = 0, NFAC-1
          CALL  RDPRM(W1,NLOOP,ILOOP,'FACTOR WEIGHT')
          IF(W1 .EQ. 0.0)  GOTO  201
          Q(K_W + I) = W1
        END DO

201     WRITE(NOUT, 22)  (Q(K_W + I), I = 0, NFAC-1)
22      FORMAT(' FACTOR WEIGHTS USED:', 10(F10.4, 1X))

C
        CALL  RDPRMI(ISEED,I,NLOOP,ILOOP,
     &   'For random seeds give non-zero starting number')
	ISEED=MOD(IABS(ISEED),340189)
C
          CALL  SUBKMEANS(Q(K_X), Q(K_CM), Q(K_NIMI),
     &                  Q(K_IC), Q(K_NC), Q(K_WSS), Q(K_AT),
     &                  NOBJ, NFAC, KCLASS, Q(K_W), NFTOT, Q(K_COO),
     &                  INUM, BB, WW, DB, X_DIM, USE_DISK,ISEED)
C

        C = BB * WW
        H = (BB / (KCLASS - 1)) / (WW / (NOBJ - KCLASS))
        WRITE (NDAT, 41)  NOBJ, NFAC, KCLASS
41      FORMAT(//,' K - M e a n s   C l u s t e r   A n a l y s i s',
     &         /,'   Number of objects   =  ',i8
     &         /,'   Number of factors   =  ',i8
     &         /,'   Number of groups    =  ',i8)

        CALL  PRNTXX(Q(K_NC), Q(K_WSS), KCLASS, NDAT)
        WRITE(NDAT, 42)  BB, WW, C, H, DB
42      FORMAT(/,'Tr(B)                                              = '
     &         ,g12.5,
     &         /,'Tr(W)                                              = '
     &         ,g12.5,
     &         /,'Coleman criterion   B*W                            = '
     &         ,g12.5,
     &         /,'Harabasz criterion (B/(kclass-1))/(W/(nobj-kclass))= '
     &         ,g12.5,
     &         /,'Davies-Bouldin criterion                           = '
     &         ,g12.5)

        WRITE(NDAT, *)
        IF(NSEL(1).NE.0)  PARAM(NSEL(1)) = BB
        IF(NSEL(2).NE.0)  PARAM(NSEL(2)) = WW
        IF(NSEL(3).NE.0)  PARAM(NSEL(3)) = C
        IF(NSEL(4).NE.0)  PARAM(NSEL(4)) = H
        IF(NSEL(5).NE.0)  PARAM(NSEL(5)) = DB
         IF(RUNTIME)  CALL ALLOCIT(0,RUNTIME,IPQ,'CL KM',IRTFLG)
        END
