
C++***************************************************************1/5/82
C
C  SUMALI.F
C
C **************************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK            *
C *  COPYRIGHT (C)1981,1987, WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH  			   *
C **************************************************************************
C
C  SUMALI.F    
C
C  PURPOSE:  TO 'SUM' ANGLES,SHIFTS FROM TWO ALIGNMENT CYCLES
C
C--*************************************************************************

	SUBROUTINE SUMALI(P)

	COMMON /PARAM/PARAM(103),NSEL(9)
	COMMON /UNITS/LUN,NIN,NOUT,NECHO,IFOUND,NPROC,NDAT
	COMMON /FUNCTION/FCHAR
	LOGICAL       P
        CHARACTER *80 FCHAR
CNO_SAVE

	CALL READPQ(FCHAR)

	DO I=7,9
	   IF (NSEL(I) .GT.99 .OR .NSEL(I).LT.3) THEN
              CALL ERRT(101,'ILLEGAL REGISTER USED',NERR)
              RETURN
           ENDIF
        ENDDO

	ANGOLD = PARAM(NSEL(1))
	XSHOLD = PARAM(NSEL(2))
	YSHOLD = PARAM(NSEL(3))
	ANGNEW = PARAM(NSEL(4))
	XSHNEW = PARAM(NSEL(5))
	YSHNEW = PARAM(NSEL(6))

	C      = COSD(ANGNEW)
	S      = SIND(ANGNEW)
	IF (P)  S = -S
	XSHSUM = XSHNEW+XSHOLD*C-YSHOLD*S
	YSHSUM = YSHNEW+XSHOLD*S+YSHOLD*C
	ANGSUM = ANGNEW+ANGOLD
	DO WHILE(ANGSUM.LT.0.0)
	ANGSUM=ANGSUM+360.0
	ENDDO
	ANGSUM=AMOD(ANGSUM,360.0)

	PARAM(NSEL(7)) = ANGSUM
	PARAM(NSEL(8)) = XSHSUM
	PARAM(NSEL(9)) = YSHSUM

	END
