C++*******************************************************************
C
C $$ TF.FOR
C
C **************************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK            *
C *  COPYRIGHT (C)1981,1987, WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH 			   *
C **************************************************************************
C
C
C $$ TF:
C
C    CALL TF(B,CS,DZ,LAMBDA,KM,NSAM,Q,DS,IE)
C      B
C      CS
C      DZ
C      LAMBDA
C      KM
C      NSAM
C      Q
C      DS
C      IE
C
C--*******************************************************************
C changed 9/5/94 to include intelligible
C Gaussian parameter jf
C
	SUBROUTINE TF(B,CS,DZ,LAMBDA,KM,NSAM,Q,DS,IE,WGH,ENV)
	REAL B(1),LAMBDA,KM,KAPPA
	DATA NRUN/0/,PI/3.14159/
	CS1 = CS*1.E7
	F1=1./SQRT(CS1*LAMBDA)
	F2=SQRT(SQRT(CS1*LAMBDA**3))
	KM1=KM*F2
	DK=KM1/FLOAT(NSAM-1)
	Q1 = (Q*F2)**2
        ENV1=ENV/F2**2
	F=-PI**2
	DS1=DS*DS*F1
	KAPPA=DS1*F/(16.*ALOG(2.))
  	DZ1=DZ*F1
	DO 50 K=1,NSAM
	AK=FLOAT(K-1)*DK
	P=AK**3-DZ1*AK
	CH=EXP(AK**4*KAPPA)
         B(K)=(EXP(F*Q1*P**2)*CH)*2*EXP(-ENV1*AK**2)
         IF(IE.EQ.1)GO TO 50
         QQT=2.*PI*(.25*AK**4-.5*DZ1*AK**2)
         B(K)=B(K)*((1.0-WGH)*SIN(QQT)-WGH*COS(QQT))
50	CONTINUE
	END

