
C++*************************************************************************
C
C   TILT.FOR
c
C **************************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK            *
C *  COPYRIGHT (C)1981,1987, WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH 			   *
C **************************************************************************
C
C   TILT(LUN)
C
C    PARAMETERS:     LUN     LOGICAL UNIT NUMBER OF FILE
C
C--*************************************************************************

	SUBROUTINE TILT(LUN)

 
        INCLUDE 'CMBLOCK.INC'  
        INCLUDE 'LABLOCK.INC'  

	COMMON BUF(1)
        COMMON /COMMUN/ NUMBER,FILNAM,FILPAT

        DIMENSION       VALUES(3)
        INTEGER         NUMBER(200)
        CHARACTER *81   FILNAM,FILPAT

        CHARACTER       NULL

	DATA PI/3.14159/
        DATA AMIN/-10E30/,AMAX/10E30/
        INTEGER NVAL, IRTFLG
        REAL FWA(4)

        NULL=CHAR(0)

C       GET IMAGE FILE NAMES
4004    WRITE(NOUT,*) 'FOR IMAGE FILE NAMES:'
        NPROJ = 200
        CALL FILSEQP(FILPAT,NLET,NUMBER,200,NPROJ, 
     $     'FILE PREFIX OR TEMPLATE (EG. PIC****)',IRTFLG)
     
        CALL FILGET(FILPAT,FILNAM,NLETF,1,IRTFLG)
	CALL OPENF(FILNAM,LUN,NSAM,NROW,'OLD',NF,NDUM)

C       FIRST FILE ASSUMED TO BE THE AXIAL PROJ. IT IS ONLY OPENED
C       TO KEEP DIMENSIONS FOR CHECKING AGAINST DIMS. OF SUBSEQUENT FILES.

	IF (NF .EQ. 1)   IERR=4
	IF (IFORM .NE .-1) IERR=2
	IF (IERR  .NE. 0)  GOTO 999
	NSAM1=NSAM
	NROW1=NROW
	CLOSE(LUN)

	DO  IPROJ=2,NPROJ

          CALL FILGET(FILPAT,FILNAM,NLETF,IPROJ,IRTFLG)

          CALL OPENF(FILNAM,LUN,NSAM,NROW,'OLD',NF,NDUM)
          IF (NF    .EQ. 1)     IERR=4
          IF (IFORM .NE. -1)    IERR=2
          IF (NSAM  .NE. NSAM1) IERR=1
          IF (NROW  .NE. NROW1) IERR=1
          IF (IERR  .NE. 0)GOTO 999

           NVAL = 4
           IRTFLG = 0
           CALL RDPRAF(FWA,4,NVAL,AMIN,AMAX,
     $       '$.AXIAL VIEW: UNIT VECT. AX,AY, BX,BY:',NULL,IRTFLG)

           ARX = FWA(1)
           ARY = FWA(2)
           BRX = FWA(3)
           BRY = FWA(4)

          WRITE(NECHO,33)ARX,ARY,BRX,BRY
33        FORMAT(1X,4F8.2)


           NVAL = 4
           IRTFLG = 0
           CALL RDPRAF(FWA,4,NVAL,AMIN,AMAX,
     $        '$.TILTD VIEW: UNIT VECT. AX,AY, BX,BY:',NULL,IRTFLG)

           ATX = FWA(1)
           ATY = FWA(2)
           BTX = FWA(3)
           BTY = FWA(4)

          CALL TILTFD(ARX,ARY,BRX,BRY,ATX,ATY,BTX,BTY,GAMR,GAMT,
     1       PHI,THA,GAMT2,IER)
          IF (IER .NE. 0) THEN
            IERR = 35
            GOTO 999
          ENDIF

45        PHID=PHI*180./PI
          THAD=THA*180./PI
          GAMR=GAMR*180./PI
          GAMT=GAMT*180./PI
          GAMT2=GAMT2*180./PI

          WRITE(NOUT,50)IPROJ,PHID,THAD,GAMR,GAMT,GAMT2
50        FORMAT(' PROJ. NO.',I3,'PHI=',F8.2,'  THETA=',F8.2,/
     1      ' ANGLE BETW. UNIT VECTORS IN AXIAL PROJ.',F8.2,/
     2      ' ANGLE BETW. UNIT VECTORS IN TILTED PROJ.',F8.2,/
     3      ' ANGLE CHECK',F8.2)

          IRTFLG = -1      
          VALUES(1) = 1.0  
          VALUES(2) = PHI
          VALUES(3) = THA
          CALL SETLAB(LUN,NSAM,BUF,14,3,VALUES,'F',IRTFLG)
          VALUES(1) = 1.0
          CALL SETLAB(LUN,NSAM,BUF,21,1,VALUES,'U',IRTFLG)

          CLOSE(LUN)
	ENDDO

	RETURN


999	CALL ERRT(IERR,'TILT  ',NE)
	RETURN
	END

