
C**********************************************************************
C
C      TMSTRT.FOR    CREATED JAN 85 
C                    MODIFIED AND ENHANCED JAN 87 al
C                    PREVIOUSLY NAMED VT125.FOR
C                    TEXT ANGLE, SIZE AND JUSTIFICATION ADDED FEB 87 al
C                    LINE INTENSITY AND TYPES ADDED MAR 87 al
C
C************************************************************************
C      AUTHOR:   R.BANERJEE & A. LEITH
C      COPYRIGHT (C)1985, WADSWORTH CENTER FOR LABORATORIES AND RESEARCH
C      NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY, 12201
C      THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR
C      LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR 
C      USED FOR PUPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF 
C      THE CENTER FOR LABORATORIES AND RESEARCH
C**********************************************************************
C
C       TMSTRT.FOR
C
C       PURPOSE:   CONTAINS GRAPHIC COMMANDS FOR A
C                  DIGITAL VT125 OR VT240 TERMINAL.
C
C       THIS ROUTINE CAN BE CALLED AT DIFFERENT ENTRY POINTS
C       ENTRY LIST:
C
C             CALL TMSTRT(IPLUN)
C                  WHERE IPLUN IS THE UNIT NO.
C
C             CALL TMCLR(IPLUN)
C                  CLEAR THE SCREEN
C      
C             CALL TMMOVE(IPLUN,X,Y)
C                  MOVES PEN TO X,Y 
C
C             CALL TMDRAW(IPLUN,X,Y)
C                  DRAWS A LINE FROM CURRENT PEN POSITION TO X,Y 
C
C             CALL TMLINE(IPLUN,X,Y,INTEN,LINTYP)
C                  DRAWS A LINE FROM CURRENT PEN POSITION TO X,Y 
C                  WITH INTENSITY AND LINE TYPE SPECIFIED
C
C             CALL TMTEXT(IPLUN,TEXT)
C                  WRITES TEXT AT CURRENT CURSOR POSITION
C
C             CALL TMEND(IPLUN)
C                  ENDS A GRAPHIC SEQUENCE
C
C             CALL TMHARD(IPLUN)
C                  TAKES A HARD COPY OF THE SCREEN
C
C   NOTES:    THE VT125 GRAPHICS TERMINAL HAS A 768 X 280 PIXEL ARRAY.
C             THE ORIGIN IS AT TOP LEFT OF THE SCREEN.  
C
C**********************************************************************

       SUBROUTINE TMSTRT(IPLUN)

       CHARACTER * 1  ESC,QUOT,FF,NEWLIN
       CHARACTER * 80 TEXT
       INTEGER        ITEXAR(100),ITWID(17),ITHIT(17),LINTEN(10)
       INTEGER        LINT(10)        
   
C      ARRAY TO CONVERT GENERAL TEXT SIZE TO FIT THIS TERMINAL
       DATA ITEXAR
C        1  2  3  4  5  6  7  8  9  0  1  2  3  4  5  6  7  8  9  0
     & / 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
     &   1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2,
     &   3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4,
     &   5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6,
     &   7, 7, 8, 8, 9, 9,10,10,11,11,12,12,13,13,14,14,15,15,16,16/

C      ARRAY FOR WIDTH OF EACH CHARACTER SIZE
       DATA ITWID
C        0  1  2  3  4  5  6  7  8  9  0  1   2   3   4   5   6  
     & / 5, 9,18,27,36,45,54,63,72,81,90,99,108,117,126,135,144/

C      ARRAY FOR HEIGHT OF EACH CHARACTER SIZE
       DATA ITHIT
C        0  1  2  3  4  5  6   7   8   9  10  11  12  13  14  15  16
     & /10,20,30,45,60,75,90,105,120,135,150,165,180,195,210,225,240/

C      ARRAY FOR LINE INTENSITY
C      INTENSITY:   0 1 2 3 4 5 6 7 8 9  
       DATA LINTEN /0,1,1,1,2,2,2,3,3,3/

C      ARRAY FOR LINETYPE PATTERNS
C      DEC VT125 STANDARD BIT PATTERNS:  0=00000000,1=11111111,2=11110000,
C      3=11100100,4=10101010,5=11101010,6-9=10001000
C      LINETYPE:  0,1,2,3,4, 5, 6, 7, 8, 9
       DATA LINT /1,2,3,4,5,12,23,24,10,15/
     
       FF     = CHAR(12)
       ESC    = CHAR(27)
       QUOT   = CHAR(39)
       NEWLIN = CHAR(92)

C..   FOR INITIALIZATION USE ESC CHAR
        WRITE(IPLUN,101) ESC
  101   FORMAT(' ',A1,'P0p')
        RETURN


      ENTRY TMSTNF(IPLUN)
        WRITE(IPLUN,107) ESC
  107   FORMAT(' ',A1,'P0p')
        RETURN


      ENTRY TMCLR(IPLUN)
C..     TO CLEAR THE SCREEN
        WRITE(IPLUN,106)
  106   FORMAT(' ','S(E)')
        RETURN


        ENTRY TMMOVE(IPLUN,X,Y)
C..        MOVE TO X,Y CO-ORDS
           IX=X
           IY=Y
           WRITE (IPLUN,103)IX,IY
  103      FORMAT(' ','P[',I13,',',I13,']')
           RETURN


        ENTRY TMDRAW(IPLUN,X,Y)
C..        DRAW LINE TO X,Y 
           IX = X
           IY = Y
           WRITE(IPLUN,102) IX,IY
  102      FORMAT(' ','V[',I13,',',I13,']')
           RETURN

        ENTRY TMLINE(IPLUN,X,Y,INTEN,LINTYP)
C..        DRAW LINE FROM PRESENT POSITON TO  X,Y CO-ORDS USING 
C..        INTENSITY AND LINE TYPE SPECIFIED
           IX = X
           IY = Y
           WRITE(IPLUN,109)LINTEN(INTEN),LINT(LINTYP+1),IX,IY
  109      FORMAT(' ','W(I',I1,')W(P',I5,')V[',I13,',',I13,']')
           RETURN


        ENTRY TMTEXT(IPLUN,TEXT,NCHAR)
C..        FOR TEXT USE TEXT IN CHAR FORM
           WRITE(IPLUN,104)QUOT,(TEXT(J:J),J=1,NCHAR),QUOT
  104      FORMAT(' ','T(W(R))',A1,80A1,A1)
           RETURN


        ENTRY TMTEX(IPLUN,TEXT,NCHAR,X,Y,ITSIZE,ITANGL,JUST)
C..        PRINTS TEXT AT X,Y WITH JUSTIFICATION, SIZE AND < DESIRED
C          SET TEXT SIZE AND ROTATION
           IF (ITSIZE .LE. 0) ITSIZE = 24
           ISIZE = ITEXAR(ITSIZE)
           ITANG = ITANGL / 45
           ITANG = ITANG  * 45
           WRITE(IPLUN,108)ITANG,ISIZE
  108      FORMAT(' ','T(D',I3,',',I2,')')

C          FIND JUSTIFIED TEXT LOCATION
           IY = Y - (ITHIT(ISIZE+1) / 2)
           IF (JUST .EQ. 1) THEN
              X1 = X - (ITWID(ISIZE+1) * NCHAR * 0.5)
              IX = X1
           ELSE IF (JUST .EQ. 2) THEN             
              X1 = X - (ITWID(ISIZE+1) * NCHAR)
              IX = X1
           ELSE
              IX = X
           ENDIF

C          MOVE TO THE LOCATION
           WRITE (IPLUN,103)IX,IY
C          WRITE TEXT
           WRITE(IPLUN,104)QUOT,(TEXT(J:J),J=1,NCHAR),QUOT

C*********************DEBUG
c           WRITE(116,9767)TEXT(1:NCHAR),X,Y,IX,IY,ITSIZE,ISIZE,
c     &                    ITANGL,ITANG,JUST
c 9767      FORMAT(' TEXT,X,Y,IX,IY,TSIZ,SIZ,T<,<,JUST:',/,
c     &            1X,A,2F6.1,8I4)
C*****************************

           RETURN


        ENTRY TMEND(IPLUN)
C..        FOR RETURN TO NORMAL MODE USE ESC CHAR
           WRITE(IPLUN,105)ESC,NEWLIN
  105      FORMAT(' ',2A)
           RETURN


        ENTRY TMHARD(IPLUN)
C..        TAKE HARD COPY OF THE SCREEN DISPLAY
           WRITE(IPLUN,110) ESC,ESC,NEWLIN
  110      FORMAT(' ',A1,'P0pS(I0,H[0,0][768,480]','S(X1Y1))',A1,A)


        RETURN
        END


C%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

        SUBROUTINE TMCLER(NOUT)

        CALL TMSTRT(NOUT)
        CALL TMCLR(NOUT)
        CALL TMEND(NOUT)
        
        RETURN
        END
