
C++************************************************************************
C
C    TOTREC.FOR  -- MAY 91 al
C
C **************************************************************************
C *  COPYRIGHT (C)1991       WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH 			   *
C **************************************************************************
C
C    TOTREC
C
C    PURPOSE:       TO RETURN NUMBER OF IMAGE, FOURIER, AND HISTOGRAM 
C                   RECORDS IN CURRENT FILE
C
C    PARAMETERS:    NSAM,NROW,NSLICE     IMAGE DIMENSIONS     (READ)
C                   IEND                 NUMBER OF RECORDS    (WRITE)
C
C    VARIABLES FROM CMBLOCK.INC 
C                   IFORM                FILE TYPE SPECIFIER. (READ)
C                   NHISTREC             HISTOGRAM RECORDS    (READ)
C                   IHIST                HISTOGRAM FLAG       (READ)
C        0         2         3         4         5         6         7     
C23456789012345678901234567890123456789012345678901234567890123456789012
C--*********************************************************************

	SUBROUTINE TOTREC(NSAM,NROW,NSLICE,IEND)

        INCLUDE 'CMBLOCK.INC'

        IF ((IFORM .EQ. 1 .OR. IFORM .EQ. 3).AND. IHIST .EQ. 0) THEN
C          2D OR 3D IMAGE WITHOUT HISTOGRAM
           IEND = NROW * NSLICE

        ELSEIF ((IFORM .EQ. 1 .OR. IFORM .EQ. 3).AND. IHIST .NE. 0) THEN
C          2D OR 3D IMAGE WITH STORED HISTOGRAM
           IEND = NROW * NSLICE + NHISTREC

        ELSEIF (IFORM .EQ. -1) THEN
C          2D FOURIER FILE
           IENDI = (NSAM + 2) * NROW
           IEND  = IENDI / NSAM
           IF (MOD(IENDI,NSAM) .NE. 0) IEND = IEND + 1

        ELSEIF (IFORM .EQ. -7 .OR. IFORM .EQ. -9) THEN
C          3D FOURIER (MICHAELS FORMAT)
           IEND = NROW * NSLICE

        ELSE
C          OTHER ODD FILE TYPE, ASSUME JUST IMAGE RECORDS
           IEND = NROW * NSLICE
        ENDIF

        RETURN
        END
