C++************************************************************************
C
C $$ TRAFCT.FOR
C
C **************************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK            *
C *  COPYRIGHT (C)1981,1987, WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *  THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR       *
C *  LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR    *
C *  USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF     *
C *  THE CENTER FOR LABORATORIES AND RESEARCH                              *
C **************************************************************************
C
C PURPOSE: CREATE A 2D TRINARY FILE (-1,0,1) ACCORDING TO TRANSFER FUNCTION.
C          THE OUTPUT CAN BE USED FOR PHASE FLIPPING IN CTF CORRECTION.
C
C23456789012345678901234567890123456789012345678901234567890123456789012
C--************************************************************************
C
C $$ TRAFCT.FOR
C
         SUBROUTINE TRAFCT(LUN)
         INCLUDE 'CMBLOCK.INC'
         REAL LAMBDA,KM
         COMMON B(1)
         COMPLEX B
         CHARACTER *81 FILNAM
         CHARACTER     NULL
         DATA PI/3.14159/
C
CNO_SAVE
         NULL = CHAR(0)
         THRETHOD=0.08
         CALL FILERD(FILNAM,NLET,NULL,'OUTPUT',IRTFLG)
         IF (IRTFLG .EQ. -1) RETURN
         CALL RDPRM(CS,NLOOP,ILOOP,'CS(MM)')
         CALL RDPRM2(DZ,LAMBDA,NLOOP,ILOOP,
     &   'DEFOCUS(ANGSTROEMS), LAMBDA(ANGSTROEMS)')
         CALL RDPRMI(NSAM,NDUM,NLOOP,ILOOP,'NUMBER OF SP.FREQ.PTS')
         CALL RDPRM(KM,NLOOP,ILOOP,'MAXIMUM SPATIAL FREQUENCY[A-1]')
         CALL RDPRM2(Q,DS,NLOOP,ILOOP,
     &   'SOURCE SIZE[A-1], DEFOCUS SPREAD[A]')
C IGNORE THE SOURCE SIZE AND DEFOCUS SPREAD
         Q=0.
         DS=0.
      CALL RDPRM2(DZA,AZZ,NLOOP,ILOOP,'ASTIGMATISM[A], AZIMUTH[DEG]')
         CALL RDPRM2(WGH,ENV,NLOOP,ILOOP,
     &   'Ampl contrast ratio [0-1], Gaussian env halfw [Fou units]')
C IGNORE THE GAUSSIAN ENVELOPE FUNCTION
         ENV=0.
        IF(MOD(NSAM,2).EQ.0)  THEN
        IFORM = -12
        LSM=NSAM+2
        ELSE
        IFORM=-11
        LSM=NSAM+1
        ENDIF
         NROW=NSAM
         IXC=NSAM/2+1
         IYC=IXC
        NSLICE=1
         CALL OPENF(FILNAM,LUN,LSM,NROW,'UNKNOWN',NF,NSLICE)
         SC=KM/FLOAT(NSAM/2)
         IE=0
C IE=0 SELECTS TRANSFER FUNCTION OPTION IN SUBROUTINE TFD
         DO  K=1,NROW
         KY=K-1
         IF(K.GT.IYC) KY=KY-NROW
         DO  I=1,LSM,2
         KX=(I-1)/2
C
         AK = SQRT(FLOAT(KY)**2 + FLOAT(KX)**2)*SC
         AZ = PI/2.
         IF(KX.EQ.0) GOTO 5
         AZ=ATAN2(FLOAT(KY),FLOAT(KX))+PI/2.
5        AZR=AZZ*(PI/180.)
         DZZ=DZ+DZA/2*SIN(2*(AZ-AZR))
C
         CALL TFD(TF,CS,DZZ,LAMBDA,KM,NSAM,Q,DS,IE,AK,WGH,ENV)
         IF(TF .GE. THRETHOD) THEN
            TF=1.0
         ELSEIF (TF .LE. -1.*THRETHOD) THEN
            TF=-1.0
         ELSE
            TF=0.
         ENDIF
         B(KX+1)=CMPLX(TF,0.0)
C
	 ENDDO
         CALL WRTLIN(LUN,B,LSM,K)
	 ENDDO
C
         END
