C++************************************************************************
C
C $$ TRAFCT3.FOR
C
C **************************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK            *
C *  COPYRIGHT (C)1981,1987, WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *  THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR       *
C *  LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR    *
C *  USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF     *
C *  THE CENTER FOR LABORATORIES AND RESEARCH                              *
C **************************************************************************
C
C PURPOSE: CREATE A TRINARY FILE (-1,0,1) ACCORDING TO TRANSFER FUNCTION.
C          THE OUTPUT CAN BE USED FOR PHASE FLIPPING IN CTF CORRECTION.
C
C23456789012345678901234567890123456789012345678901234567890123456789012
C--************************************************************************

         SUBROUTINE TRAFCT3(LUN)
         INCLUDE 'CMBLOCK.INC'
         COMMON B(1)
         COMPLEX  B
         CHARACTER *81 FILNAM
         REAL LAMBDA,KM,SIGN
         CHARACTER     NULL
         DATA PI/3.1415926/
C
CNO_SAVE
         NULL = CHAR(0)
         THRETHOD=0.08
         CALL FILERD(FILNAM,NLET,NULL,'OUTPUT',IRTFLG)
         IF (IRTFLG .EQ. -1) RETURN
         CALL RDPRM(CS,NLOOP,ILOOP,'CS(MM)')
         CALL RDPRM2(DZ,LAMBDA,NLOOP,ILOOP,
     &   'DEFOCUS(ANGSTROEMS), LAMBDA(ANGSTROEMS)')
         CALL RDPRMI(NSAM,NDUM,NLOOP,ILOOP,'NUMBER OF SP.FREQ.PTS')
         CALL RDPRM(KM,NLOOP,ILOOP,'MAXIMUM SPATIAL FREQUENCY[A-1]')
         CALL RDPRM2(Q,DS,NLOOP,ILOOP,
     &   'SOURCE SIZE[A-1], DEFOCUS SPREAD[A]')
C IGNORE SOURCE SIZE AND DEFOCUS SPREAD
         Q=0
         DS=0
         CALL RDPRM2(DZA,AZZ,NLOOP,ILOOP,'ASTIGMATISM[A], AZIMUTH[DEG]')
         CALL RDPRM2(WGH,ENV,NLOOP,ILOOP,
     &   'Ampl contrast ratio [0-1], Gaussian env halfw [Fou units]')
C IGNORE THE GAUSSIAN ENVELOPE FUNCTION
         ENV=0
         CALL  RDPRM(sign,nloop,iloop,'SIGN (+1 or -1.)')
         IFORM = -7
         NROW=NSAM
         NSLICE=NROW
        IF(MOD(NSAM,2).EQ.0)  THEN
        IFORM = -22
        LSM=NSAM+2
        ELSE
        IFORM=-21
        LSM=NSAM+1
        ENDIF
         CALL OPENFB(B,FILNAM,LUN,LSM,NROW,'UNKNOWN',NF,NSLICE)
         SC=KM/FLOAT(NSAM/2)
C
         NS2=NSAM/2
         NR2=NROW/2
         NL2=NSLICE/2
C
        DO    K=1,NSLICE
        IZ=K-1
        IF(IZ.GT.NL2)  IZ=IZ-NSLICE
        DO    J=1,NROW
        IY=J-1
        IF(IY.GT.NR2)  IY=IY-NROW
        DO    I=1,LSM
        IX=(I-1)/2
C
        AK=SQRT(FLOAT(IX*IX)+FLOAT(IY*IY)+FLOAT(IZ*IZ))*SC
        IF(AK.NE.0.0) THEN
        AZ=0.0
        ELSE
        AZ = PI/2.
        ENDIF
C       AZ=ATAN2(0.0,AK)
        AZR=AZZ*(PI/180.)
        DZZ=DZ+DZA/2*SIN(2*(AZ-AZR))
        CALL TFD(TF,CS,DZZ,LAMBDA,KM,NSAM,Q,DS,IE,AK,WGH,ENV)

C       CREATE A TRINARY FILE, NEAR ZERO USE THRETHOLD
        IF(TF .GE. THRETHOD) THEN
            TF=1.
        ELSEIF(TF .LE. -1.*THRETHOD) THEN
            TF=-1.
        ELSE
            TF=0.0
        ENDIF
        B(IX+1)=CMPLX(TF,0.0)*SIGN
	 ENDDO
         CALL  WRTLIN(LUN,B,LSM,J+(K-1)*NROW)
	 ENDDO
	 ENDDO
         END


















