
C++*************************************************************************
C
C TSWITCH.F                  FILENAMES LENGTHENED JAN 89 al
C                            REWRITTEN MAR 90 al
C                            REWRITTEN MAR 93 al
C                            ADDED 'IQ' SEPT 97 al
C                            ADDED 'AF' FEBR 98 pp
C
C **************************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK            *
C *  COPYRIGHT (C)1981,1987, WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH 			   *
C **************************************************************************
C
C     TSWITCH(ICOM,IWHICH,MAXDIM)
C
C     PURPOSE:     SELECTS CORRECT TASK LEVEL CALLING ROUTINE
C
C     PARAMETERS:  IWHICH     TASK LEVEL SELECTION NUMBER  
C                  MAXDIM     MAX. SIZE OF COMMON BUFFER
C
c    NOTE:         TO ADD A NEW COMMAND:
C                  1) INCREMENT NMENU PRAMETER
C                  2) NEW OPERATIONS WHICH DO NOT HAVE ANY SHORT 
C                     OPERATION, SHOULD USE A NUMBER FOR THE SHORT 
C                     OPERATION (SO AS TO SAVE REMAINING 2 LETTER SHORT
C                     OPERATIONS FOR THE FUTURE). 
C                  3) PLACE LONG OPERATION IN MENUL(NMENU), SHORT 
C                     OPERATION IN MENU AND THE CORRESPONDING 
C                     SUBROUTINE NUMBER IN IW(NMENU).  
C                  4) UPDATE THE OPERATIONS HANDLED TABLE DIRECTLY BELOW.
C                  5) ADD NEW NUMBER TO GOTO IF YOU HAVE ADDED A NEW
C                     MAIN SUBROUTINE
C                  6) EDIT CORRESPONDING SUBROUTINE TO ADD THE NECESSARY
C                     LISTING TO ITS MENU AND THE NECESSARY CALLS. THE 
C                     OPERATION SENT TO THE SUBROUTINE WILL BE THE 2
C                     CHAR. SHORT OPERATION AT ALL TIMES!  THE LONG
C                     OPERATION IS AVAILABLE IN COMMON /SP_OPER/
C
C
C     CODE      CALLER               OPERATIONS HANDLED
C	1	UTIL1		DE DU FI HI LI MO PK PR RA RN
C				TT ST TF FS CA GR CG CV CL
C	2	UTIL2		AD BL CP IN IP MU PA PD SH SQ SU
C				WI CE AR MR DF MA WV PP SZ WU MM CM
C				PV NK AS MN TH GP RP
C	3	UTIL3		ED RC RT BC CT OR FC SL RO OD MK AF
C	4	CORR1		AC CC CN
C	5	TAPE1		(NO LONGER USED)
C	6	FOUR1		FT PW FF FL FP EF RF GF RD CF FQ FD
C	7	PLOT1		CO PF PL CS
C	8	TVWN1          	WT
C	9	UTIL4		AP HF AT MS IQ
C	10	UTIL5		RM
C	11	PLOT2		TP
C	12	VTIL2		PS SK PJ BP DC DR MF
C	13	VTIL3		SF SC PH TA SI CR SP
C	14	CONF1		CI EP RS PT
C       15      DRIV1           NC VM ME CK TM SR RR FR PO SA VO MD AA
C       16      DRIV2           TV SE
C       17      DRIV3           UD LD SD       
C       18      SPIDER          EN DO LB EX RE IF GO
C       19      UTIL6		EC
C       20      MOD1            MY 
C
C23456789012345678901234567890123456789012345678901234567890123456789012
C--*********************************************************************

      SUBROUTINE TSWITCH(IWHICH,ICOM,MAXDIM,IRTFLG)

      INCLUDE 'CMBLOCK.INC'
CNO_SAVE

      CHARACTER *20    FCHARS
      COMMON /SP_OPER/ FCHARS

C     NUMBER OF OPERATIONS IN MENU 
      PARAMETER (NMENU = 136) 

      CHARACTER * 2         MENU(NMENU)
      CHARACTER *12         MENUL(NMENU)
      INTEGER               IW(NMENU)

      DATA MENU(124), MENUL(124), IW(124) /'AA','  ',15/
      DATA MENU(1),   MENUL(1),   IW(1)   /'AC','  ',4/
      DATA MENU(2),   MENUL(2),   IW(2)   /'AD','  ',2/
      DATA MENU(136), MENUL(136), IW(136) /'AF','  ',3/
      DATA MENU(3),   MENUL(3),   IW(3)   /'AP','  ',9/
      DATA MENU(4),   MENUL(4),   IW(4)   /'AR','  ',2/
      DATA MENU(5),   MENUL(5),   IW(5)   /'AS','  ',2/
      DATA MENU(129), MENUL(129), IW(129) /'AT','  ',9/
      DATA MENU(6),   MENUL(6),   IW(6)   /'BC','  ',3/
      DATA MENU(7),   MENUL(7),   IW(7)   /'BL','  ',2/
      DATA MENU(8),   MENUL(8),   IW(8)   /'BP','  ',12/
      DATA MENU(9),   MENUL(9),   IW(9)   /'CA','  ',1/
      DATA MENU(10),  MENUL(10),  IW(10)  /'CC','  ',4/
      DATA MENU(11),  MENUL(11),  IW(11)  /'CE','  ',2/
      DATA MENU(12),  MENUL(12),  IW(12)  /'CF','  ',6/
      DATA MENU(13),  MENUL(13),  IW(13)  /'CG','  ',1/
      DATA MENU(14),  MENUL(14),  IW(14)  /'CI','  ',14/
      DATA MENU(15),  MENUL(15),  IW(15)  /'CK','  ',15/
      DATA MENU(125), MENUL(125), IW(125) /'CL','  ',1/
      DATA MENU(16),  MENUL(16),  IW(16)  /'CM','  ',2/
      DATA MENU(17),  MENUL(17),  IW(17)  /'CN','  ',4/
      DATA MENU(18),  MENUL(18),  IW(18)  /'CO','  ',7/
      DATA MENU(19),  MENUL(19),  IW(19)  /'CP','  ',2/
      DATA MENU(20),  MENUL(20),  IW(20)  /'CR','  ',13/
      DATA MENU(21),  MENUL(21),  IW(21)  /'CS','  ',7/
      DATA MENU(22),  MENUL(22),  IW(22)  /'CT','  ',3/
      DATA MENU(23),  MENUL(23),  IW(23)  /'CV','  ',1/
      DATA MENU(24),  MENUL(24),  IW(24)  /'DC','  ',12/
      DATA MENU(25),  MENUL(25),  IW(25)  /'DE','  ',1/
      DATA MENU(26),  MENUL(26),  IW(26)  /'DF','  ',2/
      DATA MENU(118), MENUL(118), IW(118) /'DO','  ',18/
      DATA MENU(27),  MENUL(27),  IW(27)  /'DR','  ',12/
      DATA MENU(28),  MENUL(28),  IW(28)  /'DU','  ',1/
      DATA MENU(128), MENUL(128), IW(128) /'EC','  ',19/
      DATA MENU(29),  MENUL(29),  IW(29)  /'ED','  ',3/
      DATA MENU(30),  MENUL(30),  IW(30)  /'EF','  ',6/
      DATA MENU(117), MENUL(117), IW(117) /'EN','  ',18/
      DATA MENU(31),  MENUL(31),  IW(31)  /'EP','  ',14/
      DATA MENU(119), MENUL(119), IW(119) /'EX','  ',18/
      DATA MENU(32),  MENUL(32),  IW(32)  /'FC','  ',3/
      DATA MENU(131), MENUL(131), IW(131) /'FD','  ',6/
      DATA MENU(33),  MENUL(33),  IW(33)  /'FF','  ',6/
      DATA MENU(34),  MENUL(34),  IW(34)  /'FI','  ',1/
      DATA MENU(35),  MENUL(35),  IW(35)  /'FL','  ',6/
      DATA MENU(36),  MENUL(36),  IW(36)  /'FP','  ',6/
      DATA MENU(37),  MENUL(37),  IW(37)  /'FQ','  ',6/
      DATA MENU(38),  MENUL(38),  IW(38)  /'FR','  ',15/
      DATA MENU(39),  MENUL(39),  IW(39)  /'FS','  ',1/
      DATA MENU(40),  MENUL(40),  IW(40)  /'FT','  ',6/
      DATA MENU(41),  MENUL(41),  IW(41)  /'GF','  ',6/
      DATA MENU(130), MENUL(130), IW(130) /'GO','  ',18/
      DATA MENU(42),  MENUL(42),  IW(42)  /'GP','  ',2/
      DATA MENU(43),  MENUL(43),  IW(43)  /'GR','  ',1/
      DATA MENU(44),  MENUL(44),  IW(44)  /'HI','  ',1/
      DATA MENU(126), MENUL(126), IW(126) /'HF','  ',9/
      DATA MENU(121), MENUL(121), IW(121) /'IF','  ',18/
      DATA MENU(45),  MENUL(45),  IW(45)  /'IN','  ',2/
      DATA MENU(46),  MENUL(46),  IW(46)  /'IP','  ',2/
      DATA MENU(134), MENUL(134), IW(134) /'IQ','  ',9/
      DATA MENU(122), MENUL(122), IW(122) /'LB','  ',18/
      DATA MENU(47),  MENUL(47),  IW(47)  /'LD','  ',17/
      DATA MENU(48),  MENUL(48),  IW(48)  /'LI','  ',1/
      DATA MENU(49),  MENUL(49),  IW(49)  /'MA','  ',2/
      DATA MENU(50),  MENUL(50),  IW(50)  /'MD','  ',15/
      DATA MENU(51),  MENUL(51),  IW(51)  /'ME','  ',15/
      DATA MENU(52),  MENUL(52),  IW(52)  /'MF','  ',12/
      DATA MENU(123), MENUL(123), IW(123) /'MK','  ',3/
      DATA MENU(53),  MENUL(53),  IW(53)  /'MM','  ',2/
      DATA MENU(54),  MENUL(54),  IW(54)  /'MN','  ',2/
      DATA MENU(55),  MENUL(55),  IW(55)  /'MO','  ',1/
      DATA MENU(56),  MENUL(56),  IW(56)  /'MR','  ',2/
      DATA MENU(132), MENUL(132), IW(132) /'MS','  ',9/
      DATA MENU(57),  MENUL(57),  IW(57)  /'MU','  ',2/
      DATA MENU(133), MENUL(133), IW(133) /'My','  ',20/
      DATA MENU(58),  MENUL(58),  IW(58)  /'NC','  ',15/
      DATA MENU(59),  MENUL(59),  IW(59)  /'NK','  ',2/
      DATA MENU(60),  MENUL(60),  IW(60)  /'OD','  ',3/
      DATA MENU(61),  MENUL(61),  IW(61)  /'OR','  ',3/
      DATA MENU(62),  MENUL(62),  IW(62)  /'PA','  ',2/
      DATA MENU(63),  MENUL(63),  IW(63)  /'PD','  ',2/
      DATA MENU(64),  MENUL(64),  IW(64)  /'PF','  ',7/
      DATA MENU(65),  MENUL(65),  IW(65)  /'PH','  ',13/
      DATA MENU(66),  MENUL(66),  IW(66)  /'PJ','  ',12/
      DATA MENU(67),  MENUL(67),  IW(67)  /'PK','  ',1/
      DATA MENU(68),  MENUL(68),  IW(68)  /'PL','  ',7/
      DATA MENU(69),  MENUL(69),  IW(69)  /'PO','  ',15/
      DATA MENU(70),  MENUL(70),  IW(70)  /'PP','  ',2/
      DATA MENU(71),  MENUL(71),  IW(71)  /'PR','  ',1/
      DATA MENU(72),  MENUL(72),  IW(72)  /'PS','  ',12/
      DATA MENU(73),  MENUL(73),  IW(73)  /'PT','  ',14/
      DATA MENU(74),  MENUL(74),  IW(74)  /'PV','  ',2/
      DATA MENU(75),  MENUL(75),  IW(75)  /'PW','  ',6/
      DATA MENU(76),  MENUL(76),  IW(76)  /'RA','  ',1/
      DATA MENU(77),  MENUL(77),  IW(77)  /'RC','  ',3/
      DATA MENU(78),  MENUL(78),  IW(78)  /'RD','  ',6/
      DATA MENU(120),MENUL(120),  IW(120) /'RE','  ',18/
      DATA MENU(79),  MENUL(79),  IW(79)  /'RF','  ',6/
      DATA MENU(80),  MENUL(80),  IW(80)  /'RM','  ',10/
      DATA MENU(81),  MENUL(81),  IW(81)  /'RN','  ',1/
      DATA MENU(82),  MENUL(82),  IW(82)  /'RO','  ',3/
      DATA MENU(135),MENUL(135), IW(135)  /'RP','  ',2/
      DATA MENU(83),  MENUL(83),  IW(83)  /'RR','  ',15/
      DATA MENU(84),  MENUL(84),  IW(84)  /'RS','  ',14/
      DATA MENU(85),  MENUL(85),  IW(85)  /'RT','  ',3/
      DATA MENU(86),  MENUL(86),  IW(86)  /'SA','  ',15/
      DATA MENU(87),  MENUL(87),  IW(87)  /'SC','  ',13/
      DATA MENU(88),  MENUL(88),  IW(88)  /'SD','  ',17/
      DATA MENU(127),MENUL(127),  IW(127) /'SE','  ',16/
      DATA MENU(89),  MENUL(89),  IW(89)  /'SF','  ',13/
      DATA MENU(90),  MENUL(90),  IW(90)  /'SH','  ',2/
      DATA MENU(91),  MENUL(91),  IW(91)  /'SI','  ',13/
      DATA MENU(92),  MENUL(92),  IW(92)  /'SK','  ',12/
      DATA MENU(93),  MENUL(93),  IW(93)  /'SL','  ',3/
      DATA MENU(94),  MENUL(94),  IW(94)  /'SP','  ',13/
      DATA MENU(95),  MENUL(95),  IW(95)  /'SQ','  ',2/
      DATA MENU(96),  MENUL(96),  IW(96)  /'SR','  ',15/
      DATA MENU(97),  MENUL(97),  IW(97)  /'ST','  ',1/
      DATA MENU(98),  MENUL(98),  IW(98)  /'SU','  ',2/
      DATA MENU(99),  MENUL(99),  IW(99)  /'SZ','  ',2/
      DATA MENU(100), MENUL(100), IW(100) /'TA','  ',13/
      DATA MENU(101), MENUL(101), IW(101) /'TF','  ',1/
      DATA MENU(102), MENUL(102), IW(102) /'TH','  ',2/
      DATA MENU(103), MENUL(103), IW(103) /'TM','  ',15/
      DATA MENU(105), MENUL(105), IW(105) /'TP','  ',11/
      DATA MENU(106), MENUL(106), IW(106) /'TR','  ',5/
      DATA MENU(107), MENUL(107), IW(107) /'TT','  ',1/
      DATA MENU(108), MENUL(108), IW(108) /'TV','  ',16/
      DATA MENU(109), MENUL(109), IW(109) /'TW','  ',5/
      DATA MENU(110), MENUL(110), IW(110) /'UD','  ',17/
      DATA MENU(111), MENUL(111), IW(111) /'VM','  ',15/
      DATA MENU(112), MENUL(112), IW(112) /'VO','  ',15/
      DATA MENU(113), MENUL(113), IW(113) /'WI','  ',2/
      DATA MENU(114), MENUL(114), IW(114) /'WT','  ',8/
      DATA MENU(115), MENUL(115), IW(115) /'WU','  ',2/
      DATA MENU(116), MENUL(116), IW(116) /'WV','  ',2/

      IRTFLG = 0
      ICOM   = 0
      DO I = 1,NMENU
         IF (FCHAR(1:2) .EQ. MENU(I)(1:2)) THEN
            ICOM   = I
            IWHICH = IW(I)
            FCHARS(1:3) = FCHAR(1:2) // CHAR(0)
         ENDIF
      ENDDO

      IF (ICOM .EQ. 0) THEN
C       OPERATION NOT FOUND IN THE SHORT OPERATION MENU

        LENMEN = INDEX(FCHAR,' ')
        IF (LENMEN .EQ. 0) LENMEN = INDEX(FCHAR,CHAR(0))
        IF (LENMEN .EQ. 0) LENMEN = LEN(FCHAR)
        
        DO IEND = 3,LENMEN
          DO I = 1,NMENU
           IF (FCHAR(1:IEND) .EQ. MENUL(I)(1:IEND)) THEN
              IF (ICOM .GT. 0) THEN
                 ICOM   = 0
                 IWHICH = 0
                 WRITE(NOUT,*) 
     &           '*** AMBIGUOUS OPERATION - SUPPLY MORE CHARACTERS.'
                 IRTFLG = 1
                 RETURN
              ENDIF
              ICOM   = I
              IWHICH = IW(I)

C             SAVE OPERATION IN FCHARS
              FCHARS = FCHAR(1:LENMEN-1) // CHAR(0)

C             SET FCHAR TO SHORT MENU OPERATION
              FCHAR(1:2) = MENU(I)(1:2)

C             MOVE SUBOPTIONS TO POSITION 4 IN FCHAR
              FCHAR(4:) = FCHAR(LENMEN+1:)
            ENDIF
          ENDDO
        ENDDO
      ENDIF

      IF (ICOM .EQ. 0) THEN
         IRTFLG = 1
         RETURN
      ENDIF

      
C     SOME OPERATIONS SHOULD BE SILENT IN BATCH MODE IF N_VERBOSE == 0
      IF ((ICOM .EQ. 88 .OR. ICOM .EQ. 110) .AND. N_VERBOSE .EQ. 0) THEN
         SILENT = .TRUE.
      ELSE
         SILENT = .FALSE.
      ENDIF
    
      IF (IWHICH .NE. 18) THEN
C        EVALUATE REGISTER FROM OPERATION LINE, EXCEPT FOR DRIVER STUFF
         CALL READPQ(FCHAR)
      ENDIF

      GOTO (1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20), IWHICH

1     CALL UTIL1(MAXDIM) 
      RETURN 

2     CALL UTIL2(MAXDIM) 
      RETURN 

3     CALL UTIL3(MAXDIM) 
      RETURN 

4     CALL CORR1(MAXDIM) 
      RETURN 

5     IF (FCHAR(4:8) .EQ. 'TDISK') THEN
         WRITE(NOUT,*) '*** RENAMED: CP FROM TR'
         CALL ERRT(100,'TSWITCH',NE)
      ELSEIF (FCHAR(4:7) .EQ. 'DISK') THEN
         WRITE(NOUT,*) '*** RENAMED: CP FROM PE'
         CALL ERRT(100,'TSWITCH',NE)
      ELSE
         WRITE(NOUT,*) '*** TAPE READ / WRITE NO LONGER SUPPORTED'
         CALL ERRT(100,'TSWITCH',NE)
      ENDIF
      RETURN 

6     CALL FOUR1(MAXDIM) 
      RETURN 

7     CALL PLOT1(MAXDIM) 
      RETURN 

8     IF (FCHAR(4:4) .EQ. 'T') THEN
         CALL DRIV2(MAXDIM)
      ELSE
         CALL TVWN1(MAXDIM) 
      ENDIF
      RETURN 

9     CALL UTIL4(MAXDIM) 
      RETURN 

10    CALL UTIL5(MAXDIM) 
      RETURN 

11    CALL PLOT2(MAXDIM) 
      RETURN 

12    CALL VTIL2(MAXDIM) 
      RETURN 

13    CALL VTIL3(MAXDIM) 
      RETURN 

14    CALL CONF1(MAXDIM) 
      RETURN 

15    CALL DRIV1(MAXDIM)
      RETURN

16    CALL DRIV2(MAXDIM)
      RETURN

17    CALL DRIV3(MAXDIM)
      RETURN

C     SPECIAL CASE FOR OPERATIONS IN SPIDER
18    IRTFLG = 2
      RETURN
      
19    CALL UTIL6(MAXDIM)
      RETURN

20    CALL MOD1(MAXDIM)
      RETURN

      END
                     
