
C++************************************************************************
C
C TTEST.FOR
C
C
C **************************************************************************
C *                                                                        *
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK            *
C *  COPYRIGHT (C)1981,1987, WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *  THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR       *
C *  LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR    *
C *  USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF     *
C *  THE CENTER FOR LABORATORIES AND RESEARCH   			   *
C **************************************************************************
C
C
C
C23456789012345678901234567890123456789012345678901234567890123456789012
C--************************************************************************

         SUBROUTINE  TTEST(LUN1, LUN2, LUN3, LUN4, LUN5, N1, N2,
     &                     A1, S1, A2, S2, P, NSAM, NROW, NSLICE)

         DIMENSION  A1(NSAM),S1(NSAM),A2(NSAM),S2(NSAM),P(NSAM)
         DOUBLE PRECISION  T, DF, TEMP, BETAI
CNO_SAVE

         DF = N1 + N2 - 2
         TEMP = FLOAT(N1 + N2) / FLOAT(N1) / FLOAT(N2) / DF
         DO  K = 1, NSLICE
           DO  J = 1, NROW
             CALL  REDLIN(LUN1,A1,NSAM,(K-1)*NROW+J)
             CALL  REDLIN(LUN2,S1,NSAM,(K-1)*NROW+J)
             CALL  REDLIN(LUN3,A2,NSAM,(K-1)*NROW+J)
             CALL  REDLIN(LUN4,S2,NSAM,(K-1)*NROW+J)
             DO  I = 1, NSAM
               T = DBLE(ABS(A1(I) - A2(I))) /
     &         DSQRT(TEMP*((N1 - 1)*DBLE(S1(I)) + (N2-1)*DBLE(S2(I))))

C              BETAI FUNCTION IS DESCRIBED IN THE BOOK 
C	       "NUMERICAL RECIPES" PAGE 167
C	       BY      WILLIAM H PRESS ET ALL.
C
C	       FROM TTEST ROUTINE PAGE 466

               P(I) = BETAI(0.5 * DF, 0.5D0, DF / (DF + T**2))
             END DO
             CALL  WRTLIN(LUN5,P,NSAM,(K-1)*NROW+J)
           END DO
         END DO

         RETURN
         END
