 
 
#ifdef SP_VMS 
 
C   THIS ROUTINE SPECIFIC TO UNIX SPIDER AND IS NOT 
C       USED AT VAX SITES
 
       SUBROUTINE unixtounix8
 
       COMMON /UNITS/LUNC,NIN,NOUT
 
       WRITE(NOUT,*) 'DUMMY CALL: unixtounix8'
       RETURN
       END
 
#else
 

C++************************************************************************
C
C UNIXTOUNIX8.F  -- JUL 93 al
C
C 	Modified for F90   --- yl 	10/22/97
C
C **************************************************************************
C *  COPYRIGHT (C)1993, WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH 			   *
C **************************************************************************
C
C    UNIXTOUNIX8(FILOLD,FILNEW,LUNO,LUNN,NMIN NMAX,HEADER,NORMAL,IRTFLG)
C
C    PURPOSE:       TO CONVERT A UNIX 32 BIT IMAGE FILE TO 8 BIT SPIDER
C
C    PARAMETERS:
C        FILOLD     EXISTING FILE NAME 
C        FILNEW     UNIX  8 BIT SPIDER FILE NAME 
C        LUNO       LOGICAL UNIT NUMBER TO BE ASSIGNED TO FILOLD.
C        LUNN       LOGICAL UNIT NUMBER TO BE ASSIGNED TO FILNEW
C        NMIN,NMAX  NORMAIZATION INTERVAL (USUALLY 0..255)
C        HEADER     LOGICAL VARIABLE FOR HEADER WANTED
C        NORMAL     LOGICAL VARIABLE FOR NORMALIZATION WANTED
C        ASKPAD     LOGICAL VARIABLE TO ASK FOR PADDING
C        IRTFLG     ERROR RETURN FLAG. (0 IS NORMAL)
C
C        0         2         3         4         5         6         7     
C23456789012345678901234567890123456789012345678901234567890123456789012
C--*********************************************************************

	SUBROUTINE UNIXTOUNIX8(FILOLD,FILNEW,LUNO,LUNN,NMIN,NMAX,
     &             NSAM,NROW,NSLICE,HEADER,NORMAL,ASKPAD,IRTFLG)

CNO_SAVE
        INCLUDE 'CMBLOCK.INC'

        REAL             BUFO(32000)
        INTEGER*1        BBUFO(128000)
        EQUIVALENCE      (BUFO,BBUFO)

        INTEGER*1        LBUF(1024)
	COMMON           LBUF,BUFO

        CHARACTER *(*)   FILOLD,FILNEW
        CHARACTER *81    FILN
        CHARACTER * 1    NULL,ANS
	LOGICAL          HEADER,NORMAL,ASKNAM,ASKPAD
        INTEGER   * 2    I2VAL

        NULL   = CHAR(0)

        IF ((FILOLD .EQ. NULL) .OR.
     &      (NSAM .EQ. 0 .AND. NROW .EQ. 0 .AND.NSLICE .EQ. 0)) THEN
           ASKNAM = (FILOLD .EQ. NULL)

C         OPEN 32 BIT UNIX SPIDER INPUT FILE
10        CALL OPFIL(ASKNAM,FILOLD,LUNO,'O',NSAM,NROW,NSLICE,IFORM,
     &             'ENTER UNIX SPIDER INPUT',.FALSE.,IRTFLG)
          IF (IRTFLG .NE. 0) RETURN
	ENDIF

        IF (IFORM .NE. 1 .AND. IFORM .NE. 3) THEN
          WRITE(NOUT,*)
     &         'WARNING: CONVERTER NOT TESTED FOR THIS FORMAT:',IFORM
        ENDIF

        IF (IMAMI .EQ. 0) THEN
C          MUST NORMALIZE INPUT IMAGE FIRST
           CALL NORM3(LUNO,NSAM,NROW,NSLICE,FMAX,FMIN,AV)
        ENDIF
        
C       GET SPIDER HEADER FROM INPUT FILE
        CALL REDHED(LUNO,BUFO,32000,NSAM,0,IRTFLG)
        IF (IRTFLG .NE. 0) THEN
           CALL ERRT(101,'CAN NOT READ HEADER',NE)
           RETURN
        ENDIF

C       SET NEW IFORM FOR 8 BIT UNIX      
        BUFO(5) = 8

        IPAD = 0
20      IF (ASKPAD) THEN
           NSAMRE  = MOD(NSAM,4)
           CALL RDPRMC(ANS,NC,.TRUE.,
     &        'PAD TO INCREMENT OF 4 IF NECESSARY? (N/Y)',NULL,IRTFLG)
           IF (IRTFLG .EQ. -1) GOTO 10

           IF ((NSAMRE .NE. 0) .AND. (ANS .EQ. 'Y' .OR. ANS .EQ. 'y'))
     &        THEN
C             WANT TO PAD
              IPAD = 4 - NSAMRE
           ENDIF
        ENDIF

        IF (NORMAL) THEN
           FN    = (NMAX - NMIN) / (FMAX - FMIN)
           FNCON = NMIN - FN * FMIN

        ELSEIF (FMAX .GT. 255) THEN
C          CAN NOT USE THIS FOR 8 BIT OUTPUT
           WRITE(NOUT,*) ' FMAX:',FMAX,
     &              'TOO LARGE FOR 8 BIT UN-NORMALIZED OUTPUT'
           IRTFLG = 1
           RETURN
        ELSE
           FN    = 1.0
           FNCON = 0.0
        ENDIF
  
C       SET NEW MIN & MAX
        BUFO(8)  = NMIN
        BUFO(7)  = NMAX
        BUFO(9)  = BUFO(9)  * FN + FNCON
        BUFO(10) = BUFO(10) * FN + FNCON
        BUFO(11) = 0.0

C       FIND NUMBER OF RECORDS IN THE LABEL
        LENBYT  = NSAM
        LABRECS = 1024 / LENBYT
        IF (MOD(1024,NSAM) .NE. 0) LABRECS = LABRECS + 1

C       FIND TOTAL NUMBER OF BYTES IN UNIX FILE LABEL
        LENBYT   = NSAM
        LABBYT   = LABRECS * LENBYT
        BUFO(22) = LABBYT
        BUFO(13) = LABRECS 
        BUFO(23) = LENBYT
 
        IF (FILNEW .EQ. NULL) THEN 
C         FILNEW NOT SENT FROM CALLER             
          CALL FILERD(FILNEW,NLET,NULL,'ENTER 8 BIT OUTPUT',IRTFLG)
          IF (IRTFLG .EQ. -1 .AND. ASKPAD) GOTO 20
          IF (IRTFLG .NE. 0) RETURN
        ENDIF
        CALL FILCAN(FILN,NLET,NULL,NULL,FILNEW,DATEXC,IRTFLG)
        IF (IRTFLG .NE. 0) RETURN
   
    
C       OPEN NEW 8 BIT SEQUENTIAL OUTPUT FILE

C       FOLLOWING WORKS ON SGI BUT NOT SUPPORTED ON DEC UNIX
C       OPEN(LUNN,FILE=FILN,ACCESS='SEQUENTIAL',IOSTAT=IER,
C    &      STATUS='UNKNOWN',FORM='SYSTEM')
C	CHANGE THE OPEN COMMAND FOR F90
C        OPEN(LUNN,FILE=FILN,ACCESS='SEQUENTIAL',IOSTAT=IER,
C     &      STATUS='UNKNOWN',FORM='FORMATTED',CARRIAGECONTROL='NONE')
        OPEN(LUNN,FILE=FILN,ACCESS='DIRECT',IOSTAT=IER,
     &      RECL=1,STATUS='UNKNOWN',FORM='UNFORMATTED')

        IF (IER .NE. 0) THEN
           WRITE(NOUT,900) FILNEW
900        FORMAT(' *** ERROR OPENING: ',A)
           IRTFLG = 1
           RETURN
        ENDIF

        IF (.NOT. HEADER) THEN
C          SKIP HEADER IN NEW FILE (FOR USE WITH PIXAR, ETC)
           LABBYT       = 0
        ELSE
C          PUT A SPIDER HEADER IN THE NEW FILE
           IF (LABBYT .GT. 1024) THEN
C             FILL HEADER PAD WITH ZEROS
              DO I = 1025,LABBYT
                 BBUFO(I) = 0
              ENDDO
           ENDIF
    
C          PLACE HEADER IN NEW 8 BIT UNIX FILE
	   DO I1 = 1, LABBYT
              CALL WRTSEQ8(LUNN,BUFO(I1),1,IRTFLG)
	   ENDDO
        ENDIF

        K      = 0
        DO  I = 1,NROW*NSLICE
C          READ EACH RECORD OF 32 BIT UNIX SPIDER INPUT FILE   
           CALL REDLIN(LUNO,BUFO,NSAM,I)

C          CONVERT FLOATING POINT NUMBERS TO -128...127 LOGICAL *1
           DO J=1,NSAM
	     I2VAL   = BUFO(J) * FN + FNCON
	     LBUF(1) = I2VAL
	     CALL WRTSEQ8(LUNN,LBUF(1),1,IRTFLG)
	     IF (IRTFLG .NE. 0) RETURN
           ENDDO

           IF (IPAD .GT. 0) THEN
C            ADD PADDING AFTER EACH LINE
             DO L = 1,IPAD
                LBUF(1) = 0
                CALL WRTSEQ8(LUNN,LBUF(1),1,IRTFLG)
                IF (IRTFLG .NE. 0) RETURN
             ENDDO
           ENDIF   
        ENDDO 

        WRITE(NOUT,*) ' '
        NCHAR1 = lnblnk(FILN)
        WRITE(NOUT,*) FILN(1:NCHAR1)

        IF (NSLICE .GT. 1 .AND. HEADER) THEN
          WRITE(NOUT,90) NSAM,NROW,NSLICE,LABBYT
90        FORMAT(' SPIDER 8 BIT IMAGE SIZE: (',I5,',',I5,',',I5,
     &           ')  LABEL BYTES:',I6,/)

        ELSEIF (HEADER) THEN
          WRITE(NOUT,91) NSAM,NROW,LABBYT
91        FORMAT(' SPIDER 8 BIT IMAGE SIZE: (',I5,',',I5,
     &           ')  LABEL BYTES:',I6,/)

        ELSEIF (NSLICE .GT. 1) THEN
          WRITE(NOUT,92) NSAM,NROW,NSLICE,LABBYT
92        FORMAT(' RAW IMAGE SIZE: (',I5,',',I5,',',I5,
     &           ')  LABEL BYTES:',I6,/)

        ELSE
          WRITE(NOUT,93) NSAM,NROW,LABBYT
93        FORMAT(' RAW IMAGE SIZE: (',I5,',',I5,')  LABEL BYTES:',I6,/)

        ENDIF

C       SET FLAG FOR NORMAL RETURN
        NSAMC  = NSAM
        NROWC  = NROW
        IRTFLG = 0

        RETURN
	END
 
#endif

c***************************
c           it1 = lval1
c           it2 = lval2
c           write(6,*) 'i2val,j,bufo(j):',i2val,j,bufo(j),it1,it2
c           iend = iend + 1
c           if (iend .gt. 20) stop
c******************************
 
