
C++************************************************************************
C
C UNSAV.FOR                DOCNAM LENGTHENED DEC 9 88 al
C                          REPLACES UNSAVD
C **************************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK            *
C *  COPYRIGHT (C)1981,1987, WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH 			   *
C **************************************************************************
C
C PURPOSE: RETRIEVE PARAMETERS FROM A SINGLE SPECIFED KEY FOUND IN
C          A DOC. FILE.  OPENS FILE IF NECESSARY.   
C                
C UNSAV(DOCNAM,NOPEN,NDOC,IKEY,PLIST,NLIST,LERR,NSS)
C
C PARAMETERS:
C	DOCNAM		NAME OF DOC FILE - CHAR. ARRAY           (SENT)
C	NOPEN		SWITCH =<0,  SUPRESSES ERROR MESSAGES    (SENT)
C	                SWITCH = 0,  FIRST TIME - OPEN DOC FILE
C			SWITCH = 1,  DOC FILE ALREADY OPENED
C	NDOC		LUN NUMBER FOR DOC FILE                  (SENT)
C	IKEY		KEY WANTED IN DOC FILE                   (SENT)
C	PLIST  		ARRAY OF FLOATING POINT
C                           NUMBERS RETRIEVED           (SENT/RETURNED)
C	NLIST  		NUMBER OF ELEMENTS IN ARRAY              (SENT)
C	LERR		(ON INPUT NEGATIVE LERR SUPRESSES
C                            TITLE OUTPUT)
C                       FLAG = 0, NO ERRORS IN DOC FILE
C			FLAG = 1, ERROR IN DOC FILE 
C			FLAG = 2, DOC FILE NOT FOUND   (SENT/RETURNED)
C	NSS		FLAG = 0, ALL KEYS ARE SEARCHED, DOC
C			IS REWOUND
C			FLAG = 1, SEQUENTIAL MODE; FIRST MATCHING
C			KEY IS USED, DOC IS NOT REWOUND          (SENT)
C
C--*******************************************************************
		
        SUBROUTINE UNSAV(DOCNAM,NOPEN,NDOC,IKEY,PLIST,NLIST,
     &                     LERR,NSS)


	INCLUDE 'CMBLOCK.INC' 
	
        COMMON /DOCLAB/ DOCTIC

        PARAMETER      (MAXSAV= 20)
	DIMENSION      PLIST(*),SAV(MAXSAV),DUMSAV(MAXSAV)
	CHARACTER *(*) DOCNAM
        CHARACTER *80  DOCTIC,RECLIN
        CHARACTER      NULL
	LOGICAL        NEWFILE,COMKEY,GOTKEY,MORE,OLDLEN,FLAGER

        NULL = CHAR(0)

C       NEGATIVE VALUE OF LERR SUPPRESSES TERMINAL OUTPUT OF TITLE
	NPR  = LERR

C       SET ERROR RETURN FLAG
	LERR   = 1
        FLAGER = .TRUE.
        IF (NOPEN .LT. 0) THEN
C          NEGATIVE NOPEN SUPPRESSES ERROR MESSAGES ON RETRIEVAL
           FLAGER = .FALSE.
           NOPEN  = ABS(NOPEN)
        ENDIF

        IF (NLIST .LE. 0) THEN
	   WRITE(NOUT,*) '*** REGISTER LIST EMPTY IN UNSAV'
	   RETURN

        ELSEIF (NLIST .GT. MAXSAV) THEN
           WRITE(NOUT,*) '*** TOO MANY REGISTERS WANTED IN UNSAV'
           RETURN

        ELSEIF (NOPEN. EQ. 0) THEN
C          MUST OPEN FILE FIRST
           CALL OPENDOC(DOCNAM,.TRUE.,NLET,NDOC,.FALSE.,
     &                  .TRUE.,.TRUE.,.TRUE.,NEWFILE,LERR)
           IF (LERR .NE. 0) RETURN
        ENDIF

        MORE   = .FALSE.
        GOTKEY = .FALSE.
        COMKEY = .FALSE.

        IF (IKEY .LT. 0) THEN
C          DESIRE A COMMENTED KEY
           COMKEY = .TRUE.
           IKEY = ABS(IKEY)
        ENDIF


C -----------------------------------------------------

C       READ NEXT LINE FROM DOC FILE
510	READ (NDOC,518,END=595) RECLIN
518	FORMAT(A80)

        IF (RECLIN(5:5) .EQ. ' ') THEN
           OLDLEN = .TRUE.
        ELSE
           OLDLEN = .FALSE.
        ENDIF
           
511     IF (COMKEY) THEN
C         ARE SEARCHING FOR COMMENT KEYS
          IF (RECLIN(2:2) .EQ. ';') THEN
C           COMMENT LINE FOUND AND ARE SEARCHING FOR COMMENT KEYS
            IF (OLDLEN) THEN
               READ(RECLIN(3:80),519,ERR=510) NDUM,NDUMB2,
     &          (DUMSAV(K),K=1,NDUMB2)
519            FORMAT(2I2,6F12.6)
            ELSE
               READ(RECLIN(3:80),619,ERR=510) NDUM,NDUMB2,
     &          (DUMSAV(K),K=1,NDUMB2)
619            FORMAT(I3,I2,6F12.6)
            ENDIF
            IF (NDUM .EQ. IKEY) THEN
C              DESIRED COMMENT KEY FOUND
               GOTKEY = .TRUE.
               IGOT   = NDUMB2
            ENDIF
          ENDIF

        ELSEIF (RECLIN(2:2) .EQ. ';') THEN
C         COMMENT LINE FOUND AND WE ARE NOT SEARCHING FOR COMMENT KEYS
          DOCTIC = RECLIN
          IF (NFIRST .EQ. 0) THEN
C           FIRST COMMENT ENCOUNTERED, SO WRITE OUT COMMENT
            IF (NPR .GE. 0) WRITE(NOUT,700) RECLIN
700         FORMAT(A80)
            NFIRST=1
          ENDIF
        
        ELSEIF (MORE) THEN
C         WANT A CONTINUATION LINE FOR THE PREVIOUS KEY
          MORE = .FALSE.         
          IF (OLDLEN) THEN
              READ(RECLIN,520,ERR=510) IDUM,NDUMB2,(DUMSAV(J),
     &        J=IGO,IGO+NDUMB2-1)
          ELSE
              READ(RECLIN,620,ERR=510) IDUM,NDUMB2,(DUMSAV(J),
     &        J=IGO,IGO+NDUMB2-1)
          ENDIF

          IF (IDUM .EQ. -99) THEN
C            THIS IS A CONTINUATION LINE FOR THE DESIRED KEY
             IGOT = IGO + NDUMB2 - 1
             IF (IGOT .LT. NLIST) THEN
C               STILL WANT MORE REGISTERS
                IGO = IGOT + 1
                MORE = .TRUE.
             ENDIF
          ENDIF
        ELSE

C         NOT A COMMENT AND WE ARE NOT SEARCHING FOR COMMENT KEYS
          IF (OLDLEN) THEN
             READ(RECLIN,520,ERR=510)NDUM,NDUMB2,(DUMSAV(J),J=1,NDUMB2)
520          FORMAT(I4,I2,6F12.6)
          ELSE
C	     INCREASED KEY NUMBER TO 99999.      ML
             READ(RECLIN,620,ERR=510)NDUM,NDUMB2,(DUMSAV(J),J=1,NDUMB2)
620	     FORMAT(I5,I2,6F12.6)
          ENDIF

	  IF (NDUM .EQ. IKEY) THEN
C            FOUND DESIRED KEY
             IGOT   =  NDUMB2
             GOTKEY = .TRUE.
             IF (IGOT .LT. NLIST) THEN
C               WANT MORE REGISTERS FOR THIS KEY
                MORE = .TRUE.
                IGO  = IGOT + 1
             ENDIF
          ENDIF

        ENDIF

        IF (NDUM .EQ. IKEY .AND. IGOT .GE. NLIST) THEN
C          SAVE THE REGISTER LIST FOR THIS KEY
           DO  I = 1,NLIST
              SAV(I) = DUMSAV(I)
           ENDDO
        ENDIF

        IF (MORE .OR. .NOT. GOTKEY .OR. NSS .EQ. 0) GOTO 510

C ---------------------------------------------------------


C       END OF FILE OR FIRST KEY FOUND AND  NSS = 1

595     IF (GOTKEY) THEN
C          DESIRED KEY WAS FOUND
           IF (IGOT .GE. NLIST .OR. .NOT. FLAGER) THEN
C             GOT ALL DESIRED REGISTERS FOR THIS KEY
              LERR = 0
              DO  I = 1,NLIST
                 PLIST(I) = SAV(I)
              ENDDO

           ELSE
C             DID NOT FIND AS MANY REGISTERS AS WANTED FOR THIS KEY
              WRITE(NOUT,8887) NLIST,IKEY,IGOT
8887	      FORMAT
     &        (' *** WANTED:',I5,' REG. FOR KEY:',I5,' ONLY GOT:',I5)
           ENDIF

        ELSE
C          DID NOT EVEN FIND THIS KEY
           IF (COMKEY) THEN
              WRITE(NOUT,8888) IKEY
8888	      FORMAT(' *** COMMENT KEY:',I5,' NOT FOUND')

           ELSEIF (FLAGER) THEN
              WRITE(NOUT,8889) IKEY
8889          FORMAT(' *** KEY:',I5,' NOT FOUND')
           ENDIF
        ENDIF

	IF (NSS .EQ. 0) REWIND NDOC
	RETURN
	END
