C
C++************************************************************************
C
C    UTIL1.FOR            CHANGED: TITLE PROCESSING MODIFIED NOV 87 al
C                                  LONG FILE NAMES ADDED     DEC 88 al
C	                           MAHIEDDINE LADJADJ       4/21/93
C	                           JING SU                  8/25/93
C	                           LI COMMAND REWRITTEN     8/30/96 al
C	                           TT COMMAND REWRITTEN     6/28/97 al
C
C **********************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.    AUTHOR: J.FRANK      *
C *  COPYRIGHT (C)1985, 1996 HEALTH RESEARCH INCORPORATED, ALBANY, NY. *
C * THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO HEALTH            *
C * RESEARCH INC. AND ARE NOT TO BE DISCLOSED TO OTHERS OR USED        *
C * FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF       *
C * HEALTH RESEARCH INC.                                               *
C **********************************************************************
C
C   UTIL1(MAXDIM)
C
C   PURPOSE:   A MAIN DRIVER FOR ROUTINES REQUIRING ONLY ONE FILE
C
C   PARAMETERS: MAXDIM     MAX LENGTH OF COMMON BUFFER
C
C23456789 123456789 123456789 123456789 123456789 123456789 123456789 12
C--*********************************************************************

        SUBROUTINE UTIL1(MAXDIM)

	INCLUDE 'CMBLOCK.INC' 
CNO_SAVE

	PARAMETER      (NFUNC=19)
        CHARACTER *2   FUNC(NFUNC)
        CHARACTER *81  FILNAM
        LOGICAL        DOCPRNT,TERMPRNT
        CHARACTER *1   NULL

        DATA FUNC/'DE', 'DU', 'FI', 'HI', 'LI', 'MO', 'PK', 
     &            'PR', 'RA', 'RN', 'TT', 'ST', 'TF', 'FS', 
     &            'CA', 'GR', 'CG', 'CV', 'CL'/

        NULL   = CHAR(0)
	NF     = 0
	LUN1   = 8
	LUN2   = 12
	LUN3   = 7
	LUN4   = 9
	LUN5   = 10
        LUNE   = 34
	NDOC   = LUN2
        MAXIM  = 0
        MAXIM2 = 0

        DO  IFUNC = 1,NFUNC
          IF (FCHAR(1:2) .EQ. FUNC(IFUNC)(1:2)) THEN
            GOTO ( 1, 2, 3, 4, 5, 6, 7, 8, 9,10,
     &            11,12,13,14,15,16,17,18,19), (IFUNC)
          END IF
        END DO

C       OPERATION NOT IN UTIL1, RETURN TO CALLER
        RETURN 


C	OPERATION ------------------------------------------------- 'DE'
1       CALL DELETF(FILNAM,LUN1)
        RETURN
C       DO NOT USE GOTO 9000 HERE AS IT CAUSES DOUBLE CLOSING ERROR

C	OPERATION ------------------------------------------------  'DU'

C       OPEN INPUT FILE, NO FOURIER INPUT ALLOWED 
2	CALL OPFIL(.TRUE.,FILNAM,LUN1,'O',NSAM1,NROW1,NSLICE,
     &             MAXIM,'INPUT',.FALSE.,IRTFLG)
        IF (IRTFLG .NE. 0) GOTO 9000

	IDUST = 1
   	CALL HIST(LUN1,NSAM1,NROW1,NSLICE,IDUST,LUN2,.FALSE.)
	GOTO 9000

C 	OPERATION   ----------- FILE INFO ------------------------- 'FI'
                                       
3       IF (FCHAR(4:4) .EQ. 'A') THEN

C	   FILE INFO FOR MULTIPLE FILES
           CALL FILERD(FILNAM,NLETI,NULL,'FILE INFO. ON',IRTFLG)
           IF (IRTFLG .EQ. -1) GOTO 9000
           CALL FILGEN(FILNAM,NLETI,LUN1)

        ELSEIF (FCHAR(4:4) .EQ. 'N') THEN

C	   FILE INFO FOR SINGLE FILE, NO ERROR STOP IF NOT FOUND
           CALL OPFIL(.TRUE.,FILNAM,LUN1,'Z',NSAM,NROW,NSLICE,
     &             MAXIM,'FILE INFO. ON',.TRUE.,IRTFLG)

           IF (IRTFLG .EQ. 0) THEN
C             FILE FOUND
              CALL FILDAT(LUN1,NSAM)
           ELSE
C             FILE NOT FOUND, SET REGISTER FOR NSAM, NROW, NSLICE TO ZERO
              PARAM(2) = 0
              PARAM(3) = 0
              PARAM(4) = 0
              PARAM(5) = 0
              PARAM(8) = 0
           ENDIF
        ELSE

C	   FILE INFO FOR SINGLE FILE, ERROR IF NOT FOUND
           CALL OPFIL(.TRUE.,FILNAM,LUN1,'O',NSAM,NROW,NSLICE,
     &                MAXIM,'FILE INFO. ON',.TRUE.,IRTFLG)
           IF (IRTFLG .EQ. 0) CALL FILDAT(LUN1,NSAM)
        ENDIF
        GOTO 9000

C       OPERATION -------------- HISTOGRAM ------------------------ 'HI'

C       OPEN INPUT FILE, FOURIER NOT ALLOWED 
4       CALL OPFIL(.TRUE.,FILNAM,LUN1,'O',NSAM1,NROW1,NSLICE,
     &             MAXIM,'INPUT',.FALSE.,IRTFLG)
        IF (IRTFLG .NE. 0) GOTO 9000

        IF (FCHAR(4:4) .NE. 'M') THEN
C          NORMAL HISTOGRAM
	   IDUST = 0
   	   CALL HIST(LUN1,NSAM1,NROW1,NSLICE,IDUST,LUN2,.TRUE.)
        ELSE
C          HISTOGRAM UNDER MASK
           IFORM1 = IFORM
           CALL OPFIL(.TRUE.,FILNAM,LUN2,'O',NSAM2,NROW2,NSLICE2,
     &             MAXIM2,'MASK',.FALSE.,IRTFLG)
           IFORM2 = IFORM
           IF (IRTFLG .EQ. -1) THEN
              CLOSE(LUN1)
              GOTO 4
           ELSEIF (IRTFLG .NE. 0) THEN
              GOTO 9000
           ELSEIF (NSAM1 .NE. NSAM2 .OR. NROW1 .NE. NROW2. OR.
     &             NSLICE .NE. NSLICE2 .OR. IFORM1 .NE. IFORM2) THEN
C             IMAGES NUST HAVE SAME DIMENSIONS
              CALL ERRT(1,'UTIL1',NE)
              GOTO 9000           
           ENDIF

   	   CALL HISTM(LUN1,LUN2,LUN3,NSAM1,NROW1,NSLICE)
        ENDIF
	GOTO 9000
    
C	OPERATION   ----------------------------------------------  'LI'
C       CHECK FOR 'LI R' WHICH DOES NOT USE INPUT FILE JUST REGISTERS
5       IF (FCHAR(4:4) .EQ. 'R') THEN
C          FOR 'LI R', 'LI RT',  'LI RD'
           CALL LISTREGS()
           GOTO 9000
        ENDIF

C       NEED INPUT FILE, USE IRTFLG = 88 TO ALLOW MALFORMED STACKS
        IRTFLG = 88
        CALL OPFIL(.TRUE.,FILNAM,LUN1,'O',NSAM,NROW,NSLICE,
     &              MAXIM,'INPUT',.TRUE.,IRTFLG)
        IF (IRTFLG .NE. 0) RETURN

        IF (FCHAR (4:5) .EQ. '2D') THEN
C          UNDOCUMENTED COMMAND 'LI 2D' CALLED LISTIM
           CALL ERRT(101,'THIS OPERATION NO LONGER SUPPORTED',NE)

        ELSE
           DOCPRNT = .FALSE.
           IF (FCHAR(4:4) .EQ. 'D') DOCPRNT = .TRUE. 
           TERMPRNT = .FALSE.
           IF (FCHAR(4:4) .EQ. 'T') TERMPRNT = .TRUE. 

           IF (NSEL(1) .NE. 0) THEN
C             SINGLE NUMBER (REGISTER) OPTION:
              CALL LISTITR(FILNAM,LUN1,NSAM,NROW,NSLICE)
           ELSE
              CALL LISTIT(FILNAM,LUN1,NSAM,NROW,NSLICE,DOCPRNT,TERMPRNT)
           ENDIF
        ENDIF
        GOTO 9000

C 	OPERATION ---------------- MODEL -------------------------- 'MO'
6	NSAM2  = 0
	NROW2  = 0
	NSLICE = 1
	IFORM  = 1
	IF (FCHAR(4:4) .EQ. '3') THEN
	   NSLICE = 0
	   IFORM  = 3
	ENDIF
	CALL OPFIL(.TRUE.,FILNAM,LUN1,'U',NSAM2,NROW2,NSLICE,
     &             MAXIM,'OUTPUT',.TRUE.,IRTFLG)
	IF (IRTFLG .NE. 0 .AND. FILNAM(1:1) .NE. '*') GOTO 9000
	IF (FCHAR(4:4) .EQ. '3') THEN
          IF (FCHAR(5:5) .EQ. 'H') THEN 
             LUNM = LUN1
             IF (FILNAM(1:1). EQ. '*') LUNM = 0
             CALL MODELH(LUNM,NSAM2,NROW2,NSLICE)
             GOTO 9000                  
          ENDIF
          CALL MODEL3(LUN1,LUN2,FILNAM,NSAM2,NROW2,NSLICE)
          CLOSE(LUN2)
          GOTO 9000
	ENDIF
        CALL MODEL(LUN1,NSAM2,NROW2)
        GOTO 9000
           
C 	OPERATION ---------------- PEAK SEARCH -------------------- 'PK'

C	PEAK SEARCH
7	CALL OPFIL(.TRUE.,FILNAM,LUN1,'O',NSAM1,NROW1,NSLICE1,
     &             MAXIM,'INPUT',.TRUE.,IRTFLG)
	IF (IRTFLG .NE. 0) GOTO 9000
	IF (FCHAR(4:4).NE.'3') THEN
          IF (FCHAR(4:4).EQ. 'C' .OR. FCHAR(5:5).EQ.'C') THEN
            CALL SPEAKC(FILNAM,LUN1,NSAM1,NROW1,MAXDIM,FCHAR(4:4),NDOC)
          ELSE
            CALL SPEAK(FILNAM,LUN1,NSAM1,NROW1,MAXDIM,FCHAR(4:4),NDOC)
          ENDIF
        ELSE
            CALL SPEAK3(FILNAM,LUN1,NSAM1,NROW1,NSLICE1,MAXDIM,
     &                FCHAR(5:5),NDOC)
        ENDIF
        GOTO 9000
     
C       OPERATION   ------------ GREY SCALE ----------------------- 'PR'
8       CALL OPFIL(.TRUE.,FILNAM,LUN1,'O',NSAM1,NROW1,NSLICE,
     &             MAXIM,'INPUT',.FALSE.,IRTFLG)
        IF (IRTFLG .NE. 0) GOTO 9000

 	CALL OPRINT(FILNAM,LUN1,NSAM1,NROW1,NSLICE,FCHAR(4:))
   	GOTO 9000


C	OPERATION ------------- RAMP ------------------------------ 'RA'

9       CALL OPFIL(.TRUE.,FILNAM,LUN1,'O',NSAM1,NROW1,NSLICE,
     &             MAXIM,'INPUT',.FALSE.,IRTFLG)
        IF (IRTFLG .NE. 0) GOTO 9000

        IF (FCHAR(4:5) .EQ. 'GN') THEN
          CALL MRGNORM(LUN1,NSAM1,NROW1)
        ELSE
          CALL RAMP(LUN1,NSAM1,NROW1)
        END IF
	GOTO 9000
            
C       OPERATION  ----------------- RENAME ---------------------- 'RN'

10      WRITE(NOUT,*) '*** RENAME OPERATION NO LONGER SUPPORTED'
	GOTO 9000


C       OPERATION   ------------CHANGE TITLE---------------------- 'TT'

11      CONTINUE
C       OPEN THE FILE 
	CALL OPFIL(.TRUE.,FILNAM,LUN1,'O',NSAM1,NROW1,NSLICE1,
     &             MAXIM,'INPUT',.TRUE.,IRTFLG)
	IF (IRTFLG .NE. 0) GOTO 9000

C       GET NEW TITLE HERE 
        CALL RDPRMC(CTIT,NLET,.FALSE.,'NEW TITLE',NULL,IRTFLG)
        IF (IRTFLG .EQ. -1) GOTO 9000

C	TITLE ALTERATION CAN PROCEED NOW
        NLET          = MIN(NLET,159)
        CTIT(NLET+1:) = CHAR(0)
        CALL TITLE(LUN1,NSAM1)
	GOTO 9000

C 	OPERATION  ------ SET BUFFER LOCATIONS -------------------- 'ST'

12      CALL FILERD(FILNAM,NLETI,NULL,'INPUT',IRTFLG)
        IF (IRTFLG .EQ. -1) GOTO 9000

C	SET LABEL VALUES TO SOLICTED INPUT
        CALL SETVAL(FILNAM,LUN1)
        GOTO 9000

C 	OPERATION  ------------TRANSFER FUNCTION ------------------ 'TF'

13      CALL CHKINPQ('D,C,C3,DDF,DNS,DEV,CTF,CT,CT3$',FCHAR(4:),ICALLTF)
        GOTO (1801,1802,1803,1804,1805,1806,1807,1808,1809,1810) ICALLTF

1801    CALL TRAF(LUN1)
	GOTO 9000

1802    CALL TRAFD(LUN1)
        GOTO 9000

1803    CALL TRAFC(LUN1)
        GOTO 9000

1804    CALL TRAFC3(LUN1)
        GOTO 9000

1805    CALL DEFOCUS(IRTFLG)
        GOTO 9000

1806    CALL NOISE(IRTFLG)
        GOTO 9000

1807    CALL ENVELOPE(IRTFLG)
        GOTO 9000

1808    CALL RCTFS(MAXDIM)
        GOTO 9000

1809    CALL TRAFCT(LUN1)
        GOTO 9000

1810    CALL TRAFCT3(LUN1)
        GOTO 9000

C 	OPERATION  -------------- FILE STATISTICS ----------------- 'FS'

14      NSTACK = -1
        CALL OPFIL(.TRUE.,FILNAM,LUN1,'O',NSAM,NROW,NSLICE,
     &             NSTACK,'INPUT',.TRUE.,IRTFLG)
        IF (IRTFLG .NE. 0) GOTO 9000

C       FIND STATISTICS
        CALL QSTAT(FILNAM,LUN1,LUN2,NSAM,NROW,NSLICE,NSTACK)
        CLOSE(LUN2)
	GOTO 9000

C	 OPERATION  ---------CLUSTER ANALYSIS   ------------------- 'CA'

15      IF(FCHAR(4:4) .EQ. 'S') THEN
         CALL CHKINPQ(
     &   'SR,SRD,SRI,SRP,SR/C,SRD/C,SRI/C,S,SI,SI+,SIB,SIB+,SM,SME$'
     &   ,FCHAR(4:),ICALL)
           GOTO (2003, 2010, 2010, 2010, 2010, 2010, 2010, 2010,   
     &           2009, 2009, 2009, 2009, 2009, 2011, 2011),   
     &           ICALL
        ELSE
           CALL CHKINPQ(
     &        'E,P,3,MAP,M,MT,ES,C,CT,VAR,CLA,CLAF,HC,HD,HE,KM,VIS$'
     &        ,FCHAR(4:),ICALL)
           GOTO (2003,  2003, 2004, 2005, 2006, 2007,  2007,  2003,
     &	         2007,  2007, 2012, 2013, 2015, 20333, 20334, 20335, 
     &           20344, 20555 ), ICALL
        ENDIF


C       CA S, CA E, CA ES, 
2003	CALL JPMSK(LUN1,LUN2,LUN3,LUN4,MAXDIM,FCHAR(4:))
        CLOSE(LUN2)
        CLOSE(LUN3)
        CLOSE(LUN4)
	GOTO 9000

C       CA P, 
C       CALL CAPART(LUN1,LUN2,LUN3)
2004	WRITE(NOUT,*) '*** CAPART SUBROUTINE DOES NOT COMPILE!!!'
        CLOSE(LUN2)
        CLOSE(LUN3)
	GOTO 9000

C       CA 3, 
2005	CALL CA3D(LUN1,LUN2)
        CLOSE(LUN2)
	GOTO 9000

C       CA MAP, 
2006    CALL MRNLSTRT(MAXDIM,10)
        GOTO 9000

C       CA M, CA MT, CA C, CA CT, 
2007	CALL CAMAP(LUN1,FCHAR(4:))
	GOTO 9000

C       CA S, CA SI, CA SI+, CA SIB, CA SIB+ 
2009	CALL JPMSK1(MAXDIM)
	GOTO 9000

C       CA SR, CA SRD, CA SRI, CA SRP, CA SR/C, CA SRD/C, CA SRI/C
2010	CALL JPMSK2(LUN1,LUN2,LUN3,MAXDIM)
        CLOSE(LUN2)
        CLOSE(LUN3)
	GOTO 9000

C       CA SM, CA SME
C       FACTOR MAP PREPARATION
2011	CALL SGRAF(LUN1,LUN2,.FALSE.,LUNE)
        CLOSE(LUN2)
	GOTO 9000

C       CA VAR, 
2012    CALL MRVARI(MAXDIM)
        GOTO 9000


C       CA CLA
C2013    CALL SCLASSI(MAXDIM)
2013    WRITE(NOUT,*) 'NOTICE: use CL CLA instead'
        GOTO 9000

C       CA CLAF
C2015    CALL SCLASF
2015    WRITE(NOUT,*) 'NOTICE: use CL CLAF instead'
        GOTO 9000

C       CA HC
C       H. CLUSTERING
c20333	CALL  HCLS(MAXDIM)
20333   WRITE(NOUT,*) 'NOTICE: use CL HC instead'
	GOTO 9001


C       CA HD
C       H. CLUSTERING
C20334	CALL  HDLS(MAXDIM)
20334   WRITE(NOUT,*) 'NOTICE: use CL HD instead'
	GOTO 9001

C       CA HE
C       H. CLUSTERING
C20335	CALL  HELS(MAXDIM)
20335   WRITE(NOUT,*) 'NOTICE: use CL HE instead'
	GOTO 9001

C       CA KM
C       K-means
c20344   CALL  KMNS(MAXDIM)
20344   WRITE(NOUT,*) 'NOTICE: use CL KM instead'
        GOTO  9001

C       CA VIS
C       VISUAL MAP:
20555   CALL VISMAP(LUN1,LUN2,LUN3,LUN4)
        GOTO 9000

C 	OPERATION  ------------------------------------------------ 'GR'

16      CALL OPFIL(.TRUE.,FILNAM,LUN1,'O',NSAM1,NROW1,NSLICE,
     &             MAXIM,'INPUT',.FALSE.,IRTFLG)
         IF (IRTFLG .NE. 0) GOTO 9000 

	CALL GRAPHP(LUN1,NSAM1,NROW1)
	GOTO 9000

C       OPERATION  ------- CENTER OF GRAVITY ---------------------- 'CG'

C       3-D CENTER OF GRAVITY AND RADIUS OF GYRATION
17	IF (FCHAR(4:4).EQ.'3') THEN
          CALL CENGR3(LUN1)
	  GOTO 9000

	ELSEIF (FCHAR(4:5).EQ.'PH') THEN
          CALL CENT(MAXDIM)
	  GOTO 9001
        END IF

        CALL OPFIL(.TRUE.,FILNAM,LUN1,'O',NSAM1,NROW1,NSLICE,
     &             MAXIM,'INPUT',.FALSE.,IRTFLG)
         IF (IRTFLG .NE. 0) GOTO 9000

        CALL CENGRA(LUN1,NSAM1,NROW1)
	GOTO 9000

C       OPERATION ------------------------------------------------- 'CV'

C       POCS PROGRAMS (06/05/90)
C       MODULAR POCS PROGRAMS: (12/5/91) M.R.

18      CALL CHKINPQ('REPL,REPL2$',FCHAR(4:),ICALL9)
        GOTO (9000,181,182) ICALL9
 
181     CALL MRREPLACE(LUN1,LUN2)
        GOTO 9000

182     CONTINUE
	CALL  ERRT(41,'CV REPL2',NE)
C tdfrepl uses old Fourier format and was disabled
C	CALL TDFREPL(LUN1,LUN2,LUN3)
        GOTO 9000

C       OPERATION ------------------------------------------------- 'CL'

19      CALL CHKINPQ('KM,HC,HD,HE,CLA,CLAF$',FCHAR(4:),ICALL9)
        GOTO (9000,191,192,193,194,195,196) ICALL9

C       KMEANS (CL KM)
191     CALL SUBKMNS(MAXDIM)
        GOTO 9000

C       H. CLUSTERING (CL HC)
192     CALL  HCLS(MAXDIM)
	GOTO 9001

C       H. CLUSTERING (CL HD)
193	CALL  HDLS(MAXDIM)
	GOTO 9001

C       H. CLUSTERING (CL HE)
194	CALL  HELS(MAXDIM)
	GOTO 9001

C       (CL CLA)
195     CALL SCLASSI(MAXDIM)
        GOTO 9000

C       (CL CLAF)
196     CALL SCLASF
        GOTO 9000


C       -------------------------------------------------------- END

9000	CLOSE(LUN1)
9001    FCHAR(1:1) = ';'

	RETURN
	END
