
C++*********************************************************************
C
C UTIL2.FOR                  CHANGED:  MAHIEDDINE LADJADJ   4/23/93
C                                      JING SU              8/24/93
C                                      ARDEAN LEITH         8/30/96
C
C **********************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK        *
C *  COPYRIGHT (C)1981,1987, WADSWORTH CENTER FOR LABORATORIES AND     *
C *    RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201 *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS *
C *    OR USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN        *
C *    APPROVAL OF THE CENTER FOR LABORATORIES AND RESEARCH.           *
C **********************************************************************
C
C  UTIL2(MAXDIM)
C
C  PARAMETERS:      MAXDIM         MAX LENGTH FOR UNLABELED COMMON
C
C        1         2         3         4         5         6         7
C23456789012345678901234567890123456789012345678901234567890123456789012
C--*********************************************************************

        SUBROUTINE UTIL2(MAXDIM)

	INCLUDE 'CMBLOCK.INC'
CNO_SAVE

	COMMON          BUF(1)
        DIMENSION       Q(1)
        POINTER         (IPQ,Q) 
        LOGICAL		RUNTIME
        CHARACTER *81   FILNAM1,FILNAM2,FILNAM
        COMMON /COMMUN/ FILNAM1,FILNAM2,FILNAM
	PARAMETER       (NFUNC=30)
        CHARACTER *2    FUNC(NFUNC),ANS
        LOGICAL         FIRST
        CHARACTER       NULL
C
	DATA FUNC/'AD', 'BL', 'CP', 'IN', 'IP',
     1	          'MU', 'PA', 'PD', 'SH', 'SQ',
     2            'SU', 'WI', 'CE', 'AR', 'MR',
     3            'DF', 'MA', 'WV', 'PP', 'SZ', 
     4            'WU', 'MM', 'CM', 'PV', 'NK', 
     5            'AS', 'MN', 'TH', 'GP', 'RP'/  
	DATA  LUN1,LUN2,LUN3/21,22,23/

	NULL   = CHAR(0)
        MAXIM  = 0
        MAXIM2 = 0

        DO  IFUNC = 1, NFUNC
          IF (FCHAR(1:2) .EQ. FUNC(IFUNC)) THEN
            GOTO ( 1,  2,  3,  4,  5,  6,  7,  8,  9, 10,
     &            11, 12, 13, 14, 15, 16, 17, 18, 19, 20,
     &            21, 22, 23, 24, 25, 26, 27, 28, 29, 30 ) IFUNC
          ENDIF
        ENDDO

C       FUNCTION NOT FOUND IN UTIL2
        RETURN 

C       OPERATION  ADD -------------------------------------------- 'AD' 
C	AD        ADD IMAGES           

1	FIRST = .TRUE.
110     CALL UTIL2SUP(FILNAM1,IFORM1,
     &               'FIRST INPUT','NEXT INPUT','SUMMED OUTPUT',
     &               NSAM,NROW,NSLICE,LUNA,LUNB,LUNCT,FIRST,IRTFLG)
	IF (IRTFLG .NE. 0) GOTO 9000

        SIGN = +1.0            
        CALL ADD(LUNB,LUNA,LUNCT,NSAM,NROW,NSLICE,SIGN)
        CLOSE(LUNB)
        CLOSE(LUNA)
        LUNA  = LUNCT
        FIRST = .FALSE.

C       CONTINUE UNTIL IRTFLG IS NOT ZERO
        GOTO 110  

C       OPERATION ------   BLANK ---------------------------------- 'BL'	

2   	IFORM   = 2
        NSAM2   = 0
        NSLICE2 = 1
        CALL OPFIL(.TRUE.,FILNAM,LUN2,'U',NSAM2,NROW2,NSLICE2,
     &             MAXIM,'BLANK OUTPUT',.FALSE.,IRTFLG)
	IF (IRTFLG .NE. 0) GOTO 9000

        CALL RDPRMC(ANS,NA,.TRUE.,'AVERAGE? (Y/N)',NULL,IRTFLG)
        IF (ANS(:1) .EQ. 'Y') THEN
	   CALL OPFIL(.TRUE.,FILNAM2,LUN1,'O',NSAMR,NROWR,NDUM,
     &                MAXIM2,'REFERENCE',.FALSE.,IRTFLG)
	   IF (IRTFLG .NE. 0) GOTO 9000
           IF (IMAMI .NE. 1) THEN
              CALL NORM3(LUN1,NSAMR,NROWR,NDUM,FMAXR,FMINR,AVR)
              B = AVR
           ENDIF
           CLOSE(LUN1)
           CALL BLANK(LUN2,NSAM2,NROW2,B)
        ELSE
            CALL RDPRM(B,NLOOP,ILOOP,'BACKGROUND')
            CALL BLANK(LUN2,NSAM2,NROW2,B)
        ENDIF
        GOTO 9000

C       OPERATION ----------- COPY  ------------------------------- 'CP' 
3	CALL COPY1(MAXDIM)		
        GOTO 9000

C       OPERATION -------- INSERT --------------------------------- 'IN' 
C       	IN	: INSERT
C		IN S	: INSERT AND CONTRAST STRETCH

4	CALL OPFIL(.TRUE.,FILNAM,LUN1,'O',NSAM1,NROW1,NSLICE1,
     &             MAXIM,'SMALL INPUT',.FALSE.,IRTFLG)
	IF (IRTFLG .NE. 0) GOTO 9000
	AV1    = AV
        IF (FCHAR(4:4) .EQ. 'S' .AND. IMAMI .NE. 1) THEN
           CALL NORM3(LUN1,NSAM1,NROW1,NSLICE1,FMAX1,FMIN1,AV1)
	ENDIF

        
	CALL OPFIL(.TRUE.,FILNAM,LUN2,'O',NSAM2,NROW2,NSLICE2,
     &             MAXIM2,'LARGE INPUT (OVERWRITTEN!)',.TRUE.,IRTFLG)
	IF (IRTFLG .NE. 0) GOTO 9000

	IF (IFORM .LT. 0 .AND. IFORM .NE. -9) THEN
C          WRONG LARGE INPUT FORMAT
           IER = 2
           GOTO 9900
        ENDIF

        CALL RDPRMI(NSAMS,NROWS,NLOOP,ILOOP,'TOP LEFT COORDINATES')
        NSLICS = 1
        IN     = 1
        CALL PATCH(LUN1,LUN2,NSAM1,NROW1,NSLICE1,NSAM2,NROW2,
     &             NSLICR2,NSAMS,NROWS,NSLICS, IN,AV1,FCHAR(4:4))

C       SET UNDETERMINED SATATISTICS FLAG
        CALL SETPRM(LUN2,NSAM2,NROW2,0.0,0.0,0.0,'U')
        GOTO 9000

C       OPERATION  INTERPOLATE  ----------------------------------- 'IP'
C	IP         INTERPOLATE                                      
C	IP T       TRIANGULAR INTERPOLATION

5	CALL OPFIL(.TRUE.,FILNAM,LUN1,'O',NSAM1,NROW1,NSLICE1,
     &             MAXIM,'INPUT',.FALSE.,IRTFLG)
	IF (IRTFLG .NE. 0) GOTO 9000

C	OPEN THE OUTPUT FILE
        CALL FILERD(FILNAM,NLETO,NULL,'OUTPUT',IRTFLG)
        IF (IRTFLG .EQ. -1) GOTO 9000
        CALL RDPRMI(NSAM2,NROW2,NLOOP,ILOOP,'ENTER DIMS NSAM,NROW')
        NSLICE2 = 1
        IF (IFORM .EQ. 3 .AND. NSLICE1 .NE. 1) THEN
          CALL RDPRMI(NSLICE2,NDUM,NLOOP,ILOOP,'NSLICE')
        ENDIF

C	FOR RECTANGULAR IMAGES, THE USER IS ALLOWED TO ENTER ONLY
C	ONE DIMENSION, THE OTHER DIM. IS COMPUTED TO KEEP THE SAME 
C	RELATION AS THE ONE BETWEEN THE DIMS. OF INPUT1.
        IF (NROW2 .EQ. 0) THEN
           NROW2 = FLOAT(NSAM2) / FLOAT(NSAM1) * FLOAT(NROW1)
        ENDIF

	CALL OPFIL(.FALSE.,FILNAM,LUN2,'U',NSAM2,NROW2,NSLICE2,
     &             MAXIM2,'OUTPUT',.TRUE.,IRTFLG)
	IF (IRTFLG .NE. 0) GOTO 9000

        IF (FCHAR(4:4) .EQ. 'T') THEN
C          TRIANGULAR INTERPOLATION
           CALL TRINTER(LUN1,LUN2,NSAM1,NROW1,1,NSAM2,NROW2,1)
        ELSE
           IF (NSLICE1 .EQ. 1)  THEN
              CALL INTERP(LUN1,LUN2,NSAM1,NROW1,NSAM2,NROW2,MAXDIM)
           ELSE
              CALL INTERP3(LUN1,LUN2,NSAM1,NROW1,NSLICE1,
     &                     NSAM2,NROW2,NSLICE2,MAXDIM)
           ENDIF
        ENDIF

C       SET UNDETERMINED STATISTICS FLAG
        CALL SETPRMB(BUF,LUN2,NSAM2,NROW2,0.0,0.0,0.0,'U')
        GOTO 9000                            

C       OPERATION  MULTIPLY --------------------------------------- 'MU' 
C	MU       MULTIPLY REAL OR COMPLEX FILES 
C	MU D     DIVIDE REAL FILES
C	MU M     MULTIPLY FIRST COMPLEX FILE BY THE SECOND CONJUGATED.
C	MU O     MULITPLY WITH ARITHMETIC OR

C       OPEN FILES
6       FIRST  = .TRUE.
610     IF (FCHAR(4:4) .EQ. '/' .OR. FCHAR(4:4) .EQ. 'D') THEN
           CALL UTIL2SUP(FILNAM1,IFORM1,
     &               'INPUT','DIVISOR','OUTPUT',
     &               NSAM,NROW,NSLICE,LUNA,LUNB,LUNCT,FIRST,IRTFLG)
        ELSE
           CALL UTIL2SUP(FILNAM1,IFORM1,
     &               'INPUT','MULTIPLIER','OUTPUT',
     &               NSAM,NROW,NSLICE,LUNA,LUNB,LUNCT,FIRST,IRTFLG)
        ENDIF
	IF (IRTFLG .NE. 0) GOTO 9000

        SIGN = +2.
   	IF (FCHAR(4:4) .EQ. '/' .OR. FCHAR(4:4) .EQ. 'D') THEN
            IF (IFORM1 .LT. 0) THEN
               SIGN = -3.0
               WRITE(NOUT,*) 'COMPLEX DIVISION'
            ELSE
               SIGN = -2.0
               WRITE(NOUT,*) 'DIVISION'
            ENDIF
        ELSEIF (FCHAR(4:4) .EQ. '*' .OR. FCHAR(4:4) .EQ. 'M')  THEN
           SIGN = -2.0
           WRITE(NOUT,*) ' COMPLEX MULTIPLICATION -- (X) * CONJG(Y)'
        ELSEIF (FCHAR(4:4) .EQ. 'O')  THEN
           SIGN = +5.0
           WRITE(NOUT,*) ' MULTIPLICATION WITH ARITHMETIC OR'
        ENDIF

        CALL ADD(LUNB,LUNA,LUNCT,NSAM,NROW,NSLICE,SIGN)
        FIRST = .FALSE.
        CLOSE(LUNB)
        CLOSE(LUNA)
        LUNA = LUNCT

C       CONTINUE UNTIL IRTFLG IS NOT ZERO
	GOTO 610

C       OPERATION PATCH ------------------------------------------ 'PA' 

C	OPEN FIRST INPUT FILE
7	CALL OPFIL(.TRUE.,FILNAM,LUN1,'O',NSAM1,NROW1,NSLICE1,
     &             MAXIM,'SMALL INPUT',.FALSE.,IRTFLG)
        IFORM1 = IFORM
	IF (IRTFLG .NE. 0) GOTO 9000

C       OPEN SECOND INPUT FILE
	CALL OPFIL(.TRUE.,FILNAM,LUN2,'O',NSAM2,NROW2,NSLICE2,
     &             MAXIM2,'LARGE INPUT (OVERWRITTEN!)',.TRUE.,IRTFLG)
	IF (IRTFLG .EQ. -1) GOTO 7
	IF (IRTFLG .NE. 0) GOTO 9000
        IFORM2 = IFORM

	IF (IFORM1 .NE. IFORM2) THEN
           IER = 2
           GOTO 9900
	ELSEIF (IFORM .LE. 0 .AND. IFORM .NE. -9) THEN
           IER = 2
           GOTO 9900
        ENDIF    
        CALL RDPRMI(NSAMS,NROWS,NLOOP,ILOOP,'TOP LEFT COORDINATES')
        CALL PATCH(LUN1,LUN2,NSAM1,NROW1,NSLICE1, NSAM2,NROW2,
     &             NSLICE2, NSAMS,NROWS,1, 0,0,FCHAR(4:4))

C       SET UNDETERMINED STATISTICS FLAG
        CALL SETPRM(LUN2,NSAM2,NROW2,0.,0.,0.,'U')
        GOTO 9000                            


C       OPERATION   PAD  ----------------------------------------- 'PD' 

C	EMBED A PICT. OR VOL. IN A LARGER ARRAY.

C	OPEN FIRST INPUT FILE
8	CALL OPFIL(.TRUE.,FILNAM,LUN1,'O',NSAM1,NROW1,NSLICE1,
     &             MAXIM,'INPUT',.FALSE.,IRTFLG)
	IF (IRTFLG .NE. 0) GOTO 9000

        AV1    = AV
        IMAMI1 = IMAMI
        FMAX1  = FMAX
        FMIN1  = FMIN

C	OPEN THE OUTPUT FILE
        NSAM2   = 0
        NSLICE2 = 0
        CALL OPFIL(.TRUE.,FILNAM,LUN2,'U',NSAM2,NROW2,NSLICE2,
     &             MAXIM2,'OUTPUT',.FALSE.,IRTFLG)
        IF (IRTFLG .NE. 0) THEN
           IER = 4
           GOTO 9900
        ENDIF

        IN = 2
        CALL RDPRMC(ANS,NC,.TRUE.,
     &   'AVERAGE? (Y/N), (B)ORDER,(M)INIMUM,(C)IRCULAR',NULL,IRTFLG)
        IF (NC .GE. 2 .AND. ANS(2:2).EQ. 'C') IN = 3
        IF (ANS(:1) .EQ. 'Y' .OR. ANS(:1) .EQ. 'M') THEN
           IF (IMAMI1 .NE. 1) THEN
              CALL NORM3(LUN1,NSAM1,NROW1,NSLICE1,FMAX1,FMIN1,AV1)
           ENDIF

           IF (ANS(:1) .EQ. 'M') THEN
             B = FMIN1
           ELSE
             B = AV1
           ENDIF
        ELSE
           IF (ANS(:1) .NE. 'B') THEN
              CALL RDPRM(B,NLOOP,ILOOP,'BACKGROUND')
           ENDIF
        ENDIF
        CALL RDPRMI(NSAMS,NROWS,NLOOP,ILOOP,'TOP LEFT COOS')
        NSLICS = 1
        IF (NSLICE2 .NE. 1)
     &    CALL RDPRMI(NSLICS,NDUM,NLOOP,ILOOP,'TOP Z COORDINATE')

C       AB IS A SIGNAL FOR PATCH
        IF (ANS(:1) .EQ. 'B') B = 100000
        CALL PATCH(LUN1,LUN2,NSAM1,NROW1,NSLICE1,NSAM2,NROW2,NSLICE2,
     &             NSAMS,NROWS,NSLICS, IN,B,FCHAR(4:4))

C       SET UNDETERMINED STATISTICS FLAG
        CALL SETPRM(LUN2,NSAM2,NROW2,0.,0.,0.,'U')
        GOTO 9000

C       OPERATION  ------------------------------------------------ 'SH' 
C		SH       SHIFT
C		SH F     SHIFT USING FOURIER INTERPOLATION

C	OPEN FIRST INPUT FILE
9	CALL OPFIL(.TRUE.,FILNAM,LUN1,'O',NSAM1,NROW1,NSLICE1,
     &             MAXIM,'INPUT',.FALSE.,IRTFLG)
	IF (IRTFLG .NE. 0) GOTO 9000

C	OPEN OUTPUT FILE
	CALL OPFIL(.TRUE.,FILNAM,LUN2,'U',NSAM1,NROW1,NSLICE1,
     &             MAXIM2,'OUTPUT',.FALSE.,IRTFLG)
	IF (IRTFLG .NE. 0) GOTO 9000

        CALL RDPRM2(SAMS,ROWS,NLOOP,ILOOP,'SHIFT COMPONENTS IN X-Y')

	IF (IFORM.EQ.3) THEN
C         SHIFT IN 3-D
          CALL RDPRM(SLICS,NLOOP,ILOOP,'SHIFT COMPONENT IN Z')
          IF (SAMS  .EQ. FLOAT(IFIX(SAMS)) .AND.
     &        ROWS  .EQ. FLOAT(IFIX(ROWS)) .AND.
     &        SLICS .EQ. FLOAT(IFIX(SLICS)))  THEN
            NSAMS  = SAMS
            NROWS  = ROWS
            NSLICS = SLICS
	    IF (2*NSAM1 .GT. MAXDIM) THEN
	       IER = 6
	       GOTO 9900
	    ENDIF

            CALL SHIFT3(LUN1,LUN2,NSAM1,NROW1,NSLICE1,
     &                  NSAMS,NROWS,NSLICS)
          ELSE
	    IF (FCHAR(4:5) .EQ. 'F')  THEN
               NNNN=NSAM1+2-MOD(NSAM1,2)
	       MEMWANT=NNNN*NROW1*NSLICE1
	       CALL CHKMEM(MEMWANT,BUF,MAXDIM,RUNTIME,IPQ,IRTFLG)
	       IF (IRTFLG .NE. 0)  THEN
	          IER = 6
	          GOTO 9900
	       ENDIF
               DO J = 1, NROW1*NSLICE1
                  CALL REDLIN(LUN1,Q(1 + (J-1)*NNNN),NSAM1,J)
               ENDDO
	       INS=+1
	       CALL  FMRS_3(Q,NSAM1,NROW1,NSLICE1,INS)
	       IF (INS.EQ.0)  THEN
		  IER=38
		  GOTO 9900
	       ENDIF
	       CALL  SHIFT_PF(Q,NNNN/2,NSAM1,NROW1,NSLICE1,SAMS,ROWS,
     &                        SLICS)
	       INS=-1
	       CALL  FMRS_3(Q,NSAM1,NROW1,NSLICE1,INS)
               DO J = 1, NROW1*NSLICE1
                  CALL WRTLIN(LUN2,Q(1 + (J-1)*NNNN),NSAM1,J)
               ENDDO
	       IF(RUNTIME)  CALL ALLOCIT(0,RUNTIME,IPQ,'SH',IRTFLG)
	    ELSE
		IF (5*NSAM1 .GT. MAXDIM) THEN
		IER = 6
		GOTO 9900
	     ENDIF
            CALL  SHIFT_3D(LUN1,LUN2,BUF(1),BUF(4*NSAM1+1),
     &                     NSAM1,NROW1,NSLICE1,SAMS,ROWS,SLICS)
	    ENDIF
          ENDIF
        ELSEIF (IFORM .EQ. 1)  THEN
         IF(REAL(IFIX(SAMS)).EQ.SAMS.AND.REAL(IFIX(ROWS)).EQ.ROWS) THEN
C          INTEGER SHIFT
           NSAMS = SAMS
           NROWS = ROWS
	   IF (2*NSAM1 .GT. MAXDIM) THEN
	      IER = 6
	      GOTO 9900
	   ENDIF
           CALL  SHIFT2(LUN1,LUN2,NSAM1,NROW1,NSAMS,NROWS)
         ELSE
	    IF (FCHAR(4:5).EQ.'F')  THEN
               NNNN=NSAM1+2-MOD(NSAM1,2)
	       MEMWANT=NNNN*NROW1
	       CALL CHKMEM(MEMWANT,BUF,MAXDIM,RUNTIME,IPQ,IRTFLG)
	       IF(IRTFLG.NE.0)  THEN
	          IER = 6
	          GOTO 9900
	       ENDIF
               DO  J = 1, NROW1
                  CALL REDLIN(LUN1,Q(1 + (J-1)*NNNN),NSAM1,J)
               ENDDO
	       INS=+1
	       CALL  FMRS_2(Q,NSAM1,NROW1,INS)
	       IF(INS.EQ.0)  THEN
		  IER=38
		  GOTO 9900
	       ENDIF
	       CALL  SHIFT_PF(Q,NNNN/2,NSAM1,NROW1,1,SAMS,ROWS,0)
	       INS=-1
	       CALL  FMRS_2(Q,NSAM1,NROW1,INS)
                DO J = 1, NROW1
                   CALL WRTLIN(LUN2,Q(1 + (J-1)*NNNN),NSAM1,J)
                ENDDO
	        IF(RUNTIME)  CALL ALLOCIT(0,RUNTIME,IPQ,'SH',IRTFLG)
	    ELSE
C              BILINEAR INTERPOLATION
	       IF (6*NSAM1 .GT. MAXDIM) THEN
	          IER = 6
	          GOTO 9900
	       ENDIF
               NNROWS = 1
               NNROWE = NROW1
               NNROWK = 1
               CALL SHIFTR(LUN1,LUN2,NSAM1,NROW1,NNROWS,NNROWE,
     &                  NNROWK,SAMS,ROWS)
	    ENDIF
          ENDIF
	ELSE
	   CALL  ERRT(2,'SH',NE)
	ENDIF	
        GOTO 9000

C       OPERATION  ----------------------------------------------- 'SQ'
C	SQUARES POINT BY POINT FROM INPUT AND STORES IT IN OUTPUT

10      CALL OPFIL(.TRUE.,FILNAM,LUN1,'O',NSAM1,NROW1,NSLICE1,
     &     MAXIM,'INPUT',.TRUE.,IRTFLG)
	IF (IRTFLG .NE. 0) GOTO 9000

C	OPEN  OUTPUT FILE (SAME SIZE AS INPUT)
 	CALL OPFIL(.TRUE.,FILNAM,LUN3,'U',NSAM1,NROW1,NSLICE1,
     &             MAXIM2,'OUTPUT',.TRUE.,IRTFLG)
	IF (IRTFLG .NE. 0) GOTO 9000

	SIGN = +3.0
        CALL ADD(LUN1,LUN1,LUN3,NSAM1,NROW1,NSLICE1,SIGN)
        GOTO 9000

C       OPERATION ------------------------------------------------ 'SU' 
C	SUBTRACTS ONE OR MORE IMAGE FROM THE FIRST IMAGE

11	FIRST = .TRUE.
       
1140    CALL UTIL2SUP(FILNAM1,IFORM1,
     &               'FIRST INPUT','SUBTRACTED','OUTPUT',
     &               NSAM,NROW,NSLICE,LUNA,LUNB,LUNCT,FIRST,IRTFLG)
	IF (IRTFLG .NE. 0) GOTO 9000

        SIGN = -1.0
	CALL ADD(LUNB,LUNA,LUNCT,NSAM,NROW,NSLICE,SIGN)
        CLOSE(LUNB)
        CLOSE(LUNA)
        LUNA  = LUNCT
        FIRST = .FALSE.
	GOTO 1140

C       OPERATION  ------------------------------------------------ 'WI' 
C	WI        WINDOW 
C	WI B      WINDOW USING SPECIFIED BACKGROUND 

C	OPEN INPUT FILE
12	CALL OPFIL(.TRUE.,FILNAM,LUN1,'O',NSAM1,NROW1,NSLICE1,
     &             MAXIM,'INPUT',.FALSE.,IRTFLG)
	IF (IRTFLG .NE. 0) GOTO 9000

C       OPEN OUTPUT FILE
        NSAM2   = 0
        NSLICE2 = 0
        CALL OPFIL(.TRUE.,FILNAM,LUN2,'U',NSAM2,NROW2,NSLICE2,
     &             MAXIM2,'OUTPUT',.FALSE.,IRTFLG)

        CALL RDPRMI(NSAMW,NROWW,NLOOP,ILOOP,'TOP LEFT COORDINATES')
        NSLICEW = NSLICE1
        IF (IFORM .EQ. 3 .AND. NSLICE1 .NE. 1)
     &     CALL RDPRMI(NSLICEW,NDUM,NLOOP,ILOOP,'TOP SLICE')

        BACK = 0.0
        IF (FCHAR(4:4) .EQ. 'B') 
     &     CALL RDPRM(BACK,NLOOP,ILOOP,'BACKGROUND')
        CALL WINDOW(LUN1,LUN2, NSAM1,NROW1,NSLICE1,
     &                         NSAMW,NROWW,NSLICEW, 
     &                         NSAM2,NROW2,NSLICE2,BACK)
        GOTO 9000


C       OPERATION ------------------------------------------------- 'CE' 
C	CE        CONTRAST ENHANCEMENT 
C	CE FIT    CONTRAST ENHANCEMENT, FIT THE HISTOGRAM
C	CE OD     CONTRAST ENHANCEMENT, FIT THE HISTOGRAM FOR OPTICAL
C                 DENSITY MICROGRAPHS.
C	CE GNC    CONTRAST ENHANCEMENT USING GRADUATED
C                             NON-CONVEX RESTORATION 
C	CE MED    CONTRAST ENHANCEMENT USING MEDIAN FILTERING 
 
13      IF (FCHAR(4:6) .EQ. 'FIT')  THEN
	  CALL  HISTE(MAXDIM)
	  GOTO  9911
        ELSEIF (FCHAR(4:5) .EQ. 'OD')  THEN
	  CALL  HISTOD(MAXDIM)
	  GOTO  9911
	ENDIF

	CALL OPFIL(.TRUE.,FILNAM,LUN1,'O',NSAM1,NROW1,NSLICE1,
     &             MAXIM,'INPUT',.FALSE.,IRTFLG)
	IF (IRTFLG .NE. 0) GOTO 9000

C	OPEN OUTPUT FILE
	CALL OPFIL(.TRUE.,FILNAM,LUN2,'U',NSAM1,NROW1,NSLICE1,
     &             MAXIM2,'OUTPUT',.TRUE.,IRTFLG)
	IF (IRTFLG .NE. 0) GOTO 9000

        IF (FCHAR(4:6) .EQ. 'MED') THEN
           CALL MEDIAN(LUN1,LUN2,NSAM1,NROW1,NSLICE1,MAXDIM)

        ELSEIF (FCHAR(4:6) .EQ. 'GNC') THEN
            CALL GNC(LUN1,LUN2,NSAM1,NROW1,MAXDIM)
        ELSE
           CALL ENHANC(FILNAM2,LUN1,LUN2,NSAM1,NROW1,NSLICE1)
        ENDIF
        GOTO 9000

C       OPERATION  -----------------------------------------------  'AR' 
C	AR        ARITHMETIC OPERATION

C	OPEN INPUT FILE
14	CALL OPFIL(.TRUE.,FILNAM,LUN1,'O',NSAM1,NROW1,NSLICE1,
     &             MAXIM,'INPUT',.FALSE.,IRTFLG)
	IF (IRTFLG .NE. 0) GOTO 9000

C	OPEN THE OUTPUT FILE
	CALL OPFIL(.TRUE.,FILNAM,LUN2,'U',NSAM1,NROW1,NSLICE1,
     &             MAXIM2,'OUTPUT',.TRUE.,IRTFLG)
	IF (IRTFLG .NE. 0) GOTO 9000

        CALL ARITH(LUN1,LUN2,NSAM1,NROW1,NSLICE1)
        GOTO 9000

C       OPERATION  -----------------------------------------------  'MR'
C	MIRROR SYMMETRY
C	OPEN INPUT FILE
15	CALL OPFIL(.TRUE.,FILNAM,LUN1,'O',NSAM1,NROW1,NSLICE1,
     &             MAXIM,'INPUT',.FALSE.,IRTFLG)
	IF (IRTFLG .NE. 0) GOTO 9000
C	OPEN THE OUTPUT FILE
	CALL OPFIL(.TRUE.,FILNAM,LUN2,'U',NSAM1,NROW1,NSLICE1,
     &             MAXIM2,'OUTPUT',.TRUE.,IRTFLG)
	IF (IRTFLG .NE. 0) GOTO 9000
        CALL MIRROR(LUN1,LUN2,NSAM1,NROW1,NSLICE1)
        GOTO 9000
C
C       OPERATION  ------------------------------------------------ 'DF' 
C	DENSITY FOLDOVER
16	CALL OPFIL(.TRUE.,FILNAM,LUN1,'O',NSAM1,NROW1,NSLICE1,
     &             MAXIM,'INPUT',.FALSE.,IRTFLG)
	IF (IRTFLG .NE. 0) GOTO 9000

C	OPEN OUTPUT FILE
	CALL OPFIL(.TRUE.,FILNAM,LUN2,'U',NSAM1,NROW1,NSLICE1,
     &             MAXIM2,'OUTPUT',.TRUE.,IRTFLG)
	IF (IRTFLG .NE. 0) GOTO 9000

        CALL DENOV(LUN1,LUN2,NSAM1,NROW1,NSLICE1)
        GOTO 9000

C       OPERATION  ----------------------------------------------- 'MA' 
C	MA 	MASK
C	MA X	LATERAL MASKING IN SAMPLE DIRECTION

C	OPEN FIRST INPUT FILE
17	CALL OPFIL(.TRUE.,FILNAM,LUN1,'O',NSAM1,NROW1,NSLICE1,
     &             MAXIM,'INPUT',.FALSE.,IRTFLG)
	IF (IRTFLG .NE. 0) GOTO 9000
	AV1    = AV
        IF (IMAMI .NE. 1) 
     &      CALL NORM3(LUN1,NSAM1,NROW1,NSLICE1,FMAX1,FMIN1,AV1)

C	OPEN THE OUTPUT FILE
  	CALL OPFIL(.TRUE.,FILNAM,LUN2,'U',NSAM1,NROW1,NSLICE1,
     &             MAXIM2,'OUTPUT',.TRUE.,IRTFLG)
	IF (IRTFLG .NE. 0) GOTO 9000

        CALL MASK(LUN1,LUN2,NSAM1,NROW1,NSLICE1,AV1)
        GOTO 9000

C       OPERATION ------------------------------------------------- 'WV' 
C	WV        WINDOW AVERAGING
C	WV S      WINDOW AVERAGING -- SEQUENTIAL DOCUMENT SEARCH
C	WV P      WINDOW AVERAGING OVER PATCHES       

C       TRAP FOR WINDOW AVERAGING WITH PATCH OPTION
18      IF ( FCHAR(4:4) .EQ. 'P') THEN
          CALL WINAVE2(LUN1,LUN2,LUN3)
          GOTO 9000
        END IF

C	OPEN INPUT FILE
	CALL OPFIL(.TRUE.,FILNAM,LUN1,'O',NSAM1,NROW1,NSLICE1,
     &             MAXIM,'INPUT',.FALSE.,IRTFLG)
	IF (IRTFLG .NE. 0) GOTO 9000

C	OPEN THE OUTPUT FILE
        NSAM2   = 0
        NSLICE2 = 0
        CALL OPFIL(.TRUE.,FILNAM,LUN2,'O',NSAM2,NROW2,NSLICE2,
     &             MAXIM2,'OUTPUT',.FALSE.,IRTFLG)
        IF (IRTFLG .NE. 0) THEN
           IER = 4
           GOTO 9900
        ENDIF

        CALL WINAVE(LUN1,LUN2,LUN3,NSAM1,NROW1,NSAM2,NROW2)
        GOTO 9000

C       OPERATION  ------------------------------------------------ 'PP' 
C	PP P	PUT POINT 
C 	PP L	PUT POINT SPECIFIED INTENSITY
C 	PP LL	PUT LINE

19      CONTINUE
        IF (FCHAR(4:5) .EQ. 'LL') THEN
C          PUT CONTINUOUS LINE IN IMAGE FILE
           CALL PUTLIN(LUN1,LUN2,MAXDIM)

        ELSE
           CALL OPFIL(.TRUE.,FILNAM,LUN1,'O',NSAM1,NROW1,NSLICE1,
     &             MAXIM,'INPUT',.FALSE.,IRTFLG)
	   IF (IRTFLG .NE. 0) GOTO 9000
	   IF (NSAM1 .GT. MAXDIM) THEN
C             TOO LONG LINE LENGTH
              IER = 9
              GOTO 9900
	   ELSEIF (IFORM .LT. 0) THEN
C             NOT FOR FOURIER
              IER = 2
              GOTO 9900
           ENDIF

           IF (FCHAR(4:4) .EQ. 'P') THEN
              CALL PUTPT(LUN1,LUN2,NSAM1,NROW1,NSLICE1)

           ELSEIF (FCHAR(4:4) .EQ. 'L') THEN
              CALL PUTPT2(LUN1,LUN2,NSAM1,NROW1,NSLICE1)

           ELSEIF (FCHAR(4:4) .EQ. 'V') THEN
C             CONVERT HEIGHT FIELD TO A BINARY VOLUME

C             NORMALIZE FILE IF NECESSARY
              IF (IMAMI .NE. 1) 
     &            CALL NORM3(LUN1,NSAM1,NROW1,NSLICE1,FMAX,FMIN,AV)

              WRITE(NOUT,90) FMIN,FMAX
90            FORMAT(' IMAGE DEPTH RANGE: ',G11.3,' ... ',G11.3)

6511            CALL RDPRIS(NSLICE2,NDUM,NLOOP,ILOOP,
     &            'ENTER NUMBER OF SLICES IN OUTPUT VOLUME',IRTFLG)
              IF (IRTFLG .EQ. -1) GOTO 19

              IFORM = 3
              CALL OPFIL(.TRUE.,FILNAM,LUN2,'U',NSAM1,NROW1,NSLICE2,
     &             MAXIM2,'OUTPUT',.FALSE.,IRTFLG)
	      IF (IRTFLG .EQ. -1) GOTO 6511

              CALL IMTOVOL(LUN1,NSAM1,NROW1,NSLICE2,LUN2,FMIN,FMAX,
     &                     MAXDIM)
           ENDIF
        ENDIF
        GOTO 9000

C       OPERATION ------------------------------------------------ 'SZ' 
C	SZ  	SHEARS AN IMAGE BY OFSETTING EACH ROW	

C	OPEN FIRST INPUT FILE
20	CALL OPFIL(.TRUE.,FILNAM,LUN1,'O',NSAM1,NROW1,NSLICE1,
     &             MAXIM,'INPUT1',.FALSE.,IRTFLG)
	IF (IRTFLG .NE. 0) GOTO 9000

        CALL SQUEEZ(LUN1,LUN2,NSAM1,NROW1,NSLICE1,IERR)
        IF (IERR .EQ. 1) THEN

C         MASKMU EXTENDED TO 3-D (JMC)
          CALL MASKMU(LUN1,LUN2,NSAM1,NROW1,NSLICE1)
        END IF
        GOTO 9000

C       OPERATION   SQUARE ROOT (WURZEL) ------------------------- 'WU' 
C	TAKES THE SQUARE ROOT OF A PICTURE.

C	OPEN INPUT FILE
21	CALL OPFIL(.TRUE.,FILNAM,LUN1,'O',NSAM1,NROW1,NSLICE1,
     &             MAXIM,'INPUT',.FALSE.,IRTFLG)
	IF (IRTFLG .NE. 0) GOTO 9000
        IF (FMIN .LT. 0) THEN
           CALL ERRT(101,'*** SQ. ROOT OF NEGATIVE NUMBER AVOIDED',IE)
           GOTO 9000
        ENDIF

C	OPEN OUTPUT FILE
	CALL OPFIL(.TRUE.,FILNAM,LUN3,'U',NSAM1,NROW1,NSLICE1,
     &             MAXIM2,'OUTPUT',.TRUE.,IRTFLG)
	IF (IRTFLG .NE. 0) GOTO 9000

	SIGN = +4.0
        CALL ADD(LUN1,LUN1,LUN3,NSAM1,NROW1,NSLICE1,SIGN)
        GOTO 9000

C       OPERATION    MASK MULTIPLICATION -------------------------- 'MM' 
C	MM           MASK MULT.
C	MM C	     MULT. CONTINUOUS

22      CALL OPFIL(.TRUE.,FILNAM,LUN1,'O',NSAM1,NROW1,NSLICE1,
     &             MAXIM,'MASK REFERENCE',.FALSE.,IRTFLG)
	IF (IRTFLG .NE. 0) GOTO 9000
        FILNAM2 = FILNAM

C       OPEN IMAGE INPUT FILE
	CALL OPFIL(.TRUE.,FILNAM,LUN2,'O',NSAM2,NROW2,NSLICE2,
     &             MAXIM2,'IMAGE (OVERWRITTEN!)',.TRUE.,IRTFLG)
	IF (IRTFLG .EQ. -1) GOTO 22
	IF (IRTFLG .NE. 0) GOTO 9000
	IF (IFORM .LT. 0 .AND. IFORM .NE. -9) THEN
           IER = 2
           GOTO 9900
        ENDIF
C       MASKMU EXTENDED TO 3-D (JMC)
        CALL MASKMU(LUN1,LUN2,NSAM1,NROW1,NSLICE1)
        GOTO 9000

C       OPERATION ------------------------------------------------- 'CM'

C	OPEN OUTPUT FILE
23  	CALL OPFIL(.TRUE.,FILNAM,LUN2,'U',256,256,1,
     &             MAXIM,'OUTPUT',.TRUE.,IRTFLG)
	IF (IRTFLG .NE. 0) GOTO 9000
    
C       NO MANUAL CHAPTER EITHER!!
C       CALL CLUMAP(LUN1,LUN2,256) !!!! commented out??????
        GOTO 9000

C       OPERATION  ------------------------------------------------ 'PV' 
24      CALL ERRT(100,'PV OPERATION NO LONGER SUPPORTED',NE)
CCC     CALL PDPVAX(LUN1,LUN2,FCHAR(4:4))
        GOTO 9000

C       OPERATION  ------------------------------------------------ 'NK' 
C	NK   SHRINK
		
C	OPEN INPUT FILE
25	CALL OPFIL(.TRUE.,FILNAM,LUN1,'O',NSAM1,NROW1,NSLICE1,
     &             MAXIM,'INPUT',.FALSE.,IRTFLG)
	IF (IRTFLG .NE. 0) GOTO 9000

  	CALL OPFIL(.TRUE.,FILNAM,LUN2,'U',NSAM1,NROW1,NSLICE1,
     &             MAXIM2,'OUTPUT',.TRUE.,IRTFLG)
	IF (IRTFLG .NE. 0) GOTO 9000

        CALL SHR(LUN1,LUN2,NSAM1,NSAM2)
        GOTO 9000

C       OPERATION ------------------------------------------------- 'AS'
C	AS        ADD WITH VARIANCE COMPUTED 
C	AS X10	  OPTIONAL REGISTER TO HOLD AVE. OFFSET
C       AS AD     ADD TO THE EXISTING AVERAGE WITH VARIANCE COMPUTED.
C	AS DC     ADD WITH VARIANCE COMPUTED         
C	AS F      ADD AND COMPUTE STATISTICS AND Q FACTOR MAP 
C	AS R      ADD WITH VARIANCE COMPUTED        

C	 ADDS 2 OR MORE (UP TO 500) PICTURES TOGETHER, COMPUTING
C          SEVERAL MEASURES OF VARIANCE (PER POINT, TOTAL, ETC.)
		
26      IF (FCHAR(4:4) .EQ. 'F') THEN
            CALL QFACT(LUN1,LUN2,LUN3,MAXDIM)
        ELSE
            CALL ADDS(LUN1,LUN2,LUN3,MAXDIM)
        ENDIF
        GOTO 9000

C       OPERATION  ------------------------------------------------ 'MN' 
C	MN        MONTAGE   
C	MN S      MONTAGE WITH INDIVIDUAL SCALING  

27      CALL MONT(MAXDIM)
        GOTO 9000


C       OPERATION ------------------------------------------------- 'TH'
 
C	TH        THRESHOLD    
C	TH F      THRESHOLD--FIXUP CONSTANT 
C       TH M      THRESHOLD AND CREATE MASK 
C       TH C      THRESHOLD--CHANGE A VALUE 
   
C       REPLACES ALL VALUES WITHIN AN IMAGE OR VOLUME BEYOND A
C       SPECIFIED THRESHOLD BY THE THRESHOLD VALUE.

C	OPEN INPUT FILE
28	CALL OPFIL(.TRUE.,FILNAM,LUN1,'O',NSAM1,NROW1,NSLICE1,
     &             MAXIM,'IMAGE TO BE THRESHOLDED',.FALSE.,IRTFLG)
	IF (IRTFLG .NE. 0) GOTO 9000
	IF (NSAM1 .GT. MAXDIM) THEN
          IER = 9
          GOTO 9900
        END IF

 	CALL OPFIL(.TRUE.,FILNAM,LUN2,'U',NSAM1,NROW1,NSLICE1,
     &             MAXIM2,'OUTPUT',.TRUE.,IRTFLG)
	IF (IRTFLG .NE. 0) GOTO 9000

        IF (FCHAR(4:4) .EQ. 'C') THEN
           CALL CHANGEVAL(LUN1,LUN2,NSAM1,NROW1,NSLICE1)
        ELSE
           CALL THRESH(LUN1,LUN2,NSAM1,NROW1,NSLICE1)
        ENDIF
        GOTO 9000

C       OPERATION  GP -------------------------------------------- 'GP' 
C	GP        GET PIXEL VALUE          
29	CALL OPFIL(.TRUE.,FILNAM,LUN1,'O',NSAM1,NROW1,NSLICE1,
     &             MAXIM,'INPUT',.FALSE.,IRTFLG)
	IF (IRTFLG .NE. 0) GOTO 9000
	IF (NSAM1 .GT. MAXDIM) THEN
          IER = 9
          GOTO 9900
        END IF
	CALL RDPRMI(IX,IY,NLOOP,ILOOP,'IX, IY')
	IF(IFORM.GT.1)  THEN
	CALL RDPRMI(IZ,IDUM,NLOOP,ILOOP,'IZ')
	ELSE
	IZ=1
	ENDIF
	IREC=IY+(IZ-1)*NROW1
	CALL  REDLIN(LUN1,BUF,NSAM1,IREC)
	WRITE(NOUT,8901)  IX,IY,IZ,BUF(IX)
8901	FORMAT(' LOCATION=',3I7,' VALUE=',1PE12.5)
	IF(NSEL(1).NE.0)  PARAM(NSEL(1))=BUF(IX)
        GOTO 9000

C       OPERATION  RP -------------------------------------------- 'RP' 
C	RP        REPLACE PIXEL         
30	CALL OPFIL(.TRUE.,FILNAM,LUN1,'O',NSAM1,NROW1,NSLICE1,
     &             MAXIM,'INPUT',.FALSE.,IRTFLG)
	IF (IRTFLG .NE. 0) GOTO 9000
	IF (NSAM1 .GT. MAXDIM) THEN
          IER = 9
          GOTO 9900
        END IF
	CALL RDPRMI(IX,IY,NLOOP,ILOOP,'IX, IY')
	IF(IFORM.GT.1)  THEN
	CALL RDPRMI(IZ,IDUM,NLOOP,ILOOP,'IZ')
	ELSE
	IZ=1
	ENDIF
	IREC=IY+(IZ-1)*NROW1
	CALL  REDLIN(LUN1,BUF,NSAM1,IREC)
	IF(NSEL(1).NE.0)  THEN
	BUF(IX)=PARAM(NSEL(1))
	ELSE
	CALL RDPRM(BUF(IX),NLOOP,ILOOP,'NEW PIXEL VALUE')
	ENDIF
	CALL  WRTLIN(LUN1,BUF,NSAM1,IREC)
        GOTO 9000

9900    CALL ERRT(IER,'UTIL2 ',NE)


9000    CLOSE(LUN1)
        CLOSE(LUN2)
        CLOSE(LUN3)

9911    IFOUND = 1
        RETURN
        END



C++*********************************************************************
C
C UTIL2SUP.FOR                               ARDEAN LEITH         8/1/97
C
C **********************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK        *
C *  COPYRIGHT (C)1981,1987, WADSWORTH CENTER FOR LABORATORIES AND     *
C *    RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201 *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS *
C *    OR USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN        *
C *    APPROVAL OF THE CENTER FOR LABORATORIES AND RESEARCH.           *
C **********************************************************************
C
C  UTIL2SUP(FILNAM1,IFORM1, PROMPT1,PROMPT2,PROMPT3,
C           NSAM,NROW,NSLICE, LUNA,LUNB,LUNCT, FIRST,IRTFLG)
C
C  PARAMETERS:      
C
C        1         2         3         4         5         6         7
C23456789012345678901234567890123456789012345678901234567890123456789012
C--*********************************************************************

        SUBROUTINE UTIL2SUP(FILNAM1,IFORM1,
     &                      PROMPT1,PROMPT2,PROMPT3,
     &                      NSAM,NROW,NSLICE, LUNA,LUNB,LUNCT,
     &                      FIRST,IRTFLG)

	INCLUDE 'CMBLOCK.INC'
CNO_SAVE

        CHARACTER *(*)  PROMPT1,PROMPT2,PROMPT3,FILNAM1
        CHARACTER *81   FILNAM3,FILNAM2
        LOGICAL         FIRST
        CHARACTER       NULL

C       LUN? SHOULD BE SAME AS IN UTIL2!
	DATA            LUN1,LUN2,LUN3/21,22,23/

	NULL   = CHAR(0)
        MAXIM  = 0
        MAXIM2 = 0
        MAXIM3 = 0

        IF (FIRST) THEN
C          GET NAME & OPEN FIRST INPUT FILE
1	   LUNA = LUN1
           CALL OPFIL(.TRUE.,FILNAM1,LUNA,'O',NSAM,NROW,NSLICE,
     &                MAXIM,PROMPT1,.TRUE.,IRTFLG)
	   IF (IRTFLG .NE. 0) GOTO 9000
           IFORM1 = IFORM
        ENDIF

C       OPEN 2ND OR LATER INPUT FILE
        CALL FILERD(FILNAM2,NLET2,NULL,PROMPT2,IRTFLG)
        IF (IRTFLG .EQ. -1) GOTO 9000

        IF (FILNAM2 .EQ. FILNAM1) THEN
C          SECOND INPUT SAME AS FIRST
           LUNB = LUNA
        ELSE
           LUNB = LUN2
111	   CALL OPFIL(.FALSE.,FILNAM2,LUNB,'O',NSAMT,NROWT,NSLICET,
     &                MAXIM2,PROMPT2,.TRUE.,IRTFLG)
	   IF (IRTFLG .NE. 0) GOTO 9000
	   IF (NSAMT.NE.NSAM.OR.NROWT.NE.NROW.OR.NSLICET.NE.NSLICE)
     &        THEN 
	      CALL ERRT(1,'UTIL2SUP',NE)
	      GOTO 9000
	   ELSEIF (IFORM .NE. IFORM1)  THEN
	      CALL ERRT(40,'UTIL2SUP',NE)
	      GOTO 9000
           ENDIF
        ENDIF

        IF (FIRST) THEN
C          OPEN OUTPUT FILE
           CALL FILERD(FILNAM3,NLET3,NULL,PROMPT3,IRTFLG)
           IF (IRTFLG .EQ. -1) GOTO 9000

           IF (FILNAM3 .EQ. FILNAM1) THEN
C             OUTPUT FILE SAME FILE AS FIRST INPUT
              LUNCT   = LUNA

           ELSEIF (FILNAM3 .EQ. FILNAM2) THEN
C             OUTPUT FILE SAME FILE AS SECOND INPUT
              LUNCT   = LUNB

           ELSE
C             OUTPUT FILE NOT SAME AS EITHER INPUT
              LUNCT   = LUN3
              NSAMT   = NSAM
              NROWT   = NROW
              NSLICET = NSLICE
   	      CALL OPFIL(.FALSE.,FILNAM3,LUNCT,'U',NSAMT,NROWT,NSLICET,
     &             MAXIM3,PROMPT3,.TRUE.,IRTFLG)
	      IF (IRTFLG .NE. 0) GOTO 9000
	      IF (NSAMT.NE.NSAM.OR.NROWT.NE.NROW.OR.NSLICET.NE.NSLICE)
     &           THEN 
	         CALL ERRT(1,'UTIL2SUP',NE)
	         GOTO 9000
	      ELSEIF (IFORM .NE. IFORM1)  THEN
	         CALL ERRT(40,'UTIL2SUP',NE)
	         GOTO 9000
              ENDIF
           ENDIF

C          SET UNDETERMINED STATISTICS FLAG 
           CALL SETPRM(LUNCT,NSAM,NROW,0.,0.,0.,'U')

        ENDIF
        RETURN

9000    CLOSE(LUN1)
        CLOSE(LUN2)
        CLOSE(LUN3)

        RETURN
        END
