C++************************************************************************
C
C  UTIL3.FOR                               LONG FILENAMES DEC 88 al
C                                          MAHIEDDINE LADJADJ  4/23/93
C                                          JING SU             8/31/93
C                                          REWRITTEN al        1/15/98
C
C **********************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.    AUTHOR: J.FRANK      *
C *  COPYRIGHT (C)1985, 1996 HEALTH RESEARCH INCORPORATED, ALBANY, NY. *
C * THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO HEALTH            *
C * RESEARCH INC. AND ARE NOT TO BE DISCLOSED TO OTHERS OR USED        *
C * FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF       *
C * HEALTH RESEARCH INC.                                               *
C **********************************************************************
C
C  UTIL3(MAXDIM)
C
C23456789 123456789 123456789 123456789 123456789 123456789 123456789 12
C--*********************************************************************

        SUBROUTINE UTIL3(MAXDIM)

CNO_SAVE
	INCLUDE 'CMBLOCK.INC'

	COMMON        BUF(1)

        CHARACTER *81 FILNAM,FILNM1,FILNAMO
	PARAMETER     (NFUNC=12)
        CHARACTER *2  FUNC(NFUNC)

	DATA FUNC/'ED', 'RC', 'RT', 'BC', 'CT',
     1            'OR', 'FC', 'SL', 'RO', 'OD',
     2            'MK', 'AF'/

	LUN1   = 7
	LUN2   = 8
	LUN3   = 9
        IRTFLG = 0
        MAXIM1 = 0
        MAXIM2 = 0

        DO  IFUNC = 1, NFUNC
           IF (FCHAR(1:2) .EQ. FUNC(IFUNC)) THEN
              GOTO (1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12) IFUNC
           END IF
        END DO
        RETURN

C	OPERATION ------------- EDGE ----------------------------- 'ED'

1	CALL OPFIL(.TRUE.,FILNAM,LUN1,'O',NSAM,NROW,NSLICE,
     & 		   MAXIM1,'INPUT',.FALSE.,IRTFLG)
	IF (IRTFLG .NE. 0) GOTO 9000

        IF (NSLICE .NE. 1) THEN
C          DOES NOT WORK ON 3-D FILES
           CALL ERRT(2,'UTIL3',NE)
           GOTO 9000
        END IF

C       OPEN AN OUTPUT FILE WITH DIMENSIONS BASED ON FIRST INPUT FILE
        CALL OPFIL(.TRUE.,FILNAM,LUN2,'U',NSAM,NROW,NSLICE,
     &  	   MAXIM2,'OUTPUT',.TRUE.,IRTFLG)
	IF (IRTFLG .NE. 0) GOTO 9000

        CALL EDGE(LUN1,LUN2,LUN3,NSAM,NROW,MAXDIM)
        GOTO 9000

C       OPERATION -------- REAL CONVOLUTION ----------------------- 'RC'

2	CALL OPFIL(.TRUE.,FILNAM,LUN1,'O',NSAM,NROW,NSLICE,
     & 		   MAXIM1,'INPUT',.FALSE.,IRTFLG)
	IF (IRTFLG .NE. 0) GOTO 9000

C       OPEN AN OUTPUT FILE WITH DIMENSIONS BASED ON FIRST INPUT FILE
        CALL OPFIL(.TRUE.,FILNAMO,LUN2,'U',NSAM,NROW,NSLICE,
     &  	   MAXIM2,'OUTPUT',.TRUE.,IRTFLG)
	IF (IRTFLG .NE. 0) GOTO 9000

        CALL RCONV(LUN1,LUN2,LUN3,NSAM,NROW,NSLICE,1,MAXDIM)
        GOTO 9000

C       OPERATION -------- ROTATE --------------------------------- 'RT'

3       IF (FCHAR(4:5) .EQ. '3D') THEN
C          OPERATION -------- ROTATE --------------------------- 'RT 3D'
           CALL  ROTAS3(MAXDIM,'D')
           GOTO  9911

	ELSEIF (FCHAR(4:5) .EQ. '3A') THEN
C          OPERATION -------- ROTATE --------------------------- 'RT 3A'
           CALL  ROTAS3(MAXDIM,'A')
           GOTO  9911

	ELSEIF (FCHAR(4:5) .EQ. '3L') THEN
C          OPERATION -------- ROTATE AROUND LINE --------------- 'RT 3L'
           CALL  ROTAL3(MAXDIM)
           GOTO  9911
        END IF
                   
C       OPEN INPUT FILE
        IF (FCHAR(4:5) .EQ. 'SQ')  MAXIM1 = 1 
	CALL OPFIL(.TRUE.,FILNAM,LUN1,'O',NSAM1,NROW1,NSLIC1,
     & 		   MAXIM1,'INPUT',.FALSE.,IRTFLG)
	IF (IRTFLG .NE. 0) GOTO 9000

        FMAX1  = FMAX
        FMIN1  = FMIN
        IMAMI1 = IMAMI
C       RECORD INPUT IMAGE  AVERAGE IN CASE NEEDED FOR BACKGROUND
        AV1    = AV

C       OPERATION -------- ROTATE 90, 180, 270 ----------------- 'RT 90'
C       SPECIAL ARRANGEMENT FOR 'RT 90' (DO NOT KNOW DIMENSIONS YET)
        IF (FCHAR(4:5) .EQ. '90') THEN
C          90, 180, OR 270 DEGREE ROTATION OF VOLUME
           CALL REFORM0(LUN1,LUN2,NSAM1,NROW1,NSLIC1,MAXDIM,IRTFLG)
           GOTO 9000
        END IF
                     
C       OPEN AN OUTPUT FILE WITH SAME DIMENSIONS AS INPUT FILE
        IF (FCHAR(4:5) .EQ. 'SQ' .AND. MAXIM1 .GE. 0)  MAXIM2 = 1 
	CALL OPFIL(.TRUE.,FILNAMO,LUN2,'U',NSAM1,NROW1,NSLIC1,
     &  	   MAXIM2,'OUTPUT',.TRUE.,IRTFLG)
	IF (IRTFLG .NE. 0) GOTO 9000

        IF (FCHAR(4:5) .EQ. '3') THEN
C          OPERATION -------- ROTATE 3 -------------------------- 'RT 3'
320        IF (IMAMI1 .NE. 1)
     &        CALL NORM3(LUN1,NSAM1,NROW1,NSLIC1,FMAX1,FMIN1,AV1)
           IFANGL = 0
           IFSHIF = 0
           CALL ROT3(LUN1,LUN2,NSAM1,NROW1,NSLIC1,MAXDIM,AV1,
     &           IFANGL,ALPH,BETA,GAMA,IFSHIF,SHX,SHY,SHZ)

C          RESET HEADER FOR ALTERATIONS IN STATISTICS
           CALL SETPRMB(BUF,LUN2,NSAM1,IDUM, 0.0,0.0,0.0,'U')
           GOTO 9000

        ELSEIF (FCHAR(4:5) .EQ. 'SQ') THEN
C          OPERATION -------- ROTATE & SCALE ------------------- 'RT SQ'
           CALL ROTQS(MAXDIM,LUN1,LUN2,LUN3,FILNAM,FILNAMO,
     &                NSAM1,NROW1,NSLIC1,MAXIM1,IRTFLG)
           GOTO 9000

        ENDIF

C       OPERATION -------- ROTATE --------------------------------- 'RT'
C       OPERATION -------- ROTATE USE MIN AS BACK. -------------- 'RT M'
C       OPERATION -------- ROTATE SPECIFY BACK ------------------ 'RT B'
C       OPERATION -------- ROTATE AROUND ARBITRARY CENTER  ------ 'RT C'

        CALL RDPRM(THETA,NLOOP,ILOOP,'ROTATION ANGLE')
        TH = THETA * DATAN(1.0D0) / 45.0D0
        IF (FCHAR(4:4) .NE. 'B') THEN
C          BACKGROUND IS INPUT IMAGE AVERAGE,
C          EXCEPT FOR "RT M" WHERE BACKGROUND IS MINIMUM
           IF (IMAMI1 .NE. 1)
     &        CALL NORM3(LUN1,NSAM1,NROW1,NSLIC1,FMAX1,FMIN1,AV1)
           IF (FCHAR(4:4) .EQ. 'M') AV1 = FMIN1
        ELSE
C          FOR "RT B" MUST SUPPLY BACKGROUND
           CALL RDPRM(AV1,NLOOP,ILOOP,'ENTER BACKGROUND')
        END IF

C       SET ROTATION CENTER
        SHX = 0.0
        SHY = 0.0
        IF (FCHAR(4:4) .EQ. 'C') THEN
C          ROTATE AROUND AN ARBITRARY CENTER 
           IF (NSAM1*(1+NROW1) .GT. MAXDIM) THEN
              CALL ERRT (101,
     &           'VARIABLE CENTER NOT AVAILABLE FOR THIS SIZE IMAGE',NE)
              GOTO 9000
           ENDIF
           CALL RDPRM(SHX,NLOOP,ILOOP,'X-SHIFT')
           CALL RDPRM(SHY,NLOOP,ILOOP,'Y-SHIFT')
        ENDIF

C       CAN DO A IMAGE OR A VOLUME
        DO  ISLICE = 1, NSLIC1
            NROWS = (ISLICE-1)*NROW1+1
            NROWE = NROWS + NROW1 - 1
            IF (NSAM1*(1+NROW1) .GT. MAXDIM) THEN
C              SLICE DOES NOT FIT IN-CORE, ROTATE ANYWAY
               CALL ROT(LUN1,LUN2,NSAM1,NROWS,NROWE,MAXDIM,TH,AV1)
            ELSE
C              SLICE FITS IN-CORE, ROTATE SLICE IN-CORE
               CALL ROT32(LUN1,LUN2,NSAM1,NROWS,NROWE,1,MAXDIM, 
     &                 TH,AV1,SHX,SHY)
           ENDIF
        END DO

C       SET HEADER FOR ALTERATIONS IN IMAGE DUE TO OPERATIONS
        CALL SETPRMB(BUF,LUN2,NSAM1,IDUM,0.0,0.0,0.0,'U')
        GOTO 9000
            
C       OPERATION ------------------------------------------------ 'BC'

4	CALL OPFIL(.TRUE.,FILNAM,LUN1,'O',NSAM1,NROW1,NSLIC1,
     & 		   MAXIM1,'INPUT',.FALSE.,IRTFLG)
	IF (IRTFLG .NE. 0) GOTO 9000

        IMAMI1 = IMAMI
        AV1    = AV

C       OPEN AN OUTPUT FILE WITH DIMENSIONS SAME AS INPUT FILE
        CALL OPFIL(.TRUE.,FILNAM,LUN2,'U',NSAM1,NROW1,NSLIC1,
     &  	   MAXIM2,'OUTPUT',.TRUE.,IRTFLG)
	IF (IRTFLG .NE. 0) GOTO 9000

C       BOX CONVOLUTION
        IMAMI = IMAMI1
        AV    = AV1
        CALL BOXX(LUN1,LUN2,NSAM1,NROW1,NSLIC1,MAXDIM)

C       SET HEADER FOR ALTERATIONS IN IMAGE DUE TO OPERATION
        CALL  SETPRMB(BUF,LUN2,NSAM1,IDUM,0.0,0.0,0.0,'U')
        GOTO 9000
                                
C       OPERATION ----------------- CONCATENATE -------------------'CT'

5       WRITE(NOUT,*) ' OPERATION "CT" NO LONGER SUPPORTED'
        GOTO 9000

C       OPERATION -------- ORIENTATIONAL SEARCH ------------------- 'OR'
6       IF (FCHAR(4:4) .EQ. '2') THEN
C          OPERATION -------- ORIENTATIONAL SEARCH -------------- 'OR 2'
C          OPERATION -------- ORIENTATIONAL SEARCH -------------- 'OR 2M'
           CALL  ORMD(MAXDIM)
           GOTO  9911
        ELSEIF (FCHAR(4:5) .EQ. '3Q')  THEN
C           OPERATION ------------------------------------------- 'OR 3Q'
           CALL QALI(MAXDIM,'Q')
           GOTO 9911
        ELSEIF (FCHAR(4:5) .EQ. '3A')  THEN
C           OPERATION ------------------------------------------- 'OR 3A'
           CALL QALI(MAXDIM,'A')
           GOTO 9911
        END IF
        GOTO 9911

C       OPERATION ------------------------------------------------- 'FC'

7	CALL OPFIL(.TRUE.,FILNAM,LUN1,'O',NSAM1,NROW1,NSLIC1,
     & 		   MAXIM1,'INPUT',.FALSE.,IRTFLG)
	IF (IRTFLG .NE. 0) GOTO 9000

        IF (NSLIC1 .NE. 1) THEN
C          DOES NOT WORK ON 3-D FILES
           CALL ERRT(2,'UTIL3',NE)
           GOTO 9000
        END IF

        FMAX1  = FMAX
        FMIN1  = FMIN
        IMAMI1 = IMAMI

C       OPEN AN OUTPUT FILE WITH SAME DIMENSIONS AS INPUT FILE
        CALL OPFIL(.TRUE.,FILNAM,LUN2,'U',NSAM1,NROW1,NSLIC1,
     &  	   MAXIM2,'OUTPUT',.TRUE.,IRTFLG)
	IF (IRTFLG .NE. 0) GOTO 9000

C       FILE CONTOUR
        FMAX  = FMAX1
        FMIN  = FMIN1
        IMAMI = IMAMI1
        CALL CNTRFL(LUN1,LUN2,NSAM1,NROW1,NSLIC1,MAXDIM)

C       SOME OPTIONS REQUIRE RESCALING (AL 28 JAN 92)
        CALL SETPRMB(BUF,LUN2,NSAM1,NROW1,0.0,0.0,0.0,'U')
        GOTO 9000

C       OPERATION ----------------------- SLICE --------------------'SL'

8       CALL SLICE(MAXDIM,LUN1,LUN2,LUN3)
        GOTO 9000
     
C       OPERATION --------- ROTATIONAL AVERAGE ---------------------'RO'

9	CALL OPFIL(.TRUE.,FILNAM,LUN1,'O',NSAM1,NROW1,NSLIC1,
     & 		   MAXIM1,'INPUT1',.FALSE.,IRTFLG)
	IF (IRTFLG .NE. 0) GOTO 9000

        IF (FCHAR(4:4) .EQ. 'I' .AND. NSLIC1 .NE. 1) THEN
C          OPERATION DOES NOT WORK ON 3-D FILES
           CALL ERRT(2,'UTIL3',NE)
           GOTO 9000
	ENDIF

C       OPEN AN OUTPUT FILE 
        NSAM2  = NSAM1
        NROW2  = NROW1
        NSLIC2 = NSLIC1
        IF (FCHAR(4:4) .NE. 'I') THEN
	   IF (NSLIC2 .EQ. 1)THEN
              NSAM2 = MIN0(NSAM1/2,NROW1/2)
	   ELSE
              NSAM2 = MIN0(NSAM1/2,NROW1/2,NSLIC1/2)
	   ENDIF
           NROW2  = 1
	   NSLIC2 = 1
        ENDIF
	IFORM = 1
        CALL OPFIL(.TRUE.,FILNAM,LUN2,'U',NSAM2,NROW2,NSLIC2,
     &  	   MAXIM2,'OUTPUT',.TRUE.,IRTFLG)
	IF (IRTFLG .NE. 0) GOTO 9000

C       ROTATIONAL AVERAGING
        IF (FCHAR(4:4) .EQ. 'I') THEN
           CALL RADAVI(LUN1,LUN2,NSAM1,NROW1,MAXDIM)
        ELSE
           CALL RADAV(LUN1,LUN2,NSAM1,NROW1,NSLIC1,MAXDIM)
        ENDIF
        GOTO 9000

C       OPERATION ----------- OPTICAL DENSITY --------------------- 'OD'
C       OD CONVERSION

10	CALL OPFIL(.TRUE.,FILNAM,LUN1,'O',NSAM1,NROW1,NSLIC1,
     & 		   MAXIM1,'INPUT1',.FALSE.,IRTFLG)
	IF (IRTFLG .NE. 0) GOTO 9000

        IF (NSLIC1 .NE. 1) THEN
C          DOES NOT WORK ON 3-D FILES
           CALL ERRT(2,'UTIL3',NE)
           GOTO 9000
        END IF

C       OPEN AN OUTPUT FILE WITH DIMENSIONS SAME AS INPUT FILE
        CALL OPFIL(.TRUE.,FILNAM,LUN2,'U',NSAM1,NROW1,NSLIC1,
     &  	   MAXIM2,'OUTPUT',.TRUE.,IRTFLG)
	IF (IRTFLG .NE. 0) GOTO 9000

        CALL OD(LUN1,LUN2,LUN3,NSAM1,NROW1,MAXDIM)
        GOTO 9000

11      IF (FCHAR(4:5) .EQ. '3')  THEN
C          OPERATION ----------- MARKER ------------------------- 'MK 3'
           CALL MRK3(MAXDIM)
        ELSEIF (FCHAR(4:6) .EQ. 'RT')  THEN
C          OPERATION ----------- MARKER ------------------------ 'MK RT'
           CALL MRRT(MAXDIM)
	ELSE
C          OPERATION ----------- MARKER --------------------------- 'MK'
	   CALL  MRK(MAXDIM)
	ENDIF
        GOTO  9911

C       OPERATION ----------- TRANSFORMATION --------------------- 'AF'
12      CONTINUE
C COPIED FROM RTSQ
        CALL OPFIL(.TRUE.,FILNAM,LUN1,'O',NSAM1,NROW1,NSLIC1,
     &             MAXIM1,'INPUT',.FALSE.,IRTFLG)
        IF (IRTFLG .NE. 0) GOTO 9000
C       OPEN AN OUTPUT FILE WITH SAME DIMENSIONS AS INPUT FILE
        IF (MAXIM1 .GE. 0)  MAXIM2 = 1 
        CALL OPFIL(.TRUE.,FILNAMO,LUN2,'U',NSAM1,NROW1,NSLIC1,
     &             MAXIM2,'OUTPUT',.TRUE.,IRTFLG)
        IF (IRTFLG .NE. 0) GOTO 9000
	CALL AF(MAXDIM,LUN1,LUN2,LUN3,FILNAM,FILNAMO,
     &                 NSAM1,NROW1,NSLIC1,MAXIM1,IRTFLG)
	GOTO 9000

9000    CLOSE(LUN1)
        CLOSE(LUN2)
        CLOSE(LUN3)

9911    RETURN
        END


