C++*************************************************************************
C
C  UTIL4.F                                      ADDED IQ SEPT 97 al
C                                
C **************************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK            *
C *  COPYRIGHT (C)1981,1987, WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH 			   *
C **************************************************************************
C
C   UTIL4    DRIVER FOR CERTAIN ROUTINES
C
C--*************************************************************************

        SUBROUTINE UTIL4(MAXDIM)

	INCLUDE 'CMBLOCK.INC'
CNO_SAVE

        COMMON BUF(1)

C       DO NOT CHANGE NUMINLN WITHOUT SEARCH FOR OTHER OCCURANCES!
        PARAMETER       (NUMINLN = 9)
#ifdef SP_NT
        INTEGER         LOCBUF
#else
        INTEGER * 8     LOCBUF
#endif
        COMMON /LUNARC/ LOCBUF(NUMINLN), NWORDBUF(NUMINLN), 
     &                  NSAMBUF(NUMINLN),IRECBUF(NUMINLN),
     &                  LABRECBUF(NUMINLN)

        CHARACTER * 81 FILNAM
        CHARACTER * 1  NULL

        DATA LUN/10/
	NULL=CHAR(0)

        IF (FCHAR(1:2) .EQ. 'AP')  THEN
C          OPERATION AP -------------------------------------------- AP

           IF (FCHAR(4:5) .EQ. 'RA')  THEN
              CALL FALB(MAXDIM)

           ELSEIF (FCHAR(4:5).EQ. 'SA')  THEN
              CALL SAQB(MAXDIM)

           ELSEIF(FCHAR(4:5) .EQ. 'SR')  THEN
              CALL GALI(MAXDIM)

           ELSEIF(FCHAR(4:5) .EQ. 'MD')  THEN
              CALL DSFS(MAXDIM)

           ELSEIF(FCHAR(4:5) .EQ. 'CA')  THEN
              CALL HALI(MAXDIM)

           ELSEIF(FCHAR(4:5) .EQ. 'MR')  THEN
             CALL MRALI(MAXDIM)

           ELSEIF(FCHAR(4:5) .EQ. 'MQ')  THEN
             CALL MRQLI(MAXDIM)
           ENDIF

        ELSEIF(FCHAR(1:2) .EQ. 'HF')  THEN
C          OPERATION HF -------------------------------------------- HF
           CALL HF

        ELSEIF(FCHAR(1:2) .EQ. 'AT')  THEN
C	   AUTOMATIC PARTICULE PICKING.----------------------------- AT
           IF (FCHAR(4:5) .EQ. 'IT')  THEN
	      CALL ATIT

	   ELSEIF(FCHAR(4:5) .EQ. 'PK')  THEN
	      CALL ATPK(MAXDIM)

	   ELSEIF(FCHAR(4:5) .EQ. 'SA')  THEN
	      CALL ATSA(MAXDIM)

	   ELSEIF(FCHAR(4:5) .EQ. 'WN')  THEN
	      CALL ATWN(MAXDIM)
	   ENDIF

        ELSEIF(FCHAR(1:2) .EQ. 'MS')  THEN
C	   MAKE AN INLINE STACK ------------------------------------ MS

C          SOLICIT FILE NAME
10         CALL FILERD(FILNAM,NLET,NULL,'NEW INLINE STACK',IRTFLG)
           IF (IRTFLG .NE. 0) RETURN

           IF (FILNAM(1:1) .NE. '_') THEN
              CALL ERRT(101,'NOT AN INLINE STACK',NE)
              RETURN
           ENDIF
           FILNAM(4:4) = CHAR(0)
          
20         CALL RDPRI3S(NSAM,NROW,NSLICE,NLOOP,ILOOP,
     &                  'ENTER NSAM, NROW & NSLICE',IRTFLG)
           IF (IRTFLG .EQ. -1) GOTO 10

           CALL RDPRIS(NIMAGE,IDUM,NLOOP,ILOOP,
     &                  'ENTER NUMBER OF IMAGES',IRTFLG)
           IF (IRTFLG .EQ. -1) GOTO 20

C          OPEN INLINE STACK, FOURIER NOT ALLOWED 
           ITYPE = 1
           IF (NSLICE .GT. 1) ITYPE = 3

C          FIND INLINED BUFFER NUMBER          
           CALL INLNBUF(FILNAM,NLET,NUMBUF,IRTFLG)

           IF  (NSAMBUF(NUMBUF) .GT. 0) THEN
C             FREE UP CURRENT INLINE BUFFER (DEALLOCATES IF NECESSARY)
              CALL OPENINLN(10,NUMBUF,.TRUE.,0,0,.TRUE.,IRTFLG)

              IF (N_VERBOSE .EQ. 1 .AND. IRTFLG .EQ. 0)
     &           WRITE(NOUT,*) 'DELETED INLINE FILE: ',FILNAM(1:NLET)
           ENDIF

           CALL OPENINSTK(BUF,FILNAM,LUN,NSAM,NROW,NSLICE,NIMAGE,
     &                       ITYPE,'N',NF)
           IFORM = ITYPE

        ELSEIF(FCHAR(1:2) .EQ. 'IQ')  THEN
C	   INQUIRE SOMETHING -------------------------------------- IQ
           IF (FCHAR(4:5) .EQ. 'FI')  THEN
	      CALL INQUIREIF()
           ELSE IF (FCHAR(4:6) .EQ. 'REG')  THEN
	      CALL INQUIREREG(.TRUE.,.TRUE.,IRTFLG)
           ELSE
C             UNKNOWN OPTION
              CALL ERRT(23,'UTIL4',NE)
           ENDIF
        ENDIF

        RETURN
	END

