#ifdef SP_F90

       SUBROUTINE VAX32U

       COMMON /UNITS/LUNC,NIN,NOUT

       WRITE(NOUT,*) 'DUMMY CALL: vax32u'
       RETURN
       END
#else
 
 
#ifdef SP_VMS 
 
C   THIS ROUTINE SPECIFIC TO UNIX SPIDER AND IS NOT 
C       USED AT VAX SITES
 
       SUBROUTINE vax32u
 
       COMMON /UNITS/LUNC,NIN,NOUT
 
       WRITE(NOUT,*) 'DUMMY CALL: vax32u'
       RETURN
       END
 
#else
#ifdef SP_SUN4 
 
C   THIS ROUTINE NOT AVAILABLE AT SUN SITES
 
       SUBROUTINE vax32u
 
       COMMON /UNITS/LUNC,NIN,NOUT
 
       WRITE(NOUT,*) 'DUMMY CALL: vax32u'
       RETURN
       END
#else
 
C++************************************************************************
C
C  VAX32U.FOR  --  JUL 93 al
C
C **************************************************************************
C *  COPYRIGHT (C)1989       WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH 			   *
C **************************************************************************
C
C    VAX32U(FVAL)
C
C    PURPOSE:  QUICKLY CONVERT A VAX FLOATING POINT NUMBER TO A UNIX 
C              FLOATING POINT NUMBER.  THIS SUBROUTINE IS MEANT TO BE
C              RUN ON A UNIX SYSTEM (NOT ON A VAX!)
C
C    PARAMETERS:   IVAL       FLOATING POINT NUMBER!!!
C
C    NOTES:        IVALIN     --  --  --  --
C                  LVALIN      1   2   3   4
C                             IN1 IN2 IN3 IN4
C
C
C                  IVALOUT    --  --  --  --
C                  LVALOUT     1   2   3   4
C                  I2         -----1
C
C **************************************************************************

      SUBROUTINE VAX32U(IVAL)

      LOGICAL * 1  IO1,IO2,IO3,IO4,IN1,IN2,IN3,IN4,LVALIN(4),LVALOUT(4)

      INTEGER * 2  I2

      INTEGER * 4  IVALIN,IVAL,IVALOUT
      EQUIVALENCE                 (LVALIN,IVALIN),(LVALOUT,IVALOUT)
      
      EQUIVALENCE  (IN1,LVALIN(1)), (IN2,LVALIN(2)), (IN3,LVALIN(3)),
     &             (IN4,LVALIN(4))
      EQUIVALENCE  (IO1,LVALOUT(1)),(IO2,LVALOUT(2)),(IO3,LVALOUT(3)),
     &             (IO4,LVALOUT(4))
      EQUIVALENCE  (I2,IVALOUT)
     
      IVALIN = IVAL

C     CHANGE THE EXPONENT TO EXCESS 127 NOTATION FOR UNIX

C     FLIP THE BYTES IN EACH OF THE WORDS
      IO1 = IN2
      IO2 = IN1
      IO3 = IN4
      IO4 = IN3

C     32640 = 0111 1111 1000 0000
C     256 = 0000 0001 0000 0000

      IF (IAND(I2,32640) .NE. 0)  I2 = I2 - 256

      IVAL =  IVALOUT

      RETURN
      END
   
#endif 
#endif
#endif
