
C
C  PROGRAM TO TRANSFORM VECTORS 
C  INPUT IS EXPECTED IN THE FIRST TWO REGISTERS,
C  OUTPUT IN THE SECOND PAIR.
C
C   ROUT=-OFF2+STR*{ON+(D(-1))*(SQE)*(D)*(RIN+ROFF1-OO)}
C        ___     .   .       .     .   ^   STEP1    ^
C        .       .   .       .     ^     STEP2      ^
C        .       .   .       ^        STEP3         ^
C        .       .   ^          STEP4               ^
C        .       ^          STEP5                   ^
C        <              STEP6                       >
C 
C   VECTORS:
C      RIN    INPUT VECTOR (REGISTER 1 AND 2)
C      ROFF1  OFFSET OF INPUT VECTOR
C      OO     ORIGIN OF INPUT COORDINATE SYSTEM
C      ON     ORIGIN OF OUTPUT COORDINATE SYSTEM (ON EQIV.SIZE AS INPUT)
C      OFF2   OFFSET OF OUTPUT VECTOR
C  MATRICES:
C      (D)    FIRST ROTATION (BY PHI)
C      (D(-1))SECOND ROTATION (BY -PHI2)
C      (SQE)  MATRIX TO SQUEEZE (OR STRETCH)    
C  SCALARS:
C      STR    STRETCH (OR SQUEEZE) -FACTOR
C          
C-************************************************************************

       SUBROUTINE VECTOP

       INCLUDE 'CMBLOCK.INC' 

       DATA PI/3.14159265/

cML       NSEL(4) = 0
       CALL READPQ(FCHAR)

C  IF NO REGISTERS ARE FOUND GIVE ERROR MESSAGE
cML       IF (NSEL(4) .EQ. 0) GOTO 9999      
       IF( NSEL(1) .EQ. 0 .OR . NSEL(2) .EQ. 0 .OR.
     $     NSEL(3) .EQ. 0 .OR . NSEL(4) .EQ. 0 ) GOTO 9999

       X1=PARAM(NSEL(1))
       Y1=PARAM(NSEL(2))
       CALL RDPRM2(X2,Y2,NLOOP,ILOOP,'X,Y OFFSET IN FIRST PICTURE$')
       CALL RDPRM2(X3,Y3,NLOOP,ILOOP,'X,Y ORIGIN OF FIRST PICTURE$')
       CALL RDPRM2(X4,Y4,NLOOP,ILOOP,'X,Y OFFSET IN SECOND PICTURE$')
       CALL RDPRM2(X5,Y5,NLOOP,ILOOP,'X,Y ORIGIN OF SECOND PICTURE$')
       FXX=1.
       FYY=1.
       CALL RDPRM2(FXX,FYY,NLOOP,ILOOP,'X,Y MULTIPLIER (SQUEEZE)$')
       CALL RDPRM(PHI,NLOOP,ILOOP,'ANGLE PHI OF SQEEZE COORD.SYST$')
       CALL RDPRM(PHI2,NLOOP,ILOOP,'BACK-ROTATION$')
       CALL RDPRM(FFIN,NLOOP,ILOOP,'RESULT VECTOR MULTIPLIER$')
       WRITE(NOUT,4) X1,Y1,X2,Y2,X3,Y3,X4,Y4,X5,Y5,
     $ FXX,FYY,PHI,PHI2,FFIN
4      FORMAT(' ',5F12.4)
       PHIC=PHI/180.*PI
       PHI2C=PHI2/180.*PI
C
C  DA.. IS THE FIRST ROTATION MATRIX
C
       DA11=COS(PHIC)
       DA12=SIN(PHIC)
       DA21=-DA12
       DA22=DA11
C
C  DB.. IS THE SECOND (BACK) ROTATION MATRIX
C
       DB11=COS(PHI2C)
       DB12=-SIN(PHI2C)
       DB21=-DB12
       DB22=DB11
C
       XSTEP1=X1+X2-X3
       YSTEP1=Y1+Y2-Y3
C
       XSTEP2=DA11*XSTEP1+DA12*YSTEP1
       YSTEP2=DA21*XSTEP1+DA22*YSTEP1
C
       XSTEP3=FXX*XSTEP2
       YSTEP3=FYY*YSTEP2
C
       XSTEP4=DB11*XSTEP3+DB12*YSTEP3+X5
       YSTEP4=DB21*XSTEP3+DB22*YSTEP3+Y5
C
       XSTEP5=FFIN*XSTEP4
       YSTEP5=FFIN*YSTEP4
C
       XRESU=XSTEP5-X4
       YRESU=YSTEP5-Y4
C
       WRITE(NOUT,1) X1,Y1,XRESU,YRESU
1      FORMAT(' INPUT VECTOR: (',F12.4,',',F12.4,')',
     $ 5X,'OUTPUT VECTOR: (',F12.4,',',F12.4,')')
       WRITE(NOUT,3) XSTEP1,YSTEP1,XSTEP2,YSTEP2,XSTEP3,YSTEP3
     $ ,XSTEP4,YSTEP4,XSTEP5,YSTEP5,XRESU,YRESU
3      FORMAT(' ',2F12.4)

       PARAM(NSEL(3))=XRESU
       PARAM(NSEL(4))=YRESU

       GOTO 2
9999   CALL ERRT(14,'VECTOP',NE)
2      RETURN
       END        
