
C++************************************************ 6/23/80 2/20/81 VAX
C
C VTIL2.FOR                  FILENAMES LENGTHENED            JAN 89 al
C	                     CHANGED BY MAHIEDDINE LADJADJ   4/93
C                            CHANGED BY JING SU              8/31/93
C
C **********************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.    AUTHOR: J.FRANK      *
C *  COPYRIGHT (C)1985, 1996 HEALTH RESEARCH INCORPORATED, ALBANY, NY. *
C * THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO HEALTH            *
C * RESEARCH INC. AND ARE NOT TO BE DISCLOSED TO OTHERS OR USED        *
C * FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF       *
C * HEALTH RESEARCH INC.                                               *
C **********************************************************************
C
C  VTIL2
C
C23456789012345678901234567890123456789012345678901234567890123456789012
C--*********************************************************************

        SUBROUTINE VTIL2(MAXDIM)

CNO_SAVE
	INCLUDE 'CMBLOCK.INC'

	PARAMETER      (MAXSAM = 4096)
        COMMON /COMMUN/FILNAM,FIL
        COMMON         BUF(MAXSAM + 1)

        CHARACTER *81  FILNAM,FIL
        CHARACTER *27  FUNC
        CHARACTER *1   NULL

	DATA FUNC/'PS SK CS PJ BP DC DR MF '/

        NULL   = CHAR(0)
	LUN1   = 8            
	LUN2   = 9
        LUN3   = 10
        LUN4   = 11
	LUND   = 7
        MAXIM  = 0
        MAXIM2 = 0

        IFUNC  = 0
        IF (INDEX(FUNC,FCHAR(1:2)) .GT. 0) 
     &      IFUNC = (INDEX(FUNC,FCHAR(1:2)) / 3) + 1
        IF (IFUNC .LE. 0) RETURN

        CALL CHKINPQ('3,3T,SU,ST,SHAD,INTER,AT,CYL,3E,3Q,COL,STP$'
     $               ,FCHAR(4:),ICALL1)  
        CALL CHKINPQ(
     $	'3,WX,WY,XY,GW3D,3S,GW,B,3E,GW3,W2,RP,CTF,R2,S2,3D,LOCAL$'
     $  ,FCHAR(4:),ICALL2)
      
        GOTO (1,2,3,4,5,6,7,9), IFUNC

C-----------------------------------------------------------------   PS
C       PICK SLICE
1       IF (FCHAR(4:4) .EQ. 'A') THEN

C         ARBITRARY DIRECTION OF SLICING
          CALL CSLICE
        ELSE
	  CALL OPFIL(.TRUE.,FILNAM,LUN1,'O',NSAM1,NROW1,NSLICE,
     &  	     MAXIM,'INPUT',.FALSE.,IRTFLG)
	  IF (IRTFLG .NE. 0) GOTO 9999
          IF (IFORM .NE. 3) GOTO 9300
          FMIN1 = FMIN
          FMAX1 = FMAX
          AV1   = AV
          SIG1  = SIG
          IFORM = 1
          IF (FCHAR(4:4) .EQ. 'Z') THEN

C           WANT Z SLICE
	    CALL OPFIL(.TRUE.,FILNAM,LUN2,'U',NSAM1,NROW1,1,
     &  	       MAXIM2,'OUTPUT',.FALSE.,IRTFLG)
	    IF (IRTFLG .NE. 0) GOTO 9999
            CALL PICKSL(LUN1,LUN2,NSAM1,NROW1,NSLICE)
            NSAM = NSAM1
          ELSE

C           WANT X OR Y SLICE
            NSAM = NSAM1
            IF (FCHAR(4:4) .EQ. 'X') NSAM = NROW1
	    CALL OPFIL(.TRUE.,FILNAM,LUN2,'U',NSAM,NSLICE,1,
     &                 MAXIM2,'OUTPUT',.FALSE.,IRTFLG)
            CALL PICKSV(LUN1,LUN2,NSAM1,NROW1,NSLICE)
          ENDIF
          IF (FCHAR(5:5) .EQ. 'N') THEN
C            KEEP FMIN AND FMAX SAME FOR ALL SLICES
             WRITE(NOUT,*) ' SETTING FMIN & FMAX:',FMIN1,FMAX1
             SIG = SIG1
             CALL SETPRM(LUN2,NSAM,IDUM,FMAX1,FMIN1,AV1,'U')
          ENDIF
        ENDIF
        GOTO 9999

C-----------------------------------------------------------------   SK
C       STACK SLICES
2       CALL STACK(LUN1,LUN2,FCHAR(4:))
	GOTO 9999

C-----------------------------------------------------------------   CS
C       ARBITRARY DIRECTION OF SLICING (SAME AS "PS A")
3       CALL CSLICE
        GOTO 400

C-----------------------------------------------------------------   PJ
C       MOST "PJ" ROUTINES OPEN THEIR OWN FILES
4       IF (ICALL1 .GT. 1 .AND. ICALL1 .NE. 9) GOTO 400
                                
C	OPEN FIRST INPUT FILE 
	CALL OPFIL(.TRUE.,FILNAM,LUN1,'O',NSAM1,NROW1,NSLICE1,
     &  	   MAXIM,'INPUT',.FALSE.,IRTFLG)
	IF (IRTFLG .NE. 0) GOTO 9999

C	PROJECTION
400     GOTO  (410,800,810,950,960,965,966,967,968,969,962,963,961)
     $         ,ICALL1

410     WRITE(NOUT,*) '*** PRJCT NO LONGER IN USE '
	GOTO 9999

C       3-D PROJECTIONS
800     CALL PROJ3(LUN1,LUN2,MAXDIM,IER,.FALSE.)
	IF (IER.NE.0) GOTO 9900
	GOTO 9999

C       PROJECTION WITH THRESHOLD
810     CALL PROJ3(LUN1,LUN2,MAXDIM,IER,.TRUE.)
	IF (IER.NE.0) GOTO 9900
	GOTO 9999

950     CALL MRSURF
        GOTO 9999

960     CALL MRRSURF
        GOTO 9999

961     WRITE(NOUT,*) '*** MRRSURFPAR UNFINISHED'
C       CALL MRRSURFPAR
        GOTO 9999

965     CALL MRREFL
	GOTO 9999

966     CALL INTERL
        GOTO 9999

967     CALL MRPRREP(LUN1,LUN2,MAXDIM,IER)
        GOTO 9999

C       CYLINDRICAL PROJECTION
968     MAXLEN = MAXDIM - MAXSAM
        IF ((NSLICE1 * NSAM1) .GE. MAXLEN) THEN
          WRITE(NOUT,1999) MAXLEN
1999      FORMAT(' *** NSAM*NSLICE1 > ',I6,' NOT ALLOWED')
          CALL ERRT(31,'VTIL2',IER)
          GOTO 9999
        ENDIF
        CALL MRCP(NSAM1,NROW1,NSLICE1,LUN1,LUN2,LUN3,BUF(1),
     &            BUF(MAXSAM + 1),MAXSAM)
        GOTO 9999

C       PROJECTION WITH 3 ANGLES:
969     CALL PROJ3E(LUN1,LUN2,MAXDIM,IER,.FALSE.)
	IF (IER.NE.0) GOTO 9900
	GOTO 9999

C       FAST PROJECTION WITH 3 ANGLES:
962     CALL PJ3Q(MAXDIM)
	GOTO 9119

963     CALL MRNCOLOR
        GOTO 9999

C-----------------------------------------------------------------   BP
C       MOST "BP" ROUTINES OPEN THEIR OWN FILES
5	IF (ICALL2 .GT. 1) GOTO 500
            
C	OPEN FIRST INPUT FILE 
	CALL OPFIL(.TRUE.,FILNAM,LUN1,'O',NSAM1,NROW1,NSLICE1,
     &  	   MAXIM,'INPUT',.FALSE.,IRTFLG)
	IF (IRTFLG .NE. 0) GOTO 9999

C	OPEN SECOND INPUT FILE 
	CALL OPFIL(.TRUE.,FIL,LUN2,'O',NSAM2,NROW2,NSLICE1,
     &  	   MAXIM2,'INPUT2',.FALSE.,IRTFLG)
	IF (IRTFLG .NE. 0) GOTO 9999

C	BACK PROJECTION
500     GOTO (510,900,970,980,990,995,906,998,999,
     &	      991,997,811,814,824,815,816,817,992) ,ICALL2

510     WRITE(NOUT,*) ' *** PRJCT NO LONGER IN USE '
	GOTO 9999

C       3-D BACK PROJECTION
900	CALL BPROJ3(LUN1,LUN2,MAXDIM,IER)
	IF (IER .NE. 0) GOTO 9900
	GOTO 9999

970     CALL WEIGHTC(2,MAXDIM)
        GOTO 9999

980     CALL WEIGHTC(1,MAXDIM)
        GOTO 9999

990     CALL BAPI(1)
        GOTO 9999

995     CONTINUE
        WRITE(NOUT,*) ' *** BP GW3D NO LONGER IN USE '
        CALL ERRT(100,'VTIL2',NE)
C       CALL GENW3D (SENT TO REJECTS)
        GOTO 9999

906	CALL BPROJ4(LUN1,LUN2,MAXDIM,IER)
	IF (IER .NE. 0) GOTO 9900
	GOTO 9999

998     CALL GENW
        GOTO 9999

999     WRITE(NOUT,*) ' *** MNBPROJ NO LONGER IN USE '
	GOTO 9999

991     CALL BAPI3A(MAXDIM)
        GOTO 9999

997     CALL GENW3E
        GOTO 9999

811	CALL  WGBP2(MAXDIM)
	GOTO  9119

C812	CONTINUE
c	CALL  MEM2(MAXDIM)
C	GOTO  9119

C813	CONTINUE
c	CALL  MEM3(MAXDIM)
C	GOTO  9119

814	CONTINUE
	CALL  REPS(MAXDIM)
	GOTO  9119

824	CONTINUE
C	CALL  REPC(MAXDIM)
	CALL ERRT(41,' BP CTF',NE)
	GOTO  9119

815	CONTINUE
	CALL  BPWR(MAXDIM)
	GOTO  9119

816	CALL  BPS2(MAXDIM)
	GOTO  9119

817	CALL  BCQ(MAXDIM)
	GOTO  9119

992     CONTINUE
C       CALL TDLOCAL(LUN1,LUN2,LUN3)
        WRITE(NOUT,*) ' *** BP LOCAL NO LONGER IN USE '
        CALL ERRT(100,'VTIL2',NE)
        GOTO 9999

C-----------------------------------------------------------------   DC
C	DETERMINE COMMON LINE
6       IF (FCHAR(4:4) .EQ. 'T') THEN
C          THIS PROGRAM IS OBSOLETE (WAS 'DC T').
           WRITE(NOUT,*) ' *** DC T -- NO LONGER IN USE '
        ELSE
           CALL MARKER
        END IF
        GOTO 9999

C-----------------------------------------------------------------   DR
7       CALL CHKINPQ('ERR,DIFF$',FCHAR(4:),KCALL1)
        GOTO (7100,7200,7300) KCALL1

C       PUT DENSITY REFERENCE INTO FILE:
7100    CALL OPFIL(.TRUE.,FILNAM,LUN1,'O',NSAM,NROW,NSLICE,
     &  	   MAXIM,'THREED',.FALSE.,IRTFLG)
        IF (IRTFLG .NE. 0) GOTO 9999

        CALL DENREF(LUN1,NSAM,NROW,NSLICE)
        GOTO 9999

C       CALCULATE ERROR MEASURES BETWEEN 2 VOLUMES:
7200    CALL COMP3D(LUN1,LUN2)
        GOTO 9999

C       CALCULATE ERROR MEASURES BETWEEN 2 VOLUMES WITHIN THE
C       BOUNDARIES OF A MASK, SCALE VOLUMES AND CALCULATE DIFFERENCE VOL

7300    CALL COMP3DMAD(LUN1,LUN2,LUN3,LUN4)
        GOTO 9999



C-----------------------------------------------------------------   MF
C       FIT A SPHERE MODEL TO A 3-D RECONSTRUCTION
9       CONTINUE
        WRITE(NOUT,*) 
     &    ' *** OBSOLETE SUBROUTINE (LUNA OR MATVEC) CALLED'
	GOTO 9999
C-----------------------------------------------------------------  


9300	IER = 2
C	GOTO 9900

9900    CALL ERRT(IER,'VTIL2',NE)

9999	CLOSE(LUN1)
	CLOSE(LUN2)

9119    RETURN
	END
