
C ************************************************ UPDATED NOV 87 al
C                                   LONG FILE NAMES JAN 89 al
C  CALLING PROGRAM FOR THE FILTERING OF PROJECTION FOR THE
C  WEIGHTED BACKPROJECTION METHOD.
C  SEE M.RADERMACHER,W.HOPPE PROC.INT.CONGR.EL.MICR.
C      TORONTO,1980,VOL1,218-219.
C
C ***********************************************************************

      SUBROUTINE WEIGHTC(JJ,MAXDIM)

      INCLUDE 'CMBLOCK.INC'
      INCLUDE 'LABLOCK.INC'

      COMMON ADUM(80),BUF(1024),A0(1)
      COMMON /COMMUN/ FNTD,FNPR,FNPR2,FILPAT,FILDUM,FNPRO,FILPATO

      CHARACTER *81 FNTD,FNPR,FNPR2,FILPAT,FILDUM,FNPRO,FILPATO
      CHARACTER *1  NULL
      DIMENSION     VALUES(4)

      NULL=CHAR(0)

C     GET THE NAMES OF FILES CONTAINING THE PROJECTIONS
C     (THESE FILES ARE OVERWRITTEN BY THE MODIFIED PROJECTIONS)
      CALL FILERD(FNPR,NLETP,NULL,'FIRST PROJECTION',IRTFLG)
      CALL FILERD(FNPR2,NLET,NULL,'LAST PROJECTION',IRTFLG)
      CALL FILCAD(FNPR,FILPAT,N1,IRTFLG)
      CALL FILCAD(FNPR2,FILDUM,N2,IRTFLG)

      CALL FILERD(FILPATO,NLETO,NULL,'OUTPUT FILE TEMPLATE',IRTFLG)
C FOR SINGLE AXIS TILTING RADIUS 1 SHOULD BE USED:
201   CALL RDPRMI(ISTART,IDUM,NLOOP,ILOOP,'START AT RADIUS 0 OR 1$')
      IF(ISTART.GT.1) THEN
      WRITE(NOUT,*) 
     $'PLEASE ENTER EITHER 0 OR 1 THE VALUE YOU ENTERED IS IMPOSSIBLE'
      GOTO 201
      ENDIF

200   CONTINUE

C  LOOP OVER THE PROJECTIONS:
      DO 10 K=N1,N2
        CALL FILGET(FILPAT,FNPR,NLETP,K,IRTFLG)
C OUTPUT FILE:
        CALL FILGET(FILPATO,FNPRO,NLETO,K,IRTFLG)

        IF (IRTFLG .NE. 0) THEN
           CLOSE (10)
           RETURN
        ENDIF

300     CALL OPENF(FNPR,11,NSAM,NROW,'OLD',NF,NDUM)
        IF (NF.NE.2) THEN
49        WRITE (NOUT,50) (FNPR(I:I),I=1,10)
50        FORMAT(' ***',10A1,' DOES NOT EXIST, OR ARRAY NOT REAL')
          GOTO 10
        ENDIF 

C       CHECK LABEL OF PROJECTION FILE (FILE HAS TO BE TYPE REAL)
        IF (IFORM .LT. 0) GOTO 49
C       CHECK CORE SPACE
        IF (NSAM*(NROW+2).GT.MAXDIM) THEN
        WRITE(NOUT,*) 'NOT ENOUGHT MEMORY, TRY BATCH JOB'
        RETURN
        ENDIF
C       LOAD THE WHOLE FILE IN CORE BECAUSE WEIGTHF CONTAINS AN IN CORE FFT
        DO  J=1,NROW
          CALL REDLIN(11,BUF,NSAM,J)
          IND=(J-1)*NSAM
          DO  J1=1,NSAM
            INDI=IND+J1
            A0(INDI)=BUF(J1)
	  ENDDO
C         IF(K.EQ.N1)WRITE(NDAT,33) J
33        FORMAT(' J=',I3)
C         IF(K.EQ.N1)WRITE(NDAT,70) (BUF(I),I=1,NSAM)
70        FORMAT(' ',32F4.0)
	ENDDO

C       IF(K.EQ.N1)WRITE(NDAT,70) (A0(I),I=1,NSAM)
        IEND=2*NSAM
C       IF(K.EQ.N1)WRITE(NDAT,70) (A0(I),I=NSAM+1,IEND)
        CLOSE (11)
C       MULTIPLY THE FOURIER TRANSFORM OF THE PROJECTION BY R*
        CALL WEIGHTF(A0,NSAM,NROW,JJ,ISTART)

C       PLACE ANGLES IN NEW FILE
        VALUES(1) = IANGLE
        VALUES(2) = PHI
        VALUES(3) = THETA
        VALUES(4) = PSI
        NOPRNT    = -1

C       WRITE THE RESULTS BACK ONTO DISK (OVERWRITING THE ORIGINAL FILE)
        CALL OPENF(FNPRO,11,NSAM,NROW,'UNKNOWN',NF,1)
        CALL SETLAB(11,NSAM,BUF,14,4,VALUES,'U',NOPRNT)
        DO  J=1,NROW
          IND=(J-1)*NSAM
          DO  J1=1,NSAM
            INDI=IND+J1
            BUF(J1)=A0(INDI)
	  ENDDO
C         IF(K.EQ.N1)WRITE(NDAT,33)J
C         IF(K.EQ.N1)WRITE(NDAT,70) (BUF(I),I=1,NSAM)
          CALL WRTLIN(11,BUF,NSAM,J)
	ENDDO
C       IF(K.EQ.N1)WRITE(NDAT,70) (A0(I),I=1,NSAM)
C       IF(K.EQ.N1)WRITE(NDAT,70) (A0(I),I=NSAM+1,IEND)
        CLOSE(11)
        CALL FILCAD(FNPR,FILDUM,NC,IRTFLG)
        WRITE(NOUT,30) (FNPR(I:I),I=1,10)
30      FORMAT(' PROJECTION ',10A1,' SUCCESSFULLY WEIGHTED')
        IF(JJ.EQ.2) WRITE (NOUT,31)
31      FORMAT(' ',21X,' IN X-DIRECTION')
        IF(JJ.EQ.1) WRITE (NOUT,32)
32      FORMAT(' ',21X,' IN Y-DIRECTION')
C       WEIGHT NEXT PROJECTION
10    CONTINUE
      RETURN
      END

