	SUBROUTINE WGBP2(MAXMEM)
C
c  UNIX-Spider version
C  Weighted back-projection with Parzen filter.
c  reconstruction kept in the square
c  Reconstruction from nrowl to nrowh.
c  Average outside the window is subtracted
c  Geometry  cylindrical
c  Simplified version
C                01/04/94
C
C  NILMXX IS USED IN reprwb.f,bps2.f,bprj2.f,prjs2.f  !!!
#ifdef SP_MP
	PARAMETER  (NILMAX=25,NILMXX=560)
#else
	PARAMETER  (NILMAX=93,NILMXX=560)
#endif
        INCLUDE 'CMBLOCK.INC' 
	COMMON  /F_SPEC/  FINPAT,FINPIC,NLET
	CHARACTER*80  FINPIC,finfo
	CHARACTER*80  FINPAT
	CHARACTER*1  NULL
	COMMON     DUMMY(80),BUF(1024),ILIST(NILMXX),
     A    NSAM,NROW,INANG,NN,NMAT,
     1	  LTB,LTBN,K_ANG,K_DM,K_LB,K_MAP,K_IPCUBE,
     2	  K_BCKE,K_PROJ,K_bckn,K_PRJE,K_SIGMA,
     3    KDM(7),
     4	  IUNIT,Q(1)
	COMMON /PAR/  LDPX,LDPY,LDPZ,LDPNMX,LDPNMY
	LOGICAL OPENED
C
        DATA  INPIC/100/,IOFF/6/
CNO_SAVE
c
	NULL=CHAR(0)
C
C  N - linear dimension of projections and restored cube
C  NANG - number of angles (projections)
C
        write(nout,*)  ' Single-tilt 3D-WB reconstruction program'
	IUNIT=NOUT
 	CALL  FILERD(FINPAT,NLET,NULL,
     &	  'Enter template for 2-D image name',IRTFLG)
	CALL  FILERD(FINPic,NLETI,NULL,'Selection doc',IRTFLG)
	k=0
	k2=1
	NANG=0
778	LERR=-1
	IF(NANG.eq.NILMXX)  THEN
		WRITE(NOUT,*) '  Too many images, list truncated'
		goto  779
	endif
	KP1=K+1
	CALL  UNSAV(FINPIC,K,INPIC,KP1,Q,1,LERR,K2)
	IF(LERR.EQ.0)  THEN
	NANG=NANG+1
	ILIST(NANG)=Q(1)
	K=K+1
	GOTO  778
	ENDIF
779	CLOSE(INPIC)
c
C  NANG - total number of images
c
	write(nout,2001) nang
2001	format('  Number of images =',i5)
c
c get the angles
c
 	K_ANG=1
 	CALL  FILERD(FINPIC,NLETi,NULL,'Angular doc',IRTFLG)
	k2=1
        do  k=0,nang-1
	LERR=-1
	CALL  UNSAV(FINPIC,K,INPIC,ilist(k+1),BUF,2,LERR,K2)
	IF(LERR.EQ.0)  THEN
	Q(K_ANG+k)=BUF(2)
        else
           write(nout,*)  ' Something wrong in the angular doc file'
           close(inpic)
           return
        ENDIF
	enddo
	CLOSE(INPIC)
c
        CALL RDPRMI(iri,nslice,NLOOP,ILOOP,
     &	'Radius of reconstructed object, height of the slice')
        ri=iri
        CALL  RDPRMI(nrowl,nrowh,NLOOP,ILOOP,
     &	'Reconstruction from nrow1 to nrow2')
        CALL  RDPRM2(FM,DUM,NLOOP,ILOOP,
     &		'Frequency cut-off for Parzen filter$')
C
C  Open all the projection files ....
c  only if the number is less than NILMAX
c
	IF(NANG.LE.NILMAX)  THEN
	OPENED=.TRUE.
        KE=NANG
        ELSE
        OPENED=.FALSE.
        KE=1
        ENDIF
	do    k=1,KE
 	CALL  FILGET(FINPAT,FINPIC,NLET,ILIST(k),INTFLG)
 	CALL  OPENFB(BUF,FINPIC,IOFF+K,NSAM,NROW,'O',NF,NSL)
 	IF(NF.NE.2)  THEN
	write(nout,*) ' File not found'
	RETURN
	ENDIF
	enddo
        IF(.NOT.OPENED)  CLOSE(IOFF+1)
c
	if(nrowl.lt.1.or.nrowl.gt.nrow.or.nrowh.lt.1.or.nrowh.gt.nrow
     &		.or.nrowl.gt.nrowh)  then
	nrowl=1
	nrowh=nrow
	endif
	lcyl=nrowh-nrowl+1
C
	MK=1
	M2=0
5	MK=MK*2
	M2=M2+1
	IF(MK.LT.NSAM-1)  GOTO  5
 	MK=MK*2
	M2=M2+1
C
	INANG=NANG
C
	LDPX=NSAM/2+1
	LDPY=NROW/2+1
	LDPZ=NSLICE/2+1
	LDPNMX=NSAM/2+1
	LDPNMY=NROW/2+1
C
 	K_DM=IPALIGN64(K_ANG+NANG)
	K_LB=IPALIGN64(K_DM+9*NANG)
	K_MAP=K_LB
	K_IPCUBE=K_MAP
C
	CALL  PREPSL_2(NSAM,NSLICE,NN,NMAT,Q(K_IPCUBE),RI)
c!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
	nmat=nsam*nslice
C
	K_PROJ=IPALIGN64(K_IPCUBE+5*NN)
C
        K_X=K_PROJ
        K_IBN=K_X
C
	MEMTOT=K_IBN
C	MEMTOT=K_IBN+NANG*N*N
	IF(MEMTOT.GT.MAXMEM)  THEN
	WRITE(NOUT,1001)  MEMTOT
	WRITE(NOUT,1002)  MAXMEM
	GOTO 9999
	ENDIF
C
	CALL  RDPA(NANG,Q(K_ANG),Q(K_DM),NOUT)
	LTB=NSAM*NANG
	LTBN=NSAM*NANG
C
	K_PRJE=IPALIGN64(K_PROJ+MK)
	K_SIGMA=IPALIGN64(K_PRJE+NSAM*NANG)
c ltbn = nsam*nang
	K_BCKE=IPALIGN64(K_sigma+mk)
	k_bckn=k_bcke
        K_CB=K_bcke
	MEMTOT=IPALIGN64(k_bckn+nmat)
	WRITE(NOUT,1001)  MEMTOT
1001	FORMAT(//'  Reprojection program for 3-D back-projection',/,
     1     '           Memory needed - ',I8,/)
	IF(MEMTOT.GT.MAXMEM)  THEN
	WRITE(NOUT,1002)  MAXMEM
1002	FORMAT('  Sorry, your buffer length is only',I9,/,
     1      '  Program cannot be run')
	GOTO 9999
	ENDIF
C
	CALL  FILERD(FINFO,NLETI,NULL,'3-D output',ITRFLG)
	IF(IRTFLG.EQ.-1)  GOTO 9999
	IFORM=3
 	CALL  OPENFB(BUF,FINFO,INPIC,NSAM,LCYL,'UNKNOWN',NF,NSLICE)
	IF(NF.NE.2)  GOTO 9999
C
	CALL REPRWB
     1	  (q(k_bckn),nsam,LCYL,nslice,nrowl,nrowh,nang,
     2     q(k_ipcube),nn,Q(K_PROJ),q(k_sigma),MK,m2,Q(K_PRJE),
     3		FM,iri,ltb,LTBN,inpic,OPENED)
	CLOSE(INPIC)
c 
c close all the projection files ...
c  only if the number is less than NILMAX
c
	IF(NANG.LE.NILMAX)  THEN
	do    k=1,nang
 	  CLOSE(ioff+k)
	enddo
	ENDIF
C
9999	CONTINUE
	END
