
C       REMOVED FROM ATILTAX3.FOR DEC 90 AL
C SUBROUTINE TO DETERMINE DIRECTION OF TILT AXIS BETWEEN TWO MICROGRAPHS.
C L1 LENGTH OF DISTANCES BETWEEN POINTS IN THE UNTILTED IMAGE,
C L2 LENGTH OF DISTANCES BETWEEN POINTS IN THE TILTED IMAGE,
C ICOUNT NUMBER OF LINES
C GAMMA ANGLES BETWEEN THE LINES IN THE UNTILTED IMAGE AND A REFERENCE LINE
C THETA TILT ANGLE
C
C THE FINAL RESULTS IS GIVEN AS THE ANGLE BETWEEN THE REFERENCE LINE AND THE
C TILT AXIS


	SUBROUTINE WINKEL5(IM1,IM2,L1,L2,ICOUNT,GAMMA,THETA,NOUT)

        PARAMETER (IDIS=1000)
        COMMON /ATLTXP/ OUT
        LOGICAL OUT,DFLAG
        CHARACTER *81 DOC0
        CHARACTER *1  NULL
	REAL L1(IDIS),L2(IDIS)
        DIMENSION GAMMA(IDIS),GSTRICH(IDIS),ALPHA(IDIS),C(5)

        NULL=CHAR(0)

	PI=3.14159
C        WRITE(NOUT,15)
15	FORMAT(1X,'L1 (AT 0 DEG),ANGLE TO REF., L2 (AT THETA DEG):'
     $  ,' IM1,IM2,ICOUNT,THETA')
C 	DO 333 K=1,ICOUNT
C333     WRITE(6,11)L1(K),(GAMMA(K)/PI*180.),L2(K),IM1,IM2,ICOUNT,THETA
11	FORMAT(1X,F12.4,2X,F12.4,2X,F12.4,5X,3I5,F12.4)
        ST=SIN(THETA/180.*PI)
        DO 501 KK=1,ICOUNT
        ALPHA(KK)=0.
        GSTRICH(KK)=-10.
        RAT=(L1(KK)*L1(KK)-L2(KK)*L2(KK))/(L1(KK)*L1(KK)*ST*ST)
C        WRITE(6,111)
C        WRITE(6,10) L1(KK),L2(KK),THETA,ST,RAT,ALPHA(KK)
	IF(RAT.GT.1..OR.RAT.LT.0.) GOTO 501
        G=GAMMA(KK)
        ALPHA(KK)=ASIN(SQRT(RAT))*SIGN(1.,G)
111     FORMAT(1H ,//' CALCULATED USING SINE:')
C        WRITE(6,10) L1(KK),L2(KK),THETA,ST,
C     $  RAT,(ALPHA(KK)/PI*180.)
10      FORMAT(1H ,' L1           L2          THETA     SIN(THETA)',
     $  '     RATIO      ALPHA',/
     $  6(F10.4,2X))
        GSTRICH(KK)=GAMMA(KK)-ALPHA(KK)
501     CONTINUE
        IF(OUT) WRITE(NOUT,519) (GAMMA(L)/PI*180.,ALPHA(L)/PI*180.,
     $  GSTRICH(L)/PI*180.,L=1,ICOUNT)
519     FORMAT(1H ,' ANGLE L-REFERENCE, L-AXIS         AXIS-REFERENCE '
     $  /1X,100(3(F12.4,6X)/1X))
C        WRITE(6,510) (GSTRICH(L)/PI*180.,L=1,ICOUNT)
510     FORMAT(1H ,'ANGLES:'/1X,5F12.6/)
        IC2=0
        IOP=0
C
C SAVE SINGLE ANGLES IN DOCUMENT FILE:
C
        DFLAG=.FALSE.
        CALL FILERD(DOC0,NLET,NULL,'DOC0',IRTFLG)
        IF(DOC0(1:1).EQ.'*') DFLAG=.TRUE.
        DO 601 I=1,ICOUNT
        IF(GSTRICH(I).EQ.-10.) GOTO 601
        AN=AN+GSTRICH(I)
        IC2=IC2+1
        IF(DFLAG) GOTO 601
        C(1)=IC2
        C(2)=GSTRICH(I)/PI*180.
        C(3)=ALPHA(I)/PI*180.
        C(4)=GAMMA(I)/PI*180.
        CALL SAVDN1(15,DOC0,C,4,IOP,0)
        IOP=1
601     CONTINUE
        IF(.NOT.DFLAG) CLOSE(15)
        AN=AN/IC2
        CALL CALCERR(GSTRICH,AN,ICOUNT,STDEV,VAR)
	WRITE(NOUT,511) IC2,AN/PI*180.,STDEV/PI*180.
511     FORMAT(1H ,//' TILTAXIS DIRECTION IN UNTILTED IMAGE:'/
     $  ' AVERAGE ANGLE FROM',I4,' MEASUREMENTS:',F10.6,
     $  ' STANDARD DEVIATION: ',F10.6//)
	RETURN
	END

