C++************************************************************************
C
C $$ WPRO.FOR
C
C **************************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK            *
C *  COPYRIGHT (C)1981,1987, WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *  THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR       *
C *  LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR    *
C *  USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF     *
C *  THE CENTER FOR LABORATORIES AND RESEARCH   			   *
C **************************************************************************
C
C
C
C--************************************************************************
C
C $$ WPRO.FOR
C
         SUBROUTINE  WPRO
     1   (B,NSAM,NROW,CUBE,LTB,IPCUBE,NN,PHI,THETA,PSI,RI)
         DIMENSION  B(NSAM,NROW),CUBE(LTB)
         INTEGER   IPCUBE(5,NN)
         DOUBLE PRECISION  CPHI,SPHI,CTHE,STHE,CPSI,SPSI
         DIMENSION  DM(6)
         COMMON /PAR/  LDPX,LDPY,LDPZ
CNO_SAVE
C
C IPCUBE: 1 - beginning
C         2 - end
C         3 - ix
C         4 - iy
C         5 - iz
C
         R=RI*RI
C
         CPHI=DCOSD(DBLE(PHI))
         SPHI=DSIND(DBLE(PHI))
         CTHE=DCOSD(DBLE(THETA))
         STHE=DSIND(DBLE(THETA))
         CPSI=DCOSD(DBLE(PSI))
         SPSI=DSIND(DBLE(PSI))
C
         DM(1)=CPHI*CTHE*CPSI-SPHI*SPSI
         DM(2)=SPHI*CTHE*CPSI+CPHI*SPSI
         DM(3)=-STHE*CPSI
         DM(4)=-CPHI*CTHE*SPSI-SPHI*CPSI
         DM(5)=-SPHI*CTHE*SPSI+CPHI*CPSI
         DM(6)=STHE*SPSI
C        DM(7)=STHE*CPHI
C        DM(8)=STHE*SPHI
C        DM(9)=CTHE
C
         DO    J=1,NROW
         DO    I=1,NSAM
           B(I,J)=0.0
	 ENDDO
	 ENDDO
C
         DO    I=1,NN
         XB=(IPCUBE(3,I)-LDPX)*DM(1)+(IPCUBE(4,I)-LDPY)*DM(2)+
     &   (IPCUBE(5,I)-LDPZ)*DM(3)
         YB=(IPCUBE(3,I)-LDPX)*DM(4)+(IPCUBE(4,I)-LDPY)*DM(5)+
     &   (IPCUBE(5,I)-LDPZ)*DM(6)
         DO    J=IPCUBE(1,I),IPCUBE(2,I)
C
         IQX=IFIX(XB+FLOAT(LDPX))
         IF(IQX.LT.1 .OR. IQX.GE.NSAM)  THEN
C         PRINT  *,'  IQX out of range - reduce the radius!'
         GOTO  2
         ENDIF
         IQY=IFIX(YB+FLOAT(LDPY))
         IF(IQY.LT.1 .OR. IQY.GE.NROW)  THEN
C         PRINT  *,'  IQY out of range - reduce the radius!'
         GOTO  2
         ENDIF
C
         DIPX=XB+LDPX-IQX
         DIPY=YB+LDPY-IQY
         CT=CUBE(J)
         B(IQX,IQY)    =B(IQX,IQY)    +(1.0-DIPX)*(1.0-DIPY)*CT
         B(IQX+1,IQY)  =B(IQX+1,IQY)  +     DIPX *(1.0-DIPY)*CT
         B(IQX,IQY+1)  =B(IQX,IQY+1)  +(1.0-DIPX)*     DIPY *CT
         B(IQX+1,IQY+1)=B(IQX+1,IQY+1)+     DIPX *     DIPY *CT
2        XB=XB+DM(1)
         YB=YB+DM(4)
	 ENDDO
	 ENDDO
         END
