
C++*********************************************************************
C
C WRTHED  -- 
C **********************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK        *
C *  COPYRIGHT (C)1981,1987, WADSWORTH CENTER FOR LABORATORIES AND     *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.  *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS *
C *    OR USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN        *
C *    APPROVAL OF THE CENTER FOR LABORATORIES AND RESEARCH            *
C **********************************************************************
C
C    WRTHED(LUN,BUF,NSAM,IRTFLG) 
C
C    PURPOSE: PUT HEADER RECORDS IN A SPIDER FILE      
C
C    PARAMETERS:  LUN      UNIT NUMBER             (SENT)
C                 BUF      BUFFER                  (SENT)
C                 NSAM     ROW LENGTH              (SENT)
C                 IRTFLG   ERROR FLAG (O = OK)     (RETURNED)    
C
C23456789 123456789 123456789 123456789 123456789 123456789 123456789 12
C--*********************************************************************

	SUBROUTINE WRTHED(LUN,BUF,NSAM,IRTFLG)

        INCLUDE 'CMBLOCK.INC'
CNO_SAVE

        COMMON /LUNARA/ LUNARA(100),LUNSTK(100)

        REAL            BUF(NSAM)
        COMMON /IOERR/  IERR

C       THE NUMBER OF HEADER RECORDS IS IN LUNARA
        LABREC      = LUNARA(LUN)

        IF (LABREC .LE. 0) THEN
C         CALCULATE DEFAULT LABEL RECORD LENGTH
          LENBYT = NSAM * 4
          LABREC = 1024 / LENBYT
          IF (MOD(1024,LENBYT) .NE. 0) LABREC = LABREC + 1
        ENDIF

C       SET NO OFFSET FOR HEADER IN LUNARA
 	LUNARA(LUN) = 0

C       WRITE OUT HEADER RECORDS
        ILOC = 1
        IERR = 0
        DO I = 1,LABREC
           CALL WRTLIN(LUN,BUF(ILOC),NSAM,I)
           IF (IERR .NE. 0) THEN
               WRITE(NOUT,*) '*** ERROR WRITING TO FILE'
               CALL ERRT(100,'WRTHED',NE)
               LUNARA(LUN) = LABREC
               RETURN
            ENDIF
           ILOC = ILOC + NSAM
        ENDDO

C       REPLACE HEADER OFFSET IN LUNARA	    
 	LUNARA(LUN) = LABREC

        IRTFLG = 0

        RETURN
        END
