
C++*********************************************************************
C
C YCC
C
C **************************************************************************
C
C YCC(FILNAM,FILNM1,LUN1,LUN2,NSAM,NROW,MAXDIM)
C
C PURPOSE:  CROSSCORRELATION OF TWO IMAGES ALONG Y-DIRECTION
C          WRITTEN TO ALIGN TILT SERIES OF FIBERS.
C
C PARAMETERS:
C        FILNAM    NAME OF FIRST FILE
C        FILNM1    NAME OF SECOND FILE
C        LUN1      LOGICAL UNIT NUMBER OF FIRST FILE
C        LUN2      LOGICAL UNIT NUMBER OF SECOND FILE
C        NSAM      NUMBER OF SAMPLES
C        NROW      NUMBER OF ROWS
C        MAXDIM    MAXIMUM BUFFER SPACE AVAILABLE
C
C--*********************************************************************

      SUBROUTINE YCC(FILNAM,FILNM1,LUN1,LUN2,NSAM,NROW)

      INCLUDE 'CMBLOCK.INC'
      COMMON ADUM(80),A(20),BUF(20000)

      CHARACTER *(*) FILNAM,FILNM1
      CHARACTER      YN,NULL
      LOGICAL        FFLAG,XFLAG,YFLAG
      INTEGER        H

      NULL=CHAR(0)

      IAD2=NSAM
      IAD3=2*NSAM
      IAD4=IAD3+2*NROW+2
      IFIL=IAD4+2*NROW+2
      XFLAG=.FALSE.
      YFLAG=.FALSE.

C10    CALL RDPRMC(YN,NC,.TRUE.,'CC ALONG X OR Y?:',NULL,IRTFLG)
C      IF (YN.EQ.'X') XFLAG=.TRUE.
C      IF (YN.EQ.'Y') YFLAG=.TRUE.
C      IF(.NOT.(XFLAG.OR.YFLAG)) GOTO 10

      FFLAG = .FALSE.
      CALL RDPRMC(YN,NCHAR,.TRUE.,'FOURIER FILTER (Y/N)'
     & ,NULL,IRTFLG)
      IF (YN .EQ. 'Y') FFLAG = .TRUE.
      IF (.NOT. FFLAG) GOTO 5
      CALL RDPRMI(MANY,IDUM,ILOOP,NLOOP,'# OF FILTRATIONS 1/2')
      IF(MANY.GT.2) MANY=2
      DO 6 I=1,MANY
      CALL RDPRMI(IOPT,IDUM,NLOOP,ILOOP,
     $ '(1)LP/(2)HP/(3)GAUSS LP/(4)GAUSS HP/(5)FERMI LP/(6)FERMI HP')
      CALL RDPRM(PARM1,NLOOP,ILOOP,'FILTER RADIUS')
      GOTO(100,200,300,400,500,500),IOPT
100   R2 = PARM1
      DO  H = 1,NROW+1
      BUF(IFIL+H+1)=1.
      IF(H.GT.R2) BUF(IFIL+H+1)=0.
      ENDDO
      BUF(IFIL+1)=1.
      GOTO 6

200   R2 = PARM1
      DO  H = 1,NROW+1
      BUF(1+IFIL+H)=1.
      IF(H.LE.R2) BUF(1+IFIL+H)=0.
      ENDDO
      BUF(IFIL+1)=1.
      GOTO 6

300   F1 = -1./(PARM1**2)
      DO  H =1,NROW+1
	FH2=FLOAT(H)**2
320	BUF(1+IFIL+H)=EXP(F1*FH2)
      ENDDO
      BUF(IFIL+1)=1.
      GOTO 6

400   F1 = -1./(PARM1**2)
      DO 450 H = NROW+1
	FH2=FLOAT(H)**2
        BUF(1+IFIL+H)=1.-EXP(F1*FH2)
450   	CONTINUE
      BUF(IFIL+1)=1.
      GOTO 6

500	CALL RDPRM(TEMP,NLOOP,ILOOP,'TEMPERATURE(0=CUTOFF)')
	IF(IOPT.EQ.6)TEMP=-TEMP
      DO  H = 1,NROW+1
	R=FLOAT(H) 
	ARG=(R-PARM1)/TEMP
	IF(ARG.GT.10.)ARG=10.
	IF(ARG.LT.-10.)ARG=-10.
	BUF(1+IFIL+H)=(1./(1+EXP(ARG)))
      ENDDO
        BUF(IFIL+1)=1.
        GOTO 6

6     CONTINUE
      WRITE(NDAT,82) (BUF(IFIL+I),I=1,NROW+2)
82      FORMAT(1X,10E12.4)

5     CONTINUE
      DO  I=1,NROW
        CALL REDLIN(LUN1,BUF,NSAM,I)
        CALL REDLIN(LUN2,BUF(IAD2+1),NSAM,I)
        B1=0
        B2=0
        DO  K=1,NSAM
          B1=B1+BUF(K)
          B2=B2+BUF(IAD2+K)
	ENDDO
        BUF(IAD3+I)=B1/FLOAT(NSAM)
        BUF(IAD4+I)=B2/FLOAT(NSAM)
      ENDDO

      CALL GRAPHO(BUF(IAD3+1),NROW,1,S)
      CALL GRAPHO(BUF(IAD4+1),NROW,1,S)
      CALL FOUR2(BUF(IAD3+1),NROW,1,+1,0)
      CALL FOUR2(BUF(IAD4+1),NROW,1,+1,0)

      WRITE(NDAT,82)(BUF(K+IAD3),K=1,2*NROW+2)
      WRITE(NDAT,82)(BUF(K+IAD4),K=1,2*NROW+2)
      LP=2*NROW+2
      DO  I = 1,LP,2
      KFIL=(I-1)/2+1
      I1 = I
      I2 = I+1
      SH = (-1)**(I/2)
      T1 = (BUF(I1+IAD3)*BUF(I1+IAD4) + BUF(I2+IAD3)*BUF(I2+IAD4))*SH
      T2 = (BUF(I1+IAD4)*BUF(I2+IAD3)-BUF(I2+IAD4)*BUF(I1+IAD3))*SH
      IF(FFLAG) T1=T1*BUF(IFIL+KFIL)
      IF(FFLAG) T2=T2*BUF(IFIL+KFIL)
      BUF(I2+IAD3)= T2
      BUF(I1+IAD3) = T1
      ENDDO
      WRITE(3,82) ( BUF(K+IAD3),K=1,LP)
      CALL FOUR2(BUF(IAD3+1),NROW,1,-1,-1)
      CALL GRAPHO(BUF(IAD3+1),NROW,1,S)

      WRITE(NDAT,*) ' '
      WRITE(NDAT,*) ' CROSS-CORRELATION BETWEEN:'
      WRITE(NDAT,49) FILNAM(:80)
49    FORMAT(A)
      WRITE(NDAT,*) ' AND:'
      WRITE(NDAT,49) FILNM1(:80)
      WRITE(NDAT,*) ' '

C     WRITE(NDAT,82)(BUF(A3+K),K=1,L)
77    T1 = BUF(IAD3+1)
      DO 70 I = 1,NROW
      T = BUF(IAD3+I)
      IF(T.LT.T1) GOTO 70
      T1 = T
      J = I
70    CONTINUE

C PARABOLIC FIT ESTIMATION
75	CALL PARAB1(BUF(IAD3+J-3),7,POS1)
	POS=POS1+J-1
C	WRITE(NDAT,7599)(BUF(IAD3+J-4+K),K=1,7),POS1,POS
7599	FORMAT(9G12.4)
        Y=POS-FLOAT(NROW/2)
        WRITE(NOUT,101) Y
101     FORMAT(' Y-SHIFT BETWEEN PICTURES:',F12.4) 

	RETURN
        END
