
/*$Header: /net/ithaca/usr1/web/src/RCS/action.c,v 1.3 1996/05/10 13:06:29 leith Exp $*/
/*
 * action.c
 *
 ***********************************************************************
 * COPYRIGHT (C)1992, WADSWORTH CENTER FOR LABORATORIES AND
 * RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.   
 * THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     
 * LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  
 * USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF 
 * THE CENTER FOR LABORATORIES AND RESEARCH 			  
 ***********************************************************************
 * 
 * PURPOSE:	Adds one action to the translation table of iw_t
 *              of form:  <event act_name params>
 *
 * RETURNS:	void
 * 
 * PARAMETERS:  Widget		iw_t
 *		char		*event
 *		char		*act_name
 *		char		*params
 *
 *
 * CALLED BY:   actions
 *
 ***********************************************************************
*/

#include "std.h"
#include "x.h"
#include "routines.h"

extern Display *idispl;

/**********************************************************************/
void action(Widget iw_t, char *event, char *act_name, char *params)
   {
   char tmp_act_name[80];
   char tmp_event[120];

   if (((strlen(act_name)                                 ) >= (size_t) 80) ||
       ((strlen(params) + strlen(act_name)                ) >= (size_t) 80) ||
       ((strlen(params) + strlen(act_name) + strlen(event)) >= (size_t)120))
       { 
       spout("*** Pgm. error:  overlength action in action.c, tell Dean");
       XBell(idispl,50); XBell(idispl,50); XBell(idispl,50); XBell(idispl,50);
       return;
       }

   strcpy(tmp_event, event);
   strcpy(tmp_act_name, act_name);

   XtOverrideTranslations(iw_t, XtParseTranslationTable
                         (strcat(tmp_event,
                                 strcat(tmp_act_name, params))));
   }
