
/*$Header: /net/ithaca/usr1/web/src/RCS/actions.c,v 1.4 1996/05/09 14:45:18 leith Exp $*/
/*
 * actions.c
 *
 **********************************************************************
 * COPYRIGHT (C)1992, WADSWORTH CENTER FOR LABORATORIES AND
 * RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.
 * THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     
 * LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  
 * USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF 
 * THE CENTER FOR LABORATORIES AND RESEARCH 			  
 **********************************************************************
 *
 * 
 * 
 * PURPOSE:     adds actions to iw_t's translation table for remaping
 *		the specified mouse buttons
 *
 * RETURNS:
 * 
 * PARAMETERS:	iw_t		widget whose translation table is
 *				to be modified
 * 		keys		string consisting of:
 *				   1 = left mouse button click
 *                                 2 = center mouse button click
 *                                 3 = right mouse button click
 *
 **********************************************************************
*/

#include "std.h"
#include "x.h"


extern XtAppContext app_context;        /* application context   */

/* function prototypes */
extern void action  (Widget, char *, char *, char *);

/************************  actions ***********************************/

void actions(Widget iw_t, char *act_name, void (*act)(), char *keys)
{
   char *compare;              /* string used in comparisons */

   struct XtActionsRec         /* action list                */
      {
      String       string;    
      XtActionProc act_prop;
      } acts[1]; 

   /* setup action list */
   acts[0].string   = act_name;
   acts[0].act_prop = act;

   /* remove all previous translations from iw_t */
   XtUninstallTranslations(iw_t);

   /* add new actions to context */
   XtAppAddActions(app_context, (XtActionList) acts, XtNumber(acts));

   /* set up action on mouse movement */
   compare = strchr(keys, 'M');
   if (compare != NULL)
      {
      action(iw_t, "<MotionNotify> : ", act_name, "(M)");
      }

   /* set up action on button 1 down (left button) */
   compare = strchr(keys, '1');
   if (compare != NULL) 
      {
      action(iw_t, "<Btn1Down> : ", act_name, "(1)");
      }

   /* set up action on button 2 (middle button) */
   compare = strchr(keys, '2');
   if (compare != NULL) 
      {
      action(iw_t, "<Btn2Down> : ", act_name, "(2)");
      }

   /* set up action on button 3 (right button) */
   compare = strchr(keys, '3');
   if (compare != NULL) 
      {
      action(iw_t, "<Btn3Down> : ", act_name, "(3)");
      }

   /* set up action on button 1 up (left button) */
   compare = strchr(keys, 'L');
   if (compare != NULL) 
      {
      action(iw_t, "<Btn1Up> : ", act_name, "(L)");
      }
}
