
/*$Header: /net/ithaca/usr1/web/src/RCS/annotemen.c,v 1.4 1996/04/01 17:23:43 leith Exp $*/

/***********************************************************************
 * annotemen.c                      7/93
 *
 * ported WID_ANNOTEMEN.FOR (VAX) to unix.
 *
 ***********************************************************************
 * author : Mahieddine Ladjadj
 * COPYRIGHT (C)1993, WADSWORTH CENTER FOR LABORATORIES AND
 * RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.
 * THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR
 * LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR
 * USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF
 * THE CENTER FOR LABORATORIES AND RESEARCH
 ***********************************************************************
 *
 * annotemen()
 *
 * PURPOSE:    displays wid_annote menu.
 *
 ***********************************************************************
*/

#include "common.h"
#include "routines.h"
#include <Xm/Text.h>


  /* internal function prototypes */
  void   annotemen_buta       (Widget, XtPointer, XtPointer);
   
  /* internal variables */
  static Widget   iw_annotemen = (Widget) 0;
  static Widget   iw_fdoc, iw_xregt, iw_yregt, iw_labreg, iw_tkey1,
           iw_tkey2, iw_rad;
  int      ix_reg, iy_reg, lab_reg, tkey1, tkey2, iarad ;

/*********************  annotemen ************************************/

void annotemen(void)
  {
  Widget   iw_buta, iw_butc, iw_buts;
  Widget   iw_rowcol;
  char     cval[5];


  if (iw_annotemen == (Widget) 0)
     /* annote menu widget does not exist, create it */
     {
     /* create a dialog box */
     iw_annotemen = wid_dialog(iw_win,0,"Annote options",-1,-1);
     iw_rowcol    = wid_rowcol(iw_annotemen,'v',-1,-1);
   
     /* set up rows and columns in the dialog widget */
     ix_reg     = 1;
     iy_reg     = 2;
     lab_reg    = 0;
     iarad      = 5;
     tkey1      = 1;
     tkey2      = 2000;

    /* create a text box for doc file name input */
    iw_fdoc = wid_textboxb(iw_rowcol,0, "Doc. File:   ", docnam,20);

    /* create a box for first key # input */
    sprintf(cval,"%4d",tkey1);
    iw_tkey1 = wid_textboxb(iw_rowcol,0,"Starting Key:",cval,4);

    /* create a box for last key # input */
    sprintf(cval,"%4d",tkey2);
    iw_tkey2 = wid_textboxb(iw_rowcol,0,"Ending Key:  ",cval,4);

    /* create a box for ix_reg input */
    sprintf(cval,"%4d",ix_reg);
    iw_xregt = wid_textboxb(iw_rowcol,0,"X reg:       ",cval,4);

    /* create a box for iy_reg input */
    sprintf(cval,"%4d",iy_reg);
    iw_yregt = wid_textboxb(iw_rowcol,0,"Y reg:       ",cval,4);

    /* create a box for lab_reg input */
    sprintf(cval,"%4d",lab_reg);
    iw_labreg = wid_textboxb(iw_rowcol,0,"Label Reg:   ",cval,4);

    /* create a box for marker radius input */
    sprintf(cval,"%4d",iarad );
    iw_rad =   wid_textboxb(iw_rowcol,0,"Marker Radius",cval,4);

    /* create a push button for stop, cancel & apply */
    wid_stdbut(iw_rowcol,iw_annotemen,
               &iw_buts, &iw_butc, &iw_buta,"SCA",
               fin_cb,fin_cb,annotemen_buta,NULL);
    }
  XtManageChild(iw_annotemen);
  return;
  }

 /*******************  annotemen_buta ******************************/

 void annotemen_buta(Widget iw_t, XtPointer itag, XtPointer callpar)
  {
  char  outstr[80];
  char * string;

  /* get docnam from text widget */
  string = XmTextGetString(iw_fdoc);
  if (strlen(string) == 0)
     {
     if (string) XtFree(string);
     spout("*** No doc. file name entered");
     return;
     }
  else
     {    /* probably got a valid doc file name */
     strcpy(docnam,string);
     if (string) XtFree(string);
     }

  /* get first key number */
  string = XmTextGetString(iw_tkey1);
  tkey1  = atoi(string);
  if (string) XtFree(string);

  /* get last key number */
  string = XmTextGetString(iw_tkey2);
  tkey2  = atoi(string);
  if (string) XtFree(string);

  /* get x register */
  string = XmTextGetString(iw_xregt);
  ix_reg = atoi(string);
  if (string) XtFree(string);

  /* get y register */
  string = XmTextGetString(iw_yregt);
  iy_reg = atoi(string);
  if (string) XtFree(string);

  /* get label register */
  string = XmTextGetString(iw_labreg);
  lab_reg = atoi(string);
  if (string) XtFree(string);

  /* get radius */
  string = XmTextGetString(iw_rad);
  iarad  = atoi(string);
  if (string) XtFree(string);

  if( tkey2 < tkey1)
     {
     sprintf(outstr,"*** Key 2= %d < key1= %d \n", ix_reg, iy_reg);
     spout(outstr);

     /* redo it */
     XtUnmanageChild(iw_annotemen);
     annotemen();
     return;
     }
  if (ix_reg == iy_reg || ix_reg == lab_reg || iy_reg == lab_reg)
     {
     sprintf(outstr,"WARNING: Using same registers: %d %d %d\n", 
              ix_reg, iy_reg, lab_reg);
     spout(outstr);
     }

  XtUnmanageChild(iw_annotemen);

  /* start annote program */
  annote(docnam);           
  return;
  }
