
/*$Header: /net/ithaca/usr1/web/src/RCS/average.c,v 1.1 1996/06/20 16:40:24 leith Exp $*/

/*
C**************************************************************************
C
C   average
C             
C **************************************************************************
C *  AUTHOR: ArDean Leith                                                  *
C *  COPYRIGHT (C)1993, WADSWORTH CENTER FOR LABORATORIES AND RESEARCH     *
C *    NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.              *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH  			   *
C **************************************************************************
C
C  average
C           
C
C  PURPOSE:     averages two images.
C
C  PARAMETERS:  
C
C  RETURNS:     TRUE  
C
C--*********************************************************************
*/

#include "common.h"
#include "routines.h"

 /*************************   sumum   ****************************/

 int sumum(float * first,  float * second, float * output, int npix)
 {
 int ipix;

 for (ipix = 0; ipix < npix ; ipix++)
     {
     * (output++) = * (first++) + *(second++) ;
     }

 return TRUE;
 }


 /*************************   average   ****************************/

 int average(float * input,  float * output, int npix, float divisor)
 {
 int   ipix;
 float overdiv;

 overdiv = 1.0 / divisor;

 for (ipix = 0; ipix < npix ; ipix++)
    {
    * (output++) = (*(input++))  * overdiv ;
    }

 return TRUE;
 }


 /*****************  avgsave  (runs after avgsave) ************/

 int avgsave(char * avgnamt, int nsam, int nrow, float * avgdata)
 {
 FILEDATA      *filedatat;
 
 /* open new output file */
 filedatat = opennew(avgnamt, nsam, nrow, 1, 1, "u");

 /* put newimage in output file */
 wrtvol(filedatat, avgdata);
 closefile(filedatat);

 return TRUE;
 }



