
/*$Header: /net/ithaca/usr1/web/src/RCS/bar.c,v 1.2 1995/09/06 16:05:49 mladjadj Exp $*/

/*
C***************************************************************************
C
C  WID_BAR.FOR  -- CREATED DEC 89
C                  REWRITTEN MAR 91 al
C  BAR.C           NOV 92                                                               
C **************************************************************************
C *  AUTHOR: ArDean Leith                                                  *
C *  COPYRIGHT (C)1989 , WADWSWORTH CENTER FOR LABORATORIES AND RESEARCH,  *
C *    NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.              *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH                            *
C **************************************************************************
C
C    BAR
C
C    PURPOSE:      DRAWS VERTICAL OR HORIZONTAL BAR AT CURSOR
C
C    PARAMETERS:   NONE 
C
C    CALLED BY:    WEB_COM
C
C--*********************************************************************
*/

#include "common.h"

 /* external subroutines */
 extern void     xorline    (Window, GC, int, int, int, int, int);
 extern GC       setxor     (GC);
 extern void     showbutx   (char *, char *, char *, int);
 extern void     actions    (Widget, char *, void (*)(), char *);
 extern void     getloc     (XEvent *, char, int *, int *);
 extern void     barmen     (Widget, caddr_t, caddr_t);

 /* internal subroutines */
 void bar_pop(Widget, XEvent *, String *, Cardinal *);

 /* external common variables */
 extern Widget iw_barmen;
 extern int    idx, idy;
 static GC     icontxx;

/**************************  bar  *******************************/

 void bar(Widget iw_caller, caddr_t data, caddr_t call_data)

 {

 /* put up menu */
 barmen(NULL, NULL, NULL);
 
 /* open a message window with the following strings */
 showbutx("Set bar location.", 
          "Display menu.", 
          "Stop this routine.", FALSE); 
 /* set the actions for right, left, and center buttons */
 actions(iw_win, "bar_pop",bar_pop,"M123");

 /* turn on xor writing in icontxx */
 icontxx = setxor(icontx);

 }

 /********************** bar_pop  (draw bars)  *******************/


 void bar_pop(Widget iw_t, XEvent *event, String *params,
                   Cardinal *num_params)
 {
 int ix1, iy1, ix2, iy2;

 /* get mouse position ix1,iy1  */
 getloc(event,'M',&ix1,&iy1);

 ix2 = ix1 + idx;
 iy2 = iy1 + idy;

 if (!(strcmp(*params,"M")))                 /* cursor moved */
    {

    /* mouse moved, so erase and draw new bar */
    xorline(iwin,icontxx,FALSE,ix1,iy1,ix2,iy2);
    }

 else if (!(strcmp(*params,"1")))            /* button 1 pushed */ 
    {

    /* draw permanent bar at this location */
    xorline(iwin,icontx,TRUE,ix1,iy1,ix2,iy2);

    /* save bar in backing store */
    xorline(imagsav,icontx,TRUE,ix1,iy1,ix2,iy2);
    }

 else if (!(strcmp(*params,"2")))           /* button 2 pushed */ 
    {
    /*erase  bar */
    xorline(iwin,icontxx,TRUE,ix1,iy1,ix2,iy2);

    /* put up menu */
    barmen(NULL, NULL, NULL);
    } 

 else if (!(strcmp(*params,"3")))           /* button 3 pushed */ 
    {
    /*erase  bar */
    xorline(iwin,icontxx,TRUE,ix1,iy1,ix2,iy2);

    /* free GC storage space */
    XFreeGC(idispl,icontxx);

    /* uninstall translations */
    XtUninstallTranslations(iw_t);
 
    /* unmanage information box */
    showbutx("","","",TRUE);

    XtUnmanageChild(iw_barmen);
    } 
 }
