
/*$Header: /net/ithaca/usr1/web/src/RCS/barmen.c,v 1.6 1995/07/11 20:59:19 mladjadj Exp $*/
/* 
C **************************************************************************
C *  AUTHOR: A. LEITH                                                      *
C *  COPYRIGHT (C)1990, WADSWORTH CENTER FOR LABORATORIES AND              *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH                            *
C **************************************************************************
C
C    BARMEN
C
C    PARAMETERS:   
C
C    PURPOSE:      MAKES SUPER-WIDGET TO FIND BAR LENGTH
C
C    CALLED BY:    WEB_MAIN
C
C--********************************************************************
*/

#include "common.h"
#include <Xm/Scale.h>
#include <Xm/ToggleBG.h>

#define MAX_ARGS 12

 /* external function prototypes */
 extern Widget wid_labelg   (Widget, Widget, char *, int, int);
 extern Widget wid_dialog   (Widget, Widget, char *, int, int);
 extern void   spout        (char *);
 extern void   fin_cb       (Widget, caddr_t, caddr_t);
 extern Widget wid_toggleg  (Widget, Widget, char *, int, void (*)(),
                                char *, int, int);
 extern Widget wid_pushg    (Widget, Widget, char *, void (*)(), 
                                char *,int,int);

 /* internal function prototypes */
 void          barmen_len_cb(Widget, caddr_t, caddr_t);

 /* internal common variables */
 static Widget        iw_hun, iw_ones, iw_or;
 static int           vertical = TRUE;

 /* common variables for external use */
 int                  idx = 50, idy = 0;
 Widget               iw_barmen;


 /********************   barmen   ****************************/

 void barmen(Widget iw_temp, caddr_t data, caddr_t call_data)

 {
 Widget iw_labhun, iw_labones, iw_pushf;
 int    iwid, ihi,inow;
 Arg    args[MAX_ARGS];    


 if (iw_barmen <= (Widget)0)
    {   /* create bar length menu widget first */

    iw_barmen   = wid_dialog(iw_win, 0, "Bar length ", -1, -1);

    /* create label box for 100 lengths  */
    iw_labhun  = wid_labelg(iw_barmen, 0,"length\n(100's)", 30, 5);

    /* create scale widget for 100 lengths */
    iwid =  76;
    ihi  = 224;

    inow = idx;
    if (inow <= 0) inow = idy;
    
    XtSetArg(args[0], XmNwidth,         iwid);                    
    XtSetArg(args[1], XmNheight,        ihi);                
    XtSetArg(args[2], XmNscaleWidth,    iwid-30);            
    XtSetArg(args[3], XmNscaleHeight,   ihi-5);        
    XtSetArg(args[4], XmNminimum,       0);                
    XtSetArg(args[5], XmNmaximum,       15);             
    XtSetArg(args[6], XmNdecimalPoints, 0);            
    XtSetArg(args[7], XmNvalue,         0);                  
    XtSetArg(args[8], XmNorientation,   XmVERTICAL);       
    XtSetArg(args[9], XmNshowValue,     TRUE);           
    XtSetArg(args[10],XmNx,             20);           
    XtSetArg(args[11],XmNy,             56);           
 
    iw_hun = XmCreateScale(iw_barmen, "iw_hun", args, 12);
    XtAddCallback(iw_hun,XmNvalueChangedCallback, 
                   (XtCallbackProc) barmen_len_cb,"1");
    XtManageChild(iw_hun);


    /* create label box for 1 lengths  */
    iw_labones  = wid_labelg(iw_barmen, 0,"length\n(units)", 200, 5);

    /* create scale widget for 1 lengths */   
    XtSetArg(args[4], XmNminimum,       0);                
    XtSetArg(args[5], XmNmaximum,       100);             
    XtSetArg(args[7], XmNvalue,         inow);                  
    XtSetArg(args[10],XmNx,             180);           
 
    iw_ones = XmCreateScale(iw_barmen, "iw_ones", args, 12);
    XtAddCallback(iw_ones,XmNvalueChangedCallback, 
                    (XtCallbackProc) barmen_len_cb,"0");
    XtManageChild(iw_ones);

    /* create toggle box for bar orientation  */
    iw_or = wid_toggleg(iw_barmen,0,"Vertical bar",vertical,
                        barmen_len_cb,NULL, 44,300);

    /*  create push button for finished */
    iw_pushf = wid_pushg(iw_barmen, 0," FINISHED ", fin_cb,
                        (char *) iw_barmen,  180,350);
    }

 XtManageChild(iw_barmen);
 }

 /*********** length callback *************************/

 void barmen_len_cb(Widget iw_temp, caddr_t data, caddr_t call_data)

 {
 int     len100, len1;

 XmScaleGetValue(iw_hun,  &len100);
 XmScaleGetValue(iw_ones, &len1);

 vertical = XmToggleButtonGadgetGetState(iw_or);

 if (vertical)
    {
    idx = 0;
    idy = len100 * 100 + len1;
    }
 else
    {
    idx = len100 * 100 + len1;
    idy = 0;
    }

 }

