
/*$Header: /net/alwyn/usr1/web/src/RCS/blackout.c,v 1.3 94/09/12 15:53:56 leith Exp $*/
/*
C++*************************************************************************
C
C    WID_BLACKOUT.FOR -- MARCH 91 al
C    BLACKOUT.C          NOV 92 al
C **************************************************************************
C *  AUTHOR:  ArDean Leith
C *  COPYRIGHT (C)1991, WADSWORTH CENTER FOR LABORATORIES AND              *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH			           *
C **************************************************************************
C
C    WID_BLACKOUT
C
C    PURPOSE:      BLACKS SCREEN AROUND GRAPHICS WINDOW (FOR PHOTOGRAPHY)
C                  USUAL COLOR MAP HAS A GREY RAMP IN 0...127 AND
C                  SPIDER COLOR SHADES IN 128...248.
C
C    CALLED BY:     Web_com
C
C--*********************************************************************
*/

#include "files.h"
#include "common.h"
#include "routines.h"

 void blackout_pop (Widget, XEvent *, String *, Cardinal *);

 static Colormap   mapb = 0;

 /*************************  blackout   ****************************/

 void blackout(Widget iw_dum, caddr_t call_data, caddr_t data)
 {
 int             i, ncolors;
 XColor          colors[256];
 XVisualInfo     visual_data;
 Visual          *visualb;
 Arg             args[2];

 if (mapb == 0) 
    {
    /*   create a new blackout private color map */

     ncolors = 256; 
     if (!XMatchVisualInfo(idispl, XDefaultScreen(idispl), 8,
                      PseudoColor, &visual_data))
      {
      spout("*** In blackout, failed to find visual");
      return;
      }

   visualb = visual_data.visual;

   mapb = XCreateColormap(idispl,iwtop,visualb,AllocAll);       

   if (mapb == 0) 
       {
       spout("*** In blackout, failed to create colormap");
       return;
       }

    for ( i=0; i < ncolors; i++)
       {
       colors[i].pixel = i;
       colors[i].flags = DoRed|DoGreen|DoBlue; 
       }

    XQueryColors(idispl,map,colors,ncolors);

    if (mapgo > 0) 
       {
       for ( i = 0; i < mapgo; i++)
         {
         colors[i].pixel = i ;
         colors[i].red   = 0;
         colors[i].green = 0;
         colors[i].blue  = 0;
         }
       }

    if (colorend < ncolors -1) 
       {
       for (i = colorend+1; i < ncolors; i++)
         {
         colors[i].pixel = i;
         colors[i].red   = 0;
         colors[i].green = 0;
         colors[i].blue  = 0;
         }
       }

    /* put new colors in the blackout colormap */
    XStoreColors(idispl,mapb,colors,ncolors);

    }

 /* associate colormap with window */ 
 XSetWindowColormap(idispl, iwtop, mapb); 

 XtSetArg(args[0], XmNmwmDecorations, None);
 XtSetValues(iw_top, args, 1);

 /* set the actions for right, left, and center buttons */
 actions(iw_win, "blackout_pop", blackout_pop,"123"); 
 }

 /**************  blackout_pop  *********************************/

 void blackout_pop(Widget iw_t, XEvent *event, String *params,
                   Cardinal *num_params)

 {
 Arg    args[2];

 XtSetArg(args[0], XmNmwmDecorations, -1);
 XtSetValues(iw_top, args, 1);

 /* reset original colormap */
 XSetWindowColormap(idispl, iwtop, map); 
 
 XtUninstallTranslations(iw_win); 
 }
