/* 
C++************************************************************************
C
C  bldr.c	Converted from Fortran program in Nov 95
C
C **************************************************************************
C *  COPYRIGHT (C)1992, WADSWORTH CENTER FOR LABORATORIES AND              *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH	        		   *
C **************************************************************************
C
C  Purpose:	get the rotation matrix from the given eular angles 
C
C23456789012345678901234567890123456789012345678901234567890123456789012
C--************************************************************************
C
*/
#include "common.h"
#include "routines.h"
#include "x.h"
#include "std.h"
#include <math.h>

/**************************** bldr *******************************/
 
void 	bldr(float psi, float theta, float phi, float *matrix)
{
    float	cpsi, ctheta, cphi;		/* cos values */
    float	spsi, stheta, sphi;		/* sin values */
    float	r[9];				/* return matrix */
    int		i;

    cphi   = cos(phi);
    sphi   = sin(phi);

    ctheta = cos(theta);
    stheta = sin(theta);

    cpsi   = cos(psi);
    spsi   = sin(psi);

    r[0] = cphi * ctheta * cpsi - sphi * spsi;
    r[3] = -cphi * ctheta * spsi - sphi * cpsi;
    r[6] = cphi * stheta;
    r[1] = sphi * ctheta *cpsi + cphi * spsi;
    r[4] = -sphi * ctheta *spsi + cphi * cpsi;
    r[7] = sphi * stheta;
    r[2] = -stheta * cpsi;
    r[5] = stheta * spsi;
    r[8] = ctheta;

for (i=0; i<9; i++) {
    *matrix = r[i];
    matrix++;
    }
 
    return;
}

