/*$Header: /net/ithaca/usr1/web/src/RCS/cat.c,v 1.16 1997/09/09 19:46:55 liy Exp $*/
/*
C++**********************************************************************
C
C  cat.c          Jan 94 
C
C **********************************************************************
C    AUTHOR:  ArDean Leith
C *  COPYRIGHT (C)1994, WADSWORTH CENTER FOR LABORATORIES AND          *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.  *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS *
C *    OR USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN        *
C *    APPROVAL OF THE CENTER FOR LABORATORIES AND RESEARCH            *
C **********************************************************************
C
C    cat()
C
C    PURPOSE:     category selecting program
C
C    PARAMETERS: none   
C
C    CALLED BY:  catmen_buta     
C
C--*********************************************************************
*/

#include "common.h"

#define MAXCURSOR 75

#include "routines.h"

 /* external subroutines */

 /* internal subroutine prototypes */
 void          cat_pop     (Widget, XEvent *, String *, Cardinal *);

 /* external common variables */
 extern int    ndone;
 extern char   filego[81];     /* name of first image in montage   */
 extern char   outstr[80];
 extern int    ixulmon, iyulmon;
 extern int   *docimgnums;
 extern int    docimgtotal;
 extern int    icattyp; /* 0 = montage ; 1= doc.montage */

 /* common variables */
 int           ncat = 3;

 static int    openit, icat, ifil, ifilgo;

 /************************  cat   *******************************/

 void cat(void)

 {
 int nlet;
 char   filejnk[81];    

 /* refresh screen */
 expos_cb(NULL,NULL,NULL);

 /* extract first filenumber from first file name */
 filinc(filego,filejnk,&nlet,&ifilgo);
 ifilgo = ifilgo - 1;
 if (icattyp != 1 && ifilgo < 0)
    {
    spouts("*** Bad file number in cat.c: "); spouti(ifilgo);
    spouts(" from: "); spout(filego);
    return;
    }

 /* set initial */
 icat  = 1;

 openit = TRUE;

 /* set cursor to category */
 setacursor(MAXCURSOR + 1 + icat, -1,-1);

 showbutx("Assign category to file.",
          "Increment current category number.",
          "Stop this routine.",FALSE);

 actions(iw_win, "cat_pop", cat_pop, "M123");

 sprintf(outstr,"Starting category: %d",icat);
 spout(outstr);
 spout(" ");

 }


 /********************* cat_pop **********************************/

 void cat_pop(Widget iw_t, XEvent *event, String *params,
                   Cardinal *num_params)
 {
 int          ixe, ix1, iy1, ixi, iyi, irow, icol, ipane;
 char *       ctemp;
 static FILE *fpdoc;
 float        dlist[5];

 if (!(strcmp(*params,"M")))            /*mouse moved */ 
    {
    /* left button, find image */

    /* get mouse position */
    getloc(event,'M',&ix1,&iy1);

    /* find location relative to montage */
    ixi = ix1 - ixulmon;
    iyi = iy1 - iyulmon;

    /* find image number */
    if (iskip < -1)
       {
       irow  = (iyi / (nrow * -iskip + mary + names_height)) + 1;
       icol  = (ixi / (nsam * -iskip + marx)) + 1;
       }
    else if (iskip > 1)
       {
       irow  = (int)((iyi / (nrow / (float)iskip + mary + names_height)) + 1);
       icol  = (int)((ixi / (nsam / (float)iskip + marx)) + 1);
       }
    else
       {
       irow  = (iyi / (nrow  + mary + names_height)) + 1;
       icol  = (ixi / (nsam  + marx)) + 1;
       }

    ipane = (irow -1) * nprow + icol;
    if (icattyp > 0)  /* from doc. file  montage */
       ifil  = docimgnums[ipane -1];
    else
       ifil  = ipane + ifilgo -1;

    sprintf(outstr,"Row: %d  Col: %d  Pane: %d File: %d$", 
            irow, icol, ipane, ifil);
    spout(outstr);
    }

 if (!(strcmp(*params,"1")))            /* button 1 pushed */ 
    {
    /* left button, find image */

    /* get mouse position */
    getloc(event,'M',&ix1,&iy1);
 
    /* find location relative to montage */
    ixi = ix1 - ixulmon;
    iyi = iy1 - iyulmon;

    /* find image number */
    if (iskip < -1)
       {
       irow  = (iyi / (nrow * -iskip + mary + names_height)) + 1;
       icol  = (ixi / (nsam * -iskip + marx)) + 1;
       }
    else if (iskip > 1)
       {
       irow  = (int)((iyi / (nrow / (float)iskip + mary + names_height)) + 1);
       icol  = (int)((ixi / (nsam / (float)iskip + marx)) + 1);
       }
    else
       {
       irow  = (iyi / (nrow  + mary + names_height)) + 1;
       icol  = (ixi / (nsam  + marx)) + 1;
       }

    ipane = (irow -1) * nprow + icol;
    if (icattyp > 0 &&  ipane <= docimgtotal) /* from doc. file montage*/
       {ifil  = docimgnums[ipane - 1];}
    else
       {ifil  = ipane + ifilgo - 1;}
    
    /* are we trying to write on the filename of the image */
    ixe = (irow - 1) * (nrow + mary + names_height) + nrow ;
    
    /* left button, record category if inside an image */
    if (ipane < 1 || (icattyp == 0 && (ifil > ndone + ifilgo-1)) || 
                     (icattyp == 1 && (ipane > docimgtotal)) || 
        icol > nprow || iyi > ixe ) 
       {
       spout("*** Outside montage, unable to categorize location");

       sprintf(outstr,"Row: %d   Col: %d", irow, icol);
       spout(outstr);
      }
    else
       {
       /* inside montage, put category in doc file */

       sprintf(outstr,"File: %d   Category: %d", ifil, icat);
       spout(outstr);
 
       /*    write category number at this location of screen */
       ctemp = itoa(icat);
       witext(icontx, ctemp, ix1, iy1, 0, 0, -9, 2, FALSE);
       if (ctemp) free(ctemp);

       /*     put this marker in the file */
       dlist[0] = ikeyc;
       ikeyc++;
       dlist[1] = ifil;
       dlist[2] = icat;
       /* allow addition of more data to the same file,
          have append set to TRUE (last argument) */
       fpdoc    = savdn1(docnam, datexc, &fpdoc, dlist, 3, 
                  &openit, TRUE, TRUE);
       }
    }
 else if (!(strcmp(*params,"2")))            /* button 2 pushed */ 
    {
    /*  increment present category  */
    icat++;
    if (icat > ncat) icat = 1;

    /* make a numbered cursor */
    setacursor(MAXCURSOR + 1 + icat,  -1,-1);

    sprintf(outstr,"New category: %d",icat);
    spout(outstr);
    }


 else if (!(strcmp(*params,"3")))            /* button 3 pushed */ 
    {
    if (docimgnums) free(docimgnums);
    docimgnums = NULL;

    /*     close doc file */
    fclose(fpdoc);

    /* reset default cursor */
    setacursor(0,-1,-1);

    /* uninstall translations */
    XtUninstallTranslations(iw_t);

    /*  remove message */
    showbutx("","","",TRUE);
    }
 }

