
/*$Header: /net/ithaca/usr1/web/src/RCS/catmen.c,v 1.10 1997/09/09 19:47:02 liy Exp $*/
/*
C++**********************************************************************
C
C  catmen.c          Jan 94 
C
C **********************************************************************
C    AUTHOR:  ArDean Leith
C *  COPYRIGHT (C)1994, WADSWORTH CENTER FOR LABORATORIES AND          *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.  *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS *
C *    OR USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN        *
C *    APPROVAL OF THE CENTER FOR LABORATORIES AND RESEARCH            *
C **********************************************************************
C
C    catmen()
C
C    PURPOSE:    displays category selecting menu
C
C    PARAMETERS: none   
C
C    CALLED BY:  mont2      
C
C--*********************************************************************
*/
#include "common.h"
#include "routines.h"
#include <Xm/ToggleBG.h>

 /* external function prototypes */
 extern void   cat          (void);

 /* internal function prototypes */
 void          catmen_buts(Widget, XtPointer, XtPointer);
 void          catmen_buta(Widget, XtPointer, XtPointer);
  
 /* external common variables */
 extern int           ncat;        /* number of categories wanted */

 /* internal common variables */
 static Widget        iw_catmen= 0, iw_docgg, iw_nkeyc, iw_ncat;
 static int           showing = FALSE;

 /********************   catmen   ****************************/

 void catmen(void)

 {
 static Widget  iw_rowcolv; 
 Widget  iw_pushs, iw_pusha; 

 char    cval[3];

 if (iw_catmen == (Widget)0)
    {   
    /* create marker doc file menu first */

    iw_catmen = wid_dialog(iw_win, 0, "Categories document file", -1, -1);
    iw_rowcolv  = wid_rowcol(iw_catmen, 'v', -1, -1);

    /*   create a text box for doc file name input */
    iw_docgg = wid_textboxb(iw_rowcolv,0,"Doc file:  ",docnam,20);

    /*   create a text box for category numbers input */
    sprintf(cval,"%d",ikeyc);
printf("---ikey = %d\n", ikeyc);
    iw_nkeyc = wid_textboxb(iw_rowcolv,0,"Starting key number:  ",cval,4);

    /*   create a text box for category numbers input */
    sprintf(cval,"%d",ncat);
    iw_ncat = wid_textboxb(iw_rowcolv,0,"Categories:  ",cval,2);

    /* create box for apply  */
    wid_stdbut(iw_rowcolv, iw_catmen, 
                         &iw_pushs, &iw_pushs, &iw_pusha, "SA",
                         catmen_buts, catmen_buts ,catmen_buta, NULL);

    }
 else
    {
    /*   create a text box for doc file name input */
    iw_docgg = wid_textboxb(iw_rowcolv,iw_docgg,"Doc file:",docnam,20);

    /*   recover the key num  */
    sprintf(cval,"%d",ikeyc);
    iw_nkeyc = wid_textboxb(iw_rowcolv,iw_nkeyc,"Starting key number:  ",cval,4);
    }
 XtManageChild(iw_catmen);

 }

/***********  docfile accept button callback ***********************/

 void catmen_buta(Widget iw_temp, XtPointer data, XtPointer call_data)
 {
 float        fdum;

 if (rdprxc(iw_docgg,&docnam[0],81) == 0) 
    {
    /*  this program requires a doc file name */
    spout("*** You must enter a doc. file name now!");
    return;
    }

 /* find new key */
 if (!rdprx(iw_nkeyc,'i',&ikeyc,&fdum)) return;

 /* find ncat */
 if (!rdprx(iw_ncat,'i',&ncat,&fdum)) return;
 if (ncat > 9 || ncat < 1) 
    {
    spout("*** Categories range 1 ... 9");
    return;
    }

 /*  remove doc file menu */
 XtUnmanageChild(iw_catmen);

 /*     refresh screen  */
 expos_cb(NULL,NULL,NULL);

 /* start the categorizing routine */
 showing = TRUE;
 cat();

 }


/*********** stop button callback **********************************/

 void catmen_buts(Widget iw_temp, XtPointer data, XtPointer call_data)
 {

 /*  remove message */
 if (showing)
   {
   showing = FALSE;
   showbutx("","","",TRUE);
   }

 /*  remove the menu widget */
 XtUnmanageChild(iw_catmen);

 /*  cancel buttons,  stop this routine */
 XtUninstallTranslations(iw_win);

 }


