
/*$Header: /net/ithaca/usr1/web/src/RCS/changedir.c,v 1.9 1996/05/13 14:38:31 leith Exp $*/

/***********************************************************************
 *
 * changedir.c
 *
 ***********************************************************************
 * COPYRIGHT (C)1992, WADSWORTH CENTER FOR LABORATORIES AND
 * RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.
 * THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     
 * LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  
 * USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF 
 * THE CENTER FOR LABORATORIES AND RESEARCH 			  
 ***********************************************************************
 * 
 * PURPOSE:  Change current directory     
 * 
 * PARAMETERS:	Widget 		iw_temp		pushbutton (not used)
 *		XtPointer		data		label text string
 *		XtPointer		call_data	not used 
 *
 ***********************************************************************
*/

#include "common.h"

#ifdef VMS
#include <unixio.h>
#include <unixlib.h>
#else
#include <unistd.h>
#endif

#include <Xm/FileSB.h>
#include "routines.h"

 /* internal functions */
 void            changedir_cb(Widget, XtPointer, XtPointer);

 /* file variables */
 static Widget     iw_text=(Widget)0;

/************************  changedir  ***********************************/

 void changedir(Widget iw_temp, XtPointer data, XtPointer call_data)
 
 {
 /* create new directory input box */
 iw_text = wid_text(iw_win, iw_text, "Enter new directory", dirnow,
                       *changedir_cb, NULL, 0, 0);
 }


 /**********************  changedir_cb  *********************************/

 void changedir_cb(Widget iw_temp, XtPointer data, XtPointer call_data)
 {
 Arg         args[1];   
 XmString    str_dir;
 char        *cptr;

 XmSelectionBoxCallbackStruct *cbs =
      (XmSelectionBoxCallbackStruct *) call_data;
 
 cptr = extractstr(cbs -> value);

 if (strlen(cptr) > (size_t) 80)
    {
    spout("*** Directory name truncated ");
    XBell(idispl,50);
    }
 /* should have better handling of too long directories!!! */

 strncpy(dirnow,cptr,80);
 free(cptr);
 chdir(dirnow);
 getcwd(dirnow,80);
 spouts(" Current directory: "); spout(dirnow);

 if (iw_files != (Widget)0)
    {   /* update file widget current directory */

    str_dir = XmStringCreate(dirnow, XmSTRING_DEFAULT_CHARSET);
    XtSetArg(args[0], XmNdirectory, str_dir);   
    XtSetValues(iw_files, args,1);
    if (str_dir)  XmStringFree(str_dir);
    }
 }

