/*$Header: /net/alwyn/usr1/web/src/RCS/closefilecnt.c,v 1.2 94/08/18 15:01:27 leith Exp $*/
/*
 *************************************************************************
 *
 * closefilecnt.c
 *
 *************************************************************************
 * AUTHOR: A. LEITH
 * COPYRIGHT (C)1981,1992, WADSWORTH CENTER FOR LABORATORIES AND
 * RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
 * THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR
 * LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR
 * USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF
 * THE CENTER FOR LABORATORIES AND RESEARCH
 **************************************************************************
 *
 * PURPOSE:  closes a contour file and frees the structure for it
 *
 * RETURNS:  true
 *
 * PARAMETERS: filptrcnt  
 *              
 *********************************************************************/

#include "filescnt.h"

 int closefilecnt(FILEDATACNT *fileptrcnt)

 {
 FILEDATA * fileptrimg;

 if (fileptrcnt)
    {
    if (fileptrcnt -> image)
       {
       /* retrive pointer to spider image structure */
       fileptrimg = fileptrcnt -> image;

       /* close the related file */
       if (fclose(fileptrimg -> fp)) 
          {
          printf("*** Error closing cnt file. \n");
          }

       /* free the data buffer in fileptrimg */
       if (fileptrimg -> buf) free(fileptrimg -> buf); 

       if (fileptrimg)        free(fileptrimg);
       }

    /* free point data array */
    if (fileptrcnt ->contrl) free(fileptrcnt -> contrl);

    /* free text data array */
    if (fileptrcnt -> txtctr) free(fileptrcnt -> txtctr);

    /* free contour data structure */
    free(fileptrcnt);

    }

 return TRUE;
 }
