
/*$Header: /net/ithaca/usr1/web/src/RCS/cntmen.c,v 1.10 1996/06/27 18:51:27 leith Exp $*/

/*
C++*********************************************************************
C
C cntmen.c          Mar 94                                                                   
C **********************************************************************
C *  AUTHOR: A. LEITH                                                      *
C *  COPYRIGHT (C)1994, WADSWORTH CENTER FOR LABORATORIES AND              *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH	        		   *
C **********************************************************************
C
C    cntmen
C
C    PARAMETERS:   iw_temp, data, call_data (usual callback data)
C
C    PURPOSE:      displays contour selection widget
C
C    CALLED BY:    web_com
C
C--*********************************************************************
*/

#include "common.h"
#include "routines.h"
#include "filescnt.h"
#include <Xm/Text.h>
#include <Xm/ToggleBG.h>
#include <Xm/FileSB.h>

 /* internal subroutines */
 void           cntmen0_cb (Widget, XtPointer, XtPointer);
 void           cntmen     (Widget, XtPointer, XtPointer);
 void           cntmen_buta(Widget, XtPointer, XtPointer);

 /* common file level variables */
 Widget         iw_cntmen, iw_cntcurcol, iw_cnttext;
 Widget         iw_cntplscl, iw_cntcenter, iw_cntclear, iw_cntmirror;
 int            cntlastcnt = 1;
 int            cntnumlis;
 int            cntcenter  = TRUE;
 int            cntclear   = FALSE;
 int            cntselect  = FALSE;
 int            cntmirror  = FALSE;
 int            cntcurcol  = TRUE;
 int            cnttext    = TRUE;
 float          cntplscl   = 650.0;
 char           filnextcnt[81] = "cnt001.DAT";
 char *         filnewcnt;

 /**********************  cntmen0 ************************************/

 void cntmen0(Widget iw_temp, XtPointer data,  XtPointer call_data)
 {
 char   pattern[86];


 if (filwant[0] != '\0')
    { /* use new file pattern */
    strcpy(&pattern[0],&filwant[0]);

    if (datexc[0] != '\0')
       {
       /* set default file filter */
       strcat(pattern,".");
       strcat(pattern,&datexc[0]);
       }
    filwant[0] = '\0';
    }
 else
    pattern[0] = '\0';

 if (!listfi) 
    {
    iw_filesnol = wid_text(iw_win, iw_filesnol, "Contour metafile",
                    filnextcnt, *cntmen0_cb, NULL, -1, -1);
    }
 else
    {
    /* create a file selector box */
    iw_files =  wid_file(iw_win, iw_files , "Contour metafile",
                  filnextcnt, &pattern[0], *cntmen0_cb, -1, -1);
    }
 }


/**************************** cntmen_cb ******************************/

 void cntmen0_cb(Widget iw_temp, XtPointer data,  XtPointer call_data)
  { 
  char              *extractstr(XmString);

  XmFileSelectionBoxCallbackStruct *cbs = 
    (XmFileSelectionBoxCallbackStruct *) call_data;

  /* get name of file returned from the file widget */
  filnewcnt = extractstr(cbs->value);

  strcpy(&filnextcnt[0],filnewcnt);

  if (!listfi)
     XtUnmanageChild(iw_filesnol);
  else
     XtUnmanageChild(iw_files);

  cntmen(NULL,NULL,NULL);
 }


 /**********************  cntmen *************************************/

 void cntmen(Widget iw_temp, XtPointer data, XtPointer call_data)
 { 
 char     cval[5];
 Widget   iw_rowcol;
 Widget   iw_pushs, iw_pusha, iw_dums;
 
 if (iw_cntmen <= (Widget) 0)
    {   /* create cnt menu widget first */

    iw_cntmen = wid_dialog(iw_win,iw_cntmen,
                           "Contour display options",20,20);
    iw_rowcol   = wid_rowcol(iw_cntmen,'v',-1,-1);

    /* create text box for plot scale input  --------------- cntplscl */
    sprintf(cval,"%3d",(int) cntplscl);
    iw_cntplscl = wid_textboxb(iw_rowcol,0,   "PLOT SCALE:",cval,4);

    /* create toggle box for center ----------------------- cntcenter */
    iw_cntcenter = wid_togmen(iw_rowcol,0,"CENTER CONTOURS",
                                 cntcenter,0,0);

    /* create toggle box for clear ------------------------- cntclear */
    iw_cntclear = wid_togmen (iw_rowcol,0,"CLEAR FIRST",
                                 cntclear,0,0);
 
    /* create toggle box newline -------------------------- cntmirror */
    iw_cntmirror = wid_togmen(iw_rowcol,0,"MIRROR TOP-BOTTOM",
                                 cntmirror,0,0);

    /* create toggle box nuscrn --------------------------- cntcurcol */
    iw_cntcurcol = wid_togmen (iw_rowcol,0,"USE CURRENT COLOR",
                                 cntcurcol,0,0);

    /* create toggle box listfi ----------------------------- cnttext */
    iw_cnttext = wid_togmen(iw_rowcol,0,"DISPLAY TEXT",
                               cnttext,0,0);

    /* create stop/ apply boxes  ------------------------------ apply */
    iw_pushs = (Widget) 0;
    iw_pusha = (Widget) 0;
    wid_stdbut(iw_rowcol, iw_cntmen, 
               &iw_pushs, &iw_dums, &iw_pusha, 
              "SA",fin_cb,fin_cb,cntmen_buta, NULL);
    }

 XtManageChild(iw_cntmen);
 }


 /************ accept button callback *********************************/

 void cntmen_buta(Widget iw_temp, XtPointer data, XtPointer call_data)
 {

 int           icntplscl;
 FILEDATACNT * fileptrcnt;

 /* get toggles, etc */
 cntcenter   = XmToggleButtonGadgetGetState(iw_cntcenter);
 cntclear    = XmToggleButtonGadgetGetState(iw_cntclear);
 cntmirror   = XmToggleButtonGadgetGetState(iw_cntmirror);
 cntcurcol   = XmToggleButtonGadgetGetState(iw_cntcurcol);
 cnttext     = XmToggleButtonGadgetGetState(iw_cnttext);

 /* get plot scale from menu */
 if (strtoint(iw_cntplscl,"plot scale",&icntplscl) == FALSE) return;
 cntplscl = icntplscl;

 XtUnmanageChild(iw_cntmen);

 /* open the contour file */
 fileptrcnt =  openoldcnt(filnewcnt, "o");
 
 if (fileptrcnt) 
    {
    /* display the contours */
    cntplot(fileptrcnt);

    closefilecnt(fileptrcnt);

    /* redisplay menu */
    cntmen(NULL,NULL,NULL);
    }

 return;
 }

