
/*$Header: /net/ithaca/usr1/web/src/RCS/colmen.c,v 1.16 1996/01/25 21:02:01 leith Exp $*/
/*
C++*********************************************************************
C
C WID_COLMEN.FOR  -- CREATED MARCH 91
C COLMEN.C           CONVERTED TO C -- NOV 92 al  
C                                               
C **********************************************************************
C *  AUTHOR: A. LEITH                                                      *
C *  COPYRIGHT (C)1991, WADSWORTH CENTER FOR LABORATORIES AND              *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH	        		   *
C **********************************************************************
C
C    COLMEN
C
C    PURPOSE:      DISPLAYS COLOR SELECTION SUPER-WIDGET
C
C    CALLED BY:    web_com
C
C--********************************************************************
*/

#include <Xm/Text.h>
#include <Xm/ToggleBG.h>
#include <Xm/PushB.h>

#include "common.h"
#include "routines.h"

#define MAX_ARGS 11

 /* internal function prototypes */
 void          colmen_but(Widget iw_temp, caddr_t, caddr_t);
 
 /* internal common variables */
 static Widget   iw_colmen = (Widget)0;
 static Widget   iw_color, iw_radio;
 static Widget   iw_curf, iw_curb;
 static int      over, fore, cursit, curf = TRUE, curb = FALSE, back;

 /*************************   colmen   *******************************/

 void colmen(Widget iw_caller, caddr_t data, caddr_t call_data)

 { 
 Arg             args[MAX_ARGS];  
 Widget          iw_temp;
 int             iwid, ixd, iyd, ixulb, iyulb, ici, icolort, itemp;
 int             n;
 XmString        str_label;       

 fore   = FALSE;
 cursit = FALSE;
 over   = FALSE;
 back   = FALSE;

 if  (!strcmp(data, "3"))
    {   /* altering web cursor color */
    cursit = TRUE;
    if (curf)
       itemp = ispicol[icolorcf];
    else
       itemp = ispicol[icolorcb];
    }
 else if (!strcmp(data, "0"))
    {  /* altering web foreground */
    fore  = TRUE;
    itemp = icolorx;
    }
 else if (!strcmp(data, "1"))
    {  /* altering web overlay color */
    over  = TRUE;
    itemp = ispicol[icolorov];
    }
 else if (!strcmp(data, "2"))
    {   /* altering web background color */
    back  = TRUE;
    itemp = icolorxb;
    }

/* printf(" colmen itemp: %d\n",itemp); */

 if (iw_colmen <= (Widget)0)
    {   
    /* create color choice menu widget first */

    iw_colmen  = wid_dialog(iw_win, 0, "Color options", -1, -1);

    /* create label box for color palette ----------------- pallette */
    wid_labelg(iw_colmen, 0, "     COLOR PALETTE", 60, 15);

    n = 0;
    XtSetArg(args[n], XmNautoUnmanage, FALSE); n++; 
    XtSetValues(iw_colmen, args, 1);

    /* set size for overall pallete */
    iwid    = 688;

    /* set size for individual color boxes */
    ixd     = 32;
    iyd     = 32;
    ixulb   = iwid;
    iyulb   = 30;

    n = 0;
    /* XtSetArg(args[n], XmNshowAsDefault,   0); n++; ?????? */
    XtSetArg(args[n], XmNmarginWidth,     0); n++; 
    XtSetArg(args[n], XmNmarginHeight,    0); n++; 
    XtSetArg(args[n], XmNshadowThickness, 0); n++; 
    XtSetArg(args[n], XmNwidth,         ixd); n++; 
    XtSetArg(args[n], XmNheight,        iyd); n++;
    XtSetArg(args[n], XmNcolormap,      map); n++;

    str_label = XmStringCreateLtoR("",XmSTRING_DEFAULT_CHARSET);
    XtSetArg(args[n], XmNlabelString, str_label);  n++;

    for (ici = 0; ici < MAXCOL; ici++)
       {
       ixulb = ixulb + ixd;
       if (ixulb > (iwid-ixd) || ici == mapgo || ici == colorgo )
          {
          /* start new line of color boxes */
          ixulb = 20;
          iyulb = iyulb + iyd;
          }

       /* set color for box */
       icolort  = ispicol[ici];
 
       XtSetArg(args[n],   XmNx, ixulb);
       XtSetArg(args[n+1], XmNy, iyulb); 
       XtSetArg(args[n+2], XmNbackground, icolort);

       iw_temp = XmCreatePushButton(iw_colmen, "iw_pb", args, n+3);

       XtAddCallback(iw_temp,XmNactivateCallback,
                (XtCallbackProc) colmen_but,(XtPointer) &ispicol[ici]);
       XtManageChild(iw_temp);
 
       } /* endfor ici */

    /* free the String (not doing this may result in a memory leak) */
    XmStringFree(str_label);

    /* create radio box for color cursor object toggles */
    iw_radio  = wid_rowcol(iw_colmen, 'h', 0, iyulb);

    XtSetArg(args[0], XmNradioBehavior, TRUE);
    XtSetValues(iw_radio, args, 1);

    iw_curf = wid_togmen(iw_radio,iw_curf,
              "Cursor-foreground  ", curf,-1,-1);

    iw_curb = wid_togmen(iw_radio,iw_curb,
              "  Cursor-background", curb, -1,-1);

    /* radio box is not shown if not changing cursor colors */
    if (!cursit)  XtUnmanageChild(iw_radio);

    /* create label box for current color ---------------- pallette */
    iw_color  = wid_label(iw_colmen, 0, "  CURRENT \n COLOR", map,
                         20,  iyulb + iyd + 70);

    /* put visible border around current color box */
    XtSetArg(args[0], XmNborderWidth, 2);
    XtSetValues(iw_color, args, 1);

    wid_pushg(iw_colmen, 0,"   FINISHED  ", fin_cb,
                        (char *) iw_colmen,  180,iyulb + iyd + 75);

    }
 else
    {   
    /* color menu widget already exists, update it */

    if (cursit)
       XtManageChild(iw_radio);
    else  
       XtUnmanageChild(iw_radio);
    }

 /* place current color in  current color box */
 XtSetArg(args[0], XmNbackground, itemp);
 XtSetValues(iw_color, args, 1);

 XtManageChild(iw_colmen);
 }


 /*********** color changed button callback **************************/

 void colmen_but(Widget iw_temp, caddr_t data, caddr_t call_data)
 {
 Arg    args[1];
 int    itemp, colorbox;

 if (cursit)
    {
    curf = XmToggleButtonGadgetGetState(iw_curf);
    curb = XmToggleButtonGadgetGetState(iw_curb);
    } 
 else
    {
    curf  =  curb  =  FALSE;
    }

 colorbox = * (int * ) data;     

 if (colorbox >= 0 && colorbox <= MAXCOL)
    {   
    itemp = ispicol[colorbox];

    /* set graphics foreground or background color */
       
    if (fore)
       {   /* set current color for draw operations */
       wicolor(icontx, colorbox);
       /* wicolor sets icolor and icolorx */
       }

     else if (back)
       {  /* set window background (used in clearing) */
       XtSetArg(args[0], XmNbackground, ispicol[colorbox]);
       XtSetValues(iw_win, args, 1);
       icolorb  = colorbox;
       icolorxb = ispicol[colorbox];
       }

     else if (over)
       {   /* set color used in mask overlay */
       icolorov  = colorbox;
       }

   else if (curf)
       {  /* set cursor foreground  */
       icolorcf  = colorbox;

       /* set cursor foreground color */
       setacursor(icursor,icolorcf,-1); 
       }

    else if (curb)
       {  /* set cursor background  */
       icolorcb  = colorbox;

       /* set cursor background color */
       setacursor(icursor,-1,icolorcb); 
       }

    /* place current color in current color box */
    XtSetArg(args[0], XmNbackground, itemp);
    XtSetValues(iw_color, args, 1);
    } 
 }


/*************************
       idumt = * (int * ) data;
       printf("data,mapgo,mapend,,itemp: %d - %d...%d, %d -- %d\n",
               mapgo,mapend,icolort,itemp);
***********************/
                              
