/*
*****************************************************************************
**  comapmen.c
**
**  WID_COMAPMEN.FOR (VAX) transported to UNIX   7/28/93
**
*****************************************************************************
**    AUTHOR:  mahieddine Ladjadj                                           *
**    COPYRIGHT (C)1993, WADSWORTH CENTER FOR LABORATORIES AND              *
**    RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
**      THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
**      LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
**      USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
**      THE CENTER FOR LABORATORIES AND RESEARCH			    *
*****************************************************************************
**
**
**    PURPOSE:      PUTS UP MENU FOR COMAP PARAMETERS
**
*****************************************************************************
*
*                  comapmen
*                      |
*                     \|/
*                      |
*                    comap
*                      |
*                     \|/
*                      |
*                  corr_mask
*                      |
*                     \|/
*                      |
*   |------->>---- comapmen2
*   |                   |
*   |                  \|/
*   |                   |
*   |     -----<<---------------------->>------------------->>---------
*   |     |                   |                   |                   |
*   |    \|/                 \|/                 \|/                 \|/
*   |     |                   |                   |                   |
*   | comapmen2_buta    comapmen2_buts        comapmen5           comapmen3
*   |     |                                       |                   |
*   |    \|/                                     \|/                 \|/
*   |     |                                       |                   |
*   |     |                                  comapmen5_buta     comapmen3_buta
*   |     |                                       |                   |
*   |    \|/                                     \|/                 \|/
*   |     |                                       |                   |
*   |     |                                       |                   |
*   -- comapsav  ----------------<<-------------------------<<---------                      
*
*
*
*
*/
#include "common.h"
#include <stdio.h>
#include <Xm/Text.h>
#include <string.h>
#include <Xm/ToggleBG.h>
#include "routines.h"

  /* function prototypes */
  void  comapmen_buta (Widget, caddr_t, caddr_t);

  /* externally used variables */
  int    itxreg, ityreg, labreg, itrad, sayno, key1, key2;
  float  stndrt, rangel, rangeu;
  char   filnamm[81],docxnam[81];

  /* internal variables */
  static Widget iw_comapmen= (Widget) 0, iw_doc, iw_xreg, iw_yreg,
         iw_stndrt, iw_rangel, iw_rangeu, iw_key1, iw_key2, iw_imn,
         iw_rad, iw_sayno;

/**************************  comapmen  *********************************/

void comapmen(void)
  {
  Widget iw_dum,iw_buta, iw_butc, iw_buts, iw_rowcol;
  char   filnamm[] = "bow***", docxnam[]  = "imcdoc007";
  char   cval[15];
 
  /* comap menu Widget does not exist, create it */
  if (iw_comapmen == (Widget) 0)
      {
      /* create a dialog box */
      iw_comapmen = wid_dialog(iw_win,(Widget) 0,"comap options",-1,-1);
      iw_rowcol = wid_rowcol(iw_comapmen,'v',-1,-1);
 
      /* set up the variables in the dialog widget */
      itxreg = 1;
      ityreg = 2;
      itrad  = 5;
      key1   = 1;
      key2   = 100;
      sayno  = TRUE;
      stndrt = 2.3;
      rangel = rangeu = 3.0;

      /* set mapping range */
      imagego = mapgo;

      /* create a text box for doc file name input */
      iw_doc = wid_textboxb(iw_rowcol,(Widget) 0,
                            "          Doc. File:",docxnam,20);

      /* create a box for filename  input */
      iw_imn =  wid_textboxb(iw_rowcol,(Widget) 0,
                             "         Image File:",filnamm,20);

      /* create a box for first image key  input */
      sprintf(cval,"%12d",key1);
      iw_key1 = wid_textboxb(iw_rowcol,(Widget) 0,"    First Image Key:",cval,12);

      /* create a box for last image key  input */
      sprintf(cval,"%12d",key2);
      iw_key2 = wid_textboxb(iw_rowcol,(Widget) 0,"     Last Image Key:",cval,12);

      /* create a box for stndrt */
      sprintf(cval,"%f",stndrt);
      iw_stndrt = wid_textboxb(iw_rowcol,(Widget) 0," Extent (std. dev.):",
                               cval,12);

      /* create a box for rangel input */
      sprintf(cval,"%f",rangel);
      iw_rangel = wid_textboxb(iw_rowcol,(Widget) 0,"Lower Image Thresh.:",
                               cval,12);

      /* create a box for rangeu input */
      sprintf(cval,"%f",rangeu);
      iw_rangeu = wid_textboxb(iw_rowcol,(Widget) 0,"Upper Image Thresh.:",
                               cval,12);

      /* create a box for marker radius input */
      sprintf(cval,"%12d",itrad);
      iw_rad = wid_textboxb(iw_rowcol,(Widget) 0,"      Marker Radius:",cval,12);

      /* create a toggle box for sayno input */
      iw_sayno = wid_toggleg(iw_rowcol,(Widget) 0," Show Image Numbers",
                             sayno,toggle2_cb,(caddr_t) &sayno ,-1,-1);
 
      /* create a push button for stop, cancel & apply */
      iw_dum = wid_stdbut(iw_rowcol,iw_comapmen,
                          &iw_buts,&iw_butc,&iw_buta,"SCA",
                          fin_cb,fin_cb,comapmen_buta,NULL);
      }

  XtManageChild(iw_comapmen);
  }

/*******************  comapmen_buta ******************************/

void comapmen_buta(Widget iw_t, caddr_t itag, caddr_t callpar)
  {
  char  outstr[80];
  char *string;

  /* get docxnam from text widget */
  string = XmTextGetString(iw_doc);
  if (strlen(string) == 0)
    {
      XtFree(string);
      spout(" *** WARNING: no doc file name: docxnam not assigned ");
      return;
    }
  else
    {
      strcpy(docxnam,string);
      XtFree(string);
    }

  /* get filnamm from text widget */
  string = XmTextGetString(iw_imn);
  if (strlen(string) == 0)
    {
      XtFree(string);
      spout(" *** WARNING: no file name : filnamm not assigned");
      return;
    }
  else
    {
      strcpy(filnamm,string);
      XtFree(string);
    }

  /* get standard deviation from text widget */
  string = XmTextGetString(iw_stndrt);
  sscanf(string,"%f",&stndrt);
  XtFree(string);

  /* get first key number */
  string = XmTextGetString(iw_key1);
  sscanf(string,"%d",&key1);        
  XtFree(string);

  /* get last key number */
  string = XmTextGetString(iw_key2);
  sscanf(string,"%d",&key2);
  XtFree(string);

  /* get range low threshold from text widget */
  string = XmTextGetString(iw_rangel);
  sscanf(string,"%f",&rangel);        
  XtFree(string);

  /* get upper threshold from text widget */
  string = XmTextGetString(iw_rangeu);
  sscanf(string,"%f",&rangeu);
  XtFree(string);

  /* get radius */
  string = XmTextGetString(iw_rad);
  sscanf(string,"%d",&itrad);       
  XtFree(string);

  /* get sayno toggle image numbers */
  sayno = XmToggleButtonGadgetGetState(iw_sayno);

  if (key1 > key2)
     {sprintf(outstr," WARNING: key1 %d > key2 %d ", key1,key2);
      spout(outstr);}

  XtUnmanageChild(iw_comapmen);

  /* start comap program */
  comap();
  }
