/*
*****************************************************************************
** comapmen2.c		8/93
**
** WID_COMAPMEN2.FOR transported to UNIX
**
** **************************************************************************
** *   AUTHOR:  Mahieddine Ladjadj                                          *
** *  COPYRIGHT (C)1990 , WADSWORTH CENTER FOR LABORATORIES AND             *
** *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
** *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
** *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
** *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
** *    THE CENTER FOR LABORATORIES AND RESEARCH			    *
** **************************************************************************
**
*****************************************************************************
*/

#include "common.h"
#include "std.h"
#include "x.h"
#include "routines.h" 
#include <Xm/ToggleBG.h>
  
 /* internal functions */
 void     comapmen2_but  (Widget, caddr_t, caddr_t);
 void     comapmen2_buts (Widget, caddr_t, caddr_t);
 void     ovrlap_cb      (Widget, caddr_t, caddr_t);

 /* external variables */
 extern GC icontmx;
 extern float  *bufx, *bufy;
 extern int    *nkey;
 Pixmap        msksav;
 Widget iw_comapmen2;
 int ovrlap;

/********************** comapmen2 ***********************************/

void comapmen2(void)
  {
  char   cval[15];
  Widget iw_rowcol, iw_p1, iw_p2, iw_p3, iw_p4, iw_p5, iw_p6, iw_p7;

  if (iw_comapmen2 == (Widget) 0) 
      { /* comap menu widget does not exist, create it */

      /* create a dialog box */
      iw_comapmen2 = wid_dialog(iw_win,(Widget) 0,"corr_map options",20,20);
      iw_rowcol   = wid_rowcol(iw_comapmen2,'v',-1,-1);

      /* create a push button for saving images in doc file */
      iw_p1 = wid_pushg(iw_rowcol, (Widget)0,
                   "Save Images in Doc File:", comapmen3,"0",0,0);  

      /* create a push button for displaying average image */
      iw_p2 = wid_pushg(iw_rowcol, (Widget)0,
                   " Display Averaged Image:",comapmen2_but,"2",0,0);  

      /* create a push button for saving averaged image */
      iw_p3 = wid_pushg(iw_rowcol, (Widget)0,
                   "   Store averaged Image:", comapmen5,"0",0,0);  

      /* create a push button for clearing mask */
      iw_p4 = wid_pushg(iw_rowcol, (Widget)0,
                   "            New Masking:",comapmen2_but,"4",0,0);  

      /* create a push button for clearing mask */
      iw_p6 = wid_pushg(iw_rowcol, (Widget)0,
                   "       Continue Masking:",comapmen2_but,"5",0,0);  

      /* create a toggle box for overlaping image & mask */
      ovrlap = TRUE;
      iw_p7 = wid_toggleg(iw_rowcol,(Widget) 0,
                              "Overlap Avg. Im. & Mask:",
                              ovrlap,ovrlap_cb,(caddr_t) &ovrlap,-1,-1);
      
      /* create a push button for stop */
      iw_p5 = wid_pushg(iw_rowcol, (Widget)0,
                   "           Stop Mapping:",comapmen2_buts,"0",0,0);
      }

  XtManageChild(iw_comapmen2);
  
  /* enable all planes for drawing or replacing exposure */
  wisetplanes(idispl,icontx,-1);

  /* unassign buttons */
  XtUninstallTranslations(iw_win);

  /* remove instructional message */
  showbutx("","","",TRUE);
  
  return;
} /* end of comapmen2 function */

/***************************** comapmen2_but *************************/
/*
**	Display button
*/

void comapmen2_but(Widget iw_t, caddr_t data, caddr_t callpar)
  {  
  char *oper;
  int it;
  char ops[] = "12345";

  /* remove menu widget */
  XtUnmanageChild(iw_comapmen2);

  /* refresh screen */
  expos_cb(NULL,NULL,NULL);

  /* itag=2 calculates and displays averaged image
     itag=4 do not clear masks, continue masking
     itag=5 clears masks then continue masking */
  oper = data;
  it = (int) (strchr(ops,*oper) - ops) + 1;
  comapsav(it);

  }  /* end of comapmen2_but */

/***************************** ovrlap_cb *************************/
/*
**	overlap toggle  button
*/

 void  ovrlap_cb(Widget iw_temp, caddr_t data, caddr_t call_data)
 {
   ovrlap = XmToggleButtonGadgetGetState(iw_temp); 
 }

/***************************** comapmen2_buts *************************/
/*
**	Stop button
*/

void comapmen2_buts(Widget iw_t, caddr_t itag, caddr_t callpar)
  {      
  /* remove menu widget */
  XtUnmanageChild(iw_comapmen2);

  /* flush buffer to reset the luts */
  XFlush(idispl);
 
  /* free the space used in comap.c */
  free(bufx);
  free(bufy);
  free(nkey);
  if(icontmx) XFreeGC(idispl,icontmx);
  if(msksav) 
      { XFreePixmap( idispl, msksav ); msksav = 0; }
  
  } /* end of comapmen2_buts */
