
/*$Header: /net/ithaca/usr1/web/src/RCS/dispmen.c,v 1.5 1995/07/11 17:28:11 mladjadj Exp $*/
/*
C++************************************************************************
C
C dispmen -- created Feb 94
C
C **************************************************************************
C *  AUTHOR:  ArDean Leith                                                 *
C *  COPYRIGHT (C)1994,  WADSWORTH CENTER FOR LABORATORIES AND             *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH			           *
C **************************************************************************
C
C    dispmen
C
C    PURPOSE:         SET VARIOUS PARAMETERS RELATING TO DISPLAY
C
C    VARIABLES:       
C
C    CALLED BY:       WEB_COM
C      
C***********************************************************************
*/

#include "common.h"
#include <Xm/ToggleBG.h>
#define MAX_ARGS     3
#include "routines.h"


 /* internal function prototypes */
 void          dispmen_buta(Widget, caddr_t, caddr_t);

 /* common variables */
 extern Widget    iw_scrollpar;     /* scroll window widget */

 /* local file variables */
 static Widget  iw_wantscroll;
 static int     wantscroll = TRUE;
 static Widget  iw_dispmen = (Widget)0;

 /*************************  dispmen  ********************************/

 void dispmen(Widget iw_temp, caddr_t data, caddr_t call_data)
 { 
 Widget   iw_rowcol, iw_dums, iw_dum, iw_pushc, iw_pusha;


 if (iw_dispmen <= (Widget)0)
    {   /* create widget first */

    iw_dispmen = wid_dialog(iw_win,iw_dispmen,
                             "display options",20,20);
    iw_rowcol   = wid_rowcol(iw_dispmen,'v',-1,-1);

    /* create toggle box ------------------------------ wantscroll    */
    iw_wantscroll = wid_togmen(iw_rowcol,0,"Scrolling data window",
                             wantscroll,0,0);

    /* create accept boxes  ----------------------------------- apply */
    iw_pushc = (Widget) 0;
    iw_pusha = (Widget) 0;
    iw_dum   = wid_stdbut(iw_rowcol, iw_dispmen, &iw_dums, &iw_pushc, 
                      &iw_pusha,"CA",fin_cb,fin_cb,dispmen_buta, NULL);
    }

 XtManageChild(iw_dispmen);
 }


 /************ accept button callback *********************************/

 void dispmen_buta(Widget iw_temp, caddr_t data, caddr_t call_data)
 {
 int    n, scrolling;
 Arg      args[MAX_ARGS]; 


 /* find if there has been any change in demand for scrolling widget */
 scrolling    = wantscroll;
 wantscroll   = XmToggleButtonGadgetGetState(iw_wantscroll);

 /* remove the menu widget */
 XtUnmanageChild(iw_dispmen);

 if (wantscroll && !scrolling)
    {  /* replace scroll window */

    XtManageChild(iw_scrollpar);

    n = 0;
    XtSetArg(args[n], XmNbottomWidget, iw_scrollpar);        n++;
    XtSetArg(args[n], XmNbottomAttachment, XmATTACH_WIDGET); n++;
    XtSetValues(iw_win, args, n);  
    }

 else if (!wantscroll && scrolling)
    {  /* remove scroll window   */
    n = 0;
    XtSetArg(args[n], XmNbottomAttachment, XmATTACH_FORM); n++;
    XtSetValues(iw_win, args, n);  
    XtUnmanageChild(iw_scrollpar);
    }

 }


