
/*$Header: /net/ithaca/usr1/web/src/RCS/dispsize.c,v 1.6 1995/08/21 15:36:38 leith Exp $*/

/***********************************************************************
 *
 * dispsize.c
 *
 ***********************************************************************
 * author : ArDean Leith
 * COPYRIGHT (C)1993, WADSWORTH CENTER FOR LABORATORIES AND
 * RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      
 * THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     
 * LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  
 * USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF 
 * THE CENTER FOR LABORATORIES AND RESEARCH 			  
 ***********************************************************************
 *
 * dispsize()
 * 
 * PURPOSE:    finds size of subimage given window from original image
 *
 * RETURNS:    true or false
 *
 * PARAMETERS: 
 *
 ***********************************************************************
*/

 /****************************  dispsize  *****************************/
 
#include <math.h>

 void dispsize(int nsam1t,  int nsam2t, 
               int nrow1t,  int nrow2t, 
               int nslice1t,int nslice2t, int iskipt,
               int * nsams, int * nrows, int * nslices)

 { 
 /* find number of rows in displayed image */
 if (iskipt > 1) 
    {
    *nsams   = ceil((float)(nsam2t - nsam1t + 1) / (float) iskipt);
    *nrows   = ceil((float)(nrow2t - nrow1t + 1) / (float) iskipt);
    *nslices = (nslice2t - nslice1t + 1) ;
    }
 else if (iskipt < -1)
    {
    *nsams   = (nsam2t     - nsam1t + 1) * -iskipt;
    *nrows   = (nrow2t     - nrow1t + 1) * -iskipt;
    *nslices = (nslice2t - nslice1t + 1) ;
    }
 else
    {
    *nsams   = (nsam2t   - nsam1t   + 1);
    *nrows   = (nrow2t   - nrow1t   + 1);
    *nslices = (nslice2t - nslice1t + 1);
    } 

 return;
}

