
/*$Header: /net/ithaca/usr1/web/src/RCS/docmontmen.c,v 1.8 1997/02/26 15:05:36 leith Exp $*/
/*
C++************************************************************************
C
C DOCMONTMEN -- CREATED JUNE 91 FROM WIMONT
C          -- CONVERTED TO C  -- OCT 92 al
C **************************************************************************
C *  AUTHOR:  ArDean Leith                                                 *
C *  COPYRIGHT (C)1991, WADSWORTH CENTER FOR LABORATORIES AND              *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH			           *
C **************************************************************************
C
C DOCMONTMEN
C
C PURPOSE:         DISPLAY MONTAGE MENU FOR 2-D FILES
C
C VARIABLES:       NAMES      LOGICAL FLAG TO PRINT NAMES
C                  IXUL,IYUL  UPPER LEFT CORNER FOR LAST IMAGE
C                  MARX,MARY  X & Y MARGINS FOR MONTAGE
C
C CALLED BY:   
C
C web_com --> imagemen --> imagemen_cb --> imagemen_cb_com
C                                               v
C                                               v
C  mont2 <-- imagemen1 <-- docmontmen_buta  <-- docmontmen
C
C**************************************************************************
*/

#include <Xm/Text.h>
#include <Xm/ToggleBG.h>

#include "common.h"
#include "routines.h"

 /* internal function prototypes */
 void     docmontmen_buta(Widget, XtPointer, XtPointer);
 void     docmontmen_a(Widget,    XtPointer, XtPointer);

 /* file variables */
 static Widget   iw_regno, iw_template, iw_nprow, iw_movie;
 static Widget   iw_average, iw_avgnam;
 static Widget   iw_ixul, iw_iyul;
 static Widget   iw_docmontmen = (Widget) 0,  iw_pusha;
 static int      regno = 1;
 static char     *filnewdoc;
 static char     filnewimg[128];
 
 /* externally used variables (for use in mont2) */
 int * docimgnums;
 int   docimgtotal;
 int   montaverage = FALSE;
 char  avgnam[128];

 /* externally defined variables (for use in mont2) */
 extern char   filego[81];     /* name of first image in montage   */

 /**************************  docmontmen  **********************/

 void docmontmen(char * filnewt)
 { 
 Widget iw_rowcol, iw_rowcol3;
 Widget iw_dums;
 char   cval[9];
 char * cdum = 0;

 /* remember doc file name */
 filnewdoc = filnewt;

 if (iw_docmontmen == (Widget)0)
    {   /* create doc montage menu widget first */

    iw_docmontmen = wid_dialog(iw_win, 0, "montage parameters", -1, -1);
    iw_rowcol     = wid_rowcol(iw_docmontmen, 'v', -1, -1);

    sprintf(cval,"%2d",regno);
    iw_regno = wid_textboxb(iw_rowcol,0,"Register number:",cval,2);

    /* create text box image file template ----------------- template */
    strcpy(cval,"AVG***");
    iw_template = wid_textboxb(iw_rowcol, 0, "Image file template:", cval,32);

    /* create label box for location ----------------------- location */
    iw_rowcol3  = wid_rowcol(iw_rowcol,'h',-1,-1);
                  wid_labelg(iw_rowcol3,0, "LOCATION:",-1,-1);


     /* create text boxes for ixuln & iyuln -------------------- ixuln */
    if (keepxy) 
       { /* do not want to reset ixuln & iyuln */
       sprintf(cval,"%4d",ixuln);
       iw_ixul = wid_textboxb(iw_rowcol3,0,"X",cval,4);
       sprintf(cval,"%4d",iyuln);
       iw_iyul = wid_textboxb(iw_rowcol3,0,"Y",cval,4);
       }
    else
       {
       iw_ixul = wid_textboxb(iw_rowcol3,0,"X","*",4);
       iw_iyul = wid_textboxb(iw_rowcol3,0,"Y","*",4);
       }

     /* create text box for pictures / row input --------------- nprow */
    strcpy(cval,"*AS FITS");
    iw_nprow = wid_textboxb(iw_rowcol, 0, "Frames / Row:", cval,8);

    /* create toggle box for movie ---------------------------- movie */
    iw_movie = wid_togmen(iw_rowcol,0,"Movie",movie,-1,-1);

    /* create toggle box for average -------------------- montaverage */
    iw_average = wid_toggleg(iw_rowcol,0,"Compute average",
                         montaverage,docmontmen_a,cdum,-1,-1);

    /* create text box for doc file name input  -------------- avgnam */
    iw_avgnam = wid_textboxb(iw_rowcol,0,"Average file:", avgnam,32);
    XtSetSensitive(XtParent(iw_avgnam), montaverage);

    /* create box for apply ----------------------------------- apply */
    wid_stdbut(iw_rowcol, iw_docmontmen, &iw_dums, &iw_dums, 
                        &iw_pusha,  "CA",
                        fin_cb, fin_cb ,docmontmen_buta, NULL);
    }
else
    {   /* montage menu widget already exists, update it */
    /* update text boxes for ixuln & iyuln -------------------- ixuln */
    if (keepxy) 
       { /* do not want to reset ixuln & iyuln */
       sprintf(cval,"%4d",ixuln);
       iw_ixul = wid_textboxb(iw_rowcol3,iw_ixul,"X",cval,4);
       sprintf(cval,"%4d",iyuln);
       iw_iyul = wid_textboxb(iw_rowcol3,iw_iyul,"Y",cval,4);
       }
    else
       {
       iw_ixul = wid_textboxb(iw_rowcol3,iw_ixul,"X","*",4);
       iw_iyul = wid_textboxb(iw_rowcol3,iw_iyul,"Y","*",4);
       }

    /* update text box for pictures / row input --------------- nprow */
    if (samefile)  
       sprintf(cval,"%4d",nprow);
    else
       strcpy(cval,"*AS FITS");
    iw_nprow = wid_textboxb(iw_rowcol, iw_nprow, "FRAMES / ROW:", 
                            cval,8);
    }

XtManageChild(iw_docmontmen);
 }

 /************** docmontmen_a (montaverage toggle callback) ***********/

 void docmontmen_a(Widget iw_temp, XtPointer data, XtPointer call_data)
 {
 montaverage = XmToggleButtonGadgetGetState(iw_average);
 XtSetSensitive(XtParent(iw_avgnam),montaverage);
 }

 /***********  docmontmen_buta  (accept button callback) ********/

 void docmontmen_buta(Widget iw_temp, XtPointer data, XtPointer call_data)
 {
 char        *string   = NULL;
 char        *template = NULL;
 int         maxreg, maxkeys, i;
 float       *dbuf = NULL;
 int         marlefo;

 /* find register number */
 string = XmTextGetString(iw_regno);

 if (sscanf(string,"%d",&regno) <= 0 || regno < 1 || regno > 6) 
       {   /* invalid regno */
       spout("*** Register number must be 1...6!! ");
       if (string) XtFree (string); return;
       }
 if (string) XtFree (string);

 /* find image file name template, put it in filego for mont2 */
 template = XmTextGetString(iw_template);
 strcpy(filego,template);
 if (!addext(filego, datexc, 81)) return;

 /* find next image postion (if set)  */
 if (getcorner(iw_ixul,iw_iyul,&ixuln,&iyuln) == FALSE) 
    {   /* can not interpret image position */
    spout("*** Can not interpret image location! ");
    return;
    }

 /* interrogate movie toggle */
 movie = XmToggleButtonGadgetGetState(iw_movie);
 
 /* find nprow value (number of images per row) */
 string = XmTextGetString(iw_nprow);

 if (sscanf(string,"%d",&nprow) <= 0 || nprow == 0) 
    {  /* use default for nprow */

    /* adjust marlefo for lef side position */
    marlefo = marlef;
    if (placed) marlefo = ixuln;

    if (iskip > 1)
       nprow = (iwidex - marlefo) / ((nsam / iskip)  + marx);
    else if (iskip < -1)
       nprow = (iwidex - marlefo) / ((nsam * -iskip) + marx);
    else
       nprow = (iwidex - marlefo) / ((nsam         ) + marx);
    }

 if (string) XtFree (string);

 montaverage = XmToggleButtonGadgetGetState(iw_average);                   
 if (montaverage) 
    {
    string = XmTextGetString(iw_avgnam);
    if (strlen(string) <= 0) 
       {
       pop_errmsg("*** You must enter a filename.");
       return;
       }
    else if (strlen(string) >= 128) 
       {
       pop_errmsg("*** Average file name too long.");
       return;
       }

    strcpy(avgnam,string);
    XtFree(string);
    }

 /* remove the montage menu */
 XtUnmanageChild(iw_docmontmen);
 expos_cb(NULL,NULL,NULL);

 /* recover doc file data */

 /* set size for dbuf array */
 maxreg = regno+1; maxkeys = 9999;

 if (getdoc((FILE *) NULL, filnewdoc, NULL, maxkeys, maxreg, 
             &dbuf, &docimgtotal) > 0) 
    {   /* problem retrieving doc file data */
    if (dbuf) free(dbuf); dbuf = NULL;
    return;
    }

 /* run time allocation of memory space for buf */
 if ((docimgnums = (int *) malloc(docimgtotal * sizeof(int))) == 
     (int *) NULL)
     {spout("*** Memory allocation failed in docmontmen!"); 
     if (dbuf) free(dbuf); dbuf = NULL; 
     if (template) free(template); return; }

 /* make integer array for image numbers */
 for (i=0; i < docimgtotal; i++)
    {
    docimgnums[i] = * (dbuf + i * maxreg + regno);
    }

 if (dbuf) free(dbuf);

 /* create file name for first file in series (filnew) */
 filget(template,filnewimg,127,docimgnums[0]);
 if (template) free(template);

 if (!addext(filnewimg, datexc, 128))return;

 /* call imagemen1 to activate montage display */
 imagemen1(filnewimg, FALSE);

 /* cancel waitcursor */
 waitcursor(iwin, FALSE, 79);
 }


