
/*$Header: /alwyn/usr1/web//RCS/expos_cb.c,v 1.2 94/02/14 12:44:00 leith Exp $*/
/*
 * expos_cb.c
 *
 ***********************************************************************
 * COPYRIGHT (C)1992, WADSWORTH CENTER FOR LABORATORIES AND
 * RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      
 * THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     
 * LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  
 * USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF 
 * THE CENTER FOR LABORATORIES AND RESEARCH 			  
 ***********************************************************************
 *
 * expos_cb(
 * 
 * PURPOSE:     handles exposures on draw window 
 *
 * RETURNS:     void
 * 
 * PARAMETERS:     
 *
 ***********************************************************************
*/

#include "x.h"
#include "std.h"

 extern Display        *idispl;
 extern Drawable       iwin, imagsav;
 extern unsigned int   iwidex, ihighx;
 extern int            ixulx,iyulx;
 extern GC             icontx, icontxb;
 extern int            drawing;

 unsigned int iwidexb = 0;
 unsigned int ihighxb = 0;

 void   spout(char *);

/**********************  expos_cb **********************************/

 void expos_cb(Widget iw_temp, caddr_t data, caddr_t call_data)

 { 

 Window       iroot;
 unsigned int iwidext,ihighxt,iborder,idepth,ixd,iyd;
 Pixmap       imagsavn;


 if (XGetGeometry(idispl,iwin,&iroot,&ixulx,&iyulx,&iwidext,&ihighxt,
                  &iborder,&idepth) == 0) 
     spout("*** Error getting geometry in expos_cb");

 if (iwidext > iwidexb || ihighxt > ihighxb)
    {
    /* need to enlarge backing store for images */

    imagsavn = XCreatePixmap(idispl,iroot,iwidext,ihighxt,idepth);
    if ((int) imagsavn <= 0)  
      { 
      spout("*** Can not create new backing store!");
      return;
      } 
    
    /* copy old backing store to new backing store */
    ixd = MYMIN(iwidexb,iwidext);
    iyd = MYMIN(ihighxb,ihighxt);
    XCopyArea(idispl,imagsav,imagsavn,icontx,0,0,ixd,iyd,0,0);
    XFreePixmap(idispl,imagsav);
    imagsav = imagsavn;

    iwidexb = iwidext;
    ihighxb = ihighxt;
    }

 if (iwidext != iwidex || ihighxt != ihighx)
       {  /* size of window changed but not larger than backing store */
       /* remember size of current image window */
       iwidex = iwidext;
       ihighx = ihighxt;
       }

 /* copy backing store to image window */
 XCopyArea(idispl,imagsav,iwin,icontx,0,0,iwidex,ihighx,0,0); 
 XFlush(idispl);

 drawing = FALSE;

 return;
 }



#ifdef NEVER

    if ((int)icontxb <= 0)
      { /* need to create a new graphics context for blanking */
      icontxb = XCreateGC(idispl,iwin,0,&gcval);
      XCopyGC(idispl,icontx,0,icontxb);
      }
    /*********************
    XSetForeground(idispl,icontx,icolorxb);
    wifillr(imagsavn,icontb,0,0,iwidext,ihighxt) *************/
       /********** reset scroll bar position
       XtSetArg(args[0], XmNx,  iwidex-17);
       XtSetValues(iw_vers,args,1);  ***************/

#endif
