/*$Header: /net/ithaca/usr1/web/src/RCS/filget.c,v 1.10 1997/02/24 20:38:19 leith Exp $*/

/*
C++*************************************************************************
C
C FILGET  -- CREATED JAN 89
C            CONVERTED TO C -- JULY 92 al
C
C *********************************************************************
C *  COPYRIGHT (C)1992,1996  HEALTH RESEARCH INC, EMPIRE STATE PLAZA, *
C *    ALBANY, NY 12201.  THE CONTENTS OF THIS DOCUMENT ARE           *
C *    PROPRIETARY TO HEALTH RESEARCH INC., AND ARE NOT TO BE         *
C *    DISCLOSED TO OTHERS OR USED FOR PURPOSES OTHER THAN INTENDED   *
C *    WITHOUT WRITTEN APPROVAL OF HEALTH RESEARCH INC.               *
C *********************************************************************
C
C    FILGET
C
C    PURPOSE:        USED TO CREATE FILENAME FROM 
C                    FILE-NAME TEMPLATE AND ARRAY OF FILE NUMBERS.
C
C    PARAMETERS:     FILPAT    CHAR. FILE NAME PATTERN (NEEDED)
C                    FILNAM    CHAR. FILE NAME         (RETURNED)
C                    MAXLEN    MAX LENGTH FOR FILNAM   (NEEDED)
C                    INUM      FILE NUMBER             (NEEDED)
C
C    RETURNS:        IRTFLG    ERROR FLAG (0 IS ERROR, 2 IS ALL OK)
C
C--*************************************************************************
*/

#include "std.h"
#include "routines.h"

 extern char           datexc[4];         /* file extension           */
 extern char           dirnow[81];        /* current directory        */
  
/************************  filget  *********************************/

 int filget(char * filpat, char * filnam, int maxlen, int inum)

 { 
 char   *dot, dataext[5]=".";
 long   igo, numast, nlet, locast, numi;
 int    ierflg;

 /* find if there is an extension */
 strcat(dataext,datexc);
 dot = strstr(filpat,dataext);
 
 /* normal return is 2 */
 ierflg = 2;

 nlet   = strlen(filpat);

 /*  find location of first * in filpat */
 if ((locast = strcspn(filpat,"*")) == nlet)
    { /* no * in template, find run of digits at end */

    /* skip extension at end of filename (if any) */
    if (dot) nlet = nlet - strlen(dot);

    for (locast=nlet-1; locast >=  0; locast--)
       if (! isdigit(*(filpat+locast)))
       {
       locast++;
       break;
       }

    numast = 1;
    }
 else
    {  /* has *(s)  in filpat (template)  */

    /* skip extension at end of filpat (if any) */
    if (dot) nlet = nlet - strlen(dot);

    numast = nlet - locast;
    }

 /* find number of digits in file number. (must be >= numast) */
 if (inum > 0)
    numi = MYMAX(((int) log10((float) inum) + 1.0),(numast));
 else
    numi = 1;

  
 /* find 1st char in filpat that will be altered */
 igo = nlet - numi;

 if (igo < 0)
    {
    spouts("*** FILE NUMBER: ");            spouti(inum);
    spouts("*** DESTROYS FILE TEMPLATE: "); spout(filpat);
    return 0;
    }

 if (igo < locast)
    {
    /*    printf("igo: %d, locast: %d, numi: %d, inum: %d \n",
                igo,     locast,      numi,   inum); */
    spouts("WARNING, FILE NUMBER: ");    spouti(inum);
    spouts("MAY ALTER FILE TEMPLATE: "); spout(filpat);
    ierflg = 1;
    }

 if (strlen(filpat) >= (size_t) maxlen)
    {
    spouts("*** Filename too long in filget: "); spout(filpat);
    return 0;
    }
 strcpy(filnam,filpat);

 if (sprintf(&filnam[igo],"%0*.*d",numi,numi,inum) < 0) 
    return 0;
 if (dot) strcat(filnam,dataext);

 return ierflg;
 }

