
/*$Header: /alwyn/usr1/web/RCS/filinc.c,v 1.1 93/11/10 10:11:28 leith Exp $*/
/*
C++*************************************************************************
C
C  FILINC
C             CONVERTED TO C -- JULY 92 al
C                                                             
C **************************************************************************
C *  COPYRIGHT (C)1992, WADSWORTH CENTER FOR LABORATORIES AND              *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH                            *
C **************************************************************************
C
C    FILINC(FILOLD,FILNEW,NLET,NUMFIL)
C
C    PURPOSE:       INCREMENTS AN OLD FILENAME IF POSSIBLE
C
C    PARAMETERS:    FILOLD       OLD FILE NAME                 READ
C                   FILNEW       NEW FILE NAME                 WRITE
C                   NLET         NUMBER CHAR IN FILNEW         WRITE
C                   NUMFIL       NUMBER USED FOR FILE          WRITE
C
C
C   RETURNS         IRTFLG       ERROR FLAG                    
C                                2 = NORMAL
C                                1 = EATS INTO OLD FILENAME
C                                0 = FILENAME LACKED INCREMENTALBE NUMBER
C
C    CALLED BY:     MONT2
C
C--*********************************************************************
*/

#include "files.h"


 /************************  filinc  ************************************/

 int filinc(char * filold, char * filnew, int * nlet, int * numfil)

 { 
 int    ival, errflg, carry1;
 char   ctemp;
 char * cptr, * pext;

 strcpy(filnew,filold);

 /* skip extension at end of filename (if any) */
 if ((pext = strrchr(filnew,'.')) != (char *) NULL)
     *nlet  = (int) (pext - filnew);
 else
     *nlet = strlen(filnew);  


 if (*nlet  <= 0)
    {
    /* empty filename, can not increment name */
    strcpy(filnew,NULL);
    *nlet   = 0;
    *numfil = 0;
    return 0;
    }


 /* CREATE NEW FILE NAME BY INCREMENTING NUMBER AT END OF OLD FILE NAME */

 /* since we are incrementing there is a carry of one to last digit */
 carry1 = TRUE;

 /* set no error flag for return */
 errflg = 2;

 /* go backwards thru filename looking at each character */

 for (cptr = filnew + *(nlet) -1; cptr>=filnew; cptr--)
   {
   ctemp = *cptr;

   if (isdigit(ctemp)) 
      {    /* the character is a digit */
      ival  = atoi(cptr);
      if (carry1) 
         {
         ctemp++;
         carry1 = FALSE;
         if (ctemp > '9') 
            {
            carry1 = TRUE;
            ctemp  = '0';
            }   /* endif ctemp */
         *cptr  = ctemp;
         }    /* endif carry1 */
      }    /* endif isdigit */

   else 
      {  /* character is not a digit */
      if (carry1)
         {
         ctemp  = '1';
         *cptr  = ctemp;
         errflg = 1;
         carry1 = FALSE;
         }   /* endif carry1 */
      break;
      }   /*  endif else */
   }   /* endfor */


 /* if there is still a carry of one then can not increment filename */
 if (carry1)
    errflg = 0;

 /* return with new file number */
 *numfil = ival;

 return errflg;
 }
