
/*$Header: /net/alwyn/usr1/web/src/RCS/filterskel.c,v 1.1 94/09/29 10:11:41 leith Exp $*/

/***********************************************************************
 *
 * filterskel.c
 *
 ***********************************************************************
 * author : ArDean Leith
 * COPYRIGHT (C)1993, WADSWORTH CENTER FOR LABORATORIES AND
 * RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      
 * THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     
 * LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  
 * USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF 
 * THE CENTER FOR LABORATORIES AND RESEARCH 			  
 ***********************************************************************
 *
 * filterskel()
 * 
 * PURPOSE:    findis skeleton of a binary image.
 *
 * RETURNS:    true or false
 *
 * PARAMETERS: 
 *
 ***********************************************************************
*/

#include "std.h"
#ifndef VMS
#include "float.h"
#endif
#include "routines.h"
#include "common.h"

 static char*    cimage     = NULL;

 /******************************  filtere *****************************/

 int filterskel(float * oldimage, int nsamt, int nrowt, 
             float * newimage, float * fmint, float * fmaxt)
 {
 int     ix, iy,   ipixel;
 int     icon3, iloc, diffpixel, iok;
 float * tmpimage;
 float * eroded;
 float * dilated;
 float * ploc;
 float   fmino,fmaxo;

 fmino = * fmint;
 fmaxo = * fmaxt;

 /* allocate tmpimage, eroded, dilated */
 if ((tmpimage = (float *) malloc(nsamt * nrowt *
                      sizeof(float))) == (float *) 0)
    {spout(" *** Unable to allocate tmpimage in filterskel.");
     return FALSE;}

 if ((eroded = (float *) malloc(nsamt * nrowt *
                      sizeof(float))) == (float *) 0)
    {spout(" *** Unable to allocate eroded in filterskel."); 
     return FALSE;}

 if ((dilated = (float *) malloc(nsamt * nrowt *
                      sizeof(float))) == (float *) 0)
    {spout(" *** Unable to allocate dilated in filterskel."); 
     return FALSE;}

 /* copy oldimage to tmpimage */
 memcpy((void *) tmpimage,(void *) oldimage, nsamt*nrowt*4);
 
 /* set newimage to zero */
 for (ploc = newimage; ploc < newimage + (nsamt * nrowt); ploc++)
     {
     *ploc = 0.0;
     }

 /* convolve over all positions in the new image except border */
 diffpixel = TRUE;

 while (diffpixel) 
    {  
    diffpixel = FALSE;

    iok = filtere(tmpimage, nsamt, nrowt, TRUE, 7, *fmaxt,
                  eroded , fmint, fmaxt);

    iok = filtere(eroded, nsamt, nrowt, FALSE, 0, *fmaxt,
                  dilated , fmint, fmaxt);

    for (iy = 1; iy < nrowt - 1; iy++)
       {
       icon3 = iy * nrowt;

       for (ix = 1; ix < nsamt - 1; ix++)
          {
          iloc           = icon3 + ix;
          ipixel         = tmpimage[iloc] - dilated[iloc];
          newimage[iloc] = (int) newimage[iloc] | ipixel;
          /*  if (ipixel > 0) diffpixel = TRUE;  */
          if (eroded[iloc] > 0.0) diffpixel = TRUE;
          tmpimage[iloc] = eroded[iloc];
          }
       }

    /***
     showbimage(newimage, FALSE, &cimage, FALSE, &imagel, 
                nsamt, nrowt, fmino, fmaxo);
    **********/
    } 

 *fmint = fmino;
 *fmaxt = fmaxo;

 if (tmpimage) free(tmpimage); tmpimage = NULL;
 if (eroded)   free(eroded);   eroded = NULL;
 if (dilated)  free(dilated);  dilated = NULL;

 return TRUE;
 }


