
/*$Header: /net/ithaca/usr1/web/src/RCS/filtestb.c,v 1.2 1996/08/05 18:07:57 leith Exp $*/

/*
C++*********************************************************************
C
C filtestb
C
C **********************************************************************
C *  AUTHOR:  ArDean Leith                                                 *
C *  COPYRIGHT (C)1993, WADSWORTH CENTER FOR LABORATORIES AND              *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH                            *
C **********************************************************************
C
C    filtestb
C
C    PURPOSE:         replaces outvals with distance to nearest inval
C
C    CALL TREE:
C                  
C    imagemen -- imagemen_cb  -- imagemen1-- filtermen --> filtestb 
C
C***********************************************************************
*/

#include "common.h"
#include "routines.h"

 /* external global variables used here */

 /* common global used elsewhere */

 /* common variables used here */


/******************************  filtestb *****************************/

 int filtestb(float * oldimage, int nsamt, int nrowt,
              float   in,        float out, 
              float * newimage, float * fmint, float * fmaxt)
 {
 int     iloc, nsizei, nsizeo, xot, yot, ipointo,ipointi, inval, outval;
 int     * xo = 0, * yo = 0, * xi = 0, * yi = 0, * ic = 0;
 float   dist, distmin, distmax;

 /* this could be speeded up but it is a one shot pgm, so not worth it*/
 nsizei  = -1;
 nsizeo  = -1;

 ipointo = -1;
 ipointi = -1;

 for (iloc = 0; iloc < nsamt * nrowt; iloc++)
     {
     /* fill newimage with negatives  */
     newimage[iloc] = -1.0;

     if (oldimage[iloc] == out) 
        {
        if ((++ipointo) > nsizeo)
           {  /* must get more array memory  */
           nsizeo += 1000;

           if (((xo = (int *) realloc(xo,nsizeo * sizeof(int))) == (int) 0) ||
               ((yo = (int *) realloc(yo,nsizeo * sizeof(int))) == (int) 0) ||
               ((ic = (int *) realloc(ic,nsizeo * sizeof(int))) == (int) 0))
                { 
                spout("*** Unable to alloc outer arrays in filtestb.c.");
                return FALSE;
                }
           }
        xo[ipointo] = iloc / nsamt;
        yo[ipointo] = iloc % nsamt;
        ic[ipointo] = iloc;
        }

     else if (oldimage[iloc] == in)
        {
        if ((++ipointi) > nsizei)
           {  /* must get more array memory  */
           nsizei += 1000;
           if (((xi = (int *) realloc(xi,nsizei * sizeof(int))) == (int *) 0) ||
               ((yi = (int *) realloc(yi,nsizei * sizeof(int))) == (int *) 0))

                { 
                spout("*** Unable to realloc inner space in filtestb.c.");
                return FALSE;
                }
          }

        xi[ipointi] = iloc / nsamt;
        yi[ipointi] = iloc % nsamt;
        }
     }

 distmax = (nsamt + nrowt) * (nsamt + nrowt);
 *fmaxt  = -distmax;

 for (outval =0; outval <= ipointo; outval++)
     {
     distmin = distmax;

     xot     = xo[outval]; 
     yot     = yo[outval];

     for (inval =0; inval <= ipointi; inval++)
         {
         dist = ((xot - xi[inval]) * (xot - xi[inval]) +
                 (yot - yi[inval]) * (yot - yi[inval]));

         if (dist < distmin) distmin = dist;
         }
     distmin              = sqrt(distmin);
     newimage[ic[outval]] = distmin;
     *fmaxt               = MYMAX(*fmaxt,distmin);
     }

  * fmint = -1.0;

  if (xo) free(xo);
  if (xi) free(xi);
  if (yo) free(yo);
  if (yi) free(yi);
  if (ic) free(ic);

  return TRUE;
  }


