
/*$Header: /net/ithaca/usr1/web/src/RCS/fitdocmen.c,v 1.16 1996/06/13 18:47:18 leith Exp $*/

/*
C++*************************************************************************
C
C  fitdocmen.c          May 93 al
C
C **************************************************************************
C    AUTHOR:  ArDean Leith                                                 *
C *  COPYRIGHT (C)1993, WADSWORTH CENTER FOR LABORATORIES AND              *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH                            *
C **************************************************************************
C
C    fitdocmen()
C
C    PURPOSE:    Inputs doc file name for particle picking and then
C                returns to particle picker
C
C    PARAMETERS: none   
C
C    CALLed BY:  pickp      
C
C    CALLS:      
C
C--*********************************************************************
*/
#include "common.h"
#include "routines.h"
#include <Xm/Text.h>

 /* internal subroutine prototypes */
 void          fitdocmen_butc(Widget, XtPointer, XtPointer);
 void          fitdocmen_buta(Widget, XtPointer, XtPointer);

 /*  global variables (see pickp) */
 int                nfd   = -1;     /* doc file number         */
 int                iredu = 1;      /* image reduction factor  */
 char               dfil1[12],dfil2[12],dfil3[12],dfil4[12];
 char               dfil5[12],dfil6[12];

 /* external global variables used here */
 extern float       xorg,  yorg;
 extern float       phif, thetaf, gammaff;
 extern int         fitted;

 /* internal file scope variables */
 static Widget     iw_redu, iw_nfd;
 static Widget     iw_fitdocmen= (Widget)0;
 
 /*********************** fitdocmen ********************************/

 void fitdocmen(Widget iw_temp, XtPointer data , XtPointer call_data)

 {
 static Widget iw_rowcolv;
 Widget  iw_pushc, iw_pusha, iw_dums; 
 char    cval[8];

 if (iw_fitdocmen == (Widget)0)
    {   
    /* create marker doc file menu first */

    iw_fitdocmen = wid_dialog(iw_win, 0, "Particle document file", -1,-1);
    iw_rowcolv = wid_rowcol(iw_fitdocmen, 'v', -1, -1);

    /*  create a text box for doc file number input */
    nfd++;
    sprintf(cval,"%4d",nfd);
    iw_nfd = wid_textboxb(iw_rowcolv,0,"Doc file number:",cval,4);

    /*  create a text box for reduction factor input */
    iw_redu = wid_textboxb(iw_rowcolv,0,"Reduction factor:","1",4);

    /* create box for apply  */
    wid_stdbut(iw_rowcolv, iw_fitdocmen, 
                         &iw_pushc, &iw_pushc, &iw_pusha, "CA",
     fitdocmen_butc, fitdocmen_butc ,fitdocmen_buta,NULL);

    }
 else
    {
    /*  create a text box for doc file number input */
    nfd++;
    sprintf(cval,"%4d",nfd);
    iw_nfd = wid_textboxb(iw_rowcolv,iw_nfd,"Doc file number:",cval,4);


    }
 XtManageChild(iw_fitdocmen);
 }

/***********  docfile accept button callback ***********************/

 void fitdocmen_buta(Widget iw_temp, XtPointer data, XtPointer call_data)
 {
 float        fdum;

 /* find redf */
 if (!rdprx(iw_redu,'i',&iredu,&fdum)) return;
 if (iredu < 1) 
    { spout("*** Reduction factor must be >= 1 !"); return; }

 /* find nfd */
 if (!rdprx(iw_nfd,'i',&nfd,&fdum)) return;
 if (nfd < 0 || nfd > 999) 
    { spout("*** Doc. file number range 0 ...999 !"); return; }

 filget("dcu***",dfil1,12,nfd);
 filget("dct***",dfil2,12,nfd);
 filget("dcb***",dfil3,12,nfd);
 filget("duc***",dfil4,12,nfd);
 filget("dtc***",dfil5,12,nfd);
 filget("dft***",dfil6,12,nfd);

 /*  remove doc file menu */
 XtUnmanageChild(iw_fitdocmen);

 /* set x-hairs cursor */
 setacursor(76,-1,-1);

 /* initialize some variables for each run */
 yorg = 0.0; xorg = 0.0;
 fitted = FALSE;
 thetaf = 0.0; gammaff = 0.0; phif = 0.0;

 /* retrieve info from doc files, do not list points, start pickp */
 if (fitdoc(FALSE) > 0)
    { 
    spout("*** Can not continue, fix document files!");
    XBell(idispl,50); XBell(idispl,50); XBell(idispl,50); 
    return;
    }

 /* start picking points now */
 pickp(TRUE);

 }

/*********** docfile cancel button callback ***********************/

 void fitdocmen_butc(Widget iw_temp, XtPointer data, XtPointer call_data)
 {
 /*  remove the menu widget */
 XtUnmanageChild(iw_fitdocmen);

 /* refresh screen to redraw images if damaged */
 expos_cb(NULL,NULL,NULL);
 }

