/*$Header: /net/ithaca/usr1/web/src/RCS/fitorigin.c,v 1.9 1996/04/16 14:25:34 leith Exp $*/

/*
C++************************************************************************
C
C fitorigin
C
C **************************************************************************
C *  AUTHOR:  ArDean Leith                                                 *
C *  COPYRIGHT (C)1993, WADSWORTH CENTER FOR LABORATORIES AND              *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH                            *
C **************************************************************************
C
C    fitorigin()
C
C    PURPOSE:         display origin key setting menu
C
C    CALLED BY:       pickmen_but?
C
C***********************************************************************
*/

#include "common.h"
#include "routines.h"
#include <Xm/Text.h>

 /* internal functions */
 void          fitorigin_buta(Widget, XtPointer, XtPointer);

 /* external common variables used here */
 extern int     maxpart;
 extern float * xu0, * yu0, * xs, * ys;

 /* common variables defined here */
 float          xu0t, yu0t, xs0t, ys0t;
 
 /* internal file scope variables */
 static Widget  iw_fitorigin = (Widget)0, iw_orgkey;
 static int     orgkey;

 /***********************   fitorigin   ******************************/

 void fitorigin(Widget iw_temp, XtPointer data, XtPointer call_data)

 { 
 static Widget iw_rowcolv;
 Widget        iw_pushs,iw_dum, iw_pusha;
 char          cval[5];

 if (iw_fitorigin == (Widget)0)
    {   /* create fitorigin menu widget first */

    iw_fitorigin = wid_dialog(iw_win, 0, "Origin key menu", -1, -1);
    iw_rowcolv   = wid_rowcol(iw_fitorigin, 'v', -1, -1);

    /* create text box for origin key ------------------  origin key */
    orgkey = 1;
    sprintf(cval,"%4d",orgkey);
    iw_orgkey = wid_textboxb(iw_rowcolv,0,"Key number for origin:",
               cval,4);

    /* create box for apply ---------------------------------- apply */
    wid_stdbut(iw_rowcolv, iw_fitorigin, 
                        &iw_pushs, &iw_dum, &iw_pusha,  "SA",
                        fin_cb,fin_cb ,fitorigin_buta, NULL);
    }
 else
    {
    /* create text box for origin key ------------------  origin key */
    sprintf(cval,"%4d",orgkey);
    iw_orgkey = wid_textboxb(iw_rowcolv,iw_orgkey,
                             "Key number for origin:",cval,4);
    }
 XtManageChild(iw_fitorigin);
 }


/***********  origin key set callback ***********************/

 void fitorigin_buta(Widget iw_temp, XtPointer data, XtPointer call_data)
 {

 char *   string;
 char     outmsg[80];

 /* find origin key */
 string = XmTextGetString(iw_orgkey);
 sscanf(string,"%d",&orgkey);
 if (string) free(string);

 /* retrieve points from doc file */
 spoutfile(TRUE);
 if (fitdoc(FALSE) != 0)
    {
    spout("*** Can not fit angles yet!"); XBell(idispl,50);
    spoutfile(FALSE);
    return;
    }

 spoutfile(FALSE);

 if (orgkey > maxpart  || orgkey < 1)
    {sprintf(outmsg,"Bad origin key: %d, Max key available: %d", 
            orgkey,maxpart);
    spout(outmsg); XBell(idispl,50);
    return;
    }

 xu0t = xu0[orgkey-1];
 yu0t = yu0[orgkey-1];
 xs0t =  xs[orgkey-1];
 ys0t =  ys[orgkey-1];

 /*  remove  key menu */
 XtUnmanageChild(iw_fitorigin);

 /* start fitmen menu */
 fitmen();
 }



