
/*$Header: /net/ithaca/usr1/web/src/RCS/fitsav.c,v 1.22 1996/05/07 14:08:35 leith Exp $*/

/*
C++*************************************************************************
C
C    fitsav
C
C **************************************************************************
C *  COPYRIGHT (C)1993, WADSWORTH CENTER FOR LABORATORIES AND              *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH                            *
C **************************************************************************
C
C    fitsav
C
C    PURPOSE:    saves fit angles in dfil3
C                      tilted predicted loactions in dfil6
C
C    CALLED BY:   
C
C **************************************************************************
*/

#include "std.h"
#include "common.h"
#include "x.h"
#include "routines.h"

 /* function prototypes */

 /* external variables used here */
 extern char   dfil3[12], dfil6[12];     /* doc file names     */
 extern int    iredu;                    /* current reduction */
 extern int    fitted;
 extern float  phif, thetaf, gammaff;    /* tilt angles       */
 extern float  xu0t, yu0t, xs0t, ys0t;   /* tilt origins      */
 extern float  * xu0, * yu0, * xs2, * ys2; 
 extern int    lbnum, maxpart;
 extern char   datexc[4];                /* file extension   */    
     
 /*****************************   fitsav   ****************************/

 void fitsav(int limfitt)

 { 
 float          dlist[8];
 FILE           * fpdoc;
 int            i, openit, append_flag;

 /* save fit info in doc file */ 
 dlist[0] = 121;
 dlist[1] = 0.0;
 dlist[2] = 0.0;
 dlist[3] = 0.0;
 dlist[4] = 0.0;
 dlist[5] = limfitt; 
 dlist[6] = lbnum; 
    
 /* dfil3 will be opened and closed here. */

 openit   = TRUE;  /* openit first time to get fpdoc pointer */
 fpdoc    = savdn1(dfil3, datexc, &fpdoc, dlist, 7, &openit, FALSE, TRUE);
 if (!fpdoc) 
    { /* unable to open the doc file!! */
    XBell(idispl,50); XBell(idispl,50);
    return;
    }

 /* set fitted flag */
 dlist[0] = 122;
 dlist[1] = fitted;
 dlist[2] = 0.0;
 dlist[3] = 0.0;
 dlist[4] = 0.0;
 dlist[5] = 0.0;
 dlist[6] = 0.0;
      
 fprintf(fpdoc," ; FITTED flag\n");
 fpdoc    = savdn1(dfil3, datexc, &fpdoc,dlist, 7, &openit, TRUE, TRUE);

 /* set origin */
 dlist[0] = 123;
 dlist[1] = xu0t;
 dlist[2] = yu0t;
 dlist[3] = xs0t;
 dlist[4] = ys0t;
 dlist[5] = iredu; 
 dlist[6] = 0.0;
 
 fprintf(fpdoc," ; X0,Y0 ORIG. IN 0 DEG IM., XS0,YS0 ORIG. IN TILTED IM. REDUCTION FACTOR\n");
 fpdoc    = savdn1(dfil3, datexc, &fpdoc,dlist, 7, &openit, TRUE, TRUE);

 /* set tilt angles */
 dlist[0] = 124;
 dlist[1] = thetaf;
 dlist[2] = gammaff;
 dlist[3] = phif;
 dlist[4] = 0.0;
 dlist[5] = 0.0; 
 dlist[6] = 0.0;
      
 fprintf(fpdoc," ; TILTANGLE, AXIS DIR. IN:  0 DEG IM.  THETA GAMMA PHI\n");
 fpdoc    = savdn1(dfil3, datexc, &fpdoc, dlist, 7, &openit, TRUE, TRUE);

 fclose(fpdoc); fpdoc = NULL;

 if (fitted)
    {
    openit      = TRUE; append_flag = TRUE;

    /* use angles to get predicted location in tilted image  */
    witran(xu0, yu0, xs2, ys2, maxpart, gammaff, thetaf, phif);

    dlist[6] = 1.0; 

    for ( i = 0; i < maxpart; i++)
       {
       /* save predicted right locations in doc file: dfil6 */ 
       dlist[0] = i+1;
       dlist[1] = i+1;
       dlist[2] = xs2[i] * iredu;
       dlist[3] = ys2[i] * iredu;
       dlist[4] = xs2[i];
       dlist[5] = ys2[i];       
       dlist[6] = 0.0;       
   
       fpdoc   = savdn1(dfil6, datexc, &fpdoc,
                         dlist, 7, &openit, append_flag, TRUE);
       if (i == 0) 
          { /* first time thru, will have opened file now */ 
          if (!fpdoc) 
              { /* unable to open the doc file!! */
              XBell(idispl,50); XBell(idispl,50);
              return;
              }
          append_flag = TRUE;
          }
       }
    fclose(fpdoc);
    }
 }

