/*************************************************************************
* changed to fmr_1.c       mahieddine ladjadj   5/25/94
* $$ FMR_1.FOR
*
* **************************************************************************
* *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK            *
* *  COPYRIGHT (C)1981,1987, WADSWORTH CENTER FOR LABORATORIES AND         *
* *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
* *  THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR       *
* *  LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR    *
* *  USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF     *
* *  THE CENTER FOR LABORATORIES AND RESEARCH   			   *
* **************************************************************************
*
*
*
*************************************************************************
*
* 
*/

#include "routines.h"

/********************  fmr_1   ********************************************/

int fmr_1(float * x, int n, float * work, int * inv)
  { 
  /*  inv can be +1 (forward FFT) or -1 (inverse FFT) */
  register int i;
  int irtflg ;

  if ((*inv) > 0)
      {
      for (i = 0; i < n; i++)
          work[i] = 0.0;
      irtflg = fftmcf(x, work, n, n, n, inv);
      if(n%2 > 0) 
          {   /* positive result */
          x[n-1] = x[n/2+1-1];
          for (i = n-2; i >= 3; i -= 2)
               {
               x[i-1]   = x[i/2+1-1];
               x[i+1-1] = work[i/2+1-1];
               }
          x[2-1] = work[n/2+1-1];
          return 0;
          }

      /* n%2 <= 0 */
      work[1-1] = x[n/2+1-1];
      for (i = n-1; i >= 3; i -=2)
          {
          x[i-1]   = x[(i+1)/2-1];
          x[i+1-1] = work[(i+1)/2-1];
          }
      x[2-1] = work[1-1];
      return 0;
      }  /************** if (*inv)  *****************/

  /* (*inv) less or equal to 0 */
  if (n%2 > 0)
      {  /* positive result */
      work[n/2+1-1] = x[2-1]/n;
      work[n/2 + 2-1] = -x[2-1]/n;
      for (i = 2; i <= n/2; i++)
          {
          work[i-1]   = x[2*i-1]/n;
          work[n-i+2-1] = -work[i-1];
          }
      x[1-1] = x[1-1]/n;
      for (i = 2; i <= (n/2+1); i++)
          x[i-1] = x[2*i-1-1]/n;
      for (i = n; i >= n/2+2; i--)
          x[i-1] = x[n-i+2-1];
      }
  else
      {
      work[n/2+1-1] = 0.0;
      for (i = 2; i <= n/2; i++)
          {
          work[i-1]   = x[2*i-1]/n;
          work[n-i+2-1] = -work[i-1];
          }
      work[1-1] = x[2-1]/n;
      x[1-1] = x[1-1]/n;
      for (i = 2; i <= n/2; i++)
          x[i-1] = x[2*i-1-1]/n;
      for (i = n/2+2; i <= n; i++)
          x[i-1] = x[n-i+2-1];   
      x[n/2+1-1] = work[1-1];
      }

  work[1-1] = 0.0;
  irtflg = fftmcf(x, work, n, n, n, inv);
  return 0;

  }   /*****************  end of fmr_1   ***********/
