
/*$Header: /net/ithaca/usr1/web/src/RCS/getcorner.c,v 1.2 1995/02/07 21:45:38 liy Exp $*/
/*
C++************************************************************************
C
C GETCORNER
C
C **************************************************************************
C *  AUTHOR:  ArDean Leith                                                 *
C *  COPYRIGHT (C)1991, WADSWORTH CENTER FOR LABORATORIES AND              *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH                            *
C **************************************************************************
C
C GETCORNER
C
C PURPOSE:         GET LOCATION OF CORNER 
C
C PARAMETERS:      
C                  IXULN,IYULN  UPPER LEFT CORNER FOR THIS IMAGE
C
C CALLED BY:       MONTMEN3   MONTMEN2
C
C***********************************************************************
*/

#include "std.h"
#include "x.h"
#include <Xm/Text.h>

 extern int            placed;            /* image position sent flag    */
 extern unsigned int   ihighx, iwidex;    /* display window dimensions   */
 extern int            nsam,nrow,nslice;  /* image size                  */
 extern int            marlef,martop;     /* left and top window margins */
 extern int            ntop,nbot,nrit;    /* top, bottem & rit side      */
 extern int            marx,mary;         /* x & y image margins         */


 /********************** getcorner  *********************************/

 int getcorner(Widget iw_ixul, Widget iw_iyul, int *ixuln, int *iyuln)

 {   
 char *string;

 placed = FALSE;

 if (iw_ixul > (Widget)0)
    {
    string = XmTextGetString(iw_ixul);

    if (strcmp(string,"*") != 0)
       {  /* find value for ixuln */
       *ixuln = atoi(string);
       placed = TRUE;
       }
    XtFree(string);
    }

 if (iw_iyul > (Widget)0)
    {  /* find value for iyuln */
    string = XmTextGetString(iw_iyul);

    if (strcmp(string,"*") != 0)
      {     /* value is specified for iyuln, use it */
      *iyuln = atoi(string);

      if (placed == FALSE)
         {
         /* ixuln was *, so must set ixuln first */
         if ((nsam + marx + nrit) <= iwidex)
            /* enough width for image in this row of images */
            *ixuln = nrit + marx + 1;
         else
            /* put image at left margin */
            *ixuln = marlef + marx + 1;
         placed = TRUE;
         }
      }
    else if (placed == TRUE)
      /* ixuln is set but iyuln is *, so must default iyuln */
      {
      if ((ntop + nrow + mary) <= ihighx)
         /* enough length for image in this row of images */ 
         *iyuln = ntop;
      else
         /* not enough space on this screen, put image at top */
         *iyuln = martop;
      }
    XtFree(string);
    }

 return TRUE;
 }
 
 /*****     if (*iyuln < 1 || *iyuln > nrow) return FALSE;  ***/

