
/*$Header: /net/ithaca/usr1/web/src/RCS/goldmen.c,v 1.15 1996/07/24 20:18:08 liy Exp $*/
/*
C++*************************************************************************
C
C  WID_GOLDMEN.FOR -- CREATED MAY 91
C  goldmen.c          NOV 92
C
C **************************************************************************
C    AUTHOR:  ArDean Leith
C *  COPYRIGHT (C)1990 , WADSWORTH CENTER FOR LABORATORIES AND             *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH                            *
C **************************************************************************
C
C    GOLDMEN()
C
C    PURPOSE:    displays gold marker selecting menu
C
C    PARAMETERS: none   
C
C    CALLed BY:  web_com      
C
C--*********************************************************************
*/
#include "common.h"
#include "routines.h"

#include <Xm/ToggleBG.h>

 /* internal function prototypes */
 void          goldmen_buts  (Widget, XtPointer, XtPointer);
 void          goldmen_butshf(Widget, XtPointer, XtPointer);
 void          goldmen_butm  (Widget, XtPointer, XtPointer);
 void          goldmen_butum (Widget, XtPointer, XtPointer);
 int           goldmen_mark  (void);
 void          goldmen_tgcb(Widget,caddr_t,caddr_t);
  
 /* external common variables */
 extern Widget iw_dean;
 extern Widget iw_gold;
 extern FILE * fpdocg;
 extern char   docnamg[81];
 extern int    markg;
 extern int    iradg;

 /* internal common variables */
 static Widget iw_goldmen = NULL;
 static Widget iw_num = NULL;

 /***************************   goldmen   ****************************/

 void goldmen(void)

 {
 Widget  iw_rowcolv, iw_pushs, iw_pushc; 

 if (iw_goldmen == (Widget) 0)
    {   /* create marker picking menu first */

    iw_goldmen = wid_dialog(iw_win, 0, "Marker picking menu", -1, -1);
    iw_rowcolv = wid_rowcol(iw_goldmen, 'v', -1, -1);

    wid_pushg(iw_rowcolv, 0, "Shift the image",
                  goldmen_butshf, NULL, -1,-1);

    wid_pushg(iw_rowcolv, 0, "Show current markers",
                  goldmen_butm, NULL, -1,-1);

    iw_num = wid_toggleg (iw_rowcolv,0,"Show marker numbers",
                             show_num,goldmen_tgcb,NULL,0,0);

    wid_pushg(iw_rowcolv, 0, "Erase markers",
                  goldmen_butum, NULL, -1,-1);

    /* create box for stop or cancel  */
    wid_stdbut(iw_rowcolv, iw_goldmen, 
               &iw_pushs, &iw_pushc, &iw_pushc, "SC",
               goldmen_buts, fin_cb ,fin_cb, NULL);
    }
 XtManageChild(iw_goldmen);
 }

/************** goldmen_tgcb ************************************/
void goldmen_tgcb(Widget iw_temp,caddr_t data,caddr_t call_data)
{
  if (iw_num)
    show_num = XmToggleButtonGadgetGetState(iw_num);
 }
/***********  shift button callback  *********************************/

 void goldmen_butshf(Widget iw_temp, XtPointer data, XtPointer call_data)
 {
 /*  remove message */
 showbutx("","","",TRUE);

 /*  remove the menu widget */
 XtUnmanageChild(iw_goldmen);

 /*  cancel buttons */
 XtUninstallTranslations(iw_win);

 /* check translations setting in shift??? */
 shift(MARKER);
 }

/***********  markit button callback *********************************/

 void goldmen_butm(Widget iw_temp, XtPointer data, XtPointer call_data)
 {
 float   plist[1];
 int     unused;
 int     openit = TRUE;

/* close doc file, recover and display markers from doc file */
 goldmen_mark();

 /* reopen the doc file for output again */
 fpdocg = savdn1(&docnamg[0], datexc, &fpdocg, plist, 0, 
            &openit, TRUE, FALSE);
 }


/***********  goldmen_mark *********************************/

 int goldmen_mark(void)
 {
 char *  string;
 int     ixi, iyi, ix1, iy1, i;
 float * ptr;
 int     maxkeys = 9999, maxreg = 3;
 float   plist[1];
 int     unused;
 float * dbuf = NULL;
 int     markdoc;

 /* vax does not like file opened twice */
 if (fpdocg) fclose(fpdocg); fpdocg = NULL;

 /* retrieve marker locations from doc file */
 if (unsdal(&docnamg[0], &unused, 0, plist, 0, &dbuf, &markdoc,
           maxkeys, maxreg) > 0) 
    {   /* problem retrieving doc file, assume it does not exist */
    if (dbuf) free(dbuf); dbuf = NULL; XBell(idispl,50);
    spout("*** Unable to read marker doc. file.");
    return 0;
    }

 /* add markers to display*/
 ptr = dbuf;

 for (i= 0; i < markdoc; i++)
     {
     if ((*ptr) > 0) 
        {
        /*     this marker is in use now, display it */
        ixi = *(ptr+1);
        iyi = *(ptr+2);
        ptr  += maxreg; 

        /*    find location relative to screen */
        ix1 = ixi + ixul - 1;
        iy1 = iyi + iyul - 1;


        /*   draw a circle at this location if it is in the image area*/
        if (ix1 >= ixullmin && ix1 < ixullmin+nsam  && 
               iy1 >= iyullmin && iy1 < iyullmin+nrow)
           {
           xorc(iwin,   icontx,TRUE,ix1,iy1,iradg);
           xorc(imagsav,icontx,TRUE,ix1,iy1,iradg);

           /*   write marker number at this location */
	   if (show_num)
	     {
	       string = itoa(i+1);
	       witext(icontx, string, ix1, iy1, 1, 0, 9, 2, FALSE);
	       free(string);
	     }
           }
        }
    }
 if (dbuf) free(dbuf); dbuf = NULL; 

 /* refresh screen  */
 expos_cb(NULL,NULL,NULL);

 return markdoc;
 }

/***********  unmarkit button callback *********************************/

 void goldmen_butum(Widget iw_temp, XtPointer data, XtPointer call_data)
 {
 int	ixs, iys;

 /* erase markers by redrawing image from the Ximage stuff */

 /* find the new location of the image */
 ixs = ixul - ixullmin;
 iys = iyul - iyullmin;

 /* redraw the image */
 XPutImage(idispl,imagsav,icontx, imagel, nsam1,nrow1,
          ixul,iyul, nsam-ixs, nrow-iys);

 XPutImage(idispl,iwin   ,icontx, imagel, nsam1,nrow1,
          ixul,iyul, nsam-ixs, nrow-iys);

 /*  refresh screen  */
 expos_cb(NULL,NULL,NULL);
 }

/*********** stop button callback **********************************/

 void goldmen_buts(Widget iw_temp, XtPointer data, XtPointer call_data)
 {
 /*  remove message */
 showbutx("","","",TRUE);

 /*  remove the menu widget */
 XtUnmanageChild(iw_goldmen);

/*  remove the menu widget */
 XtUnmanageChild(iw_gold);

 /*  remove the marker number input widget */
 XtUnmanageChild(iw_dean);

 /*  cancel buttons,  stop this routine */
 XtUninstallTranslations(iw_win);

 /* reset the values */
 ixul   = ixulrmin;
 iyul   = iyulrmin;

 /* leave the Ximage storage alone, it will be emptied on next image */ 
 if (fpdocg) fclose(fpdocg); fpdocg = NULL;
 }

