/*$Header: /net/ithaca/usr1/web/src/RCS/imagedis.c,v 1.18 1996/06/20 16:38:50 leith Exp $*/

/*
 ***********************************************************************
 *
 * imagedis.c  -- renamed from image.c Aug. 95
 *
 ***********************************************************************
 * COPYRIGHT (C)1992, WADSWORTH CENTER FOR LABORATORIES AND
 * RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      
 * THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     
 * LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  
 * USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF 
 * THE CENTER FOR LABORATORIES AND RESEARCH 			  
 ***********************************************************************
 *
 * imagedis(FILEDATA *filedatat,int keepimage, XImage ** imaget,
 *          int keepimagec, int nmint, int nmaxt)
 * 
 * PURPOSE:    displays an image slice, after freeing existing image
 *             and image buffer (if they had originally been allocated
 *             inside imagedis, only)
 *
 * RETURNS:    true if successfull
 *
 * CALL TREE:  imagemen --> showimage --> redvol  
 *                                    --> wipic
 * PARAMETERS:     
 *
 ***********************************************************************
*/

#include "common.h"
#include "routines.h"

/**************************  image  *****************************/

void imagedis(FILEDATA *filedatat, int keepimage, XImage ** imaget,
              int keepimagec, int keepimagef, float ** imagef,
              int nmint, int nmaxt)
 {   
 static char  *cimage  = NULL;

  if (*imaget) 
     {
     /* free any existing allocated memory in imaget */
     XFree((void*) *imaget);
     *imaget = NULL;
     }
 
 if (cimage) 
    { /* free any existing image data */
    free (cimage);
    cimage = NULL;
    }

 showimage(filedatat,keepimagec, &cimage, 
                     keepimage,  imaget, 
                     keepimagef, imagef, TRUE,
                     filedatat->fmin, filedatat->fmax,
                     nmint, nmaxt);

 return;
 }

 
