
/*$Header: /net/alwyn/usr1/web/src/RCS/itex.c,v 1.3 95/01/23 10:21:56 leith Exp $*/

/*
 * itex.c
 *
 ***********************************************************************
 * COPYRIGHT (C)1992, WADSWORTH CENTER FOR LABORATORIES AND
 * RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.
 * THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     
 * LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  
 * USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF 
 * THE CENTER FOR LABORATORIES AND RESEARCH 			  
 ***********************************************************************
 *
 * 
 * 
 * PURPOSE:  Callback routine for Text selection in Command pulldown
 *           menu     
 * 
 * PARAMETERS:	Widget 		iw_temp		pushbutton (not used)
 *		caddr_t		data		label text string
 *		caddr_t		call_data	not used 
 *
 ***********************************************************************
*/

#include "x.h"
#include "std.h"
#include "routines.h"



 /* internal functions */
 void            itex_cb   (Widget, caddr_t, caddr_t);
 void            itex_pop  (Widget, XEvent *, String *, Cardinal *);
 void            itex3     ();

 /* common variables */
 extern Widget   iw_win;           /* image window           */
 extern Display  *idispl;          /* current display        */
 extern GC       icontx;           /* usual graphics context */

 extern int      ix_posiz;         /* x coord from wid_posiz */
 extern int      iy_posiz;         /* y coord from wid_posiz */


 /* file variables */
 char            label_string[] = "Enter text";  /* label for text widget  */
 Widget          iw_text, iw_posiz;
 XmFontList      font_list;
 int             ixtext;           /* x coord for text       */
 int             iytext;           /* y coord for text       */
  

/************************  itex  ************************************/

 void itex(Widget iw_temp, caddr_t data, caddr_t call_data)
 {

 /* open a message window with the following strings */
 showbutx("Set text location with mouse.",
          "Enter text coordinates.",
          "Stop this routine.", FALSE);

 /* set the actions for right, left, and center buttons */
 actions(iw_win, "itex_pop", itex_pop, "123");
 }



 /********************* itex_pop  ************************/

 void itex_pop(Widget iw_t, XEvent *event, String *params,
                  Cardinal *num_params)
 {
 int ixt, iyt, idum; 
 
 if (!(strcmp(*params,"1")))                  /* button 1 pushed */
    {
    /* get mouse position */
    getloc(event,'B',&ixtext,&iytext);

   /* create text input box */
    iw_text = wid_text(iw_win, iw_text, label_string, (char *) NULL,
                       *itex_cb, NULL, ixtext, iytext);
    }


 else if (!(strcmp(*params,"2")))            /* button 2 pushed */
    {
    /* get mouse position */
    getloc(event,'B',&ixt,&iyt);

    /* query position */
    iw_posiz = wid_posiz(iw_win, iw_posiz, ixt, iyt,  idum, idum, 
                         'P', itex3);
    }


 else if (!(strcmp(*params,"3")))            /* button 3 pushed */
    {
    /* uninstall translations */
    XtUninstallTranslations(iw_t);

    /* unmanage information box */
    showbutx("","","",TRUE);
    }

 }


 /**********************  itex_cb  *********************************/

 void itex_cb(Widget iw_temp, caddr_t data, caddr_t call_data)
 {
 XmString    txt_string;
 char        *text;

 XmSelectionBoxCallbackStruct *cbs =
      (XmSelectionBoxCallbackStruct *) call_data;
 
 txt_string = cbs -> value;
 text = extractstr(cbs -> value);

 /* write text in current color */
 witext(icontx, text, ixtext, iytext, 0, 0, -9, 2, FALSE);
 }


 /****************  itex3 (runs after wid_posiz) *****************/

 void itex3()
 {

 ixtext = ix_posiz;
 iytext = iy_posiz;

 /* create text input box now */
 iw_text = wid_text(iw_win, iw_text, label_string, (char *) NULL,
                    itex_cb, NULL, ixtext, iytext);
 
 }
