
/*$Header: /net/ithaca/usr1/web/src/RCS/lahemen.c,v 1.2 1996/07/31 20:28:20 leith Exp $*/

/*
C++*********************************************************************
C
C lahemen
C
C **********************************************************************
C *  AUTHOR:  ArDean Leith                                                 *
C *  COPYRIGHT (C)1993, WADSWORTH CENTER FOR LABORATORIES AND              *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH                            *
C **********************************************************************
C
C    lahemen
C
C    PURPOSE:         display lahe menu
C
C    CALLED BY:       imagemen
C
C    CALL TREE:
                 
   imagemen      
      |            
      v                                                      
  imagemen_cb       
      |                       
      v                        
   imagemen1                   
      |             
      v            
   filtermen -->  lahemen --> lahe -->
                   

C***********************************************************************
*/

#include "common.h"
#include "routines.h"

 /* function prototypes */
 void         lahemen       (Widget, XtPointer, XtPointer);
 void         lahemen_buta  (Widget, XtPointer, XtPointer);
 
 /* common global set elsewhere */
 extern int      nsamold, nrowold;
 extern int      bins;
 extern int      border;

 /* file level variables used here */
 static Widget   iw_lahemen, iw_border, iw_bins;

/************************************  lahemen **********************/

 void lahemen(Widget iw_temp, XtPointer data, XtPointer call_data)
 { 
 char     cval[5];
 Widget   iw_rowcol;
 Widget   iw_pushc, iw_pusha, iw_dums;

 if (iw_lahemen <= (Widget)0)
    {   /* create lahe menu widget first */

    iw_lahemen = wid_dialog(iw_win,iw_lahemen,"lahe options",20,20);
    iw_rowcol   = wid_rowcol(iw_lahemen,'v',-1,-1);

    /* create text box for bordersize input ----------------- border */
    sprintf(cval,"%4d",border);
    iw_border = wid_textboxb(iw_rowcol,0, 
                  "Border ((box -1)/2):",cval,4);

    /* create text box for bins input ------------------------- bins */
    sprintf(cval,"%4d",bins);
    iw_bins = wid_textboxb(iw_rowcol,0, "Bins:",cval,4);

    /* create accept boxes  ---------------------------------- apply */
    iw_pushc = (Widget) 0;
    iw_pusha = (Widget) 0;
    wid_stdbut(iw_rowcol, iw_lahemen, 
               &iw_dums, &iw_pushc, &iw_pusha, 
               "CA",fin_cb,fin_cb,lahemen_buta, NULL);
    }

 XtManageChild(iw_lahemen);
 }

 /********************* lahe accept button callback *******************/

 void lahemen_buta(Widget iw_temp, XtPointer data, XtPointer call_data)
 {
 char           filtertype[2];

 if (strtoint(iw_bins,"bins",&bins) == FALSE) return;
 if (bins  < 2 ) 
    { spout("*** Bins range is: 2...");  return; }

 if (strtoint(iw_border,"border", &border) == FALSE) return;
 if (border < 1 || 
     border >= (nsamold) /2 || border >= (nrowold)/2) 
    { spout("*** Border range is: 1...min(nsam/2, nrow/2)"); return; }

 XtUnmanageChild(iw_lahemen);

 filtertype[0] = 't';
 filtertype[1] = '\0';
 filter_but(iw_temp, (XtPointer) filtertype, call_data);
 }

