
/*$Header: /net/ithaca/usr1/web/src/RCS/lutmen.c,v 1.11 1996/03/29 17:23:23 leith Exp $*/
/*
C++*************************************************************************
C
C created from imagemen.c          Nov  92
C lutmen.c
C                                                                    
C **************************************************************************
C *  AUTHOR: A. LEITH                                                      *
C *  COPYRIGHT (C)1992, WADSWORTH CENTER FOR LABORATORIES AND              *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH	        		   *
C **************************************************************************
C
C    LUTMEN
C
C    PARAMETERS:   iw_temp, data, call_data (usual callback data)
C
C    PURPOSE:      MAKES A FILE WIDGET, INTERROGATES FILE WIDGET AND
C                  CALLS LUT DISPLAY ROUTINE
C
C    CALLED BY:    web_com
C
C--********************************************************************
*/

#include <Xm/FileSB.h>
#include "common.h"
#include "routines.h"

 /* internal function  prototypes */
 void               lutmen_cb (Widget, XtPointer, XtPointer);
 void               lutmen1   (char *);

 /* internal file variables */
 static char   * fillutp;
 static char     fillut[81]  = "\0";
 static Widget   iw_lutfiles = 0;
 static char     coper[1];

/********************************  lutmen  ***************************/

 void lutmen(Widget iw_temp, XtPointer data, XtPointer call_data)
 { 
 char    nulled = '\0';
 char * lutdirptr;

 /* create a lut file selector widget */

 strncpy(coper, data,1);
 if (iw_lutfiles == (Widget) 0)
#ifdef VMS
    lutdirptr = &lutdir[0];
#else
    lutdirptr = getenv("SPRGB_DIR");
#endif 
else
    lutdirptr = &nulled;

 /* create a file selector box */
 iw_lutfiles =  wid_file(iw_win, iw_lutfiles , "Look-up-table",
               &fillut[0], lutdirptr, *lutmen_cb, -1, -1);

 /* kludge to keep filename in selection box */
 wid_fileset(iw_lutfiles,fillut);
 }


/************************** lutmen_cb ****************************/

 void lutmen_cb(Widget iw_temp, XtPointer data,  XtPointer call_data)
 { 
 XmFileSelectionBoxCallbackStruct *cbs;
 Colormap                          mapt;
 unsigned long                     cells[256];
 
 /* get file name from file selector widget */
 cbs = (XmFileSelectionBoxCallbackStruct *) call_data;

 fillutp = extractstr(cbs -> value);

 /* get rid of file selector */
 XtUnmanageChild(iw_lutfiles);
 
 /* apply the lut */
 if (!strcmp(coper, "0"))
    lut(&fillutp[0], map, mapgo, mapend);
 else
    {
    mapt = XCopyColormapAndFree(idispl, map);
    XAllocColorCells(idispl, map, TRUE, NULL, 0, cells, 256);
    lut(&fillutp[0], map, 0, 255);
    XFreeColormap(idispl, mapt);
    }

 /* start lutmen again */
 strcpy(fillut,extractstr(cbs -> value));

 lutmen(NULL,coper,NULL);

 return;
 }

