
/*$Header: /net/ithaca/usr1/web/src/RCS/mag.c,v 1.4 1995/09/06 16:18:55 mladjadj Exp $*/
/*
C++*************************************************************************
C
C MAGNIFY -- CREATED July 92
C mag.c          Nov  92                                                                    
C **************************************************************************
C *  AUTHOR: YANHONG LI                                                      *
C *  COPYRIGHT (C)1992, WADSWORTH CENTER FOR LABORATORIES AND              *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH	        		   *
C **************************************************************************
C
C    IMAGNIFICATION
C
C    PARAMETERS:   iw_temp, data, call_data (usual callback data)
C
C    PURPOSE: MAGNIFICATION
C
C    CALLED BY:    web_com
C
C--********************************************************************
*/


#include "x.h"
#include "std.h"

 /* common variables */
#include "common.h"
#include "routines.h"

 /* internal function  prototypes */
 void 	mag_pop	(Widget, XEvent *, String *, Cardinal *);
extern void  glass          (Window , Window , int , int ,
	                    int , int , int *, int *, int );

 /* internal file variables */
 static GC     icontxx;
 static int    first=1, erase=0;
 static int    lasx=0, lasy=0;
 static int    lasmagx=0, lasmagy=0;
 static int    ix3=0, iy3=0;
 static Pixmap iglassav=0;

/*****************************  mag  *********************************/

 void mag(Widget iw_temp, caddr_t data, caddr_t call_data)
 {

 /* make a xor graphics context (icontxx)	*/
 icontxx = setxor( icontx );

 /* Open a message window with the following strings	*/
 showbutx( "Set temporary glass location.",
           "Set permanent glass location.",
	   "Stop this routine.", FALSE);

 /* Set the action from right, left, and center buttons */
 actions(iw_win, "mag_pop", mag_pop, "M123");
	
 /* Turn on Xor writing in icontxx	*/
 icontxx = setxor( icontx );
	
 }

/***********************  mag_pop  **************************/

void mag_pop(Widget iw_t, XEvent *event, String *params,
		Cardinal *num_params)
{
    int		ix1, iy1;	/* mouse position	*/
    int 	ix2, iy2;

    /* Get mouse position ix1,iy1. */
    getloc( event, 'M', &ix1, &iy1 );
	
	
    if(!(strcmp(*params,"M")))
       /* cursor moved. Erase and draw a new box	*/
       {
       xorbox(iwin, icontxx, FALSE, ix1, iy1, magsizx, magsizy);    
       }
	
    else if (!(strcmp(*params, "1")))
        /* Left button pushed. 	*/
        /* Erase the old box first, drawing a new one	*/
        {
    	xorbox(iwin, icontxx, 1, ix1, iy1,magsizx, magsizy);
    	if (erase)
      	    XCopyArea(idispl, imagsav, iwin, icontx, ix3,iy3,
		     lasmagx, lasmagy, ix3, iy3);

	/* Show magnified area	*/
    	glass(iwin, iwin, ix1, iy1, FALSE, FALSE, &ix2, &iy2, TRUE);
 
	/* Redraw the box	*/
    	xorbox(iwin, icontxx, 1, ix1, iy1, magsizx, magsizy);
    	xorbox(iwin, icontxx, 1, ix1, iy1, magsizx, magsizy);

  	/* Remember the last magnification varibles	*/
    	erase = 1;
    	first = 0;
    	lasmagx = magsizx * magfac;
    	lasmagy = magsizy * magfac;
    	ix3 = ix2;
    	iy3 = iy2;
        }

    else if (!(strcmp(*params, "2")))
       /* Center button pushed	*/
       /* Make permanent magnification	*/
       {
    	xorbox(iwin, icontxx, 1, ix1, iy1, magsizx, magsizy);
    	if (erase)
      	    XCopyArea(idispl, imagsav, iwin, icontx, ix3,iy3,
			lasmagx, lasmagy, ix3, iy3);

	/* Show magnified area	*/
    	glass(iwin, iwin, ix1, iy1, 1, FALSE, &ix2, &iy2, TRUE);

	/* Redraw the box	*/
   	xorbox(iwin, icontxx, 1, ix1, iy1,magsizx, magsizy);
    	xorbox(iwin, icontxx, 1, ix1, iy1,magsizx, magsizy);

	/* Remember the last magnification varibles	*/
    	erase = 0;
    	first = FALSE;
       }
	
	
    else if (!(strcmp(*params, "3")))
        /* Right button pushed	*/
        /* Stop this function call	*/
        {
    	if (erase)
	    /* Replace the last temporary magnified area	*/
      	    XCopyArea(idispl, imagsav, iwin, icontx, ix3,iy3,
			lasmagx, lasmagy,ix3, iy3);

    	if (!first)
	    /* Erase old box	*/
      	    xorbox(iwin, icontxx, 1, ix1, iy1, magsizx, magsizy );
	
    	XFlush( idispl );
    	XtUninstallTranslations(iw_win);
   	glass(iwin, iwin, ix1, iy1, TRUE, 1, &ix2, &iy2, TRUE);

	/* Release GC	*/
    	XFreeGC(idispl, icontxx );
	
    	showbutx(NULL, NULL, NULL, 1);
    	}
    } 

/***********************  glass  **************************/

void glass(Window iwsrc, Window iwdest, int ixuls, int iyuls,
	    int perm, int finished, int *ixuld, int *iyuld, int finddest)
   {
    unsigned int 	ixsiz, iysiz;
    int	 		depth;
    int			i, j;
    int			ix, iy, ixn, iyn;
    int			lmagx, lmagy;

    if (finished )
        {
      	if (iglassav > 0 )
      	    XFreePixmap( idispl, iglassav );
      	iglassav =0;
      	return;
        }

    /* Find the size of magnified image	*/
    ixsiz = magsizx * magfac;
    lmagx = magsizx;
    if (ixsiz > iwidex)
        {
	ixsiz = iwidex;
	lmagx = ixsiz/magfac;
        }

    iysiz = magsizy * magfac;
    lmagy = magsizy;
    if (iysiz > ihighx)
        {
	iysiz = ihighx;
	lmagy = iysiz/magfac;
        }

    if ((ixsiz != lasx || iysiz != lasy) && iglassav != 0 )
        {
 	/* Mag glass has changed, set flag to create new mag pixmap	*/
    	XFreePixmap( idispl, iglassav );
    	iglassav = 0;
        }

    if (iglassav < 1 )
        {
	/* Need to create offscreen pixmap for mag glass	*/
	/* Create an offscreen backing store for the mag. Glass	*/
    	iglassav = XCreatePixmap(idispl,iwdest,ixsiz,iysiz,idepth);

	/* Remember destination window ( magnified ) size	*/
    	lasx = ixsiz;
    	lasy = iysiz;
        }

    if(finddest)
        {  /* Find upper left corner of destination area	*/
        *ixuld = ixuls - ( ixsiz - lmagx )/2;
        if ( *ixuld < 0 )
    	    *ixuld = 0;
        if (( *ixuld + ixsiz - 1 ) >iwidex )
    	    *ixuld = iwidex - ixsiz;

        *iyuld = iyuls - ( iysiz - lmagy )/2;
        if ( *iyuld < 0 )
            *iyuld = 0;
        if (( *iyuld + iysiz - 1 ) >iwidex )
    	*iyuld = iwidex - iysiz;
        }

    /* Copy columns from backing store with magfac duplication	*/
    for ( i=0; i<lmagy; i++ )
            {
    	for ( j=0; j<magfac; j++ )
    	   {
           iy = iyuls + i;
           iyn = i*magfac + j;
           XCopyArea(idispl,iwsrc,iglassav,icontx, ixuls,iy,
		lmagx,1,0,iyn);
    	   }
       }

    /* Copy top rows from glass into glass for magfac duplication*/
    ixn = ixsiz;
    for ( i=lmagx; i>0; i-- )
       {
    	for ( j=0; j<magfac; j++ )
           {
           ix = i-1;
           ixn = ixn - 1;
           XCopyArea(idispl,iglassav,iglassav,icontx, 
		ix,0,1,iysiz,ixn,0 );
           }
       }	
	
    XFlush(idispl);

    /* Copy the glass into the on_screen window	*/
    XCopyArea(idispl,iglassav,iwdest,icontx,0,0, 
		ixsiz,iysiz,*ixuld,*iyuld );

    if ( perm )
       {
       /* Copy the glass into the off_screen window	*/
       XCopyArea(idispl,iglassav,imagsav,icontx,0,0,
		ixsiz,iysiz,*ixuld,*iyuld );
       }
    return;
}

