
/*$Header: /net/ithaca/usr1/web/src/RCS/maskmen.c,v 1.11 1996/04/01 17:25:32 leith Exp $*/
/*
C+**************************************************************************
C
C WID_MASKMEN.FOR -- CREATED MAY 91
C maskmen.c                  DEC 92
C
C **************************************************************************
C    AUTHOR:  ArDean Leith                                                 *
C *  COPYRIGHT (C)1991, WADSWORTH CENTER FOR LABORATORIES AND              *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH                            *
C **************************************************************************
C
C MASKMEN
C
C PARAMETERS:    
C
C--*************************************************************************
*/

#include "common.h"
#include "routines.h"
#include <Xm/ToggleBG.h>
#include <Xm/SelectioB.h>

 /* internal function prototypes */
 void          maskmen_butcl  (Widget, XtPointer, XtPointer);
 void          maskmen_buts   (Widget, XtPointer, XtPointer);
 void          maskmen_butn   (Widget, XtPointer, XtPointer);
 void          maskmen1       (Widget, XtPointer, XtPointer);
 void          maskmen1_buta  (Widget, XtPointer, XtPointer);
 
 /* external common variables */
 extern int iwintyp;               /* winread uses this */
 extern int filler;
 extern GC  icontxx;

 /* internal common variables */
 static Widget        iw_maskmen = 0;
 Widget               iw_maskmen1 = 0;
 char                 masknam[81] = "\0";  

 /********************   maskmen   ****************************/

 void maskmen(void)

 {
 Widget  iw_rowcolv, iw_pushs, iw_pushc, iw_pusha; 

 if (iw_maskmen == (Widget)0)
    {   /* create masking menu first */

    iw_maskmen = wid_dialog(iw_win, 0, "Masking menu", -1, -1);

    iw_rowcolv = wid_rowcol(iw_maskmen, 'v', -1, -1);

                 wid_toggleg(iw_rowcolv,0,"Fill inside",filler,
                        toggle2_cb, (void *) &filler, -1,-1);

                 wid_pushg(iw_rowcolv, 0, "Clear mask",
                     maskmen_butcl, (XtPointer) iw_maskmen, -1,-1);

                 wid_pushg(iw_rowcolv, 0, "Save masks",
                     maskmen1, NULL, -1,-1);

                 wid_pushg(iw_rowcolv, 0, "Next input image",
                     maskmen_butn, NULL, -1,-1);

    /* create box for apply  */
    wid_stdbut(iw_rowcolv, iw_maskmen, 
               &iw_pushs, &iw_pushc, &iw_pusha, "SC",
               maskmen_buts, fin_cb, fin_cb, NULL);
 
    }
 XtManageChild(iw_maskmen);
 }

/***********  maskmen_butcl ----- clear masks callback ************/

 void maskmen_butcl(Widget iw_temp, XtPointer data, XtPointer call_data)

 {
 /*  blank masks but not image, by clearing overlay planes */
 clearover(NULL,NULL,NULL);

 /*  remove menu */
 XtUnmanageChild((Widget) data);
 }

/*********** maskmen_buts ----- stop button callback ***************/

 void maskmen_buts(Widget iw_temp, XtPointer data, XtPointer call_data)
 {

 /* put in a trap here to be sure user wants to stop without storing */
 /******* !!!!!!! *****/

 /*  enable all planes for drawing (in case it was not set by error)*/
 wisetplanes(idispl, icontx, -1);

 /*  remove message */
 showbutx("","","",TRUE);

 /*  remove the menu widget */
 XtUnmanageChild(iw_maskmen);

 /*  cancel menu,  stop masking mouse button assignments */
 XtUninstallTranslations(iw_win);

 /*  restore default lut */
 setamap(map);
 }


/***********  maskmen_butn -------next image callback *************/

 void maskmen_butn(Widget iw_temp, XtPointer data, XtPointer call_data)
 {
 int          nlet, numfili;

 /* put in a trap here to be sure user wants to stop without storing */
 /******* !!!!!!! *****/

 /*  enable all planes for drawing */
 wisetplanes(idispl,icontx,-1);

 /*  remove menu */
 XtUnmanageChild(iw_maskmen);

 /*  remove button assignment message */
 showbutx("","","",TRUE);             

 /* refresh screen  */
 expos_cb(NULL,NULL,NULL);

 /* increment input image file name */
 filinc(filnow,filnext,&nlet,&numfili);

 /*  restore default lut */
 setamap(map);

 /* get rid of xor graphics context */
 XFreeGC(idispl,icontxx);

 /* ask for next filename to be masked */
 imagemen(NULL,"6",NULL);  
 }

/***********  maskmen1 -----  save masks button callback ***********/

 void maskmen1(Widget iw_temp, XtPointer data, XtPointer call_data)
 {

 /* create mask file name text input widget */
 iw_maskmen1 = wid_text(iw_win, iw_maskmen1, "Mask file", &masknam[0],
                        *maskmen1_buta, NULL, ixul+nsam, iyul+nrow);

 XtManageChild(iw_maskmen1);
 }


/***********  maskmen1_buta --- filename accept callback **********/

 void maskmen1_buta(Widget iw_temp, XtPointer data, XtPointer call_data)
 {
 int                             nlet,numfild;
 XmSelectionBoxCallbackStruct *  cbs;
 char *                          string = NULL;

 cbs = (XmSelectionBoxCallbackStruct *) call_data;
 string = extractstr(cbs -> value);
 strcpy(masknam,string);
 if (string) XtFree(string);

 if (masknam[0] == '\0') 
    {
    /*  this program requires an iamge file name */
    spout("*** You must enter a mask file name now!");
    return;
    }

 /*  remove options menu */
 XtUnmanageChild(iw_maskmen);

 /*  remove mask file-name menu */
 XtUnmanageChild(iw_maskmen1);

 /* store mask image in mask image file */
 iwintyp = 3;
 nsamw   = nsam;
 nroww   = nrow;
 ixulw   = ixul;
 iyulw   = iyul;
 winread1(masknam, FALSE, 128);

 /* increment mask file name */
 filinc(masknam, masknam, &nlet, &numfild);

 }
