
/*$Header: /net/ithaca/usr1/web/src/RCS/mont2.c,v 1.21 1997/03/18 16:17:06 leith Exp $*/

/*
C++*********************************************************************
C
C MONT2 -- CREATED JULY 91 FROM WKMONT
C          CONVERTED TO C - JULY 92 al
C *********************************************************************
C *  AUTHOR:  ArDean Leith                                            *
C *  COPYRIGHT (C)1992,1996  HEALTH RESEARCH INC, EMPIRE STATE PLAZA, *
C *    ALBANY, NY 12201.  THE CONTENTS OF THIS DOCUMENT ARE           *
C *    PROPRIETARY TO HEALTH RESEARCH INC., AND ARE NOT TO BE         *
C *    DISCLOSED TO OTHERS OR USED FOR PURPOSES OTHER THAN INTENDED   *
C *    WITHOUT WRITTEN APPROVAL OF HEALTH RESEARCH INC.               *
C *********************************************************************
C
C    MONT2
C
C    PURPOSE:         DIPLAY MONTAGE FROM 2D FILE SERIES.
C
C    PARAMETERS:     
C
C    CALLED BY:       IMAGEMEN
C
C***********************************************************************
*/

#include "common.h"
#include "routines.h"
 extern int sumum(float * first, float * second, float * output, 
                  int npix);
 extern int average(float * input,  float * output,
                    int npix, float divisor);
 extern int avgsave(char * avgnam, int nsam, int nrow, float * avgdata);

 /* external variables */
 extern int   lastfile;           
 extern int   *docimgnums;      /* doc file image numbers */
 extern int   docimgtotal;      /* number of images from doc file */
 extern int   icattyp;          /* categorize type */
 extern int   montaverage;      /* want montage average */
 extern char  avgnam[128];      /* name for montage average file */

 /* internal variables used elsewhere */
 int          ndone;             /* used by cat.c                    */
 char         filego[81] = "\0"; /* name of first image in montage   */
 int          ixulmon,iyulmon;   /* upper left corner of montage     */

/****************************  mont2  ********************************/

 void mont2(int nmint, int nmaxt)

 {   
 int          resetmar, iret, numnow;
 int          numfil, nlet,  toomany;
 FILEDATA   * filedatan;
 int          nsamn, nrown, nslicen, iformn;
 int          marlefo;
 XImage *     imaget    = NULL;
 float  *     imagef    = NULL;
 float  *     imagefavg = NULL;
 size_t       slen;
 char         *avgname;

 /* DO NOT FORCE FIRST IMAGE POSITION */
 force = FALSE;

 resetmar = FALSE;
 if (placed) 
   {
   marlefo  = marlef;
   marlef   = ixuln - marx;
   resetmar = TRUE;
   }

 islice  = 1;

 ndone   = 1;
 toomany = FALSE;

 /* update the screen */
 expos_cb(NULL,NULL,NULL);

 /* display initial image on a new line*/
 newline = TRUE;

 imagedis(filedata, FALSE, &imaget,FALSE, 
          ioper == 20 && montaverage, &imagefavg, nmint, nmaxt);

 /* free up the file descriptor for this image */
 closefile(filedata); filedata = NULL;

 /* remember montage location */
 ixulmon = ixul;
 iyulmon = iyul;

 /* FORCE DESIRED NUMBER OF IMAGES/LINE NOW EVEN IF TRUNCATES */
 force = TRUE;

 /* find following image names and display their files */
 if (ioper == 20 || (ioper == 11 && icattyp == 1))
    {  /* docmontage -- second image for (ioper = 20)  */
       /* categorize from docmontage -- second image (ioper = 11) */
    numnow = 1;
    }
 else
    {strcpy(filego,filnow);}

 do
   {
   /* get next file name */
   if (ioper == 20 || (ioper == 11 && icattyp == 1))
      {   /* docmontage -- get file names using imgnums array */
      iret   = filget(filego, filnext, 80, docimgnums[numnow++]);
      numfil = lastfile;
      }
   else
      {   /* sequential montage -- increment file name */
      iret = filinc(filnow, filnext, &nlet, &numfil); 
      }

   if (iret) 
      {   /* file number incrementing succeeded */
      if (numfil <= lastfile || lastfile < 0) 
         {
         /* still want to display this next file so open it */
         if ((filedatan = openold(filnext, &nsamn, &nrown, &nslicen, 
              &iformn, "o")) == NULL)
            {   

	    /* next file not found (may not exist if * was used) */
            /* stop if lastfile indicates * was used for files */
            if (lastfile < 0) toomany = TRUE;

            /*  stop if it reaches the last file */ 
            else  strcpy(filnow,filnext);  /* try opening next file */
            }
         else
            {   /* next image file found OK, set filnow to filnext */
            strcpy(filnow,filnext);
            filedata = filedatan;
            nsam     = nsamn;
            nrow     = nrown;
            nslice   = nslicen;
            islice   = 1;

            /* normalize file if necessary */
            if ((filedata -> imami == 1) || norm(filedata) == TRUE)

               {   /* file normalized ok */
               if (fabs(filedata -> fmax - filedata ->fmin) < FLTZER) {
                  spout("*** BLANK IMAGE SKIPPED");
		  ndone--;
		  }

               else
                  {
                  newline = FALSE;
                  if (ndone % nprow == 0) newline = TRUE;

                  /* display this image, dont keep image or buffer */
                  imagedis(filedata, FALSE, &imaget,FALSE,
                           ioper == 20 && montaverage, &imagef,
                           nmint,nmaxt);
                  }

               if (ioper == 20 && montaverage)
                  { 
                  sumum(imagefavg, imagef, imagefavg , nsam * nrow);
                  free(imagef);
                  imagef = NULL;
                  }

               /* free up the file descriptor for this image */
               closefile(filedata); filedata = NULL;

               /* increment image counter */
               ndone++;

               }    /* ends: if ((filedata  */
            }       /* ends: if ((filedatan */
         }          /* ends: if (numfil     */
      }             /* ends: if (filinc     */
   }                /* ends: while          */

 while (((ioper == 20 || (ioper == 11 && icattyp == 1)) && numnow < docimgtotal) || 
        ((ioper != 20 && (ioper != 11 || icattyp != 1)) && (numfil <= lastfile && !toomany)) || 
         (lastfile < 0 && !toomany));

 if (ioper == 20 && montaverage)
    { 
    /* calulate floating point average image */
    average(imagefavg, imagefavg ,nsam * nrow, (float) ndone);

    /* store the floating point average image */
    if (strlen(avgnam) <= 0)
       spout("No file name specified for average file!");
    else
       {
       /* add datexc to avgnam if not already there */
       slen = strlen(avgnam) + strlen(datexc) + (size_t) 2;

       if (!(avgname = (char *) malloc(slen * sizeof(char))))
          {
          spout("*** Unable to allocate avgname memory in mont2!");
          return;
          }  
       strcpy(avgname,avgnam);
       if (strstr(avgname,datexc) != 
            (avgname + strlen(avgname) - strlen(datexc)))
          {   /* need to add datexc extension at end of avgname */
          if (!addext(avgname,datexc,slen)) return;
          }

       newline = TRUE;
       avgsave(avgname, nsam, nrow, imagefavg);

       /* display the average image */
       ioper = 1;    /* not a montage anymore */
       imagemen1(avgname, TRUE);
       if (avgname) free(avgname);
       }
    free(imagefavg);
    imagefavg = NULL;

    }

 if (ioper == 20)
    {   /* free storage for imgnums from doc file */
        /* do not free storage when doing categorize afterwards */
    if (docimgnums) free(docimgnums);
    docimgnums = NULL;
    }

 force = FALSE;

 /* RESET MARLEF TO DEFAULT, IF NECESSARY */
 if (resetmar)
      marlef =  marlefo;

 newline = FALSE;

 if (ioper == 11)
    {                    /* categorize images from montage now */
    catmen();
    }
 else if (ioper == 16)
    {                    /* show movie from montage now*/
    moviemen(TRUE); 
    }

 return;
 }


 
