
/*$Header: /net/ithaca/usr1/web/src/RCS/mont3.c,v 1.17 1997/08/25 19:59:50 liy Exp $*/

/*
C++************************************************************************
C
C MONT3.C -- CREATED JAN 90 FROM WKMONT
C            WIDGETIZED MAY 91
C            CONVERTED TO C JULY 92 al
C
C **************************************************************************
C *  AUTHOR:  ArDean Leith                                                 *
C *  COPYRIGHT (C)1992, WADSWORTH CENTER FOR LABORATORIES AND             *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH			           *
C **************************************************************************
C
C    MONT3
C
C    PURPOSE:         DIPLAY MONTAGE FROM FILE SERIES ON WORKSTATION.
C                     CAN NORMALIZE SLICE BY SLICE, ALSO.
C
C    VARIABLES:       NAMES      LOGICAL FLAG TO PRINT NAMES
C
C    CALLED BY:       
C
C***********************************************************************
*/

#include "common.h"
#include "routines.h"

#define MAXDIM 3000000

 /* external variables */
 extern int ixulmon, iyulmon, ndone;
 extern int endfile;           

/******************************  mont3 *******************************/
   
 int  mont3(FILEDATA *fileptr, int nmint, int nmaxt)
 {   
 int       maxvox, maxflt, numvox, resetmar, marlefo;
 int       nsam3, nrow3, nslice3, nsami, nrowi, nslices;
 int       irow, isam, nrec1, nrec2, miskip;
 int       nsliceu, j , ival,l, iy, i;
 int       numfil, nlet,  toomany,  file_exist = TRUE;
 int       nsamn, nrown, nslicen, iformn;
 FILEDATA  * filedatan;
 char      label[] = "    ";
 float     fn, fncon;
 float     *buf;
 char      *cbuf ;
 int       iloc, nrowspn, irec, irec1;

 /* max. no. of voxels in output buffer */
 maxvox = MAXDIM * 4;
 maxflt = MAXDIM;

 /* set image size and window */
 nsam3   = nsam2   - nsam1   + 1;
 nrow3   = nrow2   - nrow1   + 1;
 nslice3 = nslice2 - nslice1 + 1;

 if (axis == 'z')
     {           /* 3-d file with z slice */
     nslices = nslice3;
     if (iskip > 1)
        {   /* display reduced size image */
        nsami   =  (1 + nsam2 - nsam1) / iskip;
        nrowi   =  (1 + nrow2 - nrow1) / iskip;
        }
     else if (iskip < -1) 
        {        /* display magnified image */
        miskip  = -iskip;
        nsami   = nsam3 * miskip;
        nrowi   = nrow3 * miskip;
         }
     else
        {        /* display full size image */
        nsami   = nsam3;
        nrowi   = nrow3;
        }
      }
 else if (axis == 'y')
     {   /* y slice */
     nslices = nrow3;
     if (iskip > 1)
        {        /* display reduced size image */
        nsami   = (nsam2 - nsam1+1) / iskip;
        nrowi   = (nslice2 - nslice1+1) / iskip;

	/* modify the size because the reducing is implemented by resampling */
	if ((nsami * iskip) != (nsam2 - nsam1+1))   nsami++;
	if ((nrowi * iskip) != (nslice2 - nslice1+1))   nrowi++;
        }
     else if (iskip < -1) 
        {        /* display magnified image */
        miskip  = -iskip;
        nsami   = nsam3   * miskip;
        nrowi   = nslice3 * miskip;
        }
     else
        {        /* display full size image */
        nsami   = nsam3;
        nrowi   = nslice3;
        }
      }
 else if (axis == 'x')
     {   /* x slice */
    nslices = nsam3;

     if (iskip > 1)
        {       /* display reduced size image */
        nsami   = (1 + nrow2 - nrow1) / iskip;
        nrowi   = (1 + nslice2 - nslice1) / iskip;

	/* modify the size because the reducing is implemented by resampling */
	if ((nsami * iskip) != (nrow2 - nrow1+1))   nsami++;
	if ((nrowi * iskip) != (nslice2 - nslice1+1))   nrowi++;
        }
     else if (iskip < -1) 
        {       /* display magnified image */
        miskip  = -iskip; 
        nsami   = nrow3   * miskip;
        nrowi   = nslice3 * miskip;
        }
     else
        {       /* display full size image */
        nsami   = nrow3;
        nrowi   = nslice3;
        }
     }
 /* numvox is number of pixels in whole montage */
 numvox  = nsami * nrowi * nslices;
 
 nrowspn = nrowi;
 toomany = FALSE;

 if (names == TRUE)
    {      /* find y-offset needed for name label */
    /*  future !! WID_IMGLABELOC(FILNOW,IYLINE,IYTOT) 
    NROWSPN  = NROWSPN + IYTOT */
    nrowspn += 10;
    names    = TRUE;
    }
 resetmar = FALSE;

 if (placed == TRUE) 
    {   /* position sent from caller */
    ixul     = ixuln;
    iyul     = iyuln;
    marlefo  = marlef;
    marlef   = ixuln - marx;
    resetmar = TRUE;
    }

 force = FALSE;
 filedata = fileptr;

 /* set wait cursor */
 waitcursor(iwin, TRUE, 79);

 /* find following image names and display them */
 do
   {
   if(file_exist)
     {
     /* conversion from floating point to byte range */

     fn    = (float) (nmaxt-nmint) / (fmax - fmin);
     fncon = -fmin * fn + nmint + 0.5;

     ndone   = 0;
     newline = TRUE;

     if (axis == 'z')
       {   /* 3d file with z slice (no need for incore speedup -------- */  

       for (islice=nslice1; islice<=nslice2; islice++)
         {
         nrec1  = (islice -1) * nrow + nrow1;
         nrec2  = (islice -1) * nrow + nrow2;

         if (movie == FALSE)
           {
           /* force a new line in montage if necessary */
           if (ndone%nprow == 0) newline = TRUE;
 
           locc(&ixul,&iyul,nsami,nrowspn,&ntop,&nbot,&nrit,
              marx,mary,marlef,martop,iwidex,ihighx,placed,
              newline,&nuscrn,force);
           newline = FALSE;
           }
         if (normit == TRUE)
           {       /* normalize each z slice (handles iskip OK) */
           if (monn(icontx,fileptr,islice,nsami,nrowi,nslices,
               nmint,nmaxt) ==  FALSE) 
             {  waitcursor(iwin, FALSE, 79); return FALSE;}
           }
         else
           {       /* just display (handles iskip OK) */
           if (widisp(icontx,fileptr,nsam,nsam1,nsam2,nrec1,nrec2,
                      fmin,fmax,ixul,iyul,nmint,nmaxt,iskip,FALSE,
                      &imagel,FALSE)  == FALSE)
             {  waitcursor(iwin, FALSE, 79); return FALSE;  }
           }

         if (names == TRUE)
           {    /* put slice number under each pane */
           sprintf(label,"%4d",islice);
           witext(icontx, label, ixul, iyul+nrowspn+2, 1,
                         0, 9, 2, FALSE);
           /* future ! WID_IMGLABEL(LABEL,IXUL,IYUL+NROWS+IYLINE)*/
           }

         if(!ndone) 
           {ixulmon = ixul; iyulmon = iyul;}
         ndone = ndone + 1;
         placed = FALSE;
         /* force desired no. of images / line even if it truncates an image */
         force  = TRUE;
         }   /*for (islice=nslice1; islice<=nslice2; islice++) */
       }     /*  if (axis = z) */
       
     else if ((normit == FALSE && numvox < maxvox) ||
              (normit == TRUE  && numvox < maxflt))
       {   /* can use fast incore routine for display of x or y slices */

       if ((cbuf = (char *) malloc(numvox * sizeof(char))) == (char *) 0)
         { spout(" *** Can not allocate cbuf in mont3."); 
         waitcursor(iwin, FALSE, 79); return FALSE; }

       if (normit == TRUE)
         {   /* normalize slice by slice (handles iskip OK) */
         if (ztoxyn(fileptr,cbuf,nsam,nsam1,nsam2,nrow,nrow1,nrow2,
             nslice,nslice1,nslice2,axis,nmaxt,iskip,mapgo) == FALSE) 
           { if (cbuf)free(cbuf); closefile(fileptr); fileptr = NULL; 
              waitcursor(iwin, FALSE, 79);  cbuf = NULL; return FALSE;}
         }
       else
         {  /* do not normalize by slice */    
         if (ztoxy(fileptr, cbuf,   nsam,   nsam1,   nsam2,
             nrow,   nrow1,   nrow2,nslice, nslice1, nslice2,
             axis, fn, fncon, iskip) == FALSE) 
           {if (cbuf) free(cbuf); closefile(fileptr); fileptr = NULL; 
               cbuf = NULL; waitcursor(iwin, FALSE, 79); return FALSE;}
         }  

       for (islice=1; islice <= nslices; islice++)
         {  /* plot out values returned from ztoxy  routine in cbuf */
         if (movie == FALSE)
           {
           /* find image position */
           /* force a new line in montage if necessary */
           if (ndone%nprow == 0) newline = TRUE;
 
           locc(&ixul,&iyul,nsami,nrowspn,&ntop,&nbot,&nrit,
               marx,mary,marlef,martop,iwidex,ihighx,placed,
               newline,&nuscrn,force);
           newline = FALSE;
           }

         iloc = (islice -1) * nsami * nrowi;
         wipic(icontx, &cbuf[iloc], ixul, iyul, nsami, nrowi, TRUE, 
             TRUE, &imagel); 

         if (names == TRUE)
           {   /* put slice number under each pane */
           sprintf(label,"%4d",islice);
           witext(icontx, label, ixul, iyul+nrowspn+2, 1, 0, 9, 2, FALSE);
           /* future !!!!! WID_IMGLABEL(LABEL,IXUL,IYUL+NROWS+IYLINE)*/
           }

         if(!ndone)
           {ixulmon = ixul; iyulmon = iyul;}
         ndone = ndone + 1;
         placed = FALSE;
         /* force desired no. of images / line even if it truncates image */
         force  = TRUE;
         }    /* for (islice=1; islice <= nslices; islice++) */
       if (cbuf) free(cbuf);  cbuf = NULL; 
     }

   else if (axis == 'y')
     {   /* 3-D FILE WITH Y SLICE,CAN NOT USE FAST INCORE ROUTINE ---- */

     if (normit == FALSE && 
         (cbuf = (char *) malloc(nsami * nrowi * sizeof(char))) == (char *) 0)
       {spout(" *** Can not malloc cbuf2 in mont3."); 
        waitcursor(iwin, FALSE, 79); return FALSE; }

     buf = filedata -> buf;
     for (irow=nrow1; irow<=nrow2; irow++)
       {
       if (movie == FALSE)
          {
          /* find image position */
          /* force a new line in montage if necessary */
          if (ndone%nprow == 0) newline = TRUE;
 
          locc(&ixul,&iyul,nsami,nrowspn,&ntop,&nbot,&nrit,
               marx,mary,marlef,martop,iwidex,ihighx,placed,
               newline,&nuscrn,force);
          newline = FALSE;
          }

       if (normit == TRUE)
          {   /* normalize slice by slice */
          if (monn(icontx,fileptr,irow,
              nsami,nrowi,nslices,nmint,nmaxt) == FALSE)
            {  waitcursor(iwin, FALSE, 79); return FALSE; }
          }
       else
          {           /* OVERALL FILE NORMALIZED Y SLICING */
          if (iskip >= 1)
             {        /* normal or reduced size display */

             /* find upper end of slice and sample series */
             nsliceu = nslice2 - ((nslice2 - nslice1 + 1) % iskip) - 
                       + 1;

             iy = iyul;
             for (islice=nslice1; islice <= nsliceu; islice=islice + iskip)
                {
                irec = (islice -1) * nrow + irow;
                if (redlin(fileptr,buf,nsam,irec) == FALSE) 
                   { if (cbuf) free(cbuf);  cbuf = NULL;
                       waitcursor(iwin, FALSE, 79); return FALSE;}

                l = 0;
                for (isam=nsam1-1; isam<nsam2; isam = isam + iskip)
                  {
                  ival = buf[isam] * fn + fncon;
                  if (ival > 127) ival = ival - 256;
                  cbuf[l++] = ival;
                  }
                /* DISPLAY THIS LINE OF THE IMAGE */
                wipic(icontx, cbuf, ixul, iy++, nsami, 1, TRUE,
                      TRUE, &imagel);  
                }
             }

          else if (iskip < -1)
             {        /* magnified display */
             for (islice=nslice1; islice<=nslice2; islice++)
                {
                irec = (islice -1) * nrow + irow;
                if (redlin(fileptr,buf,nsam,irec) == FALSE) 
                   { if (cbuf) free(cbuf);  cbuf = NULL;
                        waitcursor(iwin, FALSE, 79); return FALSE;}
                iloc = 0;
                for (isam=nsam1-1; isam<nsam2; isam = isam + iskip)
                   {
                   ival = buf[isam] * fn + fncon;
                   if (ival > 127) ival = ival - 256;

                   for (j=1; j <= miskip; j++)
                       cbuf[iloc++] = ival;
                   }

                /* display this line -iskip times */
                for (j=1; j <= miskip; j++)
                   wipic(icontx, cbuf, ixul, iy++, nsami, 1, TRUE,
                      TRUE, &imagel);  
                }
             }
          }
       if (names == TRUE)
          {   /* put slice number under each pane */
          sprintf(label,"%4d",islice);
          witext(icontx, label, ixul, iyul+nrowspn+2, 1, 0, 9, 2, FALSE);
          /* future ! WID_IMGLABEL(LABEL,IXUL,IYUL+NROWS+IYLINE)*/
          }

       if(!ndone)
         {ixulmon = ixul; iyulmon = iyul;}
       ndone  = ndone + 1;
       placed = FALSE;
       /* force desired no. of images / line even if it truncates an image */
       force  = TRUE;
       }
    if (normit == FALSE) { free(cbuf); cbuf = NULL;} 
    }

 else if (axis == 'x')
    {    /* 3-D FILE WITH X SLICE (CAN NOT USE INCORE) ------------- */

    spout("WARNING X AXIS SLICING IS SLOW!");

    if (normit == FALSE && (cbuf = (char *) malloc(nsami * nrowi * sizeof(char))) == (char *) 0)
       {spout(" *** Can not allocate cbuf2 in mont3."); 
       closefile(fileptr);  fileptr = NULL; 
       waitcursor(iwin, FALSE, 79); return FALSE; }

    buf = filedata -> buf;
    for (isam= nsam1; isam<=nsam2; isam++)
       { 
       if (movie == FALSE)
          {
          /* find image position */
          /* force a new line in montage if necessary */
          if (ndone%nprow == 0) newline = TRUE;
 
          locc(&ixul,&iyul, nsami,nrowspn,&ntop,&nbot,&nrit,
               marx,mary,marlef,martop,iwidex,ihighx,placed,
               newline,&nuscrn,force);
          newline = FALSE;
          }

       if (normit == TRUE)
          {   /* normalize slice by slice */
          if (monn(icontx,fileptr,isam,
              nsami,nrowi,nslices,nmint,nmaxt) == FALSE) 
              {
              closefile(fileptr);  waitcursor(iwin, FALSE, 79); 
              fileptr = NULL; return FALSE;}
          }
       else
          {
          if (iskip >= 1)
             {  /* normal or reduced size display */

             /* find upper end of slice and sample series */
             nsliceu = nslice2 - ((nslice2 - nslice1 + 1) % iskip) - 
                       iskip + 1;

             iy = iyul;

             for (islice=nslice1; islice<=nsliceu; islice=islice + iskip)
                {
                irec1 = (islice -1) * nrow + irow;
                l = 0;
                for (irow=nrow1-1; irow<nrow2; irow = irow + iskip)
                  {
                  if (redlin(fileptr,buf,nsam,irec1+irow) == FALSE) 
                     { if (cbuf) free(cbuf);  cbuf = NULL; 
                       closefile(fileptr);  waitcursor(iwin, FALSE, 79); 
                       fileptr = NULL;   return FALSE;}
                  ival = buf[isam-1] * fn + fncon;
                  if (ival > 127) ival = ival - 256;
                  cbuf[l++] = ival;
                  }
                /* DISPLAY THIS LINE OF THE IMAGE */
                wipic(icontx, cbuf, ixul, iy++, nsami, 1, TRUE,  
                      TRUE, &imagel);  
                }
             }

          else if (iskip < -1)
             {        /* magnified display */

             for (islice=nslice1; islice <= nslice2; islice++)
                {
                irec1 = (islice -1) * nrow + irow;
                iloc  = 0;
                iy    = iyul;


                for (irow=nrow1-1; irow<nrow2; irow++)
                   {
                   if (redlin(fileptr,buf,nsam,irec+irow) == FALSE) 
                      { if (cbuf) free(cbuf);  cbuf = NULL; 
                          closefile(fileptr); fileptr = NULL;
                          waitcursor(iwin, FALSE, 79); return FALSE;}

                   ival = buf[isam] * fn + fncon;
                   if (ival > 127) ival = ival - 256;

                   for (j=1; j<=miskip; j++)
                      cbuf[iloc++] = ival;
                   }

                /* display this line -iskip times */
                for (j=1; j <= miskip; j++)
                   wipic(icontx, cbuf, ixul, iy++, nsami, 1, TRUE,
                      TRUE, &imagel);  
                }
             }

          if (names == TRUE)
             {   /* put slice number under each pane */
             sprintf(label,"%4d",islice);
             witext(icontx, label, ixul, iyul+nrowspn+2, 1, 0, 
                    9, 2, FALSE);
             /* future WID_IMGLABEL(LABEL,IXUL,IYUL+NROWS+IYLINE)*/
             }

          if(!ndone) 
            {ixulmon = ixul; iyulmon = iyul;}
          ndone  = ndone + 1;
          placed = FALSE;
          /* force desired no. of images / line even if it truncates an image */
          force  = TRUE;
          }
       } 
    if (normit == FALSE && cbuf) { free(cbuf);  cbuf = NULL;}
    }

    /* free up the file descriptor for this image */
    closefile(filedata); fileptr = NULL;
   } /*  file exists  */
   /* get next file name */
   if (filinc(filnow, filnext, &nlet, &numfil) != FALSE) 
      {   /* file number incrementing succeeded */  
      if (numfil <= endfile || endfile < 0) 
         {     /* still want to display this next file so open it */
         if ((filedatan = openold(filnext, &nsamn, &nrown, &nslicen, 
              &iformn, "q")) == NULL)
            {   /* next file not found (may not exist if * was used) */
                /* stop if lastfile indicates * was used for files */
            file_exist = FALSE;
            if (endfile < 0) toomany = TRUE;
            /* otherwise, skip and continue */

            else strcpy(filnow,filnext);  /* try opening file on next loop */
            }
         else
            {   /* next image file found OK, set filnow to filnext */
            file_exist = TRUE;
            filedata = fileptr = filedatan;
 
            if ((filedata->imami != 1) && (norm(filedata) == FALSE))
              {    
              spout("*** Normalization failed in mont3");
              closefile(filedata); fileptr = NULL;
              waitcursor(iwin, FALSE, 79);
              newline = FALSE;
              return FALSE;
              }

            strcpy(filnow,filnext);
            fmin     = filedata->fmin;
            fmax     = filedata->fmax; 
            nsam     = nsamn;
            nrow     = nrown;
            nslice   = nslicen;
            }       /* ends: if ((filedatan */
         }          /* ends: if (numfil     */
      }             /* ends: if (filinc     */

    force = FALSE;
    if (resetmar == TRUE) marlef = marlefo;

 }               /* ends: do { }while          */

 while ((numfil <= endfile && !toomany) || (endfile < 0 && !toomany));

 /*  CANCEL WAIT CURSOR */
 waitcursor(iwin, FALSE, 79);
 newline = FALSE;
 return TRUE;
 }


