 
/*$Header: /net/alwyn/usr1/web/src/RCS/movearea.c,v 1.4 94/09/12 14:21:54 leith Exp $*/

/*
C++*************************************************************************
C
C MOVEAREA -- MAR 91 al
C             CONVERTED TO C -- SEPT 92 al                                                
C **************************************************************************
C *  PART OF SPIDER - MODULAR IMAGE PROCESSING SYSTEM.                     *
C *  COPYRIGHT (C)1991, WADSWORTH CENTER FOR LABORATORIES AND              *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH                            *
C **************************************************************************
C
C movearea
C
C    PURPOSE:       MOVES AN AREA OF THE SCREEN TO ANOTHER LOCATION
C
C    PARAMETERS:    
C
C    CALLED BY:     winsel
C
C--*********************************************************************
*/

#include "common.h"
#include "routines.h"


 /* internal function prototypes */
 void            movearea_pop (Widget, XEvent *, String *, Cardinal *);

 /* internal common variables */
 static GC       icontxx;

 /* external common variables */
 extern int      iwintyp;

 /**************************************************************/

 void movearea()

 {
 /* make a xor graphics context */
 icontxx = setxor(icontx);
 wicolor(icontxx,icolorov);

 /* set up action procedure to move area */
 actions(iw_win, "movearea_pop", movearea_pop, "M123");

 showbutx("Copies window to this location.",
          "Moves window to this location.",
          "Stops this routine.", FALSE);

 XFlush(idispl);
 } 


 /**************** set window position ***************/


 void movearea_pop(Widget iw_t, XEvent *event, String *params,
                   Cardinal *num_params)
 {
 int ixul1,iyul1,ixult,iyult;
 int icoloro;
 char outstr[60];

 if (!(strcmp(*params,"M")))            /* cursor moved */
    {
    /* get mouse position ix,iy  */
    getloc(event,'M',&ixult,&iyult);

    /* mouse moved so erase old box and draw new box */
    xorbox(iwin,icontxx,FALSE,ixult,iyult,nsamw,nroww);

    ixul1 = ixult;
    iyul1 = iyult;
    } 
  
 else if (!(strcmp(*params,"1")))            /* button 1 pushed */
    {
    getloc(event,'M',&ixult,&iyult);

    /* erase old box */
    xorbox(iwin,icontxx,TRUE,ixult,iyult,nsamw,nroww);

    /* copy source window in backing store to destination */
    XCopyArea(idispl,imagsav,imagsav,icontx,
              ixulw,iyulw,nsamw,nroww,ixult,iyult);

    /* copy source window in backing store to on-screen destination */
    XCopyArea(idispl,imagsav,iwin,icontx,
              ixulw,iyulw,nsamw,nroww,ixult,iyult);

/*******************************/
    sprintf(outstr," (%d,%d) %d X %d --> (%d,%d)", 
    ixulw,iyulw,nsamw,nroww,ixult,iyult); 
    spout(outstr); 
/*******************************/
 
    /* since original windowed may be altered,
       set next move to this destination window */ 
    ixulw = ixult;
    iyulw = iyult;

    }

 else if (!(strcmp(*params,"2")))            /* button 2 pushed */
    {
    /* get mouse position 
    ixult = event -> xkey.x_root;
    iyult = event -> xkey.y_root;   */

    getloc(event,'M',&ixult,&iyult);

    /* erase old box and move original  window to this location */
    xorbox(iwin,icontxx,TRUE,ixult,iyult,nsamw,nroww);

    /* set current color to background in icontx GC */
    icoloro = icolor;
    wicolor(icontx,icolorb);

    XFillRectangle(idispl,iwin,icontx,ixulw,iyulw,nsamw,nroww);

    /* copy source window in backing store to on-screen destination */
    XCopyArea(idispl,imagsav,iwin,icontx,
              ixulw,iyulw,nsamw,nroww,ixult,iyult);

    /* copy source window in backing store to destination */
    XCopyArea(idispl,imagsav,imagsav,icontx,
              ixulw,iyulw,nsamw,nroww,ixult,iyult);

    /* clear backing store source window location */
    XFillRectangle(idispl,imagsav,icontx,ixulw,iyulw,nsamw,nroww);

    /* copy on-screen destination window in backing store destination */ 
    XCopyArea(idispl,iwin,imagsav,icontx,
              ixult,iyult,nsamw,nroww,ixult,iyult);  

    /* since original windowed altered set next move to destination */ 
    ixulw = ixult;
    iyulw = iyult;

    /* restore current forgrround color */
    wicolor(icontx,icoloro);

    }

 else if (!(strcmp(*params,"3")))               
    {                                       /* button 3 pushed */

   /* erase old box */
    xorbox(iwin,icontxx,TRUE,ixul1,iyul1,nsamw,nroww);

    XFreeGC(idispl,icontxx);

    /* uninstall translations */
    XtUninstallTranslations(iw_t);
 
    /* unmanage information box */
    showbutx("","","",TRUE);

    if (iwintyp == 1)
       {  /* interactive windowing (set size again) */
       winsiz1();
       }
    else if (iwintyp == 2)
       {  /* fixed size windowing (use same size) */
       winmov();
       }
    }

 }

