
/*$Header: /net/ithaca/usr1/web/src/RCS/norm.c,v 1.4 1995/05/08 15:11:57 leith Exp $*/
/*
 C++*******************************************************************
 C
 C NORM
 C
 C **************************************************************************
 C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK            *
 C *  COPYRIGHT (C)1981,1987, WADSWORTH CENTER FOR LABORATORIES AND         *
 C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
 C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
 C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
 C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
 C *    THE CENTER FOR LABORATORIES AND RESEARCH 			   *
 C **************************************************************************
 C
 C NORM(FILEPTR)
 C
 C PURPOSE: FINDS MAX, MIN, AV AND STANDARD DEVIATION OF AN IMAGE
 C          PLACES THESE VALUES IN THE HEADER
 C
 C--*******************************************************************
*/

#include "files.h"

 extern int   redlin(FILEDATA *, float *, int, int);
 extern int   setprm(FILEDATA *, char *);

/********************************************************/

 int norm(FILEDATA *fileptr)
 { 

 int       nsam, nrow, nslice, irec, isam;
 double    fmin, fmax, av, av2, sig, b;
 float     pix, *buf;

 nsam   = fileptr -> nsam;
 nrow   = fileptr -> nrow;
 nslice = fileptr -> nslice;
 buf    = fileptr -> buf;

   
 if (redlin(fileptr,buf,nsam,1) != TRUE)
    return FALSE;

 fmax = *buf;
 fmin = fmax;

 av  = 0.0;
 av2 = 0.0;

 for (irec = 1; irec <= nslice * nrow; irec++)
    {
    if (redlin(fileptr,buf,nsam,irec) != TRUE)
       return FALSE;

    for (isam = 0; isam < nsam; isam++)
       {
       b    = *(buf + isam);
       fmax = MYMAX(b,fmax);
       fmin = MYMIN(b,fmin);

       av   = av + b;
       av2  = av2 + b * b;
       }
    }
 pix = nsam * nrow * nslice;

 sig = sqrt (( av2 - ((av * av) / pix)) / (pix - 1.0));
 av  = av / pix;

 fileptr -> fmin = fmin;
 fileptr -> fmax = fmax;
 fileptr -> av   = av;
 fileptr -> sig  = sig;

 return (setprm(fileptr,"u"));
} 
