
/*$Header: /net/ithaca/usr1/web/src/RCS/overlut.c,v 1.4 1995/06/22 16:18:44 leith Exp $*/
/*
C***************************************************************************
C
C    WID_OVERLUT.FOR  -- CREATED FEB 90
C    overlut.c                   NOV 92
C
C **************************************************************************
C *  AUTHOR: ArDean Leith                                                  *
C *  COPYRIGHT (C)1990, WADSWORTH CENTER FOR LABORATORIES AND             *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH                            *
C **************************************************************************
C
C    OVERLUT(void)
C
C    PURPOSE:        TO SET THE COLOR TABLE FOR 7 BIT IMAGES WITH 
C                    X-OR GRAPHICS OVERLAY IN 8 RGB COLORS ONLY
C
C    CALLED BY:     GOLD
C
C--********************************************************************
*/

#include "common.h"
#include "routines.h"

 /*************************  overlut   ****************************/

 void overlut(void)
 {
 static int      ncolors;
 int             i;
 XColor          wantcol;
 XVisualInfo     visual_data;
 Visual          *visualb;

 if (mapover == 0) 
    {
    /*   create a new overlay  color map */

    ncolors = MAXCOL;
    visualb = visual;

    mapover = XCreateColormap(idispl,iwtop,visualb,AllocAll);       
    }

 if (mapover <= 0) 
    { spout("*** In overlut, failed to create colormap"); return; }

 /* recover colors in the normal colormap */
 for ( i=0; i < ncolors; i++)
    {
    colort[i].pixel = i;
    colort[i].flags = DoRed|DoGreen|DoBlue; 
    }
 XQueryColors(idispl,map,colort,ncolors);

 wantcol.flags = DoRed|DoGreen|DoBlue;
 wantcol.pixel = icolorov;
 XQueryColor(idispl, map, &wantcol);


 for (i = mapend + 1; i < ncolors; i++)
     {
     colort[i].pixel = i;
     colort[i].red   = wantcol.red;
     colort[i].green = wantcol.green;
     colort[i].blue  = wantcol.blue;
     colort[i].flags = DoRed|DoGreen|DoBlue;
     }

 /* put new colors in the blackout colormap */
 XStoreColors(idispl,mapover,colort,ncolors);

 /* associate colormap with window */
 setamap(mapover);

 /********************
 XFlush(idispl);
 XSetWindowColormap(idispl,iwin,mapover);
 XFlush(idispl);
 **********************/
 }


