
/*$Header: /net/ithaca/usr1/web/src/RCS/pickbackave.c,v 1.6 1996/05/13 14:40:04 leith Exp $*/

/*
C++*************************************************************************
C
C    pickbackave
C
C **************************************************************************
C *  COPYRIGHT (C)1993, WADSWORTH CENTER FOR LABORATORIES AND              *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH                            *
C **************************************************************************
C
C    pickbackave
C
C    PURPOSE:    add average to background averge docfile (dfil)
C
C    CALLED BY:  pickbackmen.c 
C
C **************************************************************************
*/

#include "common.h"
#include "routines.h"

 /********************   pickbackave   ****************************/

 void pickbackave(char dfil[])

 { 
 int      ncount, k, maxregp1, maxkeys, openit, maxback;
 float  * dbuf = NULL, * ptr;
 float    sum, dlist[6];
 FILE   * fp = NULL;

 /* set size for array pointed to by dbuf */
 maxregp1 = 5+1;
 maxkeys  = 1001;

 /* retrieve data from dfil1 for untilted points */
 
 if (getdoc((FILE *) NULL, dfil, datexc, maxkeys, maxregp1, 
           &dbuf, &maxback) > 0) 
    {   /* problem retrieving doc file, assume it does not exist */
    if (dbuf) free(dbuf); dbuf = NULL;
    spouts("*** Unable to read doc. file: "); spout(dfil); 
    return;
    }

 ptr    = dbuf;
 sum    = 0.0;
 ncount = 0;

 for (k = 0; k < maxback; k++)
    {
    if (*ptr != 0.0) 
        { ncount++; sum += *(ptr+1);  }
    ptr  += maxregp1; 
    }

 if (ncount < 1)
   {
   spouts("*** No windows for averaging from doc. file: ");spout(dfil);
   XBell(idispl,50);
   return;
   }

 /* find average */
 sum = sum / ncount;
 dlist[0] = 999; dlist[1] = sum;
 dlist[2] = 0.0; dlist[3] = 0.0; dlist[4] = 0.0; dlist[5] = 0.0;
 
 /* save info in doc file  */
 openit = TRUE;  
 if (!(fp = savdn1(dfil, datexc, &fp, dlist, 6, &openit, TRUE, TRUE))) 
    { /* unable to open the doc file!! */
    XBell(idispl,50); XBell(idispl,50); return;
    }

 fclose(fp);     
 return;

}

