/*$Header: /net/ithaca/usr1/web/src/RCS/pickdraw.c,v 1.10 1996/05/06 16:23:45 leith Exp $*/

/*
C++*********************************************************************
C
C pickdraw
C
C **********************************************************************
C *  AUTHOR:  ArDean Leith                                                 *
C *  COPYRIGHT (C)1993, WADSWORTH CENTER FOR LABORATORIES AND              *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH                            *
C **********************************************************************
C
C    pickdraw
C
C    PURPOSE:         display points from recovered arrays
C
C    CALLED BY:       pickp, fitmen
C
C***********************************************************************
*/

#include "common.h"
#include "routines.h"

 /* external common variables */
 extern int    ixull, iyull, ixulr, iyulr;
 extern float  * xu0, * yu0, * xs, * ys, * xs2, * ys2, * xim;
 extern int    iradi;   /* marker radius, set in pickp */

 /************************  pickdraw *********************************/

 void pickdraw(int leftside,  int ritside, 
               int locations, int numbers,  int predicted, int iend)
 {
 char *  string = NULL;
 int     ixi, iyi, i;

 /* set color to green */
 wicolor(icontx,colorgo + 29);
 /* draw each of the points */
 for (i= 0; i < iend; i++)
    {
    if (leftside)
       {
       if( xu0[i] > nsam1l && xu0[i] < nsam2l && yu0[i] > nrow1l 
              && yu0[i] < nrow2l)
          {  
          ixi = xu0[i] + ixulli;
          iyi = yu0[i] + iyulli;
          if (locations)
             {
             /*   draw a circle at this location */
             xorc(iwin,icontx,   TRUE,ixi,iyi,iradi);
             xorc(imagsav,icontx,TRUE,ixi,iyi,iradi);
             }

          if (numbers)
             {
             /*   write marker number at this location */
             string = itoa(i + 1);
             witext(icontx, string, ixi, iyi, 1, 0, 9, 2, FALSE);
             if(string) {free(string); string = (char *) NULL;}
             }
          }
       }

    if (ritside)
       {
       if( xs[i] > nsam1r && xs[i] < nsam2r && ys[i] > nrow1r 
              && ys[i] < nrow2r)
          {  
          ixi = xs[i] + ixulri;
          iyi = ys[i] + iyulri;
          if (locations)
             {
             /*   draw a circle at this location */
             xorc(iwin,icontx,   TRUE,ixi,iyi,iradi);
             xorc(imagsav,icontx,TRUE,ixi,iyi,iradi);
             }

          if (numbers)
             {
             /* write marker number at this location */
             string = itoa(i + 1);
             witext(icontx, string, ixi, iyi, 1, 0, 9, 2, FALSE);
             if(string) {free(string); string = (char *) NULL;}
             }
          }
       }

    if (predicted)
       {
       if( xs2[i] > nsam1r && xs2[i] < nsam2r && ys2[i] > nrow1r 
              && ys2[i] < nrow2r)
          {  
          ixi = xs2[i] + ixulri;
          iyi = ys2[i] + iyulri;
          if (locations)
              {
              /* draw a box at this location */
              xorbox(iwin,icontx,   TRUE,ixi-2,iyi-2, 5,5);
              xorbox(imagsav,icontx,TRUE,ixi-2,iyi-2, 5,5);
              }
          if (numbers)
              {
              /* write marker number at this location */
              string = itoa(i + 1);
              witext(icontx, string, ixi, iyi, 1, 0, 9, 2, FALSE);
              if(string) {free(string); string = (char *) NULL;}
              }
           }
       }
    }

 /*     refresh screen  */
 expos_cb(NULL,NULL,NULL);

 }
