
/*$Header: /net/ithaca/usr1/web/src/RCS/pixel.c,v 1.15 1996/07/25 15:46:00 liy Exp $*/
/*
 * pixel.c
 *
 ***********************************************************************
 * COPYRIGHT (C)1992, WADSWORTH CENTER FOR LABORATORIES AND
 * RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.  
 * THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     
 * LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  
 * USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF 
 * THE CENTER FOR LABORATORIES AND RESEARCH 			  
 ***********************************************************************
 *
 * 
 * 
 * PURPOSE:     Find location of pixel      
 * 
 * PARAMETERS:	Widget 		iw_temp		pushbutton (not used)
 *		caddr_t		data		label text string
 *		caddr_t		call_data	not used 
 *
 ***********************************************************************
*/

#include "common.h"
#include "routines.h"

 /* internal functions */
 void    pixel_pop (Widget, XEvent *, String *, Cardinal *);

 /* external variables */
 extern XImage  * imagep;
 extern char      outstr[80];
 extern int       ixreg, iyreg, isreg, ivreg;
 extern int       pixelmen_showing;
 extern FILEDATA  *filedatap;

 /* internal common variables */
 FILE             *fpdocpix = 0;
 int		  *pixellist;
 int	          pixelnum;

 /* static viarables */
 static int       openitp = TRUE;
 static int	  bufsiz  = 0;

/***************************  pixel  *********************************/

 void pixel(void)
 {
 
 openitp  = TRUE;
 pixelnum = 0;

 /* open a message window with the following strings  */
 showbutx("Query location.", 
          "Menu.", 
          "Stop this routine.", FALSE);

 /* set the actions for right, left, and center buttons */
 actions(iw_win, "pixel_pop", pixel_pop,"M123");

 }


 /************************* pixel_pop ********************************/

 void pixel_pop(Widget iw_t, XEvent *event, String *params,
               Cardinal *num_params)
 {
 int   ixi, iyi, ixs, iys, ipix, irect, i, savdocit;
 float fval;
 float dlist[7];

 if (!(strcmp(*params, "M")))
    {                           /* List location ------- mouse moved */
    getloc(event,'m',&ixs,&iys);
    if (inimag) 
       {     /* find location relative to last image */
       ixi = ixs - ixul + 1;
       iyi = iys - iyul + 1;
       }
    else
       {
       ixi = ixs;
       iyi = iys;
       }

    if (inimag && (ixi < 1 || ixi > nsam ||
                   iyi < 1 || iyi > nrow))
       {    /* cursor is outside of image, only want inside */
       if (getscreen)
          {      /* list location and screen value anyway */
          if (iys > (ihighx - iyulx))
             {
             sprintf(outstr,"*** Outside: (%d,%d) = (off screen)$",
                    ixi,iyi);
             }
          else
             {
             ipix = XGetPixel(imagep,ixs-ixulx,iys-iyulx);
             sprintf(outstr,"Outside: (%d,%d) = %d$",ixi,iyi,ipix);
             }          
          }
       else
          sprintf(outstr,"*** Outside: (%d,%d)$", ixi,iyi);
       }

    else if (getscreen)
       {      /* cursor inside image and want screen value */     
       if (iys > (ihighx - iyulx))
          sprintf(outstr,"Location: (%d,%d) = (off screen)$",ixi,iyi);
       else
          {
          ipix = XGetPixel(imagep,ixs-ixulx,iys-iyulx);
          sprintf(outstr,"Location: (%d,%d) = %d$",ixi,iyi,ipix);
          }
       }

    else if (inimag)
       /* want position relative to image*/
       sprintf(outstr,"Location in image: (%d,%d)$", ixi,iyi);

    else
       /* cursor inside image*/
       sprintf(outstr,"Screen location: (%d,%d)$", ixi,iyi);

    spout(outstr);
    } 

 else if (!(strcmp(*params, "1")))
    {                     /*  List location -------- button 1 pushed */
    getloc(event,'B',&ixs,&iys);

    if (inimag) 
       {     /* find location relative to last image */
       ixi = ixs - ixul + 1;
       iyi = iys - iyul + 1;
       }
    else
       {
       ixi = ixs;
       iyi = iys;
       }

    if (inimag && ( ixi < 1 || ixi > nsam ||
                    iyi < 1 || iyi > nrow))
       {    /* cursor is outside of image, only want inside */
       sprintf(outstr,"*** Outside image: (%d,%d)", ixi,iyi);
       spout(outstr);
       }

    else 
       {   /* want to record this location */

       if (getfile)
          {    /* want value in image at this location */
          irect = (islice -1) * nrow + iyi -1;

          if (redlin(filedatap,filedatap -> buf,nsam,irect) == FALSE) return;
          fval = filedatap -> buf[ixi -1];
          }

       if (getfile && getscreen)
          /* record location, screen and file values */
          {
          if (iys > (ihighx - iyulx))
             {
             sprintf(outstr,"Key:%d  (%d,%d) = (off screen) from:%f",
                      ikey,ixi,iyi,fval);
             }
          else
             {
             ipix = XGetPixel(imagep,ixs-ixulx,iys-iyulx);
             sprintf(outstr,"Key:%d  (%d,%d) = %d from:%f",
                            ikey,ixi,iyi,ipix,fval);
             } 
          }

      else if (getfile)
          /* record location and file values */
          sprintf(outstr,"Key:%d  (%d,%d)   from:%f",ikey,ixi,iyi,fval);

      else if (getscreen)
          /* record location and  screenvalues */
         if (iys > (ihighx - iyulx))
             {
             sprintf(outstr,"Key:%d  (%d,%d) = (off screen)",
                     ikey,ixi,iyi);
             }
          else
             {
             ipix = XGetPixel(imagep,ixs-ixulx,iys-iyulx);
             sprintf(outstr,"Key:%d  (%d,%d) = %d", ikey,ixi,iyi,ipix);
             }
      else 
          /* record location */
          sprintf(outstr,"Key:%d  (%d,%d)",ikey,ixi,iyi);

      spout(outstr);

       if (docit)
          {  /* save info in doc file */ 

          /*     put this marker in the file */
          for (i=1; i <=6; i++) dlist[i] = 0.0;

          dlist[0] = ikey;
          dlist[ixreg] = ixi;
          dlist[iyreg] = iyi;
          if (getscreen) dlist[isreg] = ipix;
          if (getfile)   dlist[ivreg] = fval;  
          fpdocpix    = savdn1(docnam, datexc, &fpdocpix, dlist, 7, 
                     &openitp, TRUE, TRUE);
          }

       if (leavit)
          {
	  /* check the pixel buffer size, if the size is not enough to the new */
	  /* pixel, add more */
 	  if (pixelnum >= bufsiz-1) {
             if ((pixellist = (int *) realloc(pixellist, (bufsiz+400)*
                    	sizeof(int))) == NULL)
             {
             spout("*** Unable to reallocate pixelbuf memory in pixel.c");
             return;
             }
	     bufsiz = bufsiz+400;
	  }
	     
	  /* record the pixel number */
	  pixellist[pixelnum] = ixi;		pixelnum++;
	  pixellist[pixelnum] = iyi;		pixelnum++;

	  /* leave permanent circle at this location */
          xorc(iwin,    icontx, TRUE, ixs, iys, iradius);
          xorc(imagsav, icontx, TRUE, ixs, iys, iradius);
          }
       }
       ikey++;
    }

 else if (!(strcmp(*params, "2")))
    {                    /* show menu --------       button 2 pushed */
    /* kludge to prevent file name incrementing */
    savdocit = docit; docit = FALSE; 
    pixelmen_showing = TRUE;
    docit   = savdocit;
    pixelmen(NULL, NULL, NULL); 
    }

 else if (!(strcmp(*params, "3")))
    {                    /* stop routine -------    button 3 pushed */
    pixelmen_showing = TRUE;
    pixelmen_buts(NULL,NULL,NULL);
    pixelnum = 0;
    }
 }
