/*$Header $*/

/***********************************************************************
 *
 * pop_errmsg.c
 *
 ***********************************************************************
 * author : ArDean Leith
 * COPYRIGHT (C)1993, WADSWORTH CENTER FOR LABORATORIES AND
 * RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      
 * THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     
 * LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  
 * USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF 
 * THE CENTER FOR LABORATORIES AND RESEARCH                       
 ***********************************************************************
 *
 * pop_errmsg()
 * 
 * PURPOSE:    .
 *
 * RETURNS:    
 *
 * PARAMETERS: 
 *
 ***********************************************************************
*/

#include "x.h"
#include <Xm/MessageB.h>

extern  Widget   iw_win;

/****************************** Str2XmString *************************/

XmString Str2XmString( char *string )
    {    
     XmString        motif_string;

     motif_string = XmStringCreateLtoR( string, 
                                XmSTRING_DEFAULT_CHARSET );

     return( motif_string );
     }       

/****************************** RemoveDialButton *********************/

void RemoveDialButton( Widget widget, int which_button )
   {      
   Widget  dead_widget;

   dead_widget = (Widget) XmMessageBoxGetChild( widget, which_button );

   XtUnmanageChild( dead_widget );
   }      
 
/******************************  pop_errmsg_buto *********************/

void pop_errmsg_buto(Widget widget, caddr_t client_data, 
                           XmAnyCallbackStruct * call_data)
   {
   XtRemoveGrab( widget );
   XtUnmanageChild( widget );
   }

/******************************  pop_errmsg *************************/

void pop_errmsg( char message[] )
   {
   Arg             args[2];
   static Widget   widget = (Widget) 0;
   XmString        motif_string;

   motif_string = Str2XmString( message );

   if (widget == 0)
      { 
      widget = (Widget) XmCreateErrorDialog(iw_win, "Error Message",
                                            NULL, 0 );

      RemoveDialButton(widget, XmDIALOG_HELP_BUTTON );
      RemoveDialButton(widget, XmDIALOG_CANCEL_BUTTON );
      XtAddCallback(widget, XmNokCallback, 
                        (XtCallbackProc) pop_errmsg_buto, NULL);
      }

   XtSetArg( args[0], XmNmessageString, motif_string );
   XtSetValues(widget, args, 1);

   XtAddGrab(widget, TRUE, FALSE);
   XtManageChild(widget);

   XmStringFree(motif_string );
   }      

