
/*$Header: /usr1/web/src/RCS/querylut.c,v 1.2 94/07/26 11:04:25 odesanya Exp $*/
/*
C***********************************************************************
C
C querylut.c
C
C **********************************************************************
C    AUTHOR:  ArDean Leith
C *  COPYRIGHT (C)1994, WADSWORTH CENTER FOR LABORATORIES AND          *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.  *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS *
C *    OR USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN        *
C *    APPROVAL OF THE CENTER FOR LABORATORIES AND RESEARCH            *
C **********************************************************************
C
C    PURPOSE:        determine best colormap positions for ramp & colors
C
C    PARAMETERS:     values for the ramp start... end
C                    colors start...end
C
C    CALLED BY:      defluts
C
C    CALLS:     
C
C--*********************************************************************
*/

#include "std.h"
#include "x.h"
#include "routines.h"

#define  MAXCOLT 256

 extern Display   *idispl;

 /*************************  querylut   *******************************/

 int querylut(Colormap mapt, int * mapgot,  int * mapendt, 
                int * colorgot, int *colorendt) 
 {

 int             i;
 XColor          colors[MAXCOLT];

 /* query existing  colors used in lut  */
 for (i=0; i <MAXCOLT; i++)
    {
    colors[i].pixel = i;
    colors[i].flags = DoRed|DoGreen|DoBlue; 
    }
 XQueryColors(idispl, mapt, colors, MAXCOLT);

 * mapgot  = 0;
 * mapendt = 127;
 for (i = 0; i <= (* mapendt); i++)
    {
    if (colors[i].red > 0 || colors[i].green > 0 || 
        colors[i].blue  > 0) *mapgot = i;
    }

 * colorgot  = 128;
 * colorendt = MAXCOLT-1;
 for (i = (*colorendt); i >= (* colorgot); i--)
    {
    if (colors[i].red > 0 || colors[i].green > 0 || 
        colors[i].blue  > 0) *colorendt = i;
    }

    i = *mapgot;    *mapgot = i + 1; 
    i = *colorendt; *colorendt = i - 1;

  return TRUE;
}

