
/*$Header: /alwyn/usr1/web//RCS/radcur.c,v 1.1 93/11/23 16:14:52 leith Exp $*/
/*
C++*************************************************************************
C
C RADCUR.C  -- CREATED NOV 93 from curmen.c -- al
C                                                                   
C **************************************************************************
C *  AUTHOR: A. LEITH                                                      *
C *  COPYRIGHT (C)1991, WADSWORTH CENTER FOR LABORATORIES AND              *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH                            *
C **************************************************************************
C
C    radcur()
C
C    PARAMETERS:   IW_PARENT   PARENT WIDGET
C                  IXUL,IYUL   CORNERS OF WIDGET
C
C    PURPOSE:      SETS UP A CURSOR SELECTION SUPER-WIDGET
C
C    CALLED BY: 
C
C--*********************************************************************
*/

#include "common.h"

 /* external function prototypes */
 extern void   spout        (char *);
 extern int    wimakecur    (Cursor *, char * , char *,
                             XColor *, XColor *, int, int);
 extern void   setacursor   (int, int, int);
 
 /* externally defined common variables */
 extern Cursor   icurrad;

 /* internal common variables */


 /*  TO CALCULATE CURSOR APPEARANCE USE A 16X16 GRID.  USE A 
      ENDIAN NUMBERING SYSTEM THAT STARTS WITH ONE AT LEFT END
      OF EACH BYTE NOT AT THE USUAL RIGHT END!  */


 static char lfore[] = {
      0X01, 0X80,   0X02, 0X40, 
      0X04, 0X20,   0X08, 0X10, 
      0X10, 0X08,   0X00, 0X00, 
      0X00, 0X00,   0X00, 0X00, 
      0X00, 0X00,   0X00, 0X00, 
      0X00, 0X00,   0X10, 0X08, 
      0X08, 0X10,   0X04, 0X20, 
      0X02, 0X40,   0X01, 0X80 };

 static char lback[] = {
      0X03, 0XC0,   0X07, 0XE0, 
      0X0E, 0X70,   0X1C, 0X38, 
      0X18, 0X18,   0X00, 0X00, 
      0X00, 0X00,   0X00, 0X00, 
      0X00, 0X00,   0X00, 0X00, 
      0X00, 0X00,   0X18, 0X18, 
      0X1C, 0X38,   0X0E, 0X70, 
      0X07, 0XE0,   0X03, 0XC0 };


 /***************************** radcur *******************************/

 void radcur(int idum)
 {


 if (icurrad == 0)
    {
    /* must make cursor before it can be used */

    wimakecur(&icurrad,lfore,lback,
                      &colorcursf,&colorcursb, 8,8);
    }
 }


