
/*$Header: /net/ithaca/usr1/web/src/RCS/rdpriw.c,v 1.5 1996/05/16 17:34:41 leith Exp $*/
/*
 * rdpriw.c
 *
 **********************************************************************
 * COPYRIGHT (C)1992, WADSWORTH CENTER FOR LABORATORIES AND
 * RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.
 * THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     
 * LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  
 * USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF 
 * THE CENTER FOR LABORATORIES AND RESEARCH 			  
 **********************************************************************
 *
 * 
 * 
 * PURPOSE:	retrieves string from widget and converts to integer
 *              checks to see if value of integer is within range
 *
 * RETURNS:	error flag (FALSE is error!)
 * 
 * PARAMETERS:  iw_it     widget to be interrogated
 *              message   error message
 *              ival      integer value (returned)
 *              
 * 
 *
 **********************************************************************
*/

#include "std.h"
#include "x.h"
#include <Xm/TextF.h>
#include <Xm/Text.h>

 /* function prototypes */
 extern void spout(char *);
 extern void spouts(char *);
 extern void spouti(int);

 /*************************** rdpriw ******************************/
 
 int rdpriw(int * ival, int ilow, int ihi, Widget iw_it, 
              char * message, char * cdum)
 {

 char * string;

 if (iw_it == (Widget) 0)
    {
    spout("iw_it not set, pgm. error in rdpriw caller");
    return FALSE;
    }

 string = XmTextGetString(iw_it);

 if (sscanf(string,"%d",ival) <= 0)  
    {
    spouts("*** Illegal value for: "); spout(message);
    if (string) XtFree(string);
    return FALSE;
    } 

 if (* ival < ilow || *ival > ihi)
    {
    spouts("*** "); spouts(message); spouts(" out of range: ");
    spouti(ilow);   spouts("..."); spouti(ihi); spout(" "); 
    if (string) XtFree(string);
    return FALSE;
    } 

 XtFree(string);
 return TRUE;
 }

