
/*$Header: /alwyn/usr1/web//RCS/redlin8.c,v 1.1 94/03/18 16:22:00 leith Exp $*/
/*
C**************************************************************************
C
C   REDLIN8.C  -- CREATED MAR 4 1994
C             
C **************************************************************************
C *  AUTHOR: ArDean Leith                                                  *
C *  COPYRIGHT (C)1992, WADSWORTH CENTER FOR LABORATORIES AND RESEARCH     *
C *    NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.              *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH  			   *
C **************************************************************************
C
C  REDLIN8(FILEDATA,CDATA,NSAM,IREC)
C           
C
C  PURPOSE:     READS SPIDER IMAGE INTO 8 BIT ARRAY NORMALIZED FROM
C               NMIN TO NMAX.  RETURNS NORMALIZTION CONSTANTS ALSO.
C
C  PARAMETERS:  NSAM1

C  RETURNS:     
C
C  CALLED BY:   SURF
C
C  NOTES:       
C
C--*********************************************************************
*/

#include "files.h"

 /* external function prototypes */
 extern void  spout     (char *);

 /* externally defined variables */
 
 /* static variables for use here */


 /*************************   redlin8   ****************************/

 int redlin8(FILEDATA *fileptr, unsigned char *buf, int nsam, int irec)
 {

 FILE      *fp;
 int       ioff;
 size_t    igot;

 /* find number of header and record bytes to be skipped */
 if (irec != 0) 
    ioff  = fileptr -> offset + (irec - 1) * nsam;
 else
    ioff  = 0;


 /* find file pointer for this file */
 fp    = fileptr -> fp;

 if ((igot = fseek(fp,ioff,SEEK_SET)) != 0) 
     {       /* offset seek failed */
     printf("*** seek failed in redlin8: %d \n",igot);
     printf(" igot: % d, ioff: %d ,nsam: %d \n",igot,ioff,nsam);
     return FALSE;
     }

 /* offset seek was successful, read record number nsam */
 igot = fread(buf, sizeof(unsigned char), nsam, fp);

 if (feof(fp))
      {
      printf("*** End of file in redlin8 \n");
      printf("igot: %d, ioff: %d ,nsam: %d \n",igot,ioff,nsam);
      return FALSE;
      }          

 if (ferror(fp))
      {
      printf("*** Error reading input file in redlin8 \n");
      return FALSE;
      }

 return TRUE;
 }



