/*$Header: /alwyn/usr1/web//RCS/redlin8f.c,v 1.1 94/03/02 12:11:15 leith Exp $*/
/*
 * redlin8.c
 *
 *************************************************************************
 * AUTHOR: A. LEITH 
 * COPYRIGHT (C)1981,1992, WADSWORTH CENTER FOR LABORATORIES AND
 * RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
 * THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     
 * LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  
 * USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF 
 * THE CENTER FOR LABORATORIES AND RESEARCH 			  
 **************************************************************************
 *
 * redlin8(fileptr,buf,nsam,irec)
 * 
 * PURPOSE:     
 *
 * RETURNS:      TRUE IF OK, FALSE OTHERWISE
 * 
 * PARAMETERS:   fileptr
 *               buf
 *               nsam
 *               irec    
 *
 *********************************************************************/

#include "files.h"

 int redlin8f(FILEDATA *fileptr, float *buf, int nsam, int irec)
 {

 FILE          * fp;
 int             ioff,i;
 size_t          igot;
 unsigned char * cptr;


 /* find number of header and record bytes to be skipped */
 if (irec !=0)
    ioff  = fileptr -> offset + (irec - 1) * nsam;
 else
    ioff  = 0;


 /* find file pointer for this file */
 fp    = fileptr -> fp;

 if ((igot = fseek(fp,ioff,SEEK_SET)) != 0) 
     {       /* offset seek failed */
     printf("*** Seek failed in redlin8f: %d \n",igot);
     printf(" igot: % d, ioff: %d ,nsam: %d \n",igot,ioff,nsam);
     return FALSE;
     }

 /* offset seek was successful, read record number nsam */
 cptr = (unsigned char *) buf;
 igot = fread(cptr, sizeof(unsigned char), nsam, fp);

 if (feof(fp))
      {
      printf("*** End of file in redlin8f. \n");
      printf("igot: %d, ioff: %d ,nsam: %d \n",igot,ioff,nsam);
      printf("headbyt: %d, irec: %d ,offset: %d \n",
              fileptr->headbyt,irec,fileptr->offset);
      return FALSE;
      }          

 if (ferror(fp))
      {
      printf("*** Error reading input file in redlin8f. \n");
      return FALSE;
      }

 /* convert from 8 bit raw to floating point */
 cptr = (unsigned char *) buf + nsam - 1;
 for (i= nsam-1; i >= 0; i--)
    {
    buf[i] = *cptr--;
    }

 return TRUE;
 }

