
/*$Header: /net/alwyn/usr1/web/src/RCS/redvol8.c,v 1.3 1994/07/12 19:44:28 odesanya Exp $*/
/*
C**************************************************************************
C
C   REDVOL8.C  -- CREATED NOV 13 1992
C             
C **************************************************************************
C *  AUTHOR: ArDean Leith                                                  *
C *  COPYRIGHT (C)1992, WADSWORTH CENTER FOR LABORATORIES AND RESEARCH     *
C *    NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.              *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH  			   *
C **************************************************************************
C
C  REDVOL8(FILEDATA,CVOL,NSAM1,NSAM2,NROW1,NROW2,NSLICE1,NSLICE2,
C          FN,FNCON)
C           
C
C  PURPOSE:     READS SPIDER IMAGE INTO 8BIT ARRAY NORMALIZED FROM
C               NMIN TO NMAX.  RETURNS NORMALIZTION CONSTANTS ALSO.
C
C  PARAMETERS:  NSAM1,NSAM2     SAMPLE RANGE
C               NROW1,NROW2     ROW RANGE
C               NSLICE1,NSLICE2 SLICE RANGE

C  RETURNS:     
C
C  CALLED BY:   SURF
C
C  NOTES:       
C
C--*********************************************************************
*/

#include "files.h"


 /* external function prototypes */
 extern int   closefile(FILEDATA *);
 extern int   redlin    (FILEDATA *, float *, int, int);
 extern void  spout     (char *);


 /* externally defined variables */
 
 /* static variables for use here */


 /*************************   redvol8   ****************************/

 int redvol8(FILEDATA *filedata, unsigned char  * cptr,
         int nsam1, int nsam2, int nrow1, int nrow2, 
         int nslice1, int nslice2, int nmint, int nmaxt, 
         float * fn, float * fncon)

 {
 int             nsam, nrow, nslice, irec;
 int             islice, irow, isam ;
 float           * buf;
 unsigned char * cptrt;

 nsam   = filedata -> nsam;
 nrow   = filedata -> nrow;
 nslice = filedata -> nslice;

 /* find buf for redlin */
 buf    = filedata -> buf;

 /* load volume data into 8 bit vol */

 *fn     = (nmaxt - nmint ) / ((filedata-> fmax) - (filedata -> fmin));
 *fncon  = (-filedata -> fmin * *fn) + nmint;

 /* fill volume with 8 bit data */
 irec   = 0;

 cptrt = cptr;

 for (islice = 0; islice < nslice; islice++)
    {
    for (irow = 0; irow < nrow; irow++)
       {
       if (!redlin(filedata,buf,nsam,++irec))
          return FALSE;

       for (isam =0; isam < nsam; isam++)
          {
          *cptrt++ =  (unsigned char) (buf[isam] * *fn + *fncon);
          }
       }
    }
 return TRUE;
 }




