
/*$Header: /alwyn/usr1/web/RCS/rhist.c,v 1.1 93/11/10 10:11:41 leith Exp $*/
/*
C++*******************************************************************
C
C  RHIST.FOR
C  rhist.c          NOV 92
C **************************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK            *
C *  COPYRIGHT (C)1981,1987, WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH                            *
C **************************************************************************
C
C RHIST(LUN,A)
C
C PURPOSE:   READS HISTOGRAM RECORDS FROM AN IMAGE FILE INTO ARRAY A
C
C PARAMETERS:        filedata  file info
C                    A         HISTOGRAM ARRAY
C
C--*******************************************************************
*/

#include "files.h"

 /* external subroutines */
 extern int    redlin     (FILEDATA *, float *, int, int);
 extern void   spout      (char *);


 /********************** rhist  **********************************/

 int rhist(FILEDATA *filedata, int * jhist)

 {
 int    in, irec, i;
 int    nsam;
 float  * buf;


 /* check if histogram data not in image file yet */
 if (filedata -> ihist != 1)  
    {
    printf("filedata -> ihist: %d \n", filedata -> ihist);
    spout("*** No histogram in file.");
     return FALSE;
     }

 buf  = filedata -> buf;
 nsam = filedata -> nsam;

 in   = nsam;
 irec = filedata -> nrow * filedata -> nslice;

 for (i = 0; i < 128; i++)
    {
    if (in++ >= nsam-1)
       {
       /* need to read another input record */
       if (!redlin(filedata,buf,nsam,++irec)) return FALSE; 
       in = 0;
       } 

    /* put histogram bin value in array a */    
    jhist[i] = buf[in];
    }

 return TRUE;
 }
