
/*$Header: /net/ithaca/usr1/web/src/RCS/rubberline.c,v 1.2 1995/09/06 16:27:05 mladjadj Exp $*/
/*
C***************************************************************************
C
C RUBBERLINE  -- CREATED DEC 89 as WID_RUBR.FOR
C                ALTERED FOR WIDGETS MAR 91 al
C                CONVERTED TO C OCT 92 al
C **************************************************************************
C *  AUTHOR: ArDean Leith                                                  *
C *  COPYRIGHT (C)1989, WADWSWORTH CENTER FOR LABORATORIES AND RESEARCH,  *
C *    NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.              *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH  			   *
C **************************************************************************
C
C RUBBERLINE
C
C PURPOSE:      DRAWS RUBBER BAND LINES 
C
C PARAMETERS:   NONE
C
C CALLED BY:    WEB_COM
C
C--*********************************************************************
*/

#include "std.h"
#include "x.h"
#include "common.h"

 /* external subroutines */
 extern void     xorline    (Window, GC, int, int, int, int, int);
 extern GC       setxor     (GC);
 extern void     showbutx   (char *, char *, char *, int);
 extern void     actions    (Widget, char *, void (*)(), char *);
 extern void     getloc     (XEvent *, char, int *, int *);
 
 /* internal subroutines */
 void rubber_pop(Widget, XEvent *, String *, Cardinal *);
 
 /* global variables */
 static GC  icontxx;
 static int firstpt;
 static int ix1, iy1, ix2, iy2;



/*********************  rubberline  *******************************/

 void rubberline(void)
 {
 
 /* open a message window with the following strings */
 showbutx("Starts / sets line segment.", 
          NULL, 
          "Stop this routine.", FALSE);


 /* set the actions for right, left, and center buttons */
 actions(iw_win, "rubber_pop",rubber_pop,"M13");

 /* turn on xor wiriting in icontxx */
 icontxx = setxor(icontx);

 /* set first point flag */
 firstpt = TRUE;
 }


 /**************** rubber_pop  (draw rubber lines)  ***************/


 void rubber_pop(Widget iw_t, XEvent *event, String *params,
                   Cardinal *num_params)
 {

 if (!(strcmp(*params,"M")))                 /* cursor moved */
    {
    /* get mouse position ix2,iy2  */
    getloc(event,'M',&ix2,&iy2);

    if (!firstpt)
       {
       /* already have line, mouse moved, so erase and draw new line */
       xorline(iwin,icontxx,FALSE,ix1,iy1,ix2,iy2);
       }
    }

 else if (!(strcmp(*params,"1")))            /* button 1 pushed */ 
    {
    /* get mouse position ix2,iy2  */
    getloc(event,'M',&ix2,&iy2);

    if (firstpt)
       firstpt = FALSE;
    else
       {   /* draw permanent line to this location */
       xorline(iwin,icontx,TRUE,ix1,iy1,ix2,iy2);
       /* save line in backing store */
       xorline(imagsav,icontx,TRUE,ix1,iy1,ix2,iy2);
       }
    ix1 = ix2;
    iy1 = iy2;
    }
 
 else if (!(strcmp(*params,"3")))          /* button 3 pushed */        
    {                                       

    /* erase old line and cancel this routine */
    xorline(iwin,icontxx,TRUE,ix1,iy1,ix2,iy2);

    XFreeGC(idispl,icontxx);

    /* uninstall translations */
    XtUninstallTranslations(iw_t);
 
    /* unmanage information box */
    showbutx("","","",TRUE);

    /* reset first point jflag */
    firstpt = TRUE;

    return;
    }
 }
