 
/*$Header: /net/alwyn/usr1/web/src/RCS/setacursor.c,v 1.7 94/09/12 14:27:31 leith Exp $*/
/*

C++*********************************************************************
C
C SETCURSOR.FOR  -- CREATED APRIL 92
C                   CONVERTED TO C -- SEPT 92 al
C                                                           
C **********************************************************************
C *  AUTHOR: A. LEITH                                                      *
C *  COPYRIGHT (C)1992, WADSWORTH CENTER FOR LABORATORIES AND              *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH	        		   *
C **********************************************************************
C
C    SETCURSOR(
C
C    PARAMETERS:   ICURSOR            SPIDER CURSOR NUMBER  (READ)
C                  ICOLORF            SPIDER COLOR NUMBER   (READ)
C                  ICOLORB            SPIDER COLOR NUMBER   (READ)
C
C    PURPOSE:      SETS UP A CURSOR FOR WEB USE
C
C    CALLED BY:    web_main   curmen_but 
C
C--*********************************************************************
*/

#include "common.h"

#define MAXCURSOR 75

 /* external function prototypes */
 extern Cursor newcursor (int, int);

 /* internal static variables */
 static int first = TRUE;


 /********************  setacursor  *****************************/

 void setacursor(int icursort, int forecolor, int backcolor)

 {

 if (icursort < 0)
    {   /* icursort is X-window cursor pointer not spider cursor number */
     
    icursor  = 0;
    icursorx = -icursort;
    XDefineCursor(idispl,iwin,icursorx);
    }

   
 else if (first || (icursor != icursort && icursort <= MAXCURSOR))
    {    
    /* want a new spider cursor by number */
    first   = FALSE;
    icursor = icursort;

    /* use default cursor if icursort is zero */
    if (icursor == 0) icursor = 34;
     
    icursorx = XCreateFontCursor(idispl,icursor*2);  
    XDefineCursor(idispl,iwin,icursorx);
    }

 else if  (icursor != icursort && icursort >= MAXCURSOR+1 &&
           icursor <= MAXCURSOR +4)
    {  
    /* special code for Rademachers cross-hair cursor and other */ 
    /* locally defined cursors */
 
    first    = FALSE;

    /* define the cursor shape (if necessary) */
    icursorx = newcursor(icursort, MAXCURSOR);
    icursor  = icursort;

    XDefineCursor(idispl,iwin,icursorx);
    }

 if (forecolor >= 0)
    {
    /* query  color definition for this color number */
    colorcursf.pixel = ispicol[forecolor];
    colorcursf.flags = DoRed|DoGreen|DoBlue; 
    XQueryColor(idispl,map,&colorcursf);
    }

 if (backcolor >= 0)
    {
    /* query  color definition for this color number */
    colorcursb.pixel = ispicol[backcolor];
    colorcursb.flags = DoRed|DoGreen|DoBlue; 
    XQueryColor(idispl,map,&colorcursb);
    }

 XFlush(idispl);
 /* set cursor colors */
 XRecolorCursor(idispl,icursorx,&colorcursf,&colorcursb);
 XFlush(idispl);

 return;
 }


/*******************************************************************
C      #(1)  /'cw                  '/#(2)  /'cursor_shape        '/
C      #(3)  /'num_glyphs          '/#(4)  /'X                   '/
C      #(5)  /'arrow               '/#(6)  /'based_arrow_down    '/
C      #(7)  /'based_arrow_up      '/#(8)  /'boat                '/
C      #(9)  /'bogosity            '/#(10) /'bottom_left_corner  '/
C      #(11) /'bottom_right_corner '/#(12) /'bottom_side         '/
C      #(13) /'bottom_tee          '/#(14) /'box_sprial          '/
C      #(15) /'center_ptr          '/#(16) /'circle              '/
C      #(17) /'clock               '/#(18) /'coffee_mug          '/
C      #(19) /'cross               '/#(20) /'cross_reverse       '/
C      #(21) /'cross_hair          '/#(22) /'diamond_cross       '/
C      #(23) /'dot                 '/#(24) /'dot_box             '/
C      #(25) /'double_arrow        '/#(26) /'draft_large         '/
C      #(27) /'draft_small         '/#(28) /'draped_box          '/
C      #(29) /'exchange            '/#(30) /'fleur               '/
C      #(31) /'gobbler             '/#(32) /'gumby               '/
C      #(33) /'hand                '/#(34) /'hand1               '/
C      #(35) /'heart               '/#(36) /'icon                '/
C      #(37) /'iron_cross          '/#(38) /'left_ptr            '/
C      #(39) /'left_side           '/#(40) /'left_tee            '/
C      #(41) /'left_button         '/#(42) /'ll_angle            '/
C      #(43) /'lr_angle            '/#(44) /'man                 '/
C      #(45) /'middle_button       '/#(46) /'mouse               '/
C      #(47) /'pencil              '/#(48) /'pirate              '/
C      #(49) /'plus                '/#(50) /'question_arrow      '/
C      #(51) /'right_ptr           '/#(52) /'right_side          '/
C      #(53) /'right_tee           '/#(54) /'right_button        '/
C      #(55) /'rtl_logo            '/#(56) /'sailboat            '/
C      #(57) /'sb_down_arrow       '/#(58) /'sb_h_double_arrow   '/
C      #(59) /'sb_left_arrow       '/#(60) /'sb_right_arrow      '/
C      #(61) /'sb_up_arrow         '/#(62) /'sb_v_double_arrow   '/
C      #(63) /'shuttle             '/#(64) /'sizing              '/
C      #(65) /'spider              '/#(66) /'spraycan            '/
C      #(67) /'star                '/#(68) /'target              '/
C      #(69) /'t_cross             '/#(70) /'top_left_arrow      '/
C      #(71) /'top_left_corner     '/#(72) /'top_right_corner    '/
C      #(73) /'top_side            '/#(74) /'top_tee             '/
C      #(75) /'trek                '/#(76) /'ul_angle            '/
C      #(77) /'umbrella            '/#(78) /'ur_angle            '/
C      #(79) /'watch               '/#(80) /'xterm               '/
C      #(81) /'select              '/#(82) /'leftselect          '/
C      #(83) /'help_select         '/#(84) /'wait                '/
C      #(85) /'inactive            '/#(86) /'resize              '/
C      #(87) /'vpane               '/#(88) /'hpane               '/
C      #(89) /'text_insertion      '/#(90) /'text_insertion_bl   '/
C      #(91) /'cross_hair          '/#(92) /'draw                '/
C      #(93) /'pencil              '/#(94) /'rpencil             '/
C      #(95) /'center              '/#(96) /'rightselect         '/
C      #(97) /'wselect             '/#(98) /'eselect             '/
C      #(99) /'x                   '/#(100) /'circle             '/
C      #(101) /'mouse_c            '/#(102) /'lpencil            '/
C      #(103) /'leftgrab           '/#(104) /'grabhand           '/
C      #(105) /'rightgrab          '/#(106) /'leftpointing       '/
C      #(107) /'uppointing         '/#(108) /'rightpointing      '/
C      #(109) /'check               '/
*******************************************************************/

