
/*
C++************************************************************************
C
C setline
C
C **************************************************************************
C *  AUTHOR:  Lekan Odesanya                                                *
C *  COPYRIGHT (C)1993, WADSWORTH CENTER FOR LABORATORIES AND              *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH                            *
C **************************************************************************
C
C    setline
C
C    PURPOSE:         set the line style and width
C
C
C***********************************************************************
*/

#include "common.h"

 /************************   setline   ******************************/

 void setline( Widget widget, caddr_t data, caddr_t call_data )
 {

 int           request;
 XGCValues     gcv;


   request = atoi(data);

   if( request > 2 ) /*  want to change line width  */
    {
      gcv.line_width = request - 3;
      XChangeGC( idispl, icontx, GCLineWidth, &gcv );
    }
   else             /*  want to change line style  */
    {
      switch( request )
       {
         case 0:   gcv.line_style = LineSolid;        break;
         case 1:   gcv.line_style = LineOnOffDash;    break;
         case 2:   gcv.line_style = LineDoubleDash;   break;
       }

      XChangeGC( idispl, icontx, GCLineStyle, &gcv );
    }

}
