/*$Header: /net/ithaca/usr1/web/src/RCS/setmag.c,v 1.5 1995/02/02 19:49:19 liy Exp $*/
/*
C++*************************************************************************
C
C MAGNIFY -- CREATED July 92
C setmag.c           Nov  92                                                                    
C **************************************************************************
C *  AUTHOR: YANHONG LI                                                      *
C *  COPYRIGHT (C)1992, WADSWORTH CENTER FOR LABORATORIES AND              *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH	        		   *
C **************************************************************************
C
C    SET MAGNIFICATION PARAMETERS
C
C    PARAMETERS:   iw_temp, data, call_data (usual callback data)
C
C    PURPOSE:      SET MAGNIFICATION PARAMETERS
C
C    CALLED BY:    web_main
C
C--********************************************************************
*/


#include "x.h"
#include "std.h"
#include <Xm/RowColumn.h>
#include <Xm/Scale.h>

#define  MAX_ARGS 12

 /* common variables */
#include "common.h"

 /* external function  prototypes */
 extern Widget wid_labelg   (Widget, Widget, char *, int, int);
 extern Widget wid_dialog   (Widget,...);
 extern Widget wid_stdbut   (Widget,...);

 extern void   fin_cb	    (Widget, caddr_t, caddr_t);
 
 /* internal function  prototypes */
 Widget scalev	(Widget iw_parent,Widget iw_its,int imin,int imax,
		int inow,int iwid,int ihi,int ixdum,int iydum);
 void   pushbuta(Widget iw_temp, caddr_t data, caddr_t callback);

 /* internal file variables */
 static  Widget		iw_magx, iw_magy, iw_magf, iw_setmag = 0;

/***********************  setmag  **************************/

 void setmag(Widget iw_temp, caddr_t data, caddr_t call_data)
{
    Widget		iw_but, ipushc, ipusha, rowcolh;
    Arg          	args[3];    /* arg list  */
    
 if (iw_setmag <= (Widget)0)
   {
    iw_setmag = wid_dialog( iw_main, 0, "setmag", 0, 0 );
 
    /* create the labels of magsize and magfac	*/
    wid_labelg(iw_setmag, 0, "size",60, 30);
    wid_labelg(iw_setmag, 0, "x",40, 60);
    wid_labelg(iw_setmag, 0, "y",120, 60);
    wid_labelg(iw_setmag, 0, "factor ", 180, 30);

    /* create the magsize scale	*/
    iw_magx  = scalev(iw_setmag,0, 2,512,magsizx,50,200, 10,80);
    iw_magy  = scalev(iw_setmag,0, 2,512,magsizy,50, 200,90,80);
    iw_magf  = scalev(iw_setmag,0, 2,32,magfac,55, 210,180, 70);

    /* create standard buttons for set mag varibles */
    /* set the position for standard buttons	*/
    XtSetArg(args[0], XmNx, 10);                    
    XtSetArg(args[1], XmNy, 300);
    XtSetArg(args[2], XmNdefaultPosition, False );                
    rowcolh = XmCreateRowColumn(iw_setmag, "sss", args, 3);
    XtManageChild( rowcolh );

    /* create the buttons	*/
    iw_but = wid_stdbut(rowcolh,iw_setmag, &ipushc,&ipushc,
		      &ipusha,"CA",fin_cb,fin_cb,pushbuta,NULL);
   }

    XtManageChild(iw_setmag);
 
 }
/*****************  scalev  ***************************/

 Widget scalev(Widget iw_parent,Widget iw_its,int imin,int imax,
		int inow,int iwid,int ihi,int ixdum,int iydum)
{   
    Arg          args[MAX_ARGS];    /* arg list  */
    Widget       iw_lab;
    Widget       iw_rowcolh;

    if (iw_its == (Widget)0) 
    { 
    	/* create scale widget */
    	XtSetArg(args[0], XmNwidth, iwid);                    
    	XtSetArg(args[1], XmNheight, ihi);                
    	XtSetArg(args[2], XmNscaleWidth, iwid-30);            
    	XtSetArg(args[3], XmNscaleHeight, ihi);        
    	XtSetArg(args[4], XmNminimum, imin);                
    	XtSetArg(args[5], XmNmaximum, imax);             
    	XtSetArg(args[6], XmNdecimalPoints, 0);            
    	XtSetArg(args[7], XmNvalue, inow);                  
    	XtSetArg(args[8], XmNorientation, XmVERTICAL);       
    	XtSetArg(args[9], XmNshowValue, TRUE);           
     	XtSetArg(args[10], XmNx, ixdum);                    
    	XtSetArg(args[11], XmNy, iydum);                

    	iw_its = XmCreateScale(iw_parent, "iw_scale", args, 12);
    }

    else 
    { /* alter scale size in existing widget */

    	XtSetArg(args[0], XmNminimum, imin);       
    	XtSetArg(args[1], XmNmaximum, imax);       
    	XtSetArg(args[2], XmNvalue,   inow);
       
    	XtSetValues(iw_its, args, 3);
    }

    XtManageChild(iw_its);
    return iw_its;

 }
/*****************  pushbuta  ***************************/

 void   pushbuta(Widget iw_temp, caddr_t data, caddr_t callback)
{
/* accept the values of magsizx, magsizy and magfac	*/
    XmScaleGetValue(iw_magx,&magsizx);
    XmScaleGetValue(iw_magy,&magsizy);
    XmScaleGetValue(iw_magf,&magfac);

    XtUnmanageChild(iw_setmag);
}



