
/*$Header: /net/ithaca/usr1/web/src/RCS/setmen.c,v 1.1 1996/07/31 20:28:22 leith Exp $*/

/*
C++*********************************************************************
C
C setmen
C
C **********************************************************************
C *  AUTHOR:  ArDean Leith                                                 *
C *  COPYRIGHT (C)1993, WADSWORTH CENTER FOR LABORATORIES AND              *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH                            *
C **********************************************************************
C
C    setmen
C
C    PURPOSE:         display setmen menu
C
C    CALLED BY:        
C
C    CALL TREE:


                   
   imagemen        
      |            
      v            
  imagemen_cb      
      |            
      v           
   imagemen1      
      |            
      v            
   filtermen -->  setmen --> set -->
                 


C***********************************************************************
*/

#include <Xm/RowColumn.h>
#include <Xm/Text.h>
#include <Xm/Scale.h>
#include "common.h"
#include "routines.h"

#include "std.h"
#ifndef VMS
#include "float.h"
#endif

 int           filset  (float *, int, int, float, float,
                     float *, float *, float *);
 void          setmen       (Widget, XtPointer, XtPointer);
 void          setmen_buta  (Widget, XtPointer, XtPointer);

 /* internal function prototypes */
 void          filter_but    (Widget, XtPointer, XtPointer);

 /* external global variables used here */
 extern float    fminold, fmaxold;
 static float    oldset,newset;

 /* common global used elsewhere */

 /* common variables used here */
 static Widget   iw_setmen,  iw_oldset, iw_newset;

 /******************************  filset *****************************/

 int filset(float * oldimage, int nsamt, int nrowt, 
            float oldsett, float newsett,
             float * newimage, float * fmint, float * fmaxt)
 {
 int     iloc;
 float   fval;

  * fmint = MYMAX(fmaxold,newsett);
  * fmaxt = MYMIN(fminold,newsett);

 /* convolve over all positions in the new image */

 for (iloc = 0; iloc < nsamt * nrowt; iloc++)
     {
     fval = oldimage[iloc];
     if (fval == oldsett)
        {
        newimage[iloc] = newsett;
        * fmint = MYMIN(*fmint,newsett);
        * fmaxt = MYMAX(*fmaxt,newsett);
        }
     else
        {
        newimage[iloc] = fval;
        * fmint = MYMIN(*fmint,fval);
        * fmaxt = MYMAX(*fmaxt,fval);
        }
     }

  return TRUE;
  }
/************************************  setmen **********************/

 void setmen(Widget iw_temp, XtPointer data, XtPointer call_data)
 { 
 char     cval[10];
 Widget   iw_rowcol;
 Widget   iw_pushc, iw_pusha, iw_dums;

 if (iw_setmen <= (Widget)0)
    {   /* create set menu widget first */

    iw_setmen = wid_dialog(iw_win,iw_setmen,"set options",20,20);
    iw_rowcol   = wid_rowcol(iw_setmen,'v',-1,-1);

    /* create text box for old value input ---------------------- old */
    sprintf(cval,"%7.2f",oldset);
    iw_oldset = wid_textboxb(iw_rowcol,0,"Old value:",cval,10);

    /* create text box for new value input ---------------------- new */
    sprintf(cval,"%7.2f",newset);
    iw_newset = wid_textboxb(iw_rowcol,0, "New value:",cval,10);

    /* create accept boxes  ---------------------------------- apply */
    iw_pushc = (Widget) 0;
    iw_pusha = (Widget) 0;
    wid_stdbut(iw_rowcol, iw_setmen, 
               &iw_dums, &iw_pushc, &iw_pusha, 
              "CA",fin_cb,fin_cb,setmen_buta, NULL);
    }

 XtManageChild(iw_setmen);
 }

 /********************* set accept button callback *******************/

 void setmen_buta(Widget iw_temp, XtPointer data, XtPointer call_data)
 {
 char   filtertype[2];
 char * string;

 string = XmTextGetString(iw_oldset);
 if (sscanf(string,"%f",&oldset) <= 0)  
    {
    spout("*** Illegal value for: Old value");
    XmStringFree((unsigned char *) string);
    return;
    } 

 XmStringFree((unsigned char *) string);

 string = XmTextGetString(iw_newset);
 if (sscanf(string,"%f",&newset) <= 0)  
    {
    spout("*** Illegal value for: New value");
    XmStringFree((unsigned char *) string);
    return;
    } 
/***********************/
 printf(" old & new: %f , %f \n",oldset,newset);
/*****************************/
 XmStringFree((unsigned char *) string);

 XtUnmanageChild(iw_setmen);

 filtertype[0] = 'A';
 filtertype[1] = '\0';
 filter_but(iw_temp, (XtPointer) filtertype, call_data);
 }


