
/*$Header: /net/ithaca/usr1/web/src/RCS/setprm.c,v 1.4 1996/04/01 21:41:43 mladjadj Exp $*/
/*
 C++************************************************************* 1/1/81 VAX
 C
 C SETPRM
 C
 C **************************************************************************
 C *  COPYRIGHT (C)1992, WADSWORTH CENTER FOR LABORATORIES AND              *
 C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
 C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
 C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
 C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
 C *    THE CENTER FOR LABORATORIES AND RESEARCH                            *
 C **************************************************************************
 C
 C    SETPRM:   SET LABEL PARAMETERS IDENTIFYING TYPE,
 C         NORMALIZATION STATUS OF FILE, AND TO WRITE LABEL INTO FILE.
 C
 C     SETPRM(FILEDATA *fileptr, char *type)
 C
 C      TYPE           CHAR. VARIABLE CONTAINING 1 OR TWO CHARACTERS 
 C			 SYMBOLIZING THE DATA TYPE:
 C			TYPE SYMBOL	DATA TYPE	IFORM
 C			  R		 2-D REAL	 +1
 C			  R3		 3-D REAL	 +3
 C			  P		 2-D POLAR	 +2
 C			  D		 NON-IMAGE DATA   0
 C			  F		 2-D FOURIER	 -1
 C			  F3		 3-D FOURIER  	 -3
 C			  U		 UNCHANGED	 UNCHANGED	
 C
 C
 C   THE FIRST RECORD OF THE FILE CONTAINS THE FOLLOWING INFO: 
 C          ELEMENT # 5  FLAG INDICATING DATA TYPE (=IFORM)
 C                    6  IMAMI = FLAG INDICATING IF THE IMAGE HAS 
 C				BEEN SEARCHED FOR MAX AND MIN. 
 C				IF FMAXD=FMIND IN SETPRM ARGUMENTS THEN
 C				IMAMI IS SET TO -1, OTHERWISE, TO +1.
 C                    7  FMAXD = IMAGE MAXIMUM
 C                    8  FMIND = IMAGE MINIMUM
 C                    9  AVD   = IMAGE AVERAGE
 C                   10  SIG  = STANDARD DEVIATION (SQ. ROOT OF VARIANCE)
 C                   11  IHIST= FLAG INDICATING IF THE HISTOGRAM HAS
 C                                   BEEN COMPUTED,AND STORED IN RECORDS
 C                                   1+NROW+1 ETC.
 C
 C--*******************************************************************
*/

#include "files.h"

 /* external subroutines */
 extern int    redlin (FILEDATA *, float *, int, int);
 extern int    wrtlin (FILEDATA *, float *, int, int);
 extern void   spout  (char *);

 /********************** setprm  **********************************/

 int setprm(FILEDATA *fileptr, char *type)

 {
 float     *buf, * ptrf;
 int k1,offset,tsam;

 /* allocate space for buffer */
 /* can not use filedata buffer as size may be too small! */
 /* VAX does not like to write n items smaller than nsam in wrtlin.c */
 /* see opennew.c explanations */
#ifdef VMS
 buf = (float *) malloc((fileptr -> nsam) * (fileptr -> reclen) * sizeof(float));
#else
 buf = (float *) malloc(256 * sizeof(float));
#endif
 
 if (buf == 0)
    {     /* allocation was not successful */
    spout(" *** Unable to allocate memory in SETPRM.");
    return FALSE;
    }
   
 if (redlin(fileptr,buf,256,0) != TRUE)
    {
    spout(" *** Unable to redlin in SETPRM.");
    if (buf) free(buf);
    return FALSE;
    }

 /*  SET FLAG INDICATING WHETHER FMAXD,FMIND HAS BEEN COMPUTED OR NOT */
 buf[5] = 1.0;
 if (fileptr -> fmin == fileptr -> fmax) buf[5] = 0.0;

 buf[6]  = fileptr -> fmax;
 buf[7]  = fileptr -> fmin;
 buf[8]  = fileptr -> av;
 buf[9]  = fileptr -> sig;
 buf[10] = fileptr -> ihist;


 if (strcmp(type,"u") != 0)
    {
    buf[4] = 1.0;
    if ( strcmp(type + 1,"3"))
       buf[4] = 3.0;
    if ( strcmp(type,"F"))
       {
       buf[4] = -1.0;
       if ( strcmp(type + 1,"3"))
          buf[4] = -3.0;
       }
    if ( strcmp(type,"P"))
          buf[4] = 2.0;
    if ( strcmp(type,"D"))
          buf[4] = 0.0;
    } 

#ifdef VMS
/* VAX VAX VAX VAX VAX VAX VAX VAX VAX VAX VAX VAX VAX VAX VAX VAX VAX VAX VAX VAX */

  offset = fileptr -> offset; /* should write record 0 for offset .NE. 0 */
  fileptr -> offset = 0;      /* otherwise, put it back after this */
  ptrf = buf;
  for (k1=1; k1 <=  fileptr ->headrec ; k1++)
       {
       if (wrtlin(fileptr,ptrf,fileptr -> nsam,k1) != TRUE)
          {
          spout(" *** Unable to wrtlin in SETPRM.");
          if (buf) free(buf);
	  fileptr -> offset = offset;
          return FALSE;
          }
       ptrf +=  fileptr -> nsam;  
       }

  fileptr -> offset = offset;  /* otherwise, put it back after this */
  
/* VAX VAX VAX VAX VAX VAX VAX VAX VAX VAX VAX VAX VAX VAX VAX VAX VAX VAX VAX VAX */

#else
 if (wrtlin(fileptr,buf,256,0) != TRUE)
    {
    spout(" *** Unable to wrtlin in SETPRM.");
    if (buf) free(buf);
    return FALSE;
    }
#endif
 if (buf) free(buf);
 return TRUE;
 } 

