/*$Header: /alwyn/usr1/web//RCS/setxor.c,v 1.2 93/11/10 10:45:33 leith Exp $*/
/*
C***************************************************************************
C
C SETXOR  -- CREATED NOV 89
C           -- converted to C Aug 92 al                                                     
C **************************************************************************
C *  AUTHOR: ArDean Leith                                                  *
C *  COPYRIGHT (C)1989 , WADWSWORTH CENTER FOR LABORATORIES AND RESEARCH,  *
C *    NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.              *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH  			   *
C **************************************************************************
C
C SETXOR(ICONTX1)
C
C PURPOSE:      CREATES NEW GRAPHICS CONTEXT SET TO EXCLUSIVE OR
C
C PARAMETERS:   icontx1    SOURCE  CONTEXT
C               
C RETURNS:      icontx2    new x-or context
C
C CALLED BY:    winsiz 
C
C--*********************************************************************
*/

#include "x.h"
#include "std.h"
#include "common.h"


 /************************************************************/

 GC setxor(GC icontx1)
 {

 GC             icontx2;
 XGCValues      gcval;
 unsigned long  gcmask;

 /* create new graphics context */
 icontx2 = XCreateGC(idispl, iwin, 0, &gcval);

 /* COPY SOME CHARACTARISTICS OF THE OLD GC TO THE XOR GC */
 gcmask = GCForeground | GCBackground | GCLineWidth | GCFont;

 XCopyGC(idispl, icontx1, gcmask, icontx2);

 XSetFunction(idispl,icontx2,GXxor);

 XFlush(idispl);

 return icontx2;
 }
