/*$Header: /net/ithaca/usr1/web/src/RCS/shift.c,v 1.13 1997/04/15 20:28:49 leith Exp $*/

/***********************************************************************
 *
 * shift.c
 *
 ***********************************************************************
 * COPYRIGHT (C)1992, WADSWORTH CENTER FOR LABORATORIES AND
 * RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.  
 * THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     
 * LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  
 * USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF 
 * THE CENTER FOR LABORATORIES AND RESEARCH 			  
 ***********************************************************************
 *
 * PURPOSE:     Shift a large image on the screen      
 * 
 * PARAMETERS:	 
 *
 ***********************************************************************
*/

#include "common.h"
#include "routines.h"

 /* internal functions */
 void           shift_pop (Widget, XEvent *, String *, Cardinal *);

 /* external functions */
 void          gold_pop     (Widget, XEvent *, String *, Cardinal *);
 void          pixel_pop    (Widget, XEvent *, String *, Cardinal *);

 /* externally defined file variables */
 extern int 	 nmark;
 extern int	 *pixellist;		/* variables for  pixel */
 extern int	 pixelnum;			/* picking list */

 extern char        outstr[80];

 /* internal file common  variables */
 static  int     down = FALSE;         /* button one position      */
 static  int     leftside;             /* currently want left side */
 static  int     picking;              /* called by particle pgm.  */
 static  int     ix0t, iy0t;           /* last mouse location      */
 static  int     icolort;
 static  int     lxd, lyd, rxd, ryd;

 /***********************  shift  ***********************************/

 void shift(int picktemp)

 {
 /* open a message window with the following strings  */
 showbutx("Hold to move. Release to set image location.", 
          "Stop moving", 
          "Stop moving ", FALSE);

 /* set the actions for right, left, and center buttons */
 actions(iw_win, "shift_pop", shift_pop,"M123L");

 /* initialize button one position */
 down    = FALSE;

 /* set flag that identifies calling program */
 picking = picktemp;
 }

 /************************* shift_pop **************************/

 void shift_pop(Widget iw_t, XEvent *event, String *params,
               Cardinal *num_params)
 {
 int        ixd,iyd,ixs,iys,nsamlt,nrowlt,nsamrt,nrowrt;
 int	    loop;		/* the viables for pixel picking */

 if ((!(strcmp(*params, "M")) && down))
    {                         /*  mouse moved with button #1 down */
    getloc(event,'m',&ixs,&iys);

    /* find change in mouse postion */
    ixd = ixs - ix0t;  iyd = iys - iy0t;

    if (ixd != 0 || iyd != 0)
       {    /* move image */

       if (leftside) 
          {
          ixulli += ixd;    iyulli += iyd;

          /* find displayed row and col limits */
          nsam1l = MYMAX(1,ixullmin-ixulli);
          nsam2l = MYMIN(nsaml,ixlrlmax-ixulli+1);

          nrow1l = MYMAX(1,iyullmin-iyulli);
          nrow2l = MYMIN(nrowl,iylrlmax-iyulli+1);

          /* find shifted target location */
          lxd = MYMAX(ixullmin,ixulli);  lyd = MYMAX(iyullmin,iyulli);

          ixull = lxd; iyull = lyd;

          /* find diplayed size */
          nsamlt = nsam2l - nsam1l+1; 
          nrowlt = nrow2l - nrow1l+1;

          /* clears left side rectangle in imagsav */
          /* display,drawable,gc,   x,     y,  
                                   width, height */

          XFillRectangle(idispl, imagsav, icontx, 
                     ixullmin,            iyullmin,
                     ixlrlmax - ixullmin, iylrlmax - iyullmin);

          /* transfers image from imagel to imagsav location */
          /*  display,drawable,gc,image,  srcx,  srcy, 
                                          destx, desty, 
                                          width, height */
          XPutImage(idispl,imagsav,icontx,imagel, 
                    nsam1l, nrow1l,
                    lxd,  lyd, 
                    nsamlt, nrowlt);

          /* copies from imagsav to window */
          /* display,src,dest,gc,   srcx,  srcy, 
                                    width, height,  
                                    destx, desty */
          XCopyArea( idispl, imagsav, iwin, icontx, 
                     ixullmin,            iyullmin, 
                     ixlrlmax - ixullmin, iylrlmax - iyullmin,
                     ixullmin,            iyullmin);

/******************
       printf("li:(%d,%d) s:(%d,%d) d:(%d,%d) 0t:(%d,%d) iul:(%d,%d)\n",
         ixulli,iyulli, ixs,iys,  ixd,iyd,  ix0t,iy0t, nsam1l,nrow1l);
******************/
 
          ix0t = ixs;  iy0t = iys;

          }
       else if (picking)
          {    /* right side picking */
          ixulri += ixd;  iyulri += iyd;

          nsam1r = MYMAX(1,ixulrmin-ixulri);
          nsam2r = MYMIN(nsamr,ixlrrmax-ixulri+1);

          nrow1r = MYMAX(1,iyulrmin-iyulri);
          nrow2r = MYMIN(nrowr,iylrrmax-iyulri+1);

          nsamrt = nsam2r - nsam1r + 1; 
          nrowrt = nrow2r - nrow1r + 1;

          /* find shifted target location */
          rxd = MYMAX(ixulrmin,ixulri);  ryd = MYMAX(iyulrmin,iyulri);

          ixulr = rxd;   iyulr = ryd;


          XFillRectangle(idispl, imagsav, icontx, 
                     ixulrmin,            iyulrmin,
                     ixlrrmax - ixulrmin, iylrrmax - iyulrmin);

          XPutImage(idispl,imagsav,icontx,imager, 
                    nsam1r,  nrow1r,
                    rxd,     ryd, 
                    nsamrt,  nrowrt);

          XCopyArea(idispl, imagsav, iwin, icontx, 
                     ixulrmin,            iyulrmin, 
                     ixlrrmax - ixulrmin, iylrrmax - iyulrmin,
                     ixulrmin,            iyulrmin);
 
          ix0t = ixs;  iy0t = iys; 
          }
       }
    } 

 else if (!strcmp(*params, "1"))
    {                                /*  -- button 1 pushed down */
    getloc(event,'B',&ix0t,&iy0t);

    down    = TRUE;
    /* I do not know why I changed the color here al */
    icolort = icolor;
    wicolor(icontx, colorgo + 1);

    nsamlt = nsam2l - nsam1l + 1; 
    nrowlt = nrow2l - nrow1l + 1;

    nsamrt = nsam2r - nsam1r + 1; 
    nrowrt = nrow2r - nrow1r + 1;

    if ((ix0t >= ixull && ix0t < ixull + nsamlt  && 
         iy0t >= iyull && iy0t < iyull + nrowlt))
       {    /* cursor is inside  left image */
       leftside = TRUE;
       }

    else if (picking &&
       (ix0t >= ixulr && ix0t < ixulr + nsamrt  && 
        iy0t >= iyulr && iy0t < iyulr + nrowrt))
       {    /* cursor is inside  right image */
       leftside = FALSE;
       }

    else 
       {   
       down = FALSE;
       }          
    }

 else if (!strcmp(*params, "L"))
    {                                /*  -- button 1 released */
    down = FALSE;   
    }

 else if (!(strcmp(*params, "2")) || (!(strcmp(*params, "3"))))
    {                               /*  --  button 2 or 3 pushed */
    /*  remove message */
    showbutx("","","",TRUE);

    /* remove all translations from iw_win */
    XtUninstallTranslations(iw_win);

    /* reset color now */
    wicolor(icontx,icolort); 

    /* call pickp because buttons need to be reassigned */
    if (picking== 1) pickp(FALSE);

    /* if only shift image, return to imagemen */
    else if (picking == IMAGE ) {
	ixul = ixulli;
	iyul = iyulli;
	}

    /* if setting markers, turn to marker menu */
    else if (picking == MARKER) {
	ixul = ixulli;
	iyul = iyulli;

 	showbutx("set marker location.",
                 "menu.",
                 "save locations in doc file.",FALSE);

 	actions(iw_win, "gold_pop", gold_pop, "123");
	}
	
    else if (picking == PIXEL) {
	ixul = ixulli;
	iyul = iyulli;

	/* redraw the markers */
     	for(loop=0; loop<pixelnum; loop=loop+2) {
	    ixs = pixellist[loop]+ixul;
	    iys = pixellist[loop+1]+iyul;
	    
	    /* leave the markers */
            xorc(iwin,    icontx, TRUE, ixs, iys, iradius);
            xorc(imagsav, icontx, TRUE, ixs, iys, iradius);
	    }

	if (pixelnum == 0)
            pixelmen(NULL, NULL, NULL);
	else 
            {
	    showbutx("Query location.",
          	     "menu.",
          	     "Stop this routine.",FALSE);

 	    actions(iw_win, "pixel_pop", pixel_pop, "M123");
	    }
	}
	
    else { }

    if (leftside)
       {
       sprintf(outstr,
               "Origin: (%d,%d) UL: (%d,%d) Size:(%d,%d)\n",
               ixulli,iyulli, lxd,lyd,  nsaml,nrowl);
       }
    else
       {
       sprintf(outstr,
               "Origin: (%d,%d) UL: (%d,%d) Size:(%d,%d)\n",
               ixulri,iyulri, rxd,ryd,  nsamr,nrowr);
       }
    spout(outstr);

    }

 }
