
/*$Header: /net/ithaca/usr1/web/src/RCS/showbimage.c,v 1.6 1996/01/22 20:44:26 leith Exp $*/

/***********************************************************************
 *
 * showbimage.c
 *
 ***********************************************************************
 * COPYRIGHT (C)1992, WADSWORTH CENTER FOR LABORATORIES AND
 * RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      
 * THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     
 * LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  
 * USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF 
 * THE CENTER FOR LABORATORIES AND RESEARCH 			  
 ***********************************************************************
 *
 * showbimage
 * 
 * PURPOSE:    displays an image from floating point buffer
 *
 * RETURNS:    true if successfull
 * 
 * PARAMETERS:     
 *
 ***********************************************************************
*/

#include "common.h"
#include "routines.h"

 /* common variables  */
 
/****************************  showbimage  ****************************/

int showbimage(float * fbuf, int keepcimage, char** cimage,
                             int keepimage,  XImage** imaget, 
                             int nsamt, int nrowt,
                             float fmint, float fmaxt)
{   
 int        nsams, nrows, nrowlab, iytot=0;
 int        idum;

 /* find nsams, nrows in displayed image */
 dispsize(1,nsamt,1,nrowt,idum,idum,iskip,
         &nsams, &nrows, &idum);

 /* scale existing 32 bit buffer into 8 bit buffer */ 
 if (!scaleimg(fbuf, nsamt,1,nsamt,  nrowt,1,nrowt, fmint,fmaxt, 
          iskip, imagego,127, cimage))
       return FALSE;

 if (placed) 
    {  /* use location from ixuln, iyuln */
    ixul = ixuln;
    iyul = iyuln;
    }

 if (names) 
    /* find y-offset needed for file name label */
    {
    /*  future wid_imglabeloc(filnow,iyline,iytot); !!!!!!!!!!!!*/
    nrowlab = nrows + iytot;
    }

 if (!movie)
    {   /* find location for next image */
    locc(&ixul, &iyul, nsams, nrows, 
               &ntop, &nbot,  &nrit, marx, mary, marlef, martop,
               iwidex, ihighx, placed , newline, &nuscrn, force);
    }


 /* display image at ixul, iyul; deallocate imaget if !keepimage) */
 wipic(icontx,*cimage,ixul,iyul,nsams,nrows,TRUE,keepimage,imaget);

 if ((!keepcimage) && *cimage)
    {
    free(*cimage);
    *cimage = NULL;
    } 
       
 /* record magnification value for this image */
 lastskip = iskip;

 if (names)
    {     /* print image file name below image */
    /* future wid_imglabel(filnow,ixul,iyul+nrows+iyline) !!!!! */
    }

 placed = FALSE;
 
 return TRUE;
 }

 
