/*$Header: /net/ithaca/usr1/web/src/RCS/showbutx.c,v 1.11 1996/05/07 14:55:24 leith Exp $*/

/*
 ***********************************************************************
 *
 * showbutx.c
 *
 ***********************************************************************
 * COPYRIGHT (C)1992, WADSWORTH CENTER FOR LABORATORIES AND
 * RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.  
 * THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     
 * LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  
 * USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF 
 * THE CENTER FOR LABORATORIES AND RESEARCH 			  
 ***********************************************************************
 * 
 * PURPOSE:	Opens a message box displaying the mapping of the mouse
 *              buttons
 *
 * RETURNS:     void
 * 
 * PARAMETERS:	char	*but1	       text description of button 1
 *		char	*but2	       text description of button 2
 *		char	*but3	       text description of button 3
 *		int	unmanage       unmanage the window if TRUE
 *
 ***********************************************************************
*/

#include "x.h"
#include <Xm/LabelG.h>
#include <Xm/BulletinB.h>
#include "std.h"
#include "routines.h"
#ifdef VMS
#include <string.h>
#else
#include <strings.h>
#endif

#define MAX_MESSAGE_LENGTH 240

/* external global variables */
extern Widget       iw_win;    /* image window widget  */
extern Display      *idispl;

/* internal file variables */
static Widget       iw_mess   = (Widget) 0 ;  /* dialog widget   */
static Widget       iw_labelg = (Widget) 0 ;  /* label widget    */

/********************** showbutx ***************************/

void showbutx(char *but1, char *but2, char *but3, int unmanage)
 {   
 char            message[MAX_MESSAGE_LENGTH];   
 Arg             args[2];     /* arg list */
 unsigned long   ilen;
 XmString        str_label;  /* String label */
   
 if (unmanage && iw_mess)
    {
    XtUnmanageChild(iw_mess);
    }

 else 
    {
    /* error trap kludge for alpha bug on particle picking  buggy */
    if (but1 != NULL) ilen = strlen(but1);
    if (but2 != NULL) ilen += strlen(but2);
    if (but3 != NULL) ilen += strlen(but3);

    if ((ilen + 57) >=  MAX_MESSAGE_LENGTH)
       {
       message[MAX_MESSAGE_LENGTH - 1] = '\0';
       printf("*** Showbutx got an overlength string: %d \n",ilen);
       printf("*** String:%s \n",message); XBell(idispl,50);
       XBell(idispl,50);
       }

    /* set the message string */
    strcpy(message, "BUTTON   left:    ");
    strcat(message, but1);
    strcat(message, "\n");

    if (but2 != NULL) 
       {
       strcat(message, "         center:  ");
       strcat(message, but2);
       strcat(message, "\n");
       }

    if (but3 != NULL)
       {
       strcat(message, "         right:   ");
       strcat(message, but3);
       }

    if (iw_mess == (Widget) 0) 
       {  /* must create widget the first time it is used */
       XtSetArg(args[0], XmNdefaultPosition, False);    
       iw_mess   = XmCreateBulletinBoardDialog(iw_win,"iw_mess",args,1);

       XtSetArg(args[0], XmNalignment, XmALIGNMENT_BEGINNING); 
       iw_labelg = XmCreateLabelGadget(iw_mess,"iw_labelg",args,1);
       XtManageChild(iw_labelg);
       }

    /* note: XmStringCreateLtoR handles newline char oK) if this
    changed to XmStringCreate you will have to solve newline problem  */

    str_label = XmStringCreateLtoR(message,XmSTRING_DEFAULT_CHARSET);
    XtSetArg(args[0], XmNlabelString, str_label); 
    XtSetValues(iw_labelg,args,1);

    /* free the String (not doing this may result in a memory leak) */
    XmStringFree(str_label);

    XtManageChild(iw_mess);
    }

 XFlush(idispl);

 }

