
/*$Header: /net/ithaca/usr1/web/src/RCS/showimage.c,v 1.10 1996/07/26 15:21:16 mladjadj Exp $*/

/***********************************************************************
 *
 * showimage.c
 *
 ***********************************************************************
 * COPYRIGHT (C)1992, WADSWORTH CENTER FOR LABORATORIES AND
 * RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      
 * THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     
 * LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  
 * USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF 
 * THE CENTER FOR LABORATORIES AND RESEARCH 			  
 ***********************************************************************
 *
 * showimage(
 * 
 * PURPOSE:    displays an image from a file
 *
 * RETURNS:    true if successfull
 * 
 * PARAMETERS:  
 *
 *
 ***********************************************************************
*/

#include "common.h"
#include "routines.h"

/***********************  showimage **********************************/

int showimage(FILEDATA *filedatat, int keepcimage, char** cimage,
                               int keepimage,  XImage** imaget, 
                               int keep32,     float**  fimage,
                               int showimaget, float fmint, float fmaxt,
                               int nmint,      int nmaxt)
{   
 int        nsams, nrows;
 float      fn, fncon;
 int        idum;
 char       *s, *fname;

 /* find nsams, nrows in displayed image */
 dispsize(nsam1,nsam2,nrow1,nrow2,idum,idum,iskip,
          &nsams, &nrows, &idum);

 if (placed) 
    {  /* use location from ixuln, iyuln */
    ixul = ixuln;
    iyul = iyuln;
    }

 if (!movie)
    {   /* find location for next image */
    if (names)
       locc(&ixul, &iyul, nsams, nrows+names_height, 
         &ntop, &nbot,  &nrit, marx, mary, marlef, martop,
         iwidex, ihighx, placed , newline, &nuscrn, force);
    else
       locc(&ixul, &iyul, nsams, nrows, 
         &ntop, &nbot,  &nrit, marx, mary, marlef, martop,
         iwidex, ihighx, placed , newline, &nuscrn, force);
    }

 /* load image from file into new 8 bit buffer and maybe float buffer */
 if (!redvol(filedatat, TRUE, cimage, keep32, fimage, nsam1, nsam2,
            nrow1, nrow2, islice, islice, nmint, nmaxt, fmint, fmaxt,
            &fn,  &fncon, iskip)) 
            return FALSE;

 /* display image at ixul, iyul; deallocate imaget if !keepimage) */
 wipic(icontx,*cimage,ixul,iyul,nsams,nrows,showimaget,
                     keepimage,imaget);

 if ((!keepcimage) && *cimage)
    {  /* free the char array for the image */
    free(*cimage);
    *cimage = NULL;
    } 

 /* record cbuf and ximage for possible later reference */
 filedatat -> ximage = *imaget;
       
 /* record magnification value for this image */
 lastskip = iskip;

 if (names)
    {     /* print image file name below image */

    /* strip pathname from filename  */
#ifdef VMS
    /* vms specific line follows */
     s = strrchr(filnow,']');
#else
     /* unix specific line follows */
     s = strrchr(filnow,'/');
#endif

    if (s) 
      {
      s++;
      fname = (char *) malloc(sizeof(char) * (strlen(s) + 1));
      strcpy(fname,s);
      fname = strtok(fname,".");

      /* The 7th parameter is set to -1 to use the current 
          foreground color */
      witext(icontx, fname, ixul, iyul+nrows+names_height,
                 1, 0, -1, 2, FALSE);
      free( fname );
      }
   }
 placed = FALSE;
 
 return TRUE;
 }

 
