
/*$Header: /net/ithaca/usr1/web/src/RCS/spoutfile.c,v 1.7 1996/05/10 14:59:53 leith Exp $*/

/*
 ***********************************************************************
 *
 * spoutfile.c
 *
 ***********************************************************************
 * COPYRIGHT (C)1992, WADSWORTH CENTER FOR LABORATORIES AND
 * RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      
 * THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     
 * LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  
 * USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF 
 * THE CENTER FOR LABORATORIES AND RESEARCH 			  
 ***********************************************************************
 *
 * spoutfile(useit)
 * 
 * PURPOSE:     uses a results file to trace web ouput
 *
 * PARAMETERS:   useit     T/F flag to write to  file
 *
 * RETURNS:      T/F  if successful 
 * 
 ***********************************************************************
 */

#include "std.h"
#include "routines.h"

 /* external common variables */
 extern char      datexc[4];         /* file extension  */
 extern int       trace_web;

 /* global variables used elsewhere */
 FILE   * resfp = NULL;

 /**************************** spoutfile*******************************/

 int spoutfile (int useit)
   {
   static char     resname[41];
   char            * datentime;
   time_t          now;

   if (!useit)
      {
      trace_web = FALSE;
      }
   else
      {
      if (!resfp)
         {    /* results file not available for restart */

         /* add datexc to web_results.  */
         strcpy(resname,"web_results.");
         strcat(resname,datexc);

         /* open for appending to end of file */
         resfp = fopen(resname,"a");

         if ( resfp == (FILE *) NULL)
            {
            spouts("*** Unable to open a results file: "); spout(resname); 
            trace_web = FALSE;
            return FALSE;
            }

         /* find current date and time */
         now       = time(NULL);
         datentime = ctime(&now);
         /* should this pointer be freed later ? */

         /* set time in file header */
         fprintf(resfp," ; %3.3s  %s  %s", datexc, datentime, resname);
         }
      trace_web = TRUE;
      }

  return TRUE;
  }


 
