
/*$Header: /net/ithaca/usr1/web/src/RCS/stackdis.c,v 1.2 1998/02/09 19:48:01 liy Exp $*/

/*
C++*********************************************************************
C
C stackdis.c -- CREATED Jan 1998 YL
C 
C *********************************************************************
C *				                                      *
C *  COPYRIGHT (C)1992,1996  HEALTH RESEARCH INC, EMPIRE STATE PLAZA, *
C *    ALBANY, NY 12201.  THE CONTENTS OF THIS DOCUMENT ARE           *
C *    PROPRIETARY TO HEALTH RESEARCH INC., AND ARE NOT TO BE         *
C *    DISCLOSED TO OTHERS OR USED FOR PURPOSES OTHER THAN INTENDED   *
C *    WITHOUT WRITTEN APPROVAL OF HEALTH RESEARCH INC.               *
C *********************************************************************
C
C    STACKDIS
C
C    PURPOSE:         DIPLAY A STACK FILE.
C
C    PARAMETERS:     
C
C    CALLED BY:       STACKMEN
C
C***********************************************************************
*/

#include "common.h"
#include "files.h"
#include "routines.h"
#include "std.h"

 /* external varibles */
 extern int stkgo, stkend;
 
/****************************  stackdis  ********************************/

 void stackdis(int nmint, int nmaxt)

 {   
 XImage *     imaget    = NULL;
 float  *     imagef    = NULL;
 float	      header[256];
 int       nsam,nrow,nslice,iform,headbyt,headrec;
 int	    i, j;
 int        nsams, nrows, idum;
 char	    outstr[100];
 char	    savename[81], *strtmp;
 int	    savestate;
  
 /* DO NOT FORCE FIRST IMAGE POSITION */
 force = FALSE;
 savestate = FALSE;
 
 /* check the starting # and ending # */
 if (stkgo < 1 || stkgo > stkend) {
     spout(" Can not interpret stack image number!\n");
     return;
 }
 
  /* set offset for reading header from file */
  headbyt = filedata->headbyt;
  nsam = filedata->nsam;
  nrow = filedata->nrow;
  nslice = filedata->nslice;
  filedata->offset = headbyt*stkgo + nsam*nrow*nslice*(stkgo-1)*4;
  
  /* set the full image size for image display */
  nsam2 = nsam;  nrow2 = nrow;  islice = 1;      
  dispsize( nsam1, nsam2, nrow1, nrow2, 1,1,iskip, &nsams, &nrows, &islice);

 /* display the images */
 for (i=stkgo-1; i<stkend; i++) {

    /* read header of image file */
    redlin(filedata,header,256,1);

    /* if the image is not exist, skip it */
    if (header[24] == 1) {

	nslice = header[0];
	if (nslice < 0) nslice = - nslice;
	filedata -> nslice  = nslice;
	
	filedata -> nrow    = header[1];
	
	filedata -> nlabel  = header[3];
	filedata -> iform   = header[4];
	filedata -> imami   = header[5];
	filedata -> fmax    = header[6];
	filedata -> fmin    = header[7];
	filedata -> av      = header[8];
	filedata -> sig     = header[9];
	filedata -> ihist   = header[10];
	
	filedata -> nsam    = header[11];
	filedata -> headrec = header[12];
	filedata -> iangle  = header[13];
	filedata -> phi     = header[14];
	filedata -> theta   = header[15];
	filedata -> gamma   = header[16];
	
	filedata -> headbyt = header[21];
	filedata -> reclen  = header[22];

	/* set error correction for bad headbyt and reclen spider files */
	iform = filedata -> iform;
	if (iform < 4 && 
	 (filedata -> reclen < (filedata -> nsam) * 4)) 
	 {
	 filedata -> reclen = (filedata -> nsam) * 4;
	 } 
	
	headrec = 1024 / (filedata -> reclen);
	if (filedata->reclen < 1024 &&
	 (1024 % (filedata -> reclen)) != 0) headrec++;
	headbyt = headrec * (filedata -> reclen);
	
	if (iform < 4 && ((filedata -> headbyt) < headbyt))
	 {
	 filedata -> headbyt = headbyt;
	 }
	
	if ((filedata->buf = (float *) malloc(filedata->nsam * sizeof(float))) == 
	(float *) 0) 
	{spout("*** Unable to malloc buf in stackdis."); return; }
	
	/* initialize ximage pointer*/
	filedata -> ximage = NULL; 
	
	/* set offset for reading image data from file in future */
	filedata -> offset += filedata -> headbyt;
    
        if (filedata->imami != 1)  norm(filedata);
	
	fmin = filedata->fmin;
	fmax = filedata->fmax;
	sprintf(outstr, "*** Image %d:  Range: %f,    %f", i+1, fmin, fmax);
	spout(outstr);
	
	if (nslice > 1) newline = TRUE;
	
	/* write the image # in stack if "write image name" has been set */
	/* put the filename in to temp buf */
	if (names) {
	   strcpy(savename, filnow);
#ifdef VMS
	    /* vms specific line follows */
	    strtmp = strrchr(filnow,']');
#else
	    /* unix specific line follows */
	    strtmp = strrchr(filnow,'/');
#endif

	    sprintf(strtmp+1, "@%3d.", i+1);
	    strtmp++;
	    while(*++strtmp == ' ') {
		*strtmp = '0';
	    }
	}
	    
	for (j=0; j<nslice; j++) {
	    if (imaget) {
		free(imaget);
		imaget = NULL;
	    }
	    if (imagef) {
		free(imagef);
		imagef = NULL;
	    }
	    
	    imagedis(filedata, FALSE, &imaget,FALSE, 
		  FALSE, &imagef, nmint,nmaxt);
	    
	    /* set the file pointer for next image */
	    filedata -> offset += nsam * nrow * 4;	    
	    newline = FALSE;
	    
	    /* 3D image only display the number once. */
	    if(names && nslice > 1) {
		savestate = names;
		names = FALSE;
	    }
	    if (savestate && j==nslice-1) {
		names = savestate;
		savestate = FALSE;
	    }
	}
	
	/* recover filnow */
	if (names) strcpy(filnow, savename);
    }
    else {
	/* add offset */
	filedata -> offset += headbyt;

	 dispsize(nsam1,nsam2,nrow1,nrow2,idum,idum,iskip,
		  &nsams, &nrows, &idum);
	if (names)
	   locc(&ixul, &iyul, nsams, nrows+names_height, 
	     &ntop, &nbot,  &nrit, marx, mary, marlef, martop,
	     iwidex, ihighx, placed , newline, &nuscrn, force);
	else
	   locc(&ixul, &iyul, nsams, nrows, 
	     &ntop, &nbot,  &nrit, marx, mary, marlef, martop,
	     iwidex, ihighx, placed , newline, &nuscrn, force);

	/* set the file pointer for next image */
	filedata -> offset += nsam * nrow * nslice *4;	    
    }
 }
 return;
}


 
