/*
C++************************************************************************
C
C STACKMEN -- CREATED Jan 1998 Yanhong Li
C
C **************************************************************************
C *  AUTHOR:  ArDean Leith                                                 *
C *  COPYRIGHT (C)1991, WADSWORTH CENTER FOR LABORATORIES AND              *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH			           *
C **************************************************************************
C
C STACKMEN
C
C PURPOSE:         DISPLAY THE MENU FOR STACK FILES
C
C VARIABLES:       
C                  
C                  
C
C CALLED BY:       
C
C**************************************************************************
*/

#include <Xm/Scale.h>
#include <Xm/Text.h>
#include <Xm/ToggleBG.h>

#include "common.h"
#include "routines.h"

/* internal function prototypes */
 void          stackmen_buta(Widget iw_temp, XtPointer, XtPointer);
 void          stackmen_butc(Widget iw_temp, XtPointer, XtPointer);
 void          stackmen_toga(Widget, XtPointer, XtPointer);
 void          stackmen_togb(Widget, XtPointer, XtPointer);
 void          stackmen_togc(Widget, XtPointer, XtPointer);

 /* file variables */
 static Widget   iw_all, iw_single, iw_section;
 static Widget   iw_rowcol1, iw_rowcol2;
 static Widget   iw_single1, iw_stkgo, iw_stkend;
 static Widget   iw_stackmen = (Widget)0, iw_pushc, iw_pusha;

 /* externally used variables */
 int             stkgo;           /* used in stack display */
 int             stkend;           /* used in stack display */
 static int      all=TRUE, single=FALSE, section=FALSE;    
 static int	 keepstknum = FALSE;       

 /************************************************************/

 void stackmen(void)

 { 
 Widget iw_rowcol;
 Widget iw_dums;
 char   cval[4];

 if (iw_stackmen == (Widget)0)
    {   /* create a menu widget first */
    stkgo = stkend =1;

    iw_stackmen = wid_dialog(iw_win, 0, "stack display options", -1, -1);
    iw_rowcol   = wid_rowcol(iw_stackmen, 'v', -1, -1);

    /* create a toggle box for image selection ---------------------- all */
    iw_all = wid_toggleg(iw_rowcol,iw_all,"DISPLAY ALL THE IMAGES",
	    all,stackmen_toga, NULL, -1,-1);

    /* create a toggle box for image selection ---------------------- single */
    iw_single = wid_toggleg(iw_rowcol,iw_single,
	    "DISPLAY ONE IMAGE IN STACK",single,stackmen_togb,NULL, -1,-1);

    /* create text box for single image number --------------- single */
    iw_rowcol1   = wid_rowcol(iw_rowcol, 'h', -1, -1);
    if (keepstknum) {
	sprintf(cval,"%4d",stkgo);
	iw_single1 = wid_textboxb(iw_rowcol1, iw_single1, "INPUT THE IMAGE # :", 	
                            cval,4);
    }
    else {
	iw_single1 = wid_textboxb(iw_rowcol1, iw_single1, "INPUT THE IMAGE # :", 
                            "*",4);
    }
    
    if (!single) {
	XtUnmanageChild(iw_rowcol1);
    }

    /* create a toggle box for image selection ---------------------- section */
    iw_section = wid_toggleg(iw_rowcol,iw_section,
	    "DISPLAY A SET IAMGES IN STACK",section,
		stackmen_togc, NULL,-1,-1);

    /* create text boxes for stkgo &stkend -------------------- section*/
    iw_rowcol2   = wid_rowcol(iw_rowcol, 'h', -1, -1);
    if (keepstknum) 
       { /* do not want to reset stkgo & stkend */
       sprintf(cval,"%4d",stkgo);
       iw_stkgo = wid_textboxb(iw_rowcol2,0,"Start",cval,4);
       sprintf(cval,"%4d",stkend);
       iw_stkend = wid_textboxb(iw_rowcol2,0,"End ",cval,4);
       }
    else
       {
       iw_stkgo = wid_textboxb(iw_rowcol2,0,"Start","*",4);
       iw_stkend = wid_textboxb(iw_rowcol2,0,"End ","*",4);
       keepstknum = TRUE;
       }
    if (!section) {
/*	XtUnmanageChild(iw_stkgo);
	XtUnmanageChild(iw_stkend);
*/	XtUnmanageChild(iw_rowcol2);
    }

    /* create box for apply ----------------------------------- apply */
    wid_stdbut(iw_rowcol, iw_stackmen, &iw_dums, &iw_pushc, 
                        &iw_pusha,  "CA",
                        fin_cb, stackmen_butc ,stackmen_buta, NULL);
    keepstknum = TRUE;
    }

 else
    {   /* stack menu widget already exists, update it */
    /* update text boxes for stkgo & stkend -------------------- section */
    if (single) {
       sprintf(cval,"%4d",stkgo);
       iw_single1 = wid_textboxb(iw_rowcol,iw_single1,"INPUT THE IMAGE #:",cval,4);
       }
    else if (section) {
	if (keepstknum) 
	   { /* do not want to reset stkgo & stkend */
	   sprintf(cval,"%4d",stkgo);
	   iw_stkgo = wid_textboxb(iw_rowcol,iw_stkgo,"START",cval,4);
	   sprintf(cval,"%4d",stkend);
	   iw_stkend = wid_textboxb(iw_rowcol,iw_stkend,"END ",cval,4);
	   }
	else
	   {
	   sprintf(cval,"%4d",1);
	   iw_stkgo = wid_textboxb(iw_rowcol,iw_stkgo,"START",cval,4);
	   sprintf(cval,"%4d",maxim);
	   iw_stkend = wid_textboxb(iw_rowcol,iw_stkend,"END ",cval,4);
	   }
        }
    }
 XtManageChild(iw_stackmen);
 }



 /***********  stackmen_toga  (tog  button callback) ********/

 void stackmen_toga(Widget iw_temp, XtPointer data, XtPointer call_data)
 {
  XmToggleButtonGadgetSetState(iw_all, TRUE,  FALSE);
  XmToggleButtonGadgetSetState(iw_single, FALSE,  FALSE);
/*  XtUnmanageChild(iw_single1);*/
  XtUnmanageChild(iw_rowcol1);
  XmToggleButtonGadgetSetState(iw_section, FALSE,  FALSE);
/*  XtUnmanageChild(iw_stkgo);
  XtUnmanageChild(iw_stkgo);
*/  XtUnmanageChild(iw_rowcol2);
 }

 /***********  stackmen_togb  (tog  button callback) ********/

 void stackmen_togb(Widget iw_temp, XtPointer data, XtPointer call_data)
 {
  XmToggleButtonGadgetSetState(iw_all, FALSE,  FALSE);
  XmToggleButtonGadgetSetState(iw_single, TRUE,  FALSE);
  XtManageChild(iw_rowcol1);
  XmToggleButtonGadgetSetState(iw_section, FALSE,  FALSE);
  XtUnmanageChild(iw_rowcol2);
 }

 /***********  stackmen_togc  (tog  button callback) ********/

 void stackmen_togc(Widget iw_temp, XtPointer data, XtPointer call_data)
 {
  XmToggleButtonGadgetSetState(iw_all, FALSE,  FALSE);
  XmToggleButtonGadgetSetState(iw_single, FALSE,  FALSE);
  XtUnmanageChild(iw_rowcol1);
  XmToggleButtonGadgetSetState(iw_section, TRUE,  FALSE);
  XtManageChild(iw_rowcol2);
 }

 /***********  stackmen_buta  (accept button callback) ********/

 void stackmen_buta(Widget iw_temp, XtPointer data, XtPointer call_data)
 {
 char *string = NULL;
 int  vval;

 /* get the state of toggle */
 all = XmToggleButtonGadgetGetState(iw_all);
 single = XmToggleButtonGadgetGetState(iw_single);
 section = XmToggleButtonGadgetGetState(iw_section);

 /* get the num for stkgo and stkend */
 if (all) {
    stkgo = 1;
    stkend = maxim;
    }
 else if (single) {
    string = XmTextGetString(iw_single1);
     
    /* find file numbers wanted */
    if (sscanf(string,"%d",&vval) <= 0 || vval < 0)
       {   /* can not interpret the image number */
       spout("*** Can not interpret number of the image in stack! ");
       if (string) XtFree (string); return;
       }
    stkgo = vval;
    stkend = vval;
    }
 else if (section) {
    /* get stkgo */
    string = XmTextGetString(iw_stkgo);
    if (!strcmp(string,  "*")) {
	stkgo = 1;
    }
    else if (sscanf(string,"%d",&vval) <= 0 || vval < 0)
       {   /* can not interpret vval */
       spout("*** Can not interpret number of the start image in stack! ");
       if (string) XtFree (string); return;
       }
    else 
	stkgo = vval;

    /* get stkend */
    string = XmTextGetString(iw_stkend);
    if (!strcmp(string,  "*")) {
	stkend = maxim;
    }
    else if (sscanf(string,"%d",&vval) <= 0 || vval < 0)
       {   /* can not interpret vval */
       spout("*** Can not interpret number of the ending image in stack! ");
       if (string) XtFree (string); return;
       }
    else 
	stkend = vval;

    if (string) XtFree (string);
 }
 else {
       spout("*** Can not interpret the operation! ");   return;  
 }

 /* remove the montage menu */
 XtUnmanageChild(iw_stackmen);
 expos_cb(NULL,NULL,NULL);

 /* display the montage, imagego set in imagemen */
 stackdis(imagego,imageend);
 }

 /***********  stackmen_butc  (cancel button callback) ********/

 void stackmen_butc(Widget iw_temp, XtPointer data, XtPointer call_data)

 {
 XtUnmanageChild(iw_stackmen);
 closefile(filedata);
 filedata = NULL;
 }

