
/*$Header: /net/ithaca/usr1/web/src/RCS/strtoint.c,v 1.4 1996/05/16 17:35:03 leith Exp $*/
/*
 * strtoint.c
 *
 **********************************************************************
 * COPYRIGHT (C)1992, WADSWORTH CENTER FOR LABORATORIES AND
 * RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.
 * THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     
 * LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  
 * USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF 
 * THE CENTER FOR LABORATORIES AND RESEARCH 			  
 **********************************************************************
 *
 * 
 * 
 * PURPOSE:	retrieves string from widget and converts to integer
 *
 * RETURNS:	error flag (FALSE is error!)
 * 
 * PARAMETERS:  iw_it     widget to be interrogated
 *              message   error message
 *              ival      integer value (returned)
 *
 **********************************************************************
*/

#include "std.h"
#include "x.h"
#include <Xm/TextF.h>
#include <Xm/Text.h>


/* function prototypes */
 extern void spout(char *);
 extern void spouts(char *);

 /*********************** strtoint ******************************/
 
 int strtoint(Widget iw_it, char * message, int * ival)

 {
 char * string;

 if (!XtIsWidget(iw_it))
    {
    spout("*** iw_it not set, pgm. error in strtoint caller");
    return FALSE;
    }

 string = XmTextGetString(iw_it);

 if (sscanf(string,"%d",ival) <= 0)  
    {
    spouts("*** Illegal value for: "); spout(message);
    XtFree(string);
    return FALSE;
    } 

 XtFree(string);
 return TRUE;
 }

