
/*$Header: /net/alwyn/usr1/web/src/RCS/thresh.c,v 1.2 94/10/04 13:28:33 leith Exp $*/

/***********************************************************************
 *
 * thresh.c
 *
 ***********************************************************************
 * author : ArDean Leith
 * COPYRIGHT (C)1993, WADSWORTH CENTER FOR LABORATORIES AND
 * RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      
 * THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     
 * LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  
 * USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF 
 * THE CENTER FOR LABORATORIES AND RESEARCH 			  
 ***********************************************************************
 *
 * thresh()
 * 
 * PURPOSE:    Thresholds an image
 *
 * RETURNS:    true or false
 *
 * PARAMETERS: 
 *
 ***********************************************************************
*/

#include "std.h"
#ifndef VMS
#include "float.h"
#endif

 /******************************  thresh ******************************/

 int thresh(float * oldimage, int nsamt, int nrowt, 
             float lower, float lowerval,
             float upper, float upperval,
             float * newimage, float * fmint, float * fmaxt)
 {
 float   oldval;
 int     iloc;

 *fmint = FLT_MAX;
 *fmaxt = FLT_MIN;

 /* convolve over all positions in the new image */

 for (iloc = 0; iloc < nrowt * nsamt; iloc++)
       {
       oldval = oldimage[iloc];

       if (oldval <= lower) 
          {
          newimage[iloc] = lowerval;
          *fmaxt         = MYMAX(*fmaxt,lowerval);
          *fmint         = MYMIN(*fmint,lowerval);
          }
  
       else if (oldval > upper)
          {
          newimage[iloc] = upperval;
          *fmaxt         = MYMAX(*fmaxt,upperval);
          *fmint         = MYMIN(*fmint,upperval);
          }

       else
          {
          newimage[iloc] = oldval;
          *fmaxt         = MYMAX(*fmaxt,oldval);
          *fmint         = MYMIN(*fmint,oldval);
          }
        }

 return TRUE;
 }


