
/*$Header: /net/ithaca/usr1/web/src/RCS/threshmen.c,v 1.1 1996/07/31 20:28:21 leith Exp $*/

/*
C++*********************************************************************
C
C threshmen
C
C **********************************************************************
C *  AUTHOR:  ArDean Leith                                                 *
C *  COPYRIGHT (C)1993, WADSWORTH CENTER FOR LABORATORIES AND              *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH                            *
C **********************************************************************
C
C    threshmen
C
C    PURPOSE:         display threshmen menu
C
C    CALLED BY:       imagemen
C
C    CALL TREE:


                  
   imagemen       
      |          
      v           
  imagemen_cb     
      |           
      v           
   imagemen1      
      |            
      v           
   filtermen --> threshmen --> threshmen_buta --> filter_but --> thresh

C***********************************************************************
*/

#include <Xm/Text.h>
#include <Xm/Scale.h>
#include "common.h"
#include "routines.h"

 /* internal function prototypes */
 void          threshmen_buta(Widget, XtPointer, XtPointer);
 void          threshmen     (Widget, XtPointer, XtPointer);

 /* external global variables used here */
 extern float    fminold, fmaxold;
 extern float    lower, lowerval, upper,  upperval;

 /* common variables used here */
 static Widget   iw_threshmen, iw_lower,    iw_lowerval,  
                 iw_upper,     iw_upperval, iw_ngo, iw_nend;
 static int      ngo=0, nend=100;

/*********************************** threshmen **********************/

 void threshmen(Widget iw_temp, XtPointer data, XtPointer call_data)
 { 
 char     cval11[12];
 Widget   iw_rowcol, iw_rowcolh;
 Widget   iw_pushc, iw_pusha, iw_dums;

 if (iw_threshmen <= (Widget)0)
    {   /* create thresh menu widget first */

    iw_threshmen = wid_dialog(iw_win,iw_threshmen,
                           "Threshold values",20,20);
    iw_rowcol    = wid_rowcol(iw_threshmen,'v',-1,-1);

    /* create a horizontal row-col widget for scales */
    iw_rowcolh = wid_rowcol(iw_rowcol, 'h', -1,-1);

    /* create scale widget for lower --------------------------- ngo */
    ngo     = 0;
    iw_ngo  = wid_scale(iw_rowcolh, 0, "", 0,100,  ngo, 
                        180,50, -1,-1);

    /* create scale widget for upper -------------------------- nend */
    nend    = 100;
    iw_nend = wid_scale(iw_rowcolh, 0, "", 0,100,  nend, 
                         180,50, -1,-1);

    XtAddCallback(iw_ngo,XmNvalueChangedCallback,
                           (XtCallbackProc) threshmen,"0");
    XtAddCallback(iw_nend,XmNvalueChangedCallback,
                           (XtCallbackProc) threshmen,"0");

    /* create text box for lower ----------------------------  lower */
    lower = fminold + ngo * (fmaxold - fminold) / 100.0;
    sprintf(cval11,"%f",lower);
    iw_lower = wid_textboxb(iw_rowcol,iw_lower,
                              "Lower Threshold:",cval11,10);

    /* create text box for lowerval ----------------------  lowerval */
    lowerval = fminold;
    sprintf(cval11,"%f",lowerval);
    iw_lowerval = wid_textboxb(iw_rowcol,iw_lowerval,
                               "Lower Value:    ",cval11,10);

    /* create text box for upper ----------------------------  upper */
    upper = fminold + nend * (fmaxold - fminold)/ 100.0;
    sprintf(cval11,"%f",upper);
    iw_upper = wid_textboxb(iw_rowcol,iw_upper,
                               "Upper Threshold:",cval11,10);

    /* create text box for upperval ----------------------  upperval */
    upperval = fmaxold;
    sprintf(cval11,"%f",upperval);
    iw_upperval = wid_textboxb(iw_rowcol,iw_upperval,
                              "Upper Value:    ",cval11,10);

    /* create accept boxes  ---------------------------------- apply */
    iw_pushc = (Widget) 0;
    iw_pusha = (Widget) 0;
    wid_stdbut(iw_rowcol, iw_threshmen, 
               &iw_dums, &iw_pushc, &iw_pusha, 
               "CA",fin_cb,fin_cb,threshmen_buta, NULL);
    }

 else
    {   /* thresh menu widget already exists, update it */

    /* get ngo & nend */
    XmScaleGetValue(iw_ngo, &ngo);
    XmScaleGetValue(iw_nend,&nend);

    /* alter text box for lower -----------------------------  lower */
    lower = fminold + ngo * (fmaxold - fminold)/ 100.0;
    sprintf(cval11,"%f",lower);
    iw_lower = wid_textboxb(iw_rowcol,iw_lower,
                            "Lower Threshold:",cval11,10);

    /* create text box for lowerval ----------------------  lowerval */
    sprintf(cval11,"%f",lowerval);
    iw_lowerval = wid_textboxb(iw_rowcol,iw_lowerval,
                               "Lower Value:    ",cval11,10);

    /* alter text box for upper -----------------------------  upper */
    upper = fminold + nend * (fmaxold - fminold)/ 100.0;
    sprintf(cval11,"%f",upper);
    iw_upper = wid_textboxb(iw_rowcol,iw_upper,
                            "Upper Threshold:",cval11,10);

    /* alter text box for upperval ------------------------  upperval */
    sprintf(cval11,"%f",upperval);
    iw_upperval = wid_textboxb(iw_rowcol,iw_upperval,
                               "Upper Value:    ",cval11,10);
   }

 XtManageChild(iw_threshmen);
 }



 /********************* thresh accept button callback *****************/

 void threshmen_buta(Widget iw_temp, XtPointer data, XtPointer call_data)
 {
 char *         string;
 char           filtertype[2];

 /* find thresholds */
 string = XmTextGetString(iw_lower);
 sscanf(string,"%f",&lower);
 if (string) free(string);

 string = XmTextGetString(iw_lowerval);
 sscanf(string,"%f",&lowerval);
 if (string) free(string);

 string = XmTextGetString(iw_upper);
 sscanf(string,"%f",&upper);
 if (string) free(string);

 string = XmTextGetString(iw_upperval);
 sscanf(string,"%f",&upperval);
 if (string) free(string);

 filtertype[0] = 'u';
 filtertype[1] = '\0';
 filter_but(iw_temp, (XtPointer) filtertype, call_data);
 }
