/*$Header: /alwyn/usr1/web//RCS/visual_info.c,v 1.3 94/02/14 10:07:45 leith Exp $*/
/*
C++*************************************************************************
C
C VISUAL_INFO                         
C
C **************************************************************************
C *  COPYRIGHT (C)1992, WADSWORTH CENTER FOR LABORATORIES AND             *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH 			   *
C **************************************************************************
C
C  VISUAL_INFO
C
C  PURPOSE:  GIVES MISC. INFO ON X-WINDOW VISUAL USEFUL FOR DEBUGGING
C--*******************************************************************
*/

#include "std.h"
#include "x.h"

 void visual_info(Display *idispl, Visual *vis)
 {

 XVisualInfo   vTemplate;
 XVisualInfo   *visualList;
 int           visualsMatched, iclass;
 char          *class;

 vTemplate.visualid = XVisualIDFromVisual(vis);

 visualList  = XGetVisualInfo(idispl,VisualIDMask,
                             &vTemplate, &visualsMatched);
 if (visualsMatched == 0)
    {
    printf("No such visual! \n");
    return;
    }

 iclass = visualList[0].class;

 if (iclass == DirectColor)
    class = "DirectColor";       
 else if (iclass == GrayScale)
    class = "GreyScale";
 else if (iclass == PseudoColor)
    class = "PseudoColor";
 else if (iclass == StaticColor)
    class = "StaticGray";
 else if (iclass == TrueColor)
    class = "TrueColor";
 else if (iclass == GrayScale)
    class = "GrayScale";
 else
    class = "Unknown";

 printf("---------- Visual: %d ---------------\n",visualList[0].visual);

 printf("Visual class:     %s (%d) \n",class,visualList[0].class );

 printf("Visual depth:     %6d \n",visualList[0].depth );

 printf("Visual map size:  %6d \n",visualList[0].colormap_size);

 printf(" -------------------------------------------------\n");

 XFree((char *) visualList); 

}

