
/*$Header: /alwyn/usr1/web/RCS/waitcursor.c,v 1.1 93/11/10 10:11:21 leith Exp $*/
/*
C++*************************************************************************
C
C WAITCURSOR                        
C             CONVERTED TO C -- SEPT 92 al
C **************************************************************************
C *  AUTHOR: ARDEAN LEITH
C *  COPYRIGHT (C)1990, WADSWORTH CENTER FOR LABORATORIES AND              *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH 			   *
C **************************************************************************
C
C    WAITCURSOR(IWIN,WAIT,IWANT)
C
C    PARAMETERS:  IWIN          WINDOW WHERE CURSOR IS DESIRED       READS
C                 WAIT          LOGICAL FLAG TO START OR STOP WAIT   READS
C                 ICWANT        DESIRED TEMP CURSOR NUMBER           READS
C
C    PURPOSE:     SET TEMPORARY WAIT CURSOR FOR THIS WINDOW
C
C    CALLED BY:   
C
C***********************************************************************
*/

#include "x.h"
#include "std.h"
#include "common.h"

#define MAXCURSOR 75

 extern void setacursor (int, int, int);

 /************************************************************/

 void waitcursor(Window idum, int wait, int icwant)

 {
 static int lastcursor, lastcursorx;

 if (wait)
    {           
    /* install waiting cursor */
    if (icwant < 0 || icwant >= MAXCURSOR) icwant = 75;
    
    lastcursor  = icursor;
    lastcursorx = icursorx; 
   
    /* (in setacursor -1,-1 means do not change cursor colors) */
    setacursor(icwant, -1,-1);
    }

 else
    {
    /* replace wait cursor with last cursor before wait cursor */
    /* (-1,-1 means do not change cursor colors) */
    setacursor(lastcursor,-1,-1);
    }  
 
 XFlush(idispl);
 return;
 }


