
/*$Header: /net/ithaca/usr1/web/src/RCS/web_com.c,v 1.43 1997/05/12 18:44:34 leith Exp $*/

/***********************************************************************
 *
 * web_com.c
 *
 ***********************************************************************
 * COPYRIGHT (C)1992, WADSWORTH CENTER FOR LABORATORIES AND
 * RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.
 * THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     
 * LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  
 * USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF 
 * THE CENTER FOR LABORATORIES AND RESEARCH 			  
 ***********************************************************************
 * 
 * web_com(iw_menub)
 *
 * PURPOSE:     contains web commands for menu bar
 *
 * RETURNS:
 * 
 * PARAMETERS: iw_menub     menu-bar widget for menu item    
 *
 ***********************************************************************
*/

#include "std.h"
#include "x.h"
#include "routines.h"
 
/*******************************  web_com  ***************************/

 void web_com(Widget iw_menub)
 { 
 Widget iw_menup1a, iw_menup1b, iw_menup1c, iw_menup1d;
 Widget iw_menup1,  iw_menup2,  iw_menup3,  iw_menup4, iw_menup5;
 Widget iw_menup2a, iw_menup2b, iw_menup2c, iw_menup2d,iw_menup2e;
 Widget iw_menup2f;

 /* create a OPTIONS entry on menubar ----------------------------*/
 iw_menup1 = wid_pulldown(iw_menub,"OPTIONS  ",'O');

 /* create menu items for OPTIONS */ 
 wid_pushg(iw_menup1,(Widget)0,"Image",        imoptmen,   "0",0,0);
 wid_pushg(iw_menup1,(Widget)0,"Contrast",  contrastmen,   "0",0,0);
 wid_pushg(iw_menup1,(Widget)0,"Cursor",         curmen,   "0",0,0);
 wid_pushg(iw_menup1,(Widget)0,"Display",       dispmen,   "0",0,0);
 wid_pushg(iw_menup1,(Widget)0,"Font",          fontmen,   "0",0,0);
 wid_pushg(iw_menup1,(Widget)0,"Magnify",        setmag,   "0",0,0);

 /* create a color menu item in OPTIONS */
 iw_menup1a = wid_pulldown(iw_menup1,"Color",'M');
 wid_pushg(iw_menup1a,(Widget)0,"Foreground",   colmen,    "0",0,0);
 wid_pushg(iw_menup1a,(Widget)0,"Background",   colmen,    "2",0,0);
 wid_pushg(iw_menup1a,(Widget)0,"Overlay",      colmen,    "1",0,0);
 wid_pushg(iw_menup1a,(Widget)0,"Cursor",       colmen,    "3",0,0);
 
 /* create a line style menu item in OPTIONS */
 iw_menup1c = wid_pulldown(iw_menup1,"Line Style",'M');
 wid_pushg(iw_menup1c,(Widget)0,"Solid",        setline,   "0",0,0);
 wid_pushg(iw_menup1c,(Widget)0,"OnOffDash",    setline,   "1",0,0);
 wid_pushg(iw_menup1c,(Widget)0,"DoubleDash",   setline,   "2",0,0);

 /* create a line width menu item in OPTIONS */
 iw_menup1d = wid_pulldown(iw_menup1,"Line Width",'M');
 wid_pushg(iw_menup1d,(Widget)0,"0",        setline,   "3",0,0);
 wid_pushg(iw_menup1d,(Widget)0,"1",        setline,   "4",0,0);
 wid_pushg(iw_menup1d,(Widget)0,"2",        setline,   "5",0,0);
 wid_pushg(iw_menup1d,(Widget)0,"3",        setline,   "6",0,0);
 wid_pushg(iw_menup1d,(Widget)0,"4",        setline,   "7",0,0);
 wid_pushg(iw_menup1d,(Widget)0,"5",        setline,   "8",0,0);

 /* create a lut menu item in OPTIONS */
 iw_menup1b = wid_pulldown(iw_menup1,"Lut",'M');
 wid_pushg(iw_menup1b,(Widget)0,"Shared",        lutmen,   "0",0,0);
 wid_pushg(iw_menup1b,(Widget)0,"Private",       lutmen,   "1",0,0);

/* create a COMMAND entry on menubar ---------------------------*/
 iw_menup2 = wid_pulldown(iw_menub,"COMMANDS ",'C');

 /* create menu items for COMMANDS */ 
 wid_pushg(iw_menup2,(Widget)0,"Clear",         webclear,  "0",0,0);
 wid_pushg(iw_menup2,(Widget)0,"Image",         imagemen,  "1",0,0);
 wid_pushg(iw_menup2,(Widget)0,"Montage",       imagemen,  "2",0,0);
 wid_pushg(iw_menup2,(Widget)0,"Surface",       imagemen,  "3",0,0);
 wid_pushg(iw_menup2,(Widget)0,"Shift",         imagemen,  "i",0,0);
 wid_pushg(iw_menup2,(Widget)0,"Annotate",      imagemen,  "9",0,0);
 wid_pushg(iw_menup2,(Widget)0,"Blackout",      blackout,  "0",0,0);
 wid_pushg(iw_menup2,(Widget)0,"Colored Surface",imagemen, "h",0,0);
 wid_pushg(iw_menup2,(Widget)0,"Convolve",      imagemen,  "a",0,0);
 wid_pushg(iw_menup2,(Widget)0,"Corr-Map",      comapmen,  "0",0,0);
 wid_pushg(iw_menup2,(Widget)0,"Dendrogram",    imagemen,  "e",0,0);
 wid_pushg(iw_menup2,(Widget)0,"Distance",      distmen,   "0",0,0);
 wid_pushg(iw_menup2,(Widget)0,"Histogram",     imagemen,  "4",0,0);
 wid_pushg(iw_menup2,(Widget)0,"Magnify",       mag     ,  "0",0,0);
 wid_pushg(iw_menup2,(Widget)0,"Markers",       imagemen,  "5",0,0);
 wid_pushg(iw_menup2,(Widget)0,"Mask",          imagemen,  "6",0,0);
 wid_pushg(iw_menup2,(Widget)0,"Montage from doc. file", imagemen, "k",0,0);
 wid_pushg(iw_menup2,(Widget)0,"Movie",         imagemen,  "g",0,0);
 wid_pushg(iw_menup2,(Widget)0,"Tilted Particles",imagemen,  "8",0,0);

 /* create a  Categorize menu item in COMMANDS */
 iw_menup2f = wid_pulldown(iw_menup2,"Categorize",'N');
 wid_pushg(iw_menup2f,(Widget)0,"From sequential montage",imagemen,"b0",0,0);
 wid_pushg(iw_menup2f,(Widget)0,"From doc. file montage", imagemen,"b1",0,0);

 /* create a  Power Spectrum menu item in COMMANDS */
 iw_menup2e = wid_pulldown(iw_menup2,"Power Spectrum",'M');
 wid_pushg(iw_menup2e,(Widget)0,"Interactive",     winsiz,"81",0,0);
 wid_pushg(iw_menup2e,(Widget)0,"Fixed size",      winsiz,"82",0,0);
 wid_pushg(iw_menup2e,(Widget)0,"Specified coord.",winsiz,"83",0,0);

 wid_pushg(iw_menup2,(Widget)0,"Pixel",         pixelmen,  "0",0,0); 
 wid_pushg(iw_menup2,(Widget)0,"Profile",       imagemen,  "7",0,0);
 wid_pushg(iw_menup2,(Widget)0,"Reflections",   imagemen,  "c",0,0);
 wid_pushg(iw_menup2,(Widget)0,"SIRDS",         imagemen,  "f",0,0);


/* create a record menu item in COMMANDS */
 iw_menup2b = wid_pulldown(iw_menup2,"Record screen",'W');
 wid_pushg(iw_menup2b,(Widget)0,"Interactive",     winsiz,"61",0,0);
 wid_pushg(iw_menup2b,(Widget)0,"Fixed size",      winsiz,"62",0,0);
 wid_pushg(iw_menup2b,(Widget)0,"Specified coord.",winsiz,"63",0,0);

 wid_pushg(iw_menup2,(Widget)0,"Show Recording",   imagemen,"d",0,0);
 wid_pushg(iw_menup2,(Widget)0,"Show Contourfile", cntmen0,"0",0,0);

 /* create a EDIT entry on menubar -----------------------------------*/
 iw_menup5 = wid_pulldown(iw_menub,"EDIT ",'O');
 wid_pushg(iw_menup5,(Widget)0,"Bars",          bar,       "0",0,0);
 wid_pushg(iw_menup5,(Widget)0,"Drill-n-fill",  imagemen,  "j",0,0);
 wid_pushg(iw_menup5,(Widget)0,"Lines",         rubberline,"0",0,0);
 wid_pushg(iw_menup5,(Widget)0,"Text",          itex,      "0",0,0);

/* create a boxes menu item in EDIT */
 iw_menup2c = wid_pulldown(iw_menup5,"Draw Boxes",'W');
 wid_pushg(iw_menup2c,(Widget)0,"Interactive",     winsiz,"51",0,0);
 wid_pushg(iw_menup2c,(Widget)0,"Fixed size",      winsiz,"52",0,0);
 wid_pushg(iw_menup2c,(Widget)0,"Specified coord.",winsiz,"53",0,0);

 /* create a move area menu item in EDIT */
 iw_menup2a = wid_pulldown(iw_menup5,"Move area",'M');
 wid_pushg(iw_menup2a,(Widget)0,"Interactive",     winsiz,"71",0,0);
 wid_pushg(iw_menup2a,(Widget)0,"Fixed size",      winsiz,"72",0,0);
 wid_pushg(iw_menup2a,(Widget)0,"Specified coord.",winsiz,"73",0,0);

 /* create a window file  menu item in EDIT ----------------------*/
 iw_menup2d = wid_pulldown(iw_menup5,"Window Last File",'M');

 wid_pushg(iw_menup2d,(Widget)0,"Interactive",     winsiz,"41",0,0);
 wid_pushg(iw_menup2d,(Widget)0,"Fixed size",      winsiz,"42",0,0);
 wid_pushg(iw_menup2d,(Widget)0,"Specified coord.",winsiz,"43",0,0);
 

 /* create a INFO entry on menubar -----------------------------------*/
 iw_menup3 = wid_pulldown(iw_menub,"INFO",'O');

 /* create menu items in INFO */ 
 wid_pushg(iw_menup3,(Widget)0,"X-info", web_info, "0",0,0);
 wid_pushg(iw_menup3,(Widget)0,"Manual", web_info, "1",0,0);

 /* create a SYSTEM  entry on menubar --------------------------------*/
 iw_menup4 = wid_pulldown(iw_menub,"SYSTEM",'O');

 /* create menu items in SYSTEM */ 
 wid_pushg(iw_menup4,(Widget)0,"File extension",    newext   ,"0",0,0);
 wid_pushg(iw_menup4,(Widget)0,"Current directory", changedir,"0",0,0);
 wid_pushg(iw_menup4,(Widget)0,"File pattern ",     changepat,"0",0,0);
 wid_pushg(iw_menup4,(Widget)0,"EXIT",              exitexit, "0",0,0);
 }

