/*$Header: /net/ithaca/usr1/web/src/RCS/web_main.c,v 1.28 1997/04/16 17:53:42 leith Exp $*/

/*
 ***********************************************************************
 *
 * web_main.c
 *
 ***********************************************************************
 * COPYRIGHT (C)1992, WADSWORTH CENTER FOR LABORATORIES AND
 * RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.
 * THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     
 * LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  
 * USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF 
 * THE CENTER FOR LABORATORIES AND RESEARCH 			  
 ***********************************************************************
 *
 * web_main(parent)
 * 
 * PURPOSE:     initialize X windows
 *
 * RETURNS:     iw_main
 * 
 * PARAMETERS:  parent       parent widget   
 *
 ***********************************************************************
*/

#include "files.h"
#include "x.h"
#include "routines.h"
#include "common.h"

/*  define web icon */
#include "web_icon.xbm"  

#include <Xm/Text.h>
#include <Xm/Form.h>
#include <Xm/ScrollBar.h>
#include <Xm/ScrolledW.h>
#include <Xm/DrawingA.h>
#include <Xm/RowColumn.h>

#define MAX_ARGS     20

 char          outstr[80];

/**************************  web_main  ******************************/

 Widget web_main(Widget parent)
 { 
 Arg               args[MAX_ARGS];   /* arg list */
 register          int  n;           /* arg count */
 int               mapgop, mapendp, colorgop, colorendp;

 Pixmap            icon_pixmap;
 XWMHints          wm_hints;
 Colormap          mapdev;
 unsigned long     icon_fore, icon_back;
 XTextProperty     windowName, iconName;
 XColor            col_def, rgb_def;
 char            * icon_name   = "WEB";
 char            * window_name = 
  "Web -- A SPIDER image viewer and analyzer       COPYRIGHT (c) 1992, Health Research Inc., Albany, NY";

 /* find default screen pointer */
 if ((iscreen = DefaultScreenOfDisplay(idispl)) == 0)
    {XtWarning("*** Web can not determine screen!"); exit (-1);}

 /* find depth of screen (number of bit planes) */
 if ((idepth = DefaultDepthOfScreen(iscreen)) < 8)
    {XtWarning("*** Screen depth too shallow need >= 8 bits!"); exit (-1); }

 /* find default graphics context */
 icontx = DefaultGCOfScreen(iscreen);

 /* set default private colormap */
 mapgop   = mapgo;   mapendp   = mapend;
 colorgop = colorgo; colorendp = colorend;
 map = defluts(TRUE);
 n = 0;
 XtSetArg(args[n], XmNcolormap, map);        n++;
 XtSetValues(parent, args, n );

 /* set main window position and size -------------------------*/
 n = 0;
 XtSetArg(args[n], XmNx, 0);                 n++;
 XtSetArg(args[n], XmNy, 0);                 n++;

 ihighx = HeightOfScreen(iscreen) - 100;
 iwidex = WidthOfScreen(iscreen)  - 100;
 XtSetArg(args[n], XmNwidth,  iwidex);      n++;
 XtSetArg(args[n], XmNheight, ihighx);      n++;

 if ((iw_main = XmCreateForm(parent, "main", args,n)) == 0)
   { XtWarning("*** Web can not open main window!"); exit (-1); }
 XtManageChild(iw_main);

 /* create a menu bar for command selection -----------------*/
 n = 0;
 XtSetArg(args[n], XmNtopAttachment,  XmATTACH_FORM);  n++;
 XtSetArg(args[n], XmNleftAttachment, XmATTACH_FORM);  n++;
 XtSetArg(args[n], XmNrightAttachment,XmATTACH_FORM);  n++;
 iw_menub = XmCreateMenuBar(iw_main, "menub", args, n);
 if (iw_menub == NULL)
    { XtWarning("*** Can not create menu bar widget!"); exit (-1);}
 XtManageChild(iw_menub);

 /* create menu items under COMMANDS ----------------- */ 
 web_com(iw_menub);

 /* create a scrolled label window in iw_main for error messages etc */
 n = 0;
 XtSetArg(args[n], XmNscrollingPolicy,    XmAUTOMATIC);       n++;
 XtSetArg(args[n], XmNscrollBarDisplayPolicy, XmSTATIC);      n++;
 XtSetArg(args[n], XmNscrollBarPlacement, XmBOTTOM_RIGHT);    n++;
 XtSetArg(args[n], XmNvisualPolicy,       XmCONSTANT);        n++;
 XtSetArg(args[n], XmNeditMode,           XmMULTI_LINE_EDIT); n++;
 XtSetArg(args[n], XmNeditable,           False);             n++;
 XtSetArg(args[n], XmNleftAttachment,     XmATTACH_FORM);     n++;
 XtSetArg(args[n], XmNrightAttachment,    XmATTACH_FORM);     n++; 
 XtSetArg(args[n], XmNbottomAttachment,   XmATTACH_FORM);     n++;

 XtSetArg(args[n], XmNheight,             90);                n++;
 iw_scroll = XmCreateScrolledText(iw_main, "comscroll", args, n);
 XtManageChild(iw_scroll);

 /* find parent for the scrolling text window */
 iw_scrollpar = XtParent(iw_scroll);

 /* create spider image widget ----------------------------- */
 n = 0;
 XtSetArg(args[n], XmNtopWidget,        iw_menub);          n++;
 XtSetArg(args[n], XmNtopAttachment,    XmATTACH_WIDGET);   n++;
 XtSetArg(args[n], XmNleftAttachment,   XmATTACH_FORM);     n++;
 XtSetArg(args[n], XmNrightAttachment,  XmATTACH_FORM);     n++;
 
 XtSetArg(args[n], XmNbottomWidget,     iw_scrollpar);      n++;
 XtSetArg(args[n], XmNbottomAttachment, XmATTACH_WIDGET);   n++;
 iw_win = XmCreateDrawingArea(iw_main, "win", args, n);
 XtManageChild(iw_win);

 /* use expos_cb for redrawing the image widget contents */
 XtAddCallback(iw_win,XmNexposeCallback, (XtCallbackProc) expos_cb,NULL);

 /* find root window for this screen */
 iroot = RootWindowOfScreen(iscreen);

 /* create an offscreen backing store for image & graphics window */
 imagsav = XCreatePixmap(idispl,iroot,iwidex,ihighx,idepth);
 if (imagsav <= 0)  
    { XtWarning("*** Can not create image store!"); exit (-1); } 
 
 /* print opening output lines in iw_scroll */
 if (trace_web) spoutfile(TRUE);
 spout("This is Web;  An interactive display module for SPIDER");
 spout("Output messages appear here");

 /*************** does not mean anything?
 sprintf(outstr,"Proposed ramp: %d...%d Colors: %d...%d",
         mapgop,mapendp,colorgop,colorendp);
 spout(outstr); ***************/

 sprintf(outstr,"Image ramp: %d...%d  Colors: %d...%d",
         mapgo,mapend,colorgo,colorend);
 spout(outstr);

 /* realize all widgets now */
 XtRealizeWidget(iw_top);


 /* after realizing find window descriptor for the image widget */
 iwin  = XtWindow(iw_win);

 /* find window descriptor for the top widget */
 iwtop  = XtWindow(iw_top);
 
 /* write out visuals list */
 /******** visuals(idispl,XDefaultScreen(idispl)); *********/   
 /* type out some display/xwindows info */
 /**** wid_info(); ********/

 /* set default drawing color */
 wicolor(icontx,icolor);

 /* set default cursor and its colors */
 setacursor(icursor,icolorcf,icolorcb);

 /* set default initial image position */
 nrit = iwidex;
 nbot = ihighx;

 /* create an icon for web */
 mapdev      = DefaultColormapOfScreen(iscreen);
 XAllocNamedColor(idispl, mapdev, "Gold", &col_def, &rgb_def);
 icon_fore   = col_def.pixel;
 XAllocNamedColor(idispl, mapdev, "Blue", &col_def, &rgb_def);
 icon_back   = col_def.pixel;
 icon_pixmap =  XCreatePixmapFromBitmapData(idispl, iwtop, web_icon_bits, 
                 web_icon_width, web_icon_height, icon_fore, icon_back, idepth);

 XStringListToTextProperty(&icon_name, 1, &iconName);
 XStringListToTextProperty(&window_name, 1, &windowName);

 wm_hints.initial_state = NormalState;
 wm_hints.icon_pixmap   = icon_pixmap;
 wm_hints.flags = StateHint | IconPixmapHint;

 XSetWMProperties( idispl, iwtop, &windowName, &iconName, 
                    NULL, 0, NULL, &wm_hints, NULL);

 return iw_main;
}
