
/*$Header: /net/ithaca/usr1/web/src/RCS/web_man.c,v 1.1 1997/05/19 18:18:33 liy Exp $*/
/*
C++*************************************************************************
C
C  web_man.c     by Lekan Odesanya
C **************************************************************************
C *  COPYRIGHT (C)1992, WADSWORTH CENTER FOR LABORATORIES AND             *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH 			   *
C **************************************************************************
C
C  web_man 
C
C  PURPOSE:  DISPLAYS THE TEXT OF FILE FOR VIEWING ONLY
C
C--*******************************************************************
*/
#include <Xm/Text.h>
#ifdef VMS
#include <stat.h>
#else
#include <sys/stat.h>
#endif

#include "common.h"
#include "routines.h"

#define MAX_ARGS  6
#define MAX_CHARS 81


Widget          iw_manview, iw_manual = 0;
static char     filenameo[135] = "\0";

void  web_man(Widget iw_tempt, caddr_t data, caddr_t call_data )
{
 FILE        *fp = NULL;
 struct stat file_info;
 char        *buffer, *filename;
 Arg         args[MAX_ARGS];
 Widget      iw_dums, iw_pusha, iw_pushc;
 Widget      iw_rowcolv;

 if (iw_manual <= (Widget)0)
  {   /* create scrolled text viewer widget */

      iw_manual  = wid_dialog(iw_win, 0, "Web Manual", -1, -1);
       XtSetArg( args[0], XmNautoUnmanage, False ); 
       XtSetArg( args[1], XmNnoResize, True );  
       XtSetValues(iw_manual, args, 2);

      iw_rowcolv  = wid_rowcol(iw_manual, 'v', -1, -1);

    /* create box for Exiting ----------------------------------- Finished */
/*
      iw_dums = wid_stdbut(iw_rowcolv, iw_manual, 
                        &iw_dums, &iw_pushc, &iw_pusha,  "F",
                        fin_cb, fin_cb, fin_cb, NULL);
*/

/* create the scrolled widget */
      XtSetArg( args[0], XmNrows,               35 );
      XtSetArg( args[1], XmNcolumns,            80 );
      XtSetArg( args[2], XmNeditable,           FALSE );
      XtSetArg( args[3], XmNeditMode,           XmMULTI_LINE_EDIT );
      XtSetArg( args[4], XmNscrollHorizontal,   FALSE );
   
      iw_manview = XmCreateScrolledText(iw_rowcolv, "Web Manual Scroller",
                                       args, 5);
      XtManageChild( iw_manview );

  }
      
     filename = data;

     if(!strlen(filename) ) /* no file name specified */
      {
        spout("There is no text file for the browsing request!");
        return; 
      }

     if(strcmp(filename, filenameo) != 0)  /* different file from previous */
      {
        strcpy(filenameo, filename);
       /* try opening the file  */
        if( (fp = fopen(filename,"r")) == NULL)
        {
          sprintf(filenameo,"Unable to open text file: %s",filename);
          spout(filenameo); return;
        }

         /* get file size  */
          if( stat(filename, &file_info) != 0)
            fclose( fp );
          else
           {
            if( (buffer = (char *) XtMalloc( file_info.st_size + 5)) ==
                  (char *) NULL)
             fclose( fp );
            else
             {
              if( fread(buffer, 1, file_info.st_size, fp) < file_info.st_size)
                {
                 XtFree( buffer );
                 fclose( fp );
                }
               else
                {
                  buffer[file_info.st_size - 1 ] = '\0';  /* truncate */
                  XmTextSetString( iw_manview, buffer );
                  XtFree ( buffer );
                  fclose(fp);
                }
             }  
           }

      }  /* strcmp  */

 XtManageChild(iw_manual);
}
