
/*$Header: /net/ithaca/usr1/web/src/RCS/webclear.c,v 1.5 1995/02/08 17:22:48 liy Exp $*/
/*
C++*************************************************************************
C
C WEBCLEAR.FOR -- MARCH 91 al
C                 CONVERTED TO C -- AUG 91
C
C **************************************************************************
C *  AUTHOR:  ArDean Leith
C *  COPYRIGHT (C)1991, WADSWORTH CENTER FOR LABORATORIES AND              *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH			           *
C **************************************************************************
C
C    WEBCLEAR()
C
C    PURPOSE:          clears image window
C
C    PARAMETERS:       none
C
C    CALLED BY:        web_com
C
C--*********************************************************************
*/

#include "x.h"
#include "std.h"

 extern Display        *idispl;
 extern Drawable       iwin, imagsav;
 extern unsigned int   iwidex, ihighx;
 extern GC             icontx, icontxb;
 extern int            icolorxb;
 extern int            nbot,ntop;

 /*****************  webclear  ******************************/

 void webclear(Widget iw_dum, caddr_t data, caddr_t call_data)
 {

 XGCValues    gcval;
 int          icolorxf;

 if (icontxb <= (GC)0)
   { /* need to create a new graphics context for blanking */
   icontxb = XCreateGC(idispl,iwin,0,&gcval);
   XCopyGC(idispl,icontx,0,icontxb);
   }

 if (icolorxb < 1)
    icolorxb = 0;

 XGetGCValues(idispl, icontx, GCForeground, &gcval);
 
 XSetForeground(idispl,icontx,icolorxb);

 XFillRectangle(idispl,imagsav,icontx,0,0,iwidex,ihighx);

 XClearWindow(idispl,iwin);

 XFlush(idispl);

 XSetForeground(idispl, icontx, gcval.foreground);

 /* should start next image at upper left corner */
 nbot    = ihighx;
 ntop    = ihighx;

 return;
 }

