
/*$Header: /alwyn/usr1/web/RCS/whist.c,v 1.1 93/11/10 10:11:41 leith Exp $*/

/*C++*******************************************************************
C
C  WHIST.FOR
C  whist.c          NOV 92
C **************************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK            *
C *  COPYRIGHT (C)1981,1987, WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH                            *
C **************************************************************************
C
C  WHIST:(filedata,jhist)
c
C  PURPOSE:   WRITES HISTOGRAM INTO THE FINAL HISTOGRAM RECORDS OF AN
C             IMAGE FILE.
C
C  PARAMETERS:        filedata     file info
C                     jhist        histogram array
C
C--*******************************************************************
*/

#include "files.h"
#define NHIST 128

 /* external subroutines */
 extern int    wrtlin (FILEDATA *, float *, int, int);

 /********************** whist  **********************************/

 int whist(FILEDATA *filedata, int * jhist)

 {
 int    iout, irec, i, nsam;
 float * buf;

 buf    = filedata -> buf;

 iout   = 0;
 irec   = filedata -> nrow * filedata -> nslice;
 nsam   = filedata -> nsam;

 for (i = 0; i < NHIST; i++)
    {
    /* put histogram bin value in array a */    
    *(buf + iout) = jhist[i];
  
    if (iout++ >= nsam-1 || i == NHIST -1)
       {
       /* need to write output record */
       if (!wrtlin(filedata,buf,nsam,++irec)) return FALSE; 
       iout = 0;
       } 
    }

 return TRUE;
 }


