
/*$Header: /net/ithaca/usr1/web/src/RCS/wicolor.c,v 1.4 1996/03/26 16:39:16 leith Exp $*/
/*
C***************************************************************************
C
C WICOLOR  -- CREATED NOV 89
C             CONVERTED TO C -- SEPT 92 al                                                  
C **************************************************************************
C *  AUTHOR: ArDean Leith                                                  *
C *  COPYRIGHT (C)1989 , WADWSWORTH CENTER FOR LABORATORIES AND RESEARCH,  *
C *    NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.              *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH  			   *
C **************************************************************************
C
C WICOLOR(ICONTX,COLOR)
C
C PURPOSE:      SET COLOR FOR GRAPHICS DRAWING
C
C PARAMETERS:   ICONTX    PRESENT GRAPHICS CONTEXT
C               COLOR     SPIDER COLOR NUMBER
C
C CALLED BY:    MANY ROUTINES
C
C--*********************************************************************
*/

#include "common.h"

#define NIMAGE  128
#define MAXCOLS 255
 
 /************************  wicolor  ********************************/

 int wicolor(GC icontxt, int color)
 {
 int icolort, icolorxt;

 if (color <= 0 && color > -NIMAGE)
    {
    /* set foreground to specified spider image ramp color */
    icolort  = -color;
    }

 else if (color > 0 && color <= MAXCOLS)
    {
    /* set foreground to specified spider color */
    icolort  = color;
    }

 else
    {
    /* use default color of bright white */
    icolort  = colorgo + 9;
    }

 /* select the color */
 XSetForeground(idispl,icontxt, (unsigned long) ispicol[icolort]);

 if (icontxt == icontx)
    {
    /* record current color in icontx GC */
    icolor  = icolort;
    icolorx = ispicol[icolort];
    }

 return TRUE;
 }


