
/*$Header: /net/ithaca/usr1/web/src/RCS/wid_angles.c,v 1.4 1995/12/18 20:38:54 liy Exp $*/
/*
C++************************************************************************
C
C WID_ANGLES
C
C **************************************************************************
C *  AUTHOR:  ArDean Leith                                                 *
C *  COPYRIGHT (C)1991, WADSWORTH CENTER FOR LABORATORIES AND              *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH			           *
C **************************************************************************
C
C WID_ANGLES
C
C PURPOSE:      SET UP AN ANGLE SCALE WIDGET FOR 3-D VOLS
C
C PARAMETERS:   IW_PARENT         PARENT WIDGET         READ
C               IW_ITS            WIDGET NUMBERS        WRITE

C CALLED BY:    SURFMEN
C
C***********************************************************************
*/

#include "std.h"
#include "x.h"

 extern Widget wid_labelg   (Widget, Widget, char *, int, int);
 extern Widget wid_rowcol   (Widget, char , int, int);
 extern Widget wid_scale    (Widget, Widget, char *,
                             int, int, int,  int, int, int, int);

/*******************  wid_angles  ***************************/

 Widget wid_angles(Widget iw_parent, Widget iw_its[3], int system,
              int iphi, int itheta, int ipsi, int ixdum, int iydum)

 {   
 Widget               iw_rowcolv;
 Widget               iw_rowcolh1,iw_rowcolh2,iw_rowcolh3;
 static  int          iwid, ihi;
 char		      label1[10],label2[10],label3[10];		/* the labels */
 char		      label4[10],label5[10],label6[10];		/* the labels */

 if (iw_its[0] == (Widget)0) 
    {  /* must create new  widgets  */

    iwid = 300;
    ihi  = 50;

    iw_rowcolv   = wid_rowcol(iw_parent,'v',-1,-1);

    /* create rowcol widgets for each axis */
    iw_rowcolh1   = wid_rowcol(iw_rowcolv,'h',-1,-1);
    iw_rowcolh2   = wid_rowcol(iw_rowcolv,'h',-1,-1);
    iw_rowcolh3   = wid_rowcol(iw_rowcolv,'h',-1,-1);

    /* Euler angles */
    if(system) {
      strcpy(label1, "Phi:  ");
      strcpy(label2, "Theta:");
      strcpy(label3, "Psi:  ");
      }
  
    /* XYZ angles */
    else {
      strcpy(label1, "  X:  ");
      strcpy(label2, "  Y:  ");
      strcpy(label3, "  Z:  ");
      }

      strcpy(label4, "  +-X:");
      strcpy(label5, "  +-Y:");
      strcpy(label6, "  +-Z:");

    iw_its[0] =  wid_scale(iw_rowcolh1, iw_its[0], label1,
              0,360,iphi,    iwid,ihi, -1,-1);
 
    iw_its[1] =  wid_scale(iw_rowcolh2, iw_its[1], label2,
              0,360,itheta,  iwid,ihi, -1,-1);

    iw_its[2] =  wid_scale(iw_rowcolh3, iw_its[2], label3,
              0,360,ipsi,    iwid,ihi, -1,-1);

    iwid = 180;
    iw_its[3] =  wid_scale(iw_rowcolh1, iw_its[3], label4,
              -180,180,0,    iwid,ihi, -1,-1);
 
    iw_its[4] =  wid_scale(iw_rowcolh2, iw_its[4], label5,
              -180,180,0,  iwid,ihi, -1,-1);

    iw_its[5] =  wid_scale(iw_rowcolh3, iw_its[5], label6,
              -180,180,0,    iwid,ihi, -1,-1);

    return iw_rowcolv;
    }
 }
