
/*$Header: /net/ithaca/usr1/web/src/RCS/wid_dialog.c,v 1.6 1996/03/21 14:26:54 leith Exp $*/
/*
C++************************************************************************* 
C
C WID_DIALOG                        
C               CONVERTED TO C -- JULY 92 al
C **************************************************************************
C *  AUTHOR:  ArDean Leith                                 
C *  COPYRIGHT (C)1991, WADSWORTH CENTER FOR LABORATORIES AND              *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH 			   *
C **************************************************************************
C
C  WID_DIALOG
C
C  PURPOSE:        CREATES A DIALOG WIDGET
C
C  PARAMETERS      IW_PARENT       PARENT WIDGET
C                  IW_IT           DIALOG WIDGET
C                  TITLE           WIDGET TITLE
C                  IX,IY           POSITION (IN PIXELS)
C
C  CALLED BY:      imoptmen   montmen3   others
C
C--*********************************************************************
*/

#include "x.h"
#include<Xm/BulletinB.h>
#include "std.h"
#include "common.h"

#define MAX_ARGS 5

 extern void  spout(char *);


/************************************************************/

 Widget wid_dialog(Widget iw_parent, Widget iw_dialog, char * title, 
                   int ix, int iy)

 { 
 Arg           args[MAX_ARGS];   /* arg list */
 register      int  n;           /* arg count */
 Position      ixp,iyp;          /* parent widget's position */

 /* need to find location relative to present position of top window */
 XtSetArg(args[0], XmNx, &ixp);
 XtSetArg(args[1], XmNy, &iyp);
 XtGetValues(iw_top,args,2);
 /*( printf ("getvalues on iw_top gave, ixp,iyp: %d %d \n",ixp,iyp);*/

 if (ix < 0 || iy < 0)
    {    /*  use default placement for dialog box */
    ix = 30;
    iy = 30;
    }

 n = 0;
 XtSetArg(args[n], XmNx, (Position) ix+ixp); n++;
 XtSetArg(args[n], XmNy, (Position) iy+iyp); n++;
 XtSetArg(args[n], XmNdefaultPosition, False); n++;

 if (iw_dialog == (Widget)0)
    {   /* create widget first */
    iw_dialog = XmCreateBulletinBoardDialog(iw_parent,title,
                                            args,n);
    if (iw_dialog == (Widget)0)
       {
       spout("*** WID_DIALOG Cannot open dialog widget.");
       return iw_dialog;
       }
    }
 else
    { 
    XtSetValues(iw_dialog,args,n);
    }
 return iw_dialog;
 }
 
