
/*$Header: /net/ithaca/usr1/web/src/RCS/wid_file.c,v 1.12 1996/04/01 17:26:03 leith Exp $*/

/*
C++*************************************************************************
C
C WID_FILE -- CREATED JUNE 91
C                                                                     
C **************************************************************************
C *  AUTHOR: A. LEITH                                                      *
C *  COPYRIGHT (C)1992, WADSWORTH CENTER FOR LABORATORIES AND              *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH	        		   *
C **************************************************************************
C
C    WID_FILE
C
C    PARAMETERS:   IW_PARENT   PAREN WIDGET             READ
C                  IW_FILE     WIDGET NUMBER            READ/WRITE
C                  LABEL       WIDGET LABEL             READ
C                  FILNAM      FILE NAME                READ
C                  FILPATH     DIRECTORY PATH           READ
C                  CB          CALLBACK ON ACCEPT       READ
C                  IX,IY       UPPER LEFT CORNER        READ
C
C    PURPOSE:      MAKES A FILE WIDGET
C
C    CALLED BY:    WID_IMAGEMEN
C
C--********************************************************************
*/

#include "x.h"
#include "std.h"
#include "common.h"
#include "routines.h"
#include <Xm/FileSB.h>
#include <Xm/SelectioB.h>

 /* external common variables */
 extern Widget         iw_top;            /* top widget   */

 /* file variables */

 /********************  wid_file  ****************************/

 Widget wid_file(Widget iw_parent, Widget iw_file, 
               char *label, char *filnam, char *filpath,
               void (*cb) (), int ix, int iy)

 {
 Arg           args[8];          /* arg list */
 register      int  n;           /* arg count */
 Position      ixp,iyp;          /* parent widget's position */
 XmString      str_filnam = 0,  str_label = 0,  str_filpath = 0;
 XmString      str_prompt = 0;
 Widget	       iw_temp;

 /* need to find location relative to present position of top window */
 XtSetArg(args[0], XmNx, &ixp);
 XtSetArg(args[1], XmNy, &iyp);
 XtGetValues(iw_top,args,2);

 n = 0;

 /* set label for filename list in the widget */
 str_label = XmStringCreate(label, XmSTRING_DEFAULT_CHARSET);
 XtSetArg(args[n], XmNfileListLabelString, str_label); n++;

 if (*filpath != '\0')
    {
    /* set up dir search pattern */ 
    str_filpath = XmStringCreate(filpath, XmSTRING_DEFAULT_CHARSET);
    XtSetArg(args[n], XmNdirMask, str_filpath);    n++;
    }

 if (*filnam != '\0')
    {
    /* set up file name listed in the selection box */
    str_filnam = XmStringCreate(filnam, XmSTRING_DEFAULT_CHARSET); 
    XtSetArg(args[n], XmNtextString, str_filnam);  n++;
    }

 if (iw_file == (Widget)0)
    { /* must create and manage new file widget */

    XtSetArg(args[n], XmNdefaultPosition, False);  n++;

    if (ix < 0 || iy < 0)
       {    /*  use default placement for dialog box */
       ix = 20;
       iy = 20;
       }

    XtSetArg(args[n], XmNx, (Position) ix+ixp);    n++;
    XtSetArg(args[n], XmNy, (Position) iy+iyp);    n++;

    iw_file = XmCreateFileSelectionDialog(iw_parent,"iw_file",args,n);
	
    XtAddCallback(iw_file,XmNokCallback,cb,NULL);
    XtAddCallback(iw_file,XmNcancelCallback, (XtCallbackProc) fin_cb,
                         (XtPointer)iw_file);

    XtManageChild(iw_file);

    /* get rid of help button in widget*/
    XtUnmanageChild(XmFileSelectionBoxGetChild(
                  iw_file,XmDIALOG_HELP_BUTTON));
    }

 else 
    { /* can use existing widget */
	
    if ( ix > 0 || iy > 0)
       {
       XtSetArg(args[n], XmNx, (Position) ix+ixp); n++;
       XtSetArg(args[n], XmNy, (Position) iy+iyp); n++;
       }
    XtSetValues(iw_file,args,n);

    XtRemoveAllCallbacks(iw_file,XmNokCallback); 
    XtAddCallback(iw_file,XmNokCallback,cb,NULL);
    XtAddCallback(iw_file,XmNcancelCallback,(XtCallbackProc) fin_cb,
                                   (XtPointer) iw_file);

    XtManageChild(iw_file);

    /* remove the Help button */
    if ((iw_temp = XmFileSelectionBoxGetChild(
		   iw_file,XmDIALOG_HELP_BUTTON))!=NULL)
         XtUnmanageChild(iw_temp);
    }

 if (str_label)   XmStringFree(str_label);
 if (str_filpath) XmStringFree(str_filpath);
 if (str_filnam)  XmStringFree(str_filnam);

 return iw_file;

 }
 /********************  wid_fileset  ****************************/

 void wid_fileset(Widget iw_file, char *filnam)

 {
 Arg           args[1];   
 XmString      str_filnam;


 if (*filnam != '\0')
    {
    /* set up file name listed in the selection box */
    str_filnam = XmStringCreate(filnam, XmSTRING_DEFAULT_CHARSET); 

    XtSetArg(args[0], XmNtextString, str_filnam);    

    XtSetValues(iw_file,args,1);
    XmStringFree(str_filnam);
    }
 }

