
/*$Header: /net/ithaca/usr1/web/src/RCS/wid_label.c,v 1.6 1996/05/09 14:44:13 leith Exp $*/
/*
 * wid_label.c
 *
 ***********************************************************************
 * COPYRIGHT (C)1992, WADSWORTH CENTER FOR LABORATORIES AND
 * RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      
 * THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     
 * LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  
 * USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF 
 * THE CENTER FOR LABORATORIES AND RESEARCH 			  
 ***********************************************************************
 *
 * wid_label(Widget iw_parent, Widget iw_label, 
               char *label, int ix, int iy)
 * 
 * PURPOSE:    creates a label widget  
 *
 * RETURNS:    iw_button      widget for the pushbutton gadget
 * 
 * PARAMETERS:     
 *
 * RETURNS:    widget number
 *
 ***********************************************************************
*/

#include "std.h"
#include "x.h"
#include <Xm/Label.h>

/***************************  wid_label  *****************************/

 Widget wid_label(Widget iw_parent, Widget iw_label, 
               char *label, Colormap mapt, int ix, int iy)
 { 
 Arg           args[5];          /* arg list */
 int           n;                /* arg count */
 XmString      str_label;        /* String label */

 n = 0;

 /* note: XmStringCreateLtoR handles newline char oK) if this
    changed to XmStringCreate you will have to solve newline problem*/

 str_label = XmStringCreateLtoR(label,XmSTRING_DEFAULT_CHARSET);
 XtSetArg(args[n], XmNlabelString, str_label); n++;
 
 if (  iw_label ==  (Widget) 0)
    {      /* create new label gadget */
    if (ix > 0 && iy > 0)
       {     /* set label position */
       XtSetArg(args[n], XmNx, (Position) ix);   n++;
       XtSetArg(args[n], XmNy, (Position) iy);   n++;
       }
    else
       {
       /* use default alignment */
       XtSetArg(args[n], XmNalignment, XmALIGNMENT_BEGINNING);  n++;
       }

     if (mapt) 
        {
        XtSetArg(args[n], XmNcolormap, mapt);  n++;
        }

    iw_label = XmCreateLabel(iw_parent,"iw_label",args,n);
    }
 else 
    {
    XtSetValues(iw_label,args,n);
    }

 /* free the String (not doing this may result in a memory leak) */
 XmStringFree(str_label);

 XtManageChild(iw_label);
 return iw_label;
 }
 
