
/*$Header: /net/ithaca/usr1/web/src/RCS/wid_labelg.c,v 1.5 1996/05/09 14:44:52 leith Exp $*/
/*
 * wid_labelg.c
 *
 ***********************************************************************
 * COPYRIGHT (C)1992, WADSWORTH CENTER FOR LABORATORIES AND
 * RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      
 * THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     
 * LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  
 * USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF 
 * THE CENTER FOR LABORATORIES AND RESEARCH 			  
 ***********************************************************************
 *
 * wid_labelg(Widget iw_parent, Widget iw_labelg, 
               char *label, int ix, int iy)
 * 
 * PURPOSE:    creates a label widget  
 *
 * RETURNS:    iw_button      widget for the pushbutton gadget
 * 
 * PARAMETERS:     
 *
 * RETURNS:    widget number
 *
 ***********************************************************************
*/


#include "x.h"
#include <Xm/LabelG.h>
#include "std.h"

/********************** wid_labelg ***************************/

 Widget wid_labelg(Widget iw_parent, Widget iw_labelg, 
               char *label, int ix, int iy)
 { 
 Arg           args[3];          /* arg list */
 int           n;                /* arg count */
 XmString      str_label;        /* String label */

 n = 0;

 /* note: XmStringCreateLtoR handles newline char oK) if this
    changed to XmStringCreate you will have to solve newline problem*/

 str_label = XmStringCreateLtoR(label,XmSTRING_DEFAULT_CHARSET);
 XtSetArg(args[n], XmNlabelString, str_label); n++;

 
 if (iw_labelg <= (Widget)0)
    { /* create new label gadget */
    if (ix > 0 && iy > 0)
       { /* set label position */
       XtSetArg(args[n], XmNx, (Position) ix); n++;
       XtSetArg(args[n], XmNy, (Position) iy); n++;
       }
    else
       {  /* use default alignment */
       XtSetArg(args[n], XmNalignment, XmALIGNMENT_BEGINNING);  n++;
       }

    iw_labelg = XmCreateLabelGadget(iw_parent,"iw_labelg",args,n);
    }
 else 
    {
    XtSetValues(iw_labelg,args,n);
    }

 /* free the String (not doing this may result in a memory leak) */
 XmStringFree(str_label);

 XtManageChild(iw_labelg);
 return iw_labelg;

 }
 
