/*$Header: /net/ithaca/usr1/web/src/RCS/wid_mess.c,v 1.5 1996/03/21 14:26:46 leith Exp $*/

/*
 ***********************************************************************
 *
 * wid_mess.c
 *
 ***********************************************************************
 * COPYRIGHT (C)1992, WADSWORTH CENTER FOR LABORATORIES AND
 * RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.  
 * THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     
 * LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  
 * USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF 
 * THE CENTER FOR LABORATORIES AND RESEARCH 			  
 ***********************************************************************
 *
 * wid_mess(iw_parent, iw_mess, message, ix, iy)
 *
 * 
 * PURPOSE:   	creates a message dialog widget  
 *
 * RETURNS:   	the message widget's number
 * 
 * PARAMETERS:	Widget	iw_parent	parent widget
 *		Widget	iw_mess		message widget
 *		char	*message	message to be put in widget
 *		int	ix		x coord of ulh corner
 *		int     iy		y coord of ulh corner
 *
 ***********************************************************************
*/

#include "common.h"
#include <Xm/BulletinB.h>

#define  MAX_ARGS  3

static  Widget iw_messlabel;

/* function prototypes */
Widget wid_labelg (Widget, Widget, char *, int, int);


/**********************************************************************/
Widget wid_mess(Widget iw_parent, Widget iw_mess, char *message,
                   int ix, int iy)
{
   Arg          args[MAX_ARGS];     /* arg list  */
   int          n;                  /* arg count */
   Position    ixp,iyp;             /* parent widget's position */


   if (iw_mess == (Widget)0) 
      {
      /* need to find location relative to present position of top window */
      XtSetArg(args[0], XmNx, &ixp);
      XtSetArg(args[1], XmNy, &iyp);
      XtGetValues(iw_top,args,2);

      if (ix < 0 || iy < 0)
         {    /*  use default placement for message box */
         ix = 40;
         iy = 40;
         }

      n = 0;
      XtSetArg(args[n], XmNx, (Position) ix+ixp);      n++;
      XtSetArg(args[n], XmNy, (Position) iy+iyp);      n++;
      XtSetArg(args[n], XmNdefaultPosition, False);    n++;

      iw_mess = XmCreateBulletinBoardDialog(iw_parent,"iw_mess",args,n);
      iw_messlabel = (Widget) 0;
      }


   iw_messlabel = wid_labelg(iw_mess, iw_messlabel,message,-1,-1);

   XtManageChild(iw_mess);

   return (iw_mess);
}
