
/*$Header: /net/alwyn/usr1/web/src/RCS/wid_okcan.c,v 1.2 1994/06/02 14:06:59 odesanya Exp $*/
/*
 * wid_okcan.c
 *
 ***********************************************************************
 * COPYRIGHT (C)1992, WADSWORTH CENTER FOR LABORATORIES AND
 * RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.
 * THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     
 * LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  
 * USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF 
 * THE CENTER FOR LABORATORIES AND RESEARCH 			  
 ***********************************************************************
 *
 * 
 * 
 * PURPOSE:	creates an OK and CANCEL button section of window 
 *
 * RETURNS:	void
 * 
 * PARAMETERS:	Widget	big_parent	parent who callbacks should go
 *                                      to
 * 		Widget	immed_parent	parent of OK and CANCEL buttons
 *		int	(*cb)()		OK callback
 *
 ***********************************************************************
*/
#include "std.h"
#include "x.h"
#include <Xm/Form.h>
#include <Xm/PushBG.h>
#define MAX_ARGS 5

/* function prototypes */
void fin_cb(Widget, caddr_t, caddr_t);  /* default cancel callback */


/**********************************************************************/
void wid_okcan(Widget big_parent, Widget immed_parent, int (*cb) ())
{
   Arg           args[MAX_ARGS];    /* arg list                       */
   register      int n;             /* arg count                      */
   Widget        iw_butpar;         /* parent of ok and cancel button */
   Widget        iw_ok;             /* ok button                      */
   Widget        iw_cancel;         /* cancel button                  */

   /* create a parent for the OK and Cancel buttons */
   n = 0;
   XtSetArg(args[n], XmNhorizontalSpacing, 3);                    n++;
   iw_butpar = XmCreateForm(immed_parent, "iw_form", args, n);
   XtManageChild(iw_butpar);

   /* create OK and Cancel buttons */
   n = 0;
   XtSetArg(args[n], XmNshowAsDefault, 1);                        n++;
   XtSetArg(args[n], XmNleftAttachment, XmATTACH_FORM);           n++;
   iw_ok = XmCreatePushButtonGadget(iw_butpar, "OK", args, n);

   n = 0;
   XtSetArg(args[n], XmNdefaultButtonShadowThickness, 1);         n++;
   XtSetArg(args[n], XmNrightAttachment, XmATTACH_FORM);          n++;
   iw_cancel = XmCreatePushButtonGadget(iw_butpar, "Cancel", args, n);
   XtManageChild(iw_ok);
   XtManageChild(iw_cancel);

   /* add callbacks for buttons */
   XtAddCallback(iw_cancel, XmNactivateCallback, (XtCallbackProc) fin_cb, 
                              (XtPointer) big_parent);
   XtAddCallback(iw_ok, XmNactivateCallback, (XtCallbackProc) cb, 
                              (XtPointer) big_parent);
}

