
/*$Header: /net/ithaca/usr1/web/src/RCS/wid_optmenu.c,v 1.3 1996/04/01 17:26:36 leith Exp $*/
/*
 * wid_optmenu.c
 *
 ***********************************************************************
 * COPYRIGHT (C)1992, WADSWORTH CENTER FOR LABORATORIES AND
 * RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      
 * THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     
 * LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  
 * USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF 
 * THE CENTER FOR LABORATORIES AND RESEARCH 			  
 ***********************************************************************
 *
 * wid_optmenu(Widget iw_parent, char *label)
 * 
 * PURPOSE:    creates option menu
 *
 * RETURNS:    iw_button      widget for the option menu
 * 
 * PARAMETERS: iw_parent      parent
 *             label          label for menu item
 *
 ***********************************************************************
*/

#include "std.h"
#include "x.h"
#include <Xm/RowColumn.h>

 /************************************************************/

 Widget wid_optmenu(Widget iw_parent, char *label)
 { 
 Arg           args[3];   /* arg list */
 register      int  n;           /* arg count */
 Widget        iw_pull, iw_button;
 XmString      str_temp;

 iw_pull = XmCreatePulldownMenu(iw_parent,"iw_menup",NULL,0);

 n = 0;
 XtSetArg(args[n], XmNsubMenuId, iw_pull); n++;

 str_temp =  XmStringCreate(label, XmSTRING_DEFAULT_CHARSET); 
 XtSetArg(args[n], XmNlabelString, str_temp); n++;

 iw_button = XmCreateOptionMenu(iw_parent,"iw_optmenu",args,n);
 XtManageChild(iw_button);

 /* can free the string now */
 XmStringFree(str_temp);

 return iw_pull;
 }
 
