
/*$Header: /net/ithaca/usr1/web/src/RCS/wid_posiz.c,v 1.11 1996/03/29 15:31:56 leith Exp $*/
/*
 * wid_posiz.c
 *
 **********************************************************************
 * COPYRIGHT (C)1992, WADSWORTH CENTER FOR LABORATORIES AND
 * RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.
 * THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     
 * LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  
 * USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF 
 * THE CENTER FOR LABORATORIES AND RESEARCH 			  
 **********************************************************************
 *
 * 
 * 
 * PURPOSE:	creates a position and size widget
 *
 * RETURNS:	Widget number
 * 
 * PARAMETERS:  
 *
 * NOTE:	a row column widget is used for the vertical alignment
 *		of the children and a separate row column child is
 *		used whenever horizontal orientation is needed
 **********************************************************************
*/

#include "std.h"
#include "x.h"
#include "routines.h"

 /* internal functions */
 void          wid_posiz_buta(Widget, XtPointer, XtPointer);
 void          junk          ();
 void          subit         (void (*)());
 void          doit	     (void);
 
 /* file variables */
 static Widget        iw_ix = (Widget)0,  iw_iy = (Widget)0,
                      iw_icols = (Widget)0, iw_irows = (Widget)0;
 static Widget        iw_pushc,   iw_pusha;   
 static Widget        iw_rowcol1, iw_rowcol2; 
 static Widget        iw_title1,  iw_title2;
 static Widget        iw_posizt= (Widget)0;

 /* common variables */
 int           ix_posiz,   iy_posiz,  icols_posiz, irows_posiz;

 /******************************************************************/
 
 Widget wid_posiz(Widget iw_parent, Widget iw_posiz, int ixt, int iyt, 
                  int icolst, int irowst, char ctype, void (* call)())
 {
 Widget        iw_rowcol, iw_dum; 
 char          cval[5];

 ix_posiz    = ixt;    iy_posiz    = iyt;
 icols_posiz = icolst; irows_posiz = irowst;

 if (iw_posiz == (Widget)0) 
    {
    /* create a  new dialog widget for iw_posiz */
    iw_posiz  = wid_dialog(iw_parent,0, "position",-1,-1);

    /* create a RowColumn widget within iw_posiz */
    iw_rowcol = wid_rowcol(iw_posiz, 'v', -1, -1);

    /*--------------- position portion of widget ----------------*/

    /* create a label widget with default alignment */
    iw_title1 = wid_labelg(iw_rowcol, 0, 
                "Enter X & Y position (in pixels)", -1,-1);

    /* create a parent for the prompts and labels */
    iw_rowcol1  = wid_rowcol(iw_rowcol, 'h', -1, -1);

    /* create a label and text box for ix */
    sprintf(cval,"%4d",ix_posiz);
    iw_ix = wid_textboxb(iw_rowcol1,0,"X:   ",cval,4);
    sprintf(cval,"%4d",iy_posiz);
    iw_iy = wid_textboxb(iw_rowcol1,0,"Y:   ",cval,4);

    if (ctype == 's'  || ctype == 'S' )
       {
       XtUnmanageChild(iw_title1);
       XtUnmanageChild(iw_rowcol1);
       }
 
    /*------------------- size portion of widget ----------------*/

    /* create a label widget with default alignment */
    iw_title2 = wid_labelg(iw_rowcol, 0, 
                        "Enter cols. & rows (in pixels)", -1,-1);

    /* create a rowcol parent for the prompts and labels */
    iw_rowcol2  = wid_rowcol(iw_rowcol, 'h', -1, -1);

    /* create a label and text box for width & height */
    sprintf(cval,"%4d",icols_posiz);
    iw_icols = wid_textboxb(iw_rowcol2,0,"COLS:",cval,4);
    sprintf(cval,"%4d",irows_posiz);
    iw_irows = wid_textboxb(iw_rowcol2,0,"ROWS:",cval,4);

    if (ctype == 'P'  || ctype == 'p' )
       {
       XtUnmanageChild(iw_title2);
       XtUnmanageChild(iw_rowcol2);
       }
   
   /* create a separator for consistancy with other pop up dialogs */
   wid_sep(iw_rowcol);

   iw_dum = wid_stdbut(iw_rowcol, iw_posiz, &iw_dum, &iw_pushc, &iw_pusha, 
                       "CA",fin_cb,fin_cb, wid_posiz_buta, (char *) call);
   }

 else 
    {
    /* update widget for iw_posiz */
    iw_posiz  = wid_dialog(iw_parent,iw_posiz, "position",-1,-1);

    XtRemoveAllCallbacks(iw_pusha,XmNactivateCallback); 
    XtAddCallback(iw_pusha,XmNactivateCallback,
                   (XtCallbackProc) wid_posiz_buta, (XtPointer) call);

    if (ctype == 'p' || ctype == 'b' || ctype == 'P' || ctype == 'B' )
       {
       /* update label and text box for ix */
       sprintf(cval,"%4d",ix_posiz);
       iw_ix = wid_textboxb(iw_rowcol1,iw_ix,"X:",cval,4);
       sprintf(cval,"%4d",iy_posiz);
       iw_iy = wid_textboxb(iw_rowcol1,iw_iy,"Y:",cval,4);

       XtManageChild(iw_title1);
       XtManageChild(iw_rowcol1);
       }
    if (ctype == 'P'  || ctype == 'p' )
       {
       XtUnmanageChild(iw_title2);
       XtUnmanageChild(iw_rowcol2);
       }
  
    if (ctype == 's' || ctype == 'b' || ctype == 'S' || ctype == 'B' )
       {
       /* update text box for cols & rows */
       sprintf(cval,"%4d",icols_posiz);
       iw_icols = wid_textboxb(iw_rowcol2,iw_icols,"COLS:",cval,4);
       sprintf(cval,"%4d",irows_posiz);
       iw_irows = wid_textboxb(iw_rowcol2,iw_irows,"ROWS:",cval,4);
       XtManageChild(iw_title2);
       XtManageChild(iw_rowcol2); 
       }
    if (ctype == 'P'  || ctype == 'p' )
       {
       XtUnmanageChild(iw_title2);
       XtUnmanageChild(iw_rowcol2);
       }
    if (ctype == 's'  || ctype == 'S' )
       {
       XtUnmanageChild(iw_title1);
       XtUnmanageChild(iw_rowcol1);
       }
    }

 XtManageChild(iw_posiz);

 iw_posizt = iw_posiz;
 return iw_posiz;
 }


 /****************** accept button callback   *********************/


 void wid_posiz_buta(Widget iw_temp, XtPointer data, XtPointer call_data)

 { 
 /* recover values from the text boxes */
 if (iw_ix    > (Widget)0 && strtoint(iw_ix,   "x position",&ix_posiz)    
             == FALSE) return;
 if (iw_iy    > (Widget)0 && strtoint(iw_iy,   "y position",&iy_posiz)    
             == FALSE) return;
 if (iw_icols > (Widget)0 && strtoint(iw_icols,"columns",   &icols_posiz)
             == FALSE) return;
 if (iw_irows > (Widget)0 && strtoint(iw_irows,"rows",      &irows_posiz)
             == FALSE) return;

 /* unmanage wid_posiz widget */
 XtUnmanageChild(iw_posizt);

 /* kludge to get it to call routine passed in data */
 subit((void (*)()) data); 
 }


 /****************** kludge routine to activate data *****************/


 void subit(void (*doit)())
 {
 doit();
 }



 /****************** sample kludge routine    ************************/


 void junk()
 {
 printf(" in junk, SUCCESS \n");
 printf(" ix,iy: %d %d \n",ix_posiz,iy_posiz);
 }
