
/*$Header: /net/ithaca/usr1/web/src/RCS/wid_prom.c,v 1.1 1993/11/10 10:11:15 leith Exp $*/
/*
 * wid_prom.c
 *
 ***********************************************************************
 * COPYRIGHT (C)1992, WADSWORTH CENTER FOR LABORATORIES AND
 * RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.   
 * THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     
 * LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  
 * USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF 
 * THE CENTER FOR LABORATORIES AND RESEARCH 			  
 ***********************************************************************
 *
 * 
 * 
 * PURPOSE:	creates a label and a text field box
 *
 * RETURNS:	void (perhaps should return the text widget...)
 * 
 * PARAMETERS:	Widget	iw_parent	parent of prompt
 *		char	*label		label for prompt
 *
 * NOTE:	iw_parent should be of Widget type that handles the
 *              geometry of its children, e.g., a RowColumn Widget.
 ***********************************************************************
*/

#include "std.h"
#include "x.h"
#include <Xm/Label.h>
#include <Xm/TextF.h>
#define  MAX_ARGS  4

/*function prototypes */
void outmess(char *);


/**********************************************************************/
void wid_prom(Widget iw_parent, char *label)
{
   Arg           args[MAX_ARGS];    /* arg list              */
   register      int n;             /* arg count             */
   Widget        iw_lab;            /* label widget          */
   Widget        iw_tex;            /* text insertion widget */
   XmString      str_label;         /* String label          */

   outmess("in wid_prom");

   str_label = XmStringCreateLtoR(label, XmSTRING_DEFAULT_CHARSET);

   /* create label widget */
   n = 0;
   XtSetArg(args[n], XmNlabelString, str_label);                   n++;
   iw_lab = XmCreateLabel(iw_parent, "iw_lab", args, n);
   XtManageChild(iw_lab);

   XmStringFree(str_label);

   /* create text field widget */
   n = 0;
   iw_tex = XmCreateTextField(iw_parent, "iw_tex", args, n);

   XtManageChild(iw_tex);
}

