
/*$Header: /net/ithaca/usr1/web/src/RCS/wid_pulldown.c,v 1.2 1996/03/22 17:39:41 leith Exp $*/
/*
 * wid_pulldown.c
 *
 ***********************************************************************
 * COPYRIGHT (C)1992, WADSWORTH CENTER FOR LABORATORIES AND
 * RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      
 * THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     
 * LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  
 * USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF 
 * THE CENTER FOR LABORATORIES AND RESEARCH 			  
 ***********************************************************************
 *
 * wid_pulldown(Widget iw_parent, char *label, int quick)
 * 
 * PURPOSE:    creates pull-down menu
 *
 * RETURNS:    iw_button      widget for the pulldown menu
 * 
 * PARAMETERS: iw_parent      parent
 *             label          label for menu item
 *             quick          unused
 *
 ***********************************************************************
*/

#include "std.h"
#include "x.h"
#include <Xm/CascadeBG.h>
#include <Xm/CascadeB.h>
#include <Xm/RowColumn.h>

 /********************* wid_pulldown *************************/

 Widget wid_pulldown(Widget iw_parent, char *label, int quick)
 { 
 Arg           args[3];   /* arg list */
 register      int  n;           /* arg count */
 Widget        iw_pull, iw_button;
 XmString      str_temp;

 iw_pull = XmCreatePulldownMenu(iw_parent,"iw_menup",NULL,0);

 n = 0;
 XtSetArg(args[n], XmNsubMenuId, iw_pull); n++;

 str_temp =  XmStringCreate(label, XmSTRING_DEFAULT_CHARSET); 
 XtSetArg(args[n], XmNlabelString, str_temp); n++;

 /*  ----- not implemented yet ------------------------
 XtSetArg(args[n], XmNmnemonic , quick); n++;
 */

 iw_button = XmCreateCascadeButtonGadget(iw_parent,"iw_cascade",args,n);
 XtManageChild(iw_button);

 /* can free the string now */
 XmStringFree(str_temp);

 return iw_pull;
 }
 
