
/*$Header: /net/ithaca/usr1/web/src/RCS/wid_push.c,v 1.4 1996/03/22 17:35:55 leith Exp $*/
/*
 * wid_push.c
 *
 ***********************************************************************
 * COPYRIGHT (C)1992, WADSWORTH CENTER FOR LABORATORIES AND
 * RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      
 * THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     
 * LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  
 * USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF 
 * THE CENTER FOR LABORATORIES AND RESEARCH 			  
 ***********************************************************************
 *
 * wid_push(iw_parent, iw_pushg, *data, mapt, ix, iy)
 * 
 * PURPOSE:    creates a push button widget  
 *
 * RETURNS:    iw_button      widget for the pushbutton gadget
 * 
 * PARAMETERS: iw_parent      parent widget
 *             iw_pushg       this widget identifier
 *             data           callback client data
 *             ix,iy          position    
 *
 ***********************************************************************
*/

#include "x.h"
#include <Xm/PushB.h>
#include "std.h"

#define MAX_ARGS 4

/***********************  wid_push  *************************/

 Widget wid_push(Widget iw_parent, Widget iw_push, 
               char *label, void (*cb)(),
               char *data, Colormap mapt, int ix, int iy)
 { 

 Arg           args[4];   /* arg list */
 int           n;         /* arg count */
 XmString      str_temp;

 n = 0;

 if (ix > 0 || iy > 0)
    {
    XtSetArg(args[n], XmNx, (Position) ix); n++;
    XtSetArg(args[n], XmNy, (Position) iy); n++;
    }

 str_temp =  XmStringCreate(label, XmSTRING_DEFAULT_CHARSET); 
 XtSetArg(args[n], XmNlabelString,  str_temp); n++;


 if (iw_push <= (Widget)0)
    {   /* create widget first */

    if ((int) mapt != 0) XtSetArg(args[n], XmNcolormap, mapt);  n++;
    iw_push = XmCreatePushButton(iw_parent,"iw_pb",args,n);
    }

 else 
    {
    /* update callbacks in case they are changed */
    XtRemoveAllCallbacks(iw_push,XmNactivateCallback);

    /* set label / position */ 
    XtSetValues(iw_push,args,n);
    }

 /* add call back */
 XtAddCallback(iw_push,XmNactivateCallback,cb,data);

 /* can free the string now */
 XmStringFree(str_temp);

 XtManageChild(iw_push);

 return iw_push;
 }
 
