
/*$Header: /net/ithaca/usr1/web/src/RCS/wid_pushg.c,v 1.5 1996/03/26 16:30:08 leith Exp $*/
/*
 * wid_pushg.c
 *
 ***********************************************************************
 * COPYRIGHT (C)1992, WADSWORTH CENTER FOR LABORATORIES AND
 * RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      
 * THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     
 * LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  
 * USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF 
 * THE CENTER FOR LABORATORIES AND RESEARCH 			  
 ***********************************************************************
 *
 * wid_pushg(iw_parent, iw_pushg, *data, ix, iy)
 * 
 * PURPOSE:    creates a push button gadget  
 *
 * RETURNS:    iw_button      widget for the pushbutton gadget
 * 
 * PARAMETERS: iw_parent      parent widget
 *             iw_pushg       this widget identifier
 *             data           callback client data
 *             ix,iy          position    
 *
 ***********************************************************************
*/


#include "x.h"
#include <Xm/PushBG.h>
#include "std.h"

/***********************  wid_pushg  ************************/

 Widget wid_pushg(Widget iw_parent, Widget iw_pushg, 
               char *label, void (*cb)(),
               char *data, int ix, int iy)
 { 

 Arg           args[3];     /* arg list */
 int           n;           /* arg count */
 XmString      str_temp;

 n = 0;

 if (ix > 0 || iy > 0)
    {
    XtSetArg(args[n], XmNx, (Position) ix); n++;
    XtSetArg(args[n], XmNy, (Position) iy); n++;
    }

 str_temp =  XmStringCreate(label, XmSTRING_DEFAULT_CHARSET); 
 XtSetArg(args[n], XmNlabelString, str_temp); n++;

 if (iw_pushg == (Widget) 0)

    {   
    /* create widget first */
    iw_pushg = XmCreatePushButtonGadget(iw_parent,"iw_pb",args,n);
    }

 else 
    {  
    /* update callbacks in case they are changed */
    XtRemoveAllCallbacks(iw_pushg,XmNactivateCallback); 

    /* set label and position */
    XtSetValues(iw_pushg,args,n);
    }

 /* add call back */
 XtAddCallback(iw_pushg, XmNactivateCallback, cb, data);

 XtManageChild(iw_pushg);

 /* can free the string now */
 XmStringFree(str_temp);

 return iw_pushg;
 }
 
