
/*$Header: /net/ithaca/usr1/web/src/RCS/wid_rowcol.c,v 1.3 1996/03/21 14:26:37 leith Exp $*/
/*
C++************************************************************************* 
C
C WID_ROWCOL  -- JULY 92 al
C **************************************************************************
C *  AUTHOR:  ArDean Leith                                 
C *  COPYRIGHT (C)1992, WADSWORTH CENTER FOR LABORATORIES AND              *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH 			   *
C **************************************************************************
C
C  WID_ROWCOL
C
C  PURPOSE:        CREATES A ROW COL WIDGET
C
C  PARAMETERS      IW_PARENT       PARENT WIDGET
C                  IW_IT           DIALOG WIDGET
C                  TYPE            ROW OR COLUMN
C                  IX,IY           POSITION (IN PIXELS)
C
C  CALLED BY:      imoptmen   montmen3   others
C
C--*********************************************************************
*/

#include "x.h"
#include<Xm/RowColumn.h>
#include "std.h"

#define MAX_ARGS 5

 extern void  spout(char *);

 extern Widget iw_top;


/************************************************************/

 Widget wid_rowcol(Widget iw_parent, char type, int ix, int iy) 

 { 
 Arg           args[MAX_ARGS];   /* arg list */
 register      int  n;           /* arg count */

 Position      ixp,iyp;          /* parent widget's position */
 Widget        iw_rowcol;

 n = 0;
 if (ix >= 0 || iy >= 0)
    {
    /* need to find location relative to present position of top window */
    XtSetArg(args[0], XmNx, &ixp);
    XtSetArg(args[1], XmNy, &iyp);
    XtGetValues(iw_top,args,2);

    /*( printf ("getvalues on iw_top gave, ixp,iyp: %d %d \n",ixp,iyp);*/
    XtSetArg(args[n], XmNx, (Position) ix+ixp); n++;
    XtSetArg(args[n], XmNy, (Position) iy+iyp); n++;
    XtSetArg(args[n], XmNdefaultPosition, False); n++;
    }

 if (type == 'h')
    {
    XtSetArg(args[n], XmNorientation, XmHORIZONTAL);    n++;
    }
 else
    {
    XtSetArg(args[n], XmNspacing, 6);    n++;
    }

 /* create a RowColumn widget as a parent for text input box  */
 iw_rowcol = XmCreateRowColumn(iw_parent,"iw_rowcol", args, n);

 if (iw_rowcol == (Widget)0)
    {
    spout("*** wid_rowcol cannot create widget.");
    return iw_rowcol;
    }

 XtManageChild(iw_rowcol);

 return iw_rowcol;
 }
 
