
/*$Header: /net/alwyn/usr1/web/src/RCS/wid_scale.c,v 1.2 1995/01/26 20:34:39 liy Exp $*/
/*
C++************************************************************************
C
C WID_SCALE
C
C **************************************************************************
C *  AUTHOR:  ArDean Leith                                                 *
C *  COPYRIGHT (C)1992, WADSWORTH CENTER FOR LABORATORIES AND              *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH			           *
C **************************************************************************
C
C WID_SCALE
C
C PURPOSE:      SET UP A SCALE WIDGET 
C
C PARAMETERS:   IW_PARENT         PARENT WIDGET         READ
C               IW_ITS            WIDGET NUMBERS        WRITE
C               LABEL             LABEL                 READ
C               IMIN,IMAX         SCALE MIN & MAX       READ
C               INOW              CURRENT VALUE         READ
C               IWID,IHI          SCALE SIZE            READ
C               IXDUM,IYDUM       UNUSED
C
C CALLED BY:    SURFMEN           CONTRASTMEN
C
C***********************************************************************
*/

#include "std.h"
#include "x.h"
#include <Xm/Scale.h>

#define  MAX_ARGS 10

 extern Widget wid_labelg   (Widget, Widget, char *, int, int);
 extern Widget wid_rowcol   (Widget, char , int, int);
 
/*****************  wid_scale  ***************************/

 Widget wid_scale(Widget iw_parent, Widget iw_its, char * label,
              int imin, int imax, int inow,  int iwid, int ihi,
              int ixdum, int iydum)

 {   
 Arg          args[MAX_ARGS];    /* arg list  */
 Widget       iw_lab;
 Widget       iw_rowcolh;

 if (iw_its == (void *)0) 
    {  /* must create new widget  */

    if (strlen(label) > 0)
       {
       /* need rowcol widget to hold label and scale widget */
       iw_rowcolh  = wid_rowcol(iw_parent,'h',-1,-1);

       /* create label widget*/
       iw_lab      = wid_labelg(iw_rowcolh, 0, label, -1, -1);
       }
    else
       iw_rowcolh = iw_parent; 

    /* create scale widget */
    XtSetArg(args[0], XmNwidth, iwid);                    
    XtSetArg(args[1], XmNheight, ihi);                
    XtSetArg(args[2], XmNscaleWidth, iwid-10);            
    XtSetArg(args[3], XmNscaleHeight, ihi/2);        
    XtSetArg(args[4], XmNminimum, imin);                
    XtSetArg(args[5], XmNmaximum, imax);             
    XtSetArg(args[6], XmNdecimalPoints, 0);            
    XtSetArg(args[7], XmNvalue, inow);                  
    XtSetArg(args[8], XmNorientation, XmHORIZONTAL);       
    XtSetArg(args[9], XmNshowValue, TRUE);           
 
    iw_its = XmCreateScale(iw_rowcolh, "iw_scale", args, 10);
    }

 else 
    { /* alter scale size in existing widget */

    XtSetArg(args[0], XmNminimum, imin);       
    XtSetArg(args[1], XmNmaximum, imax);       
    XtSetArg(args[2], XmNvalue,   inow);
       
    XtSetValues(iw_its, args, 3);
    }

 XtManageChild(iw_its);
 return iw_its;

 }
