
/*$Header: /net/ithaca/usr1/web/src/RCS/wid_text.c,v 1.5 1996/03/21 15:47:49 leith Exp $*/
/*
 * wid_text.c
 *
 ***********************************************************************
 * COPYRIGHT (C)1992, WADSWORTH CENTER FOR LABORATORIES AND
 * RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.
 * THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     
 * LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  
 * USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF 
 * THE CENTER FOR LABORATORIES AND RESEARCH 			  
 ***********************************************************************
 *
 * 
 * 
 * PURPOSE:	create a text input pop up dialog box
 *
 * RETURNS:	iw_text
 * 
 * PARAMETERS:  Widget	iw_parent	parent widget
 *		Widget  iw_text		text input dialog box
 *		char	*prompt		prompt string
 *		int	(*cb)()		OK callback
 *		int	ix		x coord of ulh corner
 *		int 	iy		y coord of ulh corner
 *
 ***********************************************************************
*/

#include "std.h"
#include "x.h"
#include <Xm/SelectioB.h>

#define  MAX_ARGS 7

 /* function prototypes */
 extern void fin_cb  (Widget, caddr_t, caddr_t);
 extern void widpos  (int *, int *);

 /**********************************************************************/

 Widget wid_text(Widget iw_parent, Widget iw_text, char *prompt, 
                 char * text,
                void (*cb)(), caddr_t cbdata, int ix, int iy)
 {
   Arg           args[MAX_ARGS];              /* arg list      */
   register      int n;                       /* arg count     */
   char          label[80];
   XmString      str_prompt, str_text;        /* String prompt */


   /* create a String prompt */
   str_prompt = XmStringCreate(prompt, XmSTRING_DEFAULT_CHARSET);

   n = 0;
   XtSetArg(args[n], XmNselectionLabelString, str_prompt);      n++;

   if (text != (char *) NULL)
      {
      str_text = XmStringCreate(text, XmSTRING_DEFAULT_CHARSET);
      XtSetArg(args[n], XmNtextString, str_text);      n++;
      }

   /* for all widgets that are subclass of XmBulletinBoard, must set
      this argument = false, otherwise, positioning does not work the
      first time! */
   XtSetArg(args[n], XmNdefaultPosition, False);    n++;


   if (iw_text <= (Widget)0) 
      {              /* must create new widget */
      iw_text = XmCreatePromptDialog(iw_parent, "iw_text", NULL, 0);

      widpos(&ix,&iy);
      XtSetArg(args[n], XmNx, (Position) ix);    n++;
      XtSetArg(args[n], XmNy, (Position) iy);    n++;
      XtSetValues(iw_text, args, n);

      /* ok callback should be sent the text the user inserted */
      XtAddCallback(iw_text,XmNokCallback,    cb,    cbdata);
      XtAddCallback(iw_text,XmNcancelCallback, (XtCallbackProc) fin_cb,
                              (XtPointer) iw_text);
      }

   else 
      {             /* can use existing widget */
      if (ix > 0 || iy > 0)
         {
         widpos(&ix,&iy);
         XtSetArg(args[n], XmNx, (Position) ix);     n++;
         XtSetArg(args[n], XmNy, (Position) iy);     n++;
         }
      XtSetValues(iw_text, args, n);

      XtRemoveAllCallbacks(iw_text,XmNokCallback); 
      /* ok callback should be sent the text the user inserted */
      XtAddCallback(iw_text,XmNokCallback, cb, cbdata);
      }

   XtManageChild(iw_text);
   XtUnmanageChild(XmSelectionBoxGetChild
                   (iw_text,XmDIALOG_HELP_BUTTON));


   /* free String storage */
   XmStringFree(str_prompt);
   if (text != (char *) NULL)
       XmStringFree(str_text);

   return (iw_text);
 }
