
/*$Header: /net/ithaca/usr1/web/src/RCS/wid_textboxb.c,v 1.4 1996/04/11 14:21:13 leith Exp $*/
/*
************************************************************************* 
*
*  TEXTBOXB
*
**************************************************************************                     *
*  COPYRIGHT (C)1991, WADSWORTH CENTER FOR LABORATORIES AND              *
*  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
*    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
*    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
*    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
*    THE CENTER FOR LABORATORIES AND RESEARCH 			         *
**************************************************************************
*
*  TEXTBOXB(IW_PARENT,IW_TEXTIN,STRING,PROMPT,IX,IY)       
*
*  PURPOSE:        CREATES A TEXT INPUT WINDOW USING ROW COLUMN WIDGET
* 
*  PARAMETERS      IW_PARENT       PARENT WIDGET                READS
*                  IW_TEXT         TEXT WIDGET                  WRITES
*                  PROMPT          BOX LABEL                    READS
*                  STRING          OUTPUT STRING                READS
*                  ICOL            LENGTH OF TEXT BOX           READS
*
* CALLED BY:       many routines
*
**************************************************************************
*/

#include "std.h"
#include "x.h"
#include <Xm/Text.h>
#include <Xm/RowColumn.h>

#include "routines.h"

/************************  wid_textboxb   ***********************/

 Widget wid_textboxb(Widget iw_parent, Widget iw_text,  
               char *prompt, char *string,  int icol)

 {  
 Arg           args[3];    /* arg list  */
 register      int n;      /* arg count */
 Widget        iw_rowcol;

 n = 0;
 
 if (iw_text == (Widget)0)
    {
    if (strlen(prompt) > (size_t) 0)
       {    
       /* create a new RowColumn widget as a parent for text input box  */
       XtSetArg(args[n], XmNorientation, XmHORIZONTAL);    n++;
       iw_rowcol = XmCreateRowColumn(iw_parent, "iw_rowcol", args, n);
       XtManageChild(iw_rowcol);

       /* create label widget for the prompt */
       wid_labelg(iw_rowcol, 0, prompt, -1,-1);
       }
    else
       iw_rowcol = iw_parent;

    n = 0;
    XtSetArg(args[n], XmNvalue, string); n++;                  
    XtSetArg(args[n], XmNcolumns, (short) icol); n++; 
    XtSetArg(args[n], XmNeditMode, XmSINGLE_LINE_EDIT); n++; 
 
    /* XmTextField is not used because it results in a memory leak */ 
    iw_text = XmCreateText(iw_rowcol, "iw_text", args, n);
    }

 else 
    {    /* alter existing textbox string value */
    XtSetArg(args[n], XmNvalue, string); n++;                  
    XtSetArg(args[n], XmNcolumns, (short) icol); n++; 
    XtSetValues(iw_text, args, n);

    /* note that iw_text is child of iw_rowcol which may be unmanaged */
    XtManageChild(XtParent(iw_text));
    }

 XtManageChild(iw_text);
 return (iw_text);
 }


