
/*$Header: /net/ithaca/usr1/web/src/RCS/wid_toggleg.c,v 1.4 1996/03/26 13:59:40 leith Exp $*/
/*
 * wid_toggleg.c
 *
 ***********************************************************************
 * COPYRIGHT (C)1992, WADSWORTH CENTER FOR LABORATORIES AND
 * RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      
 * THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     
 * LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  
 * USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF 
 * THE CENTER FOR LABORATORIES AND RESEARCH 			  
 ***********************************************************************
 *
 * wid_toggleg(iw_parent, iw_toggleg, label,value,callback, data, ix, iy)
 * 
 * PURPOSE:    creates a toggle button gadget with callback 
 *
 * RETURNS:    iw_toggleg      toggle widget 
 * 
 * PARAMETERS:     
 *
 ***********************************************************************
*/


#include "x.h"
#include <Xm/ToggleBG.h>
#include "std.h"

/******************  wid_toggleg  ******************************/

 Widget wid_toggleg(Widget iw_parent, Widget iw_toggleg, 
               char *label, int value,
               void (*cb)(), char *data, int ix, int iy)
 { 
 Arg           args[6];   /* arg list */
 register      int  n;           /* arg count */
 XmString      str_temp;

 n = 0;

 if (ix > 0 || iy > 0)
    {
    XtSetArg(args[n], XmNx, (Position) ix); n++;
    XtSetArg(args[n], XmNy, (Position) iy); n++;
    }

 /* set the color to red */
 XtSetArg(args[n], XmNselectColor, 147); n++;
	
 str_temp =  XmStringCreate(label, XmSTRING_DEFAULT_CHARSET); 
 XtSetArg(args[n], XmNlabelString,  str_temp); n++;

 if ( iw_toggleg == (Widget) 0)
    {   
    /* create widget first time */
    iw_toggleg = XmCreateToggleButtonGadget(iw_parent,"iw_tog",args,n);
    }

 else 
    {   /* update callbacks in case they are changed */
    XtRemoveAllCallbacks(iw_toggleg, XmNvalueChangedCallback);

    /* set label & position */ 
    XtSetValues(iw_toggleg,args,n);
    }

 /* can free the string now */
 XmStringFree(str_temp);

 /* add call back */
 XtAddCallback(iw_toggleg,XmNvalueChangedCallback,cb,data);

 /* set the toggle, do not notify other toggles */
 XmToggleButtonGadgetSetState(iw_toggleg,value,FALSE);

 XtManageChild(iw_toggleg);

 return iw_toggleg;
 }
 
