
/*$Header: /net/ithaca/usr1/web/src/RCS/wid_togmen.c,v 1.6 1995/02/28 17:04:20 liy Exp $*/
/*
 * wid_togmen.c
 *
 ***********************************************************************
 * COPYRIGHT (C)1992, WADSWORTH CENTER FOR LABORATORIES AND
 * RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      
 * THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     
 * LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  
 * USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF 
 * THE CENTER FOR LABORATORIES AND RESEARCH 			  
 ***********************************************************************
 *
 * wid_togmen(iw_parent, iw_pushg, label, value, ix, iy)
 * 
 * PURPOSE:    creates a toggle button gadget  
 *
 * RETURNS:    iw_button      widget for the pushbutton gadget
 * 
 * PARAMETERS:     
 *
 ***********************************************************************
*/

#include "std.h"
#include "x.h"
#include <Xm/ToggleBG.h>

#define MAX_ARGS 8

/*************************  wid_togmen  ***************************/

 Widget wid_togmen(Widget iw_parent, Widget iw_toggleg, 
               char *label,int value, int ix, int iy)
 { 
 Arg           args[MAX_ARGS];   /* arg list */
 register      int  n;           /* arg count */

 n = 0;

 XtSetArg(args[n], XmNset,TRUE);     n++;
 XtSetArg(args[n], XmNselectColor, 147); n++;	/* red */
 XtSetArg(args[n], XmNlabelString, XmStringCreate(label,
                              XmSTRING_DEFAULT_CHARSET)); n++;

 if ((long)iw_toggleg <= 0)
    {   /* create widget first */

    if (ix >= 0 && iy >= 0)
       { /* set label position */
       XtSetArg(args[n], XmNx, ix); n++;
       XtSetArg(args[n], XmNy, iy); n++;
       }
    else
       {
       /* use default alignment */
       XtSetArg(args[n], XmNalignment, XmALIGNMENT_BEGINNING);  n++;
       }

    iw_toggleg = XmCreateToggleButtonGadget(iw_parent,"iw_tog",args,n);
    }
 else 
    {
    XtSetValues(iw_toggleg,args,n);
    }

 XmToggleButtonGadgetSetState(iw_toggleg,value,FALSE);

 XtManageChild(iw_toggleg);

 return iw_toggleg;
 }
 
