
/*$Header: /alwyn/usr1/web//RCS/wimakecur.c,v 1.3 94/02/16 12:21:49 leith Exp $*/
/*
C++*************************************************************************
C
C  WIMAKECUR.FOR  -- CREATED MAR 91
C                                                                     
C **************************************************************************
C *  AUTHOR: A. LEITH                                                      *
C *  COPYRIGHT (C)1991, WADSWORTH CENTER FOR LABORATORIES AND              *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH                            *
C **************************************************************************
C
C    WIMAKECUR(ICUR,LFORE,LBACK,COLORF,COLORB,IXHOT,IYHOT)
C
C    PARAMETERS:   ICUR        CURSOR NUMBER             WRITES
C                  LFORE       CURSOR FORGROUND DATA     READS
C                  LBACK       CURSOR BACKGROUND DATA    READS
C                  COLORF      CURSOR FOREGROUND COLOR   READS
C                  COLORB      CURSOR BACKGROUND DATA    READS
C                  IXHOT,IYHOT CURSOR HOT SPOT COOR.     READS
C
C    PURPOSE:      SETS UP A CURSOR FROM BITMAP DATA
C
C    CALLED BY:    CURSOR_BUT
C
C--*********************************************************************
*/

#include "common.h"

 /* external function prototypes */

 /* internal function prototypes */

 /* external common variables */

 /* internal common variables */

 /********************   wimakecur   ****************************/

 int  wimakecur(Cursor *icur, char * lfore, char * lback,
                XColor * colorft, XColor * colorb,
                int ixhot, int iyhot)
 {

 static int iwidec=16, ihighc=16;
 Pixmap     ifore, iback;
 
 if (*icur == 0) 
    {   /* cursor does not exist, need to create it */

    /* create cursor foreground pixmap */
    ifore = XCreatePixmapFromBitmapData(idispl,iwin,
                   lfore,iwidec,ihighc,1,0,1);

    /* create cursor background pixmap */
    iback = XCreatePixmapFromBitmapData(idispl,iwin,
                    lback,iwidec,ihighc,1,0,1);

    /* create the cursor */
    *icur  = XCreatePixmapCursor(idispl,ifore,iback,
                   colorft,colorb,ixhot,iyhot);

    /* free pixmap storage */
    XFreePixmap(idispl,ifore);
    XFreePixmap(idispl,iback);
    }
 return TRUE;
 }

