
/*$Header: /net/ithaca/usr1/web/src/RCS/winfile.c,v 1.7 1997/04/15 20:21:02 leith Exp $*/
/*
C **********************************************************************
C
C WINFILE  -- 
C             CONVERTED TO C -- SEPT 92 al
C **********************************************************************
C *  AUTHOR: ArDean Leith                                                  *
C *  COPYRIGHT (C)1991, WADSWORTH CENTER FOR LABORATORIES AND RESEARCH,    *
C *    NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.              *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH 			   *
C **********************************************************************
C
C  WINFILE()
C
C  PURPOSE:      READSBACK WINDOW, STORES CORRESPONDING 
C                AREA FROM AN IMAGE FILE IN A NEW IN A IMAGE FILE
C
C  PARAMETERS:   NONE
C
C  CALLED BY:    WINSEL
C
--*********************************************************************
*/

#include <Xm/SelectioB.h>

#include "common.h"
#include "routines.h"

 /* internal function prototypes */
 void winfile_cb(Widget, XtPointer, XtPointer);

 /* external common variables */
 extern int iwintyp;

 /* file variables */
 static char     prompt[] = "Enter window file name"; 
 static Widget   iw_text  = (Widget)  0;

/************************  winfile  **********************************/

 void winfile(void)
 {
 int nlet, numwin;


if (strlen(filnow) <= 0)
    {
    spout("*** MUST DISPLAY IMAGE FIRST");
    return;
    }

 if (strlen(winnam) > 0) 
    {   /* increment window file name */
    filinc(winnam, winnam, &nlet, &numwin);
    }

 /* create text input box */
 iw_text = wid_text(iw_win, iw_text, prompt, &winnam[0],
                    winfile_cb, NULL, ixulw+nsamw, iyulw+nroww);
 }



 /*************  winfile_cb  (runs after wid_text) *****************/

 void winfile_cb(Widget iw_temp, XtPointer data, XtPointer call_data)
 {
 float       *buf, fiskip;
 FILEDATA    *filedatao, *filedatan;
 int         iform, ixi, iyi, nsami, nrowi;

 XmSelectionBoxCallbackStruct * cbs;

 cbs = (XmSelectionBoxCallbackStruct *) call_data;

 strcpy(winnam,extractstr(cbs -> value));

 /* redraw image in case damaged by window name box */ 
 expos_cb(NULL,NULL,NULL);

 /* open existing image file for windowing */
 if ((filedatao = openold(filnow, &nsam, &nrow, &nslice, &iform, "o")) ==
      (FILEDATA *) NULL)  return;

 /* find corner locations relative to displayed image */
 ixi   = ixulw - ixul + 1;
 iyi   = iyulw - iyul + 1;
 nsami = nsamw;
 nrowi = nroww;

 if (iskip > 1) 
    {    /* window is from a reduced size image */
    ixi   = ixi   * iskip;
    iyi   = iyi   * iskip;
    nsami = nsami * iskip;
    nrowi = nrowi * iskip;
    }

 else if (iskip < 1)
    {   /* window is from expanded size image */
    fiskip = 1.0 / iskip;
    ixi    = ixi   * fiskip;
    iyi    = iyi   * fiskip;
    nsami  = nsami * fiskip;
    nrowi  = nrowi * fiskip;
    }

 /* add datexc to winnam if not already there */
 if (strstr(winnam,datexc) == 0)
    {
    strcat(winnam,".");
    strcat(winnam,datexc);
    }

 /* open new output file for window */
 if ((filedatan = opennew(winnam, nsami, nrowi, 1, 1, "u")) == 
     (FILEDATA *) NULL)
    {closefile(filedatao); winfile(); return; }

 /* set wait cursor */
 waitcursor(iwin, TRUE, 79);

 /* do the windowing */
 windowsp(filedatao, filedatan, nsam, nrow, nslice, 
        ixi, iyi, 1, nsami, nrowi, 1, filedatao -> fmin);

 /* close the input and output files */
 closefile(filedatao);
 closefile(filedatan);

 /* reset wait cursor */
 waitcursor(iwin, FALSE, 79);

 /* list window positons */
 windata(ixi, iyi, nsami, nrowi);
 
 if (iwintyp != 3)
    {   /* fixed size or interactive window */
    winmov();
    }
 winsiz1();
 }



