
/*$Header: /net/ithaca/usr1/web/src/RCS/winmov.c,v 1.5 1995/08/29 18:41:45 liy Exp $*/

/*
C++*************************************************************************
C
C WID_WINMOV.FOR -- CREATED JAN 90 al
C                   WIDGETIZED APRIL 91 al
C WINMOV.C          CONVERTED TO C -- SEPT 92 al
C **************************************************************************
C *  COPYRIGHT (C)1990, WADSWORTH CENTER FOR LABORATORIES AND             *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH                            *
C **************************************************************************
C
C WINMOV
C
C PURPOSE:       POSITIONS A DETERMINED SIZE OF WINDOW ON SCREEN
C
C CALLED BY:     WINSIZ
C
C                     / winsiz_pop --> winsiz_pop2 --> winsel --> movearea
C winsiz --> winsiz1 -- wid_posiz  --> winmov      /           
C                     \ wid_posiz  --> winsiz3    /
C
C--*********************************************************************
*/

#include "common.h"
#include "routines.h"

 void           winmov_pop (Widget, XEvent *, String *, Cardinal *);

 static GC      icontxx;

 /**************************************************************/

 void winmov(void)
 {

 /* make a xor graphics context */
 icontxx = setxor(icontx);
 wicolor(icontxx,icolorov);

 /* set up action procedure to set window location */
 actions(iw_win, "winmov_pop", winmov_pop, "M123");

 showbutx("Sets window location.",
          "Changes window size.",
          "Stops this routine.", FALSE);
 } 


 /**************** set window position ***************/


 void winmov_pop(Widget iw_t, XEvent *event, String *params,
                   Cardinal *num_params)
 {

 if (!(strcmp(*params,"M")))                 /* cursor moved */
    {
    /* get mouse position ix,iy  */
    getloc(event,'M',&ixulw,&iyulw);

    /* mouse moved so erase old box and draw new box */
    xorbox(iwin,icontxx,FALSE,ixulw,iyulw,nsamw,nroww);
    } 

 else if (!(strcmp(*params,"1")))            /* button 1 pushed */
    {
    /* erase old box */
    xorbox(iwin,icontxx,TRUE,ixulw,iyulw,nsamw,nroww);

    /* if 'record the last file', keep the window */
    if (ioper == 4)	
    	xorbox(imagsav,icontx,TRUE,ixulw,iyulw,nsamw,nroww);

    XFreeGC(idispl,icontxx);

    /* uninstall translations */
    XtUninstallTranslations(iw_t);
 
    /* unmanage information box */
    showbutx("","","",TRUE);

    winsel();
    return;
    }
 else if (!(strcmp(*params,"2")))            /* button 2 pushed */
    {
    /* erase old box and use winsiz to change box size */
    xorbox(iwin,icontxx,TRUE,ixulw,iyulw,nsamw,nroww);

    /* uninstall translations */
    XtUninstallTranslations(iw_t);
 
    /* unmanage information box */
    showbutx("","","",TRUE);

    winsiz(NULL, NULL,NULL);
    return;
    }
 else if (!(strcmp(*params,"3")))          /* button 3 pushed */        
    {                                       
    /* erase old box and cancel this routine */
    xorbox(iwin,icontxx,TRUE,ixulw,iyulw,nsamw,nroww);

    XFreeGC(idispl,icontxx);

    /* uninstall translations */
    XtUninstallTranslations(iw_t);
 
    /* unmanage information box */
    showbutx("","","",TRUE);

    return;
    }
 }

