
/*$Header: /net/ithaca/usr1/web/src/RCS/winread.c,v 1.12 1996/03/29 15:32:01 leith Exp $*/
/*
C **********************************************************************
C
C WINREAD  -- CREATED MAY 91 FROM WIREAD al
C             CONVERTED TO C -- SEPT 92 al
C **********************************************************************
C *  AUTHOR: ArDean Leith                                                  *
C *  COPYRIGHT (C)1991, WADSWORTH CENTER FOR LABORATORIES AND RESEARCH,    *
C *    NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.              *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH 			   *
C **********************************************************************
C
C  WINREAD()
C
C  PURPOSE:      READSBACK WINDOW, STORES IN A IMAGE FILE
C
C  PARAMETERS:   NONE
C
C  CALLED BY:    WINSEL    MASKMEN
C
--**********************************************************************
*/

#include <Xm/SelectioB.h>
#include "common.h"
#include "routines.h"

 /* internal functions */
 void winread_cb(Widget, XtPointer, XtPointer);
 void winread1(char *, int, int);

 /* external common variables */
 extern int       iwintyp;
 extern char      outstr[80];

 /* file variables */
 static char     prompt[] = "Enter window file name"; 
 static Widget   iw_text  = (Widget) 0;
  
/************************  winread  *********************************/

 void winread(void)
 {
 int nlet, numwin;

 if (strlen(winnam) > 0) 
    {   /* increment window file name */
    filinc(winnam, winnam, &nlet, &numwin);
    }

 /* create text input box */
 iw_text = wid_text(iw_win, iw_text, prompt, winnam,
                    *winread_cb, &winnam[0],
                    ixulw+nsamw, iyulw+nroww);
 }

 /*************  winread_cb  (runs after wid_text) *****************/

 void winread_cb(Widget iw_temp, XtPointer data, XtPointer call_data)
 {
 char * string;

 XmSelectionBoxCallbackStruct * cbs;

 cbs = (XmSelectionBoxCallbackStruct *) call_data;

 string = extractstr(cbs -> value); 

 strcpy(winnam,string);

 XtFree(string);

 winread1(winnam,TRUE,255);
 }

 /*************  winread1  (runs after winread_cb) ******************/

 void winread1(char * winnamt,int zmap, int ipmask)
 {
 XImage        *imagerec = NULL;
 float         *buf, value;
 FILEDATA      *filedatat = NULL;
 int           i, j, k, ipad, itemp, ilen;
 char          *text;
 unsigned char cit;

 /* add datexc to winnam if not already there */
 if (strstr(winnamt,datexc) == 0)
    {
    strcat(winnamt,".");
    strcat(winnamt,datexc);
    }

 /* open new output file for window */
 filedatat = opennew(winnamt, nsamw, nroww, 1, 1, "u");
 if (filedatat == (FILEDATA *) NULL) return;

 /* redraw image in case damaged by window name box */ 
 expos_cb(NULL,NULL,NULL);

 /* set wait cursor */
 waitcursor(iwin, TRUE, 79);

 if (zmap)
    {
    imagerec = XGetImage(idispl, imagsav, ixulw,iyulw, nsamw,nroww,
                      ipmask, ZPixmap);
    }
 else
    {
    imagerec = XGetImage(idispl, imagsav, ixulw,iyulw, nsamw,nroww,
                      ipmask, XYPixmap);
    }

 if (imagerec == (XImage *) NULL) 
    { spout("*** Image formation failed");  return; }

 /* images are padded to units of four bytes */
 ipad = nsamw % 4;
 if (ipad > 0) ipad = 4 - ipad;

 /* use default read / write buffer from filedatat */
 buf = filedatat -> buf;

 if (!zmap)
    {
    /* convert single bit image to spider format */
    ilen = imagerec -> bytes_per_line;
    for (i=1; i <= nroww; i++)
       {
       itemp = (i-1) * ilen;
       for (j=0; j < nsamw; j++)
          {
          /* recover the relevant character of line every 8 cols */

#if defined(__osf__) || defined(VMS)

          if (!(j%8))
              {
              cit    = imagerec -> data[itemp++];
              buf[j] = cit & 1;   
              }
          else
              { 
              cit    = cit >> 1;        
              buf[j] = cit & 1 ;
              }
#else
          if (!(j%8))
              {
              cit    = imagerec -> data[itemp++];
              buf[j] = (cit & 128) >> 7;   
              }
          else
              { 
              cit    = cit << 1;        
              buf[j] = (cit & 128) >> 7;
              }
#endif

          }
       wrtlin(filedatat, buf, nsamw, i);
       }
    }

 else if (zmap)
    {
    /* convert image to spider format */
    k = 0;
    for (i=1; i <= nroww; i++)
       {
       for (j=0; j < nsamw; j++)
          {
          value  = (unsigned char) imagerec->data[k++];
          buf[j] = value;
          }
       wrtlin(filedatat, buf, nsamw, i);
       k = k + ipad;
       }
    }

 sprintf(outstr,"A %d x %d window recorded from: (%d,%d)\n",
     nsamw,nroww,ixulw,iyulw);
 spout(outstr);

 /* free image memory.  This deallocates image buffer also */
 XDestroyImage(imagerec);

 closefile(filedatat); filedatat = NULL;

 /* reset wait cursor */
 waitcursor(iwin, FALSE, 79);

 if (iwintyp != 3)
    {   /* fixed size or interactive window */
    winmov;
    }

 }








