
/*$Header: /net/ithaca/usr1/web/src/RCS/winsiz.c,v 1.13 1996/03/26 17:32:51 leith Exp $*/

/*
C++*************************************************************************
C
C WINSIZ -- CREATED JAN 90 al
C           CONVERTED TO C -- AUG 92 al
C **************************************************************************
C *  COPYRIGHT (C)1990 , WADSWORTH CENTER FOR LABORATORIES AND             *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH                            *
C **************************************************************************
C
C WINSIZ
C
C PURPOSE:       RETURNS WINDOW COORDINATES AND SIZE
C
C VARIABLES:     IWINTYP       WINDOW TYPE IFS
C                IOPER         OPERATION
C
C CALLED BY:     web_com  
C
C
C                     / winsiz_pop --> winsiz_pop2 --> winsel --> movearea
C winsiz --> winsiz1 -- wid_posiz  --> winmov      /           
C                     \ wid_posiz  --> winsiz3    /
C
C--*********************************************************************
*/

#include "common.h"
#include "routines.h"

 /* internal function prototypes */
 void winsiz_pop (Widget, XEvent *, String *, Cardinal *);
 void winsiz_pop2(Widget, XEvent *, String *, Cardinal *);
 void winsiz1    (void);
 void winsiz3    (void);
 void winsiz4    (void);

 /* common variables */
 extern int      ix_posiz;         /* x coord from wid_posiz */
 extern int      iy_posiz;         /* y coord from wid_posiz */
 extern int      icols_posiz;      /* columns from wid_posiz */
 extern int      irows_posiz;      /* rows    from wid_posiz */

 /* internally or externally used variables */
 static GC       icontxx;
 int             iwintyp;
 static Widget   iw_posiz = (Widget) 0;

 /********************************* winsiz ***************************/

 void winsiz(Widget iw_temp, XtPointer data, XtPointer call_data)

 {
 char ctemp[3];

 if (data != NULL) 
    {
    strncpy(ctemp, (char*) data, 1); ctemp[1]= '\0'; 
    ioper   = atoi(&ctemp[0]);

    strncpy(ctemp, (char*)data, 2); ctemp[2]= '\0';
    iwintyp = atoi(&ctemp[1]);
    }

 if (iwintyp < 1 || iwintyp > 3)
    {
    printf(
        "in winsiz, iwintyp: %d ioper: %d ctemp: %c%c Notify Dean!\n",
        iwintyp,ioper,ctemp[0],ctemp[1]);
    } 
 winsiz1();
 }



 /***************************** winsiz1 ******************************/

 void winsiz1(void)

 {

 /* make a xor graphics context */
 icontxx = setxor(icontx);

 /* set default color for box in xor GC */
 wicolor(icontxx,icolorov);

 if (iwintyp == 1) 
    {   /* interactive windowing by rubber box */

    /* set upper left corner cursor */
    setacursor(67,-1,-1);

    actions(iw_win, "winsiz_pop", winsiz_pop, "13");

    showbutx("Sets upper left window corner.",
             NULL, 
             "Stop this routine.", FALSE);

    XFlush(idispl);
    }

 else if (iwintyp == 2) 
    {    /* desired a fixed size window */
    iw_posiz = wid_posiz(iw_win, iw_posiz, ixulw, iyulw, nsamw, nroww,
               'S', winsiz4);
    }

 else if (iwintyp == 3) 
    {    /* desired a specified coordinate window */
    iw_posiz = wid_posiz(iw_win, iw_posiz, ixulw, iyulw, nsamw, nroww,
               'B', winsiz3);
    }
 else
    {
    printf("iwintyp: %d in winsiz1 Notify Dean!\n", iwintyp);
    } 
 
 return;
 }


 /******************* SET INTERACTIVE UL CORNER *********************/

 void winsiz_pop(Widget iw_t, XEvent *event, String *params,
                  Cardinal *num_params)
 {

 /* uninstall translations */
 XtUninstallTranslations(iw_t);
   
 if (!(strcmp(*params,"1")))            /* button 1 pushed */
    {
    getloc(event,'B',&ixulw,&iyulw);

    /* for "record file'. If the cursor is not in the last image, return */
    if( ioper == 4 && (ixulw < ixul || iyulw < iyul || 
	ixulw > (ixul + nsam *iskip) || iyulw > (iyul + nrow *iskip))) {
 	spout(" The cursor is not in the last image.");
        actions(iw_win, "winsiz_pop", winsiz_pop, "13");
	return;
	}

    /* set lower right corner cursor */
    setacursor(7,-1,-1);

    /* set up action procedure to set lower right corner */
    actions(iw_win, "winsiz_pop2", winsiz_pop2, "M123");

    showbutx("Set lower right window corner.",
             "Change upper right window corner.", 
             "Stop this routine.", FALSE);
    XFlush(idispl);
    }

 else if (!(strcmp(*params,"3")))               
    {                                       /* button 3 pushed */
    /* set default cursor */
    setacursor(0,-1,-1);

    if (icontxx > (GC)0) XFreeGC(idispl,icontxx);

    /* unmanage information box */
    showbutx("","","",TRUE);
    }
 }

 /**************** SET INTERACTIVE LOWER RIGHT CORNER ***************/

 void winsiz_pop2(Widget iw_t, XEvent *event, String *params,
                  Cardinal *num_params)
 {
 int ix,iy;

   
 if (!(strcmp(*params,"M")))            /* cursor moved */
    {
    /* get mouse position */
    getloc(event,'M',&ix,&iy);

    nsamw = ix - ixulw + 1;
    nroww = iy - iyulw + 1;

    /* mouse moved so draw new box */
    xorbox(iwin,icontxx,FALSE,ixulw,iyulw,nsamw,nroww);
    }

 else if (!(strcmp(*params,"1")))       /* button 1 pushed */
    {
    getloc(event,'B',&ix,&iy);

    nsamw = ix - ixulw + 1;
    nroww = iy - iyulw + 1;

    /* erase old box and set source window to this location */
    xorbox(iwin,icontxx,TRUE,ixulw,iyulw,nsamw,nroww);

    /* if 'record the last file', keep the window */
    if (ioper == 4)	
    	xorbox(imagsav,icontx,TRUE,ixulw,iyulw,nsamw,nroww);

    /* set default cursor */
    setacursor(0,-1,-1);

    /* unmanage information box */
    showbutx("","","",TRUE);

    /* uninstall translations */
    XtUninstallTranslations(iw_t);


    /* proceed to specific operation on window */
    winsel();
    return;
    }


 else if (!(strcmp(*params,"2")))       /* button 2 pushed */
    {   /* resize window */

    /* erase old box and set source window to this location */
    xorbox(iwin,icontxx,TRUE,ixulw,iyulw,nsamw,nroww);

    /* set default cursor */
    setacursor(0,-1,-1);

    /* unmanage information box */
    showbutx("","","",TRUE);

    /* uninstall translations */
    XtUninstallTranslations(iw_t);

    winsiz1();
    return;
    }

 else if (!(strcmp(*params,"3")))       /* button 3 pushed */
    {   /* abort window */

    /* erase old box and set source window to this location */
    xorbox(iwin,icontxx,TRUE,ixulw,iyulw,nsamw,nroww);

    /* set default cursor */
    setacursor(0,-1,-1);

    /* unmanage information box */
    showbutx("","","",TRUE);

    /* uninstall translations */
    XtUninstallTranslations(iw_t);

    XFreeGC(idispl,icontxx);

    /******** if (docit)  CLOSE(LUNDOCW) */
    return;
    }

 }

 /****************** for set size window    *************************/


 void winsiz4(void)
 {
 nsamw = icols_posiz;
 nroww = irows_posiz;

 winmov();
 }

 /****************** for set coordinate window    *******************/


 void winsiz3(void)
 {
 ixulw = ix_posiz;
 iyulw = iy_posiz;
 nsamw = icols_posiz;
 nroww = irows_posiz;

 winsel();
 }
