
/*$Header: /net/ithaca/usr1/web/src/RCS/wipic.c,v 1.12 1996/03/21 15:29:23 leith Exp $*/

/***********************************************************************
 *
 * wipic.c
 *
 ***********************************************************************
 * COPYRIGHT (C)1992, WADSWORTH CENTER FOR LABORATORIES AND
 * RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      
 * THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     
 * LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  
 * USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF 
 * THE CENTER FOR LABORATORIES AND RESEARCH 			  
 ***********************************************************************
 *
 * wipic(icontx, cbuf,  ixul, iyul, nsam, nrow, showit, keepimage
 *       XImage * image)
 * 
 * PURPOSE:    displays an image 
 *
 * RETURNS:    
 * 
 * PARAMETERS:  keepimage  deallocate XImage structure if false.   
 *
 ***********************************************************************
*/

#include "std.h"
#include "common.h"
#include "x.h"

 /* common variables */
 extern Display       *idispl;
 extern Screen        *iscreen;
 extern Visual        *visual;
 extern Window        iwin;
 extern Pixmap        imagsav;

 /*******************  wipic   **************************/

 void wipic(GC icontx, unsigned char * cbuf, 
              int ixul, int iyul, int nsam, int nrow, int showit,
              int keepimage, XImage ** imaget)
 { 
 XImage * image;

 image  = XCreateImage(idispl,visual,DefaultDepthOfScreen(iscreen),
          ZPixmap, 0, (char *) cbuf,
          (unsigned int) nsam, (unsigned int) nrow, 8, nsam);

 if (showit)
    {
    XPutImage(idispl,iwin,   icontx,image,0,0,ixul,iyul,
              (unsigned int)nsam, (unsigned int)nrow); 

    XPutImage(idispl,imagsav,icontx,image,0,0,ixul,iyul,
              (unsigned int)nsam, (unsigned int)nrow); 
    }

 if (!keepimage) 
    {
    /* do not deallocate data memory ever!! XDestroyImage will!! */
    if (image) XFree((void *)image); 
    image = NULL;
    }

 *imaget = image;
 }

