
/*$Header: /alwyn/usr1/web/RCS/wisetplanes.c,v 1.1 93/11/10 10:11:45 leith Exp $*/
/*
C++*************************************************************************
C
C WISETPLANES.FOR                         
C wisetplanes.c
C
C **************************************************************************
C *  AUTHOR: ARDEAN LEITH
C *  COPYRIGHT (C)1990, WADSWORTH CENTER FOR LABORATORIES AND              *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH                            *
C **************************************************************************
C
C    WISETPLANES(IDISPL,ICONTX,IPLANES)
C
C    PARAMETERS:  IDISPL        DISPLAY POINTER
C                 ICONTX        GRAPHICS CONTEXT
C                 TPLANES       MASK FOR PLANES DESIRED (<0 IS ALL)
C                 IRTFLG        ERROR FLAG
C
C    PURPOSE:     SET WRITING PLANES
C
C    CALLED BY:   WIGOLD         WIMARK
C
C    CALLS:       X-WINDOWS
C
C    NOTE:         IPLANES VALUE         PLANES ACTIVE
C
C                    < 0                   ALL
C                      1                   1
C                      3                   1-2
C                     15                   1-4
C                    127                   1-7
C                    128                   8
C                    255                   1-8
C***********************************************************************
*/

#include "x.h"

 int wisetplanes(Display *idispl, GC icontx, int iplanes)
 {
 int mask;

 if (iplanes < 0)
    {
    /* default to all planes */
    mask = -1;
    }
 else
    {
    mask = iplanes;
    }

 /*  SET PLANES FOR THIS DISPLAY */
 XSetPlaneMask(idispl,icontx,mask);
 XFlush(idispl);

 return TRUE;
 }
