
/*$Header: /net/alwyn/usr1/web/src/RCS/witext.c,v 1.3 94/09/12 14:23:03 leith Exp $*/

/*
 * witext.c
 *
 ***********************************************************************
 * COPYRIGHT (C)1992, WADSWORTH CENTER FOR LABORATORIES AND
 * RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.
 * THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     
 * LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  
 * USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF 
 * THE CENTER FOR LABORATORIES AND RESEARCH 			  
 ***********************************************************************
 *
 * witext(icontxt, text, ix, iy, itsize, just, inten, ipen, overprint)
 * 
 * PURPOSE:     text drawing routine 
 *              POSITIONS TEXT WITH LOWER LEFT PIXEL AT SPECIFIED LOC.    
 * 
 * PARAMETERS:	 
 *
 ***********************************************************************
*/

#include "common.h"
#include "routines.h"

 /*********************** witext *******************************/

 void witext(GC icontxt, char * text, int ix, int iy, 
             int itsize, int just, int inten, int ipen, int overprint)

 {
 int ici, nchar, ixj;

 if (inten >= 0)
    {  /* set color in icontxt using spider colors */
    if (ipen < 0)
       ici = -ipen;
    else
       ici = colorgo + ipen * 10 + inten;

    wicolor(icontxt,ici);
    }

 /* justify text if desired */
 ixj = ix;

 if (just == 1)
    {    /* centered text */
    ixj = ix + pixlen(icontx,text);
    }
 else if (just ==2)
    {    /* left justified text */
    ixj = ixj - pixlen(icontx,text);
    }

 /* String command needs text length */
 nchar = strlen(text);

 if (overprint) 
    {    /*  WRITE TEXT TO SCREEN (FOREGROUND & BACKGROUND)  */
    XDrawImageString(idispl, iwin, icontxt, ixj, iy, text, nchar);

    /* write text to backing store */
    XDrawImageString(idispl, imagsav, icontxt, ixj, iy, text, nchar);
    }   

 else
    {   /* write text to screen (foreground only) */
    XDrawString(idispl, iwin, icontxt, ixj, iy, text, nchar);

    /* write text to backing store (foreground only) */
    XDrawString(idispl, imagsav, icontxt, ixj, iy, text, nchar);
    }   
 }
