
/*$Header: /net/ithaca/usr1/web/src/RCS/witran.c,v 1.5 1996/04/11 15:20:50 leith Exp $*/

/*
 ***********************************************************************
 *
 * witran.c
 * ported from witran.for by Jing Su
 *
 ***********************************************************************
 * COPYRIGHT (C)1992, WADSWORTH CENTER FOR LABORATORIES AND
 * RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.  
 * THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     
 * LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  
 * USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF 
 * THE CENTER FOR LABORATORIES AND RESEARCH                       
 ***********************************************************************
 *
 *  PROGRAM TO APPLY TRANSFORMATION TO X,Y AND OUTPUT XS,YS
 *
 ***********************************************************************
*/

#include "std.h"

/***************************** witran ****************************/

void witran(float * x, float * y, float * xs, float * ys, int n,
            float gam, float the, float phi)
{
float        rgam, rthe, rphi, cgam, sgam, cphi, sphi, cthe;
float        cthecphi, cthesphi;
extern float xu0t, yu0t, xs0t, ys0t;
int          i;

const float pid =  (3.1415927 / 180.0);

rthe     = the * pid;
rphi     = phi * pid;
rgam     = gam * pid;

cgam     = cos(rgam);
sgam     = sin(rgam);
cphi     = cos(rphi);
sphi     = sin(rphi);
cthe     = cos(rthe);

cthecphi = cthe * cphi;
cthesphi = cthe * sphi;

for (i = 0; i < n; i++)
    {
    xs[i] =  ((x[i] - xu0t) * cgam - (y[i] - yu0t) * sgam) * cthecphi
           + ((x[i] - xu0t) * sgam + (y[i] - yu0t) * cgam) * sphi + xs0t;

    ys[i] = -((x[i] - xu0t) * cgam - (y[i] - yu0t) * sgam) * cthesphi
           + ((x[i] - xu0t) * sgam + (y[i] - yu0t) * cgam) * cphi +ys0t;
    }

return;
}


