
/*$Header: /net/ithaca/usr1/web/src/RCS/wrtlin.c,v 1.6 1995/05/08 15:12:13 leith Exp $*/
/*
 * wrtlin.c
 *
 *************************************************************************
 * SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK 
 * COPYRIGHT (C)1981,1992, WADSWORTH CENTER FOR LABORATORIES AND
 * RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
 * THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     
 * LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  
 * USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF 
 * THE CENTER FOR LABORATORIES AND RESEARCH 			  
 **************************************************************************
 *
 * wrtlin(fileptr,buf,nsam,irec)
 * 
 * PURPOSE:     
 *
 * RETURNS: number of positions written into file
 * 
 * PARAMETERS:   fileptr
 *               buf
 *               nsam
 *               irec    
 *
 *********************************************************************/

#include "files.h"

#ifdef P_SGIOSF
unsigned int *pt;
#define CONVERT_4( A, B )                        \
             (unsigned int)(A) =                 \
            ((unsigned int)(B) >> 24) |          \
            ((unsigned int)(B) << 24) |          \
           (((unsigned int)(B) >> 8) & 0xff00) | \
           (((unsigned int)(B) << 8) & 0xff0000)

#endif

 int wrtlin(FILEDATA *fileptr, float *buf, int nsam, int irec)

 {
 FILE    *fp;
 int     ioff, itest, k1, ot;
 size_t  igot;

 /* find offset of this line in the file */ 
 if (irec != 0)
    ioff  = (fileptr -> offset) + (irec -1) * nsam * 4;
 else
    ioff  = 0;

 /* find fileptr for this file */
 fp    = fileptr -> fp;

 if ((igot = fseek(fp,ioff,SEEK_SET)) != 0) 
    {
    printf("*** Seek failed in wrtlin: %d \n",igot);
    printf("wrtlin; igot: %d, ioff: %d ,nsam: %d \n",igot,ioff,nsam);
    return FALSE;
    }

 /* have set file position to the correct offset, put buf in file */
#ifdef VMS
    igot    = fwrite(buf, (size_t)(nsam*sizeof(float)), 1, fp);
    itest   = 1;
#else
#ifdef  P_SGIOSF
       /* convert to sgi like byte order */
       pt = (unsigned int *) buf;
       /* flip the bytes for date and time in header */
       for (k1 = 0; k1 < nsam; k1++, pt++)
          { CONVERT_4(*pt,*pt);  }
#endif

    igot = fwrite(buf, sizeof(float), nsam, fp);
    itest = nsam;
#endif

 if ((int) igot == itest)
    return TRUE;

 else 
    {
    printf("*** Write error in wrtlin. \n");
    printf("wrtlin; fp: %d igot: %d   ioff: %d nsam: %d \n",
                    fp,    igot,      ioff,    nsam);
    return FALSE;
    }
 }

