/*$Header: /alwyn/usr1/web//RCS/xorbox.c,v 1.3 94/02/14 09:15:50 leith Exp $*/
/*
C***************************************************************************
C
C XORBOX  -- CREATED JAN 90
C            CONVERTED TO C -- 2 SEPT 92 al
C                                                                 
C **************************************************************************
C *  AUTHOR: ArDean Leith                                                  *
C *  COPYRIGHT (C)1989, WADWSWORTH CENTER FOR LABORATORIES AND RESEARCH,   *
C *    NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.              *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH  			   *
C **************************************************************************
C
C XORBOX(IWIN,ICONTX,PERM,IX2,IY2,NSAM,NROW)
C
C PURPOSE:      DRAW AN A-XORED BOX
C
C PARAMETERS:   ICONTX      GRAPHICS CONTEXT
C               IPERM       LOGICAL FALG FOR PERMANENT DRAWING
C               IX2,IY2     UPPER LEFT CORNER OF BOX
C               NSAM,NROW   BOX DIMENSIONS
C
C CALLED BY:    WIWIND
C
C--***************************************************************

*/

#include "std.h"
#include "x.h"
#include "common.h"

 static int drawingt = FALSE;
 static int ixo,iyo,nsamo,nrowo;

 /******************************************************************/

 void xorbox(Window iwint, GC icontxt, int perm, int ix2, int iy2,
             int    nsamt, int nrowt)
 {

 if (perm) drawingt = FALSE;

 if (drawingt)
    {            /* in rubber-band loop so erase old box and draw new one */
    XDrawRectangle(idispl,iwint,icontxt,ixo,iyo,nsamo,nrowo);
    XDrawRectangle(idispl,iwint,icontxt,ix2,iy2,nsamt,nrowt);
    }
 else
    {            /* starting new rubber band loop , so draw new box */
    XDrawRectangle(idispl,iwint,icontxt,ix2,iy2,nsamt,nrowt);
    if (!perm) drawingt = TRUE;
    }
 XFlush(idispl);
 ixo   = ix2;
 iyo   = iy2;
 nsamo = nsamt;
 nrowo = nrowt;
 return;
 }

