/*$Header: /net/alwyn/usr1/web/src/RCS/xorc.c,v 1.4 95/01/20 13:01:37 leith Exp $*/
/*
C***************************************************************************
C
C XORC  -- CREATED JAN 90
C          CONVERTED TO C -- 1 OCT 92 al
C                                                                 
C **************************************************************************
C *  AUTHOR: ArDean Leith                                                  *
C *  COPYRIGHT (C)1990, WADWSWORTH CENTER FOR LABORATORIES AND RESEARCH,   *
C *    NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.              *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH  			   *
C **************************************************************************
C
C XORC(IWINT,ICONTXT,PERM,IX2,IY2,IRAD)
C
C PURPOSE:      DRAW AN A-XORED CIRCLE
C
C PARAMETERS:   IWIN        X WINDOW
C               ICONTXT     GRAPHICS CONTEXT
C               IPERM       LOGICAL FALG FOR PERMANENT DRAWING
C               IX2,IY2     POINT ON CIRCLE
C               IRAD        RADIUS OF CIRCLE
C
C CALLED BY:    PIXEL
C
C--***************************************************************

*/

#include "std.h"
#include "x.h"
#include "common.h"

 static int drawingt = FALSE;
 static int ixo,iyo,iwido;

 /**********************   xorc   ******************************/

 void xorc(Window iwint, GC icontxt, int perm, 
           int ix2, int iy2, int irad)
 {
 int iwid, ix, iy;

 if (perm) drawingt = FALSE;

 ix   = ix2 - irad;
 iy   = iy2 - irad;
 iwid = 2 * irad;

 if (drawingt)
    {            /* in rubber-band loop so erase old O and draw new */
    XDrawArc(idispl,iwint,icontxt,ixo,iyo,iwido,iwido,0,23040);
    XDrawArc(idispl,iwint,icontxt,ix, iy, iwid, iwid, 0,23040);
    }
 else
    {            /* starting new rubber band loop, so draw new O */
    XDrawArc(idispl,iwint,icontxt,ix, iy, iwid, iwid, 0,23040);
    if (!perm) drawingt = TRUE;
    }

 XFlush(idispl);
 ixo   = ixo;
 iyo   = iyo;
 iwido = iwid;

 return;
 }

