 
/*$Header: /alwyn/usr1/web//RCS/xorlin.c,v 1.2 93/11/18 12:29:32 leith Exp $*/
/*
C***************************************************************************
C
C XORLIN  -- CREATED NOV 93
C                                                                 
C **************************************************************************
C *  AUTHOR: ArDean Leith                                                  *
C *  COPYRIGHT (C)1993, WADWSWORTH CENTER FOR LABORATORIES AND RESEARCH,   *
C *    NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.              *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH  			   *
C **************************************************************************
C
C XORLIN(IWINT,ICONTXT,ERASE,DRAW,IX0,IY0,IX1,IY1,IX2,IY2,IX3,IY3)
C
C PURPOSE:      DRAW AN A-XORED LINE
C
C PARAMETERS:   IWIN        X WINDOW
C               ICONTXT     GRAPHICS CONTEXT
C               ERASE,DRAW  LOGICAL FLAGS FOR ERASE THEN DRAW
C               IPERM       LOGICAL FALG FOR PERMANENT DRAWING
C               IX0,IY0     OLD START POINT
C               IX1,IY1     OLD END POINT
C               IX2,IY2     NEW START POINT
C               IX3,IY3     NEW END POINT
C
C CALLED BY:    
C
C--***************************************************************
*/

#include "common.h"

 /**********************   xorlin   ******************************/

 void xorlin(Window iwint, GC icontxt, int erase, int draw, 
           int * ix0, int * iy0, int * ix1, int * iy1,
           int ix2, int iy2, int ix3, int iy3)
 {

 if (erase)
    {            
    XDrawLine(idispl,iwint,icontxt,*ix0,*iy0, *ix1,*iy1);
    }

 if (draw)
    {            
    XDrawLine(idispl,iwint,icontxt,ix2,iy2, ix3,iy3);

    /* set ix0,iy0,ix1,iy1 to new line coordinates */
    *ix0 = ix2;  *iy0 = iy2;
    *ix1 = ix3;  *iy1 = iy3;
    }

 XFlush(idispl);

 return;
 }

