 
/*$Header: /alwyn/usr1/web//RCS/xorline.c,v 1.2 94/02/14 09:22:17 leith Exp $*/
/*
C***************************************************************************
C
C XORLINE  -- CREATED NOV 89 as WIXOR.FOR
C          CONVERTED TO C -- 1 OCT 92 al
C                                                                 
C **************************************************************************
C *  AUTHOR: ArDean Leith                                                  *
C *  COPYRIGHT (C)1989, WADWSWORTH CENTER FOR LABORATORIES AND RESEARCH,   *
C *    NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.              *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH  			   *
C **************************************************************************
C
C XORLINE(IWINT,ICONTXT,PERM,IX2,IY2,IX3,IY3)
C
C PURPOSE:      DRAW AN A-XORED LINE
C
C PARAMETERS:   IWIN        X WINDOW
C               ICONTXT     GRAPHICS CONTEXT
C               IPERM       LOGICAL FALG FOR PERMANENT DRAWING
C               IX2,IY2     NEW START POINT
C               IX3,IY3     NEW END POINT
C
C CALLED BY:    PIXEL
C
C--***************************************************************
*/

#include "std.h"
#include "x.h"
#include "common.h"

 static int drawingt = FALSE;
 static int ix0,iy0,ix1, iy1;

 /**********************   xorc   ******************************/

 void xorline(Window iwint, GC icontxt, int perm, 
           int ix2, int iy2, int  ix3, int iy3)
 {
 if (perm) drawingt = FALSE;

 if (drawingt)
    {            /* in rubber-band loop so erase old and draw new */
    XDrawLine(idispl,iwint,icontxt,ix0,iy0,ix1,iy1);
    XDrawLine(idispl,iwint,icontxt,ix2,iy2,ix3,iy3);
    }
 else
    {            /* starting new rubber band loop, so draw new  */
    XDrawLine(idispl,iwint,icontxt,ix2,iy2,ix3,iy3);
    if (!perm) drawingt = TRUE;
    }

 XFlush(idispl);
 ix0   = ix2;
 iy0   = iy2;
 ix1   = ix3;
 iy1   = iy3;

 return;
 }

