
/*$Header: /net/ithaca/usr1/web/src/RCS/ztoxy.c,v 1.3 1997/08/25 19:59:42 liy Exp $*/
/*
C++************************************************************************
C
C ZTOXY -- CREATED JULY 92 al
C
C **************************************************************************
C *  AUTHOR:  ArDean Leith                                                 *
C *  COPYRIGHT (C)1992 , WADSWORTH CENTER FOR LABORATORIES AND             *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH			           *
C **************************************************************************
C
C    ZTOXY(NSAM,NSAM1,NSAM2,NROW,NROW1,NROW2,
C           NSLICE,NSLICE1,NSLICE2,AXIS,FN,FNCON)
C
C    PURPOSE:         DIPLAYING MONTAGE FROM FILE SERIES ON X WORKSTATION
C
C    RETURNS:         ERROR FLAG
C
C    CALLED BY:       MONT3
C
C    NOTES:
C
C     AXIS      NEW SECTION         NEW ROW            NEW SAMPLE
C     ---        -----------     -----------------    --------------
C      X       (ISAM-NSAM1+1)    (ISLICE-NSLICE1+1)   (IROW-NROW1+1)
C
C
C     LOC = (NEW SECTION-1)*NSAMS*NROWS + (NEW ROW-1)*NSAMS + NEW SAMPLE
C
C
C        0         2         3         4         5         6         7     
C23456789012345678901234567890123456789012345678901234567890123456789012
C***********************************************************************
*/

#include "files.h"

 /* function  prototypes */
 extern int   redlin(FILEDATA *, float *, int, int);
 extern void  spout(char *);

/**********************************************************/

 int ztoxy(FILEDATA *filedata,    char *lbuf, 
             int nsam,   int nsam1,   int nsam2,
             int nrow,   int nrow1,   int nrow2,
             int nslice, int nslice1, int nslice2,
             char axis, float fn, float fncon, int iskip)

 {  

 int        nsami, nrowi, nslices, icon, iconx, icony, iconz;
 int        npixpsl, miskip, miskipm1, iskipz, icons, irect;
 int        iconr, ival, iloc, l, m, iloct; 
 int        isam, irow, islice, nsamu, nrowu, nsliceu;
 float      *buf;

 if (axis == 'x')
    { 
    nsami   = nrow2   - nrow1   + 1;
    nrowi   = nslice2 - nslice1 + 1;
    nslices = nsam2   - nsam1   + 1;
    }
 else if (axis == 'y')
    {
    nsami   = nsam2   - nsam1   + 1;
    nrowi   = nslice2 - nslice1 + 1;
    nslices = nrow2   - nrow1   + 1;
    }
 else if (axis == 'z')
    {
    nsami   = nsam2   - nsam1   + 1;
    nrowi   = nrow2   - nrow1   + 1;
    nslices = nslice2 - nslice1 + 1;
    }
 else 
    {
    spout(" *** IN ZTOXY: UNSUPORTED AXIS");
    return FALSE;
    }

 buf = filedata -> buf;

 if (iskip == 1)
    {    /* display full size */
    npixpsl = nrowi * nsami;
    if (axis == 'y')
       {
       icon = -nrow1 * npixpsl - nslice1 * nsami - nsam1;
       nsamu = nsam2;
       }
    else if (axis == 'x') 
       {
       icon = -nsam1 * npixpsl - nslice1 * nsami -nrow1;
       nrowu = nrow2;
       }
    }

 else if (iskip > 1)
    {   /* display at reduced size */
    if ((nsami / iskip*iskip) == nsami)
    	nsami   = nsami / iskip;
    else 
    	nsami   = nsami / iskip + 1;
    if ((nrowi / iskip*iskip) == nrowi)
    	nrowi   = nrowi / iskip;
    else 
    	nrowi   = nrowi / iskip + 1;

    npixpsl = nrowi * nsami;
    if (axis == 'y')
       {
       icon = -nrow1 * npixpsl - nslice1 * nsami / iskip - 
              nsam1 / iskip ;  
       nsamu = nsam2 - (nsam2 - nsam1 + 1) % iskip + 1;
       }
    if (axis == 'x')
       {
       icon = -nsam1 * npixpsl - nslice1 * nsami / iskip -
               nrow1 / iskip;
       nrowu = nrow2 - (nrow2-nrow1+1) % iskip + 1;
       }
    }
 else if (iskip < -1)
    {   /* display magnified image */
    miskip   = -iskip;
    miskipm1 = miskip - 1;
    nsami    = nsami * miskip;
    nrowi    = nrowi * miskip;
    npixpsl  = nrowi * nsami;
    if (axis == 'y')
       icon = -nrow1 * npixpsl - nslice1 * miskip * nsami - 1;
    else
       icon = -nsam1 * npixpsl - nslice1 * miskip * nsami -
               nrow1 * miskip;
    }
 else
    { spout("*** invalid iskip in ztoxy"); return FALSE; }

 /* find skip factors for z axis */
 iskipz = MYMAX(1,iskip);
 
 /* find upper end of col. series */
 nsliceu = nslice2;

 for (islice=nslice1; islice<=nsliceu; islice=islice+iskipz)
   {
   if (axis == 'y')
      {  
      if (iskip < 0)
         icons = islice * nsami * miskip + icon;
      else if (iskip > 1)
         icons = islice * nsami / iskip  + icon;
      else
         icons = islice * nsami          + icon;

      for (irow=nrow1; irow <= nrow2; irow++)
         {
         irect = (islice - 1) * nrow + irow;
         if (redlin(filedata,buf,nsam,irect) == FALSE)  return FALSE;

         if (iskip == 1)
            {  /* display full size y slice */

            iconr = irow * npixpsl + icons;
            for (isam=nsam1; isam <= nsam2; isam++)
               {
               ival  = buf[isam-1] * fn + fncon;
               if (ival >= 128) ival = ival - 256;

               iloc = isam + iconr;

/***************bug ************/
   if (iloc < 0 || iloc > nsami * nrowi * nslices -1)
    printf("illegal iloc: %d, irow: %d, isam: %d \n",iloc,irow,isam);

/********************/

               lbuf[iloc] = ival;
               }         
            }
         else if (iskip > 1) 
            {   /* display reduced size image y slice */
            iconr = irow * npixpsl + icons;
            
            for (isam=nsam1; isam <= nsamu; isam=isam+iskip)
               {
               ival  = buf[isam-1] * fn + fncon;
               if (ival >= 128) ival = ival - 256;

               iloc = isam / iskip + iconr;
               lbuf[iloc] = ival;
               }         
            }
         else if (iskip < -1) 
            {   /* display magnified image y slice */

            iloc = irow * npixpsl + icons;
            
            for (isam=nsam1-1; isam < nsam2; isam++)
               {
               ival  = buf[isam] * fn + fncon;
               if (ival >= 128) ival = ival - 256;

               for (l = 1; l <= miskip; l++)
                  {
                  iloc++;
                  for (m = 0; m <= miskipm1; m++)
                     {
/***************bug ************/
   iloct = iloc + m * nsami;
   if (iloct < 0 || iloct > nsami * nrowi * nslices -1) 
    {
    printf("illegal iloct: %d, irow: %d, isam: %d \n",iloct,irow,isam);
    printf("icons: %d, iconr: %d, npixpsl: %d \n",icons,iconr,npixpsl);
    printf("l: %d, m: %d  \n",l,m);
    }
/********************/
                     lbuf[iloc + m * nsami] = ival;
                     }
                  }
               }      
            }
         }
      }
      
   else if (axis == 'x')
      { 
      if (iskip ==1)
         {   /* full size x slice */
         icons = islice * nsami + icon;

         for (irow=nrow1; irow <= nrow2; irow++)
            {
            irect = (islice - 1) * nrow + irow;
            if (redlin(filedata,buf,nsam,irect) == FALSE) return FALSE;
            iconr = irow + icons;

            for (isam=nsam1; isam <= nsam2; isam++)
               {
               ival  = buf[isam-1] * fn + fncon;
               if (ival >= 128) ival = ival - 256;

               iloc = isam *npixpsl + iconr;

/***************bug ************/
   if (iloc < 0 || iloc > nsami * nrowi * nslices -1) {
    printf("illegal iloc: %d, irow: %d, isam: %d \n",iloc,irow,isam);
    printf("icons: %d, iconr: %d, npixpsl: %d \n",icons,iconr,npixpsl);
     }
/********************/
               lbuf[iloc] = ival;
               }         
            }
         }
      else if (iskip > 1)
         {   /* reduced size x slice */
         icons = islice * nsami / iskip + icon;

         for (irow=nrow1; irow <= nrow2; irow=irow+iskip)
            {
            irect = (islice - 1) * nrow + irow;
            if (redlin(filedata,buf,nsam,irect) == FALSE)  return FALSE;
            iconr = irow / iskip + icons;

            for (isam=nsam1; isam <= nsam2; isam++)
               {
               ival  = buf[isam-1] * fn + fncon;
               if (ival >= 128) ival = ival - 256;

               iloc = isam * npixpsl + iconr;
               lbuf[iloc] = ival;
               }         
            }
         }
      else if (iskip < -1)
         {   /* magnifed x slice */ 

         icons = islice * nsami * miskip + icon;

         for (irow=nrow1; irow <= nrow2; irow++)
            {
            irect = (islice - 1) * nrow + irow;
            if (redlin(filedata,buf,nsam,irect) == FALSE) return FALSE;

            iconr = irow * miskip + icons;

            for (isam=nsam1; isam <= nsam2; isam++)
               {
               ival  = buf[isam-1] * fn + fncon;
               if (ival >= 128) ival = ival - 256;

               iloc = isam * npixpsl + iconr;
 
               for (l = 1; l <= miskip; l++)
                  {
                  for (m = 0; m <= miskipm1; m++)
                     {
        
/***************bug ************/
   iloct = iloc + m * nsami;
   if (iloct < 0 || iloct > nsami * nrowi * nslices -1) 
    {
    printf("illegal iloct: %d, irow: %d, isam: %d \n",iloct,irow,isam);
    printf("icons: %d, iconr: %d, npixpsl: %d \n",icons,iconr,npixpsl);
    printf("l: %d, m: %d nsami: %d ,icon %d \n",l,m,nsami,icon);
    }
/********************/
                     lbuf[iloc + m * nsami] = ival;
                     }
                  iloc++;
                  }
               }
            }
         }
      }
   }

 return TRUE;
 }       

