C++*******************************************************************
C
C $$ NOISE.FOR
C
C **************************************************************************
C *  SPIDER - MODULAR IMAGE PROCESSING SYSTEM.  AUTHOR: J.FRANK            *
C *  COPYRIGHT (C)1981,1987, WADSWORTH CENTER FOR LABORATORIES AND         *
C *  RESEARCH, NEW YORK STATE DEPARTMENT OF HEALTH, ALBANY, NY 12201.      *
C *    THE CONTENTS OF THIS DOCUMENT ARE PROPRIETARY TO THE CENTER FOR     *
C *    LABORATORIES AND RESEARCH AND ARE NOT TO BE DISCLOSED TO OTHERS OR  *
C *    USED FOR PURPOSES OTHER THAN INTENDED WITHOUT WRITTEN APPROVAL OF   *
C *    THE CENTER FOR LABORATORIES AND RESEARCH 			   *
C **************************************************************************
C
C
C $$ NOISE:  CALCULATE THE BACKGROUND NOISE OF POWER SPECTRUM AND SUBTRACT IT 
C            USING LEAST-SQUARE METHOD TO FIT POINTS INTO GAUSSIAN PROFILE
C            USING STEEPEST DESCENT METHOD
C            f(Xi,A)=A1exp(-(Xi/A2)**2)+A3
C
C    CALL NOISE(IRTFLG)
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

	SUBROUTINE NOISE(IRTFLG)
        INCLUDE 'CMBLOCK.INC'
C	COMMON /COMMUN/IMFILE
	COMMON /IMFILE/IMFILE
	common adum(2048),buf(1)
	DIMENSION Y1(512),Y2(512),X(120)
	real KFR(120),K(120)
	REAL KM,KS
	CHARACTER OUTNAME*81,IMFILE*81,NULL*1,CHO*1
CNO_SAVE
	LUN1=8
	LUN2=10
	NULL=CHAR(0)
	INUM=1
	CALL DEFO003(INUM,N,KFR,Y2,NSAM,SPMAX,LUN1,IRTFLG)
	IF(IRTFLG .NE. 0) RETURN
	CALL RDPRMI(NUM,NDUM,NLOOP,ILOOP,'HOW MANY POINTS YOU WANT?$')
	IF(NUM .EQ. 0) RETURN
	KM=SPMAX
        KS=KM/FLOAT(NSAM)
	WRITE(NOUT,*) ' INPUT THE POINT YOU WANT:'
	DO  I=1,NUM
	   WRITE(NOUT,40) I
40	   FORMAT(' POINT #',I4,':   ')
	   CALL RDPRM(k(I),NLOOP,ILOOP,'R [point]=?$')
C          get value of y1, bilinear interprelataion
	   Y1(I)=(1.-(k(i)-int(k(i))))*buf(int(k(i)))+
     &        (k(i)-int(k(i)))*buf(int(k(i))+1)
	   WRITE(NOUT,*) K(I),Y1(I)
	ENDDO
	IF(NUM .EQ. 1) THEN
	   CALL RDPRM(A2,NLOOP,ILOOP,'SUPPLY A2 VALUE [A-1]: $ ')
	ENDIF
	
C....... GET X(I) VALUE
	DO  I=1,NUM
	   X(I)=K(I)*KS
	ENDDO

C......FOR  SINGLE INPUT POINT
        IF(NUM .EQ. 1) THEN
	   A3=0
	   A1=Y1(1)/(EXP(-(X(1)/A2)**2))
	   GOTO 899
	ENDIF

C...... SET INITIAL VALUE FOR A1,A2 AND A3
	IF( NUM .GT. 2) THEN	
	A3=Y1(NUM)*0.8
	A2=SQRT((X(2)**2-X(1)**2)/LOG(Y1(1)/Y1(2)))
	A1=(Y1(1)-A3)/EXP(-(X(1)/A2)**2)
	ELSEIF(NUM .GT. 1) THEN
	A3=0
	A2=SQRT((X(2)**2-X(1)**2)/LOG(Y1(1)/Y1(2)))
	A1=(Y1(1)-A3)/EXP(-(X(1)/A2)**2)
	ELSE
	A3=0
	A1=(Y1(1)-A3)/EXP(-(X(1)/A2)**2)
	ENDIF
	
C.......SET INITIAL VALUE OF X**2
	DO  I=1,NUM
  	  Y2(I)=A1*EXP(-(X(I)/A2)**2)+A3
	ENDDO
	X0=0
c	XMIN=0
c	DO I=1,NUM
c	IF(XMIN .GT. (Y1(I)-Y2(I))) XMIN=Y1(I)-Y2(I)
c	ENDDO
	DO I=1,NUM
c	X0=X0+(Y1(I)-Y2(I)-xmin)**2
	X0=X0+(Y1(I)-Y2(I))**2
	ENDDO
C	write(nout,*) 'x0=',x0
        NSTEP=0
999	DA1=0.001*A1
	DA2=0.001*A2
	DA3=0.001*A3
C...... CALCULATE dX**2/dA1
     	DO  I=1,NUM
	   Y2(I)=(A1+0.1*DA1)*EXP(-(X(I)/A2)**2)+A3
	ENDDO
	X1=0
c	XMIN=0
c	DO I=1,NUM
c	IF(XMIN .GT. (Y1(I)-Y2(I))) XMIN=Y1(I)-Y2(I)
c	ENDDO
	DO  I=1,NUM
c	   X1=X1+(Y1(I)-Y2(I)-xmin)**2
	   X1=X1+(Y1(I)-Y2(I))**2
	ENDDO
	DXA1=(X1-X0)/(0.1*DA1)
C	WRITE(NOUT,*)'x1=',x1,'dxa1=',dxa1
C.......CALCULATE DERIVATE dX**2/dA2
	DO  I=1,NUM
	   Y2(I)=A1*EXP(-(X(I)/(A2+0.1*DA2))**2)+A3
	ENDDO
	X1=0
c	XMIN=0
c	DO I=1,NUM
c	IF(XMIN .GT. (Y1(I)-Y2(I))) XMIN=Y1(I)-Y2(I)
c	ENDDO
	DO  I=1,NUM
c	   X1=X1+(Y1(I)-Y2(I)-xmin)**2
	   X1=X1+(Y1(I)-Y2(I))**2
	ENDDO
	IF(NUM .LT. 2) THEN
	   DXA2=0
	ELSE
	   DXA2=(X1-X0)/(0.1*DA2)
	ENDIF
	
C	write(nout,*)'x1=',x1,'dxa2',dxa2
C...... CALCULATE DERIVATE dX**2/dA3
	DO  I=1,NUM
	   Y2(I)=A1*EXP(-(X(I)/A2)**2)+(A3+0.1*DA3)
	ENDDO
	X1=0
c	XMIN=0
c	DO I=1,NUM
c	IF( XMIN .GT. (Y1(I)-Y2(I))) XMIN=(Y1(I)-Y2(I))
c	ENDDO
	DO I=1,NUM
c	   X1=X1+(Y1(I)-Y2(I)-xmin)**2
	   X1=X1+(Y1(I)-Y2(I))**2
	ENDDO
	IF(NUM .LT. 3) THEN
	   DXA3=0
	ELSE
	   DXA3=(X1-X0)/(0.1*DA3)
	ENDIF
C	write(nout,*)'x1=',x1,'dxa3=',dxa3
C..........................
	SUM=SQRT((DXA1*DA1)**2+(DXA2*DA2)**2+(DXA3*DA3)**2)
	A1=A1-DXA1*DA1**2/SUM
	A2=A2-DXA2*DA2**2/SUM
	A3=A3-DXA3*DA3**2/SUM
	
C....... CRITERIA FOR ITERATION  ...... CALCULATE THE Y2
	DO  I=1,NUM
	   Y2(I)=A1*EXP(-(X(I)/A2)**2)+A3
	ENDDO
	X1=0
c	XMIN=0
c	DO I=1,NUM
c	IF(XMIN .GT. (Y1(I)-Y2(I))) XMIN=Y1(I)-Y2(I)
c	ENDDO
	DO  I=1,NUM
c          X1=X1+(Y1(I)-Y2(I)-xmin)**2	
	   X1=X1+(Y1(I)-Y2(I))**2
	ENDDO
	D=X1-X0

C       SOLVE GOTO 899 BY REWRITING THE IF () THEN .. LOOP . ML 7/5/95
	IF (D .LE. 0) THEN
	   X0=X1
	   P=A2/KS
C	   WRITE(NOUT,*)'A1=',A1,' A2=',A2,'(A-1)  ',P,'POINTS','  A3',A3
	   NSTEP=NSTEP+1
	   GOTO 999
	END IF
C	IF (D .GT. 0) THEN
	   A1=A1+0.5*DXA1*DA1**2/SUM
	   A2=A2+0.5*DXA2*DA2**2/SUM
	   A3=A3+0.5*DXA3*DA3**2/SUM
899	   P=A2/KS
	   WRITE(NOUT,*)'A1=',A1,'  A2=',A2,'(A-1)  ',
     &                   P,'POINTS','  A3=',A3
	   WRITE(NOUT,*)' CREATE A NOISE DELETED PROFILE'
	   CALL FILERD(OUTNAME,NLET,NULL,'OUTPUT',IRTFLG)
	   IF (IRTFLG .NE. 0) RETURN
           CALL OPENF(OUTNAME,LUN2,NSAM,1,'UNKNOWN',NF,1)
	   CALL OPENF(IMFILE,LUN1,NSAM,NROW,'O',NF,NSLICE)
 	   CALL REDLIN(LUN1,Y2,NSAM,1)
C	   CALL RDPRMI(NK1,NK2,NLLOP,ILOOP,'MAX. CAL. POINTS=$')

C  add an additional value, so all the minimi are above zero, at the 
c  other places value below zero are set to zero.

	   XMIN=0
	   DO I=1,NSAM
	      X1=FLOAT(I)*KS
	      Y1(I)=A1*EXP(-(X1/A2)**2)+A3
	      Y2(I)=Y2(I)-Y1(I)
	      do  j=1,num
                 IF( i .eq. int(k(j))-1 .or. i .eq. int(k(j))
     &            .or. i .eq.  int(k(j))+1) then
                   if (XMIN .GT. Y2(I)) XMIN=Y2(I)
	         ENDIF
	      ENDDO
	   ENDDO
	   DO I=1,NSAM
   	      Y2(I)=Y2(I)-XMIN
	      IF (Y2(I) .LT. 0) Y2(I)=0
	   ENDDO
	   CALL WRTLIN(LUN2,Y2,NSAM,1)	
C	ELSE
C	   X0=X1
C	   P=A2/KS
CC	   WRITE(NOUT,*)'A1=',A1,' A2=',A2,'(A-1)  ',P,'POINTS','  A3',A3
C	   NSTEP=NSTEP+1
C	   GOTO 999
C	ENDIF
	
	CLOSE(LUN1)
	CLOSE(LUN2)
	RETURN
	END
